/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/strings","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/platform","vs/base/common/event","vs/base/common/types","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/functional","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/objects","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/diffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],te=function(O){for(var n=[],P=0,t=O.length;P<t;P++)n[P]=ee[O[P]];return n},Pe=this,Re=typeof global=="object"?global:{},ce;(function(O){O.global=Pe;var n=function(){function P(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(P.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),P.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=P._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},P._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},P}();O.Environment=n})(ce||(ce={}));var ce;(function(O){var n=function(){function D(o,A,d){this.type=o,this.detail=A,this.timestamp=d}return D}();O.LoaderEvent=n;var P=function(){function D(o){this._events=[new n(1,"",o)]}return D.prototype.record=function(o,A){this._events.push(new n(o,A,O.Utilities.getHighPerformanceTimestamp()))},D.prototype.getEvents=function(){return this._events},D}();O.LoaderEventRecorder=P;var t=function(){function D(){}return D.prototype.record=function(o,A){},D.prototype.getEvents=function(){return[]},D.INSTANCE=new D,D}();O.NullLoaderEventRecorder=t})(ce||(ce={}));var ce;(function(O){var n=function(){function P(){}return P.fileUriToFilePath=function(t,D){if(D=decodeURI(D).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(D))return D.substr(8);if(/^file:\/\//.test(D))return D.substr(5)}else if(/^file:\/\//.test(D))return D.substr(7);return D},P.startsWith=function(t,D){return t.length>=D.length&&t.substr(0,D.length)===D},P.endsWith=function(t,D){return t.length>=D.length&&t.substr(t.length-D.length)===D},P.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},P.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},P.forEachProperty=function(t,D){if(t){var o=void 0;for(o in t)t.hasOwnProperty(o)&&D(o,t[o])}},P.isEmpty=function(t){var D=!0;return P.forEachProperty(t,function(){D=!1}),D},P.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var D=Array.isArray(t)?[]:{};return P.forEachProperty(t,function(o,A){A&&typeof A=="object"?D[o]=P.recursiveClone(A):D[o]=A}),D},P.generateAnonymousModule=function(){return"===anonymous"+P.NEXT_ANONYMOUS_ID+++"==="},P.isAnonymousModule=function(t){return P.startsWith(t,"===anonymous")},P.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()},P.NEXT_ANONYMOUS_ID=1,P.PERFORMANCE_NOW_PROBED=!1,P.HAS_PERFORMANCE_NOW=!1,P}();O.Utilities=n})(ce||(ce={}));var ce;(function(O){function n(D){if(D instanceof Error)return D;var o=new Error(D.message||String(D)||"Unknown Error");return D.stack&&(o.stack=D.stack),o}O.ensureError=n;var P=function(){function D(){}return D.validateConfigurationOptions=function(o){function A(l){if(l.phase==="loading"){console.error('Loading "'+l.moduleId+'" failed'),console.error(l),console.error("Here are the modules that depend on it:"),console.error(l.neededBy);return}if(l.phase==="factory"){console.error('The factory method of "'+l.moduleId+'" has thrown an exception'),console.error(l);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError=="undefined"&&(o.catchError=!1),typeof o.recordStats=="undefined"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=A),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(O.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags=="undefined"&&(o.preferScriptTags=!1),Array.isArray(o.nodeModules)||(o.nodeModules=[]),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){var d=n(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",o.onError(d),o.nodeCachedData=void 0}return o},D.mergeConfigurationOptions=function(o,A){o===void 0&&(o=null),A===void 0&&(A=null);var d=O.Utilities.recursiveClone(A||{});return O.Utilities.forEachProperty(o,function(l,f){l==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules!="undefined"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(f):l==="paths"&&typeof d.paths!="undefined"?O.Utilities.forEachProperty(f,function(p,M){return d.paths[p]=M}):l==="config"&&typeof d.config!="undefined"?O.Utilities.forEachProperty(f,function(p,M){return d.config[p]=M}):d[l]=O.Utilities.recursiveClone(f)}),D.validateConfigurationOptions(d)},D}();O.ConfigurationOptionsUtil=P;var t=function(){function D(o,A){if(this._env=o,this.options=P.mergeConfigurationOptions(A),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var d=this.options.nodeRequire.main.filename,l=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,l+1)}if(this.options.nodeMain&&this._env.isNode){var d=this.options.nodeMain,l=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,l+1)}}}return D.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0},D.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var o=0,A=this.options.nodeModules;o<A.length;o++){var d=A[o];this.nodeModulesMap[d]=!0}},D.prototype._createSortedPathsRules=function(){var o=this;this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,function(A,d){Array.isArray(d)?o.sortedPathsRules.push({from:A,to:d}):o.sortedPathsRules.push({from:A,to:[d]})}),this.sortedPathsRules.sort(function(A,d){return d.from.length-A.from.length})},D.prototype.cloneAndMerge=function(o){return new D(this._env,P.mergeConfigurationOptions(o,this.options))},D.prototype.getOptionsLiteral=function(){return this.options},D.prototype._applyPaths=function(o){for(var A,d=0,l=this.sortedPathsRules.length;d<l;d++)if(A=this.sortedPathsRules[d],O.Utilities.startsWith(o,A.from)){for(var f=[],p=0,M=A.to.length;p<M;p++)f.push(A.to[p]+o.substr(A.from.length));return f}return[o]},D.prototype._addUrlArgsToUrl=function(o){return O.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs},D.prototype._addUrlArgsIfNecessaryToUrl=function(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o},D.prototype._addUrlArgsIfNecessaryToUrls=function(o){if(this.options.urlArgs)for(var A=0,d=o.length;A<d;A++)o[A]=this._addUrlArgsToUrl(o[A]);return o},D.prototype.moduleIdToPaths=function(o){if(this._env.isNode){var A=this.nodeModulesMap[o]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o);if(A)return this.isBuild()?["empty:"]:["node|"+o]}var d=o,l;if(!O.Utilities.endsWith(d,".js")&&!O.Utilities.isAbsolutePath(d)){l=this._applyPaths(d);for(var f=0,p=l.length;f<p;f++)this.isBuild()&&l[f]==="empty:"||(O.Utilities.isAbsolutePath(l[f])||(l[f]=this.options.baseUrl+l[f]),!O.Utilities.endsWith(l[f],".js")&&!O.Utilities.containsQueryString(l[f])&&(l[f]=l[f]+".js"))}else!O.Utilities.endsWith(d,".js")&&!O.Utilities.containsQueryString(d)&&(d=d+".js"),l=[d];return this._addUrlArgsIfNecessaryToUrls(l)},D.prototype.requireToUrl=function(o){var A=o;return O.Utilities.isAbsolutePath(A)||(A=this._applyPaths(A)[0],O.Utilities.isAbsolutePath(A)||(A=this.options.baseUrl+A)),this._addUrlArgsIfNecessaryToUrl(A)},D.prototype.isBuild=function(){return this.options.isBuild},D.prototype.isDuplicateMessageIgnoredFor=function(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)},D.prototype.getConfigForModule=function(o){if(this.options.config)return this.options.config[o]},D.prototype.shouldCatchError=function(){return this.options.catchError},D.prototype.shouldRecordStats=function(){return this.options.recordStats},D.prototype.onError=function(o){this.options.onError(o)},D}();O.Configuration=t})(ce||(ce={}));var ce;(function(O){var n=function(){function l(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return l.prototype.load=function(f,p,M,v){var m=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new D;else if(this._env.isElectronRenderer){var e=f.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new P:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new P;var N={callback:M,errorback:v};if(this._callbackMap.hasOwnProperty(p)){this._callbackMap[p].push(N);return}this._callbackMap[p]=[N],this._scriptLoader.load(f,p,function(){return m.triggerCallback(p)},function(C){return m.triggerErrorback(p,C)})},l.prototype.triggerCallback=function(f){var p=this._callbackMap[f];delete this._callbackMap[f];for(var M=0;M<p.length;M++)p[M].callback()},l.prototype.triggerErrorback=function(f,p){var M=this._callbackMap[f];delete this._callbackMap[f];for(var v=0;v<M.length;v++)M[v].errorback(p)},l}(),P=function(){function l(){}return l.prototype.attachListeners=function(f,p,M){var v=function(){f.removeEventListener("load",m),f.removeEventListener("error",e)},m=function(N){v(),p()},e=function(N){v(),M(N)};f.addEventListener("load",m),f.addEventListener("error",e)},l.prototype.load=function(f,p,M,v){if(/^node\|/.test(p)){var m=f.getConfig().getOptionsLiteral(),e=A(f.getRecorder(),m.nodeRequire||O.global.nodeRequire),N=p.split("|"),C=null;try{C=e(N[1])}catch(s){v(s);return}f.enqueueDefineAnonymousModule([],function(){return C}),M()}else{var L=document.createElement("script");L.setAttribute("async","async"),L.setAttribute("type","text/javascript"),this.attachListeners(L,M,v);var h=f.getConfig().getOptionsLiteral().trustedTypesPolicy;h&&(p=h.createScriptURL(p)),L.setAttribute("src",p);var i=f.getConfig().getOptionsLiteral().cspNonce;i&&L.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(L)}},l}();function t(l){var f=l.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var p=f?self.eval(f.createScript("","true")):new Function("true");return p.call(self),!0}catch{return!1}}var D=function(){function l(){this._cachedCanUseEval=null}return l.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(f)),this._cachedCanUseEval},l.prototype.load=function(f,p,M,v){if(/^node\|/.test(p)){var m=f.getConfig().getOptionsLiteral(),e=A(f.getRecorder(),m.nodeRequire||O.global.nodeRequire),N=p.split("|"),C=null;try{C=e(N[1])}catch(i){v(i);return}f.enqueueDefineAnonymousModule([],function(){return C}),M()}else{var L=f.getConfig().getOptionsLiteral().trustedTypesPolicy,h=/^((http:)|(https:)|(file:))/.test(p)&&p.substring(0,self.origin.length)!==self.origin;if(!h&&this._canUseEval(f)){fetch(p).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+p;var s=L?self.eval(L.createScript("",i)):new Function(i);s.call(self),M()}).then(void 0,v);return}try{L&&(p=L.createScriptURL(p)),importScripts(p),M()}catch(i){v(i)}}},l}(),o=function(){function l(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return l.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},l.prototype._initNodeRequire=function(f,p){var M=p.getConfig().getOptionsLiteral().nodeCachedData;if(!M||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var v=this,m=f("module");function e(N){var C=N.constructor,L=function(i){try{return N.require(i)}finally{}};return L.resolve=function(i,s){return C._resolveFilename(i,N,!1,s)},L.resolve.paths=function(i){return C._resolveLookupPaths(i,N)},L.main=process.mainModule,L.extensions=C._extensions,L.cache=C._cache,L}m.prototype._compile=function(N,C){var L=m.wrap(N.replace(/^#!.*/,"")),h=p.getRecorder(),i=v._getCachedDataPath(M,C),s={filename:C},a;try{var u=v._fs.readFileSync(i);a=u.slice(0,16),s.cachedData=u.slice(16),h.record(60,i)}catch{h.record(61,i)}var b=new v._vm.Script(L,s),_=b.runInThisContext(s),c=v._path.dirname(C),g=e(this),w=[this.exports,g,this,C,c,process,Re,Buffer],y=_.apply(this.exports,w);return v._handleCachedData(b,L,i,!s.cachedData,p),v._verifyCachedData(b,L,i,a,p),y}},l.prototype.load=function(f,p,M,v){var m=this,e=f.getConfig().getOptionsLiteral(),N=A(f.getRecorder(),e.nodeRequire||O.global.nodeRequire),C=e.nodeInstrumenter||function(_){return _};this._init(N),this._initNodeRequire(N,f);var L=f.getRecorder();if(/^node\|/.test(p)){var h=p.split("|"),i=null;try{i=N(h[1])}catch(_){v(_);return}f.enqueueDefineAnonymousModule([],function(){return i}),M()}else{p=O.Utilities.fileUriToFilePath(this._env.isWindows,p);var s=this._path.normalize(p),a=this._getElectronRendererScriptPathOrUri(s),u=Boolean(e.nodeCachedData),b=u?this._getCachedDataPath(e.nodeCachedData,p):void 0;this._readSourceAndCachedData(s,b,L,function(_,c,g,w){if(_){v(_);return}var y;c.charCodeAt(0)===l._BOM?y=l._PREFIX+c.substring(1)+l._SUFFIX:y=l._PREFIX+c+l._SUFFIX,y=C(y,s);var S={filename:a,cachedData:g},R=m._createAndEvalScript(f,y,S,M,v);m._handleCachedData(R,y,b,u&&!g,f),m._verifyCachedData(R,y,b,w,f)})}},l.prototype._createAndEvalScript=function(f,p,M,v,m){var e=f.getRecorder();e.record(31,M.filename);var N=new this._vm.Script(p,M),C=N.runInThisContext(M),L=f.getGlobalAMDDefineFunc(),h=!1,i=function(){return h=!0,L.apply(null,arguments)};return i.amd=L.amd,C.call(O.global,f.getGlobalAMDRequireFunc(),i,M.filename,this._path.dirname(M.filename)),e.record(32,M.filename),h?v():m(new Error("Didn't receive define call in "+M.filename+"!")),N},l.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var p=f.match(/^([a-z])\:(.*)/i);return p?"file:///"+(p[1].toUpperCase()+":"+p[2]).replace(/\\/g,"/"):"file://"+f},l.prototype._getCachedDataPath=function(f,p){var M=this._crypto.createHash("md5").update(p,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),v=this._path.basename(p).replace(/\.js$/,"");return this._path.join(f.path,v+"-"+M+".code")},l.prototype._handleCachedData=function(f,p,M,v,m){var e=this;f.cachedDataRejected?this._fs.unlink(M,function(N){m.getRecorder().record(62,M),e._createAndWriteCachedData(f,p,M,m),N&&m.getConfig().onError(N)}):v&&this._createAndWriteCachedData(f,p,M,m)},l.prototype._createAndWriteCachedData=function(f,p,M,v){var m=this,e=Math.ceil(v.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),N=-1,C=0,L=void 0,h=function(){setTimeout(function(){L||(L=m._crypto.createHash("md5").update(p,"utf8").digest());var i=f.createCachedData();if(!(i.length===0||i.length===N||C>=5)){if(i.length<N){h();return}N=i.length,m._fs.writeFile(M,Buffer.concat([L,i]),function(s){s&&v.getConfig().onError(s),v.getRecorder().record(63,M),h()})}},e*Math.pow(4,C++))};h()},l.prototype._readSourceAndCachedData=function(f,p,M,v){if(!p)this._fs.readFile(f,{encoding:"utf8"},v);else{var m=void 0,e=void 0,N=void 0,C=2,L=function(h){h?v(h):--C==0&&v(void 0,m,e,N)};this._fs.readFile(f,{encoding:"utf8"},function(h,i){m=i,L(h)}),this._fs.readFile(p,function(h,i){!h&&i&&i.length>0?(N=i.slice(0,16),e=i.slice(16),M.record(60,p)):M.record(61,p),L()})}},l.prototype._verifyCachedData=function(f,p,M,v,m){var e=this;!v||f.cachedDataRejected||setTimeout(function(){var N=e._crypto.createHash("md5").update(p,"utf8").digest();v.equals(N)||(m.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+M+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(M,function(C){C&&m.getConfig().onError(C)}))},Math.ceil(5e3*(1+Math.random())))},l._BOM=65279,l._PREFIX="(function (require, define, __filename, __dirname) { ",l._SUFFIX=`
});`,l}();function A(l,f){if(f.__$__isRecorded)return f;var p=function(v){l.record(33,v);try{return f(v)}finally{l.record(34,v)}};return p.__$__isRecorded=!0,p}O.ensureRecordedNodeRequire=A;function d(l){return new n(l)}O.createScriptLoader=d})(ce||(ce={}));var ce;(function(O){var n=function(){function d(l){var f=l.lastIndexOf("/");f!==-1?this.fromModulePath=l.substr(0,f+1):this.fromModulePath=""}return d._normalizeModuleId=function(l){var f=l,p;for(p=/\/\.\//;p.test(f);)f=f.replace(p,"/");for(f=f.replace(/^\.\//g,""),p=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;p.test(f);)f=f.replace(p,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},d.prototype.resolveModule=function(l){var f=l;return O.Utilities.isAbsolutePath(f)||(O.Utilities.startsWith(f,"./")||O.Utilities.startsWith(f,"../"))&&(f=d._normalizeModuleId(this.fromModulePath+f)),f},d.ROOT=new d(""),d}();O.ModuleIdResolver=n;var P=function(){function d(l,f,p,M,v,m){this.id=l,this.strId=f,this.dependencies=p,this._callback=M,this._errorback=v,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return d._safeInvokeFunction=function(l,f){try{return{returnedValue:l.apply(O.global,f),producedError:null}}catch(p){return{returnedValue:null,producedError:p}}},d._invokeFactory=function(l,f,p,M){return l.isBuild()&&!O.Utilities.isAnonymousModule(f)?{returnedValue:null,producedError:null}:l.shouldCatchError()?this._safeInvokeFunction(p,M):{returnedValue:p.apply(O.global,M),producedError:null}},d.prototype.complete=function(l,f,p){this._isComplete=!0;var M=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);var v=d._invokeFactory(f,this.strId,this._callback,p);M=v.producedError,l.record(22,this.strId),!M&&typeof v.returnedValue!="undefined"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=v.returnedValue)}else this.exports=this._callback;if(M){var m=O.ensureError(M);m.phase="factory",m.moduleId=this.strId,this.error=m,f.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},d.prototype.onDependencyError=function(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1},d.prototype.isComplete=function(){return this._isComplete},d}();O.Module=P;var t=function(){function d(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return d.prototype.getMaxModuleId=function(){return this._nextId},d.prototype.getModuleId=function(l){var f=this._strModuleIdToIntModuleId.get(l);return typeof f=="undefined"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(l,f),this._intModuleIdToStrModuleId[f]=l),f},d.prototype.getStrModuleId=function(l){return this._intModuleIdToStrModuleId[l]},d}(),D=function(){function d(l){this.id=l}return d.EXPORTS=new d(0),d.MODULE=new d(1),d.REQUIRE=new d(2),d}();O.RegularDependency=D;var o=function(){function d(l,f,p){this.id=l,this.pluginId=f,this.pluginParam=p}return d}();O.PluginDependency=o;var A=function(){function d(l,f,p,M,v){v===void 0&&(v=0),this._env=l,this._scriptLoader=f,this._loaderAvailableTimestamp=v,this._defineFunc=p,this._requireFunc=M,this._moduleIdProvider=new t,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return d.prototype.reset=function(){return new d(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},d.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},d.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},d._findRelevantLocationInStack=function(l,f){for(var p=function(s){return s.replace(/\\/g,"/")},M=p(l),v=f.split(/\n/),m=0;m<v.length;m++){var e=v[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){var N=e[1],C=e[2],L=e[3],h=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(h),N=p(N),N===M){var i={line:parseInt(C,10),col:parseInt(L,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+l)},d.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var l=[],f=0,p=0,M=this._modules2.length;p<M;p++){var v=this._modules2[p];if(!!v){var m=this._buildInfoPath[v.id]||null,e=this._buildInfoDefineStack[v.id]||null,N=this._buildInfoDependencies[v.id];l[f++]={id:v.strId,path:m,defineLocation:m&&e?d._findRelevantLocationInStack(m,e):null,dependencies:N,shim:null,exports:v.exports}}}return l},d.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder},d.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},d.prototype.enqueueDefineAnonymousModule=function(l,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var p=null;this._config.isBuild()&&(p=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:p,dependencies:l,callback:f}},d.prototype.defineModule=function(l,f,p,M,v,m){var e=this;m===void 0&&(m=new n(l));var N=this._moduleIdProvider.getModuleId(l);if(this._modules2[N]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}var C=new P(N,l,this._normalizeDependencies(f,m),p,M,m);this._modules2[N]=C,this._config.isBuild()&&(this._buildInfoDefineStack[N]=v,this._buildInfoDependencies[N]=(C.dependencies||[]).map(function(L){return e._moduleIdProvider.getStrModuleId(L.id)})),this._resolve(C)},d.prototype._normalizeDependency=function(l,f){if(l==="exports")return D.EXPORTS;if(l==="module")return D.MODULE;if(l==="require")return D.REQUIRE;var p=l.indexOf("!");if(p>=0){var M=f.resolveModule(l.substr(0,p)),v=f.resolveModule(l.substr(p+1)),m=this._moduleIdProvider.getModuleId(M+"!"+v),e=this._moduleIdProvider.getModuleId(M);return new o(m,e,v)}return new D(this._moduleIdProvider.getModuleId(f.resolveModule(l)))},d.prototype._normalizeDependencies=function(l,f){for(var p=[],M=0,v=0,m=l.length;v<m;v++)p[M++]=this._normalizeDependency(l[v],f);return p},d.prototype._relativeRequire=function(l,f,p,M){if(typeof f=="string")return this.synchronousRequire(f,l);this.defineModule(O.Utilities.generateAnonymousModule(),f,p,M,null,l)},d.prototype.synchronousRequire=function(l,f){f===void 0&&(f=new n(l));var p=this._normalizeDependency(l,f),M=this._modules2[p.id];if(!M)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!M.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(M.error)throw M.error;return M.exports},d.prototype.configure=function(l,f){var p=this._config.shouldRecordStats();f?this._config=new O.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!p&&(this._recorder=null)},d.prototype.getConfig=function(){return this._config},d.prototype._onLoad=function(l){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),f.dependencies,f.callback,null,f.stack)}},d.prototype._createLoadError=function(l,f){var p=this,M=this._moduleIdProvider.getStrModuleId(l),v=(this._inverseDependencies2[l]||[]).map(function(e){return p._moduleIdProvider.getStrModuleId(e)}),m=O.ensureError(f);return m.phase="loading",m.moduleId=M,m.neededBy=v,m},d.prototype._onLoadError=function(l,f){var p=this._createLoadError(l,f);this._modules2[l]||(this._modules2[l]=new P(l,this._moduleIdProvider.getStrModuleId(l),[],function(){},null,null));for(var M=[],v=0,m=this._moduleIdProvider.getMaxModuleId();v<m;v++)M[v]=!1;var e=!1,N=[];for(N.push(l),M[l]=!0;N.length>0;){var C=N.shift(),L=this._modules2[C];L&&(e=L.onDependencyError(p)||e);var h=this._inverseDependencies2[C];if(h)for(var v=0,m=h.length;v<m;v++){var i=h[v];M[i]||(N.push(i),M[i]=!0)}}e||this._config.onError(p)},d.prototype._hasDependencyPath=function(l,f){var p=this._modules2[l];if(!p)return!1;for(var M=[],v=0,m=this._moduleIdProvider.getMaxModuleId();v<m;v++)M[v]=!1;var e=[];for(e.push(p),M[l]=!0;e.length>0;){var N=e.shift(),C=N.dependencies;if(C)for(var v=0,m=C.length;v<m;v++){var L=C[v];if(L.id===f)return!0;var h=this._modules2[L.id];h&&!M[L.id]&&(M[L.id]=!0,e.push(h))}}return!1},d.prototype._findCyclePath=function(l,f,p){if(l===f||p===50)return[l];var M=this._modules2[l];if(!M)return null;var v=M.dependencies;if(v)for(var m=0,e=v.length;m<e;m++){var N=this._findCyclePath(v[m].id,f,p+1);if(N!==null)return N.push(l),N}return null},d.prototype._createRequire=function(l){var f=this,p=function(M,v,m){return f._relativeRequire(l,M,v,m)};return p.toUrl=function(M){return f._config.requireToUrl(l.resolveModule(M))},p.getStats=function(){return f.getLoaderEvents()},p.hasDependencyCycle=function(){return f._hasDependencyCycle},p.config=function(M,v){v===void 0&&(v=!1),f.configure(M,v)},p.__$__nodeRequire=O.global.nodeRequire,p},d.prototype._loadModule=function(l){var f=this;if(!(this._modules2[l]||this._knownModules2[l])){this._knownModules2[l]=!0;var p=this._moduleIdProvider.getStrModuleId(l),M=this._config.moduleIdToPaths(p),v=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(p.indexOf("/")===-1||v.test(p))&&M.push("node|"+p);var m=-1,e=function(N){if(m++,m>=M.length)f._onLoadError(l,N);else{var C=M[m],L=f.getRecorder();if(f._config.isBuild()&&C==="empty:"){f._buildInfoPath[l]=C,f.defineModule(f._moduleIdProvider.getStrModuleId(l),[],null,null,null),f._onLoad(l);return}L.record(10,C),f._scriptLoader.load(f,C,function(){f._config.isBuild()&&(f._buildInfoPath[l]=C),L.record(11,C),f._onLoad(l)},function(h){L.record(12,C),e(h)})}};e(null)}},d.prototype._loadPluginDependency=function(l,f){var p=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var M=function(v){p.defineModule(p._moduleIdProvider.getStrModuleId(f.id),[],v,null,null)};M.error=function(v){p._config.onError(p._createLoadError(f.id,v))},l.load(f.pluginParam,this._createRequire(n.ROOT),M,this._config.getOptionsLiteral())}},d.prototype._resolve=function(l){var f=this,p=l.dependencies;if(p)for(var M=0,v=p.length;M<v;M++){var m=p[M];if(m===D.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(m===D.MODULE){l.unresolvedDependenciesCount--;continue}if(m===D.REQUIRE){l.unresolvedDependenciesCount--;continue}var e=this._modules2[m.id];if(e&&e.isComplete()){if(e.error){l.onDependencyError(e.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");var N=this._findCyclePath(m.id,l.id,0)||[];N.reverse(),N.push(m.id),console.warn(N.map(function(h){return f._moduleIdProvider.getStrModuleId(h)}).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(l.id),m instanceof o){var C=this._modules2[m.pluginId];if(C&&C.isComplete()){this._loadPluginDependency(C.exports,m);continue}var L=this._inversePluginDependencies2.get(m.pluginId);L||(L=[],this._inversePluginDependencies2.set(m.pluginId,L)),L.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)},d.prototype._onModuleComplete=function(l){var f=this,p=this.getRecorder();if(!l.isComplete()){var M=l.dependencies,v=[];if(M)for(var m=0,e=M.length;m<e;m++){var N=M[m];if(N===D.EXPORTS){v[m]=l.exports;continue}if(N===D.MODULE){v[m]={id:l.strId,config:function(){return f._config.getConfigForModule(l.strId)}};continue}if(N===D.REQUIRE){v[m]=this._createRequire(l.moduleIdResolver);continue}var C=this._modules2[N.id];if(C){v[m]=C.exports;continue}v[m]=null}l.complete(p,this._config,v);var L=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,L)for(var m=0,e=L.length;m<e;m++){var h=L[m],i=this._modules2[h];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var s=this._inversePluginDependencies2.get(l.id);if(s){this._inversePluginDependencies2.delete(l.id);for(var m=0,e=s.length;m<e;m++)this._loadPluginDependency(l.exports,s[m])}}},d}();O.ModuleManager=A})(ce||(ce={}));var x,ce;(function(O){var n=new O.Environment,P=null,t=function(d,l,f){typeof d!="string"&&(f=l,l=d,d=null),(typeof l!="object"||!Array.isArray(l))&&(f=l,l=null),l||(l=["require","exports","module"]),d?P.defineModule(d,l,f,null,null):P.enqueueDefineAnonymousModule(l,f)};t.amd={jQuery:!0};var D=function(d,l){l===void 0&&(l=!1),P.configure(d,l)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){D(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=D,o.getConfig=function(){return P.getConfig().getOptionsLiteral()},o.reset=function(){P=P.reset()},o.getBuildInfo=function(){return P.getBuildInfo()},o.getStats=function(){return P.getLoaderEvents()},o.define=t;function A(){if(typeof O.global.require!="undefined"||typeof require!="undefined"){var d=O.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){var l=O.ensureRecordedNodeRequire(P.getRecorder(),d);O.global.nodeRequire=l,o.nodeRequire=l,o.__$__nodeRequire=l}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=o,require=o):(n.isElectronRenderer||(O.global.define=t),O.global.require=o)}O.init=A,(typeof O.global.define!="function"||!O.global.define.amd)&&(P=new O.ModuleManager(n,O.createScriptLoader(n),t,o,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require!="undefined"&&typeof O.global.require!="function"&&o.config(O.global.require),x=function(){return t.apply(null,arguments)},x.amd=t.amd,typeof doNotInitLoader=="undefined"&&A())})(ce||(ce={}));var Se=this,ye;(function(O){var n=Se||{},P=n.Plugin&&n.Plugin.Resources?n.Plugin.Resources:void 0,t=n&&n.document&&n.document.location&&n.document.location.hash.indexOf("pseudo=true")>=0;function D(f,p){var M;return p.length===0?M=f:M=f.replace(/\{(\d+)\}/g,function(v,m){var e=m[0];return typeof p[e]!="undefined"?p[e]:v}),t&&(M="\uFF3B"+M.replace(/[aouei]/g,"$&$&")+"\uFF3D"),M}function o(f,p){var M=f[p];return M||(M=f["*"],M)?M:null}function A(f,p){for(var M=[],v=0;v<arguments.length-2;v++)M[v]=arguments[v+2];return D(p,M)}function d(f){return function(p,M){var v=Array.prototype.slice.call(arguments,2);return D(f[p],v)}}var l=function(){function f(){this.localize=A}return f.prototype.setPseudoTranslation=function(p){t=p},f.prototype.create=function(p,M){return{localize:d(M[p])}},f.prototype.load=function(p,M,v,m){if(m=m||{},!p||p.length===0)v({localize:A});else{var e=void 0;if(P&&P.getString)e=".nls.keys",M([p+e],function(L){v({localize:function(h,i){if(!L[h])return"NLS error: unknown key "+h;var s=L[h].keys;if(i>=s.length)return"NLS error unknown index "+i;var a=s[i],u=[];u[0]=h+"_"+a;for(var b=0;b<arguments.length-2;b++)u[b+1]=arguments[b+2];return P.getString.apply(P,u)}})});else if(m.isBuild)M([p+".nls",p+".nls.keys"],function(L,h){f.BUILD_MAP[p]=L,f.BUILD_MAP_KEYS[p]=h,v(L)});else{var N=m["vs/nls"]||{},C=N.availableLanguages?o(N.availableLanguages,p):null;e=".nls",C!==null&&C!==f.DEFAULT_TAG&&(e=e+"."+C),M([p+e],function(L){Array.isArray(L)?L.localize=d(L):L.localize=d(L[p]),v(L)})}}},f.prototype._getEntryPointsMap=function(){return n.nlsPluginEntryPoints=n.nlsPluginEntryPoints||{},n.nlsPluginEntryPoints},f.prototype.write=function(p,M,v){var m=v.getEntryPoint(),e=this._getEntryPointsMap();e[m]=e[m]||[],e[m].push(M),M!==m&&v.asModule(p+"!"+M,"define(['vs/nls', 'vs/nls!"+m+`'], function(nls, data) { return nls.create("`+M+'", data); });')},f.prototype.writeFile=function(p,M,v,m,e){var N=this._getEntryPointsMap();if(N.hasOwnProperty(M)){for(var C=v.toUrl(M+".nls.js"),L=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],h=N[M],i={},s=0;s<h.length;s++)i[h[s]]=f.BUILD_MAP[h[s]];L.push('define("'+M+'.nls", '+JSON.stringify(i,null,"	")+");"),m(C,L.join(`\r
`))}},f.prototype.finishBuild=function(p){p("nls.metadata.json",JSON.stringify({keys:f.BUILD_MAP_KEYS,messages:f.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},f.DEFAULT_TAG="i-default",f.BUILD_MAP={},f.BUILD_MAP_KEYS={},f}();O.NLSPlugin=l,function(){x("vs/nls",new l)}()})(ye||(ye={})),x(ee[17],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.getClassNamesArray=n.Codicon=n.getCodiconAriaLabel=void 0;function P(A){return A?A.replace(/\$\((.*?)\)/g,(d,l)=>` ${l} `).trim():""}n.getCodiconAriaLabel=P;class t{constructor(d,l,f){this.id=d,this.definition=l,this.description=f,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}n.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(A,d){const l=["codicon","codicon-"+A];return d&&l.push("codicon-modifier-"+d),l}n.getClassNamesArray=D;var o;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const d=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function l(M){if(M instanceof t)return["codicon","codicon-"+M.id];const v=d.exec(M.id);if(!v)return l(t.error);let[,m,e]=v;const N=["codicon","codicon-"+m];return e&&N.push("codicon-modifier-"+e.substr(1)),N}A.asClassNameArray=l;function f(M){return l(M).join(" ")}A.asClassName=f;function p(M){return"."+l(M).join(".")}A.asCSSSelector=p})(o=n.CSSIcon||(n.CSSIcon={}))}),x(ee[18],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class P{constructor(D,o,A,d){this.originalStart=D,this.originalLength=o,this.modifiedStart=A,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=P}),x(ee[8],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createErrorWithActions=n.isErrorWithActions=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(b=>{b(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}n.ErrorHandler=P,n.errorHandler=new P;function t(a){n.errorHandler.setUnexpectedErrorHandler(a)}n.setUnexpectedErrorHandler=t;function D(a){l(a)||n.errorHandler.onUnexpectedError(a)}n.onUnexpectedError=D;function o(a){l(a)||n.errorHandler.onUnexpectedExternalError(a)}n.onUnexpectedExternalError=o;function A(a){if(a instanceof Error){let{name:u,message:b}=a;const _=a.stacktrace||a.stack;return{$isError:!0,name:u,message:b,stack:_}}return a}n.transformErrorForSerialization=A;const d="Canceled";function l(a){return a instanceof f?!0:a instanceof Error&&a.name===d&&a.message===d}n.isCancellationError=l;class f extends Error{constructor(){super(d);this.name=this.message}}n.CancellationError=f;function p(){const a=new Error(d);return a.name=a.message,a}n.canceled=p;function M(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}n.illegalArgument=M;function v(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}n.illegalState=v;function m(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=m;function e(a){const u=new Error(`${a} has been disposed`);return u.name="DISPOSED",u}n.disposed=e;function N(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}n.getErrorMessage=N;class C extends Error{constructor(u){super("NotImplemented");u&&(this.message=u)}}n.NotImplementedError=C;class L extends Error{constructor(u){super("NotSupported");u&&(this.message=u)}}n.NotSupportedError=L;class h extends Error{constructor(){super(...arguments);this.isExpected=!0}}n.ExpectedError=h;function i(a){const u=a;return u instanceof Error&&Array.isArray(u.actions)}n.isErrorWithActions=i;function s(a,u=Object.create(null)){const b=new Error(a);return u.actions&&(b.actions=u.actions),b}n.createErrorWithActions=s}),x(ee[19],te([0,1,8]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch=n.equals=n.tail2=n.tail=void 0;function t(I,U=0){return I[I.length-(1+U)]}n.tail=t;function D(I){if(I.length===0)throw new Error("Invalid tail call");return[I.slice(0,I.length-1),I[I.length-1]]}n.tail2=D;function o(I,U,B=(q,z)=>q===z){if(I===U)return!0;if(!I||!U||I.length!==U.length)return!1;for(let q=0,z=I.length;q<z;q++)if(!B(I[q],U[q]))return!1;return!0}n.equals=o;function A(I,U,B){let q=0,z=I.length-1;for(;q<=z;){const se=(q+z)/2|0,ae=B(I[se],U);if(ae<0)q=se+1;else if(ae>0)z=se-1;else return se}return-(q+1)}n.binarySearch=A;function d(I,U){let B=0,q=I.length;if(q===0)return 0;for(;B<q;){const z=Math.floor((B+q)/2);U(I[z])?q=z:B=z+1}return B}n.findFirstInSorted=d;function l(I,U,B){if(I=I|0,I>=U.length)throw new TypeError("invalid index");let q=U[Math.floor(U.length*Math.random())],z=[],se=[],ae=[];for(let he of U){const de=B(he,q);de<0?z.push(he):de>0?se.push(he):ae.push(he)}return I<z.length?l(I,z,B):I<z.length+ae.length?ae[0]:l(I-(z.length+ae.length),se,B)}n.quickSelect=l;function f(I,U){const B=[];let q;for(const z of I.slice(0).sort(U))!q||U(q[0],z)!==0?(q=[z],B.push(q)):q.push(z);return B}n.groupBy=f;function p(I,U,B){const q=[];function z(he,de,ge){if(de===0&&ge.length===0)return;const me=q[q.length-1];me&&me.start+me.deleteCount===he?(me.deleteCount+=de,me.toInsert.push(...ge)):q.push({start:he,deleteCount:de,toInsert:ge})}let se=0,ae=0;for(;;){if(se===I.length){z(se,0,U.slice(ae));break}if(ae===U.length){z(se,I.length-se,[]);break}const he=I[se],de=U[ae],ge=B(he,de);ge===0?(se+=1,ae+=1):ge<0?(z(se,1,[]),se+=1):ge>0&&(z(se,0,[de]),ae+=1)}return q}n.sortedDiff=p;function M(I,U,B){const q=p(I,U,B),z=[],se=[];for(const ae of q)z.push(...I.slice(ae.start,ae.start+ae.deleteCount)),se.push(...ae.toInsert);return{removed:z,added:se}}n.delta=M;function v(I,U,B){if(B===0)return[];const q=I.slice(0,B).sort(U);return e(I,U,q,B,I.length),q}n.top=v;function m(I,U,B,q,z){return B===0?Promise.resolve([]):new Promise((se,ae)=>{(async()=>{const he=I.length,de=I.slice(0,B).sort(U);for(let ge=B,me=Math.min(B+q,he);ge<he;ge=me,me=Math.min(me+q,he)){if(ge>B&&await new Promise(Ae=>setTimeout(Ae)),z&&z.isCancellationRequested)throw(0,P.canceled)();e(I,U,de,ge,me)}return de})().then(se,ae)})}n.topAsync=m;function e(I,U,B,q,z){for(const se=B.length;q<z;q++){const ae=I[q];if(U(ae,B[se-1])<0){B.pop();const he=d(B,de=>U(ae,de)<0);B.splice(he,0,ae)}}}function N(I){return I.filter(U=>!!U)}n.coalesce=N;function C(I){let U=0;for(let B=0;B<I.length;B++)I[B]&&(I[U]=I[B],U+=1);I.length=U}n.coalesceInPlace=C;function L(I,U,B){I.splice(B,0,I.splice(U,1)[0])}n.move=L;function h(I){return!Array.isArray(I)||I.length===0}n.isFalsyOrEmpty=h;function i(I){return Array.isArray(I)&&I.length>0}n.isNonEmptyArray=i;function s(I,U=B=>B){const B=new Set;return I.filter(q=>{const z=U(q);return B.has(z)?!1:(B.add(z),!0)})}n.distinct=s;function a(I){const U=new Set;return B=>{const q=I(B);return U.has(q)?!1:(U.add(q),!0)}}n.uniqueFilter=a;function u(I,U){const B=b(I,U);if(B!==-1)return I[B]}n.findLast=u;function b(I,U){for(let B=I.length-1;B>=0;B--){const q=I[B];if(U(q))return B}return-1}n.lastIndex=b;function _(I,U){return I.length>0?I[0]:U}n.firstOrDefault=_;function c(I,U,B=(q,z)=>q===z){let q=0;for(let z=0,se=Math.min(I.length,U.length);z<se&&B(I[z],U[z]);z++)q++;return q}n.commonPrefixLength=c;function g(I){return[].concat(...I)}n.flatten=g;function w(I,U){let B=typeof U=="number"?I:0;typeof U=="number"?B=I:(B=0,U=I);const q=[];if(B<=U)for(let z=B;z<U;z++)q.push(z);else for(let z=B;z>U;z--)q.push(z);return q}n.range=w;function y(I,U,B){return I.reduce((q,z)=>(q[U(z)]=B?B(z):z,q),Object.create(null))}n.index=y;function S(I,U){return I.push(U),()=>R(I,U)}n.insert=S;function R(I,U){const B=I.indexOf(U);if(B>-1)return I.splice(B,1),U}n.remove=R;function W(I,U,B){const q=I.slice(0,U),z=I.slice(U);return q.concat(B,z)}n.arrayInsert=W;function H(I,U){let B;if(typeof U=="number"){let q=U;B=()=>{const z=Math.sin(q++)*179426549;return z-Math.floor(z)}}else B=Math.random;for(let q=I.length-1;q>0;q-=1){const z=Math.floor(B()*(q+1)),se=I[q];I[q]=I[z],I[z]=se}}n.shuffle=H;function j(I,U){const B=I.indexOf(U);B>-1&&(I.splice(B,1),I.unshift(U))}n.pushToStart=j;function E(I,U){const B=I.indexOf(U);B>-1&&(I.splice(B,1),I.push(U))}n.pushToEnd=E;function T(I,U){return Array.isArray(I)?I.map(U):U(I)}n.mapArrayOrNot=T;function ne(I){return Array.isArray(I)?I:[I]}n.asArray=ne;function G(I){return I[Math.floor(Math.random()*I.length)]}n.getRandomElement=G;function J(I,U){for(const B of I){const q=U(B);if(q!==void 0)return q}}n.mapFind=J;function r(I,U,B){const q=be(I,U),z=I.length,se=B.length;I.length=z+se;for(let ae=z-1;ae>=q;ae--)I[ae+se]=I[ae];for(let ae=0;ae<se;ae++)I[ae+q]=B[ae]}n.insertInto=r;function le(I,U,B,q){const z=be(I,U),se=I.splice(z,B);return r(I,z,q),se}n.splice=le;function be(I,U){return U<0?Math.max(U+I.length,0):Math.min(U,I.length)}function K(I,U){return(B,q)=>U(I(B),I(q))}n.compareBy=K;const Y=(I,U)=>I-U;n.numberComparator=Y;function Z(I,U){if(I.length===0)return;let B=I[0];for(let q=1;q<I.length;q++){const z=I[q];U(z,B)>0&&(B=z)}return B}n.findMaxBy=Z;function X(I,U){if(I.length===0)return;let B=I[0];for(let q=1;q<I.length;q++){const z=I[q];U(z,B)>=0&&(B=z)}return B}n.findLastMaxBy=X;function ie(I,U){return Z(I,(B,q)=>-U(B,q))}n.findMinBy=ie;class re{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let B=this.firstIdx;for(;B<this.items.length&&U(this.items[B]);)B++;const q=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,q}takeFromEndWhile(U){let B=this.lastIdx;for(;B>=0&&U(this.items[B]);)B--;const q=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,q}peek(){return this.items[this.firstIdx]}dequeue(){const U=this.items[this.firstIdx];return this.firstIdx++,U}takeCount(U){const B=this.items.slice(this.firstIdx,this.firstIdx+U);return this.firstIdx+=U,B}}n.ArrayQueue=re}),x(ee[11],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function P(t){const D=this;let o=!1,A;return function(){return o||(o=!0,A=t.apply(D,arguments)),A}}n.once=P}),x(ee[20],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var P;(function(t){function D(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}t.is=D;const o=Object.freeze([]);function A(){return o}t.empty=A;function*d(a){yield a}t.single=d;function l(a){return a||o}t.from=l;function f(a){return!a||a[Symbol.iterator]().next().done===!0}t.isEmpty=f;function p(a){return a[Symbol.iterator]().next().value}t.first=p;function M(a,u){for(const b of a)if(u(b))return!0;return!1}t.some=M;function v(a,u){for(const b of a)if(u(b))return b}t.find=v;function*m(a,u){for(const b of a)u(b)&&(yield b)}t.filter=m;function*e(a,u){let b=0;for(const _ of a)yield u(_,b++)}t.map=e;function*N(...a){for(const u of a)for(const b of u)yield b}t.concat=N;function*C(a){for(const u of a)for(const b of u)yield b}t.concatNested=C;function L(a,u,b){let _=b;for(const c of a)_=u(_,c);return _}t.reduce=L;function*h(a,u,b=a.length){for(u<0&&(u+=a.length),b<0?b+=a.length:b>a.length&&(b=a.length);u<b;u++)yield a[u]}t.slice=h;function i(a,u=Number.POSITIVE_INFINITY){const b=[];if(u===0)return[b,a];const _=a[Symbol.iterator]();for(let c=0;c<u;c++){const g=_.next();if(g.done)return[b,t.empty()];b.push(g.value)}return[b,{[Symbol.iterator](){return _}}]}t.consume=i;function s(a,u,b=(_,c)=>_===c){const _=a[Symbol.iterator](),c=u[Symbol.iterator]();for(;;){const g=_.next(),w=c.next();if(g.done!==w.done)return!1;if(g.done)return!0;if(!b(g.value,w.value))return!1}}t.equals=s})(P=n.Iterable||(n.Iterable={}))}),x(ee[21],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.MAX_VALUE=126]="MAX_VALUE"})(P=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,C){this._keyCodeToStr[N]=C,this._strToKeyCode[C.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const o=new D,A=new D,d=new D;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const l=[],f=Object.create(null),p=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>p[e]||0,toEnum:e=>f[e]||0,toString:e=>l[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=126;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",N=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",0,e,0,e,e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_CLEAR",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let C=[],L=[];for(const h of N){const[i,s,a,u,b,_,c,g,w,y]=h;if(L[a]||(L[a]=!0,l[a]=u,f[u]=a,p[u.toLowerCase()]=a,s&&(n.IMMUTABLE_CODE_TO_KEY_CODE[a]=b,b!==0&&b!==3&&b!==5&&b!==4&&b!==6&&b!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[b]=a))),!C[b]){if(C[b]=!0,!_)throw new Error(`String representation missing for key code ${b} around scan code ${u}`);o.define(b,_),A.define(b,w||_),d.define(b,y||w||_)}c&&(n.EVENT_KEY_CODE_MAP[c]=b),g&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[g]=b)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(e){function N(a){return o.keyCodeToStr(a)}e.toString=N;function C(a){return o.strToKeyCode(a)}e.fromString=C;function L(a){return A.keyCodeToStr(a)}e.toUserSettingsUS=L;function h(a){return d.keyCodeToStr(a)}e.toUserSettingsGeneral=h;function i(a){return A.strToKeyCode(a)||d.strToKeyCode(a)}e.fromUserSettings=i;function s(a){if(a>=93&&a<=108)return null;switch(a){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(a)}e.toElectronAccelerator=s})(M=n.KeyCodeUtils||(n.KeyCodeUtils={}));var v;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(v=n.KeyMod||(n.KeyMod={}));function m(e,N){const C=(N&65535)<<16>>>0;return(e|C)>>>0}n.KeyChord=m}),x(ee[22],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class P{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new P(()=>D(this.getValue()))}}n.Lazy=P}),x(ee[9],te([0,1,11,20]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const D=!1;let o=null;function A(c){o=c}if(n.setDisposableTracker=A,D){const c="__is_disposable_tracked__";A(new class{trackDisposable(g){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[c]||console.log(w)},3e3)}setParent(g,w){if(g&&g!==h.None)try{g[c]=!0}catch{}}markAsDisposed(g){if(g&&g!==h.None)try{g[c]=!0}catch{}}markAsSingleton(g){}})}function d(c){return o?.trackDisposable(c),c}function l(c){o?.markAsDisposed(c)}function f(c,g){o?.setParent(c,g)}function p(c,g){if(!!o)for(const w of c)o.setParent(w,g)}function M(c){return o?.markAsSingleton(c),c}n.markAsSingleton=M;class v extends Error{constructor(g){super(`Encountered errors while disposing of store. Errors: [${g.join(", ")}]`);this.errors=g}}n.MultiDisposeError=v;function m(c){return typeof c.dispose=="function"&&c.dispose.length===0}n.isDisposable=m;function e(c){if(t.Iterable.is(c)){let g=[];for(const w of c)if(w)try{w.dispose()}catch(y){g.push(y)}if(g.length===1)throw g[0];if(g.length>1)throw new v(g);return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}n.dispose=e;function N(...c){const g=C(()=>e(c));return p(c,g),g}n.combinedDisposable=N;function C(c){const g=d({dispose:(0,P.once)(()=>{l(g),c()})});return g}n.toDisposable=C;class L{constructor(){this._toDispose=new Set,this._isDisposed=!1,d(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return f(g,this),this._isDisposed?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}n.DisposableStore=L,L.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new L,d(this),f(this._store,this)}dispose(){l(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}n.Disposable=h,h.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,d(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){this._isDisposed||g===this._value||(this._value?.dispose(),g&&f(g,this),this._value=g)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,l(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const g=this._value;return this._value=void 0,g&&f(g,null),g}}n.MutableDisposable=i;class s{constructor(g){this._disposable=g,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}n.RefCountedDisposable=s;class a{constructor(){this.references=new Map}acquire(g,...w){let y=this.references.get(g);y||(y={counter:0,object:this.createReferencedObject(g,...w)},this.references.set(g,y));const{object:S}=y,R=(0,P.once)(()=>{--y.counter==0&&(this.destroyReferencedObject(g,y.object),this.references.delete(g))});return y.counter++,{object:S,dispose:R}}}n.ReferenceCollection=a;class u{constructor(g){this.referenceCollection=g}async acquire(g,...w){const y=this.referenceCollection.acquire(g,...w);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(S){throw y.dispose(),S}}}n.AsyncReferenceCollection=u;class b{constructor(g){this.object=g}dispose(){}}n.ImmortalReference=b;function _(c){const g=new L;try{c(g)}finally{g.dispose()}}n.disposeOnReturn=_}),x(ee[23],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class P{constructor(o){this.element=o,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class t{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let o=this._first;for(;o!==P.Undefined;){const A=o.next;o.prev=P.Undefined,o.next=P.Undefined,o=A}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(o){return this._insert(o,!1)}push(o){return this._insert(o,!0)}_insert(o,A){const d=new P(o);if(this._first===P.Undefined)this._first=d,this._last=d;else if(A){const f=this._last;this._last=d,d.prev=f,f.next=d}else{const f=this._first;this._first=d,d.next=f,f.prev=d}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(d))}}shift(){if(this._first!==P.Undefined){const o=this._first.element;return this._remove(this._first),o}}pop(){if(this._last!==P.Undefined){const o=this._last.element;return this._remove(this._last),o}}_remove(o){if(o.prev!==P.Undefined&&o.next!==P.Undefined){const A=o.prev;A.next=o.next,o.next.prev=A}else o.prev===P.Undefined&&o.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):o.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):o.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let o=this._first;for(;o!==P.Undefined;)yield o.element,o=o.next}}n.LinkedList=t}),x(ee[5],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isIOS=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.isElectronSandboxed=n.globals=void 0;const P="en";let t=!1,D=!1,o=!1,A=!1,d=!1,l=!1,f=!1,p=!1,M=!1,v,m=P,e,N;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let C;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?C=n.globals.vscode.process:typeof process!="undefined"&&(C=process);const L=typeof C?.versions?.electron=="string",h=L&&C?.type==="renderer";if(n.isElectronSandboxed=h&&C?.sandboxed,typeof navigator=="object"&&!h)N=navigator.userAgent,t=N.indexOf("Windows")>=0,D=N.indexOf("Macintosh")>=0,p=(N.indexOf("Macintosh")>=0||N.indexOf("iPad")>=0||N.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=N.indexOf("Linux")>=0,l=!0,v=navigator.language,m=v;else if(typeof C=="object"){t=C.platform==="win32",D=C.platform==="darwin",o=C.platform==="linux",A=o&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,f=L,M=!!C.env.CI||!!C.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=P,m=P;const w=C.env.VSCODE_NLS_CONFIG;if(w)try{const y=JSON.parse(w),S=y.availableLanguages["*"];v=y.locale,m=S||P,e=y._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");var i;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(i=n.Platform||(n.Platform={}));function s(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=s;let a=0;D?a=1:t?a=3:o&&(a=2),n.isWindows=t,n.isMacintosh=D,n.isLinux=o,n.isLinuxSnap=A,n.isNative=d,n.isElectron=f,n.isWeb=l,n.isIOS=p,n.isCI=M,n.platform=a,n.userAgent=N,n.language=m;var u;(function(w){function y(){return n.language}w.value=y;function S(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}w.isDefaultVariant=S;function R(){return n.language==="en"}w.isDefault=R})(u=n.Language||(n.Language={})),n.locale=v,n.translationsConfigFile=e,n.setTimeout0=(()=>{if(typeof n.globals.postMessage=="function"&&!n.globals.importScripts){let w=[];n.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let R=0,W=w.length;R<W;R++){const H=w[R];if(H.id===S.data.vscodeScheduleAsyncWork){w.splice(R,1),H.callback();return}}});let y=0;return S=>{const R=++y;w.push({id:R,callback:S}),n.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return w=>setTimeout(w)})();var b;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(b=n.OperatingSystem||(n.OperatingSystem={})),n.OS=D||p?2:t?1:3;let _=!0,c=!1;function g(){if(!c){c=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,_=new Uint16Array(w.buffer)[0]===(2<<8)+1}return _}n.isLittleEndian=g,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),x(ee[24],te([0,1,5]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof P.globals.vscode!="undefined"&&typeof P.globals.vscode.process!="undefined"){const D=P.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),x(ee[25],te([0,1,24]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,D=97,o=90,A=122,d=46,l=47,f=92,p=58,M=63;class v extends Error{constructor(s,a,u){let b;typeof a=="string"&&a.indexOf("not ")===0?(b="must not be",a=a.replace(/^not /,"")):b="must be";const _=s.indexOf(".")!==-1?"property":"argument";let c=`The "${s}" ${_} ${b} of type ${a}`;c+=`. Received type ${typeof u}`;super(c);this.code="ERR_INVALID_ARG_TYPE"}}function m(i,s){if(typeof i!="string")throw new v(s,"string",i)}function e(i){return i===l||i===f}function N(i){return i===l}function C(i){return i>=t&&i<=o||i>=D&&i<=A}function L(i,s,a,u){let b="",_=0,c=-1,g=0,w=0;for(let y=0;y<=i.length;++y){if(y<i.length)w=i.charCodeAt(y);else{if(u(w))break;w=l}if(u(w)){if(!(c===y-1||g===1))if(g===2){if(b.length<2||_!==2||b.charCodeAt(b.length-1)!==d||b.charCodeAt(b.length-2)!==d){if(b.length>2){const S=b.lastIndexOf(a);S===-1?(b="",_=0):(b=b.slice(0,S),_=b.length-1-b.lastIndexOf(a)),c=y,g=0;continue}else if(b.length!==0){b="",_=0,c=y,g=0;continue}}s&&(b+=b.length>0?`${a}..`:"..",_=2)}else b.length>0?b+=`${a}${i.slice(c+1,y)}`:b=i.slice(c+1,y),_=y-c-1;c=y,g=0}else w===d&&g!==-1?++g:g=-1}return b}function h(i,s){if(s===null||typeof s!="object")throw new v("pathObject","Object",s);const a=s.dir||s.root,u=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${u}`:`${a}${i}${u}`:u}n.win32={resolve(...i){let s="",a="",u=!1;for(let b=i.length-1;b>=-1;b--){let _;if(b>=0){if(_=i[b],m(_,"path"),_.length===0)continue}else s.length===0?_=P.cwd():(_=P.env[`=${s}`]||P.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==s.toLowerCase()&&_.charCodeAt(2)===f)&&(_=`${s}\\`));const c=_.length;let g=0,w="",y=!1;const S=_.charCodeAt(0);if(c===1)e(S)&&(g=1,y=!0);else if(e(S))if(y=!0,e(_.charCodeAt(1))){let R=2,W=R;for(;R<c&&!e(_.charCodeAt(R));)R++;if(R<c&&R!==W){const H=_.slice(W,R);for(W=R;R<c&&e(_.charCodeAt(R));)R++;if(R<c&&R!==W){for(W=R;R<c&&!e(_.charCodeAt(R));)R++;(R===c||R!==W)&&(w=`\\\\${H}\\${_.slice(W,R)}`,g=R)}}}else g=1;else C(S)&&_.charCodeAt(1)===p&&(w=_.slice(0,2),g=2,c>2&&e(_.charCodeAt(2))&&(y=!0,g=3));if(w.length>0)if(s.length>0){if(w.toLowerCase()!==s.toLowerCase())continue}else s=w;if(u){if(s.length>0)break}else if(a=`${_.slice(g)}\\${a}`,u=y,y&&s.length>0)break}return a=L(a,!u,"\\",e),u?`${s}\\${a}`:`${s}${a}`||"."},normalize(i){m(i,"path");const s=i.length;if(s===0)return".";let a=0,u,b=!1;const _=i.charCodeAt(0);if(s===1)return N(_)?"\\":i;if(e(_))if(b=!0,e(i.charCodeAt(1))){let g=2,w=g;for(;g<s&&!e(i.charCodeAt(g));)g++;if(g<s&&g!==w){const y=i.slice(w,g);for(w=g;g<s&&e(i.charCodeAt(g));)g++;if(g<s&&g!==w){for(w=g;g<s&&!e(i.charCodeAt(g));)g++;if(g===s)return`\\\\${y}\\${i.slice(w)}\\`;g!==w&&(u=`\\\\${y}\\${i.slice(w,g)}`,a=g)}}}else a=1;else C(_)&&i.charCodeAt(1)===p&&(u=i.slice(0,2),a=2,s>2&&e(i.charCodeAt(2))&&(b=!0,a=3));let c=a<s?L(i.slice(a),!b,"\\",e):"";return c.length===0&&!b&&(c="."),c.length>0&&e(i.charCodeAt(s-1))&&(c+="\\"),u===void 0?b?`\\${c}`:c:b?`${u}\\${c}`:`${u}${c}`},isAbsolute(i){m(i,"path");const s=i.length;if(s===0)return!1;const a=i.charCodeAt(0);return e(a)||s>2&&C(a)&&i.charCodeAt(1)===p&&e(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,a;for(let _=0;_<i.length;++_){const c=i[_];m(c,"path"),c.length>0&&(s===void 0?s=a=c:s+=`\\${c}`)}if(s===void 0)return".";let u=!0,b=0;if(typeof a=="string"&&e(a.charCodeAt(0))){++b;const _=a.length;_>1&&e(a.charCodeAt(1))&&(++b,_>2&&(e(a.charCodeAt(2))?++b:u=!1))}if(u){for(;b<s.length&&e(s.charCodeAt(b));)b++;b>=2&&(s=`\\${s.slice(b)}`)}return n.win32.normalize(s)},relative(i,s){if(m(i,"from"),m(s,"to"),i===s)return"";const a=n.win32.resolve(i),u=n.win32.resolve(s);if(a===u||(i=a.toLowerCase(),s=u.toLowerCase(),i===s))return"";let b=0;for(;b<i.length&&i.charCodeAt(b)===f;)b++;let _=i.length;for(;_-1>b&&i.charCodeAt(_-1)===f;)_--;const c=_-b;let g=0;for(;g<s.length&&s.charCodeAt(g)===f;)g++;let w=s.length;for(;w-1>g&&s.charCodeAt(w-1)===f;)w--;const y=w-g,S=c<y?c:y;let R=-1,W=0;for(;W<S;W++){const j=i.charCodeAt(b+W);if(j!==s.charCodeAt(g+W))break;j===f&&(R=W)}if(W!==S){if(R===-1)return u}else{if(y>S){if(s.charCodeAt(g+W)===f)return u.slice(g+W+1);if(W===2)return u.slice(g+W)}c>S&&(i.charCodeAt(b+W)===f?R=W:W===2&&(R=3)),R===-1&&(R=0)}let H="";for(W=b+R+1;W<=_;++W)(W===_||i.charCodeAt(W)===f)&&(H+=H.length===0?"..":"\\..");return g+=R,H.length>0?`${H}${u.slice(g,w)}`:(u.charCodeAt(g)===f&&++g,u.slice(g,w))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const s=n.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===f){if(s.charCodeAt(1)===f){const a=s.charCodeAt(2);if(a!==M&&a!==d)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(C(s.charCodeAt(0))&&s.charCodeAt(1)===p&&s.charCodeAt(2)===f)return`\\\\?\\${s}`;return i},dirname(i){m(i,"path");const s=i.length;if(s===0)return".";let a=-1,u=0;const b=i.charCodeAt(0);if(s===1)return e(b)?i:".";if(e(b)){if(a=u=1,e(i.charCodeAt(1))){let g=2,w=g;for(;g<s&&!e(i.charCodeAt(g));)g++;if(g<s&&g!==w){for(w=g;g<s&&e(i.charCodeAt(g));)g++;if(g<s&&g!==w){for(w=g;g<s&&!e(i.charCodeAt(g));)g++;if(g===s)return i;g!==w&&(a=u=g+1)}}}}else C(b)&&i.charCodeAt(1)===p&&(a=s>2&&e(i.charCodeAt(2))?3:2,u=a);let _=-1,c=!0;for(let g=s-1;g>=u;--g)if(e(i.charCodeAt(g))){if(!c){_=g;break}}else c=!1;if(_===-1){if(a===-1)return".";_=a}return i.slice(0,_)},basename(i,s){s!==void 0&&m(s,"ext"),m(i,"path");let a=0,u=-1,b=!0,_;if(i.length>=2&&C(i.charCodeAt(0))&&i.charCodeAt(1)===p&&(a=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let c=s.length-1,g=-1;for(_=i.length-1;_>=a;--_){const w=i.charCodeAt(_);if(e(w)){if(!b){a=_+1;break}}else g===-1&&(b=!1,g=_+1),c>=0&&(w===s.charCodeAt(c)?--c==-1&&(u=_):(c=-1,u=g))}return a===u?u=g:u===-1&&(u=i.length),i.slice(a,u)}for(_=i.length-1;_>=a;--_)if(e(i.charCodeAt(_))){if(!b){a=_+1;break}}else u===-1&&(b=!1,u=_+1);return u===-1?"":i.slice(a,u)},extname(i){m(i,"path");let s=0,a=-1,u=0,b=-1,_=!0,c=0;i.length>=2&&i.charCodeAt(1)===p&&C(i.charCodeAt(0))&&(s=u=2);for(let g=i.length-1;g>=s;--g){const w=i.charCodeAt(g);if(e(w)){if(!_){u=g+1;break}continue}b===-1&&(_=!1,b=g+1),w===d?a===-1?a=g:c!==1&&(c=1):a!==-1&&(c=-1)}return a===-1||b===-1||c===0||c===1&&a===b-1&&a===u+1?"":i.slice(a,b)},format:h.bind(null,"\\"),parse(i){m(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.length;let u=0,b=i.charCodeAt(0);if(a===1)return e(b)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(e(b)){if(u=1,e(i.charCodeAt(1))){let R=2,W=R;for(;R<a&&!e(i.charCodeAt(R));)R++;if(R<a&&R!==W){for(W=R;R<a&&e(i.charCodeAt(R));)R++;if(R<a&&R!==W){for(W=R;R<a&&!e(i.charCodeAt(R));)R++;R===a?u=R:R!==W&&(u=R+1)}}}}else if(C(b)&&i.charCodeAt(1)===p){if(a<=2)return s.root=s.dir=i,s;if(u=2,e(i.charCodeAt(2))){if(a===3)return s.root=s.dir=i,s;u=3}}u>0&&(s.root=i.slice(0,u));let _=-1,c=u,g=-1,w=!0,y=i.length-1,S=0;for(;y>=u;--y){if(b=i.charCodeAt(y),e(b)){if(!w){c=y+1;break}continue}g===-1&&(w=!1,g=y+1),b===d?_===-1?_=y:S!==1&&(S=1):_!==-1&&(S=-1)}return g!==-1&&(_===-1||S===0||S===1&&_===g-1&&_===c+1?s.base=s.name=i.slice(c,g):(s.name=i.slice(c,_),s.base=i.slice(c,g),s.ext=i.slice(_,g))),c>0&&c!==u?s.dir=i.slice(0,c-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...i){let s="",a=!1;for(let u=i.length-1;u>=-1&&!a;u--){const b=u>=0?i[u]:P.cwd();m(b,"path"),b.length!==0&&(s=`${b}/${s}`,a=b.charCodeAt(0)===l)}return s=L(s,!a,"/",N),a?`/${s}`:s.length>0?s:"."},normalize(i){if(m(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===l,a=i.charCodeAt(i.length-1)===l;return i=L(i,!s,"/",N),i.length===0?s?"/":a?"./":".":(a&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return m(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let s;for(let a=0;a<i.length;++a){const u=i[a];m(u,"path"),u.length>0&&(s===void 0?s=u:s+=`/${u}`)}return s===void 0?".":n.posix.normalize(s)},relative(i,s){if(m(i,"from"),m(s,"to"),i===s||(i=n.posix.resolve(i),s=n.posix.resolve(s),i===s))return"";const a=1,u=i.length,b=u-a,_=1,c=s.length-_,g=b<c?b:c;let w=-1,y=0;for(;y<g;y++){const R=i.charCodeAt(a+y);if(R!==s.charCodeAt(_+y))break;R===l&&(w=y)}if(y===g)if(c>g){if(s.charCodeAt(_+y)===l)return s.slice(_+y+1);if(y===0)return s.slice(_+y)}else b>g&&(i.charCodeAt(a+y)===l?w=y:y===0&&(w=0));let S="";for(y=a+w+1;y<=u;++y)(y===u||i.charCodeAt(y)===l)&&(S+=S.length===0?"..":"/..");return`${S}${s.slice(_+w)}`},toNamespacedPath(i){return i},dirname(i){if(m(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===l;let a=-1,u=!0;for(let b=i.length-1;b>=1;--b)if(i.charCodeAt(b)===l){if(!u){a=b;break}}else u=!1;return a===-1?s?"/":".":s&&a===1?"//":i.slice(0,a)},basename(i,s){s!==void 0&&m(s,"ext"),m(i,"path");let a=0,u=-1,b=!0,_;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let c=s.length-1,g=-1;for(_=i.length-1;_>=0;--_){const w=i.charCodeAt(_);if(w===l){if(!b){a=_+1;break}}else g===-1&&(b=!1,g=_+1),c>=0&&(w===s.charCodeAt(c)?--c==-1&&(u=_):(c=-1,u=g))}return a===u?u=g:u===-1&&(u=i.length),i.slice(a,u)}for(_=i.length-1;_>=0;--_)if(i.charCodeAt(_)===l){if(!b){a=_+1;break}}else u===-1&&(b=!1,u=_+1);return u===-1?"":i.slice(a,u)},extname(i){m(i,"path");let s=-1,a=0,u=-1,b=!0,_=0;for(let c=i.length-1;c>=0;--c){const g=i.charCodeAt(c);if(g===l){if(!b){a=c+1;break}continue}u===-1&&(b=!1,u=c+1),g===d?s===-1?s=c:_!==1&&(_=1):s!==-1&&(_=-1)}return s===-1||u===-1||_===0||_===1&&s===u-1&&s===a+1?"":i.slice(s,u)},format:h.bind(null,"/"),parse(i){m(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.charCodeAt(0)===l;let u;a?(s.root="/",u=1):u=0;let b=-1,_=0,c=-1,g=!0,w=i.length-1,y=0;for(;w>=u;--w){const S=i.charCodeAt(w);if(S===l){if(!g){_=w+1;break}continue}c===-1&&(g=!1,c=w+1),S===d?b===-1?b=w:y!==1&&(y=1):b!==-1&&(y=-1)}if(c!==-1){const S=_===0&&a?1:_;b===-1||y===0||y===1&&b===c-1&&b===_+1?s.base=s.name=i.slice(S,c):(s.name=i.slice(S,b),s.base=i.slice(S,c),s.ext=i.slice(b,c))}return _>0?s.dir=i.slice(0,_-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=P.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=P.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=P.platform==="win32"?n.win32.join:n.posix.join,n.resolve=P.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=P.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=P.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=P.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=P.platform==="win32"?n.win32.extname:n.posix.extname,n.format=P.platform==="win32"?n.win32.format:n.posix.format,n.parse=P.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=P.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=P.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=P.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),x(ee[12],te([0,1,5]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=P.globals.performance&&typeof P.globals.performance.now=="function";class D{constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new D(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?P.globals.performance.now():Date.now()}}n.StopWatch=D}),x(ee[6],te([0,1,8,11,9,23,12]),function(O,n,P,t,D,o,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.Emitter=n.setGlobalLeakWarningThreshold=n.Event=void 0;var d;(function(a){a.None=()=>D.Disposable.None;function u(K){return(Y,Z=null,X)=>{let ie=!1,re;return re=K(I=>{if(!ie)return re?re.dispose():ie=!0,Y.call(Z,I)},null,X),ie&&re.dispose(),re}}a.once=u;function b(K,Y){return S((Z,X=null,ie)=>K(re=>Z.call(X,Y(re)),null,ie))}a.map=b;function _(K,Y){return S((Z,X=null,ie)=>K(re=>{Y(re),Z.call(X,re)},null,ie))}a.forEach=_;function c(K,Y){return S((Z,X=null,ie)=>K(re=>Y(re)&&Z.call(X,re),null,ie))}a.filter=c;function g(K){return K}a.signal=g;function w(...K){return(Y,Z=null,X)=>(0,D.combinedDisposable)(...K.map(ie=>ie(re=>Y.call(Z,re),null,X)))}a.any=w;function y(K,Y,Z){let X=Z;return b(K,ie=>(X=Y(X,ie),X))}a.reduce=y;function S(K){let Y;const Z=new m({onFirstListenerAdd(){Y=K(Z.fire,Z)},onLastListenerRemove(){Y.dispose()}});return Z.event}function R(K,Y,Z,X=100,ie=!1){let re,I,U=0;return K(B=>{U++,re=Z(re,B),ie&&!I&&(Y(re),re=void 0),clearTimeout(I),I=setTimeout(()=>{const q=re;re=void 0,I=void 0,(!ie||U>1)&&Y(q),U=0},X)})}a.debouncedListener=R;function W(K,Y,Z=100,X=!1,ie){let re,I,U,B=0;const q=new m({leakWarningThreshold:ie,onFirstListenerAdd(){re=K(z=>{B++,I=Y(I,z),X&&!U&&(q.fire(I),I=void 0),clearTimeout(U),U=setTimeout(()=>{const se=I;I=void 0,U=void 0,(!X||B>1)&&q.fire(se),B=0},Z)})},onLastListenerRemove(){re.dispose()}});return q.event}a.debounce=W;function H(K,Y=(Z,X)=>Z===X){let Z=!0,X;return c(K,ie=>{const re=Z||!Y(ie,X);return Z=!1,X=ie,re})}a.latch=H;function j(K,Y){return[a.filter(K,Y),a.filter(K,Z=>!Y(Z))]}a.split=j;function E(K,Y=!1,Z=[]){let X=Z.slice(),ie=K(U=>{X?X.push(U):I.fire(U)});const re=()=>{X&&X.forEach(U=>I.fire(U)),X=null},I=new m({onFirstListenerAdd(){ie||(ie=K(U=>I.fire(U)))},onFirstListenerDidAdd(){X&&(Y?setTimeout(re):re())},onLastListenerRemove(){ie&&ie.dispose(),ie=null}});return I.event}a.buffer=E;class T{constructor(Y){this.event=Y}map(Y){return new T(b(this.event,Y))}forEach(Y){return new T(_(this.event,Y))}filter(Y){return new T(c(this.event,Y))}reduce(Y,Z){return new T(y(this.event,Y,Z))}latch(){return new T(H(this.event))}debounce(Y,Z=100,X=!1,ie){return new T(W(this.event,Y,Z,X,ie))}on(Y,Z,X){return this.event(Y,Z,X)}once(Y,Z,X){return u(this.event)(Y,Z,X)}}function ne(K){return new T(K)}a.chain=ne;function G(K,Y,Z=X=>X){const X=(...U)=>I.fire(Z(...U)),ie=()=>K.on(Y,X),re=()=>K.removeListener(Y,X),I=new m({onFirstListenerAdd:ie,onLastListenerRemove:re});return I.event}a.fromNodeEventEmitter=G;function J(K,Y,Z=X=>X){const X=(...U)=>I.fire(Z(...U)),ie=()=>K.addEventListener(Y,X),re=()=>K.removeEventListener(Y,X),I=new m({onFirstListenerAdd:ie,onLastListenerRemove:re});return I.event}a.fromDOMEventEmitter=J;function r(K){return new Promise(Y=>u(K)(Y))}a.toPromise=r;function le(K,Y){return Y(void 0),K(Z=>Y(Z))}a.runAndSubscribe=le;function be(K,Y){let Z=null;function X(re){Z?.dispose(),Z=new D.DisposableStore,Y(re,Z)}X(void 0);const ie=K(re=>X(re));return(0,D.toDisposable)(()=>{ie.dispose(),Z?.dispose()})}a.runAndSubscribeWithStore=be})(d=n.Event||(n.Event={}));class l{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${l._idPool++}`}start(u){this._stopWatch=new A.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}l._idPool=0;let f=-1;function p(a){const u=f;return f=a,{dispose(){f=u}}}n.setGlobalLeakWarningThreshold=p;class M{constructor(u,b=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=b,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let b=f;if(typeof this.customThreshold=="number"&&(b=this.customThreshold),b<=0||u<b)return;this._stacks||(this._stacks=new Map);const _=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(_)||0;if(this._stacks.set(_,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=b*.5;let g,w=0;for(const[y,S]of this._stacks)(!g||w<S)&&(g=y,w=S);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${w}):`),console.warn(g)}return()=>{const g=this._stacks.get(_)||0;this._stacks.set(_,g-1)}}}class v{set(u){return this._actual=u,this}unset(){this._actual=void 0}dispose(){this._actual?.dispose(),this.unset()}}class m{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=f>0?new M(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new l(this._options._profName):void 0}get event(){return this._event||(this._event=(u,b,_)=>{this._listeners||(this._listeners=new o.LinkedList);const c=this._listeners.isEmpty();c&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const g=new v,w=this._listeners.push([u,b,g]);c&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,b);const y=this._leakageMon?.check(this._listeners.size),S=g.set((0,D.toDisposable)(()=>{y&&y(),this._disposed||(w(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}));return _ instanceof D.DisposableStore?_.add(S):Array.isArray(_)&&_.push(S),S}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new o.LinkedList);for(let b of this._listeners)this._deliveryQueue.push([b,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[[b,_],c]=this._deliveryQueue.shift();try{b.call(_,c)}catch(g){(0,P.onUnexpectedError)(g)}}this._perfMon?.stop()}}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){for(let[u,b,_]of this._listeners)_.dispose();this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}}n.Emitter=m;class e extends m{async fireAsync(u,b,_){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new o.LinkedList);for(const c of this._listeners)this._asyncDeliveryQueue.push([c,u]);for(;this._asyncDeliveryQueue.size>0&&!b.isCancellationRequested;){const[[c,g],w]=this._asyncDeliveryQueue.shift(),y=[],S={...w,token:b,waitUntil:R=>{if(Object.isFrozen(y))throw new Error("waitUntil can NOT be called asynchronous");_&&(R=_(R,c)),y.push(R)}};try{c.call(g,S)}catch(R){(0,P.onUnexpectedError)(R);continue}Object.freeze(y),await Promise.allSettled(y).then(R=>{for(const W of R)W.status==="rejected"&&(0,P.onUnexpectedError)(W.reason)})}}}}n.AsyncEmitter=e;class N extends m{constructor(u){super(u);this._isPaused=0,this._eventQueue=new o.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}n.PauseableEmitter=N;class C extends N{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}n.DebounceEmitter=C;class L extends m{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(b=>super.fire(b)),this._queuedEvents=[]})}}n.MicrotaskEmitter=L;class h{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const b={event:u,listener:null};this.events.push(b),this.hasListeners&&this.hook(b);const _=()=>{this.hasListeners&&this.unhook(b);const c=this.events.indexOf(b);this.events.splice(c,1)};return(0,D.toDisposable)((0,t.once)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(b=>this.emitter.fire(b))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=h;class i{constructor(){this.buffers=[]}wrapEvent(u){return(b,_,c)=>u(g=>{const w=this.buffers[this.buffers.length-1];w?w.push(()=>b.call(_,g)):b.call(_,g)},void 0,c)}bufferEvents(u){const b=[];this.buffers.push(b);const _=u();return this.buffers.pop(),b.forEach(c=>c()),_}}n.EventBufferer=i;class s{constructor(){this.listening=!1,this.inputEvent=d.None,this.inputEventListener=D.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=s}),x(ee[13],te([0,1,6]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(d,l){const f=setTimeout(d.bind(l),0);return{dispose(){clearTimeout(f)}}});var D;(function(d){function l(f){return f===d.None||f===d.Cancelled||f instanceof o?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}d.isCancellationToken=l,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=n.CancellationToken||(n.CancellationToken={}));class o{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new o),this._token}cancel(){this._token?this._token instanceof o&&this._token.cancel():this._token=D.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=D.None}}n.CancellationTokenSource=A}),x(ee[26],te([0,1,13]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LRUCachedComputed=n.Cache=void 0;class t{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new P.CancellationTokenSource,d=this.task(A.token);return this.result={promise:d,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}n.Cache=t;class D{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const d=JSON.stringify(A);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.computeFn(A)),this.lastCache}}n.LRUCachedComputed=D}),x(ee[2],te([0,1,26,22]),function(O,n,P,t){"use strict";var D;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function o(F){return!F||typeof F!="string"?!0:F.trim().length===0}n.isFalsyOrWhitespace=o;const A=/{(\d+)}/g;function d(F,...k){return k.length===0?F:F.replace(A,function(V,$){const Q=parseInt($,10);return isNaN(Q)||Q<0||Q>=k.length?V:k[Q]})}n.format=d;const l=/{([^}]+)}/g;function f(F,k){return F.replace(l,(V,$)=>k[$]??V)}n.format2=f;function p(F){return F.replace(/[<>&]/g,function(k){switch(k){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return k}})}n.escape=p;function M(F){return F.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=M;function v(F,k){let V=0;const $=k.charCodeAt(0);for(let Q=F.length-1;Q>=0;Q--)F.charCodeAt(Q)===$&&V++;return V}n.count=v;function m(F,k,V="\u2026"){return F.length<=k?F:`${F.substr(0,k)}${V}`}n.truncate=m;function e(F,k=" "){const V=N(F,k);return C(V,k)}n.trim=e;function N(F,k){if(!F||!k)return F;const V=k.length;if(V===0||F.length===0)return F;let $=0;for(;F.indexOf(k,$)===$;)$=$+V;return F.substring($)}n.ltrim=N;function C(F,k){if(!F||!k)return F;const V=k.length,$=F.length;if(V===0||$===0)return F;let Q=$,oe=-1;for(;oe=F.lastIndexOf(k,Q-1),!(oe===-1||oe+V!==Q);){if(oe===0)return"";Q=oe}return F.substring(0,Q)}n.rtrim=C;function L(F){return F.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=L;function h(F){return F.replace(/\*/g,"")}n.stripWildcards=h;function i(F,k,V={}){if(!F)throw new Error("Cannot create regex from empty string");k||(F=M(F)),V.wholeWord&&(/\B/.test(F.charAt(0))||(F="\\b"+F),/\B/.test(F.charAt(F.length-1))||(F=F+"\\b"));let $="";return V.global&&($+="g"),V.matchCase||($+="i"),V.multiline&&($+="m"),V.unicode&&($+="u"),new RegExp(F,$)}n.createRegExp=i;function s(F){return F.source==="^"||F.source==="^$"||F.source==="$"||F.source==="^\\s*$"?!1:!!(F.exec("")&&F.lastIndex===0)}n.regExpLeadsToEndlessLoop=s;function a(F){return!!F.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=a;function u(F){return(F.global?"g":"")+(F.ignoreCase?"i":"")+(F.multiline?"m":"")+(F.unicode?"u":"")}n.regExpFlags=u;function b(F){return F.split(/\r\n|\r|\n/)}n.splitLines=b;function _(F){for(let k=0,V=F.length;k<V;k++){const $=F.charCodeAt(k);if($!==32&&$!==9)return k}return-1}n.firstNonWhitespaceIndex=_;function c(F,k=0,V=F.length){for(let $=k;$<V;$++){const Q=F.charCodeAt($);if(Q!==32&&Q!==9)return F.substring(k,$)}return F.substring(k,V)}n.getLeadingWhitespace=c;function g(F,k=F.length-1){for(let V=k;V>=0;V--){const $=F.charCodeAt(V);if($!==32&&$!==9)return V}return-1}n.lastNonWhitespaceIndex=g;function w(F,k){return F<k?-1:F>k?1:0}n.compare=w;function y(F,k,V=0,$=F.length,Q=0,oe=k.length){for(;V<$&&Q<oe;V++,Q++){let ve=F.charCodeAt(V),ue=k.charCodeAt(Q);if(ve<ue)return-1;if(ve>ue)return 1}const fe=$-V,Ne=oe-Q;return fe<Ne?-1:fe>Ne?1:0}n.compareSubstring=y;function S(F,k){return R(F,k,0,F.length,0,k.length)}n.compareIgnoreCase=S;function R(F,k,V=0,$=F.length,Q=0,oe=k.length){for(;V<$&&Q<oe;V++,Q++){let ve=F.charCodeAt(V),ue=k.charCodeAt(Q);if(ve===ue)continue;if(ve>=128||ue>=128)return y(F.toLowerCase(),k.toLowerCase(),V,$,Q,oe);W(ve)&&(ve-=32),W(ue)&&(ue-=32);const _e=ve-ue;if(_e!==0)return _e}const fe=$-V,Ne=oe-Q;return fe<Ne?-1:fe>Ne?1:0}n.compareSubstringIgnoreCase=R;function W(F){return F>=97&&F<=122}n.isLowerAsciiLetter=W;function H(F){return F>=65&&F<=90}n.isUpperAsciiLetter=H;function j(F,k){return F.length===k.length&&R(F,k)===0}n.equalsIgnoreCase=j;function E(F,k){const V=k.length;return k.length>F.length?!1:R(F,k,0,V)===0}n.startsWithIgnoreCase=E;function T(F,k){let V,$=Math.min(F.length,k.length);for(V=0;V<$;V++)if(F.charCodeAt(V)!==k.charCodeAt(V))return V;return $}n.commonPrefixLength=T;function ne(F,k){let V,$=Math.min(F.length,k.length);const Q=F.length-1,oe=k.length-1;for(V=0;V<$;V++)if(F.charCodeAt(Q-V)!==k.charCodeAt(oe-V))return V;return $}n.commonSuffixLength=ne;function G(F){return 55296<=F&&F<=56319}n.isHighSurrogate=G;function J(F){return 56320<=F&&F<=57343}n.isLowSurrogate=J;function r(F,k){return(F-55296<<10)+(k-56320)+65536}n.computeCodePoint=r;function le(F,k,V){const $=F.charCodeAt(V);if(G($)&&V+1<k){const Q=F.charCodeAt(V+1);if(J(Q))return r($,Q)}return $}n.getNextCodePoint=le;function be(F,k){const V=F.charCodeAt(k-1);if(J(V)&&k>1){const $=F.charCodeAt(k-2);if(G($))return r($,V)}return V}class K{constructor(k,V=0){this._str=k,this._len=k.length,this._offset=V}get offset(){return this._offset}setOffset(k){this._offset=k}prevCodePoint(){const k=be(this._str,this._offset);return this._offset-=k>=65536?2:1,k}nextCodePoint(){const k=le(this._str,this._len,this._offset);return this._offset+=k>=65536?2:1,k}eol(){return this._offset>=this._len}}n.CodePointIterator=K;class Y{constructor(k,V=0){this._iterator=new K(k,V)}get offset(){return this._iterator.offset}nextGraphemeLength(){const k=pe.getInstance(),V=this._iterator,$=V.offset;let Q=k.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const oe=V.offset,fe=k.getGraphemeBreakType(V.nextCodePoint());if(Fe(Q,fe)){V.setOffset(oe);break}Q=fe}return V.offset-$}prevGraphemeLength(){const k=pe.getInstance(),V=this._iterator,$=V.offset;let Q=k.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const oe=V.offset,fe=k.getGraphemeBreakType(V.prevCodePoint());if(Fe(fe,Q)){V.setOffset(oe);break}Q=fe}return $-V.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=Y;function Z(F,k){return new Y(F,k).nextGraphemeLength()}n.nextCharLength=Z;function X(F,k){return new Y(F,k).prevGraphemeLength()}n.prevCharLength=X;function ie(F,k){k>0&&J(F.charCodeAt(k))&&k--;const V=k+Z(F,k);return[V-X(F,V),V]}n.getCharContainingOffset=ie;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function I(F){return re.test(F)}n.containsRTL=I;const U=/^[\t\n\r\x20-\x7E]*$/;function B(F){return U.test(F)}n.isBasicASCII=B,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(F){return n.UNUSUAL_LINE_TERMINATORS.test(F)}n.containsUnusualLineTerminators=q;function z(F){return F>=11904&&F<=55215||F>=63744&&F<=64255||F>=65281&&F<=65374}n.isFullWidthCharacter=z;function se(F){return F>=127462&&F<=127487||F===8986||F===8987||F===9200||F===9203||F>=9728&&F<=10175||F===11088||F===11093||F>=127744&&F<=128591||F>=128640&&F<=128764||F>=128992&&F<=129008||F>=129280&&F<=129535||F>=129648&&F<=129782}n.isEmojiImprecise=se;function ae(F,k){if(F.length<k)return F;const V=/\b/g;let $=0;for(;V.test(F)&&!(F.length-V.lastIndex<k);)$=V.lastIndex,V.lastIndex+=1;return F.substring($).replace(/^\s/,"")}n.lcut=ae;const he=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function me(F){return F&&(F=F.replace(he,""),F=F.replace(de,""),F=F.replace(ge,"")),F}n.removeAnsiEscapeCodes=me,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(F){return!!(F&&F.length>0&&F.charCodeAt(0)===65279)}n.startsWithUTF8BOM=Ae;function Ie(F){return Ae(F)?F.substr(1):F}n.stripUTF8BOM=Ie;function ke(F,k){if(!F||!k||F.length<k.length)return!1;const V=k.length,$=F.toLowerCase();let Q=0,oe=-1;for(;Q<V;){const fe=$.indexOf(k[Q],oe+1);if(fe<0)return!1;oe=fe,Q++}return!0}n.fuzzyContains=ke;function Te(F,k=!1){return F?(k&&(F=F.replace(/\\./g,"")),F.toLowerCase()!==F):!1}n.containsUppercaseCharacter=Te;function Ue(F){return F.charAt(0).toUpperCase()+F.slice(1)}n.uppercaseFirstLetter=Ue;function Oe(F,k=1){if(k===0)return"";let V=-1;do V=F.indexOf(`
`,V+1),k--;while(k>0&&V>=0);return V===-1?F:(F[V-1]==="\r"&&V--,F.substr(0,V))}n.getNLines=Oe;function Be(F){const k=90-65+1;return F=F%(2*k),F<k?String.fromCharCode(97+F):String.fromCharCode(65+F-k)}n.singleLetterHash=Be;function Ve(F){return pe.getInstance().getGraphemeBreakType(F)}n.getGraphemeBreakType=Ve;function Fe(F,k){return F===0?k!==5&&k!==7:F===2&&k===3?!1:F===4||F===2||F===3||k===4||k===2||k===3?!0:!(F===8&&(k===8||k===9||k===11||k===12)||(F===11||F===9)&&(k===9||k===10)||(F===12||F===10)&&k===10||k===5||k===13||k===7||F===1||F===13&&k===14||F===6&&k===6)}var We;(function(F){F[F.Other=0]="Other",F[F.Prepend=1]="Prepend",F[F.CR=2]="CR",F[F.LF=3]="LF",F[F.Control=4]="Control",F[F.Extend=5]="Extend",F[F.Regional_Indicator=6]="Regional_Indicator",F[F.SpacingMark=7]="SpacingMark",F[F.L=8]="L",F[F.V=9]="V",F[F.T=10]="T",F[F.LV=11]="LV",F[F.LVT=12]="LVT",F[F.ZWJ=13]="ZWJ",F[F.Extended_Pictographic=14]="Extended_Pictographic"})(We=n.GraphemeBreakType||(n.GraphemeBreakType={}));class pe{constructor(){this._data=qe()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(k){if(k<32)return k===10?3:k===13?2:4;if(k<127)return 0;const V=this._data,$=V.length/3;let Q=1;for(;Q<=$;)if(k<V[3*Q])Q=2*Q;else if(k>V[3*Q+1])Q=2*Q+1;else return V[3*Q+2];return 0}}pe._INSTANCE=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(F,k){if(F===0)return 0;const V=ze(F,k);if(V!==void 0)return V;const $=new K(k,F);return $.prevCodePoint(),$.offset}n.getLeftDeleteOffset=He;function ze(F,k){const V=new K(k,F);let $=V.prevCodePoint();for(;je($)||$===65039||$===8419;){if(V.offset===0)return;$=V.prevCodePoint()}if(!se($))return;let Q=V.offset;return Q>0&&V.prevCodePoint()===8205&&(Q=V.offset),Q}function je(F){return 127995<=F&&F<=127999}var De;(function(F){F[F.zwj=8205]="zwj",F[F.emojiVariantSelector=65039]="emojiVariantSelector",F[F.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={})),n.noBreakWhitespace="\xA0";class we{constructor(k){this.confusableDictionary=k}static getInstance(k){return we.cache.get(Array.from(k))}static getLocales(){return we._locales.getValue()}isAmbiguous(k){return this.confusableDictionary.has(k)}getPrimaryConfusable(k){return this.confusableDictionary.get(k)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=we,D=we,we.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),we.cache=new P.LRUCachedComputed(F=>{function k(ue){const _e=new Map;for(let Le=0;Le<ue.length;Le+=2)_e.set(ue[Le],ue[Le+1]);return _e}function V(ue,_e){const Le=new Map(ue);for(const[Ee,Me]of _e)Le.set(Ee,Me);return Le}function $(ue,_e){if(!ue)return _e;const Le=new Map;for(const[Ee,Me]of ue)_e.has(Ee)&&Le.set(Ee,Me);return Le}const Q=D.ambiguousCharacterData.getValue();let oe=F.filter(ue=>!ue.startsWith("_")&&ue in Q);oe.length===0&&(oe=["_default"]);let fe;for(const ue of oe){const _e=k(Q[ue]);fe=$(fe,_e)}const Ne=k(Q._common),ve=V(Ne,fe);return new we(ve)}),we._locales=new t.Lazy(()=>Object.keys(we.ambiguousCharacterData.getValue()).filter(F=>!F.startsWith("_")));class Ce{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ce.getRawData())),this._data}static isInvisibleCharacter(k){return Ce.getData().has(k)}static get codePoints(){return Ce.getData()}}n.InvisibleCharacters=Ce,Ce._data=void 0}),x(ee[27],te([0,1,2]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(L){return D(L,0)}n.hash=t;function D(L,h){switch(typeof L){case"object":return L===null?o(349,h):Array.isArray(L)?l(L,h):f(L,h);case"string":return d(L,h);case"boolean":return A(L,h);case"number":return o(L,h);case"undefined":return o(937,h);default:return o(617,h)}}n.doHash=D;function o(L,h){return(h<<5)-h+L|0}n.numberHash=o;function A(L,h){return o(L?433:863,h)}function d(L,h){h=o(149417,h);for(let i=0,s=L.length;i<s;i++)h=o(L.charCodeAt(i),h);return h}n.stringHash=d;function l(L,h){return h=o(104579,h),L.reduce((i,s)=>D(s,i),h)}function f(L,h){return h=o(181387,h),Object.keys(L).sort().reduce((i,s)=>(i=d(s,i),D(L[s],i)),h)}class p{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=D(h,this._value),this._value}}n.Hasher=p;var M;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function v(L,h,i=32){const s=i-h,a=~((1<<s)-1);return(L<<h|(a&L)>>>s)>>>0}function m(L,h=0,i=L.byteLength,s=0){for(let a=0;a<i;a++)L[h+a]=s}function e(L,h,i="0"){for(;L.length<h;)L=i+L;return L}function N(L,h=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(i=>i.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),h/4)}n.toHexString=N;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const i=h.length;if(i===0)return;const s=this._buff;let a=this._buffLen,u=this._leftoverHighSurrogate,b,_;for(u!==0?(b=u,_=-1,u=0):(b=h.charCodeAt(0),_=0);;){let c=b;if(P.isHighSurrogate(b))if(_+1<i){const g=h.charCodeAt(_+1);P.isLowSurrogate(g)?(_++,c=P.computeCodePoint(b,g)):c=65533}else{u=b;break}else P.isLowSurrogate(b)&&(c=65533);if(a=this._push(s,a,c),_++,_<i)b=h.charCodeAt(_);else break}this._buffLen=a,this._leftoverHighSurrogate=u}_push(h,i,s){return s<128?h[i++]=s:s<2048?(h[i++]=192|(s&1984)>>>6,h[i++]=128|(s&63)>>>0):s<65536?(h[i++]=224|(s&61440)>>>12,h[i++]=128|(s&4032)>>>6,h[i++]=128|(s&63)>>>0):(h[i++]=240|(s&1835008)>>>18,h[i++]=128|(s&258048)>>>12,h[i++]=128|(s&4032)>>>6,h[i++]=128|(s&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),N(this._h0)+N(this._h1)+N(this._h2)+N(this._h3)+N(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=C._bigBlock32,i=this._buffDV;for(let y=0;y<64;y+=4)h.setUint32(y,i.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)h.setUint32(y,v(h.getUint32(y-12,!1)^h.getUint32(y-32,!1)^h.getUint32(y-56,!1)^h.getUint32(y-64,!1),1),!1);let s=this._h0,a=this._h1,u=this._h2,b=this._h3,_=this._h4,c,g,w;for(let y=0;y<80;y++)y<20?(c=a&u|~a&b,g=1518500249):y<40?(c=a^u^b,g=1859775393):y<60?(c=a&u|a&b|u&b,g=2400959708):(c=a^u^b,g=3395469782),w=v(s,5)+c+_+g+h.getUint32(y*4,!1)&4294967295,_=b,b=u,u=v(a,30),a=s,s=w;this._h0=this._h0+s&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+u&4294967295,this._h3=this._h3+b&4294967295,this._h4=this._h4+_&4294967295}}n.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),x(ee[14],te([0,1,18,27]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class D{constructor(v){this.source=v}getElements(){const v=this.source,m=new Int32Array(v.length);for(let e=0,N=v.length;e<N;e++)m[e]=v.charCodeAt(e);return m}}n.StringDiffSequence=D;function o(M,v,m){return new p(new D(M),new D(v)).ComputeDiff(m).changes}n.stringDiff=o;class A{static Assert(v,m){if(!v)throw new Error(m)}}n.Debug=A;class d{static Copy(v,m,e,N,C){for(let L=0;L<C;L++)e[N+L]=v[m+L]}static Copy2(v,m,e,N,C){for(let L=0;L<C;L++)e[N+L]=v[m+L]}}n.MyArray=d;var l;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class f{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(v,m){this.m_originalStart=Math.min(this.m_originalStart,v),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(v,m){this.m_originalStart=Math.min(this.m_originalStart,v),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class p{constructor(v,m,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=v,this._modifiedSequence=m;const[N,C,L]=p._getElements(v),[h,i,s]=p._getElements(m);this._hasStrings=L&&s,this._originalStringElements=N,this._originalElementsOrHash=C,this._modifiedStringElements=h,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(v){return v.length>0&&typeof v[0]=="string"}static _getElements(v){const m=v.getElements();if(p._isStringArray(m)){const e=new Int32Array(m.length);for(let N=0,C=m.length;N<C;N++)e[N]=(0,t.stringHash)(m[N],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(v,m){return this._originalElementsOrHash[v]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[v]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(v,m){if(!this.ElementsAreEqual(v,m))return!1;const e=p._getStrictElement(this._originalSequence,v),N=p._getStrictElement(this._modifiedSequence,m);return e===N}static _getStrictElement(v,m){return typeof v.getStrictElement=="function"?v.getStrictElement(m):null}OriginalElementsAreEqual(v,m){return this._originalElementsOrHash[v]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[v]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(v,m){return this._modifiedElementsOrHash[v]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[v]===this._modifiedStringElements[m]:!0}ComputeDiff(v){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,v)}_ComputeDiff(v,m,e,N,C){const L=[!1];let h=this.ComputeDiffRecursive(v,m,e,N,L);return C&&(h=this.PrettifyChanges(h)),{quitEarly:L[0],changes:h}}ComputeDiffRecursive(v,m,e,N,C){for(C[0]=!1;v<=m&&e<=N&&this.ElementsAreEqual(v,e);)v++,e++;for(;m>=v&&N>=e&&this.ElementsAreEqual(m,N);)m--,N--;if(v>m||e>N){let u;return e<=N?(A.Assert(v===m+1,"originalStart should only be one more than originalEnd"),u=[new P.DiffChange(v,0,e,N-e+1)]):v<=m?(A.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),u=[new P.DiffChange(v,m-v+1,e,0)]):(A.Assert(v===m+1,"originalStart should only be one more than originalEnd"),A.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),u=[]),u}const L=[0],h=[0],i=this.ComputeRecursionPoint(v,m,e,N,L,h,C),s=L[0],a=h[0];if(i!==null)return i;if(!C[0]){const u=this.ComputeDiffRecursive(v,s,e,a,C);let b=[];return C[0]?b=[new P.DiffChange(s+1,m-(s+1)+1,a+1,N-(a+1)+1)]:b=this.ComputeDiffRecursive(s+1,m,a+1,N,C),this.ConcatenateChanges(u,b)}return[new P.DiffChange(v,m-v+1,e,N-e+1)]}WALKTRACE(v,m,e,N,C,L,h,i,s,a,u,b,_,c,g,w,y,S){let R=null,W=null,H=new f,j=m,E=e,T=_[0]-w[0]-N,ne=-1073741824,G=this.m_forwardHistory.length-1;do{const J=T+v;J===j||J<E&&s[J-1]<s[J+1]?(u=s[J+1],c=u-T-N,u<ne&&H.MarkNextChange(),ne=u,H.AddModifiedElement(u+1,c),T=J+1-v):(u=s[J-1]+1,c=u-T-N,u<ne&&H.MarkNextChange(),ne=u-1,H.AddOriginalElement(u,c+1),T=J-1-v),G>=0&&(s=this.m_forwardHistory[G],v=s[0],j=1,E=s.length-1)}while(--G>=-1);if(R=H.getReverseChanges(),S[0]){let J=_[0]+1,r=w[0]+1;if(R!==null&&R.length>0){const le=R[R.length-1];J=Math.max(J,le.getOriginalEnd()),r=Math.max(r,le.getModifiedEnd())}W=[new P.DiffChange(J,b-J+1,r,g-r+1)]}else{H=new f,j=L,E=h,T=_[0]-w[0]-i,ne=1073741824,G=y?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const J=T+C;J===j||J<E&&a[J-1]>=a[J+1]?(u=a[J+1]-1,c=u-T-i,u>ne&&H.MarkNextChange(),ne=u+1,H.AddOriginalElement(u+1,c+1),T=J+1-C):(u=a[J-1],c=u-T-i,u>ne&&H.MarkNextChange(),ne=u,H.AddModifiedElement(u+1,c+1),T=J-1-C),G>=0&&(a=this.m_reverseHistory[G],C=a[0],j=1,E=a.length-1)}while(--G>=-1);W=H.getChanges()}return this.ConcatenateChanges(R,W)}ComputeRecursionPoint(v,m,e,N,C,L,h){let i=0,s=0,a=0,u=0,b=0,_=0;v--,e--,C[0]=0,L[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const c=m-v+(N-e),g=c+1,w=new Int32Array(g),y=new Int32Array(g),S=N-e,R=m-v,W=v-e,H=m-N,E=(R-S)%2==0;w[S]=v,y[R]=m,h[0]=!1;for(let T=1;T<=c/2+1;T++){let ne=0,G=0;a=this.ClipDiagonalBound(S-T,T,S,g),u=this.ClipDiagonalBound(S+T,T,S,g);for(let r=a;r<=u;r+=2){r===a||r<u&&w[r-1]<w[r+1]?i=w[r+1]:i=w[r-1]+1,s=i-(r-S)-W;const le=i;for(;i<m&&s<N&&this.ElementsAreEqual(i+1,s+1);)i++,s++;if(w[r]=i,i+s>ne+G&&(ne=i,G=s),!E&&Math.abs(r-R)<=T-1&&i>=y[r])return C[0]=i,L[0]=s,le<=y[r]&&1447>0&&T<=1447+1?this.WALKTRACE(S,a,u,W,R,b,_,H,w,y,i,m,C,s,N,L,E,h):null}const J=(ne-v+(G-e)-T)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ne,J))return h[0]=!0,C[0]=ne,L[0]=G,J>0&&1447>0&&T<=1447+1?this.WALKTRACE(S,a,u,W,R,b,_,H,w,y,i,m,C,s,N,L,E,h):(v++,e++,[new P.DiffChange(v,m-v+1,e,N-e+1)]);b=this.ClipDiagonalBound(R-T,T,R,g),_=this.ClipDiagonalBound(R+T,T,R,g);for(let r=b;r<=_;r+=2){r===b||r<_&&y[r-1]>=y[r+1]?i=y[r+1]-1:i=y[r-1],s=i-(r-R)-H;const le=i;for(;i>v&&s>e&&this.ElementsAreEqual(i,s);)i--,s--;if(y[r]=i,E&&Math.abs(r-S)<=T&&i<=w[r])return C[0]=i,L[0]=s,le>=w[r]&&1447>0&&T<=1447+1?this.WALKTRACE(S,a,u,W,R,b,_,H,w,y,i,m,C,s,N,L,E,h):null}if(T<=1447){let r=new Int32Array(u-a+2);r[0]=S-a+1,d.Copy2(w,a,r,1,u-a+1),this.m_forwardHistory.push(r),r=new Int32Array(_-b+2),r[0]=R-b+1,d.Copy2(y,b,r,1,_-b+1),this.m_reverseHistory.push(r)}}return this.WALKTRACE(S,a,u,W,R,b,_,H,w,y,i,m,C,s,N,L,E,h)}PrettifyChanges(v){for(let m=0;m<v.length;m++){const e=v[m],N=m<v.length-1?v[m+1].originalStart:this._originalElementsOrHash.length,C=m<v.length-1?v[m+1].modifiedStart:this._modifiedElementsOrHash.length,L=e.originalLength>0,h=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<C&&(!L||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!h||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const s=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!s)break;e.originalStart++,e.modifiedStart++}let i=[null];if(m<v.length-1&&this.ChangesOverlap(v[m],v[m+1],i)){v[m]=i[0],v.splice(m+1,1),m--;continue}}for(let m=v.length-1;m>=0;m--){const e=v[m];let N=0,C=0;if(m>0){const u=v[m-1];N=u.originalStart+u.originalLength,C=u.modifiedStart+u.modifiedLength}const L=e.originalLength>0,h=e.modifiedLength>0;let i=0,s=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let u=1;;u++){const b=e.originalStart-u,_=e.modifiedStart-u;if(b<N||_<C||L&&!this.OriginalElementsAreEqual(b,b+e.originalLength)||h&&!this.ModifiedElementsAreEqual(_,_+e.modifiedLength))break;const g=(b===N&&_===C?5:0)+this._boundaryScore(b,e.originalLength,_,e.modifiedLength);g>s&&(s=g,i=u)}e.originalStart-=i,e.modifiedStart-=i;const a=[null];if(m>0&&this.ChangesOverlap(v[m-1],v[m],a)){v[m-1]=a[0],v.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,e=v.length;m<e;m++){const N=v[m-1],C=v[m],L=C.originalStart-N.originalStart-N.originalLength,h=N.originalStart,i=C.originalStart+C.originalLength,s=i-h,a=N.modifiedStart,u=C.modifiedStart+C.modifiedLength,b=u-a;if(L<5&&s<20&&b<20){const _=this._findBetterContiguousSequence(h,s,a,b,L);if(_){const[c,g]=_;(c!==N.originalStart+N.originalLength||g!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=c-N.originalStart,N.modifiedLength=g-N.modifiedStart,C.originalStart=c+L,C.modifiedStart=g+L,C.originalLength=i-C.originalStart,C.modifiedLength=u-C.modifiedStart)}}}return v}_findBetterContiguousSequence(v,m,e,N,C){if(m<C||N<C)return null;const L=v+m-C+1,h=e+N-C+1;let i=0,s=0,a=0;for(let u=v;u<L;u++)for(let b=e;b<h;b++){const _=this._contiguousSequenceScore(u,b,C);_>0&&_>i&&(i=_,s=u,a=b)}return i>0?[s,a]:null}_contiguousSequenceScore(v,m,e){let N=0;for(let C=0;C<e;C++){if(!this.ElementsAreEqual(v+C,m+C))return 0;N+=this._originalStringElements[v+C].length}return N}_OriginalIsBoundary(v){return v<=0||v>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[v])}_OriginalRegionIsBoundary(v,m){if(this._OriginalIsBoundary(v)||this._OriginalIsBoundary(v-1))return!0;if(m>0){const e=v+m;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(v){return v<=0||v>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[v])}_ModifiedRegionIsBoundary(v,m){if(this._ModifiedIsBoundary(v)||this._ModifiedIsBoundary(v-1))return!0;if(m>0){const e=v+m;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(v,m,e,N){const C=this._OriginalRegionIsBoundary(v,m)?1:0,L=this._ModifiedRegionIsBoundary(e,N)?1:0;return C+L}ConcatenateChanges(v,m){let e=[];if(v.length===0||m.length===0)return m.length>0?m:v;if(this.ChangesOverlap(v[v.length-1],m[0],e)){const N=new Array(v.length+m.length-1);return d.Copy(v,0,N,0,v.length-1),N[v.length-1]=e[0],d.Copy(m,1,N,v.length,m.length-1),N}else{const N=new Array(v.length+m.length);return d.Copy(v,0,N,0,v.length),d.Copy(m,0,N,v.length,m.length),N}}ChangesOverlap(v,m,e){if(A.Assert(v.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),A.Assert(v.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),v.originalStart+v.originalLength>=m.originalStart||v.modifiedStart+v.modifiedLength>=m.modifiedStart){const N=v.originalStart;let C=v.originalLength;const L=v.modifiedStart;let h=v.modifiedLength;return v.originalStart+v.originalLength>=m.originalStart&&(C=m.originalStart+m.originalLength-v.originalStart),v.modifiedStart+v.modifiedLength>=m.modifiedStart&&(h=m.modifiedStart+m.modifiedLength-v.modifiedStart),e[0]=new P.DiffChange(N,C,L,h),!0}else return e[0]=null,!1}ClipDiagonalBound(v,m,e,N){if(v>=0&&v<N)return v;const C=e,L=N-e-1,h=m%2==0;if(v<0){const i=C%2==0;return h===i?0:1}else{const i=L%2==0;return h===i?N-1:N-2}}}n.LcsDiff=p}),x(ee[7],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.assertNever=n.withUndefinedAsNull=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isObject=n.isStringArray=n.isString=n.isArray=void 0;function P(w){return Array.isArray(w)}n.isArray=P;function t(w){return typeof w=="string"}n.isString=t;function D(w){return Array.isArray(w)&&w.every(y=>t(y))}n.isStringArray=D;function o(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}n.isObject=o;function A(w){return typeof w=="number"&&!isNaN(w)}n.isNumber=A;function d(w){return!!w&&typeof w[Symbol.iterator]=="function"}n.isIterable=d;function l(w){return w===!0||w===!1}n.isBoolean=l;function f(w){return typeof w=="undefined"}n.isUndefined=f;function p(w){return!M(w)}n.isDefined=p;function M(w){return f(w)||w===null}n.isUndefinedOrNull=M;function v(w,y){if(!w)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}n.assertType=v;function m(w){if(M(w))throw new Error("Assertion Failed: argument is undefined or null");return w}n.assertIsDefined=m;function e(...w){const y=[];for(let S=0;S<w.length;S++){const R=w[S];if(M(R))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);y.push(R)}return y}n.assertAllDefined=e;const N=Object.prototype.hasOwnProperty;function C(w){if(!o(w))return!1;for(let y in w)if(N.call(w,y))return!1;return!0}n.isEmptyObject=C;function L(w){return typeof w=="function"}n.isFunction=L;function h(...w){return w.length>0&&w.every(L)}n.areFunctions=h;function i(w,y){const S=Math.min(w.length,y.length);for(let R=0;R<S;R++)s(w[R],y[R])}n.validateConstraints=i;function s(w,y){if(t(y)){if(typeof w!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(L(y)){try{if(w instanceof y)return}catch{}if(!M(w)&&w.constructor===y||y.length===1&&y.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=s;function a(w){let y=[],S=Object.getPrototypeOf(w);for(;Object.prototype!==S;)y=y.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return y}n.getAllPropertyNames=a;function u(w){const y=[];for(const S of a(w))typeof w[S]=="function"&&y.push(S);return y}n.getAllMethodNames=u;function b(w,y){const S=W=>function(){const H=Array.prototype.slice.call(arguments,0);return y(W,H)};let R={};for(const W of w)R[W]=S(W);return R}n.createProxyObject=b;function _(w){return w===null?void 0:w}n.withNullAsUndefined=_;function c(w){return typeof w=="undefined"?null:w}n.withUndefinedAsNull=c;function g(w,y="Unreachable"){throw new Error(y)}n.assertNever=g}),x(ee[28],te([0,1,7]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.filter=n.getCaseInsensitive=n.distinct=n.getOrDefault=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(N){if(!N||typeof N!="object"||N instanceof RegExp)return N;const C=Array.isArray(N)?[]:{};return Object.keys(N).forEach(L=>{N[L]&&typeof N[L]=="object"?C[L]=t(N[L]):C[L]=N[L]}),C}n.deepClone=t;function D(N){if(!N||typeof N!="object")return N;const C=[N];for(;C.length>0;){const L=C.shift();Object.freeze(L);for(const h in L)if(o.call(L,h)){const i=L[h];typeof i=="object"&&!Object.isFrozen(i)&&C.push(i)}}return N}n.deepFreeze=D;const o=Object.prototype.hasOwnProperty;function A(N,C){return d(N,C,new Set)}n.cloneAndChange=A;function d(N,C,L){if((0,P.isUndefinedOrNull)(N))return N;const h=C(N);if(typeof h!="undefined")return h;if((0,P.isArray)(N)){const i=[];for(const s of N)i.push(d(s,C,L));return i}if((0,P.isObject)(N)){if(L.has(N))throw new Error("Cannot clone recursive data-structure");L.add(N);const i={};for(let s in N)o.call(N,s)&&(i[s]=d(N[s],C,L));return L.delete(N),i}return N}function l(N,C,L=!0){return(0,P.isObject)(N)?((0,P.isObject)(C)&&Object.keys(C).forEach(h=>{h in N?L&&((0,P.isObject)(N[h])&&(0,P.isObject)(C[h])?l(N[h],C[h],L):N[h]=C[h]):N[h]=C[h]}),N):C}n.mixin=l;function f(N,C){if(N===C)return!0;if(N==null||C===null||C===void 0||typeof N!=typeof C||typeof N!="object"||Array.isArray(N)!==Array.isArray(C))return!1;let L,h;if(Array.isArray(N)){if(N.length!==C.length)return!1;for(L=0;L<N.length;L++)if(!f(N[L],C[L]))return!1}else{const i=[];for(h in N)i.push(h);i.sort();const s=[];for(h in C)s.push(h);if(s.sort(),!f(i,s))return!1;for(L=0;L<i.length;L++)if(!f(N[i[L]],C[i[L]]))return!1}return!0}n.equals=f;function p(N){const C=new Set;return JSON.stringify(N,(L,h)=>{if((0,P.isObject)(h)||Array.isArray(h)){if(C.has(h))return"[Circular]";C.add(h)}return h})}n.safeStringify=p;function M(N,C,L){const h=C(N);return typeof h=="undefined"?L:h}n.getOrDefault=M;function v(N,C){const L=Object.create(null);return!N||!C||Object.keys(C).forEach(i=>{const s=N[i],a=C[i];f(s,a)||(L[i]=a)}),L}n.distinct=v;function m(N,C){const L=C.toLowerCase(),h=Object.keys(N).find(i=>i.toLowerCase()===L);return h?N[h]:N[C]}n.getCaseInsensitive=m;function e(N,C){const L=Object.create(null);for(const[h,i]of Object.entries(N))C(h,i)&&(L[h]=i);return L}n.filter=e}),x(ee[15],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var P;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P=n.Constants||(n.Constants={}));function t(o){return o<0?0:o>255?255:o|0}n.toUint8=t;function D(o){return o<0?0:o>4294967295?4294967295:o|0}n.toUint32=D}),x(ee[10],te([0,1,25,5]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const D=/^\w[\w\d+.-]*$/,o=/^\//,A=/^\/\//;function d(_,c){if(!_.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!D.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!o.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(_,c){return!_&&!c?"file":_}function f(_,c){switch(_){case"https":case"http":case"file":c?c[0]!==M&&(c=M+c):c=M;break}return c}const p="",M="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(c,g,w,y,S,R=!1){typeof c=="object"?(this.scheme=c.scheme||p,this.authority=c.authority||p,this.path=c.path||p,this.query=c.query||p,this.fragment=c.fragment||p):(this.scheme=l(c,R),this.authority=g||p,this.path=f(this.scheme,w||p),this.query=y||p,this.fragment=S||p,d(this,R))}static isUri(c){return c instanceof m?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}get fsPath(){return i(this,!1)}with(c){if(!c)return this;let{scheme:g,authority:w,path:y,query:S,fragment:R}=c;return g===void 0?g=this.scheme:g===null&&(g=p),w===void 0?w=this.authority:w===null&&(w=p),y===void 0?y=this.path:y===null&&(y=p),S===void 0?S=this.query:S===null&&(S=p),R===void 0?R=this.fragment:R===null&&(R=p),g===this.scheme&&w===this.authority&&y===this.path&&S===this.query&&R===this.fragment?this:new N(g,w,y,S,R)}static parse(c,g=!1){const w=v.exec(c);return w?new N(w[2]||p,b(w[4]||p),b(w[5]||p),b(w[7]||p),b(w[9]||p),g):new N(p,p,p,p,p)}static file(c){let g=p;if(t.isWindows&&(c=c.replace(/\\/g,M)),c[0]===M&&c[1]===M){const w=c.indexOf(M,2);w===-1?(g=c.substring(2),c=M):(g=c.substring(2,w),c=c.substring(w)||M)}return new N("file",g,c,p,p)}static from(c){const g=new N(c.scheme,c.authority,c.path,c.query,c.fragment);return d(g,!0),g}static joinPath(c,...g){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return t.isWindows&&c.scheme==="file"?w=m.file(P.win32.join(i(c,!0),...g)).path:w=P.posix.join(c.path,...g),c.with({path:w})}toString(c=!1){return s(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof m)return c;{const g=new N(c);return g._formatted=c.external,g._fsPath=c._sep===e?c.fsPath:null,g}}else return c}}n.URI=m;const e=t.isWindows?1:void 0;class N extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(c=!1){return c?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=e),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function L(_,c){let g,w=-1;for(let y=0;y<_.length;y++){const S=_.charCodeAt(y);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||c&&S===47)w!==-1&&(g+=encodeURIComponent(_.substring(w,y)),w=-1),g!==void 0&&(g+=_.charAt(y));else{g===void 0&&(g=_.substr(0,y));const R=C[S];R!==void 0?(w!==-1&&(g+=encodeURIComponent(_.substring(w,y)),w=-1),g+=R):w===-1&&(w=y)}}return w!==-1&&(g+=encodeURIComponent(_.substring(w))),g!==void 0?g:_}function h(_){let c;for(let g=0;g<_.length;g++){const w=_.charCodeAt(g);w===35||w===63?(c===void 0&&(c=_.substr(0,g)),c+=C[w]):c!==void 0&&(c+=_[g])}return c!==void 0?c:_}function i(_,c){let g;return _.authority&&_.path.length>1&&_.scheme==="file"?g=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===47&&(_.path.charCodeAt(1)>=65&&_.path.charCodeAt(1)<=90||_.path.charCodeAt(1)>=97&&_.path.charCodeAt(1)<=122)&&_.path.charCodeAt(2)===58?c?g=_.path.substr(1):g=_.path[1].toLowerCase()+_.path.substr(2):g=_.path,t.isWindows&&(g=g.replace(/\//g,"\\")),g}n.uriToFsPath=i;function s(_,c){const g=c?h:L;let w="",{scheme:y,authority:S,path:R,query:W,fragment:H}=_;if(y&&(w+=y,w+=":"),(S||y==="file")&&(w+=M,w+=M),S){let j=S.indexOf("@");if(j!==-1){const E=S.substr(0,j);S=S.substr(j+1),j=E.indexOf(":"),j===-1?w+=g(E,!1):(w+=g(E.substr(0,j),!1),w+=":",w+=g(E.substr(j+1),!1)),w+="@"}S=S.toLowerCase(),j=S.indexOf(":"),j===-1?w+=g(S,!1):(w+=g(S.substr(0,j),!1),w+=S.substr(j))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const j=R.charCodeAt(1);j>=65&&j<=90&&(R=`/${String.fromCharCode(j+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const j=R.charCodeAt(0);j>=65&&j<=90&&(R=`${String.fromCharCode(j+32)}:${R.substr(2)}`)}w+=g(R,!0)}return W&&(w+="?",w+=g(W,!1)),H&&(w+="#",w+=c?H:L(H,!1)),w}function a(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+a(_.substr(3)):_}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(_){return _.match(u)?_.replace(u,c=>a(c)):_}}),x(ee[44],te([0,1,8,6,9,5,7,2]),function(O,n,P,t,D,o,A,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const l="$initialize";let f=!1;function p(_){!o.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(_.message))}n.logOnceWebWorkerWarning=p;var M;(function(_){_[_.Request=0]="Request",_[_.Reply=1]="Reply",_[_.SubscribeEvent=2]="SubscribeEvent",_[_.Event=3]="Event",_[_.UnsubscribeEvent=4]="UnsubscribeEvent"})(M||(M={}));class v{constructor(c,g,w,y){this.vsWorker=c,this.req=g,this.method=w,this.args=y,this.type=0}}class m{constructor(c,g,w,y){this.vsWorker=c,this.seq=g,this.res=w,this.err=y,this.type=1}}class e{constructor(c,g,w,y){this.vsWorker=c,this.req=g,this.eventName=w,this.arg=y,this.type=2}}class N{constructor(c,g,w){this.vsWorker=c,this.req=g,this.event=w,this.type=3}}class C{constructor(c,g){this.vsWorker=c,this.req=g,this.type=4}}class L{constructor(c){this._workerId=-1,this._handler=c,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(c){this._workerId=c}sendMessage(c,g){const w=String(++this._lastSentReq);return new Promise((y,S)=>{this._pendingReplies[w]={resolve:y,reject:S},this._send(new v(this._workerId,w,c,g))})}listen(c,g){let w=null;const y=new t.Emitter({onFirstListenerAdd:()=>{w=String(++this._lastSentReq),this._pendingEmitters.set(w,y),this._send(new e(this._workerId,w,c,g))},onLastListenerRemove:()=>{this._pendingEmitters.delete(w),this._send(new C(this._workerId,w)),w=null}});return y.event}handleMessage(c){!c||!c.vsWorker||this._workerId!==-1&&c.vsWorker!==this._workerId||this._handleMessage(c)}_handleMessage(c){switch(c.type){case 1:return this._handleReplyMessage(c);case 0:return this._handleRequestMessage(c);case 2:return this._handleSubscribeEventMessage(c);case 3:return this._handleEventMessage(c);case 4:return this._handleUnsubscribeEventMessage(c)}}_handleReplyMessage(c){if(!this._pendingReplies[c.seq]){console.warn("Got reply to unknown seq");return}let g=this._pendingReplies[c.seq];if(delete this._pendingReplies[c.seq],c.err){let w=c.err;c.err.$isError&&(w=new Error,w.name=c.err.name,w.message=c.err.message,w.stack=c.err.stack),g.reject(w);return}g.resolve(c.res)}_handleRequestMessage(c){let g=c.req;this._handler.handleMessage(c.method,c.args).then(y=>{this._send(new m(this._workerId,g,y,void 0))},y=>{y.detail instanceof Error&&(y.detail=(0,P.transformErrorForSerialization)(y.detail)),this._send(new m(this._workerId,g,void 0,(0,P.transformErrorForSerialization)(y)))})}_handleSubscribeEventMessage(c){const g=c.req,w=this._handler.handleEvent(c.eventName,c.arg)(y=>{this._send(new N(this._workerId,g,y))});this._pendingEvents.set(g,w)}_handleEventMessage(c){if(!this._pendingEmitters.has(c.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(c.req).fire(c.event)}_handleUnsubscribeEventMessage(c){if(!this._pendingEvents.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(c.req).dispose(),this._pendingEvents.delete(c.req)}_send(c){let g=[];if(c.type===0)for(let w=0;w<c.args.length;w++)c.args[w]instanceof ArrayBuffer&&g.push(c.args[w]);else c.type===1&&c.res instanceof ArrayBuffer&&g.push(c.res);this._handler.sendMessage(c,g)}}class h extends D.Disposable{constructor(c,g,w){super();let y=null;this._worker=this._register(c.create("vs/base/common/worker/simpleWorker",j=>{this._protocol.handleMessage(j)},j=>{y&&y(j)})),this._protocol=new L({sendMessage:(j,E)=>{this._worker.postMessage(j,E)},handleMessage:(j,E)=>{if(typeof w[j]!="function")return Promise.reject(new Error("Missing method "+j+" on main thread host."));try{return Promise.resolve(w[j].apply(w,E))}catch(T){return Promise.reject(T)}},handleEvent:(j,E)=>{if(s(j)){const T=w[j].call(w,E);if(typeof T!="function")throw new Error(`Missing dynamic event ${j} on main thread host.`);return T}if(i(j)){const T=w[j];if(typeof T!="function")throw new Error(`Missing event ${j} on main thread host.`);return T}throw new Error(`Malformed event name ${j}`)}}),this._protocol.setWorkerId(this._worker.getId());let S=null;typeof o.globals.require!="undefined"&&typeof o.globals.require.getConfig=="function"?S=o.globals.require.getConfig():typeof o.globals.requirejs!="undefined"&&(S=o.globals.requirejs.s.contexts._.config);const R=A.getAllMethodNames(w);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(S)),g,R]);const W=(j,E)=>this._request(j,E),H=(j,E)=>this._protocol.listen(j,E);this._lazyProxy=new Promise((j,E)=>{y=E,this._onModuleLoaded.then(T=>{j(a(T,W,H))},T=>{E(T),this._onError("Worker failed to load "+g,T)})})}getProxyObject(){return this._lazyProxy}_request(c,g){return new Promise((w,y)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(c,g).then(w,y)},y)})}_onError(c,g){console.error(c),console.info(g)}}n.SimpleWorkerClient=h;function i(_){return _[0]==="o"&&_[1]==="n"&&d.isUpperAsciiLetter(_.charCodeAt(2))}function s(_){return/^onDynamic/.test(_)&&d.isUpperAsciiLetter(_.charCodeAt(9))}function a(_,c,g){const w=R=>function(){const W=Array.prototype.slice.call(arguments,0);return c(R,W)},y=R=>function(W){return g(R,W)};let S={};for(const R of _){if(s(R)){S[R]=y(R);continue}if(i(R)){S[R]=g(R,void 0);continue}S[R]=w(R)}return S}class u{constructor(c,g){this._requestHandlerFactory=g,this._requestHandler=null,this._protocol=new L({sendMessage:(w,y)=>{c(w,y)},handleMessage:(w,y)=>this._handleMessage(w,y),handleEvent:(w,y)=>this._handleEvent(w,y)})}onmessage(c){this._protocol.handleMessage(c)}_handleMessage(c,g){if(c===l)return this.initialize(g[0],g[1],g[2],g[3]);if(!this._requestHandler||typeof this._requestHandler[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this._requestHandler[c].apply(this._requestHandler,g))}catch(w){return Promise.reject(w)}}_handleEvent(c,g){if(!this._requestHandler)throw new Error("Missing requestHandler");if(s(c)){const w=this._requestHandler[c].call(this._requestHandler,g);if(typeof w!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return w}if(i(c)){const w=this._requestHandler[c];if(typeof w!="function")throw new Error(`Missing event ${c} on request handler.`);return w}throw new Error(`Malformed event name ${c}`)}initialize(c,g,w,y){this._protocol.setWorkerId(c);const W=a(y,(H,j)=>this._protocol.sendMessage(H,j),(H,j)=>this._protocol.listen(H,j));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(W),Promise.resolve(A.getAllMethodNames(this._requestHandler))):(g&&(typeof g.baseUrl!="undefined"&&delete g.baseUrl,typeof g.paths!="undefined"&&typeof g.paths.vs!="undefined"&&delete g.paths.vs,typeof g.trustedTypesPolicy!==void 0&&delete g.trustedTypesPolicy,g.catchError=!0,o.globals.require.config(g)),new Promise((H,j)=>{(o.globals.require||O)([w],T=>{if(this._requestHandler=T.create(W),!this._requestHandler){j(new Error("No RequestHandler!"));return}H(A.getAllMethodNames(this._requestHandler))},j)}))}}n.SimpleWorkerServer=u;function b(_){return new u(_,null)}n.create=b}),x(ee[16],te([0,1,15]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(d){const l=(0,P.toUint8)(d);this._defaultValue=l,this._asciiMap=t._createAsciiMap(l),this._map=new Map}static _createAsciiMap(d){const l=new Uint8Array(256);for(let f=0;f<256;f++)l[f]=d;return l}set(d,l){const f=(0,P.toUint8)(l);d>=0&&d<256?this._asciiMap[d]=f:this._map.set(d,f)}get(d){return d>=0&&d<256?this._asciiMap[d]:this._map.get(d)||this._defaultValue}}n.CharacterClassifier=t;var D;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(D||(D={}));class o{constructor(){this._actual=new t(0)}add(d){this._actual.set(d,1)}has(d){return this._actual.get(d)===1}}n.CharacterSet=o}),x(ee[3],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class P{constructor(D,o){this.lineNumber=D,this.column=o}with(D=this.lineNumber,o=this.column){return D===this.lineNumber&&o===this.column?this:new P(D,o)}delta(D=0,o=0){return this.with(this.lineNumber+D,this.column+o)}equals(D){return P.equals(this,D)}static equals(D,o){return!D&&!o?!0:!!D&&!!o&&D.lineNumber===o.lineNumber&&D.column===o.column}isBefore(D){return P.isBefore(this,D)}static isBefore(D,o){return D.lineNumber<o.lineNumber?!0:o.lineNumber<D.lineNumber?!1:D.column<o.column}isBeforeOrEqual(D){return P.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,o){return D.lineNumber<o.lineNumber?!0:o.lineNumber<D.lineNumber?!1:D.column<=o.column}static compare(D,o){const A=D.lineNumber|0,d=o.lineNumber|0;if(A===d){const l=D.column|0,f=o.column|0;return l-f}return A-d}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new P(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}n.Position=P}),x(ee[4],te([0,1,3]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(o,A,d,l){o>d||o===d&&A>l?(this.startLineNumber=d,this.startColumn=l,this.endLineNumber=o,this.endColumn=A):(this.startLineNumber=o,this.startColumn=A,this.endLineNumber=d,this.endColumn=l)}isEmpty(){return t.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return t.containsPosition(this,o)}static containsPosition(o,A){return!(A.lineNumber<o.startLineNumber||A.lineNumber>o.endLineNumber||A.lineNumber===o.startLineNumber&&A.column<o.startColumn||A.lineNumber===o.endLineNumber&&A.column>o.endColumn)}static strictContainsPosition(o,A){return!(A.lineNumber<o.startLineNumber||A.lineNumber>o.endLineNumber||A.lineNumber===o.startLineNumber&&A.column<=o.startColumn||A.lineNumber===o.endLineNumber&&A.column>=o.endColumn)}containsRange(o){return t.containsRange(this,o)}static containsRange(o,A){return!(A.startLineNumber<o.startLineNumber||A.endLineNumber<o.startLineNumber||A.startLineNumber>o.endLineNumber||A.endLineNumber>o.endLineNumber||A.startLineNumber===o.startLineNumber&&A.startColumn<o.startColumn||A.endLineNumber===o.endLineNumber&&A.endColumn>o.endColumn)}strictContainsRange(o){return t.strictContainsRange(this,o)}static strictContainsRange(o,A){return!(A.startLineNumber<o.startLineNumber||A.endLineNumber<o.startLineNumber||A.startLineNumber>o.endLineNumber||A.endLineNumber>o.endLineNumber||A.startLineNumber===o.startLineNumber&&A.startColumn<=o.startColumn||A.endLineNumber===o.endLineNumber&&A.endColumn>=o.endColumn)}plusRange(o){return t.plusRange(this,o)}static plusRange(o,A){let d,l,f,p;return A.startLineNumber<o.startLineNumber?(d=A.startLineNumber,l=A.startColumn):A.startLineNumber===o.startLineNumber?(d=A.startLineNumber,l=Math.min(A.startColumn,o.startColumn)):(d=o.startLineNumber,l=o.startColumn),A.endLineNumber>o.endLineNumber?(f=A.endLineNumber,p=A.endColumn):A.endLineNumber===o.endLineNumber?(f=A.endLineNumber,p=Math.max(A.endColumn,o.endColumn)):(f=o.endLineNumber,p=o.endColumn),new t(d,l,f,p)}intersectRanges(o){return t.intersectRanges(this,o)}static intersectRanges(o,A){let d=o.startLineNumber,l=o.startColumn,f=o.endLineNumber,p=o.endColumn,M=A.startLineNumber,v=A.startColumn,m=A.endLineNumber,e=A.endColumn;return d<M?(d=M,l=v):d===M&&(l=Math.max(l,v)),f>m?(f=m,p=e):f===m&&(p=Math.min(p,e)),d>f||d===f&&l>p?null:new t(d,l,f,p)}equalsRange(o){return t.equalsRange(this,o)}static equalsRange(o,A){return!!o&&!!A&&o.startLineNumber===A.startLineNumber&&o.startColumn===A.startColumn&&o.endLineNumber===A.endLineNumber&&o.endColumn===A.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(o){return new P.Position(o.endLineNumber,o.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(o){return new P.Position(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,A){return new t(this.startLineNumber,this.startColumn,o,A)}setStartPosition(o,A){return new t(o,A,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(o){return new t(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}static fromPositions(o,A=o){return new t(o.lineNumber,o.column,A.lineNumber,A.column)}static lift(o){return o?new t(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,A){return!(o.endLineNumber<A.startLineNumber||o.endLineNumber===A.startLineNumber&&o.endColumn<A.startColumn||A.endLineNumber<o.startLineNumber||A.endLineNumber===o.startLineNumber&&A.endColumn<o.startColumn)}static areIntersecting(o,A){return!(o.endLineNumber<A.startLineNumber||o.endLineNumber===A.startLineNumber&&o.endColumn<=A.startColumn||A.endLineNumber<o.startLineNumber||A.endLineNumber===o.startLineNumber&&A.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,A){if(o&&A){const f=o.startLineNumber|0,p=A.startLineNumber|0;if(f===p){const M=o.startColumn|0,v=A.startColumn|0;if(M===v){const m=o.endLineNumber|0,e=A.endLineNumber|0;if(m===e){const N=o.endColumn|0,C=A.endColumn|0;return N-C}return m-e}return M-v}return f-p}return(o?1:0)-(A?1:0)}static compareRangesUsingEnds(o,A){return o.endLineNumber===A.endLineNumber?o.endColumn===A.endColumn?o.startLineNumber===A.startLineNumber?o.startColumn-A.startColumn:o.startLineNumber-A.startLineNumber:o.endColumn-A.endColumn:o.endLineNumber-A.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}}n.Range=t}),x(ee[29],te([0,1,3,4]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var D;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(D=n.SelectionDirection||(n.SelectionDirection={}));class o extends t.Range{constructor(d,l,f,p){super(d,l,f,p);this.selectionStartLineNumber=d,this.selectionStartColumn=l,this.positionLineNumber=f,this.positionColumn=p}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return o.selectionsEqual(this,d)}static selectionsEqual(d,l){return d.selectionStartLineNumber===l.selectionStartLineNumber&&d.selectionStartColumn===l.selectionStartColumn&&d.positionLineNumber===l.positionLineNumber&&d.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,l){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,d,l):new o(d,l,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new P.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,l){return this.getDirection()===0?new o(d,l,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,d,l)}static fromPositions(d,l=d){return new o(d.lineNumber,d.column,l.lineNumber,l.column)}static fromRange(d,l){return l===0?new o(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new o(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new o(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,l){if(d&&!l||!d&&l)return!1;if(!d&&!l)return!0;if(d.length!==l.length)return!1;for(let f=0,p=d.length;f<p;f++)if(!this.selectionsEqual(d[f],l[f]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,l,f,p,M){return M===0?new o(d,l,f,p):new o(f,p,d,l)}}n.Selection=o}),x(ee[30],te([0,1,16]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class D extends P.CharacterClassifier{constructor(d){super(0);for(let l=0,f=d.length;l<f;l++)this.set(d.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=D;function o(A){const d={};return l=>(d.hasOwnProperty(l)||(d[l]=A(l)),d[l])}n.getMapForWordSeparators=o(A=>new D(A))}),x(ee[31],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(d=""){let l="(-?\\d*\\.\\d\\w*)|([^";for(const f of n.USUAL_WORD_SEPARATORS)d.indexOf(f)>=0||(l+="\\"+f);return l+="\\s]+)",new RegExp(l,"g")}n.DEFAULT_WORD_REGEXP=P();function t(d){let l=n.DEFAULT_WORD_REGEXP;if(d&&d instanceof RegExp)if(d.global)l=d;else{let f="g";d.ignoreCase&&(f+="i"),d.multiline&&(f+="m"),d.unicode&&(f+="u"),l=new RegExp(d.source,f)}return l.lastIndex=0,l}n.ensureValidWordDefinition=t;const D={maxLen:1e3,windowSize:15,timeBudget:150};function o(d,l,f,p,M=D){if(f.length>M.maxLen){let C=d-M.maxLen/2;return C<0?C=0:p+=C,f=f.substring(C,d+M.maxLen/2),o(d,l,f,p,M)}const v=Date.now(),m=d-1-p;let e=-1,N=null;for(let C=1;!(Date.now()-v>=M.timeBudget);C++){const L=m-M.windowSize*C;l.lastIndex=Math.max(0,L);const h=A(l,f,m,e);if(!h&&N||(N=h,L<=0))break;e=L}if(N){const C={word:N[0],startColumn:p+1+N.index,endColumn:p+1+N.index+N[0].length};return l.lastIndex=0,C}return null}n.getWordAtText=o;function A(d,l,f,p){let M;for(;M=d.exec(l);){const v=M.index||0;if(v<=f&&d.lastIndex>=f)return M;if(p>0&&v>p)return null}return null}}),x(ee[32],te([0,1,14,2]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const D=3;function o(N,C,L,h){return new P.LcsDiff(N,C,L).ComputeDiff(h)}class A{constructor(C){const L=[],h=[];for(let i=0,s=C.length;i<s;i++)L[i]=v(C[i],1),h[i]=m(C[i],1);this.lines=C,this._startColumns=L,this._endColumns=h}getElements(){const C=[];for(let L=0,h=this.lines.length;L<h;L++)C[L]=this.lines[L].substring(this._startColumns[L]-1,this._endColumns[L]-1);return C}getStrictElement(C){return this.lines[C]}getStartLineNumber(C){return C+1}getEndLineNumber(C){return C+1}createCharSequence(C,L,h){const i=[],s=[],a=[];let u=0;for(let b=L;b<=h;b++){const _=this.lines[b],c=C?this._startColumns[b]:1,g=C?this._endColumns[b]:_.length+1;for(let w=c;w<g;w++)i[u]=_.charCodeAt(w-1),s[u]=b+1,a[u]=w,u++}return new d(i,s,a)}}class d{constructor(C,L,h){this._charCodes=C,this._lineNumbers=L,this._columns=h}getElements(){return this._charCodes}getStartLineNumber(C){return this._lineNumbers[C]}getStartColumn(C){return this._columns[C]}getEndLineNumber(C){return this._lineNumbers[C]}getEndColumn(C){return this._columns[C]+1}}class l{constructor(C,L,h,i,s,a,u,b){this.originalStartLineNumber=C,this.originalStartColumn=L,this.originalEndLineNumber=h,this.originalEndColumn=i,this.modifiedStartLineNumber=s,this.modifiedStartColumn=a,this.modifiedEndLineNumber=u,this.modifiedEndColumn=b}static createFromDiffChange(C,L,h){let i,s,a,u,b,_,c,g;return C.originalLength===0?(i=0,s=0,a=0,u=0):(i=L.getStartLineNumber(C.originalStart),s=L.getStartColumn(C.originalStart),a=L.getEndLineNumber(C.originalStart+C.originalLength-1),u=L.getEndColumn(C.originalStart+C.originalLength-1)),C.modifiedLength===0?(b=0,_=0,c=0,g=0):(b=h.getStartLineNumber(C.modifiedStart),_=h.getStartColumn(C.modifiedStart),c=h.getEndLineNumber(C.modifiedStart+C.modifiedLength-1),g=h.getEndColumn(C.modifiedStart+C.modifiedLength-1)),new l(i,s,a,u,b,_,c,g)}}function f(N){if(N.length<=1)return N;const C=[N[0]];let L=C[0];for(let h=1,i=N.length;h<i;h++){const s=N[h],a=s.originalStart-(L.originalStart+L.originalLength),u=s.modifiedStart-(L.modifiedStart+L.modifiedLength);Math.min(a,u)<D?(L.originalLength=s.originalStart+s.originalLength-L.originalStart,L.modifiedLength=s.modifiedStart+s.modifiedLength-L.modifiedStart):(C.push(s),L=s)}return C}class p{constructor(C,L,h,i,s){this.originalStartLineNumber=C,this.originalEndLineNumber=L,this.modifiedStartLineNumber=h,this.modifiedEndLineNumber=i,this.charChanges=s}static createFromDiffResult(C,L,h,i,s,a,u){let b,_,c,g,w;if(L.originalLength===0?(b=h.getStartLineNumber(L.originalStart)-1,_=0):(b=h.getStartLineNumber(L.originalStart),_=h.getEndLineNumber(L.originalStart+L.originalLength-1)),L.modifiedLength===0?(c=i.getStartLineNumber(L.modifiedStart)-1,g=0):(c=i.getStartLineNumber(L.modifiedStart),g=i.getEndLineNumber(L.modifiedStart+L.modifiedLength-1)),a&&L.originalLength>0&&L.originalLength<20&&L.modifiedLength>0&&L.modifiedLength<20&&s()){const y=h.createCharSequence(C,L.originalStart,L.originalStart+L.originalLength-1),S=i.createCharSequence(C,L.modifiedStart,L.modifiedStart+L.modifiedLength-1);let R=o(y,S,s,!0).changes;u&&(R=f(R)),w=[];for(let W=0,H=R.length;W<H;W++)w.push(l.createFromDiffChange(R[W],y,S))}return new p(b,_,c,g,w)}}class M{constructor(C,L,h){this.shouldComputeCharChanges=h.shouldComputeCharChanges,this.shouldPostProcessCharChanges=h.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=h.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=h.shouldMakePrettyDiff,this.originalLines=C,this.modifiedLines=L,this.original=new A(C),this.modified=new A(L),this.continueLineDiff=e(h.maxComputationTime),this.continueCharDiff=e(h.maxComputationTime===0?0:Math.min(h.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const C=o(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),L=C.changes,h=C.quitEarly;if(this.shouldIgnoreTrimWhitespace){const u=[];for(let b=0,_=L.length;b<_;b++)u.push(p.createFromDiffResult(this.shouldIgnoreTrimWhitespace,L[b],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:h,changes:u}}const i=[];let s=0,a=0;for(let u=-1,b=L.length;u<b;u++){const _=u+1<b?L[u+1]:null,c=_?_.originalStart:this.originalLines.length,g=_?_.modifiedStart:this.modifiedLines.length;for(;s<c&&a<g;){const w=this.originalLines[s],y=this.modifiedLines[a];if(w!==y){{let S=v(w,1),R=v(y,1);for(;S>1&&R>1;){const W=w.charCodeAt(S-2),H=y.charCodeAt(R-2);if(W!==H)break;S--,R--}(S>1||R>1)&&this._pushTrimWhitespaceCharChange(i,s+1,1,S,a+1,1,R)}{let S=m(w,1),R=m(y,1);const W=w.length+1,H=y.length+1;for(;S<W&&R<H;){const j=w.charCodeAt(S-1),E=w.charCodeAt(R-1);if(j!==E)break;S++,R++}(S<W||R<H)&&this._pushTrimWhitespaceCharChange(i,s+1,S,W,a+1,R,H)}}s++,a++}_&&(i.push(p.createFromDiffResult(this.shouldIgnoreTrimWhitespace,_,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),s+=_.originalLength,a+=_.modifiedLength)}return{quitEarly:h,changes:i}}_pushTrimWhitespaceCharChange(C,L,h,i,s,a,u){if(this._mergeTrimWhitespaceCharChange(C,L,h,i,s,a,u))return;let b;this.shouldComputeCharChanges&&(b=[new l(L,h,L,i,s,a,s,u)]),C.push(new p(L,L,s,s,b))}_mergeTrimWhitespaceCharChange(C,L,h,i,s,a,u){const b=C.length;if(b===0)return!1;const _=C[b-1];return _.originalEndLineNumber===0||_.modifiedEndLineNumber===0?!1:_.originalEndLineNumber+1===L&&_.modifiedEndLineNumber+1===s?(_.originalEndLineNumber=L,_.modifiedEndLineNumber=s,this.shouldComputeCharChanges&&_.charChanges&&_.charChanges.push(new l(L,h,L,i,s,a,s,u)),!0):!1}}n.DiffComputer=M;function v(N,C){const L=t.firstNonWhitespaceIndex(N);return L===-1?C:L+1}function m(N,C){const L=t.lastNonWhitespaceIndex(N);return L===-1?C:L+2}function e(N){if(N===0)return()=>!0;const C=Date.now();return()=>Date.now()-C<N}}),x(ee[33],te([0,1,16]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var t;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class D{constructor(e,N,C){const L=new Uint8Array(e*N);for(let h=0,i=e*N;h<i;h++)L[h]=C;this._data=L,this.rows=e,this.cols=N}get(e,N){return this._data[e*this.cols+N]}set(e,N,C){this._data[e*this.cols+N]=C}}n.Uint8Matrix=D;class o{constructor(e){let N=0,C=0;for(let h=0,i=e.length;h<i;h++){const[s,a,u]=e[h];a>N&&(N=a),s>C&&(C=s),u>C&&(C=u)}N++,C++;const L=new D(C,N,0);for(let h=0,i=e.length;h<i;h++){const[s,a,u]=e[h];L.set(s,a,u)}this._states=L,this._maxCharCode=N}nextState(e,N){return N<0||N>=this._maxCharCode?0:this._states.get(e,N)}}n.StateMachine=o;let A=null;function d(){return A===null&&(A=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let f=null;function p(){if(f===null){f=new P.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<m.length;N++)f.set(m.charCodeAt(N),1);const e=".,;";for(let N=0;N<e.length;N++)f.set(e.charCodeAt(N),2)}return f}class M{static _createLink(e,N,C,L,h){let i=h-1;do{const s=N.charCodeAt(i);if(e.get(s)!==2)break;i--}while(i>L);if(L>0){const s=N.charCodeAt(L-1),a=N.charCodeAt(i);(s===40&&a===41||s===91&&a===93||s===123&&a===125)&&i--}return{range:{startLineNumber:C,startColumn:L+1,endLineNumber:C,endColumn:i+2},url:N.substring(L,i+1)}}static computeLinks(e,N=d()){const C=p(),L=[];for(let h=1,i=e.getLineCount();h<=i;h++){const s=e.getLineContent(h),a=s.length;let u=0,b=0,_=0,c=1,g=!1,w=!1,y=!1,S=!1;for(;u<a;){let R=!1;const W=s.charCodeAt(u);if(c===13){let H;switch(W){case 40:g=!0,H=0;break;case 41:H=g?0:1;break;case 91:y=!0,w=!0,H=0;break;case 93:y=!1,H=w?0:1;break;case 123:S=!0,H=0;break;case 125:H=S?0:1;break;case 39:H=_===34||_===96?0:1;break;case 34:H=_===39||_===96?0:1;break;case 96:H=_===39||_===34?0:1;break;case 42:H=_===42?1:0;break;case 124:H=_===124?1:0;break;case 32:H=y?0:1;break;default:H=C.get(W)}H===1&&(L.push(M._createLink(C,s,h,b,u)),R=!0)}else if(c===12){let H;W===91?(w=!0,H=0):H=C.get(W),H===1?R=!0:c=13}else c=N.nextState(c,W),c===0&&(R=!0);R&&(c=1,g=!1,w=!1,S=!1,b=u+1,_=W),u++}c===13&&L.push(M._createLink(C,s,h,b,a))}return L}}n.LinkComputer=M;function v(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:M.computeLinks(m)}n.computeLinks=v}),x(ee[34],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(D,o,A,d,l){if(D&&o){const f=this.doNavigateValueSet(o,l);if(f)return{range:D,value:f}}if(A&&d){const f=this.doNavigateValueSet(d,l);if(f)return{range:A,value:f}}return null}doNavigateValueSet(D,o){const A=this.numberReplace(D,o);return A!==null?A:this.textReplace(D,o)}numberReplace(D,o){const A=Math.pow(10,D.length-(D.lastIndexOf(".")+1));let d=Number(D),l=parseFloat(D);return!isNaN(d)&&!isNaN(l)&&d===l?d===0&&!o?null:(d=Math.floor(d*A),d+=o?A:-A,String(d/A)):null}textReplace(D,o){return this.valueSetsReplace(this._defaultValueSet,D,o)}valueSetsReplace(D,o,A){let d=null;for(let l=0,f=D.length;d===null&&l<f;l++)d=this.valueSetReplace(D[l],o,A);return d}valueSetReplace(D,o,A){let d=D.indexOf(o);return d>=0?(d+=A?1:-1,d<0?d=D.length-1:d%=D.length,D[d]):null}}n.BasicInplaceReplace=P,P.INSTANCE=new P}),x(ee[35],te([0,1,28]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var D;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(D=n.MinimapPosition||(n.MinimapPosition={}));var o;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(o=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var A;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(A=n.EndOfLinePreference||(n.EndOfLinePreference={}));var d;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(d=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var l;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(l=n.EndOfLineSequence||(n.EndOfLineSequence={}));class f{constructor(i){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,i.tabSize|0),this.indentSize=i.tabSize|0,this.insertSpaces=Boolean(i.insertSpaces),this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=Boolean(i.trimAutoWhitespace),this.bracketPairColorizationOptions=i.bracketPairColorizationOptions}equals(i){return this.tabSize===i.tabSize&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace&&(0,P.equals)(this.bracketPairColorizationOptions,i.bracketPairColorizationOptions)}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}n.TextModelResolvedOptions=f;class p{constructor(i,s){this._findMatchBrand=void 0,this.range=i,this.matches=s}}n.FindMatch=p;var M;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(M=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var v;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None"})(v=n.PositionAffinity||(n.PositionAffinity={}));var m;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m=n.ModelConstants||(n.ModelConstants={}));class e{constructor(i,s,a,u,b,_){this.identifier=i,this.range=s,this.text=a,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=b,this._isTracked=_}}n.ValidAnnotatedEditOperation=e;class N{constructor(i,s,a){this.regex=i,this.wordSeparators=s,this.simpleSearch=a}}n.SearchData=N;class C{constructor(i,s,a){this.reverseEdits=i,this.changes=s,this.trimAutoWhitespaceLineNumbers=a}}n.ApplyEditsResult=C;function L(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}n.shouldSynchronizeModel=L}),x(ee[36],te([0,1,19,15]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class D{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(l,f){l=(0,t.toUint32)(l);const p=this.values,M=this.prefixSum,v=f.length;return v===0?!1:(this.values=new Uint32Array(p.length+v),this.values.set(p.subarray(0,l),0),this.values.set(p.subarray(l),l+v),this.values.set(f,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,f){return l=(0,t.toUint32)(l),f=(0,t.toUint32)(f),this.values[l]===f?!1:(this.values[l]=f,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,f){l=(0,t.toUint32)(l),f=(0,t.toUint32)(f);const p=this.values,M=this.prefixSum;if(l>=p.length)return!1;const v=p.length-l;return f>=v&&(f=v),f===0?!1:(this.values=new Uint32Array(p.length-f),this.values.set(p.subarray(0,l),0),this.values.set(p.subarray(l+f),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,t.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let f=this.prefixSumValidIndex[0]+1;f===0&&(this.prefixSum[0]=this.values[0],f++),l>=this.values.length&&(l=this.values.length-1);for(let p=f;p<=l;p++)this.prefixSum[p]=this.prefixSum[p-1]+this.values[p];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let f=0,p=this.values.length-1,M=0,v=0,m=0;for(;f<=p;)if(M=f+(p-f)/2|0,v=this.prefixSum[M],m=v-this.values[M],l<m)p=M-1;else if(l>=v)f=M+1;else break;return new A(M,l-m)}}n.PrefixSumComputer=D;class o{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const f=this._indexBySum[l],p=f>0?this._prefixSum[f-1]:0;return new A(f,l-p)}removeValues(l,f){this._values.splice(l,f),this._invalidate(l)}insertValues(l,f){this._values=(0,P.arrayInsert)(this._values,l,f),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,f=this._values.length;l<f;l++){const p=this._values[l],M=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=M+p;for(let v=0;v<p;v++)this._indexBySum[M+v]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,f){this._values[l]!==f&&(this._values[l]=f,this._invalidate(l))}}n.ConstantTimePrefixSumComputer=o;class A{constructor(l,f){this.index=l,this.remainder=f,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=f}}n.PrefixSumIndexOfResult=A}),x(ee[37],te([0,1,2,3,36]),function(O,n,P,t,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class o{constructor(d,l,f,p){this._uri=d,this._lines=l,this._eol=f,this._versionId=p,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(d){d.eol&&d.eol!==this._eol&&(this._eol=d.eol,this._lineStarts=null);const l=d.changes;for(const f of l)this._acceptDeleteRange(f.range),this._acceptInsertText(new t.Position(f.range.startLineNumber,f.range.startColumn),f.text);this._versionId=d.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const d=this._eol.length,l=this._lines.length,f=new Uint32Array(l);for(let p=0;p<l;p++)f[p]=this._lines[p].length+d;this._lineStarts=new D.PrefixSumComputer(f)}}_setLineText(d,l){this._lines[d]=l,this._lineStarts&&this._lineStarts.setValue(d,this._lines[d].length+this._eol.length)}_acceptDeleteRange(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.startLineNumber-1].substring(d.endColumn-1));return}this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.endLineNumber-1].substring(d.endColumn-1)),this._lines.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}_acceptInsertText(d,l){if(l.length===0)return;const f=(0,P.splitLines)(l);if(f.length===1){this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+f[0]+this._lines[d.lineNumber-1].substring(d.column-1));return}f[f.length-1]+=this._lines[d.lineNumber-1].substring(d.column-1),this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+f[0]);const p=new Uint32Array(f.length-1);for(let M=1;M<f.length;M++)this._lines.splice(d.lineNumber+M-1,0,f[M]),p[M-1]=f[M].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(d.lineNumber,p)}}n.MirrorTextModel=o}),x(ee[38],te([0,1,2,30,3,4,35]),function(O,n,P,t,D,o,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const d=999;class l{constructor(h,i,s,a){this.searchString=h,this.isRegex=i,this.matchCase=s,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=f(this.searchString):h=this.searchString.indexOf(`
`)>=0;let i=null;try{i=P.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch{return null}if(!i)return null;let s=!this.isRegex&&!h;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new A.SearchData(i,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}n.SearchParams=l;function f(L){if(!L||L.length===0)return!1;for(let h=0,i=L.length;h<i;h++)if(L.charCodeAt(h)===92){if(h++,h>=i)break;const a=L.charCodeAt(h);if(a===110||a===114||a===87)return!0}return!1}n.isMultilineRegexSource=f;function p(L,h,i){if(!i)return new A.FindMatch(L,null);const s=[];for(let a=0,u=h.length;a<u;a++)s[a]=h[a];return new A.FindMatch(L,s)}n.createFindMatch=p;class M{constructor(h){const i=[];let s=0;for(let a=0,u=h.length;a<u;a++)h.charCodeAt(a)===10&&(i[s++]=a);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(h){const i=this._lineFeedsOffsets;let s=0,a=i.length-1;if(a===-1||h<=i[0])return 0;for(;s<a;){const u=s+((a-s)/2>>0);i[u]>=h?a=u-1:i[u+1]>=h?(s=u,a=u):s=u+1}return s+1}}class v{static findMatches(h,i,s,a,u){const b=i.parseSearchRequest();return b?b.regex.multiline?this._doFindMatchesMultiline(h,s,new C(b.wordSeparators,b.regex),a,u):this._doFindMatchesLineByLine(h,s,b,a,u):[]}static _getMultilineMatchRange(h,i,s,a,u,b){let _,c=0;a?(c=a.findLineFeedCountBeforeOffset(u),_=i+u+c):_=i+u;let g;if(a){const R=a.findLineFeedCountBeforeOffset(u+b.length)-c;g=_+b.length+R}else g=_+b.length;const w=h.getPositionAt(_),y=h.getPositionAt(g);return new o.Range(w.lineNumber,w.column,y.lineNumber,y.column)}static _doFindMatchesMultiline(h,i,s,a,u){const b=h.getOffsetAt(i.getStartPosition()),_=h.getValueInRange(i,1),c=h.getEOL()===`\r
`?new M(_):null,g=[];let w=0,y;for(s.reset(0);y=s.next(_);)if(g[w++]=p(this._getMultilineMatchRange(h,b,_,c,y.index,y[0]),y,a),w>=u)return g;return g}static _doFindMatchesLineByLine(h,i,s,a,u){const b=[];let _=0;if(i.startLineNumber===i.endLineNumber){const g=h.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return _=this._findMatchesInLine(s,g,i.startLineNumber,i.startColumn-1,_,b,a,u),b}const c=h.getLineContent(i.startLineNumber).substring(i.startColumn-1);_=this._findMatchesInLine(s,c,i.startLineNumber,i.startColumn-1,_,b,a,u);for(let g=i.startLineNumber+1;g<i.endLineNumber&&_<u;g++)_=this._findMatchesInLine(s,h.getLineContent(g),g,0,_,b,a,u);if(_<u){const g=h.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);_=this._findMatchesInLine(s,g,i.endLineNumber,0,_,b,a,u)}return b}static _findMatchesInLine(h,i,s,a,u,b,_,c){const g=h.wordSeparators;if(!_&&h.simpleSearch){const S=h.simpleSearch,R=S.length,W=i.length;let H=-R;for(;(H=i.indexOf(S,H+R))!==-1;)if((!g||N(g,i,W,H,R))&&(b[u++]=new A.FindMatch(new o.Range(s,H+1+a,s,H+1+R+a),null),u>=c))return u;return u}const w=new C(h.wordSeparators,h.regex);let y;w.reset(0);do if(y=w.next(i),y&&(b[u++]=p(new o.Range(s,y.index+1+a,s,y.index+1+y[0].length+a),y,_),u>=c))return u;while(y);return u}static findNextMatch(h,i,s,a){const u=i.parseSearchRequest();if(!u)return null;const b=new C(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindNextMatchMultiline(h,s,b,a):this._doFindNextMatchLineByLine(h,s,b,a)}static _doFindNextMatchMultiline(h,i,s,a){const u=new D.Position(i.lineNumber,1),b=h.getOffsetAt(u),_=h.getLineCount(),c=h.getValueInRange(new o.Range(u.lineNumber,u.column,_,h.getLineMaxColumn(_)),1),g=h.getEOL()===`\r
`?new M(c):null;s.reset(i.column-1);let w=s.next(c);return w?p(this._getMultilineMatchRange(h,b,c,g,w.index,w[0]),w,a):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(h,new D.Position(1,1),s,a):null}static _doFindNextMatchLineByLine(h,i,s,a){const u=h.getLineCount(),b=i.lineNumber,_=h.getLineContent(b),c=this._findFirstMatchInLine(s,_,b,i.column,a);if(c)return c;for(let g=1;g<=u;g++){const w=(b+g-1)%u,y=h.getLineContent(w+1),S=this._findFirstMatchInLine(s,y,w+1,1,a);if(S)return S}return null}static _findFirstMatchInLine(h,i,s,a,u){h.reset(a-1);const b=h.next(i);return b?p(new o.Range(s,b.index+1,s,b.index+1+b[0].length),b,u):null}static findPreviousMatch(h,i,s,a){const u=i.parseSearchRequest();if(!u)return null;const b=new C(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindPreviousMatchMultiline(h,s,b,a):this._doFindPreviousMatchLineByLine(h,s,b,a)}static _doFindPreviousMatchMultiline(h,i,s,a){const u=this._doFindMatchesMultiline(h,new o.Range(1,1,i.lineNumber,i.column),s,a,10*d);if(u.length>0)return u[u.length-1];const b=h.getLineCount();return i.lineNumber!==b||i.column!==h.getLineMaxColumn(b)?this._doFindPreviousMatchMultiline(h,new D.Position(b,h.getLineMaxColumn(b)),s,a):null}static _doFindPreviousMatchLineByLine(h,i,s,a){const u=h.getLineCount(),b=i.lineNumber,_=h.getLineContent(b).substring(0,i.column-1),c=this._findLastMatchInLine(s,_,b,a);if(c)return c;for(let g=1;g<=u;g++){const w=(u+b-g-1)%u,y=h.getLineContent(w+1),S=this._findLastMatchInLine(s,y,w+1,a);if(S)return S}return null}static _findLastMatchInLine(h,i,s,a){let u=null,b;for(h.reset(0);b=h.next(i);)u=p(new o.Range(s,b.index+1,s,b.index+1+b[0].length),b,a);return u}}n.TextModelSearch=v;function m(L,h,i,s,a){if(s===0)return!0;const u=h.charCodeAt(s-1);if(L.get(u)!==0||u===13||u===10)return!0;if(a>0){const b=h.charCodeAt(s);if(L.get(b)!==0)return!0}return!1}function e(L,h,i,s,a){if(s+a===i)return!0;const u=h.charCodeAt(s+a);if(L.get(u)!==0||u===13||u===10)return!0;if(a>0){const b=h.charCodeAt(s+a-1);if(L.get(b)!==0)return!0}return!1}function N(L,h,i,s,a){return m(L,h,i,s,a)&&e(L,h,i,s,a)}n.isValidMatch=N;class C{constructor(h,i){this._wordSeparators=h,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(h){this._searchRegex.lastIndex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(h){const i=h.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(s=this._searchRegex.exec(h),!s))return null;const a=s.index,u=s[0].length;if(a===this._prevMatchStartIndex&&u===this._prevMatchLength){if(u===0){P.getNextCodePoint(h,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=u,!this._wordSeparators||N(this._wordSeparators,h,i,a,u))return s}while(s);return null}}n.Searcher=C}),x(ee[39],te([0,1,4,38,2,7]),function(O,n,P,t,D,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class A{static computeUnicodeHighlights(v,m,e){const N=e?e.startLineNumber:1,C=e?e.endLineNumber:v.getLineCount(),L=new f(m),h=L.getCandidateCodePoints();let i;h==="allNonBasicAscii"?i=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):i=new RegExp(`${d(Array.from(h))}`,"g");const s=new t.Searcher(null,i),a=[];let u=!1,b,_=0,c=0,g=0;e:for(let w=N,y=C;w<=y;w++){const S=v.getLineContent(w),R=S.length;s.reset(0);do if(b=s.next(S),b){let W=b.index,H=b.index+b[0].length;if(W>0){const T=S.charCodeAt(W-1);D.isHighSurrogate(T)&&W--}if(H+1<R){const T=S.charCodeAt(H-1);D.isHighSurrogate(T)&&H++}const j=S.substring(W,H),E=L.shouldHighlightNonBasicASCII(j);if(E!==0){E===3?_++:E===2?c++:E===1?g++:(0,o.assertNever)(E);const T=1e3;if(a.length>=T){u=!0;break e}a.push(new P.Range(w,W+1,w,H+1))}}while(b)}return{ranges:a,hasMore:u,ambiguousCharacterCount:_,invisibleCharacterCount:c,nonBasicAsciiCharacterCount:g}}static computeUnicodeHighlightReason(v,m){const e=new f(m);switch(e.shouldHighlightNonBasicASCII(v)){case 0:return null;case 2:return{kind:1};case 3:{const C=v.codePointAt(0),L=e.ambiguousCharacters.getPrimaryConfusable(C),h=D.AmbiguousCharacters.getLocales().filter(i=>!D.AmbiguousCharacters.getInstance(new Set([...m.allowedLocales,i])).isAmbiguous(C));return{kind:0,confusableWith:String.fromCodePoint(L),notAmbiguousInLocales:h}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=A;function d(M,v){return`[${D.escapeRegExpCharacters(M.map(e=>String.fromCodePoint(e)).join(""))}]`}var l;(function(M){M[M.Ambiguous=0]="Ambiguous",M[M.Invisible=1]="Invisible",M[M.NonBasicAscii=2]="NonBasicAscii"})(l=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class f{constructor(v){this.options=v,this.allowedCodePoints=new Set(v.allowedCodePoints),this.ambiguousCharacters=D.AmbiguousCharacters.getInstance(new Set(v.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const v=new Set;if(this.options.invisibleCharacters)for(const m of D.InvisibleCharacters.codePoints)v.add(m);if(this.options.ambiguousCharacters)for(const m of this.ambiguousCharacters.getConfusableCodePoints())v.add(m);for(const m of this.allowedCodePoints)v.delete(m);return v}shouldHighlightNonBasicASCII(v){const m=v.codePointAt(0);return this.allowedCodePoints.has(m)?0:this.options.nonBasicASCII?1:this.options.invisibleCharacters&&!(v===" "||v===`
`||v==="	")&&D.InvisibleCharacters.isInvisibleCharacter(m)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(m)?3:0}}var p;(function(M){M[M.None=0]="None",M[M.NonBasicASCII=1]="NonBasicASCII",M[M.Invisible=2]="Invisible",M[M.Ambiguous=3]="Ambiguous"})(p||(p={}))}),x(ee[40],te([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var P;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(P=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(t=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var D;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(D=n.CompletionItemKind||(n.CompletionItemKind={}));var o;(function(r){r[r.Deprecated=1]="Deprecated"})(o=n.CompletionItemTag||(n.CompletionItemTag={}));var A;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var d;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(d=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var l;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(l=n.CursorChangeReason||(n.CursorChangeReason={}));var f;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(f=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var p;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(p=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var M;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(M=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var v;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.columnSelection=18]="columnSelection",r[r.comments=19]="comments",r[r.contextmenu=20]="contextmenu",r[r.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",r[r.cursorBlinking=22]="cursorBlinking",r[r.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",r[r.cursorStyle=24]="cursorStyle",r[r.cursorSurroundingLines=25]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",r[r.cursorWidth=27]="cursorWidth",r[r.disableLayerHinting=28]="disableLayerHinting",r[r.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",r[r.domReadOnly=30]="domReadOnly",r[r.dragAndDrop=31]="dragAndDrop",r[r.emptySelectionClipboard=32]="emptySelectionClipboard",r[r.extraEditorClassName=33]="extraEditorClassName",r[r.fastScrollSensitivity=34]="fastScrollSensitivity",r[r.find=35]="find",r[r.fixedOverflowWidgets=36]="fixedOverflowWidgets",r[r.folding=37]="folding",r[r.foldingStrategy=38]="foldingStrategy",r[r.foldingHighlight=39]="foldingHighlight",r[r.foldingImportsByDefault=40]="foldingImportsByDefault",r[r.foldingMaximumRegions=41]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=43]="fontFamily",r[r.fontInfo=44]="fontInfo",r[r.fontLigatures=45]="fontLigatures",r[r.fontSize=46]="fontSize",r[r.fontWeight=47]="fontWeight",r[r.formatOnPaste=48]="formatOnPaste",r[r.formatOnType=49]="formatOnType",r[r.glyphMargin=50]="glyphMargin",r[r.gotoLocation=51]="gotoLocation",r[r.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",r[r.hover=53]="hover",r[r.inDiffEditor=54]="inDiffEditor",r[r.inlineSuggest=55]="inlineSuggest",r[r.letterSpacing=56]="letterSpacing",r[r.lightbulb=57]="lightbulb",r[r.lineDecorationsWidth=58]="lineDecorationsWidth",r[r.lineHeight=59]="lineHeight",r[r.lineNumbers=60]="lineNumbers",r[r.lineNumbersMinChars=61]="lineNumbersMinChars",r[r.linkedEditing=62]="linkedEditing",r[r.links=63]="links",r[r.matchBrackets=64]="matchBrackets",r[r.minimap=65]="minimap",r[r.mouseStyle=66]="mouseStyle",r[r.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=68]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",r[r.multiCursorModifier=70]="multiCursorModifier",r[r.multiCursorPaste=71]="multiCursorPaste",r[r.occurrencesHighlight=72]="occurrencesHighlight",r[r.overviewRulerBorder=73]="overviewRulerBorder",r[r.overviewRulerLanes=74]="overviewRulerLanes",r[r.padding=75]="padding",r[r.parameterHints=76]="parameterHints",r[r.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",r[r.quickSuggestions=79]="quickSuggestions",r[r.quickSuggestionsDelay=80]="quickSuggestionsDelay",r[r.readOnly=81]="readOnly",r[r.renameOnType=82]="renameOnType",r[r.renderControlCharacters=83]="renderControlCharacters",r[r.renderFinalNewline=84]="renderFinalNewline",r[r.renderLineHighlight=85]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=87]="renderValidationDecorations",r[r.renderWhitespace=88]="renderWhitespace",r[r.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",r[r.roundedSelection=90]="roundedSelection",r[r.rulers=91]="rulers",r[r.scrollbar=92]="scrollbar",r[r.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=94]="scrollBeyondLastLine",r[r.scrollPredominantAxis=95]="scrollPredominantAxis",r[r.selectionClipboard=96]="selectionClipboard",r[r.selectionHighlight=97]="selectionHighlight",r[r.selectOnLineNumbers=98]="selectOnLineNumbers",r[r.showFoldingControls=99]="showFoldingControls",r[r.showUnused=100]="showUnused",r[r.snippetSuggestions=101]="snippetSuggestions",r[r.smartSelect=102]="smartSelect",r[r.smoothScrolling=103]="smoothScrolling",r[r.stickyTabStops=104]="stickyTabStops",r[r.stopRenderingLineAfter=105]="stopRenderingLineAfter",r[r.suggest=106]="suggest",r[r.suggestFontSize=107]="suggestFontSize",r[r.suggestLineHeight=108]="suggestLineHeight",r[r.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",r[r.suggestSelection=110]="suggestSelection",r[r.tabCompletion=111]="tabCompletion",r[r.tabIndex=112]="tabIndex",r[r.unicodeHighlighting=113]="unicodeHighlighting",r[r.unusualLineTerminators=114]="unusualLineTerminators",r[r.useShadowDOM=115]="useShadowDOM",r[r.useTabStops=116]="useTabStops",r[r.wordSeparators=117]="wordSeparators",r[r.wordWrap=118]="wordWrap",r[r.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=121]="wordWrapColumn",r[r.wordWrapOverride1=122]="wordWrapOverride1",r[r.wordWrapOverride2=123]="wordWrapOverride2",r[r.wrappingIndent=124]="wrappingIndent",r[r.wrappingStrategy=125]="wrappingStrategy",r[r.showDeprecated=126]="showDeprecated",r[r.inlayHints=127]="inlayHints",r[r.editorClassName=128]="editorClassName",r[r.pixelRatio=129]="pixelRatio",r[r.tabFocusMode=130]="tabFocusMode",r[r.layoutInfo=131]="layoutInfo",r[r.wrappingInfo=132]="wrappingInfo"})(v=n.EditorOption||(n.EditorOption={}));var m;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(m=n.EndOfLinePreference||(n.EndOfLinePreference={}));var e;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(e=n.EndOfLineSequence||(n.EndOfLineSequence={}));var N;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(N=n.IndentAction||(n.IndentAction={}));var C;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(C=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var L;(function(r){r[r.Other=0]="Other",r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(L=n.InlayHintKind||(n.InlayHintKind={}));var h;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(h=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var i;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.MAX_VALUE=126]="MAX_VALUE"})(i=n.KeyCode||(n.KeyCode={}));var s;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(s=n.MarkerSeverity||(n.MarkerSeverity={}));var a;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(a=n.MarkerTag||(n.MarkerTag={}));var u;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(u=n.MinimapPosition||(n.MinimapPosition={}));var b;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(b=n.MouseTargetType||(n.MouseTargetType={}));var _;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(_=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var c;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(c=n.OverviewRulerLane||(n.OverviewRulerLane={}));var g;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None"})(g=n.PositionAffinity||(n.PositionAffinity={}));var w;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(w=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var y;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(y=n.RenderMinimap||(n.RenderMinimap={}));var S;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(S=n.ScrollType||(n.ScrollType={}));var R;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(R=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var W;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(W=n.SelectionDirection||(n.SelectionDirection={}));var H;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(H=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var j;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(j=n.SymbolKind||(n.SymbolKind={}));var E;(function(r){r[r.Deprecated=1]="Deprecated"})(E=n.SymbolTag||(n.SymbolTag={}));var T;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(T=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var ne;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(ne=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var G;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(G=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var J;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(J=n.WrappingIndent||(n.WrappingIndent={}))}),x(ee[41],te([0,1,6,9]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(d){this._onDidChange.fire({changedLanguages:d,changedColorMap:!1})}register(d,l){return this._map.set(d,l),this.fire([d]),(0,t.toDisposable)(()=>{this._map.get(d)===l&&(this._map.delete(d),this.fire([d]))})}registerFactory(d,l){this._factories.get(d)?.dispose();const f=new o(this,d,l);return this._factories.set(d,f),(0,t.toDisposable)(()=>{const p=this._factories.get(d);!p||p!==f||(this._factories.delete(d),p.dispose())})}async getOrCreate(d){const l=this.get(d);if(l)return l;const f=this._factories.get(d);return!f||f.isResolved?null:(await f.resolve(),this.get(d))}get(d){return this._map.get(d)||null}isResolved(d){if(this.get(d))return!0;const f=this._factories.get(d);return!!(!f||f.isResolved)}setColorMap(d){this._colorMap=d,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=D;class o extends t.Disposable{constructor(d,l,f){super();this._registry=d,this._languageId=l,this._factory=f,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const d=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,d&&!this._isDisposed&&this._register(this._registry.register(this._languageId,d))}}}),x(ee[42],te([0,1,10,4,41,17]),function(O,n,P,t,D,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=n.TokenMetadata=n.MetadataConsts=n.StandardTokenType=n.ColorId=n.FontStyle=n.LanguageId=void 0;var A;(function(E){E[E.Null=0]="Null",E[E.PlainText=1]="PlainText"})(A=n.LanguageId||(n.LanguageId={}));var d;(function(E){E[E.NotSet=-1]="NotSet",E[E.None=0]="None",E[E.Italic=1]="Italic",E[E.Bold=2]="Bold",E[E.Underline=4]="Underline",E[E.Strikethrough=8]="Strikethrough"})(d=n.FontStyle||(n.FontStyle={}));var l;(function(E){E[E.None=0]="None",E[E.DefaultForeground=1]="DefaultForeground",E[E.DefaultBackground=2]="DefaultBackground"})(l=n.ColorId||(n.ColorId={}));var f;(function(E){E[E.Other=0]="Other",E[E.Comment=1]="Comment",E[E.String=2]="String",E[E.RegEx=3]="RegEx"})(f=n.StandardTokenType||(n.StandardTokenType={}));var p;(function(E){E[E.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",E[E.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",E[E.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",E[E.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",E[E.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",E[E.ITALIC_MASK=1024]="ITALIC_MASK",E[E.BOLD_MASK=2048]="BOLD_MASK",E[E.UNDERLINE_MASK=4096]="UNDERLINE_MASK",E[E.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",E[E.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",E[E.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",E[E.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",E[E.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",E[E.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",E[E.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",E[E.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",E[E.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",E[E.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",E[E.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",E[E.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(p=n.MetadataConsts||(n.MetadataConsts={}));class M{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&768)>>>8}static getFontStyle(T){return(T&15360)>>>10}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){const ne=this.getForeground(T);let G="mtk"+ne;const J=this.getFontStyle(T);return J&1&&(G+=" mtki"),J&2&&(G+=" mtkb"),J&4&&(G+=" mtku"),J&8&&(G+=" mtks"),G}static getInlineStyleFromMetadata(T,ne){const G=this.getForeground(T),J=this.getFontStyle(T);let r=`color: ${ne[G]};`;J&1&&(r+="font-style: italic;"),J&2&&(r+="font-weight: bold;");let le="";return J&4&&(le+=" underline"),J&8&&(le+=" line-through"),le&&(r+=`text-decoration:${le};`),r}static getPresentationFromMetadata(T){const ne=this.getForeground(T),G=this.getFontStyle(T);return{foreground:ne,italic:Boolean(G&1),bold:Boolean(G&2),underline:Boolean(G&4),strikethrough:Boolean(G&8)}}}n.TokenMetadata=M;class v{constructor(T,ne,G){this._tokenBrand=void 0,this.offset=T,this.type=ne,this.language=G}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=v;class m{constructor(T,ne){this._tokenizationResultBrand=void 0,this.tokens=T,this.endState=ne}}n.TokenizationResult=m;class e{constructor(T,ne){this._encodedTokenizationResultBrand=void 0,this.tokens=T,this.endState=ne}}n.EncodedTokenizationResult=e;var N;(function(E){E[E.Method=0]="Method",E[E.Function=1]="Function",E[E.Constructor=2]="Constructor",E[E.Field=3]="Field",E[E.Variable=4]="Variable",E[E.Class=5]="Class",E[E.Struct=6]="Struct",E[E.Interface=7]="Interface",E[E.Module=8]="Module",E[E.Property=9]="Property",E[E.Event=10]="Event",E[E.Operator=11]="Operator",E[E.Unit=12]="Unit",E[E.Value=13]="Value",E[E.Constant=14]="Constant",E[E.Enum=15]="Enum",E[E.EnumMember=16]="EnumMember",E[E.Keyword=17]="Keyword",E[E.Text=18]="Text",E[E.Color=19]="Color",E[E.File=20]="File",E[E.Reference=21]="Reference",E[E.Customcolor=22]="Customcolor",E[E.Folder=23]="Folder",E[E.TypeParameter=24]="TypeParameter",E[E.User=25]="User",E[E.Issue=26]="Issue",E[E.Snippet=27]="Snippet"})(N=n.CompletionItemKind||(n.CompletionItemKind={}));var C;(function(E){const T=new Map;T.set(0,o.Codicon.symbolMethod),T.set(1,o.Codicon.symbolFunction),T.set(2,o.Codicon.symbolConstructor),T.set(3,o.Codicon.symbolField),T.set(4,o.Codicon.symbolVariable),T.set(5,o.Codicon.symbolClass),T.set(6,o.Codicon.symbolStruct),T.set(7,o.Codicon.symbolInterface),T.set(8,o.Codicon.symbolModule),T.set(9,o.Codicon.symbolProperty),T.set(10,o.Codicon.symbolEvent),T.set(11,o.Codicon.symbolOperator),T.set(12,o.Codicon.symbolUnit),T.set(13,o.Codicon.symbolValue),T.set(15,o.Codicon.symbolEnum),T.set(14,o.Codicon.symbolConstant),T.set(15,o.Codicon.symbolEnum),T.set(16,o.Codicon.symbolEnumMember),T.set(17,o.Codicon.symbolKeyword),T.set(27,o.Codicon.symbolSnippet),T.set(18,o.Codicon.symbolText),T.set(19,o.Codicon.symbolColor),T.set(20,o.Codicon.symbolFile),T.set(21,o.Codicon.symbolReference),T.set(22,o.Codicon.symbolCustomColor),T.set(23,o.Codicon.symbolFolder),T.set(24,o.Codicon.symbolTypeParameter),T.set(25,o.Codicon.account),T.set(26,o.Codicon.issues);function ne(r){let le=T.get(r);return le||(console.info("No codicon found for CompletionItemKind "+r),le=o.Codicon.symbolProperty),le}E.toIcon=ne;const G=new Map;G.set("method",0),G.set("function",1),G.set("constructor",2),G.set("field",3),G.set("variable",4),G.set("class",5),G.set("struct",6),G.set("interface",7),G.set("module",8),G.set("property",9),G.set("event",10),G.set("operator",11),G.set("unit",12),G.set("value",13),G.set("constant",14),G.set("enum",15),G.set("enum-member",16),G.set("enumMember",16),G.set("keyword",17),G.set("snippet",27),G.set("text",18),G.set("color",19),G.set("file",20),G.set("reference",21),G.set("customcolor",22),G.set("folder",23),G.set("type-parameter",24),G.set("typeParameter",24),G.set("account",25),G.set("issue",26);function J(r,le){let be=G.get(r);return typeof be=="undefined"&&!le&&(be=9),be}E.fromString=J})(C=n.CompletionItemKinds||(n.CompletionItemKinds={}));var L;(function(E){E[E.Deprecated=1]="Deprecated"})(L=n.CompletionItemTag||(n.CompletionItemTag={}));var h;(function(E){E[E.KeepWhitespace=1]="KeepWhitespace",E[E.InsertAsSnippet=4]="InsertAsSnippet"})(h=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var i;(function(E){E[E.Invoke=0]="Invoke",E[E.TriggerCharacter=1]="TriggerCharacter",E[E.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(i=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var s;(function(E){E[E.Automatic=0]="Automatic",E[E.Explicit=1]="Explicit"})(s=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var a;(function(E){E[E.Invoke=1]="Invoke",E[E.Auto=2]="Auto"})(a=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var u;(function(E){E[E.Invoke=1]="Invoke",E[E.TriggerCharacter=2]="TriggerCharacter",E[E.ContentChange=3]="ContentChange"})(u=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var b;(function(E){E[E.Text=0]="Text",E[E.Read=1]="Read",E[E.Write=2]="Write"})(b=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function _(E){return E&&P.URI.isUri(E.uri)&&t.Range.isIRange(E.range)&&(t.Range.isIRange(E.originSelectionRange)||t.Range.isIRange(E.targetSelectionRange))}n.isLocationLink=_;var c;(function(E){E[E.File=0]="File",E[E.Module=1]="Module",E[E.Namespace=2]="Namespace",E[E.Package=3]="Package",E[E.Class=4]="Class",E[E.Method=5]="Method",E[E.Property=6]="Property",E[E.Field=7]="Field",E[E.Constructor=8]="Constructor",E[E.Enum=9]="Enum",E[E.Interface=10]="Interface",E[E.Function=11]="Function",E[E.Variable=12]="Variable",E[E.Constant=13]="Constant",E[E.String=14]="String",E[E.Number=15]="Number",E[E.Boolean=16]="Boolean",E[E.Array=17]="Array",E[E.Object=18]="Object",E[E.Key=19]="Key",E[E.Null=20]="Null",E[E.EnumMember=21]="EnumMember",E[E.Struct=22]="Struct",E[E.Event=23]="Event",E[E.Operator=24]="Operator",E[E.TypeParameter=25]="TypeParameter"})(c=n.SymbolKind||(n.SymbolKind={}));var g;(function(E){E[E.Deprecated=1]="Deprecated"})(g=n.SymbolTag||(n.SymbolTag={}));var w;(function(E){const T=new Map;T.set(0,o.Codicon.symbolFile),T.set(1,o.Codicon.symbolModule),T.set(2,o.Codicon.symbolNamespace),T.set(3,o.Codicon.symbolPackage),T.set(4,o.Codicon.symbolClass),T.set(5,o.Codicon.symbolMethod),T.set(6,o.Codicon.symbolProperty),T.set(7,o.Codicon.symbolField),T.set(8,o.Codicon.symbolConstructor),T.set(9,o.Codicon.symbolEnum),T.set(10,o.Codicon.symbolInterface),T.set(11,o.Codicon.symbolFunction),T.set(12,o.Codicon.symbolVariable),T.set(13,o.Codicon.symbolConstant),T.set(14,o.Codicon.symbolString),T.set(15,o.Codicon.symbolNumber),T.set(16,o.Codicon.symbolBoolean),T.set(17,o.Codicon.symbolArray),T.set(18,o.Codicon.symbolObject),T.set(19,o.Codicon.symbolKey),T.set(20,o.Codicon.symbolNull),T.set(21,o.Codicon.symbolEnumMember),T.set(22,o.Codicon.symbolStruct),T.set(23,o.Codicon.symbolEvent),T.set(24,o.Codicon.symbolOperator),T.set(25,o.Codicon.symbolTypeParameter);function ne(G){let J=T.get(G);return J||(console.info("No codicon found for SymbolKind "+G),J=o.Codicon.symbolProperty),J}E.toIcon=ne})(w=n.SymbolKinds||(n.SymbolKinds={}));class y{constructor(T){this.value=T}}n.FoldingRangeKind=y,y.Comment=new y("comment"),y.Imports=new y("imports"),y.Region=new y("region");var S;(function(E){function T(ne){return!ne||typeof ne!="object"?!1:typeof ne.id=="string"&&typeof ne.title=="string"}E.is=T})(S=n.Command||(n.Command={}));var R;(function(E){E[E.Collapsed=0]="Collapsed",E[E.Expanded=1]="Expanded"})(R=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var W;(function(E){E[E.Editing=0]="Editing",E[E.Preview=1]="Preview"})(W=n.CommentMode||(n.CommentMode={}));var H;(function(E){E[E.Other=0]="Other",E[E.Type=1]="Type",E[E.Parameter=2]="Parameter"})(H=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new D.TokenizationRegistry;var j;(function(E){E[E.None=0]="None",E[E.Option=1]="Option",E[E.Default=2]="Default",E[E.Preferred=3]="Preferred"})(j=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),x(ee[43],te([0,1,13,6,21,10,3,4,29,42,40]),function(O,n,P,t,D,o,A,d,l,f,p){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class M{static chord(e,N){return(0,D.KeyChord)(e,N)}}n.KeyMod=M,M.CtrlCmd=2048,M.Shift=1024,M.Alt=512,M.WinCtrl=256;function v(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:t.Emitter,KeyCode:p.KeyCode,KeyMod:M,Position:A.Position,Range:d.Range,Selection:l.Selection,SelectionDirection:p.SelectionDirection,MarkerSeverity:p.MarkerSeverity,MarkerTag:p.MarkerTag,Uri:o.URI,Token:f.Token}}n.createMonacoBaseAPI=v}),x(ee[45],te([0,1,14,5,10,3,4,32,37,31,33,34,43,7,12,39]),function(O,n,P,t,D,o,A,d,l,f,p,M,v,m,e,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class C extends l.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(s){return this._lines[s-1]}getWordAtPosition(s,a){const u=(0,f.getWordAtText)(s.column,(0,f.ensureValidWordDefinition)(a),this._lines[s.lineNumber-1],0);return u?new A.Range(s.lineNumber,u.startColumn,s.lineNumber,u.endColumn):null}getWordUntilPosition(s,a){const u=this.getWordAtPosition(s,a);return u?{word:this._lines[s.lineNumber-1].substring(u.startColumn-1,s.column-1),startColumn:u.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const a=this._lines,u=this._wordenize.bind(this);let b=0,_="",c=0,g=[];return{*[Symbol.iterator](){for(;;)if(c<g.length){const w=_.substring(g[c].start,g[c].end);c+=1,yield w}else if(b<a.length)_=a[b],g=u(_,s),c=0,b+=1;else break}}}getLineWords(s,a){const u=this._lines[s-1],b=this._wordenize(u,a),_=[];for(const c of b)_.push({word:u.substring(c.start,c.end),startColumn:c.start+1,endColumn:c.end+1});return _}_wordenize(s,a){const u=[];let b;for(a.lastIndex=0;(b=a.exec(s))&&b[0].length!==0;)u.push({start:b.index,end:b.index+b[0].length});return u}getValueInRange(s){if(s=this._validateRange(s),s.startLineNumber===s.endLineNumber)return this._lines[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const a=this._eol,u=s.startLineNumber-1,b=s.endLineNumber-1,_=[];_.push(this._lines[u].substring(s.startColumn-1));for(let c=u+1;c<b;c++)_.push(this._lines[c]);return _.push(this._lines[b].substring(0,s.endColumn-1)),_.join(a)}offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const a=this._lineStarts.getIndexOf(s),u=this._lines[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,u)}}_validateRange(s){const a=this._validatePosition({lineNumber:s.startLineNumber,column:s.startColumn}),u=this._validatePosition({lineNumber:s.endLineNumber,column:s.endColumn});return a.lineNumber!==s.startLineNumber||a.column!==s.startColumn||u.lineNumber!==s.endLineNumber||u.column!==s.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:u.lineNumber,endColumn:u.column}:s}_validatePosition(s){if(!o.Position.isIPosition(s))throw new Error("bad position");let{lineNumber:a,column:u}=s,b=!1;if(a<1)a=1,u=1,b=!0;else if(a>this._lines.length)a=this._lines.length,u=this._lines[a-1].length+1,b=!0;else{const _=this._lines[a-1].length+1;u<1?(u=1,b=!0):u>_&&(u=_,b=!0)}return b?{lineNumber:a,column:u}:s}}n.MirrorModel=C;class L{constructor(s,a){this._host=s,this._models=Object.create(null),this._foreignModuleFactory=a,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(s){return this._models[s]}_getModels(){const s=[];return Object.keys(this._models).forEach(a=>s.push(this._models[a])),s}acceptNewModel(s){this._models[s.url]=new C(D.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,a){if(!this._models[s])return;this._models[s].onEvents(a)}acceptRemovedModel(s){!this._models[s]||delete this._models[s]}async computeUnicodeHighlights(s,a,u){const b=this._getModel(s);return b?N.UnicodeTextModelHighlighter.computeUnicodeHighlights(b,a,u):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(s,a,u,b){const _=this._getModel(s),c=this._getModel(a);if(!_||!c)return null;const g=_.getLinesContent(),w=c.getLinesContent(),S=new d.DiffComputer(g,w,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:u,shouldMakePrettyDiff:!0,maxComputationTime:b}).computeDiff(),R=S.changes.length>0?!1:this._modelsAreIdentical(_,c);return{quitEarly:S.quitEarly,identical:R,changes:S.changes}}_modelsAreIdentical(s,a){const u=s.getLineCount(),b=a.getLineCount();if(u!==b)return!1;for(let _=1;_<=u;_++){const c=s.getLineContent(_),g=a.getLineContent(_);if(c!==g)return!1}return!0}async computeDirtyDiff(s,a,u){const b=this._getModel(s),_=this._getModel(a);if(!b||!_)return null;const c=b.getLinesContent(),g=_.getLinesContent();return new d.DiffComputer(c,g,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:u,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(s,a){const u=this._getModel(s);if(!u)return a;const b=[];let _;a=a.slice(0).sort((c,g)=>{if(c.range&&g.range)return A.Range.compareRangesUsingStarts(c.range,g.range);const w=c.range?0:1,y=g.range?0:1;return w-y});for(let{range:c,text:g,eol:w}of a){if(typeof w=="number"&&(_=w),A.Range.isEmpty(c)&&!g)continue;const y=u.getValueInRange(c);if(g=g.replace(/\r\n|\n|\r/g,u.eol),y===g)continue;if(Math.max(g.length,y.length)>L._diffLimit){b.push({range:c,text:g});continue}const S=(0,P.stringDiff)(y,g,!1),R=u.offsetAt(A.Range.lift(c).getStartPosition());for(const W of S){const H=u.positionAt(R+W.originalStart),j=u.positionAt(R+W.originalStart+W.originalLength),E={text:g.substr(W.modifiedStart,W.modifiedLength),range:{startLineNumber:H.lineNumber,startColumn:H.column,endLineNumber:j.lineNumber,endColumn:j.column}};u.getValueInRange(E.range)!==E.text&&b.push(E)}}return typeof _=="number"&&b.push({eol:_,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),b}async computeLinks(s){const a=this._getModel(s);return a?(0,p.computeLinks)(a):null}async textualSuggest(s,a,u,b){const _=new e.StopWatch(!0),c=new RegExp(u,b),g=new Set;e:for(let w of s){const y=this._getModel(w);if(!!y){for(let S of y.words(c))if(!(S===a||!isNaN(Number(S)))&&(g.add(S),g.size>L._suggestionsLimit))break e}}return{words:Array.from(g),duration:_.elapsed()}}async computeWordRanges(s,a,u,b){const _=this._getModel(s);if(!_)return Object.create(null);const c=new RegExp(u,b),g=Object.create(null);for(let w=a.startLineNumber;w<a.endLineNumber;w++){const y=_.getLineWords(w,c);for(const S of y){if(!isNaN(Number(S.word)))continue;let R=g[S.word];R||(R=[],g[S.word]=R),R.push({startLineNumber:w,startColumn:S.startColumn,endLineNumber:w,endColumn:S.endColumn})}}return g}async navigateValueSet(s,a,u,b,_){const c=this._getModel(s);if(!c)return null;const g=new RegExp(b,_);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const w=c.getValueInRange(a),y=c.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},g);if(!y)return null;const S=c.getValueInRange(y);return M.BasicInplaceReplace.INSTANCE.navigateValueSet(a,w,y,S,u)}loadForeignModule(s,a,u){const b=(g,w)=>this._host.fhr(g,w),c={host:m.createProxyObject(u,b),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(c,a),Promise.resolve(m.getAllMethodNames(this._foreignModule))):new Promise((g,w)=>{O([s],y=>{this._foreignModule=y.create(c,a),g(m.getAllMethodNames(this._foreignModule))},w)})}fmr(s,a){if(!this._foreignModule||typeof this._foreignModule[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this._foreignModule[s].apply(this._foreignModule,a))}catch(u){return Promise.reject(u)}}}n.EditorSimpleWorker=L,L._diffLimit=1e5,L._suggestionsLimit=1e4;function h(i){return new L(i,null)}n.create=h,typeof importScripts=="function"&&(t.globals.monaco=(0,v.createMonacoBaseAPI)())}),function(){const O=self.MonacoEnvironment,n=O&&O.baseUrl?O.baseUrl:"../../../",P=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:l=>l,createScript:(l,...f)=>{const p=f.slice(0,-1).join(","),M=f.pop().toString();return`(function anonymous(${p}) {
${M}
})`}}):void 0;function t(){try{return(P?self.eval(P.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function D(){return new Promise((l,f)=>{if(typeof self.define=="function"&&self.define.amd)return l();const p=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(p)&&p.substring(0,self.origin.length)!==self.origin)&&t()){fetch(p).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${p}`,(P?self.eval(P.createScript("",v)):new Function(v)).call(self),l()}).then(void 0,f);return}P?importScripts(P.createScriptURL(p)):importScripts(p),l()})}const o=function(l){D().then(()=>{require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//}),require([l],function(f){setTimeout(function(){let p=f.create((M,v)=>{self.postMessage(M,v)},null);for(self.onmessage=M=>p.onmessage(M.data,M.ports);d.length>0;)self.onmessage(d.shift())},0)})})};let A=!0,d=[];self.onmessage=l=>{if(!A){d.push(l);return}A=!1,o(l.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/921264bfe3ffbbfe5ec8c4b08214b88e2148fa3e/core/vs/base/worker/workerMain.js.map
