/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/network","vs/nls!vs/code/electron-main/main","electron","vs/nls","vs/base/common/types","vs/base/common/errors","vs/base/common/resources","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/node/pfs","os","vs/platform/workspaces/common/workspaces","vs/base/common/strings","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/labels","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/objects","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/storage/common/storage","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/credentials/node/credentialsMainService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],Z=function(V){for(var e=[],p=0,n=V.length;p<n;p++)e[p]=J[V[p]];return e};define(J[104],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(n,D){if(!n)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(J[105],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function p(M){return M?M.replace(/\$\((.*?)\)/g,(I,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=p;class n{constructor(I,f,y){this.id=I,this.definition=f,this.description=y,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function D(M,I){const f=["codicon","codicon-"+M];return I&&f.push("codicon-modifier-"+I),f}e.getClassNamesArray=D;var C;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function f(P){if(P instanceof n)return["codicon","codicon-"+P.id];const S=I.exec(P.id);if(!S)return f(n.error);let[,m,t]=S;const d=["codicon","codicon-"+m];return t&&d.push("codicon-modifier-"+t.substr(1)),d}M.asClassNameArray=f;function y(P){return f(P).join(" ")}M.asClassName=y;function b(P){return"."+f(P).join(".")}M.asCSSSelector=b})(C=e.CSSIcon||(e.CSSIcon={}))}),define(J[46],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(M){return(I,f,y)=>{let b=null,P=null;if(typeof y.value=="function"?(b="value",P=y.value):typeof y.get=="function"&&(b="get",P=y.get),!P)throw new Error("not supported");y[b]=M(P,f)}}e.createDecorator=p;function n(M,I,f){let y=null,b=null;if(typeof f.value=="function"?(y="value",b=f.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(y="get",b=f.get),!b)throw new Error("not supported");const P=`$memoize$${I}`;f[y]=function(...S){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,S)}),this[P]}}e.memoize=n;function D(M,I,f){return p((y,b)=>{const P=`$debounce$${b}`,S=`$debounce$result$${b}`;return function(...m){this[S]||(this[S]=f?f():void 0),clearTimeout(this[P]),I&&(this[S]=I(this[S],...m),m=[this[S]]),this[P]=setTimeout(()=>{y.apply(this,m),this[S]=f?f():void 0},M)}})}e.debounce=D;function C(M,I,f){return p((y,b)=>{const P=`$throttle$timer$${b}`,S=`$throttle$result$${b}`,m=`$throttle$lastRun$${b}`,t=`$throttle$pending$${b}`;return function(...d){if(this[S]||(this[S]=f?f():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),I&&(this[S]=I(this[S],...d)),this[t])return;const g=this[m]+M;g<=Date.now()?(this[m]=Date.now(),y.apply(this,[this[S]]),this[S]=f?f():void 0):(this[t]=!0,this[P]=setTimeout(()=>{this[t]=!1,this[m]=Date.now(),y.apply(this,[this[S]]),this[S]=f?f():void 0},g-Date.now()))}})}e.throttle=C}),define(J[15],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(l=>{l(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=p,e.errorHandler=new p;function n(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=n;function D(c){f(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=D;function C(c){f(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=C;function M(c){if(c instanceof Error){let{name:o,message:l}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:o,message:l,stack:s}}return c}e.transformErrorForSerialization=M;const I="Canceled";function f(c){return c instanceof y?!0:c instanceof Error&&c.name===I&&c.message===I}e.isCancellationError=f;class y extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=y;function b(){const c=new Error(I);return c.name=c.message,c}e.canceled=b;function P(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=P;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=S;function m(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function t(c){const o=new Error(`${c} has been disposed`);return o.name="DISPOSED",o}e.disposed=t;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=d;class g extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=g;class v extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=v;class k extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=k;function u(c){const o=c;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=u;function w(c,o=Object.create(null)){const l=new Error(c);return o.actions&&(l.actions=o.actions),l}e.createErrorWithActions=w}),define(J[30],Z([0,1,15]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(F,A=0){return F[F.length-(1+A)]}e.tail=n;function D(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=D;function C(F,A,O=(U,G)=>U===G){if(F===A)return!0;if(!F||!A||F.length!==A.length)return!1;for(let U=0,G=F.length;U<G;U++)if(!O(F[U],A[U]))return!1;return!0}e.equals=C;function M(F,A,O){let U=0,G=F.length-1;for(;U<=G;){const ne=(U+G)/2|0,ce=O(F[ne],A);if(ce<0)U=ne+1;else if(ce>0)G=ne-1;else return ne}return-(U+1)}e.binarySearch=M;function I(F,A){let O=0,U=F.length;if(U===0)return 0;for(;O<U;){const G=Math.floor((O+U)/2);A(F[G])?U=G:O=G+1}return O}e.findFirstInSorted=I;function f(F,A,O){if(F=F|0,F>=A.length)throw new TypeError("invalid index");let U=A[Math.floor(A.length*Math.random())],G=[],ne=[],ce=[];for(let ae of A){const re=O(ae,U);re<0?G.push(ae):re>0?ne.push(ae):ce.push(ae)}return F<G.length?f(F,G,O):F<G.length+ce.length?ce[0]:f(F-(G.length+ce.length),ne,O)}e.quickSelect=f;function y(F,A){const O=[];let U;for(const G of F.slice(0).sort(A))!U||A(U[0],G)!==0?(U=[G],O.push(U)):U.push(G);return O}e.groupBy=y;function b(F,A,O){const U=[];function G(ae,re,le){if(re===0&&le.length===0)return;const he=U[U.length-1];he&&he.start+he.deleteCount===ae?(he.deleteCount+=re,he.toInsert.push(...le)):U.push({start:ae,deleteCount:re,toInsert:le})}let ne=0,ce=0;for(;;){if(ne===F.length){G(ne,0,A.slice(ce));break}if(ce===A.length){G(ne,F.length-ne,[]);break}const ae=F[ne],re=A[ce],le=O(ae,re);le===0?(ne+=1,ce+=1):le<0?(G(ne,1,[]),ne+=1):le>0&&(G(ne,0,[re]),ce+=1)}return U}e.sortedDiff=b;function P(F,A,O){const U=b(F,A,O),G=[],ne=[];for(const ce of U)G.push(...F.slice(ce.start,ce.start+ce.deleteCount)),ne.push(...ce.toInsert);return{removed:G,added:ne}}e.delta=P;function S(F,A,O){if(O===0)return[];const U=F.slice(0,O).sort(A);return t(F,A,U,O,F.length),U}e.top=S;function m(F,A,O,U,G){return O===0?Promise.resolve([]):new Promise((ne,ce)=>{(async()=>{const ae=F.length,re=F.slice(0,O).sort(A);for(let le=O,he=Math.min(O+U,ae);le<ae;le=he,he=Math.min(he+U,ae)){if(le>O&&await new Promise(me=>setTimeout(me)),G&&G.isCancellationRequested)throw(0,p.canceled)();t(F,A,re,le,he)}return re})().then(ne,ce)})}e.topAsync=m;function t(F,A,O,U,G){for(const ne=O.length;U<G;U++){const ce=F[U];if(A(ce,O[ne-1])<0){O.pop();const ae=I(O,re=>A(ce,re)<0);O.splice(ae,0,ce)}}}function d(F){return F.filter(A=>!!A)}e.coalesce=d;function g(F){let A=0;for(let O=0;O<F.length;O++)F[O]&&(F[A]=F[O],A+=1);F.length=A}e.coalesceInPlace=g;function v(F,A,O){F.splice(O,0,F.splice(A,1)[0])}e.move=v;function k(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=k;function u(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=u;function w(F,A=O=>O){const O=new Set;return F.filter(U=>{const G=A(U);return O.has(G)?!1:(O.add(G),!0)})}e.distinct=w;function c(F){const A=new Set;return O=>{const U=F(O);return A.has(U)?!1:(A.add(U),!0)}}e.uniqueFilter=c;function o(F,A){const O=l(F,A);if(O!==-1)return F[O]}e.findLast=o;function l(F,A){for(let O=F.length-1;O>=0;O--){const U=F[O];if(A(U))return O}return-1}e.lastIndex=l;function s(F,A){return F.length>0?F[0]:A}e.firstOrDefault=s;function i(F,A,O=(U,G)=>U===G){let U=0;for(let G=0,ne=Math.min(F.length,A.length);G<ne&&O(F[G],A[G]);G++)U++;return U}e.commonPrefixLength=i;function r(F){return[].concat(...F)}e.flatten=r;function a(F,A){let O=typeof A=="number"?F:0;typeof A=="number"?O=F:(O=0,A=F);const U=[];if(O<=A)for(let G=O;G<A;G++)U.push(G);else for(let G=O;G>A;G--)U.push(G);return U}e.range=a;function h(F,A,O){return F.reduce((U,G)=>(U[A(G)]=O?O(G):G,U),Object.create(null))}e.index=h;function E(F,A){return F.push(A),()=>R(F,A)}e.insert=E;function R(F,A){const O=F.indexOf(A);if(O>-1)return F.splice(O,1),A}e.remove=R;function L(F,A,O){const U=F.slice(0,A),G=F.slice(A);return U.concat(O,G)}e.arrayInsert=L;function W(F,A){let O;if(typeof A=="number"){let U=A;O=()=>{const G=Math.sin(U++)*179426549;return G-Math.floor(G)}}else O=Math.random;for(let U=F.length-1;U>0;U-=1){const G=Math.floor(O()*(U+1)),ne=F[U];F[U]=F[G],F[G]=ne}}e.shuffle=W;function $(F,A){const O=F.indexOf(A);O>-1&&(F.splice(O,1),F.unshift(A))}e.pushToStart=$;function Q(F,A){const O=F.indexOf(A);O>-1&&(F.splice(O,1),F.push(A))}e.pushToEnd=Q;function ee(F,A){return Array.isArray(F)?F.map(A):A(F)}e.mapArrayOrNot=ee;function x(F){return Array.isArray(F)?F:[F]}e.asArray=x;function q(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=q;function X(F,A){for(const O of F){const U=A(O);if(U!==void 0)return U}}e.mapFind=X;function H(F,A,O){const U=te(F,A),G=F.length,ne=O.length;F.length=G+ne;for(let ce=G-1;ce>=U;ce--)F[ce+ne]=F[ce];for(let ce=0;ce<ne;ce++)F[ce+U]=O[ce]}e.insertInto=H;function j(F,A,O,U){const G=te(F,A),ne=F.splice(G,O);return H(F,G,U),ne}e.splice=j;function te(F,A){return A<0?Math.max(A+F.length,0):Math.min(A,F.length)}function N(F,A){return(O,U)=>A(F(O),F(U))}e.compareBy=N;const z=(F,A)=>F-A;e.numberComparator=z;function K(F,A){if(F.length===0)return;let O=F[0];for(let U=1;U<F.length;U++){const G=F[U];A(G,O)>0&&(O=G)}return O}e.findMaxBy=K;function B(F,A){if(F.length===0)return;let O=F[0];for(let U=1;U<F.length;U++){const G=F[U];A(G,O)>=0&&(O=G)}return O}e.findLastMaxBy=B;function T(F,A){return K(F,(O,U)=>-A(O,U))}e.findMinBy=T;class _{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const U=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,U}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const U=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,U}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const O=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,O}}e.ArrayQueue=_}),define(J[43],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(n){const D=this;let C=!1,M;return function(){return C||(C=!0,M=n.apply(D,arguments)),M}}e.once=p}),define(J[68],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(n){function D(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=D;const C=Object.freeze([]);function M(){return C}n.empty=M;function*I(c){yield c}n.single=I;function f(c){return c||C}n.from=f;function y(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=y;function b(c){return c[Symbol.iterator]().next().value}n.first=b;function P(c,o){for(const l of c)if(o(l))return!0;return!1}n.some=P;function S(c,o){for(const l of c)if(o(l))return l}n.find=S;function*m(c,o){for(const l of c)o(l)&&(yield l)}n.filter=m;function*t(c,o){let l=0;for(const s of c)yield o(s,l++)}n.map=t;function*d(...c){for(const o of c)for(const l of o)yield l}n.concat=d;function*g(c){for(const o of c)for(const l of o)yield l}n.concatNested=g;function v(c,o,l){let s=l;for(const i of c)s=o(s,i);return s}n.reduce=v;function*k(c,o,l=c.length){for(o<0&&(o+=c.length),l<0?l+=c.length:l>c.length&&(l=c.length);o<l;o++)yield c[o]}n.slice=k;function u(c,o=Number.POSITIVE_INFINITY){const l=[];if(o===0)return[l,c];const s=c[Symbol.iterator]();for(let i=0;i<o;i++){const r=s.next();if(r.done)return[l,n.empty()];l.push(r.value)}return[l,{[Symbol.iterator](){return s}}]}n.consume=u;function w(c,o,l=(s,i)=>s===i){const s=c[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const r=s.next(),a=i.next();if(r.done!==a.done)return!1;if(r.done)return!0;if(!l(r.value,a.value))return!1}}n.equals=w})(p=e.Iterable||(e.Iterable={}))}),define(J[44],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function M(o,l=!1){let s=0,i=o.length,r="",a=0,h=16,E=0;function R(q){let X=0,H=0;for(;X<q;){const j=o.charCodeAt(s);if(j>=48&&j<=57)H=H*16+j-48;else if(j>=65&&j<=70)H=H*16+j-65+10;else if(j>=97&&j<=102)H=H*16+j-97+10;else break;s++,X++}return X<q&&(H=-1),H}function L(q){s=q,r="",a=0,h=16,E=0}function W(){const q=s;if(o.charCodeAt(s)===48)s++;else for(s++;s<o.length&&y(o.charCodeAt(s));)s++;if(s<o.length&&o.charCodeAt(s)===46)if(s++,s<o.length&&y(o.charCodeAt(s)))for(s++;s<o.length&&y(o.charCodeAt(s));)s++;else return E=3,o.substring(q,s);let X=s;if(s<o.length&&(o.charCodeAt(s)===69||o.charCodeAt(s)===101))if(s++,(s<o.length&&o.charCodeAt(s)===43||o.charCodeAt(s)===45)&&s++,s<o.length&&y(o.charCodeAt(s))){for(s++;s<o.length&&y(o.charCodeAt(s));)s++;X=s}else E=3;return o.substring(q,X)}function $(){let q="",X=s;for(;;){if(s>=i){q+=o.substring(X,s),E=2;break}const H=o.charCodeAt(s);if(H===34){q+=o.substring(X,s),s++;break}if(H===92){if(q+=o.substring(X,s),s++,s>=i){E=2;break}switch(o.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const te=R(4);te>=0?q+=String.fromCharCode(te):E=4;break}default:E=5}X=s;continue}if(H>=0&&H<=31)if(f(H)){q+=o.substring(X,s),E=2;break}else E=6;s++}return q}function Q(){if(r="",E=0,a=s,s>=i)return a=i,h=17;let q=o.charCodeAt(s);if(I(q)){do s++,r+=String.fromCharCode(q),q=o.charCodeAt(s);while(I(q));return h=15}if(f(q))return s++,r+=String.fromCharCode(q),q===13&&o.charCodeAt(s)===10&&(s++,r+=`
`),h=14;switch(q){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,r=$(),h=10;case 47:{const X=s-1;if(o.charCodeAt(s+1)===47){for(s+=2;s<i&&!f(o.charCodeAt(s));)s++;return r=o.substring(X,s),h=12}if(o.charCodeAt(s+1)===42){s+=2;const H=i-1;let j=!1;for(;s<H;){if(o.charCodeAt(s)===42&&o.charCodeAt(s+1)===47){s+=2,j=!0;break}s++}return j||(s++,E=1),r=o.substring(X,s),h=13}return r+=String.fromCharCode(q),s++,h=16}case 45:if(r+=String.fromCharCode(q),s++,s===i||!y(o.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=W(),h=11;default:for(;s<i&&ee(q);)s++,q=o.charCodeAt(s);if(a!==s){switch(r=o.substring(a,s),r){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return r+=String.fromCharCode(q),s++,h=16}}function ee(q){if(I(q)||f(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let q;do q=Q();while(q>=12&&q<=15);return q}return{setPosition:L,getPosition:()=>s,scan:l?x:Q,getToken:()=>h,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>s-a,getTokenError:()=>E}}e.createScanner=M;function I(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function f(o){return o===10||o===13||o===8232||o===8233}function y(o){return o>=48&&o<=57}var b;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(b||(b={}));function P(o,l){const s=[],i=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function E(R,L,W,$){a.value=R,a.offset=L,a.length=W,a.type=$,a.colonOffset=void 0,r=a}try{u(o,{onObjectBegin:(R,L)=>{if(l<=R)throw i;r=void 0,h=l>R,s.push("")},onObjectProperty:(R,L,W)=>{if(l<L||(E(R,L,W,"property"),s[s.length-1]=R,l<=L+W))throw i},onObjectEnd:(R,L)=>{if(l<=R)throw i;r=void 0,s.pop()},onArrayBegin:(R,L)=>{if(l<=R)throw i;r=void 0,s.push(0)},onArrayEnd:(R,L)=>{if(l<=R)throw i;r=void 0,s.pop()},onLiteralValue:(R,L,W)=>{if(l<L||(E(R,L,W,c(R)),l<=L+W))throw i},onSeparator:(R,L,W)=>{if(l<=L)throw i;if(R===":"&&r&&r.type==="property")r.colonOffset=L,h=!1,r=void 0;else if(R===","){const $=s[s.length-1];typeof $=="number"?s[s.length-1]=$+1:(h=!0,s[s.length-1]=""),r=void 0}}})}catch(R){if(R!==i)throw R}return{path:s,previousNode:r,isAtPropertyKey:h,matches:R=>{let L=0;for(let W=0;L<R.length&&W<s.length;W++)if(R[L]===s[W]||R[L]==="*")L++;else if(R[L]!=="**")return!1;return L===R.length}}}e.getLocation=P;function S(o,l=[],s=C.DEFAULT){let i=null,r=[];const a=[];function h(R){Array.isArray(r)?r.push(R):i!==null&&(r[i]=R)}return u(o,{onObjectBegin:()=>{const R={};h(R),a.push(r),r=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const R=[];h(R),a.push(r),r=R,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:h,onError:(R,L,W)=>{l.push({error:R,offset:L,length:W})}},s),r[0]}e.parse=S;function m(o,l=[],s=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function a(R){return i.children.push(R),R}u(o,{onObjectBegin:R=>{i=a({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,L,W)=>{i=a({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:L,length:W,parent:i})},onObjectEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onArrayBegin:(R,L)=>{i=a({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onLiteralValue:(R,L,W)=>{a({type:c(R),offset:L,length:W,parent:i,value:R}),r(L+W)},onSeparator:(R,L,W)=>{i.type==="property"&&(R===":"?i.colonOffset=L:R===","&&r(L))},onError:(R,L,W)=>{l.push({error:R,offset:L,length:W})}},s);const E=i.children[0];return E&&delete E.parent,E}e.parseTree=m;function t(o,l){if(!o)return;let s=o;for(let i of l)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const a of s.children)if(Array.isArray(a.children)&&a.children[0].value===i){s=a.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=t;function d(o){if(!o.parent||!o.parent.children)return[];const l=d(o.parent);if(o.parent.type==="property"){const s=o.parent.children[0].value;l.push(s)}else if(o.parent.type==="array"){const s=o.parent.children.indexOf(o);s!==-1&&l.push(s)}return l}e.getNodePath=d;function g(o){switch(o.type){case"array":return o.children.map(g);case"object":{const l=Object.create(null);for(let s of o.children){const i=s.children[1];i&&(l[s.children[0].value]=g(i))}return l}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=g;function v(o,l,s=!1){return l>=o.offset&&l<o.offset+o.length||s&&l===o.offset+o.length}e.contains=v;function k(o,l,s=!1){if(v(o,l,s)){const i=o.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=l;r++){const a=k(i[r],l,s);if(a)return a}return o}}e.findNodeAtOffset=k;function u(o,l,s=C.DEFAULT){const i=M(o,!1);function r(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(_){return _?F=>_(F,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=r(l.onObjectBegin),E=a(l.onObjectProperty),R=r(l.onObjectEnd),L=r(l.onArrayBegin),W=r(l.onArrayEnd),$=a(l.onLiteralValue),Q=a(l.onSeparator),ee=r(l.onComment),x=a(l.onError),q=s&&s.disallowComments,X=s&&s.allowTrailingComma;function H(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:q||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(_){case 12:case 13:q?j(10):ee();break;case 16:j(1);break;case 15:case 14:break;default:return _}}}function j(_,F=[],A=[]){if(x(_),F.length+A.length>0){let O=i.getToken();for(;O!==17;){if(F.indexOf(O)!==-1){H();break}else if(A.indexOf(O)!==-1)break;O=H()}}}function te(_){const F=i.getTokenValue();return _?$(F):E(F),H(),!0}function N(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(j(2),_=0)}catch{j(2)}$(_);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return H(),!0}function z(){return i.getToken()!==10?(j(3,[],[2,5]),!1):(te(!1),i.getToken()===6?(Q(":"),H(),T()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function K(){h(),H();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||j(4,[],[]),Q(","),H(),i.getToken()===2&&X)break}else _&&j(6,[],[]);z()||j(4,[],[2,5]),_=!0}return R(),i.getToken()!==2?j(7,[2],[]):H(),!0}function B(){L(),H();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||j(4,[],[]),Q(","),H(),i.getToken()===4&&X)break}else _&&j(6,[],[]);T()||j(4,[],[4,5]),_=!0}return W(),i.getToken()!==4?j(8,[4],[]):H(),!0}function T(){switch(i.getToken()){case 3:return B();case 1:return K();case 10:return te(!0);default:return N()}}return H(),i.getToken()===17?s.allowEmptyContent?!0:(j(4,[],[]),!1):T()?(i.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=u;function w(o,l){let s=M(o),i=[],r,a=0,h;do switch(h=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:a!==h&&i.push(o.substring(a,h)),l!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,l)),a=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=w;function c(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[106],Z([0,1,44]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(y,b,P){let S,m,t,d,g;if(b){for(d=b.offset,g=d+b.length,t=d;t>0&&!f(y,t-1);)t--;let h=g;for(;h<y.length&&!f(y,h);)h++;m=y.substring(t,h),S=M(m,P)}else m=y,S=0,t=0,d=0,g=y.length;const v=I(P,y);let k=!1,u=0,w;P.insertSpaces?w=C(" ",P.tabSize||4):w="	";const c=(0,p.createScanner)(m,!1);let o=!1;function l(){return v+C(w,S+u)}function s(){let h=c.scan();for(k=!1;h===15||h===14;)k=k||h===14,h=c.scan();return o=h===16||c.getTokenError()!==0,h}const i=[];function r(h,E,R){!o&&E<g&&R>d&&y.substring(E,R)!==h&&i.push({offset:E,length:R-E,content:h})}let a=s();if(a!==17){const h=c.getTokenOffset()+t,E=C(w,S);r(E,t,h)}for(;a!==17;){let h=c.getTokenOffset()+c.getTokenLength()+t,E=s(),R="";for(;!k&&(E===12||E===13);){const W=c.getTokenOffset()+t;r(" ",h,W),h=c.getTokenOffset()+c.getTokenLength()+t,R=E===12?l():"",E=s()}if(E===2)a!==1&&(u--,R=l());else if(E===4)a!==3&&(u--,R=l());else{switch(a){case 3:case 1:u++,R=l();break;case 5:case 12:R=l();break;case 13:k?R=l():R=" ";break;case 6:R=" ";break;case 10:if(E===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?R=" ":E!==5&&E!==17&&(o=!0);break;case 16:o=!0;break}k&&(E===12||E===13)&&(R=l())}const L=c.getTokenOffset()+t;r(R,h,L),a=E}return i}e.format=n;function D(y,b){const P=JSON.stringify(y,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?P.replace(/\r\n|\r|\n/g,b.eol):P}e.toFormattedString=D;function C(y,b){let P="";for(let S=0;S<b;S++)P+=y;return P}function M(y,b){let P=0,S=0;const m=b.tabSize||4;for(;P<y.length;){const t=y.charAt(P);if(t===" ")S++;else if(t==="	")S+=m;else break;P++}return Math.floor(S/m)}function I(y,b){for(let P=0;P<b.length;P++){const S=b.charAt(P);if(S==="\r")return P+1<b.length&&b.charAt(P+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=I;function f(y,b){return`\r
`.indexOf(y.charAt(b))!==-1}e.isEOL=f}),define(J[107],Z([0,1,44,106]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(y,b,P){return C(y,b,void 0,P)}e.removeProperty=D;function C(y,b,P,S,m){const t=b.slice(),d=[],g=(0,p.parseTree)(y,d);let v,k;for(;t.length>0&&(k=t.pop(),v=(0,p.findNodeAtLocation)(g,t),v===void 0&&P!==void 0);)typeof k=="string"?P={[k]:P}:P=[P];if(v)if(v.type==="object"&&typeof k=="string"&&Array.isArray(v.children)){const u=(0,p.findNodeAtLocation)(v,[k]);if(u!==void 0)if(P===void 0){if(!u.parent)throw new Error("Malformed AST");const w=v.children.indexOf(u.parent);let c,o=u.parent.offset+u.parent.length;if(w>0){const l=v.children[w-1];c=l.offset+l.length}else c=v.offset+1,v.children.length>1&&(o=v.children[1].offset);return M(y,{offset:c,length:o-c,content:""},S)}else return M(y,{offset:u.offset,length:u.length,content:JSON.stringify(P)},S);else{if(P===void 0)return[];const w=`${JSON.stringify(k)}: ${JSON.stringify(P)}`,c=m?m(v.children.map(l=>l.children[0].value)):v.children.length;let o;if(c>0){const l=v.children[c-1];o={offset:l.offset+l.length,length:0,content:","+w}}else v.children.length===0?o={offset:v.offset+1,length:0,content:w}:o={offset:v.offset+1,length:0,content:w+","};return M(y,o,S)}}else if(v.type==="array"&&typeof k=="number"&&Array.isArray(v.children))if(P!==void 0){const u=`${JSON.stringify(P)}`;let w;if(v.children.length===0||k===0)w={offset:v.offset+1,length:0,content:v.children.length===0?u:u+","};else{const c=k===-1||k>v.children.length?v.children.length:k,o=v.children[c-1];w={offset:o.offset+o.length,length:0,content:","+u}}return M(y,w,S)}else{const u=k,w=v.children[u];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===u){const o=v.children[u-1],l=o.offset+o.length,s=v.offset+v.length;c={offset:l,length:s-2-l,content:""}}else c={offset:w.offset,length:v.children[u+1].offset-w.offset,content:""};return M(y,c,S)}else throw new Error(`Can not add ${typeof k!="number"?"index":"property"} to parent of type ${v.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return M(y,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(P)},S)}}e.setProperty=C;function M(y,b,P){let S=I(y,b),m=b.offset,t=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;m>0&&!(0,n.isEOL)(S,m-1);)m--;for(;t<S.length&&!(0,n.isEOL)(S,t);)t++}const d=(0,n.format)(S,{offset:m,length:t-m},P);for(let v=d.length-1;v>=0;v--){const k=d[v];S=I(S,k),m=Math.min(m,k.offset),t=Math.max(t,k.offset+k.length),t+=k.content.length-k.length}const g=y.length-(S.length-t)-m;return[{offset:m,length:g,content:S.substring(m,t)}]}e.withFormatting=M;function I(y,b){return y.substring(0,b.offset)+b.content+y.substring(b.offset+b.length)}e.applyEdit=I;function f(y,b){let P=b.slice(0).sort((m,t)=>{const d=m.offset-t.offset;return d===0?m.length-t.length:d}),S=y.length;for(let m=P.length-1;m>=0;m--){let t=P[m];if(t.offset+t.length<=S)y=I(y,t);else throw new Error("Overlapping edit");S=t.offset}return y}e.applyEdits=f}),define(J[82],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,g){this._keyCodeToStr[d]=g,this._strToKeyCode[g.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const C=new D,M=new D,I=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],y=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>b[t]||0,toEnum:t=>y[t]||0,toString:t=>f[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",d=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let g=[],v=[];for(const k of d){const[u,w,c,o,l,s,i,r,a,h]=k;if(v[c]||(v[c]=!0,f[c]=o,y[o]=c,b[o.toLowerCase()]=c,w&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[l]=c))),!g[l]){if(g[l]=!0,!s)throw new Error(`String representation missing for key code ${l} around scan code ${o}`);C.define(l,s),M.define(l,a||s),I.define(l,h||a||s)}i&&(e.EVENT_KEY_CODE_MAP[i]=l),r&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=l)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(t){function d(c){return C.keyCodeToStr(c)}t.toString=d;function g(c){return C.strToKeyCode(c)}t.fromString=g;function v(c){return M.keyCodeToStr(c)}t.toUserSettingsUS=v;function k(c){return I.keyCodeToStr(c)}t.toUserSettingsGeneral=k;function u(c){return M.strToKeyCode(c)||I.strToKeyCode(c)}t.fromUserSettings=u;function w(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(c)}t.toElectronAccelerator=w})(P=e.KeyCodeUtils||(e.KeyCodeUtils={}));var S;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(S=e.KeyMod||(e.KeyMod={}));function m(t,d){const g=(d&65535)<<16>>>0;return(t|g)>>>0}e.KeyChord=m}),define(J[59],Z([0,1,15]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(n||(n={}));function D(P,S){if(P===0)return null;const m=(P&65535)>>>0,t=(P&4294901760)>>>16;return t!==0?new I([C(m,S),C(t,S)]):new I([C(m,S)])}e.createKeybinding=D;function C(P,S){const m=!!(P&2048),t=!!(P&256),d=S===2?t:m,g=!!(P&1024),v=!!(P&512),k=S===2?m:t,u=P&255;return new M(d,g,v,k,u)}e.createSimpleKeybinding=C;class M{constructor(S,m,t,d,g){this.ctrlKey=S,this.shiftKey=m,this.altKey=t,this.metaKey=d,this.keyCode=g}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.keyCode===S.keyCode}getHashCode(){const S=this.ctrlKey?"1":"0",m=this.shiftKey?"1":"0",t=this.altKey?"1":"0",d=this.metaKey?"1":"0";return`${S}${m}${t}${d}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=M;class I{constructor(S){if(S.length===0)throw(0,p.illegalArgument)("parts");this.parts=S}getHashCode(){let S="";for(let m=0,t=this.parts.length;m<t;m++)m!==0&&(S+=";"),S+=this.parts[m].getHashCode();return S}equals(S){if(S===null||this.parts.length!==S.parts.length)return!1;for(let m=0;m<this.parts.length;m++)if(!this.parts[m].equals(S.parts[m]))return!1;return!0}}e.ChordKeybinding=I;class f{constructor(S,m,t,d,g){this.ctrlKey=S,this.shiftKey=m,this.altKey=t,this.metaKey=d,this.scanCode=g}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.scanCode===S.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=f;class y{constructor(S,m,t,d,g,v){this.ctrlKey=S,this.shiftKey=m,this.altKey=t,this.metaKey=d,this.keyLabel=g,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=y;class b{}e.ResolvedKeybinding=b}),define(J[108],Z([0,1,82,59]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(M){M=M.toLowerCase().trim();let I=!1,f=!1,y=!1,b=!1,P;do P=!1,/^ctrl(\+|\-)/.test(M)&&(I=!0,M=M.substr("ctrl-".length),P=!0),/^shift(\+|\-)/.test(M)&&(f=!0,M=M.substr("shift-".length),P=!0),/^alt(\+|\-)/.test(M)&&(y=!0,M=M.substr("alt-".length),P=!0),/^meta(\+|\-)/.test(M)&&(b=!0,M=M.substr("meta-".length),P=!0),/^win(\+|\-)/.test(M)&&(b=!0,M=M.substr("win-".length),P=!0),/^cmd(\+|\-)/.test(M)&&(b=!0,M=M.substr("cmd-".length),P=!0);while(P);let S;const m=M.indexOf(" ");return m>0?(S=M.substring(0,m),M=M.substring(m)):(S=M,M=""),{remains:M,ctrl:I,shift:f,alt:y,meta:b,key:S}}static parseSimpleKeybinding(M){const I=this._readModifiers(M),f=p.KeyCodeUtils.fromUserSettings(I.key);return[new n.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,f),I.remains]}static parseKeybinding(M,I){if(!M)return null;const f=[];let y;do[y,M]=this.parseSimpleKeybinding(M),f.push(y);while(M.length>0);return new n.ChordKeybinding(f)}static parseSimpleUserBinding(M){const I=this._readModifiers(M),f=I.key.match(/^\[([^\]]+)\]$/);if(f){const b=f[1],P=p.ScanCodeUtils.lowerCaseToEnum(b);return[new n.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,P),I.remains]}const y=p.KeyCodeUtils.fromUserSettings(I.key);return[new n.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,y),I.remains]}static parseUserBinding(M){if(!M)return[];const I=[];let f;for(;M.length>0;)[f,M]=this.parseSimpleUserBinding(M),I.push(f);return I}}e.KeybindingParser=D}),define(J[109],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new p(()=>D(this.getValue()))}}e.Lazy=p}),define(J[2],Z([0,1,43,68]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function M(i){C=i}if(e.setDisposableTracker=M,D){const i="__is_disposable_tracked__";M(new class{trackDisposable(r){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(a)},3e3)}setParent(r,a){if(r&&r!==k.None)try{r[i]=!0}catch{}}markAsDisposed(r){if(r&&r!==k.None)try{r[i]=!0}catch{}}markAsSingleton(r){}})}function I(i){return C?.trackDisposable(i),i}function f(i){C?.markAsDisposed(i)}function y(i,r){C?.setParent(i,r)}function b(i,r){if(!!C)for(const a of i)C.setParent(a,r)}function P(i){return C?.markAsSingleton(i),i}e.markAsSingleton=P;class S extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=S;function m(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=m;function t(i){if(n.Iterable.is(i)){let r=[];for(const a of i)if(a)try{a.dispose()}catch(h){r.push(h)}if(r.length===1)throw r[0];if(r.length>1)throw new S(r);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function d(...i){const r=g(()=>t(i));return b(i,r),r}e.combinedDisposable=d;function g(i){const r=I({dispose:(0,p.once)(()=>{f(r),i()})});return r}e.toDisposable=g;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return y(r,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class k{constructor(){this._store=new v,I(this),y(this._store,this)}dispose(){f(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=k,k.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&y(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&y(r,null),r}}e.MutableDisposable=u;class w{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=w;class c{constructor(){this.references=new Map}acquire(r,...a){let h=this.references.get(r);h||(h={counter:0,object:this.createReferencedObject(r,...a)},this.references.set(r,h));const{object:E}=h,R=(0,p.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(r,h.object),this.references.delete(r))});return h.counter++,{object:E,dispose:R}}}e.ReferenceCollection=c;class o{constructor(r){this.referenceCollection=r}async acquire(r,...a){const h=this.referenceCollection.acquire(r,...a);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(E){throw h.dispose(),E}}}e.AsyncReferenceCollection=o;class l{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=l;function s(i){const r=new v;try{i(r)}finally{r.dispose()}}e.disposeOnReturn=s}),define(J[110],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(C){this.element=C,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class n{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let C=this._first;for(;C!==p.Undefined;){const M=C.next;C.prev=p.Undefined,C.next=p.Undefined,C=M}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,M){const I=new p(C);if(this._first===p.Undefined)this._first=I,this._last=I;else if(M){const y=this._last;this._last=I,I.prev=y,y.next=I}else{const y=this._first;this._first=I,I.next=y,y.prev=I}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(I))}}shift(){if(this._first!==p.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==p.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==p.Undefined&&C.next!==p.Undefined){const M=C.prev;M.next=C.next,C.next.prev=M}else C.prev===p.Undefined&&C.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):C.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):C.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==p.Undefined;)yield C.element,C=C.next}}e.LinkedList=n}),function(){function V(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function M(f){C.push(f,Date.now())}function I(){const f=[];for(let y=0;y<C.length;y+=2)f.push({name:C[y],startTime:C[y+1]});return f}return{mark:M,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const M of performance.getEntriesByType("mark"))C.push({name:M.name,startTime:Math.round(D+M.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=p(n))}(),define(J[3],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let n=!1,D=!1,C=!1,M=!1,I=!1,f=!1,y=!1,b=!1,P=!1,S,m=p,t,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const v=typeof g?.versions?.electron=="string",k=v&&g?.type==="renderer";if(e.isElectronSandboxed=k&&g?.sandboxed,typeof navigator=="object"&&!k)d=navigator.userAgent,n=d.indexOf("Windows")>=0,D=d.indexOf("Macintosh")>=0,b=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=d.indexOf("Linux")>=0,f=!0,S=navigator.language,m=S;else if(typeof g=="object"){n=g.platform==="win32",D=g.platform==="darwin",C=g.platform==="linux",M=C&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,y=v,P=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=p,m=p;const a=g.env.VSCODE_NLS_CONFIG;if(a)try{const h=JSON.parse(a),E=h.availableLanguages["*"];S=h.locale,m=E||p,t=h._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var u;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(u=e.Platform||(e.Platform={}));function w(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let c=0;D?c=1:n?c=3:C&&(c=2),e.isWindows=n,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=M,e.isNative=I,e.isElectron=y,e.isWeb=f,e.isIOS=b,e.isCI=P,e.platform=c,e.userAgent=d,e.language=m;var o;(function(a){function h(){return e.language}a.value=h;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=E;function R(){return e.language==="en"}a.isDefault=R})(o=e.Language||(e.Language={})),e.locale=S,e.translationsConfigFile=t,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let R=0,L=a.length;R<L;R++){const W=a[R];if(W.id===E.data.vscodeScheduleAsyncWork){a.splice(R,1),W.callback();return}}});let h=0;return E=>{const R=++h;a.push({id:R,callback:E}),e.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return a=>setTimeout(a)})();var l;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||b?2:n?1:3;let s=!0,i=!1;function r(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,s=new Uint16Array(a.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(J[36],Z([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(J[9],Z([0,1,36]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,C=90,M=122,I=46,f=47,y=92,b=58,P=63;class S extends Error{constructor(w,c,o){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const s=w.indexOf(".")!==-1?"property":"argument";let i=`The "${w}" ${s} ${l} of type ${c}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function m(u,w){if(typeof u!="string")throw new S(w,"string",u)}function t(u){return u===f||u===y}function d(u){return u===f}function g(u){return u>=n&&u<=C||u>=D&&u<=M}function v(u,w,c,o){let l="",s=0,i=-1,r=0,a=0;for(let h=0;h<=u.length;++h){if(h<u.length)a=u.charCodeAt(h);else{if(o(a))break;a=f}if(o(a)){if(!(i===h-1||r===1))if(r===2){if(l.length<2||s!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const E=l.lastIndexOf(c);E===-1?(l="",s=0):(l=l.slice(0,E),s=l.length-1-l.lastIndexOf(c)),i=h,r=0;continue}else if(l.length!==0){l="",s=0,i=h,r=0;continue}}w&&(l+=l.length>0?`${c}..`:"..",s=2)}else l.length>0?l+=`${c}${u.slice(i+1,h)}`:l=u.slice(i+1,h),s=h-i-1;i=h,r=0}else a===I&&r!==-1?++r:r=-1}return l}function k(u,w){if(w===null||typeof w!="object")throw new S("pathObject","Object",w);const c=w.dir||w.root,o=w.base||`${w.name||""}${w.ext||""}`;return c?c===w.root?`${c}${o}`:`${c}${u}${o}`:o}e.win32={resolve(...u){let w="",c="",o=!1;for(let l=u.length-1;l>=-1;l--){let s;if(l>=0){if(s=u[l],m(s,"path"),s.length===0)continue}else w.length===0?s=p.cwd():(s=p.env[`=${w}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==w.toLowerCase()&&s.charCodeAt(2)===y)&&(s=`${w}\\`));const i=s.length;let r=0,a="",h=!1;const E=s.charCodeAt(0);if(i===1)t(E)&&(r=1,h=!0);else if(t(E))if(h=!0,t(s.charCodeAt(1))){let R=2,L=R;for(;R<i&&!t(s.charCodeAt(R));)R++;if(R<i&&R!==L){const W=s.slice(L,R);for(L=R;R<i&&t(s.charCodeAt(R));)R++;if(R<i&&R!==L){for(L=R;R<i&&!t(s.charCodeAt(R));)R++;(R===i||R!==L)&&(a=`\\\\${W}\\${s.slice(L,R)}`,r=R)}}}else r=1;else g(E)&&s.charCodeAt(1)===b&&(a=s.slice(0,2),r=2,i>2&&t(s.charCodeAt(2))&&(h=!0,r=3));if(a.length>0)if(w.length>0){if(a.toLowerCase()!==w.toLowerCase())continue}else w=a;if(o){if(w.length>0)break}else if(c=`${s.slice(r)}\\${c}`,o=h,h&&w.length>0)break}return c=v(c,!o,"\\",t),o?`${w}\\${c}`:`${w}${c}`||"."},normalize(u){m(u,"path");const w=u.length;if(w===0)return".";let c=0,o,l=!1;const s=u.charCodeAt(0);if(w===1)return d(s)?"\\":u;if(t(s))if(l=!0,t(u.charCodeAt(1))){let r=2,a=r;for(;r<w&&!t(u.charCodeAt(r));)r++;if(r<w&&r!==a){const h=u.slice(a,r);for(a=r;r<w&&t(u.charCodeAt(r));)r++;if(r<w&&r!==a){for(a=r;r<w&&!t(u.charCodeAt(r));)r++;if(r===w)return`\\\\${h}\\${u.slice(a)}\\`;r!==a&&(o=`\\\\${h}\\${u.slice(a,r)}`,c=r)}}}else c=1;else g(s)&&u.charCodeAt(1)===b&&(o=u.slice(0,2),c=2,w>2&&t(u.charCodeAt(2))&&(l=!0,c=3));let i=c<w?v(u.slice(c),!l,"\\",t):"";return i.length===0&&!l&&(i="."),i.length>0&&t(u.charCodeAt(w-1))&&(i+="\\"),o===void 0?l?`\\${i}`:i:l?`${o}\\${i}`:`${o}${i}`},isAbsolute(u){m(u,"path");const w=u.length;if(w===0)return!1;const c=u.charCodeAt(0);return t(c)||w>2&&g(c)&&u.charCodeAt(1)===b&&t(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let w,c;for(let s=0;s<u.length;++s){const i=u[s];m(i,"path"),i.length>0&&(w===void 0?w=c=i:w+=`\\${i}`)}if(w===void 0)return".";let o=!0,l=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++l;const s=c.length;s>1&&t(c.charCodeAt(1))&&(++l,s>2&&(t(c.charCodeAt(2))?++l:o=!1))}if(o){for(;l<w.length&&t(w.charCodeAt(l));)l++;l>=2&&(w=`\\${w.slice(l)}`)}return e.win32.normalize(w)},relative(u,w){if(m(u,"from"),m(w,"to"),u===w)return"";const c=e.win32.resolve(u),o=e.win32.resolve(w);if(c===o||(u=c.toLowerCase(),w=o.toLowerCase(),u===w))return"";let l=0;for(;l<u.length&&u.charCodeAt(l)===y;)l++;let s=u.length;for(;s-1>l&&u.charCodeAt(s-1)===y;)s--;const i=s-l;let r=0;for(;r<w.length&&w.charCodeAt(r)===y;)r++;let a=w.length;for(;a-1>r&&w.charCodeAt(a-1)===y;)a--;const h=a-r,E=i<h?i:h;let R=-1,L=0;for(;L<E;L++){const $=u.charCodeAt(l+L);if($!==w.charCodeAt(r+L))break;$===y&&(R=L)}if(L!==E){if(R===-1)return o}else{if(h>E){if(w.charCodeAt(r+L)===y)return o.slice(r+L+1);if(L===2)return o.slice(r+L)}i>E&&(u.charCodeAt(l+L)===y?R=L:L===2&&(R=3)),R===-1&&(R=0)}let W="";for(L=l+R+1;L<=s;++L)(L===s||u.charCodeAt(L)===y)&&(W+=W.length===0?"..":"\\..");return r+=R,W.length>0?`${W}${o.slice(r,a)}`:(o.charCodeAt(r)===y&&++r,o.slice(r,a))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const w=e.win32.resolve(u);if(w.length<=2)return u;if(w.charCodeAt(0)===y){if(w.charCodeAt(1)===y){const c=w.charCodeAt(2);if(c!==P&&c!==I)return`\\\\?\\UNC\\${w.slice(2)}`}}else if(g(w.charCodeAt(0))&&w.charCodeAt(1)===b&&w.charCodeAt(2)===y)return`\\\\?\\${w}`;return u},dirname(u){m(u,"path");const w=u.length;if(w===0)return".";let c=-1,o=0;const l=u.charCodeAt(0);if(w===1)return t(l)?u:".";if(t(l)){if(c=o=1,t(u.charCodeAt(1))){let r=2,a=r;for(;r<w&&!t(u.charCodeAt(r));)r++;if(r<w&&r!==a){for(a=r;r<w&&t(u.charCodeAt(r));)r++;if(r<w&&r!==a){for(a=r;r<w&&!t(u.charCodeAt(r));)r++;if(r===w)return u;r!==a&&(c=o=r+1)}}}}else g(l)&&u.charCodeAt(1)===b&&(c=w>2&&t(u.charCodeAt(2))?3:2,o=c);let s=-1,i=!0;for(let r=w-1;r>=o;--r)if(t(u.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(c===-1)return".";s=c}return u.slice(0,s)},basename(u,w){w!==void 0&&m(w,"ext"),m(u,"path");let c=0,o=-1,l=!0,s;if(u.length>=2&&g(u.charCodeAt(0))&&u.charCodeAt(1)===b&&(c=2),w!==void 0&&w.length>0&&w.length<=u.length){if(w===u)return"";let i=w.length-1,r=-1;for(s=u.length-1;s>=c;--s){const a=u.charCodeAt(s);if(t(a)){if(!l){c=s+1;break}}else r===-1&&(l=!1,r=s+1),i>=0&&(a===w.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return c===o?o=r:o===-1&&(o=u.length),u.slice(c,o)}for(s=u.length-1;s>=c;--s)if(t(u.charCodeAt(s))){if(!l){c=s+1;break}}else o===-1&&(l=!1,o=s+1);return o===-1?"":u.slice(c,o)},extname(u){m(u,"path");let w=0,c=-1,o=0,l=-1,s=!0,i=0;u.length>=2&&u.charCodeAt(1)===b&&g(u.charCodeAt(0))&&(w=o=2);for(let r=u.length-1;r>=w;--r){const a=u.charCodeAt(r);if(t(a)){if(!s){o=r+1;break}continue}l===-1&&(s=!1,l=r+1),a===I?c===-1?c=r:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||l===-1||i===0||i===1&&c===l-1&&c===o+1?"":u.slice(c,l)},format:k.bind(null,"\\"),parse(u){m(u,"path");const w={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return w;const c=u.length;let o=0,l=u.charCodeAt(0);if(c===1)return t(l)?(w.root=w.dir=u,w):(w.base=w.name=u,w);if(t(l)){if(o=1,t(u.charCodeAt(1))){let R=2,L=R;for(;R<c&&!t(u.charCodeAt(R));)R++;if(R<c&&R!==L){for(L=R;R<c&&t(u.charCodeAt(R));)R++;if(R<c&&R!==L){for(L=R;R<c&&!t(u.charCodeAt(R));)R++;R===c?o=R:R!==L&&(o=R+1)}}}}else if(g(l)&&u.charCodeAt(1)===b){if(c<=2)return w.root=w.dir=u,w;if(o=2,t(u.charCodeAt(2))){if(c===3)return w.root=w.dir=u,w;o=3}}o>0&&(w.root=u.slice(0,o));let s=-1,i=o,r=-1,a=!0,h=u.length-1,E=0;for(;h>=o;--h){if(l=u.charCodeAt(h),t(l)){if(!a){i=h+1;break}continue}r===-1&&(a=!1,r=h+1),l===I?s===-1?s=h:E!==1&&(E=1):s!==-1&&(E=-1)}return r!==-1&&(s===-1||E===0||E===1&&s===r-1&&s===i+1?w.base=w.name=u.slice(i,r):(w.name=u.slice(i,s),w.base=u.slice(i,r),w.ext=u.slice(s,r))),i>0&&i!==o?w.dir=u.slice(0,i-1):w.dir=w.root,w},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let w="",c=!1;for(let o=u.length-1;o>=-1&&!c;o--){const l=o>=0?u[o]:p.cwd();m(l,"path"),l.length!==0&&(w=`${l}/${w}`,c=l.charCodeAt(0)===f)}return w=v(w,!c,"/",d),c?`/${w}`:w.length>0?w:"."},normalize(u){if(m(u,"path"),u.length===0)return".";const w=u.charCodeAt(0)===f,c=u.charCodeAt(u.length-1)===f;return u=v(u,!w,"/",d),u.length===0?w?"/":c?"./":".":(c&&(u+="/"),w?`/${u}`:u)},isAbsolute(u){return m(u,"path"),u.length>0&&u.charCodeAt(0)===f},join(...u){if(u.length===0)return".";let w;for(let c=0;c<u.length;++c){const o=u[c];m(o,"path"),o.length>0&&(w===void 0?w=o:w+=`/${o}`)}return w===void 0?".":e.posix.normalize(w)},relative(u,w){if(m(u,"from"),m(w,"to"),u===w||(u=e.posix.resolve(u),w=e.posix.resolve(w),u===w))return"";const c=1,o=u.length,l=o-c,s=1,i=w.length-s,r=l<i?l:i;let a=-1,h=0;for(;h<r;h++){const R=u.charCodeAt(c+h);if(R!==w.charCodeAt(s+h))break;R===f&&(a=h)}if(h===r)if(i>r){if(w.charCodeAt(s+h)===f)return w.slice(s+h+1);if(h===0)return w.slice(s+h)}else l>r&&(u.charCodeAt(c+h)===f?a=h:h===0&&(a=0));let E="";for(h=c+a+1;h<=o;++h)(h===o||u.charCodeAt(h)===f)&&(E+=E.length===0?"..":"/..");return`${E}${w.slice(s+a)}`},toNamespacedPath(u){return u},dirname(u){if(m(u,"path"),u.length===0)return".";const w=u.charCodeAt(0)===f;let c=-1,o=!0;for(let l=u.length-1;l>=1;--l)if(u.charCodeAt(l)===f){if(!o){c=l;break}}else o=!1;return c===-1?w?"/":".":w&&c===1?"//":u.slice(0,c)},basename(u,w){w!==void 0&&m(w,"ext"),m(u,"path");let c=0,o=-1,l=!0,s;if(w!==void 0&&w.length>0&&w.length<=u.length){if(w===u)return"";let i=w.length-1,r=-1;for(s=u.length-1;s>=0;--s){const a=u.charCodeAt(s);if(a===f){if(!l){c=s+1;break}}else r===-1&&(l=!1,r=s+1),i>=0&&(a===w.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return c===o?o=r:o===-1&&(o=u.length),u.slice(c,o)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===f){if(!l){c=s+1;break}}else o===-1&&(l=!1,o=s+1);return o===-1?"":u.slice(c,o)},extname(u){m(u,"path");let w=-1,c=0,o=-1,l=!0,s=0;for(let i=u.length-1;i>=0;--i){const r=u.charCodeAt(i);if(r===f){if(!l){c=i+1;break}continue}o===-1&&(l=!1,o=i+1),r===I?w===-1?w=i:s!==1&&(s=1):w!==-1&&(s=-1)}return w===-1||o===-1||s===0||s===1&&w===o-1&&w===c+1?"":u.slice(w,o)},format:k.bind(null,"/"),parse(u){m(u,"path");const w={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return w;const c=u.charCodeAt(0)===f;let o;c?(w.root="/",o=1):o=0;let l=-1,s=0,i=-1,r=!0,a=u.length-1,h=0;for(;a>=o;--a){const E=u.charCodeAt(a);if(E===f){if(!r){s=a+1;break}continue}i===-1&&(r=!1,i=a+1),E===I?l===-1?l=a:h!==1&&(h=1):l!==-1&&(h=-1)}if(i!==-1){const E=s===0&&c?1:s;l===-1||h===0||h===1&&l===i-1&&l===s+1?w.base=w.name=u.slice(E,i):(w.name=u.slice(E,l),w.base=u.slice(E,i),w.ext=u.slice(l,i))}return s>0?w.dir=u.slice(0,s-1):c&&(w.dir="/"),w},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[83],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var n;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...M){const I=M.reduce((b,P)=>(b[P]=!0,b),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(b=>!I[b]).forEach(b=>{for(let P=0;P<f.length;P++)if(b.search(f[P])!==-1){delete C[b];break}})}e.sanitizeProcessEnvironment=D}),define(J[84],Z([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(M){this._highResolution=n&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new D(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(J[4],Z([0,1,15,43,2,110,84]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(c){c.None=()=>D.Disposable.None;function o(N){return(z,K=null,B)=>{let T=!1,_;return _=N(F=>{if(!T)return _?_.dispose():T=!0,z.call(K,F)},null,B),T&&_.dispose(),_}}c.once=o;function l(N,z){return E((K,B=null,T)=>N(_=>K.call(B,z(_)),null,T))}c.map=l;function s(N,z){return E((K,B=null,T)=>N(_=>{z(_),K.call(B,_)},null,T))}c.forEach=s;function i(N,z){return E((K,B=null,T)=>N(_=>z(_)&&K.call(B,_),null,T))}c.filter=i;function r(N){return N}c.signal=r;function a(...N){return(z,K=null,B)=>(0,D.combinedDisposable)(...N.map(T=>T(_=>z.call(K,_),null,B)))}c.any=a;function h(N,z,K){let B=K;return l(N,T=>(B=z(B,T),B))}c.reduce=h;function E(N){let z;const K=new m({onFirstListenerAdd(){z=N(K.fire,K)},onLastListenerRemove(){z.dispose()}});return K.event}function R(N,z,K,B=100,T=!1){let _,F,A=0;return N(O=>{A++,_=K(_,O),T&&!F&&(z(_),_=void 0),clearTimeout(F),F=setTimeout(()=>{const U=_;_=void 0,F=void 0,(!T||A>1)&&z(U),A=0},B)})}c.debouncedListener=R;function L(N,z,K=100,B=!1,T){let _,F,A,O=0;const U=new m({leakWarningThreshold:T,onFirstListenerAdd(){_=N(G=>{O++,F=z(F,G),B&&!A&&(U.fire(F),F=void 0),clearTimeout(A),A=setTimeout(()=>{const ne=F;F=void 0,A=void 0,(!B||O>1)&&U.fire(ne),O=0},K)})},onLastListenerRemove(){_.dispose()}});return U.event}c.debounce=L;function W(N,z=(K,B)=>K===B){let K=!0,B;return i(N,T=>{const _=K||!z(T,B);return K=!1,B=T,_})}c.latch=W;function $(N,z){return[c.filter(N,z),c.filter(N,K=>!z(K))]}c.split=$;function Q(N,z=!1,K=[]){let B=K.slice(),T=N(A=>{B?B.push(A):F.fire(A)});const _=()=>{B&&B.forEach(A=>F.fire(A)),B=null},F=new m({onFirstListenerAdd(){T||(T=N(A=>F.fire(A)))},onFirstListenerDidAdd(){B&&(z?setTimeout(_):_())},onLastListenerRemove(){T&&T.dispose(),T=null}});return F.event}c.buffer=Q;class ee{constructor(z){this.event=z}map(z){return new ee(l(this.event,z))}forEach(z){return new ee(s(this.event,z))}filter(z){return new ee(i(this.event,z))}reduce(z,K){return new ee(h(this.event,z,K))}latch(){return new ee(W(this.event))}debounce(z,K=100,B=!1,T){return new ee(L(this.event,z,K,B,T))}on(z,K,B){return this.event(z,K,B)}once(z,K,B){return o(this.event)(z,K,B)}}function x(N){return new ee(N)}c.chain=x;function q(N,z,K=B=>B){const B=(...A)=>F.fire(K(...A)),T=()=>N.on(z,B),_=()=>N.removeListener(z,B),F=new m({onFirstListenerAdd:T,onLastListenerRemove:_});return F.event}c.fromNodeEventEmitter=q;function X(N,z,K=B=>B){const B=(...A)=>F.fire(K(...A)),T=()=>N.addEventListener(z,B),_=()=>N.removeEventListener(z,B),F=new m({onFirstListenerAdd:T,onLastListenerRemove:_});return F.event}c.fromDOMEventEmitter=X;function H(N){return new Promise(z=>o(N)(z))}c.toPromise=H;function j(N,z){return z(void 0),N(K=>z(K))}c.runAndSubscribe=j;function te(N,z){let K=null;function B(_){K?.dispose(),K=new D.DisposableStore,z(_,K)}B(void 0);const T=N(_=>B(_));return(0,D.toDisposable)(()=>{T.dispose(),K?.dispose()})}c.runAndSubscribeWithStore=te})(I=e.Event||(e.Event={}));class f{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${f._idPool++}`}start(o){this._stopWatch=new M.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let y=-1;function b(c){const o=y;return y=c,{dispose(){y=o}}}e.setGlobalLeakWarningThreshold=b;class P{constructor(o,l=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let l=y;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),l<=0||o<l)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(s)||0;if(this._stacks.set(s,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let r,a=0;for(const[h,E]of this._stacks)(!r||a<E)&&(r=h,a=E);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${a}):`),console.warn(r)}return()=>{const r=this._stacks.get(s)||0;this._stacks.set(s,r-1)}}}class S{set(o){return this._actual=o,this}unset(){this._actual=void 0}dispose(){this._actual?.dispose(),this.unset()}}class m{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=y>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(o,l,s)=>{this._listeners||(this._listeners=new C.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=new S,a=this._listeners.push([o,l,r]);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,l);const h=this._leakageMon?.check(this._listeners.size),E=r.set((0,D.toDisposable)(()=>{h&&h(),this._disposed||(a(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}));return s instanceof D.DisposableStore?s.add(E):Array.isArray(s)&&s.push(E),E}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[[l,s],i]=this._deliveryQueue.shift();try{l.call(s,i)}catch(r){(0,p.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){for(let[o,l,s]of this._listeners)s.dispose();this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}}e.Emitter=m;class t extends m{async fireAsync(o,l,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,o]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[[i,r],a]=this._asyncDeliveryQueue.shift(),h=[],E={...a,token:l,waitUntil:R=>{if(Object.isFrozen(h))throw new Error("waitUntil can NOT be called asynchronous");s&&(R=s(R,i)),h.push(R)}};try{i.call(r,E)}catch(R){(0,p.onUnexpectedError)(R);continue}Object.freeze(h),await Promise.allSettled(h).then(R=>{for(const L of R)L.status==="rejected"&&(0,p.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=t;class d extends m{constructor(o){super(o);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=d;class g extends d{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=g;class v extends m{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class k{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const l={event:o,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const s=()=>{this.hasListeners&&this.unhook(l);const i=this.events.indexOf(l);this.events.splice(i,1)};return(0,D.toDisposable)((0,n.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(l=>this.emitter.fire(l))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=k;class u{constructor(){this.buffers=[]}wrapEvent(o){return(l,s,i)=>o(r=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>l.call(s,r)):l.call(s,r)},void 0,i)}bufferEvents(o){const l=[];this.buffers.push(l);const s=o();return this.buffers.pop(),l.forEach(i=>i()),s}}e.EventBufferer=u;class w{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=D.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(J[23],Z([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(I,f){const y=setTimeout(I.bind(f),0);return{dispose(){clearTimeout(y)}}});var D;(function(I){function f(y){return y===I.None||y===I.Cancelled||y instanceof C?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}I.isCancellationToken=f,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=M}),define(J[111],Z([0,1,23]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(M){this.task=M,this.result=null}get(){if(this.result)return this.result;const M=new p.CancellationTokenSource,I=this.task(M.token);return this.result={promise:I,dispose:()=>{this.result=null,M.cancel(),M.dispose()}},this.result}}e.Cache=n;class D{constructor(M){this.computeFn=M,this.lastCache=void 0,this.lastArgKey=void 0}get(M){const I=JSON.stringify(M);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.computeFn(M)),this.lastCache}}e.LRUCachedComputed=D}),define(J[48],Z([0,1,15,2]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(u){const w=u;return w?[w.on,w.pause,w.resume,w.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=D;function C(u){const w=u;return w?D(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=C;function M(u,w){return new I(u,w)}e.newWriteableStream=M;class I{constructor(w,c){this.reducer=w,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(c=>c(w))}emitError(w){this.listeners.error.length===0?(0,p.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(c=>c(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,c){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(w,c){if(this.state.destroyed)return;let o;switch(w){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const l=o.indexOf(c);l>=0&&o.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(u,w){const c=[];let o;for(;(o=u.read())!==null;)c.push(o);return w(c)}e.consumeReadable=f;function y(u,w,c){const o=[];let l;for(;(l=u.read())!==null&&o.length<c;)o.push(l);return l===null&&o.length>0?w(o):{read:()=>{if(o.length>0)return o.shift();if(typeof l!="undefined"){const s=l;return l=void 0,s}return u.read()}}}e.peekReadable=y;function b(u,w){return new Promise((c,o)=>{const l=[];P(u,{onData:s=>{w&&l.push(s)},onError:s=>{w?o(s):c(void 0)},onEnd:()=>{c(w?w(l):void 0)}})})}e.consumeStream=b;function P(u,w){let c=!1;return u.on("error",o=>{c||w.onError(o)}),u.on("end",()=>{c||w.onEnd()}),u.on("data",o=>{c||w.onData(o)}),(0,n.toDisposable)(()=>c=!0)}e.listenStream=P;function S(u,w){return new Promise((c,o)=>{const l=new n.DisposableStore,s=[],i=h=>{if(s.push(h),s.length>w)return l.dispose(),u.pause(),c({stream:u,buffer:s,ended:!1})},r=h=>o(h),a=()=>c({stream:u,buffer:s,ended:!0});l.add((0,n.toDisposable)(()=>u.removeListener("error",r))),u.on("error",r),l.add((0,n.toDisposable)(()=>u.removeListener("end",a))),u.on("end",a),l.add((0,n.toDisposable)(()=>u.removeListener("data",i))),u.on("data",i)})}e.peekStream=S;function m(u,w){const c=M(w);return c.end(u),c}e.toStream=m;function t(){const u=M(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=t;function d(u){let w=!1;return{read:()=>w?null:(w=!0,u)}}e.toReadable=d;function g(u,w,c){const o=M(c);return P(u,{onData:l=>o.write(w.data(l)),onError:l=>o.error(w.error?w.error(l):l),onEnd:()=>o.end()}),o}e.transform=g;function v(u,w,c){let o=!1;return{read:()=>{const l=w.read();return o?l:(o=!0,l!==null?c([u,l]):u)}}}e.prefixedReadable=v;function k(u,w,c){let o=!1;const l=M(c);return P(w,{onData:s=>o?l.write(s):(o=!0,l.write(c([u,s]))),onError:s=>l.error(s),onEnd:()=>{o||(o=!0,l.write(u)),l.end()}}),l}e.prefixedStream=k}),define(J[17],Z([0,1,48]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let D,C;class M{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return n?new M(Buffer.allocUnsafe(E)):new M(new Uint8Array(E))}static wrap(E){return n&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new M(E)}static fromString(E,R){return!(R?.dontUseNodeBuffer||!1)&&n?new M(Buffer.from(E)):(D||(D=new TextEncoder),new M(D.encode(E)))}static fromByteArray(E){const R=M.alloc(E.length);for(let L=0,W=E.length;L<W;L++)R.buffer[L]=E[L];return R}static concat(E,R){if(typeof R=="undefined"){R=0;for(let $=0,Q=E.length;$<Q;$++)R+=E[$].byteLength}const L=M.alloc(R);let W=0;for(let $=0,Q=E.length;$<Q;$++){const ee=E[$];L.set(ee,W),W+=ee.byteLength}return L}clone(){const E=M.alloc(this.byteLength);return E.set(this),E}toString(){return n?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(E,R){return new M(this.buffer.subarray(E,R))}set(E,R){if(E instanceof M)this.buffer.set(E.buffer,R);else if(E instanceof Uint8Array)this.buffer.set(E,R);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),R);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return y(this.buffer,E)}writeUInt32BE(E,R){b(this.buffer,E,R)}readUInt32LE(E){return P(this.buffer,E)}writeUInt32LE(E,R){S(this.buffer,E,R)}readUInt8(E){return m(this.buffer,E)}writeUInt8(E,R){t(this.buffer,E,R)}}e.VSBuffer=M;function I(h,E){return h[E+0]<<0>>>0|h[E+1]<<8>>>0}e.readUInt16LE=I;function f(h,E,R){h[R+0]=E&255,E=E>>>8,h[R+1]=E&255}e.writeUInt16LE=f;function y(h,E){return h[E]*2**24+h[E+1]*2**16+h[E+2]*2**8+h[E+3]}e.readUInt32BE=y;function b(h,E,R){h[R+3]=E,E=E>>>8,h[R+2]=E,E=E>>>8,h[R+1]=E,E=E>>>8,h[R]=E}e.writeUInt32BE=b;function P(h,E){return h[E+0]<<0>>>0|h[E+1]<<8>>>0|h[E+2]<<16>>>0|h[E+3]<<24>>>0}e.readUInt32LE=P;function S(h,E,R){h[R+0]=E&255,E=E>>>8,h[R+1]=E&255,E=E>>>8,h[R+2]=E&255,E=E>>>8,h[R+3]=E&255}e.writeUInt32LE=S;function m(h,E){return h[E]}e.readUInt8=m;function t(h,E,R){h[R]=E}e.writeUInt8=t;function d(h){return p.consumeReadable(h,E=>M.concat(E))}e.readableToBuffer=d;function g(h){return p.toReadable(h)}e.bufferToReadable=g;function v(h){return p.consumeStream(h,E=>M.concat(E))}e.streamToBuffer=v;async function k(h){return h.ended?M.concat(h.buffer):M.concat([...h.buffer,await v(h.stream)])}e.bufferedStreamToBuffer=k;function u(h){return p.toStream(h,E=>M.concat(E))}e.bufferToStream=u;function w(h){return p.transform(h,{data:E=>typeof E=="string"?M.fromString(E):M.wrap(E)},E=>M.concat(E))}e.streamToBufferReadableStream=w;function c(h){return p.newWriteableStream(E=>M.concat(E),h)}e.newWriteableBufferStream=c;function o(h,E){return p.prefixedReadable(h,E,R=>M.concat(R))}e.prefixedBufferReadable=o;function l(h,E){return p.prefixedStream(h,E,R=>M.concat(R))}e.prefixedBufferStream=l;function s(h){let E=0,R=0,L=0;const W=new Uint8Array(Math.floor(h.length/4*3)),$=ee=>{switch(R){case 3:W[L++]=E|ee,R=0;break;case 2:W[L++]=E|ee>>>2,E=ee<<6,R=3;break;case 1:W[L++]=E|ee>>>4,E=ee<<4,R=2;break;default:E=ee<<2,R=1}};for(let ee=0;ee<h.length;ee++){const x=h.charCodeAt(ee);if(x>=65&&x<=90)$(x-65);else if(x>=97&&x<=122)$(x-97+26);else if(x>=48&&x<=57)$(x-48+52);else if(x===43||x===45)$(62);else if(x===47||x===95)$(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${h[ee]}`)}}const Q=L;for(;R>0;)$(0);return M.wrap(W).slice(0,Q)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:h},E=!0,R=!1){const L=R?r:i;let W="";const $=h.byteLength%3;let Q=0;for(;Q<h.byteLength-$;Q+=3){const ee=h[Q+0],x=h[Q+1],q=h[Q+2];W+=L[ee>>>2],W+=L[(ee<<4|x>>>4)&63],W+=L[(x<<2|q>>>6)&63],W+=L[q&63]}if($===1){const ee=h[Q+0];W+=L[ee>>>2],W+=L[ee<<4&63],E&&(W+="==")}else if($===2){const ee=h[Q+0],x=h[Q+1];W+=L[ee>>>2],W+=L[(ee<<4|x>>>4)&63],W+=L[x<<2&63],E&&(W+="=")}return W}e.encodeBase64=a}),define(J[27],Z([0,1,111,109]),function(V,e,p,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=C;const M=/{(\d+)}/g;function I(Y,...se){return se.length===0?Y:Y.replace(M,function(oe,fe){const ye=parseInt(fe,10);return isNaN(ye)||ye<0||ye>=se.length?oe:se[ye]})}e.format=I;const f=/{([^}]+)}/g;function y(Y,se){return Y.replace(f,(oe,fe)=>se[fe]??oe)}e.format2=y;function b(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=b;function P(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function S(Y,se){let oe=0;const fe=se.charCodeAt(0);for(let ye=Y.length-1;ye>=0;ye--)Y.charCodeAt(ye)===fe&&oe++;return oe}e.count=S;function m(Y,se,oe="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${oe}`}e.truncate=m;function t(Y,se=" "){const oe=d(Y,se);return g(oe,se)}e.trim=t;function d(Y,se){if(!Y||!se)return Y;const oe=se.length;if(oe===0||Y.length===0)return Y;let fe=0;for(;Y.indexOf(se,fe)===fe;)fe=fe+oe;return Y.substring(fe)}e.ltrim=d;function g(Y,se){if(!Y||!se)return Y;const oe=se.length,fe=Y.length;if(oe===0||fe===0)return Y;let ye=fe,Le=-1;for(;Le=Y.lastIndexOf(se,ye-1),!(Le===-1||Le+oe!==ye);){if(Le===0)return"";ye=Le}return Y.substring(0,ye)}e.rtrim=g;function v(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function k(Y){return Y.replace(/\*/g,"")}e.stripWildcards=k;function u(Y,se,oe={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=P(Y)),oe.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let fe="";return oe.global&&(fe+="g"),oe.matchCase||(fe+="i"),oe.multiline&&(fe+="m"),oe.unicode&&(fe+="u"),new RegExp(Y,fe)}e.createRegExp=u;function w(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function c(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function o(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=o;function l(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=l;function s(Y){for(let se=0,oe=Y.length;se<oe;se++){const fe=Y.charCodeAt(se);if(fe!==32&&fe!==9)return se}return-1}e.firstNonWhitespaceIndex=s;function i(Y,se=0,oe=Y.length){for(let fe=se;fe<oe;fe++){const ye=Y.charCodeAt(fe);if(ye!==32&&ye!==9)return Y.substring(se,fe)}return Y.substring(se,oe)}e.getLeadingWhitespace=i;function r(Y,se=Y.length-1){for(let oe=se;oe>=0;oe--){const fe=Y.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.lastNonWhitespaceIndex=r;function a(Y,se){return Y<se?-1:Y>se?1:0}e.compare=a;function h(Y,se,oe=0,fe=Y.length,ye=0,Le=se.length){for(;oe<fe&&ye<Le;oe++,ye++){let He=Y.charCodeAt(oe),Ae=se.charCodeAt(ye);if(He<Ae)return-1;if(He>Ae)return 1}const Oe=fe-oe,Ke=Le-ye;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstring=h;function E(Y,se){return R(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=E;function R(Y,se,oe=0,fe=Y.length,ye=0,Le=se.length){for(;oe<fe&&ye<Le;oe++,ye++){let He=Y.charCodeAt(oe),Ae=se.charCodeAt(ye);if(He===Ae)continue;if(He>=128||Ae>=128)return h(Y.toLowerCase(),se.toLowerCase(),oe,fe,ye,Le);L(He)&&(He-=32),L(Ae)&&(Ae-=32);const $e=He-Ae;if($e!==0)return $e}const Oe=fe-oe,Ke=Le-ye;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstringIgnoreCase=R;function L(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=L;function W(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=W;function $(Y,se){return Y.length===se.length&&R(Y,se)===0}e.equalsIgnoreCase=$;function Q(Y,se){const oe=se.length;return se.length>Y.length?!1:R(Y,se,0,oe)===0}e.startsWithIgnoreCase=Q;function ee(Y,se){let oe,fe=Math.min(Y.length,se.length);for(oe=0;oe<fe;oe++)if(Y.charCodeAt(oe)!==se.charCodeAt(oe))return oe;return fe}e.commonPrefixLength=ee;function x(Y,se){let oe,fe=Math.min(Y.length,se.length);const ye=Y.length-1,Le=se.length-1;for(oe=0;oe<fe;oe++)if(Y.charCodeAt(ye-oe)!==se.charCodeAt(Le-oe))return oe;return fe}e.commonSuffixLength=x;function q(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=q;function X(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=X;function H(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=H;function j(Y,se,oe){const fe=Y.charCodeAt(oe);if(q(fe)&&oe+1<se){const ye=Y.charCodeAt(oe+1);if(X(ye))return H(fe,ye)}return fe}e.getNextCodePoint=j;function te(Y,se){const oe=Y.charCodeAt(se-1);if(X(oe)&&se>1){const fe=Y.charCodeAt(se-2);if(q(fe))return H(fe,oe)}return oe}class N{constructor(se,oe=0){this._str=se,this._len=se.length,this._offset=oe}get offset(){return this._offset}setOffset(se){this._offset=se}prevCodePoint(){const se=te(this._str,this._offset);return this._offset-=se>=65536?2:1,se}nextCodePoint(){const se=j(this._str,this._len,this._offset);return this._offset+=se>=65536?2:1,se}eol(){return this._offset>=this._len}}e.CodePointIterator=N;class z{constructor(se,oe=0){this._iterator=new N(se,oe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const se=Be.getInstance(),oe=this._iterator,fe=oe.offset;let ye=se.getGraphemeBreakType(oe.nextCodePoint());for(;!oe.eol();){const Le=oe.offset,Oe=se.getGraphemeBreakType(oe.nextCodePoint());if(xe(ye,Oe)){oe.setOffset(Le);break}ye=Oe}return oe.offset-fe}prevGraphemeLength(){const se=Be.getInstance(),oe=this._iterator,fe=oe.offset;let ye=se.getGraphemeBreakType(oe.prevCodePoint());for(;oe.offset>0;){const Le=oe.offset,Oe=se.getGraphemeBreakType(oe.prevCodePoint());if(xe(Oe,ye)){oe.setOffset(Le);break}ye=Oe}return fe-oe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function K(Y,se){return new z(Y,se).nextGraphemeLength()}e.nextCharLength=K;function B(Y,se){return new z(Y,se).prevGraphemeLength()}e.prevCharLength=B;function T(Y,se){se>0&&X(Y.charCodeAt(se))&&se--;const oe=se+K(Y,se);return[oe-B(Y,oe),oe]}e.getCharContainingOffset=T;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(Y){return _.test(Y)}e.containsRTL=F;const A=/^[\t\n\r\x20-\x7E]*$/;function O(Y){return A.test(Y)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function U(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=U;function G(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=G;function ne(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=ne;function ce(Y,se){if(Y.length<se)return Y;const oe=/\b/g;let fe=0;for(;oe.test(Y)&&!(Y.length-oe.lastIndex<se);)fe=oe.lastIndex,oe.lastIndex+=1;return Y.substring(fe).replace(/^\s/,"")}e.lcut=ce;const ae=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function he(Y){return Y&&(Y=Y.replace(ae,""),Y=Y.replace(re,""),Y=Y.replace(le,"")),Y}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function me(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=me;function ke(Y){return me(Y)?Y.substr(1):Y}e.stripUTF8BOM=ke;function Ce(Y,se){if(!Y||!se||Y.length<se.length)return!1;const oe=se.length,fe=Y.toLowerCase();let ye=0,Le=-1;for(;ye<oe;){const Oe=fe.indexOf(se[ye],Le+1);if(Oe<0)return!1;Le=Oe,ye++}return!0}e.fuzzyContains=Ce;function Se(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Se;function pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=pe;function be(Y,se=1){if(se===0)return"";let oe=-1;do oe=Y.indexOf(`
`,oe+1),se--;while(se>0&&oe>=0);return oe===-1?Y:(Y[oe-1]==="\r"&&oe--,Y.substr(0,oe))}e.getNLines=be;function Re(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Re;function Ue(Y){return Be.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ue;function xe(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}var Fe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=Ye()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const oe=this._data,fe=oe.length/3;let ye=1;for(;ye<=fe;)if(se<oe[3*ye])ye=2*ye;else if(se>oe[3*ye+1])ye=2*ye+1;else return oe[3*ye+2];return 0}}Be._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(Y,se){if(Y===0)return 0;const oe=pt(Y,se);if(oe!==void 0)return oe;const fe=new N(se,Y);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=st;function pt(Y,se){const oe=new N(se,Y);let fe=oe.prevCodePoint();for(;ot(fe)||fe===65039||fe===8419;){if(oe.offset===0)return;fe=oe.prevCodePoint()}if(!ne(fe))return;let ye=oe.offset;return ye>0&&oe.prevCodePoint()===8205&&(ye=oe.offset),ye}function ot(Y){return 127995<=Y&&Y<=127999}var Qe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class qe{constructor(se){this.confusableDictionary=se}static getInstance(se){return qe.cache.get(Array.from(se))}static getLocales(){return qe._locales.getValue()}isAmbiguous(se){return this.confusableDictionary.has(se)}getPrimaryConfusable(se){return this.confusableDictionary.get(se)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=qe,D=qe,qe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.cache=new p.LRUCachedComputed(Y=>{function se(Ae){const $e=new Map;for(let Ve=0;Ve<Ae.length;Ve+=2)$e.set(Ae[Ve],Ae[Ve+1]);return $e}function oe(Ae,$e){const Ve=new Map(Ae);for(const[Ge,it]of $e)Ve.set(Ge,it);return Ve}function fe(Ae,$e){if(!Ae)return $e;const Ve=new Map;for(const[Ge,it]of Ae)$e.has(Ge)&&Ve.set(Ge,it);return Ve}const ye=D.ambiguousCharacterData.getValue();let Le=Y.filter(Ae=>!Ae.startsWith("_")&&Ae in ye);Le.length===0&&(Le=["_default"]);let Oe;for(const Ae of Le){const $e=se(ye[Ae]);Oe=fe(Oe,$e)}const Ke=se(ye._common),He=oe(Ke,Oe);return new qe(He)}),qe._locales=new n.Lazy(()=>Object.keys(qe.ambiguousCharacterData.getValue()).filter(Y=>!Y.startsWith("_")));class Xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Xe.getRawData())),this._data}static isInvisibleCharacter(se){return Xe.getData().has(se)}static get codePoints(){return Xe.getData()}}e.InvisibleCharacters=Xe,Xe._data=void 0}),define(J[69],Z([0,1,27]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return D(v,0)}e.hash=n;function D(v,k){switch(typeof v){case"object":return v===null?C(349,k):Array.isArray(v)?f(v,k):y(v,k);case"string":return I(v,k);case"boolean":return M(v,k);case"number":return C(v,k);case"undefined":return C(937,k);default:return C(617,k)}}e.doHash=D;function C(v,k){return(k<<5)-k+v|0}e.numberHash=C;function M(v,k){return C(v?433:863,k)}function I(v,k){k=C(149417,k);for(let u=0,w=v.length;u<w;u++)k=C(v.charCodeAt(u),k);return k}e.stringHash=I;function f(v,k){return k=C(104579,k),v.reduce((u,w)=>D(w,u),k)}function y(v,k){return k=C(181387,k),Object.keys(v).sort().reduce((u,w)=>(u=I(w,u),D(v[w],u)),k)}class b{constructor(){this._value=0}get value(){return this._value}hash(k){return this._value=D(k,this._value),this._value}}e.Hasher=b;var P;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function S(v,k,u=32){const w=u-k,c=~((1<<w)-1);return(v<<k|(c&v)>>>w)>>>0}function m(v,k=0,u=v.byteLength,w=0){for(let c=0;c<u;c++)v[k+c]=w}function t(v,k,u="0"){for(;v.length<k;)v=u+v;return v}function d(v,k=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(u=>u.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),k/4)}e.toHexString=d;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(k){const u=k.length;if(u===0)return;const w=this._buff;let c=this._buffLen,o=this._leftoverHighSurrogate,l,s;for(o!==0?(l=o,s=-1,o=0):(l=k.charCodeAt(0),s=0);;){let i=l;if(p.isHighSurrogate(l))if(s+1<u){const r=k.charCodeAt(s+1);p.isLowSurrogate(r)?(s++,i=p.computeCodePoint(l,r)):i=65533}else{o=l;break}else p.isLowSurrogate(l)&&(i=65533);if(c=this._push(w,c,i),s++,s<u)l=k.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=o}_push(k,u,w){return w<128?k[u++]=w:w<2048?(k[u++]=192|(w&1984)>>>6,k[u++]=128|(w&63)>>>0):w<65536?(k[u++]=224|(w&61440)>>>12,k[u++]=128|(w&4032)>>>6,k[u++]=128|(w&63)>>>0):(k[u++]=240|(w&1835008)>>>18,k[u++]=128|(w&258048)>>>12,k[u++]=128|(w&4032)>>>6,k[u++]=128|(w&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,k[0]=k[64+0],k[1]=k[64+1],k[2]=k[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const k=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(k/4294967296),!1),this._buffDV.setUint32(60,k%4294967296,!1),this._step()}_step(){const k=g._bigBlock32,u=this._buffDV;for(let h=0;h<64;h+=4)k.setUint32(h,u.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)k.setUint32(h,S(k.getUint32(h-12,!1)^k.getUint32(h-32,!1)^k.getUint32(h-56,!1)^k.getUint32(h-64,!1),1),!1);let w=this._h0,c=this._h1,o=this._h2,l=this._h3,s=this._h4,i,r,a;for(let h=0;h<80;h++)h<20?(i=c&o|~c&l,r=1518500249):h<40?(i=c^o^l,r=1859775393):h<60?(i=c&o|c&l|o&l,r=2400959708):(i=c^o^l,r=3395469782),a=S(w,5)+i+s+r+k.getUint32(h*4,!1)&4294967295,s=l,l=o,o=S(c,30),c=w,w=a;this._h0=this._h0+w&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))});var Mt=this&&this.__classPrivateFieldSet||function(V,e,p,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!D:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(V,p):D?D.value=p:e.set(V,p),p},Ze=this&&this.__classPrivateFieldGet||function(V,e,p,n){if(p==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!n:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?n:p==="a"?n.call(V):n?n.value:e.get(V)};define(J[35],Z([0,1,30,27]),function(V,e,p,n){"use strict";var D,C,M;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(s,i,r){let a=s.get(i);return a===void 0&&(a=r,s.set(i,a)),a}e.getOrSet=I;function f(s){const i=[];return s.forEach((r,a)=>{i.push(`${a} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=f;function y(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=y;class b{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=b;class P{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class S{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const a=this._value.charCodeAt(r);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var m;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(m||(m={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(g||(g={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(i=!1){return new v(new S(void 0,!i))}static forStrings(){return new v(new b)}static forConfigKeys(){return new v(new P)}clear(){this._root=void 0}fill(i,r){if(r){const a=r.slice(0);(0,p.shuffle)(a);for(let h of a)this.set(h,i)}else{const a=i.slice(0);(0,p.shuffle)(a);for(let h of a)this.set(h[0],h[1])}}set(i,r){const a=this._iter.reset(i);let h;this._root||(this._root=new d,this._root.segment=a.value());const E=[];for(h=this._root;;){const L=a.cmp(h.segment);if(L>0)h.left||(h.left=new d,h.left.segment=a.value()),E.push([-1,h]),h=h.left;else if(L<0)h.right||(h.right=new d,h.right.segment=a.value()),E.push([1,h]),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new d,h.mid.segment=a.value()),E.push([0,h]),h=h.mid;else break}const R=h.value;h.value=r,h.key=i;for(let L=E.length-1;L>=0;L--){const W=E[L][1];W.updateHeight();const $=W.balanceFactor();if($<-1||$>1){const Q=E[L][0],ee=E[L+1][0];if(Q===1&&ee===1)E[L][1]=W.rotateLeft();else if(Q===-1&&ee===-1)E[L][1]=W.rotateRight();else if(Q===1&&ee===-1)W.right=E[L+1][1]=E[L+1][1].rotateRight(),E[L][1]=W.rotateLeft();else if(Q===-1&&ee===1)W.left=E[L+1][1]=E[L+1][1].rotateLeft(),E[L][1]=W.rotateRight();else throw new Error;if(L>0)switch(E[L-1][0]){case-1:E[L-1][1].left=E[L][1];break;case 1:E[L-1][1].right=E[L][1];break;case 0:E[L-1][1].mid=E[L][1];break}else this._root=E[0][1]}}return R}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const h=r.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const a=this._iter.reset(i),h=[];let E=this._root;for(;E;){const R=a.cmp(E.segment);if(R>0)h.push([-1,E]),E=E.left;else if(R<0)h.push([1,E]),E=E.right;else if(a.hasNext())a.next(),h.push([0,E]),E=E.mid;else break}if(!!E){if(r?(E.left=void 0,E.mid=void 0,E.right=void 0,E.height=1):(E.key=void 0,E.value=void 0),!E.mid&&!E.value)if(E.left&&E.right){const R=this._min(E.right),{key:L,value:W,segment:$}=R;this._delete(R.key,!1),E.key=L,E.value=W,E.segment=$}else{const R=E.left??E.right;if(h.length>0){const[L,W]=h[h.length-1];switch(L){case-1:W.left=R;break;case 0:W.mid=R;break;case 1:W.right=R;break}}else this._root=R}for(let R=h.length-1;R>=0;R--){const L=h[R][1];L.updateHeight();const W=L.balanceFactor();if(W>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),h[R][1]=L.rotateLeft()):W<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),h[R][1]=L.rotateRight()),R>0)switch(h[R-1][0]){case-1:h[R-1][1].left=h[R][1];break;case 1:h[R-1][1].right=h[R][1];break;case 0:h[R-1][1].mid=h[R][1];break}else this._root=h[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let a=this._root,h;for(;a;){const E=r.cmp(a.segment);if(E>0)a=a.left;else if(E<0)a=a.right;else if(r.hasNext())r.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const h=r.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[r,a]of this)i(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=v;class k{constructor(i,r){this.uri=i,this.value=r}}class u{constructor(i,r){this[D]="ResourceMap",i instanceof u?(this.map=new Map(i.map),this.toKey=r??u.defaultToKey):(this.map=new Map,this.toKey=i??u.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new k(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[a,h]of this.map)i(h.value,h.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=u,u.defaultToKey=s=>s.toString();var w;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class c{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const a=this._map.get(i);if(!!a)return r!==0&&this.touch(a,r),a.value}set(i,r,a=0){let h=this._map.get(i);if(h)h.value=r,a!==0&&this.touch(h,a);else{switch(h={key:i,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(i,h),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const a=this._state;let h=this._head;for(;h;){if(r?i.bind(r)(h.value,h.key,this):i(h.value,h.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const E={value:a.key,done:!1};return a=a.next,E}else return{value:void 0,done:!0}}};return h}values(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const E={value:a.value,done:!1};return a=a.next,E}else return{value:void 0,done:!0}}};return h}entries(){const i=this,r=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const E={value:[a.key,a.value],done:!1};return a=a.next,E}else return{value:void 0,done:!0}}};return h}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>i;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,a=i.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const a=i.next,h=i.previous;i===this._tail?(h.next=void 0,this._tail=h):(a.previous=h,h.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const a=i.next,h=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=h,h.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,a)=>{i.push([a,r])}),i}fromJSON(i){this.clear();for(const[r,a]of i)this.set(r,a)}}e.LinkedMap=c;class o extends c{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class l{constructor(i){M.set(this,void 0),Mt(this,M,i,"f")}get size(){return Ze(this,M,"f").size}forEach(i,r){Ze(this,M,"f").forEach(i,r)}get(i){return Ze(this,M,"f").get(i)}has(i){return Ze(this,M,"f").has(i)}entries(){return Ze(this,M,"f").entries()}keys(){return Ze(this,M,"f").keys()}values(){return Ze(this,M,"f").values()}[(M=new WeakMap,Symbol.iterator)](){return Ze(this,M,"f").entries()}}e.ReadonlyMapView=l}),define(J[70],Z([0,1,35]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new p.LRUCache(1e4);function D(y){return f(y,"NFC",n)}e.normalizeNFC=D;const C=new p.LRUCache(1e4);function M(y){return f(y,"NFD",C)}e.normalizeNFD=M;const I=/[^\u0000-\u0080]/;function f(y,b,P){if(!y)return y;const S=P.get(y);if(S)return S;let m;return I.test(y)?m=y.normalize(b):m=y,P.set(y,m),m}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(b){return M(b).replace(y,"")}}()}),define(J[14],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(a){return Array.isArray(a)}e.isArray=p;function n(a){return typeof a=="string"}e.isString=n;function D(a){return Array.isArray(a)&&a.every(h=>n(h))}e.isStringArray=D;function C(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=C;function M(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=M;function I(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=I;function f(a){return a===!0||a===!1}e.isBoolean=f;function y(a){return typeof a=="undefined"}e.isUndefined=y;function b(a){return!P(a)}e.isDefined=b;function P(a){return y(a)||a===null}e.isUndefinedOrNull=P;function S(a,h){if(!a)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=S;function m(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=m;function t(...a){const h=[];for(let E=0;E<a.length;E++){const R=a[E];if(P(R))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);h.push(R)}return h}e.assertAllDefined=t;const d=Object.prototype.hasOwnProperty;function g(a){if(!C(a))return!1;for(let h in a)if(d.call(a,h))return!1;return!0}e.isEmptyObject=g;function v(a){return typeof a=="function"}e.isFunction=v;function k(...a){return a.length>0&&a.every(v)}e.areFunctions=k;function u(a,h){const E=Math.min(a.length,h.length);for(let R=0;R<E;R++)w(a[R],h[R])}e.validateConstraints=u;function w(a,h){if(n(h)){if(typeof a!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(v(h)){try{if(a instanceof h)return}catch{}if(!P(a)&&a.constructor===h||h.length===1&&h.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=w;function c(a){let h=[],E=Object.getPrototypeOf(a);for(;Object.prototype!==E;)h=h.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return h}e.getAllPropertyNames=c;function o(a){const h=[];for(const E of c(a))typeof a[E]=="function"&&h.push(E);return h}e.getAllMethodNames=o;function l(a,h){const E=L=>function(){const W=Array.prototype.slice.call(arguments,0);return h(L,W)};let R={};for(const L of a)R[L]=E(L);return R}e.createProxyObject=l;function s(a){return a===null?void 0:a}e.withNullAsUndefined=s;function i(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=i;function r(a,h="Unreachable"){throw new Error(h)}e.assertNever=r}),define(J[28],Z([0,1,9,3,27,14]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(r){return r===47||r===92}e.isPathSeparator=M;function I(r){return r.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=I;function f(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function y(r,a=p.posix.sep){if(!r)return"";const h=r.length,E=r.charCodeAt(0);if(M(E)){if(M(r.charCodeAt(1))&&!M(r.charCodeAt(2))){let L=3;const W=L;for(;L<h&&!M(r.charCodeAt(L));L++);if(W!==L&&!M(r.charCodeAt(L+1))){for(L+=1;L<h;L++)if(M(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(v(E)&&r.charCodeAt(1)===58)return M(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let R=r.indexOf("://");if(R!==-1){for(R+=3;R<h;R++)if(M(r.charCodeAt(R)))return r.slice(0,R+1)}return""}e.getRoot=y;function b(r){if(!n.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let h=2;const E=h;for(;h<r.length&&(a=r.charCodeAt(h),a!==92);h++);return!(E===h||(a=r.charCodeAt(h+1),isNaN(a)||a===92))}e.isUNC=b;const P=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,a=n.isWindows){const h=a?P:S;return!(!r||r.length===0||/^\s+$/.test(r)||(h.lastIndex=0,h.test(r))||a&&m.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function d(r,a,h){const E=r===a;return!h||E?E:!r||!a?!1:(0,D.equalsIgnoreCase)(r,a)}e.isEqual=d;function g(r,a,h,E=p.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(h){if(!(0,D.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let L=a.length;return a.charAt(a.length-1)===E&&L--,r.charAt(L)===E}return a.charAt(a.length-1)!==E&&(a+=E),r.indexOf(a)===0}e.isEqualOrParent=g;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function k(r,a){return n.isWindows&&r.endsWith(":")&&(r+=p.sep),(0,p.isAbsolute)(r)||(r=(0,p.join)(a,r)),r=(0,p.normalize)(r),n.isWindows?(r=(0,D.rtrim)(r,p.sep),r.endsWith(":")&&(r+=p.sep)):(r=(0,D.rtrim)(r,p.sep),r||(r=p.sep)),r}e.sanitizeFilePath=k;function u(r){const a=(0,p.normalize)(r);return n.isWindows?r.length>3?!1:w(a)&&(r.length===2||a.charCodeAt(2)===92):a===p.posix.sep}e.isRootOrDriveLetter=u;function w(r,a){return(a!==void 0?a:n.isWindows)?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function c(r){return w(r)?r[0]:void 0}e.getDriveLetter=c;function o(r,a,h){return a.length>r.length?-1:r===a?0:(h&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=o;function l(r){const a=r.split(":");let h,E,R;for(const L of a){const W=Number(L);(0,C.isNumber)(W)?E===void 0?E=W:R===void 0&&(R=W):h=h?[h,L].join(":"):L}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:E!==void 0?E:void 0,column:R!==void 0?R:E!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,a,h=8){let E="";for(let L=0;L<h;L++)E+=s.charAt(Math.floor(Math.random()*s.length));let R;return a?R=`${a}-${E}`:R=E,r?(0,p.join)(r,R):R}e.randomPath=i}),define(J[49],Z([0,1,14]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const g=Array.isArray(d)?[]:{};return Object.keys(d).forEach(v=>{d[v]&&typeof d[v]=="object"?g[v]=n(d[v]):g[v]=d[v]}),g}e.deepClone=n;function D(d){if(!d||typeof d!="object")return d;const g=[d];for(;g.length>0;){const v=g.shift();Object.freeze(v);for(const k in v)if(C.call(v,k)){const u=v[k];typeof u=="object"&&!Object.isFrozen(u)&&g.push(u)}}return d}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function M(d,g){return I(d,g,new Set)}e.cloneAndChange=M;function I(d,g,v){if((0,p.isUndefinedOrNull)(d))return d;const k=g(d);if(typeof k!="undefined")return k;if((0,p.isArray)(d)){const u=[];for(const w of d)u.push(I(w,g,v));return u}if((0,p.isObject)(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const u={};for(let w in d)C.call(d,w)&&(u[w]=I(d[w],g,v));return v.delete(d),u}return d}function f(d,g,v=!0){return(0,p.isObject)(d)?((0,p.isObject)(g)&&Object.keys(g).forEach(k=>{k in d?v&&((0,p.isObject)(d[k])&&(0,p.isObject)(g[k])?f(d[k],g[k],v):d[k]=g[k]):d[k]=g[k]}),d):g}e.mixin=f;function y(d,g){if(d===g)return!0;if(d==null||g===null||g===void 0||typeof d!=typeof g||typeof d!="object"||Array.isArray(d)!==Array.isArray(g))return!1;let v,k;if(Array.isArray(d)){if(d.length!==g.length)return!1;for(v=0;v<d.length;v++)if(!y(d[v],g[v]))return!1}else{const u=[];for(k in d)u.push(k);u.sort();const w=[];for(k in g)w.push(k);if(w.sort(),!y(u,w))return!1;for(v=0;v<u.length;v++)if(!y(d[u[v]],g[u[v]]))return!1}return!0}e.equals=y;function b(d){const g=new Set;return JSON.stringify(d,(v,k)=>{if((0,p.isObject)(k)||Array.isArray(k)){if(g.has(k))return"[Circular]";g.add(k)}return k})}e.safeStringify=b;function P(d,g,v){const k=g(d);return typeof k=="undefined"?v:k}e.getOrDefault=P;function S(d,g){const v=Object.create(null);return!d||!g||Object.keys(g).forEach(u=>{const w=d[u],c=g[u];y(w,c)||(v[u]=c)}),v}e.distinct=S;function m(d,g){const v=g.toLowerCase(),k=Object.keys(d).find(u=>u.toLowerCase()===v);return k?d[k]:d[g]}e.getCaseInsensitive=m;function t(d,g){const v=Object.create(null);for(const[k,u]of Object.entries(d))g(k,u)&&(v[k]=u);return v}e.filter=t}),define(J[7],Z([0,1,9,3]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,M=/^\/\//;function I(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!C.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(s,i){return!s&&!i?"file":s}function y(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==P&&(i=P+i):i=P;break}return i}const b="",P="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(i,r,a,h,E,R=!1){typeof i=="object"?(this.scheme=i.scheme||b,this.authority=i.authority||b,this.path=i.path||b,this.query=i.query||b,this.fragment=i.fragment||b):(this.scheme=f(i,R),this.authority=r||b,this.path=y(this.scheme,a||b),this.query=h||b,this.fragment=E||b,I(this,R))}static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:h,query:E,fragment:R}=i;return r===void 0?r=this.scheme:r===null&&(r=b),a===void 0?a=this.authority:a===null&&(a=b),h===void 0?h=this.path:h===null&&(h=b),E===void 0?E=this.query:E===null&&(E=b),R===void 0?R=this.fragment:R===null&&(R=b),r===this.scheme&&a===this.authority&&h===this.path&&E===this.query&&R===this.fragment?this:new d(r,a,h,E,R)}static parse(i,r=!1){const a=S.exec(i);return a?new d(a[2]||b,l(a[4]||b),l(a[5]||b),l(a[7]||b),l(a[9]||b),r):new d(b,b,b,b,b)}static file(i){let r=b;if(n.isWindows&&(i=i.replace(/\\/g,P)),i[0]===P&&i[1]===P){const a=i.indexOf(P,2);a===-1?(r=i.substring(2),i=P):(r=i.substring(2,a),i=i.substring(a)||P)}return new d("file",r,i,b,b)}static from(i){const r=new d(i.scheme,i.authority,i.path,i.query,i.fragment);return I(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return n.isWindows&&i.scheme==="file"?a=m.file(p.win32.join(u(i,!0),...r)).path:a=p.posix.join(i.path,...r),i.with({path:a})}toString(i=!1){return w(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const r=new d(i);return r._formatted=i.external,r._fsPath=i._sep===t?i.fsPath:null,r}}else return i}}e.URI=m;const t=n.isWindows?1:void 0;class d extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,i){let r,a=-1;for(let h=0;h<s.length;h++){const E=s.charCodeAt(h);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||i&&E===47)a!==-1&&(r+=encodeURIComponent(s.substring(a,h)),a=-1),r!==void 0&&(r+=s.charAt(h));else{r===void 0&&(r=s.substr(0,h));const R=g[E];R!==void 0?(a!==-1&&(r+=encodeURIComponent(s.substring(a,h)),a=-1),r+=R):a===-1&&(a=h)}}return a!==-1&&(r+=encodeURIComponent(s.substring(a))),r!==void 0?r:s}function k(s){let i;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(i===void 0&&(i=s.substr(0,r)),i+=g[a]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function u(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=u;function w(s,i){const r=i?k:v;let a="",{scheme:h,authority:E,path:R,query:L,fragment:W}=s;if(h&&(a+=h,a+=":"),(E||h==="file")&&(a+=P,a+=P),E){let $=E.indexOf("@");if($!==-1){const Q=E.substr(0,$);E=E.substr($+1),$=Q.indexOf(":"),$===-1?a+=r(Q,!1):(a+=r(Q.substr(0,$),!1),a+=":",a+=r(Q.substr($+1),!1)),a+="@"}E=E.toLowerCase(),$=E.indexOf(":"),$===-1?a+=r(E,!1):(a+=r(E.substr(0,$),!1),a+=E.substr($))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const $=R.charCodeAt(1);$>=65&&$<=90&&(R=`/${String.fromCharCode($+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const $=R.charCodeAt(0);$>=65&&$<=90&&(R=`${String.fromCharCode($+32)}:${R.substr(2)}`)}a+=r(R,!0)}return L&&(a+="?",a+=r(L,!1)),W&&(a+="#",a+=i?W:v(W,!1)),a}function c(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(o)?s.replace(o,i=>c(i)):s}}),define(J[112],Z([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(y){const b=y;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=n;function D(y){const b=[];let P;try{const S=JSON.parse(y.arguments),m=S[S.length-1];m&&m.__$stack&&(S.pop(),P=m.__$stack),b.push(...S)}catch{b.push("Unable to log remote console arguments",y.arguments)}return{args:b,stack:P}}e.parse=D;function C(y){if(typeof y!="string")return C(D(y).stack);const b=y;if(b){const P=M(b),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(S&&S.length===4)return{uri:p.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=C;function M(y){if(!y)return y;const b=y.indexOf(`
`);return b===-1?y:y.substring(0,b)}function I(y,b){const{args:P,stack:S}=D(y),m=typeof P[0]=="string"&&P.length===1;let t=M(S);t&&(t=`(${t.trim()})`);let d=[];if(typeof P[0]=="string"?t&&m?d=[`%c[${b}] %c${P[0]} %c${t}`,f("blue"),f(""),f("grey")]:d=[`%c[${b}] %c${P[0]}`,f("blue"),f(""),...P.slice(1)]:d=[`%c[${b}]%`,f("blue"),...P],t&&!m&&d.push(t),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,d)}e.log=I;function f(y){return`color: ${y}`}}),define(J[113],Z([0,1,17,27,7]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(b){return JSON.stringify(b,f)}e.stringify=C;function M(b){let P=JSON.parse(b);return P=y(P),P}e.parse=M;var I;(function(b){b[b.Uri=1]="Uri",b[b.Regexp=2]="Regexp",b[b.ScmResource=3]="ScmResource",b[b.ScmResourceGroup=4]="ScmResourceGroup",b[b.ScmProvider=5]="ScmProvider",b[b.CommentController=6]="CommentController",b[b.CommentThread=7]="CommentThread",b[b.CommentThreadReply=8]="CommentThreadReply",b[b.CommentNode=9]="CommentNode",b[b.CommentThreadNode=10]="CommentThreadNode",b[b.TimelineActionContext=11]="TimelineActionContext",b[b.NotebookCellActionContext=12]="NotebookCellActionContext",b[b.TestItemContext=13]="TestItemContext",b[b.Date=14]="Date"})(I=e.MarshalledId||(e.MarshalledId={}));function f(b,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,n.regExpFlags)(P)}:P}function y(b,P=0){if(!b||P>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof p.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let S=0;S<b.length;++S)b[S]=y(b[S],P+1);else for(const S in b)Object.hasOwnProperty.call(b,S)&&(b[S]=y(b[S],P+1))}return b}e.revive=y}),define(J[10],Z([0,1,3,7]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,y,b){this._hosts[f]=y,this._ports[f]=b}setConnectionToken(f,y){this._connectionTokens[f]=y}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(f){if(this._delegate)return this._delegate(f);const y=f.authority;let b=this._hosts[y];b&&b.indexOf(":")!==-1&&(b=`[${b}]`);const P=this._ports[y],S=this._connectionTokens[y];let m=`path=${encodeURIComponent(f.path)}`;return typeof S=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),n.URI.from({scheme:p.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${b}:${P}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new C;class M{asBrowserUri(f,y){const b=this.toUri(f,y);return b.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===D.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${D.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?b.with({scheme:D.vscodeFileResource,authority:b.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(f,y){const b=this.toUri(f,y);return b.scheme===D.vscodeFileResource?b.with({scheme:D.file,authority:b.authority!==M.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(f,y){return n.URI.isUri(f)?f:n.URI.parse(y.toUrl(f))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(J[16],Z([0,1,28,10,9,3,27,7]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(m){return(0,I.uriToFsPath)(m,!0)}e.originalFSPath=f;class y{constructor(t){this._ignorePathCasing=t}compare(t,d,g=!1){return t===d?0:(0,M.compare)(this.getComparisonKey(t,g),this.getComparisonKey(d,g))}isEqual(t,d,g=!1){return t===d?!0:!t||!d?!1:this.getComparisonKey(t,g)===this.getComparisonKey(d,g)}getComparisonKey(t,d=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,d,g=!1){if(t.scheme===d.scheme){if(t.scheme===n.Schemas.file)return p.isEqualOrParent(f(t),f(d),this._ignorePathCasing(t))&&t.query===d.query&&(g||t.fragment===d.fragment);if((0,e.isEqualAuthority)(t.authority,d.authority))return p.isEqualOrParent(t.path,d.path,this._ignorePathCasing(t),"/")&&t.query===d.query&&(g||t.fragment===d.fragment)}return!1}joinPath(t,...d){return I.URI.joinPath(t,...d)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let d;return t.scheme===n.Schemas.file?d=I.URI.file(D.dirname(f(t))).path:(d=D.posix.dirname(t.path),t.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),d="/")),t.with({path:d})}normalizePath(t){if(!t.path.length)return t;let d;return t.scheme===n.Schemas.file?d=I.URI.file(D.normalize(f(t))).path:d=D.posix.normalize(t.path),t.with({path:d})}relativePath(t,d){if(t.scheme!==d.scheme||!(0,e.isEqualAuthority)(t.authority,d.authority))return;if(t.scheme===n.Schemas.file){const k=D.relative(f(t),f(d));return C.isWindows?p.toSlashes(k):k}let g=t.path||"/",v=d.path||"/";if(this._ignorePathCasing(t)){let k=0;for(const u=Math.min(g.length,v.length);k<u&&!(g.charCodeAt(k)!==v.charCodeAt(k)&&g.charAt(k).toLowerCase()!==v.charAt(k).toLowerCase());k++);g=v.substr(0,k)+g.substr(k)}return D.posix.relative(g,v)}resolvePath(t,d){if(t.scheme===n.Schemas.file){const g=I.URI.file(D.resolve(f(t),d));return t.with({authority:g.authority,path:g.path})}return d=p.toPosixPath(d),t.with({path:D.posix.resolve(t.path,d)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,d){return t===d||t!==void 0&&d!==void 0&&(0,M.equalsIgnoreCase)(t,d)}hasTrailingPathSeparator(t,d=D.sep){if(t.scheme===n.Schemas.file){const g=f(t);return g.length>p.getRoot(g).length&&g[g.length-1]===d}else{const g=t.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,d=D.sep){return(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,d=D.sep){let g=!1;if(t.scheme===n.Schemas.file){const v=f(t);g=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=t.path;g=v.length===1&&v.charCodeAt(v.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path+"/"}):t}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(m=>m.scheme===n.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new y(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(m,t){const d=[];for(let g=0;g<m.length;g++){const v=t(m[g]);m.some((k,u)=>u===g?!1:(0,e.isEqualOrParent)(v,t(k)))||d.push(m[g])}return d}e.distinctParents=b;var P;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function t(d){const g=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[w,c]=u.split(":");w&&c&&g.set(w,c)});const k=d.path.substring(0,d.path.indexOf(";"));return k&&g.set(m.META_DATA_MIME,k),g}m.parseMetaData=t})(P=e.DataUri||(e.DataUri={}));function S(m,t,d){if(t){let g=m.path;return g&&g[0]!==D.posix.sep&&(g=D.posix.sep+g),m.with({scheme:d,authority:t,path:g})}return m.with({scheme:d})}e.toLocalResource=S}),define(J[8],Z([0,1,23,15,4,2,16,3]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(F){return!!F&&typeof F.then=="function"}e.isThenable=f;function y(F){const A=new p.CancellationTokenSource,O=F(A.token),U=new Promise((G,ne)=>{const ce=A.token.onCancellationRequested(()=>{ce.dispose(),A.dispose(),ne(new n.CancellationError)});Promise.resolve(O).then(ae=>{ce.dispose(),A.dispose(),G(ae)},ae=>{ce.dispose(),A.dispose(),ne(ae)})});return new class{cancel(){A.cancel()}then(G,ne){return U.then(G,ne)}catch(G){return this.then(void 0,G)}finally(G){return U.finally(G)}}}e.createCancelablePromise=y;function b(F,A,O){return new Promise((U,G)=>{const ne=A.onCancellationRequested(()=>{ne.dispose(),U(O)});F.then(U,G).finally(()=>ne.dispose())})}e.raceCancellation=b;function P(F,A){return new Promise((O,U)=>{const G=A.onCancellationRequested(()=>{G.dispose(),U(new n.CancellationError)});F.then(O,U).finally(()=>G.dispose())})}e.raceCancellationError=P;async function S(F){let A=-1;const O=F.map((G,ne)=>G.then(ce=>(A=ne,ce))),U=await Promise.race(O);return F.forEach((G,ne)=>{ne!==A&&G.cancel()}),U}e.raceCancellablePromises=S;function m(F,A,O){let U;const G=setTimeout(()=>{U?.(void 0),O?.()},A);return Promise.race([F.finally(()=>clearTimeout(G)),new Promise(ne=>U=ne)])}e.raceTimeout=m;function t(F){return new Promise((A,O)=>{const U=F();f(U)?U.then(A,O):A(U)})}e.asPromise=t;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(O,O).then(U)})}return new Promise((O,U)=>{this.queuedPromise.then(O,U)})}return this.activePromise=A(),new Promise((O,U)=>{this.activePromise.then(G=>{this.activePromise=null,O(G)},G=>{this.activePromise=null,U(G)})})}}e.Throttler=d;class g{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=g;class v{constructor(){this.promiseMap=new Map}queue(A,O){const G=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(A)===G&&this.promiseMap.delete(A)});return this.promiseMap.set(A,G),G}}e.SequencerByKey=v;const k=(F,A)=>{let O=!0;const U=setTimeout(()=>{O=!1,A()},F);return{isTriggered:()=>O,dispose:()=>{clearTimeout(U),O=!1}}},u=F=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,F())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class w{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,O=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,ne)=>{this.doResolve=G,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}}));const U=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?u(U):k(O,U),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=w;class c{constructor(A){this.delayer=new w(A),this.throttler=new d}trigger(A,O){return this.delayer.trigger(()=>this.throttler.queue(A),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class o{constructor(){this._isOpen=!1,this._promise=new Promise((A,O)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class l extends o{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function s(F,A){return A?new Promise((O,U)=>{const G=setTimeout(()=>{ne.dispose(),O()},F),ne=A.onCancellationRequested(()=>{clearTimeout(G),ne.dispose(),U(new n.CancellationError)})}):y(O=>s(F,O))}e.timeout=s;function i(F,A=0){const O=setTimeout(F,A);return(0,C.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=i;function r(F){const A=[];let O=0;const U=F.length;function G(){return O<U?F[O++]():null}function ne(ce){ce!=null&&A.push(ce);const ae=G();return ae?ae.then(ne):Promise.resolve(A)}return Promise.resolve(null).then(ne)}e.sequence=r;function a(F,A=U=>!!U,O=null){let U=0;const G=F.length,ne=()=>{if(U>=G)return Promise.resolve(O);const ce=F[U++];return Promise.resolve(ce()).then(re=>A(re)?Promise.resolve(re):ne())};return ne()}e.first=a;function h(F,A=U=>!!U,O=null){if(F.length===0)return Promise.resolve(O);let U=F.length;const G=()=>{U=-1;for(const ne of F)ne.cancel?.()};return new Promise((ne,ce)=>{for(const ae of F)ae.then(re=>{--U>=0&&A(re)?(G(),ne(re)):U===0&&ne(O)}).catch(re=>{--U>=0&&(G(),ce(re))})})}e.firstParallel=h;class E{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((O,U)=>{this.outstandingPromises.push({factory:A,c:O,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const O=A.factory();O.then(A.c,A.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=E;class R extends E{constructor(){super(1)}}e.Queue=R;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new N;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,O=M.extUri){const U=O.getComparisonKey(A);let G=this.queues.get(U);return G||(G=new R,D.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(U),this.onDidQueueFinish()}),this.queues.set(U,G)),G}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class W{constructor(A,O){this._token=-1,typeof A=="function"&&typeof O=="number"&&this.setIfNotSet(A,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},O)}setIfNotSet(A,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},O))}}e.TimeoutTimer=W;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setInterval(()=>{A()},O)}}e.IntervalTimer=$;class Q{constructor(A,O){this.timeoutToken=-1,this.runner=A,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=Q;class ee{constructor(A,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=ee;class x extends Q{constructor(A,O){super(A,O);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class q extends C.Disposable{constructor(A,O){super();this.options=A,this.handler=O,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=F=>{(0,I.setTimeout0)(()=>{if(A)return;const O=Date.now()+15;F(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(F,A)=>{const O=requestIdleCallback(F,typeof A=="number"?{timeout:A}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(O))}}}}();class X{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=X;async function H(F,A,O){let U;for(let G=0;G<O;G++)try{return await F()}catch(ne){U=ne,await s(A)}throw U}e.retry=H;class j{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,O,U){return this._pending={taskId:A,cancel:()=>U?.(),promise:O},O.then(()=>this.donePending(A),()=>this.donePending(A)),O}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let O,U;const G=new Promise((ne,ce)=>{O=ne,U=ce});this._next={run:A,promise:G,promiseResolve:O,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=j;class te{constructor(A,O=()=>Date.now()){this.interval=A,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,O)=>{this.completeCallback=A,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(O=>{this.completeCallback(A),this.resolved=!0,O()})}error(A){return new Promise(O=>{this.errorCallback(A),this.rejected=!0,O()})}cancel(){new Promise(A=>{this.errorCallback(new n.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=N;var z;(function(F){async function A(U){let G;const ne=await Promise.all(U.map(ce=>ce.then(ae=>ae,ae=>{G||(G=ae)})));if(typeof G!="undefined")throw G;return ne}F.settled=A;function O(U){return new Promise(async(G,ne)=>{try{await U(G,ne)}catch(ce){ne(ce)}})}F.withAsyncBody=O})(z=e.Promises||(e.Promises={}));var K;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(K||(K={}));class B{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const O={emitOne:U=>this.emitOne(U),emitMany:U=>this.emitMany(U),reject:U=>this.reject(U)};try{await Promise.resolve(A(O)),this.resolve()}catch(U){this.reject(U)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(A){return new B(O=>{O.emitMany(A)})}static fromPromise(A){return new B(async O=>{O.emitMany(await A)})}static fromPromises(A){return new B(async O=>{await Promise.all(A.map(async U=>O.emitOne(await U)))})}static merge(A){return new B(async O=>{await Promise.all(A.map(async U=>{for await(const G of U)O.emitOne(G)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,O){return new B(async U=>{for await(const G of A)U.emitOne(O(G))})}map(A){return B.map(this,A)}static filter(A,O){return new B(async U=>{for await(const G of A)O(G)&&U.emitOne(G)})}filter(A){return B.filter(this,A)}static coalesce(A){return B.filter(A,O=>!!O)}coalesce(){return B.coalesce(this)}static async toPromise(A){const O=[];for await(const U of A)O.push(U);return O}toPromise(){return B.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=B,B.EMPTY=B.fromArray([]);class T extends B{constructor(A,O){super(O);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=T;function _(F){const A=new p.CancellationTokenSource,O=F(A.token);return new T(A,async U=>{const G=A.token.onCancellationRequested(()=>{G.dispose(),A.dispose(),U.reject(new n.CancellationError)});try{for await(const ne of O){if(A.token.isCancellationRequested)return;U.emitOne(ne)}G.dispose(),A.dispose()}catch(ne){G.dispose(),A.dispose(),U.reject(ne)}})}e.createCancelableAsyncIterable=_}),define(J[114],Z([0,1,8,28,35,9,3,27]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function f(){return Object.create(null)}e.getEmptyExpression=f,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",b="[^/\\\\]",P=/\//g;function S(N){switch(N){case 0:return"";case 1:return`${b}*?`;default:return`(?:${y}|${b}+${y}|${y}${b}+)*?`}}function m(N,z){if(!N)return[];const K=[];let B=!1,T=!1,_="";for(const F of N){switch(F){case z:if(!B&&!T){K.push(_),_="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":T=!0;break;case"]":T=!1;break}_+=F}return _&&K.push(_),K}e.splitGlobAware=m;function t(N){if(!N)return"";let z="";const K=m(N,e.GLOB_SPLIT);if(K.every(B=>B===e.GLOBSTAR))z=".*";else{let B=!1;K.forEach((T,_)=>{if(T===e.GLOBSTAR){B||(z+=S(2),B=!0);return}let F=!1,A="",O=!1,U="";for(const G of T){if(G!=="}"&&F){A+=G;continue}if(O&&(G!=="]"||!U)){let ne;G==="-"?ne=G:(G==="^"||G==="!")&&!U?ne="^":G===e.GLOB_SPLIT?ne="":ne=(0,I.escapeRegExpCharacters)(G),U+=ne;continue}switch(G){case"{":F=!0;continue;case"[":O=!0;continue;case"}":{z+=`(?:${m(A,",").map(ae=>t(ae)).join("|")})`,F=!1,A="";break}case"]":z+="["+U+"]",O=!1,U="";break;case"?":z+=b;continue;case"*":z+=S(1);continue;default:z+=(0,I.escapeRegExpCharacters)(G)}}_<K.length-1&&(K[_+1]!==e.GLOBSTAR||_+2<K.length)&&(z+=y),B=!1})}return z}const d=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,k=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new D.LRUCache(1e4),o=function(){return!1},l=function(){return null};function s(N,z){if(!N)return l;let K;typeof N!="string"?K=N.pattern:K=N,K=K.trim();const B=`${K}_${!!z.trimForExclusions}`;let T=c.get(B);if(T)return i(T,N);let _;if(d.test(K)){const F=K.substr(4);T=function(A,O){return typeof A=="string"&&A.endsWith(F)?K:null}}else(_=g.exec(r(K,z)))?T=a(_[1],K):(z.trimForExclusions?k:v).test(K)?T=h(K,z):(_=u.exec(r(K,z)))?T=E(_[1].substr(1),K,!0):(_=w.exec(r(K,z)))?T=E(_[1],K,!1):T=R(K);return c.set(B,T),i(T,N)}function i(N,z){return typeof z=="string"?N:function(K,B){return(0,n.isEqualOrParent)(K,z.base,!M.isLinux)?N(K.substr(z.base.length+1),B):null}}function r(N,z){return z.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function a(N,z){const K=`/${N}`,B=`\\${N}`,T=function(F,A){return typeof F!="string"?null:A?A===N?z:null:F===N||F.endsWith(K)||F.endsWith(B)?z:null},_=[N];return T.basenames=_,T.patterns=[z],T.allBasenames=_,T}function h(N,z){const K=te(N.slice(1,-1).split(",").map(A=>s(A,z)).filter(A=>A!==l),N),B=K.length;if(!B)return l;if(B===1)return K[0];const T=function(A,O){for(let U=0,G=K.length;U<G;U++)if(K[U](A,O))return N;return null},_=K.find(A=>!!A.allBasenames);_&&(T.allBasenames=_.allBasenames);const F=K.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return F.length&&(T.allPaths=F),T}function E(N,z,K){const B=C.sep===C.posix.sep,T=B?N:N.replace(P,C.sep),_=C.sep+T,F=C.posix.sep+N,A=K?function(O,U){return typeof O=="string"&&(O===T||O.endsWith(_)||!B&&(O===N||O.endsWith(F)))?z:null}:function(O,U){return typeof O=="string"&&(O===T||!B&&O===N)?z:null};return A.allPaths=[(K?"*/":"./")+N],A}function R(N){try{const z=new RegExp(`^${t(N)}$`);return function(K){return z.lastIndex=0,typeof K=="string"&&z.test(K)?N:null}}catch{return l}}function L(N,z,K){return!N||typeof z!="string"?!1:W(N)(z,void 0,K)}e.match=L;function W(N,z={}){if(!N)return o;if(typeof N=="string"||x(N)){const K=s(N,z);if(K===l)return o;const B=function(T,_){return!!K(T,_)};return K.allBasenames&&(B.allBasenames=K.allBasenames),K.allPaths&&(B.allPaths=K.allPaths),B}return H(N,z)}e.parse=W;function $(N){if(!N)return;let z;return K=>(z||(z=(N()||Promise.resolve([])).then(B=>B?ee(B):{})),z.then(B=>!!B[K]))}e.hasSiblingPromiseFn=$;function Q(N){if(!N)return;let z;return K=>{if(!z){const B=N();z=B?ee(B):{}}return!!z[K]}}e.hasSiblingFn=Q;function ee(N){const z={};for(const K of N)z[K]=!0;return z}function x(N){const z=N;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=x;function q(N){return N.allBasenames||[]}e.getBasenameTerms=q;function X(N){return N.allPaths||[]}e.getPathTerms=X;function H(N,z){const K=te(Object.getOwnPropertyNames(N).map(A=>j(A,N[A],z)).filter(A=>A!==l)),B=K.length;if(!B)return l;if(!K.some(A=>!!A.requiresSiblings)){if(B===1)return K[0];const A=function(G,ne){for(let ce=0,ae=K.length;ce<ae;ce++){const re=K[ce](G,ne);if(re)return re}return null},O=K.find(G=>!!G.allBasenames);O&&(A.allBasenames=O.allBasenames);const U=K.reduce((G,ne)=>ne.allPaths?G.concat(ne.allPaths):G,[]);return U.length&&(A.allPaths=U),A}const T=function(A,O,U){let G;for(let ne=0,ce=K.length;ne<ce;ne++){const ae=K[ne];ae.requiresSiblings&&U&&(O||(O=(0,C.basename)(A)),G||(G=O.substr(0,O.length-(0,C.extname)(A).length)));const re=ae(A,O,G,U);if(re)return re}return null},_=K.find(A=>!!A.allBasenames);_&&(T.allBasenames=_.allBasenames);const F=K.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return F.length&&(T.allPaths=F),T}function j(N,z,K){if(z===!1)return l;const B=s(N,K);if(B===l)return l;if(typeof z=="boolean")return B;if(z){const T=z.when;if(typeof T=="string"){const _=(F,A,O,U)=>{if(!U||!B(F,A))return null;const G=T.replace("$(basename)",O),ne=U(G);return(0,p.isThenable)(ne)?ne.then(ce=>ce?N:null):ne?N:null};return _.requiresSiblings=!0,_}}return B}function te(N,z){const K=N.filter(A=>!!A.basenames);if(K.length<2)return N;const B=K.reduce((A,O)=>{const U=O.basenames;return U?A.concat(U):A},[]);let T;if(z){T=[];for(let A=0,O=B.length;A<O;A++)T.push(z)}else T=K.reduce((A,O)=>{const U=O.patterns;return U?A.concat(U):A},[]);const _=function(A,O){if(typeof A!="string")return null;if(!O){let G;for(G=A.length;G>0;G--){const ne=A.charCodeAt(G-1);if(ne===47||ne===92)break}O=A.substr(G)}const U=B.indexOf(O);return U!==-1?T[U]:null};_.basenames=B,_.patterns=T,_.allBasenames=B;const F=N.filter(A=>!A.basenames);return F.push(_),F}}),define(J[33],Z([0,1,28,10,9,3,16,27,7]),function(V,e,p,n,D,C,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(i,r,a){if(typeof i=="string"&&(i=f.URI.file(i)),a){const E=a.getWorkspaceFolder(i);if(E){const R=a.getWorkspace().folders.length>1;let L;if((0,M.isEqual)(E.uri,i)?L="":L=(0,M.relativePath)(E.uri,i),R){const W=E.name?E.name:(0,M.basename)(E.uri);L=L?W+" \u2022 "+L:W}return L}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(i.fsPath))return(0,D.normalize)(P(i.fsPath));let h=(0,D.normalize)(i.fsPath);return!C.isWindows&&r?.userHome&&(h=m(h,r.userHome.fsPath)),h}e.getPathLabel=y;function b(i){if(!i)return;typeof i=="string"&&(i=f.URI.file(i));const r=(0,M.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,p.isRootOrDriveLetter)(r)?P(r):r}e.getBaseLabel=b;function P(i,r){return(0,p.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=P;let S=Object.create(null);function m(i,r){if(C.isWindows||!i||!r)return i;let a=S.original===r?S.normalized:void 0;return a||(a=`${(0,I.rtrim)(r,D.posix.sep)}${D.posix.sep}`,S={original:r,normalized:a}),(C.isLinux?i.startsWith(a):(0,I.startsWithIgnoreCase)(i,a))&&(i=`~/${i.substr(a.length)}`),i}e.tildify=m;function t(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=t;const d="\u2026",g="\\\\",v="~";function k(i,r=D.sep){const a=new Array(i.length);let h=!1;for(let E=0;E<i.length;E++){let R=i[E];if(R===""){a[E]=`.${r}`;continue}if(!R){a[E]=R;continue}h=!0;let L="";R.indexOf(g)===0?(L=R.substr(0,R.indexOf(g)+g.length),R=R.substr(R.indexOf(g)+g.length)):R.indexOf(r)===0?(L=R.substr(0,R.indexOf(r)+r.length),R=R.substr(R.indexOf(r)+r.length)):R.indexOf(v)===0&&(L=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const W=R.split(r);for(let $=1;h&&$<=W.length;$++)for(let Q=W.length-$;h&&Q>=0;Q--){h=!1;let ee=W.slice(Q,Q+$).join(r);for(let x=0;!h&&x<i.length;x++)if(x!==E&&i[x]&&i[x].indexOf(ee)>-1){const q=Q+$===W.length,X=Q>0&&i[x].indexOf(r)>-1?r+ee:ee,H=i[x].endsWith(X);h=!q||H}if(!h){let x="";(W[0].endsWith(":")||L!=="")&&(Q===1&&(Q=0,$++,ee=W[0]+r+ee),Q>0&&(x=W[0]+r),x=L+x),Q>0&&(x=x+d+r),x=x+ee,Q+$<W.length&&(x=x+r+d),a[E]=x}}h&&(a[E]=R)}return a}e.shorten=k;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function w(i,r=Object.create(null)){const a=[];let h=!1,E="";for(const R of i)if(R==="$"||h&&R==="{")E&&a.push({value:E,type:u.TEXT}),E="",h=!0;else if(R==="}"&&h){const L=r[E];if(typeof L=="string")L.length&&a.push({value:L,type:u.VARIABLE});else if(L){const W=a[a.length-1];(!W||W.type!==u.SEPARATOR)&&a.push({value:L.label,type:u.SEPARATOR})}E="",h=!1}else E+=R;return E&&!h&&a.push({value:E,type:u.TEXT}),a.filter((R,L)=>{if(R.type===u.SEPARATOR){const W=a[L-1],$=a[L+1];return[W,$].every(Q=>Q&&(Q.type===u.VARIABLE||Q.type===u.TEXT)&&Q.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=w;function c(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function o(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function l(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=l;function s(i){const r=i.indexOf("/")!==-1?D.posix:D.win32,a=r.basename(i),h=r.dirname(i);return a.length?{name:a,parentPath:h}:{name:h,parentPath:""}}e.splitName=s}),define(J[115],Z([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(b){return b.toJSON()}class D{constructor(P){this._uriTransformer=P}transformIncoming(P){const S=this._uriTransformer.transformIncoming(P);return S===P?P:n(p.URI.from(S))}transformOutgoing(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:n(p.URI.from(S))}transformOutgoingURI(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:p.URI.from(S)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function C(b,P,S){if(!b||S>200)return null;if(typeof b=="object"){if(b instanceof p.URI)return P.transformOutgoing(b);for(let m in b)if(Object.hasOwnProperty.call(b,m)){const t=C(b[m],P,S+1);t!==null&&(b[m]=t)}}return null}function M(b,P){const S=C(b,P,0);return S===null?b:S}e.transformOutgoingURIs=M;function I(b,P,S,m){if(!b||m>200)return null;if(typeof b=="object"){if(b.$mid===1)return S?p.URI.revive(P.transformIncoming(b)):P.transformIncoming(b);for(let t in b)if(Object.hasOwnProperty.call(b,t)){const d=I(b[t],P,S,m+1);d!==null&&(b[t]=d)}}return null}function f(b,P){const S=I(b,P,!1,0);return S===null?b:S}e.transformIncomingURIs=f;function y(b,P){const S=I(b,P,!0,0);return S===null?b:S}e.transformAndReviveIncomingURIs=y}),define(J[31],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(f){return p.test(f)}e.isUUID=n;const D=new Uint8Array(16),C=[];for(let f=0;f<256;f++)C.push(f.toString(16).padStart(2,"0"));let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(f){for(let y=0;y<f.length;y++)f[y]=Math.floor(Math.random()*256);return f};function I(){M(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let f=0,y="";return y+=C[D[f++]],y+=C[D[f++]],y+=C[D[f++]],y+=C[D[f++]],y+="-",y+=C[D[f++]],y+=C[D[f++]],y+="-",y+=C[D[f++]],y+=C[D[f++]],y+="-",y+=C[D[f++]],y+=C[D[f++]],y+="-",y+=C[D[f++]],y+=C[D[f++]],y+=C[D[f++]],y+=C[D[f++]],y+=C[D[f++]],y+=C[D[f++]],y}e.generateUuid=I}),define(J[116],Z([0,1,15,4,2,3,14,27]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const f="$initialize";let y=!1;function b(s){!C.isWeb||(y||(y=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}e.logOnceWebWorkerWarning=b;var P;(function(s){s[s.Request=0]="Request",s[s.Reply=1]="Reply",s[s.SubscribeEvent=2]="SubscribeEvent",s[s.Event=3]="Event",s[s.UnsubscribeEvent=4]="UnsubscribeEvent"})(P||(P={}));class S{constructor(i,r,a,h){this.vsWorker=i,this.req=r,this.method=a,this.args=h,this.type=0}}class m{constructor(i,r,a,h){this.vsWorker=i,this.seq=r,this.res=a,this.err=h,this.type=1}}class t{constructor(i,r,a,h){this.vsWorker=i,this.req=r,this.eventName=a,this.arg=h,this.type=2}}class d{constructor(i,r,a){this.vsWorker=i,this.req=r,this.event=a,this.type=3}}class g{constructor(i,r){this.vsWorker=i,this.req=r,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,r){const a=String(++this._lastSentReq);return new Promise((h,E)=>{this._pendingReplies[a]={resolve:h,reject:E},this._send(new S(this._workerId,a,i,r))})}listen(i,r){let a=null;const h=new n.Emitter({onFirstListenerAdd:()=>{a=String(++this._lastSentReq),this._pendingEmitters.set(a,h),this._send(new t(this._workerId,a,i,r))},onLastListenerRemove:()=>{this._pendingEmitters.delete(a),this._send(new g(this._workerId,a)),a=null}});return h.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let r=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let a=i.err;i.err.$isError&&(a=new Error,a.name=i.err.name,a.message=i.err.message,a.stack=i.err.stack),r.reject(a);return}r.resolve(i.res)}_handleRequestMessage(i){let r=i.req;this._handler.handleMessage(i.method,i.args).then(h=>{this._send(new m(this._workerId,r,h,void 0))},h=>{h.detail instanceof Error&&(h.detail=(0,p.transformErrorForSerialization)(h.detail)),this._send(new m(this._workerId,r,void 0,(0,p.transformErrorForSerialization)(h)))})}_handleSubscribeEventMessage(i){const r=i.req,a=this._handler.handleEvent(i.eventName,i.arg)(h=>{this._send(new d(this._workerId,r,h))});this._pendingEvents.set(r,a)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let r=[];if(i.type===0)for(let a=0;a<i.args.length;a++)i.args[a]instanceof ArrayBuffer&&r.push(i.args[a]);else i.type===1&&i.res instanceof ArrayBuffer&&r.push(i.res);this._handler.sendMessage(i,r)}}class k extends D.Disposable{constructor(i,r,a){super();let h=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",$=>{this._protocol.handleMessage($)},$=>{h&&h($)})),this._protocol=new v({sendMessage:($,Q)=>{this._worker.postMessage($,Q)},handleMessage:($,Q)=>{if(typeof a[$]!="function")return Promise.reject(new Error("Missing method "+$+" on main thread host."));try{return Promise.resolve(a[$].apply(a,Q))}catch(ee){return Promise.reject(ee)}},handleEvent:($,Q)=>{if(w($)){const ee=a[$].call(a,Q);if(typeof ee!="function")throw new Error(`Missing dynamic event ${$} on main thread host.`);return ee}if(u($)){const ee=a[$];if(typeof ee!="function")throw new Error(`Missing event ${$} on main thread host.`);return ee}throw new Error(`Malformed event name ${$}`)}}),this._protocol.setWorkerId(this._worker.getId());let E=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?E=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(E=C.globals.requirejs.s.contexts._.config);const R=M.getAllMethodNames(a);this._onModuleLoaded=this._protocol.sendMessage(f,[this._worker.getId(),JSON.parse(JSON.stringify(E)),r,R]);const L=($,Q)=>this._request($,Q),W=($,Q)=>this._protocol.listen($,Q);this._lazyProxy=new Promise(($,Q)=>{h=Q,this._onModuleLoaded.then(ee=>{$(c(ee,L,W))},ee=>{Q(ee),this._onError("Worker failed to load "+r,ee)})})}getProxyObject(){return this._lazyProxy}_request(i,r){return new Promise((a,h)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,r).then(a,h)},h)})}_onError(i,r){console.error(i),console.info(r)}}e.SimpleWorkerClient=k;function u(s){return s[0]==="o"&&s[1]==="n"&&I.isUpperAsciiLetter(s.charCodeAt(2))}function w(s){return/^onDynamic/.test(s)&&I.isUpperAsciiLetter(s.charCodeAt(9))}function c(s,i,r){const a=R=>function(){const L=Array.prototype.slice.call(arguments,0);return i(R,L)},h=R=>function(L){return r(R,L)};let E={};for(const R of s){if(w(R)){E[R]=h(R);continue}if(u(R)){E[R]=r(R,void 0);continue}E[R]=a(R)}return E}class o{constructor(i,r){this._requestHandlerFactory=r,this._requestHandler=null,this._protocol=new v({sendMessage:(a,h)=>{i(a,h)},handleMessage:(a,h)=>this._handleMessage(a,h),handleEvent:(a,h)=>this._handleEvent(a,h)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,r){if(i===f)return this.initialize(r[0],r[1],r[2],r[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,r))}catch(a){return Promise.reject(a)}}_handleEvent(i,r){if(!this._requestHandler)throw new Error("Missing requestHandler");if(w(i)){const a=this._requestHandler[i].call(this._requestHandler,r);if(typeof a!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return a}if(u(i)){const a=this._requestHandler[i];if(typeof a!="function")throw new Error(`Missing event ${i} on request handler.`);return a}throw new Error(`Malformed event name ${i}`)}initialize(i,r,a,h){this._protocol.setWorkerId(i);const L=c(h,(W,$)=>this._protocol.sendMessage(W,$),(W,$)=>this._protocol.listen(W,$));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(L),Promise.resolve(M.getAllMethodNames(this._requestHandler))):(r&&(typeof r.baseUrl!="undefined"&&delete r.baseUrl,typeof r.paths!="undefined"&&typeof r.paths.vs!="undefined"&&delete r.paths.vs,typeof r.trustedTypesPolicy!==void 0&&delete r.trustedTypesPolicy,r.catchError=!0,C.globals.require.config(r)),new Promise((W,$)=>{(C.globals.require||V)([a],ee=>{if(this._requestHandler=ee.create(L),!this._requestHandler){$(new Error("No RequestHandler!"));return}W(M.getAllMethodNames(this._requestHandler))},$)}))}}e.SimpleWorkerServer=o;function l(s){return new o(s,null)}e.create=l}),define(J[117],Z([0,1,60,29,43]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(M,I){if(await new Promise((b,P)=>{const S=n.createReadStream(M),m=p.createHash("sha1");S.pipe(m);const t=(0,D.once)((d,g)=>{S.removeAllListeners(),m.removeAllListeners(),d?P(d):b(g)});S.once("error",t),S.once("end",t),m.once("error",t),m.once("data",d=>t(void 0,d.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=C}),define(J[118],Z([0,1,247]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(C="utf8"){this.stringDecoder=new p.StringDecoder(C),this.remaining=null}write(C){const M=[],I=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(I.length<1)return M;let f=0,y,b=f;for(;b<I.length;)if(y=I.charCodeAt(b),y===13||y===10){if(M.push(I.substring(f,b)),b++,b<I.length){const P=y;y=I.charCodeAt(b),(P===13&&y===10||P===10&&y===13)&&b++}f=b}else b++;return this.remaining=f<I.length?I.substr(f):null,M}end(){return this.remaining}}e.LineDecoder=n}),define(J[119],Z([0,1,25]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(M){const I=M.replace(/\-/g,":").toLowerCase();return!n.has(I)}function C(){const M=(0,p.networkInterfaces)();for(let I in M){const f=M[I];if(f){for(const{mac:y}of f)if(D(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(J[71],Z([0,1,25,15,35,31,119]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,P=0;const S=(0,p.networkInterfaces)();for(let m in S){const t=S[m];if(t)for(const{mac:d,internal:g}of t)g||(P+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(b+=1))}this._value=P>0?b/P:0}return this._value}};let I;async function f(){return I||(I=(async()=>await y()||C.generateUuid())()),I}e.getMachineId=f;async function y(){try{const b=await new Promise((S,m)=>{V(["crypto"],S,m)}),P=(0,M.getMac)();return b.createHash("sha256").update(P,"utf8").digest("hex")}catch(b){n.onUnexpectedError(b);return}}}),define(J[24],Z([0,1,29,25,120,8,28,70,9,3,16,7]),function(V,e,p,n,D,C,M,I,f,y,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function m(q,X=S.UNLINK){if((0,M.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return X===S.UNLINK?d(q):t(q)}async function t(q){try{const X=(0,M.randomPath)((0,n.tmpdir)());try{await p.promises.rename(q,X)}catch{return d(q)}d(X).catch(H=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function d(q){return e.Promises.rmdir(q,{recursive:!0,maxRetries:3})}function g(q){if((0,M.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(q,{recursive:!0})}e.rimrafSync=g;async function v(q,X){return w(await(X?k(q):(0,D.promisify)(p.readdir)(q)))}async function k(q){try{return await(0,D.promisify)(p.readdir)(q,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const X=[],H=await v(q);for(const j of H){let te=!1,N=!1,z=!1;try{const K=await e.Promises.lstat((0,f.join)(q,j));te=K.isFile(),N=K.isDirectory(),z=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}X.push({name:j,isFile:()=>te,isDirectory:()=>N,isSymbolicLink:()=>z})}return X}function u(q){return w(p.readdirSync(q))}e.readdirSync=u;function w(q){return q.map(X=>typeof X=="string"?y.isMacintosh?(0,I.normalizeNFC)(X):X:(X.name=y.isMacintosh?(0,I.normalizeNFC)(X.name):X.name,X))}async function c(q){const X=await v(q),H=[];for(const j of X)await l.existsDirectory((0,f.join)(q,j))&&H.push(j);return H}function o(q,X=1e3){return new Promise(H=>{let j=!1;const te=setInterval(()=>{j||(j=!0,p.access(q,N=>{j=!1,N&&(clearInterval(te),H(void 0))}))},X)})}e.whenDeleted=o;var l;(function(q){async function X(te){let N;try{if(N=await e.Promises.lstat(te),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(y.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw K}throw z}}q.stat=X;async function H(te){try{const{stat:N,symbolicLink:z}=await q.stat(te);return N.isFile()&&z?.dangling!==!0}catch{}return!1}q.existsFile=H;async function j(te){try{const{stat:N,symbolicLink:z}=await q.stat(te);return N.isDirectory()&&z?.dangling!==!0}catch{}return!1}q.existsDirectory=j})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new C.ResourceQueue;function i(q,X,H){return s.queueFor(P.URI.file(q),b.extUriBiasedIgnorePathCase).queue(()=>{const j=E(H);return new Promise((te,N)=>a(q,X,j,z=>z?N(z):te()))})}let r=!0;function a(q,X,H,j){if(!r)return p.writeFile(q,X,{mode:H.mode,flag:H.flag},j);p.open(q,H.flag,H.mode,(te,N)=>{if(te)return j(te);p.writeFile(N,X,z=>{if(z)return p.close(N,()=>j(z));p.fdatasync(N,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),r=!1),p.close(N,B=>j(B))))})})}function h(q,X,H){const j=E(H);if(!r)return p.writeFileSync(q,X,{mode:j.mode,flag:j.flag});const te=p.openSync(q,j.flag,j.mode);try{p.writeFileSync(te,X);try{p.fdatasyncSync(te)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),r=!1}}finally{p.closeSync(te)}}e.writeFileSync=h;function E(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function R(q,X){if(q===X)return;async function H(j){try{const te=await e.Promises.lstat(j);if(te.isDirectory()||te.isSymbolicLink())return;await e.Promises.utimes(j,te.atime,new Date)}catch{}}try{await e.Promises.rename(q,X),await H(X)}catch(j){if(q.toLowerCase()!==X.toLowerCase()&&j.code==="EXDEV"||q.endsWith("."))await L(q,X,{preserveSymlinks:!1}),await m(q,S.MOVE),await H(X);else throw j}}async function L(q,X,H){return $(q,X,{root:{source:q,target:X},options:H,handledSourcePaths:new Set})}const W=511;async function $(q,X,H){if(H.handledSourcePaths.has(q))return;H.handledSourcePaths.add(q);const{stat:j,symbolicLink:te}=await l.stat(q);if(te){if(H.options.preserveSymlinks)try{return await x(q,X,H)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(te.dangling)return}return j.isDirectory()?Q(q,X,j.mode&W,H):ee(q,X,j.mode&W)}async function Q(q,X,H,j){await e.Promises.mkdir(X,{recursive:!0,mode:H});const te=await v(q);for(const N of te)await $((0,f.join)(q,N),(0,f.join)(X,N),j)}async function ee(q,X,H){await e.Promises.copyFile(q,X),await e.Promises.chmod(X,H)}async function x(q,X,H){let j=await e.Promises.readlink(q);(0,M.isEqualOrParent)(j,H.root.source,!y.isLinux)&&(j=(0,f.join)(H.root.target,j.substr(H.root.source.length+1))),await e.Promises.symlink(j,X)}e.Promises=new class{get access(){return(0,D.promisify)(p.access)}get stat(){return(0,D.promisify)(p.stat)}get lstat(){return(0,D.promisify)(p.lstat)}get utimes(){return(0,D.promisify)(p.utimes)}get read(){return(q,X,H,j,te)=>new Promise((N,z)=>{p.read(q,X,H,j,te,(K,B,T)=>K?z(K):N({bytesRead:B,buffer:T}))})}get readFile(){return(0,D.promisify)(p.readFile)}get write(){return(q,X,H,j,te)=>new Promise((N,z)=>{p.write(q,X,H,j,te,(K,B,T)=>K?z(K):N({bytesWritten:B,buffer:T}))})}get appendFile(){return(0,D.promisify)(p.appendFile)}get fdatasync(){return(0,D.promisify)(p.fdatasync)}get truncate(){return(0,D.promisify)(p.truncate)}get rename(){return(0,D.promisify)(p.rename)}get copyFile(){return(0,D.promisify)(p.copyFile)}get open(){return(0,D.promisify)(p.open)}get close(){return(0,D.promisify)(p.close)}get symlink(){return(0,D.promisify)(p.symlink)}get readlink(){return(0,D.promisify)(p.readlink)}get chmod(){return(0,D.promisify)(p.chmod)}get mkdir(){return(0,D.promisify)(p.mkdir)}get unlink(){return(0,D.promisify)(p.unlink)}get rmdir(){return(0,D.promisify)(p.rmdir)}get realpath(){return(0,D.promisify)(p.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return m}get move(){return R}get copy(){return L}}}),define(J[85],Z([0,1,29,9,3,27,24]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(S){if(D.isLinux)return S;const m=(0,n.dirname)(S);if(S===m)return S;const t=((0,n.basename)(S)||S).toLowerCase();try{const g=(0,M.readdirSync)(m).filter(v=>v.toLowerCase()===t);if(g.length===1){const v=I(m);if(v)return(0,n.join)(v,g[0])}else if(g.length>1){const v=g.indexOf(t);if(v>=0){const k=I(m);if(k)return(0,n.join)(k,g[v])}}}catch{}return null}e.realcaseSync=I;async function f(S){if(D.isLinux)return S;const m=(0,n.dirname)(S);if(S===m)return S;const t=((0,n.basename)(S)||S).toLowerCase();try{const g=(await M.Promises.readdir(m)).filter(v=>v.toLowerCase()===t);if(g.length===1){const v=await f(m);if(v)return(0,n.join)(v,g[0])}else if(g.length>1){const v=g.indexOf(t);if(v>=0){const k=await f(m);if(k)return(0,n.join)(k,g[v])}}}catch{}return null}e.realcase=f;async function y(S){try{return await M.Promises.realpath(S)}catch{const t=P(S);return await M.Promises.access(t,p.constants.R_OK),t}}e.realpath=y;function b(S){try{return p.realpathSync(S)}catch{const t=P(S);return p.accessSync(t,p.constants.R_OK),t}}e.realpathSync=b;function P(S){return(0,C.rtrim)((0,n.normalize)(S),n.sep)}}),define(J[121],Z([0,1,61]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(I,f,y,b=1){let P=!1;return new Promise(S=>{const m=setTimeout(()=>{if(!P)return P=!0,S(0)},y);D(I,f,b,t=>{if(!P)return P=!0,clearTimeout(m),S(t)})})}e.findFreePort=n;function D(I,f,y,b){if(f===0)return b(0);const P=new p.Socket;P.once("connect",()=>(M(P),D(I+y,f-1,y,b))),P.once("data",()=>{}),P.once("error",S=>(M(P),S.code!=="ECONNREFUSED"?D(I+y,f-1,y,b):b(I))),P.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(I,f,y){let b=!1,P,S=1;const m=p.createServer({pauseOnConnect:!0});function t(d,g){b||(b=!0,m.removeAllListeners(),m.close(),P&&clearTimeout(P),g(d))}return new Promise(d=>{P=setTimeout(()=>{t(0,d)},y),m.on("listening",()=>{t(I,d)}),m.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&S<f?(I++,S++,m.listen(I,"127.0.0.1")):t(0,d)}),m.on("close",()=>{t(0,d)}),m.listen(I,"127.0.0.1")})}e.findFreePortFaster=C;function M(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(f){console.error(f)}}}),define(J[122],Z([0,1,25,9,24]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,M=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var f;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(f||(f={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class P{constructor(c,o,l){this.exePath=c,this.displayName=o,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:w=!1}={}){return w?y===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:w=!1,findPreview:c=!1}={}){const o=S({useAlternateBitness:w});if(!o)return null;const l=n.join(o,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(l))return null;let s=-1,i=null;for(const h of await D.Promises.readdir(l)){let E=-1;if(c){const L=h.indexOf("-");if(L<0)continue;const W=h.substring(0,L);if(!C.test(W)||h.substring(L+1)!=="preview")continue;E=parseInt(W,10)}else{if(!C.test(h))continue;E=parseInt(h,10)}if(E<=s)continue;const R=n.join(l,h,"pwsh.exe");!await D.SymlinkSupport.existsFile(R)||(i=R,s=E)}if(!i)return null;const r=o.includes("x86")?" (x86)":"",a=c?" Preview":"";return new P(i,`PowerShell${a}${r}`,!0)}async function t({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:o,pwshMsixName:l}=w?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(c))if(o.test(s)){const i=n.join(c,s,"pwsh.exe");return new P(i,l)}return null}function d(){const w=n.join(p.homedir(),".dotnet","tools","pwsh.exe");return new P(w,".NET Core PowerShell Global Tool")}function g(){const w=n.join(process.env.windir,y===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(w,"Windows PowerShell",!0)}async function*v(){let w=await m();w&&(yield w),w=await m({useAlternateBitness:!0}),w&&(yield w),w=await t(),w&&(yield w),w=d(),w&&(yield w),w=await m({findPreview:!0}),w&&(yield w),w=await t({findPreview:!0}),w&&(yield w),w=await m({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=g(),w&&(yield w)}async function*k(){for await(const w of v())await w.exists()&&(yield w)}e.enumeratePowerShellInstallations=k;async function u(){for await(const w of k())return w;return null}e.getFirstAvailablePowerShellInstallation=u}),define(J[86],Z([0,1,45,10]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(M){return new Promise((I,f)=>{let y;const b=new Map;function P(m,t,d,g,v){const k=b.get(t);if(m===M||k){const u={name:S(d),cmd:d,pid:m,ppid:t,load:g,mem:v};b.set(m,u),m===M&&(y=u),k&&(k.children||(k.children=[]),k.children.push(u),k.children.length>1&&(k.children=k.children.sort((w,c)=>w.pid-c.pid)))}}function S(m){const t=/--vscode-window-kind=shared-process/,d=/--vscode-window-kind=issue-reporter/,g=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,k=/--crashes-directory/,u=/\\pipe\\winpty-control/,w=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(k.exec(m))return"electron-crash-reporter";if(u.exec(m))return"winpty-process";if(w.exec(m))return"console-window-host (Windows internal process)";let o=c.exec(m);if(o&&o.length===2)return o[1]==="renderer"?t.exec(m)?"shared-process":d.exec(m)?"issue-reporter":g.exec(m)?"process-explorer":"window":o[1]==="utility"&&v.exec(m)?"utility-network-service":o[1];const l=/[a-zA-Z-]+\.js/g;let s="";do o=l.exec(m),o&&(s+=o+" ");while(o);return s&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${s}`:m}if(process.platform==="win32"){const m=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,d)=>{V(["windows-process-tree"],t,d)}).then(t=>{t.getProcessList(M,d=>{t.getProcessCpuUsage(d,g=>{const v=new Map;g.forEach(k=>{const u=m(k.commandLine||"");v.set(k.pid,{name:S(u),cmd:u,pid:k.pid,ppid:k.ppid,load:k.cpu||0,mem:k.memory||0})}),y=v.get(M),y?(v.forEach(k=>{const u=v.get(k.ppid);u&&(u.children||(u.children=[]),u.children.push(k))}),v.forEach(k=>{k.children&&(k.children=k.children.sort((u,w)=>u.pid-w.pid))}),I(y)):f(new Error(`Root process ${M} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let m=function(){let t=[y];const d=[];for(;t.length;){const v=t.shift();v&&(d.push(v.pid),v.children&&(t=t.concat(v.children)))}let g=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);g+=" "+d.join(" "),(0,p.exec)(g,{},(v,k,u)=>{if(v||u)f(v||new Error(u.toString()));else{const w=k.toString().split(`
`);for(let c=0;c<d.length;c++){const o=b.get(d[c]);o.load=parseFloat(w[c])}if(!y){f(new Error(`Root process ${M} not found`));return}I(y)}})};(0,p.exec)("which ps",{},(t,d,g)=>{if(t||g)if(process.platform!=="linux")f(t||new Error(g.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,p.exec)(v,{},(k,u,w)=>{k||w?f(k||new Error(w.toString())):(C(u,P),m())})}else{const v=d.toString().trim(),k="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${k}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,w,c)=>{u||c&&!c.includes("screen size is bogus")?f(u||new Error(c.toString())):(C(w,P),process.platform==="linux"?m():y?I(y):f(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=D;function C(M,I){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=M.toString().split(`
`);for(const b of y){const P=f.exec(b.trim());P&&P.length===6&&I(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(J[123],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[124],Z([0,1,12,14,123]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){p.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(I,f,y,b,P)=>{const S=M(I,b,y);S.popup({window:(0,n.withNullAsUndefined)(p.BrowserWindow.fromWebContents(I.sender)),x:P?P.x:void 0,y:P?P.y:void 0,positioningItem:P?P.positioningItem:void 0,callback:()=>{S&&I.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=C;function M(I,f,y){const b=new p.Menu;return y.forEach(P=>{let S;P.type==="separator"?S=new p.MenuItem({type:P.type}):Array.isArray(P.submenu)?S=new p.MenuItem({submenu:M(I,f,P.submenu),label:P.label}):S=new p.MenuItem({label:P.label,type:P.type,accelerator:P.accelerator,checked:P.checked,enabled:P.enabled,visible:P.visible,click:(m,t,d)=>I.sender.send(f,P.id,d)}),b.append(S)}),b}});var ue=this&&this.__decorate||function(V,e,p,n){var D=arguments.length,C=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,p):n,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(V,e,p,n);else for(var I=V.length-1;I>=0;I--)(M=V[I])&&(C=(D<3?M(C):D>3?M(e,p,C):M(e,p))||C);return D>3&&C&&Object.defineProperty(e,p,C),C};define(J[37],Z([0,1,30,8,17,23,46,15,4,2,113,27,14]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function t(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function g(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(v||(v={}));class k{constructor(z){this.buffer=z,this.pos=0}read(z){const K=this.buffer.slice(this.pos,this.pos+z);return this.pos+=K.byteLength,K}}class u{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var w;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(w||(w={}));function c(N){const z=D.VSBuffer.alloc(4);return z.writeUInt32BE(N,0),z}function o(N){return N.read(4).readUInt32BE(0)}function l(N){const z=D.VSBuffer.alloc(1);return z.writeUInt8(N,0),z}const s={Undefined:l(w.Undefined),String:l(w.String),Buffer:l(w.Buffer),VSBuffer:l(w.VSBuffer),Array:l(w.Array),Object:l(w.Object)},i=typeof Buffer!="undefined";function r(N,z){if(typeof z=="undefined")N.write(s.Undefined);else if(typeof z=="string"){const K=D.VSBuffer.fromString(z);N.write(s.String),N.write(c(K.byteLength)),N.write(K)}else if(i&&Buffer.isBuffer(z)){const K=D.VSBuffer.wrap(z);N.write(s.Buffer),N.write(c(K.byteLength)),N.write(K)}else if(z instanceof D.VSBuffer)N.write(s.VSBuffer),N.write(c(z.byteLength)),N.write(z);else if(Array.isArray(z)){N.write(s.Array),N.write(c(z.length));for(const K of z)r(N,K)}else{const K=D.VSBuffer.fromString(JSON.stringify(z));N.write(s.Object),N.write(c(K.byteLength)),N.write(K)}}function a(N){switch(N.read(1).readUInt8(0)){case w.Undefined:return;case w.String:return N.read(o(N)).toString();case w.Buffer:return N.read(o(N)).buffer;case w.VSBuffer:return N.read(o(N));case w.Array:{const K=o(N),B=[];for(let T=0;T<K;T++)B.push(a(N));return B}case w.Object:return JSON.parse(N.read(o(N)).toString())}}class h{constructor(z,K,B=null,T=1e3){this.protocol=z,this.ctx=K,this.logger=B,this.timeoutDelay=T,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(z,K){this.channels.set(z,K),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const K=this.send([z.type]);this.logger?.logOutgoing(K,0,1,g(z.type));return}case 201:case 202:case 204:case 203:{const K=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(K,z.id,1,g(z.type),z.data);return}}}send(z,K=void 0){const B=new u;return r(B,z),r(B,K),this.sendBuffer(B.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const K=new k(z),B=a(K),T=a(K),_=B[0];switch(_){case 100:return this.logger?.logIncoming(z.byteLength,B[1],1,`${t(_)}: ${B[2]}.${B[3]}`,T),this.onPromise({type:_,id:B[1],channelName:B[2],name:B[3],arg:T});case 102:return this.logger?.logIncoming(z.byteLength,B[1],1,`${t(_)}: ${B[2]}.${B[3]}`,T),this.onEventListen({type:_,id:B[1],channelName:B[2],name:B[3],arg:T});case 101:return this.logger?.logIncoming(z.byteLength,B[1],1,`${t(_)}`),this.disposeActiveRequest({type:_,id:B[1]});case 103:return this.logger?.logIncoming(z.byteLength,B[1],1,`${t(_)}`),this.disposeActiveRequest({type:_,id:B[1]})}}onPromise(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const B=new C.CancellationTokenSource;let T;try{T=K.call(this.ctx,z.name,z.arg,B.token)}catch(A){T=Promise.reject(A)}const _=z.id;T.then(A=>{this.sendResponse({id:_,data:A,type:201}),this.activeRequests.delete(z.id)},A=>{A instanceof Error?this.sendResponse({id:_,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:_,data:A,type:203}),this.activeRequests.delete(z.id)});const F=(0,y.toDisposable)(()=>B.cancel());this.activeRequests.set(z.id,F)}onEventListen(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const B=z.id,_=K.listen(this.ctx,z.name,z.arg)(F=>this.sendResponse({id:B,data:F,type:204}));this.activeRequests.set(z.id,_)}disposeActiveRequest(z){const K=this.activeRequests.get(z.id);K&&(K.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let K=this.pendingRequests.get(z.channelName);K||(K=[],this.pendingRequests.set(z.channelName,K));const B=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:z,timeoutTimer:B})}flushPendingRequests(z){const K=this.pendingRequests.get(z);if(K){for(const B of K)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=h;var E;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(z,K=null){this.protocol=z,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=K}getChannel(z){const K=this;return{call(B,T,_){return K.isDisposed?Promise.reject(I.canceled()):K.requestPromise(z,B,T,_)},listen(B,T){return K.isDisposed?Promise.reject(I.canceled()):K.requestEvent(z,B,T)}}}requestPromise(z,K,B,T=C.CancellationToken.None){const _=this.lastRequestId++,A={id:_,type:100,channelName:z,name:K,arg:B};if(T.isCancellationRequested)return Promise.reject(I.canceled());let O;return new Promise((G,ne)=>{if(T.isCancellationRequested)return ne(I.canceled());const ce=()=>{const he=me=>{switch(me.type){case 201:this.handlers.delete(_),G(me.data);break;case 202:{this.handlers.delete(_);const ke=new Error(me.data.message);ke.stack=me.data.stack,ke.name=me.data.name,ne(ke);break}case 203:this.handlers.delete(_),ne(me.data);break}};this.handlers.set(_,he),this.sendRequest(A)};let ae=null;this.state===v.Idle?ce():(ae=(0,n.createCancelablePromise)(he=>this.whenInitialized()),ae.then(()=>{ae=null,ce()}));const re=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:_,type:101}),ne(I.canceled())},le=T.onCancellationRequested(re);O=(0,y.combinedDisposable)((0,y.toDisposable)(re),le),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(z,K,B){const T=this.lastRequestId++,F={id:T,type:102,channelName:z,name:K,arg:B};let A=null;const O=new f.Emitter({onFirstListenerAdd:()=>{A=(0,n.createCancelablePromise)(G=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(O),this.sendRequest(F)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(O),this.sendRequest({id:T,type:103}))}}),U=G=>O.fire(G.data);return this.handlers.set(T,U),O.event}sendRequest(z){switch(z.type){case 100:case 102:{const K=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(K,z.id,0,`${t(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const K=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(K,z.id,0,t(z.type));return}}}send(z,K=void 0){const B=new u;return r(B,z),r(B,K),this.sendBuffer(B.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const K=new k(z),B=a(K),T=a(K),_=B[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,g(_)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,B[1],0,g(_),T),this.onResponse({type:B[0],id:B[1],data:T})}}onResponse(z){if(z.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(z.id);K&&K(z)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ue([M.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class L{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:K,onDidClientDisconnect:B})=>{f.Event.once(K.onMessage)(_=>{const F=new k(_),A=a(F),O=new h(K,A),U=new R(K);this.channels.forEach((ne,ce)=>O.registerChannel(ce,ne));const G={channelServer:O,channelClient:U,ctx:A};this._connections.add(G),this._onDidAddConnection.fire(G),B(()=>{O.dispose(),U.dispose(),this._connections.delete(G),this._onDidRemoveConnection.fire(G)})})})}get connections(){const z=[];return this._connections.forEach(K=>z.push(K)),z}getChannel(z,K){const B=this;return{call(T,_,F){let A;if((0,S.isFunction)(K)){let U=(0,p.getRandomElement)(B.connections.filter(K));A=U?Promise.resolve(U):f.Event.toPromise(f.Event.filter(B.onDidAddConnection,K))}else A=K.routeCall(B,T,_);const O=A.then(U=>U.channelClient.getChannel(z));return $(O).call(T,_,F)},listen(T,_){if((0,S.isFunction)(K))return B.getMulticastEvent(z,K,T,_);const F=K.routeEvent(B,T,_).then(A=>A.channelClient.getChannel(z));return $(F).listen(T,_)}}}getMulticastEvent(z,K,B,T){const _=this;let F=new y.DisposableStore;const A=new f.Emitter({onFirstListenerAdd:()=>{F=new y.DisposableStore;const O=new f.EventMultiplexer,U=new Map,G=ce=>{const re=ce.channelClient.getChannel(z).listen(B,T),le=O.add(re);U.set(ce,le)},ne=ce=>{const ae=U.get(ce);!ae||(ae.dispose(),U.delete(ce))};_.connections.filter(K).forEach(G),f.Event.filter(_.onDidAddConnection,K)(G,void 0,F),_.onDidRemoveConnection(ne,void 0,F),O.event(A.fire,A,F),F.add(O)},onLastListenerRemove:()=>{F.dispose()}});return A.event}registerChannel(z,K){this.channels.set(z,K),this._connections.forEach(B=>{B.channelServer.registerChannel(z,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class W{constructor(z,K,B=null){const T=new u;r(T,K),z.send(T.buffer),this.channelClient=new R(z,B),this.channelServer=new h(z,K,B)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,K){this.channelServer.registerChannel(z,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function $(N){return{call(z,K,B){return N.then(T=>T.call(z,K,B))},listen(z,K){const B=new f.Relay;return N.then(T=>B.input=T.listen(z,K)),B.event}}}e.getDelayedChannel=$;function Q(N){let z=!1;return{call(K,B,T){return z?N.call(K,B,T):(0,n.timeout)(0).then(()=>z=!0).then(()=>N.call(K,B,T))},listen(K,B){if(z)return N.listen(K,B);const T=new f.Relay;return(0,n.timeout)(0).then(()=>z=!0).then(()=>T.input=N.listen(K,B)),T.event}}}e.getNextTickChannel=Q;class ee{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const K of z.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await f.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=ee;var x;(function(N){function z(_,F){const A=_,O=F&&F.disableMarshalling,U=new Map;for(const G in A)B(G)&&U.set(G,f.Event.buffer(A[G],!0));return new class{listen(G,ne,ce){const ae=U.get(ne);if(ae)return ae;if(T(ne)){const re=A[ne];if(typeof re=="function")return re.call(A,ce)}throw new Error(`Event not found: ${ne}`)}call(G,ne,ce){const ae=A[ne];if(typeof ae=="function"){if(!O&&Array.isArray(ce))for(let re=0;re<ce.length;re++)ce[re]=(0,b.revive)(ce[re]);return ae.apply(A,ce)}throw new Error(`Method not found: ${ne}`)}}}N.fromService=z;function K(_,F){const A=F&&F.disableMarshalling;return new Proxy({},{get(O,U){if(typeof U=="string")return F?.properties?.has(U)?F.properties.get(U):T(U)?function(G){return _.listen(U,G)}:B(U)?_.listen(U):async function(...G){let ne;F&&!(0,S.isUndefinedOrNull)(F.context)?ne=[F.context,...G]:ne=G;const ce=await _.call(U,ne);return A?ce:(0,b.revive)(ce)};throw new Error(`Property not found: ${String(U)}`)}})}N.toService=K;function B(_){return _[0]==="o"&&_[1]==="n"&&P.isUpperAsciiLetter(_.charCodeAt(2))}function T(_){return/^onDynamic/.test(_)&&P.isUpperAsciiLetter(_.charCodeAt(9))}})(x=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let z=N.toString();if(z!=="[object Object]")return z}return N}function H(N){return Array.isArray(N)?N.map(X):X(N)}function j(N,z,K,B,T,_,F){F=H(F);const A=q[T],O=A[B%A.length];let U=[`%c[${N}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(_)?(U=U.concat(F),U.push(")")):U.push(F),console.log.apply(console,U)}e.logWithColors=j;class te{constructor(z,K){this._outgoingPrefix=z,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,K,B,T,_){this._totalOutgoing+=z,j(this._outgoingPrefix,this._totalOutgoing,z,K,B,T,_)}logIncoming(z,K,B,T,_){this._totalIncoming+=z,j(this._incomingPrefix,this._totalIncoming,z,K,B,T,_)}}e.IPCLogger=te}),define(J[125],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(D,C){this.sender=D,this.onMessage=C}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(J[126],Z([0,1,17,4,37]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(f){this.port=f,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",y=>p.VSBuffer.wrap(y.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class M extends D.IPCClient{constructor(f,y){const b=new C(f);super(b,y);this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=M}),define(J[87],Z([0,1,17,4,2,37]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let a=0;function h(R,L){if(!r.has(R)){const W=String(++a);r.set(R,W)}return r.get(R)}function E(R,L,W,$){if(!i.enableDiagnostics)return;const Q=h(R,L);if($ instanceof p.VSBuffer||$ instanceof Uint8Array||$ instanceof ArrayBuffer||ArrayBuffer.isView($)){const ee=p.VSBuffer.alloc($.byteLength);ee.set($),i.records.push({timestamp:Date.now(),id:Q,label:L,type:W,buff:ee})}else i.records.push({timestamp:Date.now(),id:Q,label:L,type:W,data:$})}i.traceSocketEvent=E})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function b(){return y||(y=p.VSBuffer.alloc(0)),y}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return b();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const L=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),L}if(this._chunks[0].byteLength>r){const L=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),L}let h=p.VSBuffer.alloc(r),E=0,R=0;for(;r>0;){const L=this._chunks[R];if(L.byteLength>r){const W=L.slice(0,r);h.set(W,E),E+=r,a&&(this._chunks[R]=L.slice(r),this._totalLength-=r),r-=r}else h.set(L,E),E+=L.byteLength,a?(this._chunks.shift(),this._totalLength-=L.byteLength):R++,r-=L.byteLength}return h}}e.ChunkStream=P;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(S||(S={}));function m(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,a,h,E){this.type=r,this.id=a,this.ack=h,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends D.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:m(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const h=this._state.messageType,E=this._state.id,R=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new d(h,E,R,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=p.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:m(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(a,r.data)}_bufferAdd(r,a){const h=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,h}_bufferTake(){const r=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class k extends D.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=k;class u extends C.IPCClient{constructor(r,a,h=null){super(r,a,h);this.protocol=r}static fromSocket(r,a){return new u(new k(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=u;class w{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=w;class c{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,h=this._first;for(;h;)r[a++]=h.data,h=h.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new c(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class l{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<l._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=l._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const r=Date.now(),a=(1+l._HISTORY_LENGTH)*1e3;let h=0;for(let E=0;E<l._HISTORY_LENGTH;E++)r-this.lastRuns[E]<=a&&h++;return 1-h/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class s{constructor(r,a=null,h=l.getInstance()){this._onControlMessage=new w,this.onControlMessage=this._onControlMessage.event,this._onMessage=new w,this.onMessage=this._onMessage.event,this._onDidDispose=new w,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new w,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new w,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=h,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(E=>this._receiveMessage(E))),this._socketDisposables.push(this._socket.onClose(E=>this._onSocketClose.fire(E))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,b());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,b());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,b());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,b());this._socketWriter.write(r);const a=this._outgoingUnackMsg.toArray();for(let h=0,E=a.length;h<E;h++)this._socketWriter.write(a[h]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new d(6,0,0,b())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let h=0,E=a.length;h<E;h++)this._socketWriter.write(a[h]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new d(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(r){const a=new d(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime,h=Date.now()-this._socketReader.lastReadTime,E=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&h>=2e4&&E>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const R=Math.max(2e4-a,2e4-h,2e4-E,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},R)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,b());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(J[127],Z([0,1,12,17,4,2,37,125]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(b,P){const S=D.Event.fromNodeEventEmitter(p.ipcMain,P,(t,d)=>({event:t,message:d})),m=D.Event.filter(S,({event:t})=>t.sender.id===b);return D.Event.map(m,({message:t})=>t&&n.VSBuffer.wrap(t))}class y extends M.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const P=D.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:S})=>S);return D.Event.map(P,S=>{const m=S.id,t=y.Clients.get(m);t&&t.dispose();const d=new D.Emitter;y.Clients.set(m,(0,C.toDisposable)(()=>d.fire()));const g=f(m,"vscode:message"),v=D.Event.any(D.Event.signal(f(m,"vscode:disconnect")),d.event);return{protocol:new I.Protocol(S,g),onDidClientDisconnect:v}})}}e.Server=y,y.Clients=new Map}),define(J[88],Z([0,1,12,4,31,126]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends C.Client{constructor(y,b){super({addEventListener:(P,S)=>y.addListener(P,S),removeEventListener:(P,S)=>y.removeListener(P,S),postMessage:P=>y.postMessage(P),start:()=>y.start(),close:()=>y.close()},b)}}e.Client=M;async function I(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=(0,D.generateUuid)();f.webContents.send("vscode:createMessageChannel",y);const b=n.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(S,m)=>({nonce:m,port:S.ports[0]})),{port:P}=await n.Event.toPromise(n.Event.once(n.Event.filter(b,S=>S.nonce===y)));return P}e.connect=I}),define(J[89],Z([0,1,8,4,2,14]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function I(P){const S=P;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var f;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(f||(f={}));class y extends D.Disposable{constructor(S,m=Object.create(null)){super();this.database=S,this.options=m,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((m,t)=>this.accept(t,m)),S.deleted?.forEach(m=>this.accept(m,void 0))}accept(S,m){if(this.state===f.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(m)?t=this.cache.delete(S):this.cache.get(S)!==m&&(this.cache.set(S,m),t=!0),t&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,m){const t=this.cache.get(S);return(0,C.isUndefinedOrNull)(t)?m:t}getBoolean(S,m){const t=this.get(S);return(0,C.isUndefinedOrNull)(t)?m:t==="true"}getNumber(S,m){const t=this.get(S);return(0,C.isUndefinedOrNull)(t)?m:parseInt(t,10)}async set(S,m){if(this.state===f.Closed)return;if((0,C.isUndefinedOrNull)(m))return this.delete(S);const t=String(m);if(this.cache.get(S)!==t)return this.cache.set(S,t),this.pendingInserts.set(S,t),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===f.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=y,y.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert&&S.insert.forEach((m,t)=>this.items.set(t,m)),S.delete&&S.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=b}),define(J[128],Z([0,1,8,4,35,9,24]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(b,P=Object.create(null)){this.path=b,this.options=P,this.name=(0,C.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const b=await this.whenConnected,P=new Map;return(await this.all(b,"SELECT * FROM ItemTable")).forEach(m=>P.set(m.key,m.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(b){const P=await this.whenConnected;return this.doUpdateItems(P,b)}doUpdateItems(b,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,D.mapToString)(P.insert):"0"}), delete(${P.delete?(0,D.setToString)(P.delete):"0"})`),this.transaction(b,()=>{const S=P.insert,m=P.delete;if(S&&S.size>0){const t=[];t.push([]);let d=0;S.forEach((g,v)=>{let k=t[d];k.length>I.MAX_HOST_PARAMETERS&&(d++,k=[],t.push(k)),k.push(v,g)}),t.forEach(g=>{this.prepare(b,`INSERT INTO ItemTable VALUES ${new Array(g.length/2).fill("(?,?)").join(",")}`,v=>v.run(g),()=>{const v=[];let k=0;return S.forEach((u,w)=>{v.push(w),k+=u.length}),`Keys: ${v.join(", ")} Length: ${k}`})})}if(m&&m.size){const t=[];t.push([]);let d=0;m.forEach(g=>{let v=t[d];v.length>I.MAX_HOST_PARAMETERS&&(d++,v=[],t.push(v)),v.push(g)}),t.forEach(g=>{this.prepare(b,`DELETE FROM ItemTable WHERE key IN (${new Array(g.length).fill("?").join(",")})`,v=>v.run(g),()=>{const v=[];return m.forEach(k=>{v.push(k)}),`Keys: ${v.join(", ")}`})})}})}async close(b){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,b)}doClose(b,P){return new Promise((S,m)=>{b.db.close(t=>(t&&this.handleSQLiteError(b,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?S():!b.isErroneous&&!b.isInMemory?this.backup().then(S,d=>(this.logger.error(`[storage ${this.name}] backup(): ${d}`),S())):typeof P=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(d=>{const g=()=>this.doClose(d,void 0);return this.doUpdateItems(d,{insert:P()}).then(()=>g(),v=>(g(),Promise.reject(v)))})).then(S,m):m(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const b=this.toBackupPath(this.path);return M.Promises.copy(this.path,b,{preserveSymlinks:!1})}toBackupPath(b){return`${b}.backup`}async checkIntegrity(b){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${b})`);const P=await this.whenConnected,S=await this.get(P,b?"PRAGMA integrity_check":"PRAGMA quick_check"),m=b?S.integrity_check:S.quick_check;return P.isErroneous?`${m} (last error: ${P.lastError})`:P.isInMemory?`${m} (in-memory!)`:m}async connect(b,P=!0){this.logger.trace(`[storage ${this.name}] open(${b}, retryOnBusy: ${P})`);try{return await this.doConnect(b)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&P)return await(0,p.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(b,!1);try{await M.Promises.unlink(b);try{await M.Promises.rename(this.toBackupPath(b),b)}catch{}return await this.doConnect(b)}catch(m){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${m}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(b,P){b.isErroneous=!0,b.lastError=P,this.logger.error(P)}doConnect(b){return new Promise((P,S)=>{new Promise((m,t)=>{V(["@vscode/sqlite3"],m,t)}).then(m=>{const t={db:new(this.logger.isTracing?m.verbose().Database:m.Database)(b,d=>d?t.db?t.db.close(()=>S(d)):S(d):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(t),g=>t.db.close(()=>S(g)))),isInMemory:b===I.IN_MEMORY_PATH};t.db.on("error",d=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${d}`)),this.logger.isTracing&&t.db.on("trace",d=>this.logger.trace(`[storage ${this.name}] Trace (event): ${d}`))},S)})}exec(b,P){return new Promise((S,m)=>{b.db.exec(P,t=>t?(this.handleSQLiteError(b,`[storage ${this.name}] exec(): ${t}`),m(t)):S())})}get(b,P){return new Promise((S,m)=>{b.db.get(P,(t,d)=>t?(this.handleSQLiteError(b,`[storage ${this.name}] get(): ${t}`),m(t)):S(d))})}all(b,P){return new Promise((S,m)=>{b.db.all(P,(t,d)=>t?(this.handleSQLiteError(b,`[storage ${this.name}] all(): ${t}`),m(t)):S(d))})}transaction(b,P){return new Promise((S,m)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),P(),b.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(b,`[storage ${this.name}] transaction(): ${t}`),m(t)):S())})})}prepare(b,P,S,m){const t=b.db.prepare(P),d=g=>{this.handleSQLiteError(b,`[storage ${this.name}] prepare(): ${g} (${P}). Details: ${m()}`)};t.on("error",d),S(t),t.finalize(g=>{g&&d(g),t.removeListener("error",d)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class f{constructor(b){b&&typeof b.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=b.logTrace),b&&typeof b.logError=="function"&&(this.logError=b.logError)}get isTracing(){return!!this.logTrace}trace(b){this.logTrace&&this.logTrace(b)}error(b){this.logError&&this.logError(b)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[129],Z([13,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(J[130],Z([0,1,129]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,C=D*24,M=C*7,I=C*30,f=C*365;function y(P,S,m){typeof P!="number"&&(P=P.getTime());const t=Math.round((new Date().getTime()-P)/1e3);if(t<-30)return(0,p.localize)(0,null,y(new Date().getTime()+t*1e3,!1));if(t<30)return(0,p.localize)(1,null);let d;return t<n?(d=t,S?d===1?m?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):m?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d):d===1?m?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):m?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):t<D?(d=Math.floor(t/n),S?d===1?m?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):m?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d):d===1?m?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):m?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):t<C?(d=Math.floor(t/D),S?d===1?m?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):m?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d):d===1?m?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):m?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):t<M?(d=Math.floor(t/C),S?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d)):t<I?(d=Math.floor(t/M),S?d===1?m?(0,p.localize)(30,null,d):(0,p.localize)(31,null,d):m?(0,p.localize)(32,null,d):(0,p.localize)(33,null,d):d===1?m?(0,p.localize)(34,null,d):(0,p.localize)(35,null,d):m?(0,p.localize)(36,null,d):(0,p.localize)(37,null,d)):t<f?(d=Math.floor(t/I),S?d===1?m?(0,p.localize)(38,null,d):(0,p.localize)(39,null,d):m?(0,p.localize)(40,null,d):(0,p.localize)(41,null,d):d===1?m?(0,p.localize)(42,null,d):(0,p.localize)(43,null,d):m?(0,p.localize)(44,null,d):(0,p.localize)(45,null,d)):(d=Math.floor(t/f),S?d===1?m?(0,p.localize)(46,null,d):(0,p.localize)(47,null,d):m?(0,p.localize)(48,null,d):(0,p.localize)(49,null,d):d===1?m?(0,p.localize)(50,null,d):(0,p.localize)(51,null,d):m?(0,p.localize)(52,null,d):(0,p.localize)(53,null,d))}e.fromNow=y;function b(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(J[131],Z([13,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(J[39],Z([0,1,30,14,131]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(y,b){return b&&(y.stack||y.stacktrace)?D.localize(0,null,I(y),M(y.stack)||M(y.stacktrace)):I(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function I(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?D.localize(1,null,y.message):y.message||D.localize(2,null)}function f(y=null,b=!1){if(!y)return D.localize(3,null);if(Array.isArray(y)){const P=p.coalesce(y),S=f(P[0],b);return P.length>1?D.localize(4,null,S,P.length):S}if(n.isString(y))return y;if(y.detail){const P=y.detail;if(P.error)return C(P.error,b);if(P.exception)return C(P.exception,b)}return y.stack?C(y,b):y.message?y.message:D.localize(5,null)}e.toErrorMessage=f}),define(J[132],Z([13,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(J[133],Z([0,1,132]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(M,I,f=I){this.modifierLabels=[null],this.modifierLabels[2]=M,this.modifierLabels[1]=I,this.modifierLabels[3]=f}toLabel(M,I,f){if(I.length===0)return null;const y=[];for(let b=0,P=I.length;b<P;b++){const S=I[b],m=f(S);if(m===null)return null;y[b]=D(S,m,this.modifierLabels[M])}return y.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(C,M,I){if(M===null)return"";const f=[];return C.ctrlKey&&f.push(I.ctrlKey),C.shiftKey&&f.push(I.shiftKey),C.altKey&&f.push(I.altKey),C.metaKey&&f.push(I.metaKey),M!==""&&f.push(M),f.join(I.separator)}}),define(J[134],Z([13,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(J[72],Z([0,1,45,28,10,49,9,3,36,83,14,118,24,134]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return y.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return y.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,l){if(I.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};l&&(s.cwd=l);const i=p.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],s);return new Promise(r=>{i.once("error",a=>{r({success:!1,error:a})}),i.once("exit",(a,h)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(I.isLinux||I.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(i=>{p.execFile(s,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,a,h)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function g(o){!o||(delete o.DEBUG,I.isMacintosh&&delete o.DYLD_LIBRARY_PATH,I.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=g;function v(o=f.env){return o.comspec||"cmd.exe"}e.getWindowsShell=v;class k{constructor(l,s,i,r){if(s!==void 0&&i!==void 0&&r!==void 0)this.cmd=l,this.args=s,this.shell=i,this.options=r;else{const a=l;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(f.env).forEach(h=>{a[h]=f.env[h]}),Object.keys(this.options.env).forEach(h=>{a[h]=this.options.env[h]}),this.options.env=a}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const s=l.lastIndexOf(M.sep);return s!==-1&&(l=l.substring(s+1)),k.WellKnowCommands[l]?l:"other"}start(l){return I.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(f.cwd()))?Promise.reject(new Error(m.localize(0,null))):this.useExec().then(s=>{let i,r;const a=new Promise((h,E)=>{i=h,r=E});if(s){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=p.exec(h,this.options,(E,R,L)=>{this.childProcess=null;const W=E;W&&W.killed?r({killed:this.terminateRequested,stdout:R.toString(),stderr:L.toString()}):this.handleExec(i,l,E,R,L)})}else{let h=null;const E=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,i,l,r);const L={terminated:this.terminateRequested};b.isNumber(R)&&(L.cmdCode=R),i(L)};if(this.shell&&I.isWindows){const R=C.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let L=!1,W=!1;const $=[];let Q=this.ensureQuotes(this.cmd);$.push(Q.value),L=Q.quoted,this.args&&this.args.forEach(x=>{Q=this.ensureQuotes(x),$.push(Q.value),W=W&&Q.quoted});const ee=["/s","/c"];L?W?ee.push('"'+$.join(" ")+'"'):$.length>1?ee.push('"'+$[0]+'" '+$.slice(1).join(" ")):ee.push('"'+$[0]+'"'):ee.push($.join(" ")),h=p.spawn(v(),ee,R)}else this.cmd&&(h=p.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(b.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",R=>{this.childProcess=null,r({terminated:this.terminateRequested,error:R})}),h.pid&&(this.childProcess.on("close",E),this.handleSpawn(h,i,l,r,!0)))}return a})}handleClose(l,s,i,r){}ensureQuotes(l){return k.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,d(l,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!I.isWindows)return l(!1);const s=p.spawn(v(),["/s","/c"]);s.on("error",i=>l(!0)),s.on("exit",i=>l(!1))})}}e.AbstractProcess=k,k.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},k.regexp=/^[^"].* .*[^"]/;class u extends k{constructor(l,s,i,r){super(l,s,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,s,i,r,a){[r,a].forEach((h,E)=>{const R=new P.LineDecoder;R.write(h).forEach($=>{s({line:$,source:E===0?0:1})});const W=R.end();W&&s({line:W,source:E===0?0:1})}),l({terminated:this.terminateRequested,error:i})}handleSpawn(l,s,i,r,a){const h=new P.LineDecoder,E=new P.LineDecoder;l.stdout.on("data",R=>{h.write(R).forEach(W=>i({line:W,source:0}))}),l.stderr.on("data",R=>{E.write(R).forEach(W=>i({line:W,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=E}handleClose(l,s,i,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&i({line:h,source:1})}}e.LineProcess=u;function w(o){let l=[],s=!1;const i=function(r){if(s){l.push(r);return}(!o.send(r,h=>{if(h&&console.error(h),s=!1,l.length>0){const E=l.slice(0);l=[],E.forEach(R=>i(R))}})||I.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=w;var c;(function(o){async function l(s,i,r){if(M.isAbsolute(s))return s;if(i===void 0&&(i=f.cwd()),M.dirname(s)!=="."||(r===void 0&&b.isString(f.env.PATH)&&(r=f.env.PATH.split(M.delimiter)),r===void 0||r.length===0))return M.join(i,s);async function h(E){if(await S.Promises.exists(E)){let R;try{R=await S.Promises.stat(E)}catch(L){L.message.startsWith("EACCES")&&(R=await S.Promises.lstat(E))}return R?!R.isDirectory():!1}return!1}for(let E of r){let R;if(M.isAbsolute(E)?R=M.join(E,s):R=M.join(i,E,s),await h(R))return R;let L=R+".com";if(await h(L)||(L=R+".exe",await h(L)))return L}return M.join(i,s)}o.findExecutable=l})(c=e.win32||(e.win32={}))}),define(J[135],Z([0,1,25,3,122,72]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(m,t){return m===1?n.isWindows?P():C.getWindowsShell(t):y(m,t)}e.getSystemShell=M;function I(m,t){return m===1?n.isWindows?S(t):C.getWindowsShell(t):y(m,t)}e.getSystemShellSync=I;let f=null;function y(m,t){if(n.isLinux&&m===2||n.isMacintosh&&m===3)return"/bin/bash";if(!f){let d;if(n.isWindows)d="/bin/bash";else{if(d=t.SHELL,!d)try{d=(0,p.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}f=d}return f}let b=null;async function P(){return b||(b=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),b}function S(m){if(b)return b;const t=n.isWindows&&parseFloat((0,p.release)())>=10,d=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${m.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?g:C.getWindowsShell(m)}}),define(J[136],Z([0,1,45,8,17,23,112,15,4,2,49,72,37]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends S.ChannelServer{constructor(g){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=m;class t{constructor(g,v){this.modulePath=g,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const k=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(k),this.child=null,this._client=null}getChannel(g){const v=this;return{call(k,u,w){return v.requestPromise(g,k,u,w)},listen(k,u){return v.requestEvent(g,k,u)}}}requestPromise(g,v,k,u=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const w=this.getCachedChannel(g),c=(0,n.createCancelablePromise)(s=>w.call(v,k,s)),o=u.onCancellationRequested(()=>c.cancel()),l=(0,y.toDisposable)(()=>c.cancel());return this.activeRequests.add(l),c.finally(()=>{o.dispose(),this.activeRequests.delete(l),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(g,v,k){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let u;const w=new f.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(g).listen(v,k)(w.fire,w),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return w.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,P.removeDangerousEnvVariables)(v.env),this.child=(0,p.fork)(this.modulePath,g,v);const k=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,M.isRemoteConsoleLog)(i)){(0,M.log)(i,`IPC Library: ${this.options.serverName}`);return}k.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const w=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,c=i=>this.child&&this.child.connected&&w.send(i.buffer.toString("base64")),o=k.event,l={send:c,onMessage:o};this._client=new S.ChannelClient(l);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(a=>(0,y.dispose)(a)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(g){let v=this.channels.get(g);return v||(v=this.client.getChannel(g),this.channels.set(g,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(J[137],Z([13,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(J[138],Z([13,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[139],Z([13,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[140],Z([13,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(J[141],Z([13,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(J[142],Z([13,11]),function(V,e){return V.create("vs/platform/environment/node/shellEnv",e)}),define(J[143],Z([13,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[144],Z([13,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(J[145],Z([13,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(J[146],Z([13,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(J[147],Z([13,11]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(J[148],Z([13,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[149],Z([13,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[150],Z([13,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[151],Z([13,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[152],Z([13,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(J[153],Z([13,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[154],Z([13,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(J[155],Z([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(J[156],Z([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[157],Z([13,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(J[158],Z([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[159],Z([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[160],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function p(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=p}),define(J[161],Z([0,1,4,2]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(I,f,y){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(I,f,y){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends n.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,f,y){this.channel.call("attach",[I,f,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,f){this.channel.call("terminate",[I,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,f){return this.channel.call("openExtensionDevelopmentHostWindow",[I,f])}}e.ExtensionHostDebugChannelClient=C}),define(J[162],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(M){this.driver=M}listen(M,I){throw new Error(`No event found: ${I}`)}call(M,I,f){switch(I){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=p;class n{constructor(M){this.channel=M}click(M,I,f){return this.channel.call("click",[M,I,f])}doubleClick(M){return this.channel.call("doubleClick",M)}setValue(M,I){return this.channel.call("setValue",[M,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(M){return this.channel.call("isActiveElement",M)}getElements(M,I){return this.channel.call("getElements",[M,I])}getElementXY(M,I,f){return this.channel.call("getElementXY",[M,I,f])}typeInEditor(M,I){return this.channel.call("typeInEditor",[M,I])}getTerminalBuffer(M){return this.channel.call("getTerminalBuffer",M)}writeInTerminal(M,I){return this.channel.call("writeInTerminal",[M,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class D{constructor(M){this.channel=M}registerWindowDriver(M){return this.channel.call("registerWindowDriver",M)}reloadWindowDriver(M){return this.channel.call("reloadWindowDriver",M)}}e.WindowDriverRegistryChannelClient=D}),define(J[163],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class p{constructor(D){this.machineId=D}encryption(){return new Promise((D,C)=>V(["vscode-encrypt"],D,C))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=p}),define(J[164],Z([0,1,130,46,10,9,36,16,7]),function(V,e,p,n,D,C,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(d,g,v){this._args=d,this.paths=g,this.productService=v}get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",V).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(f.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=M.env.VSCODE_PORTABLE;return d?f.URI.file((0,C.join)(d,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,C.resolve)(d):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,C.resolve)(d):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,C.resolve)(d);const g=M.env.VSCODE_EXTENSIONS;if(g)return g;const v=M.env.VSCODE_PORTABLE;return v?(0,C.join)(v,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,C.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,C.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([n.memoize],y.prototype,"appRoot",null),ue([n.memoize],y.prototype,"userHome",null),ue([n.memoize],y.prototype,"userDataPath",null),ue([n.memoize],y.prototype,"appSettingsHome",null),ue([n.memoize],y.prototype,"tmpDir",null),ue([n.memoize],y.prototype,"cacheHome",null),ue([n.memoize],y.prototype,"userRoamingDataHome",null),ue([n.memoize],y.prototype,"settingsResource",null),ue([n.memoize],y.prototype,"userDataSyncHome",null),ue([n.memoize],y.prototype,"userDataSyncLogResource",null),ue([n.memoize],y.prototype,"sync",null),ue([n.memoize],y.prototype,"machineSettingsResource",null),ue([n.memoize],y.prototype,"globalStorageHome",null),ue([n.memoize],y.prototype,"workspaceStorageHome",null),ue([n.memoize],y.prototype,"keybindingsResource",null),ue([n.memoize],y.prototype,"keyboardLayoutResource",null),ue([n.memoize],y.prototype,"argvResource",null),ue([n.memoize],y.prototype,"snippetsHome",null),ue([n.memoize],y.prototype,"isExtensionDevelopment",null),ue([n.memoize],y.prototype,"untitledWorkspacesHome",null),ue([n.memoize],y.prototype,"installSourcePath",null),ue([n.memoize],y.prototype,"builtinExtensionsPath",null),ue([n.memoize],y.prototype,"extensionsPath",null),ue([n.memoize],y.prototype,"extensionDevelopmentLocationURI",null),ue([n.memoize],y.prototype,"extensionDevelopmentKind",null),ue([n.memoize],y.prototype,"extensionTestsLocationURI",null),ue([n.memoize],y.prototype,"debugExtensionHost",null),ue([n.memoize],y.prototype,"serviceMachineIdResource",null),ue([n.memoize],y.prototype,"telemetryLogResource",null),ue([n.memoize],y.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=y;function b(t,d){return m(t["inspect-extensions"],t["inspect-brk-extensions"],5870,d,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=b;function P(t,d){return m(t["inspect-search"],t["inspect-brk-search"],5876,d,t.extensionEnvironment)}e.parseSearchPort=P;function S(t,d){return m(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,d,t.extensionEnvironment)}e.parsePtyHostPort=S;function m(t,d,g,v,k,u){const c=Number(d||t)||(v?null:g),o=c?Boolean(!!d):!1;let l;if(u)try{l=JSON.parse(u)}catch{}return{port:c,break:o,debugId:k,env:l}}}),define(J[90],Z([0,1,248,3,140]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function I(t,d,g=M){const v={},k=[],u=[];for(let l in d){const s=d[l];s.alias&&(v[l]=s.alias),s.type==="string"||s.type==="string[]"?(k.push(l),s.deprecates&&k.push(...s.deprecates)):s.type==="boolean"&&(u.push(l),s.deprecates&&u.push(...s.deprecates))}const w=p(t,{string:k,boolean:u,alias:v}),c={},o=w;c._=w._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(let l in d){const s=d[l];s.alias&&delete o[s.alias];let i=o[l];if(s.deprecates)for(const r of s.deprecates)o.hasOwnProperty(r)&&(i||(i=o[r],i&&g.onDeprecatedOption(r,s.deprecationMessage||(0,D.localize)(33,null))),delete o[r]);typeof i!="undefined"&&(s.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):s.type==="string"&&Array.isArray(i)&&(i=i.pop(),g.onMultipleValues(l,i)),c[l]=i,s.deprecationMessage&&g.onDeprecatedOption(l,s.deprecationMessage)),delete o[l]}for(let l in o)g.onUnknownOption(l);return c}e.parseArgs=I;function f(t,d){let g="";return d.args&&(Array.isArray(d.args)?g=` <${d.args.join("> <")}>`:g=` <${d.args}>`),d.alias?`-${d.alias} --${t}${g}`:`--${t}${g}`}function y(t,d){let g=0,v=[];for(const c in t){const o=t[c],l=f(c,o);g=Math.max(g,l.length),v.push([l,o.description])}let k=g+2+1;if(d-k<25)return v.reduce((c,o)=>c.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let u=d-k-1,w=[];for(const c of v){let o=c[0],l=P(c[1],u),s=b(k-o.length-2);w.push("  "+o+s+l[0]);for(let i=1;i<l.length;i++)w.push(b(k)+l[i])}return w}e.formatOptions=y;function b(t){return" ".repeat(t)}function P(t,d){let g=[];for(;t.length;){let v=t.length<d?t.length:t.lastIndexOf(" ",d),k=t.slice(0,v).trim();t=t.slice(v),g.push(k)}return g}function S(t,d,g,v,k){const u=process.stdout.isTTY&&process.stdout.columns||80,w=k?.noInputFiles!==!0?`[${(0,D.localize)(34,null)}...]`:"",c=[`${t} ${g}`];c.push(""),c.push(`${(0,D.localize)(35,null)}: ${d} [${(0,D.localize)(36,null)}]${w}`),c.push(""),k?.noPipe!==!0&&(n.isWindows?c.push((0,D.localize)(37,null,d)):c.push((0,D.localize)(38,null,d)),c.push(""));const o={};for(const l in v){const s=v[l];if(s.description&&s.cat){let i=o[s.cat];i||(o[s.cat]=i={}),i[l]=s}}for(let l in o){const s=l;let i=o[s];i&&(c.push(C[s]),c.push(...y(i,u)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=S;function m(t,d){return`${t||(0,D.localize)(39,null)}
${d||(0,D.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=m}),define(J[165],Z([0,1,61,161,90]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends n.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,f,y){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1]):super.call(I,f,y)}async openExtensionDevelopmentHostWindow(I,f){const y=(0,D.parseArgs)(I,D.OPTIONS);y.debugRenderer=f;const b=y.extensionDevelopmentPath;if(!b)return{success:!1};const[P]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:y});if(!f)return{success:!0};const S=P.win;if(!S)return{success:!0};const m=S.webContents.debugger;let t=m.isAttached()?1/0:0;const d=(0,p.createServer)(g=>{t++==0&&m.attach();let v=!1;const k=c=>{v||g.write(JSON.stringify(c)+"\0")},u=(c,o,l,s)=>k({method:o,params:l,sessionId:s});S.on("close",()=>{m.removeListener("message",u),g.end(),v=!0}),m.addListener("message",u);let w=Buffer.alloc(0);g.on("data",c=>{w=Buffer.concat([w,c]);for(let o=w.indexOf(0);o!==-1;o=w.indexOf(0)){let l;try{const s=w.slice(0,o).toString("utf8");w=w.slice(o+1),l=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}m.sendCommand(l.method,l.params,l.sessionId).then(s=>k({id:l.id,sessionId:l.sessionId,result:s})).catch(s=>k({id:l.id,sessionId:l.sessionId,error:{code:0,message:s.message}}))}}),g.on("error",c=>{console.error("error on cdp pipe:",c)}),g.on("close",()=>{v=!0,--t==0&&m.detach()})});return await new Promise(g=>d.listen(0,g)),S.on("close",()=>d.close()),{rendererDebugPort:d.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function V(e,p,n,D){function C(I){const f=M(I),y=[f];return e.isAbsolute(f)||y.unshift(D),e.resolve(...y)}function M(I){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,n);const b=I["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(P,"AppData","Roaming")}break;case"darwin":y=e.join(p.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,n)}return{getUserDataPath:C}}if(typeof define=="function")define(J[166],Z([0,249,25,10,16,36]),function(e,p,n,D,C,M){const I=C.dirname(D.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(C.joinPath(I,"package.json").fsPath);return V(p,n,f.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),n=require("os");module.exports=V(p,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[167],Z([0,1,25,164,166]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends n.AbstractNativeEnvironmentService{constructor(I,f){super(I,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,D.getUserDataPath)(I)},f)}}e.NativeEnvironmentService=C}),define(J[168],Z([0,1,29,25,28]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(M){const I=(0,D.randomPath)((0,n.tmpdir)());try{return(0,p.writeFileSync)(I,""),M&&console.log(`Marker file for --wait created: ${I}`),I}catch(f){M&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=C}),define(J[169],Z([0,1,17,31]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,M,I){let f=I&&I.get("storage.serviceMachineId",0)||null;if(f)return f;try{const b=(await M.readFile(C.serviceMachineIdResource)).value.toString();f=(0,n.isUUID)(b)?b:null}catch{f=null}if(!f){f=(0,n.generateUuid)();try{await M.writeFile(C.serviceMachineIdResource,p.VSBuffer.fromString(f))}catch{}}return I&&I.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=D}),define(J[73],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(D,C=[],M=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=p}),define(J[170],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=p;class n{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let M of this._nodes.values())M.outgoing.size===0&&C.push(M);return C}insertEdge(C,M){const I=this.lookupOrInsertNode(C),f=this.lookupOrInsertNode(M);I.outgoing.set(this._hashFn(M),f),f.incoming.set(this._hashFn(C),I)}removeNode(C){const M=this._hashFn(C);this._nodes.delete(M);for(let I of this._nodes.values())I.outgoing.delete(M),I.incoming.delete(M)}lookupOrInsertNode(C){const M=this._hashFn(C);let I=this._nodes.get(M);return I||(I=new p(C),this._nodes.set(M,I)),I}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[M,I]of this._nodes)C.push(`${M}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,M]of this._nodes){const I=new Set([C]),f=this._findCycle(M,I);if(f)return f}}_findCycle(C,M){for(let[I,f]of C.outgoing){if(M.has(I))return[...M,I].join(" -> ");M.add(I);const y=this._findCycle(f,M);if(y)return y;M.delete(I)}}}e.Graph=n}),define(J[5],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function I(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=I})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(M,I,f,y){I[p.DI_TARGET]===I?I[p.DI_DEPENDENCIES].push({id:M,index:f,optional:y}):(I[p.DI_DEPENDENCIES]=[{id:M,index:f,optional:y}],I[p.DI_TARGET]=I)}function D(M){if(p.serviceIds.has(M))return p.serviceIds.get(M);const I=function(f,y,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(I,f,b,!1)};return I.toString=()=>M,p.serviceIds.set(M,I),I}e.createDecorator=D;function C(M){return M}e.refineServiceDecorator=C}),define(J[50],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService")}),define(J[20],Z([0,1,14,7,5]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof n.URI)}e.isConfigurationOverrides=C;function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||p.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=M;var I;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=f;function y(g,v){const k=Object.create(null);for(let u in g)b(k,u,g[u],v);return k}e.toValuesTree=y;function b(g,v,k,u){const w=v.split("."),c=w.pop();let o=g;for(let l=0;l<w.length;l++){let s=w[l],i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:u(`Ignoring ${v} as ${w.slice(0,l+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[c]=k}catch{u(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(o)}`)}else u(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function P(g,v){const k=v.split(".");S(g,k)}e.removeFromValueTree=P;function S(g,v){const k=v.shift();if(v.length===0){delete g[k];return}if(Object.keys(g).indexOf(k)!==-1){const u=g[k];typeof u=="object"&&!Array.isArray(u)&&(S(u,v),Object.keys(u).length===0&&delete g[k])}}function m(g,v,k){function u(o,l){let s=o;for(const i of l){if(typeof s!="object"||s===null)return;s=s[i]}return s}const w=v.split("."),c=u(g,w);return typeof c=="undefined"?k:c}e.getConfigurationValue=m;function t(g,v,k){Object.keys(v).forEach(u=>{u!=="__proto__"&&(u in g?p.isObject(g[u])&&p.isObject(v[u])?t(g[u],v[u],k):k&&(g[u]=v[u]):g[u]=v[u])})}e.merge=t;function d(g,v,k){const u=g.inspect(v),w=g.inspect(k);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:u.defaultValue}e.getMigratedSettingValue=d}),define(J[74],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,p.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,p.createDecorator)("credentialsMainService");class n{constructor(){this.secretVault={}}async getPassword(C,M){return this.secretVault[C]?.[M]??null}async setPassword(C,M,I){this.secretVault[C]=this.secretVault[C]??{},this.secretVault[C][M]=I}async deletePassword(C,M){return this.secretVault[C]?.[M]?(delete this.secretVault[C][M],Object.keys(this.secretVault[C]).length===0&&delete this.secretVault[C],!0):!1}async findPassword(C){return JSON.stringify(this.secretVault[C])??null}async findCredentials(C){const M=[];for(const I of Object.keys(this.secretVault[C]||{}))M.push({account:I,password:this.secretVault[C][I]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=n}),define(J[75],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function n(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=n}),define(J[91],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService")}),define(J[51],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(J[171],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(J[172],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,p.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(J[92],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(J[173],Z([0,1,45,10,9,3,83,24,72,143,92]),function(V,e,p,n,D,C,M,I,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=y.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends S{openTerminal(w,c){return this.spawnTerminal(p,w,f.getWindowsShell(),c)}spawnTerminal(w,c,o,l){const s=c.windowsExec||m.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=D.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return w.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((a,h)=>{const E=g(process),R=w.spawn(o,r,{cwd:l,env:E});R.on("error",h),R.on("exit",()=>a())})}runInTerminal(w,c,o,l,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:m.getDefaultTerminalWindows();return new Promise((r,a)=>{const h=`"${c} - ${P}"`,E=`""${o.join('" "')}" & pause"`,R=["/c","start",h,"/wait",i,"/c",E],L=Object.assign({},g(process),l);Object.keys(L).filter(Q=>L[Q]===null).forEach(Q=>delete L[Q]);const W={cwd:c,env:L,windowsVerbatimArguments:!0};p.spawn(m.CMD,R,W).on("error",Q=>{a(v(Q))}),r(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const w=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${w?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class t extends S{openTerminal(w,c){return this.spawnTerminal(p,w,c)}runInTerminal(w,c,o,l,s){const i=s.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{if(i===b.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const h=i===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,V).fsPath,"-t",w||P,"-w",c];for(let $ of o)R.push("-a"),R.push($);if(l){const $=Object.assign({},g(process),l);for(let Q in $){const ee=$[Q];ee===null?(R.push("-u"),R.push(Q)):(R.push("-e"),R.push(`${Q}=${ee}`))}}let L="";const W=p.spawn(t.OSASCRIPT,R);W.on("error",$=>{a(v($))}),W.stderr.on("data",$=>{L+=$.toString()}),W.on("exit",$=>{if($===0)r(void 0);else if(L){const Q=L.split(`
`,1);a(new Error(Q[0]))}else a(new Error(y.localize(1,null,h,$)))})}else a(new Error(y.localize(2,null,i)))})}spawnTerminal(w,c,o){const l=c.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",l];o&&r.push(o);const a=g(process),h=w.spawn("/usr/bin/open",r,{cwd:o,env:a});h.on("error",i),h.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class d extends S{openTerminal(w,c){return this.spawnTerminal(p,w,c)}runInTerminal(w,c,o,l,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{let h=[];i.then(E=>{E.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const R=`${k(o)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;h.push(`''${R}''`);const L=Object.assign({},g(process),l);Object.keys(L).filter(ee=>L[ee]===null).forEach(ee=>delete L[ee]);const W={cwd:c,env:L};let $="";const Q=p.spawn(E,h,W);Q.on("error",ee=>{a(v(ee))}),Q.stderr.on("data",ee=>{$+=ee.toString()}),Q.on("exit",ee=>{if(ee===0)r(void 0);else if($){const x=$.split(`
`,1);a(new Error(x[0]))}else a(new Error(y.localize(4,null,E,ee)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const w=await I.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{w?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(w,c,o){const l=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{l.then(r=>{const a=g(process),h=w.spawn(r,[],{cwd:o,env:a});h.on("error",i),h.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=y.localize(3,null);function g(u){const w={...u.env};return(0,M.sanitizeProcessEnvironment)(w),w}function v(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(y.localize(5,null,u.path)):u}function k(u){let w="";for(let c of u)c.indexOf(" ")>=0?w+='"'+c+'"':w+=c,w+=" ";return w}}),define(J[18],Z([0,1,35,9,27,14,7,145,5]),function(V,e,p,n,D,C,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function y(H){return H.create===!0}e.isFileOpenForWriteOptions=y;var b;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var P;(function(H){H[H.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var S;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=m;function t(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=t;function d(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function g(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=g;function v(H){return m(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var k;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(j,te){super(j);this.code=te}}e.FileSystemProviderError=u;function w(H,j){const te=new u(H.toString(),j);return o(te,j),te}e.createFileSystemProviderError=w;function c(H){return H||w((0,I.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=c;function o(H,j){return H.name=j?`${j} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=o;function l(H){if(!H)return k.Unknown;if(H instanceof u)return H.code;const j=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!j)return k.Unknown;switch(j[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=l;function s(H){if(H instanceof R)return H.fileOperationResult;switch(l(H)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(j,te,N){this.resource=j,this.operation=te,this.target=N}isOperation(j){return this.operation===j}}e.FileOperationEvent=r;var a;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(j,te){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=j;const N=new Map;for(const z of j){const K=N.get(z.type);switch(K?K.push([z.resource,z]):N.set(z.type,[[z.resource,z]]),z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}}for(const[z,K]of N)switch(z){case 1:this.added=p.TernarySearchTree.forUris(()=>te),this.added.fill(K);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>te),this.updated.fill(K);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>te),this.deleted.fill(K);break}}contains(j,...te){return this.doContains(j,{includeChildren:!1},...te)}affects(j,...te){return this.doContains(j,{includeChildren:!0},...te)}doContains(j,te,...N){if(!j)return!1;const z=N.length>0;return!!((!z||N.includes(1))&&(this.added?.get(j)||te.includeChildren&&this.added?.findSuperstr(j))||(!z||N.includes(0))&&(this.updated?.get(j)||te.includeChildren&&this.updated?.findSuperstr(j))||(!z||N.includes(2))&&(this.deleted?.findSubstr(j)||te.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function E(H,j,te){return!H||!j||H===j||j.length>H.length?!1:(j.charAt(j.length-1)!==n.sep&&(j+=n.sep),te?(0,D.startsWithIgnoreCase)(H,j):H.indexOf(j)===0)}e.isParent=E;class R extends Error{constructor(j,te,N){super(j);this.fileOperationResult=te,this.options=N}}e.FileOperationError=R;class L extends R{constructor(j,te,N){super(j,2,N);this.stat=te}}e.NotModifiedSinceFileOperationError=L;var W;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})($=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=Q;async function ee(H,j){if(!j.hasProvider(M.URI.from({scheme:H.scheme})))return new Promise(te=>{const N=j.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===H.scheme&&z.added&&(N.dispose(),te())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(j){return(0,C.isNumber)(j)||(j=0),j<x.KB?(0,I.localize)(1,null,j.toFixed(0)):j<x.MB?(0,I.localize)(2,null,(j/x.KB).toFixed(2)):j<x.GB?(0,I.localize)(3,null,(j/x.MB).toFixed(2)):j<x.TB?(0,I.localize)(4,null,(j/x.GB).toFixed(2)):(0,I.localize)(5,null,(j/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var q;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function X(H){return{maxFileSize:H===0?300*x.MB:16*x.GB,maxHeapSize:H===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=X}),define(J[52],Z([0,1,250,141,90,18]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function M(S,m){const t={onUnknownOption:g=>{console.warn((0,n.localize)(0,null,g))},onMultipleValues:(g,v)=>{console.warn((0,n.localize)(1,null,g,v))},onDeprecatedOption:(g,v)=>{console.warn((0,n.localize)(2,null,g,v))}},d=(0,D.parseArgs)(S,D.OPTIONS,m?t:void 0);return d.goto&&d._.forEach(g=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,n.localize)(3,null))),d["max-memory"]&&p(parseInt(d["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),d}function I(S){const m=S.findIndex(t=>!/^-/.test(t));if(m>-1)return[...S.slice(0,m),...S.slice(m+1)]}function f(S){let[,...m]=S;process.env.VSCODE_DEV&&(m=I(m)||[]);const t=!P(process.env);return M(m,t)}e.parseMainProcessArgv=f;function y(S){const[,,...m]=S;return M(m,!0)}e.parseCLIProcessArgv=y;function b(S,...m){const t=S.indexOf("--");return t===-1?S.push(...m):S.splice(t,0,...m),S}e.addArg=b;function P(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),define(J[93],Z([0,1,45,9,142,23,39,15,3,31,135,52,8]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const m=1e4;let t;async function d(v,k,u){return k["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(u)&&!k["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(u)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=S.Promises.withAsyncBody(async(w,c)=>{const o=new C.CancellationTokenSource,l=setTimeout(()=>{o.dispose(!0),c(new Error((0,D.localize)(0,null)))},m);try{w(await g(v,o.token))}catch(s){!(0,I.isCancellationError)(s)&&!o.token.isCancellationRequested?c(new Error((0,D.localize)(1,null,(0,M.toErrorMessage)(s)))):w({})}finally{clearTimeout(l),o.dispose()}})),t)}e.getResolvedShellEnv=d;async function g(v,k){const u=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",u);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",w);const c=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(c+"(.*)"+c),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",l);const s=await(0,b.getSystemShell)(f.OS,l);return v.trace("getUnixShellEnvironment#shell",s),new Promise((i,r)=>{if(k.isCancellationRequested)return r((0,I.canceled)());const a=(0,n.basename)(s);let h,E;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(h=`& '${process.execPath}' ${R} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,E=["-Login","-Command"]):(h=`'${process.execPath}' ${R} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?E=["-ic"]:E=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),h);const L=(0,p.spawn)(s,[...E,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});k.onCancellationRequested(()=>(L.kill(),r((0,I.canceled)()))),L.on("error",Q=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(Q)),r(Q)});const W=[];L.stdout.on("data",Q=>W.push(Q));const $=[];L.stderr.on("data",Q=>$.push(Q)),L.on("close",(Q,ee)=>{const x=Buffer.concat(W).toString("utf8");v.trace("getUnixShellEnvironment#raw",x);const q=Buffer.concat($).toString("utf8");if(q.trim()&&v.trace("getUnixShellEnvironment#stderr",q),Q||ee)return r(new Error((0,D.localize)(2,null,Q,ee)));const X=o.exec(x),H=X?X[1]:"{}";try{const j=JSON.parse(H);u?j.ELECTRON_RUN_AS_NODE=u:delete j.ELECTRON_RUN_AS_NODE,w?j.ELECTRON_NO_ATTACH_CONSOLE=w:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",j),i(j)}catch(j){v.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(j)),r(j)}})})}}),define(J[174],Z([0,1,17,39,15,4,2,48,7,31,18]),function(V,e,p,n,D,C,M,I,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends M.Disposable{constructor(m,t){super();this.channel=m,this.extraCapabilities=t,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,y.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(m){return this.channel.call("stat",[m])}readdir(m){return this.channel.call("readdir",[m])}async readFile(m,t){const{buffer:d}=await this.channel.call("readFile",[m,t]);return d}readFileStream(m,t,d){const g=(0,I.newWriteableStream)(k=>p.VSBuffer.concat(k.map(u=>p.VSBuffer.wrap(u))).buffer),v=this.channel.listen("readFileStream",[m,t])(k=>{if(k instanceof p.VSBuffer)g.write(k.buffer);else{if(k==="end")g.end();else{let u=k;u instanceof Error||(u=(0,b.createFileSystemProviderError)((0,n.toErrorMessage)(u),b.FileSystemProviderErrorCode.Unknown)),g.error(u),g.end()}v.dispose()}});return d.onCancellationRequested(()=>{g.error((0,D.canceled)()),g.end(),v.dispose()}),g}writeFile(m,t,d){return this.channel.call("writeFile",[m,p.VSBuffer.wrap(t),d])}open(m,t){return this.channel.call("open",[m,t])}close(m){return this.channel.call("close",[m])}async read(m,t,d,g,v){const[k,u]=await this.channel.call("read",[m,t,v]);return d.set(k.buffer.slice(0,u),g),u}write(m,t,d,g,v){return this.channel.call("write",[m,t,p.VSBuffer.wrap(d),g,v])}mkdir(m){return this.channel.call("mkdir",[m])}delete(m,t){return this.channel.call("delete",[m,t])}rename(m,t,d){return this.channel.call("rename",[m,t,d])}copy(m,t,d){return this.channel.call("copy",[m,t,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(m=>{if(Array.isArray(m)){const t=m;this._onDidChange.fire(t.map(d=>({resource:f.URI.revive(d.resource),type:d.type})))}else{const t=m;this._onDidWatchError.fire(t)}}))}watch(m,t){const d=(0,y.generateUuid)();return this.channel.call("watch",[this.sessionId,d,m,t]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,d]))}}e.DiskFileSystemProviderClient=P}),define(J[94],Z([0,1,17,15,146,18]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(b,P,S,m,t,d){let g;try{await I(b,P,S,m,t,d)}catch(v){g=v}finally{g&&t.errorTransformer&&(g=t.errorTransformer(g)),typeof g!="undefined"&&S.error(g),S.end()}}e.readFileIntoStream=M;async function I(b,P,S,m,t,d){f(d);const g=await b.open(P,{create:!1});try{f(d);let v=0,k=0,u=t&&typeof t.length=="number"?t.length:void 0,w=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof u=="number"?u:t.bufferSize)),c=t&&typeof t.position=="number"?t.position:0,o=0;do k=await b.read(g,c,w.buffer,o,w.byteLength-o),c+=k,o+=k,v+=k,typeof u=="number"&&(u-=k),o===w.byteLength&&(await S.write(m(w)),w=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof u=="number"?u:t.bufferSize)),o=0);while(k>0&&(typeof u!="number"||u>0)&&f(d)&&y(v,t));if(o>0){let l=o;typeof u=="number"&&(l=Math.min(o,u)),S.write(m(w.slice(0,l)))}}catch(v){throw(0,C.ensureFileSystemProviderError)(v)}finally{await b.close(g)}}function f(b){if(b.isCancellationRequested)throw(0,n.canceled)();return!0}function y(b,P){if(P?.limits){if(typeof P.limits.memory=="number"&&b>P.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&b>P.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[62],Z([0,1,2,3,7,18]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function M(m){return m.recursive===!0}e.isRecursiveWatchRequest=M;class I extends p.Disposable{constructor(t,d,g,v){super();this.onFileChanges=t,this.onLogMessage=d,this.verboseLogging=g,this.options=v,this.watcherDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new p.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),t.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),t.add(this.watcher.onDidError(d=>this.onError(d)))}onError(t){this.options.restartOnError?this.restartCounter<I.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${t}`):this.error(t)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=I,I.MAX_RESTARTS=5;class f extends I{constructor(t,d,g){super(t,d,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=f;class y extends I{constructor(t,d,g){super(t,d,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function b(m){return m.map(t=>({type:t.type,resource:D.URI.file(t.path)}))}e.toFileChanges=b;function P(m){const t=new S;for(const d of m)t.processEvent(d);return t.coalesce()}e.coalesceEvents=P;class S{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return n.isLinux?t.path:t.path.toLowerCase()}processEvent(t){const d=this.mapPathToChange.get(this.toKey(t));let g=!1;if(d){const v=d.type,k=t.type;d.path!==t.path&&(t.type===2||t.type===1)?g=!0:v===1&&k===2?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(d)):v===2&&k===1?d.type=0:v===1&&k===0||(d.type=k)}else g=!0;g&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],d=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(t.push(g),!1):!0).sort((g,v)=>g.path.length-v.path.length).filter(g=>d.some(v=>(0,C.isParent)(g.path,v,!n.isLinux))?!1:(d.push(g.path),!0)).concat(t)}}}),define(J[175],Z([0,1,29,8,23,28,114,2,70,9,3,85,24,62]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class t extends I.Disposable{constructor(v,k,u,w){super();this.request=v,this.onDidFilesChange=k,this.onLogMessage=u,this.verboseLogging=w,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,M.parse)(c)),this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const k=await S.Promises.stat(v);this._register(await this.doWatch(v,k.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let k=v.path;try{k=await S.Promises.realpath(v.path),v.path===k&&(k=await(0,P.realcase)(v.path)??v.path),v.path!==k&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${k})`)}catch{}return k}async doWatch(v,k){if(b.isMacintosh&&(0,C.isEqualOrParent)(v,"/Volumes/",!0))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.Disposable.None;const u=new D.CancellationTokenSource(this.cts.token);let w=new I.DisposableStore;try{const c=(0,y.basename)(v),o=(0,p.watch)(v);w.add((0,I.toDisposable)(()=>{o.removeAllListeners(),o.close()})),this.trace(`Started watching: '${v}'`);const l=new Set;if(k)try{for(const i of await S.Promises.readdir(v))l.add(i)}catch(i){this.error(i)}const s=new Map;w.add((0,I.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),o.on("error",(i,r)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),o.on("change",(i,r)=>{if(u.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let a="";if(r&&(a=r.toString(),b.isMacintosh&&(a=(0,f.normalizeNFC)(a))),!(!a||i!=="change"&&i!=="rename"))if(k)if(i==="rename"){s.get(a)?.dispose();const h=setTimeout(async()=>{if(s.delete(a),a===c&&!await S.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.existsChildStrictCase((0,y.join)(v,a));if(u.token.isCancellationRequested)return;let R;E?l.has(a)?R=0:(R=1,l.add(a)):(l.delete(a),R=2),this.onFileChange({path:(0,y.join)(this.request.path,a),type:R})},t.FILE_DELETE_HANDLER_DELAY);s.set(a,(0,I.toDisposable)(()=>clearTimeout(h)))}else{let h;l.has(a)?h=0:(h=1,l.add(a)),this.onFileChange({path:(0,y.join)(this.request.path,a),type:h})}else if(i==="rename"||a!==c){const h=setTimeout(async()=>{const E=await S.Promises.exists(v);u.token.isCancellationRequested||(E?(this.onFileChange({path:this.request.path,type:0},!0),w.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);w.clear(),w.add((0,I.toDisposable)(()=>clearTimeout(h)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await S.Promises.exists(v)&&!u.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${c.toString()})`)}return(0,I.toDisposable)(()=>{u.dispose(!0),w.dispose()})}async onFileChange(v,k=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!k&&this.excludes.some(u=>u(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const u=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,m.coalesceEvents)(u);if(w.length>0){if(this.verboseLogging)for(const o of w)this.trace(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.throttledFileChangesWorker.work(w)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${w.length}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(b.isLinux)return S.Promises.exists(v);try{const k=(0,y.basename)(v);return(await S.Promises.readdir((0,y.dirname)(v))).some(w=>w===k)}catch(k){return this.trace(k),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function d(g,v,k,u,w=512){const c=await S.Promises.open(g,"r"),o=Buffer.allocUnsafe(w),l=new D.CancellationTokenSource(u);let s,i=!1;const r={path:g,excludes:[],recursive:!1},a=new t(r,h=>{(async()=>{for(const{type:E}of h)if(E===0){if(i)return;i=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:R}=await S.Promises.read(c,o,0,w,null);if(!R||l.token.isCancellationRequested)break;v(o.slice(0,R))}}catch(R){s=new Error(R),l.dispose(!0)}finally{i=!1}}})()});return await a.ready,k(),new Promise((h,E)=>{l.token.onCancellationRequested(async()=>{a.dispose();try{await S.Promises.close(c)}catch(R){s=new Error(R)}s?E(s):h()})})}e.watchFileContents=d}),define(J[176],Z([0,1,30,4,2,3,175]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends D.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(y){const b=this.normalizeRequests(y),P=b.filter(m=>{const t=this.watchers.get(m.path);return t?!(0,p.equals)(t.request.excludes,m.excludes):!0}),S=Array.from(this.watchers.values()).filter(({request:m})=>!b.find(t=>t.path===m.path&&(0,p.equals)(t.excludes,m.excludes))).map(({request:m})=>m.path);P.length&&this.trace(`Request to start watching: ${P.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const m of S)this.stopWatching(m);for(const m of P)this.startWatching(m)}startWatching(y){const b=new M.NodeJSFileWatcherLibrary(y,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),P={request:y,instance:b};this.watchers.set(y.path,P)}async stop(){for(const[y]of this.watchers)this.stopWatching(y);this.watchers.clear()}stopWatching(y){const b=this.watchers.get(y);b&&(this.watchers.delete(y),b.instance.dispose())}normalizeRequests(y){const b=new Map;for(const P of y){const S=C.isLinux?P.path:P.path.toLowerCase();b.set(S,P)}return Array.from(b.values())}async setVerboseLogging(y){this.verboseLogging=y;for(const[,b]of this.watchers)b.instance.setVerboseLogging(y)}trace(y){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(y)})}toMessage(y,b){return b?`[File Watcher (node.js)] ${y} (path: ${b.request.path})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=I}),define(J[177],Z([0,1,62,176]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends p.AbstractNonRecursiveWatcherClient{constructor(M,I,f){super(M,I,f);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(J[178],Z([0,1,10,37,136,62]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends C.AbstractUniversalWatcherClient{constructor(f,y,b){super(f,y,b);this.init()}createWatcher(f){const y=f.add(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(y.onDidProcessExit(({code:b,signal:P})=>this.onError(`terminated by itself with code ${b}, signal: ${P}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(J[76],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[C,M]of D)this.set(C,M)}set(D,C){const M=this._entries.get(D);return this._entries.set(D,C),M}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(J[179],Z([0,1,8,15,73,170,5,76]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const f=!1;class y extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class b{constructor(t=new I.ServiceCollection,d=!1,g){this._activeInstantiations=new Set,this._services=t,this._strict=d,this._parent=g,this._services.set(M.IInstantiationService,this)}createChild(t){return new b(t,this._strict,this)}invokeFunction(t,...d){let g=S.traceInvocation(t),v=!1;try{return t({get:u=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const w=this._getOrCreateServiceInstance(u,g);if(!w)throw new Error(`[invokeFunction] unknown service '${u}'`);return w}},...d)}finally{v=!0,g.stop()}}createInstance(t,...d){let g,v;return t instanceof D.SyncDescriptor?(g=S.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(d),g)):(g=S.traceCreation(t),v=this._createInstance(t,d,g)),g.stop(),v}_createInstance(t,d=[],g){let v=M._util.getServiceDependencies(t).sort((w,c)=>w.index-c.index),k=[];for(const w of v){let c=this._getOrCreateServiceInstance(w.id,g);if(!c&&this._strict&&!w.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${w.id}.`);k.push(c)}let u=v.length>0?v[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${t.name} at position ${u+1} conflicts with ${d.length} static arguments`);let w=u-d.length;w>0?d=d.concat(new Array(w)):d=d.slice(0,u)}return new t(...[...d,...k])}_setServiceInstance(t,d){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,d);else if(this._parent)this._parent._setServiceInstance(t,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let d=this._services.get(t);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):d}_getOrCreateServiceInstance(t,d){let g=this._getServiceInstanceOrDescriptor(t);return g instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,g,d.branch(t,!0)):(d.branch(t,!1),g)}_safeCreateAndCacheServiceInstance(t,d,g){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,d,g)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,d,g){const v=new C.Graph(w=>w.id.toString());let k=0;const u=[{id:t,desc:d,_trace:g}];for(;u.length;){const w=u.pop();if(v.lookupOrInsertNode(w),k++>1e3)throw new y(v);for(let c of M._util.getServiceDependencies(w.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(c.id);if(!o&&!c.optional&&console.warn(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`),o instanceof D.SyncDescriptor){const l={id:c.id,desc:o,_trace:w._trace.branch(c.id,!0)};v.insertEdge(w,l),u.push(l)}}}for(;;){const w=v.roots();if(w.length===0){if(!v.isEmpty())throw new y(v);break}for(const{data:c}of w){if(this._getServiceInstanceOrDescriptor(c.id)instanceof D.SyncDescriptor){const l=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,l)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,d,g=[],v,k){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(d,g,v,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,d,g,v,k);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(t,d=[],g,v){if(g){const k=new p.IdleValue(()=>this._createInstance(t,d,v));return new Proxy(Object.create(null),{get(u,w){if(w in u)return u[w];let c=k.value,o=c[w];return typeof o!="function"||(o=o.bind(c),u[w]=o),o},set(u,w,c){return k.value[w]=c,!0}})}else return this._createInstance(t,d,v)}}e.InstantiationService=b;var P;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(P||(P={}));class S{constructor(t,d){this.type=t,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return f?new S(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(t){return f?new S(0,t.name):S._None}branch(t,d){let g=new S(2,t.toString());return this._dep.push([t,d,g]),g}stop(){let t=Date.now()-this._start;S._totals+=t;let d=!1;function g(k,u){let w=[],c=new Array(k+1).join("	");for(const[o,l,s]of u._dep)if(l&&s){d=!0,w.push(`${c}CREATES -> ${o}`);let i=g(k+1,s);i&&w.push(i)}else w.push(`${c}uses -> ${o}`);return w.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(t>2||d)&&console.log(v.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(J[180],Z([0,1,15,133,59]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends D.ResolvedKeybinding{constructor(I,f){super();if(f.length===0)throw(0,p.illegalArgument)("parts");this._os=I,this._parts=f}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new D.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=C}),define(J[181],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(C,M,I,f,y,b,P){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?n(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=n(C.getSingleModifierDispatchParts())),this.bubble=M?M.charCodeAt(0)===94:!1,this.command=this.bubble?M.substr(1):M,this.commandArgs=I,this.when=f,this.isDefault=y,this.extensionId=b,this.isBuiltinExtension=P}}e.ResolvedKeybindingItem=p;function n(D){let C=[];for(let M=0,I=D.length;M<I;M++){const f=D[M];if(!f)return C;C.push(f)}return C}e.removeElementsAfterNulls=n}),define(J[182],Z([0,1,82,59,180,181]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class M extends D.BaseResolvedKeybinding{constructor(f,y){super(y,f.parts)}_keyCodeToUILabel(f){if(this._os===2)switch(f){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(f)}_getLabel(f){return f.isDuplicateModifierCase()?"":this._keyCodeToUILabel(f.keyCode)}_getAriaLabel(f){return f.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(f.keyCode)}_getElectronAccelerator(f){return p.KeyCodeUtils.toElectronAccelerator(f.keyCode)}_getUserSettingsLabel(f){if(f.isDuplicateModifierCase())return"";const y=p.KeyCodeUtils.toUserSettingsUS(f.keyCode);return y&&y.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(f){return M.getDispatchStr(f)}static getDispatchStr(f){if(f.isModifierKey())return null;let y="";return f.ctrlKey&&(y+="ctrl+"),f.shiftKey&&(y+="shift+"),f.altKey&&(y+="alt+"),f.metaKey&&(y+="meta+"),y+=p.KeyCodeUtils.toString(f.keyCode),y}_getSingleModifierDispatchPart(f){return f.keyCode===5&&!f.shiftKey&&!f.altKey&&!f.metaKey?"ctrl":f.keyCode===4&&!f.ctrlKey&&!f.altKey&&!f.metaKey?"shift":f.keyCode===6&&!f.ctrlKey&&!f.shiftKey&&!f.metaKey?"alt":f.keyCode===57&&!f.ctrlKey&&!f.shiftKey&&!f.altKey?"meta":null}static _scanCodeToKeyCode(f){const y=p.IMMUTABLE_CODE_TO_KEY_CODE[f];if(y!==-1)return y;switch(f){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(f){if(!f)return null;if(f instanceof n.SimpleKeybinding)return f;const y=this._scanCodeToKeyCode(f.scanCode);return y===0?null:new n.SimpleKeybinding(f.ctrlKey,f.shiftKey,f.altKey,f.metaKey,y)}static resolveUserBinding(f,y){const b=(0,C.removeElementsAfterNulls)(f.map(P=>this._resolveSimpleUserBinding(P)));return b.length>0?[new M(new n.ChordKeybinding(b),y)]:[]}}e.USLayoutResolvedKeybinding=M}),define(J[183],Z([0,1,8]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(D,C){if(D.length===0)return Promise.resolve(!1);const M=[];let I=!1;for(let f of D){if(f===!0)return Promise.resolve(!0);(0,p.isThenable)(f)&&M.push(f.then(y=>{y&&(I=!0)},y=>{C(y),I=!0}))}return p.Promises.settled(M).then(()=>I)}e.handleVetos=n}),define(J[6],Z([0,1,39,4,2,3,5]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function I(){return new Date().toISOString()}var f;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function y(l,s,i){switch(s){case f.Trace:l.trace(i);break;case f.Debug:l.debug(i);break;case f.Info:l.info(i);break;case f.Warning:l.warn(i);break;case f.Error:l.error(i);break;case f.Critical:l.critical(i);break;default:throw new Error("Invalid log level")}}e.log=y;function b(l){let s="";for(let i=0;i<l.length;i++){let r=l[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(i>0?" ":"")+r}return s}e.format=b;class P extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class S extends P{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(f.Trace)&&this.log(f.Trace,b([s,...i]))}debug(s,...i){this.checkLogLevel(f.Debug)&&this.log(f.Debug,b([s,...i]))}info(s,...i){this.checkLogLevel(f.Info)&&this.log(f.Info,b([s,...i]))}warn(s,...i){this.checkLogLevel(f.Warning)&&this.log(f.Warning,b([s,...i]))}error(s,...i){if(this.checkLogLevel(f.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(f.Error,b(r))}else this.log(f.Error,b([s,...i]))}critical(s,...i){this.checkLogLevel(f.Critical)&&this.log(f.Critical,b([s,...i]))}flush(){}}e.AbstractMessageLogger=S;class m extends P{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!C.isWindows}trace(s,...i){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...i):console.log(`[main ${I()}]`,s,...i))}debug(s,...i){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...i):console.log(`[main ${I()}]`,s,...i))}info(s,...i){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...i):console.log(`[main ${I()}]`,s,...i))}warn(s,...i){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,s,...i):console.warn(`[main ${I()}]`,s,...i))}error(s,...i){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,s,...i):console.error(`[main ${I()}]`,s,...i))}critical(s,...i){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,s,...i):console.error(`[main ${I()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class t extends P{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...i){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class d extends P{constructor(s,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,p.toErrorMessage)(s,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class g extends P{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const r of this.logServices)r.trace(s,...i)}debug(s,...i){for(const r of this.logServices)r.debug(s,...i)}info(s,...i){for(const r of this.logServices)r.info(s,...i)}warn(s,...i){for(const r of this.logServices)r.warn(s,...i)}error(s,...i){for(const r of this.logServices)r.error(s,...i)}critical(s,...i){for(const r of this.logServices)r.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=g;class v extends D.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=v;class k extends D.Disposable{constructor(s,i){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,i?.always?f.Trace:this.logLevel,i),this.loggers.set(s.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=k;class u{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(s){}getLevel(){return f.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=u;function w(l){if(l.verbose)return f.Trace;if(typeof l.logLevel=="string"){const s=c(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function c(l){switch(l){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=c;function o(l){switch(l){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o}),define(J[184],Z([0,1,30,8,15,4,2,9,62,6]),function(V,e,p,n,D,C,M,I,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends M.Disposable{constructor(S,m){super();this.logService=S,this.options=m,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(S,m){return m.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,m):this.watchNonRecursive(S,m)}watchUniversal(S,m){const t={path:this.toFilePath(S),excludes:m.excludes,recursive:m.recursive},d=(0,p.insert)(this.universalPathsToWatch,t);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{d(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(m=>this._onDidChangeFile.fire((0,f.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const m of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const m of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(m)&&S.includes(m.path)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,m){const t={path:this.toFilePath(S),excludes:m.excludes,recursive:!1},d=(0,p.insert)(this.nonRecursivePathsToWatch,t);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{d(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,f.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,I.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=b});var ie=this&&this.__param||function(V,e){return function(p,n){e(p,n,V)}};define(J[185],Z([0,1,30,8,17,23,4,69,68,2,35,10,63,16,48,144,18,94,6]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends y.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${c}`);const l=new y.DisposableStore;return this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o}),l.add(o.onDidChangeFile(s=>this._onDidFilesChange.fire(new g.FileChangesEvent(s,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&l.add(o.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),l.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,y.dispose)(l)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(l){o.push(l)}}),!this.provider.has(c)&&await n.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,o){const l=this.provider.get(c.scheme);return!!(l&&l.capabilities&o)}listCapabilities(){return f.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,m.isAbsolutePath)(c))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const l=new Error;throw l.name="ENOPRO",l.message=(0,d.localize)(1,null,c.toString()),l}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasReadWriteCapability)(o)||(0,g.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(l){throw(0,g.toFileSystemProviderErrorCode)(l)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(c)),1):(0,g.ensureFileSystemProviderError)(l)}}async doResolveFile(c,o){const l=await this.withProvider(c),s=this.isPathCaseSensitive(l),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,h=await l.stat(c);let E;return this.toFileStat(l,c,h,void 0,!!a,(R,L)=>(E||(E=b.TernarySearchTree.forUris(()=>!s),E.set(c,!0),i&&E.fill(!0,i)),E.get(R.resource)||E.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&r?L===1:!1))}async toFileStat(c,o,l,s,i,r){const{providerExtUri:a}=this.getExtUri(c),h={resource:o,name:a.basename(o),isFile:(l.type&g.FileType.File)!=0,isDirectory:(l.type&g.FileType.Directory)!=0,isSymbolicLink:(l.type&g.FileType.SymbolicLink)!=0,mtime:l.mtime,ctime:l.ctime,size:l.size,readonly:Boolean((l.permissions??0)&g.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,g.etag)({mtime:l.mtime,size:l.size})};if(h.isDirectory&&r(h,s)){try{const E=await c.readdir(o),R=await n.Promises.settled(E.map(async([L,W])=>{try{const $=a.joinPath(o,L),Q=i?await c.stat($):{type:W};return await this.toFileStat(c,$,Q,E.length,i,r)}catch($){return this.logService.trace($),null}}));h.children=(0,p.coalesce)(R)}catch(E){this.logService.trace(E),h.children=[]}return h}return h}async resolveAll(c){return n.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(l){return this.logService.trace(l),{stat:void 0,success:!1}}}))}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(l){return l}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=D.VSBuffer.fromString(""),l){await this.doValidateCreateFile(c,l);const s=await this.writeFile(c,o);return this._onDidRunOperation.fire(new g.FileOperationEvent(c,0,s)),s}async writeFile(c,o,l){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,c,l)||await this.mkdirp(s,i.dirname(c));let a;if((0,g.hasReadWriteCapability)(s)&&!(o instanceof D.VSBuffer))if((0,t.isReadableStream)(o)){const h=await(0,t.peekStream)(o,3);h.ended?a=D.VSBuffer.concat(h.buffer):a=h}else a=(0,t.peekReadable)(o,h=>D.VSBuffer.concat(h),3);else a=o;!(0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasReadWriteCapability)(s)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(s,c,l,a):await this.doWriteBuffered(s,c,l,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a)}catch(r){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),l)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,l){if(!!l?.unlock&&!(c.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(o)));let i;try{i=await c.stat(o)}catch{return}if((i.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(o)),0,l);if(this.throwIfFileIsReadonly(o,i),typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==g.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&l.mtime<i.mtime&&l.etag!==(0,g.etag)({mtime:l.mtime,size:i.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,l);return i}async readFile(c,o,l){const s=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(s,c,o,l):this.doReadFile(s,c,o,l)}async doReadFileAtomic(c,o,l,s){return new Promise((i,r)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,o,l,s);i(a)}catch(a){r(a)}})})}async doReadFile(c,o,l,s){const i=await this.doReadFileStream(c,o,{...l,preferUnbuffered:!0},s);return{...i,value:await(0,D.streamToBuffer)(i.value)}}async readFileStream(c,o,l){const s=await this.withReadProvider(c);return this.doReadFileStream(s,c,o,l)}async doReadFileStream(c,o,l,s){const i=new C.CancellationTokenSource(s),r=this.validateReadFile(o,l).then(h=>h,h=>{throw i.cancel(),h});let a;try{return typeof l?.etag=="string"&&l.etag!==g.ETAG_DISABLED&&await r,l?.atomic&&(0,g.hasFileAtomicReadCapability)(c)||!((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasFileReadStreamCapability)(c))||(0,g.hasReadWriteCapability)(c)&&l?.preferUnbuffered?a=this.readFileUnbuffered(c,o,l):(0,g.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,o,i.token,l):a=this.readFileBuffered(c,o,i.token,l),{...await r,value:a}}catch(h){a&&await(0,t.consumeStream)(a);const E=(0,d.localize)(8,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(h).toString());throw h instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(E,h.stat,l):new g.FileOperationError(E,(0,g.toFileOperationResult)(h),l)}}readFileStreamed(c,o,l,s=Object.create(null)){const i=c.readFileStream(o,s,l);return(0,t.transform)(i,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),s)},r=>D.VSBuffer.concat(r))}readFileBuffered(c,o,l,s=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,o,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),s)},l),i}readFileUnbuffered(c,o,l){const s=(0,t.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i;l?.atomic&&(0,g.hasFileAtomicReadCapability)(c)?i=await c.readFile(o,{atomic:!0}):i=await c.readFile(o),typeof l?.position=="number"&&(i=i.slice(l.position)),typeof l?.length=="number"&&(i=i.slice(0,l.length)),this.validateReadFileLimits(o,i.byteLength,l),s.end(D.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(c,o){const l=await this.resolve(c,{resolveMetadata:!0});if(l.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==g.ETAG_DISABLED&&o.etag===l.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),l,o);return this.validateReadFileLimits(c,l.size,o),l}validateReadFileLimits(c,o,l){if(l?.limits){let s;if(typeof l.limits.memory=="number"&&o>l.limits.memory&&(s=9),typeof l.limits.size=="number"&&o>l.limits.size&&(s=7),typeof s=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,o,l){return this.doCanMoveCopy(c,o,"move",l)}async canCopy(c,o,l){return this.doCanMoveCopy(c,o,"copy",l)}async doCanMoveCopy(c,o,l,s){if(c.toString()!==o.toString())try{const i=l==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,c,r,o,l,s)}catch(i){return i}return!0}async move(c,o,l){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"move",!!l),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(c,r==="move"?2:3,a)),a}async copy(c,o,l){const s=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"copy",!!l),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(c,r==="copy"?3:2,a)),a}async doMoveCopy(c,o,l,s,i,r){if(o.toString()===s.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(c,o,l,s,i,r);if(a&&!h&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(s)),i==="copy"){if(c===l&&(0,g.hasFileFolderCopyCapability)(c))await c.copy(o,s,{overwrite:r});else{const E=await this.resolve(o);E.isDirectory?await this.doCopyFolder(c,E,l,s):await this.doCopyFile(c,o,l,s)}return i}else return c===l?(await c.rename(o,s,{overwrite:r}),i):(await this.doMoveCopy(c,o,l,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,l,s){if((0,g.hasOpenReadWriteCloseCapability)(c)&&(0,g.hasOpenReadWriteCloseCapability)(l))return this.doPipeBuffered(c,o,l,s);if((0,g.hasOpenReadWriteCloseCapability)(c)&&(0,g.hasReadWriteCapability)(l))return this.doPipeBufferedToUnbuffered(c,o,l,s);if((0,g.hasReadWriteCapability)(c)&&(0,g.hasOpenReadWriteCloseCapability)(l))return this.doPipeUnbufferedToBuffered(c,o,l,s);if((0,g.hasReadWriteCapability)(c)&&(0,g.hasReadWriteCapability)(l))return this.doPipeUnbuffered(c,o,l,s)}async doCopyFolder(c,o,l,s){await l.mkdir(s),Array.isArray(o.children)&&await n.Promises.settled(o.children.map(async i=>{const r=this.getExtUri(l).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),l,r):this.doCopyFile(c,i.resource,l,r)}))}async doValidateMoveCopy(c,o,l,s,i,r){let a=!1;if(c===l){const{providerExtUri:E,isPathCaseSensitive:R}=this.getExtUri(c);if(R||(a=E.isEqual(o,s)),a&&i==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(o),this.resourceForError(s)));if(!a&&E.isEqualOrParent(s,o))throw new Error((0,d.localize)(15,null,this.resourceForError(o),this.resourceForError(s)))}const h=await this.exists(s);if(h&&!a){if(!r)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(o),this.resourceForError(s)),4);if(c===l){const{providerExtUri:E}=this.getExtUri(c);if(E.isEqualOrParent(o,s))throw new Error((0,d.localize)(17,null,this.resourceForError(o),this.resourceForError(s)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(c,0,l)),l}async mkdirp(c,o){const l=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(o,s.dirname(o));)try{if(((await c.stat(o)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,g.toFileSystemProviderErrorCode)(i)!==g.FileSystemProviderErrorCode.FileNotFound)throw i;l.push(s.basename(o)),o=s.dirname(o)}for(let i=l.length-1;i>=0;i--){o=s.joinPath(o,l[i]);try{await c.mkdir(o)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(l){return l}return!0}async doValidateDelete(c,o){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(l.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(c)));let i;try{i=await l.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(c)))}return l}async del(c,o){const l=await this.doValidateDelete(c,o),s=!!o?.useTrash,i=!!o?.recursive;await l.delete(c,{recursive:i,useTrash:s}),this._onDidRunOperation.fire(new g.FileOperationEvent(c,1))}watch(c,o={recursive:!1,excludes:[]}){const l=new y.DisposableStore;let s=!1,i=()=>{s=!0};return l.add((0,y.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(c,o);s?(0,y.dispose)(r):i=()=>(0,y.dispose)(r)}catch(r){this.logService.error(r)}})(),l}async doWatch(c,o){const l=await this.withProvider(c),s=(0,I.hash)([this.getExtUri(l).providerExtUri.getComparisonKey(c),o]);let i=this.activeWatchers.get(s);return i||(i={count:0,disposable:l.watch(c,o)},this.activeWatchers.set(s,i)),i.count+=1,(0,y.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,y.dispose)(i.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,y.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,l,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(o,{create:!0,unlock:l?.unlock??!1});try{(0,t.isReadableStream)(s)||(0,t.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,i,s):await this.doWriteReadableBufferedQueued(c,i,s)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,o,l){let s=0,i;if((0,t.isReadableBufferedStream)(l)){if(l.buffer.length>0){const r=D.VSBuffer.concat(l.buffer);await this.doWriteBuffer(c,o,r,r.byteLength,s,0),s+=r.byteLength}if(l.ended)return;i=l.stream}else i=l;return new Promise((r,a)=>{(0,t.listenStream)(i,{onData:async h=>{i.pause();try{await this.doWriteBuffer(c,o,h,h.byteLength,s,0)}catch(E){return a(E)}s+=h.byteLength,setTimeout(()=>i.resume())},onError:h=>a(h),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,o,l){let s=0,i;for(;(i=l.read())!==null;)await this.doWriteBuffer(c,o,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(c,o,l,s,i,r){let a=0;for(;a<s;)a+=await c.write(o,i+a,l.buffer,r+a,s-a)}async doWriteUnbuffered(c,o,l,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,l,s))}async doWriteUnbufferedQueued(c,o,l,s){let i;s instanceof D.VSBuffer?i=s:(0,t.isReadableStream)(s)?i=await(0,D.streamToBuffer)(s):(0,t.isReadableBufferedStream)(s)?i=await(0,D.bufferedStreamToBuffer)(s):i=(0,D.readableToBuffer)(s),await c.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:l?.unlock??!1})}async doPipeBuffered(c,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,l,s))}async doPipeBufferedQueued(c,o,l,s){let i,r;try{i=await c.open(o,{create:!1}),r=await l.open(s,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,E=0,R=0;do R=await c.read(i,h,a.buffer,E,a.byteLength-E),await this.doWriteBuffer(l,r,a,R,h,E),h+=R,E+=R,E===a.byteLength&&(E=0);while(R>0)}catch(a){throw(0,g.ensureFileSystemProviderError)(a)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof r=="number"?l.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,l,s))}async doPipeUnbufferedQueued(c,o,l,s){return l.writeFile(s,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,l,s))}async doPipeUnbufferedToBufferedQueued(c,o,l,s){const i=await l.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(o);await this.doWriteBuffer(l,i,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await l.close(i)}}async doPipeBufferedToUnbuffered(c,o,l,s){const i=await(0,D.streamToBuffer)(this.readFileBuffered(c,o,C.CancellationToken.None));await this.doWriteUnbuffered(l,s,void 0,i)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===P.Schemas.file?c.fsPath:c.toString(!0)}};u=ue([ie(0,k.ILogService)],u),e.FileService=u}),define(J[77],Z([0,1,29,251,8,35,17,4,28,2,9,3,16,48,24,148,18,94,184,39,178,177]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(p)}catch(l){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(l)}`)}})();class o extends k.AbstractDiskFileSystemProvider{constructor(s,i){super(s,i);this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new C.ResourceMap(r=>S.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:r}=await t.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(s){try{const i=await t.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async a=>{try{let h;a.isSymbolicLink()?h=(await this.stat((0,S.joinPath)(s,a.name))).type:h=this.toType(a),r.push([a.name,h])}catch(h){this.logService.trace(h)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let r;return i?.dangling?r=g.FileType.Unknown:s.isFile()?r=g.FileType.File:s.isDirectory()?r=g.FileType.Directory:r=g.FileType.Unknown,i&&(r|=g.FileType.SymbolicLink),r}async createResourceLock(s){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(s)})`);let i;for(;i=this.resourceLocks.get(s);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(s)})`),await i.wait();const r=new D.Barrier;return this.resourceLocks.set(s,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(s)})`),(0,y.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(s)})`),this.resourceLocks.delete(s),r.open()})}async readFile(s,i){let r;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const a=this.toFilePath(s);return await t.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}readFileStream(s,i,r){const a=(0,m.newWriteableStream)(h=>M.VSBuffer.concat(h.map(E=>M.VSBuffer.wrap(E))).buffer);return(0,v.readFileIntoStream)(this,s,a,h=>h.buffer,{...i,bufferSize:256*1024},r),a}async writeFile(s,i,r){let a;try{const h=this.toFilePath(s);if(!r.create||!r.overwrite){if(await t.Promises.exists(h)){if(!r.overwrite)throw(0,g.createFileSystemProviderError)((0,d.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,g.createFileSystemProviderError)((0,d.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(s,h)}finally{typeof a=="number"&&await this.close(a)}}async open(s,i){let r;(0,g.isFileOpenForWriteOptions)(i)&&(r=await this.createResourceLock(s));let a;try{const h=this.toFilePath(s);if((0,g.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:R}=await t.SymlinkSupport.stat(h);R.mode&128||await t.Promises.chmod(h,R.mode|128)}catch(R){this.logService.trace(R)}let E;if((0,g.isFileOpenForWriteOptions)(i)){if(P.isWindows)try{await t.Promises.truncate(h,0),E="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}E||(E="w")}else E="r";a=await t.Promises.open(h,E)}catch(h){throw r?.dispose(),(0,g.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}return this.mapHandleToPos.set(a,0),(0,g.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,s),r&&this.mapHandleToLock.set(a,r),a}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await t.Promises.fdatasync(s)}catch(i){this.canFlush=!1,this.logService.error(i)}return await t.Promises.close(s)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(s);i&&(this.mapHandleToLock.delete(s),i.dispose())}}async read(s,i,r,a,h){const E=this.normalizePos(s,i);let R=null;try{const{bytesRead:L}=await t.Promises.read(s,r,a,h,E);return L}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(s,E,R)}}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,r){const a=this.mapHandleToPos.get(s);typeof a=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,a+r):this.mapHandleToPos.delete(s)))}async write(s,i,r,a,h){return(0,D.retry)(()=>this.doWrite(s,i,r,a,h),100,3)}async doWrite(s,i,r,a,h){const E=this.normalizePos(s,i);let R=null;try{const{bytesWritten:L}=await t.Promises.write(s,r,a,h,E);return L}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),L)}finally{this.updatePos(s,E,R)}}async mkdir(s){try{await t.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const r=this.toFilePath(s);i.recursive?await t.Promises.rm(r,t.RimRafMode.MOVE):await t.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,i,r){const a=this.toFilePath(s),h=this.toFilePath(i);if(a!==h)try{await this.validateTargetDeleted(s,i,"move",r.overwrite),await t.Promises.move(a,h)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,d.localize)(2,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(h)),E.toString()))),this.toFileSystemProviderError(E)}}async copy(s,i,r){const a=this.toFilePath(s),h=this.toFilePath(i);if(a!==h)try{await this.validateTargetDeleted(s,i,"copy",r.overwrite),await t.Promises.copy(a,h,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,d.localize)(3,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(h)),E.toString()))),this.toFileSystemProviderError(E)}}async validateTargetDeleted(s,i,r,a){const h=this.toFilePath(s),E=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,f.isEqual)(h,E,!0)),R&&r==="copy")throw(0,g.createFileSystemProviderError)((0,d.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(!R&&await t.Promises.exists(E)){if(!a)throw(0,g.createFileSystemProviderError)((0,d.localize)(5,null),g.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createUniversalWatcher(s,i,r){return new w.UniversalWatcherClient(a=>s(a),a=>i(a),r)}createNonRecursiveWatcher(s,i,r){return new c.NodeJSWatcherClient(a=>s(a),a=>i(a),r)}toFileSystemProviderError(s){if(s instanceof g.FileSystemProviderError)return s;let i;switch(s.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(s,i){let r=this.toFileSystemProviderError(i);if(s&&r.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await t.SymlinkSupport.stat(this.toFilePath(s));a.mode&128||(r=(0,g.createFileSystemProviderError)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}e.DiskFileSystemProvider=o}),define(J[186],Z([0,1,4,77,2,17,48,23]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends D.Disposable{constructor(P,S){super();this.provider=P,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(P,S,m){const t=this.getUriTransformer(P);switch(S){case"stat":return this.stat(t,m[0]);case"readdir":return this.readdir(t,m[0]);case"open":return this.open(t,m[0],m[1]);case"close":return this.close(m[0]);case"read":return this.read(m[0],m[1],m[2]);case"readFile":return this.readFile(t,m[0],m[1]);case"write":return this.write(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.writeFile(t,m[0],m[1],m[2]);case"rename":return this.rename(t,m[0],m[1],m[2]);case"copy":return this.copy(t,m[0],m[1],m[2]);case"mkdir":return this.mkdir(t,m[0]);case"delete":return this.delete(t,m[0],m[1]);case"watch":return this.watch(t,m[0],m[1],m[2],m[3]);case"unwatch":return this.unwatch(m[0],m[1])}throw new Error(`IPC Command ${S} not found`)}listen(P,S,m){const t=this.getUriTransformer(P);switch(S){case"fileChange":return this.onFileChange(t,m[0]);case"readFileStream":return this.onReadFileStream(t,m[0],m[1])}throw new Error(`Unknown event ${S}`)}stat(P,S){const m=this.transformIncoming(P,S,!0);return this.provider.stat(m)}readdir(P,S){const m=this.transformIncoming(P,S);return this.provider.readdir(m)}async readFile(P,S,m){const t=this.transformIncoming(P,S,!0),d=await this.provider.readFile(t,m);return C.VSBuffer.wrap(d)}onReadFileStream(P,S,m){const t=this.transformIncoming(P,S,!0),d=new I.CancellationTokenSource,g=new p.Emitter({onLastListenerRemove:()=>{d.cancel()}}),v=this.provider.readFileStream(t,m,d.token);return(0,M.listenStream)(v,{onData:k=>g.fire(C.VSBuffer.wrap(k)),onError:k=>g.fire(k),onEnd:()=>{g.fire("end"),g.dispose(),d.dispose()}}),g.event}writeFile(P,S,m,t){const d=this.transformIncoming(P,S);return this.provider.writeFile(d,m.buffer,t)}open(P,S,m){const t=this.transformIncoming(P,S,!0);return this.provider.open(t,m)}close(P){return this.provider.close(P)}async read(P,S,m){const t=C.VSBuffer.alloc(m),d=0,g=await this.provider.read(P,S,t.buffer,d,m);return[t,g]}write(P,S,m,t,d){return this.provider.write(P,S,m.buffer,t,d)}mkdir(P,S){const m=this.transformIncoming(P,S);return this.provider.mkdir(m)}delete(P,S,m){const t=this.transformIncoming(P,S);return this.provider.delete(t,m)}rename(P,S,m,t){const d=this.transformIncoming(P,S),g=this.transformIncoming(P,m);return this.provider.rename(d,g,t)}copy(P,S,m,t){const d=this.transformIncoming(P,S),g=this.transformIncoming(P,m);return this.provider.copy(d,g,t)}onFileChange(P,S){const m=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(P,m))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return m.event}async watch(P,S,m,t,d){const g=this.sessionToWatcher.get(S);if(g){const v=this.transformIncoming(P,t),k=g.watch(m,v,d);this.watchRequests.set(S+m,k)}}async unwatch(P,S){const m=P+S,t=this.watchRequests.get(m);t&&((0,D.dispose)(t),this.watchRequests.delete(m))}dispose(){super.dispose();for(const[,P]of this.watchRequests)P.dispose();this.watchRequests.clear();for(const[,P]of this.sessionToWatcher)P.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class y extends D.Disposable{constructor(P,S,m,t){super();this.uriTransformer=P,this.logService=m,this.environmentService=t,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(P){const S=this._register(new p.Emitter);this._register(S.event(m=>{P.fire(m.map(t=>({resource:this.uriTransformer.transformOutgoingURI(t.resource),type:t.type})))})),this._register(this.fileWatcher.onDidChangeFile(m=>S.fire(m))),this._register(this.fileWatcher.onDidWatchError(m=>P.fire(m)))}getRecursiveWatcherOptions(P){}getExtraExcludes(P){}watch(P,S,m){const t=this.getExtraExcludes(this.environmentService);return Array.isArray(t)&&(m.excludes=[...m.excludes,...t]),this.watcherRequests.set(P,this.fileWatcher.watch(S,m)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(P)),this.watcherRequests.delete(P)})}dispose(){super.dispose();for(const[,P]of this.watcherRequests)P.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=y}),define(J[187],Z([0,1,12,147,3,7,18,9,186,115]),function(V,e,p,n,D,C,M,I,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends f.AbstractDiskFileSystemProviderChannel{constructor(m,t,d){super(m,t);this.environmentService=d}getUriTransformer(m){return y.DefaultURITransformer}transformIncoming(m,t){return C.URI.revive(t)}async delete(m,t,d){if(!d.useTrash)return super.delete(m,t,d);const g=this.transformIncoming(m,t),v=(0,I.normalize)(g.fsPath);try{await p.shell.trashItem(v)}catch{throw(0,M.createFileSystemProviderError)(D.isWindows?(0,n.localize)(0,null,(0,I.basename)(v)):(0,n.localize)(1,null,(0,I.basename)(v)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(m,t){return new P(m,t,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=b;class P extends f.AbstractSessionFileWatcher{watch(m,t,d){if(d.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(m,t,d)}}}),define(J[95],Z([0,1,6]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(C,M){switch(M){case p.LogLevel.Trace:return C.trace;case p.LogLevel.Debug:return C.debug;case p.LogLevel.Info:return C.info;case p.LogLevel.Warning:return C.warn;case p.LogLevel.Error:return C.error;case p.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class D extends p.AbstractLogger{constructor(M=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(M){this._logger=M;for(const{level:I,args:f}of this.buffer)n(M,I).apply(M,f);this.buffer=[]}_log(M,...I){this._logger?n(this._logger,M).apply(this._logger,I):this.getLevel()<=M&&this.buffer.push({level:M,args:I})}trace(M,...I){this._log(p.LogLevel.Trace,M,...I)}debug(M,...I){this._log(p.LogLevel.Debug,M,...I)}info(M,...I){this._log(p.LogLevel.Info,M,...I)}warn(M,...I){this._log(p.LogLevel.Warning,M,...I)}error(M,...I){this._log(p.LogLevel.Error,M,...I)}critical(M,...I){this._log(p.LogLevel.Critical,M,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(J[188],Z([0,1,8,17,16,18,5,95,6]),function(V,e,p,n,D,C,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*C.ByteSize.MB;let b=class extends f.AbstractLogger{constructor(m,t,d,g,v){super();this.name=m,this.resource=t,this.donotUseFormatters=g,this.fileService=v,this.backupIndex=1,this.setLevel(d),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,(0,f.format)(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,(0,f.format)(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,(0,f.format)(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,(0,f.format)(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const m=arguments[0];if(m instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=m.stack,this._log(f.LogLevel.Error,(0,f.format)(t))}else this._log(f.LogLevel.Error,(0,f.format)(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,(0,f.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(m){if(m.fileOperationResult!==3)throw m}}_log(m,t){this.queue.queue(async()=>{await this.initializePromise;let d=await this.loadContent();d.length>y&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(d)),d=""),this.donotUseFormatters?d+=t:d+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(m)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(d))})}getCurrentTimestamp(){const m=g=>g<10?`0${g}`:g,t=g=>g<10?`00${g}`:g<100?`0${g}`:g,d=new Date;return`${d.getFullYear()}-${m(d.getMonth()+1)}-${m(d.getDate())} ${m(d.getHours())}:${m(d.getMinutes())}:${m(d.getSeconds())}.${t(d.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(m){switch(m){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}};b=ue([ie(4,C.IFileService)],b),e.FileLogger=b;let P=class extends f.AbstractLoggerService{constructor(m,t,d){super(m.getLevel(),m.onDidChangeLogLevel);this.instantiationService=t,this.fileService=d}doCreateLogger(m,t,d){const g=new I.BufferLogService(t);return(0,C.whenProviderRegistered)(m,this.fileService).then(()=>g.logger=this.instantiationService.createInstance(b,d?.name||(0,D.basename)(m),m,g.getLevel(),!!d?.donotUseFormatters)),g}};P=ue([ie(0,f.ILogService),ie(1,M.IInstantiationService),ie(2,C.IFileService)],P),e.FileLoggerService=P}),define(J[189],Z([0,1,4,7,6]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(S){this.service=S,this.onDidChangeLogLevel=p.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(S,m,t){switch(m){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=C;class M{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){M.setLevel(this.channel,S)}static setLevel(S,m){return S.call("setLevel",m)}}e.LogLevelChannelClient=M;class I{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,m){throw new Error(`Event not found: ${m}`)}async call(S,m,t){switch(m){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${m}`)}createLogger(S,m){this.loggers.set(S.toString(),this.loggerService.createLogger(S,m))}consoleLog(S,m){let t=console.log;switch(S){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...m)}log(S,m){const t=this.loggers.get(S.toString());if(!t)throw new Error("Create the logger before logging");for(const[d,g]of m)(0,D.log)(t,d,g)}}e.LoggerChannel=I;class f extends D.AbstractLoggerService{constructor(S,m,t){super(S,m);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(S,m)=>{this.channel.call("consoleLog",[S,m])}})}doCreateLogger(S,m,t){return new y(this.channel,S,m,t)}}e.LoggerChannelClient=f;class y extends D.AbstractMessageLogger{constructor(S,m,t,d){super(d?.always);this.channel=S,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[m,d]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,m){const t=[[S,m]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(S){this.channel.call("log",[this.file,S])}}class b extends D.LogService{constructor(S,m){super(m);this.parent=S,this._register(S.onDidChangeLogLevel(t=>m.setLevel(t)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=b}),define(J[96],Z([0,1,18,6]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(I,f,y,b,P){try{const S=await new Promise((t,d)=>{V(["spdlog"],t,d)});S.setFlushOn(n.LogLevel.Trace);const m=await S.createAsyncRotatingLogger(I,f,y,b);return P&&m.clearFormatters(),m}catch(S){console.error(S)}return null}function C(I,f,y){switch(f){case n.LogLevel.Trace:I.trace(y);break;case n.LogLevel.Debug:I.debug(y);break;case n.LogLevel.Info:I.info(y);break;case n.LogLevel.Warning:I.warn(y);break;case n.LogLevel.Error:I.error(y);break;case n.LogLevel.Critical:I.critical(y);break;default:throw new Error("Invalid log level")}}class M extends n.AbstractMessageLogger{constructor(f,y,b,P,S){super();this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(f,y,b,P),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}async _createSpdLogLogger(f,y,b,P){const S=b?6:1,m=30/S*p.ByteSize.MB,t=await D(f,y,m,S,P);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:d,message:g}of this.buffer)C(this._logger,d,g);this.buffer=[]}}log(f,y){this._logger?C(this._logger,f,y):this.getLevel()<=f&&this.buffer.push({level:f,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(J[190],Z([0,1,10,16,31,18,188,6,96]),function(V,e,p,n,D,C,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends I.AbstractLoggerService{constructor(P,S){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=S}doCreateLogger(P,S,m){return P.scheme===p.Schemas.file?new f.SpdLogLogger(m?.name||(0,D.generateUuid)(),P.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,S):new M.FileLogger(m?.name??(0,n.basename)(P),P,S,!!m?.donotUseFormatters,this.fileService)}};y=ue([ie(0,I.ILogService),ie(1,C.IFileService)],y),e.LoggerService=y}),define(J[191],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function n(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function D(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function C(M){return!p(M)&&!n(M)&&!D(M)}e.isMenubarMenuItemAction=C}),define(J[53],Z([0,1,10,3,36,16]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const I=n.globals.vscode.context.configuration();if(I)M=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const I=(0,C.dirname)(p.FileAccess.asFileUri("",V));M=V.__$__nodeRequire((0,C.joinPath)(I,"product.json").fsPath);const f=V.__$__nodeRequire((0,C.joinPath)(I,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:f.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=M}),define(J[21],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(J[192],Z([0,1,74,4,2,6,3,51,21]),function(V,e,p,n,D,C,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=void 0;let y=class mt extends D.Disposable{constructor(P,S,m,t){super();this.isRunningOnServer=P,this.logService=S,this.environmentMainService=m,this.productService=t,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getSecretStoragePrefix(){return`${this.productService.urlProtocol}${this.isRunningOnServer?"-server":""}`}async getPassword(P,S){const m=await this.withKeytar(),t=await m.getPassword(P,S);if(t)try{let{content:d,hasNextChunk:g}=JSON.parse(t);if(!d||!g)return t;let v=1;for(;g;){const k=await m.getPassword(P,`${S}-${v}`),u=JSON.parse(k);d+=u.content,g=u.hasNextChunk,v++}return d}catch{return t}return t}async setPassword(P,S,m){const t=await this.withKeytar(),d=3,g=async(v,k,u)=>{let w=0,c;for(;w<d;)try{await t.setPassword(v,k,u);return}catch(o){c=o,this.logService.warn("Error attempting to set a password: ",o),w++,await new Promise(l=>setTimeout(l,200))}throw c};if(M.isWindows&&m.length>mt.MAX_PASSWORD_LENGTH){let v=0,k=0,u=!0;for(;u;){const w=m.substring(v,v+mt.PASSWORD_CHUNK_SIZE);v+=mt.PASSWORD_CHUNK_SIZE,u=m.length-v>0;const c={content:w,hasNextChunk:u};await g(P,k?`${S}-${k}`:S,JSON.stringify(c)),k++}}else await g(P,S,m);this._onDidChangePassword.fire({service:P,account:S})}async deletePassword(P,S){const t=await(await this.withKeytar()).deletePassword(P,S);return t&&this._onDidChangePassword.fire({service:P,account:S}),t}async findPassword(P){return(await this.withKeytar()).findPassword(P)}async findCredentials(P){return(await this.withKeytar()).findCredentials(P)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new p.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((P,S)=>{V(["keytar"],P,S)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(P){this.logService.warn(`Switching to using in-memory credential store instead because Keytar failed to load: ${P.message}`),this._keytarCache=new p.InMemoryCredentialsProvider}return this._keytarCache}clear(){return this._keytarCache instanceof p.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};y.MAX_PASSWORD_LENGTH=2500,y.PASSWORD_CHUNK_SIZE=y.MAX_PASSWORD_LENGTH-100,y=ue([ie(1,C.ILogService),ie(2,I.INativeEnvironmentService),ie(3,f.IProductService)],y),e.CredentialsMainService=y}),define(J[193],Z([0,1,60,6,21]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(I,f){this.productService=I,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(f);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,b,P]=y;let S=this.trustedExtensionUrlPublicKeys.get(I);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[I],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...S])}const m=Buffer.from(decodeURIComponent(P),"base64");if(m.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const t=m.slice(0,6),d=m.readUIntBE(0,6),g=Date.now()-d;if(g<0||g>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const v=m.slice(6),k=p.createVerify("SHA256");k.write(t),k.write(Buffer.from(b)),k.end();for(let u=0;u<S.length;u++){let w=S[u];if(w!==null){if(typeof w=="string")try{w=p.createPublicKey({key:Buffer.from(w,"base64"),format:"der",type:"spki"}),S[u]=w}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${I}:`,c),S[u]=null;continue}if(k.verify(w,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};C=ue([ie(0,D.IProductService),ie(1,n.ILogService)],C),e.ExtensionUrlTrustService=C}),define(J[54],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(J[194],Z([0,1,12,2,35,10,3,16,7,31,51,6]),function(V,e,p,n,D,C,M,I,f,y,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let S=class extends n.Disposable{constructor(t,d){super();this.logService=d,this.validRoots=D.TernarySearchTree.forUris(()=>!M.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(t.appRoot)),this.addValidFileRoot(f.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(d,g)=>this.handleResourceRequest(d,g)),t.protocol.interceptFileProtocol(C.Schemas.file,(d,g)=>this.handleFileRequest(d,g)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?n.Disposable.None:(this.validRoots.set(t,!0),(0,n.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,d){const g=f.URI.parse(t.url);return this.logService.error(`Refused to load resource ${g.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),d({error:-3})}handleResourceRequest(t,d){const g=f.URI.parse(t.url),v=C.FileAccess.asFileUri(g);return this.validRoots.findSubstr(v)?d({path:v.fsPath}):this.validExtensions.has((0,I.extname)(v))?d({path:v.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),d({error:-3}))}createIPCObjectUrl(){let t;const d=f.URI.from({scheme:"vscode",path:(0,y.generateUuid)()}),g=d.toString(),v=async()=>t;return p.ipcMain.handle(g,v),this.logService.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:d,update:k=>t=k,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${g}.`),p.ipcMain.removeHandler(g)}}}};S=ue([ie(0,b.INativeEnvironmentService),ie(1,P.ILogService)],S),e.ProtocolMainService=S}),define(J[40],Z([0,1,104,14]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(M,I){p.ok(n.isString(M)),p.ok(n.isObject(I)),p.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,I)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new D}),define(J[195],Z([0,1,4,40]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class C{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,y){this.schemasById[D(f)]=y,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new C;n.Registry.add(e.Extensions.JSONContribution,M)}),define(J[55],Z([0,1,30,4,14,138,195,40]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(M.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,o=!0){this.registerConfigurations([c],o)}registerConfigurations(c,o=!0){const l=this.doRegisterConfigurations(c,o);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(c){const o=this.doDeregisterConfigurations(c);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:c,remove:o}){const l=[];l.push(...this.doDeregisterConfigurations(o)),l.push(...this.doRegisterConfigurations(c,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,p.distinct)(l)})}registerDefaultConfigurations(c){const o=[],l=[];for(const{overrides:s,source:i}of c)for(const r in s)if(o.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:a});const h={type:"object",default:a,description:C.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:D.isString(i)?void 0:i};l.push(...t(r)),this.configurationProperties[r]=h,this.defaultLanguageConfigurationOverridesNode.properties[r]=h}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:i});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const o=[];for(const{overrides:l,source:s}of c)for(const i in l){const r=this.configurationDefaultsOverrides.get(i),a=D.isString(s)?s:s?.id,h=D.isString(r?.source)?r?.source:r?.source?.id;if(a===h)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const E=this.configurationProperties[i];E&&(this.updatePropertyDefaultValue(i,E),this.updateSchema(i,E))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const o of c)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,o){const l=[];return c.forEach(s=>{l.push(...this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),l}doDeregisterConfigurations(c){const o=[],l=s=>{if(s.properties)for(const i in s.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i]);s.allOf&&s.allOf.forEach(i=>l(i))};for(const s of c){l(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(c,o=!0,l,s,i=3){i=D.isUndefinedOrNull(c.scope)?i:c.scope;let r=[],a=c.properties;if(a)for(let E in a){if(o&&k(E)){delete a[E];continue}const R=a[E];if(R.source=l,R.defaultDefaultValue=a[E].default,this.updatePropertyDefaultValue(E,R),e.OVERRIDE_PROPERTY_REGEX.test(E)?R.scope=void 0:(R.scope=D.isUndefinedOrNull(R.scope)?i:R.scope,R.restricted=D.isUndefinedOrNull(R.restricted)?!!s?.includes(E):R.restricted),a[E].hasOwnProperty("included")&&!a[E].included){this.excludedConfigurationProperties[E]=a[E],delete a[E];continue}else this.configurationProperties[E]=a[E];!a[E].deprecationMessage&&a[E].markdownDeprecationMessage&&(a[E].deprecationMessage=a[E].markdownDeprecationMessage),r.push(E)}let h=c.allOf;if(h)for(let E of h)r.push(...this.validateAndRegisterProperties(E,o,l,s,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const o=l=>{let s=l.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let i=l.allOf;i&&i.forEach(o)};o(c)}updateSchema(c,o){switch(e.allSettings.properties[c]=o,o.scope){case 1:e.applicationSettings.properties[c]=o;break;case 2:e.machineSettings.properties[c]=o;break;case 6:e.machineOverridableSettings.properties[c]=o;break;case 3:e.windowSettings.properties[c]=o;break;case 4:e.resourceSettings.properties[c]=o;break;case 5:e.resourceSettings.properties[c]=o,this.resourceLanguageSettingsSchema.properties[c]=o;break}}removeFromSchema(c,o){switch(delete e.allSettings.properties[c],o.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const o=`[${c}]`,l={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,l),e.allSettings.properties[o]=l,e.applicationSettings.properties[o]=l,e.machineSettings.properties[o]=l,e.machineOverridableSettings.properties[o]=l,e.windowSettings.properties[o]=l,e.resourceSettings.properties[o]=l}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,o){const l=this.configurationDefaultsOverrides.get(c);let s=l?.value,i=l?.source;D.isUndefined(s)&&(s=o.defaultDefaultValue,i=void 0),D.isUndefined(s)&&(s=g(o.type)),o.default=s,o.defaultValueSource=i}}const S="\\[([^\\]]+)\\]",m=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(w){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let o=m.exec(w);for(;o?.length;){const l=o[1].trim();l&&c.push(l),o=m.exec(w)}}return(0,p.distinct)(c)}e.overrideIdentifiersFromKey=t;function d(w){return w.reduce((c,o)=>`${c}[${o}]`,"")}e.keyFromOverrideIdentifiers=d;function g(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const v=new P;I.Registry.add(e.Extensions.Configuration,v);function k(w){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?C.localize(7,null,w):v.getConfigurationProperties()[w]!==void 0?C.localize(8,null,w):null:C.localize(6,null)}e.validateProperty=k;function u(){const w=[],c=v.getConfigurationProperties();for(const o of Object.keys(c))w.push([o,c[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=u}),define(J[196],Z([0,1,30,4,44,2,35,49,14,7,20,55,40]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(s={},i=[],r=[]){this._contents=s,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,b.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const r=this.getContentsForOverrideIdentifer(i);return r?s?(0,b.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const r of this.overrides)r.identifiers.includes(s)&&i.push(...r.keys);return p.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return p.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=I.deepClone(this.contents),r=I.deepClone(this.overrides),a=[...this.keys];for(const h of s){this.mergeContents(i,h.contents);for(const E of h.overrides){const[R]=r.filter(L=>p.equals(L.identifiers,E.identifiers));R?(this.mergeContents(R.contents,E.contents),R.keys.push(...E.keys),R.keys=p.distinct(R.keys)):r.push(I.deepClone(E))}for(const E of h.keys)a.indexOf(E)===-1&&a.push(E)}return new m(i,a,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const a of p.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[a],E=i[a];E&&(typeof h=="object"&&typeof E=="object"?(h=I.deepClone(h),this.mergeContents(h,E)):h=E),r[a]=h}return new m(r,this.keys,this.overrides)}mergeContents(s,i){for(const r of Object.keys(i)){if(r in s&&f.isObject(s[r])&&f.isObject(i[r])){this.mergeContents(s[r],i[r]);continue}s[r]=I.deepClone(i[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?I.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,r=null;const a=h=>{h&&(r?this.mergeContents(r,h):r=I.deepClone(h))};for(const h of this.overrides)p.equals(h.identifiers,[s])?i=h.contents:h.identifiers.includes(s)&&a(h.contents);return a(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,b.addToValueTree)(this.contents,s,i,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,b.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let r=0;r<i;r++)s.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class t extends m{constructor(s={}){const i=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),a=Object.create(null),h=[];for(const E in i){const R=s[E],L=R!==void 0?R:i[E].default;(0,b.addToValueTree)(a,E,L,W=>console.error(`Conflict in default settings: ${W}`))}for(const E of Object.keys(a))P.OVERRIDE_PROPERTY_REGEX.test(E)&&h.push({identifiers:(0,P.overrideIdentifiersFromKey)(E),keys:Object.keys(a[E]),contents:(0,b.toValuesTree)(a[E],R=>console.error(`Conflict in default settings file: ${R}`))});super(a,r,h)}}e.DefaultConfigurationModel=t;class d{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!f.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:r,keys:a,overrides:h,restricted:E}=this.doParseRaw(s,i);this._configurationModel=new m(r,a,h),this._restrictedConfigurations=E||[]}doParseContent(s){let i={},r=null,a=[],h=[],E=[];function R(W){Array.isArray(a)?a.push(W):r!==null&&(a[r]=W)}let L={onObjectBegin:()=>{let W={};R(W),h.push(a),a=W,r=null},onObjectProperty:W=>{r=W},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{let W=[];R(W),h.push(a),a=W,r=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:R,onError:(W,$,Q)=>{E.push({error:W,offset:$,length:Q})}};if(s)try{D.visit(s,L),i=a[0]||{}}catch(W){console.error(`Error while parsing settings file ${this._name}: ${W}`),this._parseErrors=[W]}return i}doParseRaw(s,i){const r=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),a=this.filter(s,r,!0,i);s=a.raw;const h=(0,b.toValuesTree)(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),E=Object.keys(s),R=this.toOverrides(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:h,keys:E,overrides:R,restricted:a.restricted}}filter(s,i,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:s,restricted:[]};const h={},E=[];for(let R in s)if(P.OVERRIDE_PROPERTY_REGEX.test(R)&&r){const L=this.filter(s[R],i,!1,a);h[R]=L.raw,E.push(...L.restricted)}else{const L=i[R],W=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&E.push(R),(W===void 0||a.scopes===void 0||a.scopes.includes(W))&&(a.skipRestricted&&L?.restricted||(h[R]=s[R]))}return{raw:h,restricted:E}}toOverrides(s,i){const r=[];for(const a of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(a)){const h={};for(const E in s[a])h[E]=s[a][E];r.push({identifiers:(0,P.overrideIdentifiersFromKey)(a),keys:Object.keys(h),contents:(0,b.toValuesTree)(h,i)})}return r}}e.ConfigurationModelParser=d;class g extends C.Disposable{constructor(s,i,r,a){super();this.userSettingsResource=s,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class v{constructor(s,i,r=new m,a=new m,h=new M.ResourceMap,E=new m,R=new M.ResourceMap,L=!0){this._defaultConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=E,this._memoryConfigurationByResource=R,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(s,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(s)}updateValue(s,i,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new m,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(s):a.setValue(s,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,r){const a=this.getConsolidateConfigurationModel(i,r),h=this.getFolderConfigurationModelForResource(i.resource,r),E=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,R=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),$=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),Q=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,ee=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(s):h.freeze().getValue(s):void 0,x=i.overrideIdentifier?E.override(i.overrideIdentifier).getValue(s):E.getValue(s),q=a.getValue(s),X=p.distinct(p.flatten(a.overrides.map(H=>H.identifiers))).filter(H=>a.getOverrideValue(s,H)!==void 0);return{defaultValue:R,userValue:L,userLocalValue:W,userRemoteValue:$,workspaceValue:Q,workspaceFolderValue:ee,memoryValue:x,value:q,default:R!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:$!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ee!==void 0?{value:h?.freeze().getValue(s),override:i.overrideIdentifier?h?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:E.getValue(s),override:i.overrideIdentifier?E.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:X.length?X:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const r=[];if(!i){const{added:a,updated:h,removed:E}=c(this._defaultConfiguration,s);i=[...a,...h,...E]}for(const a of i)for(const h of(0,P.overrideIdentifiersFromKey)(a)){const E=this._defaultConfiguration.getKeysForOverrideIdentifier(h),R=s.getKeysForOverrideIdentifier(h),L=[...R.filter(W=>E.indexOf(W)===-1),...E.filter(W=>R.indexOf(W)===-1),...E.filter(W=>!I.equals(this._defaultConfiguration.override(h).getValue(W),s.override(h).getValue(W)))];r.push([h,L])}return this.updateDefaultConfiguration(s),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.localUserConfiguration,s),E=[...i,...r,...a];return E.length&&this.updateLocalUserConfiguration(s),{keys:E,overrides:h}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.remoteUserConfiguration,s);let E=[...i,...r,...a];return E.length&&this.updateRemoteUserConfiguration(s),{keys:E,overrides:h}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:r,removed:a,overrides:h}=c(this.workspaceConfiguration,s);let E=[...i,...r,...a];return E.length&&this.updateWorkspaceConfiguration(s),{keys:E,overrides:h}}compareAndUpdateFolderConfiguration(s,i){const r=this.folderConfigurations.get(s),{added:a,updated:h,removed:E,overrides:R}=c(r,i);let L=[...a,...h,...E];return(L.length||!r)&&this.updateFolderConfiguration(s,i),{keys:L,overrides:R}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:a,removed:h,overrides:E}=c(i,void 0);return{keys:[...r,...a,...h],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const a=i.getFolder(s);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const h=this._memoryConfigurationByResource.get(s);h&&(r=r.merge(h))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(s);a?(i=r.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=r}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const r=i.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:r,overrides:a,keys:h}=this._folderConfigurations.get(i);return s.push([i,{contents:r,overrides:a,keys:h}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),a=this.parseConfigurationModel(s.workspace),h=s.folders.reduce((E,R)=>(E.set(y.URI.revive(R[0]),this.parseConfigurationModel(R[1])),E),new M.ResourceMap);return new v(i,r,new m,a,h,new m,new M.ResourceMap,!1)}static parseConfigurationModel(s){return new m(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=v;function k(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,i=new Map;for(const a of l)a.keys.forEach(h=>s.add(h)),a.overrides.forEach(([h,E])=>{const R=(0,M.getOrSet)(i,h,new Set);E.forEach(L=>R.add(L))});const r=[];return i.forEach((a,h)=>r.push([h,[...a.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=k;class u{constructor(s,i,r,a){this.change=s,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const h=new Set;s.keys.forEach(R=>h.add(R)),s.overrides.forEach(([,R])=>R.forEach(L=>h.add(L))),this.affectedKeys=[...h.values()];const E=new m;this.affectedKeys.forEach(R=>E.setValue(R,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!I.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let r=(0,b.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(s=s[a],!s)return!1;r=r[a]}return!0}}e.ConfigurationChangeEvent=u;class w extends u{constructor(s,i,r,a){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=r,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=w;function c(l,s){const{added:i,removed:r,updated:a}=o(s,l),h=[],E=l?.getAllOverrideIdentifiers()||[],R=s?.getAllOverrideIdentifiers()||[];if(s){const L=R.filter(W=>!E.includes(W));for(const W of L)h.push([W,s.getKeysForOverrideIdentifier(W)])}if(l){const L=E.filter(W=>!R.includes(W));for(const W of L)h.push([W,l.getKeysForOverrideIdentifier(W)])}if(s&&l){for(const L of E)if(R.includes(L)){const W=o({contents:l.getOverrideValue(void 0,L)||{},keys:l.getKeysForOverrideIdentifier(L)},{contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)});h.push([L,[...W.added,...W.removed,...W.updated]])}}return{added:i,removed:r,updated:a,overrides:h}}function o(l,s){const i=l?s?l.keys.filter(h=>s.keys.indexOf(h)===-1):[...l.keys]:[],r=s?l?s.keys.filter(h=>l.keys.indexOf(h)===-1):[...s.keys]:[],a=[];if(l&&s){for(const h of s.keys)if(l.keys.indexOf(h)!==-1){const E=(0,b.getConfigurationValue)(s.contents,h),R=(0,b.getConfigurationValue)(l.contents,h);I.equals(E,R)||a.push(h)}}return{added:i,removed:r,updated:a}}}),define(J[197],Z([0,1,8,4,2,16,20,196,55,40]),function(V,e,p,n,D,C,M,I,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends D.Disposable{constructor(S,m){super();this.settingsResource=S,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,m)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const S=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,S)}getConfigurationData(){return this.configuration.toData()}getValue(S,m){const t=typeof S=="string"?S:void 0,d=(0,M.isConfigurationOverrides)(S)?S:(0,M.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(t,d,void 0)}updateValue(S,m,t,d){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const m=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(t,m,1)}onDidDefaultConfigurationChange(S){const m=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,S);this.trigger(t,m,6)}trigger(S,m,t){const d=new I.ConfigurationChangeEvent(S,{data:m},this.configuration);d.source=t,d.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(S){switch(S){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(J[198],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var n;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(M,I=n.Unknown,f){super(M);this._message=M,this._code=I,this._detail=f,this.isHandled=I===n.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(M){return M instanceof D&&M._code===n.TemporarilyNotAvailable}static isNoResolverFound(M){return M instanceof D&&M._code===n.NoResolverFound}static isHandled(M){return M instanceof D&&M.isHandled}}e.RemoteAuthorityResolverError=D}),define(J[199],Z([0,1,8,17,23,15,4,2,31,87,198]),function(V,e,p,n,D,C,M,I,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const P=30*1e3;var S;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function m(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(B){const T=new D.CancellationTokenSource;return setTimeout(()=>T.cancel(),B),T.token}function d(B,T){if(B.isCancellationRequested||T.isCancellationRequested)return D.CancellationToken.Cancelled;const _=new D.CancellationTokenSource;return B.onCancellationRequested(()=>_.cancel()),T.onCancellationRequested(()=>_.cancel()),_.token}class g{constructor(T){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((_,F)=>{this._resolvePromise=_,this._rejectPromise=F}),T.isCancellationRequested?this._timeout():this._disposables.add(T.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(T){this._state==="pending"?this._disposables.add(T):T.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const T=new Error("Time limit reached");return T.code="ETIMEDOUT",T.syscall="connect",T}resolve(T){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(T))}reject(T){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(T))}}function v(B,T){const _=new g(T);return _.registerDisposable(B.onControlMessage(F=>{const A=JSON.parse(F.toString()),O=j(A);O?_.reject(O):_.resolve(A)})),_.promise}function k(B,T,_,F,A,O,U){const G=new g(U);return T.connect(_,F,A,O,(ne,ce)=>{G.didTimeout?(ne&&B.error(ne),ce?.dispose()):ne||!ce?G.reject(ne):G.resolve(ce)}),G.promise}function u(B,T){const _=new g(T);return B.then(F=>{_.didTimeout||_.resolve(F)},F=>{_.didTimeout||_.reject(F)}),_.promise}async function w(B,T,_,F){const A=z(B,T);B.logService.trace(`${A} 1/6. invoking socketFactory.connect().`);let O;try{O=await k(B.logService,B.socketFactory,B.host,B.port,`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${m(T)}-${B.reconnectionToken}`,F)}catch(ae){throw B.logService.error(`${A} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ae),ae}B.logService.trace(`${A} 2/6. socketFactory.connect() was successful.`);let U,G;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(O,null),U=B.reconnectionProtocol,G=!1):(U=new y.PersistentProtocol(O,null),G=!0),B.logService.trace(`${A} 3/6. sending AuthRequest control message.`);const ne=await u(B.signService.createNewMessage((0,f.generateUuid)()),F),ce={type:"auth",auth:B.connectionToken||"00000000000000000000",data:ne.data};U.sendControl(n.VSBuffer.fromString(JSON.stringify(ce)));try{const ae=await v(U,d(F,t(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if(B.logService.trace(`${A} 4/6. received SignRequest control message.`),!await u(B.signService.validate(ne,ae.signedData),F)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const le=await u(B.signService.sign(ae.data),F),he={type:"connectionType",commit:B.commit,signedData:le,desiredConnectionType:T};return _&&(he.args=_),B.logService.trace(`${A} 5/6. sending ConnectionTypeRequest control message.`),U.sendControl(n.VSBuffer.fromString(JSON.stringify(he))),{protocol:U,ownsProtocol:G}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(B.logService.error(`${A} the handshake timed out. Error:`),B.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${A} received error control message when negotiating connection. Error:`),B.logService.error(ae)),G&&H(U),ae}}async function c(B,T,_,F){const A=Date.now(),O=z(B,T),{protocol:U,ownsProtocol:G}=await w(B,T,_,F),ne=new g(F);return ne.registerDisposable(U.onControlMessage(ce=>{const ae=JSON.parse(ce.toString()),re=j(ae);re?(B.logService.error(`${O} received error control message when negotiating connection. Error:`),B.logService.error(re),G&&H(U),ne.reject(re)):(B.reconnectionProtocol&&B.reconnectionProtocol.endAcceptReconnection(),B.logService.trace(`${O} 6/6. handshake finished, connection is up and running after ${K(A)}!`),ne.resolve({protocol:U,firstMessage:ae}))})),ne.promise}async function o(B,T){const{protocol:_}=await c(B,1,void 0,T);return{protocol:_}}async function l(B,T,_){const{protocol:F,firstMessage:A}=await c(B,2,T,_),O=A&&A.debugPort;return{protocol:F,debugPort:O}}async function s(B,T,_){const F=Date.now(),A=z(B,3),{protocol:O}=await w(B,3,T,_);return B.logService.trace(`${A} 6/6. handshake finished, connection is up and running after ${K(F)}!`),O}async function i(B,T,_){const{host:F,port:A,connectionToken:O}=await B.addressProvider.getAddress();return{commit:B.commit,host:F,port:A,connectionToken:O,reconnectionToken:T,reconnectionProtocol:_,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function r(B,T,_){try{const F=(0,f.generateUuid)(),A=await i(B,F,null),{protocol:O}=await o(A,D.CancellationToken.None);return new q(B,T,_,F,O)}catch(F){throw B.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),B.logService.error(F),x.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentManagement=r;async function a(B,T){try{const _=(0,f.generateUuid)(),F=await i(B,_,null),{protocol:A,debugPort:O}=await l(F,T,D.CancellationToken.None);return new X(B,T,_,A,O)}catch(_){throw B.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),B.logService.error(_),x.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=a;async function h(B,T,_){const F=await i(B,(0,f.generateUuid)(),null);return await s(F,{host:T,port:_},D.CancellationToken.None)}e.connectRemoteAgentTunnel=h;function E(B){return(0,p.createCancelablePromise)(T=>new Promise((_,F)=>{const A=setTimeout(_,B*1e3);T.onCancellationRequested(()=>{clearTimeout(A),_()})}))}var R;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class L{constructor(T,_){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=L;class W{constructor(T,_,F,A){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.durationSeconds=F,this.cancellableTimer=A,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class ${constructor(T,_,F){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=$;class Q{constructor(T,_,F){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=F,this.type=4}}e.ConnectionGainEvent=Q;class ee{constructor(T,_,F,A){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=F,this.handled=A,this.type=3}}e.ReconnectionPermanentFailureEvent=ee;class x extends I.Disposable{constructor(T,_,F,A){super();this._connectionType=T,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=F,this.protocol=A,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(A.onSocketClose(O=>{const U=N(this._connectionType,this.reconnectionToken,!0);O?O.type===0?(this._options.logService.info(`${U} received socket close event (hadError: ${O.hadError}).`),O.error&&this._options.logService.error(O.error)):(this._options.logService.info(`${U} received socket close event (wasClean: ${O.wasClean}, code: ${O.code}, reason: ${O.reason}).`),O.event&&this._options.logService.error(O.event)):this._options.logService.info(`${U} received socket close event.`),this._beginReconnecting()})),this._register(A.onSocketTimeout(()=>{const O=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} received socket timeout event.`),this._beginReconnecting()})),x._instances.push(this),x._permanentFailure&&this._gotoPermanentFailure(x._permanentFailureMillisSinceLastIncomingData,x._permanentFailureAttempt,x._permanentFailureHandled)}static triggerPermanentFailure(T,_,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=T,this._permanentFailureAttempt=_,this._permanentFailureHandled=F,this._instances.forEach(A=>A._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(T=>T._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(T=>T._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(x._permanentFailure)return;const T=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${T} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const A=F<_.length?_[F]:_[_.length-1];try{if(A>0){const U=E(A);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A,U)),this._options.logService.info(`${T} waiting for ${A} seconds before reconnecting...`);try{await U}catch{}}if(x._permanentFailure){this._options.logService.error(`${T} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${T} resolving connection...`);const O=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${T} connecting to ${O.host}:${O.port}...`),await this._reconnect(O,t(P)),this._options.logService.info(`${T} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(O){if(O.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${T} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(O),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${T} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(O),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(O)){this._options.logService.info(`${T} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((O.code==="ETIMEDOUT"||O.code==="ENETUNREACH"||O.code==="ECONNREFUSED"||O.code==="ECONNRESET")&&O.syscall==="connect"){this._options.logService.info(`${T} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((0,C.isCancellationError)(O)){this._options.logService.info(`${T} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if(O instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${T} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(O),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,b.RemoteAuthorityResolverError.isHandled(O));break}this._options.logService.error(`${T} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(O),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!x._permanentFailure)}_gotoPermanentFailure(T,_,F){this._onDidStateChange.fire(new ee(this.reconnectionToken,T,_,F)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=x,x._permanentFailure=!1,x._permanentFailureMillisSinceLastIncomingData=0,x._permanentFailureAttempt=0,x._permanentFailureHandled=!1,x._instances=[];class q extends x{constructor(T,_,F,A,O){super(1,T,A,O);this.client=this._register(new y.Client(O,{remoteAuthority:_,clientId:F},T.ipcLogger))}async _reconnect(T,_){await o(T,_)}}e.ManagementPersistentConnection=q;class X extends x{constructor(T,_,F,A,O){super(2,T,F,A);this._startArguments=_,this.debugPort=O}async _reconnect(T,_){await l(T,this._startArguments,_)}}e.ExtensionHostPersistentConnection=X;function H(B){try{B.acceptDisconnect();const T=B.getSocket();B.dispose(),T.dispose()}catch(T){(0,C.onUnexpectedError)(T)}}function j(B){if(B&&B.type==="error"){const T=new Error(`Connection error: ${B.reason}`);return T.code="VSCODE_CONNECTION_ERROR",T}return null}function te(B,T){for(;B.length<T;)B+=" ";return B}function N(B,T,_){return`[remote-connection][${te(m(B),13)}][${T.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function z(B,T){return`${N(T,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function K(B){return`${Date.now()-B} ms`}}),define(J[78],Z([0,1,10]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(C){return C.scheme===p.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=n;function D(C){if(!C)return;const M=C.indexOf("+");return M<0?C:C.substr(0,M)}e.getRemoteName=D}),define(J[56],Z([0,1,17,152,55,5,40]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function f(t){return t.res.statusCode===204}async function y(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return f(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=y;async function b(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(f(t))return null;const g=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(g)}catch(v){throw v.message+=`:
`+g,v}}e.asJson=b;function P(t){m(t)}e.updateProxyConfigurationsScope=P;let S;function m(t){const d=M.Registry.as(D.Extensions.Configuration),g=S;S={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[S],remove:g?[g]:[]})}m(2)}),define(J[200],Z([0,1,201,14]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(M,I){return M.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:M.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function C(M,I,f={}){const y=(0,p.parse)(M),b=f.proxyUrl||D(y,I);if(!b)return null;const P=(0,p.parse)(b);if(!/^https?:$/.test(P.protocol||""))return null;const S={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,n.isBoolean)(f.strictSSL)?f.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((m,t)=>{V(["http-proxy-agent"],m,t)}))(S):new(await new Promise((m,t)=>{V(["https-proxy-agent"],m,t)}))(S)}e.getProxyAgent=C}),define(J[79],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[202],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>V(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),M=new C.validator;if(M){const I=String(p._nextId++);return this.validators.set(I,M),{id:I,data:M.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const M=this.validators.get(D.id);if(!M)return!1;this.validators.delete(D.id);try{return M.validate(C)==="ok"}catch{return!1}}async sign(D){try{const C=await this.vsda(),M=new C.signer;if(M)return M.sign(D)}catch{}return D}}e.SignService=p,p._nextId=1}),define(J[38],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(J[19],Z([0,1,12,8,4,2,3,36,14,5,183,6,38]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,y.createDecorator)("lifecycleMainService");var m;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen"})(m=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class wt extends C.Disposable{constructor(g,v){super();this.logService=g,this.stateMainService=v,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(wt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(wt.QUIT_AND_RESTART_KEY)}registerListeners(){const g=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),M.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};p.app.addListener("before-quit",g);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!M.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",k=>{this.logService.trace("Lifecycle#app.on(will-quit)"),k.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",g),p.app.removeListener("window-all-closed",v),p.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const g=[];return this._onWillShutdown.fire({join(v){g.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(g)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===g)return;this.logService.trace(`lifecycle (main): phase changed (value: ${g})`),this._phase=g;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(g){if(g<=this._phase)return;let v=this.phaseWhen.get(g);v||(v=new n.Barrier,this.phaseWhen.set(g,v)),await v.wait()}registerWindow(g){const v=new C.DisposableStore;this.windowCounter++,v.add(g.onWillLoad(u=>this._onWillLoadWindow.fire({window:g,workspace:u.workspace,reason:u.reason})));const k=(0,f.assertIsDefined)(g.win);k.on("close",u=>{const w=g.id;if(this.windowToCloseRequest.has(w)){this.windowToCloseRequest.delete(w);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${g.id}`),u.preventDefault(),this.unload(g,1).then(c=>{if(c){this.windowToCloseRequest.delete(w);return}this.windowToCloseRequest.add(w),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${w}`),this._onBeforeCloseWindow.fire(g),g.close()})}),k.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!M.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(g,v){await this.unload(g,3)||g.reload(v)}async unload(g,v){if(!g.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${g.id}`);const k=this._quitRequested?2:v;let u=await this.onBeforeUnloadWindowInRenderer(g,k);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.handleWindowUnloadVeto(u)):(u=await this.onBeforeUnloadWindowInMain(g,k),u?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${g.id})`),this.handleWindowUnloadVeto(u)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${g.id})`),await this.onWillUnloadWindowInRenderer(g,k),!1))}handleWindowUnloadVeto(g){return g?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(g){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(g),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(g,v){return new Promise(k=>{const u=this.oneTimeListenerTokenGenerator++,w=`vscode:ok${u}`,c=`vscode:cancel${u}`;p.ipcMain.once(w,()=>{k(!1)}),p.ipcMain.once(c,()=>{k(!0)}),g.send("vscode:onBeforeUnload",{okChannel:w,cancelChannel:c,reason:v})})}onBeforeUnloadWindowInMain(g,v){const k=[];return this._onBeforeUnloadWindow.fire({reason:v,window:g,veto(u){k.push(u)}}),(0,b.handleVetos)(k,u=>this.logService.error(u))}onWillUnloadWindowInRenderer(g,v){return new Promise(k=>{const w=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(w,()=>k()),g.send("vscode:onWillUnload",{replyChannel:w,reason:v})})}quit(g){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${g}`),g&&this.stateMainService.setItem(wt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(g){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(g?.addArgs&&v.push(...g.addArgs),g?.removeArgs)for(const w of g.removeArgs){const c=v.indexOf(w);c>=0&&v.splice(c,1)}const k=()=>{try{if(M.isWindows){const w=(0,I.cwd)();w!==process.cwd()&&process.chdir(w)}}catch(w){this.logService.error(w)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})};p.app.once("quit",k),await this.quit(!0)&&p.app.removeListener("quit",k)}async kill(g){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let k;v.webContents&&!v.webContents.isDestroyed()?k=new Promise(u=>v.once("closed",u)):k=Promise.resolve(),v.destroy(),await k}})()]),p.app.exit(g)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=ue([ie(0,P.ILogService),ie(1,S.IStateMainService)],t),e.LifecycleMainService=t}),define(J[203],Z([0,1,4,2,5,19]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let M=class extends n.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((b,P)=>{V(["native-keymap"],b,P)});this._keyboardLayoutData=I(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=ue([ie(0,C.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function I(f){const y=f.getKeyMap(),b=f.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:b}}}),define(J[97],Z([0,1,8,4,2,63,14,89,5]),function(V,e,p,n,D,C,M,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=(0,f.createDecorator)("storageService");var b;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var P;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(P=e.StorageScope||(e.StorageScope={}));var S;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));class m extends D.Disposable{constructor(v={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,k){k===y?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:k,target:this.getKeyTargets(v)[k]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,k,u){return this.getStorage(k)?.get(v,u)}getBoolean(v,k,u){return this.getStorage(k)?.getBoolean(v,u)}getNumber(v,k,u){return this.getStorage(k)?.getNumber(v,u)}store(v,k,u,w){if((0,M.isUndefinedOrNull)(k)){this.remove(v,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,u,w),this.getStorage(u)?.set(v,k)})}remove(v,k){this.withPausedEmitters(()=>{this.updateKeyTarget(v,k,void 0),this.getStorage(k)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,k){const u=[],w=this.getKeyTargets(v);for(const c of Object.keys(w))w[c]===k&&u.push(c);return u}updateKeyTarget(v,k,u){const w=this.getKeyTargets(k);typeof u=="number"?w[v]!==u&&(w[v]=u,this.getStorage(k)?.set(y,JSON.stringify(w))):typeof w[v]=="number"&&(delete w[v],this.getStorage(k)?.set(y,JSON.stringify(w)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const k=this.get(y,v);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=b.NONE){this._onWillSaveState.fire({reason:v});const k=this.getStorage(0),u=this.getStorage(1);switch(v){case b.NONE:await p.Promises.settled([k?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await p.Promises.settled([k?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,k=this.getStorage(1)?.items??new Map;return d(v,k,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends m{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function d(g,v,k,u){const w=a=>{try{return JSON.parse(a)}catch{return a}},c=new Map,o=new Map;g.forEach((a,h)=>{c.set(h,a),o.set(h,w(a))});const l=new Map,s=new Map;v.forEach((a,h)=>{l.set(h,a),s.set(h,w(a))}),console.group(`Storage: Global (path: ${k})`);let i=[];c.forEach((a,h)=>{i.push({key:h,value:a})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${u})`);let r=[];l.forEach((a,h)=>{r.push({key:h,value:a})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=d}),define(J[204],Z([0,1,3,36,7,31]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(y){if(p.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function I(y,b,P,S,m,t,d,g,v,k){const u=Object.create(null);u["common.machineId"]=d,u.sessionID=(0,C.generateUuid)()+Date.now(),u.commitHash=m,u.version=t,u["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,p.PlatformToString)(p.platform),u["common.nodePlatform"]=n.platform,u["common.nodeArch"]=S,u["common.product"]=k||"desktop";const w=f(g||[]);w&&(u["common.msftInternal"]=w);let c=0;const o=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),p.isLinuxSnap&&(u["common.snap"]="true");const l=M(P);l&&(u["common.platformDetail"]=l);try{const s=await y.readFile(D.URI.file(v));u["common.source"]=s.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=I;function f(y){const b=n.env.USERDNSDOMAIN;if(!b)return!1;const P=b.toLowerCase();return y.some(S=>P===S)}e.verifyMicrosoftInternalDomain=f}),define(J[32],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(J[205],Z([0,1,25,68,8,44,10,9,3,7,71,24,86,75,18,21,32]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(o,l){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],i=new Map,r=new Map,a=2e4;function h(L,W,$,Q){const ee=W.substring(L.length+1);return D.Promises.withAsyncBody(async x=>{let q;try{q=await P.Promises.readdir(W,{withFileTypes:!0})}catch{x();return}if(Q.count>=a){Q.count+=q.length,Q.maxReached=!0,x();return}let X=q.length;if(X===0){x();return}let H=q;Q.count+q.length>a&&(Q.maxReached=!0,X=a-Q.count,H=q.slice(0,X)),Q.count+=q.length;for(const j of H)if(j.isDirectory()){if($.includes(j.name)||await h(L,(0,I.join)(W,j.name),$,Q),--X==0){x();return}}else{const te=j.name.lastIndexOf(".");if(te>=0){const N=j.name.substring(te+1);N&&i.set(N,(i.get(N)??0)+1)}for(const N of s)N.relativePathPattern?.test(ee)!==!1&&N.filePattern.test(j.name)&&r.set(N.tag,(r.get(N.tag)??0)+1);if(--X==0){x();return}}})}const E={count:0,maxReached:!1};await h(o,o,l,E);const R=await w(o);return{configFiles:k(r),fileTypes:k(i),fileCount:E.count,maxFilesReached:E.maxReached,launchConfigFiles:R}}e.collectWorkspaceStats=v;function k(o){return[...n.Iterable.map(o.entries(),([l,s])=>({name:l,count:s}))].sort((l,s)=>s.count-l.count)}function u(){const o={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},l=p.cpus();return l&&l.length>0&&(o.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),o}e.getMachineInfo=u;async function w(o){try{const l=new Map,s=(0,I.join)(o,".vscode","launch.json"),i=await P.Promises.readFile(s),r=[],a=(0,C.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,C.getNodeType)(a)==="object"&&a.configurations)for(const h of a.configurations){const E=h.type;E&&(l.has(E)?l.set(E,l.get(E)+1):l.set(E,1))}return k(l)}catch{return[]}}e.collectLaunchConfigs=w;let c=class{constructor(l,s){this.telemetryService=l,this.productService=s}formatMachineInfo(l){const s=[];return s.push(`OS Version:       ${l.os}`),s.push(`CPUs:             ${l.cpus}`),s.push(`Memory (System):  ${l.memory}`),s.push(`VM:               ${l.vmHint}`),s.join(`
`)}formatEnvironment(l){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const i=p.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),f.isWindows||s.push(`Load (avg):       ${p.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${l.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(l,s){return Promise.all([(0,S.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async i=>{let[r,a]=i,h=this.formatProcessList(l,r);return s.forEach(E=>{if((0,m.isRemoteDiagnosticError)(E))h+=`
${E.errorMessage}`,a+=`
${E.errorMessage}`;else if(h+=`

Remote: ${E.hostName}`,E.processes&&(h+=`
${this.formatProcessList(l,E.processes)}`),E.workspaceMetadata){a+=`
|  Remote: ${E.hostName}`;for(const R of Object.keys(E.workspaceMetadata)){const L=E.workspaceMetadata[R];let W=`${L.fileCount} files`;L.maxFilesReached&&(W=`more than ${W}`),a+=`|    Folder (${R}): ${W}`,a+=this.formatWorkspaceStats(L)}}}),{processInfo:h,workspaceInfo:a}})}async getSystemInfo(l,s){const{memory:i,vmHint:r,os:a,cpus:h}=u(),E={os:a,memory:i,cpus:h,vmHint:r,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:s};return f.isWindows||(E.load=`${p.loadavg().map(R=>Math.round(R)).join(", ")}`),f.isLinux&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(l,s){const i=[];return(0,S.listProcesses)(l.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(l)),i.push(""),i.push(this.formatProcessList(l,r)),l.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(l))),s.forEach(a=>{if((0,m.isRemoteDiagnosticError)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.formatMachineInfo(a.machineInfo)),a.processes&&i.push(this.formatProcessList(l,a.processes)),a.workspaceMetadata)for(const h of Object.keys(a.workspaceMetadata)){const E=a.workspaceMetadata[h];let R=`${E.fileCount} files`;E.maxFilesReached&&(R=`more than ${R}`),i.push(`Folder (${h}): ${R}`),i.push(this.formatWorkspaceStats(E))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(l){const s=[],i=60;let r=0;const a=(L,W)=>{const $=` ${L}(${W})`;r+$.length>i?(s.push(h),h="|                 ",r=h.length):r+=$.length,h+=$};let h="|      File types:";const E=10;let R=l.fileTypes.length>E?E:l.fileTypes.length;for(let L=0;L<R;L++){const W=l.fileTypes[L];a(W.name,W.count)}if(s.push(h),l.configFiles.length>=0&&(h="|      Conf files:",r=0,l.configFiles.forEach(L=>{a(L.name,L.count)}),s.push(h)),l.launchConfigFiles.length>0){let L="|      Launch Configs:";l.launchConfigFiles.forEach(W=>{L+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(L)}return s.join(`
`)}expandGPUFeatures(l){const s=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${l[i]}`).join(`
                  `)}formatWorkspaceMetadata(l){const s=[],i=[];return l.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(a=>{const h=y.URI.revive(a);if(h.scheme===M.Schemas.file){const E=h.fsPath;i.push(v(E,["node_modules",".git"]).then(R=>{let L=`${R.fileCount} files`;R.maxFilesReached&&(L=`more than ${L}`),s.push(`|    Folder (${(0,I.basename)(E)}): ${L}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${E} (${R.toString()})`)}))}else s.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(l,s){const i=new Map;l.windows.forEach(a=>i.set(a.pid,a.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(l.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(l,s,i,r,a){const h=a===0;let E;h?E=r.pid===l?`${this.productService.applicationName} main`:"remote agent":(E=`${"  ".repeat(a)} ${r.name}`,r.name==="window"&&(E=`${E} (${s.get(r.pid)})`));const R=process.platform==="win32"?r.mem:p.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(r.children)&&r.children.forEach(L=>this.formatProcessItem(l,s,i,L,a+1))}async reportWorkspaceStats(l){for(const{uri:s}of l.folders){const i=y.URI.revive(s);if(i.scheme!==M.Schemas.file)continue;const r=i.fsPath;try{const a=await v(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),a.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:h.name,count:h.count})}),a.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:h.name,count:h.count})}),a.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};c=ue([ie(0,g.ITelemetryService),ie(1,d.IProductService)],c),e.DiagnosticsService=c}),define(J[206],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(C){this.appenders=C}listen(C,M){throw new Error(`Event not found: ${M}`)}call(C,M,{eventName:I,data:f}){return this.appenders.forEach(y=>y.log(I,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class n{constructor(C){this.channel=C}log(C,M){return this.channel.call("log",{eventName:C,data:M}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(J[64],Z([0,1,49,14,20,32]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class M{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,k){return Promise.resolve(void 0)}publicLog2(v,k){return this.publicLog(v,k)}publicLogError(v,k){return Promise.resolve(void 0)}publicLogError2(v,k){return this.publicLogError(v,k)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=M,e.NullTelemetryService=new M;class I{async publicLog(v,k,u){}async publicLogError(v,k,u){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(g,v){return v.onDidChangeConfiguration(k=>{k.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(k.source),configurationKeys:t(k.sourceConfig)})})}e.configurationTelemetry=f;function y(g,v){return!(v.disableTelemetry||!g.enableTelemetry||v.extensionTestsLocationURI)}e.supportsTelemetry=y;function b(g){const v=g.getValue(C.TELEMETRY_SETTING_ID),k=g.getValue("telemetry.enableCrashReporter");if(g.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||k===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function P(g){const v=Object.create(null),k=Object.create(null),u=Object.create(null);m(g,u);for(let w in u){w=w.length>150?w.substr(w.length-149):w;const c=u[w];typeof c=="number"?k[w]=c:typeof c=="boolean"?k[w]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${c.length}`),v[w]=c.substring(0,8191)):typeof c!="undefined"&&c!==null&&(v[w]=c)}return{properties:v,measurements:k}}e.validateTelemetryData=P;function S(g){if(!g)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{g.indexOf(`${u}+`)===0&&(v=u)}),v}e.cleanRemoteAuthority=S;function m(g,v,k=0,u){if(!!g)for(let w of Object.getOwnPropertyNames(g)){const c=g[w],o=u?u+w:w;Array.isArray(c)?v[o]=(0,p.safeStringify)(c):c instanceof Date?v[o]=c.toISOString():(0,n.isObject)(c)?k<2?m(c,v,k+1,o+"."):v[o]=(0,p.safeStringify)(c):v[o]=c}}function t(g){if(!g)return[];const v=[];return d(v,"",g),v}function d(g,v,k){k&&typeof k=="object"&&!Array.isArray(k)?Object.keys(k).forEach(u=>d(g,v?`${v}.${u}`:u,k[u])):g.push(v)}}),define(J[207],Z([0,1,169,64]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(C,M,I,f,y,b){const P={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${M.nameShort})`},S=await(0,p.getServiceMachineId)(I,y,b);return(0,n.supportsTelemetry)(M,I)&&(0,n.getTelemetryLevel)(f)===3&&(P["X-Market-User-Id"]=S),P}e.resolveMarketplaceHeaders=D}),define(J[208],Z([0,1,2,49,3,27,153,20,55,53,40,32,64]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(g,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let k of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(k),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3})}setExperimentProperty(g,v){this._experimentProperties[g]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,S.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const g=await this._commonProperties;let v=g.sessionID,k=g["common.machineId"],u=g["common.firstSessionDate"],w=g["common.msftInternal"];return{sessionId:v,machineId:k,firstSessionDate:u,msftInternal:w}}dispose(){this._disposables.dispose()}_log(g,v,k,u){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(w=>{k=(0,n.mixin)(k,w),k=(0,n.mixin)(k,this._experimentProperties),k=(0,n.cloneAndChange)(k,c=>{if(typeof c=="string")return this._cleanupInfo(c,u)}),this._appenders.forEach(c=>c.log(g,k))},w=>{console.error(w)})}publicLog(g,v,k){return this._log(g,3,v,k)}publicLog2(g,v,k){return this.publicLog(g,v,k)}publicLogError(g,v){return this.sendErrorTelemetry?this._log(g,2,v,!0):Promise.resolve(void 0)}publicLogError2(g,v){return this.publicLogError(g,v)}_anonymizeFilePaths(g){let v=g;const k=[];for(let o of this._cleanupPatterns)for(;;){const l=o.exec(g);if(!l)break;k.push([l.index,o.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const o=w.exec(g);if(!o)break;!u.test(o[0])&&k.every(([l,s])=>o.index<l||o.index>=s)&&(v+=g.substring(c,o.index)+"<REDACTED: user-file-path>",c=w.lastIndex)}return c<g.length&&(v+=g.substr(c)),v}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const v=g.toLowerCase(),k=/@[a-zA-Z0-9-.]+/,u=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,w=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return u.test(v)?"<REDACTED: secret>":k.test(v)?"<REDACTED: email>":w.test(v)?"<REDACTED: token>":g}_cleanupInfo(g,v){let k=g;v&&(k=this._anonymizeFilePaths(k));for(let u of this._cleanupPatterns)k=k.replace(u,"");return k=this._removePropertiesWithPossibleUserInfo(k),k}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ue([ie(1,I.IConfigurationService)],m),e.TelemetryService=m;function t(){const d=(0,M.localize)(0,null,y.default.nameLong),g=y.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=D.isWeb?"":(0,M.localize)(3,null),k=(0,M.localize)(4,null),u=(0,M.localize)(5,null),w=(0,M.localize)(6,null),c=(0,M.localize)(7,null),o=`
|       | ${k} | ${u} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,M.localize)(8,null);return`
${d} ${g} ${v}

&nbsp;

${c}
${o}

&nbsp;

${l}
`}b.Registry.as(f.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(9,null),properties:{[P.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(f.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[P.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,M.localize)(16,null,y.default.nameLong,y.default.privacyStatementUrl):(0,M.localize)(15,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${P.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[209],Z([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(J[210],Z([0,1,105,4,2,5,40,209]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var f;(function(g){function v(k){return k&&typeof k=="object"&&typeof k.id=="string"}g.isThemeColor=v})(f=e.ThemeColor||(e.ThemeColor={}));function y(g){return{id:g}}e.themeColorFromId=y;var b;(function(g){function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||f.isThemeColor(i.color))}g.isThemeIcon=v;const k=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const r=k.exec(i);if(!r)return;let[,a]=r;return{id:a}}g.fromString=u;function w(i){return{id:i}}g.fromId=w;function c(i,r){let a=i.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),r&&(a=`${a}~${r}`),{id:a}}g.modify=c;function o(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}g.getModifier=o;function l(i,r){return i.id===r.id&&i.color?.id===r.color?.id}g.isEqual=l;function s(i,r){return{id:i.id,color:r?y(r):void 0}}g.asThemeIcon=s,g.asClassNameArray=p.CSSIcon.asClassNameArray,g.asClassName=p.CSSIcon.asClassName,g.asCSSSelector=p.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function P(g){switch(g){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,D.toDisposable)(()=>{const k=this.themingParticipants.indexOf(v);this.themingParticipants.splice(k,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new S;M.Registry.add(e.Extensions.ThemingContribution,m);function t(g){return m.onColorThemeChange(g)}e.registerThemingParticipant=t;class d extends D.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(k=>this.onThemeChange(k)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,k){let u=this.theme.getColor(v);return u&&k&&(u=k(u,this.theme)),u?u.toString():null}}e.Themable=d}),define(J[65],Z([0,1,12,3,5,38]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const M="#FFFFFF",I="#1E1E1E",f="#000000",y="theme",b="themeBackground",P="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let S=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return f;let t=this.stateMainService.getItem(b,null);if(!t){let d;(n.isWindows||n.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateMainService.getItem(y,"vs-dark").split(" ")[0],t=d==="hc-black"?f:d==="vs"?M:I}return n.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,d){this.stateMainService.setItems([{key:y,data:d.baseTheme},{key:b,data:d.colorInfo.background},{key:P,data:d}]),typeof t=="number"&&this.updateBackgroundColor(t,d)}updateBackgroundColor(t,d){for(const g of p.BrowserWindow.getAllWindows())if(g.id===t){g.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};S=ue([ie(0,C.IStateMainService)],S),e.ThemeMainService=S}),define(J[98],Z([0,1,4,3,5,6]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var M;(function(t){t.Http="http",t.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=P;function S(t,d){return d?d!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=S;let m=class{constructor(d){this.logService=d,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],g=Array.from(this._tunnels.values());for(let v of g){const k=Array.from(v.values());for(let u of k){const w=await u.value;w&&d.push(w)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:g}of d.values())await g.then(v=>v?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,g,v,k,u=!1,w=I.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${v} on local port ${k}.`),!d)return;g||(g="localhost");const o=this.retainOrCreateTunnel(d,g,v,k,u,w,c);return o?o.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==g||l.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const g=this._tunnels.get(d.tunnelRemoteHost);if(g){const v=g.get(d.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,v))}}}}async tryDisposeTunnel(d,g,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${g}.`);const k=v.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(g),k}}async closeTunnel(d,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${g} `);const v=this._tunnels.get(d);if(v&&v.has(g)){const k=v.get(g);k.refcount=0,await this.tryDisposeTunnel(d,g,k)}}addTunnelToMap(d,g,v){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(g,{refcount:1,value:v})}async removeEmptyTunnelFromMap(d,g){const v=this._tunnels.get(d);v&&(await v.get(g)||v.delete(g),v.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,g){let v=[d];b(d)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):P(d)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const k=v.map(u=>this._tunnels.get(u));for(const u of k){const w=u?.get(g);if(w)return w}}canTunnel(d){return!!y(d)}createWithProvider(d,g,v,k,u,w,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${v} on local port ${k}.`);const l={elevationRequired:u?S(k===void 0?v:k):!1},s={remoteAddress:{host:g,port:v},localAddressPort:k,privacy:w,public:w!==I.Private,protocol:c},i=d.forwardPort(s,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(g,v,i),i}};m=ue([ie(0,C.ILogService)],m),e.AbstractTunnelService=m}),define(J[41],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(n=e.StateType||(e.StateType={}));var D;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,M)=>({type:"idle",updateType:C,error:M}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(J[211],Z([0,1,3,154,55,40]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[212],Z([0,1,4,41]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(I){this.service=I}listen(I,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(I,f,y){switch(f){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=D;class C{constructor(I){this.channel=I,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(J[99],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(J[213],Z([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(I){this.handler=I}listen(I,f){throw new Error(`Event not found: ${f}`)}call(I,f,y){switch(f){case"handleURL":return this.handler.handleURL(p.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=n;class D{constructor(I){this.channel=I}handleURL(I,f){return this.channel.call("handleURL",[I.toJSON(),f])}}e.URLHandlerChannelClient=D;class C{constructor(I){this.next=I}async routeCall(I,f,y,b){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(y){const P=p.URI.revive(y);if(P&&P.query){const S=/\bwindowId=(\d+)/.exec(P.query);if(S){const m=S[1],t=new RegExp(`window:${m}`),d=I.connections.find(g=>t.test(g.ctx));if(d)return d}}}return this.next.routeCall(I,f,y,b)}routeEvent(I,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=C}),define(J[214],Z([0,1,8,2,7,21]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,b){const P=[...this.handlers.values()];return(0,p.first)(P.map(S=>()=>S.handleURL(y,b)),void 0,!1).then(S=>S||!1)}registerHandler(y){return this.handlers.add(y),(0,n.toDisposable)(()=>this.handlers.delete(y))}}e.AbstractURLService=M;let I=class extends M{constructor(y){super();this.productService=y}create(y){let{authority:b,path:P,query:S,fragment:m}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&P&&P.indexOf("/")!==0&&(P=`/${P}`),D.URI.from({scheme:this.productService.urlProtocol,authority:b,path:P,query:S,fragment:m})}};I=ue([ie(0,C.IProductService)],I),e.NativeURLService=I}),define(J[215],Z([0,1,12,8,4,2,3,7]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(b){try{return I.URI.parse(b)}catch{return null}}class y{constructor(P,S,m,t,d){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=P,M.isWindows){const k=t.isBuilt?[]:[`"${t.appRoot}"`];k.push("--open-url","--"),p.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,k)}const g=D.Event.map(D.Event.fromNodeEventEmitter(p.app,"open-url",(k,u)=>({event:k,url:u})),({event:k,url:u})=>(k.preventDefault(),u));this.disposables.add(g(k=>{const u=f(k);!u||this.urlService.open(u,{originalUrl:k})})),m.getWindows().filter(k=>k.isReady).length>0?this.flush():D.Event.once(m.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||P.push(S);P.length!==0&&(this.uris=P,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(J[216],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(J[217],Z([0,1,12,2,10,7]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends n.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(D.Schemas.vscodeWebview,f)}handleWebviewRequest(f,y){try{const b=C.URI.parse(f.url),P=M.validWebviewFilePaths.get(b.path);if(typeof P=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${P}`,m=D.FileAccess.asFileUri(S,V);return y(decodeURIComponent(m.fsPath))}else return y({error:-10})}catch{}return y({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[66],Z([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(y){return!!y.workspaceUri}e.isWorkspaceToOpen=n;function D(y){return!!y.folderUri}e.isFolderToOpen=D;function C(y){return!!y.fileUri}e.isFileToOpen=C;function M(y){const b=I(y),P=y.getValue("window.menuBarVisibility");return P==="default"||b==="native"&&P==="compact"||p.isMacintosh&&p.isNative?"classic":P}e.getMenuBarVisibility=M;function I(y){if(p.isWeb)return"custom";const b=y.getValue("window");if(b){if(p.isMacintosh&&b.nativeTabs===!0||p.isMacintosh&&b.nativeFullScreen===!1)return"native";const m=y.getValue("workbench.colorCustomizations");if(m?.["window.activeBorder"]||m?.["window.inactiveBorder"])return"custom";const t=b.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=I;function f(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=f}),define(J[34],Z([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var n;(function(y){y[y.INITIAL=1]="INITIAL",y[y.LOAD=2]="LOAD",y[y.RELOAD=3]="RELOAD"})(n=e.LoadReason||(e.LoadReason={}));var D;(function(y){y[y.CLOSE=1]="CLOSE",y[y.QUIT=2]="QUIT",y[y.RELOAD=3]="RELOAD",y[y.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var C;(function(y){y[y.CLI=0]="CLI",y[y.DOCK=1]="DOCK",y[y.MENU=2]="MENU",y[y.DIALOG=3]="DIALOG",y[y.DESKTOP=4]="DESKTOP",y[y.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const M=function(y=1){return{width:1024,height:768,mode:y}};e.defaultWindowState=M;var I;(function(y){y[y.Maximized=0]="Maximized",y[y.Normal=1]="Normal",y[y.Minimized=2]="Minimized",y[y.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var f;(function(y){y[y.UNRESPONSIVE=1]="UNRESPONSIVE",y[y.CRASHED=2]="CRASHED",y[y.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(J[218],Z([0,1,12,23,4,69,2,31,74,91,6,21,34]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var m;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(m||(m={}));let t=class extends M.Disposable{constructor(g,v,k,u,w){super();this.logService=g,this.windowsMainService=v,this.credentialsService=k,this.encryptionMainService=u,this.productService=w,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=m.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const g=D.Event.fromNodeEventEmitter(p.app,"login",(v,k,u,w,c)=>({event:v,webContents:k,req:u,authInfo:w,callback:c}));this._register(g(this.onLogin,this))}async onLogin({event:g,authInfo:v,req:k,callback:u}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===m.LoginDialogShown&&k.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}g.preventDefault();let w;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),w=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{w=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(w?.username,w?.password)}async resolveProxyCredentials(g){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(g);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(g){this.logService.trace("auth#doResolveProxyCredentials - enter",g);const v=String((0,C.hash)({scheme:g.scheme,host:g.host,port:g.port}));let k,u;try{const l=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(l){const s=JSON.parse(await this.encryptionMainService.decrypt(l));k=s.username,u=s.password}}catch(l){this.logService.error(l)}if(this.state!==m.StoredCredentialsUsed&&typeof k=="string"&&typeof u=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=m.StoredCredentialsUsed,{username:k,password:u};const w=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!w){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${w.id} to handle proxy login`);const c={authInfo:g,username:this.sessionCredentials?.username??k,password:this.sessionCredentials?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};w.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,c),this.state=m.LoginDialogShown;const o=await new Promise(l=>{const s=async(i,r,a)=>{if(r===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${w.id}`),w.win?.webContents.off("ipc-message",s),a){const h={username:a.username,password:a.password};try{if(a.remember){const E=await this.encryptionMainService.encrypt(JSON.stringify(h));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v,E)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(E){this.logService.error(E)}l({username:h.username,password:h.password})}else l(void 0)};w.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=o,o}};t=ue([ie(0,b.ILogService),ie(1,S.IWindowsMainService),ie(2,f.ICredentialsMainService),ie(3,y.IEncryptionMainService),ie(4,P.IProductService)],t),e.ProxyAuthHandler=t}),define(J[219],Z([0,1,12,4,2,217,34]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends D.Disposable{constructor(y){super();this.windowsMainService=y,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(y,b){let P;if(typeof y.windowId=="number"){const{windowId:S}=y,m=this.windowsMainService.getWindowById(S);if(!m?.win)throw new Error(`Invalid windowId: ${S}`);P=m.win.webContents}else{const{webContentsId:S}=y;if(P=p.webContents.fromId(S),!P)throw new Error(`Invalid webContentsId: ${S}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(b)}async findInFrame(y,b,P,S){const m=this.getFrameByName(y,b),t=m;if(typeof t.findInFrame=="function"){t.findInFrame(P,{findNext:S.findNext,forward:S.forward});const d=(g,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),m.removeListener("found-in-frame",d))};m.on("found-in-frame",d)}}async stopFindInFrame(y,b,P){const m=this.getFrameByName(y,b);typeof m.stopFindInFrame=="function"&&m.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(y,b){const P=this.windowsMainService.getWindowById(y.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${y}`);const S=P.win.webContents.mainFrame.framesInSubtree.find(m=>m.name===b);if(!S)throw new Error(`Unknown frame: ${b}`);return S}};I=ue([ie(0,M.IWindowsMainService)],I),e.WebviewMainService=I}),define(J[220],Z([0,1,8,4,2]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends D.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:f,getActiveWindowId:y}){super();this.disposables=this._register(new D.DisposableStore),n.Event.latch(n.Event.any(I,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>y()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(J[221],Z([0,1,35,16,7,5]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var M;(function(S){S[S.EMPTY=1]="EMPTY",S[S.FOLDER=2]="FOLDER",S[S.WORKSPACE=3]="WORKSPACE"})(M=e.WorkbenchState||(e.WorkbenchState={}));function I(S){const m=S;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=I;function f(S){const m=S;return!!(m&&typeof m=="object"&&D.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=f;class y{constructor(m,t,d,g,v){this._id=m,this._transient=d,this._configuration=g,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class b{constructor(m,t){this.raw=t,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,n.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=b;function P(S){return new b({uri:S,index:0,name:(0,n.basenameOrAuthority)(S)},{uri:S.toString()})}e.toWorkspaceFolder=P}),define(J[26],Z([0,1,28,44,107,33,10,9,3,16,7,157,5,78,221]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(j){return(typeof j=="string"?(0,I.extname)(j):(0,y.extname)(j))===d}e.hasWorkspaceFileExtension=g,e.IWorkspacesService=(0,S.createDecorator)("workspacesService");function v(j){return j.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function k(j){return j.hasOwnProperty("folderUri")}e.isRecentFolder=k;function u(j){return j.hasOwnProperty("fileUri")}e.isRecentFile=u;function w(j){return j&&j.hasOwnProperty("folderUri")}e.isFolderBackupInfo=w;function c(j){return j&&j.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=c;function o(j){const te=j;return typeof te?.id=="string"&&b.URI.isUri(te.uri)}e.isSingleFolderWorkspaceIdentifier=o;function l(j){if(j.configuration)return{id:j.id,configPath:j.configuration};if(j.folders.length===1)return{id:j.id,uri:j.folders[0].uri}}e.toWorkspaceIdentifier=l;function s(j){const te=j;return typeof te?.id=="string"&&b.URI.isUri(te.configPath)}e.isWorkspaceIdentifier=s;function i(j){const te=j;if(te?.uri)return{id:te.id,uri:b.URI.revive(te.uri)};const N=j;if(N?.configPath)return{id:N.id,configPath:b.URI.revive(N.configPath)};if(j?.id)return{id:j.id}}e.reviveIdentifier=i;function r(j,te){return y.extUriBiasedIgnorePathCase.isEqualOrParent(j,te.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function a(j){return h(j)||E(j)}e.isStoredWorkspaceFolder=a;function h(j){const te=j;return typeof te?.path=="string"&&(!te.name||typeof te.name=="string")}e.isRawFileWorkspaceFolder=h;function E(j){const te=j;return typeof te?.uri=="string"&&(!te.name||typeof te.name=="string")}e.isRawUriWorkspaceFolder=E;function R(j,te,N,z,K=!f.isWindows,B){if(j.scheme!==z.scheme)return{name:N,uri:j.toString(!0)};let T=te?void 0:B.relativePath(z,j);if(T!==void 0)T.length===0?T=".":f.isWindows&&j.scheme===M.Schemas.file&&!K&&(T=T.replace(/\//g,"\\"));else if(j.scheme===M.Schemas.file)T=j.fsPath,f.isWindows&&(T=(0,C.normalizeDriveLetter)(T),K&&(T=(0,p.toSlashes)(T)));else{if(!B.isEqualAuthority(j.authority,z.authority))return{name:N,uri:j.toString(!0)};T=j.path}return{name:N,path:T}}e.getStoredWorkspaceFolder=R;function L(j,te,N){let z=[],K=new Set;const B=N.dirname(te);for(let T of j){let _;if(h(T))T.path&&(_=N.resolvePath(B,T.path));else if(E(T))try{_=b.URI.parse(T.uri),_.path[0]!=="/"&&(_=_.with({path:"/"+_.path}))}catch(F){console.warn(F)}if(_){let F=N.getComparisonKey(_);if(!K.has(F)){K.add(F);const A=T.name||N.basenameOrAuthority(_);z.push(new t.WorkspaceFolder({uri:_,name:A,index:z.length},T))}}}return z}e.toWorkspaceFolders=L;function W(j,te,N,z,K){let B=$(te,j);const T=K.dirname(te),_=K.dirname(z),F=[],A=Q(B.folders);for(const ne of B.folders){const ce=h(ne)?K.resolvePath(T,ne.path):b.URI.parse(ne.uri);let ae;N?ae=!1:ae=!h(ne)||(0,I.isAbsolute)(ne.path),F.push(R(ce,ae,ne.name,_,A,K))}const O={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},U=D.setProperty(j,["folders"],F,O);let G=D.applyEdits(j,U);return(0,y.isEqualAuthority)(B.remoteAuthority,(0,m.getRemoteAuthority)(z))&&(G=D.applyEdits(G,D.removeProperty(G,["remoteAuthority"],O))),G}e.rewriteWorkspaceFileForNewLocation=W;function $(j,te){let N=n.parse(te);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(z=>a(z));else throw new Error(`${j} looks like an invalid workspace file.`);return N}function Q(j){return f.isWindows?j.some(te=>h(te)&&te.path.indexOf("/")>=0):!0}e.useSlashForPath=Q;function ee(j){return j.workspace&&typeof j.workspace=="object"&&typeof j.workspace.id=="string"&&typeof j.workspace.configPath=="string"}function x(j){return typeof j.folderUri=="string"}function q(j){return typeof j.fileUri=="string"}function X(j,te){const N={workspaces:[],files:[]};if(j){const z=function(B,T){for(let _=0;_<B.length;_++)try{T(B[_],_)}catch(F){te.warn(`Error restoring recent entry ${JSON.stringify(B[_])}: ${F.toString()}. Skip entry.`)}},K=j;if(Array.isArray(K.entries))z(K.entries,B=>{const T=B.label,_=B.remoteAuthority;ee(B)?N.workspaces.push({label:T,remoteAuthority:_,workspace:{id:B.workspace.id,configPath:b.URI.parse(B.workspace.configPath)}}):x(B)?N.workspaces.push({label:T,remoteAuthority:_,folderUri:b.URI.parse(B.folderUri)}):q(B)&&N.files.push({label:T,remoteAuthority:_,fileUri:b.URI.parse(B.fileUri)})});else{const B=j;Array.isArray(B.workspaces3)&&z(B.workspaces3,(T,_)=>{const F=Array.isArray(B.workspaceLabels)&&B.workspaceLabels[_]||void 0;typeof T=="object"&&typeof T.id=="string"&&typeof T.configURIPath=="string"?N.workspaces.push({label:F,workspace:{id:T.id,configPath:b.URI.parse(T.configURIPath)}}):typeof T=="string"&&N.workspaces.push({label:F,folderUri:b.URI.parse(T)})}),Array.isArray(B.files2)&&z(B.files2,(T,_)=>{const F=Array.isArray(B.fileLabels)&&B.fileLabels[_]||void 0;typeof T=="string"&&N.files.push({label:F,fileUri:b.URI.parse(T)})})}}return N}e.restoreRecentlyOpened=X;function H(j){const te={entries:[]};for(const N of j.workspaces)k(N)?te.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):te.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of j.files)te.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return te}e.toStoreData=H}),define(J[47],Z([0,1,12,8,69,33,2,70,9,3,14,24,139,5,6,38,26]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,m.createDecorator)("dialogMainService");let v=class St{constructor(u,w){this.stateMainService=u,this.logService=w,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(u,w){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,S.localize)(0,null)},w)}pickFolder(u,w){return this.doPick({...u,pickFolders:!0,title:(0,S.localize)(1,null)},w)}pickFile(u,w){return this.doPick({...u,pickFiles:!0,title:(0,S.localize)(2,null)},w)}pickWorkspace(u,w){const c=(0,S.localize)(3,null),o=(0,C.mnemonicButtonLabel)((0,S.localize)(4,null)),l=g.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:c,filters:l,buttonLabel:o},w)}async doPick(u,w){const c={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};c.defaultPath=u.defaultPath||this.stateMainService.getItem(St.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(c.properties=void 0,u.pickFiles&&u.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),y.isMacintosh&&c.properties.push("treatPackageAsDirectory");const o=w||p.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(c,(0,b.withNullAsUndefined)(o));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(St.workingDirPickerStorageKey,(0,f.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(u){if(u){let w=this.windowDialogQueues.get(u.id);return w||(w=new n.Queue,this.windowDialogQueues.set(u.id,w)),w}else return this.noWindowDialogueQueue}showMessageBox(u,w){return this.getWindowDialogQueue(w).queue(async()=>w?p.dialog.showMessageBox(w,u):p.dialog.showMessageBox(u))}async showSaveDialog(u,w){const c=this.acquireFileDialogLock(u,w);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(w).queue(async()=>{let o;return w?o=await p.dialog.showSaveDialog(w,u):o=await p.dialog.showSaveDialog(u),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,M.dispose)(c)}}normalizePath(u){return u&&y.isMacintosh&&(u=(0,I.normalizeNFC)(u)),u}normalizePaths(u){return u.map(w=>this.normalizePath(w))}async showOpenDialog(u,w){u.defaultPath&&(await P.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const c=this.acquireFileDialogLock(u,w);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(w).queue(async()=>{let o;return w?o=await p.dialog.showOpenDialog(w,u):o=await p.dialog.showOpenDialog(u),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,M.dispose)(c)}}acquireFileDialogLock(u,w){if(!w)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",u);let c=this.windowFileDialogLocks.get(w.id);c||(c=new Set,this.windowFileDialogLocks.set(w.id,c));const o=(0,D.hash)(u);if(!c.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",u),c.add(o),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",u),c?.delete(o),c?.size===0&&this.windowFileDialogLocks.delete(w.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=ue([ie(0,d.IStateMainService),ie(1,t.ILogService)],v),e.DialogMainService=v}),define(J[222],Z([0,1,4,2,26]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends n.Disposable{constructor(I,f){super();this.logService=I,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,f)=>(I?I.push(f):I=[f],I),C.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const f=new Map,y=new Set;return I.forEach(b=>{const P=this.storageMainService.globalStorage.get(b.key);typeof P=="string"?f.set(b.key,P):y.add(b.key)}),{changed:Array.from(f.entries()),deleted:Array.from(y.values())}}listen(I,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(I,f,y){const b=(0,D.reviveIdentifier)(y.workspace),P=await this.withStorageInitialized(b);switch(f){case"getItems":return Array.from(P.items.entries());case"updateItems":{const S=y;if(S.insert)for(const[m,t]of S.insert)P.set(m,t);S.delete&&S.delete.forEach(m=>P.delete(m));break}case"close":{if(b)return P.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(I){const f=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await f.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${y}`)}return f}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[223],Z([0,1,8,4,2,9,24,89,128,6,97,32,26]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class m extends D.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new p.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this._storage.dispose(),this._storage=v,this._register(v.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(v);const k=v.getBoolean(b.IS_NEW_KEY);k===void 0?v.set(b.IS_NEW_KEY,!0):k&&v.set(b.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this._storage.items}get(v,k){return this._storage.get(v,k)}set(v,k){return this._storage.set(v,k)}delete(v){return this._storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends m{constructor(v,k,u){super(k);this.options=v,this.environmentService=u}async doCreate(){let v;return this.options.useInMemoryStorage?v=f.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,C.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new I.Storage(new f.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(P.firstSessionDateStorageKey,void 0)===void 0&&v.set(P.firstSessionDateStorageKey,new Date().toUTCString());const u=v.get(P.currentSessionDateStorageKey,void 0),w=new Date().toUTCString();v.set(P.lastSessionDateStorageKey,typeof u=="undefined"?null:u),v.set(P.currentSessionDateStorageKey,w)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class d extends m{constructor(v,k,u,w){super(u);this.workspace=v,this.options=k,this.environmentService=w}async doCreate(){const{storageFilePath:v,wasCreated:k}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new f.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:k?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),k=(0,C.join)(v,d.WORKSPACE_STORAGE_NAME);return await M.Promises.exists(v)?{storageFilePath:k,wasCreated:!1}:(await M.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:k,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let k;if((0,S.isSingleFolderWorkspaceIdentifier)(this.workspace)?k={folder:this.workspace.uri.toString()}:(0,S.isWorkspaceIdentifier)(this.workspace)&&(k={workspace:this.workspace.configPath.toString()}),k)try{const u=(0,C.join)(v,d.WORKSPACE_META_NAME);await M.Promises.exists(u)||await M.Promises.writeFile(u,JSON.stringify(k,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=d,d.WORKSPACE_STORAGE_NAME="state.vscdb",d.WORKSPACE_META_NAME="workspace.json"}),define(J[100],Z([0,1,16,7,26]),function(V,e,p,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(f,y,b){for(const S of f){const m=S.openedWorkspace;if((0,D.isWorkspaceIdentifier)(m)){const t=b(m);if(t){if(t.folders.some(d=>p.extUriBiasedIgnorePathCase.isEqualOrParent(y,d.uri)))return S}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(y,m.configPath))return S}}const P=f.filter(S=>(0,D.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(y,S.openedWorkspace.uri));if(P.length)return P.sort((S,m)=>-(S.openedWorkspace.uri.path.length-m.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function M(f,y){for(const b of f)if((0,D.isWorkspaceIdentifier)(b.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,y)||(0,D.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,y))return b}e.findWindowOnWorkspaceOrFolder=M;function I(f,y){const b=P=>y.some(S=>p.extUriBiasedIgnorePathCase.isEqual(n.URI.file(S),n.URI.file(P)));for(const P of f)if(P.config?.extensionDevelopmentPath?.some(S=>b(S)))return P}e.findWindowOnExtensionDevelopmentPath=I}),define(J[224],Z([0,1,12,2,3,16,7,20,19,6,38,34,26]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let m=class bt extends n.Disposable{constructor(u,w,c,o,l){super();this.windowsMainService=u,this.stateMainService=w,this.lifecycleMainService=c,this.logService=o,this.configurationService=l,this._state=t(this.stateMainService.getItem(bt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let o=this.windowsMainService.getLastActiveWindow();(!o||o.isExtensionDevelopmentHost)&&(o=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),o&&(u.lastActiveWindow=this.toWindowState(o))}const w=this.windowsMainService.getWindows().find(o=>o.isExtensionDevelopmentHost&&!o.isExtensionTestHost);w&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(w)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(o=>!o.isExtensionDevelopmentHost).map(o=>this.toWindowState(o)));const c=g(u);this.stateMainService.setItem(bt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const w=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=w:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(c=>{const o=(0,S.isWorkspaceIdentifier)(u.openedWorkspace)&&c.workspace?.id===u.openedWorkspace.id,l=(0,S.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&c.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(c.folderUri,u.openedWorkspace.uri);(o||l)&&(c.uiState=w.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=w)}toWindowState(u){return{workspace:(0,S.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,S.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const w=this.doGetNewWindowState(u),c=this.configurationService.getValue("window");let o;return w.hasDefaultState?o=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(o=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),o&&D.isMacintosh&&this.windowsMainService.getWindows().some(l=>l.isFullScreen)&&(o=!1)),w.mode===3&&!o&&(w.mode=1),w}doGetNewWindowState(u){const w=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const r=u.workspace;if((0,S.isWorkspaceIdentifier)(r)){const h=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===r.id).map(E=>E.uiState);if(h.length)return h[0]}if((0,S.isSingleFolderWorkspaceIdentifier)(r)){const h=this.state.openedWindows.filter(E=>E.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(E.folderUri,r.uri)).map(E=>E.uiState);if(h.length)return h[0]}else if(u.backupPath){const h=this.state.openedWindows.filter(E=>E.backupPath===u.backupPath).map(E=>E.uiState);if(h.length)return h[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!w&&a)return a.uiState}let c;const o=p.screen.getAllDisplays();if(o.length===1)c=o[0];else{if(D.isMacintosh){const r=p.screen.getCursorScreenPoint();c=p.screen.getDisplayNearestPoint(r)}!c&&w&&(c=p.screen.getDisplayMatching(w.getBounds())),c||(c=p.screen.getPrimaryDisplay()||o[0])}let l=(0,P.defaultWindowState)();l.x=Math.round(c.bounds.x+c.bounds.width/2-l.width/2),l.y=Math.round(c.bounds.y+c.bounds.height/2-l.height/2);const s=this.configurationService.getValue("window");let i=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")l.mode=0,i=!1;else if(s.newWindowDimensions==="fullscreen")l.mode=3,i=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&w){const r=w.serializeWindowState();r.mode===3?l.mode=3:l=r,i=l.mode!==3&&s.newWindowDimensions==="offset"}}return i&&(l=this.ensureNoOverlap(l)),l.hasDefaultState=!0,l}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const w=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;w.some(c=>c.x===u.x||c.y===u.y);)u.x+=30,u.y+=30;return u}};m.windowsStateStorageKey="windowsState",m=ue([ie(0,P.IWindowsMainService),ie(1,b.IStateMainService),ie(2,f.ILifecycleMainService),ie(3,y.ILogService),ie(4,I.IConfigurationService)],m),e.WindowsStateHandler=m;function t(k){const u={openedWindows:[]},w=k||{openedWindows:[]};return w.lastActiveWindow&&(u.lastActiveWindow=d(w.lastActiveWindow)),w.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=d(w.lastPluginDevelopmentHostWindow)),Array.isArray(w.openedWindows)&&(u.openedWindows=w.openedWindows.map(c=>d(c))),u}e.restoreWindowsState=t;function d(k){const u={uiState:k.uiState};return k.backupPath&&(u.backupPath=k.backupPath),k.remoteAuthority&&(u.remoteAuthority=k.remoteAuthority),k.folder&&(u.folderUri=M.URI.parse(k.folder)),k.workspaceIdentifier&&(u.workspace={id:k.workspaceIdentifier.id,configPath:M.URI.parse(k.workspaceIdentifier.configURIPath)}),u}function g(k){return{lastActiveWindow:k.lastActiveWindow&&v(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&v(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(u=>v(u))}}e.getWindowsStateStoreData=g;function v(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(J[101],Z([0,1,60,29,10,3,16]),function(V,e,p,n,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(y){function b(){let P=y.scheme===D.Schemas.file?(0,M.originalFSPath)(y):y.toString();return C.isLinux||(P=P.toLowerCase()),(0,p.createHash)("md5").update(P).digest("hex")}return{id:b(),configPath:y}}e.getWorkspaceIdentifier=I;function f(y,b){function P(){if(y.scheme!==D.Schemas.file)return(0,p.createHash)("md5").update(y.toString()).digest("hex");if(!b)try{b=(0,n.statSync)(y.fsPath)}catch{return}let m;return C.isLinux?m=b.ino:C.isMacintosh?m=b.birthtime.getTime():C.isWindows&&(typeof b.birthtimeMs=="number"?m=Math.floor(b.birthtimeMs):m=b.birthtime.getTime()),(0,p.createHash)("md5").update(y.fsPath).update(m?String(m):"").digest("hex")}const S=P();if(typeof S=="string")return{id:S,uri:y}}e.getSingleFolderWorkspaceIdentifier=f}),define(J[225],Z([0,1,15,4,10,6,252,116,19,84]),function(V,e,p,n,D,C,M,I,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class b{constructor(t,d){this._worker=new M.Worker(D.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",V).fsPath),this._worker.on("message",t),this._worker.on("error",d),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,d){this._worker.postMessage(t,d)}dispose(){this._worker.terminate()}}let P=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};P=ue([ie(0,C.ILogService)],P);let S=class{constructor(t,d){this._logService=t,this._shutdown=!1,this._proxy=null;const g={create:(v,k,u)=>{const w=new b(k,u);return w.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),w.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),w.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),w.postMessage(v,[]),w}};this._worker=new I.SimpleWorkerClient(g,"vs/platform/extensions/node/extensionHostStarterWorker",new P(this._logService)),this._initialize(),d.onWillShutdown(v=>{this._shutdown=!0,this._proxy&&v.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return t.createExtensionHost()}async start(t,d){const g=y.StopWatch.create(!1),v=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();const k=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),u=await v.start(t,d),w=g.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${w} ms.`),clearTimeout(k),u}async enableInspectPort(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return d.enableInspectPort(t)}async kill(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return d.kill(t)}};S=ue([ie(0,C.ILogService),ie(1,f.ILifecycleMainService)],S),e.WorkerMainProcessExtensionHostStarter=S}),define(J[57],Z([0,1,60,61,25,17,15,4,2,9,3,31,37,87,226]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(L,W=""){this.debugLabel=W,this.socket=L,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=$=>{if(this.traceSocketEvent("error",{code:$?.code,message:$?.message}),$){if($.code==="EPIPE")return;(0,M.onUnexpectedError)($)}},this.socket.on("error",this._errorListener)}traceSocketEvent(L,W){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,W)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(L){const W=$=>{this.traceSocketEvent("read",$),L(C.VSBuffer.wrap($))};return this.socket.on("data",W),{dispose:()=>this.socket.off("data",W)}}onClose(L){const W=$=>{this.traceSocketEvent("close",{hadError:$}),L({type:0,hadError:$,error:void 0})};return this.socket.on("close",W),{dispose:()=>this.socket.off("close",W)}}onEnd(L){const W=()=>{this.traceSocketEvent("nodeEndReceived"),L()};return this.socket.on("end",W),{dispose:()=>this.socket.off("end",W)}}write(L){if(!this.socket.destroyed)try{this.traceSocketEvent("write",L),this.socket.write(L.buffer,W=>{if(W){if(W.code==="EPIPE")return;(0,M.onUnexpectedError)(W)}})}catch(W){if(W.code==="EPIPE")return;(0,M.onUnexpectedError)(W)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((L,W)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),L();return}const $=()=>{this.socket.off("close",$),this.socket.off("end",$),this.socket.off("error",$),this.socket.off("timeout",$),this.socket.off("drain",$),this.traceSocketEvent("nodeDrainEnd"),L()};this.socket.on("close",$),this.socket.on("end",$),this.socket.on("error",$),this.socket.on("timeout",$),this.socket.on("drain",$)})}}e.NodeSocket=d;var g;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var v;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(v||(v={}));class k extends f.Disposable{constructor(L,W,$,Q){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=L,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:W,inflateBytesLength:$?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new u(this,W,$,Q,this._onData,(ee,x)=>this._write(ee,x))),this._register(this._flowManager.onError(ee=>{console.error(ee),(0,M.onUnexpectedError)(ee),this._onClose.fire({type:0,hadError:!0,error:ee})})),this._incomingData=new m.ChunkStream,this._register(this.socket.onData(ee=>this._acceptChunk(ee))),this._register(this.socket.onClose(ee=>this._onClose.fire(ee)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,W){this.socket.traceSocketEvent(L,W)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){this._flowManager.writeMessage(L)}_write(L,W){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",L);let $=2;L.byteLength<126?$+=0:L.byteLength<2**16?$+=2:$+=8;const Q=C.VSBuffer.alloc($);if(W?Q.writeUInt8(194,0):Q.writeUInt8(130,0),L.byteLength<126)Q.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){Q.writeUInt8(126,1);let ee=1;Q.writeUInt8(L.byteLength>>>8&255,++ee),Q.writeUInt8(L.byteLength>>>0&255,++ee)}else{Q.writeUInt8(127,1);let ee=1;Q.writeUInt8(0,++ee),Q.writeUInt8(0,++ee),Q.writeUInt8(0,++ee),Q.writeUInt8(0,++ee),Q.writeUInt8(L.byteLength>>>24&255,++ee),Q.writeUInt8(L.byteLength>>>16&255,++ee),Q.writeUInt8(L.byteLength>>>8&255,++ee),Q.writeUInt8(L.byteLength>>>0&255,++ee)}this.socket.write(C.VSBuffer.concat([Q,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const W=this._incomingData.peek(this._state.readLen),$=W.readUInt8(0),Q=($&128)>>>7,ee=($&64)>>>6,x=W.readUInt8(1),q=(x&128)>>>7,X=x&127;this._state.state=2,this._state.readLen=2+(q?4:0)+(X===126?2:0)+(X===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(ee)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const W=this._incomingData.read(this._state.readLen),$=W.readUInt8(1),Q=($&128)>>>7;let ee=$&127,x=1;ee===126?ee=W.readUInt8(++x)*2**8+W.readUInt8(++x):ee===127&&(ee=W.readUInt8(++x)*0+W.readUInt8(++x)*0+W.readUInt8(++x)*0+W.readUInt8(++x)*0+W.readUInt8(++x)*2**24+W.readUInt8(++x)*2**16+W.readUInt8(++x)*2**8+W.readUInt8(++x));let q=0;Q&&(q=W.readUInt8(++x)*2**24+W.readUInt8(++x)*2**16+W.readUInt8(++x)*2**8+W.readUInt8(++x)),this._state.state=3,this._state.readLen=ee,this._state.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const W=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",W),o(W,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",W),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(W,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=k;class u extends f.Disposable{constructor(L,W,$,Q,ee,x){super();this._tracer=L,this._onData=ee,this._writeFn=x,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,W?(this._zlibInflateStream=this._register(new w(this._tracer,Q,$,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(q=>this._onError.fire(q))),this._register(this._zlibDeflateStream.onError(q=>this._onError.fire(q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(L){this._writeQueue.push(L),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const L=this._writeQueue.shift();if(this._zlibDeflateStream){const W=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(W,!0)}else this._writeFn(L,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,W){return new Promise(($,Q)=>{L.write(W),L.flush(ee=>$(ee))})}acceptFrame(L,W,$){this._readQueue.push({data:L,isCompressed:W,isLastFrameOfMessage:$}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const W=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(W)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1}}_inflateFrame(L,W,$){return new Promise((Q,ee)=>{L.write(W),$&&L.write(C.VSBuffer.fromByteArray([0,0,255,255])),L.flush(x=>Q(x))})}}class w extends f.Disposable{constructor(L,W,$,Q){super();this._tracer=L,this._recordInflateBytes=W,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",ee=>{this._tracer.traceSocketEvent("zlibInflateError",{message:ee?.message,code:ee?.code}),this._onError.fire(ee)}),this._zlibInflate.on("data",ee=>{this._tracer.traceSocketEvent("zlibInflateData",ee),this._pendingInflateData.push(C.VSBuffer.wrap(ee))}),$&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",$.buffer),this._zlibInflate.write($.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const W=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(W)})}}class c extends f.Disposable{constructor(L,W){super();this._tracer=L,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",$=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibDeflate.on("data",$=>{this._tracer.traceSocketEvent("zlibDeflateData",$),this._pendingDeflateData.push(C.VSBuffer.wrap($))})}write(L){this._tracer.traceSocketEvent("zlibDeflateWrite",L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let W=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,W=W.slice(0,W.byteLength-4),L(W)})}}function o(R,L){if(L===0)return;let W=R.byteLength>>>2;for(let X=0;X<W;X++){const H=R.readUInt32BE(X*4);R.writeUInt32BE(H^L,X*4)}let $=W*4,Q=R.byteLength-$;const ee=L>>>24&255,x=L>>>16&255,q=L>>>8&255;Q>=1&&R.writeUInt8(R.readUInt8($)^ee,$),Q>=2&&R.writeUInt8(R.readUInt8($+1)^x,$+1),Q>=3&&R.writeUInt8(R.readUInt8($+2)^q,$+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const R=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;let L;return e.XDG_RUNTIME_DIR?L=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${R}.sock`):L=(0,y.join)((0,D.tmpdir)(),`vscode-ipc-${R}.sock`),r(L),L}e.createRandomIPCHandle=s;function i(R,L,W){const $=(0,p.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${$}-${W}-${L}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${$.substr(0,8)}-${W}-${L}.sock`):Q=(0,y.join)(R,`${W}-${L}.sock`),r(Q),Q}e.createStaticIPCHandle=i;function r(R){const L=l[b.platform];typeof L=="number"&&R.length>=L&&console.warn(`WARNING: IPC handle "${R}" is longer than ${L} chars, try a shorter --user-data-dir`)}class a extends S.IPCServer{constructor(L){super(a.toClientConnectionEvent(L));this.server=L}static toClientConnectionEvent(L){const W=I.Event.fromNodeEventEmitter(L,"connection");return I.Event.map(W,$=>({protocol:new m.Protocol(new d($,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter($,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function h(R){return new Promise((L,W)=>{const $=(0,n.createServer)();$.on("error",W),$.listen(R,()=>{$.removeListener("error",W),L(new a($))})})}e.serve=h;function E(R,L){return new Promise((W,$)=>{const Q=(0,n.createConnection)(R,()=>{Q.removeListener("error",$),W(m.Client.fromSocket(new d(Q,`ipc-client${L}`),L))});Q.once("error",$)})}e.connect=E}),define(J[227],Z([0,1,57]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(f){this.driver=f}listen(f,y){throw new Error("No event found")}call(f,y,b){switch(y){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(b);case"startTracing":return this.driver.startTracing(b[0],b[1]);case"stopTracing":return this.driver.stopTracing(b[0],b[1],b[2]);case"reloadWindow":return this.driver.reloadWindow(b);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(b[0],b[1]);case"click":return this.driver.click(b[0],b[1],b[2],b[3]);case"doubleClick":return this.driver.doubleClick(b[0],b[1]);case"setValue":return this.driver.setValue(b[0],b[1],b[2]);case"getTitle":return this.driver.getTitle(b[0]);case"isActiveElement":return this.driver.isActiveElement(b[0],b[1]);case"getElements":return this.driver.getElements(b[0],b[1],b[2]);case"getElementXY":return this.driver.getElementXY(b[0],b[1],b[2]);case"typeInEditor":return this.driver.typeInEditor(b[0],b[1],b[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(b[0],b[1]);case"writeInTerminal":return this.driver.writeInTerminal(b[0],b[1],b[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(b);case"getLocalizedStrings":return this.driver.getLocalizedStrings(b)}throw new Error(`Call not found: ${y}`)}}e.DriverChannel=n;class D{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}startTracing(f,y){return this.channel.call("startTracing",[f,y])}stopTracing(f,y,b){return this.channel.call("stopTracing",[f,y,b])}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,y){return this.channel.call("dispatchKeybinding",[f,y])}click(f,y,b,P){return this.channel.call("click",[f,y,b,P])}doubleClick(f,y){return this.channel.call("doubleClick",[f,y])}setValue(f,y,b){return this.channel.call("setValue",[f,y,b])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,y){return this.channel.call("isActiveElement",[f,y])}getElements(f,y,b){return this.channel.call("getElements",[f,y,b])}getElementXY(f,y,b,P){return this.channel.call("getElementXY",[f,y,b,P])}typeInEditor(f,y,b){return this.channel.call("typeInEditor",[f,y,b])}getTerminalBuffer(f,y){return this.channel.call("getTerminalBuffer",[f,y])}writeInTerminal(f,y,b){return this.channel.call("writeInTerminal",[f,y,b])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=D;class C{constructor(f){this.registry=f}listen(f,y){throw new Error(`Event not found: ${y}`)}call(f,y,b){switch(y){case"registerWindowDriver":return this.registry.registerWindowDriver(b);case"reloadWindowDriver":return this.registry.reloadWindowDriver(b)}throw new Error(`Call not found: ${y}`)}}e.WindowDriverRegistryChannel=C;async function M(I){const f=await(0,p.connect)(I,"driverClient"),y=f.getChannel("driver"),b=new D(y);return{client:f,driver:b}}e.connect=M}),define(J[22],Z([0,1,46,9,57,51,167,5]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(C.IEnvironmentService);class f extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([p.memoize],f.prototype,"cachedLanguagesPath",null),ue([p.memoize],f.prototype,"backupHome",null),ue([p.memoize],f.prototype,"backupWorkspacesPath",null),ue([p.memoize],f.prototype,"mainIPCHandle",null),ue([p.memoize],f.prototype,"mainLockfile",null),ue([p.memoize],f.prototype,"sandbox",null),ue([p.memoize],f.prototype,"driverVerbose",null),ue([p.memoize],f.prototype,"disableUpdates",null),ue([p.memoize],f.prototype,"disableKeytar",null),ue([p.memoize],f.prototype,"codeCachePath",null),ue([p.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(J[228],Z([0,1,60,29,28,10,9,3,16,7,24,160,20,22,18,6,26]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(u,w,c){this.configurationService=w,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,l)=>(0,D.isEqual)(o,l,!I.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await b.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let w=[];try{Array.isArray(u.rootURIWorkspaces)&&(w=u.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:y.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(w);let c=[];try{Array.isArray(u.folderWorkspaceInfos)?c=u.folderWorkspaceInfos.map(o=>({folderUri:y.URI.parse(o.folderUri),remoteAuthority:o.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(c=u.folderURIWorkspaces.map(o=>({folderUri:y.URI.parse(o),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,w){this.workspaces.some(o=>u.workspace.id===o.workspace.id)||(this.workspaces.push(u),this.saveSync());const c=this.getBackupPath(u.workspace.id);return w&&this.moveBackupFolderSync(c,w),c}moveBackupFolderSync(u,w){if(n.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),n.existsSync(w))try{n.renameSync(w,u)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(u){const w=u.id,c=this.workspaces.findIndex(o=>o.workspace.id===w);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(w=>this.backupUriComparer.isEqual(u.folderUri,w.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const w=this.folders.findIndex(c=>this.backupUriComparer.isEqual(u,c.folderUri));w!==-1&&(this.folders.splice(w,1),this.saveSync())}registerEmptyWindowBackupSync(u,w){const c=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:w}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(u){const w=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,u));w!==-1&&(this.emptyWindows.splice(w,1),this.saveSync())}getBackupPath(u){return(0,M.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const w=new Set,c=[];for(let o of u){const l=o.workspace;if(!(0,g.isWorkspaceIdentifier)(l))return[];if(!w.has(l.id)){w.add(l.id);const s=this.getBackupPath(l.id);await this.doHasBackups(s)?l.configPath.scheme!==C.Schemas.file||await b.Promises.exists(l.configPath.fsPath)?c.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(u){if(!Array.isArray(u))return[];const w=[],c=new Set;for(let o of u){const l=o.folderUri,s=this.backupUriComparer.getComparisonKey(l);if(!c.has(s)){c.add(s);const i=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(i)?l.scheme!==C.Schemas.file||await b.Promises.exists(l.fsPath)?w.push(o):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return w}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const w=[],c=new Set;for(let o of u){const l=o.backupFolder;if(typeof l!="string")return[];if(!c.has(l)){c.add(l);const s=this.getBackupPath(l);await this.doHasBackups(s)?w.push(o):await this.deleteStaleBackup(s)}}return w}async deleteStaleBackup(u){try{await b.Promises.exists(u)&&await b.Promises.rm(u,b.RimRafMode.MOVE)}catch(w){this.logService.error(`Backup: Could not delete stale backup: ${w.toString()}`)}}async convertToEmptyWindowBackup(u){let w=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,w));)w=this.getRandomEmptyWindowId();const c=this.getBackupPath(w);try{await b.Promises.rename(u,c)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:w}),!0}convertToEmptyWindowBackupSync(u){let w=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,w));)w=this.getRandomEmptyWindowId();const c=this.getBackupPath(w);try{n.renameSync(u,c)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:w}),!0}async getDirtyWorkspaces(){const u=[];for(const w of this.workspaces)await this.hasBackups(w)&&u.push(w);for(const w of this.folders)await this.hasBackups(w)&&u.push(w);return u}hasBackups(u){let w;return(0,P.isEmptyWindowBackupInfo)(u)?w=u.backupFolder:(0,g.isFolderBackupInfo)(u)?w=this.getBackupPath(this.getFolderHash(u)):w=this.getBackupPath(u.workspace.id),this.doHasBackups(w)}async doHasBackups(u){try{const w=await b.Promises.readdir(u);for(const c of w)try{if((await b.Promises.readdir((0,M.join)(u,c))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,b.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await b.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const w=u.folderUri;let c;return w.scheme===C.Schemas.file?c=I.isLinux?w.fsPath:w.fsPath.toLowerCase():c=w.toString().toLowerCase(),(0,p.createHash)("md5").update(c).digest("hex")}};v=ue([ie(0,m.IEnvironmentMainService),ie(1,S.IConfigurationService),ie(2,d.ILogService)],v),e.BackupMainService=v}),define(J[229],Z([0,1,8,4,108,59,2,3,37,57,162,227,22,182,19,34,18,7,9,17,6]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function c(s){return s<21}let o=class{constructor(i,r,a,h,E,R,L){this.windowServer=i,this.options=r,this.windowsMainService=a,this.lifecycleMainService=h,this.fileService=E,this.environmentMainService=R,this.logService=L,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(r=>r.id).filter(r=>this.registeredWindowIds.has(r)&&!this.reloadingWindowIds.has(r))}async capturePage(i){const r=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!r?.win)throw new Error("Invalid window");return(await r.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,r){}async stopTracing(i,r,a){if(!a)return;const h=await this.capturePage(i),E=Buffer.from(h,"base64");await this.fileService.writeFile(v.URI.file((0,k.join)(this.environmentMainService.logsPath,`${r}.png`)),u.VSBuffer.wrap(E))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const r=this.windowsMainService.getWindowById(i);if(!r)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(r)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,r){await this.whenUnfrozen(i);const a=D.KeybindingParser.parseUserBinding(r);for(let h of a)await this._dispatchKeybinding(i,h)}async _dispatchKeybinding(i,r){if(r instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const a=this.windowsMainService.getWindowById(i);if(!a?.win)throw new Error("Invalid window");const h=a.win.webContents,E=new C.SimpleKeybinding(!1,!1,!1,!1,r.keyCode),L=new m.USLayoutResolvedKeybinding(E.toChord(),I.OS).getElectronAccelerator(),W=[];r.ctrlKey&&W.push("ctrl"),r.metaKey&&W.push("meta"),r.shiftKey&&W.push("shift"),r.altKey&&W.push("alt"),h.sendInputEvent({type:"keyDown",keyCode:L,modifiers:W}),c(r.keyCode)||h.sendInputEvent({type:"char",keyCode:L,modifiers:W}),h.sendInputEvent({type:"keyUp",keyCode:L,modifiers:W}),await(0,p.timeout)(100)}async click(i,r,a,h){await(await this.getWindowDriver(i)).click(r,a,h)}async doubleClick(i,r){await(await this.getWindowDriver(i)).doubleClick(r)}async setValue(i,r,a){await(await this.getWindowDriver(i)).setValue(r,a)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,r){return await(await this.getWindowDriver(i)).isActiveElement(r)}async getElements(i,r,a){return await(await this.getWindowDriver(i)).getElements(r,a)}async getElementXY(i,r,a,h){return await(await this.getWindowDriver(i)).getElementXY(r,a,h)}async typeInEditor(i,r,a){await(await this.getWindowDriver(i)).typeInEditor(r,a)}async getTerminalBuffer(i,r){return await(await this.getWindowDriver(i)).getTerminalBuffer(r)}async writeInTerminal(i,r,a){await(await this.getWindowDriver(i)).writeInTerminal(r,a)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){await this.whenUnfrozen(i);const r=`window:${i}`,a=new f.StaticRouter(E=>E===r),h=this.windowServer.getChannel("windowDriver",a);return new b.WindowDriverChannelClient(h)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};o=ue([ie(2,d.IWindowsMainService),ie(3,t.ILifecycleMainService),ie(4,g.IFileService),ie(5,S.IEnvironmentMainService),ie(6,w.ILogService)],o),e.Driver=o;async function l(s,i,r,a){const h=r.driverVerbose,E=a.createInstance(o,s,{verbose:h}),R=new P.WindowDriverRegistryChannel(E);s.registerChannel("windowDriverRegistry",R);const L=await(0,y.serve)(i),W=new P.DriverChannel(E);return L.registerChannel("driver",W),(0,M.combinedDisposable)(L,s)}e.serve=l}),define(J[230],Z([0,1,61,57]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,C,M,I,f){const y=P=>f(P,void 0),b=p.createConnection({host:D,port:C},()=>{b.removeListener("error",y);const P=Buffer.alloc(16);for(let d=0;d<16;d++)P[d]=Math.round(Math.random()*256);const S=P.toString("base64"),m=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${C}/?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`];b.write(m.join(`\r
`)+`\r
\r
`);const t=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",t),f(void 0,new n.NodeSocket(b,I)))};b.on("data",t)});b.setNoDelay(!0),b.once("error",y)}}}),define(J[231],Z([0,1,201,8,17,15,2,14,20,51,93,6,200,226]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends M.Disposable{constructor(g,v,k){super();this.environmentService=v,this.logService=k,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,v){this.logService.trace("RequestService#request",g.url);const{proxyUrl:k,strictSSL:u}=this;let w;try{w=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",l))}const c={...process.env,...w},o=g.agent?g.agent:await(0,S.getProxyAgent)(g.url||"",c,{proxyUrl:k,strictSSL:u});return g.agent=o,g.strictSSL=u,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,v)}async getNodeRequest(g){return((0,p.parse)(g.url).protocol==="https:"?await new Promise((u,w)=>{V(["https"],u,w)}):await new Promise((u,w)=>{V(["http"],u,w)})).request}_request(g,v){return n.Promises.withAsyncBody(async(k,u)=>{let w;const c=(0,p.parse)(g.url),o=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),l={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,I.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(l.auth=g.user+":"+g.password),w=o(l,s=>{const i=(0,I.isNumber)(g.followRedirects)?g.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&i>0&&s.headers.location)this._request({...g,url:s.headers.location,followRedirects:i-1},v).then(k,u);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,m.createGunzip)())),k({res:s,stream:(0,D.streamToBufferReadableStream)(r)})}}),w.on("error",u),g.timeout&&w.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&w.write(g.data),w.end(),v.onCancellationRequested(()=>{w.abort(),u((0,C.canceled)())})})}async resolveProxy(g){}};t=ue([ie(0,f.IConfigurationService),ie(1,y.INativeEnvironmentService),ie(2,P.ILogService)],t),e.RequestService=t}),define(J[232],Z([0,1,12,231]),function(V,e,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(M){return p.net.request}class C extends n.RequestService{request(I,f){return super.request({...I||{},getRawRequest:D},f)}}e.RequestMainService=C}),define(J[233],Z([0,1,12,8,4,2,10,14,88,22,19,6,53,54,65,39]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends C.Disposable{constructor(k,u,w,c,o,l,s){super();this.machineId=k,this.userEnv=u,this.environmentMainService=w,this.lifecycleMainService=c,this.logService=o,this.themeMainService=l,this.protocolMainService=s,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(k,u)=>this.onWindowConnection(k,u)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(k,u)=>this.onWorkerConnection(k,u)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(k,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const w=await this.connect();if(k.sender.isDestroyed())return w.close();k.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[w])}onWorkerConnection(k,u){this.logService.trace("SharedProcess: onWorkerConnection",u);const w=new C.DisposableStore,c=l=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${l}')`,u),w.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",u))},o=p.BrowserWindow.fromId(u.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!u.reply.channel){c("unavailable");return}w.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,l=>l.window.win===o)(()=>c("load"))),w.add(D.Event.fromNodeEventEmitter(o,"closed")(()=>c("closed"))),o.webContents.postMessage(u.reply.channel,u.reply.nonce,k.ports)}onWillShutdown(){const k=this.window;!k||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(k.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{k.close()}catch{}this.window=void 0},0))}send(k,...u){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${k}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(k,...u)}catch(w){this.logService.warn(`Error sending IPC message to channel '${k}' of shared process: ${(0,d.toErrorMessage)(w)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(k=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),k()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(k=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),k()}))})()),this._whenIpcReady}createWindow(){const k=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${k.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),k.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:S.default}),this.window.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=k=>{this.logService.trace("SharedProcess#close prevented"),k.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(k,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(k,u,w)=>this._onDidError.fire({type:3,details:{reason:w,exitCode:u}})))}async connect(){await this.whenIpcReady;const k=(0,I.assertIsDefined)(this.window);return(0,f.connect)(k)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const k=this.window;return k?!k.isDestroyed()&&!k.webContents.isDestroyed():!1}};g=ue([ie(2,y.IEnvironmentMainService),ie(3,b.ILifecycleMainService),ie(4,P.ILogService),ie(5,t.IThemeMainService),ie(6,m.IProtocolMainService)],g),e.SharedProcess=g}),define(J[234],Z([0,1,8,17,9,14,7,22,18,6]),function(V,e,p,n,D,C,M,I,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class b{constructor(m,t,d){this.storagePath=m,this.logService=t,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(m){m.fileOperationResult!==1&&this.logService.error(m)}}getItem(m,t){const d=this.storage[m];return(0,C.isUndefinedOrNull)(d)?t:d}setItem(m,t){this.setItems([{key:m,data:t}])}setItems(m){let t=!1;for(const{key:d,data:g}of m)this.storage[d]!==g&&((0,C.isUndefinedOrNull)(g)?(0,C.isUndefined)(this.storage[d])||(this.storage[d]=void 0,t=!0):(this.storage[d]=g,t=!0));t&&this.save()}removeItem(m){(0,C.isUndefined)(this.storage[m])||(this.storage[m]=void 0,this.save())}async save(m){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),m)}async doSave(){if(!this.initializing)return;await this.initializing;const m=JSON.stringify(this.storage,null,4);if(m!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(m)),this.lastSavedStorageContents=m}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=b;let P=class Pt{constructor(m,t,d){this.fileStorage=new b(M.URI.file((0,D.join)(m.userDataPath,Pt.STATE_FILE)),t,d)}async init(){return this.fileStorage.init()}getItem(m,t){return this.fileStorage.getItem(m,t)}setItem(m,t){this.fileStorage.setItem(m,t)}setItems(m){this.fileStorage.setItems(m)}removeItem(m){this.fileStorage.removeItem(m)}close(){return this.fileStorage.close()}};P.STATE_FILE="storage.json",P=ue([ie(0,I.IEnvironmentMainService),ie(1,y.ILogService),ie(2,f.IFileService)],P),e.StateMainService=P}),define(J[80],Z([0,1,43,2,51,22,5,19,6,97,223]),function(V,e,p,n,D,C,M,I,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let P=class extends n.Disposable{constructor(t,d,g){super();this.logService=t,this.environmentService=d,this.lifecycleMainService=g,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{t.join(this.globalStorage.close());for(const[,d]of this.mapWorkspaceToStorage)t.join(d.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const t=new b.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}createWorkspaceStorage(t){return new b.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(t){let d=this.mapWorkspaceToStorage.get(t.id);return d||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),d=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,d),(0,p.once)(d.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),d}};P=ue([ie(0,f.ILogService),ie(1,D.IEnvironmentService),ie(2,I.ILifecycleMainService)],P),e.StorageMainService=P,e.IGlobalStorageMainService=(0,M.createDecorator)("globalStorageMainService");let S=class extends y.AbstractStorageService{constructor(t,d){super();this.environmentMainService=t,this.storageMainService=d,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};S=ue([ie(0,C.IEnvironmentMainService),ie(1,e.IStorageMainService)],S),e.GlobalStorageMainService=S}),define(J[235],Z([0,1,61,121,230,8,2,20,6,21,199,98,79]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function m(k,u,w,c,o){let l;for(let s=3;s&&(l&&l.dispose(),l=await new t(k,u,w,c,o).waitForReady(),!(o&&n.BROWSER_RESTRICTED_PORTS[o]||!n.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));s--);return l}class t extends M.Disposable{constructor(u,w,c,o,l){super();this.defaultTunnelHost=w,this.suggestedLocalPort=l,this.privacy=P.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=u,this._server=p.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(w=>{w()})}async waitForReady(){let u=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),w=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),w=this._server.address(),w||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),w=this._server.address()),this.tunnelLocalPort=w.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${w.port}`,this}async _onConnection(u){u.pause();const w=(0,P.isLocalhost)(this.tunnelRemoteHost)||(0,P.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,b.connectRemoteAgentTunnel)(this._options,w,this.tunnelRemotePort),o=c.getSocket().socket,l=c.readEntireBuffer();c.dispose(),l.byteLength>0&&u.write(l.buffer),u.on("end",()=>{this._socketsDispose.delete(u.localAddress),o.end()}),u.on("close",()=>o.end()),u.on("error",()=>{this._socketsDispose.delete(u.localAddress),o.destroy()}),o.on("end",()=>u.end()),o.on("close",()=>u.end()),o.on("error",()=>{u.destroy()}),u.pipe(o),o.pipe(u),this._socketsDispose.set(u.localAddress,()=>{u.end(),o.end()})}}let d=class extends P.AbstractTunnelService{constructor(u,w,c,o,l){super(w);this.socketFactory=u,this.signService=c,this.productService=o,this.configurationService=l}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,w,c,o,l,s,i){const r=this.getTunnelFromMap(w,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,w,c,o,l,s,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${w}:${c} on local port ${o}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},h=m(a,this.defaultTunnelHost,w,c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(w,c,h),h}}};d=ue([ie(1,f.ILogService),ie(2,S.ISignService),ie(3,y.IProductService),ie(4,I.IConfigurationService)],d),e.BaseTunnelService=d;let g=class extends d{constructor(u,w,c,o){super(D.nodeSocketFactory,u,w,c,o)}};g=ue([ie(0,f.ILogService),ie(1,S.ISignService),ie(2,y.IProductService),ie(3,I.IConfigurationService)],g),e.TunnelService=g;let v=class extends M.Disposable{constructor(u,w,c,o){super();this.logService=u,this.productService=w,this.signService=c,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(u,w,c,o,l,s,i,r){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${o} on local port ${l}.`),!this._tunnelServices.has(u)){const a=new g(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(u,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(u))})}return this._tunnelServices.get(u).openTunnel(w,c,o,l,s,i,r)}};v=ue([ie(0,f.ILogService),ie(1,y.IProductService),ie(2,S.ISignService),ie(3,I.IConfigurationService)],v),e.SharedTunnelsService=v}),define(J[81],Z([0,1,8,23,4,20,22,19,6,21,56,41]),function(V,e,p,n,D,C,M,I,f,y,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(t,d,g){return`${g.updateUrl}/api/update/${t}/${d}/${g.commit}`}e.createUpdateURL=S;let m=class{constructor(d,g,v,k,u,w){this.lifecycleMainService=d,this.configurationService=g,this.environmentMainService=v,this.requestService=k,this.logService=u,this.productService=w,this._state=P.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.getUpdateMode(),g=this.getProductQuality(d);if(!g){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(g),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),d==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(d){return d==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(d=60*60*1e3){return(0,p.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(d){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};m=ue([ie(0,I.ILifecycleMainService),ie(1,C.IConfigurationService),ie(2,M.IEnvironmentMainService),ie(3,b.IRequestService),ie(4,f.ILogService),ie(5,y.IProductService)],m),e.AbstractUpdateService=m}),define(J[236],Z([0,1,12,46,4,2,20,22,19,6,21,56,32,41,81]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let d=class extends t.AbstractUpdateService{constructor(v,k,u,w,c,o,l){super(v,k,w,c,o,l);this.telemetryService=u,this.disposables=new C.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,k)=>k)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,k,u)=>({url:k,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,k,u,w)=>({releaseNotes:k,version:u,productVersion:u,date:w}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(m.State.Idle(1,u))}buildUpdateFeedUrl(v){let k;this.productService.darwinUniversalAssetId?k=this.productService.darwinUniversalAssetId:k=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,t.createUpdateURL)(k,v,this.productService);try{p.autoUpdater.setFeedURL({url:u})}catch(w){this.logService.error("Failed to set update feed URL",w);return}return u}doCheckForUpdates(v){this.setState(m.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(m.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(m.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(m.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([n.memoize],d.prototype,"onRawError",null),ue([n.memoize],d.prototype,"onRawUpdateNotAvailable",null),ue([n.memoize],d.prototype,"onRawUpdateAvailable",null),ue([n.memoize],d.prototype,"onRawUpdateDownloaded",null),d=ue([ie(0,f.ILifecycleMainService),ie(1,M.IConfigurationService),ie(2,S.ITelemetryService),ie(3,I.IEnvironmentMainService),ie(4,P.IRequestService),ie(5,y.ILogService),ie(6,b.IProductService)],d),e.DarwinUpdateService=d}),define(J[237],Z([0,1,45,29,8,4,9,22,19,6,32,41]),function(V,e,p,n,D,C,M,I,f,y,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(d,g,v){if(this.lifecycleMainService=d,this.logService=v,this._state=P.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,g.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,k=>this.logService.error(k))}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}scheduleCheckForUpdates(d=60*60*1e3){return(0,D.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(d){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};S=ue([ie(0,f.ILifecycleMainService),ie(1,I.IEnvironmentMainService),ie(2,y.ILogService)],S);let m=class extends S{constructor(d,g,v,k,u,w){super(v,k,u);this.snap=d,this.snapRevision=g,this.telemetryService=w;const c=(0,n.watch)(M.dirname(this.snap)),o=C.Event.fromNodeEventEmitter(c,"change",(r,a)=>a),l=C.Event.filter(o,r=>r==="current"),i=C.Event.debounce(l,(r,a)=>a,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),c.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(d=>{d?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},d=>{this.logService.error(d),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,d.message||d))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const d=await new Promise((v,k)=>(0,n.realpath)(`${M.dirname(this.snap)}/current`,(u,w)=>u?k(u):v(w))),g=M.basename(d);return this.snapRevision!==g}isLatestVersion(){return this.isUpdateAvailable().then(void 0,d=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};m=ue([ie(2,f.ILifecycleMainService),ie(3,I.IEnvironmentMainService),ie(4,y.ILogService),ie(5,b.ITelemetryService)],m),e.SnapUpdateService=m}),define(J[42],Z([0,1,12,29,4,44,33,2,10,9,3,16,14,24,159,50,47,22,5,6,21,100,26,101]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w,c,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,k.createDecorator)("workspacesManagementMainService");let s=class extends I.Disposable{constructor(r,a,h,E,R){super();this.environmentMainService=r,this.logService=a,this.backupMainService=h,this.dialogMainService=E,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(r){return this.doResolveLocalWorkspace(r,a=>(0,n.readFileSync)(a,"utf8"))}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,a=>m.Promises.readFile(a,"utf8"))}doResolveLocalWorkspace(r,a){if(!!this.isWorkspacePath(r)&&r.scheme===f.Schemas.file)try{const h=a(r.fsPath);return h instanceof Promise?h.then(E=>this.doResolveWorkspace(r,E),E=>{}):this.doResolveWorkspace(r,h)}catch{return}}isWorkspacePath(r){return(0,o.isUntitledWorkspace)(r,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,a){try{const h=this.doParseStoredWorkspace(r,a),E=(0,l.getWorkspaceIdentifier)(r);return{id:E.id,configPath:E.configPath,folders:(0,o.toWorkspaceFolders)(h.folders,E.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:h.remoteAuthority,transient:h.transient}}catch(h){this.logService.warn(h.toString())}}doParseStoredWorkspace(r,a){const h=(0,C.parse)(a);if(h&&Array.isArray(h.folders))h.folders=h.folders.filter(E=>(0,o.isStoredWorkspaceFolder)(E));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return h}async createUntitledWorkspace(r,a){const{workspace:h,storedWorkspace:E}=this.newUntitledWorkspace(r,a),R=h.configPath.fsPath;return await m.Promises.mkdir((0,y.dirname)(R),{recursive:!0}),await m.Promises.writeFile(R,JSON.stringify(E,null,"	")),h}createUntitledWorkspaceSync(r,a){const{workspace:h,storedWorkspace:E}=this.newUntitledWorkspace(r,a),R=h.configPath.fsPath;return(0,n.mkdirSync)((0,y.dirname)(R),{recursive:!0}),(0,m.writeFileSync)(R,JSON.stringify(E,null,"	")),h}newUntitledWorkspace(r=[],a){const h=(Date.now()+Math.round(Math.random()*1e3)).toString(),E=(0,P.joinPath)(this.untitledWorkspacesHome,h),R=(0,P.joinPath)(E,o.UNTITLED_WORKSPACE_NAME),L=[];for(const W of r)L.push((0,o.getStoredWorkspaceFolder)(W.uri,!0,W.name,E,!b.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(R),storedWorkspace:{folders:L,remoteAuthority:a}}}async getWorkspaceIdentifier(r){return(0,l.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,o.isUntitledWorkspace)(r.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(r){!this.isUntitledWorkspace(r)||(this.doDeleteUntitledWorkspaceSync(r),this._onDidDeleteUntitledWorkspace.fire(r))}async deleteUntitledWorkspace(r){this.deleteUntitledWorkspaceSync(r)}doDeleteUntitledWorkspaceSync(r){const a=(0,P.originalFSPath)(r.configPath);try{(0,m.rimrafSync)((0,y.dirname)(a));const h=(0,y.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);(0,n.existsSync)(h)&&(0,m.writeFileSync)((0,y.join)(h,"obsolete"),"")}catch(h){this.logService.warn(`Unable to delete untitled workspace ${a} (${h}).`)}}getUntitledWorkspacesSync(){const r=[];try{const a=(0,m.readdirSync)(this.untitledWorkspacesHome.fsPath).map(h=>(0,P.joinPath)(this.untitledWorkspacesHome,h,o.UNTITLED_WORKSPACE_NAME));for(const h of a){const E=(0,l.getWorkspaceIdentifier)(h),R=this.resolveLocalWorkspaceSync(h);R?r.push({workspace:E,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(E)}}catch(a){a.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${a}).`)}return r}async enterWorkspace(r,a,h){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,a,h))return;const R=this.doEnterWorkspace(r,(0,l.getWorkspaceIdentifier)(h));if(!!R)return this._onDidEnterWorkspace.fire({window:r,workspace:R.workspace}),R}async isValidTargetWorkspacePath(r,a,h){if(!h)return!0;if((0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,h))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(a,h)){const E={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,P.basename)(h)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(E,(0,S.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(r,a){if(!r.config)return;r.focus();let h;return r.config.extensionDevelopmentPath||(h=this.backupMainService.registerWorkspaceBackupSync({workspace:a,remoteAuthority:r.remoteAuthority},r.config.backupPath)),(0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&this.deleteUntitledWorkspaceSync(r.openedWorkspace),r.config.workspace=a,r.config.backupPath=h,{workspace:a,backupPath:h}}};s=ue([ie(0,v.IEnvironmentMainService),ie(1,u.ILogService),ie(2,d.IBackupMainService),ie(3,g.IDialogMainService),ie(4,w.IProductService)],s),e.WorkspacesManagementMainService=s}),define(J[102],Z([0,1,12,23,5,34,26,42]),function(V,e,p,n,D,C,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,D.createDecorator)(e.ID);let f=class{constructor(b,P){this.windowsMainService=b,this.workspacesManagementMainService=P}async getRemoteDiagnostics(b){const P=this.windowsMainService.getWindows();return(await Promise.all(P.map(m=>new Promise(t=>{const d=m.remoteAuthority;if(d){const g=`vscode:getDiagnosticInfoResponse${m.id}`,v={includeProcesses:b.includeProcesses,folders:b.includeWorkspaceMetadata?this.getFolderURIs(m):void 0};m.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:g,args:v}),p.ipcMain.once(g,(k,u)=>{u||t({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),t(u)}),setTimeout(()=>{t({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)}else t(void 0)})))).filter(m=>!!m)}getFolderURIs(b){const P=[],S=b.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(S))P.push(S.uri);else if((0,M.isWorkspaceIdentifier)(S)){const m=this.workspacesManagementMainService.resolveLocalWorkspaceSync(S.configPath);m&&m.folders.forEach(d=>{P.push(d.uri)})}return P}};f=ue([ie(0,C.IWindowsMainService),ie(1,I.IWorkspacesManagementMainService)],f),e.DiagnosticsMainService=f}),define(J[103],Z([0,1,12,30,3,14,7,24,20,52,5,6,99,34,26,42]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let g=class{constructor(k,u,w,c,o){this.logService=k,this.windowsMainService=u,this.urlService=w,this.workspacesManagementMainService=c,this.configurationService=o}async start(k,u){this.logService.trace("Received data from other instance: ",k,u),D.isMacintosh&&p.app.focus({steal:!0});const w=this.parseOpenUrl(k);if(w.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:o,url:l}of w)this.urlService.open(o,{originalUrl:l})})}else return this.startOpenWindow(k,u)}parseOpenUrl(k){return k["open-url"]&&k._urls&&k._urls.length>0?(0,n.coalesce)(k._urls.map(u=>{try{return{uri:M.URI.parse(u),url:u}}catch{return null}})):[]}async startOpenWindow(k,u){const w=(0,y.isLaunchedFromCli)(u)?0:4;let c=[];const o=k.wait&&k.waitMarkerFilePath?M.URI.file(k.waitMarkerFilePath):void 0,l=k.remote||void 0,s={context:w,cli:k,userEnv:u,waitMarkerFileURI:o,remoteAuthority:l};if(k.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(k.extensionDevelopmentPath,s);else if(!k._.length&&!k["folder-uri"]&&!k["file-uri"]){let i=!1;if(k["new-window"]||k["unity-launch"])i=!0;else if(k["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!D.isMacintosh}if(i)c=this.windowsMainService.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,s),c=[r]):c=this.windowsMainService.open({...s,forceEmpty:!0})}}else c=this.windowsMainService.open({...s,forceNewWindow:k["new-window"],preferNewWindow:!k["reuse-window"]&&!k.wait,forceReuseWindow:k["reuse-window"],diffMode:k.diff,addMode:k.add,noRecentEntry:!!k["skip-add-to-recently-opened"],gotoLineMode:k.goto});if(o&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,I.whenDeleted)(o.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const k=[];return p.BrowserWindow.getAllWindows().forEach(u=>{const w=this.windowsMainService.getWindowById(u.id);w?k.push(this.codeWindowToInfo(w)):k.push(this.browserWindowToInfo(u))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:k,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}getFolderURIs(k){const u=[],w=k.openedWorkspace;if((0,t.isSingleFolderWorkspaceIdentifier)(w))u.push(w.uri);else if((0,t.isWorkspaceIdentifier)(w)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(w.configPath);c&&c.folders.forEach(l=>{u.push(l.uri)})}return u}codeWindowToInfo(k){const u=this.getFolderURIs(k),w=(0,C.assertIsDefined)(k.win);return this.browserWindowToInfo(w,u,k.remoteAuthority)}browserWindowToInfo(k,u=[],w){return{pid:k.webContents.getOSProcessId(),title:k.getTitle(),folderURIs:u,remoteAuthority:w}}};g=ue([ie(0,P.ILogService),ie(1,m.IWindowsMainService),ie(2,S.IURLService),ie(3,d.IWorkspacesManagementMainService),ie(4,f.IConfigurationService)],g),e.LaunchMainService=g}),define(J[58],Z([0,1,45,12,25,120,46,4,33,2,10,9,3,7,85,71,24,151,47,22,5,19,6,21,32,65,34,26,42]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w,c,o,l,s,i,r,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,w.createDecorator)("nativeHostMainService");let E=class extends y.Disposable{constructor(L,W,$,Q,ee,x,q,X,H,j){super();this.sharedProcess=L,this.windowsMainService=W,this.dialogMainService=$,this.lifecycleMainService=Q,this.environmentMainService=ee,this.telemetryService=x,this.logService=q,this.productService=X,this.themeMainService=H,this.workspacesManagementMainService=j,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,te=>te.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(te,N)=>N.id),te=>!!this.windowsMainService.getWindowById(te)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(te,N)=>N.id),te=>!!this.windowsMainService.getWindowById(te)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(te,N)=>N.id),te=>!!this.windowsMainService.getWindowById(te)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),te=>!!te),te=>te.id),I.Event.filter(I.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(te,N)=>N.id),te=>!!this.windowsMainService.getWindowById(te))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(te,N,z)=>z),te=>!(Array.isArray(te)&&te.length===1&&te[0]==="workArea")),I.Event.fromNodeEventEmitter(n.screen,"display-added"),I.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(L){return this.windowsMainService.getWindowCount()}async getActiveWindowId(L){const W=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(L,W,$){return Array.isArray(W)?this.doOpenWindow(L,W,$):this.doOpenEmptyWindow(L,W)}async doOpenWindow(L,W,$=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:L,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:$.forceNewWindow,forceReuseWindow:$.forceReuseWindow,preferNewWindow:$.preferNewWindow,diffMode:$.diffMode,addMode:$.addMode,gotoLineMode:$.gotoLineMode,noRecentEntry:$.noRecentEntry,waitMarkerFileURI:$.waitMarkerFileURI,remoteAuthority:$.remoteAuthority||void 0})}async doOpenEmptyWindow(L,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:L},W)}async toggleFullScreen(L){const W=this.windowById(L);W&&W.toggleFullScreen()}async handleTitleDoubleClick(L){const W=this.windowById(L);W&&W.handleTitleDoubleClick()}async isMaximized(L){const W=this.windowById(L);return W?.win?W.win.isMaximized():!1}async maximizeWindow(L){const W=this.windowById(L);W?.win&&W.win.maximize()}async unmaximizeWindow(L){const W=this.windowById(L);W?.win&&W.win.unmaximize()}async minimizeWindow(L){const W=this.windowById(L);W?.win&&W.win.minimize()}async focusWindow(L,W){W&&typeof W.windowId=="number"&&(L=W.windowId);const $=this.windowById(L);$&&$.focus({force:W?.force??!1})}async setMinimumSize(L,W,$){const Q=this.windowById(L);if(Q?.win){const[ee,x]=Q.win.getSize(),[q,X]=Q.win.getMinimumSize(),[H,j]=[W??q,$??X],[te,N]=[Math.max(ee,H),Math.max(x,j)];(q!==H||X!==j)&&Q.win.setMinimumSize(H,j),(ee!==te||x!==N)&&Q.win.setSize(te,N)}}async saveWindowSplash(L,W){this.themeMainService.saveWindowSplash(L,W)}async installShellCommand(L){const{source:W,target:$}=await this.getShellCommandLink();try{const{symbolicLink:Q}=await g.SymlinkSupport.stat(W);if(Q&&!Q.dangling){const ee=await(0,t.realpath)(W);if($===ee)return}await g.Promises.unlink(W)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await g.Promises.symlink($,W)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:ee}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ee===0)try{const x=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${$}' '${W}'\\" with administrator privileges"`;await(0,C.promisify)(p.exec)(x)}catch{throw new Error((0,v.localize)(3,null,W))}}}async uninstallShellCommand(L){const{source:W}=await this.getShellCommandLink();try{await g.Promises.unlink(W)}catch($){switch($.code){case"EACCES":{const{response:Q}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const ee=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,C.promisify)(p.exec)(ee)}catch{throw new Error((0,v.localize)(7,null,W))}break}case"ENOENT":break;default:throw $}}}async getShellCommandLink(){const L=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await g.Promises.exists(L))throw new Error((0,v.localize)(8,null,L));return{source:W,target:L}}async showMessageBox(L,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(L))}async showSaveDialog(L,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(L))}async showOpenDialog(L,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(L))}toBrowserWindow(L){const W=this.windowById(L);if(W?.win)return W.win}async pickFileFolderAndOpen(L,W){const $=await this.dialogMainService.pickFileFolder(W);$&&(this.sendPickerTelemetry($,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all($.map(async Q=>await g.SymlinkSupport.existsDirectory(Q)?{folderUri:m.URI.file(Q)}:{fileUri:m.URI.file(Q)})),W,L))}async pickFolderAndOpen(L,W){const $=await this.dialogMainService.pickFolder(W);$&&(this.sendPickerTelemetry($,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked($.map(Q=>({folderUri:m.URI.file(Q)})),W,L))}async pickFileAndOpen(L,W){const $=await this.dialogMainService.pickFile(W);$&&(this.sendPickerTelemetry($,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked($.map(Q=>({fileUri:m.URI.file(Q)})),W,L))}async pickWorkspaceAndOpen(L,W){const $=await this.dialogMainService.pickWorkspace(W);$&&(this.sendPickerTelemetry($,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked($.map(Q=>({workspaceUri:m.URI.file(Q)})),W,L))}doOpenPicked(L,W,$){this.windowsMainService.open({context:3,contextWindowId:$,cli:this.environmentMainService.args,urisToOpen:L,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(L,W,$){const Q=L?L.length:0;this.telemetryService.publicLog(W,{...$,outcome:Q?"success":"canceled",numberOfPaths:Q})}async showItemInFolder(L,W){n.shell.showItemInFolder(W)}async setRepresentedFilename(L,W){const $=this.windowById(L);$&&$.setRepresentedFilename(W)}async setDocumentEdited(L,W){const $=this.windowById(L);$&&$.setDocumentEdited(W)}async openExternal(L,W){return S.isLinuxSnap?this.safeSnapOpenExternal(W):n.shell.openExternal(W),!0}safeSnapOpenExternal(L){const W=process.env.GDK_PIXBUF_MODULE_FILE,$=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(L),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=$}moveItemToTrash(L,W){return n.shell.trashItem(W)}async isAdmin(){let L;return S.isWindows?L=(await new Promise((W,$)=>{V(["native-is-elevated"],W,$)}))():L=process.getuid()===0,L}async writeElevated(L,W,$,Q){const ee=await new Promise((x,q)=>{V(["@vscode/sudo-prompt"],x,q)});return new Promise((x,q)=>{const X=[`"${this.cliPath}"`];Q?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${W.fsPath}"`,`"${$.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ee.exec(X.join(" "),H,(j,te,N)=>{te&&this.logService.trace(`[sudo-prompt] received stdout: ${te}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),j?q(j):x(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(L,W,$){process.kill(W,$)}async readClipboardText(L,W){return n.clipboard.readText(W)}async writeClipboardText(L,W,$){return n.clipboard.writeText(W,$)}async readClipboardFindText(L){return n.clipboard.readFindText()}async writeClipboardFindText(L,W){return n.clipboard.writeFindText(W)}async writeClipboardBuffer(L,W,$,Q){return n.clipboard.writeBuffer(W,Buffer.from($),Q)}async readClipboardBuffer(L,W){return n.clipboard.readBuffer(W)}async hasClipboard(L,W,$){return n.clipboard.has(W,$)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,W){const $=this.windowById(L);$&&$.updateTouchBar(W)}async notifyReady(L){const W=this.windowById(L);W&&W.setReady()}async relaunch(L,W){return this.lifecycleMainService.relaunch(W)}async reload(L,W){const $=this.windowById(L);if($){if((0,a.isWorkspaceIdentifier)($.openedWorkspace)){const Q=$.openedWorkspace.configPath;if(Q.scheme===b.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Q))?.transient)return this.openWindow($.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload($,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,W){const $=this.windowById(W);if($?.win)return $.win.close()}async quit(L){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(L,W){await this.lifecycleMainService.kill(W)}async resolveProxy(L,W){const Q=this.windowById(L)?.win?.webContents?.session;if(Q)return Q.resolveProxy(W)}async openDevTools(L,W){const $=this.windowById(L);$?.win&&$.win.webContents.openDevTools(W)}async toggleDevTools(L){const W=this.windowById(L);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(L,W){const $=this.windowById(L);$?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&$.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(L,W,$,Q){if(!S.isWindows)return;const ee=await new Promise((x,q)=>{V(["@vscode/windows-registry"],x,q)});try{return ee.GetStringRegKey(W,$,Q)}catch{return}}windowById(L){if(typeof L=="number")return this.windowsMainService.getWindowById(L)}};ue([M.memoize],E.prototype,"cliPath",null),E=ue([ie(1,r.IWindowsMainService),ie(2,k.IDialogMainService),ie(3,c.ILifecycleMainService),ie(4,u.IEnvironmentMainService),ie(5,s.ITelemetryService),ie(6,o.ILogService),ie(7,l.IProductService),ie(8,i.IThemeMainService),ie(9,h.IWorkspacesManagementMainService)],E),e.NativeHostMainService=E}),define(J[238],Z([0,1,12,25,33,2,10,3,86,149,75,102,47,22,5,103,6,58,53,21,54,66]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,t.createDecorator)("issueMainService");let o=class kt{constructor(s,i,r,a,h,E,R,L,W,$){this.userEnv=s,this.environmentMainService=i,this.launchMainService=r,this.logService=a,this.diagnosticsService=h,this.diagnosticsMainService=E,this.dialogMainService=R,this.nativeHostMainService=L,this.protocolMainService=W,this.productService=$,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[i,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(i,r);this.safeSend(s,"vscode:issueSystemInfoResponse",a)}),p.ipcMain.on("vscode:listProcesses",async s=>{const i=[];try{const r=await this.launchMainService.getMainProcessId();i.push({name:(0,y.localize)(0,null),rootProcess:await(0,f.listProcesses)(r)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(h=>{(0,b.isRemoteDiagnosticError)(h)?i.push({name:h.hostName,rootProcess:h}):h.processes&&i.push({name:h.hostName,rootProcess:h.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(s,"vscode:listProcessesResponse",i)}),p.ipcMain.on("vscode:issueReporterClipboard",async s=>{const i={title:this.productService.nameLong,message:(0,y.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,y.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,y.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",r.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const i=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",i)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,y.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,y.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(s,i)=>{const{id:r,from:a,args:h}=i;let E;switch(a){case"issueReporter":E=this.issueReporterParentWindow;break;case"processExplorer":E=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}E&&E.webContents.send("vscode:runAction",{id:r,from:a,args:h})}),p.ipcMain.on("vscode:openExternal",(s,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),p.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async s=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",i.windows)})}safeSend(s,i,...r){s.sender.isDestroyed()||s.sender.send(i,...r)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new C.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,r,{backgroundColor:s.styles.backgroundColor,title:(0,y.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:k.default}),this.issueReporterWindow.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new C.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,r,{backgroundColor:s.styles.backgroundColor,title:(0,y.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:k.default}),this.processExplorerWindow.loadURL(M.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,i,r,a){const h=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:r.title,backgroundColor:r.backgroundColor||kt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${a}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,c.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,i)}getWindowPosition(s,i,r){let a;const h=p.screen.getAllDisplays();if(h.length===1)a=h[0];else{if(I.isMacintosh){const L=p.screen.getCursorScreenPoint();a=p.screen.getDisplayNearestPoint(L)}!a&&s&&(a=p.screen.getDisplayMatching(s.getBounds())),a||(a=p.screen.getPrimaryDisplay()||h[0])}const E={width:i,height:r},R=a.bounds;return E.x=R.x+R.width/2-E.width/2,E.y=R.y+R.height/2-E.height/2,R.width>0&&R.height>0&&(E.x<R.x&&(E.x=R.x),E.y<R.y&&(E.y=R.y),E.x>R.x+R.width&&(E.x=R.x),E.y>R.y+R.height&&(E.y=R.y),E.width>R.width&&(E.width=R.width),E.height>R.height&&(E.height=R.height)),E}async getPerformanceInfo(){try{const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,i)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};o.DEFAULT_BACKGROUND_COLOR="#1E1E1E",o=ue([ie(1,m.IEnvironmentMainService),ie(2,d.ILaunchMainService),ie(3,g.ILogService),ie(4,b.IDiagnosticsService),ie(5,P.IDiagnosticsMainService),ie(6,S.IDialogMainService),ie(7,v.INativeHostMainService),ie(8,w.IProtocolMainService),ie(9,u.IProductService)],o),e.IssueMainService=o}),define(J[239],Z([0,1,23,20,22,19,6,58,21,56,32,41,81]),function(V,e,p,n,D,C,M,I,f,y,b,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let m=class extends S.AbstractUpdateService{constructor(d,g,v,k,u,w,c,o){super(d,g,k,u,w,o);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(d){return(0,S.createUpdateURL)(`linux-${process.arch}`,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(P.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},p.CancellationToken.None).then(y.asJson).then(g=>{!g||!g.url||!g.version||!g.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(g))}).then(void 0,g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const v=d?g.message||g:void 0;this.setState(P.State.Idle(1,v))}))}async doDownloadUpdate(d){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(P.State.Idle(1))}};m=ue([ie(0,C.ILifecycleMainService),ie(1,n.IConfigurationService),ie(2,b.ITelemetryService),ie(3,D.IEnvironmentMainService),ie(4,y.IRequestService),ie(5,M.ILogService),ie(6,I.INativeHostMainService),ie(7,f.IProductService)],m),e.LinuxUpdateService=m}),define(J[240],Z([0,1,45,29,25,8,23,46,9,7,117,24,20,22,18,19,6,58,21,56,32,41,81]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(a,h=1e3){for(;!a();)await(0,C.timeout)(h)}let s;function i(){return typeof s=="undefined"&&(s=n.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),s}let r=class extends o.AbstractUpdateService{constructor(h,E,R,L,W,$,Q,ee,x){super(h,E,L,W,$,x);this.telemetryService=R,this.fileService=Q,this.nativeHostMainService=ee}get cachePath(){const h=f.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(h,{recursive:!0}).then(()=>h)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(h){let E="win32";return process.arch!=="ia32"&&(E+=`-${process.arch}`),i()===1?E+="-archive":this.productService.target==="user"&&(E+="-user"),(0,o.createUpdateURL)(E,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(c.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},M.CancellationToken.None).then(u.asJson).then(E=>{const R=i();return!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(E)),Promise.resolve(null)):(this.setState(c.State.Downloading(E)),this.cleanup(E.version).then(()=>this.getUpdatePackagePath(E.version).then(L=>P.Promises.exists(L).then(W=>{if(W)return Promise.resolve(L);const $=E.url,Q=E.hash,ee=`${L}.tmp`;return this.requestService.request({url:$},M.CancellationToken.None).then(x=>this.fileService.writeFile(y.URI.file(ee),x.stream)).then(Q?()=>(0,b.checksum)(ee,E.hash):()=>{}).then(()=>P.Promises.rename(ee,L)).then(()=>L)})).then(L=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},W&&E.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(E)):this.setState(c.State.Ready(E))})))}).then(void 0,E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const R=h?E.message||E:void 0;this.setState(c.State.Idle(i(),R))}))}async doDownloadUpdate(h){h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(c.State.Idle(i()))}async getUpdatePackagePath(h){const E=await this.cachePath;return f.join(E,`CodeSetup-${this.productService.quality}-${h}.exe`)}async cleanup(h=null){const E=h?$=>!new RegExp(`${this.productService.quality}-${h}\\.exe$`).test($):()=>!0,R=await this.cachePath,W=(await P.Promises.readdir(R)).filter(E).map(async $=>{try{await P.Promises.unlink(f.join(R,$))}catch{}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const h=this.state.update;this.setState(c.State.Updating(h));const E=await this.cachePath;this.availableUpdate.updateFilePath=f.join(E,`CodeSetup-${this.productService.quality}-${h.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(i()))});const L=`${this.productService.win32MutexName}-ready`,W=await new Promise(($,Q)=>{V(["windows-mutex"],$,Q)});l(()=>W.isActive(L)).then(()=>this.setState(c.State.Ready(h)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};ue([I.memoize],r.prototype,"cachePath",null),r=ue([ie(0,d.ILifecycleMainService),ie(1,S.IConfigurationService),ie(2,w.ITelemetryService),ie(3,m.IEnvironmentMainService),ie(4,u.IRequestService),ie(5,g.ILogService),ie(6,t.IFileService),ie(7,v.INativeHostMainService),ie(8,k.IProductService)],r),e.Win32UpdateService=r}),define(J[241],Z([0,1,12,8,23,39,4,33,2,10,9,63,3,7,155,50,20,47,22,52,18,19,6,21,54,207,80,32,210,65,66,34,26,42]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w,c,o,l,s,i,r,a,h,E,R,L,W,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(Q||(Q={}));let ee=class extends f.Disposable{constructor(q,X,H,j,te,N,z,K,B,T,_,F,A,O,U){super();this.logService=X,this.environmentMainService=H,this.fileService=j,this.globalStorageMainService=te,this.configurationService=N,this.themeMainService=z,this.workspacesManagementMainService=K,this.backupMainService=B,this.telemetryService=T,this.dialogMainService=_,this.lifecycleMainService=F,this.productService=A,this.protocolMainService=O,this.windowsMainService=U,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[G,ne]=this.restoreWindowState(q.state);this.windowState=G,this.logService.trace("window#ctor: using window state",G);const ce=this.windowState.mode===0||this.windowState.mode===3,ae=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:R.WindowMinimumSize.WIDTH,minHeight:R.WindowMinimumSize.HEIGHT,show:!ce,title:this.productService.nameLong,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,R.zoomLevelToZoomFactor)(ae?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};S.isLinux?re.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),S.isMacintosh&&(re.acceptFirstMouse=!0,ae?.clickThroughInactive===!1&&(re.acceptFirstMouse=!1));const le=S.isMacintosh&&ae?.nativeTabs===!0;le&&(re.tabbingIdentifier=this.productService.nameShort);const he=(0,R.getTitleBarStyle)(this.configurationService)==="custom";if(he&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,S.isMacintosh||(re.frame=!1)),(0,P.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(re),(0,P.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),S.isMacintosh&&he&&this._win.setSheetOffset(22),S.isMacintosh&&ne&&(!le||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(me=>typeof me=="number")){const me=this.windowState;this._win.setBounds({width:me.width,height:me.height,x:me.x,y:me.y})}ce&&((0,P.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,P.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(q){S.isMacintosh?this._win.setRepresentedFilename(q):this.representedFilename=q}getRepresentedFilename(){return S.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(q){S.isMacintosh&&this._win.setDocumentEdited(q),this.documentEdited=q}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(q){S.isMacintosh&&q?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.info(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(q=>{if(this.isReady)return q(this);this.whenReadyCallbacks.push(q)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(q=>{function X(){H.dispose(),j.dispose(),q()}const H=this.onDidClose(()=>X()),j=this.onWillLoad(()=>X())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(X,H)=>this.onWindowError(2,H)),this._win.webContents.on("did-fail-load",(X,H,j)=>this.onWindowError(3,{reason:j,exitCode:H})),this._win.webContents.on("will-prevent-unload",X=>{X.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",X=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",X,this._win)}),this._win.on("unmaximize",X=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",X,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(X=>this.onDidDeleteUntitledWorkspace(X)));const q=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:q},async(X,H)=>{const j=await this.getMarketplaceHeaders();H({cancel:!1,requestHeaders:Object.assign(X.requestHeaders,j)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(q,X){switch(q){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${X?.reason||"<unknown>"}, code: ${X?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${X?.reason||"<unknown>"}, code: ${X?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:q,reason:X?.reason,code:X?.exitCode}),q){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(q===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(H.response!==1){const j=H.response===0;this.destroyWindow(j)}}else if(q===2){let H;X?H=(0,t.localize)(6,null,X.reason,X.exitCode??"<unknown>"):H=(0,t.localize)(5,null);const te=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:H,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(te)}break}}destroyWindow(q){if(this._onDidDestroy.fire(),this._win?.destroy(),q&&this.config){let X,H;(0,W.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?X={folderUri:this.openedWorkspace.uri}:(0,W.isWorkspaceIdentifier)(this.openedWorkspace)?X={workspaceUri:this.openedWorkspace.configPath}:H=!0;const[j]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:X?[X]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});j.focus()}}onDidDeleteUntitledWorkspace(q){this.openedWorkspace?.id===q.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const q=this.getMenuBarVisibility();q!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=q,this.setMenuBarVisibility(q));let X=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;X?.endsWith("/")&&(X=X.substr(0,X.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((X||"").indexOf("@")===-1&&(X!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=X,this.currentNoProxy=H;const j=X||"",te=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${j}', bypassing '${te}'`),this._win.webContents.session.setProxy({proxyRules:j,proxyBypassRules:te,pacScript:""})}}addTabbedWindow(q){S.isMacintosh&&q.win&&this._win.addTabbedWindow(q.win)}load(q,X=Object.create(null)){this.logService.info(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!X.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),X.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(q,X),this.readyState===0?this.currentConfig=q:this.pendingLoadConfig=q,this.readyState=1,this._win.loadURL(y.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:q.workspace,reason:X.isReload?3:H?2:1})}updateConfiguration(q,X){const H=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(H){const j=(0,u.isLaunchedFromCli)(H)&&!(0,u.isLaunchedFromCli)(q.userEnv),te=this.isExtensionDevelopmentHost;(j||te)&&(q.userEnv={...H,...q.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(q.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),X.disableExtensions!==void 0&&(q["disable-extensions"]=X.disableExtensions),q.fullscreen=this.isFullScreen,q.maximized=this._win.isMaximized(),q.partsSplash=this.themeMainService.getWindowSplash(),(0,P.mark)("code/willOpenNewWindow"),q.perfMarks=(0,P.getMarks)(),this.configObjectUrl.update(q)}async reload(q){const X=Object.assign({},this.currentConfig);X.workspace=await this.validateWorkspaceBeforeReload(X),delete X.filesToOpenOrCreate,delete X.filesToDiff,delete X.filesToWait,this.isExtensionDevelopmentHost&&q&&(X.verbose=q.verbose,X.debugId=q.debugId,X.extensionEnvironment=q.extensionEnvironment,X["inspect-extensions"]=q["inspect-extensions"],X["inspect-brk-extensions"]=q["inspect-brk-extensions"],X["extensions-dir"]=q["extensions-dir"]),X.isInitialStartup=!1,this.load(X,{isReload:!0,disableExtensions:q?.["disable-extensions"]})}async validateWorkspaceBeforeReload(q){if((0,W.isWorkspaceIdentifier)(q.workspace)){const X=q.workspace.configPath;if(X.scheme===y.Schemas.file&&!await this.fileService.exists(X))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(q.workspace)){const X=q.workspace.uri;if(X.scheme===y.Schemas.file&&!await this.fileService.exists(X))return}return q.workspace}serializeWindowState(){if(!this._win)return(0,L.defaultWindowState)();if(this.isFullScreen){let H;try{H=p.screen.getDisplayMatching(this.getBounds())}catch{}const j=(0,L.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||j.width,height:this.windowState.height||j.height,x:this.windowState.x||0,y:this.windowState.y||0}}const q=Object.create(null);let X;if(!S.isMacintosh&&this._win.isMaximized()?X=0:X=1,X===0?q.mode=0:q.mode=1,X===1||X===0){let H;X===1?H=this.getBounds():H=this._win.getNormalBounds(),q.x=H.x,q.y=H.y,q.width=H.width,q.height=H.height}return q}restoreWindowState(q){(0,P.mark)("code/willRestoreCodeWindowState");let X=!1;if(q)try{const H=p.screen.getAllDisplays();X=H.length>1,q=this.validateWindowState(q,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,P.mark)("code/didRestoreCodeWindowState"),[q||(0,L.defaultWindowState)(),X]}validateWindowState(q,X){if(this.logService.trace(`window#validateWindowState: validating window state on ${X.length} display(s)`,q),typeof q.x!="number"||typeof q.y!="number"||typeof q.width!="number"||typeof q.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(q.width<=0||q.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(X.length===1){const te=this.getWorkingArea(X[0]);if(te){let N=function(){!q||typeof q.x!="number"||typeof q.y!="number"||!te||(q.x<te.x&&(q.x=te.x),q.y<te.y&&(q.y=te.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",te),N(),q.width>te.width&&(q.width=te.width),q.height>te.height&&(q.height=te.height),q.x>te.x+te.width-128&&(q.x=te.x+te.width-q.width),q.y>te.y+te.height-128&&(q.y=te.y+te.height-q.height),N()}return q}if(q.display&&q.mode===3){const te=X.find(N=>N.id===q.display);if(te&&typeof te.bounds?.x=="number"&&typeof te.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,L.defaultWindowState)(3);return N.x=te.bounds.x,N.y=te.bounds.y,N}}let H,j;try{H=p.screen.getDisplayMatching({x:q.x,y:q.y,width:q.width,height:q.height}),j=this.getWorkingArea(H)}catch{}if(H&&j&&q.x+q.width>j.x&&q.y+q.height>j.y&&q.x<j.x+j.width&&q.y<j.y+j.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",j),q}getWorkingArea(q){if(q.workArea.width>0&&q.workArea.height>0)return q.workArea;if(q.bounds.width>0&&q.bounds.height>0)return q.bounds}getBounds(){const[q,X]=this._win.getPosition(),[H,j]=this._win.getSize();return{x:q,y:X,width:H,height:j}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(q){this.useNativeFullScreen()?this.setNativeFullScreen(q):this.setSimpleFullScreen(q),this.sendWhenReady(q?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(q){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(q)}setSimpleFullScreen(q){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(q),this._win.webContents.focus()}useNativeFullScreen(){const q=this.configurationService.getValue("window");return!q||typeof q.nativeFullScreen!="boolean"||q.nativeTabs?!0:q.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let q=(0,R.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(q)<0&&(q="classic"),q}setMenuBarVisibility(q,X=!0){S.isMacintosh||(q==="toggle"&&X&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),q==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(q)}):this.doSetMenuBarVisibility(q))}doSetMenuBarVisibility(q){const X=this.isFullScreen;switch(q){case"classic":this._win.setMenuBarVisibility(!X),this._win.autoHideMenuBar=X;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(S.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(q,X,...H){this.isReady?this.send(q,...H):this.ready().then(()=>{X.isCancellationRequested||this.send(q,...H)})}send(q,...X){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${q}' for window that is destroyed`);return}try{this._win.webContents.send(q,...X)}catch(H){this.logService.warn(`Error sending IPC message to channel '${q}' of window ${this._id}: ${(0,C.toErrorMessage)(H)}`)}}}updateTouchBar(q){!S.isMacintosh||this.touchBarGroups.forEach((X,H)=>{const j=q[H];X.segments=this.createTouchBarGroupSegments(j)})}createTouchBar(){if(!!S.isMacintosh){for(let q=0;q<10;q++){const X=this.createTouchBarGroup();this.touchBarGroups.push(X)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(q=[]){const X=this.createTouchBarGroupSegments(q),H=new p.TouchBar.TouchBarSegmentedControl({segments:X,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:H.segments[j].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(q=[]){return q.map(H=>{let j;H.icon&&!h.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===y.Schemas.file&&(j=p.nativeImage.createFromPath(m.URI.revive(H.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let te;return typeof H.title=="string"?te=H.title:te=H.title.value,{id:H.id,label:j?void 0:te,icon:j}})}dispose(){super.dispose(),this._win=null}};ee=ue([ie(1,o.ILogService),ie(2,k.IEnvironmentMainService),ie(3,w.IFileService),ie(4,r.IGlobalStorageMainService),ie(5,g.IConfigurationService),ie(6,E.IThemeMainService),ie(7,$.IWorkspacesManagementMainService),ie(8,d.IBackupMainService),ie(9,a.ITelemetryService),ie(10,v.IDialogMainService),ie(11,c.ILifecycleMainService),ie(12,l.IProductService),ie(13,s.IProtocolMainService),ie(14,L.IWindowsMainService)],ee),e.CodeWindow=ee}),define(J[67],Z([0,1,12,30,8,4,33,2,10,3,16,7,24,158,5,19,6,38,80,26,42]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let c=class ze extends I.Disposable{constructor(l,s,i,r,a){super();this.stateMainService=l,this.logService=s,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this.globalStorageMainService=a,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){const s=[],i=[];for(let r of l)if((0,u.isRecentWorkspace)(r))!this.workspacesManagementMainService.isUntitledWorkspace(r.workspace)&&this.indexOfWorkspace(s,r.workspace)===-1&&s.push(r);else if((0,u.isRecentFolder)(r))this.indexOfFolder(s,r.folderUri)===-1&&s.push(r);else{const a=this.indexOfFile(i,r.fileUri)>=0,h=r.fileUri.scheme===f.Schemas.file&&ze.COMMON_FILES_FILTER.indexOf((0,b.basename)(r.fileUri))>=0;!a&&!h&&(i.push(r),y.isWindows&&r.fileUri.scheme===f.Schemas.file&&p.app.addRecentDocument(r.fileUri.fsPath))}await this.addEntriesFromStorage(s,i),s.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(s.length=ze.MAX_TOTAL_RECENT_ENTRIES),i.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(i.length=ze.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:s,files:i}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(l){const s=h=>{const E=this.location(h);for(const R of l)if(b.extUriBiasedIgnorePathCase.isEqual(R,E))return!1;return!0},i=await this.getRecentlyOpened(),r=i.workspaces.filter(s),a=i.files.filter(s);(r.length!==i.workspaces.length||a.length!==i.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:r}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(l){const s=[],i=[];if(l){const a=l.config?.workspace;(0,u.isWorkspaceIdentifier)(a)&&!this.workspacesManagementMainService.isUntitledWorkspace(a)?s.push({workspace:a,remoteAuthority:l.remoteAuthority}):(0,u.isSingleFolderWorkspaceIdentifier)(a)&&s.push({folderUri:a.uri,remoteAuthority:l.remoteAuthority})}const r=l?.config?.filesToOpenOrCreate;if(r)for(let a of r){const h=a.fileUri;h&&this.indexOfFile(i,h)===-1&&i.push({fileUri:h})}return await this.addEntriesFromStorage(s,i),{workspaces:s,files:i}}async addEntriesFromStorage(l,s){let i=await this.getRecentlyOpenedFromStorage();for(let r of i.workspaces){let a=(0,u.isRecentFolder)(r)?this.indexOfFolder(l,r.folderUri):this.indexOfWorkspace(l,r.workspace);a>=0?l[a].label=l[a].label||r.label:l.push(r)}for(let r of i.files){let a=this.indexOfFile(s,r.fileUri);a>=0?s[a].label=s[a].label||r.label:s.push(r)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let l;const s=this.globalStorageMainService.get(ze.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof s=="string")try{l=JSON.parse(s)}catch(i){this.logService.error("Unexpected error parsing opened paths list",i)}else l=this.stateMainService.getItem(ze.legacyRecentlyOpenedStorageKey),l&&(this.stateMainService.removeItem(ze.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store(ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(l),0,1));return(0,u.restoreRecentlyOpened)(l,this.logService)}async saveRecentlyOpened(l){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,u.toStoreData)(l)),0,1)}location(l){return(0,u.isRecentFolder)(l)?l.folderUri:(0,u.isRecentFile)(l)?l.fileUri:l.workspace.configPath}indexOfWorkspace(l,s){return l.findIndex(i=>(0,u.isRecentWorkspace)(i)&&i.workspace.id===s.id)}indexOfFolder(l,s){return l.findIndex(i=>(0,u.isRecentFolder)(i)&&b.extUriBiasedIgnorePathCase.isEqual(i.folderUri,s))}indexOfFile(l,s){return l.findIndex(i=>b.extUriBiasedIgnorePathCase.isEqual(i.fileUri,s))}async handleWindowsJumpList(){!y.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!y.isWindows)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let s=[];for(let a of p.app.getJumpListSettings().removedItems){const h=a.args;if(h){const E=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);E&&s.push(P.URI.parse(E[2]))}}await this.removeRecentlyOpened(s);let i=!1;const r=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,ze.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const h=(0,u.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:E,description:R}=this.getWindowsJumpListLabel(h,a.label);let L;return P.URI.isUri(h)?L=`--folder-uri "${h.toString()}"`:(i=!0,L=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:E.substr(0,255),description:R.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));r.length>0&&l.push({type:"custom",name:i?(0,m.localize)(2,null):(0,m.localize)(3,null),items:r})}l.push({type:"recent"});try{p.app.setJumpList(l)}catch(s){this.logService.warn("updateWindowsJumpList#setJumpList",s)}}getWindowsJumpListLabel(l,s){if(s)return{title:(0,M.splitName)(s).name,description:s};if(P.URI.isUri(l))return{title:(0,b.basename)(l),description:this.renderJumpListPathDescription(l)};if(this.workspacesManagementMainService.isUntitledWorkspace(l))return{title:(0,m.localize)(4,null),description:""};let i=(0,b.basename)(l.configPath);return i.endsWith(u.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,i),description:this.renderJumpListPathDescription(l.configPath)}}renderJumpListPathDescription(l){return l.scheme==="file"?(0,M.normalizeDriveLetter)(l.fsPath):l.toString()}async updateMacOSRecentDocuments(){if(!y.isMacintosh)return;p.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),s=[];let i=0;for(let a=0;a<l.workspaces.length&&i<ze.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const h=this.location(l.workspaces[a]);if(h.scheme===f.Schemas.file){const E=(0,b.originalFSPath)(h);await S.Promises.exists(E)&&(s.push(E),i++)}}const r=[];for(let a=0;a<l.files.length&&i<ze.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const h=this.location(l.files[a]);if(h.scheme===f.Schemas.file){const E=(0,b.originalFSPath)(h);if(ze.COMMON_FILES_FILTER.includes((0,b.basename)(h))||s.includes(E))continue;await S.Promises.exists(E)&&(r.push(E),i++)}}r.reverse().forEach(a=>p.app.addRecentDocument(a)),s.reverse().forEach(a=>p.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.legacyRecentlyOpenedStorageKey="openedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=ue([ie(0,v.IStateMainService),ie(1,g.ILogService),ie(2,w.IWorkspacesManagementMainService),ie(3,d.ILifecycleMainService),ie(4,k.IGlobalStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(J[242],Z([0,1,12,8,23,33,3,7,150,20,22,19,6,191,58,21,38,32,41,66,34,67]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let l=class Et{constructor(r,a,h,E,R,L,W,$,Q,ee,x){this.updateService=r,this.configurationService=a,this.windowsMainService=h,this.environmentMainService=E,this.telemetryService=R,this.workspacesHistoryMainService=L,this.stateMainService=W,this.lifecycleMainService=$,this.logService=Q,this.nativeHostMainService=ee,this.productService=x,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,u.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const r=this.stateMainService.getItem(Et.lastKnownMenubarStorageKey);r&&(r.menus&&(this.menubarMenus=r.menus),r.keybindings&&(this.keybindings=r.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,W,$)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,W,$)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,W,$)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick($),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,W,$)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick($),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const r=this.productService.twitterUrl;r&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(r,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const h=this.productService.reportIssueUrl;h&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(h,"openReportIssues"));const E=this.productService.licenseUrl;E&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const L=E.indexOf("?")>0?"&":"?";this.openUrl(`${E}${L}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(E,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&E&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(r=>this.onDidChangeWindowsCount(r)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let r=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;let r=this.configurationService.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,a){this.menubarMenus=r.menus,this.keybindings=r.keybindings,this.stateMainService.setItem(Et.lastKnownMenubarStorageKey,r),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(r){!M.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.closedLastWindow=r.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const r=p.Menu.getApplicationMenu();if(r&&this.oldMenus.push(r),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(M.isMacintosh?new p.Menu:null);return}const a=new p.Menu;let h;if(M.isMacintosh){const R=new p.Menu;h=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),a.append(h)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:R});this.setMenuById(R,"File"),a.append(L)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),a.append(L)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),a.append(L)}if(this.shouldDrawMenu("View")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:R});this.setMenuById(R,"View"),a.append(L)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),a.append(L)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),a.append(L)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),a.append(L)}let E;if(this.shouldDrawMenu("Window")){const R=new p.Menu;E=new p.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(E&&a.append(E),this.shouldDrawMenu("Help")){const R=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),a.append(L)}a.items&&a.items.length>0?p.Menu.setApplicationMenu(a):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(r){const a=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),h=this.getUpdateMenuItems();let E;if(this.shouldDrawMenu("Preferences")){const q=new p.Menu;this.setMenuById(q,"Preferences"),E=new p.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:q})}const R=new p.Menu,L=new p.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),W=new p.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),$=new p.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new p.MenuItem({label:f.localize(15,null),role:"unhide"}),ee=new p.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),x=[a];x.push(...h),E&&x.push(s(),E),x.push(s(),L,s(),W,$,Q,s(),ee),x.forEach(q=>r.append(q))}shouldDrawMenu(r){if(!M.isMacintosh&&(0,u.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(r){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[r];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[r]}}setMenu(r,a){a.forEach(h=>{if((0,m.isMenubarMenuItemSeparator)(h))r.append(s());else if((0,m.isMenubarMenuItemSubmenu)(h)){const E=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(h.label),submenu:E});this.setMenu(E,h.submenu.items),r.append(R)}else(0,m.isMenubarMenuItemRecentAction)(h)?r.append(this.createOpenRecentMenuItem(h)):(0,m.isMenubarMenuItemAction)(h)&&(h.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(r),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[h.id]?r.append(new p.MenuItem(this.likeAction(h.id,{label:this.mnemonicLabel(h.label),click:this.fallbackMenuHandlers[h.id]}))):r.append(this.createMenuItem(h.label,h.id,!1,h.checked)):r.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)):r.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)))})}setMenuById(r,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(r,this.menubarMenus[a].items)}insertCheckForUpdatesItems(r){const a=this.getUpdateMenuItems();a.length&&(a.forEach(h=>r.append(h)),r.append(s()))}createOpenRecentMenuItem(r){const a=I.URI.revive(r.uri),h=r.id,E=h==="openRecentFile"?{fileUri:a}:h==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new p.MenuItem(this.likeAction(h,{label:r.label,click:(R,L,W)=>{const $=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[E],forceNewWindow:$,gotoLineMode:!1,remoteAuthority:r.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(r){return!!(r&&(!M.isMacintosh&&(r.ctrlKey||r.shiftKey)||M.isMacintosh&&(r.metaKey||r.altKey)))}createRoleMenuItem(r,a,h){const E={label:this.mnemonicLabel(r),role:h,enabled:!0};return new p.MenuItem(this.withKeybinding(a,E))}setMacWindowMenu(r){const a=new p.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),h=new p.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),E=new p.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(s()),L.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,h,s(),R,...L,s(),E].forEach(W=>r.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(r,a,h,E){const R=this.mnemonicLabel(r),L=typeof a=="function"?a:(x,q,X)=>{const H=x?x.userSettingsLabel:null;let j=a;Array.isArray(a)&&(j=this.isOptionClick(X)?a[1]:a[0]),H&&X.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:j})},W=typeof h=="boolean"?h:this.windowsMainService.getWindowCount()>0,$=typeof E=="boolean"?E:!1,Q={label:R,click:L,enabled:W};$&&(Q.type="checkbox",Q.checked=$);let ee;return typeof a=="string"?ee=a:Array.isArray(a)&&(ee=a[0]),M.isMacintosh&&(ee==="editor.action.clipboardCutAction"?Q.role="cut":ee==="editor.action.clipboardCopyAction"?Q.role="copy":ee==="editor.action.clipboardPasteAction"&&(Q.role="paste"),ee==="undo"?Q.click=this.makeContextAwareClickHandler(L,{inDevTools:x=>x.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):ee==="redo"?Q.click=this.makeContextAwareClickHandler(L,{inDevTools:x=>x.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):ee==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(L,{inDevTools:x=>x.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(ee,Q))}makeContextAwareClickHandler(r,a){return(h,E,R)=>{const L=p.BrowserWindow.getFocusedWindow();if(!L)return a.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return a.inDevTools(L.webContents.devToolsWebContents);r(h,E||L,R)}}runActionInRenderer(r){let a=p.BrowserWindow.getFocusedWindow();if(!a){const E=this.windowsMainService.getLastActiveWindow();E?.isMinimized()&&(a=E.win)}const h=a?this.windowsMainService.getWindowById(a.id):void 0;if(h){if(this.logService.trace("menubar#runActionInRenderer",r),M.isMacintosh&&!this.environmentMainService.isBuilt&&!h.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const E={id:r.commandId,from:"menu"};h.sendWhenReady("vscode:runAction",D.CancellationToken.None,E)}else{const E={userSettingsLabel:r.userSettingsLabel};h.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,E)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",r)}withKeybinding(r,a){const h=typeof r=="string"?this.keybindings[r]:void 0;if(h?.label){if(h.isNative!==!1)a.accelerator=h.label,a.userSettingsLabel=h.userSettingsLabel;else if(typeof a.label=="string"){const E=a.label.indexOf("[");E>=0?a.label=`${a.label.substr(0,E)} [${h.label}]`:a.label=`${a.label} [${h.label}]`}}else a.accelerator=void 0;return a}likeAction(r,a,h=!a.accelerator){h&&(a=this.withKeybinding(r,a));const E=a.click;return a.click=(R,L,W)=>{this.reportMenuActionTelemetry(r),E&&E(R,L,W)},a}openUrl(r,a){this.nativeHostMainService.openExternal(void 0,r),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(r){this.telemetryService.publicLog2("workbenchActionExecuted",{id:r,from:o})}mnemonicLabel(r){return(0,C.mnemonicMenuLabel)(r,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=ue([ie(0,k.IUpdateService),ie(1,y.IConfigurationService),ie(2,w.IWindowsMainService),ie(3,b.IEnvironmentMainService),ie(4,v.ITelemetryService),ie(5,c.IWorkspacesHistoryMainService),ie(6,g.IStateMainService),ie(7,P.ILifecycleMainService),ie(8,S.ILogService),ie(9,t.INativeHostMainService),ie(10,d.IProductService)],l),e.Menubar=l;function s(){return new p.MenuItem({type:"separator"})}}),define(J[243],Z([0,1,5,19,6,242]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let M=class{constructor(f,y,b){this.instantiationService=f,this.lifecycleMainService=y,this.logService=b,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(f,y){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(y,f)}};M=ue([ie(0,p.IInstantiationService),ie(1,n.ILifecycleMainService),ie(2,D.ILogService)],M),e.MenubarMainService=M}),define(J[244],Z([0,1,12,29,25,30,23,4,28,43,33,2,10,9,63,3,36,16,14,7,156,50,20,47,22,18,5,19,6,53,21,54,78,38,66,241,100,224,26,101,67,42]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w,c,o,l,s,i,r,a,h,E,R,L,W,$,Q,ee,x,q,X,H,j,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(B){return(0,X.isWorkspaceIdentifier)(B?.workspace)}function z(B){return(0,X.isSingleFolderWorkspaceIdentifier)(B?.workspace)}let K=class rt extends P.Disposable{constructor(T,_,F,A,O,U,G,ne,ce,ae,re,le,he,me,ke){super();this.machineId=T,this.initialUserEnv=_,this.logService=F,this.stateMainService=A,this.environmentMainService=O,this.lifecycleMainService=U,this.backupMainService=G,this.configurationService=ne,this.workspacesHistoryMainService=ce,this.workspacesManagementMainService=ae,this.instantiationService=re,this.dialogMainService=le,this.fileService=he,this.productService=me,this.protocolMainService=ke,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(T=>this._onDidSignalReadyWindow.fire(T.window))),this._register(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const _=new P.DisposableStore;if(_.add(I.Event.any(T.onDidClose,T.onDidDestroy)(()=>_.dispose())),T.config.extensionDevelopmentPath)for(const F of T.config.extensionDevelopmentPath)_.add(this.protocolMainService.addValidFileRoot(u.URI.file(F)));T.config.extensionTestsPath&&_.add(this.protocolMainService.addValidFileRoot(u.URI.file(T.config.extensionTestsPath)))}}))}openEmptyWindow(T,_){let F=this.environmentMainService.args;const A=_?.remoteAuthority||void 0,O=!0,U=_?.forceReuseWindow,G=!U;return this.open({...T,cli:F,forceEmpty:O,forceNewWindow:G,forceReuseWindow:U,remoteAuthority:A})}openExistingWindow(T,_){T.focus(),this.handleWaitMarkerFile(_,[T])}open(T){this.logService.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const _=[],F=[],A=[],O=[],U=[];let G,ne=0;const ce=this.getPathsToOpen(T);this.logService.trace("windowsManager#open pathsToOpen",ce);for(const he of ce)z(he)?T.addMode?_.push(he):F.push(he):N(he)?A.push(he):he.fileUri?(G||(G={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:he.remoteAuthority}),G.filesToOpenOrCreate.push(he)):he.backupPath?U.push({backupFolder:(0,m.basename)(he.backupPath),remoteAuthority:he.remoteAuthority}):ne++;T.diffMode&&G&&G.filesToOpenOrCreate.length>=2&&(G.filesToDiff=G.filesToOpenOrCreate.slice(0,2),G.filesToOpenOrCreate=[]),G&&T.waitMarkerFileURI&&(G.filesToWait={paths:[...G.filesToDiff,...G.filesToOpenOrCreate],waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?(O.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),A.push(...O),U.push(...this.backupMainService.getEmptyWindowBackupPaths())):U.length=0;const{windows:ae,filesOpenedInWindow:re}=this.doOpen(T,A,F,U,ne,G,_);if(this.logService.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${A.length}, foldersToOpen: ${F.length}, emptyToRestore: ${U.length}, emptyToOpen: ${ne})`),ae.length>1)if(re)re.focus();else{const he=this.windowsStateHandler.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let me=!0,ke=!0;if(he){const Ce=ae.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ce.length&&(Ce[0].focus(),me=!1,ke=!1)}if(me)for(let Ce=ae.length-1;Ce>=0;Ce--){const Se=ae[Ce];if(!(Se.openedWorkspace&&O.some(pe=>Se.openedWorkspace&&pe.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&U.some(pe=>Se.backupPath&&pe.backupFolder===(0,m.basename)(Se.backupPath)))){Se.focus(),ke=!1;break}}ke&&ae[ae.length-1].focus()}const le=G&&G.filesToDiff.length>0;if(!ae.some(he=>he.isExtensionDevelopmentHost)&&!le&&!T.noRecentEntry){const he=[];for(const me of ce)N(me)&&!me.transient?he.push({label:me.label,workspace:me.workspace,remoteAuthority:me.remoteAuthority}):z(me)?he.push({label:me.label,folderUri:me.workspace.uri,remoteAuthority:me.remoteAuthority}):me.fileUri&&he.push({label:me.label,fileUri:me.fileUri,remoteAuthority:me.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(he)}return this.handleWaitMarkerFile(T,ae),ae}handleWaitMarkerFile(T,_){const F=T.waitMarkerFileURI;T.context===0&&F&&_.length===1&&_[0]&&(async()=>{await _[0].whenClosedOrLoaded;try{await this.fileService.del(F)}catch{}})()}doOpen(T,_,F,A,O,U,G){const ne=[];let ce;function ae(Se,pe){ne.push(Se),pe&&(ce=Se,U=void 0)}let{openFolderInNewWindow:re,openFilesInNewWindow:le}=this.shouldOpenNewWindow(T);if(!T.initialStartup&&G.length>0){const Se=G[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(Se);pe&&ae(this.doAddFoldersToExistingWindow(pe,G.map(be=>be.workspace.uri)))}const he=F.length+_.length+A.length;if(U&&he===0){const Se=U.filesToOpenOrCreate[0]||U.filesToDiff[0],pe=this.getWindows().filter(Re=>U&&(0,v.isEqualAuthority)(Re.remoteAuthority,U.remoteAuthority));let be;Se?.fileUri&&!le&&((T.context===4||T.context===0||T.context===1)&&(be=(0,x.findWindowOnFile)(pe,Se.fileUri,Re=>Re.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),be||(be=this.doGetLastActiveWindow(pe))),be?(0,X.isWorkspaceIdentifier)(be.openedWorkspace)?_.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,X.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?F.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):ae(this.doOpenFilesInExistingWindow(T,be,U),!0):ae(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:U,forceNewWindow:!0,remoteAuthority:U.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow}),!0)}const me=(0,C.distinct)(_,Se=>Se.workspace.id);if(me.length>0){const Se=(0,C.coalesce)(me.map(pe=>(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(Se.length>0){const pe=Se[0],be=(0,v.isEqualAuthority)(U?.remoteAuthority,pe.remoteAuthority)?U:void 0;ae(this.doOpenFilesInExistingWindow(T,pe,be),!!be),re=!0}me.forEach(pe=>{if(Se.some(Ue=>Ue.openedWorkspace&&Ue.openedWorkspace.id===pe.workspace.id))return;const be=pe.remoteAuthority,Re=(0,v.isEqualAuthority)(U?.remoteAuthority,be)?U:void 0;ae(this.doOpenFolderOrWorkspace(T,pe,re,Re),!!Re),re=!0})}const ke=(0,C.distinct)(F,Se=>v.extUriBiasedIgnorePathCase.getComparisonKey(Se.workspace.uri));if(ke.length>0){const Se=(0,C.coalesce)(ke.map(pe=>(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(Se.length>0){const pe=Se[0],be=(0,v.isEqualAuthority)(U?.remoteAuthority,pe.remoteAuthority)?U:void 0;ae(this.doOpenFilesInExistingWindow(T,pe,be),!!be),re=!0}ke.forEach(pe=>{if(Se.some(Ue=>(0,X.isSingleFolderWorkspaceIdentifier)(Ue.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Ue.openedWorkspace.uri,pe.workspace.uri)))return;const be=pe.remoteAuthority,Re=(0,v.isEqualAuthority)(U?.remoteAuthority,be)?U:void 0;ae(this.doOpenFolderOrWorkspace(T,pe,re,Re),!!Re),re=!0})}const Ce=(0,C.distinct)(A,Se=>Se.backupFolder);if(Ce.length>0&&Ce.forEach(Se=>{const pe=Se.remoteAuthority,be=(0,v.isEqualAuthority)(U?.remoteAuthority,pe)?U:void 0;ae(this.doOpenEmpty(T,!0,pe,be,Se),!!be),re=!0}),ne.length===0||U){U&&!O&&O++;const Se=U?U.remoteAuthority:T.remoteAuthority;for(let pe=0;pe<O;pe++)ae(this.doOpenEmpty(T,re,Se,U),!!U),re=!0}return{windows:(0,C.distinct)(ne),filesOpenedInWindow:ce}}doOpenFilesInExistingWindow(T,_,F){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),_.focus();const A={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToWait:F?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",M.CancellationToken.None,A),_}doAddFoldersToExistingWindow(T,_){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:_}),T.focus();const F={foldersToAdd:_};return T.sendWhenReady("vscode:addFolders",M.CancellationToken.None,F),T}doOpenEmpty(T,_,F,A,O){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!O,remoteAuthority:F,filesToOpen:A,forceNewWindow:_});let U;return!_&&typeof T.contextWindowId=="number"&&(U=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:F,forceNewWindow:_,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:A,windowToUse:U,emptyWindowBackupInfo:O})}doOpenFolderOrWorkspace(T,_,F,A,O){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:_,filesToOpen:A}),!F&&!O&&typeof T.contextWindowId=="number"&&(O=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({workspace:_.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:A,windowToUse:O})}getPathsToOpen(T){let _,F=!1,A=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(T),F=!0):T.forceEmpty?_=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(_=this.doExtractPathsFromCLI(T.cli),_.length===0&&_.push(Object.create(null)),F=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),A=!0),!T.addMode&&F){const O=_.filter(U=>z(U));if(O.length>1){const U=O[0].remoteAuthority;if(O.every(G=>(0,v.isEqualAuthority)(G.remoteAuthority,U))){const G=this.workspacesManagementMainService.createUntitledWorkspaceSync(O.map(ne=>({uri:ne.workspace.uri})));_.push({workspace:G,remoteAuthority:U}),_=_.filter(ne=>!z(ne))}}}return T.initialStartup&&!A&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter(O=>N(O)||z(O)||O.backupPath)),_}doExtractPathsFromAPI(T){const _=[],F={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority};for(const A of(0,C.coalesce)(T.urisToOpen||[])){const O=this.resolveOpenable(A,F);if(O)O.label=A.label,_.push(O);else{const U=this.resourceFromOpenable(A),G={title:this.productService.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,w.localize)(0,null))],defaultId:0,message:U.scheme===S.Schemas.file?(0,w.localize)(1,null):(0,w.localize)(2,null),detail:U.scheme===S.Schemas.file?(0,w.localize)(3,null,(0,b.getPathLabel)(U.fsPath,this.environmentMainService)):(0,w.localize)(4,null,U.toString()),noLink:!0};this.dialogMainService.showMessageBox(G,(0,k.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return _}doExtractPathsFromCLI(T){const _=[],F={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:!1},A=T["folder-uri"];if(A)for(const G of A){const ne=this.cliArgToUri(G);if(ne){const ce=this.resolveOpenable({folderUri:ne},F);ce&&_.push(ce)}}const O=T["file-uri"];if(O)for(const G of O){const ne=this.cliArgToUri(G);if(ne){const ce=this.resolveOpenable((0,X.hasWorkspaceFileExtension)(G)?{workspaceUri:ne}:{fileUri:ne},F);ce&&_.push(ce)}}const U=T._;for(const G of U){const ne=F.remoteAuthority?this.doResolvePathRemote(G,F):this.doResolveFilePath(G,F);ne&&_.push(ne)}return _}cliArgToUri(T){try{const _=u.URI.parse(T);if(!_.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${T}`);return}return _}catch(_){this.logService.error(`Invalid URI input string: ${T}, ${_.message}`)}}doGetPathsFromLastSession(){const T=this.getRestoreWindowsSetting();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":{const _=[];T!=="one"&&_.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&_.push(this.windowsStateHandler.state.lastActiveWindow);const F=[];for(const A of _)if(A.workspace){const O=this.resolveOpenable({workspaceUri:A.workspace.configPath},{remoteAuthority:A.remoteAuthority,rejectTransientWorkspaces:!0});N(O)&&F.push(O)}else if(A.folderUri){const O=this.resolveOpenable({folderUri:A.folderUri},{remoteAuthority:A.remoteAuthority});z(O)&&F.push(O)}else T!=="folders"&&A.backupPath&&F.push({backupPath:A.backupPath,remoteAuthority:A.remoteAuthority});return F}}}getRestoreWindowsSetting(){let T;return this.lifecycleMainService.wasRestarted?T="all":(T=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}resolveOpenable(T,_=Object.create(null)){let F=this.resourceFromOpenable(T);return F.scheme===S.Schemas.file?((0,Q.isFileToOpen)(T)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(F.fsPath,_)):this.doResolveRemoteOpenable(T,_)}doResolveRemoteOpenable(T,_){let F=this.resourceFromOpenable(T);const A=(0,W.getRemoteAuthority)(F)||_.remoteAuthority;if(F=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(F)),(0,Q.isFileToOpen)(T)){if(_.gotoLineMode){const{path:O,line:U,column:G}=(0,f.parseLineAndColumnAware)(F.path);return{fileUri:F.with({path:O}),selection:U?{startLineNumber:U,startColumn:G||1}:void 0,remoteAuthority:A}}return{fileUri:F,remoteAuthority:A}}else if((0,Q.isWorkspaceToOpen)(T))return{workspace:(0,H.getWorkspaceIdentifier)(F),remoteAuthority:A};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:A}}resourceFromOpenable(T){return(0,Q.isWorkspaceToOpen)(T)?T.workspaceUri:(0,Q.isFolderToOpen)(T)?T.folderUri:T.fileUri}doResolveFilePath(T,_){let F,A;_.gotoLineMode&&({path:T,line:F,column:A}=(0,f.parseLineAndColumnAware)(T)),T=(0,f.sanitizeFilePath)((0,m.normalize)(T),(0,g.cwd)());try{const O=(0,n.statSync)(T);if(O.isFile()){if(!_.forceOpenWorkspaceAsFile){const U=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.URI.file(T));if(U)return U.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:U.id,configPath:U.configPath},type:i.FileType.File,exists:!0,remoteAuthority:U.remoteAuthority,transient:U.transient}}return{fileUri:u.URI.file(T),type:i.FileType.File,exists:!0,selection:F?{startLineNumber:F,startColumn:A||1}:void 0}}else{if(O.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(u.URI.file(T),O),type:i.FileType.Directory,exists:!0};if(!d.isWindows&&T==="/dev/null")return{fileUri:u.URI.file(T),type:i.FileType.File,exists:!0}}}catch{const U=u.URI.file(T);if(this.workspacesHistoryMainService.removeRecentlyOpened([U]),_.ignoreFileNotFound)return{fileUri:U,type:i.FileType.File,exists:!1}}}doResolvePathRemote(T,_){const F=T.charCodeAt(0),A=_.remoteAuthority;let O,U;_.gotoLineMode&&({path:T,line:O,column:U}=(0,f.parseLineAndColumnAware)(T)),F!==47&&((0,f.isWindowsDriveLetter)(F)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,f.toSlashes)(T)),T=`/${T}`);const G=u.URI.from({scheme:S.Schemas.vscodeRemote,authority:A,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,X.hasWorkspaceFileExtension)(T))return _.forceOpenWorkspaceAsFile?{fileUri:G,selection:O?{startLineNumber:O,startColumn:U||1}:void 0,remoteAuthority:_.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(G),remoteAuthority:A};if(_.gotoLineMode||m.posix.basename(T).indexOf(".")!==-1)return{fileUri:G,selection:O?{startLineNumber:O,startColumn:U||1}:void 0,remoteAuthority:A}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(G),remoteAuthority:A}}shouldOpenNewWindow(T){const _=this.configurationService.getValue("window"),F=_?.openFoldersInNewWindow||"default",A=_?.openFilesInNewWindow||"off";let O=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(F==="on"||F==="off")&&(O=F==="on");let U=!1;return T.forceNewWindow||T.forceReuseWindow?U=!!T.forceNewWindow&&!T.forceReuseWindow:(d.isMacintosh?T.context===1&&(U=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(U=!0),!T.cli.extensionDevelopmentPath&&(A==="on"||A==="off")&&(U=A==="on")),{openFolderInNewWindow:!!O,openFilesInNewWindow:U}}openExtensionDevelopmentHostWindow(T,_){const F=(0,x.findWindowOnExtensionDevelopmentPath)(this.getWindows(),T);if(F)return this.lifecycleMainService.reload(F,_.cli),F.focus(),[F];let A=_.cli["folder-uri"]||[],O=_.cli["file-uri"]||[],U=_.cli._;if(!U.length&&!A.length&&!O.length&&!_.cli.extensionTestsPath){const ae=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=ae&&(ae.workspace||ae.folderUri);re&&(u.URI.isUri(re)?re.scheme===S.Schemas.file?U=[re.fsPath]:A=[re.toString()]:re.configPath.scheme===S.Schemas.file?U=[(0,v.originalFSPath)(re.configPath)]:O=[re.configPath.toString()])}let G=_.remoteAuthority;for(const ae of T)if(ae.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=u.URI.parse(ae),le=(0,W.getRemoteAuthority)(re);le&&(G?(0,v.isEqualAuthority)(le,G)||this.logService.error("more than one extension development path authority"):G=le)}U=U.filter(ae=>{const re=u.URI.file(ae);return(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(re),G)}),A=A.filter(ae=>{const re=this.cliArgToUri(ae);return re&&!!(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(re),G):!1}),O=O.filter(ae=>{const re=this.cliArgToUri(ae);return re&&!!(0,x.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(re),G):!1}),_.cli._=U,_.cli["folder-uri"]=A,_.cli["file-uri"]=O;const ne=!U.length&&!A.length&&!O.length,ce={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:G};return this.open(ce)}openInBrowserWindow(T){const _=this.configurationService.getValue("window"),F={...this.environmentMainService.args,...T.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,m.join)(this.environmentMainService.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.initialUserEnv,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:E.default,isInitialStartup:T.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof _?.zoomLevel=="number"?_.zoomLevel:void 0,autoDetectHighContrast:_?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let A;if(!T.forceNewWindow&&!T.forceNewTabbedWindow&&(A=T.windowToUse||this.getLastActiveWindow(),A&&A.focus()),A){const O=A.config;!F.extensionDevelopmentPath&&O&&!!O.extensionDevelopmentPath&&(F.extensionDevelopmentPath=O.extensionDevelopmentPath,F.verbose=O.verbose,F["inspect-brk-extensions"]=O["inspect-brk-extensions"],F.debugId=O.debugId,F.extensionEnvironment=O.extensionEnvironment,F["inspect-extensions"]=O["inspect-extensions"],F["extensions-dir"]=O["extensions-dir"])}else{const O=this.windowsStateHandler.getNewWindowState(F);(0,t.mark)("code/willCreateCodeWindow");const U=A=this.instantiationService.createInstance(ee.CodeWindow,{state:O,extensionDevelopmentPath:F.extensionDevelopmentPath,isExtensionTestHost:!!F.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow){const ne=this.getLastActiveWindow();ne&&ne.addTabbedWindow(U)}rt.WINDOWS.push(U),this._onDidOpenWindow.fire(U),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,y.once)(U.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(U)),(0,y.once)(U.onDidClose)(()=>this.onWindowClosed(U)),(0,y.once)(U.onDidDestroy)(()=>this._onDidDestroyWindow.fire(U));const G=(0,k.assertIsDefined)(U.win?.webContents);G.removeAllListeners("devtools-reload-page"),G.on("devtools-reload-page",()=>this.lifecycleMainService.reload(U)),this.lifecycleMainService.registerWindow(U)}return F.windowId=A.id,A.isReady?this.lifecycleMainService.unload(A,4).then(O=>{O||this.doOpenInBrowserWindow(A,F,T)}):this.doOpenInBrowserWindow(A,F,T),A}doOpenInBrowserWindow(T,_,F){if(!_.extensionDevelopmentPath)if((0,X.isWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:_.workspace,remoteAuthority:_.remoteAuthority});else if((0,X.isSingleFolderWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:_.workspace.uri,remoteAuthority:_.remoteAuthority});else{const A=F.emptyWindowBackupInfo&&F.emptyWindowBackupInfo.backupFolder;_.backupPath=this.backupMainService.registerEmptyWindowBackupSync(A,_.remoteAuthority)}T.load(_)}onWindowClosed(T){const _=rt.WINDOWS.indexOf(T);rt.WINDOWS.splice(_,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=p.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(T){return this.doGetLastActiveWindow(this.getWindows().filter(_=>(0,v.isEqualAuthority)(_.remoteAuthority,T)))}doGetLastActiveWindow(T){const _=Math.max.apply(Math,T.map(F=>F.lastFocusTime));return T.find(F=>F.lastFocusTime===_)}sendToFocused(T,..._){const F=this.getFocusedWindow()||this.getLastActiveWindow();F&&F.sendWhenReady(T,M.CancellationToken.None,..._)}sendToAll(T,_,F){for(const A of this.getWindows())F&&F.indexOf(A.id)>=0||A.sendWhenReady(T,M.CancellationToken.None,_)}getWindows(){return rt.WINDOWS}getWindowCount(){return rt.WINDOWS.length}getWindowById(T){const _=this.getWindows().filter(F=>F.id===T);return(0,C.firstOrDefault)(_)}getWindowByWebContents(T){const _=p.BrowserWindow.fromWebContents(T);if(!!_)return this.getWindowById(_.id)}};K.WINDOWS=[],K=ue([ie(2,h.ILogService),ie(3,$.IStateMainService),ie(4,s.IEnvironmentMainService),ie(5,a.ILifecycleMainService),ie(6,c.IBackupMainService),ie(7,o.IConfigurationService),ie(8,j.IWorkspacesHistoryMainService),ie(9,te.IWorkspacesManagementMainService),ie(10,r.IInstantiationService),ie(11,l.IDialogMainService),ie(12,i.IFileService),ie(13,R.IProductService),ie(14,L.IProtocolMainService)],K),e.WindowsMainService=K}),define(J[245],Z([0,1,50,34,67,42]),function(V,e,p,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(f,y,b,P){this.workspacesManagementMainService=f,this.windowsMainService=y,this.workspacesHistoryMainService=b,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,y){const b=this.windowsMainService.getWindowById(f);if(b)return this.workspacesManagementMainService.enterWorkspace(b,this.windowsMainService.getWindows(),y)}createUntitledWorkspace(f,y,b){return this.workspacesManagementMainService.createUntitledWorkspace(y,b)}deleteUntitledWorkspace(f,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(f,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}addRecentlyOpened(f,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}removeRecentlyOpened(f,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ue([ie(0,C.IWorkspacesManagementMainService),ie(1,n.IWindowsMainService),ie(2,D.IWorkspacesHistoryMainService),ie(3,p.IBackupMainService)],M),e.WorkspacesMainService=M}),define(J[246],Z([0,1,12,29,25,17,39,15,28,43,44,33,2,10,9,3,14,7,31,71,124,37,127,88,218,137,50,228,20,74,192,165,75,102,47,229,91,163,22,52,93,171,193,172,225,92,173,174,18,187,77,73,5,76,238,203,103,19,6,189,243,58,21,78,233,79,38,222,80,204,32,206,208,64,41,212,236,239,237,240,99,213,214,215,216,219,34,244,220,26,67,245,42]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w,c,o,l,s,i,r,a,h,E,R,L,W,$,Q,ee,x,q,X,H,j,te,N,z,K,B,T,_,F,A,O,U,G,ne,ce,ae,re,le,he,me,ke,Ce,Se,pe,be,Re,Ue,xe,Fe,Be,Ye,st,pt,ot,Qe,qe,Xe,Y,se,oe,fe,ye,Le,Oe,Ke,He,Ae,$e,Ve,Ge,it,Ct,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let vt=class extends S.Disposable{constructor(de,we,ve,ge,Pe,De,Me,Ee,Ie,We){super();this.mainProcessNodeIpcServer=de,this.userEnv=we,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Ee,this.fileService=Ie,this.productService=We,this.configureSession(),this.registerListeners()}configureSession(){const de=Ee=>Ee?.startsWith(`${m.Schemas.vscodeWebview}://`),we=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((Ee,Ie,We,Ne)=>de(Ne.requestingUrl)?We(we.has(Ie)):We(!1)),p.session.defaultSession.setPermissionCheckHandler((Ee,Ie,We,Ne)=>de(Ne.requestingUrl)?we.has(Ie):!1);const ve=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,"devtools"]),ge=Ee=>{for(let Ie=Ee;Ie;Ie=Ie.parent)if(Ie.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},Pe=Ee=>Ee.resourceType==="xhr"||ge(Ee.frame),De=Ee=>{const Ie=Ee.frame;if(!Ie||!this.windowsMainService)return!1;const We=p.BrowserWindow.getAllWindows();for(const Ne of We)if(Ie.processId===Ne.webContents.mainFrame.processId)return!0;return!1};p.session.defaultSession.webRequest.onBeforeRequest((Ee,Ie)=>{const We=v.URI.parse(Ee.url);return We.scheme===m.Schemas.vscodeFileResource&&!De(Ee)?(this.logService.error("Blocked vscode-file request",Ee.url),Ie({cancel:!0})):We.path.endsWith(".svg")&&!ve.has(We.scheme)?Ie({cancel:!Pe(Ee)}):Ie({cancel:!1})}),p.session.defaultSession.webRequest.onHeadersReceived((Ee,Ie)=>{const We=Ee.responseHeaders,Ne=We["content-type"]||We["Content-Type"];if(Ne&&Array.isArray(Ne)){const Je=v.URI.parse(Ee.url);if(Je.path.endsWith(".svg")&&ve.has(Je.scheme))return We["Content-Type"]=["image/svg+xml"],Ie({cancel:!1,responseHeaders:We});if(!Je.path.includes(m.Schemas.vscodeRemoteResource)&&Ne.some(tt=>tt.toLowerCase().includes("image/svg")))return Ie({cancel:!Pe(Ee)})}return Ie({cancel:!1})});const Me=p.session.defaultSession;typeof Me.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Me.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>(0,I.onUnexpectedError)(ve)),process.on("unhandledRejection",ve=>(0,I.onUnexpectedError)(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,w.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(ve,ge)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ge)}),p.app.on("activate",(ve,ge)=>{this.logService.trace("app#activate"),ge||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(ve,ge)=>{ge.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ge.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let de=[],we;p.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),we!==void 0&&(clearTimeout(we),we=void 0),we=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],we=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",ve=>{const ge=this.windowsMainService?.getWindowByWebContents(ve.sender);let Pe,De;return ge?.config?(Pe=ge.config,De={...process.env,...ge.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),p.ipcMain.handle("vscode:writeNlsFile",(ve,ge,Pe)=>{const De=this.validateNlsPath([ge]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,C.VSBuffer.fromString(Pe))}),p.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const Pe=this.validateNlsPath(ge);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let we;for(const ve of de)typeof ve=="string"&&(typeof we!="string"?we=ve:we=(0,t.join)(we,ve));if(!(typeof we!="string"||!(0,t.isAbsolute)(we)||!(0,f.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return v.URI.file(we)}onUnexpectedError(de){if(de){const we={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(we))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;d.isWindows&&de&&p.app.setAppUserModelId(de);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ie){this.logService.error(Ie)}const we=new o.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(ve),Me=await this.initServices(ve,ge,Pe);if(this.environmentMainService.driverHandle){const Ie=await(0,ee.serve)(we,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ie)}this._register(Me.createInstance(s.ProxyAuthHandler)),Me.invokeFunction(Ie=>this.initChannels(Ie,we,De));const Ee=Me.invokeFunction(Ie=>this.openFirstWindow(Ie,we));Me.invokeFunction(Ie=>this.afterWindowOpen(Ie,ge)),this.environmentMainService.args.trace&&Me.invokeFunction(Ie=>this.stopTracingEventually(Ie,Ee))}async resolveMachineId(){let de=this.stateMainService.getItem(Ye.machineIdKey);return(!de||d.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,u.getMachineId)(),this.stateMainService.setItem(Ye.machineIdKey,de)),de}setupSharedProcess(de){const we=this._register(this.mainInstantiationService.createInstance(be.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new l.Client(Pe,"main")})(),ge=(async()=>(await we.whenReady(),ve))();return{sharedProcess:we,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,we,ve){const ge=new ne.ServiceCollection;switch(process.platform){case"win32":ge.set(Qe.IUpdateService,new U.SyncDescriptor(oe.Win32UpdateService));break;case"linux":d.isLinuxSnap?ge.set(Qe.IUpdateService,new U.SyncDescriptor(se.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(Qe.IUpdateService,new U.SyncDescriptor(Y.LinuxUpdateService));break;case"darwin":ge.set(Qe.IUpdateService,new U.SyncDescriptor(Xe.DarwinUpdateService));break}ge.set(Ae.IWindowsMainService,new U.SyncDescriptor($e.WindowsMainService,[de,this.userEnv])),ge.set(Q.IDialogMainService,new U.SyncDescriptor(Q.DialogMainService)),ge.set(re.ILaunchMainService,new U.SyncDescriptor(re.LaunchMainService)),ge.set($.IDiagnosticsMainService,new U.SyncDescriptor($.DiagnosticsMainService)),ge.set(W.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(ve.then(De=>De.getChannel("diagnostics"))))),ge.set(ce.IIssueMainService,new U.SyncDescriptor(ce.IssueMainService,[this.userEnv])),ge.set(x.IEncryptionMainService,new U.SyncDescriptor(q.EncryptionMainService,[de])),ge.set(ae.IKeyboardLayoutMainService,new U.SyncDescriptor(ae.KeyboardLayoutMainService)),ge.set(Ce.INativeHostMainService,new U.SyncDescriptor(Ce.NativeHostMainService,[we])),ge.set(E.ICredentialsMainService,new U.SyncDescriptor(R.CredentialsMainService,[!1])),ge.set(Ke.IWebviewManagerService,new U.SyncDescriptor(He.WebviewMainService)),ge.set(Ge.IWorkspacesService,new U.SyncDescriptor(Ct.WorkspacesMainService)),ge.set(It.IWorkspacesManagementMainService,new U.SyncDescriptor(It.WorkspacesManagementMainService)),ge.set(it.IWorkspacesHistoryMainService,new U.SyncDescriptor(it.WorkspacesHistoryMainService)),ge.set(ke.IMenubarMainService,new U.SyncDescriptor(ke.MenubarMainService)),ge.set(te.IExtensionUrlTrustService,new U.SyncDescriptor(N.ExtensionUrlTrustService)),ge.set(z.IExtensionHostStarter,new U.SyncDescriptor(K.WorkerMainProcessExtensionHostStarter)),ge.set(Fe.IStorageMainService,new U.SyncDescriptor(Fe.StorageMainService)),ge.set(Fe.IGlobalStorageMainService,new U.SyncDescriptor(Fe.GlobalStorageMainService)),d.isWindows?ge.set(B.IExternalTerminalMainService,new U.SyncDescriptor(T.WindowsExternalTerminalService)):d.isMacintosh?ge.set(B.IExternalTerminalMainService,new U.SyncDescriptor(T.MacExternalTerminalService)):d.isLinux&&ge.set(B.IExternalTerminalMainService,new U.SyncDescriptor(T.LinuxExternalTerminalService));const Pe=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(r.IBackupMainService,Pe),ge.set(fe.IURLService,new U.SyncDescriptor(Le.NativeURLService)),(0,ot.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,c.getDelayedChannel)(ve.then(Ne=>Ne.getChannel("telemetryAppender"))),Me=new st.TelemetryAppenderClient(De),Ee=(0,Be.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ie=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appenders:[Me],commonProperties:Ee,piiPaths:Ie,sendErrorTelemetry:!0};ge.set(Ye.ITelemetryService,new U.SyncDescriptor(pt.TelemetryService,[We]))}else ge.set(Ye.ITelemetryService,ot.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,we,ve){const ge=c.ProxyChannel.fromService(de.get(re.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Pe=c.ProxyChannel.fromService(de.get($.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Pe);const De=this.fileService.getProvider(m.Schemas.file);(0,g.assertType)(De instanceof O.DiskFileSystemProvider);const Me=new A.DiskFileSystemProviderChannel(De,this.logService,this.environmentMainService);we.registerChannel(_.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me),ve.then(je=>je.registerChannel(_.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me));const Ee=new qe.UpdateChannel(de.get(Qe.IUpdateService));we.registerChannel("update",Ee);const Ie=c.ProxyChannel.fromService(de.get(ce.IIssueMainService));we.registerChannel("issue",Ie);const We=c.ProxyChannel.fromService(de.get(x.IEncryptionMainService));we.registerChannel("encryption",We);const Ne=c.ProxyChannel.fromService(de.get(E.ICredentialsMainService));we.registerChannel("credentials",Ne);const Je=c.ProxyChannel.fromService(de.get(Re.ISignService));we.registerChannel("sign",Je);const tt=c.ProxyChannel.fromService(de.get(ae.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",tt),this.nativeHostMainService=de.get(Ce.INativeHostMainService);const dt=c.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",dt),ve.then(je=>je.registerChannel("nativeHost",dt));const _e=c.ProxyChannel.fromService(de.get(Ge.IWorkspacesService));we.registerChannel("workspaces",_e);const ft=c.ProxyChannel.fromService(de.get(ke.IMenubarMainService));we.registerChannel("menubar",ft);const at=c.ProxyChannel.fromService(de.get(fe.IURLService));we.registerChannel("url",at);const ct=c.ProxyChannel.fromService(de.get(te.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",ct);const gt=c.ProxyChannel.fromService(de.get(Ke.IWebviewManagerService));we.registerChannel("webview",gt);const lt=this._register(new xe.StorageDatabaseChannel(this.logService,de.get(Fe.IStorageMainService)));we.registerChannel("storage",lt),ve.then(je=>je.registerChannel("storage",lt));const ut=c.ProxyChannel.fromService(de.get(B.IExternalTerminalMainService));we.registerChannel("externalTerminal",ut);const nt=new me.LogLevelChannel(de.get(he.ILogService));we.registerChannel("logLevel",nt),ve.then(je=>je.registerChannel("logLevel",nt));const ht=new me.LoggerChannel(de.get(he.ILoggerService));we.registerChannel("logger",ht),ve.then(je=>je.registerChannel("logger",ht));const Te=new L.ElectronExtensionHostDebugBroadcastChannel(de.get(Ae.IWindowsMainService));we.registerChannel("extensionhostdebugservice",Te);const et=c.ProxyChannel.fromService(de.get(z.IExtensionHostStarter));we.registerChannel(z.ipcExtensionHostStarterChannelName,et)}openFirstWindow(de,we){const ve=this.windowsMainService=de.get(Ae.IWindowsMainService),ge=de.get(fe.IURLService),Pe=de.get(Ce.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Te=>{try{return{uri:v.URI.parse(Te),url:Te}}catch{return}}).filter(Te=>{if(!Te||this.shouldBlockURI(Te.uri))return!1;const et=this.getWindowOpenableFromProtocolLink(Te.uri);return et?(De.push(et),!1):!0}),Ee=this,Ie=this.environmentMainService,We=this.productService;ge.registerHandler({async handleURL(Te,et){if(Te.scheme===We.urlProtocol&&Te.path==="workspace"&&(Te=Te.with({authority:"file",path:v.URI.parse(Te.query).path,query:""})),Ee.shouldBlockURI(Te))return!0;const je=Ee.getWindowOpenableFromProtocolLink(Te);if(je){const[yt]=ve.open({context:5,cli:{...Ie.args},urisToOpen:[je],gotoLineMode:!0});return yt.focus(),!0}if(d.isMacintosh&&ve.getWindowCount()===0){const[yt]=ve.open({context:5,cli:{...Ie.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,pe.getRemoteAuthority)(Te)});return await yt.ready(),ge.open(Te,et)}return!1}});const Ne=this._register(new Ve.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),Je=new c.StaticRouter(Te=>Ne.getActiveClientId().then(et=>Te===et)),tt=new ye.URLHandlerRouter(Je),dt=we.getChannel("urlHandler",tt);ge.registerHandler(new ye.URLHandlerChannelClient(dt)),this._register(new Oe.ElectronURLListener(Me,ge,ve,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,ft=global.macOpenFiles,at=(0,H.isLaunchedFromCli)(process.env)?0:4,ct=_e._.length,gt=!!_e["folder-uri"],lt=!!_e["file-uri"],ut=_e["skip-add-to-recently-opened"]===!0,nt=_e.wait&&_e.waitMarkerFilePath?v.URI.file(_e.waitMarkerFilePath):void 0,ht=_e.remote||void 0;return De.length>0?ve.open({context:at,cli:_e,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!ct&&!gt&&!lt?ve.open({context:at,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:ut,waitMarkerFileURI:nt,initialStartup:!0,remoteAuthority:ht}):ft.length&&!ct&&!gt&&!lt?ve.open({context:1,cli:_e,urisToOpen:ft.map(Te=>this.getWindowOpenableFromPathSync(Te)),noRecentEntry:ut,waitMarkerFileURI:nt,initialStartup:!0}):ve.open({context:at,cli:_e,forceNewWindow:_e["new-window"]||!ct&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:ut,waitMarkerFileURI:nt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(de){return!!(de.authority===m.Schemas.file&&d.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,P.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,P.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===m.Schemas.file){const we=v.URI.file(de.fsPath);return(0,Ge.hasWorkspaceFileExtension)(we)?{workspaceUri:we}:{fileUri:we}}else if(de.authority===m.Schemas.vscodeRemote){const we=de.path.indexOf(t.posix.sep,1);if(we!==-1){const ve=de.path.substring(1,we),ge=de.path.substring(we),Pe=v.URI.from({scheme:m.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return(0,Ge.hasWorkspaceFileExtension)(ge)?{workspaceUri:Pe}:/:[\d]+$/.test(ge)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(de){try{if((0,n.statSync)(de).isDirectory())return{folderUri:v.URI.file(de)};if((0,Ge.hasWorkspaceFileExtension)(de))return{workspaceUri:v.URI.file(de)}}catch{}return{fileUri:v.URI.file(de)}}async afterWindowOpen(de,we){this.lifecycleMainService.phase=3;let ve=!1;(0,y.once)(this.lifecycleMainService.onWillShutdown)(()=>ve=!0);const ge=de.get(Ye.ITelemetryService);this._register(we.onDidError(({type:Me,details:Ee})=>{let Ie;switch(Me){case 1:Ie="SharedProcess: detected unresponsive window";break;case 2:Ie=`SharedProcess: crashed (detail: ${Ee?.reason??"<unknown>"}, code: ${Ee?.exitCode??"<unknown>"})`;break;case 3:Ie=`SharedProcess: failed to load (detail: ${Ee?.reason??"<unknown>"}, code: ${Ee?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Ie)),ge.publicLog2("sharedprocesserror",{type:Me,reason:Ee?.reason,code:Ee?.exitCode,visible:we.isVisible(),shuttingdown:ve})}));const Pe=this.productService.win32MutexName;if(d.isWindows&&Pe)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Ee=new Me(Pe);(0,y.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(Me,Ee)=>{Ee({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=de.get(Qe.IUpdateService);(De instanceof oe.Win32UpdateService||De instanceof Y.LinuxUpdateService||De instanceof Xe.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ee=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,b.stripComments)(Ee))["enable-crash-reporter"]===void 0){const Ne=(0,ot.getTelemetryLevel)(this.configurationService)>=1,Je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ne},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,k.generateUuid)()}"`,"}"],tt=Ee.substring(0,Ee.length-2).concat(`,
`,Je.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(tt))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(de,we,ve){try{return await(0,j.getResolvedShellEnv)(this.logService,de,we)}catch(ge){const Pe=(0,M.toErrorMessage)(ge);ve?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(de,we){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(Q.IDialogMainService);let ge=!1;const Pe=async Me=>{if(ge)return;ge=!0;const Ee=await p.contentTracing.stopRecording(`${(0,f.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ee}`):ve.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Ee),buttons:[(0,P.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,g.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(we.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};vt=ue([ie(2,G.IInstantiationService),ie(3,he.ILogService),ie(4,X.IEnvironmentMainService),ie(5,le.ILifecycleMainService),ie(6,h.IConfigurationService),ie(7,Ue.IStateMainService),ie(8,F.IFileService),ie(9,Se.IProductService)],vt),e.CodeApplication=vt}),define(J[253],Z([0,1,12,29,30,8,39,15,28,43,33,10,9,63,3,36,27,24,37,57,246,11,20,197,205,22,52,168,18,185,77,73,179,76,19,95,6,190,96,53,21,54,194,98,235,56,232,79,202,38,234,64,65,211]),function(V,e,p,n,D,C,M,I,f,y,b,P,S,m,t,d,g,v,k,u,w,c,o,l,s,i,r,a,h,E,R,L,W,$,Q,ee,x,q,X,H,j,te,N,z,K,B,T,_,F,A,O,U,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ne{main(){try{this.startup()}catch(re){console.error(re.message),p.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(pe=>console.error(pe));const[re,le,he,me,ke,Ce,Se]=this.createServices();try{try{await this.initServices(he,me,ke)}catch(pe){throw this.handleStartupDataDirError(he,Se.nameLong,pe),pe}await re.invokeFunction(async pe=>{const be=pe.get(x.ILogService),Re=pe.get(Q.ILifecycleMainService),Ue=pe.get(h.IFileService),xe=await this.claimInstance(be,he,Re,re,Se,!0);return v.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Fe=>{be.warn(`Error writing main lockfile: ${Fe.stack}`)}),Ce.logger=new X.SpdLogLogger("main",(0,S.join)(he.logsPath,"main.log"),!0,!1,Ce.getLevel()),(0,y.once)(Re.onWillShutdown)(Fe=>{Ue.dispose(),me.dispose(),Fe.join(v.Promises.unlink(he.mainLockfile).catch(()=>{}))}),re.createInstance(w.CodeApplication,xe,le).startup()})}catch(pe){re.invokeFunction(this.quit,pe)}}createServices(){const re=new $.ServiceCollection,le={_serviceBrand:void 0,...H.default};re.set(j.IProductService,le);const he=new i.EnvironmentMainService(this.resolveArgs(),le),me=this.patchEnvironment(he);re.set(i.IEnvironmentMainService,he);const ke=new ee.BufferLogService,Ce=new x.MultiplexLogService([new x.ConsoleMainLogger((0,x.getLogLevel)(he)),ke]);process.once("exit",()=>Ce.dispose()),re.set(x.ILogService,Ce);const Se=new E.FileService(Ce);re.set(h.IFileService,Se);const pe=new R.DiskFileSystemProvider(Ce);Se.registerProvider(P.Schemas.file,pe),re.set(x.ILoggerService,new q.LoggerService(Ce,Se));const be=new l.ConfigurationService(he.settingsResource,Se);re.set(o.IConfigurationService,be),re.set(Q.ILifecycleMainService,new L.SyncDescriptor(Q.LifecycleMainService));const Re=new O.StateMainService(he,Ce,Se);return re.set(A.IStateMainService,Re),re.set(B.IRequestService,new L.SyncDescriptor(T.RequestMainService)),re.set(G.IThemeMainService,new L.SyncDescriptor(G.ThemeMainService)),re.set(_.ISignService,new L.SyncDescriptor(F.SignService)),re.set(z.ITunnelService,new L.SyncDescriptor(K.TunnelService)),re.set(te.IProtocolMainService,new L.SyncDescriptor(N.ProtocolMainService)),[new W.InstantiationService(re,!0),me,he,be,Re,ke,le]}patchEnvironment(re){const le={VSCODE_IPC_HOOK:re.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const me=process.env[he];typeof me=="string"&&(le[he]=me)}),Object.assign(process.env,le),le}initServices(re,le,he){return C.Promises.settled([Promise.all([re.extensionsPath,re.codeCachePath,re.logsPath,re.globalStorageHome.fsPath,re.workspaceStorageHome.fsPath,re.backupHome].map(me=>me?v.Promises.mkdir(me,{recursive:!0}):void 0)),le.initialize(),he.init()])}async claimInstance(re,le,he,me,ke,Ce){let Se;try{(0,m.mark)("code/willStartMainServer"),Se=await(0,u.serve)(le.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),(0,y.once)(he.onWillShutdown)(()=>Se.dispose())}catch(pe){if(pe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,ke.nameLong,pe),pe;let be;try{be=await(0,u.connect)(le.mainIPCHandle,"main")}catch(Fe){if(!Ce||t.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,ke.nameShort),(0,c.localize)(1,null),ke.nameLong),Fe;try{(0,n.unlinkSync)(le.mainIPCHandle)}catch(Be){throw re.warn("Could not delete obsolete instance handle",Be),Be}return this.claimInstance(re,le,he,me,ke,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw re.error(Fe),be.dispose(),new Error(Fe)}let Re;!le.args.wait&&!le.args.status&&(Re=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,ke.nameShort),(0,c.localize)(3,null),ke.nameLong)},1e4));const Ue=k.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0}),xe=k.ProxyChannel.toService(be.getChannel("diagnostics"),{disableMarshalling:!0});if(le.args.status)return me.invokeFunction(async()=>{const Fe=new s.DiagnosticsService(U.NullTelemetryService,ke),Be=await Ue.getMainProcessInfo(),Ye=await xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),st=await Fe.getDiagnostics(Be,Ye);throw console.log(st),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ue,re),re.trace("Sending env to running instance..."),await Ue.start(le.args,process.env),be.dispose(),Re&&clearTimeout(Re),new I.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw re.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(re,le,he){if(he.code==="EACCES"||he.code==="EPERM"){const me=(0,D.coalesce)([re.userDataPath,re.extensionsPath,u.XDG_RUNTIME_DIR]).map(ke=>(0,b.getPathLabel)(ke,re));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,M.toErrorMessage)(he),me.join(`
`)),le)}}showStartupWarningDialog(re,le,he){p.dialog.showMessageBoxSync({title:he,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,c.localize)(6,null))],message:re,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(re,le){if(t.isWindows){const he=await re.getMainProcessId();le.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((me,ke)=>{V(["windows-foreground-love"],me,ke)})).allowSetForegroundWindow(he)}catch(me){le.error(me)}}}quit(re,le){const he=re.get(x.ILogService),me=re.get(Q.ILifecycleMainService);let ke=0;le&&(le.isExpected?le.message&&he.trace(le.message):(ke=1,le.stack?he.error(le.stack):he.error(`Startup error: ${le.toString()}`))),me.kill(ke)}resolveArgs(){const re=this.validatePaths((0,r.parseMainProcessArgv)(process.argv));if(re.wait&&!re.waitMarkerFilePath){const le=(0,a.createWaitMarkerFile)(re.verbose);le&&((0,r.addArg)(process.argv,"--waitMarkerFilePath",le),re.waitMarkerFilePath=le)}return re}validatePaths(re){if(re["open-url"]&&(re._urls=re._,re._=[]),!re.remote){const le=this.doValidatePaths(re._,re.goto);re._=le}return re}doValidatePaths(re,le){const he=(0,d.cwd)(),me=re.map(Se=>{let pe=String(Se),be;le&&(be=(0,f.parseLineAndColumnAware)(pe),pe=be.path),pe&&(pe=this.preparePath(he,pe));const Re=(0,f.sanitizeFilePath)(pe,he),Ue=(0,S.basename)(Re);return Ue&&!(0,f.isValidBasename)(Ue)?null:le&&be?(be.path=Re,this.toPath(be)):Re}),ke=t.isWindows||t.isMacintosh,Ce=(0,D.distinct)(me,Se=>Se&&ke?Se.toLowerCase():Se||"");return(0,D.coalesce)(Ce)}preparePath(re,le){return t.isWindows&&(le=(0,g.rtrim)(le,'"')),le=(0,g.trim)((0,g.trim)(le," "),"	"),t.isWindows&&(le=(0,S.resolve)(re,le),le=(0,g.rtrim)(le,".")),le}toPath(re){const le=[re.path];return typeof re.line=="number"&&le.push(String(re.line)),typeof re.column=="number"&&le.push(String(re.column)),le.join(":")}}new ne().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/921264bfe3ffbbfe5ec8c4b08214b88e2148fa3e/core/vs/code/electron-main/main.js.map
