/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","fs","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],be=function(te){for(var e=[],d=0,t=te.length;d<t;d++)e[d]=ve[te[d]];return e};define(ve[55],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(t,k){if(!t)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=d}),define(ve[73],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function d(D){return D?D.replace(/\$\((.*?)\)/g,(P,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=d;class t{constructor(P,y,T){this.id=P,this.definition=y,this.description=T,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,P){const y=["codicon","codicon-"+D];return P&&y.push("codicon-modifier-"+P),y}e.getClassNamesArray=k;var A;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function y(C){if(C instanceof t)return["codicon","codicon-"+C.id];const f=P.exec(C.id);if(!f)return y(t.error);let[,_,p]=f;const c=["codicon","codicon-"+_];return p&&c.push("codicon-modifier-"+p.substr(1)),c}D.asClassNameArray=y;function T(C){return y(C).join(" ")}D.asClassName=T;function F(C){return"."+y(C).join(".")}D.asCSSSelector=F})(A=e.CSSIcon||(e.CSSIcon={}))}),define(ve[74],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function t(F){const C=[];for(let f in F)d.call(F,f)&&C.push(F[f]);return C}e.values=t;function k(F,C){for(let f in F)if(d.call(F,f)&&C({key:f,value:F[f]},function(){delete F[f]})===!1)return}e.forEach=k;function A(F,C){const f=Object.create(null);for(const _ of F){const p=C(_);let c=f[p];c||(c=f[p]=[]),c.push(_)}return f}e.groupBy=A;function D(F){const C=Object.create(null);return F&&F.forEach((f,_)=>{C[_]=f}),C}e.fromMap=D;function P(F,C){const f=[],_=[];for(let p of F)C.has(p)||f.push(p);for(let p of C)F.has(p)||_.push(p);return{removed:f,added:_}}e.diffSets=P;function y(F,C){const f=[],_=[];for(let[p,c]of F)C.has(p)||f.push(c);for(let[p,c]of C)F.has(p)||_.push(c);return{removed:f,added:_}}e.diffMaps=y;class T{constructor(){this.map=new Map}add(C,f){let _=this.map.get(C);_||(_=new Set,this.map.set(C,_)),_.add(f)}delete(C,f){const _=this.map.get(C);!_||(_.delete(f),_.size===0&&this.map.delete(C))}forEach(C,f){const _=this.map.get(C);!_||_.forEach(f)}}e.SetMap=T}),define(ve[56],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(D){return(P,y,T)=>{let F=null,C=null;if(typeof T.value=="function"?(F="value",C=T.value):typeof T.get=="function"&&(F="get",C=T.get),!C)throw new Error("not supported");T[F]=D(C,y)}}e.createDecorator=d;function t(D,P,y){let T=null,F=null;if(typeof y.value=="function"?(T="value",F=y.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(T="get",F=y.get),!F)throw new Error("not supported");const C=`$memoize$${P}`;y[T]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,f)}),this[C]}}e.memoize=t;function k(D,P,y){return d((T,F)=>{const C=`$debounce$${F}`,f=`$debounce$result$${F}`;return function(..._){this[f]||(this[f]=y?y():void 0),clearTimeout(this[C]),P&&(this[f]=P(this[f],..._),_=[this[f]]),this[C]=setTimeout(()=>{T.apply(this,_),this[f]=y?y():void 0},D)}})}e.debounce=k;function A(D,P,y){return d((T,F)=>{const C=`$throttle$timer$${F}`,f=`$throttle$result$${F}`,_=`$throttle$lastRun$${F}`,p=`$throttle$pending$${F}`;return function(...c){if(this[f]||(this[f]=y?y():void 0),(this[_]===null||this[_]===void 0)&&(this[_]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...c)),this[p])return;const v=this[_]+D;v<=Date.now()?(this[_]=Date.now(),T.apply(this,[this[f]]),this[f]=y?y():void 0):(this[p]=!0,this[C]=setTimeout(()=>{this[p]=!1,this[_]=Date.now(),T.apply(this,[this[f]]),this[f]=y?y():void 0},v-Date.now()))}})}e.throttle=A}),define(ve[16],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class d{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(E=>{E(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=d,e.errorHandler=new d;function t(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=t;function k(g){y(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=k;function A(g){y(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=A;function D(g){if(g instanceof Error){let{name:n,message:E}=g;const a=g.stacktrace||g.stack;return{$isError:!0,name:n,message:E,stack:a}}return g}e.transformErrorForSerialization=D;const P="Canceled";function y(g){return g instanceof T?!0:g instanceof Error&&g.name===P&&g.message===P}e.isCancellationError=y;class T extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=T;function F(){const g=new Error(P);return g.name=g.message,g}e.canceled=F;function C(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=C;function f(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=f;function _(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=_;function p(g){const n=new Error(`${g} has been disposed`);return n.name="DISPOSED",n}e.disposed=p;function c(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=c;class v extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=v;class I extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=I;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function m(g){const n=g;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=m;function o(g,n=Object.create(null)){const E=new Error(g);return n.actions&&(E.actions=n.actions),E}e.createErrorWithActions=o}),define(ve[17],be([1,0,16]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(ee,Y=0){return ee[ee.length-(1+Y)]}e.tail=t;function k(ee){if(ee.length===0)throw new Error("Invalid tail call");return[ee.slice(0,ee.length-1),ee[ee.length-1]]}e.tail2=k;function A(ee,Y,ae=(he,we)=>he===we){if(ee===Y)return!0;if(!ee||!Y||ee.length!==Y.length)return!1;for(let he=0,we=ee.length;he<we;he++)if(!ae(ee[he],Y[he]))return!1;return!0}e.equals=A;function D(ee,Y,ae){let he=0,we=ee.length-1;for(;he<=we;){const ke=(he+we)/2|0,Ne=ae(ee[ke],Y);if(Ne<0)he=ke+1;else if(Ne>0)we=ke-1;else return ke}return-(he+1)}e.binarySearch=D;function P(ee,Y){let ae=0,he=ee.length;if(he===0)return 0;for(;ae<he;){const we=Math.floor((ae+he)/2);Y(ee[we])?he=we:ae=we+1}return ae}e.findFirstInSorted=P;function y(ee,Y,ae){if(ee=ee|0,ee>=Y.length)throw new TypeError("invalid index");let he=Y[Math.floor(Y.length*Math.random())],we=[],ke=[],Ne=[];for(let _e of Y){const Ee=ae(_e,he);Ee<0?we.push(_e):Ee>0?ke.push(_e):Ne.push(_e)}return ee<we.length?y(ee,we,ae):ee<we.length+Ne.length?Ne[0]:y(ee-(we.length+Ne.length),ke,ae)}e.quickSelect=y;function T(ee,Y){const ae=[];let he;for(const we of ee.slice(0).sort(Y))!he||Y(he[0],we)!==0?(he=[we],ae.push(he)):he.push(we);return ae}e.groupBy=T;function F(ee,Y,ae){const he=[];function we(_e,Ee,z){if(Ee===0&&z.length===0)return;const W=he[he.length-1];W&&W.start+W.deleteCount===_e?(W.deleteCount+=Ee,W.toInsert.push(...z)):he.push({start:_e,deleteCount:Ee,toInsert:z})}let ke=0,Ne=0;for(;;){if(ke===ee.length){we(ke,0,Y.slice(Ne));break}if(Ne===Y.length){we(ke,ee.length-ke,[]);break}const _e=ee[ke],Ee=Y[Ne],z=ae(_e,Ee);z===0?(ke+=1,Ne+=1):z<0?(we(ke,1,[]),ke+=1):z>0&&(we(ke,0,[Ee]),Ne+=1)}return he}e.sortedDiff=F;function C(ee,Y,ae){const he=F(ee,Y,ae),we=[],ke=[];for(const Ne of he)we.push(...ee.slice(Ne.start,Ne.start+Ne.deleteCount)),ke.push(...Ne.toInsert);return{removed:we,added:ke}}e.delta=C;function f(ee,Y,ae){if(ae===0)return[];const he=ee.slice(0,ae).sort(Y);return p(ee,Y,he,ae,ee.length),he}e.top=f;function _(ee,Y,ae,he,we){return ae===0?Promise.resolve([]):new Promise((ke,Ne)=>{(async()=>{const _e=ee.length,Ee=ee.slice(0,ae).sort(Y);for(let z=ae,W=Math.min(ae+he,_e);z<_e;z=W,W=Math.min(W+he,_e)){if(z>ae&&await new Promise(N=>setTimeout(N)),we&&we.isCancellationRequested)throw(0,d.canceled)();p(ee,Y,Ee,z,W)}return Ee})().then(ke,Ne)})}e.topAsync=_;function p(ee,Y,ae,he,we){for(const ke=ae.length;he<we;he++){const Ne=ee[he];if(Y(Ne,ae[ke-1])<0){ae.pop();const _e=P(ae,Ee=>Y(Ne,Ee)<0);ae.splice(_e,0,Ne)}}}function c(ee){return ee.filter(Y=>!!Y)}e.coalesce=c;function v(ee){let Y=0;for(let ae=0;ae<ee.length;ae++)ee[ae]&&(ee[Y]=ee[ae],Y+=1);ee.length=Y}e.coalesceInPlace=v;function I(ee,Y,ae){ee.splice(ae,0,ee.splice(Y,1)[0])}e.move=I;function b(ee){return!Array.isArray(ee)||ee.length===0}e.isFalsyOrEmpty=b;function m(ee){return Array.isArray(ee)&&ee.length>0}e.isNonEmptyArray=m;function o(ee,Y=ae=>ae){const ae=new Set;return ee.filter(he=>{const we=Y(he);return ae.has(we)?!1:(ae.add(we),!0)})}e.distinct=o;function g(ee){const Y=new Set;return ae=>{const he=ee(ae);return Y.has(he)?!1:(Y.add(he),!0)}}e.uniqueFilter=g;function n(ee,Y){const ae=E(ee,Y);if(ae!==-1)return ee[ae]}e.findLast=n;function E(ee,Y){for(let ae=ee.length-1;ae>=0;ae--){const he=ee[ae];if(Y(he))return ae}return-1}e.lastIndex=E;function a(ee,Y){return ee.length>0?ee[0]:Y}e.firstOrDefault=a;function i(ee,Y,ae=(he,we)=>he===we){let he=0;for(let we=0,ke=Math.min(ee.length,Y.length);we<ke&&ae(ee[we],Y[we]);we++)he++;return he}e.commonPrefixLength=i;function r(ee){return[].concat(...ee)}e.flatten=r;function s(ee,Y){let ae=typeof Y=="number"?ee:0;typeof Y=="number"?ae=ee:(ae=0,Y=ee);const he=[];if(ae<=Y)for(let we=ae;we<Y;we++)he.push(we);else for(let we=ae;we>Y;we--)he.push(we);return he}e.range=s;function l(ee,Y,ae){return ee.reduce((he,we)=>(he[Y(we)]=ae?ae(we):we,he),Object.create(null))}e.index=l;function h(ee,Y){return ee.push(Y),()=>u(ee,Y)}e.insert=h;function u(ee,Y){const ae=ee.indexOf(Y);if(ae>-1)return ee.splice(ae,1),Y}e.remove=u;function w(ee,Y,ae){const he=ee.slice(0,Y),we=ee.slice(Y);return he.concat(ae,we)}e.arrayInsert=w;function R(ee,Y){let ae;if(typeof Y=="number"){let he=Y;ae=()=>{const we=Math.sin(he++)*179426549;return we-Math.floor(we)}}else ae=Math.random;for(let he=ee.length-1;he>0;he-=1){const we=Math.floor(ae()*(he+1)),ke=ee[he];ee[he]=ee[we],ee[we]=ke}}e.shuffle=R;function O(ee,Y){const ae=ee.indexOf(Y);ae>-1&&(ee.splice(ae,1),ee.unshift(Y))}e.pushToStart=O;function L(ee,Y){const ae=ee.indexOf(Y);ae>-1&&(ee.splice(ae,1),ee.push(Y))}e.pushToEnd=L;function S(ee,Y){return Array.isArray(ee)?ee.map(Y):Y(ee)}e.mapArrayOrNot=S;function U(ee){return Array.isArray(ee)?ee:[ee]}e.asArray=U;function M(ee){return ee[Math.floor(Math.random()*ee.length)]}e.getRandomElement=M;function X(ee,Y){for(const ae of ee){const he=Y(ae);if(he!==void 0)return he}}e.mapFind=X;function G(ee,Y,ae){const he=B(ee,Y),we=ee.length,ke=ae.length;ee.length=we+ke;for(let Ne=we-1;Ne>=he;Ne--)ee[Ne+ke]=ee[Ne];for(let Ne=0;Ne<ke;Ne++)ee[Ne+he]=ae[Ne]}e.insertInto=G;function q(ee,Y,ae,he){const we=B(ee,Y),ke=ee.splice(we,ae);return G(ee,we,he),ke}e.splice=q;function B(ee,Y){return Y<0?Math.max(Y+ee.length,0):Math.min(Y,ee.length)}function x(ee,Y){return(ae,he)=>Y(ee(ae),ee(he))}e.compareBy=x;const j=(ee,Y)=>ee-Y;e.numberComparator=j;function V(ee,Y){if(ee.length===0)return;let ae=ee[0];for(let he=1;he<ee.length;he++){const we=ee[he];Y(we,ae)>0&&(ae=we)}return ae}e.findMaxBy=V;function Z(ee,Y){if(ee.length===0)return;let ae=ee[0];for(let he=1;he<ee.length;he++){const we=ee[he];Y(we,ae)>=0&&(ae=we)}return ae}e.findLastMaxBy=Z;function se(ee,Y){return V(ee,(ae,he)=>-Y(ae,he))}e.findMinBy=se;class ce{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let ae=this.firstIdx;for(;ae<this.items.length&&Y(this.items[ae]);)ae++;const he=ae===this.firstIdx?null:this.items.slice(this.firstIdx,ae);return this.firstIdx=ae,he}takeFromEndWhile(Y){let ae=this.lastIdx;for(;ae>=0&&Y(this.items[ae]);)ae--;const he=ae===this.lastIdx?null:this.items.slice(ae+1,this.lastIdx+1);return this.lastIdx=ae,he}peek(){return this.items[this.firstIdx]}dequeue(){const Y=this.items[this.firstIdx];return this.firstIdx++,Y}takeCount(Y){const ae=this.items.slice(this.firstIdx,this.firstIdx+Y);return this.firstIdx+=Y,ae}}e.ArrayQueue=ce}),define(ve[75],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function d(t){const k=this;let A=!1,D;return function(){return A||(A=!0,D=t.apply(k,arguments)),D}}e.once=d}),define(ve[76],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(ve[77],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(t){function k(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}t.is=k;const A=Object.freeze([]);function D(){return A}t.empty=D;function*P(g){yield g}t.single=P;function y(g){return g||A}t.from=y;function T(g){return!g||g[Symbol.iterator]().next().done===!0}t.isEmpty=T;function F(g){return g[Symbol.iterator]().next().value}t.first=F;function C(g,n){for(const E of g)if(n(E))return!0;return!1}t.some=C;function f(g,n){for(const E of g)if(n(E))return E}t.find=f;function*_(g,n){for(const E of g)n(E)&&(yield E)}t.filter=_;function*p(g,n){let E=0;for(const a of g)yield n(a,E++)}t.map=p;function*c(...g){for(const n of g)for(const E of n)yield E}t.concat=c;function*v(g){for(const n of g)for(const E of n)yield E}t.concatNested=v;function I(g,n,E){let a=E;for(const i of g)a=n(a,i);return a}t.reduce=I;function*b(g,n,E=g.length){for(n<0&&(n+=g.length),E<0?E+=g.length:E>g.length&&(E=g.length);n<E;n++)yield g[n]}t.slice=b;function m(g,n=Number.POSITIVE_INFINITY){const E=[];if(n===0)return[E,g];const a=g[Symbol.iterator]();for(let i=0;i<n;i++){const r=a.next();if(r.done)return[E,t.empty()];E.push(r.value)}return[E,{[Symbol.iterator](){return a}}]}t.consume=m;function o(g,n,E=(a,i)=>a===i){const a=g[Symbol.iterator](),i=n[Symbol.iterator]();for(;;){const r=a.next(),s=i.next();if(r.done!==s.done)return!1;if(r.done)return!0;if(!E(r.value,s.value))return!1}}t.equals=o})(d=e.Iterable||(e.Iterable={}))}),define(ve[57],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function D(n,E=!1){let a=0,i=n.length,r="",s=0,l=16,h=0;function u(M){let X=0,G=0;for(;X<M;){const q=n.charCodeAt(a);if(q>=48&&q<=57)G=G*16+q-48;else if(q>=65&&q<=70)G=G*16+q-65+10;else if(q>=97&&q<=102)G=G*16+q-97+10;else break;a++,X++}return X<M&&(G=-1),G}function w(M){a=M,r="",s=0,l=16,h=0}function R(){const M=a;if(n.charCodeAt(a)===48)a++;else for(a++;a<n.length&&T(n.charCodeAt(a));)a++;if(a<n.length&&n.charCodeAt(a)===46)if(a++,a<n.length&&T(n.charCodeAt(a)))for(a++;a<n.length&&T(n.charCodeAt(a));)a++;else return h=3,n.substring(M,a);let X=a;if(a<n.length&&(n.charCodeAt(a)===69||n.charCodeAt(a)===101))if(a++,(a<n.length&&n.charCodeAt(a)===43||n.charCodeAt(a)===45)&&a++,a<n.length&&T(n.charCodeAt(a))){for(a++;a<n.length&&T(n.charCodeAt(a));)a++;X=a}else h=3;return n.substring(M,X)}function O(){let M="",X=a;for(;;){if(a>=i){M+=n.substring(X,a),h=2;break}const G=n.charCodeAt(a);if(G===34){M+=n.substring(X,a),a++;break}if(G===92){if(M+=n.substring(X,a),a++,a>=i){h=2;break}switch(n.charCodeAt(a++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const B=u(4);B>=0?M+=String.fromCharCode(B):h=4;break}default:h=5}X=a;continue}if(G>=0&&G<=31)if(y(G)){M+=n.substring(X,a),h=2;break}else h=6;a++}return M}function L(){if(r="",h=0,s=a,a>=i)return s=i,l=17;let M=n.charCodeAt(a);if(P(M)){do a++,r+=String.fromCharCode(M),M=n.charCodeAt(a);while(P(M));return l=15}if(y(M))return a++,r+=String.fromCharCode(M),M===13&&n.charCodeAt(a)===10&&(a++,r+=`
`),l=14;switch(M){case 123:return a++,l=1;case 125:return a++,l=2;case 91:return a++,l=3;case 93:return a++,l=4;case 58:return a++,l=6;case 44:return a++,l=5;case 34:return a++,r=O(),l=10;case 47:{const X=a-1;if(n.charCodeAt(a+1)===47){for(a+=2;a<i&&!y(n.charCodeAt(a));)a++;return r=n.substring(X,a),l=12}if(n.charCodeAt(a+1)===42){a+=2;const G=i-1;let q=!1;for(;a<G;){if(n.charCodeAt(a)===42&&n.charCodeAt(a+1)===47){a+=2,q=!0;break}a++}return q||(a++,h=1),r=n.substring(X,a),l=13}return r+=String.fromCharCode(M),a++,l=16}case 45:if(r+=String.fromCharCode(M),a++,a===i||!T(n.charCodeAt(a)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=R(),l=11;default:for(;a<i&&S(M);)a++,M=n.charCodeAt(a);if(s!==a){switch(r=n.substring(s,a),r){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode(M),a++,l=16}}function S(M){if(P(M)||y(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let M;do M=L();while(M>=12&&M<=15);return M}return{setPosition:w,getPosition:()=>a,scan:E?U:L,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>s,getTokenLength:()=>a-s,getTokenError:()=>h}}e.createScanner=D;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function T(n){return n>=48&&n<=57}var F;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(F||(F={}));function C(n,E){const a=[],i=new Object;let r;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function h(u,w,R,O){s.value=u,s.offset=w,s.length=R,s.type=O,s.colonOffset=void 0,r=s}try{m(n,{onObjectBegin:(u,w)=>{if(E<=u)throw i;r=void 0,l=E>u,a.push("")},onObjectProperty:(u,w,R)=>{if(E<w||(h(u,w,R,"property"),a[a.length-1]=u,E<=w+R))throw i},onObjectEnd:(u,w)=>{if(E<=u)throw i;r=void 0,a.pop()},onArrayBegin:(u,w)=>{if(E<=u)throw i;r=void 0,a.push(0)},onArrayEnd:(u,w)=>{if(E<=u)throw i;r=void 0,a.pop()},onLiteralValue:(u,w,R)=>{if(E<w||(h(u,w,R,g(u)),E<=w+R))throw i},onSeparator:(u,w,R)=>{if(E<=w)throw i;if(u===":"&&r&&r.type==="property")r.colonOffset=w,l=!1,r=void 0;else if(u===","){const O=a[a.length-1];typeof O=="number"?a[a.length-1]=O+1:(l=!0,a[a.length-1]=""),r=void 0}}})}catch(u){if(u!==i)throw u}return{path:a,previousNode:r,isAtPropertyKey:l,matches:u=>{let w=0;for(let R=0;w<u.length&&R<a.length;R++)if(u[w]===a[R]||u[w]==="*")w++;else if(u[w]!=="**")return!1;return w===u.length}}}e.getLocation=C;function f(n,E=[],a=A.DEFAULT){let i=null,r=[];const s=[];function l(u){Array.isArray(r)?r.push(u):i!==null&&(r[i]=u)}return m(n,{onObjectBegin:()=>{const u={};l(u),s.push(r),r=u,i=null},onObjectProperty:u=>{i=u},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const u=[];l(u),s.push(r),r=u,i=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:l,onError:(u,w,R)=>{E.push({error:u,offset:w,length:R})}},a),r[0]}e.parse=f;function _(n,E=[],a=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(u){i.type==="property"&&(i.length=u-i.offset,i=i.parent)}function s(u){return i.children.push(u),u}m(n,{onObjectBegin:u=>{i=s({type:"object",offset:u,length:-1,parent:i,children:[]})},onObjectProperty:(u,w,R)=>{i=s({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:u,offset:w,length:R,parent:i})},onObjectEnd:(u,w)=>{i.length=u+w-i.offset,i=i.parent,r(u+w)},onArrayBegin:(u,w)=>{i=s({type:"array",offset:u,length:-1,parent:i,children:[]})},onArrayEnd:(u,w)=>{i.length=u+w-i.offset,i=i.parent,r(u+w)},onLiteralValue:(u,w,R)=>{s({type:g(u),offset:w,length:R,parent:i,value:u}),r(w+R)},onSeparator:(u,w,R)=>{i.type==="property"&&(u===":"?i.colonOffset=w:u===","&&r(w))},onError:(u,w,R)=>{E.push({error:u,offset:w,length:R})}},a);const h=i.children[0];return h&&delete h.parent,h}e.parseTree=_;function p(n,E){if(!n)return;let a=n;for(let i of E)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let r=!1;for(const s of a.children)if(Array.isArray(s.children)&&s.children[0].value===i){a=s.children[1],r=!0;break}if(!r)return}else{const r=i;if(a.type!=="array"||r<0||!Array.isArray(a.children)||r>=a.children.length)return;a=a.children[r]}return a}e.findNodeAtLocation=p;function c(n){if(!n.parent||!n.parent.children)return[];const E=c(n.parent);if(n.parent.type==="property"){const a=n.parent.children[0].value;E.push(a)}else if(n.parent.type==="array"){const a=n.parent.children.indexOf(n);a!==-1&&E.push(a)}return E}e.getNodePath=c;function v(n){switch(n.type){case"array":return n.children.map(v);case"object":{const E=Object.create(null);for(let a of n.children){const i=a.children[1];i&&(E[a.children[0].value]=v(i))}return E}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=v;function I(n,E,a=!1){return E>=n.offset&&E<n.offset+n.length||a&&E===n.offset+n.length}e.contains=I;function b(n,E,a=!1){if(I(n,E,a)){const i=n.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=E;r++){const s=b(i[r],E,a);if(s)return s}return n}}e.findNodeAtOffset=b;function m(n,E,a=A.DEFAULT){const i=D(n,!1);function r(ce){return ce?()=>ce(i.getTokenOffset(),i.getTokenLength()):()=>!0}function s(ce){return ce?ee=>ce(ee,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=r(E.onObjectBegin),h=s(E.onObjectProperty),u=r(E.onObjectEnd),w=r(E.onArrayBegin),R=r(E.onArrayEnd),O=s(E.onLiteralValue),L=s(E.onSeparator),S=r(E.onComment),U=s(E.onError),M=a&&a.disallowComments,X=a&&a.allowTrailingComma;function G(){for(;;){const ce=i.scan();switch(i.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:M||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(ce){case 12:case 13:M?q(10):S();break;case 16:q(1);break;case 15:case 14:break;default:return ce}}}function q(ce,ee=[],Y=[]){if(U(ce),ee.length+Y.length>0){let ae=i.getToken();for(;ae!==17;){if(ee.indexOf(ae)!==-1){G();break}else if(Y.indexOf(ae)!==-1)break;ae=G()}}}function B(ce){const ee=i.getTokenValue();return ce?O(ee):h(ee),G(),!0}function x(){switch(i.getToken()){case 11:{let ce=0;try{ce=JSON.parse(i.getTokenValue()),typeof ce!="number"&&(q(2),ce=0)}catch{q(2)}O(ce);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return G(),!0}function j(){return i.getToken()!==10?(q(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(L(":"),G(),se()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function V(){l(),G();let ce=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ce||q(4,[],[]),L(","),G(),i.getToken()===2&&X)break}else ce&&q(6,[],[]);j()||q(4,[],[2,5]),ce=!0}return u(),i.getToken()!==2?q(7,[2],[]):G(),!0}function Z(){w(),G();let ce=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ce||q(4,[],[]),L(","),G(),i.getToken()===4&&X)break}else ce&&q(6,[],[]);se()||q(4,[],[4,5]),ce=!0}return R(),i.getToken()!==4?q(8,[4],[]):G(),!0}function se(){switch(i.getToken()){case 3:return Z();case 1:return V();case 10:return B(!0);default:return x()}}return G(),i.getToken()===17?a.allowEmptyContent?!0:(q(4,[],[]),!1):se()?(i.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=m;function o(n,E){let a=D(n),i=[],r,s=0,l;do switch(l=a.getPosition(),r=a.scan(),r){case 12:case 13:case 17:s!==l&&i.push(n.substring(s,l)),E!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,E)),s=a.getPosition();break}while(r!==17);return i.join("")}e.stripComments=o;function g(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ve[142],be([1,0,57]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(T,F,C){let f,_,p,c,v;if(F){for(c=F.offset,v=c+F.length,p=c;p>0&&!y(T,p-1);)p--;let l=v;for(;l<T.length&&!y(T,l);)l++;_=T.substring(p,l),f=D(_,C)}else _=T,f=0,p=0,c=0,v=T.length;const I=P(C,T);let b=!1,m=0,o;C.insertSpaces?o=A(" ",C.tabSize||4):o="	";const g=(0,d.createScanner)(_,!1);let n=!1;function E(){return I+A(o,f+m)}function a(){let l=g.scan();for(b=!1;l===15||l===14;)b=b||l===14,l=g.scan();return n=l===16||g.getTokenError()!==0,l}const i=[];function r(l,h,u){!n&&h<v&&u>c&&T.substring(h,u)!==l&&i.push({offset:h,length:u-h,content:l})}let s=a();if(s!==17){const l=g.getTokenOffset()+p,h=A(o,f);r(h,p,l)}for(;s!==17;){let l=g.getTokenOffset()+g.getTokenLength()+p,h=a(),u="";for(;!b&&(h===12||h===13);){const R=g.getTokenOffset()+p;r(" ",l,R),l=g.getTokenOffset()+g.getTokenLength()+p,u=h===12?E():"",h=a()}if(h===2)s!==1&&(m--,u=E());else if(h===4)s!==3&&(m--,u=E());else{switch(s){case 3:case 1:m++,u=E();break;case 5:case 12:u=E();break;case 13:b?u=E():u=" ";break;case 6:u=" ";break;case 10:if(h===6){u="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?u=" ":h!==5&&h!==17&&(n=!0);break;case 16:n=!0;break}b&&(h===12||h===13)&&(u=E())}const w=g.getTokenOffset()+p;r(u,l,w),s=h}return i}e.format=t;function k(T,F){const C=JSON.stringify(T,void 0,F.insertSpaces?F.tabSize||4:"	");return F.eol!==void 0?C.replace(/\r\n|\r|\n/g,F.eol):C}e.toFormattedString=k;function A(T,F){let C="";for(let f=0;f<F;f++)C+=T;return C}function D(T,F){let C=0,f=0;const _=F.tabSize||4;for(;C<T.length;){const p=T.charAt(C);if(p===" ")f++;else if(p==="	")f+=_;else break;C++}return Math.floor(f/_)}function P(T,F){for(let C=0;C<F.length;C++){const f=F.charAt(C);if(f==="\r")return C+1<F.length&&F.charAt(C+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return T&&T.eol||`
`}e.getEOL=P;function y(T,F){return`\r
`.indexOf(T.charAt(F))!==-1}e.isEOL=y}),define(ve[143],be([1,0,57,142]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(T,F,C){return A(T,F,void 0,C)}e.removeProperty=k;function A(T,F,C,f,_){const p=F.slice(),c=[],v=(0,d.parseTree)(T,c);let I,b;for(;p.length>0&&(b=p.pop(),I=(0,d.findNodeAtLocation)(v,p),I===void 0&&C!==void 0);)typeof b=="string"?C={[b]:C}:C=[C];if(I)if(I.type==="object"&&typeof b=="string"&&Array.isArray(I.children)){const m=(0,d.findNodeAtLocation)(I,[b]);if(m!==void 0)if(C===void 0){if(!m.parent)throw new Error("Malformed AST");const o=I.children.indexOf(m.parent);let g,n=m.parent.offset+m.parent.length;if(o>0){const E=I.children[o-1];g=E.offset+E.length}else g=I.offset+1,I.children.length>1&&(n=I.children[1].offset);return D(T,{offset:g,length:n-g,content:""},f)}else return D(T,{offset:m.offset,length:m.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const o=`${JSON.stringify(b)}: ${JSON.stringify(C)}`,g=_?_(I.children.map(E=>E.children[0].value)):I.children.length;let n;if(g>0){const E=I.children[g-1];n={offset:E.offset+E.length,length:0,content:","+o}}else I.children.length===0?n={offset:I.offset+1,length:0,content:o}:n={offset:I.offset+1,length:0,content:o+","};return D(T,n,f)}}else if(I.type==="array"&&typeof b=="number"&&Array.isArray(I.children))if(C!==void 0){const m=`${JSON.stringify(C)}`;let o;if(I.children.length===0||b===0)o={offset:I.offset+1,length:0,content:I.children.length===0?m:m+","};else{const g=b===-1||b>I.children.length?I.children.length:b,n=I.children[g-1];o={offset:n.offset+n.length,length:0,content:","+m}}return D(T,o,f)}else{const m=b,o=I.children[m];let g;if(I.children.length===1)g={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===m){const n=I.children[m-1],E=n.offset+n.length,a=I.offset+I.length;g={offset:E,length:a-2-E,content:""}}else g={offset:o.offset,length:I.children[m+1].offset-o.offset,content:""};return D(T,g,f)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${I.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(T,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(C)},f)}}e.setProperty=A;function D(T,F,C){let f=P(T,F),_=F.offset,p=F.offset+F.content.length;if(F.length===0||F.content.length===0){for(;_>0&&!(0,t.isEOL)(f,_-1);)_--;for(;p<f.length&&!(0,t.isEOL)(f,p);)p++}const c=(0,t.format)(f,{offset:_,length:p-_},C);for(let I=c.length-1;I>=0;I--){const b=c[I];f=P(f,b),_=Math.min(_,b.offset),p=Math.max(p,b.offset+b.length),p+=b.content.length-b.length}const v=T.length-(f.length-p)-_;return[{offset:_,length:v,content:f.substring(_,p)}]}e.withFormatting=D;function P(T,F){return T.substring(0,F.offset)+F.content+T.substring(F.offset+F.length)}e.applyEdit=P;function y(T,F){let C=F.slice(0).sort((_,p)=>{const c=_.offset-p.offset;return c===0?_.length-p.length:c}),f=T.length;for(let _=C.length-1;_>=0;_--){let p=C[_];if(p.offset+p.length<=f)T=P(T,p);else throw new Error("Overlapping edit");f=p.offset}return T}e.applyEdits=y}),define(ve[91],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new d(()=>k(this.getValue()))}}e.Lazy=d}),define(ve[6],be([1,0,75,77]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let A=null;function D(i){A=i}if(e.setDisposableTracker=D,k){const i="__is_disposable_tracked__";D(new class{trackDisposable(r){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(s)},3e3)}setParent(r,s){if(r&&r!==b.None)try{r[i]=!0}catch{}}markAsDisposed(r){if(r&&r!==b.None)try{r[i]=!0}catch{}}markAsSingleton(r){}})}function P(i){return A?.trackDisposable(i),i}function y(i){A?.markAsDisposed(i)}function T(i,r){A?.setParent(i,r)}function F(i,r){if(!!A)for(const s of i)A.setParent(s,r)}function C(i){return A?.markAsSingleton(i),i}e.markAsSingleton=C;class f extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=f;function _(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=_;function p(i){if(t.Iterable.is(i)){let r=[];for(const s of i)if(s)try{s.dispose()}catch(l){r.push(l)}if(r.length===1)throw r[0];if(r.length>1)throw new f(r);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=p;function c(...i){const r=v(()=>p(i));return F(i,r),r}e.combinedDisposable=c;function v(i){const r=P({dispose:(0,d.once)(()=>{y(r),i()})});return r}e.toDisposable=v;class I{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{p(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return T(r,this),this._isDisposed?I.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=I,I.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new I,P(this),T(this._store,this)}dispose(){y(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&T(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&T(r,null),r}}e.MutableDisposable=m;class o{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class g{constructor(){this.references=new Map}acquire(r,...s){let l=this.references.get(r);l||(l={counter:0,object:this.createReferencedObject(r,...s)},this.references.set(r,l));const{object:h}=l,u=(0,d.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(r,l.object),this.references.delete(r))});return l.counter++,{object:h,dispose:u}}}e.ReferenceCollection=g;class n{constructor(r){this.referenceCollection=r}async acquire(r,...s){const l=this.referenceCollection.acquire(r,...s);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=n;class E{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=E;function a(i){const r=new I;try{i(r)}finally{r.dispose()}}e.disposeOnReturn=a}),define(ve[92],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class d{constructor(A){this.element=A,this.next=d.Undefined,this.prev=d.Undefined}}d.Undefined=new d(void 0);class t{constructor(){this._first=d.Undefined,this._last=d.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===d.Undefined}clear(){let A=this._first;for(;A!==d.Undefined;){const D=A.next;A.prev=d.Undefined,A.next=d.Undefined,A=D}this._first=d.Undefined,this._last=d.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,D){const P=new d(A);if(this._first===d.Undefined)this._first=P,this._last=P;else if(D){const T=this._last;this._last=P,P.prev=T,T.next=P}else{const T=this._first;this._first=P,P.next=T,T.prev=P}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(P))}}shift(){if(this._first!==d.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==d.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==d.Undefined&&A.next!==d.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===d.Undefined&&A.next===d.Undefined?(this._first=d.Undefined,this._last=d.Undefined):A.next===d.Undefined?(this._last=this._last.prev,this._last.next=d.Undefined):A.prev===d.Undefined&&(this._first=this._first.next,this._first.prev=d.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==d.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[144],be([0]),e):(te=typeof globalThis!="undefined"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(_e,Ee){for(var z=0;z<Ee.length;z++){var W=Ee[z];W.enumerable=W.enumerable||!1,W.configurable=!0,"value"in W&&(W.writable=!0),Object.defineProperty(_e,W.key,W)}}function d(_e,Ee,z){return Ee&&e(_e.prototype,Ee),z&&e(_e,z),Object.defineProperty(_e,"prototype",{writable:!1}),_e}function t(_e,Ee){if(!!_e){if(typeof _e=="string")return k(_e,Ee);var z=Object.prototype.toString.call(_e).slice(8,-1);if(z==="Object"&&_e.constructor&&(z=_e.constructor.name),z==="Map"||z==="Set")return Array.from(_e);if(z==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(z))return k(_e,Ee)}}function k(_e,Ee){(Ee==null||Ee>_e.length)&&(Ee=_e.length);for(var z=0,W=new Array(Ee);z<Ee;z++)W[z]=_e[z];return W}function A(_e,Ee){var z=typeof Symbol!="undefined"&&_e[Symbol.iterator]||_e["@@iterator"];if(z)return(z=z.call(_e)).next.bind(z);if(Array.isArray(_e)||(z=t(_e))||Ee&&_e&&typeof _e.length=="number"){z&&(_e=z);var W=0;return function(){return W>=_e.length?{done:!0}:{done:!1,value:_e[W++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=D();function P(_e){te.defaults=_e}var y=/[&<>"']/,T=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(Ee){return f[Ee]};function p(_e,Ee){if(Ee){if(y.test(_e))return _e.replace(T,_)}else if(F.test(_e))return _e.replace(C,_);return _e}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(_e){return _e.replace(c,function(Ee,z){return z=z.toLowerCase(),z==="colon"?":":z.charAt(0)==="#"?z.charAt(1)==="x"?String.fromCharCode(parseInt(z.substring(2),16)):String.fromCharCode(+z.substring(1)):""})}var I=/(^|[^\[])\^/g;function b(_e,Ee){_e=_e.source||_e,Ee=Ee||"";var z={replace:function(N,$){return $=$.source||$,$=$.replace(I,"$1"),_e=_e.replace(N,$),z},getRegex:function(){return new RegExp(_e,Ee)}};return z}var m=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(_e,Ee,z){if(_e){var W;try{W=decodeURIComponent(v(z)).replace(m,"").toLowerCase()}catch{return null}if(W.indexOf("javascript:")===0||W.indexOf("vbscript:")===0||W.indexOf("data:")===0)return null}Ee&&!o.test(z)&&(z=r(Ee,z));try{z=encodeURI(z).replace(/%25/g,"%")}catch{return null}return z}var n={},E=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(_e,Ee){n[" "+_e]||(E.test(_e)?n[" "+_e]=_e+"/":n[" "+_e]=u(_e,"/",!0)),_e=n[" "+_e];var z=_e.indexOf(":")===-1;return Ee.substring(0,2)==="//"?z?Ee:_e.replace(a,"$1")+Ee:Ee.charAt(0)==="/"?z?Ee:_e.replace(i,"$1")+Ee:_e+Ee}var s={exec:function(){}};function l(_e){for(var Ee=1,z,W;Ee<arguments.length;Ee++){z=arguments[Ee];for(W in z)Object.prototype.hasOwnProperty.call(z,W)&&(_e[W]=z[W])}return _e}function h(_e,Ee){var z=_e.replace(/\|/g,function($,K,re){for(var de=!1,ye=K;--ye>=0&&re[ye]==="\\";)de=!de;return de?"|":" |"}),W=z.split(/ \|/),N=0;if(W[0].trim()||W.shift(),W[W.length-1].trim()||W.pop(),W.length>Ee)W.splice(Ee);else for(;W.length<Ee;)W.push("");for(;N<W.length;N++)W[N]=W[N].trim().replace(/\\\|/g,"|");return W}function u(_e,Ee,z){var W=_e.length;if(W===0)return"";for(var N=0;N<W;){var $=_e.charAt(W-N-1);if($===Ee&&!z)N++;else if($!==Ee&&z)N++;else break}return _e.substr(0,W-N)}function w(_e,Ee){if(_e.indexOf(Ee[1])===-1)return-1;for(var z=_e.length,W=0,N=0;N<z;N++)if(_e[N]==="\\")N++;else if(_e[N]===Ee[0])W++;else if(_e[N]===Ee[1]&&(W--,W<0))return N;return-1}function R(_e){_e&&_e.sanitize&&!_e.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(_e,Ee){if(Ee<1)return"";for(var z="";Ee>1;)Ee&1&&(z+=_e),Ee>>=1,_e+=_e;return z+_e}function L(_e,Ee,z,W){var N=Ee.href,$=Ee.title?p(Ee.title):null,K=_e[1].replace(/\\([\[\]])/g,"$1");if(_e[0].charAt(0)!=="!"){W.state.inLink=!0;var re={type:"link",raw:z,href:N,title:$,text:K,tokens:W.inlineTokens(K,[])};return W.state.inLink=!1,re}else return{type:"image",raw:z,href:N,title:$,text:p(K)}}function S(_e,Ee){var z=_e.match(/^(\s+)(?:```)/);if(z===null)return Ee;var W=z[1];return Ee.split(`
`).map(function(N){var $=N.match(/^\s+/);if($===null)return N;var K=$[0];return K.length>=W.length?N.slice(W.length):N}).join(`
`)}var U=function(){function _e(z){this.options=z||te.defaults}var Ee=_e.prototype;return Ee.space=function(W){var N=this.rules.block.newline.exec(W);if(N&&N[0].length>0)return{type:"space",raw:N[0]}},Ee.code=function(W){var N=this.rules.block.code.exec(W);if(N){var $=N[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:N[0],codeBlockStyle:"indented",text:this.options.pedantic?$:u($,`
`)}}},Ee.fences=function(W){var N=this.rules.block.fences.exec(W);if(N){var $=N[0],K=S($,N[3]||"");return{type:"code",raw:$,lang:N[2]?N[2].trim():N[2],text:K}}},Ee.heading=function(W){var N=this.rules.block.heading.exec(W);if(N){var $=N[2].trim();if(/#$/.test($)){var K=u($,"#");(this.options.pedantic||!K||/ $/.test(K))&&($=K.trim())}var re={type:"heading",raw:N[0],depth:N[1].length,text:$,tokens:[]};return this.lexer.inline(re.text,re.tokens),re}},Ee.hr=function(W){var N=this.rules.block.hr.exec(W);if(N)return{type:"hr",raw:N[0]}},Ee.blockquote=function(W){var N=this.rules.block.blockquote.exec(W);if(N){var $=N[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:N[0],tokens:this.lexer.blockTokens($,[]),text:$}}},Ee.list=function(W){var N=this.rules.block.list.exec(W);if(N){var $,K,re,de,ye,Re,We,$e,je,ze,Ue,Qe,nt=N[1].trim(),Le=nt.length>1,et={type:"list",raw:"",ordered:Le,start:Le?+nt.slice(0,-1):"",loose:!1,items:[]};nt=Le?"\\d{1,9}\\"+nt.slice(-1):"\\"+nt,this.options.pedantic&&(nt=Le?nt:"[*+-]");for(var ne=new RegExp("^( {0,3}"+nt+")((?: [^\\n]*)?(?:\\n|$))");W&&(Qe=!1,!(!(N=ne.exec(W))||this.rules.block.hr.test(W)));){if($=N[0],W=W.substring($.length),$e=N[2].split(`
`,1)[0],je=W.split(`
`,1)[0],this.options.pedantic?(de=2,Ue=$e.trimLeft()):(de=N[2].search(/[^ ]/),de=de>4?1:de,Ue=$e.slice(de),de+=N[1].length),Re=!1,!$e&&/^ *$/.test(je)&&($+=je+`
`,W=W.substring(je.length+1),Qe=!0),!Qe)for(var oe=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])");W&&(ze=W.split(`
`,1)[0],$e=ze,this.options.pedantic&&($e=$e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!oe.test($e));){if($e.search(/[^ ]/)>=de||!$e.trim())Ue+=`
`+$e.slice(de);else if(!Re)Ue+=`
`+$e;else break;!Re&&!$e.trim()&&(Re=!0),$+=ze+`
`,W=W.substring(ze.length+1)}et.loose||(We?et.loose=!0:/\n *\n *$/.test($)&&(We=!0)),this.options.gfm&&(K=/^\[[ xX]\] /.exec(Ue),K&&(re=K[0]!=="[ ] ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),et.items.push({type:"list_item",raw:$,task:!!K,checked:re,loose:!1,text:Ue}),et.raw+=$}et.items[et.items.length-1].raw=$.trimRight(),et.items[et.items.length-1].text=Ue.trimRight(),et.raw=et.raw.trimRight();var J=et.items.length;for(ye=0;ye<J;ye++){this.lexer.state.top=!1,et.items[ye].tokens=this.lexer.blockTokens(et.items[ye].text,[]);var pe=et.items[ye].tokens.filter(function(Me){return Me.type==="space"}),Ce=pe.every(function(Me){for(var He=Me.raw.split(""),Ye=0,rt=A(He),gt;!(gt=rt()).done;){var vt=gt.value;if(vt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!et.loose&&pe.length&&Ce&&(et.loose=!0,et.items[ye].loose=!0)}return et}},Ee.html=function(W){var N=this.rules.block.html.exec(W);if(N){var $={type:"html",raw:N[0],pre:!this.options.sanitizer&&(N[1]==="pre"||N[1]==="script"||N[1]==="style"),text:N[0]};return this.options.sanitize&&($.type="paragraph",$.text=this.options.sanitizer?this.options.sanitizer(N[0]):p(N[0]),$.tokens=[],this.lexer.inline($.text,$.tokens)),$}},Ee.def=function(W){var N=this.rules.block.def.exec(W);if(N){N[3]&&(N[3]=N[3].substring(1,N[3].length-1));var $=N[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$,raw:N[0],href:N[2],title:N[3]}}},Ee.table=function(W){var N=this.rules.block.table.exec(W);if(N){var $={type:"table",header:h(N[1]).map(function(We){return{text:We}}),align:N[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:N[3]?N[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($.header.length===$.align.length){$.raw=N[0];var K=$.align.length,re,de,ye,Re;for(re=0;re<K;re++)/^ *-+: *$/.test($.align[re])?$.align[re]="right":/^ *:-+: *$/.test($.align[re])?$.align[re]="center":/^ *:-+ *$/.test($.align[re])?$.align[re]="left":$.align[re]=null;for(K=$.rows.length,re=0;re<K;re++)$.rows[re]=h($.rows[re],$.header.length).map(function(We){return{text:We}});for(K=$.header.length,de=0;de<K;de++)$.header[de].tokens=[],this.lexer.inlineTokens($.header[de].text,$.header[de].tokens);for(K=$.rows.length,de=0;de<K;de++)for(Re=$.rows[de],ye=0;ye<Re.length;ye++)Re[ye].tokens=[],this.lexer.inlineTokens(Re[ye].text,Re[ye].tokens);return $}}},Ee.lheading=function(W){var N=this.rules.block.lheading.exec(W);if(N){var $={type:"heading",raw:N[0],depth:N[2].charAt(0)==="="?1:2,text:N[1],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Ee.paragraph=function(W){var N=this.rules.block.paragraph.exec(W);if(N){var $={type:"paragraph",raw:N[0],text:N[1].charAt(N[1].length-1)===`
`?N[1].slice(0,-1):N[1],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Ee.text=function(W){var N=this.rules.block.text.exec(W);if(N){var $={type:"text",raw:N[0],text:N[0],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Ee.escape=function(W){var N=this.rules.inline.escape.exec(W);if(N)return{type:"escape",raw:N[0],text:p(N[1])}},Ee.tag=function(W){var N=this.rules.inline.tag.exec(W);if(N)return!this.lexer.state.inLink&&/^<a /i.test(N[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(N[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(N[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(N[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:N[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(N[0]):p(N[0]):N[0]}},Ee.link=function(W){var N=this.rules.inline.link.exec(W);if(N){var $=N[2].trim();if(!this.options.pedantic&&/^</.test($)){if(!/>$/.test($))return;var K=u($.slice(0,-1),"\\");if(($.length-K.length)%2==0)return}else{var re=w(N[2],"()");if(re>-1){var de=N[0].indexOf("!")===0?5:4,ye=de+N[1].length+re;N[2]=N[2].substring(0,re),N[0]=N[0].substring(0,ye).trim(),N[3]=""}}var Re=N[2],We="";if(this.options.pedantic){var $e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);$e&&(Re=$e[1],We=$e[3])}else We=N[3]?N[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test($)?Re=Re.slice(1):Re=Re.slice(1,-1)),L(N,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},N[0],this.lexer)}},Ee.reflink=function(W,N){var $;if(($=this.rules.inline.reflink.exec(W))||($=this.rules.inline.nolink.exec(W))){var K=($[2]||$[1]).replace(/\s+/g," ");if(K=N[K.toLowerCase()],!K||!K.href){var re=$[0].charAt(0);return{type:"text",raw:re,text:re}}return L($,K,$[0],this.lexer)}},Ee.emStrong=function(W,N,$){$===void 0&&($="");var K=this.rules.inline.emStrong.lDelim.exec(W);if(!!K&&!(K[3]&&$.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=K[1]||K[2]||"";if(!re||re&&($===""||this.rules.inline.punctuation.exec($))){var de=K[0].length-1,ye,Re,We=de,$e=0,je=K[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(je.lastIndex=0,N=N.slice(-1*W.length+de);(K=je.exec(N))!=null;)if(ye=K[1]||K[2]||K[3]||K[4]||K[5]||K[6],!!ye){if(Re=ye.length,K[3]||K[4]){We+=Re;continue}else if((K[5]||K[6])&&de%3&&!((de+Re)%3)){$e+=Re;continue}if(We-=Re,!(We>0)){if(Re=Math.min(Re,Re+We+$e),Math.min(de,Re)%2){var ze=W.slice(1,de+K.index+Re);return{type:"em",raw:W.slice(0,de+K.index+Re+1),text:ze,tokens:this.lexer.inlineTokens(ze,[])}}var Ue=W.slice(2,de+K.index+Re-1);return{type:"strong",raw:W.slice(0,de+K.index+Re+1),text:Ue,tokens:this.lexer.inlineTokens(Ue,[])}}}}}},Ee.codespan=function(W){var N=this.rules.inline.code.exec(W);if(N){var $=N[2].replace(/\n/g," "),K=/[^ ]/.test($),re=/^ /.test($)&&/ $/.test($);return K&&re&&($=$.substring(1,$.length-1)),$=p($,!0),{type:"codespan",raw:N[0],text:$}}},Ee.br=function(W){var N=this.rules.inline.br.exec(W);if(N)return{type:"br",raw:N[0]}},Ee.del=function(W){var N=this.rules.inline.del.exec(W);if(N)return{type:"del",raw:N[0],text:N[2],tokens:this.lexer.inlineTokens(N[2],[])}},Ee.autolink=function(W,N){var $=this.rules.inline.autolink.exec(W);if($){var K,re;return $[2]==="@"?(K=p(this.options.mangle?N($[1]):$[1]),re="mailto:"+K):(K=p($[1]),re=K),{type:"link",raw:$[0],text:K,href:re,tokens:[{type:"text",raw:K,text:K}]}}},Ee.url=function(W,N){var $;if($=this.rules.inline.url.exec(W)){var K,re;if($[2]==="@")K=p(this.options.mangle?N($[0]):$[0]),re="mailto:"+K;else{var de;do de=$[0],$[0]=this.rules.inline._backpedal.exec($[0])[0];while(de!==$[0]);K=p($[0]),$[1]==="www."?re="http://"+K:re=K}return{type:"link",raw:$[0],text:K,href:re,tokens:[{type:"text",raw:K,text:K}]}}},Ee.inlineText=function(W,N){var $=this.rules.inline.text.exec(W);if($){var K;return this.lexer.state.inRawBlock?K=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($[0]):p($[0]):$[0]:K=p(this.options.smartypants?N($[0]):$[0]),{type:"text",raw:$[0],text:K}}},_e}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:s,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=b(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=b(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=b(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=b(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=b(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=b(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=l({},M),M.gfm=l({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=b(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=b(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=l({},M.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:s,paragraph:b(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:s,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:s,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=b(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=b(M._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=b(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=b(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=b(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=b(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=b(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=b(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=b(X.reflink).replace("label",X._label).replace("ref",M._label).getRegex(),X.nolink=b(X.nolink).replace("ref",M._label).getRegex(),X.reflinkSearch=b(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=l({},X),X.pedantic=l({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=l({},X.normal,{escape:b(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),X.gfm.url=b(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=l({},X.gfm,{br:b(X.br).replace("{2,}","*").getRegex(),text:b(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function G(_e){return _e.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(_e){var Ee="",z,W,N=_e.length;for(z=0;z<N;z++)W=_e.charCodeAt(z),Math.random()>.5&&(W="x"+W.toString(16)),Ee+="&#"+W+";";return Ee}var B=function(){function _e(z){this.tokens=[],this.tokens.links=Object.create(null),this.options=z||te.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var W={block:M.normal,inline:X.normal};this.options.pedantic?(W.block=M.pedantic,W.inline=X.pedantic):this.options.gfm&&(W.block=M.gfm,this.options.breaks?W.inline=X.breaks:W.inline=X.gfm),this.tokenizer.rules=W}_e.lex=function(W,N){var $=new _e(N);return $.lex(W)},_e.lexInline=function(W,N){var $=new _e(N);return $.inlineTokens(W)};var Ee=_e.prototype;return Ee.lex=function(W){W=W.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(W,this.tokens);for(var N;N=this.inlineQueue.shift();)this.inlineTokens(N.src,N.tokens);return this.tokens},Ee.blockTokens=function(W,N){var $=this;N===void 0&&(N=[]),this.options.pedantic&&(W=W.replace(/^ +$/gm,""));for(var K,re,de,ye;W;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(We){return(K=We.call({lexer:$},W,N))?(W=W.substring(K.raw.length),N.push(K),!0):!1}))){if(K=this.tokenizer.space(W)){W=W.substring(K.raw.length),K.raw.length===1&&N.length>0?N[N.length-1].raw+=`
`:N.push(K);continue}if(K=this.tokenizer.code(W)){W=W.substring(K.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+K.raw,re.text+=`
`+K.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(K);continue}if(K=this.tokenizer.fences(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.heading(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.hr(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.blockquote(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.list(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.html(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.def(W)){W=W.substring(K.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+K.raw,re.text+=`
`+K.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[K.tag]||(this.tokens.links[K.tag]={href:K.href,title:K.title});continue}if(K=this.tokenizer.table(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.lheading(W)){W=W.substring(K.raw.length),N.push(K);continue}if(de=W,this.options.extensions&&this.options.extensions.startBlock&&function(){var We=1/0,$e=W.slice(1),je=void 0;$.options.extensions.startBlock.forEach(function(ze){je=ze.call({lexer:this},$e),typeof je=="number"&&je>=0&&(We=Math.min(We,je))}),We<1/0&&We>=0&&(de=W.substring(0,We+1))}(),this.state.top&&(K=this.tokenizer.paragraph(de))){re=N[N.length-1],ye&&re.type==="paragraph"?(re.raw+=`
`+K.raw,re.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(K),ye=de.length!==W.length,W=W.substring(K.raw.length);continue}if(K=this.tokenizer.text(W)){W=W.substring(K.raw.length),re=N[N.length-1],re&&re.type==="text"?(re.raw+=`
`+K.raw,re.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(K);continue}if(W){var Re="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,N},Ee.inline=function(W,N){this.inlineQueue.push({src:W,tokens:N})},Ee.inlineTokens=function(W,N){var $=this;N===void 0&&(N=[]);var K,re,de,ye=W,Re,We,$e;if(this.tokens.links){var je=Object.keys(this.tokens.links);if(je.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(ye))!=null;)je.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(ye=ye.slice(0,Re.index)+"["+O("a",Re[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(ye))!=null;)ye=ye.slice(0,Re.index)+"["+O("a",Re[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(ye))!=null;)ye=ye.slice(0,Re.index)+"++"+ye.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;W;)if(We||($e=""),We=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ue){return(K=Ue.call({lexer:$},W,N))?(W=W.substring(K.raw.length),N.push(K),!0):!1}))){if(K=this.tokenizer.escape(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.tag(W)){W=W.substring(K.raw.length),re=N[N.length-1],re&&K.type==="text"&&re.type==="text"?(re.raw+=K.raw,re.text+=K.text):N.push(K);continue}if(K=this.tokenizer.link(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.reflink(W,this.tokens.links)){W=W.substring(K.raw.length),re=N[N.length-1],re&&K.type==="text"&&re.type==="text"?(re.raw+=K.raw,re.text+=K.text):N.push(K);continue}if(K=this.tokenizer.emStrong(W,ye,$e)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.codespan(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.br(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.del(W)){W=W.substring(K.raw.length),N.push(K);continue}if(K=this.tokenizer.autolink(W,q)){W=W.substring(K.raw.length),N.push(K);continue}if(!this.state.inLink&&(K=this.tokenizer.url(W,q))){W=W.substring(K.raw.length),N.push(K);continue}if(de=W,this.options.extensions&&this.options.extensions.startInline&&function(){var Ue=1/0,Qe=W.slice(1),nt=void 0;$.options.extensions.startInline.forEach(function(Le){nt=Le.call({lexer:this},Qe),typeof nt=="number"&&nt>=0&&(Ue=Math.min(Ue,nt))}),Ue<1/0&&Ue>=0&&(de=W.substring(0,Ue+1))}(),K=this.tokenizer.inlineText(de,G)){W=W.substring(K.raw.length),K.raw.slice(-1)!=="_"&&($e=K.raw.slice(-1)),We=!0,re=N[N.length-1],re&&re.type==="text"?(re.raw+=K.raw,re.text+=K.text):N.push(K);continue}if(W){var ze="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(ze);break}else throw new Error(ze)}}return N},d(_e,null,[{key:"rules",get:function(){return{block:M,inline:X}}}]),_e}(),x=function(){function _e(z){this.options=z||te.defaults}var Ee=_e.prototype;return Ee.code=function(W,N,$){var K=(N||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(W,K);re!=null&&re!==W&&($=!0,W=re)}return W=W.replace(/\n$/,"")+`
`,K?'<pre><code class="'+this.options.langPrefix+p(K,!0)+'">'+($?W:p(W,!0))+`</code></pre>
`:"<pre><code>"+($?W:p(W,!0))+`</code></pre>
`},Ee.blockquote=function(W){return`<blockquote>
`+W+`</blockquote>
`},Ee.html=function(W){return W},Ee.heading=function(W,N,$,K){return this.options.headerIds?"<h"+N+' id="'+this.options.headerPrefix+K.slug($)+'">'+W+"</h"+N+`>
`:"<h"+N+">"+W+"</h"+N+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(W,N,$){var K=N?"ol":"ul",re=N&&$!==1?' start="'+$+'"':"";return"<"+K+re+`>
`+W+"</"+K+`>
`},Ee.listitem=function(W){return"<li>"+W+`</li>
`},Ee.checkbox=function(W){return"<input "+(W?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(W){return"<p>"+W+`</p>
`},Ee.table=function(W,N){return N&&(N="<tbody>"+N+"</tbody>"),`<table>
<thead>
`+W+`</thead>
`+N+`</table>
`},Ee.tablerow=function(W){return`<tr>
`+W+`</tr>
`},Ee.tablecell=function(W,N){var $=N.header?"th":"td",K=N.align?"<"+$+' align="'+N.align+'">':"<"+$+">";return K+W+"</"+$+`>
`},Ee.strong=function(W){return"<strong>"+W+"</strong>"},Ee.em=function(W){return"<em>"+W+"</em>"},Ee.codespan=function(W){return"<code>"+W+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(W){return"<del>"+W+"</del>"},Ee.link=function(W,N,$){if(W=g(this.options.sanitize,this.options.baseUrl,W),W===null)return $;var K='<a href="'+p(W)+'"';return N&&(K+=' title="'+N+'"'),K+=">"+$+"</a>",K},Ee.image=function(W,N,$){if(W=g(this.options.sanitize,this.options.baseUrl,W),W===null)return $;var K='<img src="'+W+'" alt="'+$+'"';return N&&(K+=' title="'+N+'"'),K+=this.options.xhtml?"/>":">",K},Ee.text=function(W){return W},_e}(),j=function(){function _e(){}var Ee=_e.prototype;return Ee.strong=function(W){return W},Ee.em=function(W){return W},Ee.codespan=function(W){return W},Ee.del=function(W){return W},Ee.html=function(W){return W},Ee.text=function(W){return W},Ee.link=function(W,N,$){return""+$},Ee.image=function(W,N,$){return""+$},Ee.br=function(){return""},_e}(),V=function(){function _e(){this.seen={}}var Ee=_e.prototype;return Ee.serialize=function(W){return W.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(W,N){var $=W,K=0;if(this.seen.hasOwnProperty($)){K=this.seen[W];do K++,$=W+"-"+K;while(this.seen.hasOwnProperty($))}return N||(this.seen[W]=K,this.seen[$]=0),$},Ee.slug=function(W,N){N===void 0&&(N={});var $=this.serialize(W);return this.getNextSafeSlug($,N.dryrun)},_e}(),Z=function(){function _e(z){this.options=z||te.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new j,this.slugger=new V}_e.parse=function(W,N){var $=new _e(N);return $.parse(W)},_e.parseInline=function(W,N){var $=new _e(N);return $.parseInline(W)};var Ee=_e.prototype;return Ee.parse=function(W,N){N===void 0&&(N=!0);var $="",K,re,de,ye,Re,We,$e,je,ze,Ue,Qe,nt,Le,et,ne,oe,J,pe,Ce,Me=W.length;for(K=0;K<Me;K++){if(Ue=W[K],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ue.type]&&(Ce=this.options.extensions.renderers[Ue.type].call({parser:this},Ue),Ce!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ue.type))){$+=Ce||"";continue}switch(Ue.type){case"space":continue;case"hr":{$+=this.renderer.hr();continue}case"heading":{$+=this.renderer.heading(this.parseInline(Ue.tokens),Ue.depth,v(this.parseInline(Ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{$+=this.renderer.code(Ue.text,Ue.lang,Ue.escaped);continue}case"table":{for(je="",$e="",ye=Ue.header.length,re=0;re<ye;re++)$e+=this.renderer.tablecell(this.parseInline(Ue.header[re].tokens),{header:!0,align:Ue.align[re]});for(je+=this.renderer.tablerow($e),ze="",ye=Ue.rows.length,re=0;re<ye;re++){for(We=Ue.rows[re],$e="",Re=We.length,de=0;de<Re;de++)$e+=this.renderer.tablecell(this.parseInline(We[de].tokens),{header:!1,align:Ue.align[de]});ze+=this.renderer.tablerow($e)}$+=this.renderer.table(je,ze);continue}case"blockquote":{ze=this.parse(Ue.tokens),$+=this.renderer.blockquote(ze);continue}case"list":{for(Qe=Ue.ordered,nt=Ue.start,Le=Ue.loose,ye=Ue.items.length,ze="",re=0;re<ye;re++)ne=Ue.items[re],oe=ne.checked,J=ne.task,et="",ne.task&&(pe=this.renderer.checkbox(oe),Le?ne.tokens.length>0&&ne.tokens[0].type==="paragraph"?(ne.tokens[0].text=pe+" "+ne.tokens[0].text,ne.tokens[0].tokens&&ne.tokens[0].tokens.length>0&&ne.tokens[0].tokens[0].type==="text"&&(ne.tokens[0].tokens[0].text=pe+" "+ne.tokens[0].tokens[0].text)):ne.tokens.unshift({type:"text",text:pe}):et+=pe),et+=this.parse(ne.tokens,Le),ze+=this.renderer.listitem(et,J,oe);$+=this.renderer.list(ze,Qe,nt);continue}case"html":{$+=this.renderer.html(Ue.text);continue}case"paragraph":{$+=this.renderer.paragraph(this.parseInline(Ue.tokens));continue}case"text":{for(ze=Ue.tokens?this.parseInline(Ue.tokens):Ue.text;K+1<Me&&W[K+1].type==="text";)Ue=W[++K],ze+=`
`+(Ue.tokens?this.parseInline(Ue.tokens):Ue.text);$+=N?this.renderer.paragraph(ze):ze;continue}default:{var He='Token with "'+Ue.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return $},Ee.parseInline=function(W,N){N=N||this.renderer;var $="",K,re,de,ye=W.length;for(K=0;K<ye;K++){if(re=W[K],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(de=this.options.extensions.renderers[re.type].call({parser:this},re),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type))){$+=de||"";continue}switch(re.type){case"escape":{$+=N.text(re.text);break}case"html":{$+=N.html(re.text);break}case"link":{$+=N.link(re.href,re.title,this.parseInline(re.tokens,N));break}case"image":{$+=N.image(re.href,re.title,re.text);break}case"strong":{$+=N.strong(this.parseInline(re.tokens,N));break}case"em":{$+=N.em(this.parseInline(re.tokens,N));break}case"codespan":{$+=N.codespan(re.text);break}case"br":{$+=N.br();break}case"del":{$+=N.del(this.parseInline(re.tokens,N));break}case"text":{$+=N.text(re.text);break}default:{var Re='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return $},_e}();function se(_e,Ee,z){if(typeof _e=="undefined"||_e===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _e!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_e)+", string expected");if(typeof Ee=="function"&&(z=Ee,Ee=null),Ee=l({},se.defaults,Ee||{}),R(Ee),z){var W=Ee.highlight,N;try{N=B.lex(_e,Ee)}catch(de){return z(de)}var $=function(ye){var Re;if(!ye)try{Ee.walkTokens&&se.walkTokens(N,Ee.walkTokens),Re=Z.parse(N,Ee)}catch(We){ye=We}return Ee.highlight=W,ye?z(ye):z(null,Re)};if(!W||W.length<3||(delete Ee.highlight,!N.length))return $();var K=0;se.walkTokens(N,function(de){de.type==="code"&&(K++,setTimeout(function(){W(de.text,de.lang,function(ye,Re){if(ye)return $(ye);Re!=null&&Re!==de.text&&(de.text=Re,de.escaped=!0),K--,K===0&&$()})},0))}),K===0&&$();return}try{var re=B.lex(_e,Ee);return Ee.walkTokens&&se.walkTokens(re,Ee.walkTokens),Z.parse(re,Ee)}catch(de){if(de.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+p(de.message+"",!0)+"</pre>";throw de}}se.options=se.setOptions=function(_e){return l(se.defaults,_e),P(se.defaults),se},se.getDefaults=D,se.defaults=te.defaults,se.use=function(){for(var _e=arguments.length,Ee=new Array(_e),z=0;z<_e;z++)Ee[z]=arguments[z];var W=l.apply(void 0,[{}].concat(Ee)),N=se.defaults.extensions||{renderers:{},childTokens:{}},$;Ee.forEach(function(K){if(K.extensions&&($=!0,K.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var ye=N.renderers?N.renderers[de.name]:null;ye?N.renderers[de.name]=function(){for(var Re=arguments.length,We=new Array(Re),$e=0;$e<Re;$e++)We[$e]=arguments[$e];var je=de.renderer.apply(this,We);return je===!1&&(je=ye.apply(this,We)),je}:N.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");N[de.level]?N[de.level].unshift(de.tokenizer):N[de.level]=[de.tokenizer],de.start&&(de.level==="block"?N.startBlock?N.startBlock.push(de.start):N.startBlock=[de.start]:de.level==="inline"&&(N.startInline?N.startInline.push(de.start):N.startInline=[de.start]))}de.childTokens&&(N.childTokens[de.name]=de.childTokens)})),K.renderer&&function(){var de=se.defaults.renderer||new x,ye=function($e){var je=de[$e];de[$e]=function(){for(var ze=arguments.length,Ue=new Array(ze),Qe=0;Qe<ze;Qe++)Ue[Qe]=arguments[Qe];var nt=K.renderer[$e].apply(de,Ue);return nt===!1&&(nt=je.apply(de,Ue)),nt}};for(var Re in K.renderer)ye(Re);W.renderer=de}(),K.tokenizer&&function(){var de=se.defaults.tokenizer||new U,ye=function($e){var je=de[$e];de[$e]=function(){for(var ze=arguments.length,Ue=new Array(ze),Qe=0;Qe<ze;Qe++)Ue[Qe]=arguments[Qe];var nt=K.tokenizer[$e].apply(de,Ue);return nt===!1&&(nt=je.apply(de,Ue)),nt}};for(var Re in K.tokenizer)ye(Re);W.tokenizer=de}(),K.walkTokens){var re=se.defaults.walkTokens;W.walkTokens=function(de){K.walkTokens.call(this,de),re&&re.call(this,de)}}$&&(W.extensions=N),se.setOptions(W)})},se.walkTokens=function(_e,Ee){for(var z=function(){var K=N.value;switch(Ee.call(se,K),K.type){case"table":{for(var re=A(K.header),de;!(de=re()).done;){var ye=de.value;se.walkTokens(ye.tokens,Ee)}for(var Re=A(K.rows),We;!(We=Re()).done;)for(var $e=We.value,je=A($e),ze;!(ze=je()).done;){var Ue=ze.value;se.walkTokens(Ue.tokens,Ee)}break}case"list":{se.walkTokens(K.items,Ee);break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[K.type]?se.defaults.extensions.childTokens[K.type].forEach(function(Qe){se.walkTokens(K[Qe],Ee)}):K.tokens&&se.walkTokens(K.tokens,Ee)}},W=A(_e),N;!(N=W()).done;)z()},se.parseInline=function(_e,Ee){if(typeof _e=="undefined"||_e===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _e!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_e)+", string expected");Ee=l({},se.defaults,Ee||{}),R(Ee);try{var z=B.lexInline(_e,Ee);return Ee.walkTokens&&se.walkTokens(z,Ee.walkTokens),Z.parseInline(z,Ee)}catch(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+p(W.message+"",!0)+"</pre>";throw W}},se.Parser=Z,se.parser=Z.parse,se.Renderer=x,se.TextRenderer=j,se.Lexer=B,se.lexer=B.lex,se.Tokenizer=U,se.Slugger=V,se.parse=se;var ce=se.options,ee=se.setOptions,Y=se.use,ae=se.walkTokens,he=se.parseInline,we=se,ke=Z.parse,Ne=B.lex;te.Lexer=B,te.Parser=Z,te.Renderer=x,te.Slugger=V,te.TextRenderer=j,te.Tokenizer=U,te.getDefaults=D,te.lexer=Ne,te.marked=se,te.options=ce,te.parse=we,te.parseInline=he,te.parser=ke,te.setOptions=ee,te.use=Y,te.walkTokens=ae,Object.defineProperty(te,"__esModule",{value:!0})}),define(ve[93],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(P,y,T){return Math.min(Math.max(P,y),T)}e.clamp=d;function t(P,y){return(y+P%y)%y}e.rot=t;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class A{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class D{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const T=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=T,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function te(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function D(y){A.push(y,Date.now())}function P(){const y=[];for(let T=0;T<A.length;T+=2)y.push({name:A[T],startTime:A[T+1]});return y}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(k+D.startTime)});return A}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function d(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=d(t))}(),define(ve[11],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const d="en";let t=!1,k=!1,A=!1,D=!1,P=!1,y=!1,T=!1,F=!1,C=!1,f,_=d,p,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const I=typeof v?.versions?.electron=="string",b=I&&v?.type==="renderer";if(e.isElectronSandboxed=b&&v?.sandboxed,typeof navigator=="object"&&!b)c=navigator.userAgent,t=c.indexOf("Windows")>=0,k=c.indexOf("Macintosh")>=0,F=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,y=!0,f=navigator.language,_=f;else if(typeof v=="object"){t=v.platform==="win32",k=v.platform==="darwin",A=v.platform==="linux",D=A&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,T=I,C=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=d,_=d;const s=v.env.VSCODE_NLS_CONFIG;if(s)try{const l=JSON.parse(s),h=l.availableLanguages["*"];f=l.locale,_=h||d,p=l._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var m;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function o(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let g=0;k?g=1:t?g=3:A&&(g=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=A,e.isLinuxSnap=D,e.isNative=P,e.isElectron=T,e.isWeb=y,e.isIOS=F,e.isCI=C,e.platform=g,e.userAgent=c,e.language=_;var n;(function(s){function l(){return e.language}s.value=l;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=h;function u(){return e.language==="en"}s.isDefault=u})(n=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=p,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let u=0,w=s.length;u<w;u++){const R=s[u];if(R.id===h.data.vscodeScheduleAsyncWork){s.splice(u,1),R.callback();return}}});let l=0;return h=>{const u=++l;s.push({id:u,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:u},"*")}}return s=>setTimeout(s)})();var E;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(E=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||F?2:t?1:3;let a=!0,i=!1;function r(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[40],be([1,0,11]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof d.globals.vscode!="undefined"&&typeof d.globals.vscode.process!="undefined"){const k=d.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return d.isWindows?"win32":d.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ve[9],be([1,0,40]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,A=90,D=122,P=46,y=47,T=92,F=58,C=63;class f extends Error{constructor(o,g,n){let E;typeof g=="string"&&g.indexOf("not ")===0?(E="must not be",g=g.replace(/^not /,"")):E="must be";const a=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${a} ${E} of type ${g}`;i+=`. Received type ${typeof n}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function _(m,o){if(typeof m!="string")throw new f(o,"string",m)}function p(m){return m===y||m===T}function c(m){return m===y}function v(m){return m>=t&&m<=A||m>=k&&m<=D}function I(m,o,g,n){let E="",a=0,i=-1,r=0,s=0;for(let l=0;l<=m.length;++l){if(l<m.length)s=m.charCodeAt(l);else{if(n(s))break;s=y}if(n(s)){if(!(i===l-1||r===1))if(r===2){if(E.length<2||a!==2||E.charCodeAt(E.length-1)!==P||E.charCodeAt(E.length-2)!==P){if(E.length>2){const h=E.lastIndexOf(g);h===-1?(E="",a=0):(E=E.slice(0,h),a=E.length-1-E.lastIndexOf(g)),i=l,r=0;continue}else if(E.length!==0){E="",a=0,i=l,r=0;continue}}o&&(E+=E.length>0?`${g}..`:"..",a=2)}else E.length>0?E+=`${g}${m.slice(i+1,l)}`:E=m.slice(i+1,l),a=l-i-1;i=l,r=0}else s===P&&r!==-1?++r:r=-1}return E}function b(m,o){if(o===null||typeof o!="object")throw new f("pathObject","Object",o);const g=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return g?g===o.root?`${g}${n}`:`${g}${m}${n}`:n}e.win32={resolve(...m){let o="",g="",n=!1;for(let E=m.length-1;E>=-1;E--){let a;if(E>=0){if(a=m[E],_(a,"path"),a.length===0)continue}else o.length===0?a=d.cwd():(a=d.env[`=${o}`]||d.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===T)&&(a=`${o}\\`));const i=a.length;let r=0,s="",l=!1;const h=a.charCodeAt(0);if(i===1)p(h)&&(r=1,l=!0);else if(p(h))if(l=!0,p(a.charCodeAt(1))){let u=2,w=u;for(;u<i&&!p(a.charCodeAt(u));)u++;if(u<i&&u!==w){const R=a.slice(w,u);for(w=u;u<i&&p(a.charCodeAt(u));)u++;if(u<i&&u!==w){for(w=u;u<i&&!p(a.charCodeAt(u));)u++;(u===i||u!==w)&&(s=`\\\\${R}\\${a.slice(w,u)}`,r=u)}}}else r=1;else v(h)&&a.charCodeAt(1)===F&&(s=a.slice(0,2),r=2,i>2&&p(a.charCodeAt(2))&&(l=!0,r=3));if(s.length>0)if(o.length>0){if(s.toLowerCase()!==o.toLowerCase())continue}else o=s;if(n){if(o.length>0)break}else if(g=`${a.slice(r)}\\${g}`,n=l,l&&o.length>0)break}return g=I(g,!n,"\\",p),n?`${o}\\${g}`:`${o}${g}`||"."},normalize(m){_(m,"path");const o=m.length;if(o===0)return".";let g=0,n,E=!1;const a=m.charCodeAt(0);if(o===1)return c(a)?"\\":m;if(p(a))if(E=!0,p(m.charCodeAt(1))){let r=2,s=r;for(;r<o&&!p(m.charCodeAt(r));)r++;if(r<o&&r!==s){const l=m.slice(s,r);for(s=r;r<o&&p(m.charCodeAt(r));)r++;if(r<o&&r!==s){for(s=r;r<o&&!p(m.charCodeAt(r));)r++;if(r===o)return`\\\\${l}\\${m.slice(s)}\\`;r!==s&&(n=`\\\\${l}\\${m.slice(s,r)}`,g=r)}}}else g=1;else v(a)&&m.charCodeAt(1)===F&&(n=m.slice(0,2),g=2,o>2&&p(m.charCodeAt(2))&&(E=!0,g=3));let i=g<o?I(m.slice(g),!E,"\\",p):"";return i.length===0&&!E&&(i="."),i.length>0&&p(m.charCodeAt(o-1))&&(i+="\\"),n===void 0?E?`\\${i}`:i:E?`${n}\\${i}`:`${n}${i}`},isAbsolute(m){_(m,"path");const o=m.length;if(o===0)return!1;const g=m.charCodeAt(0);return p(g)||o>2&&v(g)&&m.charCodeAt(1)===F&&p(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let o,g;for(let a=0;a<m.length;++a){const i=m[a];_(i,"path"),i.length>0&&(o===void 0?o=g=i:o+=`\\${i}`)}if(o===void 0)return".";let n=!0,E=0;if(typeof g=="string"&&p(g.charCodeAt(0))){++E;const a=g.length;a>1&&p(g.charCodeAt(1))&&(++E,a>2&&(p(g.charCodeAt(2))?++E:n=!1))}if(n){for(;E<o.length&&p(o.charCodeAt(E));)E++;E>=2&&(o=`\\${o.slice(E)}`)}return e.win32.normalize(o)},relative(m,o){if(_(m,"from"),_(o,"to"),m===o)return"";const g=e.win32.resolve(m),n=e.win32.resolve(o);if(g===n||(m=g.toLowerCase(),o=n.toLowerCase(),m===o))return"";let E=0;for(;E<m.length&&m.charCodeAt(E)===T;)E++;let a=m.length;for(;a-1>E&&m.charCodeAt(a-1)===T;)a--;const i=a-E;let r=0;for(;r<o.length&&o.charCodeAt(r)===T;)r++;let s=o.length;for(;s-1>r&&o.charCodeAt(s-1)===T;)s--;const l=s-r,h=i<l?i:l;let u=-1,w=0;for(;w<h;w++){const O=m.charCodeAt(E+w);if(O!==o.charCodeAt(r+w))break;O===T&&(u=w)}if(w!==h){if(u===-1)return n}else{if(l>h){if(o.charCodeAt(r+w)===T)return n.slice(r+w+1);if(w===2)return n.slice(r+w)}i>h&&(m.charCodeAt(E+w)===T?u=w:w===2&&(u=3)),u===-1&&(u=0)}let R="";for(w=E+u+1;w<=a;++w)(w===a||m.charCodeAt(w)===T)&&(R+=R.length===0?"..":"\\..");return r+=u,R.length>0?`${R}${n.slice(r,s)}`:(n.charCodeAt(r)===T&&++r,n.slice(r,s))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const o=e.win32.resolve(m);if(o.length<=2)return m;if(o.charCodeAt(0)===T){if(o.charCodeAt(1)===T){const g=o.charCodeAt(2);if(g!==C&&g!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(v(o.charCodeAt(0))&&o.charCodeAt(1)===F&&o.charCodeAt(2)===T)return`\\\\?\\${o}`;return m},dirname(m){_(m,"path");const o=m.length;if(o===0)return".";let g=-1,n=0;const E=m.charCodeAt(0);if(o===1)return p(E)?m:".";if(p(E)){if(g=n=1,p(m.charCodeAt(1))){let r=2,s=r;for(;r<o&&!p(m.charCodeAt(r));)r++;if(r<o&&r!==s){for(s=r;r<o&&p(m.charCodeAt(r));)r++;if(r<o&&r!==s){for(s=r;r<o&&!p(m.charCodeAt(r));)r++;if(r===o)return m;r!==s&&(g=n=r+1)}}}}else v(E)&&m.charCodeAt(1)===F&&(g=o>2&&p(m.charCodeAt(2))?3:2,n=g);let a=-1,i=!0;for(let r=o-1;r>=n;--r)if(p(m.charCodeAt(r))){if(!i){a=r;break}}else i=!1;if(a===-1){if(g===-1)return".";a=g}return m.slice(0,a)},basename(m,o){o!==void 0&&_(o,"ext"),_(m,"path");let g=0,n=-1,E=!0,a;if(m.length>=2&&v(m.charCodeAt(0))&&m.charCodeAt(1)===F&&(g=2),o!==void 0&&o.length>0&&o.length<=m.length){if(o===m)return"";let i=o.length-1,r=-1;for(a=m.length-1;a>=g;--a){const s=m.charCodeAt(a);if(p(s)){if(!E){g=a+1;break}}else r===-1&&(E=!1,r=a+1),i>=0&&(s===o.charCodeAt(i)?--i==-1&&(n=a):(i=-1,n=r))}return g===n?n=r:n===-1&&(n=m.length),m.slice(g,n)}for(a=m.length-1;a>=g;--a)if(p(m.charCodeAt(a))){if(!E){g=a+1;break}}else n===-1&&(E=!1,n=a+1);return n===-1?"":m.slice(g,n)},extname(m){_(m,"path");let o=0,g=-1,n=0,E=-1,a=!0,i=0;m.length>=2&&m.charCodeAt(1)===F&&v(m.charCodeAt(0))&&(o=n=2);for(let r=m.length-1;r>=o;--r){const s=m.charCodeAt(r);if(p(s)){if(!a){n=r+1;break}continue}E===-1&&(a=!1,E=r+1),s===P?g===-1?g=r:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||E===-1||i===0||i===1&&g===E-1&&g===n+1?"":m.slice(g,E)},format:b.bind(null,"\\"),parse(m){_(m,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return o;const g=m.length;let n=0,E=m.charCodeAt(0);if(g===1)return p(E)?(o.root=o.dir=m,o):(o.base=o.name=m,o);if(p(E)){if(n=1,p(m.charCodeAt(1))){let u=2,w=u;for(;u<g&&!p(m.charCodeAt(u));)u++;if(u<g&&u!==w){for(w=u;u<g&&p(m.charCodeAt(u));)u++;if(u<g&&u!==w){for(w=u;u<g&&!p(m.charCodeAt(u));)u++;u===g?n=u:u!==w&&(n=u+1)}}}}else if(v(E)&&m.charCodeAt(1)===F){if(g<=2)return o.root=o.dir=m,o;if(n=2,p(m.charCodeAt(2))){if(g===3)return o.root=o.dir=m,o;n=3}}n>0&&(o.root=m.slice(0,n));let a=-1,i=n,r=-1,s=!0,l=m.length-1,h=0;for(;l>=n;--l){if(E=m.charCodeAt(l),p(E)){if(!s){i=l+1;break}continue}r===-1&&(s=!1,r=l+1),E===P?a===-1?a=l:h!==1&&(h=1):a!==-1&&(h=-1)}return r!==-1&&(a===-1||h===0||h===1&&a===r-1&&a===i+1?o.base=o.name=m.slice(i,r):(o.name=m.slice(i,a),o.base=m.slice(i,r),o.ext=m.slice(a,r))),i>0&&i!==n?o.dir=m.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let o="",g=!1;for(let n=m.length-1;n>=-1&&!g;n--){const E=n>=0?m[n]:d.cwd();_(E,"path"),E.length!==0&&(o=`${E}/${o}`,g=E.charCodeAt(0)===y)}return o=I(o,!g,"/",c),g?`/${o}`:o.length>0?o:"."},normalize(m){if(_(m,"path"),m.length===0)return".";const o=m.charCodeAt(0)===y,g=m.charCodeAt(m.length-1)===y;return m=I(m,!o,"/",c),m.length===0?o?"/":g?"./":".":(g&&(m+="/"),o?`/${m}`:m)},isAbsolute(m){return _(m,"path"),m.length>0&&m.charCodeAt(0)===y},join(...m){if(m.length===0)return".";let o;for(let g=0;g<m.length;++g){const n=m[g];_(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.posix.normalize(o)},relative(m,o){if(_(m,"from"),_(o,"to"),m===o||(m=e.posix.resolve(m),o=e.posix.resolve(o),m===o))return"";const g=1,n=m.length,E=n-g,a=1,i=o.length-a,r=E<i?E:i;let s=-1,l=0;for(;l<r;l++){const u=m.charCodeAt(g+l);if(u!==o.charCodeAt(a+l))break;u===y&&(s=l)}if(l===r)if(i>r){if(o.charCodeAt(a+l)===y)return o.slice(a+l+1);if(l===0)return o.slice(a+l)}else E>r&&(m.charCodeAt(g+l)===y?s=l:l===0&&(s=0));let h="";for(l=g+s+1;l<=n;++l)(l===n||m.charCodeAt(l)===y)&&(h+=h.length===0?"..":"/..");return`${h}${o.slice(a+s)}`},toNamespacedPath(m){return m},dirname(m){if(_(m,"path"),m.length===0)return".";const o=m.charCodeAt(0)===y;let g=-1,n=!0;for(let E=m.length-1;E>=1;--E)if(m.charCodeAt(E)===y){if(!n){g=E;break}}else n=!1;return g===-1?o?"/":".":o&&g===1?"//":m.slice(0,g)},basename(m,o){o!==void 0&&_(o,"ext"),_(m,"path");let g=0,n=-1,E=!0,a;if(o!==void 0&&o.length>0&&o.length<=m.length){if(o===m)return"";let i=o.length-1,r=-1;for(a=m.length-1;a>=0;--a){const s=m.charCodeAt(a);if(s===y){if(!E){g=a+1;break}}else r===-1&&(E=!1,r=a+1),i>=0&&(s===o.charCodeAt(i)?--i==-1&&(n=a):(i=-1,n=r))}return g===n?n=r:n===-1&&(n=m.length),m.slice(g,n)}for(a=m.length-1;a>=0;--a)if(m.charCodeAt(a)===y){if(!E){g=a+1;break}}else n===-1&&(E=!1,n=a+1);return n===-1?"":m.slice(g,n)},extname(m){_(m,"path");let o=-1,g=0,n=-1,E=!0,a=0;for(let i=m.length-1;i>=0;--i){const r=m.charCodeAt(i);if(r===y){if(!E){g=i+1;break}continue}n===-1&&(E=!1,n=i+1),r===P?o===-1?o=i:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||n===-1||a===0||a===1&&o===n-1&&o===g+1?"":m.slice(o,n)},format:b.bind(null,"/"),parse(m){_(m,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return o;const g=m.charCodeAt(0)===y;let n;g?(o.root="/",n=1):n=0;let E=-1,a=0,i=-1,r=!0,s=m.length-1,l=0;for(;s>=n;--s){const h=m.charCodeAt(s);if(h===y){if(!r){a=s+1;break}continue}i===-1&&(r=!1,i=s+1),h===P?E===-1?E=s:l!==1&&(l=1):E!==-1&&(l=-1)}if(i!==-1){const h=a===0&&g?1:a;E===-1||l===0||l===1&&E===i-1&&E===a+1?o.base=o.name=m.slice(h,i):(o.name=m.slice(h,E),o.base=m.slice(h,i),o.ext=m.slice(E,i))}return a>0?o.dir=m.slice(0,a-1):g&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=d.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d.platform==="win32"?e.win32.join:e.posix.join,e.resolve=d.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=d.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=d.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=d.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=d.platform==="win32"?e.win32.extname:e.posix.extname,e.format=d.platform==="win32"?e.win32.format:e.posix.format,e.parse=d.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=d.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=d.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[94],be([1,0,9]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(C){const f=(0,d.extname)(C),_=k[f.toLowerCase()];return _!==void 0?_:P(C)}e.getMediaOrTextMime=D;function P(C){const f=(0,d.extname)(C);return A[f.toLowerCase()]}e.getMediaMime=P;function y(C){for(const f in A)if(A[f]===C)return f}e.getExtensionForMimeType=y;const T=/^(.+)\/(.+?)(;.+)?$/;function F(C,f){const _=T.exec(C);return _?`${_[1].toLowerCase()}/${_[2].toLowerCase()}${_[3]??""}`:f?void 0:C}e.normalizeMimeType=F}),define(ve[95],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var d;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(d=e.Source||(e.Source={}));var t;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(A,...D){const P=D.reduce((F,C)=>(F[C]=!0,F),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(F=>!P[F]).forEach(F=>{for(let C=0;C<y.length;C++)if(F.search(y[C])!==-1){delete A[F];break}})}e.sanitizeProcessEnvironment=k}),define(ve[46],be([1,0,11]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=d.globals.performance&&typeof d.globals.performance.now=="function";class k{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new k(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?d.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ve[3],be([1,0,16,75,6,92,46]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(g){g.None=()=>k.Disposable.None;function n(x){return(j,V=null,Z)=>{let se=!1,ce;return ce=x(ee=>{if(!se)return ce?ce.dispose():se=!0,j.call(V,ee)},null,Z),se&&ce.dispose(),ce}}g.once=n;function E(x,j){return h((V,Z=null,se)=>x(ce=>V.call(Z,j(ce)),null,se))}g.map=E;function a(x,j){return h((V,Z=null,se)=>x(ce=>{j(ce),V.call(Z,ce)},null,se))}g.forEach=a;function i(x,j){return h((V,Z=null,se)=>x(ce=>j(ce)&&V.call(Z,ce),null,se))}g.filter=i;function r(x){return x}g.signal=r;function s(...x){return(j,V=null,Z)=>(0,k.combinedDisposable)(...x.map(se=>se(ce=>j.call(V,ce),null,Z)))}g.any=s;function l(x,j,V){let Z=V;return E(x,se=>(Z=j(Z,se),Z))}g.reduce=l;function h(x){let j;const V=new _({onFirstListenerAdd(){j=x(V.fire,V)},onLastListenerRemove(){j.dispose()}});return V.event}function u(x,j,V,Z=100,se=!1){let ce,ee,Y=0;return x(ae=>{Y++,ce=V(ce,ae),se&&!ee&&(j(ce),ce=void 0),clearTimeout(ee),ee=setTimeout(()=>{const he=ce;ce=void 0,ee=void 0,(!se||Y>1)&&j(he),Y=0},Z)})}g.debouncedListener=u;function w(x,j,V=100,Z=!1,se){let ce,ee,Y,ae=0;const he=new _({leakWarningThreshold:se,onFirstListenerAdd(){ce=x(we=>{ae++,ee=j(ee,we),Z&&!Y&&(he.fire(ee),ee=void 0),clearTimeout(Y),Y=setTimeout(()=>{const ke=ee;ee=void 0,Y=void 0,(!Z||ae>1)&&he.fire(ke),ae=0},V)})},onLastListenerRemove(){ce.dispose()}});return he.event}g.debounce=w;function R(x,j=(V,Z)=>V===Z){let V=!0,Z;return i(x,se=>{const ce=V||!j(se,Z);return V=!1,Z=se,ce})}g.latch=R;function O(x,j){return[g.filter(x,j),g.filter(x,V=>!j(V))]}g.split=O;function L(x,j=!1,V=[]){let Z=V.slice(),se=x(Y=>{Z?Z.push(Y):ee.fire(Y)});const ce=()=>{Z&&Z.forEach(Y=>ee.fire(Y)),Z=null},ee=new _({onFirstListenerAdd(){se||(se=x(Y=>ee.fire(Y)))},onFirstListenerDidAdd(){Z&&(j?setTimeout(ce):ce())},onLastListenerRemove(){se&&se.dispose(),se=null}});return ee.event}g.buffer=L;class S{constructor(j){this.event=j}map(j){return new S(E(this.event,j))}forEach(j){return new S(a(this.event,j))}filter(j){return new S(i(this.event,j))}reduce(j,V){return new S(l(this.event,j,V))}latch(){return new S(R(this.event))}debounce(j,V=100,Z=!1,se){return new S(w(this.event,j,V,Z,se))}on(j,V,Z){return this.event(j,V,Z)}once(j,V,Z){return n(this.event)(j,V,Z)}}function U(x){return new S(x)}g.chain=U;function M(x,j,V=Z=>Z){const Z=(...Y)=>ee.fire(V(...Y)),se=()=>x.on(j,Z),ce=()=>x.removeListener(j,Z),ee=new _({onFirstListenerAdd:se,onLastListenerRemove:ce});return ee.event}g.fromNodeEventEmitter=M;function X(x,j,V=Z=>Z){const Z=(...Y)=>ee.fire(V(...Y)),se=()=>x.addEventListener(j,Z),ce=()=>x.removeEventListener(j,Z),ee=new _({onFirstListenerAdd:se,onLastListenerRemove:ce});return ee.event}g.fromDOMEventEmitter=X;function G(x){return new Promise(j=>n(x)(j))}g.toPromise=G;function q(x,j){return j(void 0),x(V=>j(V))}g.runAndSubscribe=q;function B(x,j){let V=null;function Z(ce){V?.dispose(),V=new k.DisposableStore,j(ce,V)}Z(void 0);const se=x(ce=>Z(ce));return(0,k.toDisposable)(()=>{se.dispose(),V?.dispose()})}g.runAndSubscribeWithStore=B})(P=e.Event||(e.Event={}));class y{constructor(n){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${n}_${y._idPool++}`}start(n){this._stopWatch=new D.StopWatch(!0),this._listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this._elapsedOverall+=n,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${n.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let T=-1;function F(g){const n=T;return T=g,{dispose(){T=n}}}e.setGlobalLeakWarningThreshold=F;class C{constructor(n,E=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=E,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n){let E=T;if(typeof this.customThreshold=="number"&&(E=this.customThreshold),E<=0||n<E)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(a)||0;if(this._stacks.set(a,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=E*.5;let r,s=0;for(const[l,h]of this._stacks)(!r||s<h)&&(r=l,s=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${s}):`),console.warn(r)}return()=>{const r=this._stacks.get(a)||0;this._stacks.set(a,r-1)}}}class f{set(n){return this._actual=n,this}unset(){this._actual=void 0}dispose(){this._actual?.dispose(),this.unset()}}class _{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=T>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(n,E,a)=>{this._listeners||(this._listeners=new A.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=new f,s=this._listeners.push([n,E,r]);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,E);const l=this._leakageMon?.check(this._listeners.size),h=r.set((0,k.toDisposable)(()=>{l&&l(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}));return a instanceof k.DisposableStore?a.add(h):Array.isArray(a)&&a.push(h),h}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let E of this._listeners)this._deliveryQueue.push([E,n]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[[E,a],i]=this._deliveryQueue.shift();try{E.call(a,i)}catch(r){(0,d.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){for(let[n,E,a]of this._listeners)a.dispose();this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}}e.Emitter=_;class p extends _{async fireAsync(n,E,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,n]);for(;this._asyncDeliveryQueue.size>0&&!E.isCancellationRequested;){const[[i,r],s]=this._asyncDeliveryQueue.shift(),l=[],h={...s,token:E,waitUntil:u=>{if(Object.isFrozen(l))throw new Error("waitUntil can NOT be called asynchronous");a&&(u=a(u,i)),l.push(u)}};try{i.call(r,h)}catch(u){(0,d.onUnexpectedError)(u);continue}Object.freeze(l),await Promise.allSettled(l).then(u=>{for(const w of u)w.status==="rejected"&&(0,d.onUnexpectedError)(w.reason)})}}}}e.AsyncEmitter=p;class c extends _{constructor(n){super(n);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=c;class v extends c{constructor(n){super(n);this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=v;class I extends _{constructor(n){super(n);this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(E=>super.fire(E)),this._queuedEvents=[]})}}e.MicrotaskEmitter=I;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new _({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const E={event:n,listener:null};this.events.push(E),this.hasListeners&&this.hook(E);const a=()=>{this.hasListeners&&this.unhook(E);const i=this.events.indexOf(E);this.events.splice(i,1)};return(0,k.toDisposable)((0,t.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(E=>this.emitter.fire(E))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class m{constructor(){this.buffers=[]}wrapEvent(n){return(E,a,i)=>n(r=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>E.call(a,r)):E.call(a,r)},void 0,i)}bufferEvents(n){const E=[];this.buffers.push(E);const a=n();return this.buffers.pop(),E.forEach(i=>i()),a}}e.EventBufferer=m;class o{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=k.Disposable.None,this.emitter=new _({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ve[21],be([1,0,3]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,y){const T=setTimeout(P.bind(y),0);return{dispose(){clearTimeout(T)}}});var k;(function(P){function y(T){return T===P.None||T===P.Cancelled||T instanceof A?!0:!T||typeof T!="object"?!1:typeof T.isCancellationRequested=="boolean"&&typeof T.onCancellationRequested=="function"}P.isCancellationToken=y,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new d.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=k.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(ve[145],be([1,0,21]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new d.CancellationTokenSource,P=this.task(D.token);return this.result={promise:P,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=t;class k{constructor(D){this.computeFn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const P=JSON.stringify(D);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.computeFn(D)),this.lastCache}}e.LRUCachedComputed=k}),define(ve[96],be([1,0,16,6]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(m){const o=m;return o?[o.on,o.pause,o.resume,o.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=k;function A(m){const o=m;return o?k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=A;function D(m,o){return new P(m,o)}e.newWriteableStream=D;class P{constructor(o,g){this.reducer=o,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(g=>g(o))}emitError(o){this.listeners.error.length===0?(0,d.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(g=>g(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,g){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(o,g){if(this.state.destroyed)return;let n;switch(o){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const E=n.indexOf(g);E>=0&&n.splice(E,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(m,o){const g=[];let n;for(;(n=m.read())!==null;)g.push(n);return o(g)}e.consumeReadable=y;function T(m,o,g){const n=[];let E;for(;(E=m.read())!==null&&n.length<g;)n.push(E);return E===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof E!="undefined"){const a=E;return E=void 0,a}return m.read()}}}e.peekReadable=T;function F(m,o){return new Promise((g,n)=>{const E=[];C(m,{onData:a=>{o&&E.push(a)},onError:a=>{o?n(a):g(void 0)},onEnd:()=>{g(o?o(E):void 0)}})})}e.consumeStream=F;function C(m,o){let g=!1;return m.on("error",n=>{g||o.onError(n)}),m.on("end",()=>{g||o.onEnd()}),m.on("data",n=>{g||o.onData(n)}),(0,t.toDisposable)(()=>g=!0)}e.listenStream=C;function f(m,o){return new Promise((g,n)=>{const E=new t.DisposableStore,a=[],i=l=>{if(a.push(l),a.length>o)return E.dispose(),m.pause(),g({stream:m,buffer:a,ended:!1})},r=l=>n(l),s=()=>g({stream:m,buffer:a,ended:!0});E.add((0,t.toDisposable)(()=>m.removeListener("error",r))),m.on("error",r),E.add((0,t.toDisposable)(()=>m.removeListener("end",s))),m.on("end",s),E.add((0,t.toDisposable)(()=>m.removeListener("data",i))),m.on("data",i)})}e.peekStream=f;function _(m,o){const g=D(o);return g.end(m),g}e.toStream=_;function p(){const m=D(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=p;function c(m){let o=!1;return{read:()=>o?null:(o=!0,m)}}e.toReadable=c;function v(m,o,g){const n=D(g);return C(m,{onData:E=>n.write(o.data(E)),onError:E=>n.error(o.error?o.error(E):E),onEnd:()=>n.end()}),n}e.transform=v;function I(m,o,g){let n=!1;return{read:()=>{const E=o.read();return n?E:(n=!0,E!==null?g([m,E]):m)}}}e.prefixedReadable=I;function b(m,o,g){let n=!1;const E=D(g);return C(o,{onData:a=>n?E.write(a):(n=!0,E.write(g([m,a]))),onError:a=>E.error(a),onEnd:()=>{n||(n=!0,E.write(m)),E.end()}}),E}e.prefixedStream=b}),define(ve[23],be([1,0,96]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let k,A;class D{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return t?new D(Buffer.allocUnsafe(h)):new D(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new D(h)}static fromString(h,u){return!(u?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(h)):(k||(k=new TextEncoder),new D(k.encode(h)))}static fromByteArray(h){const u=D.alloc(h.length);for(let w=0,R=h.length;w<R;w++)u.buffer[w]=h[w];return u}static concat(h,u){if(typeof u=="undefined"){u=0;for(let O=0,L=h.length;O<L;O++)u+=h[O].byteLength}const w=D.alloc(u);let R=0;for(let O=0,L=h.length;O<L;O++){const S=h[O];w.set(S,R),R+=S.byteLength}return w}clone(){const h=D.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(h,u){return new D(this.buffer.subarray(h,u))}set(h,u){if(h instanceof D)this.buffer.set(h.buffer,u);else if(h instanceof Uint8Array)this.buffer.set(h,u);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),u);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),u);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return T(this.buffer,h)}writeUInt32BE(h,u){F(this.buffer,h,u)}readUInt32LE(h){return C(this.buffer,h)}writeUInt32LE(h,u){f(this.buffer,h,u)}readUInt8(h){return _(this.buffer,h)}writeUInt8(h,u){p(this.buffer,h,u)}}e.VSBuffer=D;function P(l,h){return l[h+0]<<0>>>0|l[h+1]<<8>>>0}e.readUInt16LE=P;function y(l,h,u){l[u+0]=h&255,h=h>>>8,l[u+1]=h&255}e.writeUInt16LE=y;function T(l,h){return l[h]*2**24+l[h+1]*2**16+l[h+2]*2**8+l[h+3]}e.readUInt32BE=T;function F(l,h,u){l[u+3]=h,h=h>>>8,l[u+2]=h,h=h>>>8,l[u+1]=h,h=h>>>8,l[u]=h}e.writeUInt32BE=F;function C(l,h){return l[h+0]<<0>>>0|l[h+1]<<8>>>0|l[h+2]<<16>>>0|l[h+3]<<24>>>0}e.readUInt32LE=C;function f(l,h,u){l[u+0]=h&255,h=h>>>8,l[u+1]=h&255,h=h>>>8,l[u+2]=h&255,h=h>>>8,l[u+3]=h&255}e.writeUInt32LE=f;function _(l,h){return l[h]}e.readUInt8=_;function p(l,h,u){l[u]=h}e.writeUInt8=p;function c(l){return d.consumeReadable(l,h=>D.concat(h))}e.readableToBuffer=c;function v(l){return d.toReadable(l)}e.bufferToReadable=v;function I(l){return d.consumeStream(l,h=>D.concat(h))}e.streamToBuffer=I;async function b(l){return l.ended?D.concat(l.buffer):D.concat([...l.buffer,await I(l.stream)])}e.bufferedStreamToBuffer=b;function m(l){return d.toStream(l,h=>D.concat(h))}e.bufferToStream=m;function o(l){return d.transform(l,{data:h=>typeof h=="string"?D.fromString(h):D.wrap(h)},h=>D.concat(h))}e.streamToBufferReadableStream=o;function g(l){return d.newWriteableStream(h=>D.concat(h),l)}e.newWriteableBufferStream=g;function n(l,h){return d.prefixedReadable(l,h,u=>D.concat(u))}e.prefixedBufferReadable=n;function E(l,h){return d.prefixedStream(l,h,u=>D.concat(u))}e.prefixedBufferStream=E;function a(l){let h=0,u=0,w=0;const R=new Uint8Array(Math.floor(l.length/4*3)),O=S=>{switch(u){case 3:R[w++]=h|S,u=0;break;case 2:R[w++]=h|S>>>2,h=S<<6,u=3;break;case 1:R[w++]=h|S>>>4,h=S<<4,u=2;break;default:h=S<<2,u=1}};for(let S=0;S<l.length;S++){const U=l.charCodeAt(S);if(U>=65&&U<=90)O(U-65);else if(U>=97&&U<=122)O(U-97+26);else if(U>=48&&U<=57)O(U-48+52);else if(U===43||U===45)O(62);else if(U===47||U===95)O(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${l[S]}`)}}const L=w;for(;u>0;)O(0);return D.wrap(R).slice(0,L)}e.decodeBase64=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:l},h=!0,u=!1){const w=u?r:i;let R="";const O=l.byteLength%3;let L=0;for(;L<l.byteLength-O;L+=3){const S=l[L+0],U=l[L+1],M=l[L+2];R+=w[S>>>2],R+=w[(S<<4|U>>>4)&63],R+=w[(U<<2|M>>>6)&63],R+=w[M&63]}if(O===1){const S=l[L+0];R+=w[S>>>2],R+=w[S<<4&63],h&&(R+="==")}else if(O===2){const S=l[L+0],U=l[L+1];R+=w[S>>>2],R+=w[(S<<4|U>>>4)&63],R+=w[U<<2&63],h&&(R+="=")}return R}e.encodeBase64=s}),define(ve[8],be([1,0,145,91]),function(te,e,d,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=A;const D=/{(\d+)}/g;function P(J,...pe){return pe.length===0?J:J.replace(D,function(Ce,Me){const He=parseInt(Me,10);return isNaN(He)||He<0||He>=pe.length?Ce:pe[He]})}e.format=P;const y=/{([^}]+)}/g;function T(J,pe){return J.replace(y,(Ce,Me)=>pe[Me]??Ce)}e.format2=T;function F(J){return J.replace(/[<>&]/g,function(pe){switch(pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return pe}})}e.escape=F;function C(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function f(J,pe){let Ce=0;const Me=pe.charCodeAt(0);for(let He=J.length-1;He>=0;He--)J.charCodeAt(He)===Me&&Ce++;return Ce}e.count=f;function _(J,pe,Ce="\u2026"){return J.length<=pe?J:`${J.substr(0,pe)}${Ce}`}e.truncate=_;function p(J,pe=" "){const Ce=c(J,pe);return v(Ce,pe)}e.trim=p;function c(J,pe){if(!J||!pe)return J;const Ce=pe.length;if(Ce===0||J.length===0)return J;let Me=0;for(;J.indexOf(pe,Me)===Me;)Me=Me+Ce;return J.substring(Me)}e.ltrim=c;function v(J,pe){if(!J||!pe)return J;const Ce=pe.length,Me=J.length;if(Ce===0||Me===0)return J;let He=Me,Ye=-1;for(;Ye=J.lastIndexOf(pe,He-1),!(Ye===-1||Ye+Ce!==He);){if(Ye===0)return"";He=Ye}return J.substring(0,He)}e.rtrim=v;function I(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=I;function b(J){return J.replace(/\*/g,"")}e.stripWildcards=b;function m(J,pe,Ce={}){if(!J)throw new Error("Cannot create regex from empty string");pe||(J=C(J)),Ce.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Me="";return Ce.global&&(Me+="g"),Ce.matchCase||(Me+="i"),Ce.multiline&&(Me+="m"),Ce.unicode&&(Me+="u"),new RegExp(J,Me)}e.createRegExp=m;function o(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=o;function g(J){return!!J.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function n(J){return(J.global?"g":"")+(J.ignoreCase?"i":"")+(J.multiline?"m":"")+(J.unicode?"u":"")}e.regExpFlags=n;function E(J){return J.split(/\r\n|\r|\n/)}e.splitLines=E;function a(J){for(let pe=0,Ce=J.length;pe<Ce;pe++){const Me=J.charCodeAt(pe);if(Me!==32&&Me!==9)return pe}return-1}e.firstNonWhitespaceIndex=a;function i(J,pe=0,Ce=J.length){for(let Me=pe;Me<Ce;Me++){const He=J.charCodeAt(Me);if(He!==32&&He!==9)return J.substring(pe,Me)}return J.substring(pe,Ce)}e.getLeadingWhitespace=i;function r(J,pe=J.length-1){for(let Ce=pe;Ce>=0;Ce--){const Me=J.charCodeAt(Ce);if(Me!==32&&Me!==9)return Ce}return-1}e.lastNonWhitespaceIndex=r;function s(J,pe){return J<pe?-1:J>pe?1:0}e.compare=s;function l(J,pe,Ce=0,Me=J.length,He=0,Ye=pe.length){for(;Ce<Me&&He<Ye;Ce++,He++){let vt=J.charCodeAt(Ce),xe=pe.charCodeAt(He);if(vt<xe)return-1;if(vt>xe)return 1}const rt=Me-Ce,gt=Ye-He;return rt<gt?-1:rt>gt?1:0}e.compareSubstring=l;function h(J,pe){return u(J,pe,0,J.length,0,pe.length)}e.compareIgnoreCase=h;function u(J,pe,Ce=0,Me=J.length,He=0,Ye=pe.length){for(;Ce<Me&&He<Ye;Ce++,He++){let vt=J.charCodeAt(Ce),xe=pe.charCodeAt(He);if(vt===xe)continue;if(vt>=128||xe>=128)return l(J.toLowerCase(),pe.toLowerCase(),Ce,Me,He,Ye);w(vt)&&(vt-=32),w(xe)&&(xe-=32);const st=vt-xe;if(st!==0)return st}const rt=Me-Ce,gt=Ye-He;return rt<gt?-1:rt>gt?1:0}e.compareSubstringIgnoreCase=u;function w(J){return J>=97&&J<=122}e.isLowerAsciiLetter=w;function R(J){return J>=65&&J<=90}e.isUpperAsciiLetter=R;function O(J,pe){return J.length===pe.length&&u(J,pe)===0}e.equalsIgnoreCase=O;function L(J,pe){const Ce=pe.length;return pe.length>J.length?!1:u(J,pe,0,Ce)===0}e.startsWithIgnoreCase=L;function S(J,pe){let Ce,Me=Math.min(J.length,pe.length);for(Ce=0;Ce<Me;Ce++)if(J.charCodeAt(Ce)!==pe.charCodeAt(Ce))return Ce;return Me}e.commonPrefixLength=S;function U(J,pe){let Ce,Me=Math.min(J.length,pe.length);const He=J.length-1,Ye=pe.length-1;for(Ce=0;Ce<Me;Ce++)if(J.charCodeAt(He-Ce)!==pe.charCodeAt(Ye-Ce))return Ce;return Me}e.commonSuffixLength=U;function M(J){return 55296<=J&&J<=56319}e.isHighSurrogate=M;function X(J){return 56320<=J&&J<=57343}e.isLowSurrogate=X;function G(J,pe){return(J-55296<<10)+(pe-56320)+65536}e.computeCodePoint=G;function q(J,pe,Ce){const Me=J.charCodeAt(Ce);if(M(Me)&&Ce+1<pe){const He=J.charCodeAt(Ce+1);if(X(He))return G(Me,He)}return Me}e.getNextCodePoint=q;function B(J,pe){const Ce=J.charCodeAt(pe-1);if(X(Ce)&&pe>1){const Me=J.charCodeAt(pe-2);if(M(Me))return G(Me,Ce)}return Ce}class x{constructor(pe,Ce=0){this._str=pe,this._len=pe.length,this._offset=Ce}get offset(){return this._offset}setOffset(pe){this._offset=pe}prevCodePoint(){const pe=B(this._str,this._offset);return this._offset-=pe>=65536?2:1,pe}nextCodePoint(){const pe=q(this._str,this._len,this._offset);return this._offset+=pe>=65536?2:1,pe}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class j{constructor(pe,Ce=0){this._iterator=new x(pe,Ce)}get offset(){return this._iterator.offset}nextGraphemeLength(){const pe=ze.getInstance(),Ce=this._iterator,Me=Ce.offset;let He=pe.getGraphemeBreakType(Ce.nextCodePoint());for(;!Ce.eol();){const Ye=Ce.offset,rt=pe.getGraphemeBreakType(Ce.nextCodePoint());if($e(He,rt)){Ce.setOffset(Ye);break}He=rt}return Ce.offset-Me}prevGraphemeLength(){const pe=ze.getInstance(),Ce=this._iterator,Me=Ce.offset;let He=pe.getGraphemeBreakType(Ce.prevCodePoint());for(;Ce.offset>0;){const Ye=Ce.offset,rt=pe.getGraphemeBreakType(Ce.prevCodePoint());if($e(rt,He)){Ce.setOffset(Ye);break}He=rt}return Me-Ce.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=j;function V(J,pe){return new j(J,pe).nextGraphemeLength()}e.nextCharLength=V;function Z(J,pe){return new j(J,pe).prevGraphemeLength()}e.prevCharLength=Z;function se(J,pe){pe>0&&X(J.charCodeAt(pe))&&pe--;const Ce=pe+V(J,pe);return[Ce-Z(J,Ce),Ce]}e.getCharContainingOffset=se;const ce=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ee(J){return ce.test(J)}e.containsRTL=ee;const Y=/^[\t\n\r\x20-\x7E]*$/;function ae(J){return Y.test(J)}e.isBasicASCII=ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function he(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=he;function we(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=we;function ke(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=ke;function Ne(J,pe){if(J.length<pe)return J;const Ce=/\b/g;let Me=0;for(;Ce.test(J)&&!(J.length-Ce.lastIndex<pe);)Me=Ce.lastIndex,Ce.lastIndex+=1;return J.substring(Me).replace(/^\s/,"")}e.lcut=Ne;const _e=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,z=/\x1b\[0?m/g;function W(J){return J&&(J=J.replace(_e,""),J=J.replace(Ee,""),J=J.replace(z,"")),J}e.removeAnsiEscapeCodes=W,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function $(J){return N(J)?J.substr(1):J}e.stripUTF8BOM=$;function K(J,pe){if(!J||!pe||J.length<pe.length)return!1;const Ce=pe.length,Me=J.toLowerCase();let He=0,Ye=-1;for(;He<Ce;){const rt=Me.indexOf(pe[He],Ye+1);if(rt<0)return!1;Ye=rt,He++}return!0}e.fuzzyContains=K;function re(J,pe=!1){return J?(pe&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=re;function de(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=de;function ye(J,pe=1){if(pe===0)return"";let Ce=-1;do Ce=J.indexOf(`
`,Ce+1),pe--;while(pe>0&&Ce>=0);return Ce===-1?J:(J[Ce-1]==="\r"&&Ce--,J.substr(0,Ce))}e.getNLines=ye;function Re(J){const pe=90-65+1;return J=J%(2*pe),J<pe?String.fromCharCode(97+J):String.fromCharCode(65+J-pe)}e.singleLetterHash=Re;function We(J){return ze.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=We;function $e(J,pe){return J===0?pe!==5&&pe!==7:J===2&&pe===3?!1:J===4||J===2||J===3||pe===4||pe===2||pe===3?!0:!(J===8&&(pe===8||pe===9||pe===11||pe===12)||(J===11||J===9)&&(pe===9||pe===10)||(J===12||J===10)&&pe===10||pe===5||pe===13||pe===7||J===1||J===13&&pe===14||J===6&&pe===6)}var je;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Ue()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(pe){if(pe<32)return pe===10?3:pe===13?2:4;if(pe<127)return 0;const Ce=this._data,Me=Ce.length/3;let He=1;for(;He<=Me;)if(pe<Ce[3*He])He=2*He;else if(pe>Ce[3*He+1])He=2*He+1;else return Ce[3*He+2];return 0}}ze._INSTANCE=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(J,pe){if(J===0)return 0;const Ce=nt(J,pe);if(Ce!==void 0)return Ce;const Me=new x(pe,J);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Qe;function nt(J,pe){const Ce=new x(pe,J);let Me=Ce.prevCodePoint();for(;Le(Me)||Me===65039||Me===8419;){if(Ce.offset===0)return;Me=Ce.prevCodePoint()}if(!ke(Me))return;let He=Ce.offset;return He>0&&Ce.prevCodePoint()===8205&&(He=Ce.offset),He}function Le(J){return 127995<=J&&J<=127999}var et;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={})),e.noBreakWhitespace="\xA0";class ne{constructor(pe){this.confusableDictionary=pe}static getInstance(pe){return ne.cache.get(Array.from(pe))}static getLocales(){return ne._locales.getValue()}isAmbiguous(pe){return this.confusableDictionary.has(pe)}getPrimaryConfusable(pe){return this.confusableDictionary.get(pe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ne,k=ne,ne.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new d.LRUCachedComputed(J=>{function pe(xe){const st=new Map;for(let Et=0;Et<xe.length;Et+=2)st.set(xe[Et],xe[Et+1]);return st}function Ce(xe,st){const Et=new Map(xe);for(const[tt,ct]of st)Et.set(tt,ct);return Et}function Me(xe,st){if(!xe)return st;const Et=new Map;for(const[tt,ct]of xe)st.has(tt)&&Et.set(tt,ct);return Et}const He=k.ambiguousCharacterData.getValue();let Ye=J.filter(xe=>!xe.startsWith("_")&&xe in He);Ye.length===0&&(Ye=["_default"]);let rt;for(const xe of Ye){const st=pe(He[xe]);rt=Me(rt,st)}const gt=pe(He._common),vt=Ce(gt,rt);return new ne(vt)}),ne._locales=new t.Lazy(()=>Object.keys(ne.ambiguousCharacterData.getValue()).filter(J=>!J.startsWith("_")));class oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(oe.getRawData())),this._data}static isInvisibleCharacter(pe){return oe.getData().has(pe)}static get codePoints(){return oe.getData()}}e.InvisibleCharacters=oe,oe._data=void 0}),define(ve[58],be([1,0,8]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(I){return k(I,0)}e.hash=t;function k(I,b){switch(typeof I){case"object":return I===null?A(349,b):Array.isArray(I)?y(I,b):T(I,b);case"string":return P(I,b);case"boolean":return D(I,b);case"number":return A(I,b);case"undefined":return A(937,b);default:return A(617,b)}}e.doHash=k;function A(I,b){return(b<<5)-b+I|0}e.numberHash=A;function D(I,b){return A(I?433:863,b)}function P(I,b){b=A(149417,b);for(let m=0,o=I.length;m<o;m++)b=A(I.charCodeAt(m),b);return b}e.stringHash=P;function y(I,b){return b=A(104579,b),I.reduce((m,o)=>k(o,m),b)}function T(I,b){return b=A(181387,b),Object.keys(I).sort().reduce((m,o)=>(m=P(o,m),k(I[o],m)),b)}class F{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=k(b,this._value),this._value}}e.Hasher=F;var C;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(I,b,m=32){const o=m-b,g=~((1<<o)-1);return(I<<b|(g&I)>>>o)>>>0}function _(I,b=0,m=I.byteLength,o=0){for(let g=0;g<m;g++)I[b+g]=o}function p(I,b,m="0"){for(;I.length<b;)I=m+I;return I}function c(I,b=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(m=>m.toString(16).padStart(2,"0")).join(""):p((I>>>0).toString(16),b/4)}e.toHexString=c;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const m=b.length;if(m===0)return;const o=this._buff;let g=this._buffLen,n=this._leftoverHighSurrogate,E,a;for(n!==0?(E=n,a=-1,n=0):(E=b.charCodeAt(0),a=0);;){let i=E;if(d.isHighSurrogate(E))if(a+1<m){const r=b.charCodeAt(a+1);d.isLowSurrogate(r)?(a++,i=d.computeCodePoint(E,r)):i=65533}else{n=E;break}else d.isLowSurrogate(E)&&(i=65533);if(g=this._push(o,g,i),a++,a<m)E=b.charCodeAt(a);else break}this._buffLen=g,this._leftoverHighSurrogate=n}_push(b,m,o){return o<128?b[m++]=o:o<2048?(b[m++]=192|(o&1984)>>>6,b[m++]=128|(o&63)>>>0):o<65536?(b[m++]=224|(o&61440)>>>12,b[m++]=128|(o&4032)>>>6,b[m++]=128|(o&63)>>>0):(b[m++]=240|(o&1835008)>>>18,b[m++]=128|(o&258048)>>>12,b[m++]=128|(o&4032)>>>6,b[m++]=128|(o&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),c(this._h0)+c(this._h1)+c(this._h2)+c(this._h3)+c(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,_(this._buff,this._buffLen),this._buffLen>56&&(this._step(),_(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=v._bigBlock32,m=this._buffDV;for(let l=0;l<64;l+=4)b.setUint32(l,m.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)b.setUint32(l,f(b.getUint32(l-12,!1)^b.getUint32(l-32,!1)^b.getUint32(l-56,!1)^b.getUint32(l-64,!1),1),!1);let o=this._h0,g=this._h1,n=this._h2,E=this._h3,a=this._h4,i,r,s;for(let l=0;l<80;l++)l<20?(i=g&n|~g&E,r=1518500249):l<40?(i=g^n^E,r=1859775393):l<60?(i=g&n|g&E|n&E,r=2400959708):(i=g^n^E,r=3395469782),s=f(o,5)+i+a+r+b.getUint32(l*4,!1)&4294967295,a=E,E=n,n=f(g,30),g=o,o=s;this._h0=this._h0+o&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+E&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[24],be([1,0,17,8]),function(te,e,d,t){"use strict";var k,A,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(a,i,r){let s=a.get(i);return s===void 0&&(s=r,a.set(i,s)),s}e.getOrSet=P;function y(a){const i=[];return a.forEach((r,s)=>{i.push(`${s} => ${r}`)}),`Map(${a.size}) {${i.join(", ")}}`}e.mapToString=y;function T(a){const i=[];return a.forEach(r=>{i.push(r)}),`Set(${a.size}) {${i.join(", ")}}`}e.setToString=T;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),s=this._value.charCodeAt(this._pos);return r-s}value(){return this._value[this._pos]}}e.StringIterator=F;class C{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const s=this._value.charCodeAt(r);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var _;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(_||(_={}));class p{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(v||(v={}));class I{constructor(i){this._iter=i}static forUris(i=()=>!1){return new I(new p(i))}static forPaths(i=!1){return new I(new f(void 0,!i))}static forStrings(){return new I(new F)}static forConfigKeys(){return new I(new C)}clear(){this._root=void 0}fill(i,r){if(r){const s=r.slice(0);(0,d.shuffle)(s);for(let l of s)this.set(l,i)}else{const s=i.slice(0);(0,d.shuffle)(s);for(let l of s)this.set(l[0],l[1])}}set(i,r){const s=this._iter.reset(i);let l;this._root||(this._root=new c,this._root.segment=s.value());const h=[];for(l=this._root;;){const w=s.cmp(l.segment);if(w>0)l.left||(l.left=new c,l.left.segment=s.value()),h.push([-1,l]),l=l.left;else if(w<0)l.right||(l.right=new c,l.right.segment=s.value()),h.push([1,l]),l=l.right;else if(s.hasNext())s.next(),l.mid||(l.mid=new c,l.mid.segment=s.value()),h.push([0,l]),l=l.mid;else break}const u=l.value;l.value=r,l.key=i;for(let w=h.length-1;w>=0;w--){const R=h[w][1];R.updateHeight();const O=R.balanceFactor();if(O<-1||O>1){const L=h[w][0],S=h[w+1][0];if(L===1&&S===1)h[w][1]=R.rotateLeft();else if(L===-1&&S===-1)h[w][1]=R.rotateRight();else if(L===1&&S===-1)R.right=h[w+1][1]=h[w+1][1].rotateRight(),h[w][1]=R.rotateLeft();else if(L===-1&&S===1)R.left=h[w+1][1]=h[w+1][1].rotateLeft(),h[w][1]=R.rotateRight();else throw new Error;if(w>0)switch(h[w-1][0]){case-1:h[w-1][1].left=h[w][1];break;case 1:h[w-1][1].right=h[w][1];break;case 0:h[w-1][1].mid=h[w][1];break}else this._root=h[0][1]}}return u}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let s=this._root;for(;s;){const l=r.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const s=this._iter.reset(i),l=[];let h=this._root;for(;h;){const u=s.cmp(h.segment);if(u>0)l.push([-1,h]),h=h.left;else if(u<0)l.push([1,h]),h=h.right;else if(s.hasNext())s.next(),l.push([0,h]),h=h.mid;else break}if(!!h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this._min(h.right),{key:w,value:R,segment:O}=u;this._delete(u.key,!1),h.key=w,h.value=R,h.segment=O}else{const u=h.left??h.right;if(l.length>0){const[w,R]=l[l.length-1];switch(w){case-1:R.left=u;break;case 0:R.mid=u;break;case 1:R.right=u;break}}else this._root=u}for(let u=l.length-1;u>=0;u--){const w=l[u][1];w.updateHeight();const R=w.balanceFactor();if(R>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),l[u][1]=w.rotateLeft()):R<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),l[u][1]=w.rotateRight()),u>0)switch(l[u-1][0]){case-1:l[u-1][1].left=l[u][1];break;case 1:l[u-1][1].right=l[u][1];break;case 0:l[u-1][1].mid=l[u][1];break}else this._root=l[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let s=this._root,l;for(;s;){const h=r.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(r.hasNext())r.next(),l=s.value||l,s=s.mid;else break}return s&&s.value||l}findSuperstr(i){const r=this._iter.reset(i);let s=this._root;for(;s;){const l=r.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(i){for(const[r,s]of this)i(s,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const s=r.balanceFactor();return s<-1||s>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=I;class b{constructor(i,r){this.uri=i,this.value=r}}class m{constructor(i,r){this[k]="ResourceMap",i instanceof m?(this.map=new Map(i.map),this.toKey=r??m.defaultToKey):(this.map=new Map,this.toKey=i??m.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new b(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[s,l]of this.map)i(l.value,l.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=m,m.defaultToKey=a=>a.toString();var o;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class g{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const s=this._map.get(i);if(!!s)return r!==0&&this.touch(s,r),s.value}set(i,r,s=0){let l=this._map.get(i);if(l)l.value=r,s!==0&&this.touch(l,s);else{switch(l={key:i,value:r,next:void 0,previous:void 0},s){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const s=this._state;let l=this._head;for(;l;){if(r?i.bind(r)(l.value,l.key,this):i(l.value,l.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,r=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.key,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return l}values(){const i=this,r=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.value,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return l}entries(){const i=this,r=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:[s.key,s.value],done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return l}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,s=this.size;for(;r&&s>i;)this._map.delete(r.key),r=r.next,s--;this._head=r,this._size=s,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,s=i.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const s=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(s.previous=l,l.next=s),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const s=i.next,l=i.previous;i===this._head?(s.previous=void 0,this._head=s):(s.previous=l,l.next=s),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,s)=>{i.push([s,r])}),i}fromJSON(i){this.clear();for(const[r,s]of i)this.set(r,s)}}e.LinkedMap=g;class n extends g{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class E{constructor(i){D.set(this,void 0),Ke(this,D,i,"f")}get size(){return Te(this,D,"f").size}forEach(i,r){Te(this,D,"f").forEach(i,r)}get(i){return Te(this,D,"f").get(i)}has(i){return Te(this,D,"f").has(i)}entries(){return Te(this,D,"f").entries()}keys(){return Te(this,D,"f").keys()}values(){return Te(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return Te(this,D,"f").entries()}}e.ReadonlyMapView=E}),define(ve[97],be([1,0,24,8]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...N){return function($,K){for(let re=0,de=N.length;re<de;re++){const ye=N[re]($,K);if(ye)return ye}return null}}e.or=k,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(N,$,K){if(!K||K.length<$.length)return null;let re;return N?re=t.startsWithIgnoreCase(K,$):re=K.indexOf($)===0,re?$.length>0?[{start:0,end:$.length}]:[]:null}function D(N,$){const K=$.toLowerCase().indexOf(N.toLowerCase());return K===-1?null:[{start:K,end:K+N.length}]}e.matchesContiguousSubString=D;function P(N,$){return y(N.toLowerCase(),$.toLowerCase(),0,0)}e.matchesSubString=P;function y(N,$,K,re){if(K===N.length)return[];if(re===$.length)return null;if(N[K]===$[re]){let de=null;return(de=y(N,$,K+1,re+1))?I({start:re,end:re+1},de):null}return y(N,$,K,re+1)}function T(N){return 97<=N&&N<=122}function F(N){return 65<=N&&N<=90}e.isUpper=F;function C(N){return 48<=N&&N<=57}function f(N){return N===32||N===9||N===10||N===13}const _=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(N=>_.add(N.charCodeAt(0)));function p(N){return f(N)||_.has(N)}function c(N,$){return N===$||p(N)&&p($)}function v(N){return T(N)||F(N)||C(N)}function I(N,$){return $.length===0?$=[N]:N.end===$[0].start?$[0].start=N.start:$.unshift(N),$}function b(N,$){for(let K=$;K<N.length;K++){const re=N.charCodeAt(K);if(F(re)||C(re)||K>0&&!v(N.charCodeAt(K-1)))return K}return N.length}function m(N,$,K,re){if(K===N.length)return[];if(re===$.length)return null;if(N[K]!==$[re].toLowerCase())return null;{let de=null,ye=re+1;for(de=m(N,$,K+1,re+1);!de&&(ye=b($,ye))<$.length;)de=m(N,$,K+1,ye),ye++;return de===null?null:I({start:re,end:re+1},de)}}function o(N){let $=0,K=0,re=0,de=0,ye=0;for(let ze=0;ze<N.length;ze++)ye=N.charCodeAt(ze),F(ye)&&$++,T(ye)&&K++,v(ye)&&re++,C(ye)&&de++;const Re=$/N.length,We=K/N.length,$e=re/N.length,je=de/N.length;return{upperPercent:Re,lowerPercent:We,alphaPercent:$e,numericPercent:je}}function g(N){const{upperPercent:$,lowerPercent:K}=N;return K===0&&$>.6}function n(N){const{upperPercent:$,lowerPercent:K,alphaPercent:re,numericPercent:de}=N;return K>.2&&$<.8&&re>.6&&de<.2}function E(N){let $=0,K=0,re=0,de=0;for(let ye=0;ye<N.length;ye++)re=N.charCodeAt(ye),F(re)&&$++,T(re)&&K++,f(re)&&de++;return($===0||K===0)&&de===0?N.length<=30:$<=5}function a(N,$){if(!$||($=$.trim(),$.length===0)||!E(N)||$.length>60)return null;const K=o($);if(!n(K)){if(!g(K))return null;$=$.toLowerCase()}let re=null,de=0;for(N=N.toLowerCase();de<$.length&&(re=m(N,$,0,de))===null;)de=b($,de+1);return re}e.matchesCamelCase=a;function i(N,$,K=!1){if(!$||$.length===0)return null;let re=null,de=0;for(N=N.toLowerCase(),$=$.toLowerCase();de<$.length&&(re=r(N,$,0,de,K))===null;)de=s($,de+1);return re}e.matchesWords=i;function r(N,$,K,re,de){if(K===N.length)return[];if(re===$.length)return null;if(c(N.charCodeAt(K),$.charCodeAt(re))){let ye=null,Re=re+1;if(ye=r(N,$,K+1,re+1,de),!de)for(;!ye&&(Re=s($,Re))<$.length;)ye=r(N,$,K+1,Re,de),Re++;return ye===null?null:I({start:re,end:re+1},ye)}else return null}function s(N,$){for(let K=$;K<N.length;K++)if(p(N.charCodeAt(K))||K>0&&p(N.charCodeAt(K-1)))return K;return N.length}const l=k(e.matchesPrefix,a,D),h=k(e.matchesPrefix,a,P),u=new d.LRUCache(1e4);function w(N,$,K=!1){if(typeof N!="string"||typeof $!="string")return null;let re=u.get(N);re||(re=new RegExp(t.convertSimple2RegExpPattern(N),"i"),u.set(N,re));const de=re.exec($);return de?[{start:de.index,end:de.index+de[0].length}]:K?h(N,$):l(N,$)}e.matchesFuzzy=w;function R(N,$){const K=we(N,N.toLowerCase(),0,$,$.toLowerCase(),0,!0);return K?L(K):null}e.matchesFuzzy2=R;function O(N,$,K,re,de,ye){const Re=Math.min(13,N.length);for(;K<Re;K++){const We=we(N,$,K,re,de,ye,!1);if(We)return We}return[0,ye]}e.anyScore=O;function L(N){if(typeof N=="undefined")return[];const $=[],K=N[1];for(let re=N.length-1;re>1;re--){const de=N[re]+K,ye=$[$.length-1];ye&&ye.end===de?ye.end=de+1:$.push({start:de,end:de+1})}return $}e.createMatches=L;const S=128;function U(){const N=[],$=[];for(let K=0;K<=S;K++)$[K]=0;for(let K=0;K<=S;K++)N.push($.slice(0));return N}function M(N){const $=[];for(let K=0;K<=N;K++)$[K]=0;return $}const X=M(2*S),G=M(2*S),q=U(),B=U(),x=U(),j=!1;function V(N,$,K,re,de){function ye(We,$e,je=" "){for(;We.length<$e;)We=je+We;return We}let Re=` |   |${re.split("").map(We=>ye(We,3)).join("|")}
`;for(let We=0;We<=K;We++)We===0?Re+=" |":Re+=`${$[We-1]}|`,Re+=N[We].slice(0,de+1).map($e=>ye($e.toString(),3)).join("|")+`
`;return Re}function Z(N,$,K,re){N=N.substr($),K=K.substr(re),console.log(V(B,N,N.length,K,K.length)),console.log(V(x,N,N.length,K,K.length)),console.log(V(q,N,N.length,K,K.length))}function se(N,$){if($<0||$>=N.length)return!1;const K=N.codePointAt($);switch(K){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(K)}}function ce(N,$){if($<0||$>=N.length)return!1;switch(N.charCodeAt($)){case 32:case 9:return!0;default:return!1}}function ee(N,$,K){return $[N]!==K[N]}function Y(N,$,K,re,de,ye,Re=!1){for(;$<K&&de<ye;)N[$]===re[de]&&(Re&&(X[$]=de),$+=1),de+=1;return $===K}e.isPatternInWord=Y;var ae;(function(N){N[N.Diag=1]="Diag",N[N.Left=2]="Left",N[N.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var he;(function(N){N.Default=[-100,0];function $(K){return!K||K.length===2&&K[0]===-100&&K[1]===0}N.isDefault=$})(he=e.FuzzyScore||(e.FuzzyScore={}));function we(N,$,K,re,de,ye,Re){const We=N.length>S?S:N.length,$e=re.length>S?S:re.length;if(K>=We||ye>=$e||We-K>$e-ye||!Y($,K,We,de,ye,$e,!0))return;ke(We,$e,K,ye,$,de);let je=1,ze=1,Ue=K,Qe=ye;const nt=[!1];for(je=1,Ue=K;Ue<We;je++,Ue++){const J=X[Ue],pe=G[Ue],Ce=Ue+1<We?G[Ue+1]:$e;for(ze=J-ye+1,Qe=J;Qe<Ce;ze++,Qe++){let Me=Number.MIN_SAFE_INTEGER,He=!1;Qe<=pe&&(Me=Ne(N,$,Ue,K,re,de,Qe,$e,ye,q[je-1][ze-1]===0,nt));let Ye=0;Me!==Number.MAX_SAFE_INTEGER&&(He=!0,Ye=Me+B[je-1][ze-1]);const rt=Qe>J,gt=rt?B[je][ze-1]+(q[je][ze-1]>0?-5:0):0,vt=Qe>J+1&&q[je][ze-1]>0,xe=vt?B[je][ze-2]+(q[je][ze-2]>0?-5:0):0;if(vt&&(!rt||xe>=gt)&&(!He||xe>=Ye))B[je][ze]=xe,x[je][ze]=3,q[je][ze]=0;else if(rt&&(!He||gt>=Ye))B[je][ze]=gt,x[je][ze]=2,q[je][ze]=0;else if(He)B[je][ze]=Ye,x[je][ze]=1,q[je][ze]=q[je-1][ze-1]+1;else throw new Error("not possible")}}if(j&&Z(N,K,re,ye),!nt[0]&&!Re)return;je--,ze--;const Le=[B[je][ze],ye];let et=0,ne=0;for(;je>=1;){let J=ze;do{const pe=x[je][J];if(pe===3)J=J-2;else if(pe===2)J=J-1;else break}while(J>=1);et>1&&$[K+je-1]===de[ye+ze-1]&&!ee(J+ye-1,re,de)&&et+1>q[je][J]&&(J=ze),J===ze?et++:et=1,ne||(ne=J),je--,ze=J-1,Le.push(ze)}$e===We&&(Le[0]+=2);const oe=ne-We;return Le[0]-=oe,Le}e.fuzzyScore=we;function ke(N,$,K,re,de,ye){let Re=N-1,We=$-1;for(;Re>=K&&We>=re;)de[Re]===ye[We]&&(G[Re]=We,Re--),We--}function Ne(N,$,K,re,de,ye,Re,We,$e,je,ze){if($[K]!==ye[Re])return Number.MIN_SAFE_INTEGER;let Ue=1,Qe=!1;return Re===K-re?Ue=N[K]===de[Re]?7:5:ee(Re,de,ye)&&(Re===0||!ee(Re-1,de,ye))?(Ue=N[K]===de[Re]?7:5,Qe=!0):se(ye,Re)&&(Re===0||!se(ye,Re-1))?Ue=5:(se(ye,Re-1)||ce(ye,Re-1))&&(Ue=5,Qe=!0),Ue>1&&K===re&&(ze[0]=!0),Qe||(Qe=ee(Re,de,ye)||se(ye,Re-1)||ce(ye,Re-1)),K===re?Re>$e&&(Ue-=Qe?3:5):je?Ue+=Qe?2:0:Ue+=Qe?0:1,Re+1===We&&(Ue-=Qe?3:5),Ue}function _e(N,$,K,re,de,ye,Re){return z(N,$,K,re,de,ye,!0,Re)}e.fuzzyScoreGracefulAggressive=_e;function Ee(N,$,K,re,de,ye,Re){return z(N,$,K,re,de,ye,!1,Re)}e.fuzzyScoreGraceful=Ee;function z(N,$,K,re,de,ye,Re,We){let $e=we(N,$,K,re,de,ye,We);if($e&&!Re)return $e;if(N.length>=3){const je=Math.min(7,N.length-1);for(let ze=K+1;ze<je;ze++){const Ue=W(N,ze);if(Ue){const Qe=we(Ue,Ue.toLowerCase(),K,re,de,ye,We);Qe&&(Qe[0]-=3,(!$e||Qe[0]>$e[0])&&($e=Qe))}}}return $e}function W(N,$){if($+1>=N.length)return;const K=N[$],re=N[$+1];if(K!==re)return N.slice(0,$)+re+K+N.slice($+2)}}),define(ve[146],be([1,0,73,97,8]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(d.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${A.source}`,"g");function y(v){return v.replace(P,(I,b)=>b?I:`\\${I}`)}e.escapeIcons=y;const T=new RegExp(`\\\\${A.source}`,"g");function F(v){return v.replace(T,I=>`\\${I}`)}e.markdownEscapeEscapedIcons=F;const C=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function f(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(C,(I,b,m,o)=>m?I:b||o||"")}e.stripIcons=f;function _(v){const I=v.indexOf(e.iconStartMarker);return I===-1?{text:v}:p(v,I)}e.parseLabelWithIcons=_;function p(v,I){const b=[];let m="";function o(l){if(l){m+=l;for(const h of l)b.push(E)}}let g=-1,n="",E=0,a,i,r=I;const s=v.length;for(o(v.substr(0,I));r<s;)a=v[r],i=v[r+1],a===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(g=r,o(n),n=e.iconStartMarker,r++):a===")"&&g!==-1?(E+=r-g+1,g=-1,n=""):g!==-1?D.test(a)?n+=a:(o(n),g=-1,n=""):o(a),r++;return o(n),{text:m,iconOffsets:b}}function c(v,I,b=!1){const{text:m,iconOffsets:o}=I;if(!o||o.length===0)return(0,t.matchesFuzzy)(v,m,b);const g=(0,k.ltrim)(m," "),n=m.length-g.length,E=(0,t.matchesFuzzy)(v,g,b);if(E)for(const a of E){const i=o[a.start+n]+n;a.start+=i,a.end+=i}return E}e.matchesFuzzyIconAware=c}),define(ve[78],be([1,0,24]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new d.LRUCache(1e4);function k(T){return y(T,"NFC",t)}e.normalizeNFC=k;const A=new d.LRUCache(1e4);function D(T){return y(T,"NFD",A)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function y(T,F,C){if(!T)return T;const f=C.get(T);if(f)return f;let _;return P.test(T)?_=T.normalize(F):_=T,C.set(T,_),_}e.removeAccents=function(){const T=/[\u0300-\u036f]/g;return function(F){return D(F).replace(T,"")}}()}),define(ve[47],be([1,0,8]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const A="error",D="warning",P="warn",y="info",T="ignore";function F(f){return f?d.equalsIgnoreCase(A,f)?k.Error:d.equalsIgnoreCase(D,f)||d.equalsIgnoreCase(P,f)?k.Warning:d.equalsIgnoreCase(y,f)?k.Info:k.Ignore:k.Ignore}k.fromValue=F;function C(f){switch(f){case k.Error:return A;case k.Warning:return D;case k.Info:return y;default:return T}}k.toString=C}(t||(t={})),e.default=t}),define(ve[18],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function d(s){return Array.isArray(s)}e.isArray=d;function t(s){return typeof s=="string"}e.isString=t;function k(s){return Array.isArray(s)&&s.every(l=>t(l))}e.isStringArray=k;function A(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=A;function D(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=D;function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=P;function y(s){return s===!0||s===!1}e.isBoolean=y;function T(s){return typeof s=="undefined"}e.isUndefined=T;function F(s){return!C(s)}e.isDefined=F;function C(s){return T(s)||s===null}e.isUndefinedOrNull=C;function f(s,l){if(!s)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=f;function _(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=_;function p(...s){const l=[];for(let h=0;h<s.length;h++){const u=s[h];if(C(u))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);l.push(u)}return l}e.assertAllDefined=p;const c=Object.prototype.hasOwnProperty;function v(s){if(!A(s))return!1;for(let l in s)if(c.call(s,l))return!1;return!0}e.isEmptyObject=v;function I(s){return typeof s=="function"}e.isFunction=I;function b(...s){return s.length>0&&s.every(I)}e.areFunctions=b;function m(s,l){const h=Math.min(s.length,l.length);for(let u=0;u<h;u++)o(s[u],l[u])}e.validateConstraints=m;function o(s,l){if(t(l)){if(typeof s!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(I(l)){try{if(s instanceof l)return}catch{}if(!C(s)&&s.constructor===l||l.length===1&&l.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function g(s){let l=[],h=Object.getPrototypeOf(s);for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.getAllPropertyNames=g;function n(s){const l=[];for(const h of g(s))typeof s[h]=="function"&&l.push(h);return l}e.getAllMethodNames=n;function E(s,l){const h=w=>function(){const R=Array.prototype.slice.call(arguments,0);return l(w,R)};let u={};for(const w of s)u[w]=h(w);return u}e.createProxyObject=E;function a(s){return s===null?void 0:s}e.withNullAsUndefined=a;function i(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=i;function r(s,l="Unreachable"){throw new Error(l)}e.assertNever=r}),define(ve[28],be([1,0,9,11,8,18]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function P(r){return r.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=P;function y(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=y;function T(r,s=d.posix.sep){if(!r)return"";const l=r.length,h=r.charCodeAt(0);if(D(h)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let w=3;const R=w;for(;w<l&&!D(r.charCodeAt(w));w++);if(R!==w&&!D(r.charCodeAt(w+1))){for(w+=1;w<l;w++)if(D(r.charCodeAt(w)))return r.slice(0,w+1).replace(/[\\/]/g,s)}}return s}else if(I(h)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<l;u++)if(D(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=T;function F(r){if(!t.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let l=2;const h=l;for(;l<r.length&&(s=r.charCodeAt(l),s!==92);l++);return!(h===l||(s=r.charCodeAt(l+1),isNaN(s)||s===92))}e.isUNC=F;const C=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(r,s=t.isWindows){const l=s?C:f;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||s&&_.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=p;function c(r,s,l){const h=r===s;return!l||h?h:!r||!s?!1:(0,k.equalsIgnoreCase)(r,s)}e.isEqual=c;function v(r,s,l,h=d.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let w=s.length;return s.charAt(s.length-1)===h&&w--,r.charAt(w)===h}return s.charAt(s.length-1)!==h&&(s+=h),r.indexOf(s)===0}e.isEqualOrParent=v;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function b(r,s){return t.isWindows&&r.endsWith(":")&&(r+=d.sep),(0,d.isAbsolute)(r)||(r=(0,d.join)(s,r)),r=(0,d.normalize)(r),t.isWindows?(r=(0,k.rtrim)(r,d.sep),r.endsWith(":")&&(r+=d.sep)):(r=(0,k.rtrim)(r,d.sep),r||(r=d.sep)),r}e.sanitizeFilePath=b;function m(r){const s=(0,d.normalize)(r);return t.isWindows?r.length>3?!1:o(s)&&(r.length===2||s.charCodeAt(2)===92):s===d.posix.sep}e.isRootOrDriveLetter=m;function o(r,s){return(s!==void 0?s:t.isWindows)?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function g(r){return o(r)?r[0]:void 0}e.getDriveLetter=g;function n(r,s,l){return s.length>r.length?-1:r===s?0:(l&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=n;function E(r){const s=r.split(":");let l,h,u;for(const w of s){const R=Number(w);(0,A.isNumber)(R)?h===void 0?h=R:u===void 0&&(u=R):l=l?[l,w].join(":"):w}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:h!==void 0?h:void 0,column:u!==void 0?u:h!==void 0?1:void 0}}e.parseLineAndColumnAware=E;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,s,l=8){let h="";for(let w=0;w<l;w++)h+=a.charAt(Math.floor(Math.random()*a.length));let u;return s?u=`${s}-${h}`:u=h,r?(0,d.join)(r,u):u}e.randomPath=i}),define(ve[25],be([1,0,18]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const v=Array.isArray(c)?[]:{};return Object.keys(c).forEach(I=>{c[I]&&typeof c[I]=="object"?v[I]=t(c[I]):v[I]=c[I]}),v}e.deepClone=t;function k(c){if(!c||typeof c!="object")return c;const v=[c];for(;v.length>0;){const I=v.shift();Object.freeze(I);for(const b in I)if(A.call(I,b)){const m=I[b];typeof m=="object"&&!Object.isFrozen(m)&&v.push(m)}}return c}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function D(c,v){return P(c,v,new Set)}e.cloneAndChange=D;function P(c,v,I){if((0,d.isUndefinedOrNull)(c))return c;const b=v(c);if(typeof b!="undefined")return b;if((0,d.isArray)(c)){const m=[];for(const o of c)m.push(P(o,v,I));return m}if((0,d.isObject)(c)){if(I.has(c))throw new Error("Cannot clone recursive data-structure");I.add(c);const m={};for(let o in c)A.call(c,o)&&(m[o]=P(c[o],v,I));return I.delete(c),m}return c}function y(c,v,I=!0){return(0,d.isObject)(c)?((0,d.isObject)(v)&&Object.keys(v).forEach(b=>{b in c?I&&((0,d.isObject)(c[b])&&(0,d.isObject)(v[b])?y(c[b],v[b],I):c[b]=v[b]):c[b]=v[b]}),c):v}e.mixin=y;function T(c,v){if(c===v)return!0;if(c==null||v===null||v===void 0||typeof c!=typeof v||typeof c!="object"||Array.isArray(c)!==Array.isArray(v))return!1;let I,b;if(Array.isArray(c)){if(c.length!==v.length)return!1;for(I=0;I<c.length;I++)if(!T(c[I],v[I]))return!1}else{const m=[];for(b in c)m.push(b);m.sort();const o=[];for(b in v)o.push(b);if(o.sort(),!T(m,o))return!1;for(I=0;I<m.length;I++)if(!T(c[m[I]],v[m[I]]))return!1}return!0}e.equals=T;function F(c){const v=new Set;return JSON.stringify(c,(I,b)=>{if((0,d.isObject)(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return b})}e.safeStringify=F;function C(c,v,I){const b=v(c);return typeof b=="undefined"?I:b}e.getOrDefault=C;function f(c,v){const I=Object.create(null);return!c||!v||Object.keys(v).forEach(m=>{const o=c[m],g=v[m];T(o,g)||(I[m]=g)}),I}e.distinct=f;function _(c,v){const I=v.toLowerCase(),b=Object.keys(c).find(m=>m.toLowerCase()===I);return b?c[b]:c[v]}e.getCaseInsensitive=_;function p(c,v){const I=Object.create(null);for(const[b,m]of Object.entries(c))v(b,m)&&(I[b]=m);return I}e.filter=p}),define(ve[98],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var d;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d=e.Constants||(e.Constants={}));function t(A){return A<0?0:A>255?255:A|0}e.toUint8=t;function k(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=k}),define(ve[2],be([1,0,9,11]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function P(a,i){if(!a.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!k.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!A.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(a,i){return!a&&!i?"file":a}function T(a,i){switch(a){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const F="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class _{constructor(i,r,s,l,h,u=!1){typeof i=="object"?(this.scheme=i.scheme||F,this.authority=i.authority||F,this.path=i.path||F,this.query=i.query||F,this.fragment=i.fragment||F):(this.scheme=y(i,u),this.authority=r||F,this.path=T(this.scheme,s||F),this.query=l||F,this.fragment=h||F,P(this,u))}static isUri(i){return i instanceof _?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return m(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:s,path:l,query:h,fragment:u}=i;return r===void 0?r=this.scheme:r===null&&(r=F),s===void 0?s=this.authority:s===null&&(s=F),l===void 0?l=this.path:l===null&&(l=F),h===void 0?h=this.query:h===null&&(h=F),u===void 0?u=this.fragment:u===null&&(u=F),r===this.scheme&&s===this.authority&&l===this.path&&h===this.query&&u===this.fragment?this:new c(r,s,l,h,u)}static parse(i,r=!1){const s=f.exec(i);return s?new c(s[2]||F,E(s[4]||F),E(s[5]||F),E(s[7]||F),E(s[9]||F),r):new c(F,F,F,F,F)}static file(i){let r=F;if(t.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const s=i.indexOf(C,2);s===-1?(r=i.substring(2),i=C):(r=i.substring(2,s),i=i.substring(s)||C)}return new c("file",r,i,F,F)}static from(i){const r=new c(i.scheme,i.authority,i.path,i.query,i.fragment);return P(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return t.isWindows&&i.scheme==="file"?s=_.file(d.win32.join(m(i,!0),...r)).path:s=d.posix.join(i.path,...r),i.with({path:s})}toString(i=!1){return o(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof _)return i;{const r=new c(i);return r._formatted=i.external,r._fsPath=i._sep===p?i.fsPath:null,r}}else return i}}e.URI=_;const p=t.isWindows?1:void 0;class c extends _{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(i=!1){return i?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(a,i){let r,s=-1;for(let l=0;l<a.length;l++){const h=a.charCodeAt(l);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||i&&h===47)s!==-1&&(r+=encodeURIComponent(a.substring(s,l)),s=-1),r!==void 0&&(r+=a.charAt(l));else{r===void 0&&(r=a.substr(0,l));const u=v[h];u!==void 0?(s!==-1&&(r+=encodeURIComponent(a.substring(s,l)),s=-1),r+=u):s===-1&&(s=l)}}return s!==-1&&(r+=encodeURIComponent(a.substring(s))),r!==void 0?r:a}function b(a){let i;for(let r=0;r<a.length;r++){const s=a.charCodeAt(r);s===35||s===63?(i===void 0&&(i=a.substr(0,r)),i+=v[s]):i!==void 0&&(i+=a[r])}return i!==void 0?i:a}function m(a,i){let r;return a.authority&&a.path.length>1&&a.scheme==="file"?r=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?i?r=a.path.substr(1):r=a.path[1].toLowerCase()+a.path.substr(2):r=a.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=m;function o(a,i){const r=i?b:I;let s="",{scheme:l,authority:h,path:u,query:w,fragment:R}=a;if(l&&(s+=l,s+=":"),(h||l==="file")&&(s+=C,s+=C),h){let O=h.indexOf("@");if(O!==-1){const L=h.substr(0,O);h=h.substr(O+1),O=L.indexOf(":"),O===-1?s+=r(L,!1):(s+=r(L.substr(0,O),!1),s+=":",s+=r(L.substr(O+1),!1)),s+="@"}h=h.toLowerCase(),O=h.indexOf(":"),O===-1?s+=r(h,!1):(s+=r(h.substr(0,O),!1),s+=h.substr(O))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const O=u.charCodeAt(1);O>=65&&O<=90&&(u=`/${String.fromCharCode(O+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const O=u.charCodeAt(0);O>=65&&O<=90&&(u=`${String.fromCharCode(O+32)}:${u.substr(2)}`)}s+=r(u,!0)}return w&&(s+="?",s+=r(w,!1)),R&&(s+="#",s+=i?R:I(R,!1)),s}function g(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+g(a.substr(3)):a}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(a){return a.match(n)?a.replace(n,i=>g(i)):a}}),define(ve[59],be([1,0,23,8,2]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(F){return JSON.stringify(F,y)}e.stringify=A;function D(F){let C=JSON.parse(F);return C=T(C),C}e.parse=D;var P;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext",F[F.Date=14]="Date"})(P=e.MarshalledId||(e.MarshalledId={}));function y(F,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function T(F,C=0){if(!F||C>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return k.URI.revive(F);case 2:return new RegExp(F.source,F.flags);case 14:return new Date(F.source)}if(F instanceof d.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let f=0;f<F.length;++f)F[f]=T(F[f],C+1);else for(const f in F)Object.hasOwnProperty.call(F,f)&&(F[f]=T(F[f],C+1))}return F}e.revive=T}),define(ve[10],be([1,0,11,2]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,T,F){this._hosts[y]=T,this._ports[y]=F}setConnectionToken(y,T){this._connectionTokens[y]=T}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)return this._delegate(y);const T=y.authority;let F=this._hosts[T];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const C=this._ports[T],f=this._connectionTokens[T];let _=`path=${encodeURIComponent(y.path)}`;return typeof f=="string"&&(_+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),t.URI.from({scheme:d.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${F}:${C}`,path:"/vscode-remote-resource",query:_})}}e.RemoteAuthorities=new A;class D{asBrowserUri(y,T){const F=this.toUri(y,T);return F.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===k.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?F.with({scheme:k.vscodeFileResource,authority:F.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(y,T){const F=this.toUri(y,T);return F.scheme===k.vscodeFileResource?F.with({scheme:k.file,authority:F.authority!==D.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(y,T){return t.URI.isUri(y)?y:t.URI.parse(T.toUrl(y))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(ve[22],be([1,0,28,10,9,11,8,2]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(_){return(0,P.uriToFsPath)(_,!0)}e.originalFSPath=y;class T{constructor(p){this._ignorePathCasing=p}compare(p,c,v=!1){return p===c?0:(0,D.compare)(this.getComparisonKey(p,v),this.getComparisonKey(c,v))}isEqual(p,c,v=!1){return p===c?!0:!p||!c?!1:this.getComparisonKey(p,v)===this.getComparisonKey(c,v)}getComparisonKey(p,c=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,c,v=!1){if(p.scheme===c.scheme){if(p.scheme===t.Schemas.file)return d.isEqualOrParent(y(p),y(c),this._ignorePathCasing(p))&&p.query===c.query&&(v||p.fragment===c.fragment);if((0,e.isEqualAuthority)(p.authority,c.authority))return d.isEqualOrParent(p.path,c.path,this._ignorePathCasing(p),"/")&&p.query===c.query&&(v||p.fragment===c.fragment)}return!1}joinPath(p,...c){return P.URI.joinPath(p,...c)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return k.posix.basename(p.path)}extname(p){return k.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let c;return p.scheme===t.Schemas.file?c=P.URI.file(k.dirname(y(p))).path:(c=k.posix.dirname(p.path),p.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),c="/")),p.with({path:c})}normalizePath(p){if(!p.path.length)return p;let c;return p.scheme===t.Schemas.file?c=P.URI.file(k.normalize(y(p))).path:c=k.posix.normalize(p.path),p.with({path:c})}relativePath(p,c){if(p.scheme!==c.scheme||!(0,e.isEqualAuthority)(p.authority,c.authority))return;if(p.scheme===t.Schemas.file){const b=k.relative(y(p),y(c));return A.isWindows?d.toSlashes(b):b}let v=p.path||"/",I=c.path||"/";if(this._ignorePathCasing(p)){let b=0;for(const m=Math.min(v.length,I.length);b<m&&!(v.charCodeAt(b)!==I.charCodeAt(b)&&v.charAt(b).toLowerCase()!==I.charAt(b).toLowerCase());b++);v=I.substr(0,b)+v.substr(b)}return k.posix.relative(v,I)}resolvePath(p,c){if(p.scheme===t.Schemas.file){const v=P.URI.file(k.resolve(y(p),c));return p.with({authority:v.authority,path:v.path})}return c=d.toPosixPath(c),p.with({path:k.posix.resolve(p.path,c)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,c){return p===c||p!==void 0&&c!==void 0&&(0,D.equalsIgnoreCase)(p,c)}hasTrailingPathSeparator(p,c=k.sep){if(p.scheme===t.Schemas.file){const v=y(p);return v.length>d.getRoot(v).length&&v[v.length-1]===c}else{const v=p.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,c=k.sep){return(0,e.hasTrailingPathSeparator)(p,c)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,c=k.sep){let v=!1;if(p.scheme===t.Schemas.file){const I=y(p);v=I!==void 0&&I.length===d.getRoot(I).length&&I[I.length-1]===c}else{c="/";const I=p.path;v=I.length===1&&I.charCodeAt(I.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(p,c)?p.with({path:p.path+"/"}):p}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(_=>_.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(_=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(_,p){const c=[];for(let v=0;v<_.length;v++){const I=p(_[v]);_.some((b,m)=>m===v?!1:(0,e.isEqualOrParent)(I,p(b)))||c.push(_[v])}return c}e.distinctParents=F;var C;(function(_){_.META_DATA_LABEL="label",_.META_DATA_DESCRIPTION="description",_.META_DATA_SIZE="size",_.META_DATA_MIME="mime";function p(c){const v=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(m=>{const[o,g]=m.split(":");o&&g&&v.set(o,g)});const b=c.path.substring(0,c.path.indexOf(";"));return b&&v.set(_.META_DATA_MIME,b),v}_.parseMetaData=p})(C=e.DataUri||(e.DataUri={}));function f(_,p,c){if(p){let v=_.path;return v&&v[0]!==k.posix.sep&&(v=k.posix.sep+v),_.with({scheme:c,authority:p,path:v})}return _.with({scheme:c})}e.toLocalResource=f}),define(ve[13],be([1,0,21,16,3,6,22,11]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(ee){return!!ee&&typeof ee.then=="function"}e.isThenable=y;function T(ee){const Y=new d.CancellationTokenSource,ae=ee(Y.token),he=new Promise((we,ke)=>{const Ne=Y.token.onCancellationRequested(()=>{Ne.dispose(),Y.dispose(),ke(new t.CancellationError)});Promise.resolve(ae).then(_e=>{Ne.dispose(),Y.dispose(),we(_e)},_e=>{Ne.dispose(),Y.dispose(),ke(_e)})});return new class{cancel(){Y.cancel()}then(we,ke){return he.then(we,ke)}catch(we){return this.then(void 0,we)}finally(we){return he.finally(we)}}}e.createCancelablePromise=T;function F(ee,Y,ae){return new Promise((he,we)=>{const ke=Y.onCancellationRequested(()=>{ke.dispose(),he(ae)});ee.then(he,we).finally(()=>ke.dispose())})}e.raceCancellation=F;function C(ee,Y){return new Promise((ae,he)=>{const we=Y.onCancellationRequested(()=>{we.dispose(),he(new t.CancellationError)});ee.then(ae,he).finally(()=>we.dispose())})}e.raceCancellationError=C;async function f(ee){let Y=-1;const ae=ee.map((we,ke)=>we.then(Ne=>(Y=ke,Ne))),he=await Promise.race(ae);return ee.forEach((we,ke)=>{ke!==Y&&we.cancel()}),he}e.raceCancellablePromises=f;function _(ee,Y,ae){let he;const we=setTimeout(()=>{he?.(void 0),ae?.()},Y);return Promise.race([ee.finally(()=>clearTimeout(we)),new Promise(ke=>he=ke)])}e.raceTimeout=_;function p(ee){return new Promise((Y,ae)=>{const he=ee();y(he)?he.then(Y,ae):Y(he)})}e.asPromise=p;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const ae=()=>{this.queuedPromise=null;const he=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,he};this.queuedPromise=new Promise(he=>{this.activePromise.then(ae,ae).then(he)})}return new Promise((ae,he)=>{this.queuedPromise.then(ae,he)})}return this.activePromise=Y(),new Promise((ae,he)=>{this.activePromise.then(we=>{this.activePromise=null,ae(we)},we=>{this.activePromise=null,he(we)})})}}e.Throttler=c;class v{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=v;class I{constructor(){this.promiseMap=new Map}queue(Y,ae){const we=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.promiseMap.get(Y)===we&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,we),we}}e.SequencerByKey=I;const b=(ee,Y)=>{let ae=!0;const he=setTimeout(()=>{ae=!1,Y()},ee);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(he),ae=!1}}},m=ee=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,ee())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class o{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,ae=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((we,ke)=>{this.doResolve=we,this.doReject=ke}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const we=this.task;return this.task=null,we()}}));const he=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ae===e.MicrotaskDelay?m(he):b(ae,he),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=o;class g{constructor(Y){this.delayer=new o(Y),this.throttler=new c}trigger(Y,ae){return this.delayer.trigger(()=>this.throttler.queue(Y),ae)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=g;class n{constructor(){this._isOpen=!1,this._promise=new Promise((Y,ae)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class E extends n{constructor(Y){super();this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=E;function a(ee,Y){return Y?new Promise((ae,he)=>{const we=setTimeout(()=>{ke.dispose(),ae()},ee),ke=Y.onCancellationRequested(()=>{clearTimeout(we),ke.dispose(),he(new t.CancellationError)})}):T(ae=>a(ee,ae))}e.timeout=a;function i(ee,Y=0){const ae=setTimeout(ee,Y);return(0,A.toDisposable)(()=>clearTimeout(ae))}e.disposableTimeout=i;function r(ee){const Y=[];let ae=0;const he=ee.length;function we(){return ae<he?ee[ae++]():null}function ke(Ne){Ne!=null&&Y.push(Ne);const _e=we();return _e?_e.then(ke):Promise.resolve(Y)}return Promise.resolve(null).then(ke)}e.sequence=r;function s(ee,Y=he=>!!he,ae=null){let he=0;const we=ee.length,ke=()=>{if(he>=we)return Promise.resolve(ae);const Ne=ee[he++];return Promise.resolve(Ne()).then(Ee=>Y(Ee)?Promise.resolve(Ee):ke())};return ke()}e.first=s;function l(ee,Y=he=>!!he,ae=null){if(ee.length===0)return Promise.resolve(ae);let he=ee.length;const we=()=>{he=-1;for(const ke of ee)ke.cancel?.()};return new Promise((ke,Ne)=>{for(const _e of ee)_e.then(Ee=>{--he>=0&&Y(Ee)?(we(),ke(Ee)):he===0&&ke(ae)}).catch(Ee=>{--he>=0&&(we(),Ne(Ee))})})}e.firstParallel=l;class h{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Y){return this._size++,new Promise((ae,he)=>{this.outstandingPromises.push({factory:Y,c:ae,e:he}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const ae=Y.factory();ae.then(Y.c,Y.e),ae.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class u extends h{constructor(){super(1)}}e.Queue=u;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new x;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,ae=D.extUri){const he=ae.getComparisonKey(Y);let we=this.queues.get(he);return we||(we=new u,k.Event.once(we.onFinished)(()=>{we?.dispose(),this.queues.delete(he),this.onDidQueueFinish()}),this.queues.set(he,we)),we}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class R{constructor(Y,ae){this._token=-1,typeof Y=="function"&&typeof ae=="number"&&this.setIfNotSet(Y,ae)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,ae){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},ae)}setIfNotSet(Y,ae){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},ae))}}e.TimeoutTimer=R;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,ae){this.cancel(),this._token=setInterval(()=>{Y()},ae)}}e.IntervalTimer=O;class L{constructor(Y,ae){this.timeoutToken=-1,this.runner=Y,this.timeout=ae,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class S{constructor(Y,ae){ae%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=ae,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=S;class U extends L{constructor(Y,ae){super(Y,ae);this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner&&this.runner(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class M extends A.Disposable{constructor(Y,ae){super();this.options=Y,this.handler=ae,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ee=>{(0,P.setTimeout0)(()=>{if(Y)return;const ae=Date.now()+15;ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(ee,Y)=>{const ae=requestIdleCallback(ee,typeof Y=="number"?{timeout:Y}:void 0);let he=!1;return{dispose(){he||(he=!0,cancelIdleCallback(ae))}}}}();class X{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(ae){this._error=ae}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=X;async function G(ee,Y,ae){let he;for(let we=0;we<ae;we++)try{return await ee()}catch(ke){he=ke,await a(Y)}throw he}e.retry=G;class q{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Y,ae,he){return this._pending={taskId:Y,cancel:()=>he?.(),promise:ae},ae.then(()=>this.donePending(Y),()=>this.donePending(Y)),ae}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let ae,he;const we=new Promise((ke,Ne)=>{ae=ke,he=Ne});this._next={run:Y,promise:we,promiseResolve:ae,promiseReject:he}}return this._next.promise}}e.TaskSequentializer=q;class B{constructor(Y,ae=()=>Date.now()){this.interval=Y,this.nowFn=ae,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,ae)=>{this.completeCallback=Y,this.errorCallback=ae})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Y){return new Promise(ae=>{this.completeCallback(Y),this.resolved=!0,ae()})}error(Y){return new Promise(ae=>{this.errorCallback(Y),this.rejected=!0,ae()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=x;var j;(function(ee){async function Y(he){let we;const ke=await Promise.all(he.map(Ne=>Ne.then(_e=>_e,_e=>{we||(we=_e)})));if(typeof we!="undefined")throw we;return ke}ee.settled=Y;function ae(he){return new Promise(async(we,ke)=>{try{await he(we,ke)}catch(Ne){ke(Ne)}})}ee.withAsyncBody=ae})(j=e.Promises||(e.Promises={}));var V;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(V||(V={}));class Z{constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const ae={emitOne:he=>this.emitOne(he),emitMany:he=>this.emitMany(he),reject:he=>this.reject(he)};try{await Promise.resolve(Y(ae)),this.resolve()}catch(he){this.reject(he)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}static fromArray(Y){return new Z(ae=>{ae.emitMany(Y)})}static fromPromise(Y){return new Z(async ae=>{ae.emitMany(await Y)})}static fromPromises(Y){return new Z(async ae=>{await Promise.all(Y.map(async he=>ae.emitOne(await he)))})}static merge(Y){return new Z(async ae=>{await Promise.all(Y.map(async he=>{for await(const we of he)ae.emitOne(we)}))})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,ae){return new Z(async he=>{for await(const we of Y)he.emitOne(ae(we))})}map(Y){return Z.map(this,Y)}static filter(Y,ae){return new Z(async he=>{for await(const we of Y)ae(we)&&he.emitOne(we)})}filter(Y){return Z.filter(this,Y)}static coalesce(Y){return Z.filter(Y,ae=>!!ae)}coalesce(){return Z.coalesce(this)}static async toPromise(Y){const ae=[];for await(const he of Y)ae.push(he);return ae}toPromise(){return Z.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=Z,Z.EMPTY=Z.fromArray([]);class se extends Z{constructor(Y,ae){super(ae);this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function ce(ee){const Y=new d.CancellationTokenSource,ae=ee(Y.token);return new se(Y,async he=>{const we=Y.token.onCancellationRequested(()=>{we.dispose(),Y.dispose(),he.reject(new t.CancellationError)});try{for await(const ke of ae){if(Y.token.isCancellationRequested)return;he.emitOne(ke)}we.dispose(),Y.dispose()}catch(ke){we.dispose(),Y.dispose(),he.reject(ke)}})}e.createCancelableAsyncIterable=ce}),define(ve[99],be([1,0,13,9]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new d.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(u,w,R=!1){const O=u||"",L=w||"",S=k.value.collator.compare(O,L);return k.value.collatorIsNumeric&&S===0&&O!==L?O<L?-1:1:S}e.compareFileNames=P;function y(u,w){const R=A.value.collator;return u=u||"",w=w||"",g(R,u,w)}e.compareFileNamesDefault=y;function T(u,w){const R=A.value.collator;return u=u||"",w=w||"",i(u,w)||g(R,u,w)}e.compareFileNamesUpper=T;function F(u,w){const R=A.value.collator;return u=u||"",w=w||"",a(u,w)||g(R,u,w)}e.compareFileNamesLower=F;function C(u,w){return u=u||"",w=w||"",u===w?0:u<w?-1:1}e.compareFileNamesUnicode=C;function f(u,w,R=!1){R||(u=u&&u.toLowerCase(),w=w&&w.toLowerCase());const[O,L]=m(u),[S,U]=m(w);return O!==S?O<S?-1:1:L===U?0:L<U?-1:1}e.noIntlCompareFileNames=f;function _(u,w){const[R,O]=m(u),[L,S]=m(w);let U=k.value.collator.compare(O,S);if(U===0){if(k.value.collatorIsNumeric&&O!==S)return O<S?-1:1;if(U=k.value.collator.compare(R,L),k.value.collatorIsNumeric&&U===0&&R!==L)return R<L?-1:1}return U}e.compareFileExtensions=_;function p(u,w){u=u||"",w=w||"";const R=o(u),O=o(w),L=A.value.collator,S=D.value.collator;return g(S,R,O)||g(L,u,w)}e.compareFileExtensionsDefault=p;function c(u,w){u=u||"",w=w||"";const R=o(u),O=o(w),L=A.value.collator,S=D.value.collator;return g(S,R,O)||i(u,w)||g(L,u,w)}e.compareFileExtensionsUpper=c;function v(u,w){u=u||"",w=w||"";const R=o(u),O=o(w),L=A.value.collator,S=D.value.collator;return g(S,R,O)||a(u,w)||g(L,u,w)}e.compareFileExtensionsLower=v;function I(u,w){u=u||"",w=w||"";const R=o(u).toLowerCase(),O=o(w).toLowerCase();return R!==O?R<O?-1:1:u!==w?u<w?-1:1:0}e.compareFileExtensionsUnicode=I;const b=/^(.*?)(\.([^.]*))?$/;function m(u,w=!1){const R=u?b.exec(u):[];let O=[R&&R[1]||"",R&&R[3]||""];return w&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function o(u){const w=u?b.exec(u):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function g(u,w,R){let O=u.compare(w,R);return O!==0?O:w.length!==R.length?w.length<R.length?-1:1:0}function n(u){const w=u.charAt(0);return w.toLocaleUpperCase()!==w}function E(u){const w=u.charAt(0);return w.toLocaleLowerCase()!==w}function a(u,w){return n(u)&&E(w)?-1:E(u)&&n(w)?1:0}function i(u,w){return E(u)&&n(w)?-1:n(u)&&E(w)?1:0}function r(u,w,R=!1){return R||(u=u&&u.toLowerCase(),w=w&&w.toLowerCase()),u===w?0:u<w?-1:1}function s(u,w,R=!1){const O=u.split(t.sep),L=w.split(t.sep),S=O.length-1,U=L.length-1;let M,X;for(let G=0;;G++){if(M=S===G,X=U===G,M&&X)return P(O[G],L[G],R);if(M)return-1;if(X)return 1;const q=r(O[G],L[G],R);if(q!==0)return q}}e.comparePaths=s;function l(u,w,R){const O=u.toLowerCase(),L=w.toLowerCase(),S=h(u,w,R);if(S)return S;const U=O.endsWith(R),M=L.endsWith(R);if(U!==M)return U?-1:1;const X=P(O,L);return X!==0?X:O.localeCompare(L)}e.compareAnything=l;function h(u,w,R){const O=u.toLowerCase(),L=w.toLowerCase(),S=O.startsWith(R),U=L.startsWith(R);if(S!==U)return S?-1:1;if(S&&U){if(O.length<L.length)return-1;if(O.length>L.length)return 1}return 0}e.compareByPrefix=h}),define(ve[100],be([1,0,99,97,58,9,11,8]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,T=[y,[]];function F(q,B,x,j){if(!q||!B)return T;const V=q.length,Z=B.length;if(V<Z)return T;const se=q.toLowerCase();return C(B,x,Z,q,se,V,j)}e.scoreFuzzy=F;function C(q,B,x,j,V,Z,se){const ce=[],ee=[];for(let we=0;we<x;we++){const ke=we*Z,Ne=ke-Z,_e=we>0,Ee=q[we],z=B[we];for(let W=0;W<Z;W++){const N=W>0,$=ke+W,K=$-1,re=Ne+W-1,de=N?ce[K]:0,ye=_e&&N?ce[re]:0,Re=_e&&N?ee[re]:0;let We;!ye&&_e?We=0:We=f(Ee,z,j,V,W,Re),We&&ye+We>=de&&(se||_e||V.startsWith(B,W))?(ee[$]=Re+1,ce[$]=ye+We):(ee[$]=y,ce[$]=de)}}const Y=[];let ae=x-1,he=Z-1;for(;ae>=0&&he>=0;){const we=ae*Z+he;ee[we]===y||(Y.push(he),ae--),he--}return[ce[x*Z-1],Y.reverse()]}function f(q,B,x,j,V,Z){let se=0;if(!_(B,j[V]))return se;if(se+=1,Z>0&&(se+=Z*5),q===x[V]&&(se+=1),V===0)se+=8;else{const ce=p(x.charCodeAt(V-1));ce?se+=ce:(0,t.isUpper)(x.charCodeAt(V))&&Z===0&&(se+=2)}return se}function _(q,B){return q===B?!0:q==="/"||q==="\\"?B==="/"||B==="\\":!1}function p(q){switch(q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function v(q,B,x=0,j=0){const V=B;return V.values&&V.values.length>1?I(q,V.values,x,j):b(q,B,x,j)}e.scoreFuzzy2=v;function I(q,B,x,j){let V=0;const Z=[];for(const se of B){const[ce,ee]=b(q,se,x,j);if(typeof ce!="number")return c;V+=ce,Z.push(...ee)}return[V,h(Z)]}function b(q,B,x,j){const V=(0,t.fuzzyScore)(B.original,B.originalLowercase,x,q,q.toLowerCase(),j,!0);return V?[V[0],(0,t.createMatches)(V)]:c}const m=Object.freeze({score:0}),o=1<<18,g=1<<17,n=1<<16;function E(q,B,x,j){const V=j.values?j.values:[j];return(0,k.hash)({[j.normalized]:{values:V.map(se=>({value:se.normalized,expectContiguousMatch:se.expectContiguousMatch})),label:q,description:B,allowNonContiguousMatches:x}})}function a(q,B,x,j,V){if(!q||!B.normalized)return m;const Z=j.getItemLabel(q);if(!Z)return m;const se=j.getItemDescription(q),ce=E(Z,se,x,B),ee=V[ce];if(ee)return ee;const Y=i(Z,se,j.getItemPath(q),B,x);return V[ce]=Y,Y}e.scoreItemFuzzy=a;function i(q,B,x,j,V){const Z=!x||!j.containsPathSeparator;return x&&(D.isLinux?j.pathNormalized===x:(0,P.equalsIgnoreCase)(j.pathNormalized,x))?{score:o,labelMatch:[{start:0,end:q.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:j.values&&j.values.length>1?r(q,B,x,j.values,Z,V):s(q,B,x,j,Z,V)}function r(q,B,x,j,V,Z){let se=0;const ce=[],ee=[];for(const Y of j){const{score:ae,labelMatch:he,descriptionMatch:we}=s(q,B,x,Y,V,Z);if(ae===y)return m;se+=ae,he&&ce.push(...he),we&&ee.push(...we)}return{score:se,labelMatch:h(ce),descriptionMatch:h(ee)}}function s(q,B,x,j,V,Z){if(V||!B){const[se,ce]=F(q,j.normalized,j.normalizedLowercase,Z&&!j.expectContiguousMatch);if(se){const ee=(0,t.matchesPrefix)(j.normalized,q);let Y;return ee?(Y=g,Y+=Math.round(j.normalized.length/q.length*100)):Y=n,{score:Y+se,labelMatch:ee||l(ce)}}}if(B){let se=B;x&&(se=`${B}${A.sep}`);const ce=se.length,ee=`${se}${q}`,[Y,ae]=F(ee,j.normalized,j.normalizedLowercase,Z&&!j.expectContiguousMatch);if(Y){const he=l(ae),we=[],ke=[];return he.forEach(Ne=>{Ne.start<ce&&Ne.end>ce?(we.push({start:0,end:Ne.end-ce}),ke.push({start:Ne.start,end:ce})):Ne.start>=ce?we.push({start:Ne.start-ce,end:Ne.end-ce}):ke.push(Ne)}),{score:Y,labelMatch:we,descriptionMatch:ke}}}return m}function l(q){const B=[];if(!q)return B;let x;for(const j of q)x&&x.end===j?x.end+=1:(x={start:j,end:j+1},B.push(x));return B}function h(q){const B=q.sort((V,Z)=>V.start-Z.start),x=[];let j;for(const V of B)!j||!u(j,V)?(j=V,x.push(V)):(j.start=Math.min(j.start,V.start),j.end=Math.max(j.end,V.end));return x}function u(q,B){return!(q.end<B.start||B.end<q.start)}function w(q,B,x,j,V,Z){const se=a(q,x,j,V,Z),ce=a(B,x,j,V,Z),ee=se.score,Y=ce.score;if((ee===o||Y===o)&&ee!==Y)return ee===o?-1:1;if(ee>n||Y>n){if(ee!==Y)return ee>Y?-1:1;if(ee<g&&Y<g){const Ee=O(se.labelMatch,ce.labelMatch);if(Ee!==0)return Ee}const Ne=V.getItemLabel(q)||"",_e=V.getItemLabel(B)||"";if(Ne.length!==_e.length)return Ne.length-_e.length}if(ee!==Y)return ee>Y?-1:1;const ae=Array.isArray(se.labelMatch)&&se.labelMatch.length>0,he=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0;if(ae&&!he)return-1;if(he&&!ae)return 1;const we=R(q,se,V),ke=R(B,ce,V);return we&&ke&&we!==ke?ke>we?-1:1:L(q,B,x,V)}e.compareItemsByFuzzyScore=w;function R(q,B,x){let j=-1,V=-1;if(B.descriptionMatch&&B.descriptionMatch.length?j=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(j=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(V=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const Z=x.getItemDescription(q);Z&&(V+=Z.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(V=B.descriptionMatch[B.descriptionMatch.length-1].end);return V-j}function O(q,B){if(!q&&!B||(!q||!q.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!q||!q.length)return 1;const x=q[0].start,V=q[q.length-1].end-x,Z=B[0].start,ce=B[B.length-1].end-Z;return V===ce?0:ce<V?1:-1}function L(q,B,x,j){const V=j.getItemLabel(q)||"",Z=j.getItemLabel(B)||"",se=j.getItemDescription(q),ce=j.getItemDescription(B),ee=V.length+(se?se.length:0),Y=Z.length+(ce?ce.length:0);if(ee!==Y)return ee-Y;const ae=j.getItemPath(q),he=j.getItemPath(B);return ae&&he&&ae.length!==he.length?ae.length-he.length:V!==Z?(0,d.compareAnything)(V,Z,x.normalized):se&&ce&&se!==ce?(0,d.compareAnything)(se,ce,x.normalized):ae&&he&&ae!==he?(0,d.compareAnything)(ae,he,x.normalized):0}function S(q){return q.startsWith('"')&&q.endsWith('"')}const U=" ";function M(q){typeof q!="string"&&(q="");const B=q.toLowerCase(),{pathNormalized:x,normalized:j,normalizedLowercase:V}=X(q),Z=x.indexOf(A.sep)>=0,se=S(q);let ce;const ee=q.split(U);if(ee.length>1)for(const Y of ee){const ae=S(Y),{pathNormalized:he,normalized:we,normalizedLowercase:ke}=X(Y);we&&(ce||(ce=[]),ce.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:he,normalized:we,normalizedLowercase:ke,expectContiguousMatch:ae}))}return{original:q,originalLowercase:B,pathNormalized:x,normalized:j,normalizedLowercase:V,values:ce,containsPathSeparator:Z,expectContiguousMatch:se}}e.prepareQuery=M;function X(q){let B;D.isWindows?B=q.replace(/\//g,A.sep):B=q.replace(/\\/g,A.sep);const x=(0,P.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:x,normalizedLowercase:x.toLowerCase()}}function G(q){return Array.isArray(q)?M(q.map(B=>B.original).join(U)):M(q.original)}e.pieceToQuery=G}),define(ve[32],be([1,0,13,28,24,9,11,8]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",F="[^/\\\\]",C=/\//g;function f(x){switch(x){case 0:return"";case 1:return`${F}*?`;default:return`(?:${T}|${F}+${T}|${T}${F}+)*?`}}function _(x,j){if(!x)return[];const V=[];let Z=!1,se=!1,ce="";for(const ee of x){switch(ee){case j:if(!Z&&!se){V.push(ce),ce="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":se=!0;break;case"]":se=!1;break}ce+=ee}return ce&&V.push(ce),V}e.splitGlobAware=_;function p(x){if(!x)return"";let j="";const V=_(x,e.GLOB_SPLIT);if(V.every(Z=>Z===e.GLOBSTAR))j=".*";else{let Z=!1;V.forEach((se,ce)=>{if(se===e.GLOBSTAR){Z||(j+=f(2),Z=!0);return}let ee=!1,Y="",ae=!1,he="";for(const we of se){if(we!=="}"&&ee){Y+=we;continue}if(ae&&(we!=="]"||!he)){let ke;we==="-"?ke=we:(we==="^"||we==="!")&&!he?ke="^":we===e.GLOB_SPLIT?ke="":ke=(0,P.escapeRegExpCharacters)(we),he+=ke;continue}switch(we){case"{":ee=!0;continue;case"[":ae=!0;continue;case"}":{j+=`(?:${_(Y,",").map(_e=>p(_e)).join("|")})`,ee=!1,Y="";break}case"]":j+="["+he+"]",ae=!1,he="";break;case"?":j+=F;continue;case"*":j+=f(1);continue;default:j+=(0,P.escapeRegExpCharacters)(we)}}ce<V.length-1&&(V[ce+1]!==e.GLOBSTAR||ce+2<V.length)&&(j+=T),Z=!1})}return j}const c=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,b=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,g=new k.LRUCache(1e4),n=function(){return!1},E=function(){return null};function a(x,j){if(!x)return E;let V;typeof x!="string"?V=x.pattern:V=x,V=V.trim();const Z=`${V}_${!!j.trimForExclusions}`;let se=g.get(Z);if(se)return i(se,x);let ce;if(c.test(V)){const ee=V.substr(4);se=function(Y,ae){return typeof Y=="string"&&Y.endsWith(ee)?V:null}}else(ce=v.exec(r(V,j)))?se=s(ce[1],V):(j.trimForExclusions?b:I).test(V)?se=l(V,j):(ce=m.exec(r(V,j)))?se=h(ce[1].substr(1),V,!0):(ce=o.exec(r(V,j)))?se=h(ce[1],V,!1):se=u(V);return g.set(Z,se),i(se,x)}function i(x,j){return typeof j=="string"?x:function(V,Z){return(0,t.isEqualOrParent)(V,j.base,!D.isLinux)?x(V.substr(j.base.length+1),Z):null}}function r(x,j){return j.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function s(x,j){const V=`/${x}`,Z=`\\${x}`,se=function(ee,Y){return typeof ee!="string"?null:Y?Y===x?j:null:ee===x||ee.endsWith(V)||ee.endsWith(Z)?j:null},ce=[x];return se.basenames=ce,se.patterns=[j],se.allBasenames=ce,se}function l(x,j){const V=B(x.slice(1,-1).split(",").map(Y=>a(Y,j)).filter(Y=>Y!==E),x),Z=V.length;if(!Z)return E;if(Z===1)return V[0];const se=function(Y,ae){for(let he=0,we=V.length;he<we;he++)if(V[he](Y,ae))return x;return null},ce=V.find(Y=>!!Y.allBasenames);ce&&(se.allBasenames=ce.allBasenames);const ee=V.reduce((Y,ae)=>ae.allPaths?Y.concat(ae.allPaths):Y,[]);return ee.length&&(se.allPaths=ee),se}function h(x,j,V){const Z=A.sep===A.posix.sep,se=Z?x:x.replace(C,A.sep),ce=A.sep+se,ee=A.posix.sep+x,Y=V?function(ae,he){return typeof ae=="string"&&(ae===se||ae.endsWith(ce)||!Z&&(ae===x||ae.endsWith(ee)))?j:null}:function(ae,he){return typeof ae=="string"&&(ae===se||!Z&&ae===x)?j:null};return Y.allPaths=[(V?"*/":"./")+x],Y}function u(x){try{const j=new RegExp(`^${p(x)}$`);return function(V){return j.lastIndex=0,typeof V=="string"&&j.test(V)?x:null}}catch{return E}}function w(x,j,V){return!x||typeof j!="string"?!1:R(x)(j,void 0,V)}e.match=w;function R(x,j={}){if(!x)return n;if(typeof x=="string"||U(x)){const V=a(x,j);if(V===E)return n;const Z=function(se,ce){return!!V(se,ce)};return V.allBasenames&&(Z.allBasenames=V.allBasenames),V.allPaths&&(Z.allPaths=V.allPaths),Z}return G(x,j)}e.parse=R;function O(x){if(!x)return;let j;return V=>(j||(j=(x()||Promise.resolve([])).then(Z=>Z?S(Z):{})),j.then(Z=>!!Z[V]))}e.hasSiblingPromiseFn=O;function L(x){if(!x)return;let j;return V=>{if(!j){const Z=x();j=Z?S(Z):{}}return!!j[V]}}e.hasSiblingFn=L;function S(x){const j={};for(const V of x)j[V]=!0;return j}function U(x){const j=x;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=U;function M(x){return x.allBasenames||[]}e.getBasenameTerms=M;function X(x){return x.allPaths||[]}e.getPathTerms=X;function G(x,j){const V=B(Object.getOwnPropertyNames(x).map(Y=>q(Y,x[Y],j)).filter(Y=>Y!==E)),Z=V.length;if(!Z)return E;if(!V.some(Y=>!!Y.requiresSiblings)){if(Z===1)return V[0];const Y=function(we,ke){for(let Ne=0,_e=V.length;Ne<_e;Ne++){const Ee=V[Ne](we,ke);if(Ee)return Ee}return null},ae=V.find(we=>!!we.allBasenames);ae&&(Y.allBasenames=ae.allBasenames);const he=V.reduce((we,ke)=>ke.allPaths?we.concat(ke.allPaths):we,[]);return he.length&&(Y.allPaths=he),Y}const se=function(Y,ae,he){let we;for(let ke=0,Ne=V.length;ke<Ne;ke++){const _e=V[ke];_e.requiresSiblings&&he&&(ae||(ae=(0,A.basename)(Y)),we||(we=ae.substr(0,ae.length-(0,A.extname)(Y).length)));const Ee=_e(Y,ae,we,he);if(Ee)return Ee}return null},ce=V.find(Y=>!!Y.allBasenames);ce&&(se.allBasenames=ce.allBasenames);const ee=V.reduce((Y,ae)=>ae.allPaths?Y.concat(ae.allPaths):Y,[]);return ee.length&&(se.allPaths=ee),se}function q(x,j,V){if(j===!1)return E;const Z=a(x,V);if(Z===E)return E;if(typeof j=="boolean")return Z;if(j){const se=j.when;if(typeof se=="string"){const ce=(ee,Y,ae,he)=>{if(!he||!Z(ee,Y))return null;const we=se.replace("$(basename)",ae),ke=he(we);return(0,d.isThenable)(ke)?ke.then(Ne=>Ne?x:null):ke?x:null};return ce.requiresSiblings=!0,ce}}return Z}function B(x,j){const V=x.filter(Y=>!!Y.basenames);if(V.length<2)return x;const Z=V.reduce((Y,ae)=>{const he=ae.basenames;return he?Y.concat(he):Y},[]);let se;if(j){se=[];for(let Y=0,ae=Z.length;Y<ae;Y++)se.push(j)}else se=V.reduce((Y,ae)=>{const he=ae.patterns;return he?Y.concat(he):Y},[]);const ce=function(Y,ae){if(typeof Y!="string")return null;if(!ae){let we;for(we=Y.length;we>0;we--){const ke=Y.charCodeAt(we-1);if(ke===47||ke===92)break}ae=Y.substr(we)}const he=Z.indexOf(ae);return he!==-1?se[he]:null};ce.basenames=Z,ce.patterns=se,ce.allBasenames=Z;const ee=x.filter(Y=>!Y.basenames);return ee.push(ce),ee}}),define(ve[101],be([1,0,16,146,22,2]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(c="",v=!1){if(this.value=c,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(c,v=0){return this.value+=C(this.supportThemeIcons?(0,t.escapeIcons)(c):c).replace(/([ \t]+)/g,(I,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,v){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}}e.MarkdownString=P;function y(p){return T(p)?!p.value:Array.isArray(p)?p.every(y):!0}e.isEmptyMarkdownString=y;function T(p){return p instanceof P?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function F(p,c){return p===c?!0:!p||!c?!1:p.value===c.value&&p.isTrusted===c.isTrusted&&p.supportThemeIcons===c.supportThemeIcons&&p.supportHtml===c.supportHtml&&(p.baseUri===c.baseUri||!!p.baseUri&&!!c.baseUri&&(0,k.isEqual)(A.URI.from(p.baseUri),A.URI.from(c.baseUri)))}e.markdownStringEqual=F;function C(p){return p.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function f(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function _(p){const c=[],v=p.split("|").map(b=>b.trim());p=v[0];const I=v[1];if(I){const b=/height=(\d+)/.exec(I),m=/width=(\d+)/.exec(I),o=b?b[1]:"",g=m?m[1]:"",n=isFinite(parseInt(g)),E=isFinite(parseInt(o));n&&c.push(`width="${g}"`),E&&c.push(`height="${o}"`)}return{href:p,dimensions:c}}e.parseHrefAndDimensions=_}),define(ve[79],be([1,0,28,10,9,11,22,8,2]),function(te,e,d,t,k,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(i,r,s){if(typeof i=="string"&&(i=y.URI.file(i)),s){const h=s.getWorkspaceFolder(i);if(h){const u=s.getWorkspace().folders.length>1;let w;if((0,D.isEqual)(h.uri,i)?w="":w=(0,D.relativePath)(h.uri,i),u){const R=h.name?h.name:(0,D.basename)(h.uri);w=w?R+" \u2022 "+w:R}return w}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(i.fsPath))return(0,k.normalize)(C(i.fsPath));let l=(0,k.normalize)(i.fsPath);return!A.isWindows&&r?.userHome&&(l=_(l,r.userHome.fsPath)),l}e.getPathLabel=T;function F(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const r=(0,D.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return A.isWindows&&(0,d.isRootOrDriveLetter)(r)?C(r):r}e.getBaseLabel=F;function C(i,r){return(0,d.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let f=Object.create(null);function _(i,r){if(A.isWindows||!i||!r)return i;let s=f.original===r?f.normalized:void 0;return s||(s=`${(0,P.rtrim)(r,k.posix.sep)}${k.posix.sep}`,f={original:r,normalized:s}),(A.isLinux?i.startsWith(s):(0,P.startsWithIgnoreCase)(i,s))&&(i=`~/${i.substr(s.length)}`),i}e.tildify=_;function p(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=p;const c="\u2026",v="\\\\",I="~";function b(i,r=k.sep){const s=new Array(i.length);let l=!1;for(let h=0;h<i.length;h++){let u=i[h];if(u===""){s[h]=`.${r}`;continue}if(!u){s[h]=u;continue}l=!0;let w="";u.indexOf(v)===0?(w=u.substr(0,u.indexOf(v)+v.length),u=u.substr(u.indexOf(v)+v.length)):u.indexOf(r)===0?(w=u.substr(0,u.indexOf(r)+r.length),u=u.substr(u.indexOf(r)+r.length)):u.indexOf(I)===0&&(w=u.substr(0,u.indexOf(I)+I.length),u=u.substr(u.indexOf(I)+I.length));const R=u.split(r);for(let O=1;l&&O<=R.length;O++)for(let L=R.length-O;l&&L>=0;L--){l=!1;let S=R.slice(L,L+O).join(r);for(let U=0;!l&&U<i.length;U++)if(U!==h&&i[U]&&i[U].indexOf(S)>-1){const M=L+O===R.length,X=L>0&&i[U].indexOf(r)>-1?r+S:S,G=i[U].endsWith(X);l=!M||G}if(!l){let U="";(R[0].endsWith(":")||w!=="")&&(L===1&&(L=0,O++,S=R[0]+r+S),L>0&&(U=R[0]+r),U=w+U),L>0&&(U=U+c+r),U=U+S,L+O<R.length&&(U=U+r+c),s[h]=U}}l&&(s[h]=u)}return s}e.shorten=b;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function o(i,r=Object.create(null)){const s=[];let l=!1,h="";for(const u of i)if(u==="$"||l&&u==="{")h&&s.push({value:h,type:m.TEXT}),h="",l=!0;else if(u==="}"&&l){const w=r[h];if(typeof w=="string")w.length&&s.push({value:w,type:m.VARIABLE});else if(w){const R=s[s.length-1];(!R||R.type!==m.SEPARATOR)&&s.push({value:w.label,type:m.SEPARATOR})}h="",l=!1}else h+=u;return h&&!l&&s.push({value:h,type:m.TEXT}),s.filter((u,w)=>{if(u.type===m.SEPARATOR){const R=s[w-1],O=s[w+1];return[R,O].every(L=>L&&(L.type===m.VARIABLE||L.type===m.TEXT)&&L.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=o;function g(i,r){return A.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function n(i,r){return A.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function E(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=E;function a(i){const r=i.indexOf("/")!==-1?k.posix:k.win32,s=r.basename(i),l=r.dirname(i);return s.length?{name:s,parentPath:l}:{name:l,parentPath:""}}e.splitName=a}),define(ve[102],be([1,0,2]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(F){return F.toJSON()}class k{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:t(d.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:t(d.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:d.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function A(F,C,f){if(!F||f>200)return null;if(typeof F=="object"){if(F instanceof d.URI)return C.transformOutgoing(F);for(let _ in F)if(Object.hasOwnProperty.call(F,_)){const p=A(F[_],C,f+1);p!==null&&(F[_]=p)}}return null}function D(F,C){const f=A(F,C,0);return f===null?F:f}e.transformOutgoingURIs=D;function P(F,C,f,_){if(!F||_>200)return null;if(typeof F=="object"){if(F.$mid===1)return f?d.URI.revive(C.transformIncoming(F)):C.transformIncoming(F);for(let p in F)if(Object.hasOwnProperty.call(F,p)){const c=P(F[p],C,f,_+1);c!==null&&(F[p]=c)}}return null}function y(F,C){const f=P(F,C,!1,0);return f===null?F:f}e.transformIncomingURIs=y;function T(F,C){const f=P(F,C,!0,0);return f===null?F:f}e.transformAndReviveIncomingURIs=T}),define(ve[33],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(y){return d.test(y)}e.isUUID=t;const k=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let T=0;T<y.length;T++)y[T]=Math.floor(Math.random()*256);return y};function P(){D(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let y=0,T="";return T+=A[k[y++]],T+=A[k[y++]],T+=A[k[y++]],T+=A[k[y++]],T+="-",T+=A[k[y++]],T+=A[k[y++]],T+="-",T+=A[k[y++]],T+=A[k[y++]],T+="-",T+=A[k[y++]],T+=A[k[y++]],T+="-",T+=A[k[y++]],T+=A[k[y++]],T+=A[k[y++]],T+=A[k[y++]],T+=A[k[y++]],T+=A[k[y++]],T}e.generateUuid=P}),define(ve[147],be([1,0,103]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(A="utf8"){this.stringDecoder=new d.StringDecoder(A),this.remaining=null}write(A){const D=[],P=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(P.length<1)return D;let y=0,T,F=y;for(;F<P.length;)if(T=P.charCodeAt(F),T===13||T===10){if(D.push(P.substring(y,F)),F++,F<P.length){const C=T;T=P.charCodeAt(F),(C===13&&T===10||C===10&&T===13)&&F++}y=F}else F++;return this.remaining=y<P.length?P.substr(y):null,D}end(){return this.remaining}}e.LineDecoder=t}),define(ve[29],be([1,0,60,80,293,13,28,78,9,11,22,2]),function(te,e,d,t,k,A,D,P,y,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function _(M,X=f.UNLINK){if((0,D.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return X===f.UNLINK?c(M):p(M)}async function p(M){try{const X=(0,D.randomPath)((0,t.tmpdir)());try{await d.promises.rename(M,X)}catch{return c(M)}c(X).catch(G=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function c(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function v(M){if((0,D.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");d.rmdirSync(M,{recursive:!0})}e.rimrafSync=v;async function I(M,X){return o(await(X?b(M):(0,k.promisify)(d.readdir)(M)))}async function b(M){try{return await(0,k.promisify)(d.readdir)(M,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const X=[],G=await I(M);for(const q of G){let B=!1,x=!1,j=!1;try{const V=await e.Promises.lstat((0,y.join)(M,q));B=V.isFile(),x=V.isDirectory(),j=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}X.push({name:q,isFile:()=>B,isDirectory:()=>x,isSymbolicLink:()=>j})}return X}function m(M){return o(d.readdirSync(M))}e.readdirSync=m;function o(M){return M.map(X=>typeof X=="string"?T.isMacintosh?(0,P.normalizeNFC)(X):X:(X.name=T.isMacintosh?(0,P.normalizeNFC)(X.name):X.name,X))}async function g(M){const X=await I(M),G=[];for(const q of X)await E.existsDirectory((0,y.join)(M,q))&&G.push(q);return G}function n(M,X=1e3){return new Promise(G=>{let q=!1;const B=setInterval(()=>{q||(q=!0,d.access(M,x=>{q=!1,x&&(clearInterval(B),G(void 0))}))},X)})}e.whenDeleted=n;var E;(function(M){async function X(B){let x;try{if(x=await e.Promises.lstat(B),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(T.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw V}throw j}}M.stat=X;async function G(B){try{const{stat:x,symbolicLink:j}=await M.stat(B);return x.isFile()&&j?.dangling!==!0}catch{}return!1}M.existsFile=G;async function q(B){try{const{stat:x,symbolicLink:j}=await M.stat(B);return x.isDirectory()&&j?.dangling!==!0}catch{}return!1}M.existsDirectory=q})(E=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new A.ResourceQueue;function i(M,X,G){return a.queueFor(C.URI.file(M),F.extUriBiasedIgnorePathCase).queue(()=>{const q=h(G);return new Promise((B,x)=>s(M,X,q,j=>j?x(j):B()))})}let r=!0;function s(M,X,G,q){if(!r)return d.writeFile(M,X,{mode:G.mode,flag:G.flag},q);d.open(M,G.flag,G.mode,(B,x)=>{if(B)return q(B);d.writeFile(x,X,j=>{if(j)return d.close(x,()=>q(j));d.fdatasync(x,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),r=!1),d.close(x,Z=>q(Z))))})})}function l(M,X,G){const q=h(G);if(!r)return d.writeFileSync(M,X,{mode:q.mode,flag:q.flag});const B=d.openSync(M,q.flag,q.mode);try{d.writeFileSync(B,X);try{d.fdatasyncSync(B)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),r=!1}}finally{d.closeSync(B)}}e.writeFileSync=l;function h(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function u(M,X){if(M===X)return;async function G(q){try{const B=await e.Promises.lstat(q);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(q,B.atime,new Date)}catch{}}try{await e.Promises.rename(M,X),await G(X)}catch(q){if(M.toLowerCase()!==X.toLowerCase()&&q.code==="EXDEV"||M.endsWith("."))await w(M,X,{preserveSymlinks:!1}),await _(M,f.MOVE),await G(X);else throw q}}async function w(M,X,G){return O(M,X,{root:{source:M,target:X},options:G,handledSourcePaths:new Set})}const R=511;async function O(M,X,G){if(G.handledSourcePaths.has(M))return;G.handledSourcePaths.add(M);const{stat:q,symbolicLink:B}=await E.stat(M);if(B){if(G.options.preserveSymlinks)try{return await U(M,X,G)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(B.dangling)return}return q.isDirectory()?L(M,X,q.mode&R,G):S(M,X,q.mode&R)}async function L(M,X,G,q){await e.Promises.mkdir(X,{recursive:!0,mode:G});const B=await I(M);for(const x of B)await O((0,y.join)(M,x),(0,y.join)(X,x),q)}async function S(M,X,G){await e.Promises.copyFile(M,X),await e.Promises.chmod(X,G)}async function U(M,X,G){let q=await e.Promises.readlink(M);(0,D.isEqualOrParent)(q,G.root.source,!T.isLinux)&&(q=(0,y.join)(G.root.target,q.substr(G.root.source.length+1))),await e.Promises.symlink(q,X)}e.Promises=new class{get access(){return(0,k.promisify)(d.access)}get stat(){return(0,k.promisify)(d.stat)}get lstat(){return(0,k.promisify)(d.lstat)}get utimes(){return(0,k.promisify)(d.utimes)}get read(){return(M,X,G,q,B)=>new Promise((x,j)=>{d.read(M,X,G,q,B,(V,Z,se)=>V?j(V):x({bytesRead:Z,buffer:se}))})}get readFile(){return(0,k.promisify)(d.readFile)}get write(){return(M,X,G,q,B)=>new Promise((x,j)=>{d.write(M,X,G,q,B,(V,Z,se)=>V?j(V):x({bytesWritten:Z,buffer:se}))})}get appendFile(){return(0,k.promisify)(d.appendFile)}get fdatasync(){return(0,k.promisify)(d.fdatasync)}get truncate(){return(0,k.promisify)(d.truncate)}get rename(){return(0,k.promisify)(d.rename)}get copyFile(){return(0,k.promisify)(d.copyFile)}get open(){return(0,k.promisify)(d.open)}get close(){return(0,k.promisify)(d.close)}get symlink(){return(0,k.promisify)(d.symlink)}get readlink(){return(0,k.promisify)(d.readlink)}get chmod(){return(0,k.promisify)(d.chmod)}get mkdir(){return(0,k.promisify)(d.mkdir)}get unlink(){return(0,k.promisify)(d.unlink)}get rmdir(){return(0,k.promisify)(d.rmdir)}get realpath(){return(0,k.promisify)(d.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return g}get writeFile(){return i}get rm(){return _}get move(){return u}get copy(){return w}}}),define(ve[104],be([1,0,60,9,11,8,29]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(f){if(k.isLinux)return f;const _=(0,t.dirname)(f);if(f===_)return f;const p=((0,t.basename)(f)||f).toLowerCase();try{const v=(0,D.readdirSync)(_).filter(I=>I.toLowerCase()===p);if(v.length===1){const I=P(_);if(I)return(0,t.join)(I,v[0])}else if(v.length>1){const I=v.indexOf(p);if(I>=0){const b=P(_);if(b)return(0,t.join)(b,v[I])}}}catch{}return null}e.realcaseSync=P;async function y(f){if(k.isLinux)return f;const _=(0,t.dirname)(f);if(f===_)return f;const p=((0,t.basename)(f)||f).toLowerCase();try{const v=(await D.Promises.readdir(_)).filter(I=>I.toLowerCase()===p);if(v.length===1){const I=await y(_);if(I)return(0,t.join)(I,v[0])}else if(v.length>1){const I=v.indexOf(p);if(I>=0){const b=await y(_);if(b)return(0,t.join)(b,v[I])}}}catch{}return null}e.realcase=y;async function T(f){try{return await D.Promises.realpath(f)}catch{const p=C(f);return await D.Promises.access(p,d.constants.R_OK),p}}e.realpath=T;function F(f){try{return d.realpathSync(f)}catch{const p=C(f);return d.accessSync(p,d.constants.R_OK),p}}e.realpathSync=F;function C(f){return(0,A.rtrim)((0,t.normalize)(f),t.sep)}});var Be=this&&this.__decorate||function(te,e,d,t){var k=arguments.length,A=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,d):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,d,t);else for(var P=te.length-1;P>=0;P--)(D=te[P])&&(A=(k<3?D(A):k>3?D(e,d,A):D(e,d))||A);return k>3&&A&&Object.defineProperty(e,d,A),A};define(ve[105],be([1,0,17,13,23,21,56,16,3,6,59,8,18]),function(te,e,d,t,k,A,D,P,y,T,F,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var _;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(_=e.RequestType||(e.RequestType={}));function p(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(c=e.ResponseType||(e.ResponseType={}));function v(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(I||(I={}));class b{constructor(j){this.buffer=j,this.pos=0}read(j){const V=this.buffer.slice(this.pos,this.pos+j);return this.pos+=V.byteLength,V}}class m{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(o||(o={}));function g(x){const j=k.VSBuffer.alloc(4);return j.writeUInt32BE(x,0),j}function n(x){return x.read(4).readUInt32BE(0)}function E(x){const j=k.VSBuffer.alloc(1);return j.writeUInt8(x,0),j}const a={Undefined:E(o.Undefined),String:E(o.String),Buffer:E(o.Buffer),VSBuffer:E(o.VSBuffer),Array:E(o.Array),Object:E(o.Object)},i=typeof Buffer!="undefined";function r(x,j){if(typeof j=="undefined")x.write(a.Undefined);else if(typeof j=="string"){const V=k.VSBuffer.fromString(j);x.write(a.String),x.write(g(V.byteLength)),x.write(V)}else if(i&&Buffer.isBuffer(j)){const V=k.VSBuffer.wrap(j);x.write(a.Buffer),x.write(g(V.byteLength)),x.write(V)}else if(j instanceof k.VSBuffer)x.write(a.VSBuffer),x.write(g(j.byteLength)),x.write(j);else if(Array.isArray(j)){x.write(a.Array),x.write(g(j.length));for(const V of j)r(x,V)}else{const V=k.VSBuffer.fromString(JSON.stringify(j));x.write(a.Object),x.write(g(V.byteLength)),x.write(V)}}function s(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(n(x)).toString();case o.Buffer:return x.read(n(x)).buffer;case o.VSBuffer:return x.read(n(x));case o.Array:{const V=n(x),Z=[];for(let se=0;se<V;se++)Z.push(s(x));return Z}case o.Object:return JSON.parse(x.read(n(x)).toString())}}class l{constructor(j,V,Z=null,se=1e3){this.protocol=j,this.ctx=V,this.logger=Z,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ce=>this.onRawMessage(ce)),this.sendResponse({type:200})}registerChannel(j,V){this.channels.set(j,V),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const V=this.send([j.type]);this.logger?.logOutgoing(V,0,1,v(j.type));return}case 201:case 202:case 204:case 203:{const V=this.send([j.type,j.id],j.data);this.logger?.logOutgoing(V,j.id,1,v(j.type),j.data);return}}}send(j,V=void 0){const Z=new m;return r(Z,j),r(Z,V),this.sendBuffer(Z.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const V=new b(j),Z=s(V),se=s(V),ce=Z[0];switch(ce){case 100:return this.logger?.logIncoming(j.byteLength,Z[1],1,`${p(ce)}: ${Z[2]}.${Z[3]}`,se),this.onPromise({type:ce,id:Z[1],channelName:Z[2],name:Z[3],arg:se});case 102:return this.logger?.logIncoming(j.byteLength,Z[1],1,`${p(ce)}: ${Z[2]}.${Z[3]}`,se),this.onEventListen({type:ce,id:Z[1],channelName:Z[2],name:Z[3],arg:se});case 101:return this.logger?.logIncoming(j.byteLength,Z[1],1,`${p(ce)}`),this.disposeActiveRequest({type:ce,id:Z[1]});case 103:return this.logger?.logIncoming(j.byteLength,Z[1],1,`${p(ce)}`),this.disposeActiveRequest({type:ce,id:Z[1]})}}onPromise(j){const V=this.channels.get(j.channelName);if(!V){this.collectPendingRequest(j);return}const Z=new A.CancellationTokenSource;let se;try{se=V.call(this.ctx,j.name,j.arg,Z.token)}catch(Y){se=Promise.reject(Y)}const ce=j.id;se.then(Y=>{this.sendResponse({id:ce,data:Y,type:201}),this.activeRequests.delete(j.id)},Y=>{Y instanceof Error?this.sendResponse({id:ce,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ce,data:Y,type:203}),this.activeRequests.delete(j.id)});const ee=(0,T.toDisposable)(()=>Z.cancel());this.activeRequests.set(j.id,ee)}onEventListen(j){const V=this.channels.get(j.channelName);if(!V){this.collectPendingRequest(j);return}const Z=j.id,ce=V.listen(this.ctx,j.name,j.arg)(ee=>this.sendResponse({id:Z,data:ee,type:204}));this.activeRequests.set(j.id,ce)}disposeActiveRequest(j){const V=this.activeRequests.get(j.id);V&&(V.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let V=this.pendingRequests.get(j.channelName);V||(V=[],this.pendingRequests.set(j.channelName,V));const Z=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:j,timeoutTimer:Z})}flushPendingRequests(j){const V=this.pendingRequests.get(j);if(V){for(const Z of V)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.onPromise(Z.request);break;case 102:this.onEventListen(Z.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,T.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var h;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(j,V=null){this.protocol=j,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Z=>this.onBuffer(Z)),this.logger=V}getChannel(j){const V=this;return{call(Z,se,ce){return V.isDisposed?Promise.reject(P.canceled()):V.requestPromise(j,Z,se,ce)},listen(Z,se){return V.isDisposed?Promise.reject(P.canceled()):V.requestEvent(j,Z,se)}}}requestPromise(j,V,Z,se=A.CancellationToken.None){const ce=this.lastRequestId++,Y={id:ce,type:100,channelName:j,name:V,arg:Z};if(se.isCancellationRequested)return Promise.reject(P.canceled());let ae;return new Promise((we,ke)=>{if(se.isCancellationRequested)return ke(P.canceled());const Ne=()=>{const W=N=>{switch(N.type){case 201:this.handlers.delete(ce),we(N.data);break;case 202:{this.handlers.delete(ce);const $=new Error(N.data.message);$.stack=N.data.stack,$.name=N.data.name,ke($);break}case 203:this.handlers.delete(ce),ke(N.data);break}};this.handlers.set(ce,W),this.sendRequest(Y)};let _e=null;this.state===I.Idle?Ne():(_e=(0,t.createCancelablePromise)(W=>this.whenInitialized()),_e.then(()=>{_e=null,Ne()}));const Ee=()=>{_e?(_e.cancel(),_e=null):this.sendRequest({id:ce,type:101}),ke(P.canceled())},z=se.onCancellationRequested(Ee);ae=(0,T.combinedDisposable)((0,T.toDisposable)(Ee),z),this.activeRequests.add(ae)}).finally(()=>{this.activeRequests.delete(ae)})}requestEvent(j,V,Z){const se=this.lastRequestId++,ee={id:se,type:102,channelName:j,name:V,arg:Z};let Y=null;const ae=new y.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(we=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(ae),this.sendRequest(ee)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(ae),this.sendRequest({id:se,type:103}))}}),he=we=>ae.fire(we.data);return this.handlers.set(se,he),ae.event}sendRequest(j){switch(j.type){case 100:case 102:{const V=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(V,j.id,0,`${p(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const V=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(V,j.id,0,p(j.type));return}}}send(j,V=void 0){const Z=new m;return r(Z,j),r(Z,V),this.sendBuffer(Z.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const V=new b(j),Z=s(V),se=s(V),ce=Z[0];switch(ce){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,v(ce)),this.onResponse({type:Z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,Z[1],0,v(ce),se),this.onResponse({type:Z[0],id:Z[1],data:se})}}onResponse(j){if(j.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(j.id);V&&V(j)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,T.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Be([D.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class w{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:V,onDidClientDisconnect:Z})=>{y.Event.once(V.onMessage)(ce=>{const ee=new b(ce),Y=s(ee),ae=new l(V,Y),he=new u(V);this.channels.forEach((ke,Ne)=>ae.registerChannel(Ne,ke));const we={channelServer:ae,channelClient:he,ctx:Y};this._connections.add(we),this._onDidAddConnection.fire(we),Z(()=>{ae.dispose(),he.dispose(),this._connections.delete(we),this._onDidRemoveConnection.fire(we)})})})}get connections(){const j=[];return this._connections.forEach(V=>j.push(V)),j}getChannel(j,V){const Z=this;return{call(se,ce,ee){let Y;if((0,f.isFunction)(V)){let he=(0,d.getRandomElement)(Z.connections.filter(V));Y=he?Promise.resolve(he):y.Event.toPromise(y.Event.filter(Z.onDidAddConnection,V))}else Y=V.routeCall(Z,se,ce);const ae=Y.then(he=>he.channelClient.getChannel(j));return O(ae).call(se,ce,ee)},listen(se,ce){if((0,f.isFunction)(V))return Z.getMulticastEvent(j,V,se,ce);const ee=V.routeEvent(Z,se,ce).then(Y=>Y.channelClient.getChannel(j));return O(ee).listen(se,ce)}}}getMulticastEvent(j,V,Z,se){const ce=this;let ee=new T.DisposableStore;const Y=new y.Emitter({onFirstListenerAdd:()=>{ee=new T.DisposableStore;const ae=new y.EventMultiplexer,he=new Map,we=Ne=>{const Ee=Ne.channelClient.getChannel(j).listen(Z,se),z=ae.add(Ee);he.set(Ne,z)},ke=Ne=>{const _e=he.get(Ne);!_e||(_e.dispose(),he.delete(Ne))};ce.connections.filter(V).forEach(we),y.Event.filter(ce.onDidAddConnection,V)(we,void 0,ee),ce.onDidRemoveConnection(ke,void 0,ee),ae.event(Y.fire,Y,ee),ee.add(ae)},onLastListenerRemove:()=>{ee.dispose()}});return Y.event}registerChannel(j,V){this.channels.set(j,V),this._connections.forEach(Z=>{Z.channelServer.registerChannel(j,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class R{constructor(j,V,Z=null){const se=new m;r(se,V),j.send(se.buffer),this.channelClient=new u(j,Z),this.channelServer=new l(j,V,Z)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,V){this.channelServer.registerChannel(j,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function O(x){return{call(j,V,Z){return x.then(se=>se.call(j,V,Z))},listen(j,V){const Z=new y.Relay;return x.then(se=>Z.input=se.listen(j,V)),Z.event}}}e.getDelayedChannel=O;function L(x){let j=!1;return{call(V,Z,se){return j?x.call(V,Z,se):(0,t.timeout)(0).then(()=>j=!0).then(()=>x.call(V,Z,se))},listen(V,Z){if(j)return x.listen(V,Z);const se=new y.Relay;return(0,t.timeout)(0).then(()=>j=!0).then(()=>se.input=x.listen(V,Z)),se.event}}}e.getNextTickChannel=L;class S{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const V of j.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await y.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=S;var U;(function(x){function j(ce,ee){const Y=ce,ae=ee&&ee.disableMarshalling,he=new Map;for(const we in Y)Z(we)&&he.set(we,y.Event.buffer(Y[we],!0));return new class{listen(we,ke,Ne){const _e=he.get(ke);if(_e)return _e;if(se(ke)){const Ee=Y[ke];if(typeof Ee=="function")return Ee.call(Y,Ne)}throw new Error(`Event not found: ${ke}`)}call(we,ke,Ne){const _e=Y[ke];if(typeof _e=="function"){if(!ae&&Array.isArray(Ne))for(let Ee=0;Ee<Ne.length;Ee++)Ne[Ee]=(0,F.revive)(Ne[Ee]);return _e.apply(Y,Ne)}throw new Error(`Method not found: ${ke}`)}}}x.fromService=j;function V(ce,ee){const Y=ee&&ee.disableMarshalling;return new Proxy({},{get(ae,he){if(typeof he=="string")return ee?.properties?.has(he)?ee.properties.get(he):se(he)?function(we){return ce.listen(he,we)}:Z(he)?ce.listen(he):async function(...we){let ke;ee&&!(0,f.isUndefinedOrNull)(ee.context)?ke=[ee.context,...we]:ke=we;const Ne=await ce.call(he,ke);return Y?Ne:(0,F.revive)(Ne)};throw new Error(`Property not found: ${String(he)}`)}})}x.toService=V;function Z(ce){return ce[0]==="o"&&ce[1]==="n"&&C.isUpperAsciiLetter(ce.charCodeAt(2))}function se(ce){return/^onDynamic/.test(ce)&&C.isUpperAsciiLetter(ce.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let j=x.toString();if(j!=="[object Object]")return j}return x}function G(x){return Array.isArray(x)?x.map(X):X(x)}function q(x,j,V,Z,se,ce,ee){ee=G(ee);const Y=M[se],ae=Y[Z%Y.length];let he=[`%c[${x}]%c[${String(j).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${ae}`];/\($/.test(ce)?(he=he.concat(ee),he.push(")")):he.push(ee),console.log.apply(console,he)}e.logWithColors=q;class B{constructor(j,V){this._outgoingPrefix=j,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,V,Z,se,ce){this._totalOutgoing+=j,q(this._outgoingPrefix,this._totalOutgoing,j,V,Z,se,ce)}logIncoming(j,V,Z,se,ce){this._totalIncoming+=j,q(this._incomingPrefix,this._totalIncoming,j,V,Z,se,ce)}}e.IPCLogger=B}),define(ve[106],be([1,0,23,3,6,105]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let s=0;function l(u,w){if(!r.has(u)){const R=String(++s);r.set(u,R)}return r.get(u)}function h(u,w,R,O){if(!i.enableDiagnostics)return;const L=l(u,w);if(O instanceof d.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const S=d.VSBuffer.alloc(O.byteLength);S.set(O),i.records.push({timestamp:Date.now(),id:L,label:w,type:R,buff:S})}else i.records.push({timestamp:Date.now(),id:L,label:w,type:R,data:O})}i.traceSocketEvent=h})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function F(){return T||(T=d.VSBuffer.alloc(0)),T}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,s){if(r===0)return F();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const w=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=r),w}if(this._chunks[0].byteLength>r){const w=this._chunks[0].slice(0,r);return s&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),w}let l=d.VSBuffer.alloc(r),h=0,u=0;for(;r>0;){const w=this._chunks[u];if(w.byteLength>r){const R=w.slice(0,r);l.set(R,h),h+=r,s&&(this._chunks[u]=w.slice(r),this._totalLength-=r),r-=r}else l.set(w,h),h+=w.byteLength,s?(this._chunks.shift(),this._totalLength-=w.byteLength):u++,r-=w.byteLength}return l}}e.ChunkStream=C;var f;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(f||(f={}));function _(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var p;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(r,s,l,h){this.type=r,this.id=s,this.ack=l,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends k.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:_(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,h=this._state.id,u=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new c(l,h,u,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class I{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=d.VSBuffer.alloc(13);s.writeUInt8(r.type,0),s.writeUInt32BE(r.id,1),s.writeUInt32BE(r.ack,5),s.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:_(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(s,r.data)}_bufferAdd(r,s){const l=this._totalLength===0;return this._data.push(r,s),this._totalLength+=r.byteLength+s.byteLength,l}_bufferTake(){const r=d.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,s){this._bufferAdd(r,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class b extends k.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new I(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new c(1,0,0,r))}}e.Protocol=b;class m extends A.IPCClient{constructor(r,s,l=null){super(r,s,l);this.protocol=r}static fromSocket(r,s){return new m(new b(r),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=m;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class g{constructor(r){this.data=r,this.next=null}}class n{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],s=0,l=this._first;for(;l;)r[s++]=l.data,l=l.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const s=new g(r);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class E{constructor(){this.lastRuns=[];const r=Date.now();for(let s=0;s<E._HISTORY_LENGTH;s++)this.lastRuns[s]=r-1e3*s;setInterval(()=>{for(let s=E._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return E._INSTANCE||(E._INSTANCE=new E),E._INSTANCE}load(){const r=Date.now(),s=(1+E._HISTORY_LENGTH)*1e3;let l=0;for(let h=0;h<E._HISTORY_LENGTH;h++)r-this.lastRuns[h]<=s&&l++;return 1-l/E._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}E._HISTORY_LENGTH=10,E._INSTANCE=null;class a{constructor(r,s=null,l=E.getInstance()){this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new c(5,0,0,F());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new c(7,0,0,F());this._socketWriter.write(r)}sendResume(){const r=new c(8,0,0,F());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,s){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new c(3,0,this._incomingAckId,F());this._socketWriter.write(r);const s=this._outgoingUnackMsg.toArray();for(let l=0,h=s.length;l<h;l++)this._socketWriter.write(s[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new c(6,0,0,F())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let l=0,h=s.length;l<h;l++)this._socketWriter.write(s[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new c(1,s,this._incomingAckId,r);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(r){const s=new c(2,0,0,r);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),s=Date.now()-r.writtenTime,l=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&l>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const u=Math.max(2e4-s,2e4-l,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},u)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new c(3,0,this._incomingAckId,F());this._socketWriter.write(r)}}e.PersistentProtocol=a}),define(ve[107],be([1,0,98]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(P){const y=(0,d.toUint8)(P);this._defaultValue=y,this._asciiMap=t._createAsciiMap(y),this._map=new Map}static _createAsciiMap(P){const y=new Uint8Array(256);for(let T=0;T<256;T++)y[T]=P;return y}set(P,y){const T=(0,d.toUint8)(y);P>=0&&P<256?this._asciiMap[P]=T:this._map.set(P,T)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=t;var k;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(k||(k={}));class A{constructor(){this._actual=new t(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=A}),define(ve[48],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class d{constructor(k,A){this.lineNumber=k,this.column=A}with(k=this.lineNumber,A=this.column){return k===this.lineNumber&&A===this.column?this:new d(k,A)}delta(k=0,A=0){return this.with(this.lineNumber+k,this.column+A)}equals(k){return d.equals(this,k)}static equals(k,A){return!k&&!A?!0:!!k&&!!A&&k.lineNumber===A.lineNumber&&k.column===A.column}isBefore(k){return d.isBefore(this,k)}static isBefore(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<A.column}isBeforeOrEqual(k){return d.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<=A.column}static compare(k,A){const D=k.lineNumber|0,P=A.lineNumber|0;if(D===P){const y=k.column|0,T=A.column|0;return y-T}return D-P}clone(){return new d(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new d(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=d}),define(ve[41],be([1,0,48]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(A,D,P,y){A>P||A===P&&D>y?(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=A,this.endColumn=D):(this.startLineNumber=A,this.startColumn=D,this.endLineNumber=P,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return t.containsPosition(this,A)}static containsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<A.startColumn||D.lineNumber===A.endLineNumber&&D.column>A.endColumn)}static strictContainsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<=A.startColumn||D.lineNumber===A.endLineNumber&&D.column>=A.endColumn)}containsRange(A){return t.containsRange(this,A)}static containsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>A.endColumn)}strictContainsRange(A){return t.strictContainsRange(this,A)}static strictContainsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<=A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>=A.endColumn)}plusRange(A){return t.plusRange(this,A)}static plusRange(A,D){let P,y,T,F;return D.startLineNumber<A.startLineNumber?(P=D.startLineNumber,y=D.startColumn):D.startLineNumber===A.startLineNumber?(P=D.startLineNumber,y=Math.min(D.startColumn,A.startColumn)):(P=A.startLineNumber,y=A.startColumn),D.endLineNumber>A.endLineNumber?(T=D.endLineNumber,F=D.endColumn):D.endLineNumber===A.endLineNumber?(T=D.endLineNumber,F=Math.max(D.endColumn,A.endColumn)):(T=A.endLineNumber,F=A.endColumn),new t(P,y,T,F)}intersectRanges(A){return t.intersectRanges(this,A)}static intersectRanges(A,D){let P=A.startLineNumber,y=A.startColumn,T=A.endLineNumber,F=A.endColumn,C=D.startLineNumber,f=D.startColumn,_=D.endLineNumber,p=D.endColumn;return P<C?(P=C,y=f):P===C&&(y=Math.max(y,f)),T>_?(T=_,F=p):T===_&&(F=Math.min(F,p)),P>T||P===T&&y>F?null:new t(P,y,T,F)}equalsRange(A){return t.equalsRange(this,A)}static equalsRange(A,D){return!!A&&!!D&&A.startLineNumber===D.startLineNumber&&A.startColumn===D.startColumn&&A.endLineNumber===D.endLineNumber&&A.endColumn===D.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(A){return new d.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(A){return new d.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,D){return new t(this.startLineNumber,this.startColumn,A,D)}setStartPosition(A,D){return new t(A,D,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(A){return new t(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,D=A){return new t(A.lineNumber,A.column,D.lineNumber,D.column)}static lift(A){return A?new t(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn)}static areIntersecting(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,D){if(A&&D){const T=A.startLineNumber|0,F=D.startLineNumber|0;if(T===F){const C=A.startColumn|0,f=D.startColumn|0;if(C===f){const _=A.endLineNumber|0,p=D.endLineNumber|0;if(_===p){const c=A.endColumn|0,v=D.endColumn|0;return c-v}return _-p}return C-f}return T-F}return(A?1:0)-(D?1:0)}static compareRangesUsingEnds(A,D){return A.endLineNumber===D.endLineNumber?A.endColumn===D.endColumn?A.startLineNumber===D.startLineNumber?A.startColumn-D.startColumn:A.startLineNumber-D.startLineNumber:A.endColumn-D.endColumn:A.endLineNumber-D.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=t}),define(ve[148],be([1,0,48,41]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class A extends t.Range{constructor(P,y,T,F){super(P,y,T,F);this.selectionStartLineNumber=P,this.selectionStartColumn=y,this.positionLineNumber=T,this.positionColumn=F}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return A.selectionsEqual(this,P)}static selectionsEqual(P,y){return P.selectionStartLineNumber===y.selectionStartLineNumber&&P.selectionStartColumn===y.selectionStartColumn&&P.positionLineNumber===y.positionLineNumber&&P.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,y){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,P,y):new A(P,y,this.startLineNumber,this.startColumn)}getPosition(){return new d.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new d.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,y){return this.getDirection()===0?new A(P,y,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,P,y)}static fromPositions(P,y=P){return new A(P.lineNumber,P.column,y.lineNumber,y.column)}static fromRange(P,y){return y===0?new A(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new A(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new A(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,y){if(P&&!y||!P&&y)return!1;if(!P&&!y)return!0;if(P.length!==y.length)return!1;for(let T=0,F=P.length;T<F;T++)if(!this.selectionsEqual(P[T],y[T]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,y,T,F,C){return C===0?new A(P,y,T,F):new A(T,F,P,y)}}e.Selection=A}),define(ve[149],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(ve[150],be([1,0,107]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends d.CharacterClassifier{constructor(P){super(0);for(let y=0,T=P.length;y<T;y++)this.set(P.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function A(D){const P={};return y=>(P.hasOwnProperty(y)||(P[y]=D(y)),P[y])}e.getMapForWordSeparators=A(D=>new k(D))}),define(ve[108],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function d(P=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)P.indexOf(T)>=0||(y+="\\"+T);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=d();function t(P){let y=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)y=P;else{let T="g";P.ignoreCase&&(T+="i"),P.multiline&&(T+="m"),P.unicode&&(T+="u"),y=new RegExp(P.source,T)}return y.lastIndex=0,y}e.ensureValidWordDefinition=t;const k={maxLen:1e3,windowSize:15,timeBudget:150};function A(P,y,T,F,C=k){if(T.length>C.maxLen){let v=P-C.maxLen/2;return v<0?v=0:F+=v,T=T.substring(v,P+C.maxLen/2),A(P,y,T,F,C)}const f=Date.now(),_=P-1-F;let p=-1,c=null;for(let v=1;!(Date.now()-f>=C.timeBudget);v++){const I=_-C.windowSize*v;y.lastIndex=Math.max(0,I);const b=D(y,T,_,p);if(!b&&c||(c=b,I<=0))break;p=I}if(c){const v={word:c[0],startColumn:F+1+c.index,endColumn:F+1+c.index+c[0].length};return y.lastIndex=0,v}return null}e.getWordAtText=A;function D(P,y,T,F){let C;for(;C=P.exec(y);){const f=C.index||0;if(f<=T&&P.lastIndex>=T)return C;if(F>0&&f>F)return null}return null}}),define(ve[109],be([1,0,32,9]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(A,D,P,y){if(Array.isArray(A)){let T=0;for(const F of A){const C=k(F,D,P,y);if(C===10)return C;C>T&&(T=C)}return T}else{if(typeof A=="string")return y?A==="*"?5:A===P?10:0:0;if(A){const{language:T,pattern:F,scheme:C,hasAccessToAllModels:f}=A;if(!y&&!f)return 0;let _=0;if(C)if(C===D.scheme)_=10;else if(C==="*")_=5;else return 0;if(T)if(T===P)_=10;else if(T==="*")_=Math.max(_,5);else return 0;if(F){let p;if(typeof F=="string"?p=F:p={...F,base:(0,t.normalize)(F.base)},p===D.fsPath||(0,d.match)(p,D.fsPath))_=10;else return 0}return _}else return 0}}e.score=k}),define(ve[151],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class t{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let y=0,T=P.notIn.length;y<T;y++)switch(P.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,y){if(P.getTokenCount()===0)return!0;const T=P.findTokenIndexAtOffset(y-2),F=P.getStandardTokenType(T);return this.isOK(F)}_findNeutralCharacterInRange(P,y){for(let T=P;T<=y;T++){const F=String.fromCharCode(T);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class k{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of P)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=k;function A(D,P,y){D.has(P)?D.get(P).push(y):D.set(P,[y])}}),define(ve[152],be([1,0,107]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(_){_[_.Invalid=0]="Invalid",_[_.Start=1]="Start",_[_.H=2]="H",_[_.HT=3]="HT",_[_.HTT=4]="HTT",_[_.HTTP=5]="HTTP",_[_.F=6]="F",_[_.FI=7]="FI",_[_.FIL=8]="FIL",_[_.BeforeColon=9]="BeforeColon",_[_.AfterColon=10]="AfterColon",_[_.AlmostThere=11]="AlmostThere",_[_.End=12]="End",_[_.Accept=13]="Accept",_[_.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class k{constructor(p,c,v){const I=new Uint8Array(p*c);for(let b=0,m=p*c;b<m;b++)I[b]=v;this._data=I,this.rows=p,this.cols=c}get(p,c){return this._data[p*this.cols+c]}set(p,c,v){this._data[p*this.cols+c]=v}}e.Uint8Matrix=k;class A{constructor(p){let c=0,v=0;for(let b=0,m=p.length;b<m;b++){const[o,g,n]=p[b];g>c&&(c=g),o>v&&(v=o),n>v&&(v=n)}c++,v++;const I=new k(v,c,0);for(let b=0,m=p.length;b<m;b++){const[o,g,n]=p[b];I.set(o,g,n)}this._states=I,this._maxCharCode=c}nextState(p,c){return c<0||c>=this._maxCharCode?0:this._states.get(p,c)}}e.StateMachine=A;let D=null;function P(){return D===null&&(D=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var y;(function(_){_[_.None=0]="None",_[_.ForceTermination=1]="ForceTermination",_[_.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let T=null;function F(){if(T===null){T=new d.CharacterClassifier(0);const _=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<_.length;c++)T.set(_.charCodeAt(c),1);const p=".,;";for(let c=0;c<p.length;c++)T.set(p.charCodeAt(c),2)}return T}class C{static _createLink(p,c,v,I,b){let m=b-1;do{const o=c.charCodeAt(m);if(p.get(o)!==2)break;m--}while(m>I);if(I>0){const o=c.charCodeAt(I-1),g=c.charCodeAt(m);(o===40&&g===41||o===91&&g===93||o===123&&g===125)&&m--}return{range:{startLineNumber:v,startColumn:I+1,endLineNumber:v,endColumn:m+2},url:c.substring(I,m+1)}}static computeLinks(p,c=P()){const v=F(),I=[];for(let b=1,m=p.getLineCount();b<=m;b++){const o=p.getLineContent(b),g=o.length;let n=0,E=0,a=0,i=1,r=!1,s=!1,l=!1,h=!1;for(;n<g;){let u=!1;const w=o.charCodeAt(n);if(i===13){let R;switch(w){case 40:r=!0,R=0;break;case 41:R=r?0:1;break;case 91:l=!0,s=!0,R=0;break;case 93:l=!1,R=s?0:1;break;case 123:h=!0,R=0;break;case 125:R=h?0:1;break;case 39:R=a===34||a===96?0:1;break;case 34:R=a===39||a===96?0:1;break;case 96:R=a===39||a===34?0:1;break;case 42:R=a===42?1:0;break;case 124:R=a===124?1:0;break;case 32:R=l?0:1;break;default:R=v.get(w)}R===1&&(I.push(C._createLink(v,o,b,E,n)),u=!0)}else if(i===12){let R;w===91?(s=!0,R=0):R=v.get(w),R===1?u=!0:i=13}else i=c.nextState(i,w),i===0&&(u=!0);u&&(i=1,r=!1,s=!1,h=!1,E=n+1,a=w),n++}i===13&&I.push(C._createLink(v,o,b,E,g))}return I}}e.LinkComputer=C;function f(_){return!_||typeof _.getLineCount!="function"||typeof _.getLineContent!="function"?[]:C.computeLinks(_)}e.computeLinks=f}),define(ve[110],be([1,0,25]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class T{constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),this.indentSize=m.tabSize|0,this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace),this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}e.TextModelResolvedOptions=T;class F{constructor(m,o){this._findMatchBrand=void 0,this.range=m,this.matches=o}}e.FindMatch=F;var C;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var f;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var _;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(_=e.ModelConstants||(e.ModelConstants={}));class p{constructor(m,o,g,n,E,a){this.identifier=m,this.range=o,this.text=g,this.forceMoveMarkers=n,this.isAutoWhitespaceEdit=E,this._isTracked=a}}e.ValidAnnotatedEditOperation=p;class c{constructor(m,o,g){this.regex=m,this.wordSeparators=o,this.simpleSearch=g}}e.SearchData=c;class v{constructor(m,o,g){this.reverseEdits=m,this.changes=o,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=v;function I(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(ve[111],be([1,0,17,98]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,T){y=(0,t.toUint32)(y);const F=this.values,C=this.prefixSum,f=T.length;return f===0?!1:(this.values=new Uint32Array(F.length+f),this.values.set(F.subarray(0,y),0),this.values.set(F.subarray(y),y+f),this.values.set(T,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(y,T){return y=(0,t.toUint32)(y),T=(0,t.toUint32)(T),this.values[y]===T?!1:(this.values[y]=T,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,T){y=(0,t.toUint32)(y),T=(0,t.toUint32)(T);const F=this.values,C=this.prefixSum;if(y>=F.length)return!1;const f=F.length-y;return T>=f&&(T=f),T===0?!1:(this.values=new Uint32Array(F.length-T),this.values.set(F.subarray(0,y),0),this.values.set(F.subarray(y+T),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(y){return y<0?0:(y=(0,t.toUint32)(y),this._getPrefixSum(y))}_getPrefixSum(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let T=this.prefixSumValidIndex[0]+1;T===0&&(this.prefixSum[0]=this.values[0],T++),y>=this.values.length&&(y=this.values.length-1);for(let F=T;F<=y;F++)this.prefixSum[F]=this.prefixSum[F-1]+this.values[F];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let T=0,F=this.values.length-1,C=0,f=0,_=0;for(;T<=F;)if(C=T+(F-T)/2|0,f=this.prefixSum[C],_=f-this.values[C],y<_)F=C-1;else if(y>=f)T=C+1;else break;return new D(C,y-_)}}e.PrefixSumComputer=k;class A{constructor(y){this._values=y,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(y){return this._ensureValid(),y===0?0:this._prefixSum[y-1]}getIndexOf(y){this._ensureValid();const T=this._indexBySum[y],F=T>0?this._prefixSum[T-1]:0;return new D(T,y-F)}removeValues(y,T){this._values.splice(y,T),this._invalidate(y)}insertValues(y,T){this._values=(0,d.arrayInsert)(this._values,y,T),this._invalidate(y)}_invalidate(y){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,y-1)}_ensureValid(){if(!this._isValid){for(let y=this._validEndIndex+1,T=this._values.length;y<T;y++){const F=this._values[y],C=y>0?this._prefixSum[y-1]:0;this._prefixSum[y]=C+F;for(let f=0;f<F;f++)this._indexBySum[C+f]=y}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(y,T){this._values[y]!==T&&(this._values[y]=T,this._invalidate(y))}}e.ConstantTimePrefixSumComputer=A;class D{constructor(y,T){this.index=y,this.remainder=T,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=T}}e.PrefixSumIndexOfResult=D}),define(ve[153],be([1,0,8,48,111]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(P,y,T,F){this._uri=P,this._lines=y,this._eol=T,this._versionId=F,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const y=P.changes;for(const T of y)this._acceptDeleteRange(T.range),this._acceptInsertText(new t.Position(T.range.startLineNumber,T.range.startColumn),T.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,y=this._lines.length,T=new Uint32Array(y);for(let F=0;F<y;F++)T[F]=this._lines[F].length+P;this._lineStarts=new k.PrefixSumComputer(T)}}_setLineText(P,y){this._lines[P]=y,this._lineStarts&&this._lineStarts.setValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,y){if(y.length===0)return;const T=(0,d.splitLines)(y);if(T.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+T[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}T[T.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+T[0]);const F=new Uint32Array(T.length-1);for(let C=1;C<T.length;C++)this._lines.splice(P.lineNumber+C-1,0,T[C]),F[C-1]=T[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,F)}}e.MirrorTextModel=A}),define(ve[154],be([1,0,8,150,48,41,110]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class y{constructor(b,m,o,g){this.searchString=b,this.isRegex=m,this.matchCase=o,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=T(this.searchString):b=this.searchString.indexOf(`
`)>=0;let m=null;try{m=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!m)return null;let o=!this.isRegex&&!b;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new D.SearchData(m,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,o?this.searchString:null)}}e.SearchParams=y;function T(I){if(!I||I.length===0)return!1;for(let b=0,m=I.length;b<m;b++)if(I.charCodeAt(b)===92){if(b++,b>=m)break;const g=I.charCodeAt(b);if(g===110||g===114||g===87)return!0}return!1}e.isMultilineRegexSource=T;function F(I,b,m){if(!m)return new D.FindMatch(I,null);const o=[];for(let g=0,n=b.length;g<n;g++)o[g]=b[g];return new D.FindMatch(I,o)}e.createFindMatch=F;class C{constructor(b){const m=[];let o=0;for(let g=0,n=b.length;g<n;g++)b.charCodeAt(g)===10&&(m[o++]=g);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(b){const m=this._lineFeedsOffsets;let o=0,g=m.length-1;if(g===-1||b<=m[0])return 0;for(;o<g;){const n=o+((g-o)/2>>0);m[n]>=b?g=n-1:m[n+1]>=b?(o=n,g=n):o=n+1}return o+1}}class f{static findMatches(b,m,o,g,n){const E=m.parseSearchRequest();return E?E.regex.multiline?this._doFindMatchesMultiline(b,o,new v(E.wordSeparators,E.regex),g,n):this._doFindMatchesLineByLine(b,o,E,g,n):[]}static _getMultilineMatchRange(b,m,o,g,n,E){let a,i=0;g?(i=g.findLineFeedCountBeforeOffset(n),a=m+n+i):a=m+n;let r;if(g){const u=g.findLineFeedCountBeforeOffset(n+E.length)-i;r=a+E.length+u}else r=a+E.length;const s=b.getPositionAt(a),l=b.getPositionAt(r);return new A.Range(s.lineNumber,s.column,l.lineNumber,l.column)}static _doFindMatchesMultiline(b,m,o,g,n){const E=b.getOffsetAt(m.getStartPosition()),a=b.getValueInRange(m,1),i=b.getEOL()===`\r
`?new C(a):null,r=[];let s=0,l;for(o.reset(0);l=o.next(a);)if(r[s++]=F(this._getMultilineMatchRange(b,E,a,i,l.index,l[0]),l,g),s>=n)return r;return r}static _doFindMatchesLineByLine(b,m,o,g,n){const E=[];let a=0;if(m.startLineNumber===m.endLineNumber){const r=b.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return a=this._findMatchesInLine(o,r,m.startLineNumber,m.startColumn-1,a,E,g,n),E}const i=b.getLineContent(m.startLineNumber).substring(m.startColumn-1);a=this._findMatchesInLine(o,i,m.startLineNumber,m.startColumn-1,a,E,g,n);for(let r=m.startLineNumber+1;r<m.endLineNumber&&a<n;r++)a=this._findMatchesInLine(o,b.getLineContent(r),r,0,a,E,g,n);if(a<n){const r=b.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);a=this._findMatchesInLine(o,r,m.endLineNumber,0,a,E,g,n)}return E}static _findMatchesInLine(b,m,o,g,n,E,a,i){const r=b.wordSeparators;if(!a&&b.simpleSearch){const h=b.simpleSearch,u=h.length,w=m.length;let R=-u;for(;(R=m.indexOf(h,R+u))!==-1;)if((!r||c(r,m,w,R,u))&&(E[n++]=new D.FindMatch(new A.Range(o,R+1+g,o,R+1+u+g),null),n>=i))return n;return n}const s=new v(b.wordSeparators,b.regex);let l;s.reset(0);do if(l=s.next(m),l&&(E[n++]=F(new A.Range(o,l.index+1+g,o,l.index+1+l[0].length+g),l,a),n>=i))return n;while(l);return n}static findNextMatch(b,m,o,g){const n=m.parseSearchRequest();if(!n)return null;const E=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(b,o,E,g):this._doFindNextMatchLineByLine(b,o,E,g)}static _doFindNextMatchMultiline(b,m,o,g){const n=new k.Position(m.lineNumber,1),E=b.getOffsetAt(n),a=b.getLineCount(),i=b.getValueInRange(new A.Range(n.lineNumber,n.column,a,b.getLineMaxColumn(a)),1),r=b.getEOL()===`\r
`?new C(i):null;o.reset(m.column-1);let s=o.next(i);return s?F(this._getMultilineMatchRange(b,E,i,r,s.index,s[0]),s,g):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(b,new k.Position(1,1),o,g):null}static _doFindNextMatchLineByLine(b,m,o,g){const n=b.getLineCount(),E=m.lineNumber,a=b.getLineContent(E),i=this._findFirstMatchInLine(o,a,E,m.column,g);if(i)return i;for(let r=1;r<=n;r++){const s=(E+r-1)%n,l=b.getLineContent(s+1),h=this._findFirstMatchInLine(o,l,s+1,1,g);if(h)return h}return null}static _findFirstMatchInLine(b,m,o,g,n){b.reset(g-1);const E=b.next(m);return E?F(new A.Range(o,E.index+1,o,E.index+1+E[0].length),E,n):null}static findPreviousMatch(b,m,o,g){const n=m.parseSearchRequest();if(!n)return null;const E=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(b,o,E,g):this._doFindPreviousMatchLineByLine(b,o,E,g)}static _doFindPreviousMatchMultiline(b,m,o,g){const n=this._doFindMatchesMultiline(b,new A.Range(1,1,m.lineNumber,m.column),o,g,10*P);if(n.length>0)return n[n.length-1];const E=b.getLineCount();return m.lineNumber!==E||m.column!==b.getLineMaxColumn(E)?this._doFindPreviousMatchMultiline(b,new k.Position(E,b.getLineMaxColumn(E)),o,g):null}static _doFindPreviousMatchLineByLine(b,m,o,g){const n=b.getLineCount(),E=m.lineNumber,a=b.getLineContent(E).substring(0,m.column-1),i=this._findLastMatchInLine(o,a,E,g);if(i)return i;for(let r=1;r<=n;r++){const s=(n+E-r-1)%n,l=b.getLineContent(s+1),h=this._findLastMatchInLine(o,l,s+1,g);if(h)return h}return null}static _findLastMatchInLine(b,m,o,g){let n=null,E;for(b.reset(0);E=b.next(m);)n=F(new A.Range(o,E.index+1,o,E.index+1+E[0].length),E,g);return n}}e.TextModelSearch=f;function _(I,b,m,o,g){if(o===0)return!0;const n=b.charCodeAt(o-1);if(I.get(n)!==0||n===13||n===10)return!0;if(g>0){const E=b.charCodeAt(o);if(I.get(E)!==0)return!0}return!1}function p(I,b,m,o,g){if(o+g===m)return!0;const n=b.charCodeAt(o+g);if(I.get(n)!==0||n===13||n===10)return!0;if(g>0){const E=b.charCodeAt(o+g-1);if(I.get(E)!==0)return!0}return!1}function c(I,b,m,o,g){return _(I,b,m,o,g)&&p(I,b,m,o,g)}e.isValidMatch=c;class v{constructor(b,m){this._wordSeparators=b,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const m=b.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(o=this._searchRegex.exec(b),!o))return null;const g=o.index,n=o[0].length;if(g===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){d.getNextCodePoint(b,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=g,this._prevMatchLength=n,!this._wordSeparators||c(this._wordSeparators,b,m,g,n))return o}while(o);return null}}e.Searcher=v}),define(ve[112],be([1,0,23,11]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(k||(k={}));function A(C){for(let f=0,_=C.length;f<_;f+=4){const p=C[f+0],c=C[f+1],v=C[f+2],I=C[f+3];C[f+0]=I,C[f+1]=v,C[f+2]=c,C[f+3]=p}}function D(C){const f=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return t.isLittleEndian()||A(f),d.VSBuffer.wrap(f)}function P(C){const f=C.buffer;if(t.isLittleEndian()||A(f),f.byteOffset%4==0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const _=new Uint8Array(f.byteLength);return _.set(f),new Uint32Array(_.buffer,_.byteOffset,_.length/4)}}function y(C){const f=new Uint32Array(T(C));let _=0;if(f[_++]=C.id,C.type==="full")f[_++]=1,f[_++]=C.data.length,f.set(C.data,_),_+=C.data.length;else{f[_++]=2,f[_++]=C.deltas.length;for(const p of C.deltas)f[_++]=p.start,f[_++]=p.deleteCount,p.data?(f[_++]=p.data.length,f.set(p.data,_),_+=p.data.length):f[_++]=0}return D(f)}e.encodeSemanticTokensDto=y;function T(C){let f=0;if(f+=1+1,C.type==="full")f+=1+C.data.length;else{f+=1,f+=(1+1+1)*C.deltas.length;for(const _ of C.deltas)_.data&&(f+=_.data.length)}return f}function F(C){const f=P(C);let _=0;const p=f[_++];if(f[_++]===1){const b=f[_++],m=f.subarray(_,_+b);return _+=b,{id:p,type:"full",data:m}}const v=f[_++],I=[];for(let b=0;b<v;b++){const m=f[_++],o=f[_++],g=f[_++];let n;g>0&&(n=f.subarray(_,_+g),_+=g),I[b]={start:m,deleteCount:o,data:n}}return{id:p,type:"delta",deltas:I}}e.decodeSemanticTokensDto=F}),define(ve[155],be([1,0,3,6]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,y){return this._map.set(P,y),this.fire([P]),(0,t.toDisposable)(()=>{this._map.get(P)===y&&(this._map.delete(P),this.fire([P]))})}registerFactory(P,y){this._factories.get(P)?.dispose();const T=new A(this,P,y);return this._factories.set(P,T),(0,t.toDisposable)(()=>{const F=this._factories.get(P);!F||F!==T||(this._factories.delete(P),F.dispose())})}async getOrCreate(P){const y=this.get(P);if(y)return y;const T=this._factories.get(P);return!T||T.isResolved?null:(await T.resolve(),this.get(P))}get(P){return this._map.get(P)||null}isResolved(P){if(this.get(P))return!0;const T=this._factories.get(P);return!!(!T||T.isResolved)}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=k;class A extends t.Disposable{constructor(P,y,T){super();this._registry=P,this._languageId=y,this._factory=T,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const P=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,P&&!this._isDisposed&&this._register(this._registry.register(this._languageId,P))}}}),define(ve[81],be([1,0,2,41,155,73]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var D;(function(L){L[L.Null=0]="Null",L[L.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));var P;(function(L){L[L.NotSet=-1]="NotSet",L[L.None=0]="None",L[L.Italic=1]="Italic",L[L.Bold=2]="Bold",L[L.Underline=4]="Underline",L[L.Strikethrough=8]="Strikethrough"})(P=e.FontStyle||(e.FontStyle={}));var y;(function(L){L[L.None=0]="None",L[L.DefaultForeground=1]="DefaultForeground",L[L.DefaultBackground=2]="DefaultBackground"})(y=e.ColorId||(e.ColorId={}));var T;(function(L){L[L.Other=0]="Other",L[L.Comment=1]="Comment",L[L.String=2]="String",L[L.RegEx=3]="RegEx"})(T=e.StandardTokenType||(e.StandardTokenType={}));var F;(function(L){L[L.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",L[L.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",L[L.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",L[L.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",L[L.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",L[L.ITALIC_MASK=1024]="ITALIC_MASK",L[L.BOLD_MASK=2048]="BOLD_MASK",L[L.UNDERLINE_MASK=4096]="UNDERLINE_MASK",L[L.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",L[L.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",L[L.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",L[L.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",L[L.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",L[L.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",L[L.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",L[L.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",L[L.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",L[L.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",L[L.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",L[L.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(F=e.MetadataConsts||(e.MetadataConsts={}));class C{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&768)>>>8}static getFontStyle(S){return(S&15360)>>>10}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){const U=this.getForeground(S);let M="mtk"+U;const X=this.getFontStyle(S);return X&1&&(M+=" mtki"),X&2&&(M+=" mtkb"),X&4&&(M+=" mtku"),X&8&&(M+=" mtks"),M}static getInlineStyleFromMetadata(S,U){const M=this.getForeground(S),X=this.getFontStyle(S);let G=`color: ${U[M]};`;X&1&&(G+="font-style: italic;"),X&2&&(G+="font-weight: bold;");let q="";return X&4&&(q+=" underline"),X&8&&(q+=" line-through"),q&&(G+=`text-decoration:${q};`),G}static getPresentationFromMetadata(S){const U=this.getForeground(S),M=this.getFontStyle(S);return{foreground:U,italic:Boolean(M&1),bold:Boolean(M&2),underline:Boolean(M&4),strikethrough:Boolean(M&8)}}}e.TokenMetadata=C;class f{constructor(S,U,M){this._tokenBrand=void 0,this.offset=S,this.type=U,this.language=M}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=f;class _{constructor(S,U){this._tokenizationResultBrand=void 0,this.tokens=S,this.endState=U}}e.TokenizationResult=_;class p{constructor(S,U){this._encodedTokenizationResultBrand=void 0,this.tokens=S,this.endState=U}}e.EncodedTokenizationResult=p;var c;(function(L){L[L.Method=0]="Method",L[L.Function=1]="Function",L[L.Constructor=2]="Constructor",L[L.Field=3]="Field",L[L.Variable=4]="Variable",L[L.Class=5]="Class",L[L.Struct=6]="Struct",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Event=10]="Event",L[L.Operator=11]="Operator",L[L.Unit=12]="Unit",L[L.Value=13]="Value",L[L.Constant=14]="Constant",L[L.Enum=15]="Enum",L[L.EnumMember=16]="EnumMember",L[L.Keyword=17]="Keyword",L[L.Text=18]="Text",L[L.Color=19]="Color",L[L.File=20]="File",L[L.Reference=21]="Reference",L[L.Customcolor=22]="Customcolor",L[L.Folder=23]="Folder",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue",L[L.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={}));var v;(function(L){const S=new Map;S.set(0,A.Codicon.symbolMethod),S.set(1,A.Codicon.symbolFunction),S.set(2,A.Codicon.symbolConstructor),S.set(3,A.Codicon.symbolField),S.set(4,A.Codicon.symbolVariable),S.set(5,A.Codicon.symbolClass),S.set(6,A.Codicon.symbolStruct),S.set(7,A.Codicon.symbolInterface),S.set(8,A.Codicon.symbolModule),S.set(9,A.Codicon.symbolProperty),S.set(10,A.Codicon.symbolEvent),S.set(11,A.Codicon.symbolOperator),S.set(12,A.Codicon.symbolUnit),S.set(13,A.Codicon.symbolValue),S.set(15,A.Codicon.symbolEnum),S.set(14,A.Codicon.symbolConstant),S.set(15,A.Codicon.symbolEnum),S.set(16,A.Codicon.symbolEnumMember),S.set(17,A.Codicon.symbolKeyword),S.set(27,A.Codicon.symbolSnippet),S.set(18,A.Codicon.symbolText),S.set(19,A.Codicon.symbolColor),S.set(20,A.Codicon.symbolFile),S.set(21,A.Codicon.symbolReference),S.set(22,A.Codicon.symbolCustomColor),S.set(23,A.Codicon.symbolFolder),S.set(24,A.Codicon.symbolTypeParameter),S.set(25,A.Codicon.account),S.set(26,A.Codicon.issues);function U(G){let q=S.get(G);return q||(console.info("No codicon found for CompletionItemKind "+G),q=A.Codicon.symbolProperty),q}L.toIcon=U;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function X(G,q){let B=M.get(G);return typeof B=="undefined"&&!q&&(B=9),B}L.fromString=X})(v=e.CompletionItemKinds||(e.CompletionItemKinds={}));var I;(function(L){L[L.Deprecated=1]="Deprecated"})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(L){L[L.KeepWhitespace=1]="KeepWhitespace",L[L.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var o;(function(L){L[L.Automatic=0]="Automatic",L[L.Explicit=1]="Explicit"})(o=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var g;(function(L){L[L.Invoke=1]="Invoke",L[L.Auto=2]="Auto"})(g=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var n;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(n=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var E;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(E=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(L){return L&&d.URI.isUri(L.uri)&&t.Range.isIRange(L.range)&&(t.Range.isIRange(L.originSelectionRange)||t.Range.isIRange(L.targetSelectionRange))}e.isLocationLink=a;var i;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var r;(function(L){L[L.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(L){const S=new Map;S.set(0,A.Codicon.symbolFile),S.set(1,A.Codicon.symbolModule),S.set(2,A.Codicon.symbolNamespace),S.set(3,A.Codicon.symbolPackage),S.set(4,A.Codicon.symbolClass),S.set(5,A.Codicon.symbolMethod),S.set(6,A.Codicon.symbolProperty),S.set(7,A.Codicon.symbolField),S.set(8,A.Codicon.symbolConstructor),S.set(9,A.Codicon.symbolEnum),S.set(10,A.Codicon.symbolInterface),S.set(11,A.Codicon.symbolFunction),S.set(12,A.Codicon.symbolVariable),S.set(13,A.Codicon.symbolConstant),S.set(14,A.Codicon.symbolString),S.set(15,A.Codicon.symbolNumber),S.set(16,A.Codicon.symbolBoolean),S.set(17,A.Codicon.symbolArray),S.set(18,A.Codicon.symbolObject),S.set(19,A.Codicon.symbolKey),S.set(20,A.Codicon.symbolNull),S.set(21,A.Codicon.symbolEnumMember),S.set(22,A.Codicon.symbolStruct),S.set(23,A.Codicon.symbolEvent),S.set(24,A.Codicon.symbolOperator),S.set(25,A.Codicon.symbolTypeParameter);function U(M){let X=S.get(M);return X||(console.info("No codicon found for SymbolKind "+M),X=A.Codicon.symbolProperty),X}L.toIcon=U})(s=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(S){this.value=S}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var h;(function(L){function S(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}L.is=S})(h=e.Command||(e.Command={}));var u;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var R;(function(L){L[L.Other=0]="Other",L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(R=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new k.TokenizationRegistry;var O;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})(O=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[156],be([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(ve[157],be([1,0,156]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,A=k*24,D=A*7,P=A*30,y=A*365;function T(C,f,_){typeof C!="number"&&(C=C.getTime());const p=Math.round((new Date().getTime()-C)/1e3);if(p<-30)return(0,d.localize)(0,null,T(new Date().getTime()+p*1e3,!1));if(p<30)return(0,d.localize)(1,null);let c;return p<t?(c=p,f?c===1?_?(0,d.localize)(2,null,c):(0,d.localize)(3,null,c):_?(0,d.localize)(4,null,c):(0,d.localize)(5,null,c):c===1?_?(0,d.localize)(6,null,c):(0,d.localize)(7,null,c):_?(0,d.localize)(8,null,c):(0,d.localize)(9,null,c)):p<k?(c=Math.floor(p/t),f?c===1?_?(0,d.localize)(10,null,c):(0,d.localize)(11,null,c):_?(0,d.localize)(12,null,c):(0,d.localize)(13,null,c):c===1?_?(0,d.localize)(14,null,c):(0,d.localize)(15,null,c):_?(0,d.localize)(16,null,c):(0,d.localize)(17,null,c)):p<A?(c=Math.floor(p/k),f?c===1?_?(0,d.localize)(18,null,c):(0,d.localize)(19,null,c):_?(0,d.localize)(20,null,c):(0,d.localize)(21,null,c):c===1?_?(0,d.localize)(22,null,c):(0,d.localize)(23,null,c):_?(0,d.localize)(24,null,c):(0,d.localize)(25,null,c)):p<D?(c=Math.floor(p/A),f?c===1?(0,d.localize)(26,null,c):(0,d.localize)(27,null,c):c===1?(0,d.localize)(28,null,c):(0,d.localize)(29,null,c)):p<P?(c=Math.floor(p/D),f?c===1?_?(0,d.localize)(30,null,c):(0,d.localize)(31,null,c):_?(0,d.localize)(32,null,c):(0,d.localize)(33,null,c):c===1?_?(0,d.localize)(34,null,c):(0,d.localize)(35,null,c):_?(0,d.localize)(36,null,c):(0,d.localize)(37,null,c)):p<y?(c=Math.floor(p/P),f?c===1?_?(0,d.localize)(38,null,c):(0,d.localize)(39,null,c):_?(0,d.localize)(40,null,c):(0,d.localize)(41,null,c):c===1?_?(0,d.localize)(42,null,c):(0,d.localize)(43,null,c):_?(0,d.localize)(44,null,c):(0,d.localize)(45,null,c)):(c=Math.floor(p/y),f?c===1?_?(0,d.localize)(46,null,c):(0,d.localize)(47,null,c):_?(0,d.localize)(48,null,c):(0,d.localize)(49,null,c):c===1?_?(0,d.localize)(50,null,c):(0,d.localize)(51,null,c):_?(0,d.localize)(52,null,c):(0,d.localize)(53,null,c))}e.fromNow=T;function F(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(ve[158],be([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ve[49],be([1,0,17,18,158]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,F){return F&&(T.stack||T.stacktrace)?k.localize(0,null,P(T),D(T.stack)||D(T.stacktrace)):P(T)}function D(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?k.localize(1,null,T.message):T.message||k.localize(2,null)}function y(T=null,F=!1){if(!T)return k.localize(3,null);if(Array.isArray(T)){const C=d.coalesce(T),f=y(C[0],F);return C.length>1?k.localize(4,null,f,C.length):f}if(t.isString(T))return T;if(T.detail){const C=T.detail;if(C.error)return A(C.error,F);if(C.exception)return A(C.exception,F)}return T.stack?A(T,F):T.message?T.message:k.localize(5,null)}e.toErrorMessage=y}),define(ve[159],be([19,20]),function(te,e){return te.create("vs/base/node/processes",e)}),define(ve[113],be([1,0,37,28,10,25,9,11,40,95,18,147,29,159]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function p(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(n,E){if(P.isWindows)try{const a={stdio:["pipe","pipe","ignore"]};E&&(a.cwd=E);const i=d.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],a);return new Promise(r=>{i.once("error",s=>{r({success:!1,error:s})}),i.once("exit",(s,l)=>{r(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(a){return Promise.resolve({success:!1,error:a,code:a.status?p(a.status):1})}else if(P.isLinux||P.isMacintosh)try{const a=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",te).fsPath;return new Promise(i=>{d.execFile(a,[n.pid.toString()],{encoding:"utf8",shell:!0},(r,s,l)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(a){return Promise.resolve({success:!1,error:a})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function v(n){!n||(delete n.DEBUG,P.isMacintosh&&delete n.DYLD_LIBRARY_PATH,P.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function I(n=y.env){return n.comspec||"cmd.exe"}e.getWindowsShell=I;class b{constructor(E,a,i,r){if(a!==void 0&&i!==void 0&&r!==void 0)this.cmd=E,this.args=a,this.shell=i,this.options=r;else{const s=E;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(y.env).forEach(l=>{s[l]=y.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let E=this.cmd.toLowerCase();const a=E.lastIndexOf(D.sep);return a!==-1&&(E=E.substring(a+1)),b.WellKnowCommands[E]?E:"other"}start(E){return P.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(y.cwd()))?Promise.reject(new Error(_.localize(0,null))):this.useExec().then(a=>{let i,r;const s=new Promise((l,h)=>{i=l,r=h});if(a){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=d.exec(l,this.options,(h,u,w)=>{this.childProcess=null;const R=h;R&&R.killed?r({killed:this.terminateRequested,stdout:u.toString(),stderr:w.toString()}):this.handleExec(i,E,h,u,w)})}else{let l=null;const h=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,i,E,r);const w={terminated:this.terminateRequested};F.isNumber(u)&&(w.cmdCode=u),i(w)};if(this.shell&&P.isWindows){const u=A.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let w=!1,R=!1;const O=[];let L=this.ensureQuotes(this.cmd);O.push(L.value),w=L.quoted,this.args&&this.args.forEach(U=>{L=this.ensureQuotes(U),O.push(L.value),R=R&&L.quoted});const S=["/s","/c"];w?R?S.push('"'+O.join(" ")+'"'):O.length>1?S.push('"'+O[0]+'" '+O.slice(1).join(" ")):S.push('"'+O[0]+'"'):S.push(O.join(" ")),l=d.spawn(I(),S,u)}else this.cmd&&(l=d.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(F.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",u=>{this.childProcess=null,r({terminated:this.terminateRequested,error:u})}),l.pid&&(this.childProcess.on("close",h),this.handleSpawn(l,i,E,r,!0)))}return s})}handleClose(E,a,i,r){}ensureQuotes(E){return b.regexp.test(E)?{value:'"'+E+'"',quoted:!0}:{value:E,quoted:E.length>0&&E[0]==='"'&&E[E.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(E=>E.pid,E=>-1):new Promise(E=>{this.pidResolve=E})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(E=>(this.terminateRequested=!0,c(E,this.options.cwd).then(a=>(a.success&&(this.childProcess=null),a))),E=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(E=>{if(!this.shell||!P.isWindows)return E(!1);const a=d.spawn(I(),["/s","/c"]);a.on("error",i=>E(!0)),a.on("exit",i=>E(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class m extends b{constructor(E,a,i,r){super(E,a,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(E,a,i,r,s){[r,s].forEach((l,h)=>{const u=new C.LineDecoder;u.write(l).forEach(O=>{a({line:O,source:h===0?0:1})});const R=u.end();R&&a({line:R,source:h===0?0:1})}),E({terminated:this.terminateRequested,error:i})}handleSpawn(E,a,i,r,s){const l=new C.LineDecoder,h=new C.LineDecoder;E.stdout.on("data",u=>{l.write(u).forEach(R=>i({line:R,source:0}))}),E.stderr.on("data",u=>{h.write(u).forEach(R=>i({line:R,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=h}handleClose(E,a,i,r){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}e.LineProcess=m;function o(n){let E=[],a=!1;const i=function(r){if(a){E.push(r);return}(!n.send(r,l=>{if(l&&console.error(l),a=!1,E.length>0){const h=E.slice(0);E=[],h.forEach(u=>i(u))}})||P.isWindows)&&(a=!0)};return{send:i}}e.createQueuedSender=o;var g;(function(n){async function E(a,i,r){if(D.isAbsolute(a))return a;if(i===void 0&&(i=y.cwd()),D.dirname(a)!=="."||(r===void 0&&F.isString(y.env.PATH)&&(r=y.env.PATH.split(D.delimiter)),r===void 0||r.length===0))return D.join(i,a);async function l(h){if(await f.Promises.exists(h)){let u;try{u=await f.Promises.stat(h)}catch(w){w.message.startsWith("EACCES")&&(u=await f.Promises.lstat(h))}return u?!u.isDirectory():!1}return!1}for(let h of r){let u;if(D.isAbsolute(h)?u=D.join(h,a):u=D.join(i,h,a),await l(u))return u;let w=u+".com";if(await l(w)||(w=u+".exe",await l(w)))return w}return D.join(i,a)}n.findExecutable=E})(g=e.win32||(e.win32={}))}),define(ve[160],be([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ve[114],be([1,0,160,11,108,17,25,149]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=T;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class C{constructor(oe,J,pe,Ce){this.id=oe,this.name=J,this.defaultValue=pe,this.schema=Ce}applyUpdate(oe,J){return _(oe,J)}compute(oe,J,pe){return pe}}class f{constructor(oe,J){this.newValue=oe,this.didChange=J}}e.ApplyUpdateResult=f;function _(ne,oe){if(typeof ne!="object"||typeof oe!="object"||!ne||!oe)return new f(oe,ne!==oe);if(Array.isArray(ne)||Array.isArray(oe)){const pe=Array.isArray(ne)&&Array.isArray(oe)&&A.equals(ne,oe);return new f(oe,pe)}let J=!1;for(const pe in oe)if(oe.hasOwnProperty(pe)){const Ce=_(ne[pe],oe[pe]);Ce.didChange&&(ne[pe]=Ce.newValue,J=!0)}return new f(ne,J)}class p{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,J){return _(oe,J)}validate(oe){return this.defaultValue}}class c{constructor(oe,J,pe,Ce){this.id=oe,this.name=J,this.defaultValue=pe,this.schema=Ce}applyUpdate(oe,J){return _(oe,J)}validate(oe){return typeof oe=="undefined"?this.defaultValue:oe}compute(oe,J,pe){return pe}}function v(ne,oe){return typeof ne=="undefined"?oe:ne==="false"?!1:Boolean(ne)}e.boolean=v;class I extends c{constructor(oe,J,pe,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="boolean",Ce.default=pe);super(oe,J,pe,Ce)}validate(oe){return v(oe,this.defaultValue)}}function b(ne,oe,J,pe){if(typeof ne=="undefined")return oe;let Ce=parseInt(ne,10);return isNaN(Ce)?oe:(Ce=Math.max(J,Ce),Ce=Math.min(pe,Ce),Ce|0)}e.clampedInt=b;class m extends c{constructor(oe,J,pe,Ce,Me,He=void 0){typeof He!="undefined"&&(He.type="integer",He.default=pe,He.minimum=Ce,He.maximum=Me);super(oe,J,pe,He);this.minimum=Ce,this.maximum=Me}static clampedInt(oe,J,pe,Ce){return b(oe,J,pe,Ce)}validate(oe){return m.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}class o extends c{constructor(oe,J,pe,Ce,Me){typeof Me!="undefined"&&(Me.type="number",Me.default=pe);super(oe,J,pe,Me);this.validationFn=Ce}static clamp(oe,J,pe){return oe<J?J:oe>pe?pe:oe}static float(oe,J){if(typeof oe=="number")return oe;if(typeof oe=="undefined")return J;const pe=parseFloat(oe);return isNaN(pe)?J:pe}validate(oe){return this.validationFn(o.float(oe,this.defaultValue))}}class g extends c{static string(oe,J){return typeof oe!="string"?J:oe}constructor(oe,J,pe,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.default=pe);super(oe,J,pe,Ce)}validate(oe){return g.string(oe,this.defaultValue)}}function n(ne,oe,J){return typeof ne!="string"||J.indexOf(ne)===-1?oe:ne}e.stringSet=n;class E extends c{constructor(oe,J,pe,Ce,Me=void 0){typeof Me!="undefined"&&(Me.type="string",Me.enum=Ce,Me.default=pe);super(oe,J,pe,Me);this._allowedValues=Ce}validate(oe){return n(oe,this.defaultValue,this._allowedValues)}}class a extends C{constructor(oe,J,pe,Ce,Me,He,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=Me,Ye.default=Ce);super(oe,J,pe,Ye);this._allowedValues=Me,this._convert=He}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function i(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,J,pe){return pe===0?oe.accessibilitySupport:pe}}class s extends C{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:d.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{insertSpace:v(J.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(J.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(ne){switch(ne){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function R(ne){switch(ne){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class O extends p{constructor(){super(128)}compute(oe,J,pe){const Ce=["monaco-editor"];return J.get(33)&&Ce.push(J.get(33)),oe.extraEditorClassName&&Ce.push(oe.extraEditorClassName),J.get(66)==="default"?Ce.push("mouse-default"):J.get(66)==="copy"&&Ce.push("mouse-copy"),J.get(100)&&Ce.push("showUnused"),J.get(126)&&Ce.push("showDeprecated"),Ce.join(" ")}}class L extends I{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(oe,J,pe){return pe&&oe.emptySelectionClipboard}}class S extends C{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:d.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:d.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{cursorMoveOnType:v(J.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":n(J.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":n(J.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(J.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(J.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(J.loop,this.defaultValue.loop)}}}class U extends C{constructor(){super(45,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(oe){return typeof oe=="undefined"?this.defaultValue:typeof oe=="string"?oe==="false"?U.OFF:oe==="true"?U.ON:oe:Boolean(oe)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class M extends p{constructor(){super(44)}compute(oe,J,pe){return oe.fontInfo}}class X extends c{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(oe){const J=o.float(oe,this.defaultValue);return J===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(J,6,100)}compute(oe,J,pe){return oe.fontInfo.fontSize}}class G extends C{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.MINIMUM_VALUE,maximum:G.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(m.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,G.MINIMUM_VALUE,G.MAXIMUM_VALUE))}}G.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],G.MINIMUM_VALUE=1,G.MAXIMUM_VALUE=1e3;class q extends C{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},J={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},pe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...J},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...J},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...J},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...J},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...J},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:pe,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:pe,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:pe,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:pe,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:pe,description:d.localize(38,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{multiple:n(J.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:J.multipleDefinitions??n(J.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:J.multipleTypeDefinitions??n(J.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:J.multipleDeclarations??n(J.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:J.multipleImplementations??n(J.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:J.multipleReferences??n(J.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(J.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(J.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(J.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(J.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(J.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class B extends C{constructor(){const oe={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:d.localize(41,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:d.localize(42,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{enabled:v(J.enabled,this.defaultValue.enabled),delay:m.clampedInt(J.delay,this.defaultValue.delay,0,1e4),sticky:v(J.sticky,this.defaultValue.sticky),above:v(J.above,this.defaultValue.above)}}}var x;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class j extends p{constructor(){super(131)}compute(oe,J,pe){return j.computeLayout(J,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio})}static computeContainedMinimapLineCount(oe){const J=oe.height/oe.lineHeight,pe=oe.scrollBeyondLastLine?J-1:0,Ce=(oe.viewLineCount+pe)/(oe.pixelRatio*oe.height),Me=Math.floor(oe.viewLineCount/Ce);return{typicalViewportLineCount:J,extraLinesBeyondLastLine:pe,desiredRatio:Ce,minimapLineCount:Me}}static _computeMinimapLayout(oe,J){const pe=oe.outerWidth,Ce=oe.outerHeight,Me=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Ce),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ce};const He=J.stableMinimapLayoutInput,Ye=He&&oe.outerHeight===He.outerHeight&&oe.lineHeight===He.lineHeight&&oe.typicalHalfwidthCharacterWidth===He.typicalHalfwidthCharacterWidth&&oe.pixelRatio===He.pixelRatio&&oe.scrollBeyondLastLine===He.scrollBeyondLastLine&&oe.minimap.enabled===He.minimap.enabled&&oe.minimap.side===He.minimap.side&&oe.minimap.size===He.minimap.size&&oe.minimap.showSlider===He.minimap.showSlider&&oe.minimap.renderCharacters===He.minimap.renderCharacters&&oe.minimap.maxColumn===He.minimap.maxColumn&&oe.minimap.scale===He.minimap.scale&&oe.verticalScrollbarWidth===He.verticalScrollbarWidth&&oe.isViewportWrapping===He.isViewportWrapping,rt=oe.lineHeight,gt=oe.typicalHalfwidthCharacterWidth,vt=oe.scrollBeyondLastLine,xe=oe.minimap.renderCharacters;let st=Me>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const Et=oe.minimap.maxColumn,tt=oe.minimap.size,ct=oe.minimap.side,Pt=oe.verticalScrollbarWidth,Rt=oe.viewLineCount,Tt=oe.remainingWidth,ut=oe.isViewportWrapping,Ft=xe?2:3;let Mt=Math.floor(Me*Ce);const Se=Mt/Me;let ge=!1,me=!1,ie=Ft*st,Ie=st/Me,Ae=1;if(tt==="fill"||tt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:at,desiredRatio:St,minimapLineCount:pt}=j.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:vt,height:Ce,lineHeight:rt,pixelRatio:Me});if(Rt/pt>1)ge=!0,me=!0,st=1,ie=1,Ie=st/Me;else{let dt=!1,kt=st+1;if(tt==="fit"){const Ut=Math.ceil((Rt+at)*ie);ut&&Ye&&Tt<=J.stableFitRemainingWidth?(dt=!0,kt=J.stableFitMaxMinimapScale):dt=Ut>Mt}if(tt==="fill"||dt){ge=!0;const Ut=st;ie=Math.min(rt*Me,Math.max(1,Math.floor(1/St))),ut&&Ye&&Tt<=J.stableFitRemainingWidth&&(kt=J.stableFitMaxMinimapScale),st=Math.min(kt,Math.max(1,Math.floor(ie/Ft))),st>Ut&&(Ae=Math.min(2,st/Ut)),Ie=st/Me/Ae,Mt=Math.ceil(Math.max(ft,Rt+at)*ie),ut?(J.stableMinimapLayoutInput=oe,J.stableFitRemainingWidth=Tt,J.stableFitMaxMinimapScale=st):(J.stableMinimapLayoutInput=null,J.stableFitRemainingWidth=0)}}}const Ve=Math.floor(Et*Ie),Ge=Math.min(Ve,Math.max(0,Math.floor((Tt-Pt-2)*Ie/(gt+Ie)))+e.MINIMAP_GUTTER_WIDTH);let ot=Math.floor(Me*Ge);const bt=ot/Me;ot=Math.floor(ot*Ae);const yt=xe?1:2,_t=ct==="left"?0:pe-Ge-Pt;return{renderMinimap:yt,minimapLeft:_t,minimapWidth:Ge,minimapHeightIsEditorHeight:ge,minimapIsSampling:me,minimapScale:st,minimapLineHeight:ie,minimapCanvasInnerWidth:ot,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:bt,minimapCanvasOuterHeight:Se}}static computeLayout(oe,J){const pe=J.outerWidth|0,Ce=J.outerHeight|0,Me=J.lineHeight|0,He=J.lineNumbersDigitCount|0,Ye=J.typicalHalfwidthCharacterWidth,rt=J.maxDigitWidth,gt=J.pixelRatio,vt=J.viewLineCount,xe=oe.get(123),st=xe==="inherit"?oe.get(122):xe,Et=st==="inherit"?oe.get(118):st,tt=oe.get(121),ct=oe.get(2),Pt=J.isDominatedByLongLines,Rt=oe.get(50),Tt=oe.get(60).renderType!==0,ut=oe.get(61),Ft=oe.get(94),Mt=oe.get(65),Se=oe.get(92),ge=Se.verticalScrollbarSize,me=Se.verticalHasArrows,ie=Se.arrowSize,Ie=Se.horizontalScrollbarSize,Ae=oe.get(58),Ve=oe.get(37);let Ge;if(typeof Ae=="string"&&/^\d+(\.\d+)?ch$/.test(Ae)){const xt=parseFloat(Ae.substr(0,Ae.length-2));Ge=m.clampedInt(xt*Ye,0,0,1e3)}else Ge=m.clampedInt(Ae,0,0,1e3);Ve&&(Ge+=16);let ot=0;if(Tt){const xt=Math.max(He,ut);ot=Math.round(xt*rt)}let bt=0;Rt&&(bt=Me);let yt=0,_t=yt+bt,ft=_t+ot,at=ft+Ge;const St=pe-bt-ot-Ge;let pt=!1,Nt=!1,dt=-1;ct!==2&&(st==="inherit"&&Pt?(pt=!0,Nt=!0):Et==="on"||Et==="bounded"?Nt=!0:Et==="wordWrapColumn"&&(dt=tt));const kt=j._computeMinimapLayout({outerWidth:pe,outerHeight:Ce,lineHeight:Me,typicalHalfwidthCharacterWidth:Ye,pixelRatio:gt,scrollBeyondLastLine:Ft,minimap:Mt,verticalScrollbarWidth:ge,viewLineCount:vt,remainingWidth:St,isViewportWrapping:Nt},J.memory||new F);kt.renderMinimap!==0&&kt.minimapLeft===0&&(yt+=kt.minimapWidth,_t+=kt.minimapWidth,ft+=kt.minimapWidth,at+=kt.minimapWidth);const Ut=St-kt.minimapWidth,Ct=Math.max(1,Math.floor((Ut-ge-2)/Ye)),Bt=me?ie:0;return Nt&&(dt=Math.max(1,Ct),Et==="bounded"&&(dt=Math.min(dt,tt))),{width:pe,height:Ce,glyphMarginLeft:yt,glyphMarginWidth:bt,lineNumbersLeft:_t,lineNumbersWidth:ot,decorationsLeft:ft,decorationsWidth:Ge,contentLeft:at,contentWidth:Ut,minimap:kt,viewportColumn:Ct,isWordWrapMinified:pt,isViewportWrapping:Nt,wrappingColumn:dt,verticalScrollbarWidth:ge,horizontalScrollbarHeight:Ie,overviewRuler:{top:Bt,width:ge,height:Ce-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=j;class V extends C{constructor(){const oe={enabled:!0};super(57,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:d.localize(43,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:v(oe.enabled,this.defaultValue.enabled)}}}class Z extends C{constructor(){const oe={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"boolean",default:oe.enabled,description:d.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:d.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:d.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{enabled:v(J.enabled,this.defaultValue.enabled),fontSize:m.clampedInt(J.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(J.fontFamily,this.defaultValue.fontFamily)}}}class se extends o{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>o.clamp(oe,0,150),{markdownDescription:d.localize(47,null)})}compute(oe,J,pe){return oe.fontInfo.lineHeight}}class ce extends C{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:d.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(49,null),d.localize(50,null),d.localize(51,null)],default:oe.size,description:d.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:d.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:d.localize(54,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:d.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:d.localize(57,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{enabled:v(J.enabled,this.defaultValue.enabled),size:n(J.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(J.side,this.defaultValue.side,["right","left"]),showSlider:n(J.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(J.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(J.scale,1,1,3),maxColumn:m.clampedInt(J.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(ne){return ne==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Y extends C{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(59,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{top:m.clampedInt(J.top,0,0,1e3),bottom:m.clampedInt(J.bottom,0,0,1e3)}}}class ae extends C{constructor(){const oe={enabled:!0,cycle:!1};super(76,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:d.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:d.localize(61,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{enabled:v(J.enabled,this.defaultValue.enabled),cycle:v(J.cycle,this.defaultValue.cycle)}}}class he extends p{constructor(){super(129)}compute(oe,J,pe){return oe.pixelRatio}}class we extends C{constructor(){const oe={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",oe,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:oe.strings,description:d.localize(62,null)},comments:{type:"boolean",default:oe.comments,description:d.localize(63,null)},other:{type:"boolean",default:oe.other,description:d.localize(64,null)}}}],default:oe,description:d.localize(65,null)});this.defaultValue=oe}validate(oe){if(typeof oe=="boolean")return oe;if(oe&&typeof oe=="object"){const J=oe,pe={other:v(J.other,this.defaultValue.other),comments:v(J.comments,this.defaultValue.comments),strings:v(J.strings,this.defaultValue.strings)};return pe.other&&pe.comments&&pe.strings?!0:!pe.other&&!pe.comments&&!pe.strings?!1:pe}return this.defaultValue}}var ke;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends C{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(66,null),d.localize(67,null),d.localize(68,null),d.localize(69,null)],default:"on",description:d.localize(70,null)})}validate(oe){let J=this.defaultValue.renderType,pe=this.defaultValue.renderFn;return typeof oe!="undefined"&&(typeof oe=="function"?(J=4,pe=oe):oe==="interval"?J=3:oe==="relative"?J=2:oe==="on"?J=1:J=0),{renderType:J,renderFn:pe}}}function _e(ne){const oe=ne.get(87);return oe==="editable"?ne.get(81):oe!=="on"}e.filterValidationDecorations=_e;class Ee extends C{constructor(){const oe=[],J={type:"number",description:d.localize(71,null)};super(91,"rulers",oe,{type:"array",items:{anyOf:[J,{type:["object"],properties:{column:J,color:{type:"string",description:d.localize(72,null),format:"color-hex"}}}]},default:oe,description:d.localize(73,null)})}validate(oe){if(Array.isArray(oe)){const J=[];for(let pe of oe)if(typeof pe=="number")J.push({column:m.clampedInt(pe,0,0,1e4),color:null});else if(pe&&typeof pe=="object"){const Ce=pe;J.push({column:m.clampedInt(Ce.column,0,0,1e4),color:Ce.color})}return J.sort((pe,Ce)=>pe.column-Ce.column),J}return this.defaultValue}}function z(ne,oe){if(typeof ne!="string")return oe;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends C{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(74,null),d.localize(75,null),d.localize(76,null)],default:"auto",description:d.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(78,null),d.localize(79,null),d.localize(80,null)],default:"auto",description:d.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:d.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:d.localize(84,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe,pe=m.clampedInt(J.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ce=m.clampedInt(J.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(J.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(J.vertical,this.defaultValue.vertical),horizontal:z(J.horizontal,this.defaultValue.horizontal),useShadows:v(J.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(J.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(J.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(J.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(J.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:pe,horizontalSliderSize:m.clampedInt(J.horizontalSliderSize,pe,0,1e3),verticalScrollbarSize:Ce,verticalSliderSize:m.clampedInt(J.verticalSliderSize,Ce,0,1e3),scrollByPage:v(J.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class N extends C{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:d.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:d.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:d.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:d.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:d.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:d.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:d.localize(91,null)}})}applyUpdate(oe,J){let pe=!1;J.allowedCharacters&&(D.equals(oe.allowedCharacters,J.allowedCharacters)||(oe={...oe,allowedCharacters:J.allowedCharacters},pe=!0)),J.allowedLocales&&(D.equals(oe.allowedLocales,J.allowedLocales)||(oe={...oe,allowedLocales:J.allowedLocales},pe=!0));const Ce=super.applyUpdate(oe,J);return pe?new f(Ce.newValue,!0):Ce}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{nonBasicASCII:de(J.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(J.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(J.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(J.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(J.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,J){if(typeof oe!="object"||!oe)return J;const pe={};for(const[Ce,Me]of Object.entries(oe))Me===!0&&(pe[Ce]=!0);return pe}}class $ extends C{constructor(){const oe={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:d.localize(92,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{enabled:v(J.enabled,this.defaultValue.enabled),mode:n(J.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends C{constructor(){const oe={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,description:d.localize(93,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:v(oe.enabled,this.defaultValue.enabled)}}}class re extends C{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(94,null),d.localize(95,null),d.localize(96,null)],default:oe.bracketPairs,description:d.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(98,null),d.localize(99,null),d.localize(100,null)],default:oe.bracketPairsHorizontal,description:d.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:d.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:d.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:oe.highlightActiveIndentation,description:d.localize(104,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{bracketPairs:de(J.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(J.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(J.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(J.indentation,this.defaultValue.indentation),highlightActiveIndentation:v(J.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function de(ne,oe,J){const pe=J.indexOf(ne);return pe===-1?oe:J[pe]}class ye extends C{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(105,null),d.localize(106,null)],default:oe.insertMode,description:d.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:d.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:d.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:d.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:d.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:d.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:d.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:d.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:d.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(146,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const J=oe;return{insertMode:n(J.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(J.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(J.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(J.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(J.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(J.showIcons,this.defaultValue.showIcons),showStatusBar:v(J.showStatusBar,this.defaultValue.showStatusBar),preview:v(J.preview,this.defaultValue.preview),previewMode:n(J.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(J.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(J.showMethods,this.defaultValue.showMethods),showFunctions:v(J.showFunctions,this.defaultValue.showFunctions),showConstructors:v(J.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(J.showDeprecated,this.defaultValue.showDeprecated),showFields:v(J.showFields,this.defaultValue.showFields),showVariables:v(J.showVariables,this.defaultValue.showVariables),showClasses:v(J.showClasses,this.defaultValue.showClasses),showStructs:v(J.showStructs,this.defaultValue.showStructs),showInterfaces:v(J.showInterfaces,this.defaultValue.showInterfaces),showModules:v(J.showModules,this.defaultValue.showModules),showProperties:v(J.showProperties,this.defaultValue.showProperties),showEvents:v(J.showEvents,this.defaultValue.showEvents),showOperators:v(J.showOperators,this.defaultValue.showOperators),showUnits:v(J.showUnits,this.defaultValue.showUnits),showValues:v(J.showValues,this.defaultValue.showValues),showConstants:v(J.showConstants,this.defaultValue.showConstants),showEnums:v(J.showEnums,this.defaultValue.showEnums),showEnumMembers:v(J.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(J.showKeywords,this.defaultValue.showKeywords),showWords:v(J.showWords,this.defaultValue.showWords),showColors:v(J.showColors,this.defaultValue.showColors),showFiles:v(J.showFiles,this.defaultValue.showFiles),showReferences:v(J.showReferences,this.defaultValue.showReferences),showFolders:v(J.showFolders,this.defaultValue.showFolders),showTypeParameters:v(J.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(J.showSnippets,this.defaultValue.showSnippets),showUsers:v(J.showUsers,this.defaultValue.showUsers),showIssues:v(J.showIssues,this.defaultValue.showIssues)}}}class Re extends C{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(147,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class We extends p{constructor(){super(130)}compute(oe,J,pe){return J.get(81)?!0:oe.tabFocusMode}}var $e;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})($e=e.WrappingIndent||(e.WrappingIndent={}));function je(ne){switch(ne){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ze extends p{constructor(){super(132)}compute(oe,J,pe){const Ce=J.get(131);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:Ce.isWordWrapMinified,isViewportWrapping:Ce.isViewportWrapping,wrappingColumn:Ce.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Qe:t.isLinux?nt:Ue,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var et;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.autoClosingBrackets=5]="autoClosingBrackets",ne[ne.autoClosingDelete=6]="autoClosingDelete",ne[ne.autoClosingOvertype=7]="autoClosingOvertype",ne[ne.autoClosingQuotes=8]="autoClosingQuotes",ne[ne.autoIndent=9]="autoIndent",ne[ne.automaticLayout=10]="automaticLayout",ne[ne.autoSurround=11]="autoSurround",ne[ne.bracketPairColorization=12]="bracketPairColorization",ne[ne.guides=13]="guides",ne[ne.codeLens=14]="codeLens",ne[ne.codeLensFontFamily=15]="codeLensFontFamily",ne[ne.codeLensFontSize=16]="codeLensFontSize",ne[ne.colorDecorators=17]="colorDecorators",ne[ne.columnSelection=18]="columnSelection",ne[ne.comments=19]="comments",ne[ne.contextmenu=20]="contextmenu",ne[ne.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=22]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=24]="cursorStyle",ne[ne.cursorSurroundingLines=25]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=27]="cursorWidth",ne[ne.disableLayerHinting=28]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ne[ne.domReadOnly=30]="domReadOnly",ne[ne.dragAndDrop=31]="dragAndDrop",ne[ne.emptySelectionClipboard=32]="emptySelectionClipboard",ne[ne.extraEditorClassName=33]="extraEditorClassName",ne[ne.fastScrollSensitivity=34]="fastScrollSensitivity",ne[ne.find=35]="find",ne[ne.fixedOverflowWidgets=36]="fixedOverflowWidgets",ne[ne.folding=37]="folding",ne[ne.foldingStrategy=38]="foldingStrategy",ne[ne.foldingHighlight=39]="foldingHighlight",ne[ne.foldingImportsByDefault=40]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=41]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=43]="fontFamily",ne[ne.fontInfo=44]="fontInfo",ne[ne.fontLigatures=45]="fontLigatures",ne[ne.fontSize=46]="fontSize",ne[ne.fontWeight=47]="fontWeight",ne[ne.formatOnPaste=48]="formatOnPaste",ne[ne.formatOnType=49]="formatOnType",ne[ne.glyphMargin=50]="glyphMargin",ne[ne.gotoLocation=51]="gotoLocation",ne[ne.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ne[ne.hover=53]="hover",ne[ne.inDiffEditor=54]="inDiffEditor",ne[ne.inlineSuggest=55]="inlineSuggest",ne[ne.letterSpacing=56]="letterSpacing",ne[ne.lightbulb=57]="lightbulb",ne[ne.lineDecorationsWidth=58]="lineDecorationsWidth",ne[ne.lineHeight=59]="lineHeight",ne[ne.lineNumbers=60]="lineNumbers",ne[ne.lineNumbersMinChars=61]="lineNumbersMinChars",ne[ne.linkedEditing=62]="linkedEditing",ne[ne.links=63]="links",ne[ne.matchBrackets=64]="matchBrackets",ne[ne.minimap=65]="minimap",ne[ne.mouseStyle=66]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=68]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=70]="multiCursorModifier",ne[ne.multiCursorPaste=71]="multiCursorPaste",ne[ne.occurrencesHighlight=72]="occurrencesHighlight",ne[ne.overviewRulerBorder=73]="overviewRulerBorder",ne[ne.overviewRulerLanes=74]="overviewRulerLanes",ne[ne.padding=75]="padding",ne[ne.parameterHints=76]="parameterHints",ne[ne.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=79]="quickSuggestions",ne[ne.quickSuggestionsDelay=80]="quickSuggestionsDelay",ne[ne.readOnly=81]="readOnly",ne[ne.renameOnType=82]="renameOnType",ne[ne.renderControlCharacters=83]="renderControlCharacters",ne[ne.renderFinalNewline=84]="renderFinalNewline",ne[ne.renderLineHighlight=85]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=87]="renderValidationDecorations",ne[ne.renderWhitespace=88]="renderWhitespace",ne[ne.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ne[ne.roundedSelection=90]="roundedSelection",ne[ne.rulers=91]="rulers",ne[ne.scrollbar=92]="scrollbar",ne[ne.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=94]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=95]="scrollPredominantAxis",ne[ne.selectionClipboard=96]="selectionClipboard",ne[ne.selectionHighlight=97]="selectionHighlight",ne[ne.selectOnLineNumbers=98]="selectOnLineNumbers",ne[ne.showFoldingControls=99]="showFoldingControls",ne[ne.showUnused=100]="showUnused",ne[ne.snippetSuggestions=101]="snippetSuggestions",ne[ne.smartSelect=102]="smartSelect",ne[ne.smoothScrolling=103]="smoothScrolling",ne[ne.stickyTabStops=104]="stickyTabStops",ne[ne.stopRenderingLineAfter=105]="stopRenderingLineAfter",ne[ne.suggest=106]="suggest",ne[ne.suggestFontSize=107]="suggestFontSize",ne[ne.suggestLineHeight=108]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ne[ne.suggestSelection=110]="suggestSelection",ne[ne.tabCompletion=111]="tabCompletion",ne[ne.tabIndex=112]="tabIndex",ne[ne.unicodeHighlighting=113]="unicodeHighlighting",ne[ne.unusualLineTerminators=114]="unusualLineTerminators",ne[ne.useShadowDOM=115]="useShadowDOM",ne[ne.useTabStops=116]="useTabStops",ne[ne.wordSeparators=117]="wordSeparators",ne[ne.wordWrap=118]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=121]="wordWrapColumn",ne[ne.wordWrapOverride1=122]="wordWrapOverride1",ne[ne.wordWrapOverride2=123]="wordWrapOverride2",ne[ne.wrappingIndent=124]="wrappingIndent",ne[ne.wrappingStrategy=125]="wrappingStrategy",ne[ne.showDeprecated=126]="showDeprecated",ne[ne.inlayHints=127]="inlayHints",ne[ne.editorClassName=128]="editorClassName",ne[ne.pixelRatio=129]="pixelRatio",ne[ne.tabFocusMode=130]="tabFocusMode",ne[ne.layoutInfo=131]="layoutInfo",ne[ne.wrappingInfo=132]="wrappingInfo"})(et=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new I(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(148,null)})),acceptSuggestionOnEnter:Le(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(149,null),""],markdownDescription:d.localize(150,null)})),accessibilitySupport:Le(new r),accessibilityPageSize:Le(new m(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(151,null)})),ariaLabel:Le(new g(4,"ariaLabel",d.localize(152,null))),autoClosingBrackets:Le(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(153,null),d.localize(154,null),""],description:d.localize(155,null)})),autoClosingDelete:Le(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(156,null),""],description:d.localize(157,null)})),autoClosingOvertype:Le(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(158,null),""],description:d.localize(159,null)})),autoClosingQuotes:Le(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(160,null),d.localize(161,null),""],description:d.localize(162,null)})),autoIndent:Le(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[d.localize(163,null),d.localize(164,null),d.localize(165,null),d.localize(166,null),d.localize(167,null)],description:d.localize(168,null)})),automaticLayout:Le(new I(10,"automaticLayout",!1)),autoSurround:Le(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(169,null),d.localize(170,null),d.localize(171,null),""],description:d.localize(172,null)})),bracketPairColorization:Le(new K),bracketPairGuides:Le(new re),stickyTabStops:Le(new I(104,"stickyTabStops",!1,{description:d.localize(173,null)})),codeLens:Le(new I(14,"codeLens",!0,{description:d.localize(174,null)})),codeLensFontFamily:Le(new g(15,"codeLensFontFamily","",{description:d.localize(175,null)})),codeLensFontSize:Le(new m(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(176,null)})),colorDecorators:Le(new I(17,"colorDecorators",!0,{description:d.localize(177,null)})),columnSelection:Le(new I(18,"columnSelection",!1,{description:d.localize(178,null)})),comments:Le(new s),contextmenu:Le(new I(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new I(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(179,null)})),cursorBlinking:Le(new a(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:d.localize(180,null)})),cursorSmoothCaretAnimation:Le(new I(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(181,null)})),cursorStyle:Le(new a(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:d.localize(182,null)})),cursorSurroundingLines:Le(new m(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(183,null)})),cursorSurroundingLinesStyle:Le(new E(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(184,null),d.localize(185,null)],description:d.localize(186,null)})),cursorWidth:Le(new m(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(187,null)})),disableLayerHinting:Le(new I(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new I(29,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new I(30,"domReadOnly",!1)),dragAndDrop:Le(new I(31,"dragAndDrop",!0,{description:d.localize(188,null)})),emptySelectionClipboard:Le(new L),extraEditorClassName:Le(new g(33,"extraEditorClassName","")),fastScrollSensitivity:Le(new o(34,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:d.localize(189,null)})),find:Le(new S),fixedOverflowWidgets:Le(new I(36,"fixedOverflowWidgets",!1)),folding:Le(new I(37,"folding",!0,{description:d.localize(190,null)})),foldingStrategy:Le(new E(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(191,null),d.localize(192,null)],description:d.localize(193,null)})),foldingHighlight:Le(new I(39,"foldingHighlight",!0,{description:d.localize(194,null)})),foldingImportsByDefault:Le(new I(40,"foldingImportsByDefault",!1,{description:d.localize(195,null)})),foldingMaximumRegions:Le(new m(41,"foldingMaximumRegions",5e3,10,65e3,{description:d.localize(196,null)})),unfoldOnClickAfterEndOfLine:Le(new I(42,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(197,null)})),fontFamily:Le(new g(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(198,null)})),fontInfo:Le(new M),fontLigatures2:Le(new U),fontSize:Le(new X),fontWeight:Le(new G),formatOnPaste:Le(new I(48,"formatOnPaste",!1,{description:d.localize(199,null)})),formatOnType:Le(new I(49,"formatOnType",!1,{description:d.localize(200,null)})),glyphMargin:Le(new I(50,"glyphMargin",!0,{description:d.localize(201,null)})),gotoLocation:Le(new q),hideCursorInOverviewRuler:Le(new I(52,"hideCursorInOverviewRuler",!1,{description:d.localize(202,null)})),hover:Le(new B),inDiffEditor:Le(new I(54,"inDiffEditor",!1)),letterSpacing:Le(new o(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>o.clamp(ne,-5,20),{description:d.localize(203,null)})),lightbulb:Le(new V),lineDecorationsWidth:Le(new c(58,"lineDecorationsWidth",10)),lineHeight:Le(new se),lineNumbers:Le(new Ne),lineNumbersMinChars:Le(new m(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new I(62,"linkedEditing",!1,{description:d.localize(204,null)})),links:Le(new I(63,"links",!0,{description:d.localize(205,null)})),matchBrackets:Le(new E(64,"matchBrackets","always",["always","near","never"],{description:d.localize(206,null)})),minimap:Le(new ce),mouseStyle:Le(new E(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new o(67,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:d.localize(207,null)})),mouseWheelZoom:Le(new I(68,"mouseWheelZoom",!1,{markdownDescription:d.localize(208,null)})),multiCursorMergeOverlapping:Le(new I(69,"multiCursorMergeOverlapping",!0,{description:d.localize(209,null)})),multiCursorModifier:Le(new a(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[d.localize(210,null),d.localize(211,null)],markdownDescription:d.localize(212,null)})),multiCursorPaste:Le(new E(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(213,null),d.localize(214,null)],markdownDescription:d.localize(215,null)})),occurrencesHighlight:Le(new I(72,"occurrencesHighlight",!0,{description:d.localize(216,null)})),overviewRulerBorder:Le(new I(73,"overviewRulerBorder",!0,{description:d.localize(217,null)})),overviewRulerLanes:Le(new m(74,"overviewRulerLanes",3,0,3)),padding:Le(new Y),parameterHints:Le(new ae),peekWidgetDefaultFocus:Le(new E(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(218,null),d.localize(219,null)],description:d.localize(220,null)})),definitionLinkOpensInPeek:Le(new I(78,"definitionLinkOpensInPeek",!1,{description:d.localize(221,null)})),quickSuggestions:Le(new we),quickSuggestionsDelay:Le(new m(80,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(222,null)})),readOnly:Le(new I(81,"readOnly",!1)),renameOnType:Le(new I(82,"renameOnType",!1,{description:d.localize(223,null),markdownDeprecationMessage:d.localize(224,null)})),renderControlCharacters:Le(new I(83,"renderControlCharacters",!0,{description:d.localize(225,null),restricted:!0})),renderFinalNewline:Le(new I(84,"renderFinalNewline",!0,{description:d.localize(226,null)})),renderLineHighlight:Le(new E(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(227,null)],description:d.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Le(new I(86,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(229,null)})),renderValidationDecorations:Le(new E(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new E(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(230,null),d.localize(231,null),d.localize(232,null),""],description:d.localize(233,null)})),revealHorizontalRightPadding:Le(new m(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Le(new I(90,"roundedSelection",!0,{description:d.localize(234,null)})),rulers:Le(new Ee),scrollbar:Le(new W),scrollBeyondLastColumn:Le(new m(93,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(235,null)})),scrollBeyondLastLine:Le(new I(94,"scrollBeyondLastLine",!0,{description:d.localize(236,null)})),scrollPredominantAxis:Le(new I(95,"scrollPredominantAxis",!0,{description:d.localize(237,null)})),selectionClipboard:Le(new I(96,"selectionClipboard",!0,{description:d.localize(238,null),included:t.isLinux})),selectionHighlight:Le(new I(97,"selectionHighlight",!0,{description:d.localize(239,null)})),selectOnLineNumbers:Le(new I(98,"selectOnLineNumbers",!0)),showFoldingControls:Le(new E(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(240,null),d.localize(241,null)],description:d.localize(242,null)})),showUnused:Le(new I(100,"showUnused",!0,{description:d.localize(243,null)})),showDeprecated:Le(new I(126,"showDeprecated",!0,{description:d.localize(244,null)})),inlayHints:Le(new Z),snippetSuggestions:Le(new E(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(245,null),d.localize(246,null),d.localize(247,null),d.localize(248,null)],description:d.localize(249,null)})),smartSelect:Le(new Re),smoothScrolling:Le(new I(103,"smoothScrolling",!1,{description:d.localize(250,null)})),stopRenderingLineAfter:Le(new m(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new $),suggestFontSize:Le(new m(107,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(251,null)})),suggestLineHeight:Le(new m(108,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(252,null)})),suggestOnTriggerCharacters:Le(new I(109,"suggestOnTriggerCharacters",!0,{description:d.localize(253,null)})),suggestSelection:Le(new E(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(254,null),d.localize(255,null),d.localize(256,null)],description:d.localize(257,null)})),tabCompletion:Le(new E(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(258,null),d.localize(259,null),d.localize(260,null)],description:d.localize(261,null)})),tabIndex:Le(new m(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new N),unusualLineTerminators:Le(new E(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(262,null),d.localize(263,null),d.localize(264,null)],description:d.localize(265,null)})),useShadowDOM:Le(new I(115,"useShadowDOM",!0)),useTabStops:Le(new I(116,"useTabStops",!0,{description:d.localize(266,null)})),wordSeparators:Le(new g(117,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:d.localize(267,null)})),wordWrap:Le(new E(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(268,null),d.localize(269,null),d.localize(270,null),d.localize(271,null)],description:d.localize(272,null)})),wordWrapBreakAfterCharacters:Le(new g(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new g(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new m(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(273,null)})),wordWrapOverride1:Le(new E(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new E(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Le(new a(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[d.localize(274,null),d.localize(275,null),d.localize(276,null),d.localize(277,null)],description:d.localize(278,null)})),wrappingStrategy:Le(new E(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(279,null),d.localize(280,null)],description:d.localize(281,null)})),editorClassName:Le(new O),pixelRatio:Le(new he),tabFocusMode:Le(new We),layoutInfo:Le(new j),wrappingInfo:Le(new ze)}}),define(ve[161],be([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[162],be([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[163],be([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[164],be([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[165],be([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ve[166],be([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ve[167],be([19,20]),function(te,e){return te.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[168],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[169],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[170],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[171],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[172],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[173],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[174],be([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[175],be([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[176],be([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ve[177],be([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ve[178],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[179],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ve[180],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[181],be([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[182],be([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[183],be([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ve[184],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var t;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var k;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[185],be([1,0,163]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function A(f){return f=f.trim(),f==="*"||t.test(f)}e.isValidVersionStr=A;function D(f){if(!A(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let _=f.match(t);return _?{hasCaret:_[1]==="^",hasGreaterEquals:_[1]===">=",majorBase:_[2]==="x"?0:parseInt(_[2],10),majorMustEqual:_[2]!=="x",minorBase:_[4]==="x"?0:parseInt(_[4],10),minorMustEqual:_[4]!=="x",patchBase:_[6]==="x"?0:parseInt(_[6],10),patchMustEqual:_[6]!=="x",preRelease:_[8]||null}:null}e.parseVersion=D;function P(f){if(!f)return null;let _=f.majorBase,p=f.majorMustEqual,c=f.minorBase,v=f.minorMustEqual,I=f.patchBase,b=f.patchMustEqual;f.hasCaret&&(_===0||(v=!1),b=!1);let m=0;if(f.preRelease){const o=k.exec(f.preRelease);if(o){const[,g,n,E]=o;m=Date.UTC(Number(g),Number(n)-1,Number(E))}}return{majorBase:_,majorMustEqual:p,minorBase:c,minorMustEqual:v,patchBase:I,patchMustEqual:b,isMinimum:f.hasGreaterEquals,notBefore:m}}e.normalizeVersion=P;function y(f,_,p){let c;typeof f=="string"?c=P(D(f)):c=f;let v;_ instanceof Date?v=_.getTime():typeof _=="string"&&(v=new Date(_).getTime());let I;if(typeof p=="string"?I=P(D(p)):I=p,!c||!I)return!1;let b=c.majorBase,m=c.minorBase,o=c.patchBase,g=I.majorBase,n=I.minorBase,E=I.patchBase,a=I.notBefore,i=I.majorMustEqual,r=I.minorMustEqual,s=I.patchMustEqual;return I.isMinimum?b>g?!0:b<g?!1:m>n?!0:m<n||v&&v<a?!1:o>=E:(b===1&&g===0&&(!i||!r||!s)&&(g=1,n=0,E=0,i=!0,r=!1,s=!1),b<g?!1:b>g?!i:m<n?!1:m>n?!r:o<E?!1:o>E?!s:!(v&&v<a))}e.isValidVersion=y;function T(f,_,p,c){return p.isBuiltin||typeof p.main=="undefined"?!0:C(f,_,p.engines.vscode,c)}e.isValidExtensionVersion=T;function F(f,_,p){return f==="*"||C(_,p,f)}e.isEngineValid=F;function C(f,_,p,c=[]){let v=P(D(p));if(!v)return c.push(d.localize(0,null,p)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return c.push(d.localize(1,null,p)),!1}else if(!v.majorMustEqual)return c.push(d.localize(2,null,p)),!1;return y(f,_,v)?!0:(c.push(d.localize(3,null,f,p)),!1)}}),define(ve[115],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(k,A=[],D=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=d}),define(ve[61],be([1,0,115]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function k(D,P,y){P instanceof d.SyncDescriptor||(P=new d.SyncDescriptor(P,[],y)),t.push([D,P])}e.registerSingleton=k;function A(){return t}e.getSingletonServiceDescriptors=A}),define(ve[186],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=d;class t{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let D of this._nodes.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const P=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(D);P.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(A),P)}removeNode(A){const D=this._hashFn(A);this._nodes.delete(D);for(let P of this._nodes.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(A){const D=this._hashFn(A);let P=this._nodes.get(D);return P||(P=new d(A),this._nodes.set(D,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[D,P]of this._nodes)A.push(`${D}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,D]of this._nodes){const P=new Set([A]),y=this._findCycle(D,P);if(y)return y}}_findCycle(A,D){for(let[P,y]of A.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const T=this._findCycle(y,D);if(T)return T;D.delete(P)}}}e.Graph=t}),define(ve[4],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(y){return y[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(d=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,P,y,T){P[d.DI_TARGET]===P?P[d.DI_DEPENDENCIES].push({id:D,index:y,optional:T}):(P[d.DI_DEPENDENCIES]=[{id:D,index:y,optional:T}],P[d.DI_TARGET]=P)}function k(D){if(d.serviceIds.has(D))return d.serviceIds.get(D);const P=function(y,T,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,y,F,!1)};return P.toString=()=>D,d.serviceIds.set(D,P),P}e.createDecorator=k;function A(D){return D}e.refineServiceDecorator=A}),define(ve[116],be([1,0,18,2,4]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof t.URI)}e.isConfigurationOverrides=A;function D(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||d.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function T(v,I){const b=Object.create(null);for(let m in v)F(b,m,v[m],I);return b}e.toValuesTree=T;function F(v,I,b,m){const o=I.split("."),g=o.pop();let n=v;for(let E=0;E<o.length;E++){let a=o[E],i=n[a];switch(typeof i){case"undefined":i=n[a]=Object.create(null);break;case"object":break;default:m(`Ignoring ${I} as ${o.slice(0,E+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[g]=b}catch{m(`Ignoring ${I} as ${o.join(".")} is ${JSON.stringify(n)}`)}else m(`Ignoring ${I} as ${o.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=F;function C(v,I){const b=I.split(".");f(v,b)}e.removeFromValueTree=C;function f(v,I){const b=I.shift();if(I.length===0){delete v[b];return}if(Object.keys(v).indexOf(b)!==-1){const m=v[b];typeof m=="object"&&!Array.isArray(m)&&(f(m,I),Object.keys(m).length===0&&delete v[b])}}function _(v,I,b){function m(n,E){let a=n;for(const i of E){if(typeof a!="object"||a===null)return;a=a[i]}return a}const o=I.split("."),g=m(v,o);return typeof g=="undefined"?b:g}e.getConfigurationValue=_;function p(v,I,b){Object.keys(I).forEach(m=>{m!=="__proto__"&&(m in v?d.isObject(v[m])&&d.isObject(I[m])?p(v[m],I[m],b):b&&(v[m]=I[m]):v[m]=I[m])})}e.merge=p;function c(v,I,b){const m=v.inspect(I),o=v.inspect(b);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:m.defaultValue}e.getMigratedSettingValue=c}),define(ve[62],be([1,0,11,8,4]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",d.isMacintosh),A.set("isLinux",d.isLinux),A.set("isWindows",d.isWindows),A.set("isWeb",d.isWeb),A.set("isMacNative",d.isMacintosh&&!d.isWeb),A.set("isEdge",d.isEdge),A.set("isFirefox",d.isFirefox),A.set("isChrome",d.isChrome),A.set("isSafari",d.isSafari);const D=Object.prototype.hasOwnProperty;var P;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(S){return _.create(S)}static equals(S,U){return p.create(S,U)}static notEquals(S,U){return I.create(S,U)}static regex(S,U){return a.create(S,U)}static in(S,U){return c.create(S,U)}static not(S){return b.create(S)}static and(...S){return s.create(S,null)}static or(...S){return l.create(S,null,!0)}static greater(S,U){return o.create(S,U)}static greaterEquals(S,U){return g.create(S,U)}static smaller(S,U){return n.create(S,U)}static smallerEquals(S,U){return E.create(S,U)}static deserialize(S,U=!1){if(!!S)return this._deserializeOrExpression(S,U)}static _deserializeOrExpression(S,U){let M=S.split("||");return l.create(M.map(X=>this._deserializeAndExpression(X,U)),null,!0)}static _deserializeAndExpression(S,U){let M=S.split("&&");return s.create(M.map(X=>this._deserializeOne(X,U)),null)}static _deserializeOne(S,U){if(S=S.trim(),S.indexOf("!=")>=0){let M=S.split("!=");return I.create(M[0].trim(),this._deserializeValue(M[1],U))}if(S.indexOf("==")>=0){let M=S.split("==");return p.create(M[0].trim(),this._deserializeValue(M[1],U))}if(S.indexOf("=~")>=0){let M=S.split("=~");return a.create(M[0].trim(),this._deserializeRegexValue(M[1],U))}if(S.indexOf(" in ")>=0){let M=S.split(" in ");return c.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(S)){const M=S.split(">=");return g.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(S)){const M=S.split(">");return o.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(S)){const M=S.split("<=");return E.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(S)){const M=S.split("<");return n.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(S)?b.create(S.substr(1).trim()):_.create(S)}static _deserializeValue(S,U){if(S=S.trim(),S==="true")return!0;if(S==="false")return!1;let M=/^'([^']*)'$/.exec(S);return M?M[1].trim():S}static _deserializeRegexValue(S,U){if((0,t.isFalsyOrWhitespace)(S)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=S.indexOf("/"),X=S.lastIndexOf("/");if(M===X||M<0){if(U)throw new Error(`bad regexp-value '${S}', missing /-enclosure`);return console.warn(`bad regexp-value '${S}', missing /-enclosure`),null}let G=S.slice(M+1,X),q=S[X+1]==="i"?"i":"";try{return new RegExp(G,q)}catch(B){if(U)throw new Error(`bad regexp-value '${S}', parse error: ${B}`);return console.warn(`bad regexp-value '${S}', parse error: ${B}`),null}}}e.ContextKeyExpr=y;function T(L,S){const U=L?L.substituteConstants():void 0,M=S?S.substituteConstants():void 0;return!U&&!M?!0:!U||!M?!1:U.equals(M)}e.expressionsAreEqualWithConstantSubstitution=T;function F(L,S){return L.cmp(S)}class C{constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class _{constructor(S,U){this.key=S,this.negated=U,this.type=2}static create(S,U=null){const M=A.get(S);return typeof M=="boolean"?M?f.INSTANCE:C.INSTANCE:new _(S,U)}cmp(S){return S.type!==this.type?this.type-S.type:u(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=A.get(this.key);return typeof S=="boolean"?S?f.INSTANCE:C.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=_;class p{constructor(S,U,M){this.key=S,this.value=U,this.negated=M,this.type=4}static create(S,U,M=null){if(typeof U=="boolean")return U?_.create(S,M):b.create(S,M);const X=A.get(S);return typeof X=="boolean"?U===(X?"true":"false")?f.INSTANCE:C.INSTANCE:new p(S,U,M)}cmp(S){return S.type!==this.type?this.type-S.type:w(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=A.get(this.key);if(typeof S=="boolean"){const U=S?"true":"false";return this.value===U?f.INSTANCE:C.INSTANCE}return this}evaluate(S){return S.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(S){return S.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class c{constructor(S,U){this.key=S,this.valueKey=U,this.type=10,this.negated=null}static create(S,U){return new c(S,U)}cmp(S){return S.type!==this.type?this.type-S.type:w(this.key,this.valueKey,S.key,S.valueKey)}equals(S){return S.type===this.type?this.key===S.key&&this.valueKey===S.valueKey:!1}substituteConstants(){return this}evaluate(S){const U=S.getValue(this.valueKey),M=S.getValue(this.key);return Array.isArray(U)?U.indexOf(M)>=0:typeof M=="string"&&typeof U=="object"&&U!==null?D.call(U,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(S){return S.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=c;class v{constructor(S){this._actual=S,this.type=11}static create(S){return new v(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new v(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class I{constructor(S,U,M){this.key=S,this.value=U,this.negated=M,this.type=5}static create(S,U,M=null){if(typeof U=="boolean")return U?b.create(S,M):_.create(S,M);const X=A.get(S);return typeof X=="boolean"?U===(X?"true":"false")?C.INSTANCE:f.INSTANCE:new I(S,U,M)}cmp(S){return S.type!==this.type?this.type-S.type:w(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=A.get(this.key);if(typeof S=="boolean"){const U=S?"true":"false";return this.value===U?C.INSTANCE:f.INSTANCE}return this}evaluate(S){return S.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(S){return S.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class b{constructor(S,U){this.key=S,this.negated=U,this.type=3}static create(S,U=null){const M=A.get(S);return typeof M=="boolean"?M?C.INSTANCE:f.INSTANCE:new b(S,U)}cmp(S){return S.type!==this.type?this.type-S.type:u(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=A.get(this.key);return typeof S=="boolean"?S?C.INSTANCE:f.INSTANCE:this}evaluate(S){return!S.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(S){return S.mapNot(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;function m(L,S){if(typeof L=="string"){const U=parseFloat(L);isNaN(U)||(L=U)}return typeof L=="string"||typeof L=="number"?S(L):C.INSTANCE}class o{constructor(S,U,M){this.key=S,this.value=U,this.negated=M,this.type=12}static create(S,U,M=null){return m(U,X=>new o(S,X,M))}cmp(S){return S.type!==this.type?this.type-S.type:w(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class g{constructor(S,U,M){this.key=S,this.value=U,this.negated=M,this.type=13}static create(S,U,M=null){return m(U,X=>new g(S,X,M))}cmp(S){return S.type!==this.type?this.type-S.type:w(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=g;class n{constructor(S,U,M){this.key=S,this.value=U,this.negated=M,this.type=14}static create(S,U,M=null){return m(U,X=>new n(S,X,M))}cmp(S){return S.type!==this.type?this.type-S.type:w(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class E{constructor(S,U,M){this.key=S,this.value=U,this.negated=M,this.type=15}static create(S,U,M=null){return m(U,X=>new E(S,X,M))}cmp(S){return S.type!==this.type?this.type-S.type:w(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=E;class a{constructor(S,U){this.key=S,this.regexp=U,this.type=7,this.negated=null}static create(S,U){return new a(S,U)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.key<S.key)return-1;if(this.key>S.key)return 1;const U=this.regexp?this.regexp.source:"",M=S.regexp?S.regexp.source:"";return U<M?-1:U>M?1:0}equals(S){if(S.type===this.type){const U=this.regexp?this.regexp.source:"",M=S.regexp?S.regexp.source:"";return this.key===S.key&&U===M}return!1}substituteConstants(){return this}evaluate(S){let U=S.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const S=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${S}`}keys(){return[this.key]}map(S){return S.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class i{constructor(S){this._actual=S,this.type=8}static create(S){return new i(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new i(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(L){let S=null;for(let U=0,M=L.length;U<M;U++){const X=L[U].substituteConstants();if(L[U]!==X&&S===null){S=[];for(let G=0;G<U;G++)S[G]=L[G]}S!==null&&(S[U]=X)}return S===null?L:S}class s{constructor(S,U){this.expr=S,this.negated=U,this.type=6}static create(S,U){return s._normalizeArr(S,U)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let U=0,M=this.expr.length;U<M;U++){const X=F(this.expr[U],S.expr[U]);if(X!==0)return X}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let U=0,M=this.expr.length;U<M;U++)if(!this.expr[U].equals(S.expr[U]))return!1;return!0}return!1}substituteConstants(){const S=r(this.expr);return S===this.expr?this:s.create(S,this.negated)}evaluate(S){for(let U=0,M=this.expr.length;U<M;U++)if(!this.expr[U].evaluate(S))return!1;return!0}static _normalizeArr(S,U){const M=[];let X=!1;for(const G of S)if(!!G){if(G.type===1){X=!0;continue}if(G.type===0)return C.INSTANCE;if(G.type===6){M.push(...G.expr);continue}M.push(G)}if(M.length===0&&X)return f.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(F);for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];for(;M.length>1;){const G=M[M.length-1];if(G.type!==9)break;M.pop();const q=M.pop(),B=M.length===0,x=l.create(G.expr.map(j=>s.create([j,q],null)),null,B);x&&(M.push(x),M.sort(F))}return M.length===1?M[0]:new s(M,U)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(let U of this.expr)S.push(...U.keys());return S}map(S){return new s(this.expr.map(U=>U.map(S)),null)}negate(){if(!this.negated){const S=[];for(let U of this.expr)S.push(U.negate());this.negated=l.create(S,this,!0)}return this.negated}}class l{constructor(S,U){this.expr=S,this.negated=U,this.type=9}static create(S,U,M){return l._normalizeArr(S,U,M)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let U=0,M=this.expr.length;U<M;U++){const X=F(this.expr[U],S.expr[U]);if(X!==0)return X}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let U=0,M=this.expr.length;U<M;U++)if(!this.expr[U].equals(S.expr[U]))return!1;return!0}return!1}substituteConstants(){const S=r(this.expr);return S===this.expr?this:l.create(S,this.negated,!1)}evaluate(S){for(let U=0,M=this.expr.length;U<M;U++)if(this.expr[U].evaluate(S))return!0;return!1}static _normalizeArr(S,U,M){let X=[],G=!1;if(S){for(let q=0,B=S.length;q<B;q++){const x=S[q];if(!!x){if(x.type===0){G=!0;continue}if(x.type===1)return f.INSTANCE;if(x.type===9){X=X.concat(x.expr);continue}X.push(x)}}if(X.length===0&&G)return C.INSTANCE;X.sort(F)}if(X.length!==0){if(X.length===1)return X[0];for(let q=1;q<X.length;q++)X[q-1].equals(X[q])&&(X.splice(q,1),q--);if(X.length===1)return X[0];if(M){for(let q=0;q<X.length;q++)for(let B=q+1;B<X.length;B++)R(X[q],X[B])&&(X.splice(B,1),B--);if(X.length===1)return X[0]}return new l(X,U)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(let U of this.expr)S.push(...U.keys());return S}map(S){return new l(this.expr.map(U=>U.map(S)),null)}negate(){if(!this.negated){let S=[];for(let U of this.expr)S.push(U.negate());for(;S.length>1;){const U=S.shift(),M=S.shift(),X=[];for(const q of O(U))for(const B of O(M))X.push(s.create([q,B],null));const G=S.length===0;S.unshift(l.create(X,null,G))}this.negated=S[0]}return this.negated}}class h extends _{constructor(S,U,M){super(S,null);this._defaultValue=U,typeof M=="object"?h._info.push({...M,key:S}):M!==!0&&h._info.push({key:S,description:M,type:U!=null?typeof U:void 0})}static all(){return h._info.values()}bindTo(S){return S.createKey(this.key,this._defaultValue)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return p.create(this.key,S)}notEqualsTo(S){return I.create(this.key,S)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(L,S){return L<S?-1:L>S?1:0}function w(L,S,U,M){return L<U?-1:L>U?1:S<M?-1:S>M?1:0}function R(L,S){if(S.type===6&&L.type!==9&&L.type!==6){for(const X of S.expr)if(L.equals(X))return!0}const U=L.negate(),M=O(U).concat(O(S));M.sort(F);for(let X=0;X<M.length;X++){const q=M[X].negate();for(let B=X+1;B<M.length;B++){const x=M[B];if(q.equals(x))return!0}}return!1}e.implies=R;function O(L){return L.type===9?L.expr:[L]}}),define(ve[187],be([1,0,4]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[188],be([1,0,4]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,d.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,d.createDecorator)("externalTerminal")}),define(ve[189],be([1,0,37,10,9,11,95,29,113,164,188]),function(te,e,d,t,k,A,D,P,y,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=T.localize(0,null);class f{async getDefaultTerminalForPlatforms(){return{windows:_.getDefaultTerminalWindows(),linux:await c.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class _ extends f{openTerminal(o,g){return this.spawnTerminal(d,o,y.getWindowsShell(),g)}spawnTerminal(o,g,n,E){const a=g.windowsExec||_.getDefaultTerminalWindows();E&&E[1]===":"&&(E=E[0].toUpperCase()+E.substr(1));const i=k.basename(a).toLowerCase();if(i==="cmder"||i==="cmder.exe")return o.spawn(a,E?[E]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return a.indexOf(" ")>=0&&r.push('""'),r.push(a),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((s,l)=>{const h=v(process),u=o.spawn(n,r,{cwd:E,env:h});u.on("error",l),u.on("exit",()=>s())})}runInTerminal(o,g,n,E,a){const i="windowsExec"in a&&a.windowsExec?a.windowsExec:_.getDefaultTerminalWindows();return new Promise((r,s)=>{const l=`"${g} - ${C}"`,h=`""${n.join('" "')}" & pause"`,u=["/c","start",l,"/wait",i,"/c",h],w=Object.assign({},v(process),E);Object.keys(w).filter(L=>w[L]===null).forEach(L=>delete w[L]);const R={cwd:g,env:w,windowsVerbatimArguments:!0};d.spawn(_.CMD,u,R).on("error",L=>{s(I(L))}),r(void 0)})}static getDefaultTerminalWindows(){if(!_._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");_._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return _._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=_,_.CMD="cmd.exe";class p extends f{openTerminal(o,g){return this.spawnTerminal(d,o,g)}runInTerminal(o,g,n,E,a){const i=a.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{if(i===F.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const l=i===F.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,te).fsPath,"-t",o||C,"-w",g];for(let O of n)u.push("-a"),u.push(O);if(E){const O=Object.assign({},v(process),E);for(let L in O){const S=O[L];S===null?(u.push("-u"),u.push(L)):(u.push("-e"),u.push(`${L}=${S}`))}}let w="";const R=d.spawn(p.OSASCRIPT,u);R.on("error",O=>{s(I(O))}),R.stderr.on("data",O=>{w+=O.toString()}),R.on("exit",O=>{if(O===0)r(void 0);else if(w){const L=w.split(`
`,1);s(new Error(L[0]))}else s(new Error(T.localize(1,null,l,O)))})}else s(new Error(T.localize(2,null,i)))})}spawnTerminal(o,g,n){const E=g.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((a,i)=>{const r=["-a",E];n&&r.push(n);const s=v(process),l=o.spawn("/usr/bin/open",r,{cwd:n,env:s});l.on("error",i),l.on("exit",()=>a())})}}e.MacExternalTerminalService=p,p.OSASCRIPT="/usr/bin/osascript";class c extends f{openTerminal(o,g){return this.spawnTerminal(d,o,g)}runInTerminal(o,g,n,E,a){const i=a.linuxExec?Promise.resolve(a.linuxExec):c.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{let l=[];i.then(h=>{h.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const u=`${b(n)}; echo; read -p "${c.WAIT_MESSAGE}" -n1;`;l.push(`''${u}''`);const w=Object.assign({},v(process),E);Object.keys(w).filter(S=>w[S]===null).forEach(S=>delete w[S]);const R={cwd:g,env:w};let O="";const L=d.spawn(h,l,R);L.on("error",S=>{s(I(S))}),L.stderr.on("data",S=>{O+=S.toString()}),L.on("exit",S=>{if(S===0)r(void 0);else if(O){const U=O.split(`
`,1);s(new Error(U[0]))}else s(new Error(T.localize(4,null,h,S)))})})})}static async getDefaultTerminalLinuxReady(){if(!c._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)c._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await P.Promises.exists("/etc/debian_version");c._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{o?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return c._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,g,n){const E=g.linuxExec?Promise.resolve(g.linuxExec):c.getDefaultTerminalLinuxReady();return new Promise((a,i)=>{E.then(r=>{const s=v(process),l=o.spawn(r,[],{cwd:n,env:s});l.on("error",i),l.on("exit",()=>a())})})}}e.LinuxExternalTerminalService=c,c.WAIT_MESSAGE=T.localize(3,null);function v(m){const o={...m.env};return(0,D.sanitizeProcessEnvironment)(o),o}function I(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(T.localize(5,null,m.path)):m}function b(m){let o="";for(let g of m)g.indexOf(" ")>=0?o+='"'+g+'"':o+=g,o+=" ";return o}}),define(ve[42],be([1,0,24,9,8,18,2,165,4]),function(te,e,d,t,k,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function T(G){return G.create===!0}e.isFileOpenForWriteOptions=T;var F;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var C;(function(G){G[G.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var f;(function(G){G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(G){return!!(G.capabilities&2)}e.hasReadWriteCapability=_;function p(G){return!!(G.capabilities&8)}e.hasFileFolderCopyCapability=p;function c(G){return!!(G.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function v(G){return!!(G.capabilities&16)}e.hasFileReadStreamCapability=v;function I(G){return _(G)?!!(G.capabilities&16384):!1}e.hasFileAtomicReadCapability=I;var b;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(q,B){super(q);this.code=B}}e.FileSystemProviderError=m;function o(G,q){const B=new m(G.toString(),q);return n(B,q),B}e.createFileSystemProviderError=o;function g(G){return G||o((0,P.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=g;function n(G,q){return G.name=q?`${q} (FileSystemError)`:"FileSystemError",G}e.markAsFileSystemProviderError=n;function E(G){if(!G)return b.Unknown;if(G instanceof m)return G.code;const q=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!q)return b.Unknown;switch(q[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=E;function a(G){if(G instanceof u)return G.fileOperationResult;switch(E(G)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var i;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(q,B,x){this.resource=q,this.operation=B,this.target=x}isOperation(q){return this.operation===q}}e.FileOperationEvent=r;var s;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class l{constructor(q,B){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=q;const x=new Map;for(const j of q){const V=x.get(j.type);switch(V?V.push([j.resource,j]):x.set(j.type,[[j.resource,j]]),j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}}for(const[j,V]of x)switch(j){case 1:this.added=d.TernarySearchTree.forUris(()=>B),this.added.fill(V);break;case 0:this.updated=d.TernarySearchTree.forUris(()=>B),this.updated.fill(V);break;case 2:this.deleted=d.TernarySearchTree.forUris(()=>B),this.deleted.fill(V);break}}contains(q,...B){return this.doContains(q,{includeChildren:!1},...B)}affects(q,...B){return this.doContains(q,{includeChildren:!0},...B)}doContains(q,B,...x){if(!q)return!1;const j=x.length>0;return!!((!j||x.includes(1))&&(this.added?.get(q)||B.includeChildren&&this.added?.findSuperstr(q))||(!j||x.includes(0))&&(this.updated?.get(q)||B.includeChildren&&this.updated?.findSuperstr(q))||(!j||x.includes(2))&&(this.deleted?.findSubstr(q)||B.includeChildren&&this.deleted?.findSuperstr(q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function h(G,q,B){return!G||!q||G===q||q.length>G.length?!1:(q.charAt(q.length-1)!==t.sep&&(q+=t.sep),B?(0,k.startsWithIgnoreCase)(G,q):G.indexOf(q)===0)}e.isParent=h;class u extends Error{constructor(q,B,x){super(q);this.fileOperationResult=B,this.options=x}}e.FileOperationError=u;class w extends u{constructor(q,B,x){super(q,2,x);this.stat=B}}e.NotModifiedSinceFileOperationError=w;var R;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",G[G.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}e.etag=L;async function S(G,q){if(!q.hasProvider(D.URI.from({scheme:G.scheme})))return new Promise(B=>{const x=q.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===G.scheme&&j.added&&(x.dispose(),B())})})}e.whenProviderRegistered=S,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(q){return(0,A.isNumber)(q)||(q=0),q<U.KB?(0,P.localize)(1,null,q.toFixed(0)):q<U.MB?(0,P.localize)(2,null,(q/U.KB).toFixed(2)):q<U.GB?(0,P.localize)(3,null,(q/U.MB).toFixed(2)):q<U.TB?(0,P.localize)(4,null,(q/U.GB).toFixed(2)):(0,P.localize)(5,null,(q/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var M;(function(G){G[G.IA32=0]="IA32",G[G.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function X(G){return{maxFileSize:G===0?300*U.MB:16*U.GB,maxHeapSize:G===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=X}),define(ve[82],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...k){this._entries=new Map;for(let[A,D]of k)this.set(A,D)}set(k,A){const D=this._entries.get(k);return this._entries.set(k,A),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=d}),define(ve[190],be([1,0,13,16,115,186,4,82]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class T extends Error{constructor(p){super("cyclic dependency between services");this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class F{constructor(p=new P.ServiceCollection,c=!1,v){this._activeInstantiations=new Set,this._services=p,this._strict=c,this._parent=v,this._services.set(D.IInstantiationService,this)}createChild(p){return new F(p,this._strict,this)}invokeFunction(p,...c){let v=f.traceInvocation(p),I=!1;try{return p({get:m=>{if(I)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(m,v);if(!o)throw new Error(`[invokeFunction] unknown service '${m}'`);return o}},...c)}finally{I=!0,v.stop()}}createInstance(p,...c){let v,I;return p instanceof k.SyncDescriptor?(v=f.traceCreation(p.ctor),I=this._createInstance(p.ctor,p.staticArguments.concat(c),v)):(v=f.traceCreation(p),I=this._createInstance(p,c,v)),v.stop(),I}_createInstance(p,c=[],v){let I=D._util.getServiceDependencies(p).sort((o,g)=>o.index-g.index),b=[];for(const o of I){let g=this._getOrCreateServiceInstance(o.id,v);if(!g&&this._strict&&!o.optional)throw new Error(`[createInstance] ${p.name} depends on UNKNOWN service ${o.id}.`);b.push(g)}let m=I.length>0?I[0].index:c.length;if(c.length!==m){console.warn(`[createInstance] First service dependency of ${p.name} at position ${m+1} conflicts with ${c.length} static arguments`);let o=m-c.length;o>0?c=c.concat(new Array(o)):c=c.slice(0,m)}return new p(...[...c,...b])}_setServiceInstance(p,c){if(this._services.get(p)instanceof k.SyncDescriptor)this._services.set(p,c);else if(this._parent)this._parent._setServiceInstance(p,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){let c=this._services.get(p);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):c}_getOrCreateServiceInstance(p,c){let v=this._getServiceInstanceOrDescriptor(p);return v instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,v,c.branch(p,!0)):(c.branch(p,!1),v)}_safeCreateAndCacheServiceInstance(p,c,v){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,c,v)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,c,v){const I=new A.Graph(o=>o.id.toString());let b=0;const m=[{id:p,desc:c,_trace:v}];for(;m.length;){const o=m.pop();if(I.lookupOrInsertNode(o),b++>1e3)throw new T(I);for(let g of D._util.getServiceDependencies(o.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(g.id);if(!n&&!g.optional&&console.warn(`[createInstance] ${p} depends on ${g.id} which is NOT registered.`),n instanceof k.SyncDescriptor){const E={id:g.id,desc:n,_trace:o._trace.branch(g.id,!0)};I.insertEdge(o,E),m.push(E)}}}for(;;){const o=I.roots();if(o.length===0){if(!I.isEmpty())throw new T(I);break}for(const{data:g}of o){if(this._getServiceInstanceOrDescriptor(g.id)instanceof k.SyncDescriptor){const E=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,E)}I.removeNode(g)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,c,v=[],I,b){if(this._services.get(p)instanceof k.SyncDescriptor)return this._createServiceInstance(c,v,I,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,c,v,I,b);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(p,c=[],v,I){if(v){const b=new d.IdleValue(()=>this._createInstance(p,c,I));return new Proxy(Object.create(null),{get(m,o){if(o in m)return m[o];let g=b.value,n=g[o];return typeof n!="function"||(n=n.bind(g),m[o]=n),n},set(m,o,g){return b.value[o]=g,!0}})}else return this._createInstance(p,c,I)}}e.InstantiationService=F;var C;(function(_){_[_.Creation=0]="Creation",_[_.Invocation=1]="Invocation",_[_.Branch=2]="Branch"})(C||(C={}));class f{constructor(p,c){this.type=p,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(p){return y?new f(1,p.name||p.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(p){return y?new f(0,p.name):f._None}branch(p,c){let v=new f(2,p.toString());return this._dep.push([p,c,v]),v}stop(){let p=Date.now()-this._start;f._totals+=p;let c=!1;function v(b,m){let o=[],g=new Array(b+1).join("	");for(const[n,E,a]of m._dep)if(E&&a){c=!0,o.push(`${g}CREATES -> ${n}`);let i=v(b+1,a);i&&o.push(i)}else o.push(`${g}uses -> ${n}`);return o.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(p>2||c)&&console.log(I.join(`
`))}}e.Trace=f,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ve[12],be([1,0,49,3,6,11,4]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function P(){return new Date().toISOString()}var y;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function T(E,a,i){switch(a){case y.Trace:E.trace(i);break;case y.Debug:E.debug(i);break;case y.Info:E.info(i);break;case y.Warning:E.warn(i);break;case y.Error:E.error(i);break;case y.Critical:E.critical(i);break;default:throw new Error("Invalid log level")}}e.log=T;function F(E){let a="";for(let i=0;i<E.length;i++){let r=E[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}a+=(i>0?" ":"")+r}return a}e.format=F;class C extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class f extends C{constructor(a){super();this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,F([a,...i]))}debug(a,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,F([a,...i]))}info(a,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,F([a,...i]))}warn(a,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,F([a,...i]))}error(a,...i){if(this.checkLogLevel(y.Error))if(a instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=a.stack,this.log(y.Error,F(r))}else this.log(y.Error,F([a,...i]))}critical(a,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,F([a,...i]))}flush(){}}e.AbstractMessageLogger=f;class _ extends C{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a),this.useColors=!A.isWindows}trace(a,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,a,...i):console.log(`[main ${P()}]`,a,...i))}debug(a,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,a,...i):console.log(`[main ${P()}]`,a,...i))}info(a,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,a,...i):console.log(`[main ${P()}]`,a,...i))}warn(a,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,a,...i):console.warn(`[main ${P()}]`,a,...i))}error(a,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,a,...i):console.error(`[main ${P()}]`,a,...i))}critical(a,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,a,...i):console.error(`[main ${P()}]`,a,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class p extends C{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a)}trace(a,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",a,...i)}debug(a,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...i)}info(a,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",a,...i)}warn(a,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",a,...i)}error(a,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",a,...i)}critical(a,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...i)}dispose(){}flush(){}}e.ConsoleLogger=p;class c extends C{constructor(a,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=a,this.setLevel(i)}trace(a,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(a),...i])}debug(a,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(a),...i])}info(a,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(a),...i])}warn(a,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(a),...i])}error(a,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(a),...i])}critical(a,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(a),...i])}extractMessage(a){return typeof a=="string"?a:(0,d.toErrorMessage)(a,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class v extends C{constructor(a){super();this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const i of this.logServices)i.setLevel(a);super.setLevel(a)}trace(a,...i){for(const r of this.logServices)r.trace(a,...i)}debug(a,...i){for(const r of this.logServices)r.debug(a,...i)}info(a,...i){for(const r of this.logServices)r.info(a,...i)}warn(a,...i){for(const r of this.logServices)r.warn(a,...i)}error(a,...i){for(const r of this.logServices)r.error(a,...i)}critical(a,...i){for(const r of this.logServices)r.critical(a,...i)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=v;class I extends k.Disposable{constructor(a){super();this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...i){this.logger.trace(a,...i)}debug(a,...i){this.logger.debug(a,...i)}info(a,...i){this.logger.info(a,...i)}warn(a,...i){this.logger.warn(a,...i)}error(a,...i){this.logger.error(a,...i)}critical(a,...i){this.logger.critical(a,...i)}flush(){this.logger.flush()}}e.LogService=I;class b extends k.Disposable{constructor(a,i){super();this.logLevel=a,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(a){return this.loggers.get(a.toString())}createLogger(a,i){let r=this.loggers.get(a.toString());return r||(r=this.doCreateLogger(a,i?.always?y.Trace:this.logLevel,i),this.loggers.set(a.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(a=>a.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class m{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return y.Info}trace(a,...i){}debug(a,...i){}info(a,...i){}warn(a,...i){}error(a,...i){}critical(a,...i){}dispose(){}flush(){}}e.NullLogService=m;function o(E){if(E.verbose)return y.Trace;if(typeof E.logLevel=="string"){const a=g(E.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function g(E){switch(E){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=g;function n(E){switch(E){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=n}),define(ve[191],be([1,0,42,12]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(P,y,T,F,C){try{const f=await new Promise((p,c)=>{te(["spdlog"],p,c)});f.setFlushOn(t.LogLevel.Trace);const _=await f.createAsyncRotatingLogger(P,y,T,F);return C&&_.clearFormatters(),_}catch(f){console.error(f)}return null}function A(P,y,T){switch(y){case t.LogLevel.Trace:P.trace(T);break;case t.LogLevel.Debug:P.debug(T);break;case t.LogLevel.Info:P.info(T);break;case t.LogLevel.Warning:P.warn(T);break;case t.LogLevel.Error:P.error(T);break;case t.LogLevel.Critical:P.critical(T);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(y,T,F,C,f){super();this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(y,T,F,C),this._register(this.onDidChangeLogLevel(_=>{this._logger&&this._logger.setLevel(_)}))}async _createSpdLogLogger(y,T,F,C){const f=F?6:1,_=30/f*d.ByteSize.MB,p=await k(y,T,_,f,C);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:c,message:v}of this.buffer)A(this._logger,c,v);this.buffer=[]}}log(y,T){this._logger?A(this._logger,y,T):this.getLevel()<=y&&this.buffer.push({level:y,message:T})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(ve[117],be([1,0,47,166,4]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function T(p,c){return c-p}y.compare=T;const F=Object.create(null);F[y.Error]=(0,t.localize)(0,null),F[y.Warning]=(0,t.localize)(1,null),F[y.Info]=(0,t.localize)(2,null);function C(p){return F[p]||""}y.toString=C;function f(p){switch(p){case d.default.Error:return y.Error;case d.default.Warning:return y.Warning;case d.default.Info:return y.Info;case d.default.Ignore:return y.Hint}}y.fromSeverity=f;function _(p){switch(p){case y.Error:return d.default.Error;case y.Warning:return d.default.Warning;case y.Info:return d.default.Info;case y.Hint:return d.default.Ignore}}y.toSeverity=_}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(y){const T="";function F(f){return C(f,!0)}y.makeKey=F;function C(f,_){let p=[T];return f.source?p.push(f.source.replace("\xA6","\\\xA6")):p.push(T),f.code?typeof f.code=="string"?p.push(f.code.replace("\xA6","\\\xA6")):p.push(f.code.value.replace("\xA6","\\\xA6")):p.push(T),f.severity!==void 0&&f.severity!==null?p.push(D.toString(f.severity)):p.push(T),f.message&&_?p.push(f.message.replace("\xA6","\\\xA6")):p.push(T),f.startLineNumber!==void 0&&f.startLineNumber!==null?p.push(f.startLineNumber.toString()):p.push(T),f.startColumn!==void 0&&f.startColumn!==null?p.push(f.startColumn.toString()):p.push(T),f.endLineNumber!==void 0&&f.endLineNumber!==null?p.push(f.endLineNumber.toString()):p.push(T),f.endColumn!==void 0&&f.endColumn!==null?p.push(f.endColumn.toString()):p.push(T),p.push(T),p.join("\xA6")}y.makeKeyOptionalMessage=C})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(ve[192],be([1,0,3,47,4]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,k.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new y,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=P;class y{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=y}),define(ve[118],be([1,0,6,8,2,4]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.selectionFragment=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(T){return{resolved:T,dispose(){}}}});function D(T,F){return k.URI.isUri(T)?(0,t.equalsIgnoreCase)(T.scheme,F):(0,t.startsWithIgnoreCase)(T,F+":")}e.matchesScheme=D;function P(T,...F){return F.some(C=>D(T,C))}e.matchesSomeScheme=P;function y(T){let F;const C=/^L?(\d+)(?:,(\d+))?/.exec(T.fragment);return C&&(F={startLineNumber:parseInt(C[1]),startColumn:C[2]?parseInt(C[2]):1}),F}e.selectionFragment=y}),define(ve[193],be([1,0,10,11,40,22]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const P=t.globals.vscode.context.configuration();if(P)D=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof te?.__$__nodeRequire=="function"){const P=(0,A.dirname)(d.FileAccess.asFileUri("",te));D=te.__$__nodeRequire((0,A.joinPath)(P,"product.json").fsPath);const y=te.__$__nodeRequire((0,A.joinPath)(P,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:y.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=D});var Fe=this&&this.__param||function(te,e){return function(d,t){e(d,t,te)}};define(ve[119],be([1,0,13,21,6,4]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var D;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let y=class extends k.Disposable{constructor(C,f){super();this.deferred=new d.DeferredPromise,f.withProgress(C,_=>(this.reporter=_,this.lastStep&&_.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=Be([Fe(1,e.IProgressService)],y),e.UnmanagedProgress=y;class T extends k.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(C){this.stop();const f=++this.currentOperationId,_=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{f===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>_.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:f,token:_.token,stop:()=>this.doStop(f),isCurrent:()=>this.currentOperationId===f}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(ve[50],be([1,0,55,18]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,P){d.ok(t.isString(D)),d.ok(t.isObject(P)),d.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,P)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(ve[194],be([1,0,3,50]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,T){this.schemasById[k(y)]=T,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new A;t.Registry.add(e.Extensions.JSONContribution,D)}),define(ve[120],be([1,0,17,3,18,161,194,50]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=P.Registry.as(D.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,n=!0){this.registerConfigurations([g],n)}registerConfigurations(g,n=!0){const E=this.doRegisterConfigurations(g,n);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E})}deregisterConfigurations(g){const n=this.doDeregisterConfigurations(g);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:g,remove:n}){const E=[];E.push(...this.doDeregisterConfigurations(n)),E.push(...this.doRegisterConfigurations(g,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,d.distinct)(E)})}registerDefaultConfigurations(g){const n=[],E=[];for(const{overrides:a,source:i}of g)for(const r in a)if(n.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const s={...this.configurationDefaultsOverrides.get(r)?.value||{},...a[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:s});const l={type:"object",default:s,description:A.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:k.isString(i)?void 0:i};E.push(...p(r)),this.configurationProperties[r]=l,this.defaultLanguageConfigurationOverridesNode.properties[r]=l}else{this.configurationDefaultsOverrides.set(r,{value:a[r],source:i});const s=this.configurationProperties[r];s&&(this.updatePropertyDefaultValue(r,s),this.updateSchema(r,s))}this.registerOverrideIdentifiers(E),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(g){const n=[];for(const{overrides:E,source:a}of g)for(const i in E){const r=this.configurationDefaultsOverrides.get(i),s=k.isString(a)?a:a?.id,l=k.isString(r?.source)?r?.source:r?.source?.id;if(s===l)if(n.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const h=this.configurationProperties[i];h&&(this.updatePropertyDefaultValue(i,h),this.updateSchema(i,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const n of g)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,n){const E=[];return g.forEach(a=>{E.push(...this.validateAndRegisterProperties(a,n,a.extensionInfo,a.restrictedProperties)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),E}doDeregisterConfigurations(g){const n=[],E=a=>{if(a.properties)for(const i in a.properties)n.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,a.properties[i]);a.allOf&&a.allOf.forEach(i=>E(i))};for(const a of g){E(a);const i=this.configurationContributors.indexOf(a);i!==-1&&this.configurationContributors.splice(i,1)}return n}validateAndRegisterProperties(g,n=!0,E,a,i=3){i=k.isUndefinedOrNull(g.scope)?i:g.scope;let r=[],s=g.properties;if(s)for(let h in s){if(n&&b(h)){delete s[h];continue}const u=s[h];if(u.source=E,u.defaultDefaultValue=s[h].default,this.updatePropertyDefaultValue(h,u),e.OVERRIDE_PROPERTY_REGEX.test(h)?u.scope=void 0:(u.scope=k.isUndefinedOrNull(u.scope)?i:u.scope,u.restricted=k.isUndefinedOrNull(u.restricted)?!!a?.includes(h):u.restricted),s[h].hasOwnProperty("included")&&!s[h].included){this.excludedConfigurationProperties[h]=s[h],delete s[h];continue}else this.configurationProperties[h]=s[h];!s[h].deprecationMessage&&s[h].markdownDeprecationMessage&&(s[h].deprecationMessage=s[h].markdownDeprecationMessage),r.push(h)}let l=g.allOf;if(l)for(let h of l)r.push(...this.validateAndRegisterProperties(h,n,E,a,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(g){const n=E=>{let a=E.properties;if(a)for(const r in a)this.updateSchema(r,a[r]);let i=E.allOf;i&&i.forEach(n)};n(g)}updateSchema(g,n){switch(e.allSettings.properties[g]=n,n.scope){case 1:e.applicationSettings.properties[g]=n;break;case 2:e.machineSettings.properties[g]=n;break;case 6:e.machineOverridableSettings.properties[g]=n;break;case 3:e.windowSettings.properties[g]=n;break;case 4:e.resourceSettings.properties[g]=n;break;case 5:e.resourceSettings.properties[g]=n,this.resourceLanguageSettingsSchema.properties[g]=n;break}}removeFromSchema(g,n){switch(delete e.allSettings.properties[g],n.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g],delete this.resourceLanguageSettingsSchema.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const n=`[${g}]`,E={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,E),e.allSettings.properties[n]=E,e.applicationSettings.properties[n]=E,e.machineSettings.properties[n]=E,e.machineOverridableSettings.properties[n]=E,e.windowSettings.properties[n]=E,e.resourceSettings.properties[n]=E}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,n){const E=this.configurationDefaultsOverrides.get(g);let a=E?.value,i=E?.source;k.isUndefined(a)&&(a=n.defaultDefaultValue,i=void 0),k.isUndefined(a)&&(a=v(n.type)),n.default=a,n.defaultValueSource=i}}const f="\\[([^\\]]+)\\]",_=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(o){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(o)){let n=_.exec(o);for(;n?.length;){const E=n[1].trim();E&&g.push(E),n=_.exec(o)}}return(0,d.distinct)(g)}e.overrideIdentifiersFromKey=p;function c(o){return o.reduce((g,n)=>`${g}[${n}]`,"")}e.keyFromOverrideIdentifiers=c;function v(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const I=new C;P.Registry.add(e.Extensions.Configuration,I);function b(o){return o.trim()?e.OVERRIDE_PROPERTY_REGEX.test(o)?A.localize(7,null,o):I.getConfigurationProperties()[o]!==void 0?A.localize(8,null,o):null:A.localize(6,null)}e.validateProperty=b;function m(){const o=[],g=I.getConfigurationProperties();for(const n of Object.keys(g))o.push([n,g[n].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.getScopes=m}),define(ve[195],be([1,0,17,3,57,6,24,25,18,2,116,120,50]),function(te,e,d,t,k,A,D,P,y,T,F,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class _{constructor(a={},i=[],r=[]){this._contents=a,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(a){return a?(0,F.getConfigurationValue)(this.contents,a):this.contents}getOverrideValue(a,i){const r=this.getContentsForOverrideIdentifer(i);return r?a?(0,F.getConfigurationValue)(r,a):r:void 0}getKeysForOverrideIdentifier(a){const i=[];for(const r of this.overrides)r.identifiers.includes(a)&&i.push(...r.keys);return d.distinct(i)}getAllOverrideIdentifiers(){const a=[];for(const i of this.overrides)a.push(...i.identifiers);return d.distinct(a)}override(a){let i=this.overrideConfigurations.get(a);return i||(i=this.createOverrideConfigurationModel(a),this.overrideConfigurations.set(a,i)),i}merge(...a){const i=P.deepClone(this.contents),r=P.deepClone(this.overrides),s=[...this.keys];for(const l of a){this.mergeContents(i,l.contents);for(const h of l.overrides){const[u]=r.filter(w=>d.equals(w.identifiers,h.identifiers));u?(this.mergeContents(u.contents,h.contents),u.keys.push(...h.keys),u.keys=d.distinct(u.keys)):r.push(P.deepClone(h))}for(const h of l.keys)s.indexOf(h)===-1&&s.push(h)}return new _(i,s,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(a){const i=this.getContentsForOverrideIdentifer(a);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const s of d.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[s],h=i[s];h&&(typeof l=="object"&&typeof h=="object"?(l=P.deepClone(l),this.mergeContents(l,h)):l=h),r[s]=l}return new _(r,this.keys,this.overrides)}mergeContents(a,i){for(const r of Object.keys(i)){if(r in a&&y.isObject(a[r])&&y.isObject(i[r])){this.mergeContents(a[r],i[r]);continue}a[r]=P.deepClone(i[r])}}checkAndFreeze(a){return this.isFrozen&&!Object.isFrozen(a)?P.deepFreeze(a):a}getContentsForOverrideIdentifer(a){let i=null,r=null;const s=l=>{l&&(r?this.mergeContents(r,l):r=P.deepClone(l))};for(const l of this.overrides)d.equals(l.identifiers,[a])?i=l.contents:l.identifiers.includes(a)&&s(l.contents);return s(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(a,i){this.addKey(a),(0,F.addToValueTree)(this.contents,a,i,r=>{throw new Error(r)})}removeValue(a){this.removeKey(a)&&(0,F.removeFromValueTree)(this.contents,a)}addKey(a){let i=this.keys.length;for(let r=0;r<i;r++)a.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,a)}removeKey(a){let i=this.keys.indexOf(a);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=_;class p extends _{constructor(a={}){const i=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),s=Object.create(null),l=[];for(const h in i){const u=a[h],w=u!==void 0?u:i[h].default;(0,F.addToValueTree)(s,h,w,R=>console.error(`Conflict in default settings: ${R}`))}for(const h of Object.keys(s))C.OVERRIDE_PROPERTY_REGEX.test(h)&&l.push({identifiers:(0,C.overrideIdentifiersFromKey)(h),keys:Object.keys(s[h]),contents:(0,F.toValuesTree)(s[h],u=>console.error(`Conflict in default settings file: ${u}`))});super(s,r,l)}}e.DefaultConfigurationModel=p;class c{constructor(a){this._name=a,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new _}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(a,i){if(!y.isUndefinedOrNull(a)){const r=this.doParseContent(a);this.parseRaw(r,i)}}reparse(a){this._raw&&this.parseRaw(this._raw,a)}parseRaw(a,i){this._raw=a;const{contents:r,keys:s,overrides:l,restricted:h}=this.doParseRaw(a,i);this._configurationModel=new _(r,s,l),this._restrictedConfigurations=h||[]}doParseContent(a){let i={},r=null,s=[],l=[],h=[];function u(R){Array.isArray(s)?s.push(R):r!==null&&(s[r]=R)}let w={onObjectBegin:()=>{let R={};u(R),l.push(s),s=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let R=[];u(R),l.push(s),s=R,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:u,onError:(R,O,L)=>{h.push({error:R,offset:O,length:L})}};if(a)try{k.visit(a,w),i=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return i}doParseRaw(a,i){const r=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(a,r,!0,i);a=s.raw;const l=(0,F.toValuesTree)(a,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),h=Object.keys(a),u=this.toOverrides(a,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:l,keys:h,overrides:u,restricted:s.restricted}}filter(a,i,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:a,restricted:[]};const l={},h=[];for(let u in a)if(C.OVERRIDE_PROPERTY_REGEX.test(u)&&r){const w=this.filter(a[u],i,!1,s);l[u]=w.raw,h.push(...w.restricted)}else{const w=i[u],R=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&h.push(u),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&(s.skipRestricted&&w?.restricted||(l[u]=a[u]))}return{raw:l,restricted:h}}toOverrides(a,i){const r=[];for(const s of Object.keys(a))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const h in a[s])l[h]=a[s][h];r.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,F.toValuesTree)(l,i)})}return r}}e.ConfigurationModelParser=c;class v extends A.Disposable{constructor(a,i,r,s){super();this.userSettingsResource=a,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const a=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(a.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new _}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class I{constructor(a,i,r=new _,s=new _,l=new D.ResourceMap,h=new _,u=new D.ResourceMap,w=!0){this._defaultConfiguration=a,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=h,this._memoryConfigurationByResource=u,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(a,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(a)}updateValue(a,i,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new _,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(a):s.setValue(a,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(a,i,r){const s=this.getConsolidateConfigurationModel(i,r),l=this.getFolderConfigurationModelForResource(i.resource,r),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,u=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this._defaultConfiguration.freeze().getValue(a),w=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.userConfiguration.freeze().getValue(a),R=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.localUserConfiguration.freeze().getValue(a),O=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.remoteUserConfiguration.freeze().getValue(a),L=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this._workspaceConfiguration.freeze().getValue(a):void 0,S=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(a):l.freeze().getValue(a):void 0,U=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(a):h.getValue(a),M=s.getValue(a),X=d.distinct(d.flatten(s.overrides.map(G=>G.identifiers))).filter(G=>s.getOverrideValue(a,G)!==void 0);return{defaultValue:u,userValue:w,userLocalValue:R,userRemoteValue:O,workspaceValue:L,workspaceFolderValue:S,memoryValue:U,value:M,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,workspaceFolder:S!==void 0?{value:l?.freeze().getValue(a),override:i.overrideIdentifier?l?.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:h.getValue(a),override:i.overrideIdentifier?h.getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:X.length?X:void 0}}keys(a){const i=this.getFolderConfigurationModelForResource(void 0,a);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(a){this._defaultConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(a){this._localUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(a){this._remoteUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(a){this._workspaceConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(a,i){this._folderConfigurations.set(a,i),this._foldersConsolidatedConfigurations.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this._foldersConsolidatedConfigurations.delete(a)}compareAndUpdateDefaultConfiguration(a,i){const r=[];if(!i){const{added:s,updated:l,removed:h}=g(this._defaultConfiguration,a);i=[...s,...l,...h]}for(const s of i)for(const l of(0,C.overrideIdentifiersFromKey)(s)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(l),u=a.getKeysForOverrideIdentifier(l),w=[...u.filter(R=>h.indexOf(R)===-1),...h.filter(R=>u.indexOf(R)===-1),...h.filter(R=>!P.equals(this._defaultConfiguration.override(l).getValue(R),a.override(l).getValue(R)))];r.push([l,w])}return this.updateDefaultConfiguration(a),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(a){const{added:i,updated:r,removed:s,overrides:l}=g(this.localUserConfiguration,a),h=[...i,...r,...s];return h.length&&this.updateLocalUserConfiguration(a),{keys:h,overrides:l}}compareAndUpdateRemoteUserConfiguration(a){const{added:i,updated:r,removed:s,overrides:l}=g(this.remoteUserConfiguration,a);let h=[...i,...r,...s];return h.length&&this.updateRemoteUserConfiguration(a),{keys:h,overrides:l}}compareAndUpdateWorkspaceConfiguration(a){const{added:i,updated:r,removed:s,overrides:l}=g(this.workspaceConfiguration,a);let h=[...i,...r,...s];return h.length&&this.updateWorkspaceConfiguration(a),{keys:h,overrides:l}}compareAndUpdateFolderConfiguration(a,i){const r=this.folderConfigurations.get(a),{added:s,updated:l,removed:h,overrides:u}=g(r,i);let w=[...s,...l,...h];return(w.length||!r)&&this.updateFolderConfiguration(a,i),{keys:w,overrides:u}}compareAndDeleteFolderConfiguration(a){const i=this.folderConfigurations.get(a);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:r,updated:s,removed:l,overrides:h}=g(i,void 0);return{keys:[...r,...s,...l],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(a,i){let r=this.getConsolidatedConfigurationModelForResource(a,i);return a.overrideIdentifier?r.override(a.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:a},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&a){const s=i.getFolder(a);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const l=this._memoryConfigurationByResource.get(a);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(a){let i=this._foldersConsolidatedConfigurations.get(a);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(a);s?(i=r.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(a,i)):i=r}return i}getFolderConfigurationModelForResource(a,i){if(i&&a){const r=i.getFolder(a);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((a,i)=>{const{contents:r,overrides:s,keys:l}=this._folderConfigurations.get(i);return a.push([i,{contents:r,overrides:s,keys:l}]),a},[])}}allKeys(){const a=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>a.add(i)),this.userConfiguration.freeze().keys.forEach(i=>a.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>a.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>a.add(r))),[...a.values()]}allOverrideIdentifiers(){const a=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>a.add(r))),[...a.values()]}getAllKeysForOverrideIdentifier(a){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(a).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(a).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(a).forEach(s=>i.add(s))),[...i.values()]}static parse(a){const i=this.parseConfigurationModel(a.defaults),r=this.parseConfigurationModel(a.user),s=this.parseConfigurationModel(a.workspace),l=a.folders.reduce((h,u)=>(h.set(T.URI.revive(u[0]),this.parseConfigurationModel(u[1])),h),new D.ResourceMap);return new I(i,r,new _,s,l,new _,new D.ResourceMap,!1)}static parseConfigurationModel(a){return new _(a.contents,a.keys,a.overrides).freeze()}}e.Configuration=I;function b(...E){if(E.length===0)return{keys:[],overrides:[]};if(E.length===1)return E[0];const a=new Set,i=new Map;for(const s of E)s.keys.forEach(l=>a.add(l)),s.overrides.forEach(([l,h])=>{const u=(0,D.getOrSet)(i,l,new Set);h.forEach(w=>u.add(w))});const r=[];return i.forEach((s,l)=>r.push([l,[...s.values()]])),{keys:[...a.values()],overrides:r}}e.mergeChanges=b;class m{constructor(a,i,r,s){this.change=a,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;a.keys.forEach(u=>l.add(u)),a.overrides.forEach(([,u])=>u.forEach(w=>l.add(w))),this.affectedKeys=[...l.values()];const h=new _;this.affectedKeys.forEach(u=>h.setValue(u,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(a,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,a)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(a,i,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(a,i,this.currentWorkspace);return!P.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(a,i){let r=(0,F.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(a=a[s],!a)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=m;class o extends m{constructor(a,i,r,s){super({keys:a.allKeys(),overrides:[]},void 0,a,i);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o;function g(E,a){const{added:i,removed:r,updated:s}=n(a,E),l=[],h=E?.getAllOverrideIdentifiers()||[],u=a?.getAllOverrideIdentifiers()||[];if(a){const w=u.filter(R=>!h.includes(R));for(const R of w)l.push([R,a.getKeysForOverrideIdentifier(R)])}if(E){const w=h.filter(R=>!u.includes(R));for(const R of w)l.push([R,E.getKeysForOverrideIdentifier(R)])}if(a&&E){for(const w of h)if(u.includes(w)){const R=n({contents:E.getOverrideValue(void 0,w)||{},keys:E.getKeysForOverrideIdentifier(w)},{contents:a.getOverrideValue(void 0,w)||{},keys:a.getKeysForOverrideIdentifier(w)});l.push([w,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:r,updated:s,overrides:l}}function n(E,a){const i=E?a?E.keys.filter(l=>a.keys.indexOf(l)===-1):[...E.keys]:[],r=a?E?a.keys.filter(l=>E.keys.indexOf(l)===-1):[...a.keys]:[],s=[];if(E&&a){for(const l of a.keys)if(E.keys.indexOf(l)!==-1){const h=(0,F.getConfigurationValue)(a.contents,l),u=(0,F.getConfigurationValue)(E.contents,l);P.equals(h,u)||s.push(l)}}return{added:i,removed:r,updated:s}}}),define(ve[121],be([1,0,4]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var t;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(D,P=t.Unknown,y){super(D);this._message=D,this._code=P,this._detail=y,this.isHandled=P===t.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(D){return D instanceof k&&D._code===t.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof k&&D._code===t.NoResolverFound}static isHandled(D){return D instanceof k&&D.isHandled}}e.RemoteAuthorityResolverError=k}),define(ve[83],be([1,0,10]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(A){return A.scheme===d.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=t;function k(A){if(!A)return;const D=A.indexOf("+");return D<0?A:A.substr(0,D)}e.getRemoteName=k}),define(ve[27],be([1,0,8,4,83]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=A;function D(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class y{constructor(_){this.value=_,this._lower=_.toLowerCase()}static equals(_,p){if(typeof _=="undefined"||_===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof _=="string"||typeof p=="string"){let c=typeof _=="string"?_:_.value,v=typeof p=="string"?p:p.value;return d.equalsIgnoreCase(c,v)}return _._lower===p._lower}static toKey(_){return typeof _=="string"?_.toLowerCase():_._lower}}e.ExtensionIdentifier=y;function T(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function F(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function C(f,_){if(_){const p=`onResolveRemoteAuthority:${(0,k.getRemoteName)(_)}`;return f.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[122],be([1,0,8,27]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(p,c){return p.uuid&&c.uuid?p.uuid===c.uuid:p.id===c.id?!0:(0,d.compareIgnoreCase)(p.id,c.id)===0}e.areSameExtensions=k;class A{constructor(c,v){this.version=v,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof A?k(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=A;function D(p,c){return`${p}.${c}`}e.getExtensionId=D;function P(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function y(p,c){return P(D(p,c))}e.getGalleryExtensionId=y;function T(p,c){const v=[],I=b=>{for(const m of v)if(m.some(o=>k(c(o),c(b))))return m;return null};for(const b of p){const m=I(b);m?m.push(b):v.push([b])}return v}e.groupByExtension=T;function F(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function C(p){return{id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),...p.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function f(p){const c=new Set;if(p.malicious)for(const v of p.malicious)c.add(v.id);return c}e.getMaliciousExtensionsSet=f;function _(p,c){const v=[],I=c.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const b=I.shift();if(b&&v.every(m=>!k(m.identifier,{id:b}))){const m=p.filter(o=>k(o.identifier,{id:b}));m.length===1&&(v.push(m[0]),I.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=_}),define(ve[196],be([1,0,10,162,122,4]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const D=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function P(n){const E=D.exec(n);return E&&E[1]?[(0,k.adoptToGalleryExtensionId)(E[1]),E[2]]:[(0,k.adoptToGalleryExtensionId)(n),void 0]}e.getIdAndVersion=P;var y;(function(n){n.WIN32_X64="win32-x64",n.WIN32_IA32="win32-ia32",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));function T(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function F(n){switch(n){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function C(n,E){switch(n){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function f(n,E){return E==="web"&&!n.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function _(n,E,a){return f(E,a)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===a?!0:p(a).includes(n)}e.isTargetPlatformCompatible=_;function p(n){switch(n){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function c(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=c;var v;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var I;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var b;(function(n){n.Install="install",n.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var m;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var o;(function(n){n.Unsupported="Unsupported",n.UnsupportedPreRelease="UnsupportedPreRelease",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatiblePreRelease="IncompatiblePreRelease",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.Extract="Extract",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Internal="Internal"})(o=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(E,a){super(E);this.code=a,this.name=a}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=d.FileAccess.asBrowserUri("./media/defaultIcon.png",te).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(ve[197],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class d{constructor(){this.validators=new Map}vsda(){return new Promise((k,A)=>te(["vsda"],k,A))}async createNewMessage(k){try{const A=await this.vsda(),D=new A.validator;if(D){const P=String(d._nextId++);return this.validators.set(P,D),{id:P,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,A){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(A)==="ok"}catch{return!1}}async sign(k){try{const A=await this.vsda(),D=new A.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=d,d._nextId=1}),define(ve[198],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,A,D=5){let P;return P=A(y=>{const T=typeof y=="string"?y:y.data;let F=this._terminalBufferMap.get(k);if(F){F.data.push(T);return}const C=setTimeout(()=>this.flushBuffer(k),D);F={data:[T],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(k),P.dispose()}},this._terminalBufferMap.set(k,F)}),P}stopBuffering(k){const A=this._terminalBufferMap.get(k);A&&A.dispose()}flushBuffer(k){const A=this._terminalBufferMap.get(k);A&&(this._terminalBufferMap.delete(k),this._callback(k,A.data.join("")))}}e.TerminalDataBufferer=d}),define(ve[199],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(ve[84],be([1,0,73,3,6,4,50,199]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var y;(function(v){function I(b){return b&&typeof b=="object"&&typeof b.id=="string"}v.isThemeColor=I})(y=e.ThemeColor||(e.ThemeColor={}));function T(v){return{id:v}}e.themeColorFromId=T;var F;(function(v){function I(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||y.isThemeColor(i.color))}v.isThemeIcon=I;const b=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function m(i){const r=b.exec(i);if(!r)return;let[,s]=r;return{id:s}}v.fromString=m;function o(i){return{id:i}}v.fromId=o;function g(i,r){let s=i.id;const l=s.lastIndexOf("~");return l!==-1&&(s=s.substring(0,l)),r&&(s=`${s}~${r}`),{id:s}}v.modify=g;function n(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}v.getModifier=n;function E(i,r){return i.id===r.id&&i.color?.id===r.color?.id}v.isEqual=E;function a(i,r){return{id:i.id,color:r?T(r):void 0}}v.asThemeIcon=a,v.asClassNameArray=d.CSSIcon.asClassNameArray,v.asClassName=d.CSSIcon.asClassName,v.asCSSSelector=d.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function C(v){switch(v){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,k.toDisposable)(()=>{const b=this.themingParticipants.indexOf(I);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let _=new f;D.Registry.add(e.Extensions.ThemingContribution,_);function p(v){return _.onColorThemeChange(v)}e.registerThemingParticipant=p;class c extends k.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,b){let m=this.theme.getColor(I);return m&&b&&(m=b(m,this.theme)),m?m.toString():null}}e.Themable=c}),define(ve[123],be([1,0,3,11,4,12]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(p){p.Http="http",p.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=C;function f(p,c){return c?c!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=f;let _=class{constructor(c){this.logService=c,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c){return this._tunnelProvider=c,c?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this._canElevate=c.elevation,this._privacyOptions=c.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],v=Array.from(this._tunnels.values());for(let I of v){const b=Array.from(I.values());for(let m of b){const o=await m.value;o&&c.push(o)}}return c}async dispose(){for(const c of this._tunnels.values()){for(const{value:v}of c.values())await v.then(I=>I?.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,v,I,b,m=!1,o=P.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${I} on local port ${b}.`),!c)return;v||(v="localhost");const n=this.retainOrCreateTunnel(c,v,I,b,m,o,g);return n?n.then(E=>{if(!E){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(E);return(E.tunnelRemoteHost!==v||E.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const v=this._tunnels.get(c.tunnelRemoteHost);if(v){const I=v.get(c.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,I))}}}}async tryDisposeTunnel(c,v,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${v}.`);const b=I.value.then(async m=>{m&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(v),b}}async closeTunnel(c,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${v} `);const I=this._tunnels.get(c);if(I&&I.has(v)){const b=I.get(v);b.refcount=0,await this.tryDisposeTunnel(c,v,b)}}addTunnelToMap(c,v,I){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(v,{refcount:1,value:I})}async removeEmptyTunnelFromMap(c,v){const I=this._tunnels.get(c);I&&(await I.get(v)||I.delete(v),I.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,v){let I=[c];F(c)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):C(c)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const b=I.map(m=>this._tunnels.get(m));for(const m of b){const o=m?.get(v);if(o)return o}}canTunnel(c){return!!T(c)}createWithProvider(c,v,I,b,m,o,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${I} on local port ${b}.`);const E={elevationRequired:m?f(b===void 0?I:b):!1},a={remoteAddress:{host:v,port:I},localAddressPort:b,privacy:o,public:o!==P.Private,protocol:g},i=c.forwardPort(a,E);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(v,I,i),i}};_=Be([Fe(0,A.ILogService)],_),e.AbstractTunnelService=_}),define(ve[200],be([1,0,10]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(P){return P.scheme!==d.Schemas.file&&P.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=t;function k(P){if(P.folders.length)return P.folders.every(y=>t(y.uri))?P.folders[0].uri:void 0;if(P.configuration&&t(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=k;function A(P){return k(P)?.scheme}e.getVirtualWorkspaceScheme=A;function D(P){return k(P)!==void 0}e.isVirtualWorkspace=D}),define(ve[43],be([1,0,24,22,2,4]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var D;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function P(f){const _=f;return!!(_&&typeof _=="object"&&typeof _.id=="string"&&Array.isArray(_.folders))}e.isWorkspace=P;function y(f){const _=f;return!!(_&&typeof _=="object"&&k.URI.isUri(_.uri)&&typeof _.name=="string"&&typeof _.toResource=="function")}e.isWorkspaceFolder=y;class T{constructor(_,p,c,v,I){this._id=_,this._transient=c,this._configuration=v,this._ignorePathCasing=I,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=p}update(_){this._id=_.id,this._configuration=_.configuration,this._transient=_.transient,this._ignorePathCasing=_._ignorePathCasing,this.folders=_.folders}get folders(){return this._folders}set folders(_){this._folders=_,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(_){this._configuration=_}getFolder(_){return _&&this._foldersMap.findSubstr(_.with({scheme:_.scheme,authority:_.authority,path:_.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const _ of this.folders)this._foldersMap.set(_.uri,_)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class F{constructor(_,p){this.raw=p,this.uri=_.uri,this.index=_.index,this.name=_.name}toResource(_){return(0,t.joinPath)(this.uri,_)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function C(f){return new F({uri:f,index:0,name:(0,t.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=C}),define(ve[201],be([1,0,28,57,143,79,10,9,11,22,2,167,4,83,43]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const c=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(q){return(typeof q=="string"?(0,P.extname)(q):(0,T.extname)(q))===c}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,f.createDecorator)("workspacesService");function I(q){return q.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function b(q){return q.hasOwnProperty("folderUri")}e.isRecentFolder=b;function m(q){return q.hasOwnProperty("fileUri")}e.isRecentFile=m;function o(q){return q&&q.hasOwnProperty("folderUri")}e.isFolderBackupInfo=o;function g(q){return q&&q.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=g;function n(q){const B=q;return typeof B?.id=="string"&&F.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=n;function E(q){if(q.configuration)return{id:q.id,configPath:q.configuration};if(q.folders.length===1)return{id:q.id,uri:q.folders[0].uri}}e.toWorkspaceIdentifier=E;function a(q){const B=q;return typeof B?.id=="string"&&F.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=a;function i(q){const B=q;if(B?.uri)return{id:B.id,uri:F.URI.revive(B.uri)};const x=q;if(x?.configPath)return{id:x.id,configPath:F.URI.revive(x.configPath)};if(q?.id)return{id:q.id}}e.reviveIdentifier=i;function r(q,B){return T.extUriBiasedIgnorePathCase.isEqualOrParent(q,B.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function s(q){return l(q)||h(q)}e.isStoredWorkspaceFolder=s;function l(q){const B=q;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=l;function h(q){const B=q;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=h;function u(q,B,x,j,V=!y.isWindows,Z){if(q.scheme!==j.scheme)return{name:x,uri:q.toString(!0)};let se=B?void 0:Z.relativePath(j,q);if(se!==void 0)se.length===0?se=".":y.isWindows&&q.scheme===D.Schemas.file&&!V&&(se=se.replace(/\//g,"\\"));else if(q.scheme===D.Schemas.file)se=q.fsPath,y.isWindows&&(se=(0,A.normalizeDriveLetter)(se),V&&(se=(0,d.toSlashes)(se)));else{if(!Z.isEqualAuthority(q.authority,j.authority))return{name:x,uri:q.toString(!0)};se=q.path}return{name:x,path:se}}e.getStoredWorkspaceFolder=u;function w(q,B,x){let j=[],V=new Set;const Z=x.dirname(B);for(let se of q){let ce;if(l(se))se.path&&(ce=x.resolvePath(Z,se.path));else if(h(se))try{ce=F.URI.parse(se.uri),ce.path[0]!=="/"&&(ce=ce.with({path:"/"+ce.path}))}catch(ee){console.warn(ee)}if(ce){let ee=x.getComparisonKey(ce);if(!V.has(ee)){V.add(ee);const Y=se.name||x.basenameOrAuthority(ce);j.push(new p.WorkspaceFolder({uri:ce,name:Y,index:j.length},se))}}}return j}e.toWorkspaceFolders=w;function R(q,B,x,j,V){let Z=O(B,q);const se=V.dirname(B),ce=V.dirname(j),ee=[],Y=L(Z.folders);for(const ke of Z.folders){const Ne=l(ke)?V.resolvePath(se,ke.path):F.URI.parse(ke.uri);let _e;x?_e=!1:_e=!l(ke)||(0,P.isAbsolute)(ke.path),ee.push(u(Ne,_e,ke.name,ce,Y,V))}const ae={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},he=k.setProperty(q,["folders"],ee,ae);let we=k.applyEdits(q,he);return(0,T.isEqualAuthority)(Z.remoteAuthority,(0,_.getRemoteAuthority)(j))&&(we=k.applyEdits(we,k.removeProperty(we,["remoteAuthority"],ae))),we}e.rewriteWorkspaceFileForNewLocation=R;function O(q,B){let x=t.parse(B);if(x&&Array.isArray(x.folders))x.folders=x.folders.filter(j=>s(j));else throw new Error(`${q} looks like an invalid workspace file.`);return x}function L(q){return y.isWindows?q.some(B=>l(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function S(q){return q.workspace&&typeof q.workspace=="object"&&typeof q.workspace.id=="string"&&typeof q.workspace.configPath=="string"}function U(q){return typeof q.folderUri=="string"}function M(q){return typeof q.fileUri=="string"}function X(q,B){const x={workspaces:[],files:[]};if(q){const j=function(Z,se){for(let ce=0;ce<Z.length;ce++)try{se(Z[ce],ce)}catch(ee){B.warn(`Error restoring recent entry ${JSON.stringify(Z[ce])}: ${ee.toString()}. Skip entry.`)}},V=q;if(Array.isArray(V.entries))j(V.entries,Z=>{const se=Z.label,ce=Z.remoteAuthority;S(Z)?x.workspaces.push({label:se,remoteAuthority:ce,workspace:{id:Z.workspace.id,configPath:F.URI.parse(Z.workspace.configPath)}}):U(Z)?x.workspaces.push({label:se,remoteAuthority:ce,folderUri:F.URI.parse(Z.folderUri)}):M(Z)&&x.files.push({label:se,remoteAuthority:ce,fileUri:F.URI.parse(Z.fileUri)})});else{const Z=q;Array.isArray(Z.workspaces3)&&j(Z.workspaces3,(se,ce)=>{const ee=Array.isArray(Z.workspaceLabels)&&Z.workspaceLabels[ce]||void 0;typeof se=="object"&&typeof se.id=="string"&&typeof se.configURIPath=="string"?x.workspaces.push({label:ee,workspace:{id:se.id,configPath:F.URI.parse(se.configURIPath)}}):typeof se=="string"&&x.workspaces.push({label:ee,folderUri:F.URI.parse(se)})}),Array.isArray(Z.files2)&&j(Z.files2,(se,ce)=>{const ee=Array.isArray(Z.fileLabels)&&Z.fileLabels[ce]||void 0;typeof se=="string"&&x.files.push({label:ee,fileUri:F.URI.parse(se)})})}}return x}e.restoreRecentlyOpened=X;function G(q){const B={entries:[]};for(const x of q.workspaces)b(x)?B.entries.push({folderUri:x.folderUri.toString(),label:x.label,remoteAuthority:x.remoteAuthority}):B.entries.push({workspace:{id:x.workspace.id,configPath:x.workspace.configPath.toString()},label:x.label,remoteAuthority:x.remoteAuthority});for(const x of q.files)B.entries.push({fileUri:x.fileUri.toString(),label:x.label,remoteAuthority:x.remoteAuthority});return B}e.toStoreData=G}),define(ve[85],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const A=this._idPool++;return this._data.set(A,k),this.logDebugInfo(),A}get(k,A){return this._data.has(k)?this._data.get(k)[A]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(ve[44],be([1,0,10,22,4]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(P=>{const y=this._providerInfo.get(P.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(P,y){y===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,y)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(ve[26],be([1,0,4]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(ve[202],be([1,0,13]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(D,P,y){this._deferredPromises=new Map,this._id=D,this._shared=P,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of T.values())F.complete()}catch(F){for(const C of T.values())C.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(D,P){let y=this._value[D];return typeof y=="undefined"&&(y=P),y}update(D,P){this._value[D]=P;let y=this._deferredPromises.get(D);if(y!==void 0)return y.p;const T=new d.DeferredPromise;return this._deferredPromises.set(D,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class k extends t{constructor(D,P){super(D.identifier.value,!0,P);this._extension=D}setKeysForSync(D){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},D)}}e.ExtensionGlobalMemento=k}),define(ve[203],be([1,0,3,2,12]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(P,y){this._logService=P,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,y,T){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptModelChanged(y.value,T)}$acceptDirtyStateChanged(P,y){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptDirty(y)}$acceptModelSaved(P){const y=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(P,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,y);const T=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));T.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=Be([Fe(0,k.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(ve[14],be([1,0,4]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[204],be([1,0,27,3]),function(te,e,d,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,y){k.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(P.identifier),Ke(this,k,y,"f"),Te(this,k,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(P){return Te(this,k,"f").get(this._id,P)}store(P,y){return Te(this,k,"f").store(this._id,P,y)}delete(P){return Te(this,k,"f").delete(this._id,P)}}e.ExtensionSecrets=A,k=new WeakMap}),define(ve[124],be([1,0,4,3]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(D){this._level=D}$onDidChangeTelemetryLevel(D){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=D,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(ve[63],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,k=(b,m)=>{const o={controllerId:m};return t.set(b,o),o};e.createPrivateApiFor=k;const A=b=>t.get(b);e.getPrivateApiFor=A;const D=(b,m,o,g)=>{let n=o;return{enumerable:!0,configurable:!1,get(){return n},set(E){if(!g(n,E)){const a=n;n=E,b.listener?.({op:3,key:m,value:E,previous:a})}}}},P=(b,m)=>b===m,y={range:(b,m)=>b===m?!0:!b||!m?!1:b.isEqual(m),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(b,m)=>!(b.length!==m.length||b.some(o=>!m.find(g=>o.id===g.id)))},T=Object.keys(y),F=(b,m)=>({range:D(b,"range",void 0,y.range),label:D(b,"label",m,y.label),description:D(b,"description",void 0,y.description),sortText:D(b,"sortText",void 0,y.sortText),canResolveChildren:D(b,"canResolveChildren",!1,y.canResolveChildren),busy:D(b,"busy",!1,y.busy),error:D(b,"error",void 0,y.error),tags:D(b,"tags",[],y.tags)}),C=(b,m)=>{const o=new Map;for(const g of T)y[g](b[g],m[g])||o.set(g,m[g]);return o};e.diffTestItems=C;class f extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=f;class _ extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=_;class p extends Error{constructor(m,o,g){super(`TestItem with ID "${m}" is from controller "${o}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=p;const c=b=>{const m=(0,e.getPrivateApiFor)(b);let o=new Map;return{get size(){return o.size},forEach(g,n){for(const E of o.values())g.call(n,E,this)},replace(g){const n=new Map,E=new Set(o.keys()),a={op:4,ops:[]};for(const i of g){if(!(i instanceof v))throw new _(i.id);const r=(0,e.getPrivateApiFor)(i).controllerId;if(r!==m.controllerId)throw new p(i.id,r,m.controllerId);if(n.has(i.id))throw new f(i.id);n.set(i.id,i),E.delete(i.id),a.ops.push({op:0,item:i})}for(const i of E.keys())a.ops.push({op:1,id:i});m.listener?.(a),o=n},add(g){if(!(g instanceof v))throw new _(g.id);o.set(g.id,g),m.listener?.({op:0,item:g})},delete(g){o.delete(g)&&m.listener?.({op:1,id:g})},get(g){return o.get(g)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class v{constructor(m,o,g,n){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const E=(0,e.createPrivateApiFor)(this,m);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return E.parent instanceof I?void 0:E.parent}},children:{value:c(this),enumerable:!0,writable:!1},...F(E,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class I extends v{constructor(m,o){super(m,m,o,void 0)}}e.TestItemRootImpl=I}),define(ve[51],be([1,0,4,123,3,14]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var D;(function(y){function T(C){return{remoteAddress:C.remoteAddress,localAddress:C.localAddress,public:!!C.public,privacy:C.privacy??(C.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:C.protocol}}y.fromApiTunnel=T;function F(C){return{remoteAddress:{host:C.tunnelRemoteHost,port:C.tunnelRemotePort},localAddress:C.localAddress,public:C.privacy!==t.TunnelPrivacyId.ConstantPrivate&&C.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:C.privacy,protocol:C.protocol}}y.fromServiceTunnel=F})(D=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let P=class{constructor(T){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,F){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,F){return{dispose:()=>{}}}async $providePortAttributes(T,F,C,f,_){return[]}async $forwardPort(T,F){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=Be([Fe(0,A.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[7],be([1,0,17,16,101,24,94,8,18,2,33,42,121]),function(te,e,d,t,k,A,D,P,y,T,F,C,f){"use strict";var _,p,c,v,I,b,m,o,g,n,E,a,i,r,s,l,h,u,w,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O(Q){function H(){return Reflect.construct(Q,arguments,this.constructor)}return Object.defineProperty(H,"name",Object.getOwnPropertyDescriptor(Q,"name")),Object.setPrototypeOf(H,Q),Object.setPrototypeOf(H.prototype,Q.prototype),H}let L=I=class{constructor(H){_.set(this,void 0),Ke(this,_,H,"f")}static from(...H){let ue=H;return new I(function(){if(ue){for(const De of ue)De&&typeof De.dispose=="function"&&De.dispose();ue=void 0}})}dispose(){typeof Te(this,_,"f")=="function"&&(Te(this,_,"f").call(this),Ke(this,_,void 0,"f"))}};_=new WeakMap,L=I=Be([O],L),e.Disposable=L;let S=b=class{constructor(H,ue){if(H<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=H,this._character=ue}static Min(...H){if(H.length===0)throw new TypeError;let ue=H[0];for(let De=1;De<H.length;De++){const qe=H[De];qe.isBefore(ue)&&(ue=qe)}return ue}static Max(...H){if(H.length===0)throw new TypeError;let ue=H[0];for(let De=1;De<H.length;De++){const qe=H[De];qe.isAfter(ue)&&(ue=qe)}return ue}static isPosition(H){if(!H)return!1;if(H instanceof b)return!0;let{line:ue,character:De}=H;return typeof ue=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,ue=0){if(H===null||ue===null)throw(0,t.illegalArgument)();let De;return typeof H=="undefined"?De=0:typeof H=="number"?De=H:(De=typeof H.lineDelta=="number"?H.lineDelta:0,ue=typeof H.characterDelta=="number"?H.characterDelta:0),De===0&&ue===0?this:new b(this.line+De,this.character+ue)}with(H,ue=this.character){if(H===null||ue===null)throw(0,t.illegalArgument)();let De;return typeof H=="undefined"?De=this.line:typeof H=="number"?De=H:(De=typeof H.line=="number"?H.line:this.line,ue=typeof H.character=="number"?H.character:this.character),De===this.line&&ue===this.character?this:new b(De,ue)}toJSON(){return{line:this.line,character:this.character}}};S=b=Be([O],S),e.Position=S;let U=m=class{constructor(H,ue,De,qe){let Xe,Ze;if(typeof H=="number"&&typeof ue=="number"&&typeof De=="number"&&typeof qe=="number"?(Xe=new S(H,ue),Ze=new S(De,qe)):H instanceof S&&ue instanceof S&&(Xe=H,Ze=ue),!Xe||!Ze)throw new Error("Invalid arguments");Xe.isBefore(Ze)?(this._start=Xe,this._end=Ze):(this._start=Ze,this._end=Xe)}static isRange(H){return H instanceof m?!0:H?S.isPosition(H.start)&&S.isPosition(H.end):!1}get start(){return this._start}get end(){return this._end}contains(H){return H instanceof m?this.contains(H._start)&&this.contains(H._end):H instanceof S?!(H.isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const ue=S.Max(H.start,this._start),De=S.Min(H.end,this._end);if(!ue.isAfter(De))return new m(ue,De)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const ue=S.Min(H.start,this._start),De=S.Max(H.end,this.end);return new m(ue,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,ue=this.end){if(H===null||ue===null)throw(0,t.illegalArgument)();let De;return H?S.isPosition(H)?De=H:(De=H.start||this.start,ue=H.end||this.end):De=this.start,De.isEqual(this._start)&&ue.isEqual(this.end)?this:new m(De,ue)}toJSON(){return[this.start,this.end]}};U=m=Be([O],U),e.Range=U;let M=o=class extends U{constructor(H,ue,De,qe){let Xe,Ze;if(typeof H=="number"&&typeof ue=="number"&&typeof De=="number"&&typeof qe=="number"?(Xe=new S(H,ue),Ze=new S(De,qe)):H instanceof S&&ue instanceof S&&(Xe=H,Ze=ue),!Xe||!Ze)throw new Error("Invalid arguments");super(Xe,Ze);this._anchor=Xe,this._active=Ze}static isSelection(H){return H instanceof o?!0:H?U.isRange(H)&&S.isPosition(H.anchor)&&S.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=o=Be([O],M),e.Selection=M;class X{constructor(H,ue,De){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,t.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(ue),this.connectionToken=De}}e.ResolvedAuthority=X;class G extends Error{constructor(H,ue=f.RemoteAuthorityResolverErrorCode.Unknown,De){super(H);this._message=H,this._code=ue,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,G.prototype)}static NotAvailable(H,ue){return new G(H,f.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(H){return new G(H,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=G;var q;(function(Q){Q[Q.LF=1]="LF",Q[Q.CRLF=2]="CRLF"})(q=e.EndOfLine||(e.EndOfLine={}));var B;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Append=2]="Append",Q[Q.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let x=g=class{constructor(H,ue){this._range=H,this._newText=ue}static isTextEdit(H){return H instanceof g?!0:H?U.isRange(H)&&typeof H.newText=="string":!1}static replace(H,ue){return new g(H,ue)}static insert(H,ue){return g.replace(new U(H,H),ue)}static delete(H){return g.replace(H,"")}static setEndOfLine(H){const ue=new g(new U(new S(0,0),new S(0,0)),"");return ue.newEol=H,ue}get range(){return this._range}set range(H){if(H&&!U.isRange(H))throw(0,t.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,t.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,t.illegalArgument)("newEol");this._newEol=H}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};x=g=Be([O],x),e.TextEdit=x;var j;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.Cell=3]="Cell",Q[Q.CellReplace=5]="CellReplace"})(j=e.FileEditType||(e.FileEditType={}));let V=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,ue,De,qe){this._edits.push({_type:1,from:H,to:ue,options:De,metadata:qe})}createFile(H,ue,De){this._edits.push({_type:1,from:void 0,to:H,options:ue,metadata:De})}deleteFile(H,ue,De){this._edits.push({_type:1,from:H,to:void 0,options:ue,metadata:De})}replaceNotebookMetadata(H,ue,De){this._edits.push({_type:3,metadata:De,uri:H,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(H,ue,De,qe,Xe){let Ze,it,Dt=[],Lt;if(Qt.isNotebookRange(ue)&&zt.isNotebookCellDataArray(De)&&!zt.isNotebookCellDataArray(qe)?(Ze=ue.start,it=ue.end,Dt=De,Lt=qe):typeof ue=="number"&&typeof De=="number"&&zt.isNotebookCellDataArray(qe)&&(Ze=ue,it=De,Dt=qe,Lt=Xe),Ze===void 0||it===void 0)throw new Error("Invalid arguments");(Ze!==it||Dt.length>0)&&this._edits.push({_type:5,uri:H,index:Ze,count:it-Ze,cells:Dt,metadata:Lt})}replaceNotebookCellMetadata(H,ue,De,qe){this._edits.push({_type:3,metadata:qe,uri:H,edit:{editType:8,index:ue,metadata:De}})}replace(H,ue,De,qe){this._edits.push({_type:2,uri:H,edit:new x(ue,De),metadata:qe})}insert(H,ue,De,qe){this.replace(H,new U(ue,ue),De,qe)}delete(H,ue,De){this.replace(H,ue,"",De)}has(H){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===H.toString())}set(H,ue){if(ue)for(const De of ue)De&&this._edits.push({_type:2,uri:H,edit:De});else{for(let De=0;De<this._edits.length;De++){const qe=this._edits[De];qe._type===2&&qe.uri.toString()===H.toString()&&(this._edits[De]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(H){const ue=[];for(let De of this._edits)De._type===2&&De.uri.toString()===H.toString()&&ue.push(De.edit);return ue}entries(){const H=new A.ResourceMap;for(let ue of this._edits)if(ue._type===2){let De=H.get(ue.uri);De||(De=[ue.uri,[]],H.set(ue.uri,De)),De[1].push(ue.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};V=Be([O],V),e.WorkspaceEdit=V;let Z=n=class{constructor(H){this._tabstop=1,this.value=H||""}static isSnippetString(H){return H instanceof n?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}appendText(H){return this.value+=n._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,ue=this._tabstop++){if(typeof H=="function"){const De=new n;De._tabstop=this._tabstop,H(De),this._tabstop=De._tabstop,H=De.value}else H=n._escape(H);return this.value+="${",this.value+=ue,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,ue=this._tabstop++){const De=H.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(H,ue){if(typeof ue=="function"){const De=new n;De._tabstop=this._tabstop,ue(De),this._tabstop=De._tabstop,ue=De.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};Z=n=Be([O],Z),e.SnippetString=Z;var se;(function(Q){Q[Q.Unnecessary=1]="Unnecessary",Q[Q.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var ce;(function(Q){Q[Q.Hint=3]="Hint",Q[Q.Information=2]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=0]="Error"})(ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ee=E=class{constructor(H,ue){if(this.uri=H,ue)if(ue instanceof U)this.range=ue;else if(ue instanceof S)this.range=new U(ue,ue);else throw new Error("Illegal argument")}static isLocation(H){return H instanceof E?!0:H?U.isRange(H.range)&&T.URI.isUri(H.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ee=E=Be([O],ee),e.Location=ee;let Y=class{constructor(H,ue){this.location=H,this.message=ue}static is(H){return H?typeof H.message=="string"&&H.location&&U.isRange(H.location.range)&&T.URI.isUri(H.location.uri):!1}static isEqual(H,ue){return H===ue?!0:!H||!ue?!1:H.message===ue.message&&H.location.range.isEqual(ue.location.range)&&H.location.uri.toString()===ue.location.uri.toString()}};Y=Be([O],Y),e.DiagnosticRelatedInformation=Y;let ae=class{constructor(H,ue,De=ce.Error){if(!U.isRange(H))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=H,this.message=ue,this.severity=De}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,ue){return H===ue?!0:!H||!ue?!1:H.message===ue.message&&H.severity===ue.severity&&H.code===ue.code&&H.severity===ue.severity&&H.source===ue.source&&H.range.isEqual(ue.range)&&(0,d.equals)(H.tags,ue.tags)&&(0,d.equals)(H.relatedInformation,ue.relatedInformation,Y.isEqual)}};ae=Be([O],ae),e.Diagnostic=ae;let he=class{constructor(H,ue){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=ue}};he=Be([O],he),e.Hover=he;var we;(function(Q){Q[Q.Text=0]="Text",Q[Q.Read=1]="Read",Q[Q.Write=2]="Write"})(we=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ke=class{constructor(H,ue=we.Text){this.range=H,this.kind=ue}toJSON(){return{range:this.range,kind:we[this.kind]}}};ke=Be([O],ke),e.DocumentHighlight=ke;var Ne;(function(Q){Q[Q.File=0]="File",Q[Q.Module=1]="Module",Q[Q.Namespace=2]="Namespace",Q[Q.Package=3]="Package",Q[Q.Class=4]="Class",Q[Q.Method=5]="Method",Q[Q.Property=6]="Property",Q[Q.Field=7]="Field",Q[Q.Constructor=8]="Constructor",Q[Q.Enum=9]="Enum",Q[Q.Interface=10]="Interface",Q[Q.Function=11]="Function",Q[Q.Variable=12]="Variable",Q[Q.Constant=13]="Constant",Q[Q.String=14]="String",Q[Q.Number=15]="Number",Q[Q.Boolean=16]="Boolean",Q[Q.Array=17]="Array",Q[Q.Object=18]="Object",Q[Q.Key=19]="Key",Q[Q.Null=20]="Null",Q[Q.EnumMember=21]="EnumMember",Q[Q.Struct=22]="Struct",Q[Q.Event=23]="Event",Q[Q.Operator=24]="Operator",Q[Q.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var _e;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(_e=e.SymbolTag||(e.SymbolTag={}));let Ee=a=class{constructor(H,ue,De,qe,Xe){this.name=H,this.kind=ue,this.containerName=Xe,typeof De=="string"&&(this.containerName=De),qe instanceof ee?this.location=qe:De instanceof U&&(this.location=new ee(qe,De)),a.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};Ee=a=Be([O],Ee),e.SymbolInformation=Ee;let z=i=class{constructor(H,ue,De,qe,Xe){this.name=H,this.detail=ue,this.kind=De,this.range=qe,this.selectionRange=Xe,this.children=[],i.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children&&H.children.forEach(i.validate)}};z=i=Be([O],z),e.DocumentSymbol=z;var W;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.Automatic=2]="Automatic"})(W=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let N=class{constructor(H,ue){this.title=H,this.kind=ue}};N=Be([O],N),e.CodeAction=N;let $=r=class{constructor(H){this.value=H}append(H){return new r(this.value?this.value+r.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+r.sep)}};$.sep=".",$=r=Be([O],$),e.CodeActionKind=$,$.Empty=new $(""),$.QuickFix=$.Empty.append("quickfix"),$.Refactor=$.Empty.append("refactor"),$.RefactorExtract=$.Refactor.append("extract"),$.RefactorInline=$.Refactor.append("inline"),$.RefactorRewrite=$.Refactor.append("rewrite"),$.Source=$.Empty.append("source"),$.SourceOrganizeImports=$.Source.append("organizeImports"),$.SourceFixAll=$.Source.append("fixAll");let K=class{constructor(H,ue){if(this.range=H,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};K=Be([O],K),e.SelectionRange=K;class re{constructor(H,ue,De,qe,Xe,Ze){this.kind=H,this.name=ue,this.detail=De,this.uri=qe,this.range=Xe,this.selectionRange=Ze}}e.CallHierarchyItem=re;class de{constructor(H,ue){this.fromRanges=ue,this.from=H}}e.CallHierarchyIncomingCall=de;class ye{constructor(H,ue){this.fromRanges=ue,this.to=H}}e.CallHierarchyOutgoingCall=ye;var Re;(function(Q){Q[Q.Information=0]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=2]="Error"})(Re=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let We=class{constructor(H,ue){this.range=H,this.command=ue}get isResolved(){return!!this.command}};We=Be([O],We),e.CodeLens=We;let $e=s=class{constructor(H,ue=!1){p.set(this,void 0),Ke(this,p,new k.MarkdownString(H,{supportThemeIcons:ue}),"f")}static isMarkdownString(H){return H instanceof s?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}get value(){return Te(this,p,"f").value}set value(H){Te(this,p,"f").value=H}get isTrusted(){return Te(this,p,"f").isTrusted}set isTrusted(H){Te(this,p,"f").isTrusted=H}get supportThemeIcons(){return Te(this,p,"f").supportThemeIcons}set supportThemeIcons(H){Te(this,p,"f").supportThemeIcons=H}get supportHtml(){return Te(this,p,"f").supportHtml}set supportHtml(H){Te(this,p,"f").supportHtml=H}get baseUri(){return Te(this,p,"f").baseUri}set baseUri(H){Te(this,p,"f").baseUri=H}appendText(H){return Te(this,p,"f").appendText(H),this}appendMarkdown(H){return Te(this,p,"f").appendMarkdown(H),this}appendCodeblock(H,ue){return Te(this,p,"f").appendCodeblock(ue??"",H),this}};p=new WeakMap,$e=s=Be([O],$e),e.MarkdownString=$e;let je=class{constructor(H,ue){this.label=H,this.documentation=ue}};je=Be([O],je),e.ParameterInformation=je;let ze=class{constructor(H,ue){this.label=H,this.documentation=ue,this.parameters=[]}};ze=Be([O],ze),e.SignatureInformation=ze;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=Be([O],Ue),e.SignatureHelp=Ue;var Qe;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.TriggerCharacter=2]="TriggerCharacter",Q[Q.ContentChange=3]="ContentChange"})(Qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var nt;(function(Q){Q[Q.Other=0]="Other",Q[Q.Type=1]="Type",Q[Q.Parameter=2]="Parameter"})(nt=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(H){this.label=H}};Le=Be([O],Le),e.InlayHintLabelPart=Le;let et=class{constructor(H,ue,De){this.label=H,this.position=ue,this.kind=De}};et=Be([O],et),e.InlayHint=et;var ne;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.TriggerCharacter=1]="TriggerCharacter",Q[Q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(Q){Q[Q.Text=0]="Text",Q[Q.Method=1]="Method",Q[Q.Function=2]="Function",Q[Q.Constructor=3]="Constructor",Q[Q.Field=4]="Field",Q[Q.Variable=5]="Variable",Q[Q.Class=6]="Class",Q[Q.Interface=7]="Interface",Q[Q.Module=8]="Module",Q[Q.Property=9]="Property",Q[Q.Unit=10]="Unit",Q[Q.Value=11]="Value",Q[Q.Enum=12]="Enum",Q[Q.Keyword=13]="Keyword",Q[Q.Snippet=14]="Snippet",Q[Q.Color=15]="Color",Q[Q.File=16]="File",Q[Q.Reference=17]="Reference",Q[Q.Folder=18]="Folder",Q[Q.EnumMember=19]="EnumMember",Q[Q.Constant=20]="Constant",Q[Q.Struct=21]="Struct",Q[Q.Event=22]="Event",Q[Q.Operator=23]="Operator",Q[Q.TypeParameter=24]="TypeParameter",Q[Q.User=25]="User",Q[Q.Issue=26]="Issue"})(oe=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(J=e.CompletionItemTag||(e.CompletionItemTag={}));let pe=class{constructor(H,ue){this.label=H,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pe=Be([O],pe),e.CompletionItem=pe;let Ce=class{constructor(H=[],ue=!1){this.items=H,this.isIncomplete=ue}};Ce=Be([O],Ce),e.CompletionList=Ce;let Me=class{constructor(H,ue,De){this.text=H,this.range=ue,this.command=De}};Me=Be([O],Me),e.InlineSuggestion=Me;let He=class{constructor(H){this.items=H}};He=Be([O],He),e.InlineSuggestions=He;var Ye;(function(Q){Q[Q.Active=-1]="Active",Q[Q.Beside=-2]="Beside",Q[Q.One=1]="One",Q[Q.Two=2]="Two",Q[Q.Three=3]="Three",Q[Q.Four=4]="Four",Q[Q.Five=5]="Five",Q[Q.Six=6]="Six",Q[Q.Seven=7]="Seven",Q[Q.Eight=8]="Eight",Q[Q.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var rt;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var gt;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative"})(gt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var vt;(function(Q){Q[Q.Manual=1]="Manual",Q[Q.AfterDelay=2]="AfterDelay",Q[Q.FocusOut=3]="FocusOut"})(vt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var xe;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(xe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var st;(function(Q){Q[Q.Keyboard=1]="Keyboard",Q[Q.Mouse=2]="Mouse",Q[Q.Command=3]="Command"})(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Et;(function(Q){Q[Q.Undo=1]="Undo",Q[Q.Redo=2]="Redo"})(Et=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var tt;(function(Q){Q[Q.OpenOpen=0]="OpenOpen",Q[Q.ClosedClosed=1]="ClosedClosed",Q[Q.OpenClosed=2]="OpenClosed",Q[Q.ClosedOpen=3]="ClosedOpen"})(tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(Q){function H(ue){switch(ue){case"keyboard":return Q.Keyboard;case"mouse":return Q.Mouse;case"api":return Q.Command}}Q.fromValue=H}(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ct=class{constructor(H,ue){if(ue&&!T.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!U.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.target=ue}};ct=Be([O],ct),e.DocumentLink=ct;let Pt=class{constructor(H,ue,De,qe){this.red=H,this.green=ue,this.blue=De,this.alpha=qe}};Pt=Be([O],Pt),e.Color=Pt;let Rt=class{constructor(H,ue){if(ue&&!(ue instanceof Pt))throw(0,t.illegalArgument)("color");if(!U.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.color=ue}};Rt=Be([O],Rt),e.ColorInformation=Rt;let Tt=class{constructor(H){if(!H||typeof H!="string")throw(0,t.illegalArgument)("label");this.label=H}};Tt=Be([O],Tt),e.ColorPresentation=Tt;var ut;(function(Q){Q[Q.RGB=0]="RGB",Q[Q.HEX=1]="HEX",Q[Q.HSL=2]="HSL"})(ut=e.ColorFormat||(e.ColorFormat={}));var Ft;(function(Q){Q[Q.Error=0]="Error",Q[Q.Warning=1]="Warning",Q[Q.Information=2]="Information"})(Ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Mt{constructor(H,ue,De){if(this.startIndex=H,this.length=ue,this.tooltip=De,typeof H!="number"||H<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Mt;var Se;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Editor=2]="Editor"})(Se=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(H){this.options=H,typeof H!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=ge;var me;(function(Q){Q[Q.Always=1]="Always",Q[Q.Silent=2]="Silent",Q[Q.Never=3]="Never"})(me=e.TaskRevealKind||(e.TaskRevealKind={}));var ie;(function(Q){Q[Q.Shared=1]="Shared",Q[Q.Dedicated=2]="Dedicated",Q[Q.New=3]="New"})(ie=e.TaskPanelKind||(e.TaskPanelKind={}));let Ie=l=class{constructor(H,ue){if(this.label=ue,typeof H!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=H}static from(H){switch(H){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};Ie.Clean=new l("clean","Clean"),Ie.Build=new l("build","Build"),Ie.Rebuild=new l("rebuild","Rebuild"),Ie.Test=new l("test","Test"),Ie=l=Be([O],Ie),e.TaskGroup=Ie;function Ae(Q){let H="";for(let ue=0;ue<Q.length;ue++)H+=Q[ue].replace(/,/g,",,")+",";return H}let Ve=class{constructor(H,ue,De){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=H,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=De):this._options=ue)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(let ue of this._args)H.push(ue);return Ae(H)}};Ve=Be([O],Ve),e.ProcessExecution=Ve;let Ge=class{constructor(H,ue,De){if(this._args=[],Array.isArray(ue)){if(!H)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H,this._args=ue,this._options=De}else{if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ue of this._args)H.push(typeof ue=="string"?ue:ue.value);return Ae(H)}};Ge=Be([O],Ge),e.ShellExecution=Ge;var ot;(function(Q){Q[Q.Escape=1]="Escape",Q[Q.Strong=2]="Strong",Q[Q.Weak=3]="Weak"})(ot=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class yt{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=yt;let _t=h=class{constructor(H,ue,De,qe,Xe,Ze){this.__deprecated=!1,this._definition=this.definition=H;let it;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=De,this.execution=qe,it=Xe,this.__deprecated=!0):ue===bt.Global||ue===bt.Workspace?(this.target=ue,this._name=this.name=De,this._source=this.source=qe,this.execution=Xe,it=Ze):(this.target=ue,this._name=this.name=De,this._source=this.source=qe,this.execution=Xe,it=Ze),typeof it=="string"?(this._problemMatchers=[it],this._hasDefinedMatchers=!0):Array.isArray(it)?(this._problemMatchers=it,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ve?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const ue=this._definition.type;(h.EmptyType===ue||h.ProcessType===ue||h.ShellType===ue||h.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};_t.ExtensionCallbackType="customExecution",_t.ProcessType="process",_t.ShellType="shell",_t.EmptyType="$empty",_t=h=Be([O],_t),e.Task=_t;var ft;(function(Q){Q[Q.SourceControl=1]="SourceControl",Q[Q.Window=10]="Window",Q[Q.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let at=class{constructor(H,ue=St.None){this.collapsibleState=ue,T.URI.isUri(H)?this.resourceUri=H:this.label=H}};at=Be([O],at),e.TreeItem=at;var St;(function(Q){Q[Q.None=0]="None",Q[Q.Collapsed=1]="Collapsed",Q[Q.Expanded=2]="Expanded"})(St=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let pt=class{constructor(H){this.value=H}async asString(){return JSON.stringify(this.value)}};pt=Be([O],pt),e.TreeDataTransferItem=pt;let Nt=class{constructor(){this._items=new Map}get(H){return this._items.get(H)}set(H,ue){this._items.set(H,ue)}forEach(H){this._items.forEach(H)}};Nt=Be([O],Nt),e.TreeDataTransfer=Nt;let dt=class{constructor(H,ue){this.id=H,this.color=ue}};dt=Be([O],dt),e.ThemeIcon=dt,dt.File=new dt("file"),dt.Folder=new dt("folder");let kt=class{constructor(H){this.id=H}};kt=Be([O],kt),e.ThemeColor=kt;var Ut;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace",Q[Q.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(H,ue){if(typeof H!="string"&&(!H||!T.URI.isUri(H)&&!T.URI.isUri(H.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof H=="string"?this.baseUri=T.URI.file(H):T.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=ue}get base(){return this._base}set base(H){this._base=H,this._baseUri=T.URI.file(H)}get baseUri(){return this._baseUri}set baseUri(H){this._baseUri=H,this._base=H.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ct=Be([O],Ct),e.RelativePattern=Ct;let Bt=class{constructor(H,ue,De,qe){this.enabled=typeof H=="boolean"?H:!0,typeof ue=="string"&&(this.condition=ue),typeof De=="string"&&(this.hitCondition=De),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Bt=Be([O],Bt),e.Breakpoint=Bt;let xt=class extends Bt{constructor(H,ue,De,qe,Xe){super(ue,De,qe,Xe);if(H===null)throw(0,t.illegalArgument)("location");this.location=H}};xt=Be([O],xt),e.SourceBreakpoint=xt;let mt=class extends Bt{constructor(H,ue,De,qe,Xe){super(ue,De,qe,Xe);this.functionName=H}};mt=Be([O],mt),e.FunctionBreakpoint=mt;let ei=class extends Bt{constructor(H,ue,De,qe,Xe,Ze,it){super(qe,Xe,Ze,it);if(!ue)throw(0,t.illegalArgument)("dataId");this.label=H,this.dataId=ue,this.canPersist=De}};ei=Be([O],ei),e.DataBreakpoint=ei;let Yt=class{constructor(H,ue,De){this.command=H,this.args=ue||[],this.options=De}};Yt=Be([O],Yt),e.DebugAdapterExecutable=Yt;let ti=class{constructor(H,ue){this.port=H,this.host=ue}};ti=Be([O],ti),e.DebugAdapterServer=ti;let oi=class{constructor(H){this.path=H}};oi=Be([O],oi),e.DebugAdapterNamedPipeServer=oi;let At=class{constructor(H){this.implementation=H}};At=Be([O],At),e.DebugAdapterInlineImplementation=At;let ii=class{constructor(H,ue){this.range=H,this.expression=ue}};ii=Be([O],ii),e.EvaluatableExpression=ii;var _i;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.Explicit=1]="Explicit"})(_i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Kt=class{constructor(H,ue){this.range=H,this.text=ue}};Kt=Be([O],Kt),e.InlineValueText=Kt;let Xt=class{constructor(H,ue,De=!0){this.range=H,this.variableName=ue,this.caseSensitiveLookup=De}};Xt=Be([O],Xt),e.InlineValueVariableLookup=Xt;let lt=class{constructor(H,ue){this.range=H,this.expression=ue}};lt=Be([O],lt),e.InlineValueEvaluatableExpression=lt;let ai=class{constructor(H,ue){this.frameId=H,this.stoppedLocation=ue}};ai=Be([O],ai),e.InlineValueContext=ai;var Vt;(function(Q){Q[Q.Changed=1]="Changed",Q[Q.Created=2]="Created",Q[Q.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let jt=u=class extends Error{constructor(H,ue=C.FileSystemProviderErrorCode.Unknown,De){super(T.URI.isUri(H)?H.toString(!0):H);this.code=De?.name??"Unknown",(0,C.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(H){return new u(H,C.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(H){return new u(H,C.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(H){return new u(H,C.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(H){return new u(H,C.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(H){return new u(H,C.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(H){return new u(H,C.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};jt=u=Be([O],jt),e.FileSystemError=jt;let ni=class{constructor(H,ue,De){this.start=H,this.end=ue,this.kind=De}};ni=Be([O],ni),e.FoldingRange=ni;var Si;(function(Q){Q[Q.Comment=1]="Comment",Q[Q.Imports=2]="Imports",Q[Q.Region=3]="Region"})(Si=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gi;(function(Q){Q[Q.Collapsed=0]="Collapsed",Q[Q.Expanded=1]="Expanded"})(gi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ci;(function(Q){Q[Q.Editing=0]="Editing",Q[Q.Preview=1]="Preview"})(Ci=e.CommentMode||(e.CommentMode={}));class pi{constructor(H,ue=[]){this.tokenTypes=H,this.tokenModifiers=ue}}e.SemanticTokensLegend=pi;function ri(Q){return typeof Q=="undefined"||(0,y.isStringArray)(Q)}class li{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let ue=0,De=H.tokenTypes.length;ue<De;ue++)this._tokenTypeStrToInt.set(H.tokenTypes[ue],ue);for(let ue=0,De=H.tokenModifiers.length;ue<De;ue++)this._tokenModifierStrToInt.set(H.tokenModifiers[ue],ue)}}push(H,ue,De,qe,Xe){if(typeof H=="number"&&typeof ue=="number"&&typeof De=="number"&&typeof qe=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(H,ue,De,qe,Xe);if(U.isRange(H)&&typeof ue=="string"&&ri(De))return this._push(H,ue,De);throw(0,t.illegalArgument)()}_push(H,ue,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const qe=H.start.line,Xe=H.start.character,Ze=H.end.character-H.start.character,it=this._tokenTypeStrToInt.get(ue);let Dt=0;if(De)for(const Lt of De){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Lt);Dt|=1<<Wt>>>0}this._pushEncoded(qe,Xe,Ze,it,Dt)}_pushEncoded(H,ue,De,qe,Xe){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Lt=0,Wt=0;for(let Ht=0;Ht<Dt;Ht++){let qt=this._data[5*Ht],fi=this._data[5*Ht+1];qt===0?(qt=Lt,fi+=Wt):qt+=Lt,this._data[5*Ht]=qt,this._data[5*Ht+1]=fi,Lt=qt,Wt=fi}}let Ze=H,it=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ze-=this._prevLine,Ze===0&&(it-=this._prevChar)),this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=it,this._data[this._dataLen++]=De,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Xe,this._prevLine=H,this._prevChar=ue}static _sortAndDeltaEncode(H){let ue=[];const De=H.length/5|0;for(let it=0;it<De;it++)ue[it]=it;ue.sort((it,Dt)=>{const Lt=H[5*it],Wt=H[5*Dt];if(Lt===Wt){const Ht=H[5*it+1],qt=H[5*Dt+1];return Ht-qt}return Lt-Wt});const qe=new Uint32Array(H.length);let Xe=0,Ze=0;for(let it=0;it<De;it++){const Dt=5*ue[it],Lt=H[Dt+0],Wt=H[Dt+1],Ht=H[Dt+2],qt=H[Dt+3],fi=H[Dt+4],Hi=Lt-Xe,Yi=Hi===0?Wt-Ze:Wt,mi=5*it;qe[mi+0]=Hi,qe[mi+1]=Yi,qe[mi+2]=Ht,qe[mi+3]=qt,qe[mi+4]=fi,Xe=Lt,Ze=Wt}return qe}build(H){return this._dataIsSortedAndDeltaEncoded?new Jt(new Uint32Array(this._data),H):new Jt(li._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=li;class Jt{constructor(H,ue){this.resultId=ue,this.data=H}}e.SemanticTokens=Jt;class ci{constructor(H,ue,De){this.start=H,this.deleteCount=ue,this.data=De}}e.SemanticTokensEdit=ci;class yi{constructor(H,ue){this.resultId=ue,this.edits=H}}e.SemanticTokensEdits=yi;var Di;(function(Q){Q[Q.Separate=0]="Separate",Q[Q.MergeWithParent=1]="MergeWithParent"})(Di=e.DebugConsoleMode||(e.DebugConsoleMode={}));let $t=class{constructor(){}};$t.Back={iconPath:new dt("arrow-left")},$t=Be([O],$t),e.QuickInputButtons=$t;var Ii;(function(Q){Q[Q.Separator=-1]="Separator",Q[Q.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(Q){Q[Q.UI=1]="UI",Q[Q.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Pi{constructor(H,ue,De){this.badge=H,this.tooltip=ue,this.color=De}static validate(H){if(H.badge){let ue=(0,P.nextCharLength)(H.badge,0);if(ue<H.badge.length&&(ue+=(0,P.nextCharLength)(H.badge,ue)),H.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Pi;let ui=class{constructor(H){this.kind=H}};ui=Be([O],ui),e.ColorTheme=ui;var di;(function(Q){Q[Q.Light=1]="Light",Q[Q.Dark=2]="Dark",Q[Q.HighContrast=3]="HighContrast"})(di=e.ColorThemeKind||(e.ColorThemeKind={}));class Qt{constructor(H,ue){if(H<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");H<=ue?(this._start=H,this._end=ue):(this._start=ue,this._end=H)}static isNotebookRange(H){return H instanceof Qt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(H){let ue=this._start,De=this._end;return H.start!==void 0&&(ue=H.start),H.end!==void 0&&(De=H.end),ue===this._start&&De===this._end?this:new Qt(ue,De)}}e.NotebookRange=Qt;class zt{constructor(H,ue,De,qe,Xe,Ze,it){this.kind=H,this.value=ue,this.languageId=De,this.mime=qe,this.outputs=Xe??[],this.metadata=Ze,this.executionSummary=it,zt.validate(this)}static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(ue=>zt.isNotebookCellData(ue))}static isNotebookCellData(H){return!0}}e.NotebookCellData=zt;class Oe{constructor(H){this.cells=H}}e.NotebookData=Oe;class Ot{constructor(H,ue){this.data=H,this.mime=ue;const De=(0,D.normalizeMimeType)(ue,!0);if(!De)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(H){return H instanceof Ot?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const ue={name:H.name,message:H.message,stack:H.stack};return Ot.json(ue,"application/vnd.code.notebook.error")}static stdout(H){return Ot.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Ot.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,ue="application/octet-stream"){return new Ot(H,ue)}static text(H,ue=D.Mimes.text){const De=Te(Ot,c,"f",v).encode(String(H));return new Ot(De,ue)}static json(H,ue="application/json"){const De=JSON.stringify(H,void 0,"	");return Ot.text(De,ue)}}e.NotebookCellOutputItem=Ot,c=Ot,v={value:new TextEncoder};class Zt{constructor(H,ue,De){this.items=Zt.ensureUniqueMimeTypes(H,!0),typeof ue=="string"?(this.id=ue,this.metadata=De):(this.id=(0,F.generateUuid)(),this.metadata=ue??De)}static isNotebookCellOutput(H){return H instanceof Zt?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&(0,y.isArray)(H.items)}static ensureUniqueMimeTypes(H,ue=!1){const De=new Set,qe=new Set;for(let Xe=0;Xe<H.length;Xe++){const Ze=H[Xe],it=(0,D.normalizeMimeType)(Ze.mime);if(!De.has(it)){De.add(it);continue}qe.add(Xe),ue&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return qe.size===0?H:H.filter((Xe,Ze)=>!qe.has(Ze))}}e.NotebookCellOutput=Zt;var ht;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(ht=e.NotebookCellKind||(e.NotebookCellKind={}));var Ti;(function(Q){Q[Q.Idle=1]="Idle",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(Ti=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class wi{constructor(H,ue){this.text=H,this.alignment=ue}}e.NotebookCellStatusBarItem=wi;var Ri;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred"})(Ri=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Li{constructor(H,ue=[]){this.uri=H,this.provides=(0,d.asArray)(ue)}}e.NotebookRendererScript=Li;let hi=class{constructor(H,ue){this.label=H,this.timestamp=ue}};hi=Be([O],hi),e.TimelineItem=hi;var Oi;(function(Q){Q[Q.Production=1]="Production",Q[Q.Development=2]="Development",Q[Q.Test=3]="Test"})(Oi=e.ExtensionMode||(e.ExtensionMode={}));var bi;(function(Q){Q[Q.Node=1]="Node",Q[Q.Webworker=2]="Webworker"})(bi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fi;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(Fi=e.StandardTokenType||(e.StandardTokenType={}));class Ni{constructor(H,ue){this.ranges=H,this.wordPattern=ue}}e.LinkedEditingRanges=Ni;class Mi{constructor(H,ue){this._port=H,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var Ui;(function(Q){Q[Q.Queued=1]="Queued",Q[Q.Running=2]="Running",Q[Q.Passed=3]="Passed",Q[Q.Failed=4]="Failed",Q[Q.Skipped=5]="Skipped",Q[Q.Errored=6]="Errored"})(Ui=e.TestResultState||(e.TestResultState={}));var Bi;(function(Q){Q[Q.Run=1]="Run",Q[Q.Debug=2]="Debug",Q[Q.Coverage=3]="Coverage"})(Bi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let le=class{constructor(H=void 0,ue=void 0,De=void 0){this.include=H,this.exclude=ue,this.profile=De}};le=Be([O],le),e.TestRunRequest=le;let fe=w=class{constructor(H){this.message=H}static diff(H,ue,De){const qe=new w(H);return qe.expectedOutput=ue,qe.actualOutput=De,qe}};fe=w=Be([O],fe),e.TestMessage=fe;let Pe=class{constructor(H){this.id=H}};Pe=Be([O],Pe),e.TestTag=Pe;let Je=class{constructor(H,ue){this.covered=H,this.total=ue}};Je=Be([O],Je),e.CoveredCount=Je;let wt=R=class{constructor(H,ue,De,qe){this.uri=H,this.statementCoverage=ue,this.branchCoverage=De,this.functionCoverage=qe}static fromDetails(H,ue){const De=new Je(0,0),qe=new Je(0,0),Xe=new Je(0,0);for(const it of ue)if("branches"in it){De.total+=1,De.covered+=it.executionCount>0?1:0;for(const Dt of it.branches)qe.total+=1,qe.covered+=Dt.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=it.executionCount>0?1:0;const Ze=new R(H,De,qe.total>0?qe:void 0,Xe.total>0?Xe:void 0);return Ze.detailedCoverage=ue,Ze}};wt=R=Be([O],wt),e.FileCoverage=wt;let It=class{constructor(H,ue,De=[]){this.executionCount=H,this.location=ue,this.branches=De}};It=Be([O],It),e.StatementCoverage=It;let Wi=class{constructor(H,ue){this.executionCount=H,this.location=ue}};Wi=Be([O],Wi),e.BranchCoverage=Wi;let $i=class{constructor(H,ue){this.executionCount=H,this.location=ue}};$i=Be([O],$i),e.FunctionCoverage=$i;var Gi;(function(Q){Q[Q.None=0]="None",Q[Q.Option=1]="Option",Q[Q.Default=2]="Default",Q[Q.Preferred=3]="Preferred"})(Gi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ki;(function(Q){Q[Q.Untrusted=0]="Untrusted",Q[Q.Trusted=1]="Trusted",Q[Q.Unspecified=2]="Unspecified"})(Ki=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(Q){Q[Q.Notify=1]="Notify",Q[Q.OpenBrowser=2]="OpenBrowser",Q[Q.OpenPreview=3]="OpenPreview",Q[Q.Silent=4]="Silent",Q[Q.Ignore=5]="Ignore",Q[Q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(H,ue,De,qe,Xe,Ze){this.kind=H,this.name=ue,this.detail=De,this.uri=qe,this.range=Xe,this.selectionRange=Ze}}e.TypeHierarchyItem=Qi}),define(ve[125],be([1,0,55,10,8,153,108,7,17]),function(te,e,d,t,k,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function F(p,c){c?T.set(p,c):T.delete(p)}e.setWordDefinitionFor=F;function C(p){return T.get(p)}e.getWordDefinitionFor=C;class f extends A.MirrorTextModel{constructor(c,v,I,b,m,o,g,n){super(v,I,b,m);this._proxy=c,this._languageId=o,this._isDirty=g,this._notebook=n,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,y.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===t.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},get notebook(){return c._notebook},save(){return c._save()},getText(v){return v?c._getTextInRange(v):c.getText()},get eol(){return c._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(v){return c._lineAt(v)},offsetAt(v){return c._offsetAt(v)},positionAt(v){return c._positionAt(v)},validateRange(v){return c._validateRange(v)},validatePosition(v){return c._validatePosition(v)},getWordRangeAtPosition(v,I){return c._getWordRangeAtPosition(v,I)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,d.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,d.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const v=this._validateRange(c);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const I=this._eol,b=v.start.line,m=v.end.line,o=[];o.push(this._lines[b].substring(v.start.character));for(let g=b+1;g<m;g++)o.push(this._lines[g]);return o.push(this._lines[m].substring(0,v.end.character)),o.join(I)}_lineAt(c){let v;if(c instanceof P.Position?v=c.line:typeof c=="number"&&(v=c),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new _(v,this._lines[v],v===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(c),I=this._lines[v.index].length;return new P.Position(v.index,Math.min(v.remainder,I))}_validateRange(c){if(!(c instanceof P.Range))throw new Error("Invalid argument");const v=this._validatePosition(c.start),I=this._validatePosition(c.end);return v===c.start&&I===c.end?c:new P.Range(v.line,v.character,I.line,I.character)}_validatePosition(c){if(!(c instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:v,character:I}=c,b=!1;if(v<0)v=0,I=0,b=!0;else if(v>=this._lines.length)v=this._lines.length-1,I=this._lines[v].length,b=!0;else{const m=this._lines[v].length;I<0?(I=0,b=!0):I>m&&(I=m,b=!0)}return b?new P.Position(v,I):c}_getWordRangeAtPosition(c,v){const I=this._validatePosition(c);if(!v)v=C(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const b=(0,D.getWordAtText)(I.character+1,(0,D.ensureValidWordDefinition)(v),this._lines[I.line],0);if(b)return new P.Range(I.line,b.startColumn-1,I.line,b.endColumn-1)}}e.ExtHostDocumentData=f;class _{constructor(c,v,I){this._line=c,this._text=v,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=_}),define(ve[205],be([1,0,7,3,111,6,109,24,2,33]),function(te,e,d,t,k,A,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(f,_,p,c){this._notebook=p,this._selector=c,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(_.onDidChangeDocument(I=>{const b=this._cellUris.get(I.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(f.onDidChangeNotebookCells(I=>v(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const f=[],_=[];for(const p of this._notebook.getCells())p.kind===d.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,p.document.uri,p.document.languageId,!0))&&(this._cellUris.set(p.document.uri,this._cells.length),this._cells.push(p),f.push(p.document.getText().length+1),_.push(p.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(f)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(_))}get version(){return this._versionId}getText(f){if(!f){let b="";for(const m of this._cells)b+=m.document.getText()+`
`;return b=b.slice(0,-1),b}if(f.isEmpty)return"";const _=this.locationAt(f.start),p=this.locationAt(f.end),c=this._cellUris.get(_.uri),v=this._cellUris.get(p.uri);if(c===void 0||v===void 0)return"";if(c===v)return this._cells[c].document.getText(new d.Range(_.range.start,p.range.end));const I=[this._cells[c].document.getText(new d.Range(_.range.start,new d.Position(this._cells[c].document.lineCount,0)))];for(let b=c+1;b<v;b++)I.push(this._cells[b].document.getText());return I.push(this._cells[v].document.getText(new d.Range(new d.Position(0,0),p.range.end))),I.join(`
`)}offsetAt(f){const _=this._cellLines.getIndexOf(f.line),p=this._cellLengths.getPrefixSum(_.index-1),c=this._cells[_.index].document.offsetAt(f.with(_.remainder));return p+c}positionAt(f){if(typeof f=="number"){const p=this._cellLengths.getIndexOf(f),c=this._cellLines.getPrefixSum(p.index-1);return this._cells[p.index].document.positionAt(p.remainder).translate(c)}const _=this._cellUris.get(f.uri);if(_!==void 0){const p=this._cellLines.getPrefixSum(_-1);return new d.Position(p+f.range.start.line,f.range.start.character)}return new d.Position(0,0)}locationAt(f){d.Range.isRange(f)||(f=new d.Range(f,f));const _=this._cellLines.getIndexOf(f.start.line);let p=_;f.isEmpty||(p=this._cellLines.getIndexOf(f.end.line));const c=new d.Position(_.remainder,f.start.character),v=new d.Position(p.remainder,f.end.character),I=new d.Range(c,v),b=this._cells[_.index];return new d.Location(b.document.uri,b.document.validateRange(I))}contains(f){return this._cellUris.has(f)}validateRange(f){const _=this.validatePosition(f.start),p=this.validatePosition(f.end);return f.with(_,p)}validatePosition(f){const _=this._cellLines.getIndexOf(f.line),p=new d.Position(_.remainder,f.character),c=this._cells[_.index].document.validatePosition(p),v=this._cellLines.getPrefixSum(_.index-1);return new d.Position(v+c.line,c.character)}}e.ExtHostNotebookConcatDocument=F}),define(ve[206],be([1,0,7,14,3]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let y=P==="light"?d.ColorThemeKind.Light:P==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Be([Fe(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ve[64],be([1,0,4]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=t}),define(ve[207],be([1,0,23]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(y){let T=this.buffers.indexOf(y);return T<0&&(T=this.buffers.length,this.buffers.push(y)),T}}function k(P,y){if(y.serializeBuffersForPostMessage){const T=new t,F=(_,p)=>{if(p instanceof ArrayBuffer){const c=T.add(p);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(p)){const c=A(p);if(c){const v=T.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:c,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},C=JSON.stringify(P,F),f=T.buffers.map(_=>{const p=new Uint8Array(_);return d.VSBuffer.wrap(p)});return{message:C,buffers:f}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=k;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(P,y){const T=y.map(f=>{const _=new ArrayBuffer(f.byteLength);return new Uint8Array(_).set(f.buffer),_}),F=y.length?(f,_)=>{if(typeof _=="object"&&_.$$vscode_array_buffer_reference$$){const p=_,{index:c}=p,v=T[c];if(p.view)switch(p.view.type){case 1:return new Int8Array(v,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return _}:void 0;return{message:JSON.parse(P,F),arrayBuffers:T}}e.deserializeWebviewMessage=D}),define(ve[208],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(t){function k(D){const P=new Map;return D.types.forEach((y,T)=>{P.set(y,{asString:async()=>D.items[T].asString,value:void 0})}),P}t.toITreeDataTransfer=k;async function A(D){const P={types:[],items:[]},y=Array.from(D.entries());for(const T of y)P.types.push(T[0]),P.items.push({asString:await T[1].asString()});return P}t.toTreeDataTransferDTO=A})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[209],be([1,0,177,18,2,6,4,50,42,17,10]),function(te,e,d,t,k,A,D,P,y,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function C(S,U,M){for(const X of M.visibleEditorPanes)if(X.group.id===U&&S.matches(X.input))return X.getViewState()}e.findViewStateForEditor=C;function f(S){if(o(S))return!1;const U=S;return k.URI.isUri(U?.resource)}e.isResourceEditorInput=f;function _(S){if(o(S))return!1;const U=S;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=_;function p(S){if(o(S)||_(S))return!1;const U=S;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function c(S){if(o(S))return!1;const U=S;return U?U.resource===void 0||U.resource.scheme===F.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=c;var v;(function(S){S[S.SHORT=0]="SHORT",S[S.MEDIUM=1]="MEDIUM",S[S.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var I;(function(S){S[S.EXPLICIT=1]="EXPLICIT",S[S.AUTO=2]="AUTO",S[S.FOCUS_CHANGE=3]="FOCUS_CHANGE",S[S.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(I=e.SaveReason||(e.SaveReason={}));var b;(function(S){S[S.None=0]="None",S[S.Readonly=2]="Readonly",S[S.Untitled=4]="Untitled",S[S.Singleton=8]="Singleton",S[S.RequiresTrust=16]="RequiresTrust",S[S.CanSplitInGroup=32]="CanSplitInGroup",S[S.ForceDescription=64]="ForceDescription"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class m extends A.Disposable{}e.AbstractEditorInput=m;function o(S){return S instanceof m}e.isEditorInput=o;function g(S){const U=S;return k.URI.isUri(U?.preferredResource)}function n(S){const U=S;return o(U?.primary)&&o(U?.secondary)}e.isSideBySideEditorInput=n;function E(S){const U=S;return o(U?.modified)&&o(U?.original)}e.isDiffEditorInput=E;function a(S){return o(S?.editor)}e.isEditorInputWithOptions=a;function i(S){const U=S;return a(S)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=i;function r(S){const U=S;return typeof U?.groupId=="number"&&o(U.editor)}e.isEditorIdentifier=r;var s;(function(S){S[S.UNKNOWN=0]="UNKNOWN",S[S.REPLACE=1]="REPLACE",S[S.MOVE=2]="MOVE",S[S.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var l;(function(S){S[S.GROUP_ACTIVE=0]="GROUP_ACTIVE",S[S.GROUP_INDEX=1]="GROUP_INDEX",S[S.GROUP_LOCKED=2]="GROUP_LOCKED",S[S.EDITOR_OPEN=3]="EDITOR_OPEN",S[S.EDITOR_CLOSE=4]="EDITOR_CLOSE",S[S.EDITOR_MOVE=5]="EDITOR_MOVE",S[S.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",S[S.EDITOR_LABEL=7]="EDITOR_LABEL",S[S.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",S[S.EDITOR_PIN=9]="EDITOR_PIN",S[S.EDITOR_STICKY=10]="EDITOR_STICKY",S[S.EDITOR_DIRTY=11]="EDITOR_DIRTY",S[S.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(l=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var h;(function(S){S[S.PRIMARY=1]="PRIMARY",S[S.SECONDARY=2]="SECONDARY",S[S.BOTH=3]="BOTH",S[S.ANY=4]="ANY"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(U,M){if(!U)return;if(M?.supportSideBySide){const{primary:G,secondary:q}=this.getSideEditors(U);if(G&&q){if(M?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(G,{filterByScheme:M.filterByScheme}),secondary:this.getOriginalUri(q,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===h.ANY)return this.getOriginalUri(G,{filterByScheme:M.filterByScheme})??this.getOriginalUri(q,{filterByScheme:M.filterByScheme});U=M.supportSideBySide===h.PRIMARY?G:q}}if(_(U)||p(U))return;const X=g(U)?U.preferredResource:U.resource;return!X||!M||!M.filterByScheme?X:this.filterUri(X,M.filterByScheme)}getSideEditors(U){return n(U)||p(U)?{primary:U.primary,secondary:U.secondary}:E(U)||_(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,M){if(!U)return;if(M?.supportSideBySide){const{primary:G,secondary:q}=this.getSideEditors(U);if(G&&q){if(M?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(G,{filterByScheme:M.filterByScheme}),secondary:this.getCanonicalUri(q,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===h.ANY)return this.getCanonicalUri(G,{filterByScheme:M.filterByScheme})??this.getCanonicalUri(q,{filterByScheme:M.filterByScheme});U=M.supportSideBySide===h.PRIMARY?G:q}}if(_(U)||p(U))return;const X=U.resource;return!X||!M||!M.filterByScheme?X:this.filterUri(X,M.filterByScheme)}filterUri(U,M){if(Array.isArray(M)){if(M.some(X=>U.scheme===X))return U}else if(M===U.scheme)return U}}e.EditorResourceAccessor=new u;var w;(function(S){S[S.LEFT=0]="LEFT",S[S.RIGHT=1]="RIGHT"})(w=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const M=this.instantiationService=U.get(D.IInstantiationService);for(const[X,G]of this.editorSerializerConstructors)this.createEditorSerializer(X,G,M);this.editorSerializerConstructors.clear()}createEditorSerializer(U,M,X){const G=X.createInstance(M);this.editorSerializerInstances.set(U,G)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,M){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,M,this.instantiationService):this.editorSerializerConstructors.set(U,M),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new R);async function O(S,U){if(!S||!S.length)return[];const M=await Promise.all(S.map(async X=>{const G=k.URI.revive(X.fileUri);if(!G||!await U.canHandleResource(G))return;let B=X.exists,x=X.type;if(typeof B!="boolean"||typeof x!="number")try{x=(await U.resolve(G)).isDirectory?y.FileType.Directory:y.FileType.Unknown,B=!0}catch{B=!1}if(!B&&X.openOnlyIfExists||x===y.FileType.Directory)return;const j={selection:B?X.selection:void 0,pinned:!0,override:X.editorOverrideId};let V;return B?V={resource:G,options:j}:V={resource:G,options:j,forceUntitled:!0},V}));return(0,T.coalesce)(M)}e.pathsToEditors=O;var L;(function(S){S[S.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",S[S.SEQUENTIAL=1]="SEQUENTIAL"})(L=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[86],be([1,0,10,2]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(P,y){return P.scheme===d.Schemas.http||P.scheme===d.Schemas.https?P:(y&&y.authority&&y.isRemote&&P.scheme===d.Schemas.file&&(P=t.URI.from({scheme:d.Schemas.vscodeRemote,authority:y.authority,path:P.path})),t.URI.from({scheme:d.Schemas.https,authority:`${P.scheme}+${A(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=k;function A(P){return P.replace(/./g,y=>{const T=y.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?y:"-"+T.toString(16).padStart(4,"0")})}function D(P){return P.replace(/-([0-9a-f]{4})/g,(y,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=D}),define(ve[210],be([1,0,3,6,86]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(P,y,T){this._proxy=P,this._editors=y,this._initData=T,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const F=y.getVisibleTextEditors();for(const C of this._insets.values())F.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,y,T,F,C){let f;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===P){f=m;break}if(!f)throw new Error("not a visible editor");const _=this,p=this._handlePool++,c=new d.Emitter,v=new d.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,k.asWebviewUri)(m,_._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(m){this._options=m,_._proxy.$setOptions(p,m)}get options(){return this._options}set html(m){this._html=m,_._proxy.$setHtml(p,m)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(m){return _._proxy.$postMessage(p,m)}},b=new class{constructor(){this.editor=P,this.line=y,this.height=T,this.webview=I,this.onDidDispose=v.event}dispose(){_._insets.has(p)&&(_._insets.delete(p),_._proxy.$disposeEditorInset(p),v.fire(),v.dispose(),c.dispose())}};return this._proxy.$createEditorInset(p,f.id,f.value.document.uri,y+1,T,F||{},C.identifier,C.extensionLocation),this._insets.set(p,{editor:P,inset:b,onDidReceiveMessage:c}),b}$onDidDispose(P){const y=this._insets.get(P);y&&y.inset.dispose()}$onDidReceiveMessage(P,y){const T=this._insets.get(P);T&&T.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=A}),define(ve[126],be([1,0,3,13,178]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,y,T,F){const C={command:P};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof F=="number"){const f=setTimeout(()=>{clearTimeout(f);const _=this.pendingRequests.get(C.seq);if(_){this.pendingRequests.delete(C.seq);const p={type:"response",seq:0,request_seq:C.seq,success:!1,command:P,message:(0,k.localize)(0,null,F,P)};_(p)}},F)}return T&&this.pendingRequests.set(C.seq,T),C.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,y){return P.type!=="event"||y.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,t.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const y=P,T=this.pendingRequests.get(y.request_seq);T&&(this.pendingRequests.delete(y.request_seq),T(y));break}}}}internalSend(P,y){y.type=P,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((y,T)=>P.set(T,y)),await(0,t.timeout)(500),P.forEach((y,T)=>{y({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ve[211],be([1,0,179,62,4]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:d.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:d.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:d.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:d.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:d.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:d.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:d.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:d.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:d.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:d.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:d.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:d.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:d.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:d.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:d.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:d.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:d.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:d.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:d.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:d.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:d.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:d.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:d.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:d.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:d.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:d.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:d.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:d.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:d.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:d.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:d.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:d.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:d.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:d.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:d.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:d.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:d.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:d.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:d.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:d.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:d.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:d.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:d.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:d.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:d.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:d.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:d.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:d.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:d.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:d.localize(49,null)});const A=C=>d.localize(50,null,C);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:d.localize(51,null)};var D;(function(C){C[C.Inactive=0]="Inactive",C[C.Initializing=1]="Initializing",C[C.Stopped=2]="Stopped",C[C.Running=3]="Running"})(D=e.State||(e.State={}));function P(C){switch(C){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var y;(function(C){C[C.Valid=0]="Valid",C[C.Unreadable=1]="Unreadable",C[C.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(C){C[C.Initial=1]="Initial",C[C.Dynamic=2]="Dynamic"})(T=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,k.createDecorator)(e.DEBUG_SERVICE_ID);var F;(function(C){C[C.CONDITION=0]="CONDITION",C[C.HIT_COUNT=1]="HIT_COUNT",C[C.LOG_MESSAGE=2]="LOG_MESSAGE"})(F=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ve[212],be([1,0,8,2,9,25,10]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function y(a,i,r){return a.replace(P,function(s,l){return i&&l.length>0&&l[0]!=="_"?s:r&&r.hasOwnProperty(l)?r[l]:s})}e.formatPII=y;function T(a){const i={};for(const r of Object.keys(a))r.startsWith("!")||(i[r]=a[r]);return i}e.filterExceptionsFromTelemetry=T;function F(a){return a.configuration.request==="attach"&&!C(a)&&(!a.parentSession||F(a.parentSession))}e.isSessionAttach=F;function C(a){let i=a.configuration.type;if(!!i)return i==="vslsShare"&&(i=a.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(i,"extensionhost")||(0,d.equalsIgnoreCase)(i,"pwa-extensionhost")?a:a.parentSession?C(a.parentSession):void 0}e.getExtensionHostDebugSession=C;function f(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=f;function _(a,i,r){let s,l=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let u=null;for(;u=h.exec(a);){const w=u.index+1,R=w+u[0].length;if(w<=i&&R>=r){s=u[0],l=w;break}}if(s){const w=/\w+/g;let R=null;for(;(R=w.exec(s))&&!(R.index+1+l+R[0].length>=r););R&&(s=s.substring(0,w.lastIndex))}return s?{start:l,end:l+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=_;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(a){return!!(a&&a.match(p))}e.isUri=c;function v(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(c(a.path))return t.URI.parse(a.path);if((0,k.isAbsolute)(a.path))return t.URI.file(a.path)}return a.path}function I(a){if(typeof a.path=="object"){const i=t.URI.revive(a.path);if(i)return i.scheme===D.Schemas.file?i.fsPath:i.toString()}return a.path}function b(a,i){const r=i?v:I,s=(0,A.deepClone)(a);return o(s,(l,h)=>{l&&h&&(h.path=r(h))}),s}e.convertToDAPaths=b;function m(a,i){const r=i?v:I,s=(0,A.deepClone)(a);return o(s,(l,h)=>{!l&&h&&(h.path=r(h))}),s}e.convertToVSCPaths=m;function o(a,i){switch(a.type){case"event":{const r=a;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=a;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(s=>i(!1,s));break;default:break}break}case"response":{const r=a;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(s=>i(!1,s.source));break;case"loadedSources":r.body.sources.forEach(s=>i(!1,s));break;case"scopes":r.body.scopes.forEach(s=>i(!1,s.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(s=>i(!1,s.source));break;case"setBreakpoints":r.body.breakpoints.forEach(s=>i(!1,s.source));break;case"disassemble":{const s=r;s.body&&s.body.instructions.forEach(l=>i(!1,l.location))}break;default:break}break}}}function g(a){return a.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):n(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:n(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=g;function n(a,i){return typeof a!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:a-i}async function E(a,i){const r=a.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const s=i.activeEditorPane;s&&s.input.resource?.scheme===D.Schemas.untitled&&await i.save({editor:s.input,groupId:s.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=E}),define(ve[213],be([1,0,29,37,180,127,9,8,25,11,196,126]),function(te,e,d,t,k,A,D,P,y,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class f extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,m){this.outputStream=m,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",o=>this.handleData(o))}sendMessage(b){if(this.outputStream){const m=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${f.TWO_CRLF}${m}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const m=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+m))}continue}}else{const m=this.rawData.indexOf(f.TWO_CRLF);if(m!==-1){const g=this.rawData.toString("utf8",0,m).split(f.HEADER_LINESEPARATOR);for(const n of g){const E=n.split(f.HEADER_FIELDSEPARATOR);E[0]==="Content-Length"&&(this.contentLength=Number(E[1]))}this.rawData=this.rawData.slice(m+f.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=f,f.TWO_CRLF=`\r
\r
`,f.HEADER_LINESEPARATOR=/\r?\n/,f.HEADER_FIELDSEPARATOR=/: */;class _ extends f{startSession(){return new Promise((b,m)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.socket.on("error",g=>{o?this._onError.fire(g):m(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=_;class p extends _{constructor(b){super();this.adapterServer=b}createConnection(b){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=p;class c extends _{constructor(b){super();this.adapterServer=b}createConnection(b){return A.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=c;class v extends f{constructor(b,m,o){super();this.adapterExecutable=b,this.debugType=m,this.outputService=o}async startSession(){const b=this.adapterExecutable.command,m=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(b)if(D.isAbsolute(b)){if(!await d.Promises.exists(b))throw new Error(k.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let g=process.env;if(o.env&&Object.keys(o.env).length>0&&(g=y.mixin(y.deepClone(process.env),o.env)),b==="node")if(Array.isArray(m)&&m.length>0){const E=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,a={env:g,execArgv:E?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(a.cwd=o.cwd);const i=t.fork(m[0],m.slice(1),a);if(!i.pid)throw new Error(k.localize(2,null,m[0]));this.serverProcess=i}else throw new Error(k.localize(3,null));else{const E={env:g};o.cwd&&(E.cwd=o.cwd),this.serverProcess=t.spawn(b,m,E)}this.serverProcess.on("error",E=>{this._onError.fire(E)}),this.serverProcess.on("exit",(E,a)=>{this._onExit.fire(E)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",E=>{this._onError.fire(E)}),this.serverProcess.stdin.on("error",E=>{this._onError.fire(E)});const n=this.outputService;if(n){const E=a=>a.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",a=>{const i=n.getChannel(F.ExtensionsChannelId);i&&i.append(E(a))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((b,m)=>{const o=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,n,E){if(g)return m(g)});o.on("exit",b),o.on("error",m)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,m){if(!b)return;const o=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?o.runtime=D.join(m,b.runtime):o.runtime=b.runtime),b.runtimeArgs&&(o.runtimeArgs=b.runtimeArgs),b.program&&(D.isAbsolute(b.program)?o.program=b.program:o.program=D.join(m,b.program)),b.args&&(o.args=b.args);const g=b;return g.win&&(o.win=v.extract(g.win,m)),g.winx86&&(o.winx86=v.extract(g.winx86,m)),g.windows&&(o.windows=v.extract(g.windows,m)),g.osx&&(o.osx=v.extract(g.osx,m)),g.linux&&(o.linux=v.extract(g.linux,m)),o}static platformAdapterExecutable(b,m){let o=Object.create(null);m=m.toLowerCase();for(const r of b)if(r.contributes){const s=r.contributes.debuggers;s&&s.length>0&&s.filter(l=>typeof l.type=="string"&&P.equalsIgnoreCase(l.type,m)).forEach(l=>{const h=v.extract(l,r.extensionLocation.fsPath);o=y.mixin(o,h,r.isBuiltin)})}let g;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=o.winx86||o.win||o.windows:T.isWindows?g=o.win||o.windows:T.isMacintosh?g=o.osx:T.isLinux&&(g=o.linux),g=g||o;const n=g.program||o.program,E=g.args||o.args,a=g.runtime||o.runtime,i=g.runtimeArgs||o.runtimeArgs;if(a)return{type:"executable",command:a,args:(i||[]).concat(typeof n=="string"?[n]:[]).concat(E||[])};if(n)return{type:"executable",command:n,args:E||[]}}}e.ExecutableDebugAdapter=v}),define(ve[214],be([1,0,37,28,11]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(T,F){return new Promise((C,f)=>{let _="";const p=d.spawn(T,F);p.pid&&p.stdout.on("data",c=>{_+=c.toString()}),p.on("error",c=>{f(c)}),p.on("close",c=>{C(_)})})}async function D(T){if(T)if(k.isWindows){const F=await new Promise((C,f)=>{te(["windows-process-tree"],C,f)});return new Promise(C=>{F.getProcessTree(T,f=>{C(f.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(T)]).then(F=>{const C=F.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},F=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var P;(function(T){T[T.cmd=0]="cmd",T[T.powershell=1]="powershell",T[T.bash=2]="bash"})(P||(P={}));function y(T,F,C,f){T=T.trim().toLowerCase();let _;T.indexOf("powershell")>=0||T.indexOf("pwsh")>=0?_=1:T.indexOf("cmd.exe")>=0?_=0:T.indexOf("bash")>=0?_=2:k.isWindows?_=0:_=2;let p,c=" ";switch(_){case 1:if(p=v=>(v=v.replace(/\'/g,"''"),v.length>0&&v.charAt(v.length-1)==="\\"?`'${v}\\'`:`'${v}'`),C){const v=(0,t.getDriveLetter)(C);v&&(c+=`${v}:; `),c+=`cd ${p(C)}; `}if(f)for(const v in f){const I=f[v];I===null?c+=`Remove-Item env:${v}; `:c+=`\${env:${v}}='${I}'; `}if(F.length>0){const v=p(F.shift());c+=v[0]==="'"?`& ${v} `:`${v} `;for(const I of F)c+=`${p(I)} `}break;case 0:if(p=v=>(v=v.replace(/\"/g,'""'),v.indexOf(" ")>=0||v.indexOf('"')>=0||v.length===0?`"${v}"`:v),C){const v=(0,t.getDriveLetter)(C);v&&(c+=`${v}: && `),c+=`cd ${p(C)} && `}if(f){c+='cmd /C "';for(const v in f){let I=f[v];I===null?c+=`set "${v}=" && `:(I=I.replace(/[\^\&\|\<\>]/g,b=>`^${b}`),c+=`set "${v}=${I}" && `)}}for(const v of F)c+=`${p(v)} `;f&&(c+='"');break;case 2:{p=I=>(I=I.replace(/(["'\\\$])/g,"\\$1"),I.indexOf(" ")>=0||I.indexOf(";")>=0||I.length===0?`"${I}"`:I);const v=I=>/[^\w@%\/+=,.:^-]/.test(I)?`'${I.replace(/'/g,"'\\''")}'`:I;if(C&&(c+=`cd ${p(C)} ; `),f){c+="/usr/bin/env";for(const I in f){const b=f[I];b===null?c+=` -u ${v(I)}`:c+=` ${v(`${I}=${b}`)}`}c+=" "}for(const I of F)c+=`${p(I)} `;break}}return c}e.prepareCommand=y}),define(ve[128],be([1,0,32,77,94,10,9,11,62]),function(te,e,d,t,k,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var T;(function(w){w[w.Markup=1]="Markup",w[w.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",k.Mimes.latex,k.Mimes.markdown,"image/png","image/jpeg",k.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[k.Mimes.latex,k.Mimes.markdown,"application/json",k.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(w){w[w.Running=1]="Running",w[w.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var C;(function(w){w[w.Pending=2]="Pending",w[w.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var f;(function(w){w[w.WithHardKernelDependency=0]="WithHardKernelDependency",w[w.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",w[w.Pure=2]="Pure",w[w.Never=3]="Never"})(f=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var _;(function(w){w.Always="always",w.Never="never",w.Optional="optional"})(_=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(w){w[w.ModelChange=1]="ModelChange",w[w.Move=2]="Move",w[w.ChangeLanguage=5]="ChangeLanguage",w[w.Initialize=6]="Initialize",w[w.ChangeCellMetadata=7]="ChangeCellMetadata",w[w.Output=8]="Output",w[w.OutputItem=9]="OutputItem",w[w.ChangeCellContent=10]="ChangeCellContent",w[w.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",w[w.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",w[w.ChangeCellMime=13]="ChangeCellMime",w[w.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(w){w[w.Handle=0]="Handle",w[w.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(w){w[w.Replace=1]="Replace",w[w.Output=2]="Output",w[w.Metadata=3]="Metadata",w[w.CellLanguage=4]="CellLanguage",w[w.DocumentMetadata=5]="DocumentMetadata",w[w.Move=6]="Move",w[w.OutputItems=7]="OutputItems",w[w.PartialMetadata=8]="PartialMetadata",w[w.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var I;(function(w){w.scheme=A.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function O(G,q){return G.with({scheme:w.scheme,fragment:`ch${q.toString().padStart(7,"0")}${G.scheme!==A.Schemas.file?G.scheme:""}`})}w.generate=O;function L(G){if(G.scheme!==w.scheme)return;const q=R.exec(G.fragment);return q?{handle:Number(q[1]),notebook:G.with({scheme:G.fragment.substring(q[0].length)||A.Schemas.file,fragment:null})}:void 0}w.parse=L;function S(G,q,B){return G.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`ch${q.toString().padStart(7,"0")},${B??""},${G.scheme!==A.Schemas.file?G.scheme:""}`})}w.generateCellOutputUri=S;function U(G){if(G.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const q=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(G.fragment);if(!q)return;const B=Number(q[1]),x=q[2]&&q[2]!==""?q[2]:void 0,j=q[3];return{handle:B,outputId:x,notebook:G.with({scheme:j||A.Schemas.file,fragment:null})}}w.parseCellOutputUri=U;function M(G,q,B){return G.with({scheme:B,fragment:`ch${q.toString().padStart(7,"0")}${G.scheme!==A.Schemas.file?G.scheme:""}`})}w.generateCellUri=M;function X(G,q){if(G.scheme!==q)return;const B=R.exec(G.fragment);return B?{handle:Number(B[1]),notebook:G.with({scheme:G.fragment.substring(B[0].length)||A.Schemas.file,fragment:null})}:void 0}w.parseCellUri=X})(I=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[k.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(w){return b.get(w)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=m;function o(w){return b.get(w)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function g(w){return b.get(w)?.mergeable??!1}e.mimeTypeIsMergeable=g;const n=w=>P.isWindows?w.replace(/\//g,"\\"):w;class E{constructor(R=[],O=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=O,this.order=[...new Set(R)].map(L=>({pattern:L,matches:d.parse(n(L))}))}sort(R){const O=new Map(t.Iterable.map(R,S=>[S,n(S)]));let L=[];for(const{matches:S}of this.order)for(const[U,M]of O)if(S(M)){L.push(U),O.delete(U);break}return O.size&&(L=L.concat([...O.keys()].sort((S,U)=>this.defaultOrder.indexOf(S)-this.defaultOrder.indexOf(U)))),L}prioritize(R,O){const L=this.findIndex(R);if(L===-1){this.order.unshift({pattern:R,matches:d.parse(n(R))});return}const S=new Set(O.map(M=>this.findIndex(M,L)));S.delete(-1);const U=Array.from(S).sort();this.order.splice(L+1,0,...U.map(M=>this.order[M]));for(let M=U.length-1;M>=0;M--)this.order.splice(U[M],1)}toArray(){return this.order.map(R=>R.pattern)}findIndex(R,O=this.order.length){const L=n(R);for(let S=0;S<O;S++)if(this.order[S].matches(L))return S;return-1}}e.MimeTypeDisplayOrder=E;function a(w,R,O,L=(S,U)=>S===U){const S=[];function U(G,q,B){if(q===0&&B.length===0)return;const x=S[S.length-1];x&&x.start+x.deleteCount===G?(x.deleteCount+=q,x.toInsert.push(...B)):S.push({start:G,deleteCount:q,toInsert:B})}let M=0,X=0;for(;;){if(M===w.length){U(M,0,R.slice(X));break}if(X===R.length){U(M,w.length-M,[]);break}const G=w[M],q=R[X];if(L(G,q)){M+=1,X+=1;continue}O(q)?(U(M,1,[]),M+=1):(U(M,0,[q]),X+=1)}return S}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(w){w.default="default",w.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(w){const R=w;return!!((typeof R.include=="string"||d.isRelativePattern(R.include))&&(typeof R.exclude=="string"||d.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=r;function s(w,R,O){if(Array.isArray(w.viewType)&&w.viewType.indexOf(R)>=0||w.viewType===R)return!0;if(w.filenamePattern){const L=r(w.filenamePattern)?w.filenamePattern.include:w.filenamePattern,S=r(w.filenamePattern)?w.filenamePattern.exclude:void 0;if(d.match(L,(0,D.basename)(O.fsPath).toLowerCase()))return!(S&&d.match(S,(0,D.basename)(O.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class l{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let O=0;O<this.textModel.cells.length;O++)R[O]=this.textModel.cells[O].getHashValue();return R}}e.CellSequence=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var h;(function(w){w[w.Left=1]="Left",w[w.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(R){return`${u._prefix}${R}`}static parse(R){if(R.startsWith(u._prefix))return R.substring(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(ve[215],be([1,0,4]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(ve[216],be([1,0,4,62]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,d.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(A){A[A.Append=1]="Append",A[A.Replace=2]="Replace",A[A.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[217],be([1,0,181,4,62]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[218],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=d;function t(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=t}),define(ve[129],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var t;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(C){C[C.Error=0]="Error",C[C.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var A;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const D=(C,f)=>{f.expand!==void 0&&(C.expand=f.expand),f.item!==void 0&&(C.item=C.item?Object.assign(C.item,f.item):f.item)};e.applyTestItemUpdate=D;var P;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var y;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire",C[C.AddTag=5]="AddTag",C[C.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(f){}update(f){}remove(f,_){}complete(){}}e.IncrementalChangeCollector=T;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(f){const _=this.createChangeCollector();for(const p of f)switch(p[0]){case 0:{const c=p[1];if(c.parent){if(this.items.has(c.parent)){const v=this.items.get(c.parent);v.children.add(c.item.extId);const I=this.createItem(c,v);this.items.set(c.item.extId,I),_.add(I)}}else{const v=this.createItem(c);this.roots.add(v),this.items.set(c.item.extId,v),_.add(v)}c.expand===2&&this.busyControllerCount++;break}case 1:{const c=p[1],v=this.items.get(c.extId);if(!v)break;c.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,c),_.update(v);break}case 2:{const c=this.items.get(p[1]);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c);const v=[[p[1]]];for(;v.length;)for(const I of v.pop()){const b=this.items.get(I);b&&(v.push(b.children),this.items.delete(I),_.remove(b,b!==c),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(p[1]);break;case 3:this.updatePendingRoots(p[1]);break;case 5:this._tags.set(p[1].id,p[1]);break;case 6:this._tags.delete(p[1]);break}_.complete()}retireTest(f){}updatePendingRoots(f){this.pendingRootCount+=f}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=F}),define(ve[87],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(A){A.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class k{constructor(D,P=D.length){if(this.path=D,this.viewEnd=P,D.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(D,P,y=D.parent){if(D.id===P)return new k([P]);let T=[D.id];for(let F=y;F&&F.id!==P;F=F.parent)T.push(F.id);return T.push(P),new k(T.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const P=D.indexOf("\0");return P===-1?D:D.slice(0,P)}static fromString(D){return new k(D.split("\0"))}static join(D,P){return new k([...D.path,P])}static joinToString(D,P){return D.toString()+"\0"+P}static compare(D,P){return D===P?0:P.startsWith(D+"\0")?2:D.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new k(this.path,D)}compare(D){if(typeof D=="string")return k.compare(this.toString(),D);for(let P=0;P<D.viewEnd&&P<this.viewEnd;P++)if(D.path[P]!==this.path[P])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=k}),define(ve[219],be([1,0,9,40,18,25,11,79,182]),function(te,e,d,t,k,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(C,f,_){this._contributedVariables=new Map,this._context=C,this._labelService=f,_&&(this._envVariablesPromise=_.then(p=>this.prepareEnv(p)))}prepareEnv(C){if(D.isWindows){const f=Object.create(null);return Object.keys(C).forEach(_=>{f[_.toLowerCase()]=C[_]}),f}return C}resolveWithEnvironment(C,f,_){return this.recursiveResolve(this.prepareEnv(C),f?f.uri:void 0,_)}async resolveAsync(C,f){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,f)}async resolveAnyBase(C,f,_,p){const c=A.deepClone(f);return D.isWindows&&c.windows?Object.keys(c.windows).forEach(v=>c[v]=c.windows[v]):D.isMacintosh&&c.osx?Object.keys(c.osx).forEach(v=>c[v]=c.osx[v]):D.isLinux&&c.linux&&Object.keys(c.linux).forEach(v=>c[v]=c.linux[v]),delete c.windows,delete c.osx,delete c.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,c,_,p)}async resolveAnyAsync(C,f,_){return this.resolveAnyBase(C,f,_)}async resolveAnyMap(C,f,_){const p=new Map;return{newConfig:await this.resolveAnyBase(C,f,_,p),resolvedVariables:p}}resolveWithInteractionReplace(C,f,_,p){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,f,_,p){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,f){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,f)}recursiveResolve(C,f,_,p,c){if(k.isString(_))return this.resolveString(C,f,_,p,c);if(k.isArray(_))return _.map(v=>this.recursiveResolve(C,f,v,p,c));if(k.isObject(_)){let v=Object.create(null);return Object.keys(_).forEach(I=>{const b=this.resolveString(C,f,I,p,c);v[b]=this.recursiveResolve(C,f,_[I],p,c)}),v}return _}resolveString(C,f,_,p,c){return _.replace(T.VARIABLE_REGEXP,(I,b)=>{if(b.includes(T.VARIABLE_LHS))return I;let m=this.evaluateSingleVariable(C,I,b,f,p);return c&&c.set(b,m),m!==I&&k.isString(m)&&m.match(T.VARIABLE_REGEXP)&&(m=this.resolveString(C,f,m,p,c)),m})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,f,_,p,c){let v;const I=_.split(":");I.length>1&&(_=I[0],v=I[1]);const b=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,y.localize)(0,null,f))},m=()=>{const g=b();if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new Error((0,y.localize)(1,null,f,d.basename(g)))},o=()=>{if(v){const g=this._context.getFolderUri(v);if(g)return g;throw new Error((0,y.localize)(2,null,f,v))}if(p)return p;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,f)):new Error((0,y.localize)(4,null,f))};switch(_){case"env":if(v){if(C){const g=C[D.isWindows?v.toLowerCase():v];if(k.isString(g))return g}return""}throw new Error((0,y.localize)(5,null,f));case"config":if(v){const g=this._context.getConfigurationValue(p,v);if(k.isUndefinedOrNull(g))throw new Error((0,y.localize)(6,null,f,v));if(k.isObject(g))throw new Error((0,y.localize)(7,null,f,v));return g}throw new Error((0,y.localize)(8,null,f));case"command":return this.resolveFromMap(f,v,c,"command");case"input":return this.resolveFromMap(f,v,c,"input");default:switch(_){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return p||v?(0,P.normalizeDriveLetter)(this.fsPath(o())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(o()));case"lineNumber":{const g=this._context.getLineNumber();if(g)return g;throw new Error((0,y.localize)(9,null,f))}case"selectedText":{const g=this._context.getSelectedText();if(g)return g;throw new Error((0,y.localize)(10,null,f))}case"file":return b();case"fileWorkspaceFolder":return m();case"relativeFile":return p||v?d.relative(this.fsPath(o()),b()):b();case"relativeFileDirname":{const g=d.dirname(b());if(p||v){const n=d.relative(this.fsPath(o()),g);return n.length===0?".":n}return g}case"fileDirname":return d.dirname(b());case"fileExtname":return d.extname(b());case"fileBasename":return d.basename(b());case"fileBasenameNoExtension":{const g=d.basename(b());return g.slice(0,g.length-d.extname(g).length)}case"fileDirnameBasename":return d.basename(d.dirname(b()));case"execPath":{const g=this._context.getExecPath();return g||f}case"execInstallFolder":{const g=this._context.getAppRoot();return g||f}case"pathSeparator":return d.sep;default:try{const g=v?`${_}:${v}`:_;return this.resolveFromMap(f,g,c,void 0)}catch{return f}}}}resolveFromMap(C,f,_,p){if(f&&_){const c=p===void 0?_[f]:_[p+":"+f];if(typeof c=="string")return c;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[130],be([1,0,4,209]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var k;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var P;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function T(p){const c=p;return(0,t.isEditorInput)(c?.editor)&&(0,t.isEditorInput)(c?.replacement)}e.isEditorReplacement=T;var F;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(C=e.OpenEditorContext||(e.OpenEditorContext={}));function f(p){const c=p;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.isEditorGroup=f;function _(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=_}),define(ve[220],be([1,0,4,130]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(A){const D=A;return typeof A=="number"||(0,t.isEditorGroup)(D)}e.isPreferredGroup=k}),define(ve[15],be([1,0,17,23,101,144,59,25,18,2,41,81,184,117,63,128,87,220,7]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var m;(function(Se){function ge(ie){const{selectionStartLineNumber:Ie,selectionStartColumn:Ae,positionLineNumber:Ve,positionColumn:Ge}=ie,ot=new b.Position(Ie-1,Ae-1),bt=new b.Position(Ve-1,Ge-1);return new b.Selection(ot,bt)}Se.to=ge;function me(ie){const{anchor:Ie,active:Ae}=ie;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Ae.line+1,positionColumn:Ae.character+1}}Se.from=me})(m=e.Selection||(e.Selection={}));var o;(function(Se){function ge(ie){if(!ie)return;const{start:Ie,end:Ae}=ie;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Ae.line+1,endColumn:Ae.character+1}}Se.from=ge;function me(ie){if(!ie)return;const{startLineNumber:Ie,startColumn:Ae,endLineNumber:Ve,endColumn:Ge}=ie;return new b.Range(Ie-1,Ae-1,Ve-1,Ge-1)}Se.to=me})(o=e.Range||(e.Range={}));var g;(function(Se){function ge(me){switch(me){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 3:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}Se.to=ge})(g=e.TokenType||(e.TokenType={}));var n;(function(Se){function ge(ie){return new b.Position(ie.lineNumber-1,ie.column-1)}Se.to=ge;function me(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Se.from=me})(n=e.Position||(e.Position={}));var E;(function(Se){function ge(Ie,Ae){return(0,d.coalesce)((0,d.asArray)(Ie).map(Ve=>me(Ve,Ae)))}Se.from=ge;function me(Ie,Ae){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:ie(Ie.scheme,Ae),pattern:oe.from(Ie.pattern)??void 0,exclusive:Ie.exclusive}}function ie(Ie,Ae){return Ae&&typeof Ie=="string"?Ae.transformOutgoingScheme(Ie):Ie}})(E=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Se){function ge(ie){switch(ie){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}Se.from=ge;function me(ie){switch(ie){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}Se.to=me})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(Se){function ge(ie){let Ie;return ie.code&&((0,y.isString)(ie.code)||(0,y.isNumber)(ie.code)?Ie=String(ie.code):Ie={value:String(ie.code.value),target:ie.code.target}),{...o.from(ie.range),message:ie.message,source:ie.source,code:Ie,severity:s.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(r.from),tags:Array.isArray(ie.tags)?(0,d.coalesce)(ie.tags.map(a.from)):void 0}}Se.from=ge;function me(ie){const Ie=new b.Diagnostic(o.to(ie),ie.message,s.to(ie.severity));return Ie.source=ie.source,Ie.code=(0,y.isString)(ie.code)?ie.code:ie.code?.value,Ie.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(r.to),Ie.tags=ie.tags&&(0,d.coalesce)(ie.tags.map(a.to)),Ie}Se.to=me})(i=e.Diagnostic||(e.Diagnostic={}));var r;(function(Se){function ge(ie){return{...o.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Se.from=ge;function me(ie){return new b.DiagnosticRelatedInformation(new b.Location(ie.resource,o.to(ie)),ie.message)}Se.to=me})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var s;(function(Se){function ge(ie){switch(ie){case b.DiagnosticSeverity.Error:return _.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return _.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return _.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return _.MarkerSeverity.Hint}return _.MarkerSeverity.Error}Se.from=ge;function me(ie){switch(ie){case _.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case _.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case _.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case _.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}Se.to=me})(s=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(Se){function ge(ie){return typeof ie=="number"&&ie>=b.ViewColumn.One?ie-1:ie===b.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}Se.from=ge;function me(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=me})(l=e.ViewColumn||(e.ViewColumn={}));function h(Se){return typeof Se.range!="undefined"}function u(Se){return Se.length===0?!0:!!h(Se[0])}e.isDecorationOptionsArr=u;var w;(function(Se){function ge(Ge){return Ge.map(Se.from)}Se.fromMany=ge;function me(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ie(Ge){let ot;if(me(Ge)){const{language:ft,value:at}=Ge;ot={value:"```"+ft+`
`+at+"\n```\n"}}else b.MarkdownString.isMarkdownString(Ge)?ot={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ot={value:Ge}:ot={value:""};const bt=Object.create(null);ot.uris=bt;const yt=ft=>{try{let at=T.URI.parse(ft,!0);at=at.with({query:Ie(at.query,bt)}),bt[ft]=at}catch{}return""},_t=new A.marked.Renderer;return _t.link=yt,_t.image=ft=>typeof ft=="string"?yt(k.parseHrefAndDimensions(ft).href):"",(0,A.marked)(ot.value,{renderer:_t}),ot}Se.from=ie;function Ie(Ge,ot){if(!Ge)return Ge;let bt;try{bt=(0,D.parse)(Ge)}catch{}if(!bt)return Ge;let yt=!1;return bt=(0,P.cloneAndChange)(bt,_t=>{if(T.URI.isUri(_t)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[ft]=_t,yt=!0,ft}else return}),yt?JSON.stringify(bt):Ge}function Ae(Ge){const ot=new b.MarkdownString(Ge.value,Ge.supportThemeIcons);return ot.isTrusted=Ge.isTrusted,ot.supportHtml=Ge.supportHtml,ot.baseUri=Ge.baseUri?T.URI.from(Ge.baseUri):void 0,ot}Se.to=Ae;function Ve(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Se.from(Ge)}Se.fromStrict=Ve})(w=e.MarkdownString||(e.MarkdownString={}));function R(Se){return u(Se)?Se.map(ge=>({range:o.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?w.fromMany(ge.hoverMessage):ge.hoverMessage?w.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):Se.map(ge=>({range:o.from(ge)}))}e.fromRangeOrRangeWithMessage=R;function O(Se){return typeof Se=="undefined"?Se:typeof Se=="string"?T.URI.file(Se):Se}e.pathOrURIToURI=O;var L;(function(Se){function ge(me){return typeof me=="undefined"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?O(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Se.from=ge})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var S;(function(Se){function ge(me){return typeof me=="undefined"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?L.from(me.before):void 0,after:me.after?L.from(me.after):void 0}}Se.from=ge})(S=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var U;(function(Se){function ge(me){if(typeof me=="undefined")return me;switch(me){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=ge})(U=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var M;(function(Se){function ge(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?U.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?S.from(me.light):void 0,dark:me.dark?S.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?L.from(me.before):void 0,after:me.after?L.from(me.after):void 0}}Se.from=ge})(M=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var X;(function(Se){function ge(ie){return{text:ie.newText,eol:ie.newEol&&Qe.from(ie.newEol),range:o.from(ie.range)}}Se.from=ge;function me(ie){const Ie=new b.TextEdit(o.to(ie.range),ie.text);return Ie.newEol=typeof ie.eol=="undefined"?void 0:Qe.to(ie.eol),Ie}Se.to=me})(X=e.TextEdit||(e.TextEdit={}));var G;(function(Se){function ge(ie,Ie){const Ae={edits:[]};if(ie instanceof b.WorkspaceEdit)for(let Ve of ie._allEntries())Ve._type===1?Ae.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata}):Ve._type===2?Ae.edits.push({_type:2,resource:Ve.uri,edit:X.from(Ve.edit),modelVersionId:Ie?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Ae.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Ae.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(Ve.uri),edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Ye.from)}});return Ae}Se.from=ge;function me(ie){const Ie=new b.WorkspaceEdit;for(const Ae of ie.edits)Ae.edit?Ie.replace(T.URI.revive(Ae.resource),o.to(Ae.edit.range),Ae.edit.text):Ie.renameFile(T.URI.revive(Ae.oldUri),T.URI.revive(Ae.newUri),Ae.options);return Ie}Se.to=me})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var q;(function(Se){const ge=Object.create(null);ge[b.SymbolKind.File]=0,ge[b.SymbolKind.Module]=1,ge[b.SymbolKind.Namespace]=2,ge[b.SymbolKind.Package]=3,ge[b.SymbolKind.Class]=4,ge[b.SymbolKind.Method]=5,ge[b.SymbolKind.Property]=6,ge[b.SymbolKind.Field]=7,ge[b.SymbolKind.Constructor]=8,ge[b.SymbolKind.Enum]=9,ge[b.SymbolKind.Interface]=10,ge[b.SymbolKind.Function]=11,ge[b.SymbolKind.Variable]=12,ge[b.SymbolKind.Constant]=13,ge[b.SymbolKind.String]=14,ge[b.SymbolKind.Number]=15,ge[b.SymbolKind.Boolean]=16,ge[b.SymbolKind.Array]=17,ge[b.SymbolKind.Object]=18,ge[b.SymbolKind.Key]=19,ge[b.SymbolKind.Null]=20,ge[b.SymbolKind.EnumMember]=21,ge[b.SymbolKind.Struct]=22,ge[b.SymbolKind.Event]=23,ge[b.SymbolKind.Operator]=24,ge[b.SymbolKind.TypeParameter]=25;function me(Ie){return typeof ge[Ie]=="number"?ge[Ie]:6}Se.from=me;function ie(Ie){for(const Ae in ge)if(ge[Ae]===Ie)return Number(Ae);return b.SymbolKind.Property}Se.to=ie})(q=e.SymbolKind||(e.SymbolKind={}));var B;(function(Se){function ge(ie){switch(ie){case b.SymbolTag.Deprecated:return 1}}Se.from=ge;function me(ie){switch(ie){case 1:return b.SymbolTag.Deprecated}}Se.to=me})(B=e.SymbolTag||(e.SymbolTag={}));var x;(function(Se){function ge(ie){return{name:ie.name,kind:q.from(ie.kind),tags:ie.tags&&ie.tags.map(B.from),containerName:ie.containerName,location:ce.from(ie.location)}}Se.from=ge;function me(ie){const Ie=new b.SymbolInformation(ie.name,q.to(ie.kind),ie.containerName,ce.to(ie.location));return Ie.tags=ie.tags&&ie.tags.map(B.to),Ie}Se.to=me})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(Se){function ge(ie){const Ie={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:o.from(ie.range),selectionRange:o.from(ie.selectionRange),kind:q.from(ie.kind),tags:ie.tags?.map(B.from)??[]};return ie.children&&(Ie.children=ie.children.map(ge)),Ie}Se.from=ge;function me(ie){const Ie=new b.DocumentSymbol(ie.name,ie.detail,q.to(ie.kind),o.to(ie.range),o.to(ie.selectionRange));return(0,d.isNonEmptyArray)(ie.tags)&&(Ie.tags=ie.tags.map(B.to)),ie.children&&(Ie.children=ie.children.map(me)),Ie}Se.to=me})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var V;(function(Se){function ge(ie){const Ie=new b.CallHierarchyItem(q.to(ie.kind),ie.name,ie.detail||"",T.URI.revive(ie.uri),o.to(ie.range),o.to(ie.selectionRange));return Ie._sessionId=ie._sessionId,Ie._itemId=ie._itemId,Ie}Se.to=ge;function me(ie,Ie,Ae){if(Ie=Ie??ie._sessionId,Ae=Ae??ie._itemId,Ie===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Ae,name:ie.name,detail:ie.detail,kind:q.from(ie.kind),uri:ie.uri,range:o.from(ie.range),selectionRange:o.from(ie.selectionRange),tags:ie.tags?.map(B.from)}}Se.from=me})(V=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Z;(function(Se){function ge(me){return new b.CallHierarchyIncomingCall(V.to(me.from),me.fromRanges.map(ie=>o.to(ie)))}Se.to=ge})(Z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var se;(function(Se){function ge(me){return new b.CallHierarchyOutgoingCall(V.to(me.to),me.fromRanges.map(ie=>o.to(ie)))}Se.to=ge})(se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ce;(function(Se){function ge(ie){return{range:ie.range&&o.from(ie.range),uri:ie.uri}}Se.from=ge;function me(ie){return new b.Location(T.URI.revive(ie.uri),o.to(ie.range))}Se.to=me})(ce=e.location||(e.location={}));var ee;(function(Se){function ge(ie){const Ie=ie,Ae=ie;return{originSelectionRange:Ie.originSelectionRange?o.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Ae.uri,range:o.from(Ie.targetRange?Ie.targetRange:Ae.range),targetSelectionRange:Ie.targetSelectionRange?o.from(Ie.targetSelectionRange):void 0}}Se.from=ge;function me(ie){return{targetUri:T.URI.revive(ie.uri),targetRange:o.to(ie.range),targetSelectionRange:ie.targetSelectionRange?o.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?o.to(ie.originSelectionRange):void 0}}Se.to=me})(ee=e.DefinitionLink||(e.DefinitionLink={}));var Y;(function(Se){function ge(ie){return{range:o.from(ie.range),contents:w.fromMany(ie.contents)}}Se.from=ge;function me(ie){return new b.Hover(ie.contents.map(w.to),o.to(ie.range))}Se.to=me})(Y=e.Hover||(e.Hover={}));var ae;(function(Se){function ge(ie){return{range:o.from(ie.range),expression:ie.expression}}Se.from=ge;function me(ie){return new b.EvaluatableExpression(o.to(ie.range),ie.expression)}Se.to=me})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var he;(function(Se){function ge(ie){if(ie instanceof b.InlineValueText)return{type:"text",range:o.from(ie.range),text:ie.text};if(ie instanceof b.InlineValueVariableLookup)return{type:"variable",range:o.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=ge;function me(ie){switch(ie.type){case"text":return{range:o.to(ie.range),text:ie.text};case"variable":return{range:o.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:o.to(ie.range),expression:ie.expression}}}Se.to=me})(he=e.InlineValue||(e.InlineValue={}));var we;(function(Se){function ge(ie){return{frameId:ie.frameId,stoppedLocation:o.from(ie.stoppedLocation)}}Se.from=ge;function me(ie){return new b.InlineValueContext(ie.frameId,o.to(ie.stoppedLocation))}Se.to=me})(we=e.InlineValueContext||(e.InlineValueContext={}));var ke;(function(Se){function ge(ie){return{range:o.from(ie.range),kind:ie.kind}}Se.from=ge;function me(ie){return new b.DocumentHighlight(o.to(ie.range),ie.kind)}Se.to=me})(ke=e.DocumentHighlight||(e.DocumentHighlight={}));var Ne;(function(Se){function ge(me){switch(me){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}Se.to=ge})(Ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _e;(function(Se){function ge(me){return{triggerKind:Ne.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Se.to=ge})(_e=e.CompletionContext||(e.CompletionContext={}));var Ee;(function(Se){function ge(ie){switch(ie){case b.CompletionItemTag.Deprecated:return 1}}Se.from=ge;function me(ie){switch(ie){case 1:return b.CompletionItemTag.Deprecated}}Se.to=me})(Ee=e.CompletionItemTag||(e.CompletionItemTag={}));var z;(function(Se){const ge=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function me(Ae){return ge.get(Ae)??9}Se.from=me;const ie=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Ie(Ae){return ie.get(Ae)??b.CompletionItemKind.Property}Se.to=Ie})(z=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(Se){function ge(me,ie){const Ie=new b.CompletionItem(me.label);return Ie.insertText=me.insertText,Ie.kind=z.to(me.kind),Ie.tags=me.tags?.map(Ee.to),Ie.detail=me.detail,Ie.documentation=k.isMarkdownString(me.documentation)?w.to(me.documentation):me.documentation,Ie.sortText=me.sortText,Ie.filterText=me.filterText,Ie.preselect=me.preselect,Ie.commitCharacters=me.commitCharacters,F.Range.isIRange(me.range)?Ie.range=o.to(me.range):typeof me.range=="object"&&(Ie.range={inserting:o.to(me.range.insert),replacing:o.to(me.range.replace)}),Ie.keepWhitespace=typeof me.insertTextRules=="undefined"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules!="undefined"&&me.insertTextRules&4?Ie.insertText=new b.SnippetString(me.insertText):(Ie.insertText=me.insertText,Ie.textEdit=Ie.range instanceof b.Range?new b.TextEdit(Ie.range,Ie.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ie.additionalTextEdits=me.additionalTextEdits.map(Ae=>X.to(Ae))),Ie.command=ie&&me.command?ie.fromInternal(me.command):void 0,Ie}Se.to=ge})(W=e.CompletionItem||(e.CompletionItem={}));var N;(function(Se){function ge(ie){return{label:ie.label,documentation:ie.documentation?w.fromStrict(ie.documentation):void 0}}Se.from=ge;function me(ie){return{label:ie.label,documentation:k.isMarkdownString(ie.documentation)?w.to(ie.documentation):ie.documentation}}Se.to=me})(N=e.ParameterInformation||(e.ParameterInformation={}));var $;(function(Se){function ge(ie){return{label:ie.label,documentation:ie.documentation?w.fromStrict(ie.documentation):void 0,parameters:Array.isArray(ie.parameters)?ie.parameters.map(N.from):[],activeParameter:ie.activeParameter}}Se.from=ge;function me(ie){return{label:ie.label,documentation:k.isMarkdownString(ie.documentation)?w.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(N.to):[],activeParameter:ie.activeParameter}}Se.to=me})($=e.SignatureInformation||(e.SignatureInformation={}));var K;(function(Se){function ge(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map($.from):[]}}Se.from=ge;function me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map($.to):[]}}Se.to=me})(K=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(Se){function ge(me,ie){const Ie=new b.InlayHint(typeof ie.label=="string"?ie.label:ie.label.map(de.to.bind(void 0,me)),n.to(ie.position),ye.to(ie.kind));return Ie.tooltip=k.isMarkdownString(ie.tooltip)?w.to(ie.tooltip):ie.tooltip,Ie.paddingLeft=ie.paddingLeft,Ie.paddingRight=ie.paddingRight,Ie}Se.to=ge})(re=e.InlayHint||(e.InlayHint={}));var de;(function(Se){function ge(me,ie){const Ie=new b.InlayHintLabelPart(ie.label);return Ie.tooltip=k.isMarkdownString(ie.tooltip)?w.to(ie.tooltip):ie.tooltip,C.Command.is(ie.command)&&(Ie.command=me.fromInternal(ie.command)),ie.location&&(Ie.location=ce.to(ie.location)),Ie}Se.to=ge})(de=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ye;(function(Se){function ge(ie){return ie}Se.from=ge;function me(ie){return ie}Se.to=me})(ye=e.InlayHintKind||(e.InlayHintKind={}));var Re;(function(Se){function ge(ie){return{range:o.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Se.from=ge;function me(ie){let Ie;if(ie.url)try{Ie=typeof ie.url=="string"?T.URI.parse(ie.url,!0):T.URI.revive(ie.url)}catch{}return new b.DocumentLink(o.to(ie.range),Ie)}Se.to=me})(Re=e.DocumentLink||(e.DocumentLink={}));var We;(function(Se){function ge(ie){const Ie=new b.ColorPresentation(ie.label);return ie.textEdit&&(Ie.textEdit=X.to(ie.textEdit)),ie.additionalTextEdits&&(Ie.additionalTextEdits=ie.additionalTextEdits.map(Ae=>X.to(Ae))),Ie}Se.to=ge;function me(ie){return{label:ie.label,textEdit:ie.textEdit?X.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Ie=>X.from(Ie)):void 0}}Se.from=me})(We=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(Se){function ge(ie){return new b.Color(ie[0],ie[1],ie[2],ie[3])}Se.to=ge;function me(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Se.from=me})($e=e.Color||(e.Color={}));var je;(function(Se){function ge(ie){return{range:o.from(ie.range)}}Se.from=ge;function me(ie){return new b.SelectionRange(o.to(ie.range))}Se.to=me})(je=e.SelectionRange||(e.SelectionRange={}));var ze;(function(Se){function ge(me){switch(me){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}Se.to=ge})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ue;(function(Se){function ge(ie){switch(ie){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=ge;function me(ie){switch(ie){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}Se.to=me})(Ue=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Qe;(function(Se){function ge(ie){if(ie===b.EndOfLine.CRLF)return 1;if(ie===b.EndOfLine.LF)return 0}Se.from=ge;function me(ie){if(ie===1)return b.EndOfLine.CRLF;if(ie===0)return b.EndOfLine.LF}Se.to=me})(Qe=e.EndOfLine||(e.EndOfLine={}));var nt;(function(Se){function ge(me){if(typeof me=="object")return me.viewId;switch(me){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=ge})(nt=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(Se){function ge(me){const ie={start:me.start+1,end:me.end+1};return me.kind&&(ie.kind=et.from(me.kind)),ie}Se.from=ge})(Le=e.FoldingRange||(e.FoldingRange={}));var et;(function(Se){function ge(me){if(me)switch(me){case b.FoldingRangeKind.Comment:return C.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return C.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return C.FoldingRangeKind.Region}}Se.from=ge})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ne;(function(Se){function ge(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?o.from(me.selection):void 0,override:typeof me.override=="boolean"?f.EditorResolution.DISABLED:void 0}}Se.from=ge})(ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var oe;(function(Se){function ge(Ae){return Ae instanceof b.RelativePattern?Ae.toJSON():typeof Ae=="string"?Ae:me(Ae)||ie(Ae)?new b.RelativePattern(Ae.baseUri??Ae.base,Ae.pattern).toJSON():Ae}Se.from=ge;function me(Ae){const Ve=Ae;return Ve?T.URI.isUri(Ve.baseUri)&&typeof Ve.pattern=="string":!1}function ie(Ae){const Ve=Ae;return Ve?typeof Ve.base=="string"&&typeof Ve.pattern=="string":!1}function Ie(Ae){return typeof Ae=="string"?Ae:new b.RelativePattern(T.URI.revive(Ae.baseUri),Ae.pattern)}Se.to=Ie})(oe=e.GlobPattern||(e.GlobPattern={}));var J;(function(Se){function ge(me){if(me){if(Array.isArray(me))return me.map(ge);if(typeof me=="string")return me;{const ie=me;return{language:ie.language,scheme:ie.scheme,pattern:oe.from(ie.pattern),exclusive:ie.exclusive}}}else return}Se.from=ge})(J=e.LanguageSelector||(e.LanguageSelector={}));var pe;(function(Se){function ge(ie){return{start:ie.start,end:ie.end}}Se.from=ge;function me(ie){return new b.NotebookRange(ie.start,ie.end)}Se.to=me})(pe=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(Se){function ge(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Se.to=ge;function me(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Se.from=me})(Ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Me;(function(Se){function ge(ie){switch(ie){case b.NotebookCellKind.Markup:return c.CellKind.Markup;case b.NotebookCellKind.Code:default:return c.CellKind.Code}}Se.from=ge;function me(ie){switch(ie){case c.CellKind.Markup:return b.NotebookCellKind.Markup;case c.CellKind.Code:default:return b.NotebookCellKind.Code}}Se.to=me})(Me=e.NotebookCellKind||(e.NotebookCellKind={}));var He;(function(Se){function ge(ie){const Ie={metadata:ie.metadata??Object.create(null),cells:[]};for(let Ae of ie.cells)b.NotebookCellData.validate(Ae),Ie.cells.push(Ye.from(Ae));return Ie}Se.from=ge;function me(ie){const Ie=new b.NotebookData(ie.cells.map(Ye.to));return(0,y.isEmptyObject)(ie.metadata)||(Ie.metadata=ie.metadata),Ie}Se.to=me})(He=e.NotebookData||(e.NotebookData={}));var Ye;(function(Se){function ge(ie){return{cellKind:Me.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Ce.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(gt.from):[]}}Se.from=ge;function me(ie){return new b.NotebookCellData(Me.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(gt.to):void 0,ie.metadata,ie.internalMetadata?Ce.to(ie.internalMetadata):void 0)}Se.to=me})(Ye=e.NotebookCellData||(e.NotebookCellData={}));var rt;(function(Se){function ge(ie){return{mime:ie.mime,valueBytes:t.VSBuffer.wrap(ie.data)}}Se.from=ge;function me(ie){return new b.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}Se.to=me})(rt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var gt;(function(Se){function ge(ie){return{outputId:ie.id,items:ie.items.map(rt.from),metadata:ie.metadata}}Se.from=ge;function me(ie){const Ie=ie.items.map(rt.to);return new b.NotebookCellOutput(Ie,ie.outputId,ie.metadata)}Se.to=me})(gt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var vt;(function(Se){function ge(Ie){return ie(Ie)?{include:(0,y.withNullAsUndefined)(oe.from(Ie.include)),exclude:(0,y.withNullAsUndefined)(oe.from(Ie.exclude))}:(0,y.withNullAsUndefined)(oe.from(Ie))}Se.from=ge;function me(Ie){return ie(Ie)?{include:oe.to(Ie.include),exclude:oe.to(Ie.exclude)}:oe.to(Ie)}Se.to=me;function ie(Ie){const Ae=Ie;return Ae?!!Ae.include&&!!Ae.exclude:!1}})(vt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var xe;(function(Se){function ge(me){return{backgroundColor:me.backgroundColor,borderColor:me.borderColor,top:me.top?L.from(me.top):void 0}}Se.from=ge})(xe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var st;(function(Se){function ge(me,ie,Ie){const Ae=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(Ae,Ie),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Se.from=ge})(st=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Et;(function(Se){function ge(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}Se.from=ge})(Et=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var tt;(function(Se){function ge(ie){return{uri:ie.uri,provides:ie.provides}}Se.from=ge;function me(ie){return new b.NotebookRendererScript(T.URI.revive(ie.uri),ie.provides)}Se.to=me})(tt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ct;(function(Se){function ge(ie){return{message:w.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,location:ie.location?ce.from(ie.location):void 0}}Se.from=ge;function me(ie){const Ie=new b.TestMessage(typeof ie.message=="string"?ie.message:w.to(ie.message));return Ie.actualOutput=ie.actual,Ie.expectedOutput=ie.expected,Ie.location=ie.location?ce.to(ie.location):void 0,Ie}Se.to=me})(ct=e.TestMessage||(e.TestMessage={}));var Pt;(function(Se){let ge;(function(me){me.Delimiter="\0"})(ge||(ge={})),Se.namespace=(me,ie)=>me+"\0"+ie,Se.denamespace=me=>{const ie=me.indexOf("\0");return{ctrlId:me.slice(0,ie),tagId:me.slice(ie+1)}}})(Pt=e.TestTag||(e.TestTag={}));var Rt;(function(Se){function ge(Ae){const Ve=(0,p.getPrivateApiFor)(Ae).controllerId;return{extId:v.TestId.fromExtHostTestItem(Ae,Ve).toString(),label:Ae.label,uri:Ae.uri,tags:Ae.tags.map(Ge=>Pt.namespace(Ve,Ge.id)),range:o.from(Ae.range)||null,description:Ae.description||null,sortText:Ae.sortText||null,error:Ae.error&&w.fromStrict(Ae.error)||null}}Se.from=ge;function me(Ae){return{parent:void 0,error:void 0,id:v.TestId.fromString(Ae.extId).localId,label:Ae.label,uri:T.URI.revive(Ae.uri),tags:(Ae.tags||[]).map(Ve=>{const{tagId:Ge}=Pt.denamespace(Ve);return new b.TestTag(Ge)}),range:o.to(Ae.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ae.description||void 0,sortText:Ae.sortText||void 0}}Se.toPlain=me;function ie(Ae){const Ve=v.TestId.fromString(Ae.extId),Ge=new p.TestItemImpl(Ve.controllerId,Ve.localId,Ae.label,T.URI.revive(Ae.uri));return Ge.range=o.to(Ae.range||void 0),Ge.description=Ae.description||void 0,Ge.sortText=Ae.sortText||void 0,Ge}function Ie(Ae){let Ve;for(const Ge of Ae.tests){const ot=ie(Ge.item);(0,p.getPrivateApiFor)(ot).parent=Ve,Ve=ot}return Ve}Se.toItemFromContext=Ie})(Rt=e.TestItem||(e.TestItem={})),function(Se){function ge(ie){return{id:ie.id}}Se.from=ge;function me(ie){return new b.TestTag(ie.id)}Se.to=me}(Pt=e.TestTag||(e.TestTag={}));var Tt;(function(Se){const ge=(ie,Ie)=>{const Ae={...Rt.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(Ge=>Ge.type===0).map(ct.to)})),children:ie.children.map(Ve=>Ie.get(Ve)).filter(y.isDefined).map(Ve=>ge(Ve,Ie))};for(const Ve of Ae.children)Ve.parent=Ae;return Ae};function me(ie){const Ie=[],Ae=new Map;for(const Ve of ie.items)Ae.set(Ve.item.extId,Ve),ie.request.targets.some(Ge=>Ge.controllerId===Ve.controllerId&&Ge.testIds.includes(Ve.item.extId))&&Ie.push(Ve);return{completedAt:ie.completedAt,results:Ie.map(Ve=>ge(Ve,Ae))}}Se.to=me})(Tt=e.TestResults||(e.TestResults={}));var ut;(function(Se){function ge(Ae){return{covered:Ae.covered,total:Ae.covered}}function me(Ae){return"line"in Ae?n.from(Ae):o.from(Ae)}function ie(Ae){return"branches"in Ae?{count:Ae.executionCount,location:me(Ae.location),type:1,branches:Ae.branches.length?Ae.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&me(Ve.location)})):void 0}:{type:0,count:Ae.executionCount,location:me(Ae.location)}}Se.fromDetailed=ie;function Ie(Ae){return{uri:Ae.uri,statement:ge(Ae.statementCoverage),branch:Ae.branchCoverage&&ge(Ae.branchCoverage),function:Ae.functionCoverage&&ge(Ae.functionCoverage),details:Ae.detailedCoverage?.map(ie)}}Se.fromFile=Ie})(ut=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(Se){function ge(me){switch(me){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}Se.to=ge})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(Se){function ge(ie){const Ie=new b.TypeHierarchyItem(q.to(ie.kind),ie.name,ie.detail||"",T.URI.revive(ie.uri),o.to(ie.range),o.to(ie.selectionRange));return Ie._sessionId=ie._sessionId,Ie._itemId=ie._itemId,Ie}Se.to=ge;function me(ie,Ie,Ae){if(Ie=Ie??ie._sessionId,Ae=Ae??ie._itemId,Ie===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Ae,kind:q.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:o.from(ie.range),selectionRange:o.from(ie.selectionRange),tags:ie.tags?.map(B.from)}}Se.from=me})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[221],be([1,0,2,16,7,15,92]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(T,F,C,f={timeout:1500,errors:3}){this._logService=T,this._documents=F,this._mainThreadBulkEdits=C,this._thresholds=f,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(F,C,f)=>{const p={dispose:this._callbacks.push([F,C,T])};return Array.isArray(f)&&f.push(p),p}}async $participateInSave(T,F){const C=d.URI.revive(T);let f=!1;const _=setTimeout(()=>f=!0,this._thresholds.timeout),p=[];try{for(let c of[...this._callbacks]){if(f)break;const v=this._documents.getDocument(C),I=await this._deliverEventAsyncAndBlameBadListeners(c,{document:v,reason:A.TextDocumentSaveReason.to(F)});p.push(I)}}finally{clearTimeout(_)}return p}_deliverEventAsyncAndBlameBadListeners([T,F,C],f){const _=this._badListeners.get(T);return typeof _=="number"&&_>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,T,F,f).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const c=this._badListeners.get(T);this._badListeners.set(T,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,F,C,f){const _=[],p=Date.now(),{document:c,reason:v}=f,{version:I}=c,b=Object.freeze({document:c,reason:v,waitUntil(m){if(Object.isFrozen(_))throw(0,t.illegalState)("waitUntil can not be called async");_.push(Promise.resolve(m))}});try{F.apply(C,[b])}catch(m){return Promise.reject(m)}return Object.freeze(_),new Promise((m,o)=>{const g=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(_).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(g),m(n)}).catch(n=>{clearTimeout(g),o(n)})}).then(m=>{const o={edits:[]};for(const g of m)if(Array.isArray(g)&&g.every(n=>n instanceof k.TextEdit))for(const{newText:n,newEol:E,range:a}of g)o.edits.push({_type:2,resource:c.uri,edit:{range:a&&A.Range.from(a),text:n,eol:E&&A.EndOfLine.from(E)}});if(o.edits.length!==0)return I===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ve[222],be([1,0,10,25,2,15,128]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(C,f,_,p){this.start=C,this.deletedCount=f,this.deletedItems=_,this.items=p}static asApiEvents(C){return C.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(_=>_.apiCell)}))}}class y{constructor(C,f,_){this.notebook=C,this._extHostDocument=f,this._cellData=_,this.handle=_.handle,this.uri=k.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=_.internalMetadata??{},this._metadata=Object.freeze(_.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(_.internalMetadata??{}))}static asModelAddData(C,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:C}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const C=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return C._mime},set mime(_){C._mime=_},get outputs(){return C._outputs.slice(0)},get metadata(){return C._metadata},get executionSummary(){return C._previousResult}})}return this._apiCell}setOutputs(C){this._outputs=C.map(A.NotebookCellOutput.to)}setOutputItems(C,f,_){const p=_.map(A.NotebookCellOutputItem.to),c=this._outputs.find(v=>v.id===C);c&&(f||(c.items.length=0),c.items.push(...p))}setMetadata(C){this._metadata=Object.freeze(C)}setInternalMetadata(C){this._internalMetadata=C,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.ExtHostCell=y;class T{constructor(C,f,_,p,c,v){this._proxy=C,this._textDocumentsAndEditors=f,this._textDocuments=_,this._emitter=p,this.uri=c,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=v.viewType,this._metadata=Object.freeze(v.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,v.cells]],!0),this._versionId=v.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const C=this;this._notebook={get uri(){return C.uri},get version(){return C._versionId},get notebookType(){return C._notebookType},get isDirty(){return C._isDirty},get isUntitled(){return C.uri.scheme===d.Schemas.untitled},get isClosed(){return C._disposed},get metadata(){return C._metadata},get cellCount(){return C._cells.length},cellAt(f){return f=C._validateIndex(f),C._cells[f].apiCell},getCells(f){return(f?C._getCells(f):C._cells).map(p=>p.apiCell)},save(){return C._save()}}}return this._notebook}updateBackup(C){this._backup?.delete(),this._backup=C}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(C){C.metadata&&(this._metadata=Object.freeze({...this._metadata,...C.metadata}))}acceptDirty(C){this._isDirty=C}acceptModelChanged(C,f){this._versionId=C.versionId,this._isDirty=f;for(const _ of C.rawEvents)_.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(_.changes,!1):_.kind===D.NotebookCellsChangeType.Move?this._moveCell(_.index,_.newIdx):_.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(_.index,_.outputs):_.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(_.index,_.outputId,_.append,_.outputItems):_.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(_.index,_.language):_.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(_.index,_.mime):_.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(_.index,_.metadata):_.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(_.index,_.internalMetadata)}_validateIndex(C){return C=C|0,C<0?0:C>=this._cells.length?this._cells.length-1:C}_validateRange(C){let f=C.start|0,_=C.end|0;return f<0&&(f=0),_>this._cells.length&&(_=this._cells.length),C.with({start:f,end:_})}_getCells(C){C=this._validateRange(C);const f=[];for(let _=C.start;_<C.end;_++)f.push(this._cells[_]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(C,f){if(this._disposed)return;const _=[],p=[],c=[];C.reverse().forEach(v=>{const b=v[2].map(g=>{const n=new y(this,this._textDocumentsAndEditors,g);return f||p.push(y.asModelAddData(this.apiNotebook,g)),n}),m=new P(v[0],v[1],[],b),o=this._cells.splice(v[0],v[1],...b);for(const g of o)c.push(g.uri),m.deletedItems.push(g.apiCell);_.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:c}),f||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(_)}))}_moveCell(C,f){const _=this._cells.splice(C,1);this._cells.splice(f,0,..._);const p=[new P(C,1,_.map(c=>c.apiCell),[]),new P(f,0,[],_)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(p)}))}_setCellOutputs(C,f){const _=this._cells[C];_.setOutputs(f),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_setCellOutputItems(C,f,_,p){const c=this._cells[C];c.setOutputItems(f,_,p),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_changeCellLanguage(C,f){const _=this._cells[C];_.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelLanguageChanged(_.uri,f)}_changeCellMime(C,f){const _=this._cells[C];_.apiCell.mime=f}_changeCellMetadata(C,f){const _=this._cells[C],p=_.apiCell.metadata;_.setMetadata(f);const c=_.apiCell.metadata;(0,t.equals)(p,c)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:_.apiCell}))}_changeCellInternalMetadata(C,f){this._cells[C].setInternalMetadata(f)}getCellFromApiCell(C){return this._cells.find(f=>f.apiCell===C)}getCellFromIndex(C){return this._cells[C]}getCell(C){return this._cells.find(f=>f.handle===C)}getCellIndex(C){return this._cells.indexOf(C)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(ve[131],be([1,0,7,15,16]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:T})}replaceCells(y,T,F){this._throwIfFinalized(),!(y===T&&F.length===0)&&this._collectedEdits.push({editType:1,index:y,count:T-y,cells:F.map(t.NotebookCellData.from)})}}class D{constructor(y,T,F,C,f,_){this.id=y,this._proxy=T,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=f,this._visibleRanges=C,this._viewColumn=_}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(T){if(!Array.isArray(T)||!T.every(d.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");y._selections=T,y._trySetSelections(T)},get visibleRanges(){return y._visibleRanges},revealRange(T,F){y._proxy.$tryRevealRange(y.id,t.NotebookRange.from(T),F??d.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(T){const F=new A(this.document.version);return T(F),y._applyEdit(F.finalize())},setDecorations(T,F){return y.setDecorations(T,F)}},D.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(t.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const T=[];let F=-1;for(let C=0;C<y.cellEdits.length;C++){if(F<0){T.push(y.cellEdits[C]),F++;continue}const _=T[F],p=y.cellEdits[C];if(_.editType===1&&p.editType===1&&_.index===p.index){_.cells.push(...y.cellEdits[C].cells),_.count+=y.cellEdits[C].count;continue}T.push(y.cellEdits[C]),F++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,T)}setDecorations(y,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return T.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(T),y.key)}}e.ExtHostNotebookEditor=D,D.apiEditorsToExtHost=new WeakMap}),define(ve[223],be([1,0,15,119,170,21,56,16]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(f){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=f}async withProgress(f,_,p){const c=this._handles++,{title:v,location:I,cancellable:b}=_,m={label:(0,k.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this._proxy.$startProgress(c,{location:d.ProgressLocation.from(I),title:v,source:m,cancellable:b},f.isUnderDevelopment?void 0:f.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(c,p,!!b)}_withProgress(f,_,p){let c;p&&(c=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(f,c));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),c&&c.dispose()};let I;try{I=_(new F(this._proxy,f),p&&c?c.token:A.CancellationToken.None)}catch(b){throw v(f),b}return I.then(b=>v(f),b=>v(f)),I}$acceptProgressCanceled(f){const _=this._mapHandleToCancellationSource.get(f);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(f))}}e.ExtHostProgress=y;function T(C,f){return C.message=f.message,typeof f.increment=="number"&&(typeof C.increment=="number"?C.increment+=f.increment:C.increment=f.increment),C}class F extends t.Progress{constructor(f,_){super(p=>this.throttledReport(p));this._proxy=f,this._handle=_}throttledReport(f){this._proxy.$progressReport(this._handle,f)}}Be([(0,D.throttle)(100,(C,f)=>T(C,f),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(ve[132],be([1,0,55,16,76,15,7]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(f,_,p){const c=P._Keys.nextId();f.$registerTextEditorDecorationType(_.identifier,c,A.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:c,dispose(){f.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=P,P._Keys=new k.IdGenerator("TextEditorDecorationType");class y{constructor(f,_){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=f,this._documentVersionId=f.version,this._undoStopBefore=_.undoStopBefore,this._undoStopAfter=_.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(f,_){this._throwIfFinalized();let p=null;if(f instanceof D.Position)p=new D.Range(f,f);else if(f instanceof D.Range)p=f;else throw new Error("Unrecognized location");this._pushEdit(p,_,!1)}insert(f,_){this._throwIfFinalized(),this._pushEdit(new D.Range(f,f),_,!0)}delete(f){this._throwIfFinalized();let _=null;if(f instanceof D.Range)_=f;else throw new Error("Unrecognized location");this._pushEdit(_,null,!0)}_pushEdit(f,_,p){const c=this._document.validateRange(f);this._collectedEdits.push({range:c,text:_,forceMoveMarkers:p})}setEndOfLine(f){if(this._throwIfFinalized(),f!==D.EndOfLine.LF&&f!==D.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=f}}e.TextEditorEdit=y;class T{constructor(f,_,p,c){this._proxy=f,this._id=_,this._accept(p),this._logService=c;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(I){v._setTabSize(I)},get insertSpaces(){return v._insertSpaces},set insertSpaces(I){v._setInsertSpaces(I)},get cursorStyle(){return v._cursorStyle},set cursorStyle(I){v._setCursorStyle(I)},get lineNumbers(){return v._lineNumbers},set lineNumbers(I){v._setLineNumbers(I)}}}_accept(f){this._tabSize=f.tabSize,this._insertSpaces=f.insertSpaces,this._cursorStyle=f.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(f.lineNumbers)}_validateTabSize(f){if(f==="auto")return"auto";if(typeof f=="number"){const _=Math.floor(f);return _>0?_:null}if(typeof f=="string"){const _=parseInt(f,10);return isNaN(_)?null:_>0?_:null}return null}_setTabSize(f){const _=this._validateTabSize(f);if(_!==null){if(typeof _=="number"){if(this._tabSize===_)return;this._tabSize=_}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:_}))}}_validateInsertSpaces(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}_setInsertSpaces(f){const _=this._validateInsertSpaces(f);if(typeof _=="boolean"){if(this._insertSpaces===_)return;this._insertSpaces=_}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:_}))}_setCursorStyle(f){this._cursorStyle!==f&&(this._cursorStyle=f,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:f})))}_setLineNumbers(f){this._lineNumbers!==f&&(this._lineNumbers=f,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(f)})))}assign(f){const _={};let p=!1;if(typeof f.tabSize!="undefined"){const c=this._validateTabSize(f.tabSize);c==="auto"?(p=!0,_.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,p=!0,_.tabSize=c)}if(typeof f.insertSpaces!="undefined"){const c=this._validateInsertSpaces(f.insertSpaces);c==="auto"?(p=!0,_.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,p=!0,_.insertSpaces=c)}typeof f.cursorStyle!="undefined"&&this._cursorStyle!==f.cursorStyle&&(this._cursorStyle=f.cursorStyle,p=!0,_.cursorStyle=f.cursorStyle),typeof f.lineNumbers!="undefined"&&this._lineNumbers!==f.lineNumbers&&(this._lineNumbers=f.lineNumbers,p=!0,_.lineNumbers=A.TextEditorLineNumbersStyle.from(f.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,_))}_warnOnError(f,_){_.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=T;class F{constructor(f,_,p,c,v,I,b,m){this.id=f,this._proxy=_,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new T(this._proxy,this.id,I,p),this._visibleRanges=b,this._viewColumn=m;const o=this;this.value=Object.freeze({get document(){return c.getValue()},set document(g){throw(0,t.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(g){if(!(g instanceof D.Selection))throw(0,t.illegalArgument)("selection");o._selections=[g],o._trySetSelection()},get selections(){return o._selections},set selections(g){if(!Array.isArray(g)||g.some(n=>!(n instanceof D.Selection)))throw(0,t.illegalArgument)("selections");o._selections=g,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(g){throw(0,t.readonly)("visibleRanges")},get options(){return o._options.value},set options(g){o._disposed||o._options.assign(g)},get viewColumn(){return o._viewColumn},set viewColumn(g){throw(0,t.readonly)("viewColumn")},edit(g,n={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const E=new y(c.getValue(),n);return g(E),o._applyEdit(E)},insertSnippet(g,n,E={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!n||Array.isArray(n)&&n.length===0)a=o._selections.map(i=>A.Range.from(i));else if(n instanceof D.Position){const{lineNumber:i,column:r}=A.Position.from(n);a=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(n instanceof D.Range)a=[A.Range.from(n)];else{a=[];for(const i of n)if(i instanceof D.Range)a.push(A.Range.from(i));else{const{lineNumber:r,column:s}=A.Position.from(i);a.push({startLineNumber:r,startColumn:s,endLineNumber:r,endColumn:s})}}return _.$tryInsertSnippet(f,g.value,a,E)},setDecorations(g,n){const E=n.length===0;E&&!o._hasDecorationsForKey.has(g.key)||(E?o._hasDecorationsForKey.delete(g.key):o._hasDecorationsForKey.add(g.key),o._runOnProxy(()=>{if(A.isDecorationOptionsArr(n))return _.$trySetDecorations(f,g.key,A.fromRangeOrRangeWithMessage(n));{const a=new Array(4*n.length);for(let i=0,r=n.length;i<r;i++){const s=n[i];a[4*i]=s.start.line+1,a[4*i+1]=s.start.character+1,a[4*i+2]=s.end.line+1,a[4*i+3]=s.end.character+1}return _.$trySetDecorationsFast(f,g.key,a)}}))},revealRange(g,n){o._runOnProxy(()=>_.$tryRevealRange(f,A.Range.from(g),n||D.TextEditorRevealType.Default))},show(g){_.$tryShowEditor(f,A.ViewColumn.from(g))},hide(){_.$tryHideEditor(f)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(f){(0,d.ok)(!this._disposed),this._options._accept(f)}_acceptVisibleRanges(f){(0,d.ok)(!this._disposed),this._visibleRanges=f}_acceptViewColumn(f){(0,d.ok)(!this._disposed),this._viewColumn=f}_acceptSelections(f){(0,d.ok)(!this._disposed),this._selections=f}async _trySetSelection(){const f=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,f)),this.value}_applyEdit(f){const _=f.finalize();if(_.edits.length===0&&!_.setEndOfLine)return Promise.resolve(!0);const p=_.edits.map(v=>v.range);p.sort((v,I)=>v.end.line===I.end.line?v.end.character===I.end.character?v.start.line===I.start.line?v.start.character-I.start.character:v.start.line-I.start.line:v.end.character-I.end.character:v.end.line-I.end.line);for(let v=0,I=p.length-1;v<I;v++){const b=p[v].end;if(p[v+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=_.edits.map(v=>({range:A.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,c,{setEndOfLine:typeof _.setEndOfLine=="number"?A.EndOfLine.from(_.setEndOfLine):void 0,undoStopBefore:_.undoStopBefore,undoStopAfter:_.undoStopAfter})}_runOnProxy(f){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,_=>(_ instanceof Error&&_.name==="DISPOSED"||this._logService.warn(_),null))}}e.ExtHostTextEditor=F}),define(ve[224],be([1,0,13,3,6,18,63,15,129,87]),function(te,e,d,t,k,A,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends k.Disposable{constructor(f){super();this.controllerId=f,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new D.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(f){this._resolveHandler=f;for(const _ of this.tree.values())this.updateExpandability(_)}collectDiff(){const f=this.diff;return this.diff=[],f}pushDiff(f){const _=this.diff[this.diff.length-1];if(_&&f[0]===1){if(_[0]===1&&_[1].extId===f[1].extId){(0,y.applyTestItemUpdate)(_[1],f[1]);return}if(_[0]===0&&_[1].item.extId===f[1].extId){(0,y.applyTestItemUpdate)(_[1],f[1]);return}}this.diff.push(f),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(f,_){const p=this.tree.get(f);if(!!p){if((p.expandLevels===void 0||_>p.expandLevels)&&(p.expandLevels=_),p.expand===1){const c=this.resolveChildren(p);return c.isOpen()?this.expandChildren(p,_-1):c.wait().then(()=>this.expandChildren(p,_-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,_-1)):this.expandChildren(p,_-1)}}dispose(){for(const f of this.tree.values())(0,D.getPrivateApiFor)(f.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(f,_){switch(_.op){case 2:this.pushDiff([4,f.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(f.fullId,_.id));break;case 0:this.upsertItem(_.item,f);break;case 4:for(const p of _.ops)this.onTestItemEvent(f,p);break;case 3:{const{key:p,value:c,previous:v}=_,I=f.fullId.toString();switch(p){case"canResolveChildren":this.updateExpandability(f);break;case"tags":this.diffTagRefs(c,v,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:P.Range.from(c)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:P.MarkdownString.fromStrict(c)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[p]:c??null}}]);break}break}default:(0,A.assertNever)(_)}}upsertItem(f,_){if(!(f instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${f.id} did not`);const p=T.TestId.fromExtHostTestItem(f,this.root.id,_?.actual),c=(0,D.getPrivateApiFor)(f);c.parent&&c.parent!==_?.actual&&c.parent.children.delete(f.id);let v=this.tree.get(p.toString());if(!v){v={fullId:p,actual:f,parent:_?p.parentId:null,expandLevels:_?.expandLevels?_.expandLevels-1:void 0,expand:0},f.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(f,_),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:P.TestItem.from(f)}]),this.connectItemAndChildren(f,v,_);return}if(v.actual===f){this.connectItem(f,v,_);return}const I=v.actual.children,b=v.actual,m=(0,D.diffTestItems)(b,f);(0,D.getPrivateApiFor)(b).listener=void 0,v.actual=f,v.expand=0;for(const[o,g]of m)this.onTestItemEvent(v,{op:3,key:o,value:g,previous:b[o]});this.connectItemAndChildren(f,v,_);for(const o of I)f.children.get(o.id)||this.removeItem(T.TestId.joinToString(p,o.id))}diffTagRefs(f,_,p){const c=new Set(_.map(v=>v.id));for(const v of f)c.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:p,item:{tags:f.map(v=>P.TestTag.namespace(this.controllerId,v.id))}}]),c.forEach(this.decrementTagRefs,this)}incrementTagRefs(f){const _=this.tags.get(f.id);_?_.refCount++:(this.tags.set(f.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,f.id),ctrlLabel:this.root.label}]))}decrementTagRefs(f){const _=this.tags.get(f);_&&!--_.refCount&&(this.tags.delete(f),this.pushDiff([6,P.TestTag.namespace(this.controllerId,f)]))}setItemParent(f,_){(0,D.getPrivateApiFor)(f).parent=_&&_.actual!==this.root?_.actual:void 0}connectItem(f,_,p){this.setItemParent(f,p);const c=(0,D.getPrivateApiFor)(f);c.parent=p?.actual,c.listener=v=>this.onTestItemEvent(_,v),this.updateExpandability(_)}connectItemAndChildren(f,_,p){this.connectItem(f,_,p);for(const c of f.children)this.upsertItem(c,_)}updateExpandability(f){let _;this._resolveHandler?f.resolveBarrier?_=f.resolveBarrier.isOpen()?3:2:_=f.actual.canResolveChildren?1:0:_=0,_!==f.expand&&(f.expand=_,this.pushDiff([1,{extId:f.fullId.toString(),expand:_}]),_===1&&f.expandLevels!==void 0&&this.resolveChildren(f))}expandChildren(f,_){if(_<0)return;const p=[];for(const c of f.actual.children){const v=this.expand(T.TestId.joinToString(f.fullId,c.id),_);(0,d.isThenable)(v)&&p.push(v)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this._resolveHandler){const v=new d.Barrier;return v.open(),v}f.expand=2,this.pushExpandStateUpdate(f);const _=f.resolveBarrier=new d.Barrier,p=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),f.actual!==this.root&&(f.actual.error=v.stack||v.message||String(v))};let c;try{c=this._resolveHandler(f.actual===this.root?void 0:f.actual)}catch(v){p(v)}return(0,d.isThenable)(c)?c.catch(p).then(()=>{_.open(),this.updateExpandability(f)}):(_.open(),this.updateExpandability(f)),f.resolveBarrier}pushExpandStateUpdate(f){this.pushDiff([1,{extId:f.fullId.toString(),expand:f.expand}])}removeItem(f){const _=this.tree.get(f);if(!_)throw new Error("attempting to remove non-existent child");this.pushDiff([2,f]);const p=[_];for(;p.length;){const c=p.pop();if(!!c){(0,D.getPrivateApiFor)(c.actual).listener=void 0;for(const v of c.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(c.fullId.toString());for(const v of c.actual.children)p.push(this.tree.get(T.TestId.joinToString(c.fullId,v.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.diffOpEmitter.fire(f)}}e.SingleUseTestCollection=F}),define(ve[225],be([1,0,4,187]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(t.IEnvironmentService)}),define(ve[226],be([1,0,27,3,9]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=A;class D{constructor(F){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let C of F.activationEvents)C==="onUri"&&(C=`onUri:${d.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(F)}}keepOnly(F){const C=new Set;F.forEach(f=>C.add(d.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>C.has(d.ExtensionIdentifier.toKey(f.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,C){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const f=D._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(f.map(_=>_.identifier)),C.length>0){const _=new Set;C.forEach(p=>_.add(d.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>!_.has(d.ExtensionIdentifier.toKey(p.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(f)}static _findLoopingExtensions(F){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,I){this.addNode(v),this.addNode(I),this._arcs.has(v)?this._arcs.get(v).push(I):this._arcs.set(v,[I])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,I){const b=C.getArcs(v);for(let m=0;m<b.length;m++)if(!I.has(b[m]))return!1;return!0}getNodes(){return this._nodesArr}};let f=new Map;for(let v of F){const I=d.ExtensionIdentifier.toKey(v.identifier);if(f.set(I,v),v.extensionDependencies)for(let b of v.extensionDependencies){const m=d.ExtensionIdentifier.toKey(b);C.addArc(I,m)}}let _=new Set;C.getNodes().filter(v=>C.getArcs(v).length===0).forEach(v=>_.add(v));let p=C.getNodes().filter(v=>!_.has(v)),c;do{c=!1;for(let v=0;v<p.length;v++){const I=p[v];C.hasOnlyGoodArcs(I,_)&&(p.splice(v,1),v--,_.add(I),c=!0)}}while(c);return p.map(v=>f.get(v))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const C=this._activationMap.get(F);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const C=this._extensionsMap.get(d.ExtensionIdentifier.toKey(F));return C||void 0}}e.ExtensionDescriptionRegistry=D;var P;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(P||(P={}));function y(T,F){const C=T.isBuiltin?0:T.isUnderDevelopment?2:1,f=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(C!==f)return C-f;const _=k.posix.basename(T.extensionLocation.path),p=k.posix.basename(F.extensionLocation.path);return _<p?-1:_>p?1:0}}),define(ve[133],be([1,0,23]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var k;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function D(y){const T=d.VSBuffer.alloc(1);switch(y){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=D;function P(y,T){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=P}),define(ve[30],be([1,0,3,2,4,27,122]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");var P;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function y(o){switch(o){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=y;class T{constructor(g){this.dependency=g}}e.MissingExtensionDependency=T;var F;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=C;function f(o,g){return o.enabledApiProposals?o.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=f;function _(o,g){if(!f(o,g))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=_;class p{constructor(g,n,E,a){this.codeLoadingTime=g,this.activateCallTime=n,this.activateResolvedTime=E,this.activationReason=a}}e.ActivationTimes=p;class c{constructor(g,n){this.description=g,this.value=n}}e.ExtensionPointContribution=c,e.ExtensionHostLogFileName="exthost";var v;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(v=e.ActivationKind||(e.ActivationKind={}));function I(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=I;function b(o,g){return{identifier:new A.ExtensionIdentifier((0,D.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!g,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=b;class m{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,n){return Promise.resolve()}}e.NullExtensionService=m}),define(ve[227],be([1,0,16,27,30,12]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class P{constructor(c,v,I,b){this.startup=c,this.codeLoadingTime=v,this.activateCallTime=I,this.activateResolvedTime=b}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class y{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,v){return c===-1||v===-1?-1:v-c}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class T{constructor(c,v,I,b,m,o){this.activationFailed=c,this.activationFailedError=v,this.activationTimes=I,this.module=b,this.exports=m,this.subscriptions=o}}e.ActivatedExtension=T;class F extends T{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class C extends T{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class f extends T{constructor(c){super(!0,c,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=f;let _=class{constructor(c,v,I,b,m){this._logService=m,this._isDisposed=!1,this._registry=c,this._resolvedExtensionsSet=new Set,v.forEach(o=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,I.forEach(o=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(o),o)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(c){const v=t.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(v)}getActivatedExtension(c){const v=t.ExtensionIdentifier.toKey(c),I=this._activatedExtensions.get(v);if(!I)throw new Error("Extension `"+c.value+"` is not known or not activated");return I}activateByEvent(c,v){if(this._alreadyActivatedEvents[c])return D;const I=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(I.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,v){const I=this._registry.getExtensionDescription(c);if(!I)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:I.identifier,reason:v}])}_handleActivateRequest(c,v,I){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(c.id))){v[t.ExtensionIdentifier.toKey(c.id)]=c;return}const b=this._registry.getExtensionDescription(c.id);if(!b){const g=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,g,new k.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(c.id),new f(g));return}const m=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let o=!0;for(let g=0,n=m.length;g<n;g++){const E=m[g];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(E)))continue;const a=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(E));if(a&&!a.activationFailed)continue;if(a&&a.activationFailed){const l=b.displayName||b.identifier.value,h=this._registry.getExtensionDescription(E),u=h&&h.displayName||E,w=new Error(`Cannot activate the '${l}' extension because its dependency '${u}' failed to activate`);w.detail=a.activationFailedError,this._host.onExtensionActivationError(b.identifier,w,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(b.identifier),new f(w));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(E))){o=!1,v[t.ExtensionIdentifier.toKey(E)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(E)),reason:c.reason};continue}const i=this._registry.getExtensionDescription(E);if(i){if(!i.main&&!i.browser)continue;o=!1,v[t.ExtensionIdentifier.toKey(E)]={id:i.identifier,reason:c.reason};continue}const r=b.displayName||b.identifier.value,s=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${E}'`);this._host.onExtensionActivationError(b.identifier,s,new k.MissingExtensionDependency(E)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(b.identifier),new f(s));return}o?v[t.ExtensionIdentifier.toKey(b.identifier)]=c:I.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(m=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(m.id))),c.length===0))return Promise.resolve(void 0);const v=Object.create(null),I=[];for(let m=0,o=c.length;m<o;m++)this._handleActivateRequest(c[m],v,I);for(let m=0,o=I.length;m<o;m++){const g=t.ExtensionIdentifier.toKey(I[m].id);v[g]&&delete v[g]}const b=Object.keys(v).map(m=>v[m]);return I.length===0?Promise.all(b.map(m=>this._activateExtension(m.id,m.reason))).then(m=>{}):this._activateExtensions(b).then(m=>this._activateExtensions(I))}_activateExtension(c,v){const I=t.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(I))return Promise.resolve(void 0);const b=this._activatingExtensions.get(I);if(b)return b;const m=this._host.actualActivateExtension(c,v).then(void 0,o=>{const g=new Error;return o&&o.name&&(g.name=o.name),o&&o.message?g.message=`Activating extension '${c.value}' failed: ${o.message}.`:g.message=`Activating extension '${c.value}' failed: ${o}.`,o&&o.stack&&(g.stack=o.stack),this._isDisposed&&d.isCancellationError(o)?new f(o):(this._host.onExtensionActivationError(c,g,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(o),new f(o))}).then(o=>{this._activatedExtensions.set(I,o),this._activatingExtensions.delete(I)});return this._activatingExtensions.set(I,m),m}};_=Be([Fe(4,A.ILogService)],_),e.ExtensionsActivator=_}),define(ve[228],be([1,0,12,26,30]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends d.LogService{constructor(P,y){super(P.createLogger(y.logFile,{name:k.ExtensionHostLogFileName}))}};A=Be([Fe(0,d.ILoggerService),Fe(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(ve[229],be([1,0,16]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,D)=>{this._actualOk=A,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,d.onUnexpectedError)(A))}then(A,D){return this._ensureActual().then(A,D)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=t}),define(ve[52],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const t=[];function k(P){const y=new d(P);return t[y.nid]=y,y}e.createProxyIdentifier=k;function A(P){return t[P].sid}e.getStringIdentifierForProxy=A;class D{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=D}),define(ve[5],be([1,0,59,2,52]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=void 0;var A;(function(I){I[I.Default=0]="Default",I[I.InCenter=1]="InCenter",I[I.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",I[I.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(I){I[I.Editable=0]="Editable",I[I.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(I){I[I.Int8Array=1]="Int8Array",I[I.Uint8Array=2]="Uint8Array",I[I.Uint8ClampedArray=3]="Uint8ClampedArray",I[I.Int16Array=4]="Int16Array",I[I.Uint16Array=5]="Uint16Array",I[I.Int32Array=6]="Int32Array",I[I.Uint32Array=7]="Uint32Array",I[I.Float32Array=8]="Float32Array",I[I.Float64Array=9]="Float64Array",I[I.BigInt64Array=10]="BigInt64Array",I[I.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(I){I[I.Text=1]="Text",I[I.Error=2]="Error",I[I.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(I){I[I.Default=0]="Default",I[I.InCenter=1]="InCenter",I[I.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",I[I.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var F;(function(I){I[I.None=0]="None",I[I.Process=1]="Process",I[I.Output=2]="Output"})(F=e.CandidatePortSource||(e.CandidatePortSource={}));class C{static mixin(b){return b._id=C._n++,b}}e.IdObject=C,C._n=0;var f;(function(I){I.label="a",I.kind="b",I.detail="c",I.documentation="d",I.sortText="e",I.filterText="f",I.preselect="g",I.insertText="h",I.insertTextRules="i",I.range="j",I.commitCharacters="k",I.additionalTextEdits="l",I.command="m",I.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var _;(function(I){I.defaultRanges="a",I.completions="b",I.isIncomplete="c",I.duration="d"})(_=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(I){I[I.File=1]="File",I[I.Text=2]="Text",I[I.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function c(I){if(I&&I.edits)for(const b of I.edits)typeof b.resource=="object"?b.resource=t.URI.revive(b.resource):(b.newUri=t.URI.revive(b.newUri),b.oldUri=t.URI.revive(b.oldUri)),b.metadata&&b.metadata.iconPath&&(b.metadata=(0,d.revive)(b.metadata));return I}e.reviveWorkspaceEditDto=c;var v;(function(I){I[I.Workspace=0]="Workspace",I[I.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,k.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,k.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,k.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,k.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createProxyIdentifier)("ExtHostTelemetry")}}),define(ve[88],be([1,0,5,3,4]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,y){return this._proxy.$getPassword(P,y)}store(P,y,T){return this._proxy.$setPassword(P,y,T)}delete(P,y){return this._proxy.$deletePassword(P,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(ve[65],be([1,0,4,12,5,14]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(k.MainContext.MainThreadTelemetry)}report(y,T,F){const C=this.getUsageKey(y,T);this._reportedUsages.has(C)||(this._reportedUsages.add(C),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:y}))}getUsageKey(y,T){return`${y}-${T.identifier.value}`}};D=Be([Fe(0,A.IExtHostRpcService),Fe(1,t.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(P,y,T){}})}),define(ve[230],be([1,0,3,5,7,27]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,T,F,C={}){const f=A.ExtensionIdentifier.toKey(y.identifier),_=this._inFlightRequests.get(f)||[],p=[...F].sort().join(" ");let c=_.find(v=>v.scopes===p);if(c)return c.result;{const v=this._getSession(y,f,T,F,C);c={scopes:p,result:v},_.push(c),this._inFlightRequests.set(f,_);try{await v}finally{const I=_.findIndex(b=>b.scopes===p);I>-1&&(_.splice(I),this._inFlightRequests.set(f,_))}return v}}async _getSession(y,T,F,C,f={}){await this._proxy.$ensureProvider(F);const _=y.displayName||y.name;return this._proxy.$getSession(F,C,T,_,f)}async removeSession(y,T){const F=this._authenticationProviders.get(y);return F?F.provider.removeSession(T):this._proxy.$removeSession(y,T)}registerAuthenticationProvider(y,T,F,C){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:T,provider:F,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(_=>_.id===y)||this._providers.push({id:y,label:T});const f=F.onDidChangeSessions(_=>{this._proxy.$sendDidChangeSessions(y,{added:_.added??[],changed:_.changed??[],removed:_.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,T,C?.supportsMultipleAccounts??!1),new k.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(y);const _=this._providers.findIndex(p=>p.id===y);_>-1&&this._providers.splice(_),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,T){const F=this._authenticationProviders.get(y);if(F)return Promise.resolve(F.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,T){const F=this._authenticationProviders.get(y);if(F)return Promise.resolve(F.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,T){const F=this._authenticationProviders.get(y);if(F)return Promise.resolve(F.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,T){return this._onDidChangeSessions.fire({provider:{id:y,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(ve[231],be([1,0,5,14,15]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,y){this._proxy=P.getProxy(d.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:T=>y.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P){const y=k.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=Be([Fe(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ve[232],be([1,0,5]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const D=A.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(P){return D.$writeText(P)}})}}e.ExtHostClipboard=t});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[38],be([1,0,18,7,15,25,5,17,12,59,41,48,2,6,4,14,63,23,52,49]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(s,l){o.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ke(this,o,s.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=l,this.converter=new n(this,h=>{const u=this._apiCommands.get(h);return u?.result===a.Void?u:void 0},l),this._argumentProcessors=[{processArgument(h){return(0,T.revive)(h)}},{processArgument(h){return(0,A.cloneAndChange)(h,function(u){if(F.Range.isIRange(u))return k.Range.to(u);if(C.Position.isIPosition(u))return k.Position.to(u);if(F.Range.isIRange(u.range)&&f.URI.isUri(u.uri))return k.location.to(u);if(u instanceof I.VSBuffer)return u.buffer.buffer;if(!Array.isArray(u))return u})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const l=this.registerCommand(!1,s.id,async(...h)=>{const u=s.args.map((R,O)=>{if(!R.validate(h[O]))throw new Error(`Invalid argument '${R.name}' when running '${s.id}', received: ${h[O]}`);return R.convert(h[O])}),w=await this.executeCommand(s.internalId,...u);return s.result.convert(w,h,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new t.Disposable(()=>{l.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,l,h,u,w,R){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:h,thisArg:u,description:w,extension:R}),s&&Te(this,o,"f").$registerCommand(l),new t.Disposable(()=>{this._commands.delete(l)&&s&&Te(this,o,"f").$unregisterCommand(l)})}executeCommand(s,...l){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,l,!0)}async _doExecuteCommand(s,l,h){if(this._commands.has(s))return this._executeContributedCommand(s,l,!1);{let u=!1;const w=(0,A.cloneAndChange)(l,function(R){if(R instanceof t.Position)return k.Position.from(R);if(R instanceof t.Range)return k.Range.from(R);if(R instanceof t.Location)return k.location.from(R);if(t.NotebookRange.isNotebookRange(R))return k.NotebookRange.from(R);if(R instanceof ArrayBuffer)return u=!0,I.VSBuffer.wrap(new Uint8Array(R));if(R instanceof Uint8Array)return u=!0,I.VSBuffer.wrap(R);if(!Array.isArray(R))return R});try{const R=await Te(this,o,"f").$executeCommand(s,u?new b.SerializableObjectWithBuffers(w):w,h);return(0,T.revive)(R)}catch(R){if(R instanceof Error&&R.message==="$executeCommand:retry")return this._doExecuteCommand(s,l,!1);throw R}}}async _executeContributedCommand(s,l,h){const u=this._commands.get(s);if(!u)throw new Error("Unknown command");let{callback:w,thisArg:R,description:O}=u;if(O)for(let L=0;L<O.args.length;L++)try{(0,d.validateConstraint)(l[L],O.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${O.args[L].name}' - ${O.args[L].description}`)}try{return await w.apply(R,l)}catch(L){if(s===this.converter.delegatingCommandId){const S=this.converter.getActualCommand(...l);S&&(s=S.command)}throw this._logService.error(L,s,u.extension?.identifier),h?new class extends Error{constructor(){super((0,m.toErrorMessage)(L));this.id=s,this.source=u.extension?.displayName??u.extension?.name}}:L}}$executeContributedCommand(s,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(l=l.map(h=>this._argumentProcessors.reduce((u,w)=>w.processArgument(u),h)),this._executeContributedCommand(s,l,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),Te(this,o,"f").$getCommands().then(l=>(s&&(l=l.filter(h=>h[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[l,h]of this._commands){let{description:u}=h;u&&(s[l]=u)}return Promise.resolve(s)}};o=new WeakMap,g=Be([Fe(0,c.IExtHostRpcService),Fe(1,y.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class n{constructor(s,l,h){this._commands=s,this._lookupApiCommand=l,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,l){if(!s)return;const h={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return h;const u=this._lookupApiCommand(s.command);if(u)h.id=u.internalId,h.arguments=u.args.map((w,R)=>w.convert(s.arguments&&s.arguments[R]));else if((0,P.isNonEmptyArray)(s.arguments)){const w=++this._cachIdPool;this._cache.set(w,s),l.add((0,_.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),h.$ident=w,h.id=this.delegatingCommandId,h.arguments=[w],this._logService.trace("CommandsConverter#CREATE",s.command,w)}return h}fromInternal(s){return typeof s.$ident=="number"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const l=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=n;class E{constructor(s,l,h,u){this.name=s,this.description=l,this.validate=h,this.convert=u}optional(){return new E(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,l){return new E(s??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",r=>f.URI.isUri(r),r=>r),E.Position=new E("position","A position in a text document",r=>t.Position.isPosition(r),k.Position.from),E.Range=new E("range","A range in a text document",r=>t.Range.isRange(r),k.Range.from),E.Selection=new E("selection","A selection in a text document",r=>t.Selection.isSelection(r),k.Selection.from),E.Number=new E("number","",r=>typeof r=="number",r=>r),E.String=new E("string","",r=>typeof r=="string",r=>r),E.CallHierarchyItem=new E("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,k.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,k.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",r=>r instanceof v.TestItemImpl,k.TestItem.from);class a{constructor(s,l){this.description=s,this.convert=l}}e.ApiCommandResult=a,a.Void=new a("no result",r=>r);class i{constructor(s,l,h,u,w){this.id=s,this.internalId=l,this.description=h,this.args=u,this.result=w}}e.ApiCommand=i}),define(ve[233],be([1,0,2,15,7,81,38,17,112,118,10]),function(te,e,d,t,k,A,D,P,y,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",_(t.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,v)=>{if((0,P.isFalsyOrEmpty)(c))return;class I extends k.SymbolInformation{static to(m){const o=new I(m.name,t.SymbolKind.to(m.kind),m.containerName||"",new k.Location(v[0],t.Range.to(m.range)));return o.detail=m.detail,o.range=o.location.range,o.selectionRange=t.Range.to(m.selectionRange),o.children=m.children?m.children.map(I.to):[],o}}return c.map(I.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new D.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(t.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(t.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(v=>k.Position.isPosition(v)),c=>c.map(t.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(v=>{let I;for(const b of v.reverse())I=new k.SelectionRange(t.Range.to(b),I);return I}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(t.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(t.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(t.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(t.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:t.Range.to(c.range),placeholder:c.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return t.WorkspaceEdit.to(c)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(t.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new k.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const v=(0,y.decodeSemanticTokensDto)(c);if(v.type==="full")return new k.SemanticTokens(v.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new k.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const v=(0,y.decodeSemanticTokensDto)(c);if(v.type==="full")return new k.SemanticTokens(v.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,v,I)=>{if(!c)return new k.CompletionList([]);const b=c.suggestions.map(m=>t.CompletionItem.to(m,I));return new k.CompletionList(b,c.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return t.SignatureHelp.to(c)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,v,I)=>_(b=>new k.CodeLens(t.Range.to(b.range),b.command&&I.fromInternal(b.command)))(c))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>k.Range.isRange(c),c=>k.Selection.isSelection(c)?t.Selection.from(c):t.Range.from(c)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,v,I)=>_(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return I.fromInternal(b.command)}else{const m=new k.CodeAction(b.title,b.kind?new k.CodeActionKind(b.kind):void 0);return b.edit&&(m.edit=t.WorkspaceEdit.to(b.edit)),b.command&&(m.command=I.fromInternal(b.command)),m.isPreferred=b.isPreferred,m}})(c))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(v=>new k.ColorInformation(t.Range.to(v.range),t.Color.to(v.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",c=>c instanceof k.Color,t.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:t.Range.from(c.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(t.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(c,v,I)=>c.map(t.InlayHint.to.bind(void 0,I)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(v=>t.NotebookExclusiveDocumentPattern.to(v))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(t.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",c=>d.URI.isUri(c)||typeof c=="string"&&(0,T.matchesSomeScheme)(c,F.Schemas.http,F.Schemas.https),c=>c),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[t.ViewColumn.from(c),void 0]:[t.ViewColumn.from(c.viewColumn),t.TextEditorOpenOptions.from(c)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[t.ViewColumn.from(c),void 0]:[t.ViewColumn.from(c.viewColumn),t.TextEditorOpenOptions.from(c)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[t.ViewColumn.from(c.viewColumn),t.TextEditorOpenOptions.from(c)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void)];class f{static register(v){C.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=f;function _(c){return v=>{if(Array.isArray(v))return v.map(c)}}function p(c){if(!Array.isArray(c))return;const v=[];for(const I of c)A.isLocationLink(I)?v.push(t.DefinitionLink.to(I)):v.push(t.location.to(I));return v}}),define(ve[234],be([1,0,13,56,3,6,2,81,27,15,7,30,5]),function(te,e,d,t,k,A,D,P,y,T,F,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function _(p,c,v){const I=p.getProxy(f.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const s=this._commentControllers.get(r.handle);return s||r}else if(r&&r.$mid===7){const s=this._commentControllers.get(r.commentControlHandle);if(!s)return r;const l=s.getCommentThread(r.commentThreadHandle);return l||r}else if(r&&r.$mid===8){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const l=s.getCommentThread(r.thread.commentThreadHandle);return l?{thread:l,text:r.text}:r}else if(r&&r.$mid===9){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const l=s.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let h=r.commentUniqueId,u=l.getCommentByUniqueId(h);return u||r}else if(r&&r.$mid===10){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const l=s.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let h=r.text,u=r.commentUniqueId,w=l.getCommentByUniqueId(u);return w?(w.body=h,w):r}return r}})}createCommentController(r,s,l){const h=b.handlePool++,u=new o(r,h,s,l);this._commentControllers.set(u.handle,u);const w=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(r.identifier))||[];return w.push(u),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(r.identifier),w),u.value}$createCommentThreadTemplate(r,s,l){const h=this._commentControllers.get(r);!h||h.$createCommentThreadTemplate(s,l)}async $updateCommentThreadTemplate(r,s,l){const h=this._commentControllers.get(r);!h||h.$updateCommentThreadTemplate(s,l)}$deleteCommentThread(r,s){const l=this._commentControllers.get(r);l&&l.$deleteCommentThread(s)}$provideCommentingRanges(r,s,l){const h=this._commentControllers.get(r);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const u=v.getDocument(D.URI.revive(s));return(0,d.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(u,l)).then(w=>w?w.map(R=>T.Range.from(R)):void 0)}$toggleReaction(r,s,l,h,u){const w=this._commentControllers.get(r);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const R=w.getCommentThread(s);if(R){const O=R.getCommentByUniqueId(h.uniqueIdInThread);if(w!==void 0&&O&&w.reactionHandler)return w.reactionHandler(O,E(u))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class m{constructor(r,s,l,h,u,w,R){this._commentControllerHandle=s,this._id=l,this._uri=h,this._range=u,this._comments=w,this.extensionDescription=R,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),I.$createCommentThread(s,this.handle,this._id,this._uri,T.Range.from(this._range),R.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this._localDisposables.push({dispose:()=>{I.$deleteCommentThread(s,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(L){O.range=L},get comments(){return O.comments},set comments(L){O.comments=L},get collapsibleState(){return O.collapsibleState},set collapsibleState(L){O.collapsibleState=L},get canReply(){return O.canReply},set canReply(L){O.canReply=L},get contextValue(){return O.contextValue},set contextValue(L){O.contextValue=L},get label(){return O.label},set label(L){O.label=L},dispose:()=>{O.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const r=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),s={};r("range")&&(s.range=T.Range.from(this._range)),r("label")&&(s.label=this.label),r("contextValue")&&(s.contextValue=this.contextValue??null),r("comments")&&(s.comments=this._comments.map(l=>g(this,l,this._commentsMap))),r("collapsibleState")&&(s.collapseState=a(this._collapseState)),r("canReply")&&(s.canReply=this.canReply),this.modifications={},I.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(r){for(let s of this._commentsMap){let l=s[0],h=s[1];if(r===h)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}m._handlePool=0,Be([(0,t.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(r,s,l,h){this._extension=r,this._handle=s,this._id=l,this._label=h,this._threads=new Map,I.$registerCommentController(this.handle,l,h);const u=this;this.value=Object.freeze({id:u.id,label:u.label,get options(){return u.options},set options(w){u.options=w},get commentingRangeProvider(){return u.commentingRangeProvider},set commentingRangeProvider(w){u.commentingRangeProvider=w},get reactionHandler(){return u.reactionHandler},set reactionHandler(w){u.reactionHandler=w},createCommentThread(w,R,O){return u.createCommentThread(w,R,O).value},dispose:()=>{u.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{I.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(r){this._commentingRangeProvider=r,I.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,I.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,I.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,s,l,h){if(typeof r=="string"){const u=new m(this.id,this.handle,r,s,l,h,this._extension);return this._threads.set(u.handle,u),u}else{const u=new m(this.id,this.handle,void 0,r,s,l,this._extension);return this._threads.set(u.handle,u),u}}$createCommentThreadTemplate(r,s){const l=new m(this.id,this.handle,void 0,D.URI.revive(r),T.Range.to(s),[],this._extension);return l.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(r,s){let l=this._threads.get(r);l&&(l.range=T.Range.to(s))}$deleteCommentThread(r){let s=this._threads.get(r);s&&s.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function g(i,r,s){let l=s.get(r);l||(l=++i.commentHandle,s.set(r,l));const h=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;r.timestamp&&(0,C.checkProposedApiEnabled)(i.extensionDescription,"commentTimestamp");let u;return r.timestamp&&(u={source:r.timestamp,$mid:14}),{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:l,body:typeof r.body=="string"?r.body:T.MarkdownString.from(r.body),userName:r.author.name,userIconPath:h,label:r.label,commentReactions:r.reactions?r.reactions.map(w=>n(w)):void 0,timestamp:u}}function n(i){return{label:i.label,iconPath:i.iconPath?T.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function E(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?D.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function a(i){if(i!==void 0)switch(i){case F.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new b}e.createExtHostComments=_}),define(ve[134],be([1,0,2,5,7,4,14,12,17,8,9]),function(te,e,d,t,k,A,D,P,y,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class Ei{constructor(_,p){this._logService=p,this._provider=new Map,this._proxy=_.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(_,p){const c=Ei._handlePool++;this._provider.set(c,{provider:_,extensionId:p}),this._proxy.$registerDecorationProvider(c,p.value);const v=_.onDidChangeFileDecorations&&_.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(c,null);return}let b=(0,y.asArray)(I);if(b.length<=Ei._maxEventSize){this._proxy.$onDidChange(c,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",p.value,b.length);const m=b.map(n=>({uri:n,rank:(0,T.count)(n.path,"/")})),o=(0,y.groupBy)(m,(n,E)=>n.rank-E.rank||(0,T.compare)(n.uri.path,E.uri.path));let g=[];e:for(let n of o){let E;for(let a of n){let i=(0,F.dirname)(a.uri.path);if(E!==i&&(E=i,g.push(a.uri)>=Ei._maxEventSize))break e}}this._proxy.$onDidChange(c,g)});return new k.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(_,p,c){if(!this._provider.has(_))return Object.create(null);const v=Object.create(null),{provider:I,extensionId:b}=this._provider.get(_);return await Promise.all(p.map(async m=>{try{const{uri:o,id:g}=m,n=await Promise.resolve(I.provideFileDecoration(d.URI.revive(o),c));if(!n)return;try{k.FileDecoration.validate(n),v[g]=[n.propagate,n.tooltip,n.badge,n.color]}catch(E){this._logService.warn(`INVALID decoration from extension '${b.value}': ${E}`)}}catch(o){this._logService.error(o)}})),v}};C._handlePool=0,C._maxEventSize=250,C=Be([Fe(0,D.IExtHostRpcService),Fe(1,P.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[235],be([1,0,168,117,2,5,7,15,3,12,24,44]),function(te,e,d,t,k,A,D,P,y,T,F,C){"use strict";var f,_,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class c{constructor(b,m,o,g,n,E){this._name=b,this._owner=m,this._maxDiagnosticsPerFile=o,f.set(this,void 0),_.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,Ke(this,p,new F.ResourceMap(a=>g.getComparisonKey(a)),"f"),Ke(this,f,n,"f"),Ke(this,_,E,"f")}dispose(){this._isDisposed||(Te(this,_,"f").fire([...Te(this,p,"f").keys()]),Te(this,f,"f")&&Te(this,f,"f").$clear(this._owner),Te(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,m){if(!b){this.clear();return}this._checkDisposed();let o=[];if(k.URI.isUri(b)){if(!m){this.delete(b);return}Te(this,p,"f").set(b,m.slice()),o=[b]}else if(Array.isArray(b)){o=[];let n;b=[...b].sort(c._compareIndexedTuplesByUri);for(const E of b){const[a,i]=E;if((!n||a.toString()!==n.toString())&&(n&&Te(this,p,"f").get(n).length===0&&Te(this,p,"f").delete(n),n=a,o.push(a),Te(this,p,"f").set(a,[])),i){const r=Te(this,p,"f").get(a);r&&r.push(...i)}else{const r=Te(this,p,"f").get(a);r&&(r.length=0)}}}if(Te(this,_,"f").fire(o),!Te(this,f,"f"))return;const g=[];for(let n of o){let E=[];const a=Te(this,p,"f").get(n);if(a)if(a.length>this._maxDiagnosticsPerFile){E=[];const i=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let s of a)if(s.severity===i[r]&&E.push(P.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;E.push({severity:t.MarkerSeverity.Info,message:(0,d.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:E[E.length-1].startLineNumber,startColumn:E[E.length-1].startColumn,endLineNumber:E[E.length-1].endLineNumber,endColumn:E[E.length-1].endColumn})}else E=a.map(i=>P.Diagnostic.from(i));g.push([n,E])}Te(this,f,"f").$changeMany(this._owner,g)}delete(b){this._checkDisposed(),Te(this,_,"f").fire([b]),Te(this,p,"f").delete(b),Te(this,f,"f")&&Te(this,f,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Te(this,_,"f").fire([...Te(this,p,"f").keys()]),Te(this,p,"f").clear(),Te(this,f,"f")&&Te(this,f,"f").$clear(this._owner)}forEach(b,m){this._checkDisposed();for(let o of Te(this,p,"f").keys())b.apply(m,[o,this.get(o),this])}get(b){this._checkDisposed();const m=Te(this,p,"f").get(b);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Te(this,p,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,m){return b[0].toString()<m[0].toString()?-1:b[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=c,f=new WeakMap,_=new WeakMap,p=new WeakMap;let v=class si{constructor(b,m,o){this._logService=m,this._fileSystemInfoService=o,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=b.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(b){const m=new F.ResourceMap;for(const o of b)m.set(o,o);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(b,m){const{_collections:o,_proxy:g,_onDidChangeDiagnostics:n,_logService:E,_fileSystemInfoService:a}=this,i=new class{$changeMany(l,h){g.$changeMany(l,h),E.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,l,h.length===0?"CLEARING":h)}$clear(l){g.$clear(l),E.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,l)}dispose(){g.dispose()}};let r;if(!m)m="_generated_diagnostic_collection_name_#"+si._idPool++,r=m;else if(!o.has(m))r=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do r=m+si._idPool++;while(o.has(r))}return new class extends c{constructor(){super(m,r,si._maxDiagnosticsPerFile,a.extUri,i,n);o.set(r,this)}dispose(){super.dispose(),o.delete(r)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const m=new Map,o=[];for(const g of this._collections.values())g.forEach((n,E)=>{let a=m.get(n.toString());typeof a=="undefined"&&(a=o.length,m.set(n.toString(),a),o.push([n,[]])),o[a][1]=o[a][1].concat(...E)});return o}}_getDiagnostics(b){let m=[];for(let o of this._collections.values())o.has(b)&&(m=m.concat(o.get(b)));return m}$acceptMarkersChange(b){if(!this._mirrorCollection){const m="_generated_mirror",o=new c(m,m,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,o),this._mirrorCollection=o}for(const[m,o]of b)this._mirrorCollection.set(k.URI.revive(m),o.map(P.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=Be([Fe(1,T.ILogService),Fe(2,C.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(ve[236],be([1,0,2,5]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(D){this._proxy=D.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(P=>P?P.map(y=>d.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(P=>P?d.URI.revive(P):void 0)}}e.ExtHostDialogs=k}),define(ve[237],be([1,0,16,2,7,5,10,21,8]),function(te,e,d,t,k,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(C,f,_){this._documentsAndEditors=f,this._logService=_,this._documentContentProviders=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,f){if(Object.keys(D.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const _=T._handlePool++;this._documentContentProviders.set(_,f),this._proxy.$registerTextContentProvider(_,C);let p;return typeof f.onDidChange=="function"&&(p=f.onDidChange(c=>{if(c.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(_,c).then(v=>{if(!v&&typeof v!="string")return;const I=this._documentsAndEditors.getDocument(c);if(!I)return;const b=(0,y.splitLines)(v);if(!I.equalLines(b))return this._proxy.$onVirtualDocumentChange(c,v)},d.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(_)&&this._proxy.$unregisterTextContentProvider(_),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(C,f){const _=this._documentContentProviders.get(C);return _?Promise.resolve(_.provideTextDocumentContent(t.URI.revive(f),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(ve[238],be([1,0,3,6,2,5,125,15,18,25,7]),function(te,e,d,t,k,A,D,P,y,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(_,p){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const v of c)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const v of c)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!_)return;const p=this._documentsAndEditors.getDocument(_);if(p)return p}getDocument(_){const p=this.getDocumentData(_);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${_}'`);return p.document}ensureDocumentData(_){const p=this._documentsAndEditors.getDocument(_);if(p)return Promise.resolve(p);let c=this._documentLoader.get(_.toString());return c||(c=this._proxy.$tryOpenDocument(_).then(v=>{this._documentLoader.delete(_.toString());const I=k.URI.revive(v);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(I))},v=>(this._documentLoader.delete(_.toString()),Promise.reject(v))),this._documentLoader.set(_.toString(),c)),c}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(p=>k.URI.revive(p))}$acceptModelLanguageChanged(_,p){const c=k.URI.revive(_),v=this._documentsAndEditors.getDocument(c);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(p),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(_){const p=k.URI.revive(_),c=this._documentsAndEditors.getDocument(p);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(_,p){const c=k.URI.revive(_),v=this._documentsAndEditors.getDocument(c);if(!v)throw new Error("unknown document");v._acceptIsDirty(p),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(_,p,c){const v=k.URI.revive(_),I=this._documentsAndEditors.getDocument(v);if(!I)throw new Error("unknown document");I._acceptIsDirty(c),I.onEvents(p);let b;p.isUndoing?b=F.TextDocumentChangeReason.Undo:p.isRedoing&&(b=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:I.document,contentChanges:p.changes.map(m=>({range:P.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:b}))}setWordDefinitionFor(_,p){(0,D.setWordDefinitionFor)(_,p)}}e.ExtHostDocuments=C}),define(ve[45],be([1,0,55,3,6,2,4,5,125,14,132,15,12,24,10,77,91]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(o,g){this._extHostRpc=o,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new _.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const g=[],n=[],E=[];if(o.removedDocuments)for(const a of o.removedDocuments){const i=A.URI.revive(a),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),g.push(r.value))}if(o.addedDocuments)for(const a of o.addedDocuments){const i=A.URI.revive(a.uri);let r=this._documents.get(i);if(r&&i.scheme!==p.Schemas.vscodeNotebookCell&&i.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new I(new y.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),i,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this._documents.set(i,r),n.push(r.value)),r.ref()}if(o.removedEditors)for(const a of o.removedEditors){const i=this._editors.get(a);this._editors.delete(a),i&&E.push(i)}if(o.addedEditors)for(const a of o.addedEditors){const i=A.URI.revive(a.documentUri);d.ok(this._documents.has(i),`document '${i}' does not exist`),d.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const r=this._documents.get(i).value,s=new F.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>r.document),a.selections.map(C.Selection.to),a.options,a.visibleRanges.map(l=>C.Range.to(l)),typeof a.editorPosition=="number"?C.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,s)}o.newActiveEditor!==void 0&&(d.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,k.dispose)(g),(0,k.dispose)(E),o.removedDocuments&&this._onDidRemoveDocuments.fire(g),o.addedDocuments&&this._onDidAddDocuments.fire(n),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return o?g:g?.value}allEditors(){return[...this._editors.values()]}};b=Be([Fe(0,T.IExtHostRpcService),Fe(1,f.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[53],be([1,0,15,5,2,3,4,14,13]),function(te,e,d,t,k,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");let T=class{constructor(C){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=C.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(C){let f=-1;this._tabs=C.map((p,c)=>(p.isActive&&(f=c),Object.freeze({label:p.label,viewColumn:d.ViewColumn.to(p.viewColumn),index:c,resource:k.URI.revive(p.resource),additionalResourcesAndViewIds:p.additionalResourcesAndViewIds.map(({resource:v,viewId:I})=>({resource:k.URI.revive(v),viewId:I})),viewId:p.editorId,isActive:p.isActive,move:async(v,I)=>{this._proxy.$moveTab(p,v,d.ViewColumn.from(I)),await(0,y.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(p),await(0,y.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((p,c)=>p.viewColumn===c.viewColumn?p.index-c.index:p.viewColumn-c.viewColumn);const _=this._activeTab;this._activeTab=f===-1?void 0:this._tabs[f],this._activeTab!==_&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=Be([Fe(0,P.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(ve[239],be([1,0,2,5,6,7,15,152,8,23,30]),function(te,e,d,t,k,A,D,P,y,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class C{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const c=this._schemes.indexOf(p);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),c=[];let v,I,b=14,m=14;for(const o of p){let g=v?(0,y.commonPrefixLength)(v,o):0;for(g===0?I=1:I=m;g<o.length;g++)g+1===o.length?(b=m,m=9):m+=1,c.push([I,o.toUpperCase().charCodeAt(g),m]),c.push([I,o.toLowerCase().charCodeAt(g),m]),I=m;v=o,m=b}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new P.StateMachine(c)}}provideDocumentLinks(p){this._initStateMachine();const c=[],v=P.LinkComputer.computeLinks({getLineContent(I){return p.lineAt(I-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const I of v){const b=D.DocumentLink.to(I);b.target&&c.push(b)}return c}}class f{constructor(p,c){this._extHostLanguageFeatures=c,this._linkProvider=new C,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,c,v,I={}){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const b=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(b,v);let m=2;I.isCaseSensitive&&(m+=1024),I.isReadonly&&(m+=2048),typeof v.copy=="function"&&(m+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,F.checkProposedApiEnabled)(p,"fsChunks"),m+=4),this._proxy.$registerFileSystemProvider(b,c,m).catch(g=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${c}`),console.error(g)});const o=v.onDidChangeFile(g=>{const n=[];for(const E of g){let{uri:a,type:i}=E;if(a.scheme!==c)continue;let r;switch(i){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:a,type:r})}this._proxy.$onFileSystemChange(b,n)});return(0,k.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(p){const{type:c,ctime:v,mtime:I,size:b,permissions:m}=p;return{type:c,ctime:v,mtime:I,size:b,permissions:m}}$stat(p,c){return Promise.resolve(this._getFsProvider(p).stat(d.URI.revive(c))).then(v=>f._asIStat(v))}$readdir(p,c){return Promise.resolve(this._getFsProvider(p).readDirectory(d.URI.revive(c)))}$readFile(p,c){return Promise.resolve(this._getFsProvider(p).readFile(d.URI.revive(c))).then(v=>T.VSBuffer.wrap(v))}$writeFile(p,c,v,I){return Promise.resolve(this._getFsProvider(p).writeFile(d.URI.revive(c),v.buffer,I))}$delete(p,c,v){return Promise.resolve(this._getFsProvider(p).delete(d.URI.revive(c),v))}$rename(p,c,v,I){return Promise.resolve(this._getFsProvider(p).rename(d.URI.revive(c),d.URI.revive(v),I))}$copy(p,c,v,I){const b=this._getFsProvider(p);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(d.URI.revive(c),d.URI.revive(v),I))}$mkdir(p,c){return Promise.resolve(this._getFsProvider(p).createDirectory(d.URI.revive(c)))}$watch(p,c,v,I){const b=this._getFsProvider(p).watch(d.URI.revive(v),I);this._watches.set(c,b)}$unwatch(p,c){const v=this._watches.get(c);v&&(v.dispose(),this._watches.delete(c))}$open(p,c,v){const I=this._getFsProvider(p);if(!I.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(I.open(d.URI.revive(c),v))}$close(p,c){const v=this._getFsProvider(p);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(c))}$read(p,c,v,I){const b=this._getFsProvider(p);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const m=T.VSBuffer.alloc(I);return Promise.resolve(b.read(c,v,m.buffer,0,I)).then(o=>m.slice(0,o))}$write(p,c,v,I){const b=this._getFsProvider(p);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(c,v,I.buffer,0,I.byteLength))}_getFsProvider(p){const c=this._fsProvider.get(p);if(!c){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return c}}e.ExtHostFileSystem=f}),define(ve[66],be([1,0,5,42,7,23,4,14,44,6]),function(te,e,d,t,k,A,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class Gt{constructor(f,_){this._fileSystemProvider=new Map,this._proxy=f.getProxy(d.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(c){try{const v=p._fileSystemProvider.get(c.scheme);if(!v)return await p._proxy.$stat(c);await p._proxy.$ensureActivation(c.scheme);const I=await v.stat(c);return{type:I.type,ctime:I.ctime,mtime:I.mtime,size:I.size,permissions:I.permissions}}catch(v){Gt._handleError(v)}},async readDirectory(c){try{const v=p._fileSystemProvider.get(c.scheme);return v?(await p._proxy.$ensureActivation(c.scheme),(await v.readDirectory(c)).slice()):await p._proxy.$readdir(c)}catch(v){return Gt._handleError(v)}},async createDirectory(c){try{return await p._proxy.$mkdir(c)}catch(v){return Gt._handleError(v)}},async readFile(c){try{const v=p._fileSystemProvider.get(c.scheme);return v?(await p._proxy.$ensureActivation(c.scheme),(await v.readFile(c)).slice()):(await p._proxy.$readFile(c)).buffer}catch(v){return Gt._handleError(v)}},async writeFile(c,v){try{return await p._proxy.$writeFile(c,A.VSBuffer.wrap(v))}catch(I){return Gt._handleError(I)}},async delete(c,v){try{const I=p._fileSystemProvider.get(c.scheme);return I?(await p._proxy.$ensureActivation(c.scheme),await I.delete(c,{recursive:!1,...v})):await p._proxy.$delete(c,{recursive:!1,useTrash:!1,...v})}catch(I){return Gt._handleError(I)}},async rename(c,v,I){try{return await p._proxy.$rename(c,v,{overwrite:!1,...I})}catch(b){return Gt._handleError(b)}},async copy(c,v,I){try{return await p._proxy.$copy(c,v,{overwrite:!1,...I})}catch(b){return Gt._handleError(b)}},isWritableFileSystem(c){const v=_.getCapabilities(c);if(typeof v=="number")return!(v&2048)}})}static _handleError(f){if(f instanceof k.FileSystemError)throw f;if(!(f instanceof Error))throw new k.FileSystemError(String(f));if(f.name==="ENOPRO")throw k.FileSystemError.Unavailable(f.message);switch(f.name){case t.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(f.message);case t.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(f.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(f.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(f.message);case t.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(f.message);case t.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(f.message);default:throw new k.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,_){return this._fileSystemProvider.set(f,_),(0,T.toDisposable)(()=>this._fileSystemProvider.delete(f))}};F=Be([Fe(0,P.IExtHostRpcService),Fe(1,y.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[240],be([1,0,3,32,2,5,15,7]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,f,_,p,c,v,I,b){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter;const m=this.ensureWatching(C,_,c);this._config=0,v&&(this._config+=1),I&&(this._config+=2),b&&(this._config+=4);const o=(0,t.parse)(c),g=typeof c=="string",n=p(E=>{if(!v)for(let a of E.created){const i=k.URI.revive(a);o(i.fsPath)&&(!g||f.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!I)for(let a of E.changed){const i=k.URI.revive(a);o(i.fsPath)&&(!g||f.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!b)for(let a of E.deleted){const i=k.URI.revive(a);o(i.fsPath)&&(!g||f.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=P.Disposable.from(m,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(C,f,_){let p=P.Disposable.from();if(typeof _=="string")return p;const c=C.getProxy(A.MainContext.MainThreadFileSystem);let v=!1;(_.pattern.includes(t.GLOBSTAR)||_.pattern.includes(t.GLOB_SPLIT))&&(v=!0);const I=Math.random();return c.$watch(f.identifier.value,I,_.baseUri,{recursive:v,excludes:[]}),P.Disposable.from({dispose:()=>c.$unwatch(I)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class T{constructor(C,f,_){this._mainContext=C,this._logService=f,this._extHostDocumentsAndEditors=_,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,f,_,p,c,v){return new y(this._mainContext,C,f,this._onFileSystemEvent.event,D.GlobPattern.from(_),p,c,v)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,f){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:f.map(_=>({oldUri:k.URI.revive(_.source),newUri:k.URI.revive(_.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:f.map(_=>k.URI.revive(_.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:f.map(_=>k.URI.revive(_.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,f){return(_,p,c)=>{const v=function(b){_.call(p,b)};return v.extension=C,f.event(v,void 0,c)}}async $onWillRunFileOperation(C,f,_,p){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:f.map(c=>({oldUri:k.URI.revive(c.source),newUri:k.URI.revive(c.target)}))},_,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:f.map(c=>k.URI.revive(c.target))},_,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:f.map(c=>k.URI.revive(c.target))},_,p)}}async _fireWillEvent(C,f,_,p){const c=new Set,v=[];if(await C.fireAsync(f,p,async(b,m)=>{const o=Date.now(),g=await Promise.resolve(b);g instanceof P.WorkspaceEdit&&(v.push(g),c.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-o>_&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),p.isCancellationRequested||v.length===0)return;const I={edits:[]};for(let b of v){let{edits:m}=D.WorkspaceEdit.from(b,{getTextDocumentVersion:o=>this._extHostDocumentsAndEditors.getDocument(o)?.version,getNotebookDocumentVersion:()=>{}});I.edits=I.edits.concat(m)}return{edit:I,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=T}),define(ve[241],be([1,0,2,38]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(D,P,y,T){this._extHostNotebooks=P,this._textDocumentsAndEditors=y,this._commands=T;const F=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",C=>!0,C=>C),new t.ApiCommandArgument("resource","Interactive resource Uri",C=>!0,C=>C),new t.ApiCommandArgument("controllerId","Notebook controller Id",C=>!0,C=>C),new t.ApiCommandArgument("title","Interactive editor title",C=>!0,C=>C)],new t.ApiCommandResult("Notebook and input URI",C=>{if(C.notebookEditorId!==void 0){const f=this._extHostNotebooks.getEditorById(C.notebookEditorId);return{notebookUri:d.URI.revive(C.notebookUri),inputUri:d.URI.revive(C.inputUri),notebookEditor:f.apiEditor}}return{notebookUri:d.URI.revive(C.notebookUri),inputUri:d.URI.revive(C.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(D,P,y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:y,uri:D,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=k}),define(ve[242],be([1,0,6,5]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(D){this._handlePool=0,this._proxy=D.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,D),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=k}),define(ve[243],be([1,0,2,25,15,7,5,8,41,17,18,148,21,6,112,76,85,46,16,3,13]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class g{constructor(z,W){this._documents=z,this._provider=W}async provideDocumentSymbols(z,W){const N=this._documents.getDocument(z),$=await this._provider.provideDocumentSymbols(N,W);if(!(0,T.isFalsyOrEmpty)($))return $[0]instanceof A.DocumentSymbol?$.map(k.DocumentSymbol.from):g._asDocumentSymbolTree($)}static _asDocumentSymbolTree(z){z=z.slice(0).sort(($,K)=>{let re=$.location.range.start.compareTo(K.location.range.start);return re===0&&(re=K.location.range.end.compareTo($.location.range.end)),re});const W=[],N=[];for(const $ of z){const K={name:$.name||"!!MISSING: name!!",kind:k.SymbolKind.from($.kind),tags:$.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:$.containerName,range:k.Range.from($.location.range),selectionRange:k.Range.from($.location.range),children:[]};for(;;){if(N.length===0){N.push(K),W.push(K);break}const re=N[N.length-1];if(y.Range.containsRange(re.range,K.range)&&!y.Range.equalsRange(re.range,K.range)){re.children&&re.children.push(K),N.push(K);break}N.pop()}}return W}}class n{constructor(z,W,N){this._documents=z,this._commands=W,this._provider=N,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,W){const N=this._documents.getDocument(z),$=await this._provider.provideCodeLenses(N,W);if(!$||W.isCancellationRequested)return;const K=this._cache.add($),re=new _.DisposableStore;this._disposables.set(K,re);const de={cacheId:K,lenses:[]};for(let ye=0;ye<$.length;ye++)de.lenses.push({cacheId:[K,ye],range:k.Range.from($[ye].range),command:this._commands.toInternal($[ye].command,re)});return de}async resolveCodeLens(z,W){const N=z.cacheId&&this._cache.get(...z.cacheId);if(!N)return;let $;if(typeof this._provider.resolveCodeLens!="function"||N.isResolved?$=N:$=await this._provider.resolveCodeLens(N,W),$||($=N),W.isCancellationRequested)return;const K=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!K)return z.command=this._commands.toInternal($.command??n._badCmd,K),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}n._badCmd={command:"missing",title:"!!MISSING: command!!"};function E(Ee){return Array.isArray(Ee)?Ee.map(k.DefinitionLink.from):Ee?[k.DefinitionLink.from(Ee)]:[]}class a{constructor(z,W){this._documents=z,this._provider=W}async provideDefinition(z,W,N){const $=this._documents.getDocument(z),K=k.Position.to(W),re=await this._provider.provideDefinition($,K,N);return E(re)}}class i{constructor(z,W){this._documents=z,this._provider=W}async provideDeclaration(z,W,N){const $=this._documents.getDocument(z),K=k.Position.to(W),re=await this._provider.provideDeclaration($,K,N);return E(re)}}class r{constructor(z,W){this._documents=z,this._provider=W}async provideImplementation(z,W,N){const $=this._documents.getDocument(z),K=k.Position.to(W),re=await this._provider.provideImplementation($,K,N);return E(re)}}class s{constructor(z,W){this._documents=z,this._provider=W}async provideTypeDefinition(z,W,N){const $=this._documents.getDocument(z),K=k.Position.to(W),re=await this._provider.provideTypeDefinition($,K,N);return E(re)}}class l{constructor(z,W){this._documents=z,this._provider=W}async provideHover(z,W,N){const $=this._documents.getDocument(z),K=k.Position.to(W),re=await this._provider.provideHover($,K,N);if(!(!re||(0,T.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=$.getWordRangeAtPosition(K)),re.range||(re.range=new A.Range(K,K)),k.Hover.from(re)}}class h{constructor(z,W){this._documents=z,this._provider=W}async provideEvaluatableExpression(z,W,N){const $=this._documents.getDocument(z),K=k.Position.to(W),re=await this._provider.provideEvaluatableExpression($,K,N);if(re)return k.EvaluatableExpression.from(re)}}class u{constructor(z,W){this._documents=z,this._provider=W}async provideInlineValues(z,W,N,$){const K=this._documents.getDocument(z),re=await this._provider.provideInlineValues(K,k.Range.to(W),k.InlineValueContext.to(N),$);if(Array.isArray(re))return re.map(de=>k.InlineValue.from(de))}}class w{constructor(z,W){this._documents=z,this._provider=W}async provideDocumentHighlights(z,W,N){const $=this._documents.getDocument(z),K=k.Position.to(W),re=await this._provider.provideDocumentHighlights($,K,N);if(Array.isArray(re))return re.map(k.DocumentHighlight.from)}}class R{constructor(z,W){this._documents=z,this._provider=W}async provideLinkedEditingRanges(z,W,N){const $=this._documents.getDocument(z),K=k.Position.to(W),re=await this._provider.provideLinkedEditingRanges($,K,N);if(re&&Array.isArray(re.ranges))return{ranges:(0,T.coalesce)(re.ranges.map(k.Range.from)),wordPattern:re.wordPattern}}}class O{constructor(z,W){this._documents=z,this._provider=W}async provideReferences(z,W,N,$){const K=this._documents.getDocument(z),re=k.Position.to(W),de=await this._provider.provideReferences(K,re,N,$);if(Array.isArray(de))return de.map(k.location.from)}}class L{constructor(z,W,N,$,K,re,de){this._documents=z,this._commands=W,this._diagnostics=N,this._provider=$,this._logService=K,this._extension=re,this._apiDeprecation=de,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,W,N,$){const K=this._documents.getDocument(z),re=C.Selection.isISelection(W)?k.Selection.to(W):k.Range.to(W),de=[];for(const ze of this._diagnostics.getDiagnostics(z))if(re.intersection(ze.range)&&de.push(ze)>L._maxCodeActionsPerFile)break;const ye={diagnostics:de,only:N.only?new A.CodeActionKind(N.only):void 0,triggerKind:k.CodeActionTriggerKind.to(N.trigger)},Re=await this._provider.provideCodeActions(K,re,ye,$);if(!(0,T.isNonEmptyArray)(Re)||$.isCancellationRequested)return;const We=this._cache.add(Re),$e=new _.DisposableStore;this._disposables.set(We,$e);const je=[];for(let ze=0;ze<Re.length;ze++){const Ue=Re[ze];!Ue||(L._isCommand(Ue)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:Ue.title,command:this._commands.toInternal(Ue,$e)})):(ye.only&&(Ue.kind?ye.only.contains(Ue.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ye.only.value} 'requested but returned code action is of kind '${Ue.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ye.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[We,ze],title:Ue.title,command:Ue.command&&this._commands.toInternal(Ue.command,$e),diagnostics:Ue.diagnostics&&Ue.diagnostics.map(k.Diagnostic.from),edit:Ue.edit&&k.WorkspaceEdit.from(Ue.edit),kind:Ue.kind&&Ue.kind.value,isPreferred:Ue.isPreferred,disabled:Ue.disabled?.reason})))}return{cacheId:We,actions:je}}async resolveCodeAction(z,W){const[N,$]=z,K=this._cache.get(N,$);if(!K||L._isCommand(K)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(K,W)??K;return re?.edit?k.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}L._maxCodeActionsPerFile=1e3;class S{constructor(z,W){this._documents=z,this._provider=W}async provideDocumentFormattingEdits(z,W,N){const $=this._documents.getDocument(z),K=await this._provider.provideDocumentFormattingEdits($,W,N);if(Array.isArray(K))return K.map(k.TextEdit.from)}}class U{constructor(z,W){this._documents=z,this._provider=W}async provideDocumentRangeFormattingEdits(z,W,N,$){const K=this._documents.getDocument(z),re=k.Range.to(W),de=await this._provider.provideDocumentRangeFormattingEdits(K,re,N,$);if(Array.isArray(de))return de.map(k.TextEdit.from)}}class M{constructor(z,W){this._documents=z,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,W,N,$,K){const re=this._documents.getDocument(z),de=k.Position.to(W),ye=await this._provider.provideOnTypeFormattingEdits(re,de,N,$,K);if(Array.isArray(ye))return ye.map(k.TextEdit.from)}}class X{constructor(z,W){this._provider=z,this._logService=W,this._cache=new v.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(z,W){const N=await this._provider.provideWorkspaceSymbols(z,W);if(!(0,T.isNonEmptyArray)(N))return{symbols:[]};const $=this._cache.add(N),K={cacheId:$,symbols:[]};for(let re=0;re<N.length;re++){const de=N[re];if(!de||!de.name){this._logService.warn("INVALID SymbolInformation",de);continue}K.symbols.push({...k.WorkspaceSymbol.from(de),cacheId:[$,re]})}return K}async resolveWorkspaceSymbol(z,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const N=this._cache.get(...z.cacheId);if(N){const $=await this._provider.resolveWorkspaceSymbol(N,W);return $&&(0,t.mixin)(z,k.WorkspaceSymbol.from($),!0)}}releaseWorkspaceSymbols(z){this._cache.delete(z)}}class G{constructor(z,W,N){this._documents=z,this._provider=W,this._logService=N}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,W,N,$){const K=this._documents.getDocument(z),re=k.Position.to(W);try{const de=await this._provider.provideRenameEdits(K,re,N,$);return de?k.WorkspaceEdit.from(de):void 0}catch(de){const ye=G._asMessage(de);return ye?{rejectReason:ye,edits:void 0}:Promise.reject(de)}}async resolveRenameLocation(z,W,N){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const $=this._documents.getDocument(z),K=k.Position.to(W);try{const re=await this._provider.prepareRename($,K,N);let de,ye;if(A.Range.isRange(re)?(de=re,ye=$.getText(re)):(0,F.isObject)(re)&&(de=re.range,ye=re.placeholder),!de||!ye)return;if(de.start.line>K.line||de.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(de),text:ye}}catch(re){const de=G._asMessage(re);return de?{rejectReason:de,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class q{constructor(z,W){this.resultId=z,this.tokens=W}}class B{constructor(z,W){this._documents=z,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,W,N){const $=this._documents.getDocument(z),K=W!==0?this._previousResults.get(W):null;let re=typeof K?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits($,K.resultId,N):await this._provider.provideDocumentSemanticTokens($,N);return K&&this._previousResults.delete(W),re?(re=B._fixProvidedSemanticTokens(re),this._send(B._convertToEdits(K,re),re)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return B._isSemanticTokens(z)?B._isCorrectSemanticTokens(z)?z:new A.SemanticTokens(new Uint32Array(z.data),z.resultId):B._isSemanticTokensEdits(z)?B._isCorrectSemanticTokensEdits(z)?z:new A.SemanticTokensEdits(z.edits.map(W=>new A.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const W of z.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,W){if(!B._isSemanticTokens(W)||!z||!z.tokens)return W;const N=z.tokens,$=N.length,K=W.data,re=K.length;let de=0;const ye=Math.min($,re);for(;de<ye&&N[de]===K[de];)de++;if(de===$&&de===re)return new A.SemanticTokensEdits([],W.resultId);let Re=0;const We=ye-de;for(;Re<We&&N[$-Re-1]===K[re-Re-1];)Re++;return new A.SemanticTokensEdits([{start:de,deleteCount:$-de-Re,data:K.subarray(de,re-Re)}],W.resultId)}_send(z,W){if(B._isSemanticTokens(z)){const N=this._nextResultId++;return this._previousResults.set(N,new q(z.resultId,z.data)),(0,p.encodeSemanticTokensDto)({id:N,type:"full",data:z.data})}if(B._isSemanticTokensEdits(z)){const N=this._nextResultId++;return B._isSemanticTokens(W)?this._previousResults.set(N,new q(W.resultId,W.data)):this._previousResults.set(N,new q(z.resultId)),(0,p.encodeSemanticTokensDto)({id:N,type:"delta",deltas:(z.edits||[]).map($=>({start:$.start,deleteCount:$.deleteCount,data:$.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class x{constructor(z,W){this._documents=z,this._provider=W}async provideDocumentRangeSemanticTokens(z,W,N){const $=this._documents.getDocument(z),K=await this._provider.provideDocumentRangeSemanticTokens($,k.Range.to(W),N);return K?this._send(K):null}_send(z){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=x;class j{constructor(z,W,N,$,K){this._documents=z,this._commands=W,this._provider=N,this._apiDeprecation=$,this._extension=K,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,W,N,$){const K=this._documents.getDocument(z),re=k.Position.to(W),de=K.getWordRangeAtPosition(re)||new A.Range(re,re),ye=de.with({end:re}),Re=new I.StopWatch(!0),We=await this._provider.provideCompletionItems(K,re,$,k.CompletionContext.to(N));if(!We||$.isCancellationRequested)return;const $e=Array.isArray(We)?new A.CompletionList(We):We,je=j.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),ze=new _.DisposableStore;this._disposables.set(je,ze);const Ue=[],Qe={x:je,b:Ue,a:{replace:k.Range.from(de),insert:k.Range.from(ye)},c:$e.isIncomplete||void 0,d:Re.elapsed()};for(let nt=0;nt<$e.items.length;nt++){const Le=$e.items[nt],et=this._convertCompletionItem(Le,[je,nt],ye,de);Ue.push(et)}return Qe}async resolveCompletionItem(z,W){if(typeof this._provider.resolveCompletionItem!="function")return;const N=this._cache.get(...z);if(!N)return;const $=await this._provider.resolveCompletionItem(N,W);if(!!$)return this._convertCompletionItem($,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,W,N,$){const K=this._disposables.get(W[0]);if(!K)throw Error("DisposableStore is missing...");const re={x:W,a:z.label,b:z.kind!==void 0?k.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(k.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(z.command,K)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=z.textEdit.newText):typeof z.insertText=="string"?re.h=z.insertText:z.insertText instanceof A.SnippetString&&(re.h=z.insertText.value,re.i|=4);let de;return z.textEdit?de=z.textEdit.range:z.range&&(de=z.range),A.Range.isRange(de)?re.j=k.Range.from(de):de&&(!N?.isEqual(de.inserting)||!$?.isEqual(de.replacing))&&(re.j={insert:k.Range.from(de.inserting),replace:k.Range.from(de.replacing)}),re}}class V{constructor(z,W,N){this._documents=z,this._provider=W,this._commands=N,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,W,N,$){const K=this._documents.getDocument(z),re=k.Position.to(W),de=await this._provider.provideInlineCompletionItems(K,re,{selectedCompletionInfo:N.selectedSuggestionInfo?{range:k.Range.to(N.selectedSuggestionInfo.range),text:N.selectedSuggestionInfo.text,isSnippetText:N.selectedSuggestionInfo.isSnippetText,completionKind:k.CompletionItemKind.to(N.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:N.triggerKind},$);if(!de||$.isCancellationRequested)return;const ye=(0,F.isArray)(de)?{items:de}:de,Re=this._cache.add(ye.items);let We;return{pid:Re,items:ye.items.map(($e,je)=>{let ze;return $e.command&&(We||(We=new _.DisposableStore,this._disposables.set(Re,We)),ze=this._commands.toInternal($e.command,We)),{text:$e.text,range:$e.range?k.Range.from($e.range):void 0,command:ze,idx:je,completeBracketPairs:$e.completeBracketPairs}})}}disposeCompletions(z){this._cache.delete(z);const W=this._disposables.get(z);W&&W.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,W){const N=this._cache.get(z,W);N&&Z.get(this._provider).fireOnDidShowCompletionItem({completionItem:N})}}class Z{constructor(){this._onDidShowCompletionItemEmitter=new m.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let W=Z.map.get(z);return W||(W=new Z,Z.map.set(z,W)),W}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=Z,Z.map=new WeakMap;class se{constructor(z,W){this._documents=z,this._provider=W,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(z,W,N,$){const K=this._documents.getDocument(z),re=k.Position.to(W),de=this.reviveContext(N),ye=await this._provider.provideSignatureHelp(K,re,$,de);if(ye){const Re=this._cache.add([ye]);return{...k.SignatureHelp.from(ye),id:Re}}}reviveContext(z){let W;if(z.activeSignatureHelp){const N=k.SignatureHelp.to(z.activeSignatureHelp),$=this._cache.get(z.activeSignatureHelp.id,0);$?(W=$,W.activeSignature=N.activeSignature,W.activeParameter=N.activeParameter):W=N}return{...z,activeSignatureHelp:W}}releaseSignatureHelp(z){this._cache.delete(z)}}class ce{constructor(z,W,N,$,K){this._documents=z,this._commands=W,this._provider=N,this._logService=$,this._extension=K,this._cache=new v.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(z,W,N){const $=this._documents.getDocument(z),K=k.Range.to(W),re=await this._provider.provideInlayHints($,K,N);if(!Array.isArray(re)||re.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(N.isCancellationRequested)return;const de=this._cache.add(re);this._disposables.set(de,new _.DisposableStore);const ye={hints:[],cacheId:de};for(let Re=0;Re<re.length;Re++)this._isValidInlayHint(re[Re],K)&&ye.hints.push(this._convertInlayHint(re[Re],[de,Re]));return this._logService.trace(`[InlayHints] ${ye.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),ye}async resolveInlayHint(z,W){if(typeof this._provider.resolveInlayHint!="function")return;const N=this._cache.get(...z);if(!N)return;const $=await this._provider.resolveInlayHint(N,W);if(!!$&&!!this._isValidInlayHint($))return this._convertInlayHint($,z)}releaseHints(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_isValidInlayHint(z,W){return z.label.length===0||Array.isArray(z.label)&&z.label.every(N=>N.label.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(W&&!W.contains(z.position))}_convertInlayHint(z,W){const N=this._disposables.get(W[0]);if(!N)throw Error("DisposableStore is missing...");const $={label:"",cacheId:W,tooltip:z.tooltip&&k.MarkdownString.from(z.tooltip),position:k.Position.from(z.position),kind:k.InlayHintKind.from(z.kind??A.InlayHintKind.Other),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?$.label=z.label:$.label=z.label.map(K=>{let re={label:K.label};return re.tooltip=K.tooltip&&k.MarkdownString.from(K.tooltip),A.Location.isLocation(K.location)&&(re.location=k.location.from(K.location)),K.command&&(re.command=this._commands.toInternal(K.command,N)),re}),$}}class ee{constructor(z,W){this._documents=z,this._provider=W,this._cache=new v.Cache("DocumentLink")}async provideLinks(z,W){const N=this._documents.getDocument(z),$=await this._provider.provideDocumentLinks(N,W);if(!(!Array.isArray($)||$.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:$.filter(ee._validateLink).map(k.DocumentLink.from)};{const K=this._cache.add($),re={links:[],cacheId:K};for(let de=0;de<$.length;de++){if(!ee._validateLink($[de]))continue;const ye=k.DocumentLink.from($[de]);ye.cacheId=[K,de],re.links.push(ye)}return re}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,W){if(typeof this._provider.resolveDocumentLink!="function")return;const N=this._cache.get(...z);if(!N)return;const $=await this._provider.resolveDocumentLink(N,W);if(!(!$||!ee._validateLink($)))return k.DocumentLink.from($)}releaseLinks(z){this._cache.delete(z)}}class Y{constructor(z,W){this._documents=z,this._provider=W}async provideColors(z,W){const N=this._documents.getDocument(z),$=await this._provider.provideDocumentColors(N,W);return Array.isArray($)?$.map(re=>({color:k.Color.from(re.color),range:k.Range.from(re.range)})):[]}async provideColorPresentations(z,W,N){const $=this._documents.getDocument(z),K=k.Range.to(W.range),re=k.Color.to(W.color),de=await this._provider.provideColorPresentations(re,{document:$,range:K},N);if(!!Array.isArray(de))return de.map(k.ColorPresentation.from)}}class ae{constructor(z,W){this._documents=z,this._provider=W}async provideFoldingRanges(z,W,N){const $=this._documents.getDocument(z),K=await this._provider.provideFoldingRanges($,W,N);if(!!Array.isArray(K))return K.map(k.FoldingRange.from)}}class he{constructor(z,W,N){this._documents=z,this._provider=W,this._logService=N}async provideSelectionRanges(z,W,N){const $=this._documents.getDocument(z),K=W.map(k.Position.to),re=await this._provider.provideSelectionRanges($,K,N);if(!(0,T.isNonEmptyArray)(re))return[];if(re.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const de=[];for(let ye=0;ye<K.length;ye++){const Re=[];de.push(Re);let We=K[ye],$e=re[ye];for(;;){if(!$e.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Re.push(k.SelectionRange.from($e)),!$e.parent)break;We=$e.range,$e=$e.parent}}return de}}class we{constructor(z,W){this._documents=z,this._provider=W,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(z,W,N){const $=this._documents.getDocument(z),K=k.Position.to(W),re=await this._provider.prepareCallHierarchy($,K,N);if(!re)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(re)?re.map(ye=>this._cacheAndConvertItem(de,ye)):[this._cacheAndConvertItem(de,re)]}async provideCallsTo(z,W,N){const $=this._itemFromCache(z,W);if(!$)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls($,N);if(!!K)return K.map(re=>({from:this._cacheAndConvertItem(z,re.from),fromRanges:re.fromRanges.map(de=>k.Range.from(de))}))}async provideCallsFrom(z,W,N){const $=this._itemFromCache(z,W);if(!$)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls($,N);if(!!K)return K.map(re=>({to:this._cacheAndConvertItem(z,re.to),fromRanges:re.fromRanges.map(de=>k.Range.from(de))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,W){const N=this._cache.get(z),$=k.CallHierarchyItem.from(W,z,N.size.toString(36));return N.set($._itemId,W),$}_itemFromCache(z,W){return this._cache.get(z)?.get(W)}}class ke{constructor(z,W){this._documents=z,this._provider=W,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(z,W,N){const $=this._documents.getDocument(z),K=k.Position.to(W),re=await this._provider.prepareTypeHierarchy($,K,N);if(!re)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(re)?re.map(ye=>this._cacheAndConvertItem(de,ye)):[this._cacheAndConvertItem(de,re)]}async provideSupertypes(z,W,N){const $=this._itemFromCache(z,W);if(!$)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySupertypes($,N);if(!!K)return K.map(re=>this._cacheAndConvertItem(z,re))}async provideSubtypes(z,W,N){const $=this._itemFromCache(z,W);if(!$)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySubtypes($,N);if(!!K)return K.map(re=>this._cacheAndConvertItem(z,re))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,W){const N=this._cache.get(z),$=k.TypeHierarchyItem.from(W,z,N.size.toString(36));return N.set($._itemId,W),$}_itemFromCache(z,W){return this._cache.get(z)?.get(W)}}class Ne{constructor(z,W){this.adapter=z,this.extension=W}}class _e{constructor(z,W,N,$,K,re,de){this._adapter=new Map,this._uriTransformer=W,this._proxy=z.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=N,this._commands=$,this._diagnostics=K,this._logService=re,this._apiDeprecation=de}_transformDocumentSelector(z){return k.DocumentSelector.from(z,this._uriTransformer)}_createDisposable(z){return new A.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return _e._handlePool++}async _withAdapter(z,W,N,$,K){const re=this._adapter.get(z);if(!re||!(re.adapter instanceof W))return $;const de=Date.now();this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${N.toString().replace(/[\r\n]/g,"")}'`);const ye=N(re.adapter,re.extension);return Promise.resolve(ye).catch(Re=>{(0,b.isCancellationError)(Re)||(this._logService.error(`[${re.extension.identifier.value}] provider FAILED`),this._logService.error(Re))}).finally(()=>{this._logService.trace(`[${re.extension.identifier.value}] provider DONE after ${Date.now()-de}ms`)}),f.CancellationToken.isCancellationToken(K)?(0,o.raceCancellationError)(ye,K):ye}_addNewAdapter(z,W){const N=this._nextHandle();return this._adapter.set(N,new Ne(z,W)),N}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,W,N,$){const K=this._addNewAdapter(new g(this._documents,N),z),re=$&&$.label||_e._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(W),re),this._createDisposable(K)}$provideDocumentSymbols(z,W,N){return this._withAdapter(z,g,$=>$.provideDocumentSymbols(d.URI.revive(W),N),void 0,N)}registerCodeLensProvider(z,W,N){const $=this._nextHandle(),K=typeof N.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set($,new Ne(new n(this._documents,this._commands.converter,N),z)),this._proxy.$registerCodeLensSupport($,this._transformDocumentSelector(W),K);let re=this._createDisposable($);if(K!==void 0){const de=N.onDidChangeCodeLenses(ye=>this._proxy.$emitCodeLensEvent(K));re=A.Disposable.from(re,de)}return re}$provideCodeLenses(z,W,N){return this._withAdapter(z,n,$=>$.provideCodeLenses(d.URI.revive(W),N),void 0,N)}$resolveCodeLens(z,W,N){return this._withAdapter(z,n,$=>$.resolveCodeLens(W,N),void 0,void 0)}$releaseCodeLenses(z,W){this._withAdapter(z,n,N=>Promise.resolve(N.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(z,W,N){const $=this._addNewAdapter(new a(this._documents,N),z);return this._proxy.$registerDefinitionSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDefinition(z,W,N,$){return this._withAdapter(z,a,K=>K.provideDefinition(d.URI.revive(W),N,$),[],$)}registerDeclarationProvider(z,W,N){const $=this._addNewAdapter(new i(this._documents,N),z);return this._proxy.$registerDeclarationSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDeclaration(z,W,N,$){return this._withAdapter(z,i,K=>K.provideDeclaration(d.URI.revive(W),N,$),[],$)}registerImplementationProvider(z,W,N){const $=this._addNewAdapter(new r(this._documents,N),z);return this._proxy.$registerImplementationSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideImplementation(z,W,N,$){return this._withAdapter(z,r,K=>K.provideImplementation(d.URI.revive(W),N,$),[],$)}registerTypeDefinitionProvider(z,W,N){const $=this._addNewAdapter(new s(this._documents,N),z);return this._proxy.$registerTypeDefinitionSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideTypeDefinition(z,W,N,$){return this._withAdapter(z,s,K=>K.provideTypeDefinition(d.URI.revive(W),N,$),[],$)}registerHoverProvider(z,W,N,$){const K=this._addNewAdapter(new l(this._documents,N),z);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideHover(z,W,N,$){return this._withAdapter(z,l,K=>K.provideHover(d.URI.revive(W),N,$),void 0,$)}registerEvaluatableExpressionProvider(z,W,N,$){const K=this._addNewAdapter(new h(this._documents,N),z);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(W)),this._createDisposable(K)}$provideEvaluatableExpression(z,W,N,$){return this._withAdapter(z,h,K=>K.provideEvaluatableExpression(d.URI.revive(W),N,$),void 0,void 0)}registerInlineValuesProvider(z,W,N,$){const K=typeof N.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new u(this._documents,N),z);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(W),K);let de=this._createDisposable(re);if(K!==void 0){const ye=N.onDidChangeInlineValues(Re=>this._proxy.$emitInlineValuesEvent(K));de=A.Disposable.from(de,ye)}return de}$provideInlineValues(z,W,N,$,K){return this._withAdapter(z,u,re=>re.provideInlineValues(d.URI.revive(W),N,$,K),void 0,void 0)}registerDocumentHighlightProvider(z,W,N){const $=this._addNewAdapter(new w(this._documents,N),z);return this._proxy.$registerDocumentHighlightProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDocumentHighlights(z,W,N,$){return this._withAdapter(z,w,K=>K.provideDocumentHighlights(d.URI.revive(W),N,$),void 0,$)}registerLinkedEditingRangeProvider(z,W,N){const $=this._addNewAdapter(new R(this._documents,N),z);return this._proxy.$registerLinkedEditingRangeProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideLinkedEditingRanges(z,W,N,$){return this._withAdapter(z,R,async K=>{const re=await K.provideLinkedEditingRanges(d.URI.revive(W),N,$);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?_e._serializeRegExp(re.wordPattern):void 0}},void 0,$)}registerReferenceProvider(z,W,N){const $=this._addNewAdapter(new O(this._documents,N),z);return this._proxy.$registerReferenceSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideReferences(z,W,N,$,K){return this._withAdapter(z,O,re=>re.provideReferences(d.URI.revive(W),N,$,K),void 0,K)}registerCodeActionProvider(z,W,N,$){const K=new _.DisposableStore,re=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,N,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(W),{providedKinds:$?.providedCodeActionKinds?.map(de=>de.value),documentation:$?.documentation?.map(de=>({kind:de.kind.value,command:this._commands.converter.toInternal(de.command,K)}))},_e._extLabel(z),Boolean(N.resolveCodeAction)),K.add(this._createDisposable(re)),K}$provideCodeActions(z,W,N,$,K){return this._withAdapter(z,L,re=>re.provideCodeActions(d.URI.revive(W),N,$,K),void 0,K)}$resolveCodeAction(z,W,N){return this._withAdapter(z,L,$=>$.resolveCodeAction(W,N),void 0,void 0)}$releaseCodeActions(z,W){this._withAdapter(z,L,N=>Promise.resolve(N.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(z,W,N){const $=this._addNewAdapter(new S(this._documents,N),z);return this._proxy.$registerDocumentFormattingSupport($,this._transformDocumentSelector(W),z.identifier,z.displayName||z.name),this._createDisposable($)}$provideDocumentFormattingEdits(z,W,N,$){return this._withAdapter(z,S,K=>K.provideDocumentFormattingEdits(d.URI.revive(W),N,$),void 0,void 0)}registerDocumentRangeFormattingEditProvider(z,W,N){const $=this._addNewAdapter(new U(this._documents,N),z);return this._proxy.$registerRangeFormattingSupport($,this._transformDocumentSelector(W),z.identifier,z.displayName||z.name),this._createDisposable($)}$provideDocumentRangeFormattingEdits(z,W,N,$,K){return this._withAdapter(z,U,re=>re.provideDocumentRangeFormattingEdits(d.URI.revive(W),N,$,K),void 0,void 0)}registerOnTypeFormattingEditProvider(z,W,N,$){const K=this._addNewAdapter(new M(this._documents,N),z);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(W),$,z.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits(z,W,N,$,K,re){return this._withAdapter(z,M,de=>de.provideOnTypeFormattingEdits(d.URI.revive(W),N,$,K,re),void 0,re)}registerWorkspaceSymbolProvider(z,W){const N=this._addNewAdapter(new X(W,this._logService),z);return this._proxy.$registerNavigateTypeSupport(N,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(N)}$provideWorkspaceSymbols(z,W,N){return this._withAdapter(z,X,$=>$.provideWorkspaceSymbols(W,N),{symbols:[]},N)}$resolveWorkspaceSymbol(z,W,N){return this._withAdapter(z,X,$=>$.resolveWorkspaceSymbol(W,N),void 0,void 0)}$releaseWorkspaceSymbols(z,W){this._withAdapter(z,X,N=>N.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(z,W,N){const $=this._addNewAdapter(new G(this._documents,N,this._logService),z);return this._proxy.$registerRenameSupport($,this._transformDocumentSelector(W),G.supportsResolving(N)),this._createDisposable($)}$provideRenameEdits(z,W,N,$,K){return this._withAdapter(z,G,re=>re.provideRenameEdits(d.URI.revive(W),N,$,K),void 0,void 0)}$resolveRenameLocation(z,W,N,$){return this._withAdapter(z,G,K=>K.resolveRenameLocation(d.URI.revive(W),N,$),void 0,void 0)}registerDocumentSemanticTokensProvider(z,W,N,$){const K=this._addNewAdapter(new B(this._documents,N),z),re=typeof N.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(W),$,re);let de=this._createDisposable(K);if(re){const ye=N.onDidChangeSemanticTokens(Re=>this._proxy.$emitDocumentSemanticTokensEvent(re));de=A.Disposable.from(de,ye)}return de}$provideDocumentSemanticTokens(z,W,N,$){return this._withAdapter(z,B,K=>K.provideDocumentSemanticTokens(d.URI.revive(W),N,$),null,$)}$releaseDocumentSemanticTokens(z,W){this._withAdapter(z,B,N=>N.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,W,N,$){const K=this._addNewAdapter(new x(this._documents,N),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(W),$),this._createDisposable(K)}$provideDocumentRangeSemanticTokens(z,W,N,$){return this._withAdapter(z,x,K=>K.provideDocumentRangeSemanticTokens(d.URI.revive(W),N,$),null,$)}registerCompletionItemProvider(z,W,N,$){const K=this._addNewAdapter(new j(this._documents,this._commands.converter,N,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(K,this._transformDocumentSelector(W),$,j.supportsResolving(N),`${z.identifier.value}(${$.join("")})`),this._createDisposable(K)}$provideCompletionItems(z,W,N,$,K){return this._withAdapter(z,j,re=>re.provideCompletionItems(d.URI.revive(W),N,$,K),void 0,K)}$resolveCompletionItem(z,W,N){return this._withAdapter(z,j,$=>$.resolveCompletionItem(W,N),void 0,N)}$releaseCompletionItems(z,W){this._withAdapter(z,j,N=>N.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(z,W,N){const $=this._addNewAdapter(new V(this._documents,N,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideInlineCompletions(z,W,N,$,K){return this._withAdapter(z,V,re=>re.provideInlineCompletions(d.URI.revive(W),N,$,K),void 0,void 0)}$handleInlineCompletionDidShow(z,W,N){this._withAdapter(z,V,async $=>{$.handleDidShowCompletionItem(W,N)},void 0,void 0)}$freeInlineCompletionsList(z,W){this._withAdapter(z,V,async N=>{N.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(z,W,N,$){const K=Array.isArray($)?{triggerCharacters:$,retriggerCharacters:[]}:$,re=this._addNewAdapter(new se(this._documents,N),z);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(W),K),this._createDisposable(re)}$provideSignatureHelp(z,W,N,$,K){return this._withAdapter(z,se,re=>re.provideSignatureHelp(d.URI.revive(W),N,$,K),void 0,void 0)}$releaseSignatureHelp(z,W){this._withAdapter(z,se,N=>N.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(z,W,N){const $=typeof N.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new ce(this._documents,this._commands.converter,N,this._logService,z),z);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(W),typeof N.resolveInlayHint=="function",$,_e._extLabel(z));let re=this._createDisposable(K);if($!==void 0){const de=N.onDidChangeInlayHints(ye=>this._proxy.$emitInlayHintsEvent($));re=A.Disposable.from(re,de)}return re}$provideInlayHints(z,W,N,$){return this._withAdapter(z,ce,K=>K.provideInlayHints(d.URI.revive(W),N,$),void 0,$)}$resolveInlayHint(z,W,N){return this._withAdapter(z,ce,$=>$.resolveInlayHint(W,N),void 0,N)}$releaseInlayHints(z,W){this._withAdapter(z,ce,N=>N.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(z,W,N){const $=this._addNewAdapter(new ee(this._documents,N),z);return this._proxy.$registerDocumentLinkProvider($,this._transformDocumentSelector(W),typeof N.resolveDocumentLink=="function"),this._createDisposable($)}$provideDocumentLinks(z,W,N){return this._withAdapter(z,ee,$=>$.provideLinks(d.URI.revive(W),N),void 0,void 0)}$resolveDocumentLink(z,W,N){return this._withAdapter(z,ee,$=>$.resolveLink(W,N),void 0,void 0)}$releaseDocumentLinks(z,W){this._withAdapter(z,ee,N=>N.releaseLinks(W),void 0,void 0)}registerColorProvider(z,W,N){const $=this._addNewAdapter(new Y(this._documents,N),z);return this._proxy.$registerDocumentColorProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDocumentColors(z,W,N){return this._withAdapter(z,Y,$=>$.provideColors(d.URI.revive(W),N),[],void 0)}$provideColorPresentations(z,W,N,$){return this._withAdapter(z,Y,K=>K.provideColorPresentations(d.URI.revive(W),N,$),void 0,void 0)}registerFoldingRangeProvider(z,W,N){const $=this._nextHandle(),K=typeof N.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set($,new Ne(new ae(this._documents,N),z)),this._proxy.$registerFoldingRangeProvider($,this._transformDocumentSelector(W),K);let re=this._createDisposable($);if(K!==void 0){const de=N.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));re=A.Disposable.from(re,de)}return re}$provideFoldingRanges(z,W,N,$){return this._withAdapter(z,ae,K=>K.provideFoldingRanges(d.URI.revive(W),N,$),void 0,void 0)}registerSelectionRangeProvider(z,W,N){const $=this._addNewAdapter(new he(this._documents,N,this._logService),z);return this._proxy.$registerSelectionRangeProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideSelectionRanges(z,W,N,$){return this._withAdapter(z,he,K=>K.provideSelectionRanges(d.URI.revive(W),N,$),[],$)}registerCallHierarchyProvider(z,W,N){const $=this._addNewAdapter(new we(this._documents,N),z);return this._proxy.$registerCallHierarchyProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$prepareCallHierarchy(z,W,N,$){return this._withAdapter(z,we,K=>Promise.resolve(K.prepareSession(d.URI.revive(W),N,$)),void 0,$)}$provideCallHierarchyIncomingCalls(z,W,N,$){return this._withAdapter(z,we,K=>K.provideCallsTo(W,N,$),void 0,$)}$provideCallHierarchyOutgoingCalls(z,W,N,$){return this._withAdapter(z,we,K=>K.provideCallsFrom(W,N,$),void 0,$)}$releaseCallHierarchy(z,W){this._withAdapter(z,we,N=>Promise.resolve(N.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(z,W,N){const $=this._addNewAdapter(new ke(this._documents,N),z);return this._proxy.$registerTypeHierarchyProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$prepareTypeHierarchy(z,W,N,$){return this._withAdapter(z,ke,K=>Promise.resolve(K.prepareSession(d.URI.revive(W),N,$)),void 0,$)}$provideTypeHierarchySupertypes(z,W,N,$){return this._withAdapter(z,ke,K=>K.provideSupertypes(W,N,$),void 0,$)}$provideTypeHierarchySubtypes(z,W,N,$){return this._withAdapter(z,ke,K=>K.provideSubtypes(W,N,$),void 0,$)}$releaseTypeHierarchy(z,W){this._withAdapter(z,ke,N=>Promise.resolve(N.releaseSession(W)),void 0,void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,P.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:_e._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:_e._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?_e._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?_e._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:_e._serializeRegExp(z.beforeText),afterText:z.afterText?_e._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?_e._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(_e._serializeOnEnterRule)}setLanguageConfiguration(z,W,N){let{wordPattern:$}=N;if($&&(0,P.regExpLeadsToEndlessLoop)($))throw new Error(`Invalid language configuration: wordPattern '${$}' is not allowed to match the empty string.`);$?this._documents.setWordDefinitionFor(W,$):this._documents.setWordDefinitionFor(W,void 0),N.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),N.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const K=this._nextHandle(),re={comments:N.comments,brackets:N.brackets,wordPattern:N.wordPattern?_e._serializeRegExp(N.wordPattern):void 0,indentationRules:N.indentationRules?_e._serializeIndentationRule(N.indentationRules):void 0,onEnterRules:N.onEnterRules?_e._serializeOnEnterRules(N.onEnterRules):void 0,__electricCharacterSupport:N.__electricCharacterSupport,__characterPairSupport:N.__characterPairSupport};return this._proxy.$setLanguageConfiguration(K,W,re),this._createDisposable(K)}$setWordDefinitions(z){for(const W of z)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=_e,_e._handlePool=0}),define(ve[244],be([1,0,5,15,7,47,13,6]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(F,C,f,_){this._documents=C,this._commands=f,this._uriTransformer=_,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,C){await this._proxy.$changeLanguage(F,C);const f=this._documents.getDocumentData(F);if(!f)throw new Error(`document '${F.toString}' NOT found`);return f.document}async tokenAtPosition(F,C){const f=F.version,_=t.Position.from(C),p=await this._proxy.$tokensAtPosition(F.uri,_),c={type:k.StandardTokenType.Other,range:F.getWordRangeAtPosition(C)??new k.Range(C.line,C.character,C.line,C.character)};if(!p)return c;const v={range:t.Range.to(p.range),type:t.TokenType.to(p.type)};return!v.range.contains(C)||f!==F.version?c:v}createLanguageStatusItem(F,C,f){const _=this._handlePool++,p=this._proxy,c=this._ids,v=`${F.identifier.value}/${C}`;if(c.has(v))throw new Error(`LanguageStatusItem with id '${C}' ALREADY exists`);c.add(v);const I={selector:f,id:C,name:F.displayName??F.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b,m=new P.DisposableStore;const o=()=>{b?.dispose(),b=(0,D.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(_,{id:v,name:I.name??F.displayName??F.name,source:F.displayName??F.name,selector:t.DocumentSelector.from(I.selector,this._uriTransformer),label:I.text,detail:I.detail??"",severity:I.severity===k.LanguageStatusSeverity.Error?A.default.Error:I.severity===k.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:I.command&&this._commands.toInternal(I.command,m),accessibilityInfo:I.accessibilityInformation,busy:I.busy})},0)},g={dispose(){m.dispose(),b?.dispose(),p.$removeLanguageStatus(_),c.delete(v)},get id(){return I.id},get name(){return I.name},set name(n){I.name=n,o()},get selector(){return I.selector},set selector(n){I.selector=n,o()},get text(){return I.text},set text(n){I.text=n,o()},get detail(){return I.detail},set detail(n){I.detail=n,o()},get severity(){return I.severity},set severity(n){I.severity=n,o()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(n){I.accessibilityInformation=n,o()},get command(){return I.command},set command(n){I.command=n,o()},get busy(){return I.busy},set busy(n){I.busy=n,o()}};return o(),g}}e.ExtHostLanguages=y}),define(ve[135],be([1,0,12,5,26,14,3]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends d.AbstractLoggerService{constructor(F,C){const f=new D.Emitter;super(C.logLevel,f.event);this._proxy=F.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(f)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,C,f){return new y(this._proxy,F,C,f)}};P=Be([Fe(0,A.IExtHostRpcService),Fe(1,k.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class y extends d.AbstractMessageLogger{constructor(F,C,f,_){super(_?.always);this.proxy=F,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.proxy.$createLogger(C,_).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,C){const f=[[F,C]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(F){this.proxy.$log(this.file,F)}}}),define(ve[245],be([1,0,5,12,30]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let D=class{constructor(y,T){this._logService=T,this._proxy=y.getProxy(d.MainContext.MainThreadMessageService)}showMessage(y,T,F,C,f){const _={source:{identifier:y.identifier,label:y.displayName||y.name}};let p;typeof C=="string"||A(C)?p=[C,...f]:(_.modal=C?.modal,_.useCustom=C?.useCustom,_.detail=C?.detail,p=f),_.useCustom&&(0,k.checkProposedApiEnabled)(y,"resolvers");const c=[];for(let v=0;v<p.length;v++){const I=p[v];if(typeof I=="string")c.push({title:I,handle:v,isCloseAffordance:!1});else if(typeof I=="object"){let{title:b,isCloseAffordance:m}=I;c.push({title:b,isCloseAffordance:!!m,handle:v})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(T,F,_,c).then(v=>{if(typeof v=="number")return p[v]})}};D=Be([Fe(1,t.ILogService)],D),e.ExtHostMessageService=D}),define(ve[246],be([1,0,23,3,58,6,24,8,18,2,85,5,15,7,52,222,131]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(m,o,g,n,E){this._textDocumentsAndEditors=g,this._textDocuments=n,this._extensionStoragePaths=E,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=m.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const i=a.notebookEditor?.notebookUri,r=a.cell.handle,l=this._documents.get(i)?.getCell(r);if(l)return l.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}getEditorById(m){const o=this._editors.get(m);if(!o)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(m){for(const[o,g]of this._editors)if(g.apiEditor===m)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,o){const g=this._documents.get(m);if(!g&&!o)throw new Error(`NO notebook document for '${m}'`);return g}_getProviderData(m){const o=this._notebookContentProviders.get(m);if(!o)throw new Error(`NO provider for '${m}'`);return o}registerNotebookContentProvider(m,o,g,n,E){if((0,P.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:m,provider:g});let a;return g.onDidChangeNotebookContentOptions&&(a=g.onDidChangeNotebookContentOptions(()=>{const i=f.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(o,i)})),this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation},o,f.NotebookDocumentContentOptions.from(n),I._convertNotebookRegistrationData(m,E)),new _.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(m,o){if(!o)return;const g=o.filenamePattern.map(n=>f.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(o.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:o.displayName,filenamePattern:g,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,o,g){const n=I._notebookStatusBarItemProviderHandlePool++,E=typeof g.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,E,o);let a;return E!==void 0&&(a=g.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(E))),new _.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,E),a&&a.dispose()})}async createNotebookDocument(m){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&f.NotebookData.from(m.content)});return T.URI.revive(o)}async openNotebookDocument(m){const o=this._documents.get(m);if(o)return o.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(m),n=this._documents.get(T.URI.revive(g));return(0,y.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(m,o){T.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let g;typeof o=="object"?g={position:f.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(f.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:g={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,g),E=n&&this._editors.get(n)?.apiEditor;if(E)return E;throw n?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,o,g,n){const E=this._notebookStatusBarItemProviders.get(m),a=T.URI.revive(o),i=this._documents.get(a);if(!i||!E)return;const r=i.getCellFromIndex(g);if(!r)return;const s=await E.provideCellStatusBarItems(r.apiCell,n);if(!s)return;const l=new A.DisposableStore,h=this._statusBarCache.add([l]),w=(Array.isArray(s)?s:[s]).map(R=>f.NotebookStatusBarItem.from(R,this._commandsConverter,l));return{cacheId:h,items:w}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,o,g,n,E){if((0,P.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,g),this._notebookProxy.$registerNotebookSerializer(a,{id:m.identifier,location:m.extensionLocation},o,f.NotebookDocumentContentOptions.from(n),I._convertNotebookRegistrationData(m,E)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(m,o,g){const n=this._notebookSerializer.get(m);if(!n)throw new Error("NO serializer found");const E=await n.deserializeNotebook(o.buffer,g);return new p.SerializableObjectWithBuffers(f.NotebookData.from(E))}async $notebookToData(m,o,g){const n=this._notebookSerializer.get(m);if(!n)throw new Error("NO serializer found");const E=await n.serializeNotebook(f.NotebookData.to(o.value),g);return d.VSBuffer.wrap(E)}async $openNotebook(m,o,g,n,E){const{provider:a}=this._getProviderData(m),i=await a.openNotebook(T.URI.revive(o),{backupId:g,untitledDocumentData:n?.buffer},E);return new p.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(f.NotebookCellData.from)})}async $saveNotebook(m,o,g){const n=this.getNotebookDocument(T.URI.revive(o)),{provider:E}=this._getProviderData(m);return await E.saveNotebook(n.apiNotebook,g),!0}async $saveNotebookAs(m,o,g,n){const E=this.getNotebookDocument(T.URI.revive(o)),{provider:a}=this._getProviderData(m);return await a.saveNotebookAs(T.URI.revive(g),E.apiNotebook,n),!0}async $backupNotebook(m,o,g){const n=this.getNotebookDocument(T.URI.revive(o)),E=this._getProviderData(m),a=this._extensionStoragePaths.workspaceValue(E.extension)??this._extensionStoragePaths.globalValue(E.extension),i=String((0,k.hash)([n.uri.toString(),this._backupIdPool++])),r=T.URI.joinPath(a,i),s=await E.provider.backupNotebook(n.apiNotebook,{destination:r},g);return n.updateBackup(s),s.id}_createExtHostEditor(m,o,g){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const n=new v.ExtHostNotebookEditor(o,this._notebookEditorsProxy,m,g.visibleRanges.map(f.NotebookRange.to),g.selections.map(f.NotebookRange.to),typeof g.viewColumn=="number"?f.ViewColumn.to(g.viewColumn):void 0);this._editors.set(o,n)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const g of m.value.removedDocuments){const n=T.URI.revive(g),E=this._documents.get(n);E&&(E.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===n.toString()&&this._editors.delete(a.id)}if(m.value.addedDocuments){const g=[];for(const n of m.value.addedDocuments){const E=T.URI.revive(n.uri);if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const a=this,i=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){a._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){a._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){a._onDidChangeCellMetadata.fire(r)}},E,n);g.push(...n.cells.map(r=>c.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(E)?.dispose(),this._documents.set(E,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(m.value.addedEditors)for(const g of m.value.addedEditors){if(this._editors.has(g.id))return;const n=T.URI.revive(g.documentUri),E=this._documents.get(n);E&&this._createExtHostEditor(E,g.id,g)}const o=[];if(m.value.removedEditors)for(const g of m.value.removedEditors){const n=this._editors.get(g);n&&(this._editors.delete(g),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),o.push(n))}if(m.value.visibleEditors){this._visibleNotebookEditors=m.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const g=new Set;this._visibleNotebookEditors.forEach(n=>g.add(n.id));for(const n of this._editors.values()){const E=g.has(n.id);n._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this._activeNotebookEditor=void 0:m.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(ve[247],be([1,0,3,76,12,5,14,15]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(C,f){const _=y._Keys.nextId();C.$registerNotebookEditorDecorationType(_,P.NotebookDecorationRenderOptions.from(f)),this.value={key:_,dispose(){C.$removeNotebookEditorDecorationType(_)}}}}y._Keys=new t.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(C,f,_){this._logService=C,this._extHostRpc=f,this._notebooksAndEditors=_,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(C){return new y(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),C).value}$acceptEditorPropertiesChanged(C,f){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,f);const _=this._notebooksAndEditors.getEditorById(C);f.visibleRanges&&_._acceptVisibleRanges(f.visibleRanges.ranges.map(P.NotebookRange.to)),f.selections&&_._acceptSelections(f.selections.selections.map(P.NotebookRange.to)),f.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:_.apiEditor,visibleRanges:_.apiEditor.visibleRanges}),f.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:_.apiEditor,selections:_.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const f in C)this._notebooksAndEditors.getEditorById(f)._acceptViewColumn(P.ViewColumn.to(C[f]))}};T=Be([Fe(0,k.ILogService),Fe(1,D.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(ve[248],be([1,0,17,13,21,3,6,24,2,27,12,5,38,15,7,86,215,30,52]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let m=class{constructor(i,r,s,l,h){this._initData=r,this._extHostNotebook=s,this._commands=l,this._logService=h,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(C.MainContext.MainThreadNotebookKernels);const u=new f.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new f.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const R=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:R}}else if(w&&"notebookEditor"in w){const R=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return w})],f.ApiCommandResult.Void);this._commands.registerApiCommand(u)}createNotebookController(i,r,s,l,h,u){for(const Z of this._kernelData.values())if(Z.controller.id===r&&T.ExtensionIdentifier.equals(i.identifier,Z.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const w=this._handlePool++,R=this;this._logService.trace(`NotebookController[${w}], CREATED by ${i.identifier.value}, ${r}`);const O=()=>console.warn(`NO execute handler from notebook controller '${X.id}' of extension: '${i.identifier}'`);let L=!1;const S=new D.DisposableStore,U=new A.Emitter,M=new A.Emitter,X={id:E(i,r),notebookType:s,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:l||i.identifier.value,preloads:u?u.map(_.NotebookRendererScript.from):[]};let G=h??O,q;this._proxy.$addKernel(w,X).catch(Z=>{console.log(Z),L=!0});let B=0;const x=()=>{if(L)return;const Z=++B;Promise.resolve().then(()=>{Z===B&&this._proxy.$updateKernel(w,X)})},j=new P.ResourceMap,V={get id(){return r},get notebookType(){return X.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return X.label},set label(Z){X.label=Z??i.displayName??i.name,x()},get detail(){return X.detail??""},set detail(Z){X.detail=Z,x()},get description(){return X.description??""},set description(Z){X.description=Z,x()},get kind(){return(0,I.checkProposedApiEnabled)(i,"notebookControllerKind"),X.kind??""},set kind(Z){(0,I.checkProposedApiEnabled)(i,"notebookControllerKind"),X.kind=Z,x()},get supportedLanguages(){return X.supportedLanguages},set supportedLanguages(Z){X.supportedLanguages=Z,x()},get supportsExecutionOrder(){return X.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){X.supportsExecutionOrder=Z,x()},get rendererScripts(){return X.preloads?X.preloads.map(_.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(Z){G=Z??O},get interruptHandler(){return q},set interruptHandler(Z){q=Z,X.supportsInterrupt=Boolean(Z),x()},createNotebookCellExecution(Z){if(L)throw new Error("notebook controller is DISPOSED");if(!j.has(Z.notebook.uri))throw R._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return R._createNotebookCellExecution(Z,E(i,this.id))},dispose:()=>{L||(this._logService.trace(`NotebookController[${w}], DISPOSED`),L=!0,this._kernelData.delete(w),S.dispose(),U.dispose(),M.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(Z,se){R._proxy.$updateNotebookPriority(w,Z.uri,se)},onDidReceiveMessage:M.event,postMessage(Z,se){return(0,I.checkProposedApiEnabled)(i,"notebookMessaging"),R._proxy.$postMessage(w,se&&R._extHostNotebook.getIdByEditor(se),Z)},asWebviewUri(Z){return(0,I.checkProposedApiEnabled)(i,"notebookMessaging"),(0,c.asWebviewUri)(Z,R._initData.remote)}};return this._kernelData.set(w,{extensionId:i.identifier,controller:V,onDidReceiveMessage:M,onDidChangeSelection:U,associatedNotebooks:j}),V}$acceptNotebookAssociation(i,r,s){const l=this._kernelData.get(i);if(l){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(r));s?l.associatedNotebooks.set(h.uri,!0):l.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,h.uri.toString(),s),l.onDidChangeSelection.fire({selected:s,notebook:h.apiNotebook})}}async $executeCells(i,r,s){const l=this._kernelData.get(i);if(!l)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(r)),u=[];for(const w of s){const R=h.getCell(w);R&&u.push(R.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,h.uri.toString(),u.length),await l.controller.executeHandler.call(l.controller,u,h.apiNotebook,l.controller)}catch(w){this._logService.error(`NotebookController[${i}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(i,r,s){const l=this._kernelData.get(i);if(!l)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(r));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,h.apiNotebook);else for(const u of s){const w=h.getCell(u);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,s){const l=this._kernelData.get(i);if(!l)return;const h=this._extHostNotebook.getEditorById(r);l.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:s}))}$cellExecutionChanged(i,r,s){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(i)).getCell(r);h&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:s??p.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const h=new g(r,l,this._proxy);this._activeExecutions.set(l.uri,h);const u=h.onDidChangeState(()=>{h.state===o.Resolved&&(h.dispose(),u.dispose(),this._activeExecutions.delete(l.uri))});return h.asApiObject()}};m=Be([Fe(4,F.ILogService)],m),e.ExtHostNotebookKernels=m;var o;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(o||(o={}));class g extends D.Disposable{constructor(i,r,s){super();this._cell=r,this._proxy=s,this._handle=g.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new n(10,l=>this.update(l)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new b.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(r=>{const s=p.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return s===r.items?_.NotebookCellOutput.from(r):_.NotebookCellOutput.from({items:s,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,s){const l=this.validateAndConvertOutputs((0,d.asArray)(i));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,append:s,outputs:l})}async updateOutputItems(i,r,s){return i=p.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(i),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,items:i.map(_.NotebookCellOutputItem.from),outputId:r.id,append:s})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(s){i._executionOrder=s,i.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(s){if(i._state===o.Resolved||i._state===o.Started)throw new Error("Cannot call start again");i._state=o.Started,i._onDidChangeState.fire(),i.update({editType:v.CellExecutionUpdateType.ExecutionState,runStartTime:s})},end(s,l){if(i._state===o.Resolved)throw new Error("Cannot call resolve twice");i._state=o.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new b.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:s}))},clearOutput(s){return i.verifyStateForOutput(),i.updateOutputs([],s,!1)},appendOutput(s,l){return i.verifyStateForOutput(),i.updateOutputs(s,l,!0)},replaceOutput(s,l){return i.verifyStateForOutput(),i.updateOutputs(s,l,!1)},appendOutputItems(s,l){return i.verifyStateForOutput(),i.updateOutputItems(s,l,!0)},replaceOutputItems(s,l){return i.verifyStateForOutput(),i.updateOutputItems(s,l,!1)}})}}g.HANDLE=0;class n{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function E(a,i){return`${a.identifier.value}/${i}`}}),define(ve[249],be([1,0,3,5,131,30]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class D{constructor(y,T){this._extHostNotebook=T,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,T,F){const C=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(T)?.fire({editor:C.apiEditor,message:F})}createRendererMessaging(y,T){if(!y.contributes?.notebookRenderer?.some(_=>_.id===T))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${T})`);const F=(0,A.isProposedApiEnabled)(y,"notebookEditor"),C=new WeakMap;return{onDidReceiveMessage:(_,p,c)=>{const v=F?_:I=>{const b={};C.set(b,I.editor),_({editor:b,message:I.message})};return this.getOrCreateEmitterFor(T).event(v,p,c)},postMessage:(_,p)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(_)&&([_,p]=[p,_]);const c=F?p:C.get(p),v=c&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(c);return this.proxy.$postMessage(v?.id,T,_)}}}getOrCreateEmitterFor(y){let T=this._rendererMessageEmitters.get(y);return T||(T=new d.Emitter({onLastListenerRemove:()=>{T?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,T),T)}}e.ExtHostNotebookRenderers=D}),define(ve[136],be([1,0,5,6,4,14,12,216,66,26,44,157,23]),function(te,e,d,t,k,A,D,P,y,T,F,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class _ extends t.Disposable{constructor(v,I,b,m){super();this.id=v,this.name=I,this.logger=b,this.proxy=m,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(v){this.append(v+`
`)}append(v){this.write(v),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,v)}replace(v){const I=this.offset;this.write(v),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,I),this.visible&&this.logger.flush()}show(v,I){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:I))}hide(){this.proxy.$close(this.id)}write(v){this.offset+=f.VSBuffer.fromString(v).byteLength,this.logger.info(v)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=_;let p=class{constructor(v,I,b,m,o){this.extHostFileSystem=b,this.extHostFileSystemInfo=m,this.loggerService=o,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(d.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(I.logsLocation,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[I,b]of this.channels)b.visible=I===this.visibleChannelId}createOutputChannel(v,I){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const b=this.doCreateOutputChannel(v,I);return b.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(v,b)}async doCreateOutputChannel(v,I){const b=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(b,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(v,!1,m,I.identifier.value);return new _(g,v,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(v,I){let b=!1;const m=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return v},append(o){m(),I.then(g=>g.append(o))},appendLine(o){m(),I.then(g=>g.appendLine(o))},clear(){m(),I.then(o=>o.clear())},replace(o){m(),I.then(g=>g.replace(o))},show(o,g){m(),I.then(n=>n.show(o,g))},hide(){m(),I.then(o=>o.hide())},dispose(){b=!0,I.then(o=>o.dispose())}}}};p=Be([Fe(0,A.IExtHostRpcService),Fe(1,T.IExtHostInitDataService),Fe(2,y.IExtHostConsumerFileSystem),Fe(3,F.IExtHostFileSystemInfo),Fe(4,D.ILoggerService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(ve[250],be([1,0,13,21,3,6,5,2,7,16,17,47,84]),function(te,e,d,t,k,A,D,P,y,T,F,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(p,c,v){const I=p.getProxy(D.MainContext.MainThreadQuickOpen);class b{constructor(s,l){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=l}showQuickPick(s,l,h=t.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(s),w=++this._instances,R=I.$show(w,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},h),O={},L=R.then(()=>O);return Promise.race([L,u]).then(S=>{if(S!==O)return u.then(U=>{const M=[];for(let X=0;X<U.length;X++){const G=U[X];typeof G=="string"?M.push({label:G,handle:X}):G.kind===y.QuickPickItemKind.Separator?M.push({type:"separator",label:G.label}):M.push({label:G.label,description:G.description,detail:G.detail,picked:G.picked,alwaysShow:G.alwaysShow,handle:X})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=X=>{l.onDidSelectItem(U[X])}),I.$setItems(w,M),R.then(X=>{if(typeof X=="number")return U[X];if(Array.isArray(X))return X.map(G=>U[G])})})}).then(void 0,S=>{if(!(0,T.isCancellationError)(S))return I.$setError(w,S),Promise.reject(S)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,l=t.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,I.$input(s,typeof this._validateInput=="function",l).then(void 0,h=>{if(!(0,T.isCancellationError)(h))return Promise.reject(h)})}$validateInput(s){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,l=t.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!h)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(w=>w.uri.toString()===h.uri.toString())}createQuickPick(s){const l=new a(s,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(s){const l=new i(s,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(s,l){const h=this._sessions.get(s);h&&h._fireDidChangeValue(l)}$onDidAccept(s){const l=this._sessions.get(s);l&&l._fireDidAccept()}$onDidChangeActive(s,l){const h=this._sessions.get(s);h instanceof a&&h._fireDidChangeActive(l)}$onDidChangeSelection(s,l){const h=this._sessions.get(s);h instanceof a&&h._fireDidChangeSelection(l)}$onDidTriggerButton(s,l){const h=this._sessions.get(s);h&&h._fireDidTriggerButton(l)}$onDidTriggerItemButton(s,l,h){const u=this._sessions.get(s);u instanceof a&&u._fireDidTriggerItemButton(l,h)}$onDidHide(s){const l=this._sessions.get(s);l&&l._fireDidHide()}}class m{constructor(s,l){this._extensionId=s,this._onDidDispose=l,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((l,h)=>{const u=l===y.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(u,l)}),this.update({buttons:s.map((l,h)=>({...E(l),tooltip:l.tooltip,handle:l===y.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const l=this._handlesToButtons.get(s);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(s){if(!this._disposed){for(const l of Object.keys(s)){const h=s[l];this._pendingUpdate[l]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}m._nextId=1;function o(r){if(r instanceof y.ThemeIcon)return{id:r.id};const s=n(r),l=g(r);return{dark:typeof s=="string"?P.URI.file(s):s,light:typeof l=="string"?P.URI.file(l):l}}function g(r){return typeof r=="object"&&"light"in r?r.light:r}function n(r){return typeof r=="object"&&"dark"in r?r.dark:r}function E(r){const s=o(r.iconPath);let l,h;return"id"in s?h=f.ThemeIcon.asClassName(s):l=s,{iconPath:l,iconClass:h}}class a extends m{constructor(s,l){super(s.identifier,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((h,u)=>{this._handlesToItems.set(u,h),this._itemsToHandles.set(h,u)});const l=[];for(let h=0;h<s.length;h++){const u=s[h];u.kind===y.QuickPickItemKind.Separator?l.push({type:"separator",label:u.label}):l.push({handle:h,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((w,R)=>({...E(w),tooltip:w.tooltip,handle:R}))})}this.update({items:l})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(s){const l=(0,F.coalesce)(s.map(h=>this._handlesToItems.get(h)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(s){const l=(0,F.coalesce)(s.map(h=>this._handlesToItems.get(h)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}_fireDidTriggerItemButton(s,l){const h=this._handlesToItems.get(s);if(!h||!h.buttons||!h.buttons.length)return;const u=h.buttons[l];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:h})}}class i extends m{constructor(s,l){super(s,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?C.default.Error:C.default.Ignore})}}return new b(c,v)}e.createExtHostQuickOpen=_});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[251],be([1,0,2,3,56,6,13,5,17,99,12,27,84,15,30]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p){"use strict";var c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function I(h){if(h)return typeof h.iconPath=="string"?d.URI.file(h.iconPath):d.URI.isUri(h.iconPath)||f.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function b(h,u){if(!h.iconPath&&!u.iconPath)return 0;if(h.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof h.iconPath=="string"?h.iconPath:d.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,R=typeof u.iconPath=="string"?u.iconPath:d.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,T.comparePaths)(w,R)}function m(h,u){let w=0;if(h.strikeThrough!==u.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==u.faded)return h.faded?1:-1;if(h.tooltip!==u.tooltip)return(h.tooltip||"").localeCompare(u.tooltip||"");if(w=b(h,u),w!==0)return w;if(h.light&&u.light)w=b(h.light,u.light);else{if(h.light)return 1;if(u.light)return-1}if(w!==0)return w;if(h.dark&&u.dark)w=b(h.dark,u.dark);else{if(h.dark)return 1;if(u.dark)return-1}return w}function o(h,u){if(h.command!==u.command)return h.command<u.command?-1:1;if(h.title!==u.title)return h.title<u.title?-1:1;if(h.tooltip!==u.tooltip){if(h.tooltip!==void 0&&u.tooltip!==void 0)return h.tooltip<u.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(h.arguments===u.arguments)return 0;if(h.arguments)if(u.arguments){if(h.arguments.length!==u.arguments.length)return h.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<h.arguments.length;w++){const R=h.arguments[w],O=u.arguments[w];if(R!==O)return R<O?-1:1}return 0}function g(h,u){let w=(0,T.comparePaths)(h.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(h.command&&u.command)w=o(h.command,u.command);else{if(h.command)return 1;if(u.command)return-1}if(w!==0)return w;if(h.decorations&&u.decorations)w=m(h.decorations,u.decorations);else{if(h.decorations)return 1;if(u.decorations)return-1}return w}function n(h,u){for(let w=0;w<h.length;w++)if(h[w]!==u[w])return!1;return!0}function E(h,u){return h.command===u.command&&h.title===u.title&&h.tooltip===u.tooltip&&(h.arguments&&u.arguments?n(h.arguments,u.arguments):h.arguments===u.arguments)}function a(h,u){return(0,y.equals)(h,u,E)}class i{constructor(u,w,R){this._extension=u,this._sourceControlHandle=R,c.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Ke(this,c,w,"f")}get value(){return this._value}set value(u){u=u??"",Te(this,c,"f").$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){Te(this,c,"f").$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(u){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,Te(this,c,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,Te(this,c,"f").$setInputBoxVisibility(this._sourceControlHandle,u))}showValidationMessage(u,w){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Te(this,c,"f").$showValidationMessage(this._sourceControlHandle,u,w)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=i,c=new WeakMap;class r{constructor(u,w,R,O,L){this._proxy=u,this._commands=w,this._sourceControlHandle=R,this._id=O,this._label=L,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,w){const R=this._resourceStatesCommandsMap.get(u);return R?(0,D.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this._resourceStates].sort(g),R=(0,y.sortedDiff)(this._resourceSnapshot,u,g).map(S=>{const U=S.toInsert.map(M=>{const X=this._resourceHandlePool++;this._resourceStatesMap.set(X,M);const G=M.resourceUri;let q;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const ae=new A.DisposableStore;q=this._commands.converter.toInternal(M.command,ae),this._resourceStatesDisposablesMap.set(X,ae)}else this._resourceStatesCommandsMap.set(X,M.command);const B=I(M.decorations),x=M.decorations&&I(M.decorations.light)||B,j=M.decorations&&I(M.decorations.dark)||B,V=[x,j],Z=M.decorations&&M.decorations.tooltip||"",se=M.decorations&&!!M.decorations.strikeThrough,ce=M.decorations&&!!M.decorations.faded,ee=M.contextValue||"";return{rawResource:[X,G,V,Z,se,ce,ee,q],handle:X}});return{start:S.start,deleteCount:S.deleteCount,toInsert:U}}),O=R.map(({start:S,deleteCount:U,toInsert:M})=>[S,U,M.map(X=>X.rawResource)]),L=R.reverse();for(const{start:S,deleteCount:U,toInsert:M}of L){const X=M.map(q=>q.handle),G=this._handlesSnapshot.splice(S,U,...X);for(const q of G)this._resourceStatesMap.delete(q),this._resourceStatesCommandsMap.delete(q),this._resourceStatesDisposablesMap.get(q)?.dispose(),this._resourceStatesDisposablesMap.delete(q)}return this._resourceSnapshot=u,O}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(u,w,R,O,L,S){this._extension=u,this._commands=R,this._id=O,this._label=L,this._rootUri=S,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ke(this,v,w,"f"),this._inputBox=new i(u,Te(this,v,"f"),this.handle),Te(this,v,"f").$registerSourceControl(this.handle,O,L,S)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,Te(this,v,"f").$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,Te(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,Te(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=u;const w=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);Te(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(u){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=u;const w=u!==void 0?{command:this._commands.converter.toInternal(u.command,this._actionButtonDisposables.value),description:u.description}:void 0;Te(this,v,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&a(this._statusBarCommands,u))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=u;const w=(u||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Te(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(u,w){const R=new r(Te(this,v,"f"),this._commands,this.handle,u,w),O=t.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,O),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const u=[],w=[];for(const[R,O]of this.createdResourceGroups){O.dispose();const L=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),L.dispose(),this._groups.delete(R.handle),Te(this,v,"f").$unregisterGroup(this.handle,R.handle)}),u.push([R.handle,R.id,R.label,R.features]);const S=R._takeResourceStateSnapshot();S.length>0&&w.push([R.handle,S]),this._groups.set(R.handle,R)}Te(this,v,"f").$registerGroups(this.handle,u,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(w=>{const R=w._takeResourceStateSnapshot();R.length!==0&&u.push([w.handle,R])}),u.length>0&&Te(this,v,"f").$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),Te(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,s._handlePool=0,Be([(0,k.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),Be([(0,k.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let l=class xi{constructor(u,w,R){this._commands=w,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=u.getProxy(P.MainContext.MainThreadSCM),this._telemetry=u.getProxy(P.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const L=this._sourceControls.get(O.sourceControlHandle);if(!L)return O;const S=L.getResourceGroup(O.groupHandle);return S?S.getResourceState(O.handle):O}else if(O&&O.$mid===4){const L=this._sourceControls.get(O.sourceControlHandle);return L?L.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const L=this._sourceControls.get(O.handle);return L||O}return O}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,w,R,O){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,R,O),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const L=xi._handlePool++,S=new s(u,this._proxy,this._commands,w,R,O);this._sourceControls.set(L,S);const U=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(u.identifier))||[];return U.push(S),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(u.identifier),U),S}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(u.identifier)),R=w&&w[w.length-1];return R&&R.inputBox}$provideOriginalResource(u,w,R){const O=d.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,O.toString());const L=this._sourceControls.get(u);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>L.quickDiffProvider.provideOriginalResource(O,R)).then(S=>S||null)}$onInputBoxValueChange(u,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const R=this._sourceControls.get(u);return R&&R.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,R,O){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,w,R);const L=this._sourceControls.get(u);if(!L)return Promise.resolve(void 0);const S=L.getResourceGroup(w);return S?S.$executeResourceCommand(R,O):Promise.resolve(void 0)}$validateInput(u,w,R){this.logService.trace("ExtHostSCM#$validateInput",u);const O=this._sourceControls.get(u);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>O.inputBox.validateInput(w,R)).then(L=>{if(!L)return Promise.resolve(void 0);const S=_.MarkdownString.fromStrict(L.message);return S?Promise.resolve([S,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this._sourceControls.get(u)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};l._handlePool=0,l=Be([Fe(2,F.ILogService)],l),e.ExtHostSCM=l});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[252],be([1,0,7,5,171,6,15,18]),function(te,e,d,t,k,A,D,P){"use strict";var y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(p,c,v,I,b=d.StatusBarAlignment.Left,m){y.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Ke(this,y,p,"f"),Ke(this,T,c,"f"),this._entryId=F.ID_GEN++,this._extension=v,this._id=I,this._alignment=b,this._priority=this.validatePriority(m)}validatePriority(p){if(!!(0,P.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!F.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:Te(this,T,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:Te(this,T,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let c;this._name?c=this._name:c=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const I=this._tooltip?D.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,y,"f").$setEntry(this._entryId,p,c,this._text,I,this._command?.internal,v,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,y=new WeakMap,T=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class C{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const c={message:p};return this._messages.unshift(c),this._update(),new d.Disposable(()=>{const v=this._messages.indexOf(c);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class f{constructor(p,c){this._proxy=p.getProxy(t.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new C(this)}createStatusBarEntry(p,c,v,I){return new F(this._proxy,this._commands,p,c,v,I)}setStatusBarMessage(p,c){const v=this._statusMessage.setMessage(p);let I;return typeof c=="number"?I=setTimeout(()=>v.dispose(),c):typeof c!="undefined"&&c.then(()=>v.dispose(),()=>v.dispose()),new d.Disposable(()=>{v.dispose(),clearTimeout(I)})}}e.ExtHostStatusBar=f}),define(ve[89],be([1,0,5,3,4]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,y){this._proxy.$registerExtensionStorageKeysToSync(P,y)}initializeExtensionStorage(P,y,T){return this._proxy.$initializeExtensionStorage(P,y).then(F=>F||T)}setValue(P,y,T){return this._proxy.$setValue(P,y,T)}$acceptValue(P,y,T){this._onDidChangeStorage.fire({shared:P,key:y,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(ve[67],be([1,0,4,26,12,66,2]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let P=class{constructor(T,F,C){this._logService=F,this._extHostFileSystem=C,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getWorkspaceStorageURI(T){return D.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,F=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:D.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(T){if(this._value)return D.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return D.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Be([Fe(0,t.IExtHostInitDataService),Fe(1,k.ILogService),Fe(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ve[34],be([1,0,3,5,4,2,14,6,7,172,16,218,21,33,198,84,18,13]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class b{constructor(s,l,h,u){this._proxy=s,this._id=l,this._creationOptions=h,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},get state(){return w._state},sendText(R,O=!0){w._checkDisposed(),w._proxy.$sendText(w._id,R,O)},show(R){w._checkDisposed(),w._proxy.$show(w._id,R)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(s,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:(0,v.withNullAsUndefined)(s.shellPath),shellArgs:(0,v.withNullAsUndefined)(s.shellArgs),cwd:(0,v.withNullAsUndefined)(s.cwd),env:(0,v.withNullAsUndefined)(s.env),icon:(0,v.withNullAsUndefined)(a(s.iconPath)),color:c.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,v.withNullAsUndefined)(s.message),strictEnv:(0,v.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(s.location,l?.resolvedExtHostIdentifier),disablePersistence:(0,v.withNullAsUndefined)(s.disablePersistence)})}async createExtensionTerminal(s,l,h,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:c.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(s,l),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(s,l){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in s?{viewColumn:s.viewColumn,preserveFocus:s.preserveFocus}:void 0:s}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,l){return s===this._cols&&l===this._rows||s===0||l===0?!1:(this._cols=s,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=b;class m{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new d.Emitter,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput?.(s)}resize(s,l){this._pty.setDimensions?.({columns:s,rows:l})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(s||void 0),s&&this._pty.setDimensions?.(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=m;let o=1,g=class extends P.Disposable{constructor(s,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[h,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(s,l){const h=new b(this._proxy,(0,_.generateUuid)(),s,s.name),u=new m(s.pty);return h.createExtensionTerminal(s.location,this._serializeParentTerminal(s,l).resolvedExtHostIdentifier,a(s.iconPath),i(s.color)).then(w=>{const R=this._setupExtHostProcessListeners(w,u);this._terminalProcessDisposables[w]=R}),this._terminals.push(h),h.value}_serializeParentTerminal(s,l){if(l=l||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const h=s.location.parentTerminal;if(h){const u=this._terminals.find(w=>w.value===h);u&&(l.resolvedExtHostIdentifier=u._id)}}else s.location&&typeof s.location!="object"?l.location=s.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(s,l){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const u=new m(l),w=this._setupExtHostProcessListeners(s,u);this._terminalProcessDisposables[s]=w}async $acceptActiveTerminalChanged(s){const l=this._activeTerminal;if(s===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(s);h&&(this._activeTerminal=h,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,l){const h=this._getTerminalById(s);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:l})}async $acceptTerminalDimensions(s,l,h){const u=this._getTerminalById(s);u&&u.setDimensions(l,h)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(s,l,h){this._terminalProcesses.get(s)?.resize(l,h)}async $acceptTerminalTitleChange(s,l){const h=this._getTerminalById(s);h&&(h.name=l)}async $acceptTerminalClosed(s,l){const h=this._getTerminalObjectIndexById(this._terminals,s);if(h!==null){const u=this._terminals.splice(h,1)[0];u.setExitCode(l),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(s,l,h,u){if(l){const O=this._getTerminalObjectIndexById(this._terminals,l);if(O!==null){this._terminals[O]._id=s,this._onDidOpenTerminal.fire(this.terminals[O]),this._terminals[O].isOpen=!0;return}}const w={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:A.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},R=new b(this._proxy,s,w,h);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(s,l){const h=this._getTerminalById(s);h&&h._setProcessId(l)}async $startExtensionTerminal(s,l){const h=this._getTerminalById(s);if(!h)return{message:(0,T.localize)(0,null,s)};h.isOpen||await new Promise(w=>{const R=this.onDidOpenTerminal(async O=>{O===h.value&&(R.dispose(),w())})});const u=this._terminalProcesses.get(s);u?u.startSendingEvents(l):this._extensionTerminalAwaitingStart[s]={initialDimensions:l}}_setupExtHostProcessListeners(s,l){const h=new P.DisposableStore;h.add(l.onProcessReady(w=>this._proxy.$sendProcessReady(s,w.pid,w.cwd))),h.add(l.onDidChangeProperty(w=>this._proxy.$sendProcessProperty(s,w))),this._bufferer.startBuffering(s,l.onProcessData),h.add(l.onProcessExit(w=>this._onProcessExit(s,w))),this._terminalProcesses.set(s,l);const u=this._extensionTerminalAwaitingStart[s];return u&&l instanceof m&&(l.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),h}$acceptProcessAckDataEvent(s,l){this._terminalProcesses.get(s)?.acknowledgeDataEvent(l)}$acceptProcessInput(s,l){this._terminalProcesses.get(s)?.input(l)}$acceptTerminalInteraction(s){const l=this._getTerminalById(s);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(s,l,h){try{this._terminalProcesses.get(s)?.resize(l,h)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(s,l){this._terminalProcesses.get(s)?.shutdown(l)}$acceptProcessRequestInitialCwd(s){this._terminalProcesses.get(s)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(s,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(s){this._terminalProcesses.get(s)?.getCwd().then(l=>this._proxy.$sendProcessProperty(s,{type:"cwd",value:l}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,l,h){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,h),this._proxy.$registerProfileProvider(l,s.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(s,l){const h=new f.CancellationTokenSource().token;let u=await this._profileProviders.get(s)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,l);return}this.createTerminalFromOptions(u.options,l)}}async $provideLinks(s,l){const h=this._getTerminalById(s);if(!h)return[];this._terminalLinkCache.delete(s);const u=this._terminalLinkCancellationSource.get(s);u&&u.dispose(!0);const w=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,w);const R=[],O={terminal:h.value,line:l},L=[];for(const M of this._linkProviders)L.push(I.Promises.withAsyncBody(async X=>{w.token.onCancellationRequested(()=>X({provider:M,links:[]}));const G=await M.provideTerminalLinks(O,w.token)||[];w.token.isCancellationRequested||X({provider:M,links:G})}));const S=await Promise.all(L);if(w.token.isCancellationRequested)return[];const U=new Map;for(const M of S)M&&M.links.length>0&&R.push(...M.links.map(X=>{const G={id:o++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return U.set(G.id,{provider:M.provider,link:X}),G}));return this._terminalLinkCache.set(s,U),R}$activateLink(s,l){const h=this._terminalLinkCache.get(s)?.get(l);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(s,l){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const h=this._terminalProcessDisposables[s];h&&(h.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,l)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,l){const h=this._getTerminalObjectIndexById(s,l);return h!==null?s[h]:null}_getTerminalObjectIndexById(s,l){let h=null;return s.some((u,w)=>u._id===l?(h=w,!0):!1),h}getEnvironmentVariableCollection(s){let l=this._environmentVariableCollections.get(s.identifier.value);return l||(l=new n,this._setEnvironmentVariableCollection(s.identifier.value,l)),l}_syncEnvironmentVariableCollection(s,l){const h=(0,C.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(s,l.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(s){s.forEach(l=>{const h=l[0],u=new n(l[1]);this._setEnvironmentVariableCollection(h,u)})}$acceptDefaultProfile(s,l){this._defaultProfile=s,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(s,l){this._environmentVariableCollections.set(s,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,l)})}};g=Be([Fe(1,D.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class n{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,l){this._setIfDiffers(s,{value:l,type:y.EnvironmentVariableMutatorType.Replace})}append(s,l){this._setIfDiffers(s,{value:l,type:y.EnvironmentVariableMutatorType.Append})}prepend(s,l){this._setIfDiffers(s,{value:l,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,l){const h=this.map.get(s);(!h||h.value!==l.value||h.type!==l.type)&&(this.map.set(s,l),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,l){this.map.forEach((h,u)=>s.call(l,u,h,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=n;let E=class extends g{constructor(s){super(!1,s)}createTerminal(s,l,h){throw new F.NotSupportedError}createTerminalFromOptions(s,l){throw new F.NotSupportedError}};E=Be([Fe(0,D.IExtHostRpcService)],E),e.WorkerExtHostTerminalService=E;function a(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function i(r){return c.ThemeColor.isThemeColor(r)?r:void 0}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[253],be([1,0,17,23,21,3,75,58,6,25,18,33,5,14,63,15,7,224,129,87]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(O,L){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=O.getProxy(f.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new E(this.proxy),L.registerArgumentProcessor({processArgument:S=>S?.$mid===13?c.TestItem.toItemFromContext(S):S})}createTestController(O,L,S){if(this.controllers.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const U=new y.DisposableStore,M=U.add(new I.SingleUseTestCollection(O));M.root.label=L;const X=new Map,G=this.proxy,q={items:M.root.children,get label(){return L},set label(x){L=x,M.root.label=x,G.$updateController(O,{label:L})},get refreshHandler(){return S},set refreshHandler(x){S=x,G.$updateController(O,{canRefresh:!!x})},get id(){return O},createRunProfile:(x,j,V,Z,se)=>{let ce=(0,P.hash)(x);for(;X.has(ce);)ce++;const ee=new u(this.proxy,O,ce,x,j,V,Z,se);return X.set(ce,ee),ee},createTestItem(x,j,V){return new p.TestItemImpl(O,x,j,V)},createTestRun:(x,j,V=!0)=>this.runTracker.createTestRun(O,M,x,j,V),set resolveHandler(x){M.resolveHandler=x},get resolveHandler(){return M.resolveHandler},dispose:()=>{U.dispose()}};G.$registerTestController(O,L,!!S),U.add((0,y.toDisposable)(()=>G.$unregisterTestController(O)));const B={controller:q,collection:M,profiles:X};return this.controllers.set(O,B),U.add((0,y.toDisposable)(()=>this.controllers.delete(O))),U.add(M.onDidGenerateDiff(x=>G.$publishDiff(O,x))),q}createTestObserver(){return this.observer.checkout()}async runTests(O,L=k.CancellationToken.None){const S=a(O);if(!S)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(S.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(M=>M.id)??[U.collection.root.id],profileGroup:w[S.kind],profileId:S.profileId,controllerId:S.controllerId}],exclude:O.exclude?.map(M=>M.id)},L)}$provideFileCoverage(O,L,S){return(0,d.mapFind)(this.runTracker.trackers,M=>M.id===O?M.getCoverage(L):void 0)?.provideFileCoverage(S)??Promise.resolve([])}$resolveFileCoverage(O,L,S,U){return(0,d.mapFind)(this.runTracker.trackers,X=>X.id===O?X.getCoverage(L):void 0)?.resolveFileCoverage(S,U)??Promise.resolve([])}$configureRunProfile(O,L){this.controllers.get(O)?.profiles.get(L)?.configureHandler?.()}async $refreshTests(O,L){await this.controllers.get(O)?.controller.refreshHandler?.(L)}$publishTestResults(O){this.results=Object.freeze(O.map(L=>(0,T.deepFreeze)(c.TestResults.to(L))).concat(this.results).sort((L,S)=>S.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(O,L){const S=this.controllers.get(m.TestId.fromString(O).controllerId)?.collection;S&&(await S.expand(O,L<0?1/0:L),S.flushDiff())}$acceptDiff(O){this.observer.applyDiff(O)}async $runControllerTests(O,L){const S=this.controllers.get(O.controllerId);if(!S)return;const{collection:U,profiles:M}=S,X=M.get(O.profileId);if(!X)return;const G=O.testIds.map(j=>U.tree.get(j)).filter(F.isDefined),q=O.excludeExtIds.map(j=>S.collection.tree.get(j)).filter(F.isDefined).filter(j=>G.some(V=>V.fullId.compare(j.fullId)===2));if(!G.length)return;const B=new v.TestRunRequest(G.some(j=>j.actual instanceof p.TestItemRootImpl)?void 0:G.map(j=>j.actual),q.map(j=>j.actual),X),x=this.runTracker.prepareForMainThreadTestRun(B,i.fromInternal(O,S.collection),L);try{await X.runHandler(B,L)}finally{x.isRunning&&!L.isCancellationRequested&&await A.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(O){O===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(O)}};g=Be([Fe(0,_.IExtHostRpcService)],g),e.ExtHostTesting=g;class n extends y.Disposable{constructor(O,L,S){super();this.dto=O,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new k.CancellationTokenSource(S)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:U}of this.tasks.values())U.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(O){return this.tasks.get(O)?.coverage}createRun(O){const L=this.dto.id,S=this.dto.controllerId,U=(0,C.generateUuid)(),M=new r(this.proxy,L,U),X=x=>(j,...V)=>{if(q){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),x(j,...V))},G=(x,j)=>{const V=j instanceof Array?j.map(c.TestMessage.from):[c.TestMessage.from(j)];if(x.uri&&x.range){const Z={range:c.Range.from(x.range),uri:x.uri};for(const se of V)se.location=se.location||Z}this.proxy.$appendTestMessagesInRun(L,U,m.TestId.fromExtHostTestItem(x,S).toString(),V)};let q=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:O,get coverageProvider(){return M.coverageProvider},set coverageProvider(x){M.coverageProvider=x},enqueued:X(x=>{this.proxy.$updateTestStateInRun(L,U,m.TestId.fromExtHostTestItem(x,S).toString(),1)}),skipped:X(x=>{this.proxy.$updateTestStateInRun(L,U,m.TestId.fromExtHostTestItem(x,S).toString(),5)}),started:X(x=>{this.proxy.$updateTestStateInRun(L,U,m.TestId.fromExtHostTestItem(x,S).toString(),2)}),errored:X((x,j,V)=>{G(x,j),this.proxy.$updateTestStateInRun(L,U,m.TestId.fromExtHostTestItem(x,S).toString(),6,V)}),failed:X((x,j,V)=>{G(x,j),this.proxy.$updateTestStateInRun(L,U,m.TestId.fromExtHostTestItem(x,S).toString(),4,V)}),passed:X((x,j)=>{this.proxy.$updateTestStateInRun(L,U,m.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,j)}),appendOutput:(x,j,V)=>{q||(V&&(this.dto.isIncluded(V)?this.ensureTestIsKnown(V):V=void 0),this.proxy.$appendOutputToRun(L,U,t.VSBuffer.fromString(x),j&&c.location.from(j),V&&m.TestId.fromExtHostTestItem(V,S).toString()))},end:()=>{q||(q=!0,this.proxy.$finishedTestRunTask(L,U),this.tasks.delete(U),this.isRunning||this.dispose())}};return this.tasks.set(U,{run:B,coverage:M}),this.proxy.$startedTestRunTask(L,{id:U,name:O,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(O){if(!(O instanceof p.TestItemImpl))throw new p.InvalidTestItemError(O.id);if(this.sharedTestIds.has(m.TestId.fromExtHostTestItem(O,this.dto.controllerId).toString()))return;const L=[],S=this.dto.colllection.root;for(;;){const U=c.TestItem.from(O);if(L.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),O===S))break;O=O.parent||S}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class E{constructor(O){this.proxy=O,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(O,L,S){return this.getTracker(O,L,S)}cancelRunById(O){for(const L of this.tracked.values())if(L.id===O){L.dispose();return}}cancelAllRuns(){for(const O of this.tracked.values())O.dispose()}createTestRun(O,L,S,U,M){const X=this.tracked.get(S);if(X)return X.createRun(U);const G=i.fromPublic(O,L,S,M),q=a(S);this.proxy.$startedExtensionTestRun({controllerId:O,profile:q&&{group:w[q.kind],id:q.profileId},exclude:S.exclude?.map(x=>x.id)??[],id:G.id,include:S.include?.map(x=>x.id)??[L.root.id],persist:M});const B=this.getTracker(S,G);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(G.id)),B.createRun(U)}getTracker(O,L,S){const U=new n(L,this.proxy,S);return this.tracked.set(O,U),U.onEnd(()=>this.tracked.delete(O)),U}}e.TestRunCoordinator=E;const a=R=>{if(!!R.profile){if(!(R.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class i{constructor(O,L,S,U,M,X){this.controllerId=O,this.id=L,this.isPersisted=M,this.colllection=X,this.includePrefix=S.map(G=>G+"\0"),this.excludePrefix=U.map(G=>G+"\0")}static fromPublic(O,L,S,U){return new i(O,(0,C.generateUuid)(),S.include?.map(M=>m.TestId.fromExtHostTestItem(M,O).toString())??[O],S.exclude?.map(M=>m.TestId.fromExtHostTestItem(M,O).toString())??[],U,L)}static fromInternal(O,L){return new i(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,L)}isIncluded(O){const L=m.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const S of this.excludePrefix)if(L===S||L.startsWith(S))return!1;for(const S of this.includePrefix)if(L===S||L.startsWith(S))return!0;return!1}}e.TestRunDto=i;class r{constructor(O,L,S){this.proxy=O,this.runId=L,this.taskId=S}set coverageProvider(O){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this._coverageProvider=O,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(O){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(O))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(O,L){const S=await this.fileCoverage;let U=S?.[O];return!this._coverageProvider||!S||!U?[]:(U.detailedCoverage||(U=S[O]=await this._coverageProvider.resolveFileCoverage?.(U,L)??U),U.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class s extends b.IncrementalChangeCollector{constructor(O){super();this.emitter=O,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(O){this.added.add(O)}update(O){Object.assign(O.revived,c.TestItem.toPlain(O.item)),this.added.has(O)||this.updated.add(O)}remove(O){if(this.added.has(O)){this.added.delete(O);return}if(this.updated.delete(O),O.parent&&this.alreadyRemoved.has(O.parent)){this.alreadyRemoved.add(O.item.extId);return}this.removed.add(O)}getChangeEvent(){const{added:O,updated:L,removed:S}=this;return{get added(){return[...O].map(U=>U.revived)},get updated(){return[...L].map(U=>U.revived)},get removed(){return[...S].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(O){return this.items.get(O)}getMirroredTestDataByReference(O){return this.items.get(O.id)}createItem(O,L){return{...O,revived:c.TestItem.toPlain(O.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new s(this.changeEmitter)}}e.MirroredTestCollection=l;class h{constructor(O){this.proxy=O}checkout(){this.current||(this.current=this.createObserverData());const O=this.current;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(L=>L.revived)},dispose:(0,D.once)(()=>{--O.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(O){return this.current?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.current?.tests.apply(O)}createObserverData(){const O=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:O}}}class u{constructor(O,L,S,U,M,X,G=!1,q=void 0){this.controllerId=L,this.profileId=S,this._label=U,this.kind=M,this.runHandler=X,this._isDefault=G,this._tag=q,o.set(this,void 0),Ke(this,o,O,"f");const B=w[M];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${M}`);Te(this,o,"f").$publishTestRunProfile({profileId:S,controllerId:L,tag:q?c.TestTag.namespace(this.controllerId,q.id):null,label:U,group:B,isDefault:G,hasConfigurationHandler:!1})}get label(){return this._label}set label(O){O!==this._label&&(this._label=O,Te(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get isDefault(){return this._isDefault}set isDefault(O){O!==this._isDefault&&(this._isDefault=O,Te(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Te(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?c.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(O){O!==this._configureHandler&&(this._configureHandler=O,Te(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}dispose(){Te(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,o=new WeakMap;const w={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(ve[254],be([1,0,3,17,5,132,15,7]),function(te,e,d,t,k,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(F,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(f=>this._onDidChangeVisibleTextEditors.fire(f)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(f=>this._onDidChangeActiveTextEditor.fire(f))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const C=this._extHostDocumentsAndEditors.allEditors();return F?C:C.map(f=>f.value)}async showTextDocument(F,C,f){let _;typeof C=="number"?_={position:D.ViewColumn.from(C),preserveFocus:f}:typeof C=="object"?_={position:D.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?D.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:_={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(F.uri,_),c=p&&this._extHostDocumentsAndEditors.getEditor(p);if(c)return c.value;throw p?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,C){return new A.TextEditorDecorationType(this._proxy,F,C).value}$acceptEditorPropertiesChanged(F,C){const f=this._extHostDocumentsAndEditors.getEditor(F);if(!f)throw new Error("unknown text editor");if(C.options&&f._acceptOptions(C.options),C.selections){const _=C.selections.selections.map(D.Selection.to);f._acceptSelections(_)}if(C.visibleRanges){const _=t.coalesce(C.visibleRanges.map(D.Range.to));f._acceptVisibleRanges(_)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:f.value,options:{...C.options,lineNumbers:D.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const _=P.TextEditorSelectionChangeKind.fromValue(C.selections.source),p=C.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:f.value,selections:p,kind:_})}if(C.visibleRanges){const _=t.coalesce(C.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:f.value,visibleRanges:_})}}$acceptEditorPositionData(F){for(const C in F){const f=this._extHostDocumentsAndEditors.getEditor(C);if(!f)throw new Error("Unknown text editor");const _=D.ViewColumn.to(F[C]);f.value.viewColumn!==_&&(f._acceptViewColumn(_),this._onDidChangeTextEditorViewColumn.fire({textEditor:f.value,viewColumn:_}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=y}),define(ve[255],be([1,0,2,4,5,6,7]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class P{constructor(F,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(k.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const _=f.uri===void 0?void 0:d.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(y(_))?.get(f.handle)}return f}})}async $getTimeline(F,C,f,_,p){return this._providers.get(F)?.provideTimeline(d.URI.revive(C),f,_,p)}registerTimelineProvider(F,C,f,_){const p=new A.DisposableStore,c=this.convertTimelineItem(C.id,_,p).bind(this);let v;C.onDidChange&&(v=C.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:C.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:F,onDidChange:void 0,async provideTimeline(b,m,o,g){g?.resetCache&&(p.clear(),I.get(C.id)?.clear());const n=await C.provideTimeline(b,m,o);if(n==null)return;const E=c(b,g);return{...n,source:C.id,items:n.items.map(E)}},dispose(){for(const b of I.values())b.get(C.id)?.clear();v?.dispose(),p.dispose()}})}convertTimelineItem(F,C,f){return(_,p)=>{let c;if(p?.cacheResults){let v=this._itemsBySourceAndUriMap.get(F);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(F,v));const I=y(_);c=v.get(I),c===void 0&&(c=new Map,v.set(I,c))}return v=>{const{iconPath:I,...b}=v,m=`${F}|${v.id??v.timestamp}`;c?.set(m,v);let o,g,n;return v.iconPath&&(I instanceof D.ThemeIcon?n={id:I.id,color:I.color}:d.URI.isUri(I)?(o=I,g=I):{light:o,dark:g}=I),{...b,id:b.id??void 0,handle:m,source:F,command:v.command?C.toInternal(v.command,f):void 0,icon:o,iconDark:g,themeIcon:n,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,A.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=P;function y(T){return T?.toString()}}),define(ve[256],be([1,0,6,10,2,5]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,T,F,C){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const f=C.schemes.find(_=>!D.supportedSchemes.has(_));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,F),this._proxy.$registerUriOpener(T,C.schemes,y,C.label),(0,d.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(y,T,F){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const f=k.URI.revive(T);return C.canOpenExternalUri(f,F)}async $openUri(y,T,F){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(k.URI.revive(T.resolvedUri),{sourceUri:k.URI.revive(T.sourceUri)},F)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(ve[257],be([1,0,5,2,6,16,27]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(T,F){if(this.handles.has(D.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const C=P.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(T)),this.handlers.set(C,F),this._proxy.$registerUriHandler(C,T),(0,k.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(T)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(T,F){const C=this.handlers.get(T);if(!C)return Promise.resolve(void 0);try{C.handleUri(t.URI.revive(F))}catch(f){(0,A.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(T){return t.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=P,P.HandlePool=0});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[68],be([1,0,3,10,2,185,207,86,5]),function(te,e,d,t,k,A,D,P,y){"use strict";var T,F,C,f,_,p,c,v,I,b,m,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(h,u,w,R,O,L,S){T.set(this,void 0),F.set(this,void 0),C.set(this,void 0),f.set(this,void 0),_.set(this,void 0),p.set(this,void 0),c.set(this,""),v.set(this,void 0),I.set(this,!1),b.set(this,!1),m.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new d.Emitter),this._onDidDispose=Te(this,o,"f").event,Ke(this,T,h,"f"),Ke(this,F,u,"f"),Ke(this,v,w,"f"),Ke(this,f,R,"f"),Ke(this,_,O,"f"),Ke(this,p,L,"f"),Ke(this,m,n(L),"f"),Ke(this,C,S,"f")}dispose(){Ke(this,I,!0,"f"),Te(this,o,"f").fire(),Te(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return Ke(this,b,!0,"f"),(0,P.asWebviewUri)(h,Te(this,f,"f").remote)}get cspSource(){const h=Te(this,p,"f").extensionLocation;if(h.scheme===t.Schemas.https||h.scheme===t.Schemas.http){let u=h.toString();return u.endsWith("/")||(u+="/"),u+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,c,"f")}set html(h){this.assertNotDisposed(),Te(this,c,"f")!==h&&(Ke(this,c,h,"f"),!Te(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(Ke(this,b,!0,"f"),Te(this,C,"f").report("Webview vscode-resource: uris",Te(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,F,"f").$setHtml(Te(this,T,"f"),h))}get options(){return this.assertNotDisposed(),Te(this,v,"f")}set options(h){this.assertNotDisposed(),Te(this,F,"f").$setOptions(Te(this,T,"f"),i(Te(this,p,"f"),Te(this,_,"f"),h)),Ke(this,v,h,"f")}async postMessage(h){if(Te(this,I,"f"))return!1;const u=(0,D.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Te(this,m,"f")});return Te(this,F,"f").$postMessage(Te(this,T,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Te(this,I,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,T=new WeakMap,F=new WeakMap,C=new WeakMap,f=new WeakMap,_=new WeakMap,p=new WeakMap,c=new WeakMap,v=new WeakMap,I=new WeakMap,b=new WeakMap,m=new WeakMap,o=new WeakMap;function n(l){try{const h=(0,A.normalizeVersion)((0,A.parseVersion)(l.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class E{constructor(h,u,w,R,O){this.initData=u,this.workspace=w,this._logService=R,this._deprecationService=O,this._webviews=new Map,this._webviewProxy=h.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(h,u,w){const R=this.getWebview(h);if(R){const{message:O}=(0,D.deserializeWebviewMessage)(u,w.value);R._onMessageEmitter.fire(O)}}$onMissingCsp(h,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,u,w){const R=new g(h,this._webviewProxy,r(u),this.initData,this.workspace,w,this._deprecationService);return this._webviews.set(h,R),R._onDidDispose(()=>{this._webviews.delete(h)}),R}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=E;function a(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=a;function i(l,h,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||s(l,h)}}e.serializeWebviewOptions=i;function r(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(h=>k.URI.from(h))}}e.reviveOptions=r;function s(l,h){return[...(h?.getWorkspaceFolders()||[]).map(u=>u.uri),l.extensionLocation]}}),define(ve[258],be([1,0,21,58,6,10,22,2,15,68,85,5,7]),function(te,e,d,t,k,A,D,P,y,T,F,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class _{constructor(n,E){this.document=n,this._storagePath=E,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,E){await this.getEdit(n).undo(),E||this.disposeBackup()}async redo(n,E){await this.getEdit(n).redo(),E||this.disposeBackup()}disposeEdits(n){for(const E of n)this._edits.delete(E)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=o(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const E=this._edits.get(n,0);if(!E)throw new Error("No edit found");return E}}class p{constructor(){this._documents=new Map}get(n,E){return this._documents.get(this.key(n,E))}add(n,E,a){const i=this.key(n,E.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${n} resource:${E.uri}`);const r=new _(E,a);return this._documents.set(i,r),r}delete(n,E){const a=this.key(n,E.uri);this._documents.delete(a)}key(n,E){return`${n}@@@${E}`}}var c;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(c||(c={}));class v{constructor(){this._providers=new Map}addTextProvider(n,E,a){return this.add(0,n,E,a)}addCustomProvider(n,E,a){return this.add(1,n,E,a)}get(n){return this._providers.get(n)}add(n,E,a,i){if(this._providers.has(E))throw new Error(`Provider for viewType:${E} already registered`);return this._providers.set(E,{type:n,extension:a,provider:i}),new f.Disposable(()=>this._providers.delete(E))}}class I{constructor(n,E,a,i,r){this._extHostDocuments=E,this._extensionStoragePaths=a,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new v,this._documents=new p,this._proxy=n.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,E,a,i){const r=new k.DisposableStore;return b(a)?(r.add(this._editorProviders.addTextProvider(E,n,a)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(n),E,i.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(n))):(r.add(this._editorProviders.addCustomProvider(E,n,a)),this.supportEditing(a)&&r.add(a.onDidChangeCustomDocument(s=>{const l=this.getCustomDocumentEntry(E,s.document.uri);if(m(s)){const h=l.addEdit(s);this._proxy.$onDidEdit(s.document.uri,E,h,s.label)}else this._proxy.$onContentChange(s.document.uri,E)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(n),E,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(n))),f.Disposable.from(r,new f.Disposable(()=>{this._proxy.$unregisterEditorProvider(E)}))}async $createCustomDocument(n,E,a,i,r){const s=this._editorProviders.get(E);if(!s)throw new Error(`No provider found for '${E}'`);if(s.type!==1)throw new Error(`Invalid provide type for '${E}'`);const l=P.URI.revive(n),h=await s.provider.openCustomDocument(l,{backupId:a,untitledDocumentData:i?.buffer},r);let u;return this.supportEditing(s.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(s.extension)??this._extensionStoragePaths.globalValue(s.extension)),this._documents.add(E,h,u),{editable:this.supportEditing(s.provider)}}async $disposeCustomDocument(n,E){const a=this._editorProviders.get(E);if(!a)throw new Error(`No provider found for '${E}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${E}'`);const i=P.URI.revive(n),{document:r}=this.getCustomDocumentEntry(E,i);this._documents.delete(E,r),r.dispose()}async $resolveWebviewEditor(n,E,a,i,r,s){const l=this._editorProviders.get(a);if(!l)throw new Error(`No provider found for '${a}'`);const h=y.ViewColumn.to(r),u=this._extHostWebview.createNewWebview(E,i.webviewOptions,l.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(E,a,i.title,h,i.panelOptions,u),R=P.URI.revive(n);switch(l.type){case 1:{const{document:O}=this.getCustomDocumentEntry(a,R);return l.provider.resolveCustomEditor(O,w,s)}case 0:{const O=this._extHostDocuments.getDocument(R);return l.provider.resolveCustomTextEditor(O,w,s)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,E,a){this.getCustomDocumentEntry(E,n).disposeEdits(a)}async $onMoveCustomEditor(n,E,a){const i=this._editorProviders.get(a);if(!i)throw new Error(`No provider found for '${a}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const r=this._extHostWebviewPanels.getWebviewPanel(n);if(!r)throw new Error("No webview found");const s=P.URI.revive(E),l=this._extHostDocuments.getDocument(s);await i.provider.moveCustomTextEditor(l,r,d.CancellationToken.None)}async $undo(n,E,a,i){return this.getCustomDocumentEntry(E,n).undo(a,i)}async $redo(n,E,a,i){return this.getCustomDocumentEntry(E,n).redo(a,i)}async $revert(n,E,a){const i=this.getCustomDocumentEntry(E,n);await this.getCustomEditorProvider(E).revertCustomDocument(i.document,a),i.disposeBackup()}async $onSave(n,E,a){const i=this.getCustomDocumentEntry(E,n);await this.getCustomEditorProvider(E).saveCustomDocument(i.document,a),i.disposeBackup()}async $onSaveAs(n,E,a,i){const r=this.getCustomDocumentEntry(E,n);return this.getCustomEditorProvider(E).saveCustomDocumentAs(r.document,P.URI.revive(a),i)}async $backup(n,E,a){const i=this.getCustomDocumentEntry(E,n),s=await this.getCustomEditorProvider(E).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},a);return i.updateBackup(s),s.id}getCustomDocumentEntry(n,E){const a=this._documents.get(n,P.URI.revive(E));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(n){const a=this._editorProviders.get(n)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function b(g){return typeof g.resolveCustomTextEditor=="function"}function m(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function o(g){const n=g.scheme===A.Schemas.file||g.scheme===A.Schemas.untitled?g.fsPath:g.toString();return(0,t.hash)(n)+""}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[259],be([1,0,3,6,2,33,15,68,5,7]),function(te,e,d,t,k,A,D,P,y,T){"use strict";var F,C,f,_,p,c,v,I,b,m,o,g,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class E extends t.Disposable{constructor(s,l,h,u,w,R,O){super();F.set(this,void 0),C.set(this,void 0),f.set(this,void 0),_.set(this,void 0),p.set(this,void 0),c.set(this,void 0),v.set(this,void 0),I.set(this,void 0),b.set(this,!0),m.set(this,!0),o.set(this,!1),g.set(this,this._register(new d.Emitter)),this.onDidDispose=Te(this,g,"f").event,n.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Te(this,n,"f").event,Ke(this,F,s,"f"),Ke(this,C,l,"f"),Ke(this,f,h,"f"),Ke(this,p,R,"f"),Ke(this,I,w,"f"),Ke(this,c,u,"f"),Ke(this,_,O,"f")}dispose(){Te(this,o,"f")||(Ke(this,o,!0,"f"),Te(this,g,"f").fire(),Te(this,C,"f").$disposeWebview(Te(this,F,"f")),Te(this,_,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,_,"f")}get viewType(){return this.assertNotDisposed(),Te(this,f,"f")}get title(){return this.assertNotDisposed(),Te(this,c,"f")}set title(s){this.assertNotDisposed(),Te(this,c,"f")!==s&&(Ke(this,c,s,"f"),Te(this,C,"f").$setTitle(Te(this,F,"f"),s))}get iconPath(){return this.assertNotDisposed(),Te(this,v,"f")}set iconPath(s){this.assertNotDisposed(),Te(this,v,"f")!==s&&(Ke(this,v,s,"f"),Te(this,C,"f").$setIconPath(Te(this,F,"f"),k.URI.isUri(s)?{light:s,dark:s}:s))}get options(){return Te(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,I,"f")=="number"&&Te(this,I,"f")<0))return Te(this,I,"f")}get active(){return this.assertNotDisposed(),Te(this,m,"f")}get visible(){return this.assertNotDisposed(),Te(this,b,"f")}_updateViewState(s){Te(this,o,"f")||(this.active!==s.active||this.visible!==s.visible||this.viewColumn!==s.viewColumn)&&(Ke(this,m,s.active,"f"),Ke(this,b,s.visible,"f"),Ke(this,I,s.viewColumn,"f"),Te(this,n,"f").fire({webviewPanel:this}))}reveal(s,l){this.assertNotDisposed(),Te(this,C,"f").$reveal(Te(this,F,"f"),{viewColumn:typeof s=="undefined"?void 0:D.ViewColumn.from(s),preserveFocus:!!l})}assertNotDisposed(){if(Te(this,o,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,C=new WeakMap,f=new WeakMap,_=new WeakMap,p=new WeakMap,c=new WeakMap,v=new WeakMap,I=new WeakMap,b=new WeakMap,m=new WeakMap,o=new WeakMap,g=new WeakMap,n=new WeakMap;class a{constructor(s,l,h){this.webviews=l,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=s.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(s,l,h,u,w={}){const R=typeof u=="object"?u.viewColumn:u,O={viewColumn:D.ViewColumn.from(R),preserveFocus:typeof u=="object"&&!!u.preserveFocus},L=(0,P.shouldSerializeBuffersForPostMessage)(s),S=a.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(s),S,l,{title:h,panelOptions:i(w),webviewOptions:(0,P.serializeWebviewOptions)(s,this.workspace,w),serializeBuffersForPostMessage:L},O);const U=this.webviews.createNewWebview(S,w,s);return this.createNewWebviewPanel(S,l,h,R,w,U)}$onDidChangeWebviewPanelViewStates(s){const l=Object.keys(s);l.sort((h,u)=>{const w=s[h],R=s[u];return w.active?1:R.active?-1:+w.visible-+R.visible});for(const h of l){const u=this.getWebviewPanel(h);if(!u)continue;const w=s[h];u._updateViewState({active:w.active,visible:w.visible,viewColumn:D.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(s){this.getWebviewPanel(s)?.dispose(),this._webviewPanels.delete(s),this.webviews.deleteWebview(s)}registerWebviewPanelSerializer(s,l,h){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:h,extension:s}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(s)}),new T.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(s,l,h,u){const w=this._serializers.get(l);if(!w)throw new Error(`No serializer found for '${l}'`);const{serializer:R,extension:O}=w,L=this.webviews.createNewWebview(s,h.webviewOptions,O),S=this.createNewWebviewPanel(s,l,h.title,u,h.panelOptions,L);await R.deserializeWebviewPanel(S,h.state)}createNewWebviewPanel(s,l,h,u,w,R){const O=new E(s,this._proxy,l,h,u,w,R);return this._webviewPanels.set(s,O),O}getWebviewPanel(s){return this._webviewPanels.get(s)}}e.ExtHostWebviewPanels=a;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[260],be([1,0,3,6,68,5,7]),function(te,e,d,t,k,A,D){"use strict";var P,y,T,F,C,f,_,p,c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends t.Disposable{constructor(o,g,n,E,a,i){super();P.set(this,void 0),y.set(this,void 0),T.set(this,void 0),F.set(this,void 0),C.set(this,!1),f.set(this,void 0),_.set(this,void 0),p.set(this,void 0),c.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Te(this,c,"f").event,v.set(this,this._register(new d.Emitter)),this.onDidDispose=Te(this,v,"f").event,Ke(this,T,n,"f"),Ke(this,_,E,"f"),Ke(this,P,o,"f"),Ke(this,y,g,"f"),Ke(this,F,a,"f"),Ke(this,f,i,"f")}dispose(){Te(this,C,"f")||(Ke(this,C,!0,"f"),Te(this,v,"f").fire(),Te(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,_,"f")}set title(o){this.assertNotDisposed(),Te(this,_,"f")!==o&&(Ke(this,_,o,"f"),Te(this,y,"f").$setWebviewViewTitle(Te(this,P,"f"),o))}get description(){return this.assertNotDisposed(),Te(this,p,"f")}set description(o){this.assertNotDisposed(),Te(this,p,"f")!==o&&(Ke(this,p,o,"f"),Te(this,y,"f").$setWebviewViewDescription(Te(this,P,"f"),o))}get visible(){return Te(this,f,"f")}get webview(){return Te(this,F,"f")}get viewType(){return Te(this,T,"f")}_setVisible(o){o===Te(this,f,"f")||Te(this,C,"f")||(Ke(this,f,o,"f"),Te(this,c,"f").fire())}show(o){this.assertNotDisposed(),Te(this,y,"f").$show(Te(this,P,"f"),!!o)}assertNotDisposed(){if(Te(this,C,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,y=new WeakMap,T=new WeakMap,F=new WeakMap,C=new WeakMap,f=new WeakMap,_=new WeakMap,p=new WeakMap,c=new WeakMap,v=new WeakMap;class b{constructor(o,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,g,n,E){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:n,extension:o}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(o),g,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new D.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(o,g,n,E,a){const i=this._viewProviders.get(g);if(!i)throw new Error(`No view provider found for '${g}'`);const{provider:r,extension:s}=i,l=this._extHostWebview.createNewWebview(o,{},s),h=new I(o,this._proxy,g,n,l,!0);this._webviewViews.set(o,h),await r.resolveWebviewView(h,{state:E},a)}async $onDidChangeWebviewViewVisibility(o,g){this.getWebviewView(o)._setVisible(g)}async $disposeWebviewView(o){const g=this.getWebviewView(o);this._webviewViews.delete(o),g.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const g=this._webviewViews.get(o);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=b}),define(ve[137],be([1,0,3,5,2,10,8,4,14]),function(te,e,d,t,k,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Vi{constructor(C){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Vi.InitialState,this._proxy=C.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,f){let _;if(typeof C=="string"){_=C;try{C=k.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,D.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,_,f)}async asExternalUri(C,f){if((0,D.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const _=await this._proxy.$asExternalUri(C,f);return k.URI.from(_)}};T.InitialState={focused:!0},T=Be([Fe(0,y.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ve[261],be([1,0,9,80,33,38,6,5,2,14]),function(te,e,d,t,k,A,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let F=class extends D.Disposable{constructor(f,_){super();const p=f.getProxy(P.MainContext.MainThreadDownloadService);_.registerCommand(!1,"_workbench.downloadResource",async c=>{const v=y.URI.file((0,d.join)((0,t.tmpdir)(),(0,k.generateUuid)()));return await p.$download(c,v),v})}};F=Be([Fe(0,T.IExtHostRpcService),Fe(1,A.IExtHostCommands)],F),e.ExtHostDownloadService=F}),define(ve[262],be([1,0,135,10,191,33]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class D extends d.ExtHostLoggerService{doCreateLogger(y,T,F){return y.scheme===t.Schemas.file?new k.SpdLogLogger(F?.name||(0,A.generateUuid)(),y.fsPath,!F?.donotRotate,!!F?.donotUseFormatters,T):super.doCreateLogger(y,T,F)}}e.ExtHostLoggerService=D}),define(ve[263],be([1,0,60,9,2,67,6,10,13,29]),function(te,e,d,t,k,A,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class F extends A.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const E=await super._getWorkspaceStorageURI(n);if(E.scheme!==P.Schemas.file)return E;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${E.fsPath}.`),E;const a=E.fsPath;let i=0;do{let r;i===0?r=a:r=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${i}`:`${a}-${i}`,await C(r);const s=t.join(r,"vscode.lock"),l=await c(this._logService,s,!1);if(l)return this._workspaceStorageLock=l,process.on("exit",()=>{l.dispose()}),k.URI.file(r);i++}while(i<10);return E}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=F;async function C(g){try{await T.Promises.stat(g);return}catch{}try{await T.Promises.mkdir(g,{recursive:!0})}catch{}}const f=1e3,_=10*60*1e3;class p extends D.Disposable{constructor(n,E){super();this.logService=n,this.filename=E,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const a=await v(n,E);(!a||a.pid!==process.pid)&&(n.info(`Lock '${E}': The lock was lost unexpectedly.`),this._timer.cancel());try{await T.Promises.utimes(E,new Date,new Date)}catch(i){n.error(i),n.info(`Lock '${E}': Could not update mtime.`)}},f)}dispose(){super.dispose();try{d.unlinkSync(this.filename)}catch{}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const E={pid:process.pid,willReleaseAt:Date.now()+n};await T.Promises.writeFile(this.filename,JSON.stringify(E),{flag:"w"})}catch(E){this.logService.error(E)}}}async function c(g,n,E){try{const i={pid:process.pid,willReleaseAt:0};await T.Promises.writeFile(n,JSON.stringify(i),{flag:"wx"})}catch(i){g.error(i)}const a=await v(g,n);return!a||a.pid!==process.pid?E?(g.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),m(g,n)):(g.info(`Lock '${n}': Lock acquired.`),new p(g,n))}async function v(g,n){let E;try{E=await T.Promises.readFile(n)}catch(a){return g.error(a),null}try{return JSON.parse(String(E))}catch(a){return g.error(a),null}}async function I(g,n){let E;try{E=await T.Promises.stat(n)}catch(a){return g.error(a),0}return E.mtime.getTime()}function b(g){try{return process.kill(g,0),!0}catch{return!1}}async function m(g,n){const E=await v(g,n);if(!E)return g.info(`Lock '${n}': Could not read pid of lock holder.`),o(g,n);if(E.willReleaseAt){let l=E.willReleaseAt-Date.now();if(l<5e3){for(l>0?g.info(`Lock '${n}': The lockfile is scheduled to be released in ${l} ms.`):g.info(`Lock '${n}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,y.timeout)(Math.min(100,l)),await I(g,n)===0)return o(g,n);l=E.willReleaseAt-Date.now()}return o(g,n)}}if(!b(E.pid))return g.info(`Lock '${n}': The pid ${E.pid} appears to be gone.`),o(g,n);const a=await I(g,n),i=Date.now()-a;if(i<=_)return g.info(`Lock '${n}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;g.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const r=await I(g,n),s=Date.now()-r;return s<=_?(g.info(`Lock '${n}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null):(g.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),o(g,n))}async function o(g,n){g.info(`Lock '${n}': Deleting a stale lock.`);try{await T.Promises.unlink(n)}catch{}return c(g,n,!0)}}),define(ve[264],be([1,0,33,14,34]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends k.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,y,T){return this.createTerminalFromOptions({name:P,shellPath:y,shellArgs:T})}createTerminalFromOptions(P,y){const T=new k.ExtHostTerminal(this._proxy,(0,d.generateUuid)(),P,P.name);return this._terminals.push(T),T.create(P,this._serializeParentTerminal(P,y)),T.value}};A=Be([Fe(0,t.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(ve[265],be([1,0,5,14,176,6,26,2,37,22,29,7,11,51,3,123,93,12]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(h,u,w){this.remoteAddress=h,this.localAddress=u,this._dispose=w,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function m(l){const h=l.trim().split(`
`),u=[];return h.forEach(R=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);O&&O.length>=3&&u.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),u.reduce((R,O)=>(R[O.socket]=O,R),{})}e.getSockets=m;function o(...l){const h=[].concat(...l.map(n));return[...new Map(h.filter(u=>u.st==="0A").map(u=>{const w=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:g(w[0]),port:parseInt(w[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=o;function g(l){let h="";if(l.length===8)for(let u=l.length-2;u>=0;u-=2)h+=parseInt(l.substr(u,2),16),u!==0&&(h+=".");else for(let u=l.length-4;u>=0;u-=4)h+=parseInt(l.substr(u,4),16).toString(16),u!==0&&(h+=":");return h}e.parseIpAddress=g;function n(l){const h=l.trim().split(`
`),u=h.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return h.map(R=>R.trim().split(/\s+/).reduce((O,L,S)=>(O[u[S]||S]=L,O),{}))}e.loadConnectionTable=n;function E(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/server-main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function a(l){const h=l.trim().split(`
`),u=[];return h.forEach(w=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);R&&R.length>=4&&u.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),u}e.getRootProcesses=a;async function i(l,h,u){const w=u.reduce((O,L)=>(O[L.pid]=L,O),{}),R=[];return l.forEach(({socket:O,ip:L,port:S})=>{const U=h[O]?h[O].pid:void 0,M=U?w[U]?.cmd:void 0;U&&M&&!E(M)&&R.push({host:L,port:S,detail:M,pid:U})}),R}e.findPorts=i;function r(l,h,u){const w=new Map,R=a(h);for(const O of l){const L=u.get(O.port);if(L){w.set(O.port,L);continue}const S=R.find(U=>U.cmd.includes(`${O.port}`));if(S){let U=S,M;do M=R.find(X=>X.ppid===U.pid),M&&(U=M);while(M);w.set(O.port,{host:O.ip,port:O.port,pid:U.pid,detail:U.cmd,ppid:U.ppid})}else w.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=r;let s=class extends A.Disposable{constructor(h,u,w){super();this.logService=w,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(d.MainContext.MainThreadTunnelService),f.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const w=await this._proxy.$openTunnel(u,h.displayName);if(w){const R=new b(w.remoteAddress,w.localAddress,()=>this._proxy.$closeTunnel(w.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,u){const w=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(w,{selector:h,provider:u}),this._proxy.$registerPortsAttributesProvider(h,w),new C.Disposable(()=>{this._portAttributesProviders.delete(w),this._proxy.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(h,u,w,R,O){const L=[];for(const U of h){const M=this._portAttributesProviders.get(U);if(!M)return[];L.push(...await Promise.all(u.map(async X=>M.provider.providePortAttributes(X,w,R,O))))}const S=L.filter(U=>!!U);return S.length>0?S.map(U=>({autoForwardAction:U.autoForwardAction,port:U.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let u=new v.MovingAverage,w;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),O=(await this.findCandidatePorts()).filter(S=>(0,c.isLocalhost)(S.host)||(0,c.isAllInterfaces)(S.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(S=>S.port).join(", ")}`);const L=new Date().getTime()-R;u.update(L),(!w||JSON.stringify(w)!==JSON.stringify(O))&&(w=O,await this._proxy.$onFoundNewCandidates(w)),await new Promise(S=>setTimeout(()=>S(),this.calculateDelay(u.value)))}}async setTunnelFactory(h){if(h){if(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory){this._forwardPortProvider=h.tunnelFactory;let u=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]);const w=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:u}:void 0;this._proxy.$setTunnelProvider(w)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,u){if(this._extensionTunnels.has(h.host)){const w=this._extensionTunnels.get(h.host);w.has(h.port)&&(u&&w.get(h.port).disposeListener.dispose(),await w.get(h.port).tunnel.dispose(),w.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this._forwardPortProvider(h,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const R=await w;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const O=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:R,disposeListener:O}),_.TunnelDto.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const u=await Promise.all(h.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),w=h.filter((R,O)=>u[O]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(R=>R.port).join(", ")} to ${w.map(R=>R.port).join(", ")}`),w}async findCandidatePorts(){let h="",u="";try{h=await F.Promises.readFile("/proc/net/tcp","utf8"),u=await F.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=o(h,u),R=await new Promise(q=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,x,j)=>{q(x)})}),O=m(R),L=await F.Promises.readdir("/proc"),S=[];for(let q of L)try{const B=Number(q),x=T.joinPath(P.URI.file("/proc"),q);if((await F.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(B)){const V=await F.Promises.readlink(T.joinPath(x,"cwd").fsPath),Z=await F.Promises.readFile(T.joinPath(x,"cmdline").fsPath,"utf8");S.push({pid:B,cwd:V,cmd:Z})}}catch{}const U=[],M=w.filter(q=>{const B=O[q.socket];return B||U.push(q),B}),X=i(M,O,S);let G;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${U.length}`),U.length>0){const q=await new Promise(B=>{(0,y.exec)("ps -F -A -l | grep root",(x,j,V)=>{B(j)})});this._foundRootPorts=r(U,q,this._foundRootPorts),G=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${G.join(", ")}`)}return X.then(q=>G?q.concat(G):q)}};s=Be([Fe(0,t.IExtHostRpcService),Fe(1,D.IExtHostInitDataService),Fe(2,I.ILogService)],s),e.ExtHostTunnelService=s}),define(ve[266],be([1,0,13,23,21,16,3,6,102,229,52]),function(te,e,d,t,k,A,D,P,y,T,F){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(w,R){try{return JSON.stringify(w,R)}catch{return"null"}}const _="$$ref$$",p={[_]:-1};class c{constructor(R,O){this.jsonString=R,this.referencedBuffers=O}}function v(w,R=null,O=!1){const L=[];return{jsonString:(O?f:JSON.stringify)(w,(U,M)=>{if(typeof M=="undefined")return p;if(typeof M=="object"){if(M instanceof t.VSBuffer){const X=L.push(M)-1;return{[_]:X}}if(R)return R(U,M)}return M}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=v;function I(w,R,O){return JSON.parse(w,(L,S)=>{if(S){const U=S[_];if(typeof U=="number")return R[U];if(O&&S.$mid===1)return O.transformIncoming(S)}return S})}e.parseJsonAndRestoreBufferRefs=I;function b(w,R){return JSON.stringify(w,R)}function m(w){return w?(R,O)=>O&&O.$mid===1?w.transformOutgoing(O):O:null}var o;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},E=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class i extends P.Disposable{constructor(R,O=null,L=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=O,this._uriTransformer=L,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,U=F.ProxyIdentifier.count;S<U;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,y.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:O,sid:L}=R;return this._proxies[O]||(this._proxies[O]=this._createProxy(O,L)),this._proxies[O]}_createProxy(R,O){let L={get:(S,U)=>(typeof U=="string"&&!S[U]&&U.charCodeAt(0)===36&&(S[U]=(...M)=>this._remoteCall(R,U,M)),U===a?O:S[U])};return new Proxy(Object.create(null),L)}set(R,O){return this._locals[R.nid]=O,O}assertRegistered(R){for(let O=0,L=R.length;O<L;O++){const S=R[O];if(!this._locals[S.nid])throw new Error(`Missing proxy instance ${S.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const O=R.byteLength,L=r.read(R,0),S=L.readUInt8(),U=L.readUInt32();switch(S){case 1:case 2:{let{rpcId:M,method:X,args:G}=l.deserializeRequestJSONArgs(L);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(O,U,M,X,G,S===2);break}case 3:case 4:{let{rpcId:M,method:X,args:G}=l.deserializeRequestMixedArgs(L);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(O,U,M,X,G,S===4);break}case 5:{this._logger&&this._logger.logIncoming(O,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(O,U);break}case 7:{this._receiveReply(O,U,void 0);break}case 9:{let M=l.deserializeReplyOKJSON(L);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(O,U,M);break}case 10:{const M=l.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(O,U,M);break}case 8:{let M=l.deserializeReplyOKVSBuffer(L);this._receiveReply(O,U,M);break}case 11:{let M=l.deserializeReplyErrError(L);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(O,U,M);break}case 12:{this._receiveReplyErr(O,U,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,O,L,S,U,M){this._logger&&this._logger.logIncoming(R,O,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(L)}.${S}(`,U);const X=String(O);let G,q;if(M){const x=new k.CancellationTokenSource;U.push(x.token),G=this._invokeHandler(L,S,U),q=()=>x.cancel()}else G=this._invokeHandler(L,S,U),q=n;this._cancelInvokedHandlers[X]=q;const B=l.serializeAcknowledged(O);this._logger&&this._logger.logOutgoing(B.byteLength,O,1,"ack"),this._protocol.send(B),G.then(x=>{delete this._cancelInvokedHandlers[X];const j=l.serializeReplyOK(O,x,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,O,1,"reply:",x),this._protocol.send(j)},x=>{delete this._cancelInvokedHandlers[X];const j=l.serializeReplyErr(O,x);this._logger&&this._logger.logOutgoing(j.byteLength,O,1,"replyErr:",x),this._protocol.send(j)})}_receiveCancel(R,O){this._logger&&this._logger.logIncoming(R,O,1,"receiveCancel");const L=String(O);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(R,O,L){this._logger&&this._logger.logIncoming(R,O,0,"receiveReply:",L);const S=String(O);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const U=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],U.resolveOk(L)}_receiveReplyErr(R,O,L){this._logger&&this._logger.logIncoming(R,O,0,"receiveReplyErr:",L);const S=String(O);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const U=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let M;L&&(L.$isError?(M=new Error,M.name=L.name,M.message=L.message,M.stack=L.stack):M=L),U.resolveErr(M)}_invokeHandler(R,O,L){try{return Promise.resolve(this._doInvokeHandler(R,O,L))}catch(S){return Promise.reject(S)}}_doInvokeHandler(R,O,L){const S=this._locals[R];if(!S)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(R));let U=S[O];if(typeof U!="function")throw new Error("Unknown method "+O+" on actor "+(0,F.getStringIdentifierForProxy)(R));return U.apply(S,L)}_remoteCall(R,O,L){if(this._isDisposed)return Promise.reject(A.canceled());let S=null;if(L.length>0&&k.CancellationToken.isCancellationToken(L[L.length-1])&&(S=L.pop()),S&&S.isCancellationRequested)return Promise.reject(A.canceled());const U=l.serializeRequestArguments(L,this._uriReplacer),M=++this._lastMessageId,X=String(M),G=new T.LazyPromise;S&&S.onCancellationRequested(()=>{const B=l.serializeCancel(M);this._logger&&this._logger.logOutgoing(B.byteLength,M,0,"cancel"),this._protocol.send(l.serializeCancel(M))}),this._pendingRPCReplies[X]=G,this._onWillSendRequest(M);const q=l.serializeRequest(M,R,O,U,!!S);return this._logger&&this._logger.logOutgoing(q.byteLength,M,0,`request: ${(0,F.getStringIdentifierForProxy)(R)}.${O}(`,L),this._protocol.send(q),G}}e.RPCProtocol=i,C=E,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(R,O){this._buff=R,this._offset=O}static alloc(R,O,L){let S=new r(t.VSBuffer.alloc(L+1+4),0);return S.writeUInt8(R),S.writeUInt32(O),S}static read(R,O){return new r(R,O)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,L}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,L}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,O}static sizeMixedArray(R){let O=0;O+=1;for(let L=0,S=R.length;L<S;L++){const U=R[L];switch(O+=1,U.type){case 1:O+=this.sizeLongString(U.value);break;case 2:O+=this.sizeVSBuffer(U.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(U.value);for(let M=0;M<U.buffers.length;++M)O+=this.sizeVSBuffer(U.buffers[M]);break;case 4:break}}return O}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let O=0,L=R.length;O<L;O++){const S=R[O];switch(S.type){case 1:this.writeUInt8(1),this.writeLongString(S.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(S.value);break;case 3:this.writeUInt8(3),this.writeUInt32(S.buffers.length),this.writeLongString(S.value);for(let U=0;U<S.buffers.length;++U)this.writeBuffer(S.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let O=new Array(R);for(let L=0;L<R;L++)switch(this.readUInt8()){case 1:O[L]=this.readLongString();break;case 2:O[L]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),M=this.readLongString(),X=[];for(let G=0;G<U;++G)X.push(this.readVSBuffer());O[L]=new F.SerializableObjectWithBuffers(I(M,X,null));break}case 4:O[L]=void 0;break}return O}}r.sizeUInt32=4;var s;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(s||(s={}));class l{static _useMixedArgSerialization(R){for(let O=0,L=R.length;O<L;O++)if(R[O]instanceof t.VSBuffer||R[O]instanceof F.SerializableObjectWithBuffers||typeof R[O]=="undefined")return!0;return!1}static serializeRequestArguments(R,O){if(this._useMixedArgSerialization(R)){const L=[];for(let S=0,U=R.length;S<U;S++){const M=R[S];if(M instanceof t.VSBuffer)L[S]={type:2,value:M};else if(typeof M=="undefined")L[S]={type:4};else if(M instanceof F.SerializableObjectWithBuffers){const{jsonString:X,referencedBuffers:G}=v(M.value,O);L[S]={type:3,value:t.VSBuffer.fromString(X),buffers:G}}else L[S]={type:1,value:t.VSBuffer.fromString(b(M,O))}}return{type:1,args:L}}return{type:0,args:b(R,O)}}static serializeRequest(R,O,L,S,U){switch(S.type){case 0:return this._requestJSONArgs(R,O,L,S.args,U);case 1:return this._requestMixedArgs(R,O,L,S.args,U)}}static _requestJSONArgs(R,O,L,S,U){const M=t.VSBuffer.fromString(L),X=t.VSBuffer.fromString(S);let G=0;G+=r.sizeUInt8(),G+=r.sizeShortString(M),G+=r.sizeLongString(X);let q=r.alloc(U?2:1,R,G);return q.writeUInt8(O),q.writeShortString(M),q.writeLongString(X),q.buffer}static deserializeRequestJSONArgs(R){const O=R.readUInt8(),L=R.readShortString(),S=R.readLongString();return{rpcId:O,method:L,args:JSON.parse(S)}}static _requestMixedArgs(R,O,L,S,U){const M=t.VSBuffer.fromString(L);let X=0;X+=r.sizeUInt8(),X+=r.sizeShortString(M),X+=r.sizeMixedArray(S);let G=r.alloc(U?4:3,R,X);return G.writeUInt8(O),G.writeShortString(M),G.writeMixedArray(S),G.buffer}static deserializeRequestMixedArgs(R){const O=R.readUInt8(),L=R.readShortString(),S=R.readMixedArray(),U=new Array(S.length);for(let M=0,X=S.length;M<X;M++){const G=S[M];typeof G=="string"?U[M]=JSON.parse(G):U[M]=G}return{rpcId:O,method:L,args:U}}static serializeAcknowledged(R){return r.alloc(5,R,0).buffer}static serializeCancel(R){return r.alloc(6,R,0).buffer}static serializeReplyOK(R,O,L){if(typeof O=="undefined")return this._serializeReplyOKEmpty(R);if(O instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(R,O);if(O instanceof F.SerializableObjectWithBuffers){const{jsonString:S,referencedBuffers:U}=v(O.value,L,!0);return this._serializeReplyOKJSONWithBuffers(R,S,U)}else return this._serializeReplyOKJSON(R,f(O,L))}static _serializeReplyOKEmpty(R){return r.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,O){let L=0;L+=r.sizeVSBuffer(O);let S=r.alloc(8,R,L);return S.writeVSBuffer(O),S.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,O){const L=t.VSBuffer.fromString(O);let S=0;S+=r.sizeLongString(L);let U=r.alloc(9,R,S);return U.writeLongString(L),U.buffer}static _serializeReplyOKJSONWithBuffers(R,O,L){const S=t.VSBuffer.fromString(O);let U=0;U+=r.sizeUInt32,U+=r.sizeLongString(S);for(const X of L)U+=r.sizeVSBuffer(X);let M=r.alloc(10,R,U);M.writeUInt32(L.length),M.writeLongString(S);for(const X of L)M.writeBuffer(X);return M.buffer}static deserializeReplyOKJSON(R){const O=R.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(R,O){const L=R.readUInt32(),S=R.readLongString(),U=[];for(let M=0;M<L;++M)U.push(R.readVSBuffer());return new F.SerializableObjectWithBuffers(I(S,U,O))}static serializeReplyErr(R,O){return O?this._serializeReplyErrEror(R,O):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,O){const L=t.VSBuffer.fromString(f(A.transformErrorForSerialization(O),null));let S=0;S+=r.sizeLongString(L);let U=r.alloc(11,R,S);return U.writeLongString(L),U.buffer}static deserializeReplyErrError(R){const O=R.readLongString();return JSON.parse(O)}static _serializeReplyErrEmpty(R){return r.alloc(12,R,0).buffer}}var h;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var u;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(u||(u={}))}),define(ve[267],be([1,0,4]),function(te,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(ve[268],be([1,0,28,10,9,11,22,2,4,200,43,225,267]),function(te,e,d,t,k,A,D,P,y,T,F,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let _=class ji{constructor(c,v,I,b){this.localUserHome=c,this.remoteAgentService=v,this.environmentService=I,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const m=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=m?.userHome||c})()}hasValidBasename(c,v,I){return typeof v=="string"||typeof v=="undefined"?this.resolveOS.then(b=>this.doHasValidBasename(c,b,v)):this.doHasValidBasename(c,v,I)}doHasValidBasename(c,v,I){return c.scheme===t.Schemas.file||c.scheme===t.Schemas.vscodeRemote?(0,d.isValidBasename)(I??(0,D.basename)(c),v===1):!0}get defaultUriScheme(){return ji.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(c,v){if(c.remoteAuthority)return t.Schemas.vscodeRemote;const I=(0,T.getVirtualWorkspaceScheme)(v.getWorkspace());if(I)return I;const b=v.getWorkspace().folders[0];if(b)return b.uri.scheme;const m=v.getWorkspace().configuration;return m?m.scheme:t.Schemas.file}async userHome(c){return c?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(c=>c===1?k.win32:k.posix)}async fileURI(c){let v="";if(await this.resolveOS===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const b=c.indexOf("/",2);b===-1?(v=c.substring(2),c="/"):(v=c.substring(2,b),c=c.substring(b)||"/")}return P.URI.from({scheme:t.Schemas.file,authority:v,path:c,query:"",fragment:""})}};_=Be([Fe(1,f.IRemoteAgentService),Fe(2,C.IWorkbenchEnvironmentService),Fe(3,F.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(ve[69],be([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(D,P){this.line=D,this.character=P}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,P){return new d(0,0)}with(D){return new d(0,0)}}e.Position=d;class t{constructor(D,P,y,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(D,P),this.end=new d(y,T)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new t(0,0,0,0)}with(D){return new t(0,0,0,0)}}e.Range=t;var k;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[31],be([1,0,17,32,25,28,8,4,9,16,69,13]),function(te,e,d,t,k,A,D,P,y,T,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",_=" characters skipped \u27EB",p=(f.length+_.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var c;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function I(B){return!!B.preview}e.resultIsMatch=I;function b(B){return!!B.resource}e.isFileMatch=b;function m(B){return!!B.message}e.isProgressMessage=m;var o;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(x){this.resource=x,this.results=[]}}e.FileMatch=g;class n{constructor(x,j,V){this.ranges=j;const Z=Array.isArray(j)?j:[j];if(V&&V.matchLines===1&&E(Z)){x=(0,D.getNLines)(x,V.matchLines);let se="",ce=0,ee=0;const Y=Math.floor(V.charsPerLine/5),ae=[];for(const he of Z){const we=Math.max(he.startColumn-Y,0),ke=he.startColumn+V.charsPerLine;if(we>ee+Y+p){const Ne=f+(we-ee)+_;se+=Ne+x.slice(we,ke),ce+=we-(ee+Ne.length)}else se+=x.slice(ee,ke);ae.push(new i(0,he.startColumn-ce,he.endColumn-ce)),ee=ke}this.preview={text:se,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const se=Array.isArray(j)?j[0].startLineNumber:j.startLineNumber;this.preview={text:x,matches:(0,d.mapArrayOrNot)(j,ce=>new a(ce.startLineNumber-se,ce.startColumn,ce.endLineNumber-se,ce.endColumn))}}}}e.TextSearchMatch=n;function E(B){const x=B[0].startLineNumber;for(const j of B)if(j.startLineNumber!==x||j.endLineNumber!==x)return!1;return!0}class a{constructor(x,j,V,Z){this.startLineNumber=x,this.startColumn=j,this.endLineNumber=V,this.endColumn=Z}}e.SearchRange=a;class i extends a{constructor(x,j,V){super(x,j,x,V)}}e.OneLineRange=i;var r;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function s(B,x=!0){const j=B&&B.files&&B.files.exclude,V=x&&B&&B.search&&B.search.exclude;if(!j&&!V)return;if(!j||!V)return j||V;let Z=Object.create(null);return Z=k.mixin(Z,k.deepClone(j)),Z=k.mixin(Z,k.deepClone(V),!0),Z}e.getExcludes=s;function l(B,x){return B.excludePattern&&t.match(B.excludePattern,x)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&t.match(B.includePattern,x)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(j=>{const V=j.folder.fsPath;if(A.isEqualOrParent(x,V)){const Z=y.relative(V,x);return!j.includePattern||!!t.match(j.includePattern,Z)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var h;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(x,j){super(x);this.code=j}}e.SearchError=u;function w(B){const x=B.message;if((0,T.isCancellationError)(B))return new u(x,h.canceled);try{const j=JSON.parse(x);return new u(j.message,j.code)}catch{return new u(x,h.other)}}e.deserializeSearchError=w;function R(B){const x={message:B.message,code:B.code};return new Error(JSON.stringify(x))}e.serializeSearchError=R;function O(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=O;function L(B){return B.type==="success"}e.isSerializedSearchSuccess=L;function S(B){return!!B.path}e.isSerializedFileMatch=S;function U(B,x){const j=B.searchPath?B.searchPath:B.relativePath;return(0,D.fuzzyContains)(j,x)}e.isFilePatternMatch=U;class M{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function X(B,x){const j={...B||{},...x||{}};return Object.keys(j).filter(V=>{const Z=j[V];return typeof Z=="boolean"&&Z})}e.resolvePatternsForProvider=X;class G{constructor(x,j){this._parsedIncludeExpression=null,this._excludeExpression={...x.excludePattern||{},...j.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let V=x.includePattern;j.includePattern&&(V?V={...V,...j.includePattern}:V=j.includePattern),V&&(this._parsedIncludeExpression=t.parse(V))}matchesExcludesSync(x,j,V){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,j,V))}includedInQuerySync(x,j,V){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,j,V)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(x,j,V))}includedInQuery(x,j,V){const Z=this._parsedExcludeExpression(x,j,V),se=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(x,j,V):!0;return(0,C.isThenable)(Z)?Z.then(ce=>ce?!1:se()):se()}hasSiblingExcludeClauses(){return q(this._excludeExpression)}}e.QueryGlobTester=G;function q(B){for(const x in B)if(typeof B[x]!="boolean")return!0;return!1}}),define(ve[35],be([1,0,17,13,21,3,24,10,93,22,8,18,2,174,4,12,192,43,44,26,14,15,7,31,5]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m,o,g,n,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(O,L,S){return new T.ExtUri(U=>h(U,S)).isEqual(O,L)}function r(O,L,S){return i(O.uri,L.uri,S)?0:(0,F.compare)(O.uri.toString(),L.uri.toString())}function s(O,L,S){return O.index!==L.index?O.index<L.index?-1:1:i(O.uri,L.uri,S)?(0,F.compare)(O.name,L.name):(0,F.compare)(O.uri.toString(),L.uri.toString())}function l(O,L,S,U){const M=O.slice(0).sort((G,q)=>S(G,q,U)),X=L.slice(0).sort((G,q)=>S(G,q,U));return(0,d.delta)(M,X,(G,q)=>S(G,q,U))}function h(O,L){const S=L.getCapabilities(O.scheme);return!(S&&S&1024)}class u extends I.Workspace{constructor(L,S,U,M,X,G,q){super(L,U.map(B=>new I.WorkspaceFolder(B)),M,X,q);this._name=S,this._isUntitled=G,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(q),U.forEach(B=>{this._workspaceFolders.push(B),this._structure.set(B.uri,B)})}static toExtHostWorkspace(L,S,U,M){if(!L)return{workspace:null,added:[],removed:[]};const{id:X,name:G,folders:q,configuration:B,transient:x,isUntitled:j}=L,V=[],Z=S;S?q.forEach((Y,ae)=>{const he=f.URI.revive(Y.uri),we=u._findFolder(U||S,he,M);we?(we.name=Y.name,we.index=Y.index,V.push(we)):V.push({uri:he,name:Y.name,index:ae})}):V.push(...q.map(({uri:Y,name:ae,index:he})=>({uri:f.URI.revive(Y),name:ae,index:he}))),V.sort((Y,ae)=>Y.index<ae.index?-1:1);const se=new u(X,G,V,!!x,B?f.URI.revive(B):null,!!j,Y=>h(Y,M)),{added:ce,removed:ee}=l(Z?Z.workspaceFolders:[],se.workspaceFolders,r,M);return{workspace:se,added:ce,removed:ee}}static _findFolder(L,S,U){for(let M=0;M<L.folders.length;M++){const X=L.workspaceFolders[M];if(i(X.uri,S,U))return X}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,S){return S&&this._structure.get(L)&&(L=(0,T.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let w=class{constructor(L,S,U,M){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=U,this._requestIdProvider=new y.Counter,this._barrier=new t.Barrier,this._proxy=L.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(a.MainContext.MainThreadMessageService);const X=S.workspace;this._confirmedWorkspace=X?new u(X.id,X.name,[],!!X.transient,X.configuration?f.URI.revive(X.configuration):null,!!X.isUntitled,G=>h(G,U)):void 0}$initializeWorkspace(L,S){this._trusted=S,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?f.URI.from({scheme:P.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,S,U,...M){const X=[];if(Array.isArray(M)&&M.forEach(j=>{f.URI.isUri(j.uri)&&!X.some(V=>i(V.uri,j.uri,this._extHostFileSystemInfo))&&X.push({uri:j.uri,name:j.name||(0,T.basenameOrAuthority)(j.uri)})}),this._unconfirmedWorkspace||[S,U].some(j=>typeof j!="number"||j<0)||U===0&&X.length===0)return!1;const G=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(S+U>G.length)return!1;const q=G.slice(0);q.splice(S,U,...X.map(j=>({uri:j.uri,name:j.name||(0,T.basenameOrAuthority)(j.uri),index:void 0})));for(let j=0;j<q.length;j++){const V=q[j];if(q.some((Z,se)=>se!==j&&i(V.uri,Z.uri,this._extHostFileSystemInfo)))return!1}q.forEach((j,V)=>j.index=V);const{added:B,removed:x}=l(G,q,s,this._extHostFileSystemInfo);if(B.length===0&&x.length===0)return!1;if(this._proxy){const j=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(j,S,U,X).then(void 0,V=>{this._unconfirmedWorkspace=void 0;const Z={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(v.Severity.Error,(0,_.localize)(0,null,j,V.toString()),Z,[])})}return this.trySetWorkspaceFolders(q),!0}getWorkspaceFolder(L,S){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,S)}async getWorkspaceFolder2(L,S){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,S)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,S){let U,M="";if(typeof L=="string"?(U=f.URI.file(L),M=L):typeof L!="undefined"&&(U=L,M=L.fsPath),!U)return M;const X=this.getWorkspaceFolder(U,!0);if(!X)return M;typeof S=="undefined"&&this._actualWorkspace&&(S=this._actualWorkspace.folders.length>1);let G=(0,T.relativePath)(X.uri,U);return S&&X.name&&(G=`${X.name}/${G}`),G}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=u.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:S,added:U,removed:M}=u.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=S||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:M}))}findFiles(L,S,U,M,X=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let G;if(S===null?G=!1:S&&(typeof S=="string"?G=S:G=S.pattern),X&&X.isCancellationRequested)return Promise.resolve([]);const{includePattern:q,folder:B}=R(g.GlobPattern.from(L));return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(q),(0,C.withUndefinedAsNull)(B),(0,C.withUndefinedAsNull)(G),(0,C.withUndefinedAsNull)(U),X).then(x=>Array.isArray(x)?x.map(j=>f.URI.revive(j)):[])}async findTextInFiles(L,S,U,M,X=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const G=this._requestIdProvider.getNext(),q=typeof S.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:S.previewOptions,{includePattern:B,folder:x}=R(g.GlobPattern.from(S.include)),j=typeof S.exclude=="string"?S.exclude:S.exclude?S.exclude.pattern:void 0,V={ignoreSymlinks:typeof S.followSymlinks=="boolean"?!S.followSymlinks:void 0,disregardIgnoreFiles:typeof S.useIgnoreFiles=="boolean"?!S.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof S.useGlobalIgnoreFiles=="boolean"?!S.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof S.useParentIgnoreFiles=="boolean"?!S.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof S.useDefaultExcludes=="boolean"?!S.useDefaultExcludes:!0,fileEncoding:S.encoding,maxResults:S.maxResults,previewOptions:q,afterContext:S.afterContext,beforeContext:S.beforeContext,includePattern:B,excludePattern:j},Z=!1;if(this._activeSearchCallbacks[G]=se=>{if(Z)return;const ce=f.URI.revive(se.resource);se.results.forEach(ee=>{(0,E.resultIsMatch)(ee)?U({uri:ce,preview:{text:ee.preview.text,matches:(0,d.mapArrayOrNot)(ee.preview.matches,Y=>new n.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))},ranges:(0,d.mapArrayOrNot)(ee.ranges,Y=>new n.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))}):U({uri:ce,text:ee.text,lineNumber:ee.lineNumber})})},X.isCancellationRequested)return{};try{const se=await this._proxy.$startTextSearch(L,(0,C.withUndefinedAsNull)(x),V,G,X);return delete this._activeSearchCallbacks[G],se||{}}catch(se){throw delete this._activeSearchCallbacks[G],se}}$handleTextSearchResult(L,S){this._activeSearchCallbacks[S]&&this._activeSearchCallbacks[S](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};w=Be([Fe(0,o.IExtHostRpcService),Fe(1,m.IExtHostInitDataService),Fe(2,b.IExtHostFileSystemInfo),Fe(3,c.ILogService)],w),e.ExtHostWorkspace=w,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function R(O){let L,S;return O&&(typeof O=="string"?L=O:(L=O.pattern,S=f.URI.revive(O.baseUri))),{includePattern:L,folder:S}}}),define(ve[36],be([1,0,25,3,35,5,7,195,120,18,13,4,14,12,2]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(E,a){if(a){const i=a.split(".");let r=E;for(let s=0;r&&s<i.length;s++)r=r[i[s]];return r}}function v(E){return E instanceof p.URI}function I(E){return E&&E.uri instanceof p.URI&&E.languageId&&typeof E.languageId=="string"}function b(E){return E&&!E.uri&&E.languageId&&typeof E.languageId=="string"}function m(E){return E&&E.uri instanceof p.URI&&(!E.name||typeof E.name=="string")&&(!E.index||typeof E.index=="number")}function o(E){if(v(E))return{resource:E};if(I(E))return{resource:E.uri,overrideIdentifier:E.languageId};if(b(E))return{overrideIdentifier:E.languageId};if(m(E))return{resource:E.uri};if(E===null)return{resource:null}}let g=class{constructor(a,i,r){this._proxy=a.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new n(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(a,i))}};g=Be([Fe(0,f.IExtHostRpcService),Fe(1,k.IExtHostWorkspace),Fe(2,_.ILogService)],g),e.ExtHostConfiguration=g;class n{constructor(a,i,r,s){this._onDidChangeConfiguration=new t.Emitter,this._proxy=a,this._logService=s,this._extHostWorkspace=i,this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(a,i,r){const s=o(i)||{},l=this._toReadonlyValue(a?c(this._configuration.getValue(void 0,s,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,s,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,s,r?.identifier);function h(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(w){return typeof c(l,w)!="undefined"},get:(w,R)=>{this._validateConfigurationAccess(a?`${a}.${w}`:w,s,r?.identifier);let O=c(l,w);if(typeof O=="undefined")O=R;else{let L;const S=(U,M)=>{let X;const G=()=>{L=L||(0,d.deepClone)(l),X=X||c(L,M)};return(0,T.isObject)(U)?new Proxy(U,{get:(q,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return G(),()=>X;if(L)return X=X||c(L,M),X[B];const x=q[B];return typeof B=="string"?S(x,`${M}.${B}`):x},set:(q,B,x)=>(G(),X&&(X[B]=x),!0),deleteProperty:(q,B)=>(G(),X&&delete X[B],!0),defineProperty:(q,B,x)=>(G(),X&&Object.defineProperty(X,B,x),!0)}):U};O=S(O,w)}return O},update:(w,R,O,L)=>{w=a?`${a}.${w}`:w;const S=h(O);return R!==void 0?this._proxy.$updateConfigurationOption(S,w,R,s,L):this._proxy.$removeConfigurationOption(S,w,s,L)},inspect:w=>{w=a?`${a}.${w}`:w;const R=(0,d.deepClone)(this._configuration.inspect(w,s,this._extHostWorkspace.workspace));if(R)return{key:w,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof l=="object"&&(0,d.mixin)(u,l,!1),Object.freeze(u)}_toReadonlyValue(a){const i=r=>(0,T.isObject)(r)?new Proxy(r,{get:(s,l)=>i(s[l]),set:(s,l,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(s,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(s,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:s=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(a)}_validateConfigurationAccess(a,i,r){const s=y.OVERRIDE_PROPERTY_REGEX.test(a)?4:this._configurationScopes.get(a),l=r?`[${r.value}] `:"";if(s===4){typeof i?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(s===3){i?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,i){const r=new P.ConfigurationChangeEvent(a,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(s,l)=>r.affectsConfiguration(s,o(l))})}_toMap(a){return a.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[70],be([1,0,2,13,3,5,7,35,45,36,21,34,14,26,4,10,11,12,65,217,16]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m,o){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function(M){function X(q){if(q!=null)return q}M.from=X;function G(q){if(q!=null)return q}M.to=G})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var E;(function(M){function X(q){if(q!=null)return q}M.from=X;function G(q){if(q!=null)return q}M.to=G})(E=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(M){function X(q){if(q!=null)return q}M.from=X;function G(q){if(q!=null)return q}M.to=G})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(M){function X(B){if(B){const x=B;return x&&!!x.process}else return!1}M.is=X;function G(B){if(B==null)return;const x={process:B.process,args:B.args};return B.options&&(x.options=a.from(B.options)),x}M.from=G;function q(B){if(B!=null)return new D.ProcessExecution(B.process,B.args,B.options)}M.to=q})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(M){function X(q){if(q!=null)return q}M.from=X;function G(q){if(q!=null)return q}M.to=G})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var s;(function(M){function X(B){if(B){const x=B;return x&&(!!x.commandLine||!!x.command)}else return!1}M.is=X;function G(B){if(B==null)return;const x={};return B.commandLine!==void 0?x.commandLine=B.commandLine:(x.command=B.command,x.args=B.args),B.options&&(x.options=r.from(B.options)),x}M.from=G;function q(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new D.ShellExecution(B.commandLine,B.options):new D.ShellExecution(B.command,B.args?B.args:[],B.options)}M.to=q})(s=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function(M){function X(B){if(B){let x=B;return x&&x.customExecution==="customExecution"}else return!1}M.is=X;function G(B){return{customExecution:"customExecution"}}M.from=G;function q(B,x){return x.get(B)}M.to=q})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(M){function X(G,q){let B;return G.scope!==void 0&&typeof G.scope!="number"?B=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===D.TaskScope.Workspace&&q&&q.workspaceFile?B=q.workspaceFile:B=m.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:B}}M.from=X})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(M){function X(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}M.from=X})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(M){function X(B,x){if(B==null)return[];const j=[];for(let V of B){const Z=G(V,x);Z&&j.push(Z)}return j}M.fromMany=X;function G(B,x){if(B==null)return;let j;B.execution instanceof D.ProcessExecution?j=i.from(B.execution):B.execution instanceof D.ShellExecution?j=s.from(B.execution):B.execution&&B.execution instanceof D.CustomExecution&&(j=l.from(B.execution));const V=n.from(B.definition);let Z;return B.scope?typeof B.scope=="number"?Z=B.scope:Z=B.scope.uri:Z=D.TaskScope.Workspace,!V||!Z?void 0:{_id:B._id,definition:V,name:B.name,source:{extensionId:x.identifier.value,label:B.source,scope:Z},execution:j,isBackground:B.isBackground,group:u.from(B.group),presentationOptions:E.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}M.from=G;async function q(B,x,j){if(B==null)return;let V;i.is(B.execution)?V=i.to(B.execution):s.is(B.execution)?V=s.to(B.execution):l.is(B.execution)&&(V=l.to(B._id,j));const Z=n.to(B.definition);let se;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?se=B.source.scope:se=await x.resolveWorkspaceFolder(d.URI.revive(B.source.scope)):se=D.TaskScope.Workspace),!Z||!se)return;const ce=new D.Task(Z,se,B.name,B.source.label,V,B.problemMatchers);return B.isBackground!==void 0&&(ce.isBackground=B.isBackground),B.group!==void 0&&(ce.group=D.TaskGroup.from(B.group._id),ce.group&&B.group.isDefault&&(ce.group=new D.TaskGroup(ce.group.id,ce.group.label),B.group.isDefault&&(ce.group.isDefault=B.group.isDefault))),B.presentationOptions&&(ce.presentationOptions=E.to(B.presentationOptions)),B._id&&(ce._id=B._id),B.detail&&(ce.detail=B.detail),ce}M.to=q})(w=e.TaskDTO||(e.TaskDTO={}));var R;(function(M){function X(q){return q}M.from=X;function G(q){if(!!q)return Object.assign(Object.create(null),q)}M.to=G})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class O{constructor(X,G,q){this._id=G,this._task=q,g.set(this,void 0),Ke(this,g,X,"f")}get task(){return this._task}terminate(){Te(this,g,"f").terminateTask(this)}fireDidStartProcess(X){}fireDidEndProcess(X){}}g=new WeakMap;var L;(function(M){function X(G){return{id:G._id,task:void 0}}M.from=X})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let S=class{constructor(X,G,q,B,x,j,V,Z){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=X.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=q,this._editorService=B,this._configurationService=x,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=V,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(X,G,q){if(!q)return new D.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:G,provider:q,extension:X}),this._proxy.$registerTaskProvider(B,G),new D.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(X,G){this._proxy.$registerTaskSystem(X,G)}fetchTasks(X){return this._proxy.$fetchTasks(R.from(X)).then(async G=>{const q=[];for(let B of G){const x=await w.to(B,this._workspaceProvider,this._providedCustomExecutions2);x&&q.push(x)}return q})}get taskExecutions(){const X=[];return this._taskExecutions.forEach(G=>X.push(G)),X}terminateTask(X){if(!(X instanceof O))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(X._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(X,G,q){const B=this._providedCustomExecutions2.get(X.id);B&&(this._activeCustomExecutions2.set(X.id,B),this._terminalService.attachPtyToTerminal(G,await B.callback(q))),this._lastStartedTask=X.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(X)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(X){const G=await this.getTaskExecution(X);this._taskExecutionPromises.delete(X.id),this._taskExecutions.delete(X.id),this.customExecutionComplete(X),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(X){const G=await this.getTaskExecution(X.id);this._onDidTaskProcessStarted.fire({execution:G,processId:X.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(X){const G=await this.getTaskExecution(X.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:X.exitCode})}$provideTasks(X,G){const q=this._handlers.get(X);if(!q)return Promise.reject(new Error("no handler found"));const B=[],x=(0,t.asPromise)(()=>q.provider.provideTasks(F.CancellationToken.None)).then(j=>this.provideTasksInternal(G,B,q,j));return new Promise(j=>{x.then(V=>{Promise.all(B).then(()=>{j(V)})})})}async $resolveTask(X,G){const q=this._handlers.get(X);if(!q)return Promise.reject(new Error("no handler found"));if(G.definition.type!==q.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${q.type}].`);const B=await w.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const x=await q.provider.resolveTask(B,F.CancellationToken.None);if(!x)return;this.checkDeprecation(x,q);const j=w.from(x,q.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(j.execution)&&await this.addCustomExecution(j,x,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(X,G,q){const B=await this._proxy.$createTaskId(X);!q&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,G.execution)),this._providedCustomExecutions2.set(B,G.execution)}async getTaskExecution(X,G){if(typeof X=="string"){const x=this._taskExecutionPromises.get(X);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let q=this._taskExecutionPromises.get(X.id);if(q)return q;const B=new Promise((x,j)=>{function V(Z,se,ce){ce?x(new O(Z,se.id,ce)):j("Unexpected: Task does not exist.")}G?V(this,X,G):w.to(X.task,this._workspaceProvider,this._providedCustomExecutions2).then(Z=>V(this,X,Z))});return this._taskExecutionPromises.set(X.id,B),B.then(x=>(this._taskExecutions.set(X.id,x),x),x=>Promise.reject(x))}checkDeprecation(X,G){X._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(X){this._activeCustomExecutions2.get(X.id)&&this._activeCustomExecutions2.delete(X.id),this._notProvidedCustomExecutions.has(X.id)&&this._lastStartedTask!==X.id&&(this._providedCustomExecutions2.delete(X.id),this._notProvidedCustomExecutions.delete(X.id));let q=this._notProvidedCustomExecutions.values(),B=q.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=q.next()}};S=Be([Fe(0,f.IExtHostRpcService),Fe(1,_.IExtHostInitDataService),Fe(2,P.IExtHostWorkspace),Fe(3,y.IExtHostDocumentsAndEditors),Fe(4,T.IExtHostConfiguration),Fe(5,C.IExtHostTerminalService),Fe(6,I.ILogService),Fe(7,b.IExtHostApiDeprecationService)],S),e.ExtHostTaskBase=S;let U=class extends S{constructor(X,G,q,B,x,j,V,Z){super(X,G,q,B,x,j,V,Z);this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(X,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const q=w.from(G,X);if(q===void 0)throw new Error("Task is not valid");if(l.is(q.execution))await this.addCustomExecution(q,G,!1);else throw new o.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(q),G);return this._proxy.$executeTask(q).catch(x=>{throw new Error(x)}),B}provideTasksInternal(X,G,q,B){const x=[];if(B)for(let j of B){this.checkDeprecation(j,q),(!j.definition||!X[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const V=w.from(j,q.extension);V&&l.is(V.execution)?(x.push(V),G.push(this.addCustomExecution(V,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:q.extension}}async resolveTaskInternal(X){if(l.is(X.execution))return X;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(X,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(X,G,q){}};U=Be([Fe(0,f.IExtHostRpcService),Fe(1,_.IExtHostInitDataService),Fe(2,P.IExtHostWorkspace),Fe(3,y.IExtHostDocumentsAndEditors),Fe(4,T.IExtHostConfiguration),Fe(5,C.IExtHostTerminalService),Fe(6,I.ILogService),Fe(7,b.IExtHostApiDeprecationService)],U),e.WorkerExtHostTask=U,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(ve[269],be([1,0,9,21,49,32,22,46,31]),function(te,e,d,t,k,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(f,_,p){this.config=f,this.provider=_,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&A.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&A.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const _=this.config.folderQueries||[];return new Promise((p,c)=>{const v=I=>{this.resultCount++,f(I)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const b=I.toString(),m=d.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,m)||this.matchFile(v,{base:I,basename:m})}),Promise.all(_.map(I=>this.searchInFolder(I,v))).then(I=>{p({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{c(new Error((0,k.toErrorMessage)(I)))})})}async searchInFolder(f,_){const p=new t.CancellationTokenSource,c=this.getSearchOptionsForFolder(f),v=this.initDirectoryTree(),I=new y.QueryGlobTester(this.config,f),b=!I.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(p),m=P.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,p.token),g=m.elapsed(),n=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(E=>{const a=d.posix.relative(f.folder.path,E.path);if(b){const i=d.basename(E.path);this.matchFile(_,{base:f.folder,relativePath:a,basename:i});return}this.addDirectoryEntries(v,f.folder,a,_)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,I,_),{providerTime:g,postProcessTime:n.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(f){const _=(0,y.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),p=(0,y.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:p,includes:_,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},_,p,c){if(p===this.filePattern){const I=d.basename(this.filePattern);this.matchFile(c,{base:_,relativePath:this.filePattern,basename:I})}function v(I){const b=d.basename(I),m=d.dirname(I);let o=f[m];o||(o=f[m]=[],v(m)),o.push({base:_,relativePath:I,basename:b})}v(p)}matchDirectoryTree({rootEntries:f,pathToEntries:_},p,c){const v=this,I=this.filePattern;function b(m){const o=A.hasSiblingFn(()=>m.map(g=>g.basename));for(let g=0,n=m.length;g<n;g++){const E=m[g],{relativePath:a,basename:i}=E;if(p.matchesExcludesSync(a,i,I!==i?o:void 0))continue;const r=_[a];if(r)b(r);else{if(a===I)continue;v.matchFile(c,E)}if(v.isLimitHit)break}}b(f)}matchFile(f,_){(!this.includePattern||_.relativePath&&this.includePattern(_.relativePath,_.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(_))}}class F{constructor(){this.sessions=new Map}fileSearch(f,_,p,c){const v=this.getSessionTokenSource(f.cacheKey),I=new T(f,_,v&&v.token);let b=0;const m=o=>{b+=o.length,p(o.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(I,F.BATCH_SIZE,m,c).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:o.stats}}))}clearCache(f){const _=this.getSessionTokenSource(f);_&&_.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new t.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:D.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,_,p,c){c.onCancellationRequested(()=>{f.cancel()});const v=b=>{b&&(I.push(b),_>0&&I.length>=_&&(p(I),I=[]))};let I=[];return f.search(v).then(b=>(I.length&&p(I),b),b=>(I.length&&p(I),Promise.reject(b)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(ve[270],be([1,0,17,74,32,79,24,10,9,22,8,18,2,154,183,116,43,130,268,31]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(h,u,w,R){this.configurationService=h,this.workspaceContextService=u,this.editorGroupsService=w,this.pathService=R}text(h,u,w={}){h=this.getContentPattern(h,w);const R=this.configurationService.getValue(),O=u&&u.some(S=>!this.configurationService.getValue({resource:S}).search.useRipgrep);return{...this.commonQuery(u?.map(v.toWorkspaceFolder),w),type:2,contentPattern:h,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:R.search.usePCRE2||O||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}getContentPattern(h,u){const w=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const R={...h,wordSeparators:w.editor.wordSeparators};return this.isCaseSensitive(h,u)&&(R.isCaseSensitive=!0),this.isMultiline(h)&&(R.isMultiline=!0),R}file(h,u={}){return{...this.commonQuery(h,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(h,u){return h?(h=Array.isArray(h)?h.map(i):i(h),u?this.parseSearchPaths(h):{pattern:n(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],u={}){const w=this.handleIncludeExclude(u.includePattern,u.expandPatterns),R=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),O=h.length>1,L=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,u,R)):h.map(M=>this.getFolderQueryForRoot(M,u,R,O))).filter(M=>!!M),S={_reason:u._reason,folderQueries:L,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:R.pattern,includePattern:w.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const X=d.coalesce(d.flatten(this.editorGroupsService.groups.map(q=>q.editors.map(B=>B.resource)))).filter(q=>(0,m.pathIncludedInQuery)(S,q.fsPath)),G=this.commonQueryFromFileList(X);return{...S,...G}}const U=u.extraFileResources&&u.extraFileResources.filter(M=>(0,m.pathIncludedInQuery)(S,M.fsPath));return S.extraFileResources=U&&U.length?U:void 0,S}commonQueryFromFileList(h){const u=[],w=new D.ResourceMap,R={};let O=!1;return h.forEach(L=>{if(L.scheme===P.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(L)){const U=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:y.dirname(L.fsPath)});let M=w.get(U);M||(O=!0,M={folder:U,includePattern:{}},u.push(M),w.set(U,M));const X=y.relative(U.fsPath,L.fsPath);(0,C.assertIsDefined)(M.includePattern)[X.replace(/\\/g,"/")]=!0}else L.fsPath&&(O=!0,R[L.fsPath]=!0)}),{folderQueries:u,includePattern:R,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(h,u){if(u.isSmartCase){if(h.isRegExp){if(F.containsUppercaseCharacter(h.pattern,!0))return!0}else if(F.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,_.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const u=G=>y.isAbsolute(G)||/^\.\.?([\/\\]|$)/.test(G),R=(Array.isArray(h)?h:E(h)).map(G=>{const q=this.pathService.resolvedUserHome;return q?(0,A.untildify)(G,q.scheme===P.Schemas.file?q.fsPath:q.path):G}),O=t.groupBy(R,G=>u(G)?"searchPaths":"exprSegments"),L=(O.exprSegments||[]).map(G=>F.rtrim(G,"/")).map(G=>F.rtrim(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),a(G))),S={},U=this.expandSearchPathPatterns(O.searchPaths||[]);U&&U.length&&(S.searchPaths=U);const M=d.flatten(L),X=n(...M);return X&&(S.pattern=X),S}getExcludesForFolder(h,u){return u.disregardExcludeSettings?void 0:(0,m.getExcludes)(h,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const u=d.flatten(h.map(R=>{let{pathPortion:O,globPortion:L}=g(R);L&&(L=r(L));const S=this.expandOneSearchPath(O);return d.flatten(S.map(U=>this.resolveOneSearchPathPattern(U,L)))})),w=new Map;return u.forEach(R=>{const O=R.searchPath.toString(),L=w.get(O);L?R.pattern&&(L.pattern=L.pattern||{},L.pattern[R.pattern]=!0):w.set(O,{searchPath:R.searchPath,pattern:R.pattern?n(R.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(h){if(y.isAbsolute(h)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==P.Schemas.file?[{searchPath:u[0].uri.with({path:h})}]:[{searchPath:f.URI.file(y.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=i(h),h.startsWith("../")||h===".."){const R=y.posix.resolve(u.path,h);return[{searchPath:u.with({path:R})}]}const w=r(h);return[{searchPath:u,pattern:w}]}else{if(h==="./"||h===".\\")return[];{const u=h.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(O=>{const L=u.match(new RegExp(`^${F.escapeRegExpCharacters(O.name)}(?:/(.*)|$)`));return L?{match:L,folder:O}:null}).filter(C.isDefined);if(R.length)return R.map(O=>{const L=O.match[1];return{searchPath:O.folder.uri,pattern:L&&r(L)}});{const O=h.match(/\.[\/\\](.+)[\/\\]?/),L=O?O[1]:h,S=p.localize(0,null,L);throw new Error(S)}}}}resolveOneSearchPathPattern(h,u){const w=h.pattern&&u?`${h.pattern}/${u}`:h.pattern||u,R=[{searchPath:h.searchPath,pattern:w}];return w&&!w.endsWith("**")&&R.push({searchPath:h.searchPath,pattern:w+"/**"}),R}getFolderQueryForSearchPath(h,u,w){const R=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(h.searchPath),u,w,!1);return R?{...R,includePattern:h.pattern}:null}getFolderQueryForRoot(h,u,w,R){let O;const L=f.URI.isUri(h)?h:h.uri;if(w.searchPaths){const G=w.searchPaths.filter(q=>(0,T.isEqual)(q.searchPath,L))[0];if(G&&!G.pattern)return null;G&&(O=G.pattern)}const S=this.configurationService.getValue({resource:L}),M={...this.getExcludesForFolder(S,u)||{},...O||{}},X=f.URI.isUri(h)?(0,T.basename)(h):h.name;return{folder:L,folderName:R?X:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:S.files&&S.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!S.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!S.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof u.disregardParentIgnoreFiles=="boolean"?u.disregardParentIgnoreFiles:!S.search.useParentIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!S.search.followSymlinks}}};o=Be([Fe(0,c.IConfigurationService),Fe(1,v.IWorkspaceContextService),Fe(2,I.IEditorGroupsService),Fe(3,b.IPathService)],o),e.QueryBuilder=o;function g(l){const h=l.match(/[\*\{\}\(\)\[\]\?]/);if(h){const u=h.index,w=l.substr(0,u).match(/[/|\\][^/\\]*$/);if(w){let R=l.substr(0,w.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:l.substr((w.index||0)+1)}}}return{pathPortion:l}}function n(...l){return l.length?l.reduce((h,u)=>(h[u]=!0,h),Object.create(null)):void 0}function E(l){return k.splitGlobAware(l,",").map(h=>h.trim()).filter(h=>!!h.length)}function a(l){return[`**/${l}/**`,`**/${l}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function i(l){return l.replace(/\\/g,"/")}function r(l){return i(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(l,h){l=d.distinct(l,R=>R.toString());const u=[],w=h.getWorkspace();return l&&l.forEach(R=>{let O;if(h.getWorkbenchState()===2)O=(0,T.relativePath)(w.folders[0].uri,R),O&&O!=="."&&(O="./"+O);else{const L=h.getWorkspaceFolder(R);if(L){const S=L.name;if(w.folders.filter(M=>M.name===S).length===1){const M=(0,T.relativePath)(L.uri,R);M===""?O=`./${L.name}`:O=`./${L.name}/${M}`}else O=R.fsPath}}O&&u.push(O)}),u}e.resolveResourcesForSearchIncludes=s}),define(ve[271],be([1,0,22,2,21,16,4,270,31,43]),function(te,e,d,t,k,A,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function C(c,v){const I=v.activationEvents;if(!I)return Promise.resolve(void 0);const b=[],m=[];for(const i of I)if(/^workspaceContains:/.test(i)){const r=i.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||c.forceUsingSearch?m.push(r):b.push(r)}if(b.length===0&&m.length===0)return Promise.resolve(void 0);let o;const g=new Promise((i,r)=>{o=i}),n=i=>o({activationEvent:i}),E=Promise.all(b.map(i=>f(c,i,n))).then(()=>{}),a=_(c,v.identifier,m,n);return Promise.all([E,a]).then(()=>{o(void 0)}),g}e.checkActivateWorkspaceContainsExtension=C;async function f(c,v,I){for(const b of c.folders)if(await c.exists(d.joinPath(t.URI.revive(b),v))){I(`workspaceContains:${v}`);return}}async function _(c,v,I,b){if(I.length===0)return Promise.resolve(void 0);const m=new k.CancellationTokenSource,o=c.checkExists(c.folders,I,m.token),g=setTimeout(async()=>{m.cancel(),c.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${I.join(",")}`)},F);let n=!1;try{n=await o}catch(E){A.isCancellationError(E)||A.onUnexpectedError(E)}m.dispose(),clearTimeout(g),n&&b(`workspaceContains:${I.join(",")}`)}function p(c,v,I,b){const m=c.get(D.IInstantiationService),o=c.get(y.ISearchService),n=m.createInstance(P.QueryBuilder).file(v.map(E=>(0,T.toWorkspaceFolder)(t.URI.revive(E))),{_reason:"checkExists",includePattern:I,exists:!0});return o.fileSearch(n,b).then(E=>!!E.limitHit,E=>A.isCancellationError(E)?!1:Promise.reject(E))}e.checkGlobFileExists=p});var Ke=this&&this.__classPrivateFieldSet||function(te,e,d,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,d):k?k.value=d:e.set(te,d),d},Te=this&&this.__classPrivateFieldGet||function(te,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(te):t?t.value:e.get(te)};define(ve[39],be([1,0,169,9,71,22,13,6,24,2,12,5,36,227,89,35,30,226,16,27,23,202,7,121,4,26,67,14,82,51,34,3,271,88,204,10]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m,o,g,n,E,a,i,r,s,l,h,u,w,R,O,L,S){"use strict";var U,M,X;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let G=class qi extends P.Disposable{constructor(V,Z,se,ce,ee,Y,ae,he,we,ke){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Z,this._extHostContext=se,this._initData=ae,this._extHostWorkspace=ce,this._extHostConfiguration=ee,this._logService=Y,this._extHostTunnelService=we,this._extHostTerminalService=ke,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new p.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=he,this._instaService=V.createChild(new l.ServiceCollection([p.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const Ne=new Set;this._initData.hostExtensions.forEach(_e=>Ne.add(m.ExtensionIdentifier.toKey(_e))),this._activator=this._register(new _.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(_e,Ee,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(_e,b.transformErrorForSerialization(Ee),z)},actualActivateExtension:async(_e,Ee)=>{if(Ne.has(m.ExtensionIdentifier.toKey(_e)))return await this._mainThreadExtensionsProxy.$activateExtension(_e,Ee),new _.HostExtension;const z=this._registry.getExtensionDescription(_e);return this._activateExtension(z,Ee)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){b.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(ee=>ee.identifier).filter(ee=>this.isActivated(ee)).map(ee=>this._deactivate(ee))}catch{}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,Z){return this._activator.activateByEvent(V,Z)}_activateById(V,Z){return this._activator.activateById(V,Z)}activateByIdWithErrors(V,Z){return this._activateById(V,Z).then(()=>{const se=this._activator.getActivatedExtension(V);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}async _realPathExtensionUri(V){if(V.scheme!==S.Schemas.file)return V;const Z=await this._hostUtils.realpath(V.fsPath);return T.URI.file(Z)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const V=y.TernarySearchTree.forUris(Z=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Z));for(const Z of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Z)){const se=await this._realPathExtensionUri(Z.extensionLocation);V.set(se,Z)}return V})()),this._extensionPathIndex}_deactivate(V){let Z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return Z;const se=this._activator.getActivatedExtension(V);if(!se)return Z;try{typeof se.module.deactivate=="function"&&(Z=Promise.resolve(se.module.deactivate()).then(void 0,ce=>(this._logService.error(ce),Promise.resolve(void 0))))}catch(ce){this._logService.error(`An error occurred when deactivating the extension '${V.value}':`),this._logService.error(ce)}try{(0,P.dispose)(se.subscriptions)}catch(ce){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this._logService.error(ce)}return Z}async _activateExtension(V,Z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,Z).then(se=>{const ce=se.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,ce.codeLoadingTime,ce.activateCallTime,ce.activateResolvedTime,Z),this._logExtensionActivationTimes(V,Z,"success",ce),se},se=>{throw this._logExtensionActivationTimes(V,Z,"failure"),se})}_logExtensionActivationTimes(V,Z,se,ce){const ee=q(V,Z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ee,...ce||{},outcome:se})}_doActivateExtension(V,Z){const se=q(V,Z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",se);const ce=this._getEntryPoint(V);if(!ce)return Promise.resolve(new _.EmptyExtension(_.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${Z.startup}, activationEvent: '${Z.activationEvent}'${V.identifier.value!==Z.extensionId.value?`, root cause: ${Z.extensionId.value}`:""}`),this._logService.flush();const ee=new _.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,A.joinPath)(V.extensionLocation,ce),ee),this._loadExtensionContext(V)]).then(Y=>(k.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),qi._callActivate(this._logService,V.identifier,Y[0],Y[1],ee))).then(Y=>(k.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),Y))}_loadExtensionContext(V){const Z=new g.ExtensionGlobalMemento(V,this._storage),se=new g.ExtensionMemento(V.identifier.value,!1,this._storage),ce=new L.ExtensionSecrets(V,this._secretState),ee=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Y=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([Z.whenReady,se.whenReady,this._storagePath.whenReady]).then(()=>{const ae=this;let he,we;const ke=(0,v.isProposedApiEnabled)(V,"ipc")?this._initData.messagePorts?.get(m.ExtensionIdentifier.toKey(V.identifier)):void 0;return Object.freeze({globalState:Z,workspaceState:se,secrets:ce,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Ne){return t.join(V.extensionLocation.fsPath,Ne)},get storagePath(){return ae._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return ae._storagePath.globalValue(V).fsPath},get logPath(){return t.join(ae._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return T.URI.joinPath(ae._initData.logsLocation,V.identifier.value)},get storageUri(){return ae._storagePath.workspaceValue(V)},get globalStorageUri(){return ae._storagePath.globalValue(V)},get extensionMode(){return ee},get extension(){return he===void 0&&(he=new B(ae,V.identifier,V,Y)),he},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(V,"extensionRuntime"),ae.extensionRuntime},get environmentVariableCollection(){return ae._extHostTerminalService.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!we){if(!ke)return;const Ne=w.Event.buffer(w.Event.fromDOMEventEmitter(ke,"message",_e=>_e.data));ke.start(),we={onDidReceiveMessage:Ne,postMessage:ke.postMessage.bind(ke)}}return we}})})}static _callActivate(V,Z,se,ce,ee){return se=se||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,Z,se,ce,ee).then(Y=>new _.ActivatedExtension(!1,null,ee.build(),se,Y,ce.subscriptions))}static _callActivateOptional(V,Z,se,ce,ee){if(typeof se.activate=="function")try{ee.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const Y=typeof global=="object"?global:self,ae=se.activate.apply(Y,[ce]);return ee.activateCallStop(),ee.activateResolveStart(),Promise.resolve(ae).then(he=>(ee.activateResolveStop(),he))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(se)}_activateOneStartupFinished(V,Z){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:Z}).then(void 0,se=>{this._logService.error(se)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const Z of V.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished(V,Z)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,ee=>{this._logService.error(ee)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ee=>this._handleWorkspaceContainsEagerExtensions(ee.added)));const Z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],se=this._handleWorkspaceContainsEagerExtensions(Z),ce=Promise.all([V,se]).then(()=>{});return Promise.race([ce,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ce}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Z=>this._handleWorkspaceContainsEagerExtension(V,Z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,Z){if(this.isActivated(Z.identifier))return;const se=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ce={logService:this._logService,folders:V.map(Y=>Y.uri),forceUsingSearch:se,exists:Y=>this._hostUtils.exists(Y.fsPath),checkExists:(Y,ae,he)=>this._mainThreadWorkspaceProxy.$checkExists(Y,ae,he)},ee=await(0,R.checkActivateWorkspaceContainsExtension)(ce,Z);if(!!ee)return this._activateById(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:ee.activationEvent}).then(void 0,Y=>this._logService.error(Y))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:Z}=this._initData.environment;if(!V||!Z)throw new Error(d.localize(0,null));const se=await this._loadCommonJSModule(null,Z,new _.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(d.localize(1,null,Z.toString()));return new Promise((ce,ee)=>{const Y=(we,ke)=>{we?ee(we):ce(typeof ke=="number"&&ke>0?1:0)},ae=(0,A.originalFSPath)(Z),he=se.run(ae,Y);he&&he.then&&he.then(()=>{ce(0)}).catch(we=>{ee(we instanceof Error&&we.stack?we.stack:String(we))})})}async $extensionTestsExit(V){this._logService.info(`Extension host terminating: test runner requested exit with code ${V}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,Z){return this._resolvers[V]=Z,(0,P.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const Z=V.indexOf("+");if(Z===-1)throw new Error("Not an authority that can be resolved!");const se=V.substr(0,Z);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this._resolvers[se]}}async $resolveAuthority(V,Z){this._logService.info(`$resolveAuthority invoked for authority (${x(V)})`);const{authorityPrefix:se,resolver:ce}=await this._activateAndGetResolver(V);if(!ce)return{type:"error",error:{code:E.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${se}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ce)),k.mark(`code/extHost/willResolveAuthority/${se}`);const ee=await ce.resolve(V,{resolveAttempt:Z});k.mark(`code/extHost/didResolveAuthorityOK/${se}`);const Y={authority:V,host:ee.host,port:ee.port,connectionToken:ee.connectionToken},ae={extensionHostEnv:ee.extensionHostEnv,isTrusted:ee.isTrusted,authenticationSession:ee.authenticationSessionForInitializingExtensions?{id:ee.authenticationSessionForInitializingExtensions.id,providerId:ee.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Y,options:ae,tunnelInformation:{environmentTunnels:ee.environmentTunnels,features:ee.tunnelFeatures}}}}catch(ee){if(k.mark(`code/extHost/didResolveAuthorityError/${se}`),ee instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee}}async $getCanonicalURI(V,Z){this._logService.info(`$getCanonicalURI invoked for authority (${x(V)})`);const{authorityPrefix:se,resolver:ce}=await this._activateAndGetResolver(V);if(!ce)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${se}`);const ee=T.URI.revive(Z);if(typeof ce.getCanonicalURI=="undefined")return ee;const Y=await(0,D.asPromise)(()=>ce.getCanonicalURI(ee));return Y||ee}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,Z){return Z===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(se=>this._activateByEvent(V,!1))}async $activate(V,Z){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,Z),!0):!1}async $deltaExtensions(V,Z){V.forEach(ce=>ce.extensionLocation=T.URI.revive(ce.extensionLocation));const se=await this.getExtensionPathIndex();return await Promise.all(Z.map(async ce=>{const ee=this._registry.getExtensionDescription(ce);ee&&se.delete(await this._realPathExtensionUri(ee.extensionLocation))})),await Promise.all(V.map(async ce=>{const ee=await this._realPathExtensionUri(ce.extensionLocation);se.set(ee,ce)})),this._registry.deltaExtensions(V,Z),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let Z=o.VSBuffer.alloc(V),se=Math.random()%256;for(let ce=0;ce<V;ce++)Z.writeUInt8(se,ce);return Z}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};G=Be([Fe(0,a.IInstantiationService),Fe(1,e.IHostUtils),Fe(2,s.IExtHostRpcService),Fe(3,c.IExtHostWorkspace),Fe(4,f.IExtHostConfiguration),Fe(5,F.ILogService),Fe(6,i.IExtHostInitDataService),Fe(7,r.IExtensionStoragePaths),Fe(8,h.IExtHostTunnelService),Fe(9,u.IExtHostTerminalService)],G),e.AbstractExtHostExtensionService=G;function q(j,V){return{id:j.identifier.value,name:j.name,extensionVersion:j.version,publisherDisplayName:j.publisher,activationEvents:j.activationEvents?j.activationEvents.join(","):null,isBuiltin:j.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class B{constructor(V,Z,se,ce){U.set(this,void 0),M.set(this,void 0),X.set(this,void 0),Ke(this,U,V,"f"),Ke(this,M,Z,"f"),Ke(this,X,se.identifier,"f"),this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ce}get isActive(){return Te(this,U,"f").isActivated(Te(this,X,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,U,"f").getExtensionExports(Te(this,X,"f"))}activate(){return Te(this,U,"f").activateByIdWithErrors(Te(this,X,"f"),{startup:!1,extensionId:Te(this,M,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=B,U=new WeakMap,M=new WeakMap,X=new WeakMap;function x(j){const V=j.indexOf("+");return V===-1?j:j.substring(0,V)}}),define(ve[54],be([1,0,9,2,3,13,5,7,126,35,39,45,219,36,212,14,4,18,40,53]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let o=class{constructor(l,h,u,w,R,O){this._workspaceService=h,this._extensionService=u,this._editorsService=w,this._configurationService=R,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=l.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new n(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(S=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,h){const u=l;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let w=`debug:${encodeURIComponent(u.path||"")}`,R="?";return h&&(w+=`${R}session=${encodeURIComponent(h.id)}`,R="&"),w+=`${R}ref=${u.sourceReference}`,t.URI.parse(w)}else{if(u.path)return t.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const h=[];for(const u of l.getAllExtensionDescriptions())if(u.contributes){const w=u.contributes.debuggers;if(w&&w.length>0)for(const R of w)(0,p.isDebuggerMainContribution)(R)&&h.push(R.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(h=>l.push(h)),l}addBreakpoints(l){this.startBreakpoints();const h=l.filter(R=>{const O=R.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,R),!0)});this.fireBreakpointChanges(h,[],[]);const u=[],w=new Map;for(const R of h)if(R instanceof P.SourceBreakpoint){let O=w.get(R.location.uri.toString());O||(O={type:"sourceMulti",uri:R.location.uri,lines:[]},w.set(R.location.uri.toString(),O),u.push(O)),O.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof P.FunctionBreakpoint&&u.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(l){this.startBreakpoints();const h=l.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],h,[]);const u=h.filter(O=>O instanceof P.SourceBreakpoint).map(O=>O.id),w=h.filter(O=>O instanceof P.FunctionBreakpoint).map(O=>O.id),R=h.filter(O=>O instanceof P.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(u,w,R)}startDebugging(l,h,u){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,h,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,h,u){if(!h)return new P.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:w,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,u,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,w),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(l,h,u){if(!u)return new P.Disposable(()=>{});if(!this.definesDebugType(l,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:w,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,w),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(l,h){if(!h)return new P.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:u,factory:h}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==h)})}async $runInTerminal(l,h){return Promise.resolve(void 0)}async $substituteVariables(l,h){if(!this._variableResolver){const[R,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,O)}let u;const w=await this.getFolder(l);return w&&(u={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,h)}createDebugAdapter(l,h){if(l.type==="implementation")return new i(l.implementation)}createSignService(){}async $startDASession(l,h){const u=this,w=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const O=this.convertToDto(R),L=this.createDebugAdapter(O,w);if(!L)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const S=L;return this._debugAdapters.set(l,S),this.getDebugAdapterTrackers(w).then(U=>(U&&this._debugAdaptersTrackers.set(l,U),S.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const X=M,G={type:"response",seq:0,command:X.command,request_seq:X.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const q=await this._signService.sign(X.arguments.value);G.body={signature:q},S.sendResponse(G)}else throw new Error("no signer")}catch(q){G.success=!1,G.message=q.message,S.sendResponse(G)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(M),M=(0,p.convertToVSCPaths)(M,!0),u._debugServiceProxy.$acceptDAMessage(l,M)}),S.onError(M=>{U&&U.onError&&U.onError(M),this._debugServiceProxy.$acceptDAError(l,M.name,M.message,M.stack)}),S.onExit(M=>{U&&U.onExit&&U.onExit((0,I.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,I.withNullAsUndefined)(M),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),S.startSession()))})}$sendDAMessage(l,h){h=(0,p.convertToDAPaths)(h,!1);const u=this._debugAdaptersTrackers.get(l);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(h);const w=this._debugAdapters.get(l);w&&w.sendMessage(h)}$stopDASession(l){const h=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),h&&h.onWillStopSession&&h.onWillStopSession();const u=this._debugAdapters.get(l);return this._debugAdapters.delete(l),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const h=[],u=[],w=[];if(l.added)for(const R of l.added){const O=R.id;if(O&&!this._breakpoints.has(O)){let L;if(R.type==="function")L=new P.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")L=new P.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const S=t.URI.revive(R.uri);L=new P.SourceBreakpoint(new P.Location(S,new P.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}L._id=O,this._breakpoints.set(O,L),h.push(L)}}if(l.removed)for(const R of l.removed){const O=this._breakpoints.get(R);O&&(this._breakpoints.delete(R),u.push(O))}if(l.changed){for(const R of l.changed)if(R.id){const O=this._breakpoints.get(R.id);if(O){if(O instanceof P.FunctionBreakpoint&&R.type==="function"){const L=O;L.enabled=R.enabled,L.condition=R.condition,L.hitCondition=R.hitCondition,L.logMessage=R.logMessage,L.functionName=R.functionName}else if(O instanceof P.SourceBreakpoint&&R.type==="source"){const L=O;L.enabled=R.enabled,L.condition=R.condition,L.hitCondition=R.hitCondition,L.logMessage=R.logMessage,L.location=new P.Location(t.URI.revive(R.uri),new P.Position(R.line,R.character))}w.push(O)}}}this.fireBreakpointChanges(h,u,w)}$provideDebugConfigurations(l,h,u){return(0,A.asPromise)(async()=>{const w=this.getConfigProviderByHandle(l);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(h);return w.provideDebugConfigurations(R,u)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(l,h,u,w){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(l);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(h);return R.resolveDebugConfiguration(O,u,w)})}$resolveDebugConfigurationWithSubstitutedVariables(l,h,u,w){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(l);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(h);return R.resolveDebugConfigurationWithSubstitutedVariables(O,u,w)})}async $provideDebugAdapter(l,h){const u=this.getAdapterDescriptorFactoryByHandle(l);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(h);return this.getAdapterDescriptor(u,w).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(l){const h=await this.getSession(l);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(l){const h=await this.getSession(l);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,h){const u=await this.getSession(l);u&&u._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(l,h){const w={session:await this.getSession(l),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(l){if(l instanceof P.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof P.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const h=this._adapterFactories.filter(u=>u.type===l);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(l){const h=this._adapterFactories.filter(u=>u.handle===l);if(h.length>0)return h[0].factory}getConfigProviderByHandle(l){const h=this._configProviders.filter(u=>u.handle===l);if(h.length>0)return h[0].provider}definesDebugType(l,h){if(l.contributes){const u=l.contributes.debuggers;if(u&&u.length>0){for(const w of u)if(w.label&&w.type&&w.type===h)return!0}}return!1}getDebugAdapterTrackers(l){const u=l.configuration.type,w=this._trackerFactories.filter(R=>R.type===u||R.type==="*").map(R=>(0,A.asPromise)(()=>R.factory.createDebugAdapterTracker(l)).then(O=>O,O=>null));return Promise.race([Promise.all(w).then(R=>{const O=R.filter(L=>!!L);if(O.length>0)return new a(O)}),new Promise((R,O)=>{const L=setTimeout(()=>{clearTimeout(L),O(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(l,h){const u=h.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new P.DebugAdapterServer(u));if(l){const R=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>l.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,R))).then(O=>{if(O)return O})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,w))}daExecutableFromPackage(l,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,h,u){(l.length>0||h.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:h,changed:u}))}async getSession(l){if(l)if(typeof l=="string"){const h=this._debugSessions.get(l);if(h)return h}else{let h=this._debugSessions.get(l.id);if(!h){const u=await this.getFolder(l.folderUri),w=l.parent?this._debugSessions.get(l.parent):void 0;h=new g(this._debugServiceProxy,l.id,l.type,l.name,u,l.configuration,w),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(l){if(l){const h=t.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};o=Be([Fe(0,c.IExtHostRpcService),Fe(1,T.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,C.IExtHostDocumentsAndEditors),Fe(4,_.IExtHostConfiguration),Fe(5,m.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class g{constructor(l,h,u,w,R,O,L){this._debugServiceProxy=l,this._id=h,this._type=u,this._name=w,this._workspaceFolder=R,this._configuration=O,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,h)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=g;class n{constructor(l){this.value=Object.freeze({append(h){l.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=n;class E extends f.AbstractVariableResolverService{constructor(l,h,u,w,R){function O(){if(h){const L=h.activeEditor();if(L)return L.document.uri;const S=w.tabs.filter(U=>U.isActive);if(S.length>0){const U=S[0].resource;return U&&(U.primary||U.secondary)?U.primary??U.secondary:S[0].resource}}}super({getFolderUri:L=>{const S=l.filter(U=>U.name===L);if(S&&S.length>0)return S[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(L,S)=>u.getConfiguration(void 0,L).get(S),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=O();if(L)return d.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const L=O();if(L){const S=R.getWorkspaceFolder(L);if(S)return d.normalize(S.uri.fsPath)}}},getSelectedText:()=>{if(h){const L=h.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(h){const L=h.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=E;class a{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(h=>h.onError?h.onError(l):void 0)}onExit(l,h){this.trackers.forEach(u=>u.onExit?u.onExit(l,h):void 0)}}class i extends y.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends o{constructor(l,h,u,w,R,O){super(l,h,u,w,R,O)}createVariableResolver(l,h,u){return new E(l,h,u,this._editorTabs)}};r=Be([Fe(0,c.IExtHostRpcService),Fe(1,T.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,C.IExtHostDocumentsAndEditors),Fe(4,_.IExtHostConfiguration),Fe(5,m.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(ve[272],be([1,0,71,2,5,36,30,27,14,26,4,39,40,12,8]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(g,n,E,a,i,r,s){this._apiFactory=g,this._extensionRegistry=n,this._instaService=E,this._extHostConfiguration=a,this._extHostExtensionService=i,this._initData=r,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new I(this._apiFactory,n,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(b,n)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,n,this._initData.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(let n of g.nodeModuleName)this._factories.set(n,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(n=>g.alternativeModuleName(n))}};c=Be([Fe(2,F.IInstantiationService),Fe(3,A.IExtHostConfiguration),Fe(4,C.IExtHostExtensionService),Fe(5,T.IExtHostInitDataService),Fe(6,_.ILogService)],c),e.RequireInterceptor=c;let v=class zi{constructor(g){if(g.environment.appRoot&&zi.aliased.size){const n=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(g.environment.appRoot.fsPath)),E="[a-z0-9_.-]",a=`@${E}+\\/${E}+|${E}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${i}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(g){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(g));if(!n)return;const[,E,a,i]=n,r=zi.aliased.get(a);if(r!==void 0)return console.warn(`${a} as been renamed to ${r}, please update your imports`),E+r+i}forceForwardSlashes(g){return g.replace(/\\/g,"/")}};v.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),v=Be([Fe(0,T.IExtHostInitDataService)],v);class I{constructor(g,n,E,a,i){this._apiFactory=g,this._extensionPaths=n,this._extensionRegistry=E,this._configProvider=a,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(g,n){const E=this._extensionPaths.findSubstr(n);if(E){let a=this._extApiImpl.get(P.ExtensionIdentifier.toKey(E.identifier));return a||(a=this._apiFactory(E,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(E.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((i,r)=>a+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(g,n,E){this._extensionPaths=g,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(k.MainContext.MainThreadTelemetry);const{environment:a}=E,i=n.getProxy(k.MainContext.MainThreadKeytar);if(a.appRoot){let r=a.appRoot.fsPath;f.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>i.$getPassword(r,s),setPassword:(r,s,l)=>i.$setPassword(r,s,l),deletePassword:(r,s)=>i.$deletePassword(r,s),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(g,n){const E=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:E?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(g){const n=g.length;if(n<=7||!this.alternativeNames)return;const E=n-7;if((g.charAt(E)==="/"||g.charAt(E)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.alternativeNames.has(g)))return"keytar"}};b=Be([Fe(1,y.IExtHostRpcService),Fe(2,T.IExtHostInitDataService)],b);let m=class{constructor(g,n,E){this._extensionPaths=g,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=E.getProxy(k.MainContext.MainThreadTelemetry);const a=E.getProxy(k.MainContext.MainThreadWindow);this._impl=(i,r)=>{const s=t.URI.parse(i);return r?this.callOriginal(i,r):s.scheme==="http"||s.scheme==="https"?a.$openUri(s,i,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?a.$openUri(s,i,{}):this.callOriginal(i,r)}}load(g,n,E){const a=this._extensionPaths.findSubstr(n);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=E(g),this._impl}callOriginal(g,n){return this.sendNoForwardTelemetry(),this._original(g,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=Be([Fe(2,y.IExtHostRpcService)],m)}),define(ve[273],be([1,0,13,16,71,6,2,5,266,12,61,82,26,190,14,64,39,34]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(o,g,n,E,a){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=n,this._rpcProtocol=new y.RPCProtocol(o,null,E),g=b._transform(g,this._rpcProtocol);const i=new C.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());i.set(f.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:a}),i.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),i.set(c.IURITransformerService,new c.URITransformerService(E)),i.set(v.IHostUtils,n);const r=new _.InstantiationService(i,!0);this._disposables.add(r.invokeFunction(u=>u.get(I.IExtHostTerminalService))),this._disposables.add(r.invokeFunction(u=>u.get(v.IExtHostExtensionService))),this._logService=r.invokeFunction(u=>u.get(T.ILogService)),k.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=r.invokeFunction(u=>u.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const s=new WeakMap;this._extensionService.getExtensionPathIndex().then(u=>{Error.prepareStackTrace=(w,R)=>{let O="",L,S;for(const U of R)O+=`
	at ${U.toString()}`,S=U.getFileName(),!L&&S&&(L=u.findSubstr(D.URI.file(S)));return s.set(w,L),`${w.name||"Error"}: ${w.message||""}${O}`}});const l=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),h=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(u=>{const w=t.transformErrorForSerialization(u),R=s.get(u);R?l.$onExtensionRuntimeError(R.identifier,w):h.$onUnexpectedError(w)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(n=>{this._logService.error(n)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,d.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(o,g){o.extensions.forEach(E=>E.extensionLocation=D.URI.revive(g.transformIncomingURIs(E.extensionLocation))),o.environment.appRoot=D.URI.revive(g.transformIncomingURIs(o.environment.appRoot));const n=o.environment.extensionDevelopmentLocationURI;return n&&(o.environment.extensionDevelopmentLocationURI=n.map(E=>D.URI.revive(g.transformIncomingURIs(E)))),o.environment.extensionTestsLocationURI=D.URI.revive(g.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=D.URI.revive(g.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=D.URI.revive(g.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=D.URI.revive(g.transformIncomingURIs(o.logsLocation)),o.logFile=D.URI.revive(g.transformIncomingURIs(o.logFile)),o.workspace=g.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=b}),define(ve[274],be([1,0,175,11,7,213,35,39,45,36,34,14,54,197,13,214,53,189]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let b=class extends f.ExtHostDebugServiceBase{constructor(E,a,i,r,s,l,h){super(E,a,i,r,s,h);this._terminalService=l,this._integratedTerminalInstances=new g}createDebugAdapter(E,a){switch(E.type){case"server":return new A.SocketDebugAdapter(E);case"pipeServer":return new A.NamedPipeDebugAdapter(E);case"executable":return new A.ExecutableDebugAdapter(E,a.type)}return super.createDebugAdapter(E,a)}daExecutableFromPackage(E,a){const i=A.ExecutableDebugAdapter.platformAdapterExecutable(a.getAllExtensionDescriptions(),E.type);if(i)return new k.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new _.SignService}async $runInTerminal(E,a){if(E.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(U=>{this._integratedTerminalInstances.onTerminalClosed(U)}));const i=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),l=E.title||d.localize(0,null),h=JSON.stringify({shell:r,shellArgs:s});let u=await this._integratedTerminalInstances.checkout(h,l),w,R=!1;if(u)w=E.cwd;else{const U={shellPath:r,shellArgs:s,cwd:E.cwd,name:l,iconPath:new k.ThemeIcon("debug")};R=!0,u=this._terminalService.createTerminalFromOptions(U,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,h)}u.show(!0);const O=await u.processId;R?await new Promise(U=>setTimeout(U,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?u.sendText("cls"):r.indexOf("bash")>=0?u.sendText("clear"):t.isWindows?u.sendText("cls"):u.sendText("clear"));const L=(0,c.prepareCommand)(r,E.args,w,E.env);u.sendText(L);const S=this.onDidTerminateDebugSession(U=>{U.id===a&&(this._integratedTerminalInstances.free(u),S.dispose())});return O}else if(E.kind==="external")return o(E,await this._configurationService.getConfigProvider());return super.$runInTerminal(E,a)}createVariableResolver(E,a,i){return new f.ExtHostVariableResolverService(E,a,i,this._editorTabs,this._workspaceService)}};b=Be([Fe(0,C.IExtHostRpcService),Fe(1,D.IExtHostWorkspace),Fe(2,P.IExtHostExtensionService),Fe(3,y.IExtHostDocumentsAndEditors),Fe(4,T.IExtHostConfiguration),Fe(5,F.IExtHostTerminalService),Fe(6,v.IExtHostEditorTabs)],b),e.ExtHostDebugService=b;let m;function o(n,E){if(!m)if(t.isWindows)m=new I.WindowsExternalTerminalService;else if(t.isMacintosh)m=new I.MacExternalTerminalService;else if(t.isLinux)m=new I.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const a=E.getConfiguration("terminal");return m.runInTerminal(n.title,n.cwd,n.args,n.env||{},a.external||{})}e.runInExternalTerminal=o;class g{constructor(){this._terminalInstances=new Map}async checkout(E,a){const r=[...this._terminalInstances.entries()].map(([s,l])=>(0,p.createCancelablePromise)(async h=>{if(s.name!==a||l.lastUsedAt!==-1&&await(0,c.hasChildProcesses)(await s.processId))return null;const u=Date.now();return l.lastUsedAt+g.minUseDelay>u||h.isCancellationRequested||l.config!==E?null:(l.lastUsedAt=u,s)}));return await(0,p.firstParallel)(r,s=>!!s)}insert(E,a){this._terminalInstances.set(E,{lastUsedAt:Date.now(),config:a})}free(E){const a=this._terminalInstances.get(E);a&&(a.lastUsedAt=-1)}onTerminalClosed(E){this._terminalInstances.delete(E)}}g.minUseDelay=1e3}),define(ve[275],be([1,0,9,2,113,35,54,45,36,43,34,14,26,70,10,12,65,53,22,80]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends _.ExtHostTaskBase{constructor(n,E,a,i,r,s,l,h,u){super(n,E,a,i,r,s,l,h);this.workspaceService=a,this.editorTabs=u,E.remote.isRemote&&E.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:E.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(n,E){const a=E;if(!E.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const i=_.TaskHandleDTO.from(a,this.workspaceService),r=await this._proxy.$getTaskExecution(i);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(r,E);return this._proxy.$executeTask(i).catch(()=>{}),s}else{const i=_.TaskDTO.from(E,n);if(i===void 0)return Promise.reject(new Error("Task is not valid"));_.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,E,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),E);return this._proxy.$executeTask(i).catch(()=>{}),r}}provideTasksInternal(n,E,a,i){const r=[];if(i)for(let s of i){this.checkDeprecation(s,a),(!s.definition||!n[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const l=_.TaskDTO.from(s,a.extension);l&&(r.push(l),_.CustomExecutionDTO.is(l.execution)&&E.push(this.addCustomExecution(l,s,!0)))}return{tasks:r,extension:a.extension}}async resolveTaskInternal(n){return n}async getVariableResolver(n){if(this._variableResolver===void 0){const E=await this._configurationService.getConfigProvider();this._variableResolver=new D.ExtHostVariableResolverService(n,this._editorService,E,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(n){let E=n&&n.length>0?n[0]:void 0;if(!E){const a=t.URI.file((0,m.homedir)());E=new T.WorkspaceFolder({uri:a,name:b.basename(a),index:0})}return{uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(n,E){const a=t.URI.revive(n),i={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(a),s=await this._workspaceProvider.getWorkspaceFolders2()??[],l=await this.getVariableResolver(s),h=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(s);for(let u of E.variables)i.variables[u]=await l.resolveAsync(h,u);if(E.process!==void 0){let u;if(E.process.path!==void 0){u=E.process.path.split(d.delimiter);for(let w=0;w<u.length;w++)u[w]=await l.resolveAsync(h,u[w])}i.process=await k.win32.findExecutable(await l.resolveAsync(h,E.process.name),E.process.cwd!==void 0?await l.resolveAsync(h,E.process.cwd):void 0,u)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(n,E,a){return k.win32.findExecutable(n,E,a)}};o=Be([Fe(0,C.IExtHostRpcService),Fe(1,f.IExtHostInitDataService),Fe(2,A.IExtHostWorkspace),Fe(3,P.IExtHostDocumentsAndEditors),Fe(4,y.IExtHostConfiguration),Fe(5,F.IExtHostTerminalService),Fe(6,c.ILogService),Fe(7,v.IExtHostApiDeprecationService),Fe(8,I.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(ve[138],be([1,0,17,13,21,49,32,10,9,22,18,2,31]),function(te,e,d,t,k,A,D,P,y,T,F,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(o,g,n,E){this.query=o,this.provider=g,this.fileUtils=n,this.processType=E,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,g){const n=this.query.folderQueries||[],E=new k.CancellationTokenSource;return g.onCancellationRequested(()=>E.cancel()),new Promise((a,i)=>{this.collector=new c(o);let r=!1;const s=(l,h)=>{if(!r&&!this.isLimitHit){const u=this.resultSize(l);I(l)&&typeof this.query.maxResults=="number"&&this.resultCount+u>this.query.maxResults&&(this.isLimitHit=!0,r=!0,E.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const w=this.resultSize(l);this.resultCount+=w,(w>0||!I(l))&&this.collector.add(l,h)}};Promise.all(n.map((l,h)=>this.searchInFolder(l,u=>s(u,h),E.token))).then(l=>{E.dispose(),this.collector.flush();const h=l.some(u=>!!u&&!!u.limitHit);a({limitHit:this.isLimitHit||h,messages:(0,d.flatten)(l.map(u=>u?.message?(0,F.isArray)(u.message)?u.message:[u.message]:[])),stats:{type:this.processType}})},l=>{E.dispose();const h=(0,A.toErrorMessage)(l);i(new Error(h))})})}resultSize(o){return I(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,g){const n=Array.isArray(o.ranges)?o.ranges:[o.ranges],E=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:n.slice(0,g),preview:{matches:E.slice(0,g),text:o.preview.text},uri:o.uri}}async searchInFolder(o,g,n){const E=new f.QueryGlobTester(this.query,o),a=[],i={report:l=>{if(!this.validateProviderResult(l))return;const h=o.folder.scheme===P.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(l.uri))):void 0,u=T.relativePath(o.folder,l.uri);if(u){const w=E.includedInQuery(u,y.basename(u),h);(0,t.isThenable)(w)?a.push(w.then(R=>{R&&g(l)})):w&&g(l)}}},r=this.getSearchOptionsForFolder(o),s=await this.provider.provideTextSearchResults(p(this.query.contentPattern),r,i,n);return a.length&&await Promise.all(a),s}validateProviderResult(o){if(I(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const g=(0,f.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),n=(0,f.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),E={folder:C.URI.from(o.folder),excludes:n,includes:g,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!o.disregardParentIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return E.usePCRE2=this.query.usePCRE2,E}}e.TextSearchManager=_;function p(m){return{isCaseSensitive:m.isCaseSensitive||!1,isRegExp:m.isRegExp||!1,isWordMatch:m.isWordMatch||!1,isMultiline:m.isMultiline||!1,pattern:m.pattern}}class c{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,g=>this.sendItems(g))}add(o,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!T.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(v(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=c;function v(m){return I(m)?{preview:{matches:(0,d.mapArrayOrNot)(m.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:m.preview.text},ranges:(0,d.mapArrayOrNot)(m.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:m.text,lineNumber:m.lineNumber}}function I(m){return!!m.preview}e.extensionResultIsMatch=I;class b{constructor(o,g){this.maxBatchSize=o,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,g){!o||this.addItemToBatch(o,g)}addItems(o,g){!o||this.addItemsToBatch(o,g)}addItemToBatch(o,g){this.batch.push(o),this.batchSize+=g,this.onUpdate()}addItemsToBatch(o,g){this.batch=this.batch.concat(o),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(ve[72],be([1,0,6,5,4,269,14,64,12,2,138]),function(te,e,d,t,k,A,D,P,y,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let C=class{constructor(c,v,I){this.extHostRpc=c,this._uriTransformer=v,this._logService=I,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,v){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const I=this._handlePool++;return this._textSearchProvider.set(I,v),this._proxy.$registerTextSearchProvider(I,this._transformScheme(c)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(c,v){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const I=this._handlePool++;return this._fileSearchProvider.set(I,v),this._proxy.$registerFileSearchProvider(I,this._transformScheme(c)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(c,v,I,b){const m=f(I),o=this._fileSearchProvider.get(c);if(o)return this._fileSearchManager.fileSearch(m,o,g=>{this._proxy.$handleFileMatch(c,v,g.map(n=>n.resource))},b);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,v,I,b){const m=this._textSearchProvider.get(c);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const o=f(I);return this.createTextSearchManager(o,m).search(n=>this._proxy.$handleTextMatch(c,v,n),b)}$enableExtensionHostSearch(){}createTextSearchManager(c,v){return new F.TextSearchManager(c,v,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};C=Be([Fe(0,D.IExtHostRpcService),Fe(1,P.IURITransformerService),Fe(2,y.ILogService)],C),e.ExtHostSearch=C;function f(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(_),extraFileResources:p.extraFileResources&&p.extraFileResources.map(c=>T.URI.revive(c))}}e.reviveQuery=f;function _(p){return{...p,folder:T.URI.revive(p.folder)}}}),define(ve[276],be([1,0,61,136,35,134,36,38,45,34,70,54,72,89,51,65,137,66,44,88,124,53,135,12,228]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m,o,g,n,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(E.ILoggerService,n.ExtHostLoggerService),(0,d.registerSingleton)(E.ILogService,a.ExtHostLogService),(0,d.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService),(0,d.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,d.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,d.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,d.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,d.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,d.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,d.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,d.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch),(0,d.registerSingleton)(_.IExtHostStorage,_.ExtHostStorage),(0,d.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,d.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService),(0,d.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,d.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,d.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState),(0,d.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,d.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(ve[90],be([1,0,17,12,31,69]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=D;function P(C,f,_,p){const c=(0,d.mapArrayOrNot)(_,y),v=new k.TextSearchMatch(f,c,p),I=v.preview.matches;return{ranges:(0,d.mapArrayOrNot)(c,T),uri:C,preview:{text:v.preview.text,matches:(0,d.mapArrayOrNot)(I,T)}}}e.createTextSearchResult=P;function y(C){return new k.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function T(C){return new A.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let F=class{constructor(f,_){this.prefix=f,this.logService=_}appendLine(f){this.logService.debug(`${this.prefix}#search`,f)}};F=Be([Fe(1,t.ILogService)],F),e.OutputChannel=F}),define(ve[277],be([1,0,37,9,78,28,11,8,90,278]),function(te,e,d,t,k,A,D,P,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const F=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(m,o,g,n){const E=f(m,o,g,n),a=o.folder.fsPath;return{cmd:d.spawn(F,E.args,{cwd:a}),rgDiskPath:F,siblingClauses:E.siblingClauses,rgArgs:E,cwd:a}}e.spawnRipgrepCmd=C;function f(m,o,g,n){const E=["--files","--hidden","--case-sensitive"];p([o],g,!1).forEach(i=>{const r=(0,y.anchorGlob)(i);if(E.push("-g",r),D.isMacintosh){const s=(0,k.normalizeNFD)(r);s!==r&&E.push("-g",s)}});const a=_([o],n,void 0,!1);return a.globArgs.forEach(i=>{const r=`!${(0,y.anchorGlob)(i)}`;if(E.push("-g",r),D.isMacintosh){const s=(0,k.normalizeNFD)(r);s!==r&&E.push("-g",s)}}),o.disregardIgnoreFiles!==!1?E.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&E.push("--no-ignore-parent"),o.ignoreSymlinks||E.push("--follow"),m.exists&&E.push("--quiet"),E.push("--no-config"),o.disregardGlobalIgnoreFiles&&E.push("--no-ignore-global"),{args:E,siblingClauses:a.siblingClauses}}function _(m,o,g,n=!0){const E=[];let a={};return m.forEach(i=>{const r=Object.assign({},i.excludePattern||{},o||{}),s=c(r,n?i.folder.fsPath:void 0,g);E.push(...s.globArgs),s.siblingClauses&&(a=Object.assign(a,s.siblingClauses))}),{globArgs:E,siblingClauses:a}}e.foldersToRgExcludeGlobs=_;function p(m,o,g=!0){const n=[];return m.forEach(E=>{const a=Object.assign({},o||{},E.includePattern||{}),i=c(a,g?E.folder.fsPath:void 0);n.push(...i.globArgs)}),n}e.foldersToIncludeGlobs=p;function c(m,o,g){const n=[],E={};return Object.keys(m).forEach(a=>{if(g&&g.has(a)||!a)return;const i=m[a];a=I(o?v(o,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof i=="boolean"&&i?(a.startsWith("\\\\")&&(a+="**"),n.push(b(a))):i&&i.when&&(E[a]=i)}),{globArgs:n,siblingClauses:E}}function v(m,o){return t.isAbsolute(o)?o:t.join(m,o)}e.getAbsoluteGlob=v;function I(m){return m=P.rtrim(m,"\\"),P.rtrim(m,"/")}function b(m){return A.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=b}),define(ve[279],be([1,0,37,60,9,103,17,49,32,78,28,11,46,8,18,29,31,277,100]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(a=>a())});class o{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&y.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&y.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(r=>{const s=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),l=r.folder.fsPath;i.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==l).forEach(h=>{(0,F.isEqualOrParent)(h,l)&&(s[k.relative(l,h)]=!0)}),this.folderExcludePatterns.set(l,new n(s,l))})}cancel(){this.isCanceled=!0,m.forEach(i=>i())}walk(i,r,s,l,h){if(this.fileWalkSW=f.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);r.forEach(u=>{const w=k.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,w)||this.matchFile(s,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=f.StopWatch.create(!1),this.parallel(i,(u,w)=>{this.call(this.cmdTraversal,this,u,s,l,R=>{if(R){const O=(0,P.toErrorMessage)(R);console.error(O),this.errors.push(O),w(R,void 0)}else w(null,void 0)})},(u,w)=>{this.fileWalkSW.stop();const R=u?D.coalesce(u)[0]:null;h(R,this.isLimitHit)})}parallel(i,r,s){const l=new Array(i.length),h=new Array(i.length);let u=!1,w=0;if(i.length===0)return s(null,[]);i.forEach((R,O)=>{r(R,(L,S)=>{if(L?(u=!0,l[O]=null,h[O]=L):(l[O]=S,h[O]=null),++w===i.length)return s(u?h:null,l)})})}call(i,r,...s){try{i.apply(r,s)}catch(l){s[s.length-1](l)}}cmdTraversal(i,r,s,l){const h=i.folder.fsPath,u=C.isMacintosh;let w;const R=()=>w&&w.kill();m.add(R);let O=q=>{m.delete(R),O=()=>{},l(q)},L="";const S=this.initDirectoryTree();let U;const M=(0,I.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);w=M.cmd,U=!Object.keys(M.siblingClauses).length;const X=M.rgArgs.args.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");let G=`${M.rgDiskPath} ${X}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(G+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),s({message:G}),this.cmdResultCount=0,this.collectStdout(w,"utf8",s,(q,B,x)=>{if(q){O(q);return}if(this.isLimitHit){O();return}const V=(L+(u?T.normalizeNFC(B||""):B)).split(`
`);if(x){const Z=V.length;V[Z-1]=V[Z-1].trim(),V[Z-1]||V.pop()}else L=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,U){for(const Z of V)if(this.matchFile(r,{base:h,relativePath:Z,searchPath:this.getSearchPath(i,Z)}),this.isLimitHit){R();break}(x||this.isLimitHit)&&O();return}this.addDirectoryEntries(i,S,h,V,r),x&&(this.matchDirectoryTree(S,h,r),O())})}spawnFindCmd(i){const r=this.folderExcludePatterns.get(i.folder.fsPath),s=r.getBasenameTerms(),l=r.getPathTerms(),h=["-L","."];if(s.length||l.length){h.push("-not","(","(");for(const u of s)h.push("-name",u),h.push("-o");for(const u of l)h.push("-path",u),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),d.spawn("find",h,{cwd:i.folder.fsPath})}readStdout(i,r,s){let l="";this.collectStdout(i,r,()=>{},(h,u,w)=>{if(h){s(h);return}l+=u,w&&s(null,l)})}collectStdout(i,r,s,l){let h=(R,O,L)=>{(R||L)&&(h=()=>{},this.cmdSW&&this.cmdSW.stop()),l(R,O,L)},u=!1;i.stdout?(this.forwardData(i.stdout,r,h),i.stdout.once("data",()=>u=!0)):s({message:"stdout is null"});let w;i.stderr?w=this.collectData(i.stderr):s({message:"stderr is null"}),i.on("error",R=>{h(R)}),i.on("close",R=>{let O;!u&&(O=this.decodeData(w,r))&&E(O)?h(new Error(`command failed with error code ${R}: ${this.decodeData(w,r)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(i,r,s){const l=new A.StringDecoder(r);return i.on("data",h=>{s(null,l.write(h))}),l}collectData(i){const r=[];return i.on("data",s=>{r.push(s)}),r}decodeData(i,r){const s=new A.StringDecoder(r);return i.map(l=>s.write(l)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:r},s,l,h){l.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:s,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const u=w=>{const R=k.basename(w),O=k.dirname(w);let L=r[O];L||(L=r[O]=[],u(O)),L.push({base:s,relativePath:w,basename:R,searchPath:this.getSearchPath(i,w)})};l.forEach(u)}matchDirectoryTree({rootEntries:i,pathToEntries:r},s,l){const h=this,u=this.folderExcludePatterns.get(s),w=this.filePattern;function R(O){h.directoriesWalked++;const L=y.hasSiblingFn(()=>O.map(S=>S.basename));for(let S=0,U=O.length;S<U;S++){const M=O[S],{relativePath:X,basename:G}=M;if(u.test(X,G,w!==G?L:void 0))continue;const q=r[X];if(q)R(q);else{if(h.filesWalked++,X===w)continue;h.matchFile(l,M)}if(h.isLimitHit)break}}R(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,r,s,l,h){const u=i.folder,w=y.hasSiblingFn(()=>s);this.parallel(s,(R,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const L=r?[r,R].join(k.sep):R;if(this.folderExcludePatterns.get(i.folder.fsPath).test(L,R,this.config.filePattern!==R?w:void 0))return O(null);const S=[u.fsPath,L].join(k.sep);t.lstat(S,(U,M)=>{if(U||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(S,M,(X,G)=>X||this.isCanceled||this.isLimitHit?O(null):G.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(S,M,(q,B)=>q||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?O(null):(this.walkedPaths[B]=!0,c.Promises.readdir(S).then(x=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(i,L,x,l,j=>O(j||null))},x=>{O(null)})))):(this.filesWalked++,L===this.filePattern||this.maxFilesize&&p.isNumber(G.size)&&G.size>this.maxFilesize||this.matchFile(l,{base:u.fsPath,relativePath:L,searchPath:this.getSearchPath(i,L)}),O(null,void 0)))})},R=>{const O=R&&D.coalesce(R);return h(O&&O.length>0?O[0]:void 0)})}matchFile(i,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,k.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(r))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,r,s){return r.isSymbolicLink()?t.stat(i,s):s(null,r)}realPathIfNeeded(i,r,s){return r.isSymbolicLink()?t.realpath(i,(l,h)=>l?s(l):s(null,h)):s(null,i)}getSearchPath(i,r){return i.folderName?k.join(i.folderName,r):r}}e.FileWalker=o;class g{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new o(i)}search(i,r,s){this.walker.walk(this.folderQueries,this.extraFiles,i,r,(l,h)=>{s(l,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class n{constructor(i,r){this.expression=i,this.root=r,this.init(i)}init(i){let r,s;Object.keys(i).filter(l=>i[l]).forEach(l=>{k.isAbsolute(l)?(r=r||y.getEmptyExpression(),r[l]=i[l]):(s=s||y.getEmptyExpression(),s[l]=i[l])}),this.absoluteParsedExpr=r&&y.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=s&&y.parse(s,{trimForExclusions:!0})}test(i,r,s){return this.relativeParsedExpr&&this.relativeParsedExpr(i,r,s)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,i),r,s)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getPathTerms(this.relativeParsedExpr)),i}}function E(a){const i=a.trim().split(`
`),r=i[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return _.uppercaseFirstLetter(i[i.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=E}),define(ve[280],be([1,0,96,23]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===a)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,D=512,P=512*8,y=512*128;var T;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(T=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class F extends Error{constructor(i,r){super(i);this.decodeStreamErrorKind=r}}e.DecodeStreamError=F;class C{constructor(i){this.iconvLiteDecoder=i}static async create(i){let r;if(i!==e.UTF8)r=(await new Promise((l,h)=>{te(["@vscode/iconv-lite-umd"],l,h)})).getDecoder(c(i));else{const s=new TextDecoder;r={write(l){return s.decode(l,{stream:!0})},end(){return s.decode()}}}return new C(r)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function f(a,i){const r=i.minBytesRequiredForDetection??i.guessEncoding?P:D;return new Promise((s,l)=>{const h=(0,d.newWriteableStream)(S=>S.join("")),u=[];let w=0,R,O;const L=async()=>{try{const S=await E({buffer:t.VSBuffer.concat(u),bytesRead:w},i.guessEncoding);if(S.seemsBinary&&i.acceptTextOnly)throw new F("Stream is binary but only text is accepted for decoding",1);S.encoding=await i.overwriteEncoding(S.encoding),R=await C.create(S.encoding);const U=R.write(t.VSBuffer.concat(u).buffer);h.write(U),u.length=0,w=0,s({stream:h,detected:S})}catch(S){O?.dispose(),h.destroy(),l(S)}};O=(0,d.listenStream)(a,{onData:async S=>{R?h.write(R.write(S.buffer)):(u.push(S),w+=S.byteLength,w>=r&&(a.pause(),await L(),setTimeout(()=>a.resume())))},onError:S=>h.error(S),onEnd:async()=>{R||await L(),h.end(R?.end())}})})}e.toDecodeStream=f;async function _(a,i,r){const l=(await new Promise((w,R)=>{te(["@vscode/iconv-lite-umd"],w,R)})).getEncoder(c(i),r);let h=!1,u=!1;return{read(){if(u)return null;const w=a.read();if(typeof w!="string"){if(u=!0,!h&&r?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=l.end();return R&&R.length>0?(h=!0,t.VSBuffer.wrap(R)):null}return h=!0,t.VSBuffer.wrap(l.write(w))}}}e.toEncodeReadable=_;async function p(a){return(await new Promise((r,s)=>{te(["@vscode/iconv-lite-umd"],r,s)})).encodingExists(c(a))}e.encodingExists=p;function c(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=c;function v(a,i){if(!a||i<e.UTF16be_BOM.length)return null;const r=a.readUInt8(0),s=a.readUInt8(1);if(r===e.UTF16be_BOM[0]&&s===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&s===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const l=a.readUInt8(2);return r===e.UTF8_BOM[0]&&s===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const I=["ascii","utf-16","utf-32"];async function b(a){const i=await new Promise((u,w)=>{te(["jschardet"],u,w)}),r=a.slice(0,y),s=g(r.buffer),l=i.detect(s);if(!l||!l.encoding)return null;const h=l.encoding.toLowerCase();return 0<=I.indexOf(h)?null:o(l.encoding)}const m={ibm866:"cp866",big5:"cp950"};function o(a){const i=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return m[i]||i}function g(a){let i="";for(let r=0;r<a.length;r++)i+=String.fromCharCode(a[r]);return i}function n(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=a.match(/windows(\d+)/);return i?"windows-"+i[1]:a}}}e.toCanonicalName=n;function E({buffer:a,bytesRead:i},r){let s=v(a,i),l=!1;if(s!==e.UTF16be&&s!==e.UTF16le&&a){let h=!0,u=!0,w=!1;for(let R=0;R<i&&R<A;R++){const O=R%2==1,L=a.readUInt8(R)===0;if(L&&(w=!0),h&&(O&&!L||!O&&L)&&(h=!1),u&&(O&&L||!O&&!L)&&(u=!1),L&&!h&&!u)break}w&&(h?s=e.UTF16le:u?s=e.UTF16be:l=!0)}return r&&!l&&!s&&a?b(a.slice(0,i)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:l,encoding:s}}e.detectEncodingFromBuffer=E,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[139],be([1,0,280,29,138]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends k.TextSearchManager{constructor(P,y,T=t,F="searchProcess"){super(P,y,{readdir:C=>T.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,d.toCanonicalName)(C)},F)}}e.NativeTextSearchManager=A}),define(ve[281],be([1,0,61,4]),function(te,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class k{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(D){if(D&&this._dragOperations.has(D)){const P=this._dragOperations.get(D);return this._dragOperations.delete(D),P}}addDragOperationTransfer(D,P){this._dragOperations.set(D,P)}}e.TreeViewsDragAndDropService=k,(0,d.registerSingleton)(e.ITreeViewsDragAndDropService,k)}),define(ve[282],be([1,0,173,22,2,3,6,13,7,18,17,15,21,208,281]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function c(b,m){if((0,T.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let o;return Array.isArray(b.highlights)&&(o=b.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),o=o.length?o:void 0),{label:b.label,highlights:o}}}class v{constructor(m,o,g){this._proxy=m,this.commands=o,this.logService=g,this.treeViews=new Map,this.treeDragAndDropService=new p.TreeViewsDragAndDropService;function n(E){return E&&E.$treeViewId&&E.$treeItemHandle}o.registerArgumentProcessor({processArgument:E=>n(E)?this.convertArgument(E):Array.isArray(E)&&E.length>0?E.map(a=>n(a)?this.convertArgument(a):a):E})}registerTreeDataProvider(m,o,g){const n=this.createTreeView(m,{treeDataProvider:o},g);return{dispose:()=>n.dispose()}}createTreeView(m,o,g){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=o.dragAndDropController?.dropMimeTypes,E=o.dragAndDropController?.dragMimeTypes,a=!!o.dragAndDropController?.handleDrag,i=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:n,dragMimeTypes:E,hasHandleDrag:a}),r=this.createExtHostTreeView(m,o,g);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(s){r.message=s},get title(){return r.title},set title(s){r.title=s},get description(){return r.description},set description(s){r.description=s},reveal:(s,l)=>r.reveal(s,l),dispose:async()=>{await i,this.treeViews.delete(m),r.dispose()}}}$getChildren(m,o){const g=this.treeViews.get(m);return g?g.getChildren(o):Promise.reject(new Error((0,d.localize)(0,null,m)))}async $handleDrop(m,o,g,n,E,a,i){const r=this.treeViews.get(m);if(!r)return Promise.reject(new Error((0,d.localize)(1,null,m)));const s=_.TreeDataTransferConverter.toITreeDataTransfer(o);return a===m&&i&&await this.addAdditionalTransferItems(s,r,i,n,E),r.onDrop(s,g,n)}async addAdditionalTransferItems(m,o,g,n,E){const a=this.treeDragAndDropService.removeDragOperationTransfer(E);if(a)(await a)?.forEach((i,r)=>{i&&m.set(r,i)});else if(E&&o.handleDrag){const i=o.handleDrag(g,m,n);this.treeDragAndDropService.addDragOperationTransfer(E,i),await i}return m}async $handleDrag(m,o,g,n){const E=this.treeViews.get(m);if(!E)return Promise.reject(new Error((0,d.localize)(2,null,m)));const a=await this.addAdditionalTransferItems(new Map,E,o,n,g);if(!!a)return _.TreeDataTransferConverter.toTreeDataTransferDTO(a)}async $hasResolve(m){const o=this.treeViews.get(m);if(!o)throw new Error((0,d.localize)(3,null,m));return o.hasResolve}$resolve(m,o,g){const n=this.treeViews.get(m);if(!n)throw new Error((0,d.localize)(4,null,m));return n.resolveTreeItem(o,g)}$setExpanded(m,o,g){const n=this.treeViews.get(m);if(!n)throw new Error((0,d.localize)(5,null,m));n.setExpanded(o,g)}$setSelection(m,o){const g=this.treeViews.get(m);if(!g)throw new Error((0,d.localize)(6,null,m));g.setSelection(o)}$setVisible(m,o){const g=this.treeViews.get(m);if(!g)throw new Error((0,d.localize)(7,null,m));g.setVisible(o)}createExtHostTreeView(m,o,g){const n=new I(m,o,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(m,n),n}convertArgument(m){const o=this.treeViews.get(m.$treeViewId);return o?o.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=v;class I extends D.Disposable{constructor(m,o,g,n,E,a){super();if(this.viewId=m,this.proxy=g,this.commands=n,this.logService=E,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,a.contributes&&a.contributes.views)for(const s in a.contributes.views)for(const l of a.contributes.views[s])l.id===m&&(this._title=l.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(s=>this._onDidChangeData.fire({message:!1,element:s}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let i,r;this._register(A.Event.debounce(this._onDidChangeData.event,(s,l)=>(s||(s={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(h=>r=h),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(l.element)?s.elements.push(...l.element):s.elements.push(l.element)),l.message&&(s.message=!0),s),200,!0)(({message:s,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=r;return i=null,this.refresh(l).then(()=>h())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,T.isUndefinedOrNull)(m))}async getChildren(m){const o=m?this.getExtensionElement(m):void 0;if(m&&!o)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);let g=this.getChildrenNodes(m);return g||(g=await this.fetchChildrenNodes(o)),g?g.map(n=>n.item):void 0}getExtensionElement(m){return this.elements.get(m)}reveal(m,o){o=o||{select:!0,focus:!1};const g=(0,T.isUndefinedOrNull)(o.select)?!0:o.select,n=(0,T.isUndefinedOrNull)(o.focus)?!1:o.focus,E=(0,T.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(a=>this.resolveTreeNode(m,a[a.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:a.map(r=>r.item)},{select:g,focus:n,expand:E})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:n,expand:E})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,o){const g=this.getExtensionElement(m);g&&(o?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(m){(0,F.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(m,o,g){const n=[];for(const E of m){const a=this.getExtensionElement(E);a&&n.push(a)}if(!(!this.dndController?.handleDrag||n.length===0))return await this.dndController.handleDrag(n,o,g),o}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(m,o,g){const n=this.getExtensionElement(o);if(!!n)return(0,P.asPromise)(()=>this.dndController?.handleDrop(m,n,g))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,o){if(!this.dataProvider.resolveTreeItem)return;const g=this.elements.get(m);if(g){const n=this.nodes.get(g);if(n){const E=await this.dataProvider.resolveTreeItem(n.extensionItem,g,o)??n.extensionItem;return n.item.tooltip=this.getTooltip(E.tooltip),n.item.command=this.getCommand(n.disposableStore,E.command),n.item}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(o=>o?this.resolveUnknownParentChain(o).then(g=>this.resolveTreeNode(o,g[g.length-1]).then(n=>(g.push(n),g))):Promise.resolve([]))}resolveParent(m){const o=this.nodes.get(m);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,o){const g=this.nodes.get(m);return g?Promise.resolve(g):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(n=>this.createHandle(m,n,o,!0)).then(n=>this.getChildren(o?o.item.handle:void 0).then(()=>{const E=this.getExtensionElement(n);if(E){const a=this.nodes.get(E);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${n}`)}))}getChildrenNodes(m){if(m){let o;if(typeof m=="string"){const g=this.getExtensionElement(m);o=g?this.nodes.get(g):void 0}else o=m;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const o=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=m?this.nodes.get(m):void 0,n=await this.dataProvider.getChildren(m);if(o.token.isCancellationRequested)return;const E=await Promise.all((0,F.coalesce)(n||[]).map(async a=>{const i=await this.dataProvider.getTreeItem(a);return i&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(a,i,g):null}));return o.token.isCancellationRequested?void 0:(0,F.coalesce)(E)}finally{o.dispose()}}refresh(m){if(m.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(m);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const o=new Set,g=m.map(E=>this.nodes.get(E));for(const E of g)if(E&&!o.has(E.item.handle)){let a=E;for(;a&&a.parent&&g.findIndex(i=>a&&a.parent&&i&&i.item.handle===a.parent.item.handle)===-1;){const i=this.elements.get(a.parent.item.handle);a=i?this.nodes.get(i):void 0}a&&!a.parent&&o.add(E.item.handle)}const n=[];return o.forEach(E=>{const a=this.elements.get(E);if(a){const i=this.nodes.get(a);i&&(!i.parent||!o.has(i.parent.item.handle))&&n.push(E)}}),n}refreshHandles(m){const o={};return Promise.all(m.map(g=>this.refreshNode(g).then(n=>{n&&(o[g]=n.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(m){const o=this.getExtensionElement(m);if(o){const g=this.nodes.get(o);if(g)return this.clearChildren(o),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(n=>{if(n){const E=this.createTreeNode(o,n,g.parent);return this.updateNodeCache(o,E,g,g.parent),g.dispose(),E}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,o,g){const n=this.createTreeNode(m,o,g);if(o.id&&this.elements.has(n.item.handle))throw new Error((0,d.localize)(8,null,o.id));return this.addNodeToCache(m,n),this.addNodeToParentCache(n,g),n}getTooltip(m){return y.MarkdownString.isMarkdownString(m)?C.MarkdownString.from(m):m}getCommand(m,o){return o?this.commands.toInternal(o,m):void 0}createTreeNode(m,o,g){const n=new D.DisposableStore,E=this.createHandle(m,o,g),a=this.getLightIconPath(o);return{item:{handle:E,parentHandle:g?g.item.handle:void 0,label:c(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(n,o.command),contextValue:o.contextValue,icon:a,iconDark:this.getDarkIconPath(o)||a,themeIcon:this.getThemeIcon(o),collapsibleState:(0,T.isUndefinedOrNull)(o.collapsibleState)?y.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:g,children:void 0,disposableStore:n,dispose(){n.dispose()}}}getThemeIcon(m){return m.iconPath instanceof y.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:o,label:g,resourceUri:n},E,a){if(o)return`${I.ID_HANDLE_PREFIX}/${o}`;const i=c(g,this.extension),r=E?E.item.handle:I.LABEL_HANDLE_PREFIX;let s=i?i.label:n?(0,t.basename)(n):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const l=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,h=this.getChildrenNodes(E)||[];let u,w=0;do{if(u=`${r}/${w}:${s}`,a||!this.elements.has(u)||l===u)break;w++}while(w<=h.length);return u}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof y.ThemeIcon))return typeof m.iconPath=="string"||k.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof y.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return k.URI.isUri(m)?m:k.URI.file(m)}addNodeToCache(m,o){this.elements.set(o.item.handle,m),this.nodes.set(m,o)}updateNodeCache(m,o,g,n){this.elements.delete(o.item.handle),this.nodes.delete(m),o.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(m,o);const E=this.getChildrenNodes(n)||[],a=E.filter(i=>i.item.handle===g.item.handle)[0];a&&E.splice(E.indexOf(a),1,o)}addNodeToParentCache(m,o){o?(o.children||(o.children=[]),o.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const o=this.nodes.get(m);if(o){if(o.children)for(const g of o.children){const n=this.elements.get(g.item.handle);n&&this.clear(n)}o.children=void 0}}else this.clearAll()}clear(m){const o=this.nodes.get(m);if(o){if(o.children)for(const g of o.children){const n=this.elements.get(g.item.handle);n&&this.clear(n)}this.nodes.delete(m),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(ve[283],be([1,0,21,16,3,47,2,114,110,151,109,42,5,133,233,232,38,234,36,235,236,237,221,238,45,39,239,240,243,244,245,136,223,250,251,252,89,34,254,282,15,7,257,68,137,35,74,210,242,83,134,70,54,72,12,64,14,26,246,206,51,65,230,255,205,67,66,260,258,259,231,44,253,256,88,53,124,248,69,249,10,118,247,203,241,6,30,211]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b,m,o,g,n,E,a,i,r,s,l,h,u,w,R,O,L,S,U,M,X,G,q,B,x,j,V,Z,se,ce,ee,Y,ae,he,we,ke,Ne,_e,Ee,z,W,N,$,K,re,de,ye,Re,We,$e,je,ze,Ue,Qe,nt,Le,et,ne,oe,J,pe,Ce,Me,He,Ye,rt,gt,vt,xe,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Et(tt){const ct=tt.get(z.IExtHostInitDataService),Pt=tt.get(Qe.IExtHostFileSystemInfo),Rt=tt.get(We.IExtHostConsumerFileSystem),Tt=tt.get(i.IExtHostExtensionService),ut=tt.get(Z.IExtHostWorkspace),Ft=tt.get(oe.IExtHostTelemetry),Mt=tt.get(b.IExtHostConfiguration),Se=tt.get(_e.IURITransformerService),ge=tt.get(Ee.IExtHostRpcService),me=tt.get(U.IExtHostStorage),ie=tt.get(Re.IExtensionStoragePaths),Ie=tt.get(Ne.ILoggerService),Ae=tt.get(Ne.ILogService),Ve=tt.get($.IExtHostTunnelService),Ge=tt.get(K.IExtHostApiDeprecationService),ot=tt.get(V.IExtHostWindow),bt=tt.get(et.IExtHostSecretState),yt=tt.get(ne.IExtHostEditorTabs);ge.set(f.ExtHostContext.ExtHostFileSystemInfo,Pt),ge.set(f.ExtHostContext.ExtHostLogLevelServiceShape,Ie),ge.set(f.ExtHostContext.ExtHostWorkspace,ut),ge.set(f.ExtHostContext.ExtHostConfiguration,Mt),ge.set(f.ExtHostContext.ExtHostExtensionService,Tt),ge.set(f.ExtHostContext.ExtHostStorage,me),ge.set(f.ExtHostContext.ExtHostTunnelService,Ve),ge.set(f.ExtHostContext.ExtHostWindow,ot),ge.set(f.ExtHostContext.ExtHostSecretState,bt),ge.set(f.ExtHostContext.ExtHostTelemetry,Ft),ge.set(f.ExtHostContext.ExtHostEditorTabs,yt);const _t=ge.set(f.ExtHostContext.ExtHostDecorations,tt.get(ae.IExtHostDecorations)),ft=ge.set(f.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(a.IExtHostDocumentsAndEditors)),at=ge.set(f.ExtHostContext.ExtHostCommands,tt.get(v.IExtHostCommands)),St=ge.set(f.ExtHostContext.ExtHostTerminalService,tt.get(M.IExtHostTerminalService)),pt=ge.set(f.ExtHostContext.ExtHostDebugService,tt.get(we.IExtHostDebugService)),Nt=ge.set(f.ExtHostContext.ExtHostSearch,tt.get(ke.IExtHostSearch)),dt=ge.set(f.ExtHostContext.ExtHostTask,tt.get(he.IExtHostTask)),kt=ge.set(f.ExtHostContext.ExtHostOutputService,tt.get(w.IExtHostOutputService)),Ut=ge.set(f.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(ge)),Ct=ge.set(f.ExtHostContext.ExtHostDocuments,new E.ExtHostDocuments(ge,ft)),Bt=ge.set(f.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(ge,ft,Ae)),xt=ge.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(Ae,Ct,ge.getProxy(f.MainContext.MainThreadBulkEdits))),mt=ge.set(f.ExtHostContext.ExtHostNotebook,new W.ExtHostNotebookController(ge,at,ft,Ct,ie)),ei=ge.set(f.ExtHostContext.ExtHostNotebookDocuments,new rt.ExtHostNotebookDocuments(Ae,mt)),Yt=ge.set(f.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(Ae,ge,mt)),ti=ge.set(f.ExtHostContext.ExtHostNotebookKernels,new J.ExtHostNotebookKernels(ge,ct,mt,at,Ae)),oi=ge.set(f.ExtHostContext.ExtHostNotebookRenderers,new Ce.ExtHostNotebookRenderers(ge,mt)),At=ge.set(f.ExtHostContext.ExtHostEditors,new X.ExtHostEditors(ge,ft)),ii=ge.set(f.ExtHostContext.ExtHostTreeViews,new G.ExtHostTreeViews(ge.getProxy(f.MainContext.MainThreadTreeViews),at,Ae)),_i=ge.set(f.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(ge.getProxy(f.MainContext.MainThreadEditorInsets),At,ct)),Kt=ge.set(f.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(ge,Ae,Pt)),Xt=ge.set(f.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(ge,Ct,at.converter,Se)),lt=ge.set(f.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(ge,Se,Ct,at,Kt,Ae,Ge)),ai=ge.set(f.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(ge,lt)),Vt=ge.set(f.ExtHostContext.ExtHostFileSystemEventService,new s.ExtHostFileSystemEventService(ge,Ae,ft)),jt=ge.set(f.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(ge,ut,at)),ni=ge.set(f.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(ge,at,Ae)),Si=ge.set(f.ExtHostContext.ExtHostComments,(0,I.createExtHostComments)(ge,at,Ct)),gi=ge.set(f.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(ge.getProxy(f.MainContext.MainThreadProgress))),Ci=ge.set(f.ExtHostContext.ExtHosLabelService,new ee.ExtHostLabelService(ge)),pi=ge.set(f.ExtHostContext.ExtHostTheming,new N.ExtHostTheming(ge)),ri=ge.set(f.ExtHostContext.ExtHostAuthentication,new re.ExtHostAuthentication(ge)),li=ge.set(f.ExtHostContext.ExtHostTimeline,new de.ExtHostTimeline(ge,at)),Jt=ge.set(f.ExtHostContext.ExtHostWebviews,new j.ExtHostWebviews(ge,{remote:ct.remote},ut,Ae,Ge)),ci=ge.set(f.ExtHostContext.ExtHostWebviewPanels,new ze.ExtHostWebviewPanels(ge,Jt,ut)),yi=ge.set(f.ExtHostContext.ExtHostCustomEditors,new je.ExtHostCustomEditors(ge,Ct,ie,Jt,ci)),Di=ge.set(f.ExtHostContext.ExtHostWebviewViews,new $e.ExtHostWebviewViews(ge,Jt)),$t=ge.set(f.ExtHostContext.ExtHostTesting,new nt.ExtHostTesting(ge,at)),Ii=ge.set(f.ExtHostContext.ExtHostUriOpeners,new Le.ExtHostUriOpeners(ge));ge.set(f.ExtHostContext.ExtHostInteractive,new gt.ExtHostInteractive(ge,mt,ft,at));const ki=(0,se.values)(f.ExtHostContext);ge.assertRegistered(ki);const Pi=new Ue.ExtHostBulkEdits(ge,ft),ui=new c.ExtHostClipboard(ge),di=new u.ExtHostMessageService(ge,Ae),Qt=new o.ExtHostDialogs(ge),zt=new S.ExtHostStatusBar(ge,at.converter);return p.ExtHostApiCommands.register(at),function(Oe,Ot,Zt){const ht=function(){let le=!Oe.isUnderDevelopment;function fe(){le||(Ae.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function Pe(Je){if(Array.isArray(Je))Je.forEach(Pe);else if(typeof Je=="string")fe();else{const wt=Je;typeof wt.scheme=="undefined"&&fe(),typeof wt.exclusive=="boolean"&&(0,xe.checkProposedApiEnabled)(Oe,"documentFiltersExclusive")}return Je}}(),Ti={getSession(le,fe,Pe){return ri.getSession(Oe,le,fe,Pe)},async hasSession(le,fe){return(0,xe.checkProposedApiEnabled)(Oe,"authSession"),!!await ri.getSession(Oe,le,fe,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(le,fe,Pe,Je){return ri.registerAuthenticationProvider(le,fe,Pe,Je)}},Ai={registerCommand(le,fe,Pe){return at.registerCommand(!0,le,fe,Pe,void 0,Oe)},registerTextEditorCommand(le,fe,Pe){return at.registerCommand(!0,le,(...Je)=>{const wt=At.getActiveTextEditor();if(!wt){Ae.warn("Cannot execute "+le+" because there is no active text editor.");return}return wt.edit(It=>{fe.apply(Pe,[wt,It,...Je])}).then(It=>{It||Ae.warn("Edits from command "+le+" were not applied.")},It=>{Ae.warn("An error occurred while running command "+le,It)})},void 0,void 0,Oe)},registerDiffInformationCommand:(le,fe,Pe)=>((0,xe.checkProposedApiEnabled)(Oe,"diffCommand"),at.registerCommand(!0,le,async(...Je)=>{const wt=ft.activeEditor(!0);if(!wt){Ae.warn("Cannot execute "+le+" because there is no active text editor.");return}const It=await At.getDiffInformation(wt.id);fe.apply(Pe,[It,...Je])},void 0,void 0,Oe)),executeCommand(le,...fe){return at.executeCommand(le,...fe)},getCommands(le=!1){return at.getCommands(le)}},vi={get machineId(){return ct.telemetryInfo.machineId},get sessionId(){return ct.telemetryInfo.sessionId},get language(){return ct.environment.appLanguage},get appName(){return ct.environment.appName},get appRoot(){return ct.environment.appRoot?.fsPath??""},get appHost(){return ct.environment.appHost},get uriScheme(){return ct.environment.appUriScheme},get clipboard(){return ui.value},get shell(){return St.getDefaultShell(!1)},get isTelemetryEnabled(){return Ft.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ft.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,xe.checkProposedApiEnabled)(Oe,"telemetry"),Ft.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.checkProposedApiEnabled)(Oe,"telemetry"),Ft.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const le=Date.now()-new Date(ct.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,fe){return ot.openUri(le,{allowTunneling:!!ct.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===ct.environment.appUriScheme)return Ut.createAppUri(le);try{return await ot.asExternalUri(le,{allowTunneling:!!ct.remote.authority})}catch(fe){if((0,He.matchesScheme)(le,Me.Schemas.http)||(0,He.matchesScheme)(le,Me.Schemas.https))return le;throw fe}},get remoteName(){return(0,Y.getRemoteName)(ct.remote.authority)},get remoteAuthority(){return(0,xe.checkProposedApiEnabled)(Oe,"resolvers"),ct.remote.authority},get uiKind(){return ct.uiKind}};ct.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=ct.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Ri={createTestController(le,fe,Pe){return Pe&&(0,xe.checkProposedApiEnabled)(Oe,"testRefresh"),$t.createTestController(le,fe,Pe)},createTestObserver(){return(0,xe.checkProposedApiEnabled)(Oe,"testObserver"),$t.createTestObserver()},runTests(le){return(0,xe.checkProposedApiEnabled)(Oe,"testObserver"),$t.runTests(le)},get onDidChangeTestResults(){return(0,xe.checkProposedApiEnabled)(Oe,"testObserver"),$t.onResultsChanged},get testResults(){return(0,xe.checkProposedApiEnabled)(Oe,"testObserver"),$t.results}},Li={getExtension(le){const fe=Ot.getExtensionDescription(le);if(fe)return new i.Extension(Tt,Oe.identifier,fe,wi)},get all(){return Ot.getAllExtensionDescriptions().map(le=>new i.Extension(Tt,Oe.identifier,le,wi))},get onDidChange(){return Ot.onDidChange}},hi={createDiagnosticCollection(le){return Kt.createDiagnosticCollection(Oe.identifier,le)},get onDidChangeDiagnostics(){return Kt.onDidChangeDiagnostics},getDiagnostics:le=>Kt.getDiagnostics(le),getLanguages(){return Xt.getLanguages()},setTextDocumentLanguage(le,fe){return Xt.changeLanguage(le.uri,fe)},match(le,fe){return(0,F.score)(q.LanguageSelector.from(le),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(le,fe,Pe){return lt.registerCodeActionProvider(Oe,ht(le),fe,Pe)},registerCodeLensProvider(le,fe){return lt.registerCodeLensProvider(Oe,ht(le),fe)},registerDefinitionProvider(le,fe){return lt.registerDefinitionProvider(Oe,ht(le),fe)},registerDeclarationProvider(le,fe){return lt.registerDeclarationProvider(Oe,ht(le),fe)},registerImplementationProvider(le,fe){return lt.registerImplementationProvider(Oe,ht(le),fe)},registerTypeDefinitionProvider(le,fe){return lt.registerTypeDefinitionProvider(Oe,ht(le),fe)},registerHoverProvider(le,fe){return lt.registerHoverProvider(Oe,ht(le),fe,Oe.identifier)},registerEvaluatableExpressionProvider(le,fe){return lt.registerEvaluatableExpressionProvider(Oe,ht(le),fe,Oe.identifier)},registerInlineValuesProvider(le,fe){return lt.registerInlineValuesProvider(Oe,ht(le),fe,Oe.identifier)},registerDocumentHighlightProvider(le,fe){return lt.registerDocumentHighlightProvider(Oe,ht(le),fe)},registerLinkedEditingRangeProvider(le,fe){return lt.registerLinkedEditingRangeProvider(Oe,ht(le),fe)},registerReferenceProvider(le,fe){return lt.registerReferenceProvider(Oe,ht(le),fe)},registerRenameProvider(le,fe){return lt.registerRenameProvider(Oe,ht(le),fe)},registerDocumentSymbolProvider(le,fe,Pe){return lt.registerDocumentSymbolProvider(Oe,ht(le),fe,Pe)},registerWorkspaceSymbolProvider(le){return lt.registerWorkspaceSymbolProvider(Oe,le)},registerDocumentFormattingEditProvider(le,fe){return lt.registerDocumentFormattingEditProvider(Oe,ht(le),fe)},registerDocumentRangeFormattingEditProvider(le,fe){return lt.registerDocumentRangeFormattingEditProvider(Oe,ht(le),fe)},registerOnTypeFormattingEditProvider(le,fe,Pe,...Je){return lt.registerOnTypeFormattingEditProvider(Oe,ht(le),fe,[Pe].concat(Je))},registerDocumentSemanticTokensProvider(le,fe,Pe){return lt.registerDocumentSemanticTokensProvider(Oe,ht(le),fe,Pe)},registerDocumentRangeSemanticTokensProvider(le,fe,Pe){return lt.registerDocumentRangeSemanticTokensProvider(Oe,ht(le),fe,Pe)},registerSignatureHelpProvider(le,fe,Pe,...Je){return typeof Pe=="object"?lt.registerSignatureHelpProvider(Oe,ht(le),fe,Pe):lt.registerSignatureHelpProvider(Oe,ht(le),fe,typeof Pe=="undefined"?[]:[Pe,...Je])},registerCompletionItemProvider(le,fe,...Pe){return lt.registerCompletionItemProvider(Oe,ht(le),fe,Pe)},registerInlineCompletionItemProvider(le,fe){return(0,xe.checkProposedApiEnabled)(Oe,"inlineCompletions"),lt.registerInlineCompletionsProvider(Oe,ht(le),fe)},registerDocumentLinkProvider(le,fe){return lt.registerDocumentLinkProvider(Oe,ht(le),fe)},registerColorProvider(le,fe){return lt.registerColorProvider(Oe,ht(le),fe)},registerFoldingRangeProvider(le,fe){return lt.registerFoldingRangeProvider(Oe,ht(le),fe)},registerSelectionRangeProvider(le,fe){return lt.registerSelectionRangeProvider(Oe,le,fe)},registerCallHierarchyProvider(le,fe){return lt.registerCallHierarchyProvider(Oe,le,fe)},registerTypeHierarchyProvider(le,fe){return lt.registerTypeHierarchyProvider(Oe,le,fe)},setLanguageConfiguration:(le,fe)=>lt.setLanguageConfiguration(Oe,le,fe),getTokenInformationAtPosition(le,fe){return(0,xe.checkProposedApiEnabled)(Oe,"tokenInformation"),Xt.tokenAtPosition(le,fe)},registerInlayHintsProvider(le,fe){return(0,xe.checkProposedApiEnabled)(Oe,"inlayHints"),lt.registerInlayHintsProvider(Oe,le,fe)},createLanguageStatusItem(le,fe){return(0,xe.checkProposedApiEnabled)(Oe,"languageStatus"),Xt.createLanguageStatusItem(Oe,le,fe)}},Oi={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(le,fe,Pe){const Je=await(D.URI.isUri(le)?Promise.resolve(bi.openTextDocument(le)):Promise.resolve(le));return At.showTextDocument(Je,fe,Pe)},createTextEditorDecorationType(le){return At.createTextEditorDecorationType(Oe,le)},onDidChangeActiveTextEditor(le,fe,Pe){return At.onDidChangeActiveTextEditor(le,fe,Pe)},onDidChangeVisibleTextEditors(le,fe,Pe){return At.onDidChangeVisibleTextEditors(le,fe,Pe)},onDidChangeTextEditorSelection(le,fe,Pe){return At.onDidChangeTextEditorSelection(le,fe,Pe)},onDidChangeTextEditorOptions(le,fe,Pe){return At.onDidChangeTextEditorOptions(le,fe,Pe)},onDidChangeTextEditorVisibleRanges(le,fe,Pe){return At.onDidChangeTextEditorVisibleRanges(le,fe,Pe)},onDidChangeTextEditorViewColumn(le,fe,Pe){return At.onDidChangeTextEditorViewColumn(le,fe,Pe)},onDidCloseTerminal(le,fe,Pe){return St.onDidCloseTerminal(le,fe,Pe)},onDidOpenTerminal(le,fe,Pe){return St.onDidOpenTerminal(le,fe,Pe)},onDidChangeActiveTerminal(le,fe,Pe){return St.onDidChangeActiveTerminal(le,fe,Pe)},onDidChangeTerminalDimensions(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"terminalDimensions"),St.onDidChangeTerminalDimensions(le,fe,Pe)},onDidChangeTerminalState(le,fe,Pe){return St.onDidChangeTerminalState(le,fe,Pe)},onDidWriteTerminalData(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"terminalDataWriteEvent"),St.onDidWriteTerminalData(le,fe,Pe)},get state(){return ot.state},onDidChangeWindowState(le,fe,Pe){return ot.onDidChangeWindowState(le,fe,Pe)},showInformationMessage(le,...fe){return di.showMessage(Oe,A.default.Info,le,fe[0],fe.slice(1))},showWarningMessage(le,...fe){return di.showMessage(Oe,A.default.Warning,le,fe[0],fe.slice(1))},showErrorMessage(le,...fe){return di.showMessage(Oe,A.default.Error,le,fe[0],fe.slice(1))},showQuickPick(le,fe,Pe){return jt.showQuickPick(le,fe,Pe)},showWorkspaceFolderPick(le){return jt.showWorkspaceFolderPick(le)},showInputBox(le,fe){return jt.showInput(le,fe)},showOpenDialog(le){return Qt.showOpenDialog(le)},showSaveDialog(le){return Qt.showSaveDialog(le)},createStatusBarItem(le,fe,Pe){let Je,wt,It;return typeof le=="string"?(Je=le,wt=fe,It=Pe):(wt=le,It=fe),zt.createStatusBarEntry(Oe,Je,wt,It)},setStatusBarMessage(le,fe){return zt.setStatusBarMessage(le,fe)},withScmProgress(le){return Ge.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),gi.withProgress(Oe,{location:B.ProgressLocation.SourceControl},(fe,Pe)=>le({report(Je){}}))},withProgress(le,fe){return gi.withProgress(Oe,le,fe)},createOutputChannel(le){return kt.createOutputChannel(le,Oe)},createWebviewPanel(le,fe,Pe,Je){return ci.createWebviewPanel(Oe,le,fe,Pe,Je)},createWebviewTextEditorInset(le,fe,Pe,Je){return(0,xe.checkProposedApiEnabled)(Oe,"editorInsets"),_i.createWebviewEditorInset(le,fe,Pe,Je,Oe)},createTerminal(le,fe,Pe){return le&&typeof le=="object"&&"disablePersistence"in le&&(0,xe.checkProposedApiEnabled)(Oe,"terminalDisablePersistence"),typeof le=="object"?"pty"in le?St.createExtensionTerminal(le):St.createTerminalFromOptions(le):St.createTerminal(le,fe,Pe)},registerTerminalLinkProvider(le){return St.registerLinkProvider(le)},registerTerminalProfileProvider(le,fe){return St.registerProfileProvider(Oe,le,fe)},registerTreeDataProvider(le,fe){return ii.registerTreeDataProvider(le,fe,Oe)},createTreeView(le,fe){return ii.createTreeView(le,fe,Oe)},registerWebviewPanelSerializer:(le,fe)=>ci.registerWebviewPanelSerializer(Oe,le,fe),registerCustomEditorProvider:(le,fe,Pe={})=>yi.registerCustomEditorProvider(Oe,le,fe,Pe),registerFileDecorationProvider(le){return _t.registerFileDecorationProvider(le,Oe.identifier)},registerUriHandler(le){return Ut.registerUriHandler(Oe.identifier,le)},createQuickPick(){return jt.createQuickPick(Oe)},createInputBox(){return jt.createInputBox(Oe.identifier)},get activeColorTheme(){return pi.activeColorTheme},onDidChangeActiveColorTheme(le,fe,Pe){return pi.onDidChangeActiveColorTheme(le,fe,Pe)},registerWebviewViewProvider(le,fe,Pe){return Di.registerWebviewViewProvider(Oe,le,fe,Pe?.webviewOptions)},get activeNotebookEditor(){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),mt.onDidChangeActiveNotebookEditor(le,fe,Pe)},get visibleNotebookEditors(){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),Yt.onDidChangeNotebookEditorSelection(le,fe,Pe)},onDidChangeNotebookEditorVisibleRanges(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),Yt.onDidChangeNotebookEditorVisibleRanges(le,fe,Pe)},showNotebookDocument(le,fe){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),mt.showNotebookDocument(le,fe)},registerExternalUriOpener(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"externalUriOpener"),Ii.registerExternalUriOpener(Oe.identifier,le,fe,Pe)},get tabs(){return(0,xe.checkProposedApiEnabled)(Oe,"tabs"),yt.tabs},get activeTab(){return(0,xe.checkProposedApiEnabled)(Oe,"tabs"),yt.activeTab},get onDidChangeTabs(){return(0,xe.checkProposedApiEnabled)(Oe,"tabs"),yt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,xe.checkProposedApiEnabled)(Oe,"tabs"),yt.onDidChangeActiveTab},getInlineCompletionItemController(le){return(0,xe.checkProposedApiEnabled)(Oe,"inlineCompletions"),l.InlineCompletionController.get(le)}},bi={get rootPath(){return Ge.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ut.getPath()},set rootPath(le){throw t.readonly()},getWorkspaceFolder(le){return ut.getWorkspaceFolder(le)},get workspaceFolders(){return ut.getWorkspaceFolders()},get name(){return ut.name},set name(le){throw t.readonly()},get workspaceFile(){return ut.workspaceFile},set workspaceFile(le){throw t.readonly()},updateWorkspaceFolders:(le,fe,...Pe)=>ut.updateWorkspaceFolders(Oe,le,fe||0,...Pe),onDidChangeWorkspaceFolders:function(le,fe,Pe){return ut.onDidChangeWorkspace(le,fe,Pe)},asRelativePath:(le,fe)=>ut.getRelativePath(le,fe),findFiles:(le,fe,Pe,Je)=>ut.findFiles(le,fe,Pe,Oe.identifier,Je),findTextInFiles:(le,fe,Pe,Je)=>{(0,xe.checkProposedApiEnabled)(Oe,"findTextInFiles");let wt,It;return typeof fe=="object"?(wt=fe,It=Pe):(wt={},It=fe,Je=Pe),ut.findTextInFiles(le,wt||{},It,Oe.identifier,Je)},saveAll:le=>ut.saveAll(le),applyEdit(le){return Pi.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,fe,Pe,Je)=>Vt.createFileSystemWatcher(ut,Oe,le,fe,Pe,Je),get textDocuments(){return Ct.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw t.readonly()},openTextDocument(le){let fe;const Pe=le;if(typeof le=="string")fe=Promise.resolve(D.URI.file(le));else if(D.URI.isUri(le))fe=Promise.resolve(le);else if(!Pe||typeof Pe=="object")fe=Ct.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(Je=>Ct.ensureDocumentData(Je).then(wt=>wt.document))},onDidOpenTextDocument:(le,fe,Pe)=>Ct.onDidAddDocument(le,fe,Pe),onDidCloseTextDocument:(le,fe,Pe)=>Ct.onDidRemoveDocument(le,fe,Pe),onDidChangeTextDocument:(le,fe,Pe)=>Ct.onDidChangeDocument(le,fe,Pe),onDidSaveTextDocument:(le,fe,Pe)=>Ct.onDidSaveDocument(le,fe,Pe),onWillSaveTextDocument:(le,fe,Pe)=>xt.getOnWillSaveTextDocumentEvent(Oe)(le,fe,Pe),get notebookDocuments(){return mt.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,fe){let Pe;if(D.URI.isUri(le))Pe=le,await mt.openNotebookDocument(le);else if(typeof le=="string")Pe=D.URI.revive(await mt.createNotebookDocument({viewType:le,content:fe}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Pe).apiNotebook},get onDidOpenNotebookDocument(){return mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return mt.onDidCloseNotebookDocument},registerNotebookSerializer(le,fe,Pe,Je){return mt.registerNotebookSerializer(Oe,le,fe,Pe,(0,xe.isProposedApiEnabled)(Oe,"notebookLiveShare")?Je:void 0)},registerNotebookContentProvider:(le,fe,Pe,Je)=>((0,xe.checkProposedApiEnabled)(Oe,"notebookContentProvider"),mt.registerNotebookContentProvider(Oe,le,fe,Pe,(0,xe.isProposedApiEnabled)(Oe,"notebookLiveShare")?Je:void 0)),onDidChangeConfiguration:(le,fe,Pe)=>Zt.onDidChangeConfiguration(le,fe,Pe),getConfiguration(le,fe){return fe=arguments.length===1?void 0:fe,Zt.getConfiguration(le,fe,Oe)},registerTextDocumentContentProvider(le,fe){return Bt.registerTextDocumentContentProvider(le,fe)},registerTaskProvider:(le,fe)=>(Ge.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),dt.registerTaskProvider(Oe,le,fe)),registerFileSystemProvider(le,fe,Pe){return(0,vt.combinedDisposable)(ai.registerFileSystemProvider(Oe,le,fe,Pe),Rt.addFileSystemProvider(le,fe))},get fs(){return Rt.value},registerFileSearchProvider:(le,fe)=>((0,xe.checkProposedApiEnabled)(Oe,"fileSearchProvider"),Nt.registerFileSearchProvider(le,fe)),registerTextSearchProvider:(le,fe)=>((0,xe.checkProposedApiEnabled)(Oe,"textSearchProvider"),Nt.registerTextSearchProvider(le,fe)),registerRemoteAuthorityResolver:(le,fe)=>((0,xe.checkProposedApiEnabled)(Oe,"resolvers"),Tt.registerRemoteAuthorityResolver(le,fe)),registerResourceLabelFormatter:le=>((0,xe.checkProposedApiEnabled)(Oe,"resolvers"),Ci.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,fe,Pe)=>Vt.onDidCreateFile(le,fe,Pe),onDidDeleteFiles:(le,fe,Pe)=>Vt.onDidDeleteFile(le,fe,Pe),onDidRenameFiles:(le,fe,Pe)=>Vt.onDidRenameFile(le,fe,Pe),onWillCreateFiles:(le,fe,Pe)=>Vt.getOnWillCreateFileEvent(Oe)(le,fe,Pe),onWillDeleteFiles:(le,fe,Pe)=>Vt.getOnWillDeleteFileEvent(Oe)(le,fe,Pe),onWillRenameFiles:(le,fe,Pe)=>Vt.getOnWillRenameFileEvent(Oe)(le,fe,Pe),openTunnel:le=>((0,xe.checkProposedApiEnabled)(Oe,"resolvers"),Ve.openTunnel(Oe,le).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,xe.checkProposedApiEnabled)(Oe,"resolvers"),Ve.getTunnels()},onDidChangeTunnels:(le,fe,Pe)=>((0,xe.checkProposedApiEnabled)(Oe,"resolvers"),Ve.onDidChangeTunnels(le,fe,Pe)),registerPortAttributesProvider:(le,fe)=>((0,xe.checkProposedApiEnabled)(Oe,"portsAttributes"),Ve.registerPortsAttributesProvider(le,fe)),registerTimelineProvider:(le,fe)=>((0,xe.checkProposedApiEnabled)(Oe,"timeline"),li.registerTimelineProvider(le,fe,Oe.identifier,at.converter)),get isTrusted(){return ut.trusted},requestWorkspaceTrust:le=>((0,xe.checkProposedApiEnabled)(Oe,"workspaceTrust"),ut.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,fe,Pe)=>ut.onDidGrantWorkspaceTrust(le,fe,Pe)},Fi={get inputBox(){return Ge.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Oe)},createSourceControl(le,fe,Pe){return ni.createSourceControl(Oe,le,fe,Pe)}},Ni={createCommentController(le,fe){return Si.createCommentController(Oe,le,fe)}},Mi={get activeDebugSession(){return pt.activeDebugSession},get activeDebugConsole(){return pt.activeDebugConsole},get breakpoints(){return pt.breakpoints},onDidStartDebugSession(le,fe,Pe){return pt.onDidStartDebugSession(le,fe,Pe)},onDidTerminateDebugSession(le,fe,Pe){return pt.onDidTerminateDebugSession(le,fe,Pe)},onDidChangeActiveDebugSession(le,fe,Pe){return pt.onDidChangeActiveDebugSession(le,fe,Pe)},onDidReceiveDebugSessionCustomEvent(le,fe,Pe){return pt.onDidReceiveDebugSessionCustomEvent(le,fe,Pe)},onDidChangeBreakpoints(le,fe,Pe){return pt.onDidChangeBreakpoints(le,fe,Pe)},registerDebugConfigurationProvider(le,fe,Pe){return pt.registerDebugConfigurationProvider(le,fe,Pe||st.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,fe){return pt.registerDebugAdapterDescriptorFactory(Oe,le,fe)},registerDebugAdapterTrackerFactory(le,fe){return pt.registerDebugAdapterTrackerFactory(le,fe)},startDebugging(le,fe,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?pt.startDebugging(le,fe,{parentSession:Pe}):pt.startDebugging(le,fe,Pe||{})},stopDebugging(le){return pt.stopDebugging(le)},addBreakpoints(le){return pt.addBreakpoints(le)},removeBreakpoints(le){return pt.removeBreakpoints(le)},asDebugSourceUri(le,fe){return pt.asDebugSourceUri(le,fe)}},Ui={registerTaskProvider:(le,fe)=>dt.registerTaskProvider(Oe,le,fe),fetchTasks:le=>dt.fetchTasks(le),executeTask:le=>dt.executeTask(Oe,le),get taskExecutions(){return dt.taskExecutions},onDidStartTask:(le,fe,Pe)=>dt.onDidStartTask(le,fe,Pe),onDidEndTask:(le,fe,Pe)=>dt.onDidEndTask(le,fe,Pe),onDidStartTaskProcess:(le,fe,Pe)=>dt.onDidStartTaskProcess(le,fe,Pe),onDidEndTaskProcess:(le,fe,Pe)=>dt.onDidEndTaskProcess(le,fe,Pe)},Bi={createNotebookController(le,fe,Pe,Je,wt){return ti.createNotebookController(Oe,le,fe,Pe,Je,(0,xe.isProposedApiEnabled)(Oe,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(le,fe)=>mt.registerNotebookCellStatusBarItemProvider(Oe,le,fe),get onDidSaveNotebookDocument(){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return oi.createRendererMessaging(Oe,le)},onDidChangeNotebookDocumentMetadata(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(le,fe,Pe)},onDidChangeNotebookCells(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),mt.onDidChangeNotebookCells(le,fe,Pe)},onDidChangeNotebookCellExecutionState(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(le,fe,Pe)},onDidChangeCellOutputs(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),mt.onDidChangeCellOutputs(le,fe,Pe)},onDidChangeCellMetadata(le,fe,Pe){return(0,xe.checkProposedApiEnabled)(Oe,"notebookEditor"),mt.onDidChangeCellMetadata(le,fe,Pe)},createConcatTextDocument(le,fe){return(0,xe.checkProposedApiEnabled)(Oe,"notebookConcatTextDocument"),new ye.ExtHostNotebookConcatDocument(mt,Ct,le,fe)}};return{version:ct.version,authentication:Ti,commands:Ai,comments:Ni,debug:Mi,env:vi,extensions:Li,languages:hi,notebooks:Bi,scm:Fi,tasks:Ui,tests:Ri,window:Oi,workspace:bi,Breakpoint:B.Breakpoint,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:st.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestions,Hover:B.Hover,IndentAction:T.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:_.UIKind,Uri:D.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TreeDataTransfer:B.TreeDataTransfer,TreeDataTransferItem:B.TreeDataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Et}),define(ve[284],be([1,0,285,294,295,2,296]),function(te,e,d,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(C,f,_,p,c,v){const I=v.environment.useHostProxy,b=typeof I=="boolean"?I:!v.remote.isRemote,m=(0,D.createProxyResolver)({resolveProxy:g=>C.resolveProxy(g),getHttpProxySetting:()=>f.getConfiguration("http").get("proxy"),log:(g,n,...E)=>{switch(g){case D.LogLevel.Trace:p.trace(n,...E);break;case D.LogLevel.Debug:p.debug(n,...E);break;case D.LogLevel.Info:p.info(n,...E);break;case D.LogLevel.Warning:p.warn(n,...E);break;case D.LogLevel.Error:p.error(n,...E);break;case D.LogLevel.Critical:p.critical(n,...E);break;case D.LogLevel.Off:break;default:a(g,n,E);break}function a(i,r,...s){p.error("Unknown log level",i),p.error(r,...s)}},getLogLevel:()=>p.getLevel(),proxyResolveTelemetry:g=>{c.$publicLog2("resolveProxy",g)},useHostProxy:b,env:process.env}),o=y(f,m);return F(_,o)}e.connectProxyResolver=P;function y(C,f){const _={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(c=>{_.config=C.getConfiguration("http").get("proxySupport")||"off"});const p={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(c=>{p.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},d,(0,D.createHttpPatch)(d,f,{config:"off"},p,!0)),on:Object.assign({},d,(0,D.createHttpPatch)(d,f,{config:"on"},p,!0)),override:Object.assign({},d,(0,D.createHttpPatch)(d,f,{config:"override"},p,!0)),onRequest:Object.assign({},d,(0,D.createHttpPatch)(d,f,_,p,!0)),default:Object.assign(d,(0,D.createHttpPatch)(d,f,_,p,!1))},https:{off:Object.assign({},t,(0,D.createHttpPatch)(t,f,{config:"off"},p,!0)),on:Object.assign({},t,(0,D.createHttpPatch)(t,f,{config:"on"},p,!0)),override:Object.assign({},t,(0,D.createHttpPatch)(t,f,{config:"override"},p,!0)),onRequest:Object.assign({},t,(0,D.createHttpPatch)(t,f,_,p,!0)),default:Object.assign(t,(0,D.createHttpPatch)(t,f,_,p,!1))},tls:Object.assign(k,(0,D.createTlsPatch)(k))}}const T=new Map;function F(C,f){return C.getExtensionPathIndex().then(_=>{const p=te.__$__nodeRequire("module"),c=p._load;p._load=function(I,b,m){if(I==="tls")return f.tls;if(I!=="http"&&I!=="https")return c.apply(this,arguments);const o=f[I],g=_.findSubstr(A.URI.file(b.filename));let n=T.get(g);if(n||T.set(g,n={}),!n[I]){let E=o.default;n[I]={...E}}return n[I]}})}}),define(ve[140],be([1,0,37,297,103,17,74,32,9,8,2,31,69,298,278,90]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class I{constructor(u){this.outputChannel=u}provideTextSearchResults(u,w,R,O){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((L,S)=>{O.onCancellationRequested(()=>j());const U=E(u,w),M=w.folder.fsPath,X=U.map(ee=>ee.match(/^-/)?ee:`'${ee}'`).join(" ");this.outputChannel.appendLine(`${v} ${X}
 - cwd: ${M}`);let G=d.spawn(v,U,{cwd:M});G.on("error",ee=>{console.error(ee),this.outputChannel.appendLine("Error: "+(ee&&ee.message)),S((0,C.serializeSearchError)(new C.SearchError(ee&&ee.message,C.SearchErrorCode.rgProcessError)))});let q=!1;const B=new o(w.maxResults,M,w.previewOptions);B.on("result",ee=>{q=!0,Z="",R.report(ee)});let x=!1;const j=()=>{x=!0,G&&G.kill(),B&&B.cancel()};let V=!1;B.on("hitLimit",()=>{V=!0,j()});let Z="";G.stdout.on("data",ee=>{B.handleData(ee),q||(Z+=ee)});let se=!1;G.stdout.once("data",()=>se=!0);let ce="";G.stderr.on("data",ee=>{const Y=ee.toString();this.outputChannel.appendLine(Y),ce+=Y}),G.on("close",()=>{if(this.outputChannel.appendLine(se?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(q?"Got result from parser":"No result from parser"),Z&&this.outputChannel.appendLine(`Got data without result: ${Z}`),this.outputChannel.appendLine(""),x)L({limitHit:V});else{B.flush(),G=null;let ee;ce&&!se&&(ee=b(ce))?S((0,C.serializeSearchError)(new C.SearchError(ee.message,ee.code))):L({limitHit:V})}})})}}e.RipgrepTextSearchEngine=I;function b(h){const u=h.split(`
`),w=u[0].trim();if(u.some(O=>O.startsWith("regex parse error")))return new C.SearchError(m(u),C.SearchErrorCode.regexParseError);const R=w.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new C.SearchError(w.charAt(0).toUpperCase()+w.substr(1),C.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new C.SearchError(w.charAt(0).toUpperCase()+w.substr(1),C.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(w,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function m(h){const u=["Regex parse error"],w=h.filter(R=>R.startsWith("PCRE2:"));if(w.length>=1){const R=w[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const O=R.split(":")[1];u.push(":"+O)}}return u.join("")}e.buildRegexParseError=m;class o extends t.EventEmitter{constructor(u,w,R){super();this.maxResults=u,this.rootFolder=w,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,w){return super.on(u,w),this}handleData(u){if(this.isDone)return;const w=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(w)}handleDecodedData(u){let w=u.indexOf(`
`);const R=this.remainder+u;if(w>=0)w+=this.remainder.length;else{this.remainder=R;return}let O=0;for(;w>=0;)this.handleLine(R.substring(O,w).trim()),O=w+1,w=R.indexOf(`
`,O);this.remainder=R.substring(O)}handleLine(u){if(this.isDone||!u)return;let w;try{w=JSON.parse(u)}catch{throw new Error(`malformed line from rg: ${u}`)}if(w.type==="match"){const R=g(w.data.path),O=F.URI.file(y.join(this.rootFolder,R)),L=this.createTextSearchMatch(w.data,O);this.onResult(L),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const R=g(w.data.path),O=F.URI.file(y.join(this.rootFolder,R));this.createTextSearchContext(w.data,O).forEach(S=>this.onResult(S))}}createTextSearchMatch(u,w){const R=u.line_number-1,O=g(u.lines),L=Buffer.from(O);let S=0,U=0,M=R;u.submatches.length===0&&u.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const X=(0,A.coalesce)(u.submatches.map((G,q)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=g(G.match),x=L.slice(S,G.start).toString().length,j=U+x,V=n(B),Z=M,se=V.numLines+Z,ce=V.numLines>0?V.lastLineLength:V.lastLineLength+j;return S=G.end,U=ce,M=se,new f.Range(Z,j,se,ce)}));return(0,c.createTextSearchResult)(w,O,X,this.previewOptions)}createTextSearchContext(u,w){const R=g(u.lines),O=u.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((L,S)=>({text:L,uri:w,lineNumber:O+S}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=o;function g(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function n(h){const u=/\n/g;let w=0,R=-1,O;for(;O=u.exec(h);)w++,R=O.index;const L=R>=0?h.length-R-1:h.length;return{numLines:w,lastLineLength:L}}function E(h,u){const w=["--hidden"];w.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:O}=(0,D.groupBy)(u.includes,S=>S.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const S=new Set;O.forEach(U=>{S.add(U)}),w.push("-g","!*"),S.forEach(U=>{a(U).map(c.anchorGlob).forEach(M=>{w.push("-g",M)})})}R&&R.length&&R.forEach(S=>{w.push("-g",S)}),u.excludes.map(c.anchorGlob).forEach(S=>w.push("-g",`!${S}`)),u.maxFileSize&&w.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?u.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),u.followSymlinks&&w.push("--follow"),u.encoding&&u.encoding!=="utf8"&&w.push("--encoding",u.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,T.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),u.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),h.isRegExp&&(h.pattern=i(h.pattern),w.push("--engine","auto"));let L;if(h.isWordMatch){const U=(0,T.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",U)}else if(h.isRegExp){let S=s(h.pattern);S=l(S),w.push("--regexp",S)}else L=h.pattern,w.push("--fixed-strings");return w.push("--no-config"),u.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),h.isMultiline&&w.push("--multiline"),u.beforeContext&&w.push("--before-context",u.beforeContext+""),u.afterContext&&w.push("--after-context",u.afterContext+""),w.push("--"),L&&w.push(L),w.push("."),w}function a(h){const u=(0,P.splitGlobAware)(h,"/");return u.map((w,R)=>u.slice(0,R+1).join("/"))}e.spreadGlobComponents=a;function i(h){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(u);)h=h.replace(u,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(w);)h=h.replace(w,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=i;const r=h=>h.type==="Assertion"&&h.kind==="lookbehind";function s(h){let u;try{u=new _.RegExpParser().parsePattern(h)}catch{return h}let w="",R=0;const O=(U,M,X)=>{w+=h.slice(R,U)+X,R=M},L=[];return new _.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const M=L[0];if(!M)O(U.start,U.end,"\\r?\\n");else if(!L.some(r))if(M.type==="CharacterClass")if(M.negate){const X=h.slice(M.start+2,U.start)+h.slice(U.end,M.end-1);M.parent?.type==="Quantifier"?O(M.start,M.end,X?`[^${X}]`:"."):O(M.start,M.end,"(?!\\r?\\n"+(X?`|[${X}]`:"")+")")}else{const X=h.slice(M.start+1,U.start)+h.slice(U.end,M.end-1);O(M.start,M.end,X===""?"\\r?\\n":`(?:[${X}]|\\r?\\n)`)}else M.type==="Quantifier"&&O(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){L.unshift(U)},onQuantifierLeave(){L.shift()},onCharacterClassRangeEnter(U){L.unshift(U)},onCharacterClassRangeLeave(){L.shift()},onCharacterClassEnter(U){L.unshift(U)},onCharacterClassLeave(){L.shift()},onAssertionEnter(U){r(U)&&L.push(U)},onAssertionLeave(U){L[0]===U&&L.shift()}}).visit(u),w+=h.slice(R),w}e.fixRegexNewline=s;function l(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=l}),define(ve[286],be([1,0,21,140,119,10]),function(te,e,d,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(T){this.outputChannel=T,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(T,F,C,f){const _=new t.RipgrepTextSearchEngine(this.outputChannel);if(F.folder.scheme===A.Schemas.userData){const p={...F,folder:F.folder.with({scheme:A.Schemas.file})},c=new k.Progress(v=>C.report({...v,uri:v.uri.with({scheme:F.folder.scheme})}));return this.withToken(f,v=>_.provideTextSearchResults(T,p,c,v))}else return this.withToken(f,p=>_.provideTextSearchResults(T,F,C,p))}async withToken(T,F){const C=P(T);this.inProgress.add(C);const f=await F(C.token);return this.inProgress.delete(C),f}dispose(){this.inProgress.forEach(T=>T.cancel())}}e.RipgrepSearchProvider=D;function P(y){const T=new d.CancellationTokenSource;return y.onCancellationRequested(()=>T.cancel()),T}}),define(ve[287],be([1,0,29,140,139]),function(te,e,d,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(y){this.query=y}search(y,T,F){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(_){F({message:_})}},f=new k.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(C),d);return new Promise((_,p)=>f.search(c=>{T(c.map(D))},y).then(c=>_({limitHit:c.limitHit,type:"success",stats:c.stats}),p))}}e.TextSearchEngineAdapter=A;function D(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((y,T)=>{if(T.ranges){const F=T;return y+(Array.isArray(F.ranges)?F.ranges.length:1)}else return y+1},0)}}}),define(ve[288],be([1,0,17,13,16,3,100,9,46,2,42,31,279,287]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class p{constructor(o="searchProcess"){this.processType=o,this.caches=Object.create(null)}fileSearch(o){let g;const n=I(o),E=new A.Emitter({onFirstListenerDidAdd:()=>{g=(0,t.createCancelablePromise)(a=>this.doFileSearchWithEngine(f.Engine,n,i=>E.fire(i),a)),g.then(a=>E.fire(a),a=>E.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return E.event}textSearch(o){let g;const n=I(o),E=new A.Emitter({onFirstListenerDidAdd:()=>{g=(0,t.createCancelablePromise)(a=>this.ripgrepTextSearch(n,i=>E.fire(i),a)),g.then(a=>E.fire(a),a=>E.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return E.event}ripgrepTextSearch(o,g,n){return o.maxFileSize=(0,F.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new _.TextSearchEngineAdapter(o).search(n,g,g)}doFileSearch(o,g,n){return this.doFileSearchWithEngine(f.Engine,o,g,n)}doFileSearchWithEngine(o,g,n,E,a=p.BATCH_SIZE){let i=0;const r=l=>{Array.isArray(l)?(i+=l.length,n(l.map(h=>this.rawMatchToSearchItem(h)))):l.relativePath?(i++,n(this.rawMatchToSearchItem(l))):n(l)};if(g.sortByScore){let l=this.trySortedSearchFromCache(g,r,E);if(!l){const h=g.maxResults?Object.assign({},g,{maxResults:null}):g,u=new o(h);l=this.doSortedSearch(u,g,n,r,E)}return new Promise((h,u)=>{l.then(([w,R])=>{const O=R.map(L=>this.rawMatchToSearchItem(L));this.sendProgress(O,n,a),h(w)},u)})}const s=new o(g);return this.doSearch(s,r,a,E).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(o){return{path:o.base?(0,P.join)(o.base,o.relativePath):o.relativePath}}doSortedSearch(o,g,n,E,a){const i=new A.Emitter;let r=(0,t.createCancelablePromise)(l=>{let h=[];const u=w=>{Array.isArray(w)?h=w:(E(w),i.fire(w))};return this.doSearch(o,u,-1,l).then(w=>[w,h])}),s;if(g.cacheKey){s=this.getOrCreateCache(g.cacheKey);const l={promise:r,event:i.event,resolved:!1};s.resultsToSearchCache[g.filePattern||""]=l,r.then(()=>{l.resolved=!0},h=>{delete s.resultsToSearchCache[g.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([l,h])=>{const u=s?s.scorerCache:Object.create(null),w=(typeof g.maxResults!="number"||g.maxResults>0)&&y.StopWatch.create(!1);return this.sortResults(g,h,u,a).then(R=>{const O=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:O,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:R.length},messages:l.messages,limitHit:l.limitHit||typeof g.maxResults=="number"&&h.length>g.maxResults},R]})})}getOrCreateCache(o){const g=this.caches[o];return g||(this.caches[o]=new c)}trySortedSearchFromCache(o,g,n){const E=o.cacheKey&&this.caches[o.cacheKey];if(!E)return;const a=this.getResultsFromCache(E,o.filePattern||"",g,n);if(a)return a.then(([i,r,s])=>{const l=y.StopWatch.create(!1);return this.sortResults(o,r,E.scorerCache,n).then(h=>{const u=l.elapsed(),w={fromCache:!0,detailStats:s,type:this.processType,resultCount:r.length,sortingTime:u};return[{type:"success",limitHit:i.limitHit||typeof o.maxResults=="number"&&r.length>o.maxResults,stats:w},h]})})}sortResults(o,g,n,E){const a=(0,D.prepareQuery)(o.filePattern||""),i=(s,l)=>(0,D.compareItemsByFuzzyScore)(s,l,a,!0,v,n),r=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return d.topAsync(g,i,r,1e4,E)}sendProgress(o,g,n){if(n&&n>0)for(let E=0;E<o.length;E+=n)g(o.slice(E,E+n));else g(o)}getResultsFromCache(o,g,n,E){const a=y.StopWatch.create(!1),i=g.indexOf(P.sep)>=0;let r;for(const u in o.resultsToSearchCache)if(g.startsWith(u)){if(i&&u.indexOf(P.sep)<0&&u!=="")continue;const w=o.resultsToSearchCache[u];r={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!r)return null;const s=a.elapsed(),l=y.StopWatch.create(!1),h=r.event(n);return E&&E.onCancellationRequested(()=>{h.dispose()}),r.promise.then(([u,w])=>{if(E&&E.isCancellationRequested)throw(0,k.canceled)();const R=[],O=(0,D.prepareQuery)(g).normalizedLowercase;for(const L of w)!(0,C.isFilePatternMatch)(L,O)||R.push(L);return[u,R,{cacheWasResolved:r.resolved,cacheLookupTime:s,cacheFilterTime:l.elapsed(),cacheEntryCount:w.length}]})}doSearch(o,g,n,E){return new Promise((a,i)=>{let r=[];E&&E.onCancellationRequested(()=>o.cancel()),o.search(s=>{s&&(n?(r.push(s),n>0&&r.length>=n&&(g(r),r=[])):g(s))},s=>{g(s)},(s,l)=>{r.length&&g(r),s?i(s):a(l)})})}clearCache(o){return delete this.caches[o],Promise.resolve(void 0)}preventCancellation(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,n){return o.then(g,n)}catch(g){return this.then(void 0,g)}finally(g){return o.finally(g)}}}}e.SearchService=p,p.BATCH_SIZE=512;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(m){return(0,P.basename)(m.relativePath)}getItemDescription(m){return(0,P.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function I(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(o=>T.URI.revive(o))}}function b(m){return{...m,folder:T.URI.revive(m.folder)}}}),define(ve[289],be([1,0,6,10,2,29,12,26,14,72,64,31,288,286,90,139]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends T.ExtHostSearch{constructor(b,m,o,g){super(b,o,g);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new p.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new _.RipgrepSearchProvider(n)),m.remote.isRemote&&m.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new p.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new _.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(t.Schemas.file,new f.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,m){const o=this._handlePool++;return this._internalFileSearchProvider=m,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(b)),(0,d.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(b,m,o,g){const n=(0,T.reviveQuery)(o);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,m,n,g):super.$provideFileSearchResults(b,m,o,g)}doInternalFileSearch(b,m,o,g){const n=E=>{if((0,C.isSerializedFileMatch)(E)&&(E=[E]),Array.isArray(E)){this._proxy.$handleFileMatch(b,m,E.map(a=>k.URI.file(a.path)));return}E.message&&this._logService.debug("ExtHostSearch",E.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,n,g)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,m){return new c.NativeTextSearchManager(b,m,void 0,"textSearchProvider")}};v=Be([Fe(0,y.IExtHostRpcService),Fe(1,P.IExtHostInitDataService),Fe(2,F.IURITransformerService),Fe(3,D.ILogService)],v),e.NativeExtHostSearch=v}),define(ve[141],be([1,0,299,127,80,23,16,3,6,9,11,33,105,106,300]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class c{constructor(w,R=""){this.debugLabel=R,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,D.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(w,R){_.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,R)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const R=O=>{this.traceSocketEvent("read",O),w(A.VSBuffer.wrap(O))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(w){const R=O=>{this.traceSocketEvent("close",{hadError:O}),w({type:0,hadError:O,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(w){const R=()=>{this.traceSocketEvent("nodeEndReceived"),w()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(w){if(!this.socket.destroyed)try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,D.onUnexpectedError)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,D.onUnexpectedError)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=c;var v;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var I;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(I||(I={}));class b extends y.Disposable{constructor(w,R,O,L){super();this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:O?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new m(this,R,O,L,this._onData,(S,U)=>this._write(S,U))),this._register(this._flowManager.onError(S=>{console.error(S),(0,D.onUnexpectedError)(S),this._onClose.fire({type:0,hadError:!0,error:S})})),this._incomingData=new _.ChunkStream,this._register(this.socket.onData(S=>this._acceptChunk(S))),this._register(this.socket.onClose(S=>this._onClose.fire(S)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(w,R){this.socket.traceSocketEvent(w,R)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._flowManager.writeMessage(w)}_write(w,R){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let O=2;w.byteLength<126?O+=0:w.byteLength<2**16?O+=2:O+=8;const L=A.VSBuffer.alloc(O);if(R?L.writeUInt8(194,0):L.writeUInt8(130,0),w.byteLength<126)L.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){L.writeUInt8(126,1);let S=1;L.writeUInt8(w.byteLength>>>8&255,++S),L.writeUInt8(w.byteLength>>>0&255,++S)}else{L.writeUInt8(127,1);let S=1;L.writeUInt8(0,++S),L.writeUInt8(0,++S),L.writeUInt8(0,++S),L.writeUInt8(0,++S),L.writeUInt8(w.byteLength>>>24&255,++S),L.writeUInt8(w.byteLength>>>16&255,++S),L.writeUInt8(w.byteLength>>>8&255,++S),L.writeUInt8(w.byteLength>>>0&255,++S)}this.socket.write(A.VSBuffer.concat([L,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const R=this._incomingData.peek(this._state.readLen),O=R.readUInt8(0),L=(O&128)>>>7,S=(O&64)>>>6,U=R.readUInt8(1),M=(U&128)>>>7,X=U&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(X===126?2:0)+(X===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(S)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const R=this._incomingData.read(this._state.readLen),O=R.readUInt8(1),L=(O&128)>>>7;let S=O&127,U=1;S===126?S=R.readUInt8(++U)*2**8+R.readUInt8(++U):S===127&&(S=R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U));let M=0;L&&(M=R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U)),this._state.state=3,this._state.readLen=S,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const R=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),n(R,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(R,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class m extends y.Disposable{constructor(w,R,O,L,S,U){super();this._tracer=w,this._onData=S,this._writeFn=U,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,R?(this._zlibInflateStream=this._register(new o(this._tracer,L,O,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(w){this._writeQueue.push(w),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const w=this._writeQueue.shift();if(this._zlibDeflateStream){const R=await this._deflateMessage(this._zlibDeflateStream,w);this._writeFn(R,!0)}else this._writeFn(w,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(w,R){return new Promise((O,L)=>{w.write(R),w.flush(S=>O(S))})}acceptFrame(w,R,O){this._readQueue.push({data:w,isCompressed:R,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const w=this._readQueue.shift();if(this._zlibInflateStream&&w.isCompressed){const R=await this._inflateFrame(this._zlibInflateStream,w.data,w.isLastFrameOfMessage);this._onData.fire(R)}else this._onData.fire(w.data)}this._isProcessingReadQueue=!1}}_inflateFrame(w,R,O){return new Promise((L,S)=>{w.write(R),O&&w.write(A.VSBuffer.fromByteArray([0,0,255,255])),w.flush(U=>L(U))})}}class o extends y.Disposable{constructor(w,R,O,L){super();this._tracer=w,this._recordInflateBytes=R,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=p.createInflateRaw(L),this._zlibInflate.on("error",S=>{this._tracer.traceSocketEvent("zlibInflateError",{message:S?.message,code:S?.code}),this._onError.fire(S)}),this._zlibInflate.on("data",S=>{this._tracer.traceSocketEvent("zlibInflateData",S),this._pendingInflateData.push(A.VSBuffer.wrap(S))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(w){this._recordInflateBytes&&this._recordedInflateBytes.push(w.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",w),this._zlibInflate.write(w.buffer)}flush(w){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const R=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,w(R)})}}class g extends y.Disposable{constructor(w,R){super();this._tracer=w,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=p.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(A.VSBuffer.wrap(O))})}write(w){this._tracer.traceSocketEvent("zlibDeflateWrite",w.buffer),this._zlibDeflate.write(w.buffer)}flush(w){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let R=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,R=R.slice(0,R.byteLength-4),w(R)})}}function n(u,w){if(w===0)return;let R=u.byteLength>>>2;for(let X=0;X<R;X++){const G=u.readUInt32BE(X*4);u.writeUInt32BE(G^w,X*4)}let O=R*4,L=u.byteLength-O;const S=w>>>24&255,U=w>>>16&255,M=w>>>8&255;L>=1&&u.writeUInt8(u.readUInt8(O)^S,O),L>=2&&u.writeUInt8(u.readUInt8(O+1)^U,O+1),L>=3&&u.writeUInt8(u.readUInt8(O+2)^M,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const E={[2]:107,[1]:103};function a(){const u=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):w=(0,T.join)((0,k.tmpdir)(),`vscode-ipc-${u}.sock`),r(w),w}e.createRandomIPCHandle=a;function i(u,w,R){const O=(0,d.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${R}-${w}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${R}-${w}.sock`):L=(0,T.join)(u,`${R}-${w}.sock`),r(L),L}e.createStaticIPCHandle=i;function r(u){const w=E[F.platform];typeof w=="number"&&u.length>=w&&console.warn(`WARNING: IPC handle "${u}" is longer than ${w} chars, try a shorter --user-data-dir`)}class s extends f.IPCServer{constructor(w){super(s.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const R=P.Event.fromNodeEventEmitter(w,"connection");return P.Event.map(R,O=>({protocol:new _.Protocol(new c(O,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function l(u){return new Promise((w,R)=>{const O=(0,t.createServer)();O.on("error",R),O.listen(u,()=>{O.removeListener("error",R),w(new s(O))})})}e.serve=l;function h(u,w){return new Promise((R,O)=>{const L=(0,t.createConnection)(u,()=>{L.removeListener("error",O),R(_.Client.fromSocket(new c(L,`ipc-client${w}`),w))});L.once("error",O)})}e.connect=h}),define(ve[290],be([1,0,141,285,60,38,2,201,12]),function(te,e,d,t,k,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class T{constructor(f,_,p){this._commands=f,this.logService=_,this._ipcHandlePath=p,this._server=t.createServer((c,v)=>this.onRequest(c,v)),this.setup().catch(c=>(_.error(c),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",f=>this.logService.error(f))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(f,_){const p=(v,I)=>{_.writeHead(v,{"content-type":"application/json"}),_.end(JSON.stringify(I),b=>b&&this.logService.error(b))},c=[];f.setEncoding("utf8"),f.on("data",v=>c.push(v)),f.on("end",async()=>{try{const v=JSON.parse(c.join(""));let I;switch(v.type){case"open":I=await this.open(v);break;case"openExternal":I=await this.openExternal(v);break;case"status":I=await this.getStatus(v);break;case"extensionManagement":I=await this.manageExtensions(v);break;default:p(404,`Unknown message type: ${v.type}`);break}p(200,I)}catch(v){const I=v instanceof Error?v.message:JSON.stringify(v);p(500,I),this.logService.error("Error while processing pipe request",v)}})}async open(f){const{fileURIs:_,folderURIs:p,forceNewWindow:c,diffMode:v,addMode:I,forceReuseWindow:b,gotoLineMode:m,waitMarkerFilePath:o,remoteAuthority:g}=f,n=[];if(Array.isArray(p))for(const r of p)try{n.push({folderUri:D.URI.parse(r)})}catch{}if(Array.isArray(_))for(const r of _)try{(0,P.hasWorkspaceFileExtension)(r)?n.push({workspaceUri:D.URI.parse(r)}):n.push({fileUri:D.URI.parse(r)})}catch{}const E=o?D.URI.file(o):void 0,i={forceNewWindow:c,diffMode:v,addMode:I,gotoLineMode:m,forceReuseWindow:b,preferNewWindow:!b&&!E&&!I,waitMarkerFileURI:E,remoteAuthority:g};return this._commands.executeCommand("_remoteCLI.windowOpen",n,i),""}async openExternal(f){for(const _ of f.uris){const p=D.URI.parse(_),c=p.scheme==="file"?p:_;await this._commands.executeCommand("_remoteCLI.openExternal",c)}}async manageExtensions(f){const _=c=>c?.map(v=>/\.vsix$/i.test(v)?D.URI.parse(v):v),p={list:f.list,install:_(f.install),uninstall:_(f.uninstall),force:f.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",p)}async getStatus(f){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=T;let F=class extends T{constructor(f,_){super(f,_,(0,d.createRandomIPCHandle)())}};F=Be([Fe(0,A.IExtHostCommands),Fe(1,y.ILogService)],F),e.CLIServer=F}),define(ve[291],be([1,0,71,283,272,5,284,39,261,2,10,7,290,104]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class p extends k.RequireInterceptor{_installInterceptor(){const I=this,b=te.__$__nodeRequire("module"),m=b._load;b._load=function(E,a,i){return E=g(E),I._factories.has(E)?I._factories.get(E).load(E,T.URI.file((0,_.realpathSync)(a.filename)),r=>m.apply(this,[r,a,i])):m.apply(this,arguments)};const o=b._resolveLookupPaths;b._resolveLookupPaths=(n,E)=>o.call(this,g(n),E);const g=n=>{for(let E of I._alternatives){let a=E(n);if(a){n=a;break}}return n}}}class c extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const I=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const n=this._instaService.createInstance(f.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=n.ipcHandlePath}await this._instaService.createInstance(p,I,this._registry).install(),d.mark("code/extHost/didInitAPI");const m=await this._extHostConfiguration.getConfigProvider();await(0,D.connectProxyResolver)(this._extHostWorkspace,m,this,this._logService,this._mainThreadTelemetryProxy,this._initData),d.mark("code/extHost/didInitProxyResolver");const o=process.send,g=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...n)=>n.length===0||!n[0]||n[0].type!=="__$console"?o.apply(process,n):(g.$logExtensionHostMessage(n[0]),!1)}_getEntryPoint(I){return I.main}_loadCommonJSModule(I,b,m){if(b.scheme!==F.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let o=null;m.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{I&&d.mark(`code/extHost/willLoadExtensionCode/${I.value}`),o=te.__$__nodeRequire(b.fsPath)}catch(g){return Promise.reject(g)}finally{I&&d.mark(`code/extHost/didLoadExtensionCode/${I.value}`),m.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(I){if(!!this._initData.remote.isRemote)for(const b in I){const m=I[b];m===null?delete process.env[b]:process.env[b]=m}}}e.ExtHostExtensionService=c}),define(ve[292],be([1,0,61,264,275,274,289,291,265,54,39,72,70,34,51,67,263,262,12]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(F.IExtHostExtensionService,P.ExtHostExtensionService),(0,d.registerSingleton)(b.ILoggerService,I.ExtHostLoggerService),(0,d.registerSingleton)(c.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,d.registerSingleton)(T.IExtHostDebugService,A.ExtHostDebugService),(0,d.registerSingleton)(C.IExtHostSearch,D.NativeExtHostSearch),(0,d.registerSingleton)(f.IExtHostTask,k.ExtHostTask),(0,d.registerSingleton)(_.IExtHostTerminalService,t.ExtHostTerminalService),(0,d.registerSingleton)(p.IExtHostTunnelService,y.ExtHostTunnelService)}),define(ve[301],be([1,0,127,302,71,16,106,141,193,133,273,23,102,29,104,13,114,276,292]),function(te,e,d,t,k,A,D,P,y,T,F,C,f,_,p,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const I=t(process.argv.slice(2),{string:["uriTransformerPath"],boolean:["skipWorkspaceStorageLock","useHostProxy"]});(function(){const i=te.__$__nodeRequire("module"),r=i._load;i._load=function(s){if(s==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return r.apply(this,arguments)}})();const b=process.exit.bind(process);function m(i){process.exit=function(r){if(i)b(r);else{const s=new Error("An extension called process.exit() and this was prevented.");console.warn(s.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let o=function(i){b()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,r)=>{let s=null,l=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,u=3e5,w=new c.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),h),R=new c.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),u);process.on("message",(L,S)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){S.setNoDelay(!0);const U=C.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let M;if(L.skipWebSocketFrames)M=new P.NodeSocket(S,"extHost-socket");else{const X=C.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));M=new P.WebSocketNodeSocket(new P.NodeSocket(S,"extHost-socket"),L.permessageDeflate,X,!1)}s?(w.cancel(),R.cancel(),s.beginAcceptReconnection(M,U),s.endAcceptReconnection(),s.sendResume()):(clearTimeout(l),s=new D.PersistentProtocol(M,U),s.sendResume(),s.onDidDispose(()=>o("renderer disconnected")),i(s),s.onSocketClose(()=>{w.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(R.isScheduled())return;w.isScheduled()&&R.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(O)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,s)=>{const l=d.createConnection(i,()=>{l.removeListener("error",s),r(new D.PersistentProtocol(new P.NodeSocket(l,"extHost-renderer")))});l.once("error",s),l.on("close",()=>{o("renderer closed the socket")})})}}async function n(){const i=await g();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(r=>{(0,T.isMessageOfType)(r,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||i.send(r)}drain(){return i.drain()}}}function E(i){return new Promise(r=>{const s=i.onMessage(l=>{s.dispose();const h=JSON.parse(l.toString()),u=h.commit,w=y.default.commit;u&&w&&u!==w&&b(55);let R=0;setInterval(function(){try{process.kill(h.parentPid,0),R=0}catch(L){L&&L.code==="EPERM"?(R++,R>=3&&o(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${L.message} (code: ${L.code}) (errno: ${L.errno})`)):o(`parent process ${h.parentPid} does not exist anymore: ${L.message} (code: ${L.code}) (errno: ${L.errno})`)}},1e3);let O;try{O=te.__$__nodeRequire("native-watchdog"),O.start(h.parentPid)}catch(L){(0,A.onUnexpectedError)(L)}i.send((0,T.createMessageOfType)(0)),r({protocol:i,initData:h})});i.send((0,T.createMessageOfType)(1))})}async function a(){const i=[];process.on("unhandledRejection",(R,O)=>{i.push(O),setTimeout(()=>{const L=i.indexOf(O);L>=0&&O.catch(S=>{i.splice(L,1),(0,A.isCancellationError)(S)||(console.warn(`rejected promise not handled within 1 second: ${S}`),S&&S.stack&&console.warn(`stack trace: ${S.stack}`),R&&(0,A.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const O=i.indexOf(R);O>=0&&i.splice(O,1)}),process.on("uncaughtException",function(R){(0,A.onUnexpectedError)(R)}),k.mark("code/extHost/willConnectToRenderer");const r=await n();k.mark("code/extHost/didConnectToRenderer");const s=await E(r);k.mark("code/extHost/didWaitForInitData");const{initData:l}=s;m(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=!!I.useHostProxy,l.environment.skipWorkspaceStorageLock=(0,v.boolean)(I.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(O){b(O)}exists(O){return _.Promises.exists(O)}realpath(O){return(0,p.realpath)(O)}};let u=null;if(l.remote.authority&&I.uriTransformerPath)try{const O=te.__$__nodeRequire(I.uriTransformerPath)(l.remote.authority);u=new f.URITransformer(O)}catch(R){console.error(R)}const w=new F.ExtensionHostMain(s.protocol,l,h,u);o=R=>w.terminate(R)}e.startExtensionHostProcess=a,a().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/921264bfe3ffbbfe5ec8c4b08214b88e2148fa3e/core/vs/workbench/api/node/extensionHostProcess.js.map
