/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/strings","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/languageSelector","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/editor/common/core/range","vs/editor/common/languages","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/prefixSumComputer","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],be=function(Y){for(var e=[],r=0,k=Y.length;r<k;r++)e[r]=Ee[Y[r]];return e};define(Ee[42],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function r(k,b){if(!k)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=r}),define(Ee[68],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const r=Object.prototype.hasOwnProperty;function k(N){const v=[];for(let n in N)r.call(N,n)&&v.push(N[n]);return v}e.values=k;function b(N,v){for(let n in N)if(r.call(N,n)&&v({key:n,value:N[n]},function(){delete N[n]})===!1)return}e.forEach=b;function $(N,v){const n=Object.create(null);for(const p of N){const s=v(p);let i=n[s];i||(i=n[s]=[]),i.push(p)}return n}e.groupBy=$;function y(N){const v=Object.create(null);return N&&N.forEach((n,p)=>{v[p]=n}),v}e.fromMap=y;function O(N,v){const n=[],p=[];for(let s of N)v.has(s)||n.push(s);for(let s of v)N.has(s)||p.push(s);return{removed:n,added:p}}e.diffSets=O;function I(N,v){const n=[],p=[];for(let[s,i]of N)v.has(s)||n.push(i);for(let[s,i]of v)N.has(s)||p.push(i);return{removed:n,added:p}}e.diffMaps=I;class R{constructor(){this.map=new Map}add(v,n){let p=this.map.get(v);p||(p=new Set,this.map.set(v,p)),p.add(n)}delete(v,n){const p=this.map.get(v);!p||(p.delete(n),p.size===0&&this.map.delete(v))}forEach(v,n){const p=this.map.get(v);!p||p.forEach(n)}}e.SetMap=R}),define(Ee[52],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(y){return(O,I,R)=>{let N=null,v=null;if(typeof R.value=="function"?(N="value",v=R.value):typeof R.get=="function"&&(N="get",v=R.get),!v)throw new Error("not supported");R[N]=y(v,I)}}e.createDecorator=r;function k(y,O,I){let R=null,N=null;if(typeof I.value=="function"?(R="value",N=I.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(R="get",N=I.get),!N)throw new Error("not supported");const v=`$memoize$${O}`;I[R]=function(...n){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,n)}),this[v]}}e.memoize=k;function b(y,O,I){return r((R,N)=>{const v=`$debounce$${N}`,n=`$debounce$result$${N}`;return function(...p){this[n]||(this[n]=I?I():void 0),clearTimeout(this[v]),O&&(this[n]=O(this[n],...p),p=[this[n]]),this[v]=setTimeout(()=>{R.apply(this,p),this[n]=I?I():void 0},y)}})}e.debounce=b;function $(y,O,I){return r((R,N)=>{const v=`$throttle$timer$${N}`,n=`$throttle$result$${N}`,p=`$throttle$lastRun$${N}`,s=`$throttle$pending$${N}`;return function(...i){if(this[n]||(this[n]=I?I():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),O&&(this[n]=O(this[n],...i)),this[s])return;const u=this[p]+y;u<=Date.now()?(this[p]=Date.now(),R.apply(this,[this[n]]),this[n]=I?I():void 0):(this[s]=!0,this[v]=setTimeout(()=>{this[s]=!1,this[p]=Date.now(),R.apply(this,[this[n]]),this[n]=I?I():void 0},u-Date.now()))}})}e.throttle=$}),define(Ee[53],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ee[100],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var k;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var $;(function(a){a.DEFAULT={allowTrailingComma:!0}})($=e.ParseOptions||(e.ParseOptions={}));function y(a,P=!1){let c=0,t=a.length,h="",o=0,l=16,f=0;function m(z){let q=0,j=0;for(;q<z;){const J=a.charCodeAt(c);if(J>=48&&J<=57)j=j*16+J-48;else if(J>=65&&J<=70)j=j*16+J-65+10;else if(J>=97&&J<=102)j=j*16+J-97+10;else break;c++,q++}return q<z&&(j=-1),j}function E(z){c=z,h="",o=0,l=16,f=0}function T(){const z=c;if(a.charCodeAt(c)===48)c++;else for(c++;c<a.length&&R(a.charCodeAt(c));)c++;if(c<a.length&&a.charCodeAt(c)===46)if(c++,c<a.length&&R(a.charCodeAt(c)))for(c++;c<a.length&&R(a.charCodeAt(c));)c++;else return f=3,a.substring(z,c);let q=c;if(c<a.length&&(a.charCodeAt(c)===69||a.charCodeAt(c)===101))if(c++,(c<a.length&&a.charCodeAt(c)===43||a.charCodeAt(c)===45)&&c++,c<a.length&&R(a.charCodeAt(c))){for(c++;c<a.length&&R(a.charCodeAt(c));)c++;q=c}else f=3;return a.substring(z,q)}function A(){let z="",q=c;for(;;){if(c>=t){z+=a.substring(q,c),f=2;break}const j=a.charCodeAt(c);if(j===34){z+=a.substring(q,c),c++;break}if(j===92){if(z+=a.substring(q,c),c++,c>=t){f=2;break}switch(a.charCodeAt(c++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const V=m(4);V>=0?z+=String.fromCharCode(V):f=4;break}default:f=5}q=c;continue}if(j>=0&&j<=31)if(I(j)){z+=a.substring(q,c),f=2;break}else f=6;c++}return z}function x(){if(h="",f=0,o=c,c>=t)return o=t,l=17;let z=a.charCodeAt(c);if(O(z)){do c++,h+=String.fromCharCode(z),z=a.charCodeAt(c);while(O(z));return l=15}if(I(z))return c++,h+=String.fromCharCode(z),z===13&&a.charCodeAt(c)===10&&(c++,h+=`
`),l=14;switch(z){case 123:return c++,l=1;case 125:return c++,l=2;case 91:return c++,l=3;case 93:return c++,l=4;case 58:return c++,l=6;case 44:return c++,l=5;case 34:return c++,h=A(),l=10;case 47:{const q=c-1;if(a.charCodeAt(c+1)===47){for(c+=2;c<t&&!I(a.charCodeAt(c));)c++;return h=a.substring(q,c),l=12}if(a.charCodeAt(c+1)===42){c+=2;const j=t-1;let J=!1;for(;c<j;){if(a.charCodeAt(c)===42&&a.charCodeAt(c+1)===47){c+=2,J=!0;break}c++}return J||(c++,f=1),h=a.substring(q,c),l=13}return h+=String.fromCharCode(z),c++,l=16}case 45:if(h+=String.fromCharCode(z),c++,c===t||!R(a.charCodeAt(c)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=T(),l=11;default:for(;c<t&&g(z);)c++,z=a.charCodeAt(c);if(o!==c){switch(h=a.substring(o,c),h){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return h+=String.fromCharCode(z),c++,l=16}}function g(z){if(O(z)||I(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let z;do z=x();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>c,scan:P?U:x,getToken:()=>l,getTokenValue:()=>h,getTokenOffset:()=>o,getTokenLength:()=>c-o,getTokenError:()=>f}}e.createScanner=y;function O(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function I(a){return a===10||a===13||a===8232||a===8233}function R(a){return a>=48&&a<=57}var N;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(N||(N={}));function v(a,P){const c=[],t=new Object;let h;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function f(m,E,T,A){o.value=m,o.offset=E,o.length=T,o.type=A,o.colonOffset=void 0,h=o}try{w(a,{onObjectBegin:(m,E)=>{if(P<=m)throw t;h=void 0,l=P>m,c.push("")},onObjectProperty:(m,E,T)=>{if(P<E||(f(m,E,T,"property"),c[c.length-1]=m,P<=E+T))throw t},onObjectEnd:(m,E)=>{if(P<=m)throw t;h=void 0,c.pop()},onArrayBegin:(m,E)=>{if(P<=m)throw t;h=void 0,c.push(0)},onArrayEnd:(m,E)=>{if(P<=m)throw t;h=void 0,c.pop()},onLiteralValue:(m,E,T)=>{if(P<E||(f(m,E,T,D(m)),P<=E+T))throw t},onSeparator:(m,E,T)=>{if(P<=E)throw t;if(m===":"&&h&&h.type==="property")h.colonOffset=E,l=!1,h=void 0;else if(m===","){const A=c[c.length-1];typeof A=="number"?c[c.length-1]=A+1:(l=!0,c[c.length-1]=""),h=void 0}}})}catch(m){if(m!==t)throw m}return{path:c,previousNode:h,isAtPropertyKey:l,matches:m=>{let E=0;for(let T=0;E<m.length&&T<c.length;T++)if(m[E]===c[T]||m[E]==="*")E++;else if(m[E]!=="**")return!1;return E===m.length}}}e.getLocation=v;function n(a,P=[],c=$.DEFAULT){let t=null,h=[];const o=[];function l(m){Array.isArray(h)?h.push(m):t!==null&&(h[t]=m)}return w(a,{onObjectBegin:()=>{const m={};l(m),o.push(h),h=m,t=null},onObjectProperty:m=>{t=m},onObjectEnd:()=>{h=o.pop()},onArrayBegin:()=>{const m=[];l(m),o.push(h),h=m,t=null},onArrayEnd:()=>{h=o.pop()},onLiteralValue:l,onError:(m,E,T)=>{P.push({error:m,offset:E,length:T})}},c),h[0]}e.parse=n;function p(a,P=[],c=$.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(m){t.type==="property"&&(t.length=m-t.offset,t=t.parent)}function o(m){return t.children.push(m),m}w(a,{onObjectBegin:m=>{t=o({type:"object",offset:m,length:-1,parent:t,children:[]})},onObjectProperty:(m,E,T)=>{t=o({type:"property",offset:E,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:m,offset:E,length:T,parent:t})},onObjectEnd:(m,E)=>{t.length=m+E-t.offset,t=t.parent,h(m+E)},onArrayBegin:(m,E)=>{t=o({type:"array",offset:m,length:-1,parent:t,children:[]})},onArrayEnd:(m,E)=>{t.length=m+E-t.offset,t=t.parent,h(m+E)},onLiteralValue:(m,E,T)=>{o({type:D(m),offset:E,length:T,parent:t,value:m}),h(E+T)},onSeparator:(m,E,T)=>{t.type==="property"&&(m===":"?t.colonOffset=E:m===","&&h(E))},onError:(m,E,T)=>{P.push({error:m,offset:E,length:T})}},c);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=p;function s(a,P){if(!a)return;let c=a;for(let t of P)if(typeof t=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let h=!1;for(const o of c.children)if(Array.isArray(o.children)&&o.children[0].value===t){c=o.children[1],h=!0;break}if(!h)return}else{const h=t;if(c.type!=="array"||h<0||!Array.isArray(c.children)||h>=c.children.length)return;c=c.children[h]}return c}e.findNodeAtLocation=s;function i(a){if(!a.parent||!a.parent.children)return[];const P=i(a.parent);if(a.parent.type==="property"){const c=a.parent.children[0].value;P.push(c)}else if(a.parent.type==="array"){const c=a.parent.children.indexOf(a);c!==-1&&P.push(c)}return P}e.getNodePath=i;function u(a){switch(a.type){case"array":return a.children.map(u);case"object":{const P=Object.create(null);for(let c of a.children){const t=c.children[1];t&&(P[c.children[0].value]=u(t))}return P}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=u;function S(a,P,c=!1){return P>=a.offset&&P<a.offset+a.length||c&&P===a.offset+a.length}e.contains=S;function _(a,P,c=!1){if(S(a,P,c)){const t=a.children;if(Array.isArray(t))for(let h=0;h<t.length&&t[h].offset<=P;h++){const o=_(t[h],P,c);if(o)return o}return a}}e.findNodeAtOffset=_;function w(a,P,c=$.DEFAULT){const t=y(a,!1);function h(Se){return Se?()=>Se(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(Se){return Se?ge=>Se(ge,t.getTokenOffset(),t.getTokenLength()):()=>!0}const l=h(P.onObjectBegin),f=o(P.onObjectProperty),m=h(P.onObjectEnd),E=h(P.onArrayBegin),T=h(P.onArrayEnd),A=o(P.onLiteralValue),x=o(P.onSeparator),g=h(P.onComment),U=o(P.onError),z=c&&c.disallowComments,q=c&&c.allowTrailingComma;function j(){for(;;){const Se=t.scan();switch(t.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:z||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(Se){case 12:case 13:z?J(10):g();break;case 16:J(1);break;case 15:case 14:break;default:return Se}}}function J(Se,ge=[],ne=[]){if(U(Se),ge.length+ne.length>0){let me=t.getToken();for(;me!==17;){if(ge.indexOf(me)!==-1){j();break}else if(ne.indexOf(me)!==-1)break;me=j()}}}function V(Se){const ge=t.getTokenValue();return Se?A(ge):f(ge),j(),!0}function ie(){switch(t.getToken()){case 11:{let Se=0;try{Se=JSON.parse(t.getTokenValue()),typeof Se!="number"&&(J(2),Se=0)}catch{J(2)}A(Se);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return j(),!0}function ae(){return t.getToken()!==10?(J(3,[],[2,5]),!1):(V(!1),t.getToken()===6?(x(":"),j(),fe()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function te(){l(),j();let Se=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Se||J(4,[],[]),x(","),j(),t.getToken()===2&&q)break}else Se&&J(6,[],[]);ae()||J(4,[],[2,5]),Se=!0}return m(),t.getToken()!==2?J(7,[2],[]):j(),!0}function ue(){E(),j();let Se=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Se||J(4,[],[]),x(","),j(),t.getToken()===4&&q)break}else Se&&J(6,[],[]);fe()||J(4,[],[4,5]),Se=!0}return T(),t.getToken()!==4?J(8,[4],[]):j(),!0}function fe(){switch(t.getToken()){case 3:return ue();case 1:return te();case 10:return V(!0);default:return ie()}}return j(),t.getToken()===17?c.allowEmptyContent?!0:(J(4,[],[]),!1):fe()?(t.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=w;function d(a,P){let c=y(a),t=[],h,o=0,l;do switch(l=c.getPosition(),h=c.scan(),h){case 12:case 13:case 17:o!==l&&t.push(a.substring(o,l)),P!==void 0&&t.push(c.getTokenValue().replace(/[^\r\n]/g,P)),o=c.getPosition();break}while(h!==17);return t.join("")}e.stripComments=d;function D(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Ee[101],be([0]),e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,e(Y.marked={}))}(this,function(Y){"use strict";function e(pe,de){for(var L=0;L<de.length;L++){var F=de[L];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(pe,F.key,F)}}function r(pe,de,L){return de&&e(pe.prototype,de),L&&e(pe,L),Object.defineProperty(pe,"prototype",{writable:!1}),pe}function k(pe,de){if(!!pe){if(typeof pe=="string")return b(pe,de);var L=Object.prototype.toString.call(pe).slice(8,-1);if(L==="Object"&&pe.constructor&&(L=pe.constructor.name),L==="Map"||L==="Set")return Array.from(pe);if(L==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(L))return b(pe,de)}}function b(pe,de){(de==null||de>pe.length)&&(de=pe.length);for(var L=0,F=new Array(de);L<de;L++)F[L]=pe[L];return F}function $(pe,de){var L=typeof Symbol!="undefined"&&pe[Symbol.iterator]||pe["@@iterator"];if(L)return(L=L.call(pe)).next.bind(L);if(Array.isArray(pe)||(L=k(pe))||de&&pe&&typeof pe.length=="number"){L&&(pe=L);var F=0;return function(){return F>=pe.length?{done:!0}:{done:!1,value:pe[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Y.defaults=y();function O(pe){Y.defaults=pe}var I=/[&<>"']/,R=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(de){return n[de]};function s(pe,de){if(de){if(I.test(pe))return pe.replace(R,p)}else if(N.test(pe))return pe.replace(v,p);return pe}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(pe){return pe.replace(i,function(de,L){return L=L.toLowerCase(),L==="colon"?":":L.charAt(0)==="#"?L.charAt(1)==="x"?String.fromCharCode(parseInt(L.substring(2),16)):String.fromCharCode(+L.substring(1)):""})}var S=/(^|[^\[])\^/g;function _(pe,de){pe=pe.source||pe,de=de||"";var L={replace:function(C,M){return M=M.source||M,M=M.replace(S,"$1"),pe=pe.replace(C,M),L},getRegex:function(){return new RegExp(pe,de)}};return L}var w=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(pe,de,L){if(pe){var F;try{F=decodeURIComponent(u(L)).replace(w,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}de&&!d.test(L)&&(L=h(de,L));try{L=encodeURI(L).replace(/%25/g,"%")}catch{return null}return L}var a={},P=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(pe,de){a[" "+pe]||(P.test(pe)?a[" "+pe]=pe+"/":a[" "+pe]=m(pe,"/",!0)),pe=a[" "+pe];var L=pe.indexOf(":")===-1;return de.substring(0,2)==="//"?L?de:pe.replace(c,"$1")+de:de.charAt(0)==="/"?L?de:pe.replace(t,"$1")+de:pe+de}var o={exec:function(){}};function l(pe){for(var de=1,L,F;de<arguments.length;de++){L=arguments[de];for(F in L)Object.prototype.hasOwnProperty.call(L,F)&&(pe[F]=L[F])}return pe}function f(pe,de){var L=pe.replace(/\|/g,function(M,H,X){for(var re=!1,ve=H;--ve>=0&&X[ve]==="\\";)re=!re;return re?"|":" |"}),F=L.split(/ \|/),C=0;if(F[0].trim()||F.shift(),F[F.length-1].trim()||F.pop(),F.length>de)F.splice(de);else for(;F.length<de;)F.push("");for(;C<F.length;C++)F[C]=F[C].trim().replace(/\\\|/g,"|");return F}function m(pe,de,L){var F=pe.length;if(F===0)return"";for(var C=0;C<F;){var M=pe.charAt(F-C-1);if(M===de&&!L)C++;else if(M!==de&&L)C++;else break}return pe.substr(0,F-C)}function E(pe,de){if(pe.indexOf(de[1])===-1)return-1;for(var L=pe.length,F=0,C=0;C<L;C++)if(pe[C]==="\\")C++;else if(pe[C]===de[0])F++;else if(pe[C]===de[1]&&(F--,F<0))return C;return-1}function T(pe){pe&&pe.sanitize&&!pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(pe,de){if(de<1)return"";for(var L="";de>1;)de&1&&(L+=pe),de>>=1,pe+=pe;return L+pe}function x(pe,de,L,F){var C=de.href,M=de.title?s(de.title):null,H=pe[1].replace(/\\([\[\]])/g,"$1");if(pe[0].charAt(0)!=="!"){F.state.inLink=!0;var X={type:"link",raw:L,href:C,title:M,text:H,tokens:F.inlineTokens(H,[])};return F.state.inLink=!1,X}else return{type:"image",raw:L,href:C,title:M,text:s(H)}}function g(pe,de){var L=pe.match(/^(\s+)(?:```)/);if(L===null)return de;var F=L[1];return de.split(`
`).map(function(C){var M=C.match(/^\s+/);if(M===null)return C;var H=M[0];return H.length>=F.length?C.slice(F.length):C}).join(`
`)}var U=function(){function pe(L){this.options=L||Y.defaults}var de=pe.prototype;return de.space=function(F){var C=this.rules.block.newline.exec(F);if(C&&C[0].length>0)return{type:"space",raw:C[0]}},de.code=function(F){var C=this.rules.block.code.exec(F);if(C){var M=C[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:C[0],codeBlockStyle:"indented",text:this.options.pedantic?M:m(M,`
`)}}},de.fences=function(F){var C=this.rules.block.fences.exec(F);if(C){var M=C[0],H=g(M,C[3]||"");return{type:"code",raw:M,lang:C[2]?C[2].trim():C[2],text:H}}},de.heading=function(F){var C=this.rules.block.heading.exec(F);if(C){var M=C[2].trim();if(/#$/.test(M)){var H=m(M,"#");(this.options.pedantic||!H||/ $/.test(H))&&(M=H.trim())}var X={type:"heading",raw:C[0],depth:C[1].length,text:M,tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},de.hr=function(F){var C=this.rules.block.hr.exec(F);if(C)return{type:"hr",raw:C[0]}},de.blockquote=function(F){var C=this.rules.block.blockquote.exec(F);if(C){var M=C[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:C[0],tokens:this.lexer.blockTokens(M,[]),text:M}}},de.list=function(F){var C=this.rules.block.list.exec(F);if(C){var M,H,X,re,ve,ke,Me,Le,ze,Be,Oe,Xe,tt=C[1].trim(),Te=tt.length>1,et={type:"list",raw:"",ordered:Te,start:Te?+tt.slice(0,-1):"",loose:!1,items:[]};tt=Te?"\\d{1,9}\\"+tt.slice(-1):"\\"+tt,this.options.pedantic&&(tt=Te?tt:"[*+-]");for(var G=new RegExp("^( {0,3}"+tt+")((?: [^\\n]*)?(?:\\n|$))");F&&(Xe=!1,!(!(C=G.exec(F))||this.rules.block.hr.test(F)));){if(M=C[0],F=F.substring(M.length),Le=C[2].split(`
`,1)[0],ze=F.split(`
`,1)[0],this.options.pedantic?(re=2,Oe=Le.trimLeft()):(re=C[2].search(/[^ ]/),re=re>4?1:re,Oe=Le.slice(re),re+=C[1].length),ke=!1,!Le&&/^ *$/.test(ze)&&(M+=ze+`
`,F=F.substring(ze.length+1),Xe=!0),!Xe)for(var Q=new RegExp("^ {0,"+Math.min(3,re-1)+"}(?:[*+-]|\\d{1,9}[.)])");F&&(Be=F.split(`
`,1)[0],Le=Be,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!Q.test(Le));){if(Le.search(/[^ ]/)>=re||!Le.trim())Oe+=`
`+Le.slice(re);else if(!ke)Oe+=`
`+Le;else break;!ke&&!Le.trim()&&(ke=!0),M+=Be+`
`,F=F.substring(Be.length+1)}et.loose||(Me?et.loose=!0:/\n *\n *$/.test(M)&&(Me=!0)),this.options.gfm&&(H=/^\[[ xX]\] /.exec(Oe),H&&(X=H[0]!=="[ ] ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),et.items.push({type:"list_item",raw:M,task:!!H,checked:X,loose:!1,text:Oe}),et.raw+=M}et.items[et.items.length-1].raw=M.trimRight(),et.items[et.items.length-1].text=Oe.trimRight(),et.raw=et.raw.trimRight();var ce=et.items.length;for(ve=0;ve<ce;ve++){this.lexer.state.top=!1,et.items[ve].tokens=this.lexer.blockTokens(et.items[ve].text,[]);var Re=et.items[ve].tokens.filter(function(Ge){return Ge.type==="space"}),xe=Re.every(function(Ge){for(var Je=Ge.raw.split(""),at=0,yt=$(Je),Dt;!(Dt=yt()).done;){var Ot=Dt.value;if(Ot===`
`&&(at+=1),at>1)return!0}return!1});!et.loose&&Re.length&&xe&&(et.loose=!0,et.items[ve].loose=!0)}return et}},de.html=function(F){var C=this.rules.block.html.exec(F);if(C){var M={type:"html",raw:C[0],pre:!this.options.sanitizer&&(C[1]==="pre"||C[1]==="script"||C[1]==="style"),text:C[0]};return this.options.sanitize&&(M.type="paragraph",M.text=this.options.sanitizer?this.options.sanitizer(C[0]):s(C[0]),M.tokens=[],this.lexer.inline(M.text,M.tokens)),M}},de.def=function(F){var C=this.rules.block.def.exec(F);if(C){C[3]&&(C[3]=C[3].substring(1,C[3].length-1));var M=C[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:M,raw:C[0],href:C[2],title:C[3]}}},de.table=function(F){var C=this.rules.block.table.exec(F);if(C){var M={type:"table",header:f(C[1]).map(function(Me){return{text:Me}}),align:C[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:C[3]?C[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(M.header.length===M.align.length){M.raw=C[0];var H=M.align.length,X,re,ve,ke;for(X=0;X<H;X++)/^ *-+: *$/.test(M.align[X])?M.align[X]="right":/^ *:-+: *$/.test(M.align[X])?M.align[X]="center":/^ *:-+ *$/.test(M.align[X])?M.align[X]="left":M.align[X]=null;for(H=M.rows.length,X=0;X<H;X++)M.rows[X]=f(M.rows[X],M.header.length).map(function(Me){return{text:Me}});for(H=M.header.length,re=0;re<H;re++)M.header[re].tokens=[],this.lexer.inlineTokens(M.header[re].text,M.header[re].tokens);for(H=M.rows.length,re=0;re<H;re++)for(ke=M.rows[re],ve=0;ve<ke.length;ve++)ke[ve].tokens=[],this.lexer.inlineTokens(ke[ve].text,ke[ve].tokens);return M}}},de.lheading=function(F){var C=this.rules.block.lheading.exec(F);if(C){var M={type:"heading",raw:C[0],depth:C[2].charAt(0)==="="?1:2,text:C[1],tokens:[]};return this.lexer.inline(M.text,M.tokens),M}},de.paragraph=function(F){var C=this.rules.block.paragraph.exec(F);if(C){var M={type:"paragraph",raw:C[0],text:C[1].charAt(C[1].length-1)===`
`?C[1].slice(0,-1):C[1],tokens:[]};return this.lexer.inline(M.text,M.tokens),M}},de.text=function(F){var C=this.rules.block.text.exec(F);if(C){var M={type:"text",raw:C[0],text:C[0],tokens:[]};return this.lexer.inline(M.text,M.tokens),M}},de.escape=function(F){var C=this.rules.inline.escape.exec(F);if(C)return{type:"escape",raw:C[0],text:s(C[1])}},de.tag=function(F){var C=this.rules.inline.tag.exec(F);if(C)return!this.lexer.state.inLink&&/^<a /i.test(C[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(C[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(C[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(C[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:C[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(C[0]):s(C[0]):C[0]}},de.link=function(F){var C=this.rules.inline.link.exec(F);if(C){var M=C[2].trim();if(!this.options.pedantic&&/^</.test(M)){if(!/>$/.test(M))return;var H=m(M.slice(0,-1),"\\");if((M.length-H.length)%2==0)return}else{var X=E(C[2],"()");if(X>-1){var re=C[0].indexOf("!")===0?5:4,ve=re+C[1].length+X;C[2]=C[2].substring(0,X),C[0]=C[0].substring(0,ve).trim(),C[3]=""}}var ke=C[2],Me="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ke);Le&&(ke=Le[1],Me=Le[3])}else Me=C[3]?C[3].slice(1,-1):"";return ke=ke.trim(),/^</.test(ke)&&(this.options.pedantic&&!/>$/.test(M)?ke=ke.slice(1):ke=ke.slice(1,-1)),x(C,{href:ke&&ke.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},C[0],this.lexer)}},de.reflink=function(F,C){var M;if((M=this.rules.inline.reflink.exec(F))||(M=this.rules.inline.nolink.exec(F))){var H=(M[2]||M[1]).replace(/\s+/g," ");if(H=C[H.toLowerCase()],!H||!H.href){var X=M[0].charAt(0);return{type:"text",raw:X,text:X}}return x(M,H,M[0],this.lexer)}},de.emStrong=function(F,C,M){M===void 0&&(M="");var H=this.rules.inline.emStrong.lDelim.exec(F);if(!!H&&!(H[3]&&M.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var X=H[1]||H[2]||"";if(!X||X&&(M===""||this.rules.inline.punctuation.exec(M))){var re=H[0].length-1,ve,ke,Me=re,Le=0,ze=H[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ze.lastIndex=0,C=C.slice(-1*F.length+re);(H=ze.exec(C))!=null;)if(ve=H[1]||H[2]||H[3]||H[4]||H[5]||H[6],!!ve){if(ke=ve.length,H[3]||H[4]){Me+=ke;continue}else if((H[5]||H[6])&&re%3&&!((re+ke)%3)){Le+=ke;continue}if(Me-=ke,!(Me>0)){if(ke=Math.min(ke,ke+Me+Le),Math.min(re,ke)%2){var Be=F.slice(1,re+H.index+ke);return{type:"em",raw:F.slice(0,re+H.index+ke+1),text:Be,tokens:this.lexer.inlineTokens(Be,[])}}var Oe=F.slice(2,re+H.index+ke-1);return{type:"strong",raw:F.slice(0,re+H.index+ke+1),text:Oe,tokens:this.lexer.inlineTokens(Oe,[])}}}}}},de.codespan=function(F){var C=this.rules.inline.code.exec(F);if(C){var M=C[2].replace(/\n/g," "),H=/[^ ]/.test(M),X=/^ /.test(M)&&/ $/.test(M);return H&&X&&(M=M.substring(1,M.length-1)),M=s(M,!0),{type:"codespan",raw:C[0],text:M}}},de.br=function(F){var C=this.rules.inline.br.exec(F);if(C)return{type:"br",raw:C[0]}},de.del=function(F){var C=this.rules.inline.del.exec(F);if(C)return{type:"del",raw:C[0],text:C[2],tokens:this.lexer.inlineTokens(C[2],[])}},de.autolink=function(F,C){var M=this.rules.inline.autolink.exec(F);if(M){var H,X;return M[2]==="@"?(H=s(this.options.mangle?C(M[1]):M[1]),X="mailto:"+H):(H=s(M[1]),X=H),{type:"link",raw:M[0],text:H,href:X,tokens:[{type:"text",raw:H,text:H}]}}},de.url=function(F,C){var M;if(M=this.rules.inline.url.exec(F)){var H,X;if(M[2]==="@")H=s(this.options.mangle?C(M[0]):M[0]),X="mailto:"+H;else{var re;do re=M[0],M[0]=this.rules.inline._backpedal.exec(M[0])[0];while(re!==M[0]);H=s(M[0]),M[1]==="www."?X="http://"+H:X=H}return{type:"link",raw:M[0],text:H,href:X,tokens:[{type:"text",raw:H,text:H}]}}},de.inlineText=function(F,C){var M=this.rules.inline.text.exec(F);if(M){var H;return this.lexer.state.inRawBlock?H=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(M[0]):s(M[0]):M[0]:H=s(this.options.smartypants?C(M[0]):M[0]),{type:"text",raw:M[0],text:H}}},pe}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=_(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=_(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=_(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=_(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=_(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=_(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=l({},z),z.gfm=l({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=_(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=_(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=l({},z.normal,{html:_(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:_(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=_(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=_(z._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=_(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=_(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=_(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=_(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=_(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=_(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=_(q.reflink).replace("label",q._label).replace("ref",z._label).getRegex(),q.nolink=_(q.nolink).replace("ref",z._label).getRegex(),q.reflinkSearch=_(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=l({},q),q.pedantic=l({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:_(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:_(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=l({},q.normal,{escape:_(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=_(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=l({},q.gfm,{br:_(q.br).replace("{2,}","*").getRegex(),text:_(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(pe){return pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(pe){var de="",L,F,C=pe.length;for(L=0;L<C;L++)F=pe.charCodeAt(L),Math.random()>.5&&(F="x"+F.toString(16)),de+="&#"+F+";";return de}var V=function(){function pe(L){this.tokens=[],this.tokens.links=Object.create(null),this.options=L||Y.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:z.normal,inline:q.normal};this.options.pedantic?(F.block=z.pedantic,F.inline=q.pedantic):this.options.gfm&&(F.block=z.gfm,this.options.breaks?F.inline=q.breaks:F.inline=q.gfm),this.tokenizer.rules=F}pe.lex=function(F,C){var M=new pe(C);return M.lex(F)},pe.lexInline=function(F,C){var M=new pe(C);return M.inlineTokens(F)};var de=pe.prototype;return de.lex=function(F){F=F.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(F,this.tokens);for(var C;C=this.inlineQueue.shift();)this.inlineTokens(C.src,C.tokens);return this.tokens},de.blockTokens=function(F,C){var M=this;C===void 0&&(C=[]),this.options.pedantic&&(F=F.replace(/^ +$/gm,""));for(var H,X,re,ve;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(H=Me.call({lexer:M},F,C))?(F=F.substring(H.raw.length),C.push(H),!0):!1}))){if(H=this.tokenizer.space(F)){F=F.substring(H.raw.length),H.raw.length===1&&C.length>0?C[C.length-1].raw+=`
`:C.push(H);continue}if(H=this.tokenizer.code(F)){F=F.substring(H.raw.length),X=C[C.length-1],X&&(X.type==="paragraph"||X.type==="text")?(X.raw+=`
`+H.raw,X.text+=`
`+H.text,this.inlineQueue[this.inlineQueue.length-1].src=X.text):C.push(H);continue}if(H=this.tokenizer.fences(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.heading(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.hr(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.blockquote(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.list(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.html(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.def(F)){F=F.substring(H.raw.length),X=C[C.length-1],X&&(X.type==="paragraph"||X.type==="text")?(X.raw+=`
`+H.raw,X.text+=`
`+H.raw,this.inlineQueue[this.inlineQueue.length-1].src=X.text):this.tokens.links[H.tag]||(this.tokens.links[H.tag]={href:H.href,title:H.title});continue}if(H=this.tokenizer.table(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.lheading(F)){F=F.substring(H.raw.length),C.push(H);continue}if(re=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Le=F.slice(1),ze=void 0;M.options.extensions.startBlock.forEach(function(Be){ze=Be.call({lexer:this},Le),typeof ze=="number"&&ze>=0&&(Me=Math.min(Me,ze))}),Me<1/0&&Me>=0&&(re=F.substring(0,Me+1))}(),this.state.top&&(H=this.tokenizer.paragraph(re))){X=C[C.length-1],ve&&X.type==="paragraph"?(X.raw+=`
`+H.raw,X.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=X.text):C.push(H),ve=re.length!==F.length,F=F.substring(H.raw.length);continue}if(H=this.tokenizer.text(F)){F=F.substring(H.raw.length),X=C[C.length-1],X&&X.type==="text"?(X.raw+=`
`+H.raw,X.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=X.text):C.push(H);continue}if(F){var ke="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return this.state.top=!0,C},de.inline=function(F,C){this.inlineQueue.push({src:F,tokens:C})},de.inlineTokens=function(F,C){var M=this;C===void 0&&(C=[]);var H,X,re,ve=F,ke,Me,Le;if(this.tokens.links){var ze=Object.keys(this.tokens.links);if(ze.length>0)for(;(ke=this.tokenizer.rules.inline.reflinkSearch.exec(ve))!=null;)ze.includes(ke[0].slice(ke[0].lastIndexOf("[")+1,-1))&&(ve=ve.slice(0,ke.index)+"["+A("a",ke[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ke=this.tokenizer.rules.inline.blockSkip.exec(ve))!=null;)ve=ve.slice(0,ke.index)+"["+A("a",ke[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ke=this.tokenizer.rules.inline.escapedEmSt.exec(ve))!=null;)ve=ve.slice(0,ke.index)+"++"+ve.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(Me||(Le=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Oe){return(H=Oe.call({lexer:M},F,C))?(F=F.substring(H.raw.length),C.push(H),!0):!1}))){if(H=this.tokenizer.escape(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.tag(F)){F=F.substring(H.raw.length),X=C[C.length-1],X&&H.type==="text"&&X.type==="text"?(X.raw+=H.raw,X.text+=H.text):C.push(H);continue}if(H=this.tokenizer.link(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(H.raw.length),X=C[C.length-1],X&&H.type==="text"&&X.type==="text"?(X.raw+=H.raw,X.text+=H.text):C.push(H);continue}if(H=this.tokenizer.emStrong(F,ve,Le)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.codespan(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.br(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.del(F)){F=F.substring(H.raw.length),C.push(H);continue}if(H=this.tokenizer.autolink(F,J)){F=F.substring(H.raw.length),C.push(H);continue}if(!this.state.inLink&&(H=this.tokenizer.url(F,J))){F=F.substring(H.raw.length),C.push(H);continue}if(re=F,this.options.extensions&&this.options.extensions.startInline&&function(){var Oe=1/0,Xe=F.slice(1),tt=void 0;M.options.extensions.startInline.forEach(function(Te){tt=Te.call({lexer:this},Xe),typeof tt=="number"&&tt>=0&&(Oe=Math.min(Oe,tt))}),Oe<1/0&&Oe>=0&&(re=F.substring(0,Oe+1))}(),H=this.tokenizer.inlineText(re,j)){F=F.substring(H.raw.length),H.raw.slice(-1)!=="_"&&(Le=H.raw.slice(-1)),Me=!0,X=C[C.length-1],X&&X.type==="text"?(X.raw+=H.raw,X.text+=H.text):C.push(H);continue}if(F){var Be="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(Be);break}else throw new Error(Be)}}return C},r(pe,null,[{key:"rules",get:function(){return{block:z,inline:q}}}]),pe}(),ie=function(){function pe(L){this.options=L||Y.defaults}var de=pe.prototype;return de.code=function(F,C,M){var H=(C||"").match(/\S*/)[0];if(this.options.highlight){var X=this.options.highlight(F,H);X!=null&&X!==F&&(M=!0,F=X)}return F=F.replace(/\n$/,"")+`
`,H?'<pre><code class="'+this.options.langPrefix+s(H,!0)+'">'+(M?F:s(F,!0))+`</code></pre>
`:"<pre><code>"+(M?F:s(F,!0))+`</code></pre>
`},de.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},de.html=function(F){return F},de.heading=function(F,C,M,H){return this.options.headerIds?"<h"+C+' id="'+this.options.headerPrefix+H.slug(M)+'">'+F+"</h"+C+`>
`:"<h"+C+">"+F+"</h"+C+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(F,C,M){var H=C?"ol":"ul",X=C&&M!==1?' start="'+M+'"':"";return"<"+H+X+`>
`+F+"</"+H+`>
`},de.listitem=function(F){return"<li>"+F+`</li>
`},de.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(F){return"<p>"+F+`</p>
`},de.table=function(F,C){return C&&(C="<tbody>"+C+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+C+`</table>
`},de.tablerow=function(F){return`<tr>
`+F+`</tr>
`},de.tablecell=function(F,C){var M=C.header?"th":"td",H=C.align?"<"+M+' align="'+C.align+'">':"<"+M+">";return H+F+"</"+M+`>
`},de.strong=function(F){return"<strong>"+F+"</strong>"},de.em=function(F){return"<em>"+F+"</em>"},de.codespan=function(F){return"<code>"+F+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(F){return"<del>"+F+"</del>"},de.link=function(F,C,M){if(F=D(this.options.sanitize,this.options.baseUrl,F),F===null)return M;var H='<a href="'+s(F)+'"';return C&&(H+=' title="'+C+'"'),H+=">"+M+"</a>",H},de.image=function(F,C,M){if(F=D(this.options.sanitize,this.options.baseUrl,F),F===null)return M;var H='<img src="'+F+'" alt="'+M+'"';return C&&(H+=' title="'+C+'"'),H+=this.options.xhtml?"/>":">",H},de.text=function(F){return F},pe}(),ae=function(){function pe(){}var de=pe.prototype;return de.strong=function(F){return F},de.em=function(F){return F},de.codespan=function(F){return F},de.del=function(F){return F},de.html=function(F){return F},de.text=function(F){return F},de.link=function(F,C,M){return""+M},de.image=function(F,C,M){return""+M},de.br=function(){return""},pe}(),te=function(){function pe(){this.seen={}}var de=pe.prototype;return de.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(F,C){var M=F,H=0;if(this.seen.hasOwnProperty(M)){H=this.seen[F];do H++,M=F+"-"+H;while(this.seen.hasOwnProperty(M))}return C||(this.seen[F]=H,this.seen[M]=0),M},de.slug=function(F,C){C===void 0&&(C={});var M=this.serialize(F);return this.getNextSafeSlug(M,C.dryrun)},pe}(),ue=function(){function pe(L){this.options=L||Y.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ae,this.slugger=new te}pe.parse=function(F,C){var M=new pe(C);return M.parse(F)},pe.parseInline=function(F,C){var M=new pe(C);return M.parseInline(F)};var de=pe.prototype;return de.parse=function(F,C){C===void 0&&(C=!0);var M="",H,X,re,ve,ke,Me,Le,ze,Be,Oe,Xe,tt,Te,et,G,Q,ce,Re,xe,Ge=F.length;for(H=0;H<Ge;H++){if(Oe=F[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(xe=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),xe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Oe.type))){M+=xe||"";continue}switch(Oe.type){case"space":continue;case"hr":{M+=this.renderer.hr();continue}case"heading":{M+=this.renderer.heading(this.parseInline(Oe.tokens),Oe.depth,u(this.parseInline(Oe.tokens,this.textRenderer)),this.slugger);continue}case"code":{M+=this.renderer.code(Oe.text,Oe.lang,Oe.escaped);continue}case"table":{for(ze="",Le="",ve=Oe.header.length,X=0;X<ve;X++)Le+=this.renderer.tablecell(this.parseInline(Oe.header[X].tokens),{header:!0,align:Oe.align[X]});for(ze+=this.renderer.tablerow(Le),Be="",ve=Oe.rows.length,X=0;X<ve;X++){for(Me=Oe.rows[X],Le="",ke=Me.length,re=0;re<ke;re++)Le+=this.renderer.tablecell(this.parseInline(Me[re].tokens),{header:!1,align:Oe.align[re]});Be+=this.renderer.tablerow(Le)}M+=this.renderer.table(ze,Be);continue}case"blockquote":{Be=this.parse(Oe.tokens),M+=this.renderer.blockquote(Be);continue}case"list":{for(Xe=Oe.ordered,tt=Oe.start,Te=Oe.loose,ve=Oe.items.length,Be="",X=0;X<ve;X++)G=Oe.items[X],Q=G.checked,ce=G.task,et="",G.task&&(Re=this.renderer.checkbox(Q),Te?G.tokens.length>0&&G.tokens[0].type==="paragraph"?(G.tokens[0].text=Re+" "+G.tokens[0].text,G.tokens[0].tokens&&G.tokens[0].tokens.length>0&&G.tokens[0].tokens[0].type==="text"&&(G.tokens[0].tokens[0].text=Re+" "+G.tokens[0].tokens[0].text)):G.tokens.unshift({type:"text",text:Re}):et+=Re),et+=this.parse(G.tokens,Te),Be+=this.renderer.listitem(et,ce,Q);M+=this.renderer.list(Be,Xe,tt);continue}case"html":{M+=this.renderer.html(Oe.text);continue}case"paragraph":{M+=this.renderer.paragraph(this.parseInline(Oe.tokens));continue}case"text":{for(Be=Oe.tokens?this.parseInline(Oe.tokens):Oe.text;H+1<Ge&&F[H+1].type==="text";)Oe=F[++H],Be+=`
`+(Oe.tokens?this.parseInline(Oe.tokens):Oe.text);M+=C?this.renderer.paragraph(Be):Be;continue}default:{var Je='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return M},de.parseInline=function(F,C){C=C||this.renderer;var M="",H,X,re,ve=F.length;for(H=0;H<ve;H++){if(X=F[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(re=this.options.extensions.renderers[X.type].call({parser:this},X),re!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(X.type))){M+=re||"";continue}switch(X.type){case"escape":{M+=C.text(X.text);break}case"html":{M+=C.html(X.text);break}case"link":{M+=C.link(X.href,X.title,this.parseInline(X.tokens,C));break}case"image":{M+=C.image(X.href,X.title,X.text);break}case"strong":{M+=C.strong(this.parseInline(X.tokens,C));break}case"em":{M+=C.em(this.parseInline(X.tokens,C));break}case"codespan":{M+=C.codespan(X.text);break}case"br":{M+=C.br();break}case"del":{M+=C.del(this.parseInline(X.tokens,C));break}case"text":{M+=C.text(X.text);break}default:{var ke='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return M},pe}();function fe(pe,de,L){if(typeof pe=="undefined"||pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(pe)+", string expected");if(typeof de=="function"&&(L=de,de=null),de=l({},fe.defaults,de||{}),T(de),L){var F=de.highlight,C;try{C=V.lex(pe,de)}catch(re){return L(re)}var M=function(ve){var ke;if(!ve)try{de.walkTokens&&fe.walkTokens(C,de.walkTokens),ke=ue.parse(C,de)}catch(Me){ve=Me}return de.highlight=F,ve?L(ve):L(null,ke)};if(!F||F.length<3||(delete de.highlight,!C.length))return M();var H=0;fe.walkTokens(C,function(re){re.type==="code"&&(H++,setTimeout(function(){F(re.text,re.lang,function(ve,ke){if(ve)return M(ve);ke!=null&&ke!==re.text&&(re.text=ke,re.escaped=!0),H--,H===0&&M()})},0))}),H===0&&M();return}try{var X=V.lex(pe,de);return de.walkTokens&&fe.walkTokens(X,de.walkTokens),ue.parse(X,de)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+s(re.message+"",!0)+"</pre>";throw re}}fe.options=fe.setOptions=function(pe){return l(fe.defaults,pe),O(fe.defaults),fe},fe.getDefaults=y,fe.defaults=Y.defaults,fe.use=function(){for(var pe=arguments.length,de=new Array(pe),L=0;L<pe;L++)de[L]=arguments[L];var F=l.apply(void 0,[{}].concat(de)),C=fe.defaults.extensions||{renderers:{},childTokens:{}},M;de.forEach(function(H){if(H.extensions&&(M=!0,H.extensions.forEach(function(re){if(!re.name)throw new Error("extension name required");if(re.renderer){var ve=C.renderers?C.renderers[re.name]:null;ve?C.renderers[re.name]=function(){for(var ke=arguments.length,Me=new Array(ke),Le=0;Le<ke;Le++)Me[Le]=arguments[Le];var ze=re.renderer.apply(this,Me);return ze===!1&&(ze=ve.apply(this,Me)),ze}:C.renderers[re.name]=re.renderer}if(re.tokenizer){if(!re.level||re.level!=="block"&&re.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");C[re.level]?C[re.level].unshift(re.tokenizer):C[re.level]=[re.tokenizer],re.start&&(re.level==="block"?C.startBlock?C.startBlock.push(re.start):C.startBlock=[re.start]:re.level==="inline"&&(C.startInline?C.startInline.push(re.start):C.startInline=[re.start]))}re.childTokens&&(C.childTokens[re.name]=re.childTokens)})),H.renderer&&function(){var re=fe.defaults.renderer||new ie,ve=function(Le){var ze=re[Le];re[Le]=function(){for(var Be=arguments.length,Oe=new Array(Be),Xe=0;Xe<Be;Xe++)Oe[Xe]=arguments[Xe];var tt=H.renderer[Le].apply(re,Oe);return tt===!1&&(tt=ze.apply(re,Oe)),tt}};for(var ke in H.renderer)ve(ke);F.renderer=re}(),H.tokenizer&&function(){var re=fe.defaults.tokenizer||new U,ve=function(Le){var ze=re[Le];re[Le]=function(){for(var Be=arguments.length,Oe=new Array(Be),Xe=0;Xe<Be;Xe++)Oe[Xe]=arguments[Xe];var tt=H.tokenizer[Le].apply(re,Oe);return tt===!1&&(tt=ze.apply(re,Oe)),tt}};for(var ke in H.tokenizer)ve(ke);F.tokenizer=re}(),H.walkTokens){var X=fe.defaults.walkTokens;F.walkTokens=function(re){H.walkTokens.call(this,re),X&&X.call(this,re)}}M&&(F.extensions=C),fe.setOptions(F)})},fe.walkTokens=function(pe,de){for(var L=function(){var H=C.value;switch(de.call(fe,H),H.type){case"table":{for(var X=$(H.header),re;!(re=X()).done;){var ve=re.value;fe.walkTokens(ve.tokens,de)}for(var ke=$(H.rows),Me;!(Me=ke()).done;)for(var Le=Me.value,ze=$(Le),Be;!(Be=ze()).done;){var Oe=Be.value;fe.walkTokens(Oe.tokens,de)}break}case"list":{fe.walkTokens(H.items,de);break}default:fe.defaults.extensions&&fe.defaults.extensions.childTokens&&fe.defaults.extensions.childTokens[H.type]?fe.defaults.extensions.childTokens[H.type].forEach(function(Xe){fe.walkTokens(H[Xe],de)}):H.tokens&&fe.walkTokens(H.tokens,de)}},F=$(pe),C;!(C=F()).done;)L()},fe.parseInline=function(pe,de){if(typeof pe=="undefined"||pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(pe)+", string expected");de=l({},fe.defaults,de||{}),T(de);try{var L=V.lexInline(pe,de);return de.walkTokens&&fe.walkTokens(L,de.walkTokens),ue.parseInline(L,de)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+s(F.message+"",!0)+"</pre>";throw F}},fe.Parser=ue,fe.parser=ue.parse,fe.Renderer=ie,fe.TextRenderer=ae,fe.Lexer=V,fe.lexer=V.lex,fe.Tokenizer=U,fe.Slugger=te,fe.parse=fe;var Se=fe.options,ge=fe.setOptions,ne=fe.use,me=fe.walkTokens,Ie=fe.parseInline,Ae=fe,Ue=ue.parse,Ke=V.lex;Y.Lexer=V,Y.Parser=ue,Y.Renderer=ie,Y.Slugger=te,Y.TextRenderer=ae,Y.Tokenizer=U,Y.getDefaults=y,Y.lexer=Ke,Y.marked=fe,Y.options=Se,Y.parse=Ae,Y.parseInline=Ie,Y.parser=Ue,Y.setOptions=ge,Y.use=ne,Y.walkTokens=me,Object.defineProperty(Y,"__esModule",{value:!0})}),define(Ee[102],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(O,I,R){return Math.min(Math.max(O,I),R)}e.clamp=r;function k(O,I){return(I+O%I)%I}e.rot=k;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class ${constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=$;class y{constructor(I){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(I),this._values.fill(0,0,I)}update(I){const R=this._values[this._index];return this._values[this._index]=I,this._index=(this._index+1)%this._values.length,this._sum-=R,this._sum+=I,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function Y(b){const $=[];typeof b=="number"&&$.push("code/timeOrigin",b);function y(I){$.push(I,Date.now())}function O(){const I=[];for(let R=0;R<$.length;R+=2)I.push({name:$[R],startTime:$[R+1]});return I}return{mark:y,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const $=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const y of performance.getEntriesByType("mark"))$.push({name:y.name,startTime:Math.round(b+y.startTime)});return $}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function r(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=r(k))}(),define(Ee[69],be([1,0,17]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var k;(function(v){v.text="text/plain",v.binary="application/octet-stream",v.unknown="application/unknown",v.markdown="text/markdown",v.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},$={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function y(v){const n=(0,r.extname)(v),p=b[n.toLowerCase()];return p!==void 0?p:O(v)}e.getMediaOrTextMime=y;function O(v){const n=(0,r.extname)(v);return $[n.toLowerCase()]}e.getMediaMime=O;function I(v){for(const n in $)if($[n]===v)return n}e.getExtensionForMimeType=I;const R=/^(.+)\/(.+?)(;.+)?$/;function N(v,n){const p=R.exec(v);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:n?void 0:v}e.normalizeMimeType=N}),define(Ee[103],be([1,0,15,6]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function b(w){const d=w;return d?[d.on,d.pause,d.resume,d.destroy].every(D=>typeof D=="function"):!1}e.isReadableStream=b;function $(w){const d=w;return d?b(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=$;function y(w,d){return new O(w,d)}e.newWriteableStream=y;class O{constructor(d,D){this.reducer=d,this.options=D,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(D=>this.pendingWritePromises.push(D))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(D=>D(d))}emitError(d){this.listeners.error.length===0?(0,r.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(D=>D(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,D){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(D),this.resume();break;case"end":this.listeners.end.push(D),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(D),this.state.flowing&&this.flowErrors();break}}removeListener(d,D){if(this.state.destroyed)return;let a;switch(d){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const P=a.indexOf(D);P>=0&&a.splice(P,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const D=[...this.pendingWritePromises];this.pendingWritePromises.length=0,D.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(w,d){const D=[];let a;for(;(a=w.read())!==null;)D.push(a);return d(D)}e.consumeReadable=I;function R(w,d,D){const a=[];let P;for(;(P=w.read())!==null&&a.length<D;)a.push(P);return P===null&&a.length>0?d(a):{read:()=>{if(a.length>0)return a.shift();if(typeof P!="undefined"){const c=P;return P=void 0,c}return w.read()}}}e.peekReadable=R;function N(w,d){return new Promise((D,a)=>{const P=[];v(w,{onData:c=>{d&&P.push(c)},onError:c=>{d?a(c):D(void 0)},onEnd:()=>{D(d?d(P):void 0)}})})}e.consumeStream=N;function v(w,d){let D=!1;return w.on("error",a=>{D||d.onError(a)}),w.on("end",()=>{D||d.onEnd()}),w.on("data",a=>{D||d.onData(a)}),(0,k.toDisposable)(()=>D=!0)}e.listenStream=v;function n(w,d){return new Promise((D,a)=>{const P=new k.DisposableStore,c=[],t=l=>{if(c.push(l),c.length>d)return P.dispose(),w.pause(),D({stream:w,buffer:c,ended:!1})},h=l=>a(l),o=()=>D({stream:w,buffer:c,ended:!0});P.add((0,k.toDisposable)(()=>w.removeListener("error",h))),w.on("error",h),P.add((0,k.toDisposable)(()=>w.removeListener("end",o))),w.on("end",o),P.add((0,k.toDisposable)(()=>w.removeListener("data",t))),w.on("data",t)})}e.peekStream=n;function p(w,d){const D=y(d);return D.end(w),D}e.toStream=p;function s(){const w=y(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=s;function i(w){let d=!1;return{read:()=>d?null:(d=!0,w)}}e.toReadable=i;function u(w,d,D){const a=y(D);return v(w,{onData:P=>a.write(d.data(P)),onError:P=>a.error(d.error?d.error(P):P),onEnd:()=>a.end()}),a}e.transform=u;function S(w,d,D){let a=!1;return{read:()=>{const P=d.read();return a?P:(a=!0,P!==null?D([w,P]):w)}}}e.prefixedReadable=S;function _(w,d,D){let a=!1;const P=y(D);return v(d,{onData:c=>a?P.write(c):(a=!0,P.write(D([w,c]))),onError:c=>P.error(c),onEnd:()=>{a||(a=!0,P.write(w)),P.end()}}),P}e.prefixedStream=_}),define(Ee[21],be([1,0,103]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined";let b,$;class y{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return k?new y(Buffer.allocUnsafe(f)):new y(new Uint8Array(f))}static wrap(f){return k&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new y(f)}static fromString(f,m){return!(m?.dontUseNodeBuffer||!1)&&k?new y(Buffer.from(f)):(b||(b=new TextEncoder),new y(b.encode(f)))}static fromByteArray(f){const m=y.alloc(f.length);for(let E=0,T=f.length;E<T;E++)m.buffer[E]=f[E];return m}static concat(f,m){if(typeof m=="undefined"){m=0;for(let A=0,x=f.length;A<x;A++)m+=f[A].byteLength}const E=y.alloc(m);let T=0;for(let A=0,x=f.length;A<x;A++){const g=f[A];E.set(g,T),T+=g.byteLength}return E}clone(){const f=y.alloc(this.byteLength);return f.set(this),f}toString(){return k?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(f,m){return new y(this.buffer.subarray(f,m))}set(f,m){if(f instanceof y)this.buffer.set(f.buffer,m);else if(f instanceof Uint8Array)this.buffer.set(f,m);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),m);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return R(this.buffer,f)}writeUInt32BE(f,m){N(this.buffer,f,m)}readUInt32LE(f){return v(this.buffer,f)}writeUInt32LE(f,m){n(this.buffer,f,m)}readUInt8(f){return p(this.buffer,f)}writeUInt8(f,m){s(this.buffer,f,m)}}e.VSBuffer=y;function O(l,f){return l[f+0]<<0>>>0|l[f+1]<<8>>>0}e.readUInt16LE=O;function I(l,f,m){l[m+0]=f&255,f=f>>>8,l[m+1]=f&255}e.writeUInt16LE=I;function R(l,f){return l[f]*2**24+l[f+1]*2**16+l[f+2]*2**8+l[f+3]}e.readUInt32BE=R;function N(l,f,m){l[m+3]=f,f=f>>>8,l[m+2]=f,f=f>>>8,l[m+1]=f,f=f>>>8,l[m]=f}e.writeUInt32BE=N;function v(l,f){return l[f+0]<<0>>>0|l[f+1]<<8>>>0|l[f+2]<<16>>>0|l[f+3]<<24>>>0}e.readUInt32LE=v;function n(l,f,m){l[m+0]=f&255,f=f>>>8,l[m+1]=f&255,f=f>>>8,l[m+2]=f&255,f=f>>>8,l[m+3]=f&255}e.writeUInt32LE=n;function p(l,f){return l[f]}e.readUInt8=p;function s(l,f,m){l[m]=f}e.writeUInt8=s;function i(l){return r.consumeReadable(l,f=>y.concat(f))}e.readableToBuffer=i;function u(l){return r.toReadable(l)}e.bufferToReadable=u;function S(l){return r.consumeStream(l,f=>y.concat(f))}e.streamToBuffer=S;async function _(l){return l.ended?y.concat(l.buffer):y.concat([...l.buffer,await S(l.stream)])}e.bufferedStreamToBuffer=_;function w(l){return r.toStream(l,f=>y.concat(f))}e.bufferToStream=w;function d(l){return r.transform(l,{data:f=>typeof f=="string"?y.fromString(f):y.wrap(f)},f=>y.concat(f))}e.streamToBufferReadableStream=d;function D(l){return r.newWriteableStream(f=>y.concat(f),l)}e.newWriteableBufferStream=D;function a(l,f){return r.prefixedReadable(l,f,m=>y.concat(m))}e.prefixedBufferReadable=a;function P(l,f){return r.prefixedStream(l,f,m=>y.concat(m))}e.prefixedBufferStream=P;function c(l){let f=0,m=0,E=0;const T=new Uint8Array(Math.floor(l.length/4*3)),A=g=>{switch(m){case 3:T[E++]=f|g,m=0;break;case 2:T[E++]=f|g>>>2,f=g<<6,m=3;break;case 1:T[E++]=f|g>>>4,f=g<<4,m=2;break;default:f=g<<2,m=1}};for(let g=0;g<l.length;g++){const U=l.charCodeAt(g);if(U>=65&&U<=90)A(U-65);else if(U>=97&&U<=122)A(U-97+26);else if(U>=48&&U<=57)A(U-48+52);else if(U===43||U===45)A(62);else if(U===47||U===95)A(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${l[g]}`)}}const x=E;for(;m>0;)A(0);return y.wrap(T).slice(0,x)}e.decodeBase64=c;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:l},f=!0,m=!1){const E=m?h:t;let T="";const A=l.byteLength%3;let x=0;for(;x<l.byteLength-A;x+=3){const g=l[x+0],U=l[x+1],z=l[x+2];T+=E[g>>>2],T+=E[(g<<4|U>>>4)&63],T+=E[(U<<2|z>>>6)&63],T+=E[z&63]}if(A===1){const g=l[x+0];T+=E[g>>>2],T+=E[g<<4&63],f&&(T+="==")}else if(A===2){const g=l[x+0],U=l[x+1];T+=E[g>>>2],T+=E[(g<<4|U>>>4)&63],T+=E[U<<2&63],f&&(T+="=")}return T}e.encodeBase64=o});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[22],be([1,0,16,10]),function(Y,e,r,k){"use strict";var b,$,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function O(c,t,h){let o=c.get(t);return o===void 0&&(o=h,c.set(t,o)),o}e.getOrSet=O;function I(c){const t=[];return c.forEach((h,o)=>{t.push(`${o} => ${h}`)}),`Map(${c.size}) {${t.join(", ")}}`}e.mapToString=I;function R(c){const t=[];return c.forEach(h=>{t.push(h)}),`Set(${c.size}) {${t.join(", ")}}`}e.setToString=R;class N{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const h=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return h-o}value(){return this._value[this._pos]}}e.StringIterator=N;class v{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,k.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=v;class n{constructor(t=!0,h=!0){this._splitOnBackslash=t,this._caseSensitive=h}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let h=t.length-1;h>=0;h--,this._valueLen--){const o=this._value.charCodeAt(h);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const h=this._value.charCodeAt(this._to);if(h===47||this._splitOnBackslash&&h===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,k.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var p;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(p||(p={}));class s{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,k.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=s;class i{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(u||(u={}));class S{constructor(t){this._iter=t}static forUris(t=()=>!1){return new S(new s(t))}static forPaths(t=!1){return new S(new n(void 0,!t))}static forStrings(){return new S(new N)}static forConfigKeys(){return new S(new v)}clear(){this._root=void 0}fill(t,h){if(h){const o=h.slice(0);(0,r.shuffle)(o);for(let l of o)this.set(l,t)}else{const o=t.slice(0);(0,r.shuffle)(o);for(let l of o)this.set(l[0],l[1])}}set(t,h){const o=this._iter.reset(t);let l;this._root||(this._root=new i,this._root.segment=o.value());const f=[];for(l=this._root;;){const E=o.cmp(l.segment);if(E>0)l.left||(l.left=new i,l.left.segment=o.value()),f.push([-1,l]),l=l.left;else if(E<0)l.right||(l.right=new i,l.right.segment=o.value()),f.push([1,l]),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new i,l.mid.segment=o.value()),f.push([0,l]),l=l.mid;else break}const m=l.value;l.value=h,l.key=t;for(let E=f.length-1;E>=0;E--){const T=f[E][1];T.updateHeight();const A=T.balanceFactor();if(A<-1||A>1){const x=f[E][0],g=f[E+1][0];if(x===1&&g===1)f[E][1]=T.rotateLeft();else if(x===-1&&g===-1)f[E][1]=T.rotateRight();else if(x===1&&g===-1)T.right=f[E+1][1]=f[E+1][1].rotateRight(),f[E][1]=T.rotateLeft();else if(x===-1&&g===1)T.left=f[E+1][1]=f[E+1][1].rotateLeft(),f[E][1]=T.rotateRight();else throw new Error;if(E>0)switch(f[E-1][0]){case-1:f[E-1][1].left=f[E][1];break;case 1:f[E-1][1].right=f[E][1];break;case 0:f[E-1][1].mid=f[E][1];break}else this._root=f[0][1]}}return m}get(t){return this._getNode(t)?.value}_getNode(t){const h=this._iter.reset(t);let o=this._root;for(;o;){const l=h.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(h.hasNext())h.next(),o=o.mid;else break}return o}has(t){const h=this._getNode(t);return!(h?.value===void 0&&h?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,h){const o=this._iter.reset(t),l=[];let f=this._root;for(;f;){const m=o.cmp(f.segment);if(m>0)l.push([-1,f]),f=f.left;else if(m<0)l.push([1,f]),f=f.right;else if(o.hasNext())o.next(),l.push([0,f]),f=f.mid;else break}if(!!f){if(h?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const m=this._min(f.right),{key:E,value:T,segment:A}=m;this._delete(m.key,!1),f.key=E,f.value=T,f.segment=A}else{const m=f.left??f.right;if(l.length>0){const[E,T]=l[l.length-1];switch(E){case-1:T.left=m;break;case 0:T.mid=m;break;case 1:T.right=m;break}}else this._root=m}for(let m=l.length-1;m>=0;m--){const E=l[m][1];E.updateHeight();const T=E.balanceFactor();if(T>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),l[m][1]=E.rotateLeft()):T<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),l[m][1]=E.rotateRight()),m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this._root=l[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const h=this._iter.reset(t);let o=this._root,l;for(;o;){const f=h.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(h.hasNext())h.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(t){const h=this._iter.reset(t);let o=this._root;for(;o;){const l=h.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(h.hasNext())h.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[h,o]of this)t(o,h)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=h=>{if(!h)return!0;const o=h.balanceFactor();return o<-1||o>1?!1:t(h.left)&&t(h.right)};return t(this._root)}}e.TernarySearchTree=S;class _{constructor(t,h){this.uri=t,this.value=h}}class w{constructor(t,h){this[b]="ResourceMap",t instanceof w?(this.map=new Map(t.map),this.toKey=h??w.defaultToKey):(this.map=new Map,this.toKey=t??w.defaultToKey)}set(t,h){return this.map.set(this.toKey(t),new _(t,h)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,h){typeof h!="undefined"&&(t=t.bind(h));for(let[o,l]of this.map)t(l.value,l.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=w,w.defaultToKey=c=>c.toString();var d;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(d=e.Touch||(e.Touch={}));class D{constructor(){this[$]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,h=0){const o=this._map.get(t);if(!!o)return h!==0&&this.touch(o,h),o.value}set(t,h,o=0){let l=this._map.get(t);if(l)l.value=h,o!==0&&this.touch(l,o);else{switch(l={key:t,value:h,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(t,l),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const h=this._map.get(t);if(!!h)return this._map.delete(t),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,h){const o=this._state;let l=this._head;for(;l;){if(h?t.bind(h)(l.value,l.key,this):t(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const t=this,h=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==h)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.key,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return l}values(){const t=this,h=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==h)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.value,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return l}entries(){const t=this,h=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==h)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:[o.key,o.value],done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return l}[($=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let h=this._head,o=this.size;for(;h&&o>t;)this._map.delete(h.key),h=h.next,o--;this._head=h,this._size=o,h&&(h.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const h=t.next,o=t.previous;if(!h||!o)throw new Error("Invalid list");h.previous=o,o.next=h}t.next=void 0,t.previous=void 0,this._state++}touch(t,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(t===this._head)return;const o=t.next,l=t.previous;t===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(h===2){if(t===this._tail)return;const o=t.next,l=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((h,o)=>{t.push([o,h])}),t}fromJSON(t){this.clear();for(const[h,o]of t)this.set(h,o)}}e.LinkedMap=D;class a extends D{constructor(t,h=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,h=2){return super.get(t,h)}peek(t){return super.get(t,0)}set(t,h){return super.set(t,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class P{constructor(t){y.set(this,void 0),je(this,y,t,"f")}get size(){return De(this,y,"f").size}forEach(t,h){De(this,y,"f").forEach(t,h)}get(t){return De(this,y,"f").get(t)}has(t){return De(this,y,"f").has(t)}entries(){return De(this,y,"f").entries()}keys(){return De(this,y,"f").keys()}values(){return De(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return De(this,y,"f").entries()}}e.ReadonlyMapView=P}),define(Ee[104],be([1,0,22,10]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...C){return function(M,H){for(let X=0,re=C.length;X<re;X++){const ve=C[X](M,H);if(ve)return ve}return null}}e.or=b,e.matchesStrictPrefix=$.bind(void 0,!1),e.matchesPrefix=$.bind(void 0,!0);function $(C,M,H){if(!H||H.length<M.length)return null;let X;return C?X=k.startsWithIgnoreCase(H,M):X=H.indexOf(M)===0,X?M.length>0?[{start:0,end:M.length}]:[]:null}function y(C,M){const H=M.toLowerCase().indexOf(C.toLowerCase());return H===-1?null:[{start:H,end:H+C.length}]}e.matchesContiguousSubString=y;function O(C,M){return I(C.toLowerCase(),M.toLowerCase(),0,0)}e.matchesSubString=O;function I(C,M,H,X){if(H===C.length)return[];if(X===M.length)return null;if(C[H]===M[X]){let re=null;return(re=I(C,M,H+1,X+1))?S({start:X,end:X+1},re):null}return I(C,M,H,X+1)}function R(C){return 97<=C&&C<=122}function N(C){return 65<=C&&C<=90}e.isUpper=N;function v(C){return 48<=C&&C<=57}function n(C){return C===32||C===9||C===10||C===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(C=>p.add(C.charCodeAt(0)));function s(C){return n(C)||p.has(C)}function i(C,M){return C===M||s(C)&&s(M)}function u(C){return R(C)||N(C)||v(C)}function S(C,M){return M.length===0?M=[C]:C.end===M[0].start?M[0].start=C.start:M.unshift(C),M}function _(C,M){for(let H=M;H<C.length;H++){const X=C.charCodeAt(H);if(N(X)||v(X)||H>0&&!u(C.charCodeAt(H-1)))return H}return C.length}function w(C,M,H,X){if(H===C.length)return[];if(X===M.length)return null;if(C[H]!==M[X].toLowerCase())return null;{let re=null,ve=X+1;for(re=w(C,M,H+1,X+1);!re&&(ve=_(M,ve))<M.length;)re=w(C,M,H+1,ve),ve++;return re===null?null:S({start:X,end:X+1},re)}}function d(C){let M=0,H=0,X=0,re=0,ve=0;for(let Be=0;Be<C.length;Be++)ve=C.charCodeAt(Be),N(ve)&&M++,R(ve)&&H++,u(ve)&&X++,v(ve)&&re++;const ke=M/C.length,Me=H/C.length,Le=X/C.length,ze=re/C.length;return{upperPercent:ke,lowerPercent:Me,alphaPercent:Le,numericPercent:ze}}function D(C){const{upperPercent:M,lowerPercent:H}=C;return H===0&&M>.6}function a(C){const{upperPercent:M,lowerPercent:H,alphaPercent:X,numericPercent:re}=C;return H>.2&&M<.8&&X>.6&&re<.2}function P(C){let M=0,H=0,X=0,re=0;for(let ve=0;ve<C.length;ve++)X=C.charCodeAt(ve),N(X)&&M++,R(X)&&H++,n(X)&&re++;return(M===0||H===0)&&re===0?C.length<=30:M<=5}function c(C,M){if(!M||(M=M.trim(),M.length===0)||!P(C)||M.length>60)return null;const H=d(M);if(!a(H)){if(!D(H))return null;M=M.toLowerCase()}let X=null,re=0;for(C=C.toLowerCase();re<M.length&&(X=w(C,M,0,re))===null;)re=_(M,re+1);return X}e.matchesCamelCase=c;function t(C,M,H=!1){if(!M||M.length===0)return null;let X=null,re=0;for(C=C.toLowerCase(),M=M.toLowerCase();re<M.length&&(X=h(C,M,0,re,H))===null;)re=o(M,re+1);return X}e.matchesWords=t;function h(C,M,H,X,re){if(H===C.length)return[];if(X===M.length)return null;if(i(C.charCodeAt(H),M.charCodeAt(X))){let ve=null,ke=X+1;if(ve=h(C,M,H+1,X+1,re),!re)for(;!ve&&(ke=o(M,ke))<M.length;)ve=h(C,M,H+1,ke,re),ke++;return ve===null?null:S({start:X,end:X+1},ve)}else return null}function o(C,M){for(let H=M;H<C.length;H++)if(s(C.charCodeAt(H))||H>0&&s(C.charCodeAt(H-1)))return H;return C.length}const l=b(e.matchesPrefix,c,y),f=b(e.matchesPrefix,c,O),m=new r.LRUCache(1e4);function E(C,M,H=!1){if(typeof C!="string"||typeof M!="string")return null;let X=m.get(C);X||(X=new RegExp(k.convertSimple2RegExpPattern(C),"i"),m.set(C,X));const re=X.exec(M);return re?[{start:re.index,end:re.index+re[0].length}]:H?f(C,M):l(C,M)}e.matchesFuzzy=E;function T(C,M){const H=Ae(C,C.toLowerCase(),0,M,M.toLowerCase(),0,!0);return H?x(H):null}e.matchesFuzzy2=T;function A(C,M,H,X,re,ve){const ke=Math.min(13,C.length);for(;H<ke;H++){const Me=Ae(C,M,H,X,re,ve,!1);if(Me)return Me}return[0,ve]}e.anyScore=A;function x(C){if(typeof C=="undefined")return[];const M=[],H=C[1];for(let X=C.length-1;X>1;X--){const re=C[X]+H,ve=M[M.length-1];ve&&ve.end===re?ve.end=re+1:M.push({start:re,end:re+1})}return M}e.createMatches=x;const g=128;function U(){const C=[],M=[];for(let H=0;H<=g;H++)M[H]=0;for(let H=0;H<=g;H++)C.push(M.slice(0));return C}function z(C){const M=[];for(let H=0;H<=C;H++)M[H]=0;return M}const q=z(2*g),j=z(2*g),J=U(),V=U(),ie=U(),ae=!1;function te(C,M,H,X,re){function ve(Me,Le,ze=" "){for(;Me.length<Le;)Me=ze+Me;return Me}let ke=` |   |${X.split("").map(Me=>ve(Me,3)).join("|")}
`;for(let Me=0;Me<=H;Me++)Me===0?ke+=" |":ke+=`${M[Me-1]}|`,ke+=C[Me].slice(0,re+1).map(Le=>ve(Le.toString(),3)).join("|")+`
`;return ke}function ue(C,M,H,X){C=C.substr(M),H=H.substr(X),console.log(te(V,C,C.length,H,H.length)),console.log(te(ie,C,C.length,H,H.length)),console.log(te(J,C,C.length,H,H.length))}function fe(C,M){if(M<0||M>=C.length)return!1;const H=C.codePointAt(M);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(H)}}function Se(C,M){if(M<0||M>=C.length)return!1;switch(C.charCodeAt(M)){case 32:case 9:return!0;default:return!1}}function ge(C,M,H){return M[C]!==H[C]}function ne(C,M,H,X,re,ve,ke=!1){for(;M<H&&re<ve;)C[M]===X[re]&&(ke&&(q[M]=re),M+=1),re+=1;return M===H}e.isPatternInWord=ne;var me;(function(C){C[C.Diag=1]="Diag",C[C.Left=2]="Left",C[C.LeftLeft=3]="LeftLeft"})(me||(me={}));var Ie;(function(C){C.Default=[-100,0];function M(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}C.isDefault=M})(Ie=e.FuzzyScore||(e.FuzzyScore={}));function Ae(C,M,H,X,re,ve,ke){const Me=C.length>g?g:C.length,Le=X.length>g?g:X.length;if(H>=Me||ve>=Le||Me-H>Le-ve||!ne(M,H,Me,re,ve,Le,!0))return;Ue(Me,Le,H,ve,M,re);let ze=1,Be=1,Oe=H,Xe=ve;const tt=[!1];for(ze=1,Oe=H;Oe<Me;ze++,Oe++){const ce=q[Oe],Re=j[Oe],xe=Oe+1<Me?j[Oe+1]:Le;for(Be=ce-ve+1,Xe=ce;Xe<xe;Be++,Xe++){let Ge=Number.MIN_SAFE_INTEGER,Je=!1;Xe<=Re&&(Ge=Ke(C,M,Oe,H,X,re,Xe,Le,ve,J[ze-1][Be-1]===0,tt));let at=0;Ge!==Number.MAX_SAFE_INTEGER&&(Je=!0,at=Ge+V[ze-1][Be-1]);const yt=Xe>ce,Dt=yt?V[ze][Be-1]+(J[ze][Be-1]>0?-5:0):0,Ot=Xe>ce+1&&J[ze][Be-1]>0,Ve=Ot?V[ze][Be-2]+(J[ze][Be-2]>0?-5:0):0;if(Ot&&(!yt||Ve>=Dt)&&(!Je||Ve>=at))V[ze][Be]=Ve,ie[ze][Be]=3,J[ze][Be]=0;else if(yt&&(!Je||Dt>=at))V[ze][Be]=Dt,ie[ze][Be]=2,J[ze][Be]=0;else if(Je)V[ze][Be]=at,ie[ze][Be]=1,J[ze][Be]=J[ze-1][Be-1]+1;else throw new Error("not possible")}}if(ae&&ue(C,H,X,ve),!tt[0]&&!ke)return;ze--,Be--;const Te=[V[ze][Be],ve];let et=0,G=0;for(;ze>=1;){let ce=Be;do{const Re=ie[ze][ce];if(Re===3)ce=ce-2;else if(Re===2)ce=ce-1;else break}while(ce>=1);et>1&&M[H+ze-1]===re[ve+Be-1]&&!ge(ce+ve-1,X,re)&&et+1>J[ze][ce]&&(ce=Be),ce===Be?et++:et=1,G||(G=ce),ze--,Be=ce-1,Te.push(Be)}Le===Me&&(Te[0]+=2);const Q=G-Me;return Te[0]-=Q,Te}e.fuzzyScore=Ae;function Ue(C,M,H,X,re,ve){let ke=C-1,Me=M-1;for(;ke>=H&&Me>=X;)re[ke]===ve[Me]&&(j[ke]=Me,ke--),Me--}function Ke(C,M,H,X,re,ve,ke,Me,Le,ze,Be){if(M[H]!==ve[ke])return Number.MIN_SAFE_INTEGER;let Oe=1,Xe=!1;return ke===H-X?Oe=C[H]===re[ke]?7:5:ge(ke,re,ve)&&(ke===0||!ge(ke-1,re,ve))?(Oe=C[H]===re[ke]?7:5,Xe=!0):fe(ve,ke)&&(ke===0||!fe(ve,ke-1))?Oe=5:(fe(ve,ke-1)||Se(ve,ke-1))&&(Oe=5,Xe=!0),Oe>1&&H===X&&(Be[0]=!0),Xe||(Xe=ge(ke,re,ve)||fe(ve,ke-1)||Se(ve,ke-1)),H===X?ke>Le&&(Oe-=Xe?3:5):ze?Oe+=Xe?2:0:Oe+=Xe?0:1,ke+1===Me&&(Oe-=Xe?3:5),Oe}function pe(C,M,H,X,re,ve,ke){return L(C,M,H,X,re,ve,!0,ke)}e.fuzzyScoreGracefulAggressive=pe;function de(C,M,H,X,re,ve,ke){return L(C,M,H,X,re,ve,!1,ke)}e.fuzzyScoreGraceful=de;function L(C,M,H,X,re,ve,ke,Me){let Le=Ae(C,M,H,X,re,ve,Me);if(Le&&!ke)return Le;if(C.length>=3){const ze=Math.min(7,C.length-1);for(let Be=H+1;Be<ze;Be++){const Oe=F(C,Be);if(Oe){const Xe=Ae(Oe,Oe.toLowerCase(),H,X,re,ve,Me);Xe&&(Xe[0]-=3,(!Le||Xe[0]>Le[0])&&(Le=Xe))}}}return Le}function F(C,M){if(M+1>=C.length)return;const H=C[M],X=C[M+1];if(H!==X)return C.slice(0,M)+X+H+C.slice(M+2)}}),define(Ee[105],be([1,0,106,104,10]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const $=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(r.CSSIcon.iconNameCharacter),O=new RegExp(`(\\\\)?${$.source}`,"g");function I(u){return u.replace(O,(S,_)=>_?S:`\\${S}`)}e.escapeIcons=I;const R=new RegExp(`\\\\${$.source}`,"g");function N(u){return u.replace(R,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=N;const v=new RegExp(`(\\s)?(\\\\)?${$.source}(\\s)?`,"g");function n(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(v,(S,_,w,d)=>w?S:_||d||"")}e.stripIcons=n;function p(u){const S=u.indexOf(e.iconStartMarker);return S===-1?{text:u}:s(u,S)}e.parseLabelWithIcons=p;function s(u,S){const _=[];let w="";function d(l){if(l){w+=l;for(const f of l)_.push(P)}}let D=-1,a="",P=0,c,t,h=S;const o=u.length;for(d(u.substr(0,S));h<o;)c=u[h],t=u[h+1],c===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(D=h,d(a),a=e.iconStartMarker,h++):c===")"&&D!==-1?(P+=h-D+1,D=-1,a=""):D!==-1?y.test(c)?a+=c:(d(a),D=-1,a=""):d(c),h++;return d(a),{text:w,iconOffsets:_}}function i(u,S,_=!1){const{text:w,iconOffsets:d}=S;if(!d||d.length===0)return(0,k.matchesFuzzy)(u,w,_);const D=(0,b.ltrim)(w," "),a=w.length-D.length,P=(0,k.matchesFuzzy)(u,D,_);if(P)for(const c of P){const t=d[c.start+a]+a;c.start+=t,c.end+=t}return P}e.matchesFuzzyIconAware=i}),define(Ee[34],be([1,0,10]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(k||(k={})),function(b){const $="error",y="warning",O="warn",I="info",R="ignore";function N(n){return n?r.equalsIgnoreCase($,n)?b.Error:r.equalsIgnoreCase(y,n)||r.equalsIgnoreCase(O,n)?b.Warning:r.equalsIgnoreCase(I,n)?b.Info:b.Ignore:b.Ignore}b.fromValue=N;function v(n){switch(n){case b.Error:return $;case b.Warning:return y;case b.Info:return I;default:return R}}b.toString=v}(k||(k={})),e.default=k}),define(Ee[35],be([1,0,17,23,10,13]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(h){return h===47||h===92}e.isPathSeparator=y;function O(h){return h.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=O;function I(h){return h.indexOf("/")===-1&&(h=O(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.toPosixPath=I;function R(h,o=r.posix.sep){if(!h)return"";const l=h.length,f=h.charCodeAt(0);if(y(f)){if(y(h.charCodeAt(1))&&!y(h.charCodeAt(2))){let E=3;const T=E;for(;E<l&&!y(h.charCodeAt(E));E++);if(T!==E&&!y(h.charCodeAt(E+1))){for(E+=1;E<l;E++)if(y(h.charCodeAt(E)))return h.slice(0,E+1).replace(/[\\/]/g,o)}}return o}else if(S(f)&&h.charCodeAt(1)===58)return y(h.charCodeAt(2))?h.slice(0,2)+o:h.slice(0,2);let m=h.indexOf("://");if(m!==-1){for(m+=3;m<l;m++)if(y(h.charCodeAt(m)))return h.slice(0,m+1)}return""}e.getRoot=R;function N(h){if(!k.isWindows||!h||h.length<5)return!1;let o=h.charCodeAt(0);if(o!==92||(o=h.charCodeAt(1),o!==92))return!1;let l=2;const f=l;for(;l<h.length&&(o=h.charCodeAt(l),o!==92);l++);return!(f===l||(o=h.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=N;const v=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(h,o=k.isWindows){const l=o?v:n;return!(!h||h.length===0||/^\s+$/.test(h)||(l.lastIndex=0,l.test(h))||o&&p.test(h)||h==="."||h===".."||o&&h[h.length-1]==="."||o&&h.length!==h.trim().length||h.length>255)}e.isValidBasename=s;function i(h,o,l){const f=h===o;return!l||f?f:!h||!o?!1:(0,b.equalsIgnoreCase)(h,o)}e.isEqual=i;function u(h,o,l,f=r.sep){if(h===o)return!0;if(!h||!o||o.length>h.length)return!1;if(l){if(!(0,b.startsWithIgnoreCase)(h,o))return!1;if(o.length===h.length)return!0;let E=o.length;return o.charAt(o.length-1)===f&&E--,h.charAt(E)===f}return o.charAt(o.length-1)!==f&&(o+=f),h.indexOf(o)===0}e.isEqualOrParent=u;function S(h){return h>=65&&h<=90||h>=97&&h<=122}e.isWindowsDriveLetter=S;function _(h,o){return k.isWindows&&h.endsWith(":")&&(h+=r.sep),(0,r.isAbsolute)(h)||(h=(0,r.join)(o,h)),h=(0,r.normalize)(h),k.isWindows?(h=(0,b.rtrim)(h,r.sep),h.endsWith(":")&&(h+=r.sep)):(h=(0,b.rtrim)(h,r.sep),h||(h=r.sep)),h}e.sanitizeFilePath=_;function w(h){const o=(0,r.normalize)(h);return k.isWindows?h.length>3?!1:d(o)&&(h.length===2||o.charCodeAt(2)===92):o===r.posix.sep}e.isRootOrDriveLetter=w;function d(h,o){return(o!==void 0?o:k.isWindows)?S(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function D(h){return d(h)?h[0]:void 0}e.getDriveLetter=D;function a(h,o,l){return o.length>h.length?-1:h===o?0:(l&&(h=h.toLowerCase(),o=o.toLowerCase()),h.indexOf(o))}e.indexOfPath=a;function P(h){const o=h.split(":");let l,f,m;for(const E of o){const T=Number(E);(0,$.isNumber)(T)?f===void 0?f=T:m===void 0&&(m=T):l=l?[l,E].join(":"):E}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.parseLineAndColumnAware=P;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(h,o,l=8){let f="";for(let E=0;E<l;E++)f+=c.charAt(Math.floor(Math.random()*c.length));let m;return o?m=`${o}-${f}`:m=f,h?(0,r.join)(h,m):m}e.randomPath=t}),define(Ee[54],be([1,0,21,10,2]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function $(N){return JSON.stringify(N,I)}e.stringify=$;function y(N){let v=JSON.parse(N);return v=R(v),v}e.parse=y;var O;(function(N){N[N.Uri=1]="Uri",N[N.Regexp=2]="Regexp",N[N.ScmResource=3]="ScmResource",N[N.ScmResourceGroup=4]="ScmResourceGroup",N[N.ScmProvider=5]="ScmProvider",N[N.CommentController=6]="CommentController",N[N.CommentThread=7]="CommentThread",N[N.CommentThreadReply=8]="CommentThreadReply",N[N.CommentNode=9]="CommentNode",N[N.CommentThreadNode=10]="CommentThreadNode",N[N.TimelineActionContext=11]="TimelineActionContext",N[N.NotebookCellActionContext=12]="NotebookCellActionContext",N[N.TestItemContext=13]="TestItemContext",N[N.Date=14]="Date"})(O=e.MarshalledId||(e.MarshalledId={}));function I(N,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,k.regExpFlags)(v)}:v}function R(N,v=0){if(!N||v>200)return N;if(typeof N=="object"){switch(N.$mid){case 1:return b.URI.revive(N);case 2:return new RegExp(N.source,N.flags);case 14:return new Date(N.source)}if(N instanceof r.VSBuffer||N instanceof Uint8Array)return N;if(Array.isArray(N))for(let n=0;n<N.length;++n)N[n]=R(N[n],v+1);else for(const n in N)Object.hasOwnProperty.call(N,n)&&(N[n]=R(N[n],v+1))}return N}e.revive=R}),define(Ee[9],be([1,0,23,2]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(O){O.inMemory="inmemory",O.vscode="vscode",O.internal="private",O.walkThrough="walkThrough",O.walkThroughSnippet="walkThroughSnippet",O.http="http",O.https="https",O.file="file",O.mailto="mailto",O.untitled="untitled",O.data="data",O.command="command",O.vscodeRemote="vscode-remote",O.vscodeRemoteResource="vscode-remote-resource",O.userData="vscode-userdata",O.vscodeCustomEditor="vscode-custom-editor",O.vscodeNotebook="vscode-notebook",O.vscodeNotebookCell="vscode-notebook-cell",O.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",O.vscodeNotebookCellOutput="vscode-notebook-cell-output",O.vscodeInteractive="vscode-interactive",O.vscodeInteractiveInput="vscode-interactive-input",O.vscodeSettings="vscode-settings",O.vscodeWorkspaceTrust="vscode-workspace-trust",O.vscodeTerminal="vscode-terminal",O.webviewPanel="webview-panel",O.vscodeWebview="vscode-webview",O.extension="extension",O.vscodeFileResource="vscode-file",O.tmp="tmp",O.vsls="vsls"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class ${constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(I){this._preferredWebSchema=I}setDelegate(I){this._delegate=I}set(I,R,N){this._hosts[I]=R,this._ports[I]=N}setConnectionToken(I,R){this._connectionTokens[I]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(I){if(this._delegate)return this._delegate(I);const R=I.authority;let N=this._hosts[R];N&&N.indexOf(":")!==-1&&(N=`[${N}]`);const v=this._ports[R],n=this._connectionTokens[R];let p=`path=${encodeURIComponent(I.path)}`;return typeof n=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(n)}`),k.URI.from({scheme:r.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${N}:${v}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new $;class y{asBrowserUri(I,R){const N=this.toUri(I,R);return N.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===b.file&&(r.isNative||typeof r.globals.importScripts=="function"&&r.globals.origin===`${b.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?N.with({scheme:b.vscodeFileResource,authority:N.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):N}asFileUri(I,R){const N=this.toUri(I,R);return N.scheme===b.vscodeFileResource?N.with({scheme:b.file,authority:N.authority!==y.FALLBACK_AUTHORITY?N.authority:null,query:null,fragment:null}):N}toUri(I,R){return k.URI.isUri(I)?I:k.URI.parse(R.toUrl(I))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y}),define(Ee[24],be([1,0,35,9,17,23,10,2]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(p){return(0,O.uriToFsPath)(p,!0)}e.originalFSPath=I;class R{constructor(s){this._ignorePathCasing=s}compare(s,i,u=!1){return s===i?0:(0,y.compare)(this.getComparisonKey(s,u),this.getComparisonKey(i,u))}isEqual(s,i,u=!1){return s===i?!0:!s||!i?!1:this.getComparisonKey(s,u)===this.getComparisonKey(i,u)}getComparisonKey(s,i=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,i,u=!1){if(s.scheme===i.scheme){if(s.scheme===k.Schemas.file)return r.isEqualOrParent(I(s),I(i),this._ignorePathCasing(s))&&s.query===i.query&&(u||s.fragment===i.fragment);if((0,e.isEqualAuthority)(s.authority,i.authority))return r.isEqualOrParent(s.path,i.path,this._ignorePathCasing(s),"/")&&s.query===i.query&&(u||s.fragment===i.fragment)}return!1}joinPath(s,...i){return O.URI.joinPath(s,...i)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return b.posix.basename(s.path)}extname(s){return b.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let i;return s.scheme===k.Schemas.file?i=O.URI.file(b.dirname(I(s))).path:(i=b.posix.dirname(s.path),s.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),i="/")),s.with({path:i})}normalizePath(s){if(!s.path.length)return s;let i;return s.scheme===k.Schemas.file?i=O.URI.file(b.normalize(I(s))).path:i=b.posix.normalize(s.path),s.with({path:i})}relativePath(s,i){if(s.scheme!==i.scheme||!(0,e.isEqualAuthority)(s.authority,i.authority))return;if(s.scheme===k.Schemas.file){const _=b.relative(I(s),I(i));return $.isWindows?r.toSlashes(_):_}let u=s.path||"/",S=i.path||"/";if(this._ignorePathCasing(s)){let _=0;for(const w=Math.min(u.length,S.length);_<w&&!(u.charCodeAt(_)!==S.charCodeAt(_)&&u.charAt(_).toLowerCase()!==S.charAt(_).toLowerCase());_++);u=S.substr(0,_)+u.substr(_)}return b.posix.relative(u,S)}resolvePath(s,i){if(s.scheme===k.Schemas.file){const u=O.URI.file(b.resolve(I(s),i));return s.with({authority:u.authority,path:u.path})}return i=r.toPosixPath(i),s.with({path:b.posix.resolve(s.path,i)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,i){return s===i||s!==void 0&&i!==void 0&&(0,y.equalsIgnoreCase)(s,i)}hasTrailingPathSeparator(s,i=b.sep){if(s.scheme===k.Schemas.file){const u=I(s);return u.length>r.getRoot(u).length&&u[u.length-1]===i}else{const u=s.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,i=b.sep){return(0,e.hasTrailingPathSeparator)(s,i)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,i=b.sep){let u=!1;if(s.scheme===k.Schemas.file){const S=I(s);u=S!==void 0&&S.length===r.getRoot(S).length&&S[S.length-1]===i}else{i="/";const S=s.path;u=S.length===1&&S.charCodeAt(S.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(s,i)?s.with({path:s.path+"/"}):s}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(p=>p.scheme===k.Schemas.file?!$.isLinux:!0),e.extUriIgnorePathCase=new R(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(p,s){const i=[];for(let u=0;u<p.length;u++){const S=s(p[u]);p.some((_,w)=>w===u?!1:(0,e.isEqualOrParent)(S,s(_)))||i.push(p[u])}return i}e.distinctParents=N;var v;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function s(i){const u=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(w=>{const[d,D]=w.split(":");d&&D&&u.set(d,D)});const _=i.path.substring(0,i.path.indexOf(";"));return _&&u.set(p.META_DATA_MIME,_),u}p.parseMetaData=s})(v=e.DataUri||(e.DataUri={}));function n(p,s,i){if(s){let u=p.path;return u&&u[0]!==b.posix.sep&&(u=b.posix.sep+u),p.with({scheme:i,authority:s,path:u})}return p.with({scheme:i})}e.toLocalResource=n}),define(Ee[11],be([1,0,20,15,5,6,24,23]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(ge){return!!ge&&typeof ge.then=="function"}e.isThenable=I;function R(ge){const ne=new r.CancellationTokenSource,me=ge(ne.token),Ie=new Promise((Ae,Ue)=>{const Ke=ne.token.onCancellationRequested(()=>{Ke.dispose(),ne.dispose(),Ue(new k.CancellationError)});Promise.resolve(me).then(pe=>{Ke.dispose(),ne.dispose(),Ae(pe)},pe=>{Ke.dispose(),ne.dispose(),Ue(pe)})});return new class{cancel(){ne.cancel()}then(Ae,Ue){return Ie.then(Ae,Ue)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return Ie.finally(Ae)}}}e.createCancelablePromise=R;function N(ge,ne,me){return new Promise((Ie,Ae)=>{const Ue=ne.onCancellationRequested(()=>{Ue.dispose(),Ie(me)});ge.then(Ie,Ae).finally(()=>Ue.dispose())})}e.raceCancellation=N;function v(ge,ne){return new Promise((me,Ie)=>{const Ae=ne.onCancellationRequested(()=>{Ae.dispose(),Ie(new k.CancellationError)});ge.then(me,Ie).finally(()=>Ae.dispose())})}e.raceCancellationError=v;async function n(ge){let ne=-1;const me=ge.map((Ae,Ue)=>Ae.then(Ke=>(ne=Ue,Ke))),Ie=await Promise.race(me);return ge.forEach((Ae,Ue)=>{Ue!==ne&&Ae.cancel()}),Ie}e.raceCancellablePromises=n;function p(ge,ne,me){let Ie;const Ae=setTimeout(()=>{Ie?.(void 0),me?.()},ne);return Promise.race([ge.finally(()=>clearTimeout(Ae)),new Promise(Ue=>Ie=Ue)])}e.raceTimeout=p;function s(ge){return new Promise((ne,me)=>{const Ie=ge();I(Ie)?Ie.then(ne,me):ne(Ie)})}e.asPromise=s;class i{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const Ie=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ie};this.queuedPromise=new Promise(Ie=>{this.activePromise.then(me,me).then(Ie)})}return new Promise((me,Ie)=>{this.queuedPromise.then(me,Ie)})}return this.activePromise=ne(),new Promise((me,Ie)=>{this.activePromise.then(Ae=>{this.activePromise=null,me(Ae)},Ae=>{this.activePromise=null,Ie(Ae)})})}}e.Throttler=i;class u{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=u;class S{constructor(){this.promiseMap=new Map}queue(ne,me){const Ae=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(ne)===Ae&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,Ae),Ae}}e.SequencerByKey=S;const _=(ge,ne)=>{let me=!0;const Ie=setTimeout(()=>{me=!1,ne()},ge);return{isTriggered:()=>me,dispose:()=>{clearTimeout(Ie),me=!1}}},w=ge=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,ge())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,me=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ae,Ue)=>{this.doResolve=Ae,this.doReject=Ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ae=this.task;return this.task=null,Ae()}}));const Ie=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===e.MicrotaskDelay?w(Ie):_(me,Ie),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new k.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class D{constructor(ne){this.delayer=new d(ne),this.throttler=new i}trigger(ne,me){return this.delayer.trigger(()=>this.throttler.queue(ne),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class a{constructor(){this._isOpen=!1,this._promise=new Promise((ne,me)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class P extends a{constructor(ne){super();this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=P;function c(ge,ne){return ne?new Promise((me,Ie)=>{const Ae=setTimeout(()=>{Ue.dispose(),me()},ge),Ue=ne.onCancellationRequested(()=>{clearTimeout(Ae),Ue.dispose(),Ie(new k.CancellationError)})}):R(me=>c(ge,me))}e.timeout=c;function t(ge,ne=0){const me=setTimeout(ge,ne);return(0,$.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=t;function h(ge){const ne=[];let me=0;const Ie=ge.length;function Ae(){return me<Ie?ge[me++]():null}function Ue(Ke){Ke!=null&&ne.push(Ke);const pe=Ae();return pe?pe.then(Ue):Promise.resolve(ne)}return Promise.resolve(null).then(Ue)}e.sequence=h;function o(ge,ne=Ie=>!!Ie,me=null){let Ie=0;const Ae=ge.length,Ue=()=>{if(Ie>=Ae)return Promise.resolve(me);const Ke=ge[Ie++];return Promise.resolve(Ke()).then(de=>ne(de)?Promise.resolve(de):Ue())};return Ue()}e.first=o;function l(ge,ne=Ie=>!!Ie,me=null){if(ge.length===0)return Promise.resolve(me);let Ie=ge.length;const Ae=()=>{Ie=-1;for(const Ue of ge)Ue.cancel?.()};return new Promise((Ue,Ke)=>{for(const pe of ge)pe.then(de=>{--Ie>=0&&ne(de)?(Ae(),Ue(de)):Ie===0&&Ue(me)}).catch(de=>{--Ie>=0&&(Ae(),Ke(de))})})}e.firstParallel=l;class f{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(ne){return this._size++,new Promise((me,Ie)=>{this.outstandingPromises.push({factory:ne,c:me,e:Ie}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const me=ne.factory();me.then(ne.c,ne.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class m extends f{constructor(){super(1)}}e.Queue=m;class E{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new ie;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,me=y.extUri){const Ie=me.getComparisonKey(ne);let Ae=this.queues.get(Ie);return Ae||(Ae=new m,b.Event.once(Ae.onFinished)(()=>{Ae?.dispose(),this.queues.delete(Ie),this.onDidQueueFinish()}),this.queues.set(Ie,Ae)),Ae}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=E;class T{constructor(ne,me){this._token=-1,typeof ne=="function"&&typeof me=="number"&&this.setIfNotSet(ne,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},me)}setIfNotSet(ne,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},me))}}e.TimeoutTimer=T;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,me){this.cancel(),this._token=setInterval(()=>{ne()},me)}}e.IntervalTimer=A;class x{constructor(ne,me){this.timeoutToken=-1,this.runner=ne,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=x;class g{constructor(ne,me){me%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class U extends x{constructor(ne,me){super(ne,me);this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner&&this.runner(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class z extends $.Disposable{constructor(ne,me){super();this.options=ne,this.handler=me,this.pendingWork=[],this.throttler=this._register(new $.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ge=>{(0,O.setTimeout0)(()=>{if(ne)return;const me=Date.now()+15;ge(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(ge,ne)=>{const me=requestIdleCallback(ge,typeof ne=="number"?{timeout:ne}:void 0);let Ie=!1;return{dispose(){Ie||(Ie=!0,cancelIdleCallback(me))}}}}();class q{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function j(ge,ne,me){let Ie;for(let Ae=0;Ae<me;Ae++)try{return await ge()}catch(Ue){Ie=Ue,await c(ne)}throw Ie}e.retry=j;class J{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ne,me,Ie){return this._pending={taskId:ne,cancel:()=>Ie?.(),promise:me},me.then(()=>this.donePending(ne),()=>this.donePending(ne)),me}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let me,Ie;const Ae=new Promise((Ue,Ke)=>{me=Ue,Ie=Ke});this._next={run:ne,promise:Ae,promiseResolve:me,promiseReject:Ie}}return this._next.promise}}e.TaskSequentializer=J;class V{constructor(ne,me=()=>Date.now()){this.interval=ne,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class ie{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,me)=>{this.completeCallback=ne,this.errorCallback=me})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(me=>{this.completeCallback(ne),this.resolved=!0,me()})}error(ne){return new Promise(me=>{this.errorCallback(ne),this.rejected=!0,me()})}cancel(){new Promise(ne=>{this.errorCallback(new k.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=ie;var ae;(function(ge){async function ne(Ie){let Ae;const Ue=await Promise.all(Ie.map(Ke=>Ke.then(pe=>pe,pe=>{Ae||(Ae=pe)})));if(typeof Ae!="undefined")throw Ae;return Ue}ge.settled=ne;function me(Ie){return new Promise(async(Ae,Ue)=>{try{await Ie(Ae,Ue)}catch(Ke){Ue(Ke)}})}ge.withAsyncBody=me})(ae=e.Promises||(e.Promises={}));var te;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(te||(te={}));class ue{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const me={emitOne:Ie=>this.emitOne(Ie),emitMany:Ie=>this.emitMany(Ie),reject:Ie=>this.reject(Ie)};try{await Promise.resolve(ne(me)),this.resolve()}catch(Ie){this.reject(Ie)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}static fromArray(ne){return new ue(me=>{me.emitMany(ne)})}static fromPromise(ne){return new ue(async me=>{me.emitMany(await ne)})}static fromPromises(ne){return new ue(async me=>{await Promise.all(ne.map(async Ie=>me.emitOne(await Ie)))})}static merge(ne){return new ue(async me=>{await Promise.all(ne.map(async Ie=>{for await(const Ae of Ie)me.emitOne(Ae)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,me){return new ue(async Ie=>{for await(const Ae of ne)Ie.emitOne(me(Ae))})}map(ne){return ue.map(this,ne)}static filter(ne,me){return new ue(async Ie=>{for await(const Ae of ne)me(Ae)&&Ie.emitOne(Ae)})}filter(ne){return ue.filter(this,ne)}static coalesce(ne){return ue.filter(ne,me=>!!me)}coalesce(){return ue.coalesce(this)}static async toPromise(ne){const me=[];for await(const Ie of ne)me.push(Ie);return me}toPromise(){return ue.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class fe extends ue{constructor(ne,me){super(me);this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=fe;function Se(ge){const ne=new r.CancellationTokenSource,me=ge(ne.token);return new fe(ne,async Ie=>{const Ae=ne.token.onCancellationRequested(()=>{Ae.dispose(),ne.dispose(),Ie.reject(new k.CancellationError)});try{for await(const Ue of me){if(ne.token.isCancellationRequested)return;Ie.emitOne(Ue)}Ae.dispose(),ne.dispose()}catch(Ue){Ae.dispose(),ne.dispose(),Ie.reject(Ue)}})}e.createCancelableAsyncIterable=Se}),define(Ee[107],be([1,0,11,17]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new r.IdleValue(()=>{const m=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:m,collatorIsNumeric:m.resolvedOptions().numeric}}),$=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(m,E,T=!1){const A=m||"",x=E||"",g=b.value.collator.compare(A,x);return b.value.collatorIsNumeric&&g===0&&A!==x?A<x?-1:1:g}e.compareFileNames=O;function I(m,E){const T=$.value.collator;return m=m||"",E=E||"",D(T,m,E)}e.compareFileNamesDefault=I;function R(m,E){const T=$.value.collator;return m=m||"",E=E||"",t(m,E)||D(T,m,E)}e.compareFileNamesUpper=R;function N(m,E){const T=$.value.collator;return m=m||"",E=E||"",c(m,E)||D(T,m,E)}e.compareFileNamesLower=N;function v(m,E){return m=m||"",E=E||"",m===E?0:m<E?-1:1}e.compareFileNamesUnicode=v;function n(m,E,T=!1){T||(m=m&&m.toLowerCase(),E=E&&E.toLowerCase());const[A,x]=w(m),[g,U]=w(E);return A!==g?A<g?-1:1:x===U?0:x<U?-1:1}e.noIntlCompareFileNames=n;function p(m,E){const[T,A]=w(m),[x,g]=w(E);let U=b.value.collator.compare(A,g);if(U===0){if(b.value.collatorIsNumeric&&A!==g)return A<g?-1:1;if(U=b.value.collator.compare(T,x),b.value.collatorIsNumeric&&U===0&&T!==x)return T<x?-1:1}return U}e.compareFileExtensions=p;function s(m,E){m=m||"",E=E||"";const T=d(m),A=d(E),x=$.value.collator,g=y.value.collator;return D(g,T,A)||D(x,m,E)}e.compareFileExtensionsDefault=s;function i(m,E){m=m||"",E=E||"";const T=d(m),A=d(E),x=$.value.collator,g=y.value.collator;return D(g,T,A)||t(m,E)||D(x,m,E)}e.compareFileExtensionsUpper=i;function u(m,E){m=m||"",E=E||"";const T=d(m),A=d(E),x=$.value.collator,g=y.value.collator;return D(g,T,A)||c(m,E)||D(x,m,E)}e.compareFileExtensionsLower=u;function S(m,E){m=m||"",E=E||"";const T=d(m).toLowerCase(),A=d(E).toLowerCase();return T!==A?T<A?-1:1:m!==E?m<E?-1:1:0}e.compareFileExtensionsUnicode=S;const _=/^(.*?)(\.([^.]*))?$/;function w(m,E=!1){const T=m?_.exec(m):[];let A=[T&&T[1]||"",T&&T[3]||""];return E&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function d(m){const E=m?_.exec(m):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function D(m,E,T){let A=m.compare(E,T);return A!==0?A:E.length!==T.length?E.length<T.length?-1:1:0}function a(m){const E=m.charAt(0);return E.toLocaleUpperCase()!==E}function P(m){const E=m.charAt(0);return E.toLocaleLowerCase()!==E}function c(m,E){return a(m)&&P(E)?-1:P(m)&&a(E)?1:0}function t(m,E){return P(m)&&a(E)?-1:a(m)&&P(E)?1:0}function h(m,E,T=!1){return T||(m=m&&m.toLowerCase(),E=E&&E.toLowerCase()),m===E?0:m<E?-1:1}function o(m,E,T=!1){const A=m.split(k.sep),x=E.split(k.sep),g=A.length-1,U=x.length-1;let z,q;for(let j=0;;j++){if(z=g===j,q=U===j,z&&q)return O(A[j],x[j],T);if(z)return-1;if(q)return 1;const J=h(A[j],x[j],T);if(J!==0)return J}}e.comparePaths=o;function l(m,E,T){const A=m.toLowerCase(),x=E.toLowerCase(),g=f(m,E,T);if(g)return g;const U=A.endsWith(T),z=x.endsWith(T);if(U!==z)return U?-1:1;const q=O(A,x);return q!==0?q:A.localeCompare(x)}e.compareAnything=l;function f(m,E,T){const A=m.toLowerCase(),x=E.toLowerCase(),g=A.startsWith(T),U=x.startsWith(T);if(g!==U)return g?-1:1;if(g&&U){if(A.length<x.length)return-1;if(A.length>x.length)return 1}return 0}e.compareByPrefix=f}),define(Ee[29],be([1,0,11,35,22,17,23,10]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",N="[^/\\\\]",v=/\//g;function n(ie){switch(ie){case 0:return"";case 1:return`${N}*?`;default:return`(?:${R}|${N}+${R}|${R}${N}+)*?`}}function p(ie,ae){if(!ie)return[];const te=[];let ue=!1,fe=!1,Se="";for(const ge of ie){switch(ge){case ae:if(!ue&&!fe){te.push(Se),Se="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}Se+=ge}return Se&&te.push(Se),te}e.splitGlobAware=p;function s(ie){if(!ie)return"";let ae="";const te=p(ie,e.GLOB_SPLIT);if(te.every(ue=>ue===e.GLOBSTAR))ae=".*";else{let ue=!1;te.forEach((fe,Se)=>{if(fe===e.GLOBSTAR){ue||(ae+=n(2),ue=!0);return}let ge=!1,ne="",me=!1,Ie="";for(const Ae of fe){if(Ae!=="}"&&ge){ne+=Ae;continue}if(me&&(Ae!=="]"||!Ie)){let Ue;Ae==="-"?Ue=Ae:(Ae==="^"||Ae==="!")&&!Ie?Ue="^":Ae===e.GLOB_SPLIT?Ue="":Ue=(0,O.escapeRegExpCharacters)(Ae),Ie+=Ue;continue}switch(Ae){case"{":ge=!0;continue;case"[":me=!0;continue;case"}":{ae+=`(?:${p(ne,",").map(pe=>s(pe)).join("|")})`,ge=!1,ne="";break}case"]":ae+="["+Ie+"]",me=!1,Ie="";break;case"?":ae+=N;continue;case"*":ae+=n(1);continue;default:ae+=(0,O.escapeRegExpCharacters)(Ae)}}Se<te.length-1&&(te[Se+1]!==e.GLOBSTAR||Se+2<te.length)&&(ae+=R),ue=!1})}return ae}const i=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,_=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,D=new b.LRUCache(1e4),a=function(){return!1},P=function(){return null};function c(ie,ae){if(!ie)return P;let te;typeof ie!="string"?te=ie.pattern:te=ie,te=te.trim();const ue=`${te}_${!!ae.trimForExclusions}`;let fe=D.get(ue);if(fe)return t(fe,ie);let Se;if(i.test(te)){const ge=te.substr(4);fe=function(ne,me){return typeof ne=="string"&&ne.endsWith(ge)?te:null}}else(Se=u.exec(h(te,ae)))?fe=o(Se[1],te):(ae.trimForExclusions?_:S).test(te)?fe=l(te,ae):(Se=w.exec(h(te,ae)))?fe=f(Se[1].substr(1),te,!0):(Se=d.exec(h(te,ae)))?fe=f(Se[1],te,!1):fe=m(te);return D.set(ue,fe),t(fe,ie)}function t(ie,ae){return typeof ae=="string"?ie:function(te,ue){return(0,k.isEqualOrParent)(te,ae.base,!y.isLinux)?ie(te.substr(ae.base.length+1),ue):null}}function h(ie,ae){return ae.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function o(ie,ae){const te=`/${ie}`,ue=`\\${ie}`,fe=function(ge,ne){return typeof ge!="string"?null:ne?ne===ie?ae:null:ge===ie||ge.endsWith(te)||ge.endsWith(ue)?ae:null},Se=[ie];return fe.basenames=Se,fe.patterns=[ae],fe.allBasenames=Se,fe}function l(ie,ae){const te=V(ie.slice(1,-1).split(",").map(ne=>c(ne,ae)).filter(ne=>ne!==P),ie),ue=te.length;if(!ue)return P;if(ue===1)return te[0];const fe=function(ne,me){for(let Ie=0,Ae=te.length;Ie<Ae;Ie++)if(te[Ie](ne,me))return ie;return null},Se=te.find(ne=>!!ne.allBasenames);Se&&(fe.allBasenames=Se.allBasenames);const ge=te.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return ge.length&&(fe.allPaths=ge),fe}function f(ie,ae,te){const ue=$.sep===$.posix.sep,fe=ue?ie:ie.replace(v,$.sep),Se=$.sep+fe,ge=$.posix.sep+ie,ne=te?function(me,Ie){return typeof me=="string"&&(me===fe||me.endsWith(Se)||!ue&&(me===ie||me.endsWith(ge)))?ae:null}:function(me,Ie){return typeof me=="string"&&(me===fe||!ue&&me===ie)?ae:null};return ne.allPaths=[(te?"*/":"./")+ie],ne}function m(ie){try{const ae=new RegExp(`^${s(ie)}$`);return function(te){return ae.lastIndex=0,typeof te=="string"&&ae.test(te)?ie:null}}catch{return P}}function E(ie,ae,te){return!ie||typeof ae!="string"?!1:T(ie)(ae,void 0,te)}e.match=E;function T(ie,ae={}){if(!ie)return a;if(typeof ie=="string"||U(ie)){const te=c(ie,ae);if(te===P)return a;const ue=function(fe,Se){return!!te(fe,Se)};return te.allBasenames&&(ue.allBasenames=te.allBasenames),te.allPaths&&(ue.allPaths=te.allPaths),ue}return j(ie,ae)}e.parse=T;function A(ie){if(!ie)return;let ae;return te=>(ae||(ae=(ie()||Promise.resolve([])).then(ue=>ue?g(ue):{})),ae.then(ue=>!!ue[te]))}e.hasSiblingPromiseFn=A;function x(ie){if(!ie)return;let ae;return te=>{if(!ae){const ue=ie();ae=ue?g(ue):{}}return!!ae[te]}}e.hasSiblingFn=x;function g(ie){const ae={};for(const te of ie)ae[te]=!0;return ae}function U(ie){const ae=ie;return ae?typeof ae.base=="string"&&typeof ae.pattern=="string":!1}e.isRelativePattern=U;function z(ie){return ie.allBasenames||[]}e.getBasenameTerms=z;function q(ie){return ie.allPaths||[]}e.getPathTerms=q;function j(ie,ae){const te=V(Object.getOwnPropertyNames(ie).map(ne=>J(ne,ie[ne],ae)).filter(ne=>ne!==P)),ue=te.length;if(!ue)return P;if(!te.some(ne=>!!ne.requiresSiblings)){if(ue===1)return te[0];const ne=function(Ae,Ue){for(let Ke=0,pe=te.length;Ke<pe;Ke++){const de=te[Ke](Ae,Ue);if(de)return de}return null},me=te.find(Ae=>!!Ae.allBasenames);me&&(ne.allBasenames=me.allBasenames);const Ie=te.reduce((Ae,Ue)=>Ue.allPaths?Ae.concat(Ue.allPaths):Ae,[]);return Ie.length&&(ne.allPaths=Ie),ne}const fe=function(ne,me,Ie){let Ae;for(let Ue=0,Ke=te.length;Ue<Ke;Ue++){const pe=te[Ue];pe.requiresSiblings&&Ie&&(me||(me=(0,$.basename)(ne)),Ae||(Ae=me.substr(0,me.length-(0,$.extname)(ne).length)));const de=pe(ne,me,Ae,Ie);if(de)return de}return null},Se=te.find(ne=>!!ne.allBasenames);Se&&(fe.allBasenames=Se.allBasenames);const ge=te.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return ge.length&&(fe.allPaths=ge),fe}function J(ie,ae,te){if(ae===!1)return P;const ue=c(ie,te);if(ue===P)return P;if(typeof ae=="boolean")return ue;if(ae){const fe=ae.when;if(typeof fe=="string"){const Se=(ge,ne,me,Ie)=>{if(!Ie||!ue(ge,ne))return null;const Ae=fe.replace("$(basename)",me),Ue=Ie(Ae);return(0,r.isThenable)(Ue)?Ue.then(Ke=>Ke?ie:null):Ue?ie:null};return Se.requiresSiblings=!0,Se}}return ue}function V(ie,ae){const te=ie.filter(ne=>!!ne.basenames);if(te.length<2)return ie;const ue=te.reduce((ne,me)=>{const Ie=me.basenames;return Ie?ne.concat(Ie):ne},[]);let fe;if(ae){fe=[];for(let ne=0,me=ue.length;ne<me;ne++)fe.push(ae)}else fe=te.reduce((ne,me)=>{const Ie=me.patterns;return Ie?ne.concat(Ie):ne},[]);const Se=function(ne,me){if(typeof ne!="string")return null;if(!me){let Ae;for(Ae=ne.length;Ae>0;Ae--){const Ue=ne.charCodeAt(Ae-1);if(Ue===47||Ue===92)break}me=ne.substr(Ae)}const Ie=ue.indexOf(me);return Ie!==-1?fe[Ie]:null};Se.basenames=ue,Se.patterns=fe,Se.allBasenames=ue;const ge=ie.filter(ne=>!ne.basenames);return ge.push(Se),ge}}),define(Ee[70],be([1,0,15,105,24,2]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class O{constructor(i="",u=!1){if(this.value=i,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(i,u=0){return this.value+=v(this.supportThemeIcons?(0,k.escapeIcons)(i):i).replace(/([ \t]+)/g,(S,_)=>"&nbsp;".repeat(_.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,u){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=O;function I(s){return R(s)?!s.value:Array.isArray(s)?s.every(I):!0}e.isEmptyMarkdownString=I;function R(s){return s instanceof O?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function N(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,b.isEqual)($.URI.from(s.baseUri),$.URI.from(i.baseUri)))}e.markdownStringEqual=N;function v(s){return s.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function n(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function p(s){const i=[],u=s.split("|").map(_=>_.trim());s=u[0];const S=u[1];if(S){const _=/height=(\d+)/.exec(S),w=/width=(\d+)/.exec(S),d=_?_[1]:"",D=w?w[1]:"",a=isFinite(parseInt(D)),P=isFinite(parseInt(d));a&&i.push(`width="${D}"`),P&&i.push(`height="${d}"`)}return{href:s,dimensions:i}}e.parseHrefAndDimensions=p}),define(Ee[71],be([1,0,35,9,17,23,24,10,2]),function(Y,e,r,k,b,$,y,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(t,h,o){if(typeof t=="string"&&(t=I.URI.file(t)),o){const f=o.getWorkspaceFolder(t);if(f){const m=o.getWorkspace().folders.length>1;let E;if((0,y.isEqual)(f.uri,t)?E="":E=(0,y.relativePath)(f.uri,t),m){const T=f.name?f.name:(0,y.basename)(f.uri);E=E?T+" \u2022 "+E:T}return E}}if(t.scheme!==k.Schemas.file&&t.scheme!==k.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,r.hasDriveLetter)(t.fsPath))return(0,b.normalize)(v(t.fsPath));let l=(0,b.normalize)(t.fsPath);return!$.isWindows&&h?.userHome&&(l=p(l,h.userHome.fsPath)),l}e.getPathLabel=R;function N(t){if(!t)return;typeof t=="string"&&(t=I.URI.file(t));const h=(0,y.basename)(t)||(t.scheme===k.Schemas.file?t.fsPath:t.path);return $.isWindows&&(0,r.isRootOrDriveLetter)(h)?v(h):h}e.getBaseLabel=N;function v(t,h){return(0,r.hasDriveLetter)(t,h)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=v;let n=Object.create(null);function p(t,h){if($.isWindows||!t||!h)return t;let o=n.original===h?n.normalized:void 0;return o||(o=`${(0,O.rtrim)(h,b.posix.sep)}${b.posix.sep}`,n={original:h,normalized:o}),($.isLinux?t.startsWith(o):(0,O.startsWithIgnoreCase)(t,o))&&(t=`~/${t.substr(o.length)}`),t}e.tildify=p;function s(t,h){return t.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=s;const i="\u2026",u="\\\\",S="~";function _(t,h=b.sep){const o=new Array(t.length);let l=!1;for(let f=0;f<t.length;f++){let m=t[f];if(m===""){o[f]=`.${h}`;continue}if(!m){o[f]=m;continue}l=!0;let E="";m.indexOf(u)===0?(E=m.substr(0,m.indexOf(u)+u.length),m=m.substr(m.indexOf(u)+u.length)):m.indexOf(h)===0?(E=m.substr(0,m.indexOf(h)+h.length),m=m.substr(m.indexOf(h)+h.length)):m.indexOf(S)===0&&(E=m.substr(0,m.indexOf(S)+S.length),m=m.substr(m.indexOf(S)+S.length));const T=m.split(h);for(let A=1;l&&A<=T.length;A++)for(let x=T.length-A;l&&x>=0;x--){l=!1;let g=T.slice(x,x+A).join(h);for(let U=0;!l&&U<t.length;U++)if(U!==f&&t[U]&&t[U].indexOf(g)>-1){const z=x+A===T.length,q=x>0&&t[U].indexOf(h)>-1?h+g:g,j=t[U].endsWith(q);l=!z||j}if(!l){let U="";(T[0].endsWith(":")||E!=="")&&(x===1&&(x=0,A++,g=T[0]+h+g),x>0&&(U=T[0]+h),U=E+U),x>0&&(U=U+i+h),U=U+g,x+A<T.length&&(U=U+h+i),o[f]=U}}l&&(o[f]=m)}return o}e.shorten=_;var w;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function d(t,h=Object.create(null)){const o=[];let l=!1,f="";for(const m of t)if(m==="$"||l&&m==="{")f&&o.push({value:f,type:w.TEXT}),f="",l=!0;else if(m==="}"&&l){const E=h[f];if(typeof E=="string")E.length&&o.push({value:E,type:w.VARIABLE});else if(E){const T=o[o.length-1];(!T||T.type!==w.SEPARATOR)&&o.push({value:E.label,type:w.SEPARATOR})}f="",l=!1}else f+=m;return f&&!l&&o.push({value:f,type:w.TEXT}),o.filter((m,E)=>{if(m.type===w.SEPARATOR){const T=o[E-1],A=o[E+1];return[T,A].every(x=>x&&(x.type===w.VARIABLE||x.type===w.TEXT)&&x.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=d;function D(t,h){return $.isMacintosh||h?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,$.isMacintosh?"&":"&&"):t.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function a(t,h){return $.isMacintosh||h?t.replace(/\(&&\w\)|&&/g,""):$.isWindows?t.replace(/&&|&/g,o=>o==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function P(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=P;function c(t){const h=t.indexOf("/")!==-1?b.posix:b.win32,o=h.basename(t),l=h.dirname(t);return o.length?{name:o,parentPath:l}:{name:l,parentPath:""}}e.splitName=c}),define(Ee[108],be([1,0,2]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(N){return N.toJSON()}class b{constructor(v){this._uriTransformer=v}transformIncoming(v){const n=this._uriTransformer.transformIncoming(v);return n===v?v:k(r.URI.from(n))}transformOutgoing(v){const n=this._uriTransformer.transformOutgoing(v);return n===v?v:k(r.URI.from(n))}transformOutgoingURI(v){const n=this._uriTransformer.transformOutgoing(v);return n===v?v:r.URI.from(n)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(N){return N}transformOutgoing(N){return N}transformOutgoingURI(N){return N}transformOutgoingScheme(N){return N}};function $(N,v,n){if(!N||n>200)return null;if(typeof N=="object"){if(N instanceof r.URI)return v.transformOutgoing(N);for(let p in N)if(Object.hasOwnProperty.call(N,p)){const s=$(N[p],v,n+1);s!==null&&(N[p]=s)}}return null}function y(N,v){const n=$(N,v,0);return n===null?N:n}e.transformOutgoingURIs=y;function O(N,v,n,p){if(!N||p>200)return null;if(typeof N=="object"){if(N.$mid===1)return n?r.URI.revive(v.transformIncoming(N)):v.transformIncoming(N);for(let s in N)if(Object.hasOwnProperty.call(N,s)){const i=O(N[s],v,n,p+1);i!==null&&(N[s]=i)}}return null}function I(N,v){const n=O(N,v,!1,0);return n===null?N:n}e.transformIncomingURIs=I;function R(N,v){const n=O(N,v,!0,0);return n===null?N:n}e.transformAndReviveIncomingURIs=R}),define(Ee[36],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(I){return r.test(I)}e.isUUID=k;const b=new Uint8Array(16),$=[];for(let I=0;I<256;I++)$.push(I.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(I){for(let R=0;R<I.length;R++)I[R]=Math.floor(Math.random()*256);return I};function O(){y(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let I=0,R="";return R+=$[b[I++]],R+=$[b[I++]],R+=$[b[I++]],R+=$[b[I++]],R+="-",R+=$[b[I++]],R+=$[b[I++]],R+="-",R+=$[b[I++]],R+=$[b[I++]],R+="-",R+=$[b[I++]],R+=$[b[I++]],R+="-",R+=$[b[I++]],R+=$[b[I++]],R+=$[b[I++]],R+=$[b[I++]],R+=$[b[I++]],R+=$[b[I++]],R}e.generateUuid=O}),define(Ee[109],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(Ee[72],be([1,0,29,17]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b($,y,O,I){if(Array.isArray($)){let R=0;for(const N of $){const v=b(N,y,O,I);if(v===10)return v;v>R&&(R=v)}return R}else{if(typeof $=="string")return I?$==="*"?5:$===O?10:0:0;if($){const{language:R,pattern:N,scheme:v,hasAccessToAllModels:n}=$;if(!I&&!n)return 0;let p=0;if(v)if(v===y.scheme)p=10;else if(v==="*")p=5;else return 0;if(R)if(R===O)p=10;else if(R==="*")p=Math.max(p,5);else return 0;if(N){let s;if(typeof N=="string"?s=N:s={...N,base:(0,k.normalize)(N.base)},s===y.fsPath||(0,r.match)(s,y.fsPath))p=10;else return 0}return p}else return 0}}e.score=b}),define(Ee[110],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class k{constructor(O){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=O.open,this.close=O.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(O.notIn))for(let I=0,R=O.notIn.length;I<R;I++)switch(O.notIn[I]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(O){switch(O){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(O,I){if(O.getTokenCount()===0)return!0;const R=O.findTokenIndexAtOffset(I-2),N=O.getStandardTokenType(R);return this.isOK(N)}_findNeutralCharacterInRange(O,I){for(let R=O;R<=I;R++){const N=String.fromCharCode(R);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=k;class b{constructor(O){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of O)$(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),$(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),$(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),$(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&$(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.AutoClosingPairs=b;function $(y,O,I){y.has(O)?y.get(O).push(I):y.set(O,[I])}}),define(Ee[73],be([1,0,21,23]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(v){v[v.Full=1]="Full",v[v.Delta=2]="Delta"})(b||(b={}));function $(v){for(let n=0,p=v.length;n<p;n+=4){const s=v[n+0],i=v[n+1],u=v[n+2],S=v[n+3];v[n+0]=S,v[n+1]=u,v[n+2]=i,v[n+3]=s}}function y(v){const n=new Uint8Array(v.buffer,v.byteOffset,v.length*4);return k.isLittleEndian()||$(n),r.VSBuffer.wrap(n)}function O(v){const n=v.buffer;if(k.isLittleEndian()||$(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const p=new Uint8Array(n.byteLength);return p.set(n),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function I(v){const n=new Uint32Array(R(v));let p=0;if(n[p++]=v.id,v.type==="full")n[p++]=1,n[p++]=v.data.length,n.set(v.data,p),p+=v.data.length;else{n[p++]=2,n[p++]=v.deltas.length;for(const s of v.deltas)n[p++]=s.start,n[p++]=s.deleteCount,s.data?(n[p++]=s.data.length,n.set(s.data,p),p+=s.data.length):n[p++]=0}return y(n)}e.encodeSemanticTokensDto=I;function R(v){let n=0;if(n+=1+1,v.type==="full")n+=1+v.data.length;else{n+=1,n+=(1+1+1)*v.deltas.length;for(const p of v.deltas)p.data&&(n+=p.data.length)}return n}function N(v){const n=O(v);let p=0;const s=n[p++];if(n[p++]===1){const _=n[p++],w=n.subarray(p,p+_);return p+=_,{id:s,type:"full",data:w}}const u=n[p++],S=[];for(let _=0;_<u;_++){const w=n[p++],d=n[p++],D=n[p++];let a;D>0&&(a=n.subarray(p,p+D),p+=D),S[_]={start:w,deleteCount:d,data:a}}return{id:s,type:"delta",deltas:S}}e.decodeSemanticTokensDto=N}),define(Ee[111],be([18,19]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(Ee[112],be([1,0,111]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,b=k*60,$=b*24,y=$*7,O=$*30,I=$*365;function R(v,n,p){typeof v!="number"&&(v=v.getTime());const s=Math.round((new Date().getTime()-v)/1e3);if(s<-30)return(0,r.localize)(0,null,R(new Date().getTime()+s*1e3,!1));if(s<30)return(0,r.localize)(1,null);let i;return s<k?(i=s,n?i===1?p?(0,r.localize)(2,null,i):(0,r.localize)(3,null,i):p?(0,r.localize)(4,null,i):(0,r.localize)(5,null,i):i===1?p?(0,r.localize)(6,null,i):(0,r.localize)(7,null,i):p?(0,r.localize)(8,null,i):(0,r.localize)(9,null,i)):s<b?(i=Math.floor(s/k),n?i===1?p?(0,r.localize)(10,null,i):(0,r.localize)(11,null,i):p?(0,r.localize)(12,null,i):(0,r.localize)(13,null,i):i===1?p?(0,r.localize)(14,null,i):(0,r.localize)(15,null,i):p?(0,r.localize)(16,null,i):(0,r.localize)(17,null,i)):s<$?(i=Math.floor(s/b),n?i===1?p?(0,r.localize)(18,null,i):(0,r.localize)(19,null,i):p?(0,r.localize)(20,null,i):(0,r.localize)(21,null,i):i===1?p?(0,r.localize)(22,null,i):(0,r.localize)(23,null,i):p?(0,r.localize)(24,null,i):(0,r.localize)(25,null,i)):s<y?(i=Math.floor(s/$),n?i===1?(0,r.localize)(26,null,i):(0,r.localize)(27,null,i):i===1?(0,r.localize)(28,null,i):(0,r.localize)(29,null,i)):s<O?(i=Math.floor(s/y),n?i===1?p?(0,r.localize)(30,null,i):(0,r.localize)(31,null,i):p?(0,r.localize)(32,null,i):(0,r.localize)(33,null,i):i===1?p?(0,r.localize)(34,null,i):(0,r.localize)(35,null,i):p?(0,r.localize)(36,null,i):(0,r.localize)(37,null,i)):s<I?(i=Math.floor(s/O),n?i===1?p?(0,r.localize)(38,null,i):(0,r.localize)(39,null,i):p?(0,r.localize)(40,null,i):(0,r.localize)(41,null,i):i===1?p?(0,r.localize)(42,null,i):(0,r.localize)(43,null,i):p?(0,r.localize)(44,null,i):(0,r.localize)(45,null,i)):(i=Math.floor(s/I),n?i===1?p?(0,r.localize)(46,null,i):(0,r.localize)(47,null,i):p?(0,r.localize)(48,null,i):(0,r.localize)(49,null,i):i===1?p?(0,r.localize)(50,null,i):(0,r.localize)(51,null,i):p?(0,r.localize)(52,null,i):(0,r.localize)(53,null,i))}e.fromNow=R;function N(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(Ee[113],be([18,19]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(Ee[43],be([1,0,16,13,113]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function $(R,N){return N&&(R.stack||R.stacktrace)?b.localize(0,null,O(R),y(R.stack)||y(R.stacktrace)):O(R)}function y(R){return Array.isArray(R)?R.join(`
`):R}function O(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?b.localize(1,null,R.message):R.message||b.localize(2,null)}function I(R=null,N=!1){if(!R)return b.localize(3,null);if(Array.isArray(R)){const v=r.coalesce(R),n=I(v[0],N);return v.length>1?b.localize(4,null,n,v.length):n}if(k.isString(R))return R;if(R.detail){const v=R.detail;if(v.error)return $(v.error,N);if(v.exception)return $(v.exception,N)}return R.stack?$(R,N):R.message?R.message:b.localize(5,null)}e.toErrorMessage=I}),define(Ee[114],be([18,19]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(Ee[115],be([1,0,114,23,116,16,26,109]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=R;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class v{constructor(Q,ce,Re,xe){this.id=Q,this.name=ce,this.defaultValue=Re,this.schema=xe}applyUpdate(Q,ce){return p(Q,ce)}compute(Q,ce,Re){return Re}}class n{constructor(Q,ce){this.newValue=Q,this.didChange=ce}}e.ApplyUpdateResult=n;function p(G,Q){if(typeof G!="object"||typeof Q!="object"||!G||!Q)return new n(Q,G!==Q);if(Array.isArray(G)||Array.isArray(Q)){const Re=Array.isArray(G)&&Array.isArray(Q)&&$.equals(G,Q);return new n(Q,Re)}let ce=!1;for(const Re in Q)if(Q.hasOwnProperty(Re)){const xe=p(G[Re],Q[Re]);xe.didChange&&(G[Re]=xe.newValue,ce=!0)}return new n(G,ce)}class s{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ce){return p(Q,ce)}validate(Q){return this.defaultValue}}class i{constructor(Q,ce,Re,xe){this.id=Q,this.name=ce,this.defaultValue=Re,this.schema=xe}applyUpdate(Q,ce){return p(Q,ce)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,ce,Re){return Re}}function u(G,Q){return typeof G=="undefined"?Q:G==="false"?!1:Boolean(G)}e.boolean=u;class S extends i{constructor(Q,ce,Re,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=Re);super(Q,ce,Re,xe)}validate(Q){return u(Q,this.defaultValue)}}function _(G,Q,ce,Re){if(typeof G=="undefined")return Q;let xe=parseInt(G,10);return isNaN(xe)?Q:(xe=Math.max(ce,xe),xe=Math.min(Re,xe),xe|0)}e.clampedInt=_;class w extends i{constructor(Q,ce,Re,xe,Ge,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Re,Je.minimum=xe,Je.maximum=Ge);super(Q,ce,Re,Je);this.minimum=xe,this.maximum=Ge}static clampedInt(Q,ce,Re,xe){return _(Q,ce,Re,xe)}validate(Q){return w.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class d extends i{constructor(Q,ce,Re,xe,Ge){typeof Ge!="undefined"&&(Ge.type="number",Ge.default=Re);super(Q,ce,Re,Ge);this.validationFn=xe}static clamp(Q,ce,Re){return Q<ce?ce:Q>Re?Re:Q}static float(Q,ce){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return ce;const Re=parseFloat(Q);return isNaN(Re)?ce:Re}validate(Q){return this.validationFn(d.float(Q,this.defaultValue))}}class D extends i{static string(Q,ce){return typeof Q!="string"?ce:Q}constructor(Q,ce,Re,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=Re);super(Q,ce,Re,xe)}validate(Q){return D.string(Q,this.defaultValue)}}function a(G,Q,ce){return typeof G!="string"||ce.indexOf(G)===-1?Q:G}e.stringSet=a;class P extends i{constructor(Q,ce,Re,xe,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=xe,Ge.default=Re);super(Q,ce,Re,Ge);this._allowedValues=xe}validate(Q){return a(Q,this.defaultValue,this._allowedValues)}}class c extends v{constructor(Q,ce,Re,xe,Ge,Je,at=void 0){typeof at!="undefined"&&(at.type="string",at.enum=Ge,at.default=xe);super(Q,ce,Re,at);this._allowedValues=Ge,this._convert=Je}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function t(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends v{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ce,Re){return Re===0?Q.accessibilitySupport:Re}}class o extends v{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{insertSpace:u(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function f(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(G){switch(G){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function T(G){switch(G){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class A extends s{constructor(){super(128)}compute(Q,ce,Re){const xe=["monaco-editor"];return ce.get(33)&&xe.push(ce.get(33)),Q.extraEditorClassName&&xe.push(Q.extraEditorClassName),ce.get(66)==="default"?xe.push("mouse-default"):ce.get(66)==="copy"&&xe.push("mouse-copy"),ce.get(100)&&xe.push("showUnused"),ce.get(126)&&xe.push("showDeprecated"),xe.join(" ")}}class x extends S{constructor(){super(32,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Q,ce,Re){return Re&&Q.emptySelectionClipboard}}class g extends v{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:r.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:r.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{cursorMoveOnType:u(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":a(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":a(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(ce.loop,this.defaultValue.loop)}}}class U extends v{constructor(){super(45,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?U.OFF:Q==="true"?U.ON:Q:Boolean(Q)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class z extends s{constructor(){super(44)}compute(Q,ce,Re){return Q.fontInfo}}class q extends i{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Q){const ce=d.float(Q,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ce,6,100)}compute(Q,ce,Re){return Q.fontInfo.fontSize}}class j extends v{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.MINIMUM_VALUE,maximum:j.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(w.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,j.MINIMUM_VALUE,j.MAXIMUM_VALUE))}}j.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],j.MINIMUM_VALUE=1,j.MAXIMUM_VALUE=1e3;class J extends v{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...ce},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...ce},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Re,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Re,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Re,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Re,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Re,description:r.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{multiple:a(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??a(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??a(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??a(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??a(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??a(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends v{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:r.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{enabled:u(ce.enabled,this.defaultValue.enabled),delay:w.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:u(ce.sticky,this.defaultValue.sticky),above:u(ce.above,this.defaultValue.above)}}}var ie;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class ae extends s{constructor(){super(131)}compute(Q,ce,Re){return ae.computeLayout(ce,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ce=Q.height/Q.lineHeight,Re=Q.scrollBeyondLastLine?ce-1:0,xe=(Q.viewLineCount+Re)/(Q.pixelRatio*Q.height),Ge=Math.floor(Q.viewLineCount/xe);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Re,desiredRatio:xe,minimapLineCount:Ge}}static _computeMinimapLayout(Q,ce){const Re=Q.outerWidth,xe=Q.outerHeight,Ge=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Je=ce.stableMinimapLayoutInput,at=Je&&Q.outerHeight===Je.outerHeight&&Q.lineHeight===Je.lineHeight&&Q.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Je.pixelRatio&&Q.scrollBeyondLastLine===Je.scrollBeyondLastLine&&Q.minimap.enabled===Je.minimap.enabled&&Q.minimap.side===Je.minimap.side&&Q.minimap.size===Je.minimap.size&&Q.minimap.showSlider===Je.minimap.showSlider&&Q.minimap.renderCharacters===Je.minimap.renderCharacters&&Q.minimap.maxColumn===Je.minimap.maxColumn&&Q.minimap.scale===Je.minimap.scale&&Q.verticalScrollbarWidth===Je.verticalScrollbarWidth&&Q.isViewportWrapping===Je.isViewportWrapping,yt=Q.lineHeight,Dt=Q.typicalHalfwidthCharacterWidth,Ot=Q.scrollBeyondLastLine,Ve=Q.minimap.renderCharacters;let gt=Ge>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Nt=Q.minimap.maxColumn,it=Q.minimap.size,ot=Q.minimap.side,It=Q.verticalScrollbarWidth,Pt=Q.viewLineCount,kt=Q.remainingWidth,lt=Q.isViewportWrapping,Ft=Ve?2:3;let Lt=Math.floor(Ge*xe);const he=Lt/Ge;let le=!1,oe=!1,K=Ft*gt,_e=gt/Ge,Ce=1;if(it==="fill"||it==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:rt,desiredRatio:Et,minimapLineCount:ft}=ae.computeContainedMinimapLineCount({viewLineCount:Pt,scrollBeyondLastLine:Ot,height:xe,lineHeight:yt,pixelRatio:Ge});if(Pt/ft>1)le=!0,oe=!0,gt=1,K=1,_e=gt/Ge;else{let ct=!1,Ct=gt+1;if(it==="fit"){const Ut=Math.ceil((Pt+rt)*K);lt&&at&&kt<=ce.stableFitRemainingWidth?(ct=!0,Ct=ce.stableFitMaxMinimapScale):ct=Ut>Lt}if(it==="fill"||ct){le=!0;const Ut=gt;K=Math.min(yt*Ge,Math.max(1,Math.floor(1/Et))),lt&&at&&kt<=ce.stableFitRemainingWidth&&(Ct=ce.stableFitMaxMinimapScale),gt=Math.min(Ct,Math.max(1,Math.floor(K/Ft))),gt>Ut&&(Ce=Math.min(2,gt/Ut)),_e=gt/Ge/Ce,Lt=Math.ceil(Math.max(dt,Pt+rt)*K),lt?(ce.stableMinimapLayoutInput=Q,ce.stableFitRemainingWidth=kt,ce.stableFitMaxMinimapScale=gt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const $e=Math.floor(Nt*_e),We=Math.min($e,Math.max(0,Math.floor((kt-It-2)*_e/(Dt+_e)))+e.MINIMAP_GUTTER_WIDTH);let nt=Math.floor(Ge*We);const pt=nt/Ge;nt=Math.floor(nt*Ce);const wt=Ve?1:2,vt=ot==="left"?0:Re-We-It;return{renderMinimap:wt,minimapLeft:vt,minimapWidth:We,minimapHeightIsEditorHeight:le,minimapIsSampling:oe,minimapScale:gt,minimapLineHeight:K,minimapCanvasInnerWidth:nt,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:he}}static computeLayout(Q,ce){const Re=ce.outerWidth|0,xe=ce.outerHeight|0,Ge=ce.lineHeight|0,Je=ce.lineNumbersDigitCount|0,at=ce.typicalHalfwidthCharacterWidth,yt=ce.maxDigitWidth,Dt=ce.pixelRatio,Ot=ce.viewLineCount,Ve=Q.get(123),gt=Ve==="inherit"?Q.get(122):Ve,Nt=gt==="inherit"?Q.get(118):gt,it=Q.get(121),ot=Q.get(2),It=ce.isDominatedByLongLines,Pt=Q.get(50),kt=Q.get(60).renderType!==0,lt=Q.get(61),Ft=Q.get(94),Lt=Q.get(65),he=Q.get(92),le=he.verticalScrollbarSize,oe=he.verticalHasArrows,K=he.arrowSize,_e=he.horizontalScrollbarSize,Ce=Q.get(58),$e=Q.get(37);let We;if(typeof Ce=="string"&&/^\d+(\.\d+)?ch$/.test(Ce)){const Wt=parseFloat(Ce.substr(0,Ce.length-2));We=w.clampedInt(Wt*at,0,0,1e3)}else We=w.clampedInt(Ce,0,0,1e3);$e&&(We+=16);let nt=0;if(kt){const Wt=Math.max(Je,lt);nt=Math.round(Wt*yt)}let pt=0;Pt&&(pt=Ge);let wt=0,vt=wt+pt,dt=vt+nt,rt=dt+We;const Et=Re-pt-nt-We;let ft=!1,Mt=!1,ct=-1;ot!==2&&(gt==="inherit"&&It?(ft=!0,Mt=!0):Nt==="on"||Nt==="bounded"?Mt=!0:Nt==="wordWrapColumn"&&(ct=it));const Ct=ae._computeMinimapLayout({outerWidth:Re,outerHeight:xe,lineHeight:Ge,typicalHalfwidthCharacterWidth:at,pixelRatio:Dt,scrollBeyondLastLine:Ft,minimap:Lt,verticalScrollbarWidth:le,viewLineCount:Ot,remainingWidth:Et,isViewportWrapping:Mt},ce.memory||new N);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(wt+=Ct.minimapWidth,vt+=Ct.minimapWidth,dt+=Ct.minimapWidth,rt+=Ct.minimapWidth);const Ut=Et-Ct.minimapWidth,bt=Math.max(1,Math.floor((Ut-le-2)/at)),Bt=oe?K:0;return Mt&&(ct=Math.max(1,bt),Nt==="bounded"&&(ct=Math.min(ct,it))),{width:Re,height:xe,glyphMarginLeft:wt,glyphMarginWidth:pt,lineNumbersLeft:vt,lineNumbersWidth:nt,decorationsLeft:dt,decorationsWidth:We,contentLeft:rt,contentWidth:Ut,minimap:Ct,viewportColumn:bt,isWordWrapMinified:ft,isViewportWrapping:Mt,wrappingColumn:ct,verticalScrollbarWidth:le,horizontalScrollbarHeight:_e,overviewRuler:{top:Bt,width:le,height:xe-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=ae;class te extends v{constructor(){const Q={enabled:!0};super(57,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:r.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class ue extends v{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:r.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:r.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{enabled:u(ce.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(ce.fontFamily,this.defaultValue.fontFamily)}}}class fe extends d{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>d.clamp(Q,0,150),{markdownDescription:r.localize(47,null)})}compute(Q,ce,Re){return Q.fontInfo.lineHeight}}class Se extends v{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:r.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(49,null),r.localize(50,null),r.localize(51,null)],default:Q.size,description:r.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:r.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:r.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:r.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:r.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{enabled:u(ce.enabled,this.defaultValue.enabled),size:a(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(ce.side,this.defaultValue.side,["right","left"]),showSlider:a(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(ce.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(ce.scale,1,1,3),maxColumn:w.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ge(G){return G==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ne extends v{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{top:w.clampedInt(ce.top,0,0,1e3),bottom:w.clampedInt(ce.bottom,0,0,1e3)}}}class me extends v{constructor(){const Q={enabled:!0,cycle:!1};super(76,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:r.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{enabled:u(ce.enabled,this.defaultValue.enabled),cycle:u(ce.cycle,this.defaultValue.cycle)}}}class Ie extends s{constructor(){super(129)}compute(Q,ce,Re){return Q.pixelRatio}}class Ae extends v{constructor(){const Q={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:r.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:r.localize(63,null)},other:{type:"boolean",default:Q.other,description:r.localize(64,null)}}}],default:Q,description:r.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const ce=Q,Re={other:u(ce.other,this.defaultValue.other),comments:u(ce.comments,this.defaultValue.comments),strings:u(ce.strings,this.defaultValue.strings)};return Re.other&&Re.comments&&Re.strings?!0:!Re.other&&!Re.comments&&!Re.strings?!1:Re}return this.defaultValue}}var Ue;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Ue=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ke extends v{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(66,null),r.localize(67,null),r.localize(68,null),r.localize(69,null)],default:"on",description:r.localize(70,null)})}validate(Q){let ce=this.defaultValue.renderType,Re=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(ce=4,Re=Q):Q==="interval"?ce=3:Q==="relative"?ce=2:Q==="on"?ce=1:ce=0),{renderType:ce,renderFn:Re}}}function pe(G){const Q=G.get(87);return Q==="editable"?G.get(81):Q!=="on"}e.filterValidationDecorations=pe;class de extends v{constructor(){const Q=[],ce={type:"number",description:r.localize(71,null)};super(91,"rulers",Q,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:r.localize(72,null),format:"color-hex"}}}]},default:Q,description:r.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const ce=[];for(let Re of Q)if(typeof Re=="number")ce.push({column:w.clampedInt(Re,0,0,1e4),color:null});else if(Re&&typeof Re=="object"){const xe=Re;ce.push({column:w.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ce.sort((Re,xe)=>Re.column-xe.column),ce}return this.defaultValue}}function L(G,Q){if(typeof G!="string")return Q;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends v{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(74,null),r.localize(75,null),r.localize(76,null)],default:"auto",description:r.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"auto",description:r.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:r.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:r.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:r.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q,Re=w.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=w.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:L(ce.vertical,this.defaultValue.vertical),horizontal:L(ce.horizontal,this.defaultValue.horizontal),useShadows:u(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Re,horizontalSliderSize:w.clampedInt(ce.horizontalSliderSize,Re,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:w.clampedInt(ce.verticalSliderSize,xe,0,1e3),scrollByPage:u(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class C extends v{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:r.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:r.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:r.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:r.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:r.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:r.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:r.localize(91,null)}})}applyUpdate(Q,ce){let Re=!1;ce.allowedCharacters&&(y.equals(Q.allowedCharacters,ce.allowedCharacters)||(Q={...Q,allowedCharacters:ce.allowedCharacters},Re=!0)),ce.allowedLocales&&(y.equals(Q.allowedLocales,ce.allowedLocales)||(Q={...Q,allowedLocales:ce.allowedLocales},Re=!0));const xe=super.applyUpdate(Q,ce);return Re?new n(xe.newValue,!0):xe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{nonBasicASCII:re(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:re(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:re(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,ce){if(typeof Q!="object"||!Q)return ce;const Re={};for(const[xe,Ge]of Object.entries(Q))Ge===!0&&(Re[xe]=!0);return Re}}class M extends v{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:r.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{enabled:u(ce.enabled,this.defaultValue.enabled),mode:a(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class H extends v{constructor(){const Q={enabled:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:r.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class X extends v{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(94,null),r.localize(95,null),r.localize(96,null)],default:Q.bracketPairs,description:r.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(98,null),r.localize(99,null),r.localize(100,null)],default:Q.bracketPairsHorizontal,description:r.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:r.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:r.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:r.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{bracketPairs:re(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:re(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:u(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function re(G,Q,ce){const Re=ce.indexOf(G);return Re===-1?Q:ce[Re]}class ve extends v{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(105,null),r.localize(106,null)],default:Q.insertMode,description:r.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:r.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:r.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:r.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:r.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:r.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:r.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:r.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:r.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ce=Q;return{insertMode:a(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(ce.showIcons,this.defaultValue.showIcons),showStatusBar:u(ce.showStatusBar,this.defaultValue.showStatusBar),preview:u(ce.preview,this.defaultValue.preview),previewMode:a(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(ce.showMethods,this.defaultValue.showMethods),showFunctions:u(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:u(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(ce.showDeprecated,this.defaultValue.showDeprecated),showFields:u(ce.showFields,this.defaultValue.showFields),showVariables:u(ce.showVariables,this.defaultValue.showVariables),showClasses:u(ce.showClasses,this.defaultValue.showClasses),showStructs:u(ce.showStructs,this.defaultValue.showStructs),showInterfaces:u(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:u(ce.showModules,this.defaultValue.showModules),showProperties:u(ce.showProperties,this.defaultValue.showProperties),showEvents:u(ce.showEvents,this.defaultValue.showEvents),showOperators:u(ce.showOperators,this.defaultValue.showOperators),showUnits:u(ce.showUnits,this.defaultValue.showUnits),showValues:u(ce.showValues,this.defaultValue.showValues),showConstants:u(ce.showConstants,this.defaultValue.showConstants),showEnums:u(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:u(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(ce.showKeywords,this.defaultValue.showKeywords),showWords:u(ce.showWords,this.defaultValue.showWords),showColors:u(ce.showColors,this.defaultValue.showColors),showFiles:u(ce.showFiles,this.defaultValue.showFiles),showReferences:u(ce.showReferences,this.defaultValue.showReferences),showFolders:u(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:u(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(ce.showSnippets,this.defaultValue.showSnippets),showUsers:u(ce.showUsers,this.defaultValue.showUsers),showIssues:u(ce.showIssues,this.defaultValue.showIssues)}}}class ke extends v{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Me extends s{constructor(){super(130)}compute(Q,ce,Re){return ce.get(81)?!0:Q.tabFocusMode}}var Le;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Le=e.WrappingIndent||(e.WrappingIndent={}));function ze(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Be extends s{constructor(){super(132)}compute(Q,ce,Re){const xe=ce.get(131);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const Oe="Consolas, 'Courier New', monospace",Xe="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Xe:k.isLinux?tt:Oe,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(G){return e.editorOptionsRegistry[G.id]=G,G}var et;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.foldingMaximumRegions=41]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=43]="fontFamily",G[G.fontInfo=44]="fontInfo",G[G.fontLigatures=45]="fontLigatures",G[G.fontSize=46]="fontSize",G[G.fontWeight=47]="fontWeight",G[G.formatOnPaste=48]="formatOnPaste",G[G.formatOnType=49]="formatOnType",G[G.glyphMargin=50]="glyphMargin",G[G.gotoLocation=51]="gotoLocation",G[G.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",G[G.hover=53]="hover",G[G.inDiffEditor=54]="inDiffEditor",G[G.inlineSuggest=55]="inlineSuggest",G[G.letterSpacing=56]="letterSpacing",G[G.lightbulb=57]="lightbulb",G[G.lineDecorationsWidth=58]="lineDecorationsWidth",G[G.lineHeight=59]="lineHeight",G[G.lineNumbers=60]="lineNumbers",G[G.lineNumbersMinChars=61]="lineNumbersMinChars",G[G.linkedEditing=62]="linkedEditing",G[G.links=63]="links",G[G.matchBrackets=64]="matchBrackets",G[G.minimap=65]="minimap",G[G.mouseStyle=66]="mouseStyle",G[G.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=68]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",G[G.multiCursorModifier=70]="multiCursorModifier",G[G.multiCursorPaste=71]="multiCursorPaste",G[G.occurrencesHighlight=72]="occurrencesHighlight",G[G.overviewRulerBorder=73]="overviewRulerBorder",G[G.overviewRulerLanes=74]="overviewRulerLanes",G[G.padding=75]="padding",G[G.parameterHints=76]="parameterHints",G[G.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",G[G.quickSuggestions=79]="quickSuggestions",G[G.quickSuggestionsDelay=80]="quickSuggestionsDelay",G[G.readOnly=81]="readOnly",G[G.renameOnType=82]="renameOnType",G[G.renderControlCharacters=83]="renderControlCharacters",G[G.renderFinalNewline=84]="renderFinalNewline",G[G.renderLineHighlight=85]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=87]="renderValidationDecorations",G[G.renderWhitespace=88]="renderWhitespace",G[G.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",G[G.roundedSelection=90]="roundedSelection",G[G.rulers=91]="rulers",G[G.scrollbar=92]="scrollbar",G[G.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=94]="scrollBeyondLastLine",G[G.scrollPredominantAxis=95]="scrollPredominantAxis",G[G.selectionClipboard=96]="selectionClipboard",G[G.selectionHighlight=97]="selectionHighlight",G[G.selectOnLineNumbers=98]="selectOnLineNumbers",G[G.showFoldingControls=99]="showFoldingControls",G[G.showUnused=100]="showUnused",G[G.snippetSuggestions=101]="snippetSuggestions",G[G.smartSelect=102]="smartSelect",G[G.smoothScrolling=103]="smoothScrolling",G[G.stickyTabStops=104]="stickyTabStops",G[G.stopRenderingLineAfter=105]="stopRenderingLineAfter",G[G.suggest=106]="suggest",G[G.suggestFontSize=107]="suggestFontSize",G[G.suggestLineHeight=108]="suggestLineHeight",G[G.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",G[G.suggestSelection=110]="suggestSelection",G[G.tabCompletion=111]="tabCompletion",G[G.tabIndex=112]="tabIndex",G[G.unicodeHighlighting=113]="unicodeHighlighting",G[G.unusualLineTerminators=114]="unusualLineTerminators",G[G.useShadowDOM=115]="useShadowDOM",G[G.useTabStops=116]="useTabStops",G[G.wordSeparators=117]="wordSeparators",G[G.wordWrap=118]="wordWrap",G[G.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=121]="wordWrapColumn",G[G.wordWrapOverride1=122]="wordWrapOverride1",G[G.wordWrapOverride2=123]="wordWrapOverride2",G[G.wrappingIndent=124]="wrappingIndent",G[G.wrappingStrategy=125]="wrappingStrategy",G[G.showDeprecated=126]="showDeprecated",G[G.inlayHints=127]="inlayHints",G[G.editorClassName=128]="editorClassName",G[G.pixelRatio=129]="pixelRatio",G[G.tabFocusMode=130]="tabFocusMode",G[G.layoutInfo=131]="layoutInfo",G[G.wrappingInfo=132]="wrappingInfo"})(et=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new S(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(148,null)})),acceptSuggestionOnEnter:Te(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(149,null),""],markdownDescription:r.localize(150,null)})),accessibilitySupport:Te(new h),accessibilityPageSize:Te(new w(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(151,null)})),ariaLabel:Te(new D(4,"ariaLabel",r.localize(152,null))),autoClosingBrackets:Te(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(153,null),r.localize(154,null),""],description:r.localize(155,null)})),autoClosingDelete:Te(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(156,null),""],description:r.localize(157,null)})),autoClosingOvertype:Te(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(158,null),""],description:r.localize(159,null)})),autoClosingQuotes:Te(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(160,null),r.localize(161,null),""],description:r.localize(162,null)})),autoIndent:Te(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],t,{enumDescriptions:[r.localize(163,null),r.localize(164,null),r.localize(165,null),r.localize(166,null),r.localize(167,null)],description:r.localize(168,null)})),automaticLayout:Te(new S(10,"automaticLayout",!1)),autoSurround:Te(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(169,null),r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),bracketPairColorization:Te(new H),bracketPairGuides:Te(new X),stickyTabStops:Te(new S(104,"stickyTabStops",!1,{description:r.localize(173,null)})),codeLens:Te(new S(14,"codeLens",!0,{description:r.localize(174,null)})),codeLensFontFamily:Te(new D(15,"codeLensFontFamily","",{description:r.localize(175,null)})),codeLensFontSize:Te(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(176,null)})),colorDecorators:Te(new S(17,"colorDecorators",!0,{description:r.localize(177,null)})),columnSelection:Te(new S(18,"columnSelection",!1,{description:r.localize(178,null)})),comments:Te(new o),contextmenu:Te(new S(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new S(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(179,null)})),cursorBlinking:Te(new c(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:r.localize(180,null)})),cursorSmoothCaretAnimation:Te(new S(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(181,null)})),cursorStyle:Te(new c(24,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:r.localize(182,null)})),cursorSurroundingLines:Te(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(183,null)})),cursorSurroundingLinesStyle:Te(new P(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(184,null),r.localize(185,null)],description:r.localize(186,null)})),cursorWidth:Te(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(187,null)})),disableLayerHinting:Te(new S(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new S(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new S(30,"domReadOnly",!1)),dragAndDrop:Te(new S(31,"dragAndDrop",!0,{description:r.localize(188,null)})),emptySelectionClipboard:Te(new x),extraEditorClassName:Te(new D(33,"extraEditorClassName","")),fastScrollSensitivity:Te(new d(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:r.localize(189,null)})),find:Te(new g),fixedOverflowWidgets:Te(new S(36,"fixedOverflowWidgets",!1)),folding:Te(new S(37,"folding",!0,{description:r.localize(190,null)})),foldingStrategy:Te(new P(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(191,null),r.localize(192,null)],description:r.localize(193,null)})),foldingHighlight:Te(new S(39,"foldingHighlight",!0,{description:r.localize(194,null)})),foldingImportsByDefault:Te(new S(40,"foldingImportsByDefault",!1,{description:r.localize(195,null)})),foldingMaximumRegions:Te(new w(41,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(196,null)})),unfoldOnClickAfterEndOfLine:Te(new S(42,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(197,null)})),fontFamily:Te(new D(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(198,null)})),fontInfo:Te(new z),fontLigatures2:Te(new U),fontSize:Te(new q),fontWeight:Te(new j),formatOnPaste:Te(new S(48,"formatOnPaste",!1,{description:r.localize(199,null)})),formatOnType:Te(new S(49,"formatOnType",!1,{description:r.localize(200,null)})),glyphMargin:Te(new S(50,"glyphMargin",!0,{description:r.localize(201,null)})),gotoLocation:Te(new J),hideCursorInOverviewRuler:Te(new S(52,"hideCursorInOverviewRuler",!1,{description:r.localize(202,null)})),hover:Te(new V),inDiffEditor:Te(new S(54,"inDiffEditor",!1)),letterSpacing:Te(new d(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>d.clamp(G,-5,20),{description:r.localize(203,null)})),lightbulb:Te(new te),lineDecorationsWidth:Te(new i(58,"lineDecorationsWidth",10)),lineHeight:Te(new fe),lineNumbers:Te(new Ke),lineNumbersMinChars:Te(new w(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new S(62,"linkedEditing",!1,{description:r.localize(204,null)})),links:Te(new S(63,"links",!0,{description:r.localize(205,null)})),matchBrackets:Te(new P(64,"matchBrackets","always",["always","near","never"],{description:r.localize(206,null)})),minimap:Te(new Se),mouseStyle:Te(new P(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new d(67,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:r.localize(207,null)})),mouseWheelZoom:Te(new S(68,"mouseWheelZoom",!1,{markdownDescription:r.localize(208,null)})),multiCursorMergeOverlapping:Te(new S(69,"multiCursorMergeOverlapping",!0,{description:r.localize(209,null)})),multiCursorModifier:Te(new c(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ge,{markdownEnumDescriptions:[r.localize(210,null),r.localize(211,null)],markdownDescription:r.localize(212,null)})),multiCursorPaste:Te(new P(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(213,null),r.localize(214,null)],markdownDescription:r.localize(215,null)})),occurrencesHighlight:Te(new S(72,"occurrencesHighlight",!0,{description:r.localize(216,null)})),overviewRulerBorder:Te(new S(73,"overviewRulerBorder",!0,{description:r.localize(217,null)})),overviewRulerLanes:Te(new w(74,"overviewRulerLanes",3,0,3)),padding:Te(new ne),parameterHints:Te(new me),peekWidgetDefaultFocus:Te(new P(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(218,null),r.localize(219,null)],description:r.localize(220,null)})),definitionLinkOpensInPeek:Te(new S(78,"definitionLinkOpensInPeek",!1,{description:r.localize(221,null)})),quickSuggestions:Te(new Ae),quickSuggestionsDelay:Te(new w(80,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(222,null)})),readOnly:Te(new S(81,"readOnly",!1)),renameOnType:Te(new S(82,"renameOnType",!1,{description:r.localize(223,null),markdownDeprecationMessage:r.localize(224,null)})),renderControlCharacters:Te(new S(83,"renderControlCharacters",!0,{description:r.localize(225,null),restricted:!0})),renderFinalNewline:Te(new S(84,"renderFinalNewline",!0,{description:r.localize(226,null)})),renderLineHighlight:Te(new P(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(227,null)],description:r.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Te(new S(86,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(229,null)})),renderValidationDecorations:Te(new P(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new P(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(230,null),r.localize(231,null),r.localize(232,null),""],description:r.localize(233,null)})),revealHorizontalRightPadding:Te(new w(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Te(new S(90,"roundedSelection",!0,{description:r.localize(234,null)})),rulers:Te(new de),scrollbar:Te(new F),scrollBeyondLastColumn:Te(new w(93,"scrollBeyondLastColumn",5,0,1073741824,{description:r.localize(235,null)})),scrollBeyondLastLine:Te(new S(94,"scrollBeyondLastLine",!0,{description:r.localize(236,null)})),scrollPredominantAxis:Te(new S(95,"scrollPredominantAxis",!0,{description:r.localize(237,null)})),selectionClipboard:Te(new S(96,"selectionClipboard",!0,{description:r.localize(238,null),included:k.isLinux})),selectionHighlight:Te(new S(97,"selectionHighlight",!0,{description:r.localize(239,null)})),selectOnLineNumbers:Te(new S(98,"selectOnLineNumbers",!0)),showFoldingControls:Te(new P(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[r.localize(240,null),r.localize(241,null)],description:r.localize(242,null)})),showUnused:Te(new S(100,"showUnused",!0,{description:r.localize(243,null)})),showDeprecated:Te(new S(126,"showDeprecated",!0,{description:r.localize(244,null)})),inlayHints:Te(new ue),snippetSuggestions:Te(new P(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(245,null),r.localize(246,null),r.localize(247,null),r.localize(248,null)],description:r.localize(249,null)})),smartSelect:Te(new ke),smoothScrolling:Te(new S(103,"smoothScrolling",!1,{description:r.localize(250,null)})),stopRenderingLineAfter:Te(new w(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new ve),inlineSuggest:Te(new M),suggestFontSize:Te(new w(107,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(251,null)})),suggestLineHeight:Te(new w(108,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(252,null)})),suggestOnTriggerCharacters:Te(new S(109,"suggestOnTriggerCharacters",!0,{description:r.localize(253,null)})),suggestSelection:Te(new P(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(254,null),r.localize(255,null),r.localize(256,null)],description:r.localize(257,null)})),tabCompletion:Te(new P(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(258,null),r.localize(259,null),r.localize(260,null)],description:r.localize(261,null)})),tabIndex:Te(new w(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new C),unusualLineTerminators:Te(new P(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(262,null),r.localize(263,null),r.localize(264,null)],description:r.localize(265,null)})),useShadowDOM:Te(new S(115,"useShadowDOM",!0)),useTabStops:Te(new S(116,"useTabStops",!0,{description:r.localize(266,null)})),wordSeparators:Te(new D(117,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:r.localize(267,null)})),wordWrap:Te(new P(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(268,null),r.localize(269,null),r.localize(270,null),r.localize(271,null)],description:r.localize(272,null)})),wordWrapBreakAfterCharacters:Te(new D(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new D(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new w(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(273,null)})),wordWrapOverride1:Te(new P(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new P(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new c(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ze,{enumDescriptions:[r.localize(274,null),r.localize(275,null),r.localize(276,null),r.localize(277,null)],description:r.localize(278,null)})),wrappingStrategy:Te(new P(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(279,null),r.localize(280,null)],description:r.localize(281,null)})),editorClassName:Te(new A),pixelRatio:Te(new Ie),tabFocusMode:Te(new Me),layoutInfo:Te(new ae),wrappingInfo:Te(new Be)}}),define(Ee[117],be([18,19]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[118],be([18,19]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[119],be([18,19]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(Ee[120],be([18,19]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(Ee[121],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[122],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[123],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[124],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[125],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[126],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[127],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[128],be([18,19]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(Ee[129],be([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[130],be([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[131],be([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[132],be([18,19]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[133],be([18,19]),function(Y,e){return Y.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[134],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var r;(function(y){y[y.ACTIVATE=1]="ACTIVATE",y[y.RESTORE=2]="RESTORE",y[y.PRESERVE=3]="PRESERVE"})(r=e.EditorActivation||(e.EditorActivation={}));var k;(function(y){y[y.PICK=0]="PICK",y[y.DISABLED=1]="DISABLED",y[y.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(k=e.EditorResolution||(e.EditorResolution={}));var b;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(b=e.EditorOpenContext||(e.EditorOpenContext={}));var $;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})($=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[135],be([1,0,118]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(n){return n=n.trim(),n==="*"||k.test(n)}e.isValidVersionStr=$;function y(n){if(!$(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=n.match(k);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=y;function O(n){if(!n)return null;let p=n.majorBase,s=n.majorMustEqual,i=n.minorBase,u=n.minorMustEqual,S=n.patchBase,_=n.patchMustEqual;n.hasCaret&&(p===0||(u=!1),_=!1);let w=0;if(n.preRelease){const d=b.exec(n.preRelease);if(d){const[,D,a,P]=d;w=Date.UTC(Number(D),Number(a)-1,Number(P))}}return{majorBase:p,majorMustEqual:s,minorBase:i,minorMustEqual:u,patchBase:S,patchMustEqual:_,isMinimum:n.hasGreaterEquals,notBefore:w}}e.normalizeVersion=O;function I(n,p,s){let i;typeof n=="string"?i=O(y(n)):i=n;let u;p instanceof Date?u=p.getTime():typeof p=="string"&&(u=new Date(p).getTime());let S;if(typeof s=="string"?S=O(y(s)):S=s,!i||!S)return!1;let _=i.majorBase,w=i.minorBase,d=i.patchBase,D=S.majorBase,a=S.minorBase,P=S.patchBase,c=S.notBefore,t=S.majorMustEqual,h=S.minorMustEqual,o=S.patchMustEqual;return S.isMinimum?_>D?!0:_<D?!1:w>a?!0:w<a||u&&u<c?!1:d>=P:(_===1&&D===0&&(!t||!h||!o)&&(D=1,a=0,P=0,t=!0,h=!1,o=!1),_<D?!1:_>D?!t:w<a?!1:w>a?!h:d<P?!1:d>P?!o:!(u&&u<c))}e.isValidVersion=I;function R(n,p,s,i){return s.isBuiltin||typeof s.main=="undefined"?!0:v(n,p,s.engines.vscode,i)}e.isValidExtensionVersion=R;function N(n,p,s){return n==="*"||v(p,s,n)}e.isEngineValid=N;function v(n,p,s,i=[]){let u=O(y(s));if(!u)return i.push(r.localize(0,null,s)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return i.push(r.localize(1,null,s)),!1}else if(!u.majorMustEqual)return i.push(r.localize(2,null,s)),!1;return I(n,p,u)?!0:(i.push(r.localize(3,null,n,s)),!1)}}),define(Ee[74],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(b,$=[],y=!1){this.ctor=b,this.staticArguments=$,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=r}),define(Ee[44],be([1,0,74]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function b(y,O,I){O instanceof r.SyncDescriptor||(O=new r.SyncDescriptor(O,[],I)),k.push([y,O])}e.registerSingleton=b;function $(){return k}e.getSingletonServiceDescriptors=$}),define(Ee[136],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor($){this.incoming=new Map,this.outgoing=new Map,this.data=$}}e.Node=r;class k{constructor($){this._hashFn=$,this._nodes=new Map}roots(){const $=[];for(let y of this._nodes.values())y.outgoing.size===0&&$.push(y);return $}insertEdge($,y){const O=this.lookupOrInsertNode($),I=this.lookupOrInsertNode(y);O.outgoing.set(this._hashFn(y),I),I.incoming.set(this._hashFn($),O)}removeNode($){const y=this._hashFn($);this._nodes.delete(y);for(let O of this._nodes.values())O.outgoing.delete(y),O.incoming.delete(y)}lookupOrInsertNode($){const y=this._hashFn($);let O=this._nodes.get(y);return O||(O=new r($),this._nodes.set(y,O)),O}lookup($){return this._nodes.get(this._hashFn($))}isEmpty(){return this._nodes.size===0}toString(){let $=[];for(let[y,O]of this._nodes)$.push(`${y}, (incoming)[${[...O.incoming.keys()].join(", ")}], (outgoing)[${[...O.outgoing.keys()].join(",")}]`);return $.join(`
`)}findCycleSlow(){for(let[$,y]of this._nodes){const O=new Set([$]),I=this._findCycle(y,O);if(I)return I}}_findCycle($,y){for(let[O,I]of $.outgoing){if(y.has(O))return[...y,O].join(" -> ");y.add(O);const R=this._findCycle(I,y);if(R)return R;y.delete(O)}}}e.Graph=k}),define(Ee[3],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function O(I){return I[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=O})(r=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function k(y,O,I,R){O[r.DI_TARGET]===O?O[r.DI_DEPENDENCIES].push({id:y,index:I,optional:R}):(O[r.DI_DEPENDENCIES]=[{id:y,index:I,optional:R}],O[r.DI_TARGET]=O)}function b(y){if(r.serviceIds.has(y))return r.serviceIds.get(y);const O=function(I,R,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(O,I,N,!1)};return O.toString=()=>y,r.serviceIds.set(y,O),O}e.createDecorator=b;function $(y){return y}e.refineServiceDecorator=$}),define(Ee[75],be([1,0,13,2,3]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function $(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof k.URI)}e.isConfigurationOverrides=$;function y(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||r.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=y;var O;(function(u){u[u.USER=1]="USER",u[u.USER_LOCAL=2]="USER_LOCAL",u[u.USER_REMOTE=3]="USER_REMOTE",u[u.WORKSPACE=4]="WORKSPACE",u[u.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",u[u.DEFAULT=6]="DEFAULT",u[u.MEMORY=7]="MEMORY"})(O=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(u){switch(u){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=I;function R(u,S){const _=Object.create(null);for(let w in u)N(_,w,u[w],S);return _}e.toValuesTree=R;function N(u,S,_,w){const d=S.split("."),D=d.pop();let a=u;for(let P=0;P<d.length;P++){let c=d[P],t=a[c];switch(typeof t){case"undefined":t=a[c]=Object.create(null);break;case"object":break;default:w(`Ignoring ${S} as ${d.slice(0,P+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[D]=_}catch{w(`Ignoring ${S} as ${d.join(".")} is ${JSON.stringify(a)}`)}else w(`Ignoring ${S} as ${d.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=N;function v(u,S){const _=S.split(".");n(u,_)}e.removeFromValueTree=v;function n(u,S){const _=S.shift();if(S.length===0){delete u[_];return}if(Object.keys(u).indexOf(_)!==-1){const w=u[_];typeof w=="object"&&!Array.isArray(w)&&(n(w,S),Object.keys(w).length===0&&delete u[_])}}function p(u,S,_){function w(a,P){let c=a;for(const t of P){if(typeof c!="object"||c===null)return;c=c[t]}return c}const d=S.split("."),D=w(u,d);return typeof D=="undefined"?_:D}e.getConfigurationValue=p;function s(u,S,_){Object.keys(S).forEach(w=>{w!=="__proto__"&&(w in u?r.isObject(u[w])&&r.isObject(S[w])?s(u[w],S[w],_):_&&(u[w]=S[w]):u[w]=S[w])})}e.merge=s;function i(u,S,_){const w=u.inspect(S),d=u.inspect(_);return typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:w.defaultValue}e.getMigratedSettingValue=i}),define(Ee[45],be([1,0,23,10,3]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",r.isMacintosh),$.set("isLinux",r.isLinux),$.set("isWindows",r.isWindows),$.set("isWeb",r.isWeb),$.set("isMacNative",r.isMacintosh&&!r.isWeb),$.set("isEdge",r.isEdge),$.set("isFirefox",r.isFirefox),$.set("isChrome",r.isChrome),$.set("isSafari",r.isSafari);const y=Object.prototype.hasOwnProperty;var O;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(O=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return v.INSTANCE}static true(){return n.INSTANCE}static has(g){return p.create(g)}static equals(g,U){return s.create(g,U)}static notEquals(g,U){return S.create(g,U)}static regex(g,U){return c.create(g,U)}static in(g,U){return i.create(g,U)}static not(g){return _.create(g)}static and(...g){return o.create(g,null)}static or(...g){return l.create(g,null,!0)}static greater(g,U){return d.create(g,U)}static greaterEquals(g,U){return D.create(g,U)}static smaller(g,U){return a.create(g,U)}static smallerEquals(g,U){return P.create(g,U)}static deserialize(g,U=!1){if(!!g)return this._deserializeOrExpression(g,U)}static _deserializeOrExpression(g,U){let z=g.split("||");return l.create(z.map(q=>this._deserializeAndExpression(q,U)),null,!0)}static _deserializeAndExpression(g,U){let z=g.split("&&");return o.create(z.map(q=>this._deserializeOne(q,U)),null)}static _deserializeOne(g,U){if(g=g.trim(),g.indexOf("!=")>=0){let z=g.split("!=");return S.create(z[0].trim(),this._deserializeValue(z[1],U))}if(g.indexOf("==")>=0){let z=g.split("==");return s.create(z[0].trim(),this._deserializeValue(z[1],U))}if(g.indexOf("=~")>=0){let z=g.split("=~");return c.create(z[0].trim(),this._deserializeRegexValue(z[1],U))}if(g.indexOf(" in ")>=0){let z=g.split(" in ");return i.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const z=g.split(">=");return D.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const z=g.split(">");return d.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const z=g.split("<=");return P.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const z=g.split("<");return a.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(g)?_.create(g.substr(1).trim()):p.create(g)}static _deserializeValue(g,U){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;let z=/^'([^']*)'$/.exec(g);return z?z[1].trim():g}static _deserializeRegexValue(g,U){if((0,k.isFalsyOrWhitespace)(g)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=g.indexOf("/"),q=g.lastIndexOf("/");if(z===q||z<0){if(U)throw new Error(`bad regexp-value '${g}', missing /-enclosure`);return console.warn(`bad regexp-value '${g}', missing /-enclosure`),null}let j=g.slice(z+1,q),J=g[q+1]==="i"?"i":"";try{return new RegExp(j,J)}catch(V){if(U)throw new Error(`bad regexp-value '${g}', parse error: ${V}`);return console.warn(`bad regexp-value '${g}', parse error: ${V}`),null}}}e.ContextKeyExpr=I;function R(x,g){const U=x?x.substituteConstants():void 0,z=g?g.substituteConstants():void 0;return!U&&!z?!0:!U||!z?!1:U.equals(z)}e.expressionsAreEqualWithConstantSubstitution=R;function N(x,g){return x.cmp(g)}class v{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=v,v.INSTANCE=new v;class n{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class p{constructor(g,U){this.key=g,this.negated=U,this.type=2}static create(g,U=null){const z=$.get(g);return typeof z=="boolean"?z?n.INSTANCE:v.INSTANCE:new p(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:m(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=$.get(this.key);return typeof g=="boolean"?g?n.INSTANCE:v.INSTANCE:this}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class s{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=4}static create(g,U,z=null){if(typeof U=="boolean")return U?p.create(g,z):_.create(g,z);const q=$.get(g);return typeof q=="boolean"?U===(q?"true":"false")?n.INSTANCE:v.INSTANCE:new s(g,U,z)}cmp(g){return g.type!==this.type?this.type-g.type:E(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){const g=$.get(this.key);if(typeof g=="boolean"){const U=g?"true":"false";return this.value===U?n.INSTANCE:v.INSTANCE}return this}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=s;class i{constructor(g,U){this.key=g,this.valueKey=U,this.type=10,this.negated=null}static create(g,U){return new i(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:E(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}substituteConstants(){return this}evaluate(g){const U=g.getValue(this.valueKey),z=g.getValue(this.key);return Array.isArray(U)?U.indexOf(z)>=0:typeof z=="string"&&typeof U=="object"&&U!==null?y.call(U,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=u.create(this)),this.negated}}e.ContextKeyInExpr=i;class u{constructor(g){this._actual=g,this.type=11}static create(g){return new u(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}substituteConstants(){return this}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new u(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotInExpr=u;class S{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=5}static create(g,U,z=null){if(typeof U=="boolean")return U?_.create(g,z):p.create(g,z);const q=$.get(g);return typeof q=="boolean"?U===(q?"true":"false")?v.INSTANCE:n.INSTANCE:new S(g,U,z)}cmp(g){return g.type!==this.type?this.type-g.type:E(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){const g=$.get(this.key);if(typeof g=="boolean"){const U=g?"true":"false";return this.value===U?v.INSTANCE:n.INSTANCE}return this}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class _{constructor(g,U){this.key=g,this.negated=U,this.type=3}static create(g,U=null){const z=$.get(g);return typeof z=="boolean"?z?v.INSTANCE:n.INSTANCE:new _(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:m(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=$.get(this.key);return typeof g=="boolean"?g?v.INSTANCE:n.INSTANCE:this}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function w(x,g){if(typeof x=="string"){const U=parseFloat(x);isNaN(U)||(x=U)}return typeof x=="string"||typeof x=="number"?g(x):v.INSTANCE}class d{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=12}static create(g,U,z=null){return w(U,q=>new d(g,q,z))}cmp(g){return g.type!==this.type?this.type-g.type:E(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class D{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=13}static create(g,U,z=null){return w(U,q=>new D(g,q,z))}cmp(g){return g.type!==this.type?this.type-g.type:E(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=D;class a{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=14}static create(g,U,z=null){return w(U,q=>new a(g,q,z))}cmp(g){return g.type!==this.type?this.type-g.type:E(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class P{constructor(g,U,z){this.key=g,this.value=U,this.negated=z,this.type=15}static create(g,U,z=null){return w(U,q=>new P(g,q,z))}cmp(g){return g.type!==this.type?this.type-g.type:E(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=P;class c{constructor(g,U){this.key=g,this.regexp=U,this.type=7,this.negated=null}static create(g,U){return new c(g,U)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const U=this.regexp?this.regexp.source:"",z=g.regexp?g.regexp.source:"";return U<z?-1:U>z?1:0}equals(g){if(g.type===this.type){const U=this.regexp?this.regexp.source:"",z=g.regexp?g.regexp.source:"";return this.key===g.key&&U===z}return!1}substituteConstants(){return this}evaluate(g){let U=g.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=c;class t{constructor(g){this._actual=g,this.type=8}static create(g){return new t(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}substituteConstants(){return this}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new t(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function h(x){let g=null;for(let U=0,z=x.length;U<z;U++){const q=x[U].substituteConstants();if(x[U]!==q&&g===null){g=[];for(let j=0;j<U;j++)g[j]=x[j]}g!==null&&(g[U]=q)}return g===null?x:g}class o{constructor(g,U){this.expr=g,this.negated=U,this.type=6}static create(g,U){return o._normalizeArr(g,U)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const q=N(this.expr[U],g.expr[U]);if(q!==0)return q}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(g.expr[U]))return!1;return!0}return!1}substituteConstants(){const g=h(this.expr);return g===this.expr?this:o.create(g,this.negated)}evaluate(g){for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].evaluate(g))return!1;return!0}static _normalizeArr(g,U){const z=[];let q=!1;for(const j of g)if(!!j){if(j.type===1){q=!0;continue}if(j.type===0)return v.INSTANCE;if(j.type===6){z.push(...j.expr);continue}z.push(j)}if(z.length===0&&q)return n.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(N);for(let j=1;j<z.length;j++)z[j-1].equals(z[j])&&(z.splice(j,1),j--);if(z.length===1)return z[0];for(;z.length>1;){const j=z[z.length-1];if(j.type!==9)break;z.pop();const J=z.pop(),V=z.length===0,ie=l.create(j.expr.map(ae=>o.create([ae,J],null)),null,V);ie&&(z.push(ie),z.sort(N))}return z.length===1?z[0]:new o(z,U)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(let U of this.expr)g.push(...U.keys());return g}map(g){return new o(this.expr.map(U=>U.map(g)),null)}negate(){if(!this.negated){const g=[];for(let U of this.expr)g.push(U.negate());this.negated=l.create(g,this,!0)}return this.negated}}class l{constructor(g,U){this.expr=g,this.negated=U,this.type=9}static create(g,U,z){return l._normalizeArr(g,U,z)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const q=N(this.expr[U],g.expr[U]);if(q!==0)return q}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(g.expr[U]))return!1;return!0}return!1}substituteConstants(){const g=h(this.expr);return g===this.expr?this:l.create(g,this.negated,!1)}evaluate(g){for(let U=0,z=this.expr.length;U<z;U++)if(this.expr[U].evaluate(g))return!0;return!1}static _normalizeArr(g,U,z){let q=[],j=!1;if(g){for(let J=0,V=g.length;J<V;J++){const ie=g[J];if(!!ie){if(ie.type===0){j=!0;continue}if(ie.type===1)return n.INSTANCE;if(ie.type===9){q=q.concat(ie.expr);continue}q.push(ie)}}if(q.length===0&&j)return v.INSTANCE;q.sort(N)}if(q.length!==0){if(q.length===1)return q[0];for(let J=1;J<q.length;J++)q[J-1].equals(q[J])&&(q.splice(J,1),J--);if(q.length===1)return q[0];if(z){for(let J=0;J<q.length;J++)for(let V=J+1;V<q.length;V++)T(q[J],q[V])&&(q.splice(V,1),V--);if(q.length===1)return q[0]}return new l(q,U)}}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(let U of this.expr)g.push(...U.keys());return g}map(g){return new l(this.expr.map(U=>U.map(g)),null)}negate(){if(!this.negated){let g=[];for(let U of this.expr)g.push(U.negate());for(;g.length>1;){const U=g.shift(),z=g.shift(),q=[];for(const J of A(U))for(const V of A(z))q.push(o.create([J,V],null));const j=g.length===0;g.unshift(l.create(q,null,j))}this.negated=g[0]}return this.negated}}class f extends p{constructor(g,U,z){super(g,null);this._defaultValue=U,typeof z=="object"?f._info.push({...z,key:g}):z!==!0&&f._info.push({key:g,description:z,type:U!=null?typeof U:void 0})}static all(){return f._info.values()}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(g){return s.create(this.key,g)}notEqualsTo(g){return S.create(this.key,g)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(x,g){return x<g?-1:x>g?1:0}function E(x,g,U,z){return x<U?-1:x>U?1:g<z?-1:g>z?1:0}function T(x,g){if(g.type===6&&x.type!==9&&x.type!==6){for(const q of g.expr)if(x.equals(q))return!0}const U=x.negate(),z=A(U).concat(A(g));z.sort(N);for(let q=0;q<z.length;q++){const J=z[q].negate();for(let V=q+1;V<z.length;V++){const ie=z[V];if(J.equals(ie))return!0}}return!1}e.implies=T;function A(x){return x.type===9?x.expr:[x]}}),define(Ee[137],be([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[46],be([1,0,22,17,10,13,2,119,3]),function(Y,e,r,k,b,$,y,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function R(j){return j.create===!0}e.isFileOpenForWriteOptions=R;var N;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(N=e.FileType||(e.FileType={}));var v;(function(j){j[j.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var n;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=p;function s(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=s;function i(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=i;function u(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=u;function S(j){return p(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var _;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(J,V){super(J);this.code=V}}e.FileSystemProviderError=w;function d(j,J){const V=new w(j.toString(),J);return a(V,J),V}e.createFileSystemProviderError=d;function D(j){return j||d((0,O.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=D;function a(j,J){return j.name=J?`${J} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=a;function P(j){if(!j)return _.Unknown;if(j instanceof w)return j.code;const J=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!J)return _.Unknown;switch(J[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=P;function c(j){if(j instanceof m)return j.fileOperationResult;switch(P(j)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var t;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class h{constructor(J,V,ie){this.resource=J,this.operation=V,this.target=ie}isOperation(J){return this.operation===J}}e.FileOperationEvent=h;var o;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(J,V){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=J;const ie=new Map;for(const ae of J){const te=ie.get(ae.type);switch(te?te.push([ae.resource,ae]):ie.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,te]of ie)switch(ae){case 1:this.added=r.TernarySearchTree.forUris(()=>V),this.added.fill(te);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>V),this.updated.fill(te);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>V),this.deleted.fill(te);break}}contains(J,...V){return this.doContains(J,{includeChildren:!1},...V)}affects(J,...V){return this.doContains(J,{includeChildren:!0},...V)}doContains(J,V,...ie){if(!J)return!1;const ae=ie.length>0;return!!((!ae||ie.includes(1))&&(this.added?.get(J)||V.includeChildren&&this.added?.findSuperstr(J))||(!ae||ie.includes(0))&&(this.updated?.get(J)||V.includeChildren&&this.updated?.findSuperstr(J))||(!ae||ie.includes(2))&&(this.deleted?.findSubstr(J)||V.includeChildren&&this.deleted?.findSuperstr(J)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function f(j,J,V){return!j||!J||j===J||J.length>j.length?!1:(J.charAt(J.length-1)!==k.sep&&(J+=k.sep),V?(0,b.startsWithIgnoreCase)(j,J):j.indexOf(J)===0)}e.isParent=f;class m extends Error{constructor(J,V,ie){super(J);this.fileOperationResult=V,this.options=ie}}e.FileOperationError=m;class E extends m{constructor(J,V,ie){super(J,2,ie);this.stat=V}}e.NotModifiedSinceFileOperationError=E;var T;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function x(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=x;async function g(j,J){if(!J.hasProvider(y.URI.from({scheme:j.scheme})))return new Promise(V=>{const ie=J.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===j.scheme&&ae.added&&(ie.dispose(),V())})})}e.whenProviderRegistered=g,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(J){return(0,$.isNumber)(J)||(J=0),J<U.KB?(0,O.localize)(1,null,J.toFixed(0)):J<U.MB?(0,O.localize)(2,null,(J/U.KB).toFixed(2)):J<U.GB?(0,O.localize)(3,null,(J/U.MB).toFixed(2)):J<U.TB?(0,O.localize)(4,null,(J/U.GB).toFixed(2)):(0,O.localize)(5,null,(J/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var z;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function q(j){return{maxFileSize:j===0?300*U.MB:16*U.GB,maxHeapSize:j===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=q}),define(Ee[55],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...b){this._entries=new Map;for(let[$,y]of b)this.set($,y)}set(b,$){const y=this._entries.get(b);return this._entries.set(b,$),y}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=r}),define(Ee[138],be([1,0,11,15,74,136,3,55]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class R extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class N{constructor(s=new O.ServiceCollection,i=!1,u){this._activeInstantiations=new Set,this._services=s,this._strict=i,this._parent=u,this._services.set(y.IInstantiationService,this)}createChild(s){return new N(s,this._strict,this)}invokeFunction(s,...i){let u=n.traceInvocation(s),S=!1;try{return s({get:w=>{if(S)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(w,u);if(!d)throw new Error(`[invokeFunction] unknown service '${w}'`);return d}},...i)}finally{S=!0,u.stop()}}createInstance(s,...i){let u,S;return s instanceof b.SyncDescriptor?(u=n.traceCreation(s.ctor),S=this._createInstance(s.ctor,s.staticArguments.concat(i),u)):(u=n.traceCreation(s),S=this._createInstance(s,i,u)),u.stop(),S}_createInstance(s,i=[],u){let S=y._util.getServiceDependencies(s).sort((d,D)=>d.index-D.index),_=[];for(const d of S){let D=this._getOrCreateServiceInstance(d.id,u);if(!D&&this._strict&&!d.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${d.id}.`);_.push(D)}let w=S.length>0?S[0].index:i.length;if(i.length!==w){console.warn(`[createInstance] First service dependency of ${s.name} at position ${w+1} conflicts with ${i.length} static arguments`);let d=w-i.length;d>0?i=i.concat(new Array(d)):i=i.slice(0,w)}return new s(...[...i,..._])}_setServiceInstance(s,i){if(this._services.get(s)instanceof b.SyncDescriptor)this._services.set(s,i);else if(this._parent)this._parent._setServiceInstance(s,i);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let i=this._services.get(s);return!i&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):i}_getOrCreateServiceInstance(s,i){let u=this._getServiceInstanceOrDescriptor(s);return u instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,u,i.branch(s,!0)):(i.branch(s,!1),u)}_safeCreateAndCacheServiceInstance(s,i,u){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,i,u)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,i,u){const S=new $.Graph(d=>d.id.toString());let _=0;const w=[{id:s,desc:i,_trace:u}];for(;w.length;){const d=w.pop();if(S.lookupOrInsertNode(d),_++>1e3)throw new R(S);for(let D of y._util.getServiceDependencies(d.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(D.id);if(!a&&!D.optional&&console.warn(`[createInstance] ${s} depends on ${D.id} which is NOT registered.`),a instanceof b.SyncDescriptor){const P={id:D.id,desc:a,_trace:d._trace.branch(D.id,!0)};S.insertEdge(d,P),w.push(P)}}}for(;;){const d=S.roots();if(d.length===0){if(!S.isEmpty())throw new R(S);break}for(const{data:D}of d){if(this._getServiceInstanceOrDescriptor(D.id)instanceof b.SyncDescriptor){const P=this._createServiceInstanceWithOwner(D.id,D.desc.ctor,D.desc.staticArguments,D.desc.supportsDelayedInstantiation,D._trace);this._setServiceInstance(D.id,P)}S.removeNode(D)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,i,u=[],S,_){if(this._services.get(s)instanceof b.SyncDescriptor)return this._createServiceInstance(i,u,S,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,i,u,S,_);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}_createServiceInstance(s,i=[],u,S){if(u){const _=new r.IdleValue(()=>this._createInstance(s,i,S));return new Proxy(Object.create(null),{get(w,d){if(d in w)return w[d];let D=_.value,a=D[d];return typeof a!="function"||(a=a.bind(D),w[d]=a),a},set(w,d,D){return _.value[d]=D,!0}})}else return this._createInstance(s,i,S)}}e.InstantiationService=N;var v;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(v||(v={}));class n{constructor(s,i){this.type=s,this.name=i,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return I?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return I?new n(0,s.name):n._None}branch(s,i){let u=new n(2,s.toString());return this._dep.push([s,i,u]),u}stop(){let s=Date.now()-this._start;n._totals+=s;let i=!1;function u(_,w){let d=[],D=new Array(_+1).join("	");for(const[a,P,c]of w._dep)if(P&&c){i=!0,d.push(`${D}CREATES -> ${a}`);let t=u(_+1,c);t&&d.push(t)}else d.push(`${D}uses -> ${a}`);return d.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||i)&&console.log(S.join(`
`))}}e.Trace=n,n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(Ee[12],be([1,0,43,5,6,23,3]),function(Y,e,r,k,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function O(){return new Date().toISOString()}var I;(function(P){P[P.Trace=0]="Trace",P[P.Debug=1]="Debug",P[P.Info=2]="Info",P[P.Warning=3]="Warning",P[P.Error=4]="Error",P[P.Critical=5]="Critical",P[P.Off=6]="Off"})(I=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=I.Info;function R(P,c,t){switch(c){case I.Trace:P.trace(t);break;case I.Debug:P.debug(t);break;case I.Info:P.info(t);break;case I.Warning:P.warn(t);break;case I.Error:P.error(t);break;case I.Critical:P.critical(t);break;default:throw new Error("Invalid log level")}}e.log=R;function N(P){let c="";for(let t=0;t<P.length;t++){let h=P[t];if(typeof h=="object")try{h=JSON.stringify(h)}catch{}c+=(t>0?" ":"")+h}return c}e.format=N;class v extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(c){this.level!==c&&(this.level=c,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class n extends v{constructor(c){super();this.logAlways=c}checkLogLevel(c){return this.logAlways||this.getLevel()<=c}trace(c,...t){this.checkLogLevel(I.Trace)&&this.log(I.Trace,N([c,...t]))}debug(c,...t){this.checkLogLevel(I.Debug)&&this.log(I.Debug,N([c,...t]))}info(c,...t){this.checkLogLevel(I.Info)&&this.log(I.Info,N([c,...t]))}warn(c,...t){this.checkLogLevel(I.Warning)&&this.log(I.Warning,N([c,...t]))}error(c,...t){if(this.checkLogLevel(I.Error))if(c instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=c.stack,this.log(I.Error,N(h))}else this.log(I.Error,N([c,...t]))}critical(c,...t){this.checkLogLevel(I.Critical)&&this.log(I.Critical,N([c,...t]))}flush(){}}e.AbstractMessageLogger=n;class p extends v{constructor(c=e.DEFAULT_LOG_LEVEL){super();this.setLevel(c),this.useColors=!$.isWindows}trace(c,...t){this.getLevel()<=I.Trace&&(this.useColors?console.log(`[90m[main ${O()}][0m`,c,...t):console.log(`[main ${O()}]`,c,...t))}debug(c,...t){this.getLevel()<=I.Debug&&(this.useColors?console.log(`[90m[main ${O()}][0m`,c,...t):console.log(`[main ${O()}]`,c,...t))}info(c,...t){this.getLevel()<=I.Info&&(this.useColors?console.log(`[90m[main ${O()}][0m`,c,...t):console.log(`[main ${O()}]`,c,...t))}warn(c,...t){this.getLevel()<=I.Warning&&(this.useColors?console.warn(`[93m[main ${O()}][0m`,c,...t):console.warn(`[main ${O()}]`,c,...t))}error(c,...t){this.getLevel()<=I.Error&&(this.useColors?console.error(`[91m[main ${O()}][0m`,c,...t):console.error(`[main ${O()}]`,c,...t))}critical(c,...t){this.getLevel()<=I.Critical&&(this.useColors?console.error(`[90m[main ${O()}][0m`,c,...t):console.error(`[main ${O()}]`,c,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class s extends v{constructor(c=e.DEFAULT_LOG_LEVEL){super();this.setLevel(c)}trace(c,...t){this.getLevel()<=I.Trace&&console.log("%cTRACE","color: #888",c,...t)}debug(c,...t){this.getLevel()<=I.Debug&&console.log("%cDEBUG","background: #eee; color: #888",c,...t)}info(c,...t){this.getLevel()<=I.Info&&console.log("%c INFO","color: #33f",c,...t)}warn(c,...t){this.getLevel()<=I.Warning&&console.log("%c WARN","color: #993",c,...t)}error(c,...t){this.getLevel()<=I.Error&&console.log("%c  ERR","color: #f33",c,...t)}critical(c,...t){this.getLevel()<=I.Critical&&console.log("%cCRITI","background: #f33; color: white",c,...t)}dispose(){}flush(){}}e.ConsoleLogger=s;class i extends v{constructor(c,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=c,this.setLevel(t)}trace(c,...t){this.getLevel()<=I.Trace&&this.adapter.log(I.Trace,[this.extractMessage(c),...t])}debug(c,...t){this.getLevel()<=I.Debug&&this.adapter.log(I.Debug,[this.extractMessage(c),...t])}info(c,...t){this.getLevel()<=I.Info&&this.adapter.log(I.Info,[this.extractMessage(c),...t])}warn(c,...t){this.getLevel()<=I.Warning&&this.adapter.log(I.Warning,[this.extractMessage(c),...t])}error(c,...t){this.getLevel()<=I.Error&&this.adapter.log(I.Error,[this.extractMessage(c),...t])}critical(c,...t){this.getLevel()<=I.Critical&&this.adapter.log(I.Critical,[this.extractMessage(c),...t])}extractMessage(c){return typeof c=="string"?c:(0,r.toErrorMessage)(c,this.getLevel()<=I.Trace)}dispose(){}flush(){}}e.AdapterLogger=i;class u extends v{constructor(c){super();this.logServices=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const t of this.logServices)t.setLevel(c);super.setLevel(c)}trace(c,...t){for(const h of this.logServices)h.trace(c,...t)}debug(c,...t){for(const h of this.logServices)h.debug(c,...t)}info(c,...t){for(const h of this.logServices)h.info(c,...t)}warn(c,...t){for(const h of this.logServices)h.warn(c,...t)}error(c,...t){for(const h of this.logServices)h.error(c,...t)}critical(c,...t){for(const h of this.logServices)h.critical(c,...t)}flush(){for(const c of this.logServices)c.flush()}dispose(){for(const c of this.logServices)c.dispose()}}e.MultiplexLogService=u;class S extends b.Disposable{constructor(c){super();this.logger=c,this._register(c)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(c){this.logger.setLevel(c)}getLevel(){return this.logger.getLevel()}trace(c,...t){this.logger.trace(c,...t)}debug(c,...t){this.logger.debug(c,...t)}info(c,...t){this.logger.info(c,...t)}warn(c,...t){this.logger.warn(c,...t)}error(c,...t){this.logger.error(c,...t)}critical(c,...t){this.logger.critical(c,...t)}flush(){this.logger.flush()}}e.LogService=S;class _ extends b.Disposable{constructor(c,t){super();this.logLevel=c,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(h=>{this.logLevel=h,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(h))}))}getLogger(c){return this.loggers.get(c.toString())}createLogger(c,t){let h=this.loggers.get(c.toString());return h||(h=this.doCreateLogger(c,t?.always?I.Trace:this.logLevel,t),this.loggers.set(c.toString(),h),t?.always||this.logLevelChangeableLoggers.push(h)),h}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(c=>c.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class w{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(c){}getLevel(){return I.Info}trace(c,...t){}debug(c,...t){}info(c,...t){}warn(c,...t){}error(c,...t){}critical(c,...t){}dispose(){}flush(){}}e.NullLogService=w;function d(P){if(P.verbose)return I.Trace;if(typeof P.logLevel=="string"){const c=D(P.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function D(P){switch(P){case"trace":return I.Trace;case"debug":return I.Debug;case"info":return I.Info;case"warn":return I.Warning;case"error":return I.Error;case"critical":return I.Critical;case"off":return I.Off}}e.parseLogLevel=D;function a(P){switch(P){case I.Trace:return"trace";case I.Debug:return"debug";case I.Info:return"info";case I.Warning:return"warn";case I.Error:return"error";case I.Critical:return"critical";case I.Off:return"off"}}e.LogLevelToString=a}),define(Ee[76],be([1,0,34,120,3]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var $;(function(I){I[I.Unnecessary=1]="Unnecessary",I[I.Deprecated=2]="Deprecated"})($=e.MarkerTag||(e.MarkerTag={}));var y;(function(I){I[I.Hint=1]="Hint",I[I.Info=2]="Info",I[I.Warning=4]="Warning",I[I.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(I){function R(s,i){return i-s}I.compare=R;const N=Object.create(null);N[I.Error]=(0,k.localize)(0,null),N[I.Warning]=(0,k.localize)(1,null),N[I.Info]=(0,k.localize)(2,null);function v(s){return N[s]||""}I.toString=v;function n(s){switch(s){case r.default.Error:return I.Error;case r.default.Warning:return I.Warning;case r.default.Info:return I.Info;case r.default.Ignore:return I.Hint}}I.fromSeverity=n;function p(s){switch(s){case I.Error:return r.default.Error;case I.Warning:return r.default.Warning;case I.Info:return r.default.Info;case I.Hint:return r.default.Ignore}}I.toSeverity=p}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var O;(function(I){const R="";function N(n){return v(n,!0)}I.makeKey=N;function v(n,p){let s=[R];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(R),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(R),n.severity!==void 0&&n.severity!==null?s.push(y.toString(n.severity)):s.push(R),n.message&&p?s.push(n.message.replace("\xA6","\\\xA6")):s.push(R),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(R),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(R),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(R),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(R),s.push(R),s.join("\xA6")}I.makeKeyOptionalMessage=v})(O=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(Ee[139],be([1,0,5,34,3]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,b.createDecorator)("notificationService");var $;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})($=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class O{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=O;class I{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=I}),define(Ee[77],be([1,0,6,10,2,3]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.selectionFragment=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,$.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function y(R,N){return b.URI.isUri(R)?(0,k.equalsIgnoreCase)(R.scheme,N):(0,k.startsWithIgnoreCase)(R,N+":")}e.matchesScheme=y;function O(R,...N){return N.some(v=>y(R,v))}e.matchesSomeScheme=O;function I(R){let N;const v=/^L?(\d+)(?:,(\d+))?/.exec(R.fragment);return v&&(N={startLineNumber:parseInt(v[1]),startColumn:v[2]?parseInt(v[2]):1}),N}e.selectionFragment=I});var Fe=this&&this.__decorate||function(Y,e,r,k){var b=arguments.length,$=b<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,r):k,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")$=Reflect.decorate(Y,e,r,k);else for(var O=Y.length-1;O>=0;O--)(y=Y[O])&&($=(b<3?y($):b>3?y(e,r,$):y(e,r))||$);return b>3&&$&&Object.defineProperty(e,r,$),$},Ne=this&&this.__param||function(Y,e){return function(r,k){e(r,k,Y)}};define(Ee[140],be([1,0,11,20,6,3]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,$.createDecorator)("progressService");var y;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class O{constructor(v){this.callback=v}get value(){return this._value}report(v){this._value=v,this.callback(this._value)}}e.Progress=O,O.None=Object.freeze({report(){}});let I=class extends b.Disposable{constructor(v,n){super();this.deferred=new r.DeferredPromise,n.withProgress(v,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(v){this.reporter?this.reporter.report(v):this.lastStep=v}};I=Fe([Ne(1,e.IProgressService)],I),e.UnmanagedProgress=I;class R extends b.Disposable{constructor(v){super();this.progressIndicator=v,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(v){this.stop();const n=++this.currentOperationId,p=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},v),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:p.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(v){this.currentOperationId===v&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,$.createDecorator)("editorProgressService")}),define(Ee[37],be([1,0,42,13]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(y,O){r.ok(k.isString(y)),r.ok(k.isObject(O)),r.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,O)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new b}),define(Ee[141],be([1,0,5,37]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class ${constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,R){this.schemasById[b(I)]=R,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new $;k.Registry.add(e.Extensions.JSONContribution,y)}),define(Ee[78],be([1,0,16,5,13,117,141,37]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const N=O.Registry.as(y.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:$.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(D,a=!0){this.registerConfigurations([D],a)}registerConfigurations(D,a=!0){const P=this.doRegisterConfigurations(D,a);N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:P})}deregisterConfigurations(D){const a=this.doDeregisterConfigurations(D);N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:D,remove:a}){const P=[];P.push(...this.doDeregisterConfigurations(a)),P.push(...this.doRegisterConfigurations(D,!1)),N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(P)})}registerDefaultConfigurations(D){const a=[],P=[];for(const{overrides:c,source:t}of D)for(const h in c)if(a.push(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const o={...this.configurationDefaultsOverrides.get(h)?.value||{},...c[h]};this.configurationDefaultsOverrides.set(h,{source:t,value:o});const l={type:"object",default:o,description:$.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:b.isString(t)?void 0:t};P.push(...s(h)),this.configurationProperties[h]=l,this.defaultLanguageConfigurationOverridesNode.properties[h]=l}else{this.configurationDefaultsOverrides.set(h,{value:c[h],source:t});const o=this.configurationProperties[h];o&&(this.updatePropertyDefaultValue(h,o),this.updateSchema(h,o))}this.registerOverrideIdentifiers(P),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(D){const a=[];for(const{overrides:P,source:c}of D)for(const t in P){const h=this.configurationDefaultsOverrides.get(t),o=b.isString(c)?c:c?.id,l=b.isString(h?.source)?h?.source:h?.source?.id;if(o===l)if(a.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const f=this.configurationProperties[t];f&&(this.updatePropertyDefaultValue(t,f),this.updateSchema(t,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...D){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(D){for(const a of D)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(D,a){const P=[];return D.forEach(c=>{P.push(...this.validateAndRegisterProperties(c,a,c.extensionInfo,c.restrictedProperties)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),P}doDeregisterConfigurations(D){const a=[],P=c=>{if(c.properties)for(const t in c.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,c.properties[t]);c.allOf&&c.allOf.forEach(t=>P(t))};for(const c of D){P(c);const t=this.configurationContributors.indexOf(c);t!==-1&&this.configurationContributors.splice(t,1)}return a}validateAndRegisterProperties(D,a=!0,P,c,t=3){t=b.isUndefinedOrNull(D.scope)?t:D.scope;let h=[],o=D.properties;if(o)for(let f in o){if(a&&_(f)){delete o[f];continue}const m=o[f];if(m.source=P,m.defaultDefaultValue=o[f].default,this.updatePropertyDefaultValue(f,m),e.OVERRIDE_PROPERTY_REGEX.test(f)?m.scope=void 0:(m.scope=b.isUndefinedOrNull(m.scope)?t:m.scope,m.restricted=b.isUndefinedOrNull(m.restricted)?!!c?.includes(f):m.restricted),o[f].hasOwnProperty("included")&&!o[f].included){this.excludedConfigurationProperties[f]=o[f],delete o[f];continue}else this.configurationProperties[f]=o[f];!o[f].deprecationMessage&&o[f].markdownDeprecationMessage&&(o[f].deprecationMessage=o[f].markdownDeprecationMessage),h.push(f)}let l=D.allOf;if(l)for(let f of l)h.push(...this.validateAndRegisterProperties(f,a,P,c,t));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(D){const a=P=>{let c=P.properties;if(c)for(const h in c)this.updateSchema(h,c[h]);let t=P.allOf;t&&t.forEach(a)};a(D)}updateSchema(D,a){switch(e.allSettings.properties[D]=a,a.scope){case 1:e.applicationSettings.properties[D]=a;break;case 2:e.machineSettings.properties[D]=a;break;case 6:e.machineOverridableSettings.properties[D]=a;break;case 3:e.windowSettings.properties[D]=a;break;case 4:e.resourceSettings.properties[D]=a;break;case 5:e.resourceSettings.properties[D]=a,this.resourceLanguageSettingsSchema.properties[D]=a;break}}removeFromSchema(D,a){switch(delete e.allSettings.properties[D],a.scope){case 1:delete e.applicationSettings.properties[D];break;case 2:delete e.machineSettings.properties[D];break;case 6:delete e.machineOverridableSettings.properties[D];break;case 3:delete e.windowSettings.properties[D];break;case 4:case 5:delete e.resourceSettings.properties[D],delete this.resourceLanguageSettingsSchema.properties[D];break}}updateOverridePropertyPatternKey(){for(const D of this.overrideIdentifiers.values()){const a=`[${D}]`,P={type:"object",description:$.localize(2,null),errorMessage:$.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,P),e.allSettings.properties[a]=P,e.applicationSettings.properties[a]=P,e.machineSettings.properties[a]=P,e.machineOverridableSettings.properties[a]=P,e.windowSettings.properties[a]=P,e.resourceSettings.properties[a]=P}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const D={type:"object",description:$.localize(4,null),errorMessage:$.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(D,a){const P=this.configurationDefaultsOverrides.get(D);let c=P?.value,t=P?.source;b.isUndefined(c)&&(c=a.defaultDefaultValue,t=void 0),b.isUndefined(c)&&(c=u(a.type)),a.default=c,a.defaultValueSource=t}}const n="\\[([^\\]]+)\\]",p=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function s(d){const D=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let a=p.exec(d);for(;a?.length;){const P=a[1].trim();P&&D.push(P),a=p.exec(d)}}return(0,r.distinct)(D)}e.overrideIdentifiersFromKey=s;function i(d){return d.reduce((D,a)=>`${D}[${a}]`,"")}e.keyFromOverrideIdentifiers=i;function u(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const S=new v;O.Registry.add(e.Extensions.Configuration,S);function _(d){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?$.localize(7,null,d):S.getConfigurationProperties()[d]!==void 0?$.localize(8,null,d):null:$.localize(6,null)}e.validateProperty=_;function w(){const d=[],D=S.getConfigurationProperties();for(const a of Object.keys(D))d.push([a,D[a].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=w}),define(Ee[142],be([1,0,16,5,100,6,22,26,13,2,75,78,37]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(c={},t=[],h=[]){this._contents=c,this._keys=t,this._overrides=h,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(c){return c?(0,N.getConfigurationValue)(this.contents,c):this.contents}getOverrideValue(c,t){const h=this.getContentsForOverrideIdentifer(t);return h?c?(0,N.getConfigurationValue)(h,c):h:void 0}getKeysForOverrideIdentifier(c){const t=[];for(const h of this.overrides)h.identifiers.includes(c)&&t.push(...h.keys);return r.distinct(t)}getAllOverrideIdentifiers(){const c=[];for(const t of this.overrides)c.push(...t.identifiers);return r.distinct(c)}override(c){let t=this.overrideConfigurations.get(c);return t||(t=this.createOverrideConfigurationModel(c),this.overrideConfigurations.set(c,t)),t}merge(...c){const t=O.deepClone(this.contents),h=O.deepClone(this.overrides),o=[...this.keys];for(const l of c){this.mergeContents(t,l.contents);for(const f of l.overrides){const[m]=h.filter(E=>r.equals(E.identifiers,f.identifiers));m?(this.mergeContents(m.contents,f.contents),m.keys.push(...f.keys),m.keys=r.distinct(m.keys)):h.push(O.deepClone(f))}for(const f of l.keys)o.indexOf(f)===-1&&o.push(f)}return new p(t,o,h)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(c){const t=this.getContentsForOverrideIdentifer(c);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let h={};for(const o of r.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[o],f=t[o];f&&(typeof l=="object"&&typeof f=="object"?(l=O.deepClone(l),this.mergeContents(l,f)):l=f),h[o]=l}return new p(h,this.keys,this.overrides)}mergeContents(c,t){for(const h of Object.keys(t)){if(h in c&&I.isObject(c[h])&&I.isObject(t[h])){this.mergeContents(c[h],t[h]);continue}c[h]=O.deepClone(t[h])}}checkAndFreeze(c){return this.isFrozen&&!Object.isFrozen(c)?O.deepFreeze(c):c}getContentsForOverrideIdentifer(c){let t=null,h=null;const o=l=>{l&&(h?this.mergeContents(h,l):h=O.deepClone(l))};for(const l of this.overrides)r.equals(l.identifiers,[c])?t=l.contents:l.identifiers.includes(c)&&o(l.contents);return o(t),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(c,t){this.addKey(c),(0,N.addToValueTree)(this.contents,c,t,h=>{throw new Error(h)})}removeValue(c){this.removeKey(c)&&(0,N.removeFromValueTree)(this.contents,c)}addKey(c){let t=this.keys.length;for(let h=0;h<t;h++)c.indexOf(this.keys[h])===0&&(t=h);this.keys.splice(t,1,c)}removeKey(c){let t=this.keys.indexOf(c);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class s extends p{constructor(c={}){const t=n.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(t),o=Object.create(null),l=[];for(const f in t){const m=c[f],E=m!==void 0?m:t[f].default;(0,N.addToValueTree)(o,f,E,T=>console.error(`Conflict in default settings: ${T}`))}for(const f of Object.keys(o))v.OVERRIDE_PROPERTY_REGEX.test(f)&&l.push({identifiers:(0,v.overrideIdentifiersFromKey)(f),keys:Object.keys(o[f]),contents:(0,N.toValuesTree)(o[f],m=>console.error(`Conflict in default settings file: ${m}`))});super(o,h,l)}}e.DefaultConfigurationModel=s;class i{constructor(c){this._name=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(c,t){if(!I.isUndefinedOrNull(c)){const h=this.doParseContent(c);this.parseRaw(h,t)}}reparse(c){this._raw&&this.parseRaw(this._raw,c)}parseRaw(c,t){this._raw=c;const{contents:h,keys:o,overrides:l,restricted:f}=this.doParseRaw(c,t);this._configurationModel=new p(h,o,l),this._restrictedConfigurations=f||[]}doParseContent(c){let t={},h=null,o=[],l=[],f=[];function m(T){Array.isArray(o)?o.push(T):h!==null&&(o[h]=T)}let E={onObjectBegin:()=>{let T={};m(T),l.push(o),o=T,h=null},onObjectProperty:T=>{h=T},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{let T=[];m(T),l.push(o),o=T,h=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:m,onError:(T,A,x)=>{f.push({error:T,offset:A,length:x})}};if(c)try{b.visit(c,E),t=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return t}doParseRaw(c,t){const h=n.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),o=this.filter(c,h,!0,t);c=o.raw;const l=(0,N.toValuesTree)(c,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),f=Object.keys(c),m=this.toOverrides(c,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:l,keys:f,overrides:m,restricted:o.restricted}}filter(c,t,h,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:c,restricted:[]};const l={},f=[];for(let m in c)if(v.OVERRIDE_PROPERTY_REGEX.test(m)&&h){const E=this.filter(c[m],t,!1,o);l[m]=E.raw,f.push(...E.restricted)}else{const E=t[m],T=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&f.push(m),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&(o.skipRestricted&&E?.restricted||(l[m]=c[m]))}return{raw:l,restricted:f}}toOverrides(c,t){const h=[];for(const o of Object.keys(c))if(v.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const f in c[o])l[f]=c[o][f];h.push({identifiers:(0,v.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,N.toValuesTree)(l,t)})}return h}}e.ConfigurationModelParser=i;class u extends $.Disposable{constructor(c,t,h,o){super();this.userSettingsResource=c,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new i(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(h.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const c=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(c.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=u;class S{constructor(c,t,h=new p,o=new p,l=new y.ResourceMap,f=new p,m=new y.ResourceMap,E=!0){this._defaultConfiguration=c,this._localUserConfiguration=t,this._remoteUserConfiguration=h,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(c,t,h){return this.getConsolidateConfigurationModel(t,h).getValue(c)}updateValue(c,t,h={}){let o;h.resource?(o=this._memoryConfigurationByResource.get(h.resource),o||(o=new p,this._memoryConfigurationByResource.set(h.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(c):o.setValue(c,t),h.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(c,t,h){const o=this.getConsolidateConfigurationModel(t,h),l=this.getFolderConfigurationModelForResource(t.resource,h),f=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,m=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(c):this._defaultConfiguration.freeze().getValue(c),E=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(c):this.userConfiguration.freeze().getValue(c),T=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(c):this.localUserConfiguration.freeze().getValue(c),A=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(c):this.remoteUserConfiguration.freeze().getValue(c),x=h?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(c):this._workspaceConfiguration.freeze().getValue(c):void 0,g=l?t.overrideIdentifier?l.freeze().override(t.overrideIdentifier).getValue(c):l.freeze().getValue(c):void 0,U=t.overrideIdentifier?f.override(t.overrideIdentifier).getValue(c):f.getValue(c),z=o.getValue(c),q=r.distinct(r.flatten(o.overrides.map(j=>j.identifiers))).filter(j=>o.getOverrideValue(c,j)!==void 0);return{defaultValue:m,userValue:E,userLocalValue:T,userRemoteValue:A,workspaceValue:x,workspaceFolderValue:g,memoryValue:U,value:z,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(c),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(c),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(c),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(c),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(c),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,workspaceFolder:g!==void 0?{value:l?.freeze().getValue(c),override:t.overrideIdentifier?l?.freeze().getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:f.getValue(c),override:t.overrideIdentifier?f.getOverrideValue(c,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(c){const t=this.getFolderConfigurationModelForResource(void 0,c);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(c){this._defaultConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(c){this._localUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(c){this._remoteUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(c){this._workspaceConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(c,t){this._folderConfigurations.set(c,t),this._foldersConsolidatedConfigurations.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this._foldersConsolidatedConfigurations.delete(c)}compareAndUpdateDefaultConfiguration(c,t){const h=[];if(!t){const{added:o,updated:l,removed:f}=D(this._defaultConfiguration,c);t=[...o,...l,...f]}for(const o of t)for(const l of(0,v.overrideIdentifiersFromKey)(o)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(l),m=c.getKeysForOverrideIdentifier(l),E=[...m.filter(T=>f.indexOf(T)===-1),...f.filter(T=>m.indexOf(T)===-1),...f.filter(T=>!O.equals(this._defaultConfiguration.override(l).getValue(T),c.override(l).getValue(T)))];h.push([l,E])}return this.updateDefaultConfiguration(c),{keys:t,overrides:h}}compareAndUpdateLocalUserConfiguration(c){const{added:t,updated:h,removed:o,overrides:l}=D(this.localUserConfiguration,c),f=[...t,...h,...o];return f.length&&this.updateLocalUserConfiguration(c),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(c){const{added:t,updated:h,removed:o,overrides:l}=D(this.remoteUserConfiguration,c);let f=[...t,...h,...o];return f.length&&this.updateRemoteUserConfiguration(c),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(c){const{added:t,updated:h,removed:o,overrides:l}=D(this.workspaceConfiguration,c);let f=[...t,...h,...o];return f.length&&this.updateWorkspaceConfiguration(c),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(c,t){const h=this.folderConfigurations.get(c),{added:o,updated:l,removed:f,overrides:m}=D(h,t);let E=[...o,...l,...f];return(E.length||!h)&&this.updateFolderConfiguration(c,t),{keys:E,overrides:m}}compareAndDeleteFolderConfiguration(c){const t=this.folderConfigurations.get(c);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:h,updated:o,removed:l,overrides:f}=D(t,void 0);return{keys:[...h,...o,...l],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(c,t){let h=this.getConsolidatedConfigurationModelForResource(c,t);return c.overrideIdentifier?h.override(c.overrideIdentifier):h}getConsolidatedConfigurationModelForResource({resource:c},t){let h=this.getWorkspaceConsolidatedConfiguration();if(t&&c){const o=t.getFolder(c);o&&(h=this.getFolderConsolidatedConfiguration(o.uri)||h);const l=this._memoryConfigurationByResource.get(c);l&&(h=h.merge(l))}return h}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(c){let t=this._foldersConsolidatedConfigurations.get(c);if(!t){const h=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(c);o?(t=h.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(c,t)):t=h}return t}getFolderConfigurationModelForResource(c,t){if(t&&c){const h=t.getFolder(c);if(h)return this._folderConfigurations.get(h.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((c,t)=>{const{contents:h,overrides:o,keys:l}=this._folderConfigurations.get(t);return c.push([t,{contents:h,overrides:o,keys:l}]),c},[])}}allKeys(){const c=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>c.add(t)),this.userConfiguration.freeze().keys.forEach(t=>c.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>c.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(h=>c.add(h))),[...c.values()]}allOverrideIdentifiers(){const c=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>c.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>c.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>c.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(h=>c.add(h))),[...c.values()]}getAllKeysForOverrideIdentifier(c){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(c).forEach(h=>t.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(h=>t.add(h)),this._workspaceConfiguration.getKeysForOverrideIdentifier(c).forEach(h=>t.add(h)),this._folderConfigurations.forEach(h=>h.getKeysForOverrideIdentifier(c).forEach(o=>t.add(o))),[...t.values()]}static parse(c){const t=this.parseConfigurationModel(c.defaults),h=this.parseConfigurationModel(c.user),o=this.parseConfigurationModel(c.workspace),l=c.folders.reduce((f,m)=>(f.set(R.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new y.ResourceMap);return new S(t,h,new p,o,l,new p,new y.ResourceMap,!1)}static parseConfigurationModel(c){return new p(c.contents,c.keys,c.overrides).freeze()}}e.Configuration=S;function _(...P){if(P.length===0)return{keys:[],overrides:[]};if(P.length===1)return P[0];const c=new Set,t=new Map;for(const o of P)o.keys.forEach(l=>c.add(l)),o.overrides.forEach(([l,f])=>{const m=(0,y.getOrSet)(t,l,new Set);f.forEach(E=>m.add(E))});const h=[];return t.forEach((o,l)=>h.push([l,[...o.values()]])),{keys:[...c.values()],overrides:h}}e.mergeChanges=_;class w{constructor(c,t,h,o){this.change=c,this.previous=t,this.currentConfiguraiton=h,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;c.keys.forEach(m=>l.add(m)),c.overrides.forEach(([,m])=>m.forEach(E=>l.add(E))),this.affectedKeys=[...l.values()];const f=new p;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(c,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,c)){if(t){const h=this.previousConfiguration?this.previousConfiguration.getValue(c,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(c,t,this.currentWorkspace);return!O.equals(h,o)}return!0}return!1}doesAffectedKeysTreeContains(c,t){let h=(0,N.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof h=="object"&&(o=Object.keys(h)[0]);){if(c=c[o],!c)return!1;h=h[o]}return!0}}e.ConfigurationChangeEvent=w;class d extends w{constructor(c,t,h,o){super({keys:c.allKeys(),overrides:[]},void 0,c,t);this.source=h,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=d;function D(P,c){const{added:t,removed:h,updated:o}=a(c,P),l=[],f=P?.getAllOverrideIdentifiers()||[],m=c?.getAllOverrideIdentifiers()||[];if(c){const E=m.filter(T=>!f.includes(T));for(const T of E)l.push([T,c.getKeysForOverrideIdentifier(T)])}if(P){const E=f.filter(T=>!m.includes(T));for(const T of E)l.push([T,P.getKeysForOverrideIdentifier(T)])}if(c&&P){for(const E of f)if(m.includes(E)){const T=a({contents:P.getOverrideValue(void 0,E)||{},keys:P.getKeysForOverrideIdentifier(E)},{contents:c.getOverrideValue(void 0,E)||{},keys:c.getKeysForOverrideIdentifier(E)});l.push([E,[...T.added,...T.removed,...T.updated]])}}return{added:t,removed:h,updated:o,overrides:l}}function a(P,c){const t=P?c?P.keys.filter(l=>c.keys.indexOf(l)===-1):[...P.keys]:[],h=c?P?c.keys.filter(l=>P.keys.indexOf(l)===-1):[...c.keys]:[],o=[];if(P&&c){for(const l of c.keys)if(P.keys.indexOf(l)!==-1){const f=(0,N.getConfigurationValue)(c.contents,l),m=(0,N.getConfigurationValue)(P.contents,l);O.equals(f,m)||o.push(l)}}return{added:t,removed:h,updated:o}}}),define(Ee[79],be([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var k;(function($){$.Unknown="Unknown",$.NotAvailable="NotAvailable",$.TemporarilyNotAvailable="TemporarilyNotAvailable",$.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(y,O=k.Unknown,I){super(y);this._message=y,this._code=O,this._detail=I,this.isHandled=O===k.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(y){return y instanceof b&&y._code===k.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof b&&y._code===k.NoResolverFound}static isHandled(y){return y instanceof b&&y.isHandled}}e.RemoteAuthorityResolverError=b}),define(Ee[80],be([1,0,9]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function k($){return $.scheme===r.Schemas.vscodeRemote?$.authority:void 0}e.getRemoteAuthority=k;function b($){if(!$)return;const y=$.indexOf("+");return y<0?$:$.substr(0,y)}e.getRemoteName=b}),define(Ee[25],be([1,0,10,3,80]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function $(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=$;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));class I{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,s){if(typeof p=="undefined"||p===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof p=="string"||typeof s=="string"){let i=typeof p=="string"?p:p.value,u=typeof s=="string"?s:s.value;return r.equalsIgnoreCase(i,u)}return p._lower===s._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=I;function R(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function N(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=N;function v(n,p){if(p){const s=`onResolveRemoteAuthority:${(0,b.getRemoteName)(p)}`;return n.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[143],be([1,0,10,25]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,r.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=b;class ${constructor(i,u){this.version=u,this.id=i.id,this.uuid=i.uuid}key(){return`${this.id}-${this.version}`}equals(i){return i instanceof $?b(this,i)&&this.version===i.version:!1}}e.ExtensionIdentifierWithVersion=$;function y(s,i){return`${s}.${i}`}e.getExtensionId=y;function O(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=O;function I(s,i){return O(y(s,i))}e.getGalleryExtensionId=I;function R(s,i){const u=[],S=_=>{for(const w of u)if(w.some(d=>b(i(d),i(_))))return w;return null};for(const _ of s){const w=S(_);w?w.push(_):u.push([_])}return u}e.groupByExtension=R;function N(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=N;function v(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function n(s){const i=new Set;if(s.malicious)for(const u of s.malicious)i.add(u.id);return i}e.getMaliciousExtensionsSet=n;function p(s,i){const u=[],S=i.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const _=S.shift();if(_&&u.every(w=>!b(w.identifier,{id:_}))){const w=s.filter(d=>b(d.identifier,{id:_}));w.length===1&&(u.push(w[0]),S.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=p}),define(Ee[144],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,$,y=5){let O;return O=$(I=>{const R=typeof I=="string"?I:I.data;let N=this._terminalBufferMap.get(b);if(N){N.data.push(R);return}const v=setTimeout(()=>this.flushBuffer(b),y);N={data:[R],timeoutId:v,dispose:()=>{clearTimeout(v),this.flushBuffer(b),O.dispose()}},this._terminalBufferMap.set(b,N)}),O}stopBuffering(b){const $=this._terminalBufferMap.get(b);$&&$.dispose()}flushBuffer(b){const $=this._terminalBufferMap.get(b);$&&(this._terminalBufferMap.delete(b),this._callback(b,$.data.join("")))}}e.TerminalDataBufferer=r}),define(Ee[145],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var r;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(r=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[56],be([1,0,106,5,6,3,37,145]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,$.createDecorator)("themeService");var I;(function(u){function S(_){return _&&typeof _=="object"&&typeof _.id=="string"}u.isThemeColor=S})(I=e.ThemeColor||(e.ThemeColor={}));function R(u){return{id:u}}e.themeColorFromId=R;var N;(function(u){function S(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||I.isThemeColor(t.color))}u.isThemeIcon=S;const _=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function w(t){const h=_.exec(t);if(!h)return;let[,o]=h;return{id:o}}u.fromString=w;function d(t){return{id:t}}u.fromId=d;function D(t,h){let o=t.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),h&&(o=`${o}~${h}`),{id:o}}u.modify=D;function a(t){const h=t.id.lastIndexOf("~");if(h!==-1)return t.id.substring(h+1)}u.getModifier=a;function P(t,h){return t.id===h.id&&t.color?.id===h.color?.id}u.isEqual=P;function c(t,h){return{id:t.id,color:h?R(h):void 0}}u.asThemeIcon=c,u.asClassNameArray=r.CSSIcon.asClassNameArray,u.asClassName=r.CSSIcon.asClassName,u.asCSSSelector=r.CSSIcon.asCSSSelector})(N=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function v(u){switch(u){case O.ColorScheme.DARK:return"vs-dark";case O.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=v,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,b.toDisposable)(()=>{const _=this.themingParticipants.indexOf(S);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new n;y.Registry.add(e.Extensions.ThemingContribution,p);function s(u){return p.onColorThemeChange(u)}e.registerThemingParticipant=s;class i extends b.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,_){let w=this.theme.getColor(S);return w&&_&&(w=_(w,this.theme)),w?w.toString():null}}e.Themable=i}),define(Ee[146],be([1,0,5,23,3,12]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var y;(function(s){s.Http="http",s.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var O;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(O=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!i)return{address:i[1],port:+i[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=v;function n(s,i){return i?i!==1&&s<1024:!k.isWindows&&s<1024}e.isPortPrivileged=n;let p=class{constructor(i){this.logService=i,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],u=Array.from(this._tunnels.values());for(let S of u){const _=Array.from(S.values());for(let w of _){const d=await w.value;d&&i.push(d)}}return i}async dispose(){for(const i of this._tunnels.values()){for(const{value:u}of i.values())await u.then(S=>S?.dispose());i.clear()}this._tunnels.clear()}openTunnel(i,u,S,_,w=!1,d=O.Private,D){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${S} on local port ${_}.`),!i)return;u||(u="localhost");const a=this.retainOrCreateTunnel(i,u,S,_,w,d,D);return a?a.then(P=>{if(!P){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.makeTunnel(P);return(P.tunnelRemoteHost!==u||P.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(c),c}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const u=this._tunnels.get(i.tunnelRemoteHost);if(u){const S=u.get(i.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,S))}}}}async tryDisposeTunnel(i,u,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${u}.`);const _=S.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(u),_}}async closeTunnel(i,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${u} `);const S=this._tunnels.get(i);if(S&&S.has(u)){const _=S.get(u);_.refcount=0,await this.tryDisposeTunnel(i,u,_)}}addTunnelToMap(i,u,S){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(u,{refcount:1,value:S})}async removeEmptyTunnelFromMap(i,u){const S=this._tunnels.get(i);S&&(await S.get(u)||S.delete(u),S.size===0&&this._tunnels.delete(i))}getTunnelFromMap(i,u){let S=[i];N(i)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):v(i)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const _=S.map(w=>this._tunnels.get(w));for(const w of _){const d=w?.get(u);if(d)return d}}canTunnel(i){return!!R(i)}createWithProvider(i,u,S,_,w,d,D){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${S} on local port ${_}.`);const P={elevationRequired:w?n(_===void 0?S:_):!1},c={remoteAddress:{host:u,port:S},localAddressPort:_,privacy:d,public:d!==O.Private,protocol:D},t=i.forwardPort(c,P);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(u,S,t),t}};p=Fe([Ne(0,$.ILogService)],p),e.AbstractTunnelService=p}),define(Ee[147],be([1,0,9]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function k(O){return O.scheme!==r.Schemas.file&&O.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=k;function b(O){if(O.folders.length)return O.folders.every(I=>k(I.uri))?O.folders[0].uri:void 0;if(O.configuration&&k(O.configuration))return O.configuration}e.getVirtualWorkspaceLocation=b;function $(O){return b(O)?.scheme}e.getVirtualWorkspaceScheme=$;function y(O){return b(O)!==void 0}e.isVirtualWorkspace=y}),define(Ee[47],be([1,0,22,24,2,3]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,$.createDecorator)("contextService");var y;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function O(n){const p=n;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=O;function I(n){const p=n;return!!(p&&typeof p=="object"&&b.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=I;class R{constructor(p,s,i,u,S){this._id=p,this._transient=i,this._configuration=u,this._ignorePathCasing=S,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=R;class N{constructor(p,s){this.raw=s,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,k.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=N;function v(n){return new N({uri:n,index:0,name:(0,k.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=v}),define(Ee[57],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const $=this._idPool++;return this._data.set($,b),this.logDebugInfo(),$}get(b,$){return this._data.has(b)?this._data.get(b)[$]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(Ee[30],be([1,0,9,24,3]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class ${constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new k.ExtUri(O=>{const I=this._providerInfo.get(O.scheme);return!(I===void 0||I&1024)})}$acceptProviderInfos(O,I){I===null?this._providerInfo.delete(O.scheme):this._providerInfo.set(O.scheme,I)}isFreeScheme(O){return!this._providerInfo.has(O)&&!this._systemSchemes.has(O)}getCapabilities(O){return this._providerInfo.get(O)}}e.ExtHostFileSystemInfo=$,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],be([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ee[148],be([1,0,11]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(y,O,I){this._deferredPromises=new Map,this._id=y,this._shared=O,this._storage=I,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const N of R.values())N.complete()}catch(N){for(const v of R.values())v.error(N)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,O){let I=this._value[y];return typeof I=="undefined"&&(I=O),I}update(y,O){this._value[y]=O;let I=this._deferredPromises.get(y);if(I!==void 0)return I.p;const R=new r.DeferredPromise;return this._deferredPromises.set(y,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=k;class b extends k{constructor(y,O){super(y.identifier.value,!0,O);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=b}),define(Ee[149],be([1,0,5,2,12]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let $=class{constructor(O,I){this._logService=O,this._notebooksAndEditors=I,this._onDidChangeNotebookDocumentMetadata=new r.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(O,I,R){this._notebooksAndEditors.getNotebookDocument(k.URI.revive(O)).acceptModelChanged(I.value,R)}$acceptDirtyStateChanged(O,I){this._notebooksAndEditors.getNotebookDocument(k.URI.revive(O)).acceptDirty(I)}$acceptModelSaved(O){const I=this._notebooksAndEditors.getNotebookDocument(k.URI.revive(O));this._onDidSaveNotebookDocument.fire(I.apiNotebook)}$acceptDocumentPropertiesChanged(O,I){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",O.path,I);const R=this._notebooksAndEditors.getNotebookDocument(k.URI.revive(O));R.acceptDocumentPropertiesChanged(I),I.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};$=Fe([Ne(0,b.ILogService)],$),e.ExtHostNotebookDocuments=$}),define(Ee[14],be([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class k{constructor($){this.getProxy=$.getProxy.bind($),this.set=$.set.bind($),this.assertRegistered=$.assertRegistered.bind($),this.drain=$.drain.bind($)}}e.ExtHostRpcService=k});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[150],be([1,0,25,5]),function(Y,e,r,k){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class ${constructor(O,I){b.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(O.identifier),je(this,b,I,"f"),De(this,b,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(O){return De(this,b,"f").get(this._id,O)}store(O,I){return De(this,b,"f").store(this._id,O,I)}delete(O){return De(this,b,"f").delete(this._id,O)}}e.ExtensionSecrets=$,b=new WeakMap}),define(Ee[81],be([1,0,3,5]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new k.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new k.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(y){this._level=y}$onDidChangeTelemetryLevel(y){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=y,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ee[48],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var r;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(r=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const k=new WeakMap,b=(_,w)=>{const d={controllerId:w};return k.set(_,d),d};e.createPrivateApiFor=b;const $=_=>k.get(_);e.getPrivateApiFor=$;const y=(_,w,d,D)=>{let a=d;return{enumerable:!0,configurable:!1,get(){return a},set(P){if(!D(a,P)){const c=a;a=P,_.listener?.({op:3,key:w,value:P,previous:c})}}}},O=(_,w)=>_===w,I={range:(_,w)=>_===w?!0:!_||!w?!1:_.isEqual(w),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(_,w)=>!(_.length!==w.length||_.some(d=>!w.find(D=>d.id===D.id)))},R=Object.keys(I),N=(_,w)=>({range:y(_,"range",void 0,I.range),label:y(_,"label",w,I.label),description:y(_,"description",void 0,I.description),sortText:y(_,"sortText",void 0,I.sortText),canResolveChildren:y(_,"canResolveChildren",!1,I.canResolveChildren),busy:y(_,"busy",!1,I.busy),error:y(_,"error",void 0,I.error),tags:y(_,"tags",[],I.tags)}),v=(_,w)=>{const d=new Map;for(const D of R)I[D](_[D],w[D])||d.set(D,w[D]);return d};e.diffTestItems=v;class n extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=n;class p extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class s extends Error{constructor(w,d,D){super(`TestItem with ID "${w}" is from controller "${d}" and cannot be added as a child of an item from controller "${D}".`)}}e.MixedTestItemController=s;const i=_=>{const w=(0,e.getPrivateApiFor)(_);let d=new Map;return{get size(){return d.size},forEach(D,a){for(const P of d.values())D.call(a,P,this)},replace(D){const a=new Map,P=new Set(d.keys()),c={op:4,ops:[]};for(const t of D){if(!(t instanceof u))throw new p(t.id);const h=(0,e.getPrivateApiFor)(t).controllerId;if(h!==w.controllerId)throw new s(t.id,h,w.controllerId);if(a.has(t.id))throw new n(t.id);a.set(t.id,t),P.delete(t.id),c.ops.push({op:0,item:t})}for(const t of P.keys())c.ops.push({op:1,id:t});w.listener?.(c),d=a},add(D){if(!(D instanceof u))throw new p(D.id);d.set(D.id,D),w.listener?.({op:0,item:D})},delete(D){d.delete(D)&&w.listener?.({op:1,id:D})},get(D){return d.get(D)},toJSON(){return Array.from(d.values())},[Symbol.iterator](){return d.values()}}};class u{constructor(w,d,D,a){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const P=(0,e.createPrivateApiFor)(this,w);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return P.parent instanceof S?void 0:P.parent}},children:{value:i(this),enumerable:!0,writable:!1},...N(P,D)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=u;class S extends u{constructor(w,d){super(w,w,d,void 0)}}e.TestItemRootImpl=S}),define(Ee[58],be([1,0,3,146,5,14]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(I){function R(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:v.protocol}}I.fromApiTunnel=R;function N(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==k.TunnelPrivacyId.ConstantPrivate&&v.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}I.fromServiceTunnel=N})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let O=class{constructor(R){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,N){}async getTunnels(){return[]}async setTunnelFactory(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,N){return{dispose:()=>{}}}async $providePortAttributes(R,N,v,n,p){return[]}async $forwardPort(R,N){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};O=Fe([Ne(0,$.IExtHostRpcService)],O),e.ExtHostTunnelService=O});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[7],be([1,0,16,15,70,22,69,10,13,2,36,46,79]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n){"use strict";var p,s,i,u,S,_,w,d,D,a,P,c,t,h,o,l,f,m,E,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(W){function B(){return Reflect.construct(W,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(W,"name")),Object.setPrototypeOf(B,W),Object.setPrototypeOf(B.prototype,W.prototype),B}let x=S=class{constructor(B){p.set(this,void 0),je(this,p,B,"f")}static from(...B){let ee=B;return new S(function(){if(ee){for(const we of ee)we&&typeof we.dispose=="function"&&we.dispose();ee=void 0}})}dispose(){typeof De(this,p,"f")=="function"&&(De(this,p,"f").call(this),je(this,p,void 0,"f"))}};p=new WeakMap,x=S=Fe([A],x),e.Disposable=x;let g=_=class{constructor(B,ee){if(B<0)throw(0,k.illegalArgument)("line must be non-negative");if(ee<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=B,this._character=ee}static Min(...B){if(B.length===0)throw new TypeError;let ee=B[0];for(let we=1;we<B.length;we++){const He=B[we];He.isBefore(ee)&&(ee=He)}return ee}static Max(...B){if(B.length===0)throw new TypeError;let ee=B[0];for(let we=1;we<B.length;we++){const He=B[we];He.isAfter(ee)&&(ee=He)}return ee}static isPosition(B){if(!B)return!1;if(B instanceof _)return!0;let{line:ee,character:we}=B;return typeof ee=="number"&&typeof we=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,ee=0){if(B===null||ee===null)throw(0,k.illegalArgument)();let we;return typeof B=="undefined"?we=0:typeof B=="number"?we=B:(we=typeof B.lineDelta=="number"?B.lineDelta:0,ee=typeof B.characterDelta=="number"?B.characterDelta:0),we===0&&ee===0?this:new _(this.line+we,this.character+ee)}with(B,ee=this.character){if(B===null||ee===null)throw(0,k.illegalArgument)();let we;return typeof B=="undefined"?we=this.line:typeof B=="number"?we=B:(we=typeof B.line=="number"?B.line:this.line,ee=typeof B.character=="number"?B.character:this.character),we===this.line&&ee===this.character?this:new _(we,ee)}toJSON(){return{line:this.line,character:this.character}}};g=_=Fe([A],g),e.Position=g;let U=w=class{constructor(B,ee,we,He){let qe,Ye;if(typeof B=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"?(qe=new g(B,ee),Ye=new g(we,He)):B instanceof g&&ee instanceof g&&(qe=B,Ye=ee),!qe||!Ye)throw new Error("Invalid arguments");qe.isBefore(Ye)?(this._start=qe,this._end=Ye):(this._start=Ye,this._end=qe)}static isRange(B){return B instanceof w?!0:B?g.isPosition(B.start)&&g.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof w?this.contains(B._start)&&this.contains(B._end):B instanceof g?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const ee=g.Max(B.start,this._start),we=g.Min(B.end,this._end);if(!ee.isAfter(we))return new w(ee,we)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const ee=g.Min(B.start,this._start),we=g.Max(B.end,this.end);return new w(ee,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,ee=this.end){if(B===null||ee===null)throw(0,k.illegalArgument)();let we;return B?g.isPosition(B)?we=B:(we=B.start||this.start,ee=B.end||this.end):we=this.start,we.isEqual(this._start)&&ee.isEqual(this.end)?this:new w(we,ee)}toJSON(){return[this.start,this.end]}};U=w=Fe([A],U),e.Range=U;let z=d=class extends U{constructor(B,ee,we,He){let qe,Ye;if(typeof B=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"?(qe=new g(B,ee),Ye=new g(we,He)):B instanceof g&&ee instanceof g&&(qe=B,Ye=ee),!qe||!Ye)throw new Error("Invalid arguments");super(qe,Ye);this._anchor=qe,this._active=Ye}static isSelection(B){return B instanceof d?!0:B?U.isRange(B)&&g.isPosition(B.anchor)&&g.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=d=Fe([A],z),e.Selection=z;class q{constructor(B,ee,we){if(typeof B!="string"||B.length===0)throw(0,k.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,k.illegalArgument)("port");if(typeof we!="undefined"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,k.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(ee),this.connectionToken=we}}e.ResolvedAuthority=q;class j extends Error{constructor(B,ee=n.RemoteAuthorityResolverErrorCode.Unknown,we){super(B);this._message=B,this._code=ee,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,j.prototype)}static NotAvailable(B,ee){return new j(B,n.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(B){return new j(B,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=j;var J;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(J=e.EndOfLine||(e.EndOfLine={}));var V;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ie=D=class{constructor(B,ee){this._range=B,this._newText=ee}static isTextEdit(B){return B instanceof D?!0:B?U.isRange(B)&&typeof B.newText=="string":!1}static replace(B,ee){return new D(B,ee)}static insert(B,ee){return D.replace(new U(B,B),ee)}static delete(B){return D.replace(B,"")}static setEndOfLine(B){const ee=new D(new U(new g(0,0),new g(0,0)),"");return ee.newEol=B,ee}get range(){return this._range}set range(B){if(B&&!U.isRange(B))throw(0,k.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,k.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,k.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ie=D=Fe([A],ie),e.TextEdit=ie;var ae;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace"})(ae=e.FileEditType||(e.FileEditType={}));let te=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,ee,we,He){this._edits.push({_type:1,from:B,to:ee,options:we,metadata:He})}createFile(B,ee,we){this._edits.push({_type:1,from:void 0,to:B,options:ee,metadata:we})}deleteFile(B,ee,we){this._edits.push({_type:1,from:B,to:void 0,options:ee,metadata:we})}replaceNotebookMetadata(B,ee,we){this._edits.push({_type:3,metadata:we,uri:B,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(B,ee,we,He,qe){let Ye,Ze,_t=[],At;if(Qt.isNotebookRange(ee)&&Ht.isNotebookCellDataArray(we)&&!Ht.isNotebookCellDataArray(He)?(Ye=ee.start,Ze=ee.end,_t=we,At=He):typeof ee=="number"&&typeof we=="number"&&Ht.isNotebookCellDataArray(He)&&(Ye=ee,Ze=we,_t=He,At=qe),Ye===void 0||Ze===void 0)throw new Error("Invalid arguments");(Ye!==Ze||_t.length>0)&&this._edits.push({_type:5,uri:B,index:Ye,count:Ze-Ye,cells:_t,metadata:At})}replaceNotebookCellMetadata(B,ee,we,He){this._edits.push({_type:3,metadata:He,uri:B,edit:{editType:8,index:ee,metadata:we}})}replace(B,ee,we,He){this._edits.push({_type:2,uri:B,edit:new ie(ee,we),metadata:He})}insert(B,ee,we,He){this.replace(B,new U(ee,ee),we,He)}delete(B,ee,we){this.replace(B,ee,"",we)}has(B){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===B.toString())}set(B,ee){if(ee)for(const we of ee)we&&this._edits.push({_type:2,uri:B,edit:we});else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];He._type===2&&He.uri.toString()===B.toString()&&(this._edits[we]=void 0)}(0,r.coalesceInPlace)(this._edits)}}get(B){const ee=[];for(let we of this._edits)we._type===2&&we.uri.toString()===B.toString()&&ee.push(we.edit);return ee}entries(){const B=new $.ResourceMap;for(let ee of this._edits)if(ee._type===2){let we=B.get(ee.uri);we||(we=[ee.uri,[]],B.set(ee.uri,we)),we[1].push(ee.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};te=Fe([A],te),e.WorkspaceEdit=te;let ue=a=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof a?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=a._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,ee=this._tabstop++){if(typeof B=="function"){const we=new a;we._tabstop=this._tabstop,B(we),this._tabstop=we._tabstop,B=we.value}else B=a._escape(B);return this.value+="${",this.value+=ee,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,ee=this._tabstop++){const we=B.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(B,ee){if(typeof ee=="function"){const we=new a;we._tabstop=this._tabstop,ee(we),this._tabstop=we._tabstop,ee=we.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};ue=a=Fe([A],ue),e.SnippetString=ue;var fe;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(fe=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ge=P=class{constructor(B,ee){if(this.uri=B,ee)if(ee instanceof U)this.range=ee;else if(ee instanceof g)this.range=new U(ee,ee);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof P?!0:B?U.isRange(B.range)&&R.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ge=P=Fe([A],ge),e.Location=ge;let ne=class{constructor(B,ee){this.location=B,this.message=ee}static is(B){return B?typeof B.message=="string"&&B.location&&U.isRange(B.location.range)&&R.URI.isUri(B.location.uri):!1}static isEqual(B,ee){return B===ee?!0:!B||!ee?!1:B.message===ee.message&&B.location.range.isEqual(ee.location.range)&&B.location.uri.toString()===ee.location.uri.toString()}};ne=Fe([A],ne),e.DiagnosticRelatedInformation=ne;let me=class{constructor(B,ee,we=Se.Error){if(!U.isRange(B))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=B,this.message=ee,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,ee){return B===ee?!0:!B||!ee?!1:B.message===ee.message&&B.severity===ee.severity&&B.code===ee.code&&B.severity===ee.severity&&B.source===ee.source&&B.range.isEqual(ee.range)&&(0,r.equals)(B.tags,ee.tags)&&(0,r.equals)(B.relatedInformation,ee.relatedInformation,ne.isEqual)}};me=Fe([A],me),e.Diagnostic=me;let Ie=class{constructor(B,ee){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=ee}};Ie=Fe([A],Ie),e.Hover=Ie;var Ae;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(Ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ue=class{constructor(B,ee=Ae.Text){this.range=B,this.kind=ee}toJSON(){return{range:this.range,kind:Ae[this.kind]}}};Ue=Fe([A],Ue),e.DocumentHighlight=Ue;var Ke;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(Ke=e.SymbolKind||(e.SymbolKind={}));var pe;(function(W){W[W.Deprecated=1]="Deprecated"})(pe=e.SymbolTag||(e.SymbolTag={}));let de=c=class{constructor(B,ee,we,He,qe){this.name=B,this.kind=ee,this.containerName=qe,typeof we=="string"&&(this.containerName=we),He instanceof ge?this.location=He:we instanceof U&&(this.location=new ge(He,we)),c.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ke[this.kind],location:this.location,containerName:this.containerName}}};de=c=Fe([A],de),e.SymbolInformation=de;let L=t=class{constructor(B,ee,we,He,qe){this.name=B,this.detail=ee,this.kind=we,this.range=He,this.selectionRange=qe,this.children=[],t.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(t.validate)}};L=t=Fe([A],L),e.DocumentSymbol=L;var F;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(F=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let C=class{constructor(B,ee){this.title=B,this.kind=ee}};C=Fe([A],C),e.CodeAction=C;let M=h=class{constructor(B){this.value=B}append(B){return new h(this.value?this.value+h.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+h.sep)}};M.sep=".",M=h=Fe([A],M),e.CodeActionKind=M,M.Empty=new M(""),M.QuickFix=M.Empty.append("quickfix"),M.Refactor=M.Empty.append("refactor"),M.RefactorExtract=M.Refactor.append("extract"),M.RefactorInline=M.Refactor.append("inline"),M.RefactorRewrite=M.Refactor.append("rewrite"),M.Source=M.Empty.append("source"),M.SourceOrganizeImports=M.Source.append("organizeImports"),M.SourceFixAll=M.Source.append("fixAll");let H=class{constructor(B,ee){if(this.range=B,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};H=Fe([A],H),e.SelectionRange=H;class X{constructor(B,ee,we,He,qe,Ye){this.kind=B,this.name=ee,this.detail=we,this.uri=He,this.range=qe,this.selectionRange=Ye}}e.CallHierarchyItem=X;class re{constructor(B,ee){this.fromRanges=ee,this.from=B}}e.CallHierarchyIncomingCall=re;class ve{constructor(B,ee){this.fromRanges=ee,this.to=B}}e.CallHierarchyOutgoingCall=ve;var ke;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(ke=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Me=class{constructor(B,ee){this.range=B,this.command=ee}get isResolved(){return!!this.command}};Me=Fe([A],Me),e.CodeLens=Me;let Le=o=class{constructor(B,ee=!1){s.set(this,void 0),je(this,s,new b.MarkdownString(B,{supportThemeIcons:ee}),"f")}static isMarkdownString(B){return B instanceof o?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return De(this,s,"f").value}set value(B){De(this,s,"f").value=B}get isTrusted(){return De(this,s,"f").isTrusted}set isTrusted(B){De(this,s,"f").isTrusted=B}get supportThemeIcons(){return De(this,s,"f").supportThemeIcons}set supportThemeIcons(B){De(this,s,"f").supportThemeIcons=B}get supportHtml(){return De(this,s,"f").supportHtml}set supportHtml(B){De(this,s,"f").supportHtml=B}get baseUri(){return De(this,s,"f").baseUri}set baseUri(B){De(this,s,"f").baseUri=B}appendText(B){return De(this,s,"f").appendText(B),this}appendMarkdown(B){return De(this,s,"f").appendMarkdown(B),this}appendCodeblock(B,ee){return De(this,s,"f").appendCodeblock(ee??"",B),this}};s=new WeakMap,Le=o=Fe([A],Le),e.MarkdownString=Le;let ze=class{constructor(B,ee){this.label=B,this.documentation=ee}};ze=Fe([A],ze),e.ParameterInformation=ze;let Be=class{constructor(B,ee){this.label=B,this.documentation=ee,this.parameters=[]}};Be=Fe([A],Be),e.SignatureInformation=Be;let Oe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Oe=Fe([A],Oe),e.SignatureHelp=Oe;var Xe;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(Xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var tt;(function(W){W[W.Other=0]="Other",W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(tt=e.InlayHintKind||(e.InlayHintKind={}));let Te=class{constructor(B){this.label=B}};Te=Fe([A],Te),e.InlayHintLabelPart=Te;let et=class{constructor(B,ee,we){this.label=B,this.position=ee,this.kind=we}};et=Fe([A],et),e.InlayHint=et;var G;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(G=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(W){W[W.Deprecated=1]="Deprecated"})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));let Re=class{constructor(B,ee){this.label=B,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Re=Fe([A],Re),e.CompletionItem=Re;let xe=class{constructor(B=[],ee=!1){this.items=B,this.isIncomplete=ee}};xe=Fe([A],xe),e.CompletionList=xe;let Ge=class{constructor(B,ee,we){this.text=B,this.range=ee,this.command=we}};Ge=Fe([A],Ge),e.InlineSuggestion=Ge;let Je=class{constructor(B){this.items=B}};Je=Fe([A],Je),e.InlineSuggestions=Je;var at;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(at=e.ViewColumn||(e.ViewColumn={}));var yt;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(yt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Dt;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(Dt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ve;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var gt;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(gt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Nt;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(Nt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var it;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(it=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function B(ee){switch(ee){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=B}(gt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ot=class{constructor(B,ee){if(ee&&!R.URI.isUri(ee))throw(0,k.illegalArgument)("target");if(!U.isRange(B)||B.isEmpty)throw(0,k.illegalArgument)("range");this.range=B,this.target=ee}};ot=Fe([A],ot),e.DocumentLink=ot;let It=class{constructor(B,ee,we,He){this.red=B,this.green=ee,this.blue=we,this.alpha=He}};It=Fe([A],It),e.Color=It;let Pt=class{constructor(B,ee){if(ee&&!(ee instanceof It))throw(0,k.illegalArgument)("color");if(!U.isRange(B)||B.isEmpty)throw(0,k.illegalArgument)("range");this.range=B,this.color=ee}};Pt=Fe([A],Pt),e.ColorInformation=Pt;let kt=class{constructor(B){if(!B||typeof B!="string")throw(0,k.illegalArgument)("label");this.label=B}};kt=Fe([A],kt),e.ColorPresentation=kt;var lt;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(lt=e.ColorFormat||(e.ColorFormat={}));var Ft;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(Ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Lt{constructor(B,ee,we){if(this.startIndex=B,this.length=ee,this.tooltip=we,typeof B!="number"||B<0)throw(0,k.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,k.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=Lt;var he;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(he=e.TerminalLocation||(e.TerminalLocation={}));class le{constructor(B){this.options=B,typeof B!="object"&&(0,k.illegalArgument)("options")}}e.TerminalProfile=le;var oe;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(oe=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let _e=l=class{constructor(B,ee){if(this.label=ee,typeof B!="string"||typeof ee!="string")throw(0,k.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};_e.Clean=new l("clean","Clean"),_e.Build=new l("build","Build"),_e.Rebuild=new l("rebuild","Rebuild"),_e.Test=new l("test","Test"),_e=l=Fe([A],_e),e.TaskGroup=_e;function Ce(W){let B="";for(let ee=0;ee<W.length;ee++)B+=W[ee].replace(/,/g,",,")+",";return B}let $e=class{constructor(B,ee,we){if(typeof B!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=B,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=we):this._options=ee)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,k.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)B.push(ee);return Ce(B)}};$e=Fe([A],$e),e.ProcessExecution=$e;let We=class{constructor(B,ee,we){if(this._args=[],Array.isArray(ee)){if(!B)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,k.illegalArgument)("command");this._command=B,this._args=ee,this._options=we}else{if(typeof B!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=B,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,k.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)B.push(typeof ee=="string"?ee:ee.value);return Ce(B)}};We=Fe([A],We),e.ShellExecution=We;var nt;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(nt=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class wt{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=wt;let vt=f=class{constructor(B,ee,we,He,qe,Ye){this.__deprecated=!1,this._definition=this.definition=B;let Ze;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=we,this.execution=He,Ze=qe,this.__deprecated=!0):ee===pt.Global||ee===pt.Workspace?(this.target=ee,this._name=this.name=we,this._source=this.source=He,this.execution=qe,Ze=Ye):(this.target=ee,this._name=this.name=we,this._source=this.source=He,this.execution=qe,Ze=Ye),typeof Ze=="string"?(this._problemMatchers=[Ze],this._hasDefinedMatchers=!0):Array.isArray(Ze)?(this._problemMatchers=Ze,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof $e?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,N.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const ee=this._definition.type;(f.EmptyType===ee||f.ProcessType===ee||f.ShellType===ee||f.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=f=Fe([A],vt),e.Task=vt;var dt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let rt=class{constructor(B,ee=Et.None){this.collapsibleState=ee,R.URI.isUri(B)?this.resourceUri=B:this.label=B}};rt=Fe([A],rt),e.TreeItem=rt;var Et;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ft=class{constructor(B){this.value=B}async asString(){return JSON.stringify(this.value)}};ft=Fe([A],ft),e.TreeDataTransferItem=ft;let Mt=class{constructor(){this._items=new Map}get(B){return this._items.get(B)}set(B,ee){this._items.set(B,ee)}forEach(B){this._items.forEach(B)}};Mt=Fe([A],Mt),e.TreeDataTransfer=Mt;let ct=class{constructor(B,ee){this.id=B,this.color=ee}};ct=Fe([A],ct),e.ThemeIcon=ct,ct.File=new ct("file"),ct.Folder=new ct("folder");let Ct=class{constructor(B){this.id=B}};Ct=Fe([A],Ct),e.ThemeColor=Ct;var Ut;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let bt=class{constructor(B,ee){if(typeof B!="string"&&(!B||!R.URI.isUri(B)&&!R.URI.isUri(B.uri)))throw(0,k.illegalArgument)("base");if(typeof ee!="string")throw(0,k.illegalArgument)("pattern");typeof B=="string"?this.baseUri=R.URI.file(B):R.URI.isUri(B)?this.baseUri=B:this.baseUri=B.uri,this.pattern=ee}get base(){return this._base}set base(B){this._base=B,this._baseUri=R.URI.file(B)}get baseUri(){return this._baseUri}set baseUri(B){this._baseUri=B,this._base=B.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};bt=Fe([A],bt),e.RelativePattern=bt;let Bt=class{constructor(B,ee,we,He){this.enabled=typeof B=="boolean"?B:!0,typeof ee=="string"&&(this.condition=ee),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,N.generateUuid)()),this._id}};Bt=Fe([A],Bt),e.Breakpoint=Bt;let Wt=class extends Bt{constructor(B,ee,we,He,qe){super(ee,we,He,qe);if(B===null)throw(0,k.illegalArgument)("location");this.location=B}};Wt=Fe([A],Wt),e.SourceBreakpoint=Wt;let ht=class extends Bt{constructor(B,ee,we,He,qe){super(ee,we,He,qe);this.functionName=B}};ht=Fe([A],ht),e.FunctionBreakpoint=ht;let ei=class extends Bt{constructor(B,ee,we,He,qe,Ye,Ze){super(He,qe,Ye,Ze);if(!ee)throw(0,k.illegalArgument)("dataId");this.label=B,this.dataId=ee,this.canPersist=we}};ei=Fe([A],ei),e.DataBreakpoint=ei;let Yt=class{constructor(B,ee,we){this.command=B,this.args=ee||[],this.options=we}};Yt=Fe([A],Yt),e.DebugAdapterExecutable=Yt;let ti=class{constructor(B,ee){this.port=B,this.host=ee}};ti=Fe([A],ti),e.DebugAdapterServer=ti;let oi=class{constructor(B){this.path=B}};oi=Fe([A],oi),e.DebugAdapterNamedPipeServer=oi;let Tt=class{constructor(B){this.implementation=B}};Tt=Fe([A],Tt),e.DebugAdapterInlineImplementation=Tt;let ii=class{constructor(B,ee){this.range=B,this.expression=ee}};ii=Fe([A],ii),e.EvaluatableExpression=ii;var _i;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(_i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Gt=class{constructor(B,ee){this.range=B,this.text=ee}};Gt=Fe([A],Gt),e.InlineValueText=Gt;let Xt=class{constructor(B,ee,we=!0){this.range=B,this.variableName=ee,this.caseSensitiveLookup=we}};Xt=Fe([A],Xt),e.InlineValueVariableLookup=Xt;let st=class{constructor(B,ee){this.range=B,this.expression=ee}};st=Fe([A],st),e.InlineValueEvaluatableExpression=st;let ai=class{constructor(B,ee){this.frameId=B,this.stoppedLocation=ee}};ai=Fe([A],ai),e.InlineValueContext=ai;var Vt;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let jt=m=class extends Error{constructor(B,ee=v.FileSystemProviderErrorCode.Unknown,we){super(R.URI.isUri(B)?B.toString(!0):B);this.code=we?.name??"Unknown",(0,v.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}static FileExists(B){return new m(B,v.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(B){return new m(B,v.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(B){return new m(B,v.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(B){return new m(B,v.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(B){return new m(B,v.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(B){return new m(B,v.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}};jt=m=Fe([A],jt),e.FileSystemError=jt;let ni=class{constructor(B,ee,we){this.start=B,this.end=ee,this.kind=we}};ni=Fe([A],ni),e.FoldingRange=ni;var Si;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Si=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gi;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(gi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var yi;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(yi=e.CommentMode||(e.CommentMode={}));class pi{constructor(B,ee=[]){this.tokenTypes=B,this.tokenModifiers=ee}}e.SemanticTokensLegend=pi;function ri(W){return typeof W=="undefined"||(0,I.isStringArray)(W)}class li{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let ee=0,we=B.tokenTypes.length;ee<we;ee++)this._tokenTypeStrToInt.set(B.tokenTypes[ee],ee);for(let ee=0,we=B.tokenModifiers.length;ee<we;ee++)this._tokenModifierStrToInt.set(B.tokenModifiers[ee],ee)}}push(B,ee,we,He,qe){if(typeof B=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof qe=="number"||typeof qe=="undefined"))return typeof qe=="undefined"&&(qe=0),this._pushEncoded(B,ee,we,He,qe);if(U.isRange(B)&&typeof ee=="string"&&ri(we))return this._push(B,ee,we);throw(0,k.illegalArgument)()}_push(B,ee,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const He=B.start.line,qe=B.start.character,Ye=B.end.character-B.start.character,Ze=this._tokenTypeStrToInt.get(ee);let _t=0;if(we)for(const At of we){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(At);_t|=1<<xt>>>0}this._pushEncoded(He,qe,Ye,Ze,_t)}_pushEncoded(B,ee,we,He,qe){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const _t=this._data.length/5|0;let At=0,xt=0;for(let zt=0;zt<_t;zt++){let qt=this._data[5*zt],fi=this._data[5*zt+1];qt===0?(qt=At,fi+=xt):qt+=At,this._data[5*zt]=qt,this._data[5*zt+1]=fi,At=qt,xt=fi}}let Ye=B,Ze=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ye-=this._prevLine,Ye===0&&(Ze-=this._prevChar)),this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=qe,this._prevLine=B,this._prevChar=ee}static _sortAndDeltaEncode(B){let ee=[];const we=B.length/5|0;for(let Ze=0;Ze<we;Ze++)ee[Ze]=Ze;ee.sort((Ze,_t)=>{const At=B[5*Ze],xt=B[5*_t];if(At===xt){const zt=B[5*Ze+1],qt=B[5*_t+1];return zt-qt}return At-xt});const He=new Uint32Array(B.length);let qe=0,Ye=0;for(let Ze=0;Ze<we;Ze++){const _t=5*ee[Ze],At=B[_t+0],xt=B[_t+1],zt=B[_t+2],qt=B[_t+3],fi=B[_t+4],zi=At-qe,Yi=zi===0?xt-Ye:xt,mi=5*Ze;He[mi+0]=zi,He[mi+1]=Yi,He[mi+2]=zt,He[mi+3]=qt,He[mi+4]=fi,qe=At,Ye=xt}return He}build(B){return this._dataIsSortedAndDeltaEncoded?new Jt(new Uint32Array(this._data),B):new Jt(li._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=li;class Jt{constructor(B,ee){this.resultId=ee,this.data=B}}e.SemanticTokens=Jt;class ci{constructor(B,ee,we){this.start=B,this.deleteCount=ee,this.data=we}}e.SemanticTokensEdit=ci;class Di{constructor(B,ee){this.resultId=ee,this.edits=B}}e.SemanticTokensEdits=Di;var Ci;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(Ci=e.DebugConsoleMode||(e.DebugConsoleMode={}));let $t=class{constructor(){}};$t.Back={iconPath:new ct("arrow-left")},$t=Fe([A],$t),e.QuickInputButtons=$t;var Ii;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Ti{constructor(B,ee,we){this.badge=B,this.tooltip=ee,this.color=we}static validate(B){if(B.badge){let ee=(0,O.nextCharLength)(B.badge,0);if(ee<B.badge.length&&(ee+=(0,O.nextCharLength)(B.badge,ee)),B.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ti;let ui=class{constructor(B){this.kind=B}};ui=Fe([A],ui),e.ColorTheme=ui;var di;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast"})(di=e.ColorThemeKind||(e.ColorThemeKind={}));class Qt{constructor(B,ee){if(B<0)throw(0,k.illegalArgument)("start must be positive");if(ee<0)throw(0,k.illegalArgument)("end must be positive");B<=ee?(this._start=B,this._end=ee):(this._start=ee,this._end=B)}static isNotebookRange(B){return B instanceof Qt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let ee=this._start,we=this._end;return B.start!==void 0&&(ee=B.start),B.end!==void 0&&(we=B.end),ee===this._start&&we===this._end?this:new Qt(ee,we)}}e.NotebookRange=Qt;class Ht{constructor(B,ee,we,He,qe,Ye,Ze){this.kind=B,this.value=ee,this.languageId=we,this.mime=He,this.outputs=qe??[],this.metadata=Ye,this.executionSummary=Ze,Ht.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(ee=>Ht.isNotebookCellData(ee))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Ht;class Pe{constructor(B){this.cells=B}}e.NotebookData=Pe;class Rt{constructor(B,ee){this.data=B,this.mime=ee;const we=(0,y.normalizeMimeType)(ee,!0);if(!we)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}static isNotebookCellOutputItem(B){return B instanceof Rt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const ee={name:B.name,message:B.message,stack:B.stack};return Rt.json(ee,"application/vnd.code.notebook.error")}static stdout(B){return Rt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return Rt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,ee="application/octet-stream"){return new Rt(B,ee)}static text(B,ee=y.Mimes.text){const we=De(Rt,i,"f",u).encode(String(B));return new Rt(we,ee)}static json(B,ee="application/json"){const we=JSON.stringify(B,void 0,"	");return Rt.text(we,ee)}}e.NotebookCellOutputItem=Rt,i=Rt,u={value:new TextEncoder};class Zt{constructor(B,ee,we){this.items=Zt.ensureUniqueMimeTypes(B,!0),typeof ee=="string"?(this.id=ee,this.metadata=we):(this.id=(0,N.generateUuid)(),this.metadata=ee??we)}static isNotebookCellOutput(B){return B instanceof Zt?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&(0,I.isArray)(B.items)}static ensureUniqueMimeTypes(B,ee=!1){const we=new Set,He=new Set;for(let qe=0;qe<B.length;qe++){const Ye=B[qe],Ze=(0,y.normalizeMimeType)(Ye.mime);if(!we.has(Ze)){we.add(Ze);continue}He.add(qe),ee&&console.warn(`DUPLICATED mime type '${Ye.mime}' will be dropped`)}return He.size===0?B:B.filter((qe,Ye)=>!He.has(Ye))}}e.NotebookCellOutput=Zt;var ut;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(ut=e.NotebookCellKind||(e.NotebookCellKind={}));var Pi;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(Pi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ei{constructor(B,ee){this.text=B,this.alignment=ee}}e.NotebookCellStatusBarItem=Ei;var Ri;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(Ri=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Oi{constructor(B,ee=[]){this.uri=B,this.provides=(0,r.asArray)(ee)}}e.NotebookRendererScript=Oi;let hi=class{constructor(B,ee){this.label=B,this.timestamp=ee}};hi=Fe([A],hi),e.TimelineItem=hi;var Fi;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var bi;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(bi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Ni{constructor(B,ee){this.ranges=B,this.wordPattern=ee}}e.LinkedEditingRanges=Ni;class Li{constructor(B,ee){this._port=B,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Li;var Ui;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(Ui=e.TestResultState||(e.TestResultState={}));var Bi;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(Bi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Z=class{constructor(B=void 0,ee=void 0,we=void 0){this.include=B,this.exclude=ee,this.profile=we}};Z=Fe([A],Z),e.TestRunRequest=Z;let se=E=class{constructor(B){this.message=B}static diff(B,ee,we){const He=new E(B);return He.expectedOutput=ee,He.actualOutput=we,He}};se=E=Fe([A],se),e.TestMessage=se;let ye=class{constructor(B){this.id=B}};ye=Fe([A],ye),e.TestTag=ye;let Qe=class{constructor(B,ee){this.covered=B,this.total=ee}};Qe=Fe([A],Qe),e.CoveredCount=Qe;let mt=T=class{constructor(B,ee,we,He){this.uri=B,this.statementCoverage=ee,this.branchCoverage=we,this.functionCoverage=He}static fromDetails(B,ee){const we=new Qe(0,0),He=new Qe(0,0),qe=new Qe(0,0);for(const Ze of ee)if("branches"in Ze){we.total+=1,we.covered+=Ze.executionCount>0?1:0;for(const _t of Ze.branches)He.total+=1,He.covered+=_t.executionCount>0?1:0}else qe.total+=1,qe.covered+=Ze.executionCount>0?1:0;const Ye=new T(B,we,He.total>0?He:void 0,qe.total>0?qe:void 0);return Ye.detailedCoverage=ee,Ye}};mt=T=Fe([A],mt),e.FileCoverage=mt;let St=class{constructor(B,ee,we=[]){this.executionCount=B,this.location=ee,this.branches=we}};St=Fe([A],St),e.StatementCoverage=St;let xi=class{constructor(B,ee){this.executionCount=B,this.location=ee}};xi=Fe([A],xi),e.BranchCoverage=xi;let $i=class{constructor(B,ee){this.executionCount=B,this.location=ee}};$i=Fe([A],$i),e.FunctionCoverage=$i;var Ki;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(B,ee,we,He,qe,Ye){this.kind=B,this.name=ee,this.detail=we,this.uri=He,this.range=qe,this.selectionRange=Ye}}e.TypeHierarchyItem=Qi}),define(Ee[82],be([1,0,42,9,10,225,116,7,16]),function(Y,e,r,k,b,$,y,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function N(s,i){i?R.set(s,i):R.delete(s)}e.setWordDefinitionFor=N;function v(s){return R.get(s)}e.getWordDefinitionFor=v;class n extends $.MirrorTextModel{constructor(i,u,S,_,w,d,D,a){super(u,S,_,w);this._proxy=i,this._languageId=d,this._isDirty=D,this._notebook=a,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(i){return(0,I.equals)(this._lines,i)}get document(){if(!this._document){const i=this;this._document={get uri(){return i._uri},get fileName(){return i._uri.fsPath},get isUntitled(){return i._uri.scheme===k.Schemas.untitled},get languageId(){return i._languageId},get version(){return i._versionId},get isClosed(){return i._isDisposed},get isDirty(){return i._isDirty},get notebook(){return i._notebook},save(){return i._save()},getText(u){return u?i._getTextInRange(u):i.getText()},get eol(){return i._eol===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return i._lines.length},lineAt(u){return i._lineAt(u)},offsetAt(u){return i._offsetAt(u)},positionAt(u){return i._positionAt(u)},validateRange(u){return i._validateRange(u)},validatePosition(u){return i._validatePosition(u)},getWordRangeAtPosition(u,S){return i._getWordRangeAtPosition(u,S)}}}return Object.freeze(this._document)}_acceptLanguageId(i){(0,r.ok)(!this._isDisposed),this._languageId=i}_acceptIsDirty(i){(0,r.ok)(!this._isDisposed),this._isDirty=i}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(i){const u=this._validateRange(i);if(u.isEmpty)return"";if(u.isSingleLine)return this._lines[u.start.line].substring(u.start.character,u.end.character);const S=this._eol,_=u.start.line,w=u.end.line,d=[];d.push(this._lines[_].substring(u.start.character));for(let D=_+1;D<w;D++)d.push(this._lines[D]);return d.push(this._lines[w].substring(0,u.end.character)),d.join(S)}_lineAt(i){let u;if(i instanceof O.Position?u=i.line:typeof i=="number"&&(u=i),typeof u!="number"||u<0||u>=this._lines.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new p(u,this._lines[u],u===this._lines.length-1)}_offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.line-1)+i.character}_positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(i),S=this._lines[u.index].length;return new O.Position(u.index,Math.min(u.remainder,S))}_validateRange(i){if(!(i instanceof O.Range))throw new Error("Invalid argument");const u=this._validatePosition(i.start),S=this._validatePosition(i.end);return u===i.start&&S===i.end?i:new O.Range(u.line,u.character,S.line,S.character)}_validatePosition(i){if(!(i instanceof O.Position))throw new Error("Invalid argument");if(this._lines.length===0)return i.with(0,0);let{line:u,character:S}=i,_=!1;if(u<0)u=0,S=0,_=!0;else if(u>=this._lines.length)u=this._lines.length-1,S=this._lines[u].length,_=!0;else{const w=this._lines[u].length;S<0?(S=0,_=!0):S>w&&(S=w,_=!0)}return _?new O.Position(u,S):i}_getWordRangeAtPosition(i,u){const S=this._validatePosition(i);if(!u)u=v(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const _=(0,y.getWordAtText)(S.character+1,(0,y.ensureValidWordDefinition)(u),this._lines[S.line],0);if(_)return new O.Range(S.line,_.startColumn-1,S.line,_.endColumn-1)}}e.ExtHostDocumentData=n;class p{constructor(i,u,S){this._line=i,this._text=u,this._isLastLine=S}get lineNumber(){return this._line}get text(){return this._text}get range(){return new O.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new O.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(Ee[151],be([1,0,7,5,226,6,72,22,2,36]),function(Y,e,r,k,b,$,y,O,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class N{constructor(n,p,s,i){this._notebook=s,this._selector=i,this._disposables=new $.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=I.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(S=>{const _=this._cellUris.get(S.document.uri);_!==void 0&&(this._cellLengths.setValue(_,this._cells[_].document.getText().length+1),this._cellLines.setValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const u=S=>{S===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(S=>u(S.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new O.ResourceMap;const n=[],p=[];for(const s of this._notebook.getCells())s.kind===r.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),p.push(s.document.lineCount));this._cellLengths=new b.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new b.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(n){if(!n){let _="";for(const w of this._cells)_+=w.document.getText()+`
`;return _=_.slice(0,-1),_}if(n.isEmpty)return"";const p=this.locationAt(n.start),s=this.locationAt(n.end),i=this._cellUris.get(p.uri),u=this._cellUris.get(s.uri);if(i===void 0||u===void 0)return"";if(i===u)return this._cells[i].document.getText(new r.Range(p.range.start,s.range.end));const S=[this._cells[i].document.getText(new r.Range(p.range.start,new r.Position(this._cells[i].document.lineCount,0)))];for(let _=i+1;_<u;_++)S.push(this._cells[_].document.getText());return S.push(this._cells[u].document.getText(new r.Range(new r.Position(0,0),s.range.end))),S.join(`
`)}offsetAt(n){const p=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(p.index-1),i=this._cells[p.index].document.offsetAt(n.with(p.remainder));return s+i}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),i=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(i)}const p=this._cellUris.get(n.uri);if(p!==void 0){const s=this._cellLines.getPrefixSum(p-1);return new r.Position(s+n.range.start.line,n.range.start.character)}return new r.Position(0,0)}locationAt(n){r.Range.isRange(n)||(n=new r.Range(n,n));const p=this._cellLines.getIndexOf(n.start.line);let s=p;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const i=new r.Position(p.remainder,n.start.character),u=new r.Position(s.remainder,n.end.character),S=new r.Range(i,u),_=this._cells[p.index];return new r.Location(_.document.uri,_.document.validateRange(S))}contains(n){return this._cellUris.has(n)}validateRange(n){const p=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(p,s)}validatePosition(n){const p=this._cellLines.getIndexOf(n.line),s=new r.Position(p.remainder,n.character),i=this._cells[p.index].document.validatePosition(s),u=this._cellLines.getPrefixSum(p.index-1);return new r.Position(u+i.line,i.character)}}e.ExtHostNotebookConcatDocument=N}),define(Ee[152],be([1,0,7,14,5]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let $=class{constructor(O){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(O){let I=O==="light"?r.ColorThemeKind.Light:O==="dark"?r.ColorThemeKind.Dark:r.ColorThemeKind.HighContrast;this._actual=new r.ColorTheme(I),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};$=Fe([Ne(0,k.IExtHostRpcService)],$),e.ExtHostTheming=$}),define(Ee[59],be([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class k{constructor($){$?(this.transformIncoming=$.transformIncoming.bind($),this.transformOutgoing=$.transformOutgoing.bind($),this.transformOutgoingURI=$.transformOutgoingURI.bind($),this.transformOutgoingScheme=$.transformOutgoingScheme.bind($)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=k}),define(Ee[153],be([1,0,21]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(I){let R=this.buffers.indexOf(I);return R<0&&(R=this.buffers.length,this.buffers.push(I)),R}}function b(O,I){if(I.serializeBuffersForPostMessage){const R=new k,N=(p,s)=>{if(s instanceof ArrayBuffer){const i=R.add(s);return{$$vscode_array_buffer_reference$$:!0,index:i}}else if(ArrayBuffer.isView(s)){const i=$(s);if(i){const u=R.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:u,view:{type:i,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},v=JSON.stringify(O,N),n=R.buffers.map(p=>{const s=new Uint8Array(p);return r.VSBuffer.wrap(s)});return{message:v,buffers:n}}else return{message:JSON.stringify(O),buffers:[]}}e.serializeWebviewMessage=b;function $(O){switch(O.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(O,I){const R=I.map(n=>{const p=new ArrayBuffer(n.byteLength);return new Uint8Array(p).set(n.buffer),p}),N=I.length?(n,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const s=p,{index:i}=s,u=R[i];if(s.view)switch(s.view.type){case 1:return new Int8Array(u,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return p}:void 0;return{message:JSON.parse(O,N),arrayBuffers:R}}e.deserializeWebviewMessage=y}),define(Ee[154],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var r;(function(k){function b(y){const O=new Map;return y.types.forEach((I,R)=>{O.set(I,{asString:async()=>y.items[R].asString,value:void 0})}),O}k.toITreeDataTransfer=b;async function $(y){const O={types:[],items:[]},I=Array.from(y.entries());for(const R of I)O.types.push(R[0]),O.items.push({asString:await R[1].asString()});return O}k.toTreeDataTransferDTO=$})(r=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[155],be([1,0,128,13,2,6,3,37,46,16,9]),function(Y,e,r,k,b,$,y,O,I,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function v(g,U,z){for(const q of z.visibleEditorPanes)if(q.group.id===U&&g.matches(q.input))return q.getViewState()}e.findViewStateForEditor=v;function n(g){if(d(g))return!1;const U=g;return b.URI.isUri(U?.resource)}e.isResourceEditorInput=n;function p(g){if(d(g))return!1;const U=g;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=p;function s(g){if(d(g)||p(g))return!1;const U=g;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=s;function i(g){if(d(g))return!1;const U=g;return U?U.resource===void 0||U.resource.scheme===N.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=i;var u;(function(g){g[g.SHORT=0]="SHORT",g[g.MEDIUM=1]="MEDIUM",g[g.LONG=2]="LONG"})(u=e.Verbosity||(e.Verbosity={}));var S;(function(g){g[g.EXPLICIT=1]="EXPLICIT",g[g.AUTO=2]="AUTO",g[g.FOCUS_CHANGE=3]="FOCUS_CHANGE",g[g.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var _;(function(g){g[g.None=0]="None",g[g.Readonly=2]="Readonly",g[g.Untitled=4]="Untitled",g[g.Singleton=8]="Singleton",g[g.RequiresTrust=16]="RequiresTrust",g[g.CanSplitInGroup=32]="CanSplitInGroup",g[g.ForceDescription=64]="ForceDescription"})(_=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class w extends $.Disposable{}e.AbstractEditorInput=w;function d(g){return g instanceof w}e.isEditorInput=d;function D(g){const U=g;return b.URI.isUri(U?.preferredResource)}function a(g){const U=g;return d(U?.primary)&&d(U?.secondary)}e.isSideBySideEditorInput=a;function P(g){const U=g;return d(U?.modified)&&d(U?.original)}e.isDiffEditorInput=P;function c(g){return d(g?.editor)}e.isEditorInputWithOptions=c;function t(g){const U=g;return c(g)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=t;function h(g){const U=g;return typeof U?.groupId=="number"&&d(U.editor)}e.isEditorIdentifier=h;var o;(function(g){g[g.UNKNOWN=0]="UNKNOWN",g[g.REPLACE=1]="REPLACE",g[g.MOVE=2]="MOVE",g[g.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var l;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.GROUP_LOCKED=2]="GROUP_LOCKED",g[g.EDITOR_OPEN=3]="EDITOR_OPEN",g[g.EDITOR_CLOSE=4]="EDITOR_CLOSE",g[g.EDITOR_MOVE=5]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=7]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=9]="EDITOR_PIN",g[g.EDITOR_STICKY=10]="EDITOR_STICKY",g[g.EDITOR_DIRTY=11]="EDITOR_DIRTY",g[g.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(l=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var f;(function(g){g[g.PRIMARY=1]="PRIMARY",g[g.SECONDARY=2]="SECONDARY",g[g.BOTH=3]="BOTH",g[g.ANY=4]="ANY"})(f=e.SideBySideEditor||(e.SideBySideEditor={}));class m{getOriginalUri(U,z){if(!U)return;if(z?.supportSideBySide){const{primary:j,secondary:J}=this.getSideEditors(U);if(j&&J){if(z?.supportSideBySide===f.BOTH)return{primary:this.getOriginalUri(j,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(J,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===f.ANY)return this.getOriginalUri(j,{filterByScheme:z.filterByScheme})??this.getOriginalUri(J,{filterByScheme:z.filterByScheme});U=z.supportSideBySide===f.PRIMARY?j:J}}if(p(U)||s(U))return;const q=D(U)?U.preferredResource:U.resource;return!q||!z||!z.filterByScheme?q:this.filterUri(q,z.filterByScheme)}getSideEditors(U){return a(U)||s(U)?{primary:U.primary,secondary:U.secondary}:P(U)||p(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,z){if(!U)return;if(z?.supportSideBySide){const{primary:j,secondary:J}=this.getSideEditors(U);if(j&&J){if(z?.supportSideBySide===f.BOTH)return{primary:this.getCanonicalUri(j,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(J,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===f.ANY)return this.getCanonicalUri(j,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(J,{filterByScheme:z.filterByScheme});U=z.supportSideBySide===f.PRIMARY?j:J}}if(p(U)||s(U))return;const q=U.resource;return!q||!z||!z.filterByScheme?q:this.filterUri(q,z.filterByScheme)}filterUri(U,z){if(Array.isArray(z)){if(z.some(q=>U.scheme===q))return U}else if(z===U.scheme)return U}}e.EditorResourceAccessor=new m;var E;(function(g){g[g.LEFT=0]="LEFT",g[g.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class T{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const z=this.instantiationService=U.get(y.IInstantiationService);for(const[q,j]of this.editorSerializerConstructors)this.createEditorSerializer(q,j,z);this.editorSerializerConstructors.clear()}createEditorSerializer(U,z,q){const j=q.createInstance(z);this.editorSerializerInstances.set(U,j)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,k.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,z){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,z,this.instantiationService):this.editorSerializerConstructors.set(U,z),(0,$.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}O.Registry.add(e.EditorExtensions.EditorFactory,new T);async function A(g,U){if(!g||!g.length)return[];const z=await Promise.all(g.map(async q=>{const j=b.URI.revive(q.fileUri);if(!j||!await U.canHandleResource(j))return;let V=q.exists,ie=q.type;if(typeof V!="boolean"||typeof ie!="number")try{ie=(await U.resolve(j)).isDirectory?I.FileType.Directory:I.FileType.Unknown,V=!0}catch{V=!1}if(!V&&q.openOnlyIfExists||ie===I.FileType.Directory)return;const ae={selection:V?q.selection:void 0,pinned:!0,override:q.editorOverrideId};let te;return V?te={resource:j,options:ae}:te={resource:j,options:ae,forceUntitled:!0},te}));return(0,R.coalesce)(z)}e.pathsToEditors=A;var x;(function(g){g[g.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",g[g.SEQUENTIAL=1]="SEQUENTIAL"})(x=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[60],be([1,0,9,2]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function b(O,I){return O.scheme===r.Schemas.http||O.scheme===r.Schemas.https?O:(I&&I.authority&&I.isRemote&&O.scheme===r.Schemas.file&&(O=k.URI.from({scheme:r.Schemas.vscodeRemote,authority:I.authority,path:O.path})),k.URI.from({scheme:r.Schemas.https,authority:`${O.scheme}+${$(O.authority)}.${e.webviewRootResourceAuthority}`,path:O.path,fragment:O.fragment,query:O.query}))}e.asWebviewUri=b;function $(O){return O.replace(/./g,I=>{const R=I.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?I:"-"+R.toString(16).padStart(4,"0")})}function y(O){return O.replace(/-([0-9a-f]{4})/g,(I,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=y}),define(Ee[156],be([1,0,5,6,60]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class ${constructor(O,I,R){this._proxy=O,this._editors=I,this._initData=R,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(I.onDidChangeVisibleTextEditors(()=>{const N=I.getVisibleTextEditors();for(const v of this._insets.values())N.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this._insets.forEach(O=>O.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(O,I,R,N,v){let n;for(const w of this._editors.getVisibleTextEditors(!0))if(w.value===O){n=w;break}if(!n)throw new Error("not a visible editor");const p=this,s=this._handlePool++,i=new r.Emitter,u=new r.Emitter,S=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(w){return(0,b.asWebviewUri)(w,p._initData.remote)}get cspSource(){return b.webviewGenericCspSource}set options(w){this._options=w,p._proxy.$setOptions(s,w)}get options(){return this._options}set html(w){this._html=w,p._proxy.$setHtml(s,w)}get html(){return this._html}get onDidReceiveMessage(){return i.event}postMessage(w){return p._proxy.$postMessage(s,w)}},_=new class{constructor(){this.editor=O,this.line=I,this.height=R,this.webview=S,this.onDidDispose=u.event}dispose(){p._insets.has(s)&&(p._insets.delete(s),p._proxy.$disposeEditorInset(s),u.fire(),u.dispose(),i.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,I+1,R,N||{},v.identifier,v.extensionLocation),this._insets.set(s,{editor:O,inset:_,onDidReceiveMessage:i}),_}$onDidDispose(O){const I=this._insets.get(O);I&&I.inset.dispose()}$onDidReceiveMessage(O,I){const R=this._insets.get(O);R&&R.onDidReceiveMessage.fire(I)}}e.ExtHostEditorInsets=$}),define(Ee[157],be([1,0,5,11,129]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class ${constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(O){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=O}onEvent(O){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=O}onRequest(O){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=O}sendResponse(O){O.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.internalSend("response",O)}sendRequest(O,I,R,N){const v={command:O};if(I&&Object.keys(I).length>0&&(v.arguments=I),this.internalSend("request",v),typeof N=="number"){const n=setTimeout(()=>{clearTimeout(n);const p=this.pendingRequests.get(v.seq);if(p){this.pendingRequests.delete(v.seq);const s={type:"response",seq:0,request_seq:v.seq,success:!1,command:O,message:(0,b.localize)(0,null,N,O)};p(s)}},N)}return R&&this.pendingRequests.set(v.seq,R),v.seq}acceptMessage(O){this.messageCallback?this.messageCallback(O):(this.queue.push(O),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(O,I){return O.type!=="event"||I.type!=="event"}async processQueue(){let O;for(;this.queue.length;){if((!O||this.needsTaskBoundaryBetween(this.queue[0],O))&&await(0,k.timeout)(0),O=this.queue.shift(),!O)return;switch(O.type){case"event":this.eventCallback&&this.eventCallback(O);break;case"request":this.requestCallback&&this.requestCallback(O);break;case"response":{const I=O,R=this.pendingRequests.get(I.request_seq);R&&(this.pendingRequests.delete(I.request_seq),R(I));break}}}}internalSend(O,I){I.type=O,I.seq=this.sequence++,this.sendMessage(I)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const O=new Map;this.pendingRequests.forEach((I,R)=>O.set(R,I)),await(0,k.timeout)(500),O.forEach((I,R)=>{I({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=$}),define(Ee[158],be([1,0,130,45,3]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new k.RawContextKey("breakpointAccessType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(49,null)});const $=v=>r.localize(50,null,v);e.debuggerDisabledMessage=$,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(51,null)};var y;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(y=e.State||(e.State={}));function O(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=O;var I;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(I=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var R;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(R=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var N;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(N=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ee[159],be([1,0,10,2,17,26,9]),function(Y,e,r,k,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function I(c,t,h){return c.replace(O,function(o,l){return t&&l.length>0&&l[0]!=="_"?o:h&&h.hasOwnProperty(l)?h[l]:o})}e.formatPII=I;function R(c){const t={};for(const h of Object.keys(c))h.startsWith("!")||(t[h]=c[h]);return t}e.filterExceptionsFromTelemetry=R;function N(c){return c.configuration.request==="attach"&&!v(c)&&(!c.parentSession||N(c.parentSession))}e.isSessionAttach=N;function v(c){let t=c.configuration.type;if(!!t)return t==="vslsShare"&&(t=c.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(t,"extensionhost")||(0,r.equalsIgnoreCase)(t,"pwa-extensionhost")?c:c.parentSession?v(c.parentSession):void 0}e.getExtensionHostDebugSession=v;function n(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=n;function p(c,t,h){let o,l=0;const f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let m=null;for(;m=f.exec(c);){const E=m.index+1,T=E+m[0].length;if(E<=t&&T>=h){o=m[0],l=E;break}}if(o){const E=/\w+/g;let T=null;for(;(T=E.exec(o))&&!(T.index+1+l+T[0].length>=h););T&&(o=o.substring(0,E.lastIndex))}return o?{start:l,end:l+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(c){return!!(c&&c.match(s))}e.isUri=i;function u(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(i(c.path))return k.URI.parse(c.path);if((0,b.isAbsolute)(c.path))return k.URI.file(c.path)}return c.path}function S(c){if(typeof c.path=="object"){const t=k.URI.revive(c.path);if(t)return t.scheme===y.Schemas.file?t.fsPath:t.toString()}return c.path}function _(c,t){const h=t?u:S,o=(0,$.deepClone)(c);return d(o,(l,f)=>{l&&f&&(f.path=h(f))}),o}e.convertToDAPaths=_;function w(c,t){const h=t?u:S,o=(0,$.deepClone)(c);return d(o,(l,f)=>{!l&&f&&(f.path=h(f))}),o}e.convertToVSCPaths=w;function d(c,t){switch(c.type){case"event":{const h=c;switch(h.event){case"output":t(!1,h.body.source);break;case"loadedSource":t(!1,h.body.source);break;case"breakpoint":t(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=c;switch(h.command){case"setBreakpoints":t(!0,h.arguments.source);break;case"breakpointLocations":t(!0,h.arguments.source);break;case"source":t(!0,h.arguments.source);break;case"gotoTargets":t(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(o=>t(!1,o));break;default:break}break}case"response":{const h=c;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(o=>t(!1,o.source));break;case"loadedSources":h.body.sources.forEach(o=>t(!1,o));break;case"scopes":h.body.scopes.forEach(o=>t(!1,o.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(o=>t(!1,o.source));break;case"setBreakpoints":h.body.breakpoints.forEach(o=>t(!1,o.source));break;case"disassemble":{const o=h;o.body&&o.body.instructions.forEach(l=>t(!1,l.location))}break;default:break}break}}}function D(c){return c.filter(t=>!t.presentation?.hidden).sort((t,h)=>t.presentation?h.presentation?t.presentation.group?h.presentation.group?t.presentation.group!==h.presentation.group?t.presentation.group.localeCompare(h.presentation.group):a(t.presentation.order,h.presentation.order):-1:h.presentation.group?1:a(t.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=D;function a(c,t){return typeof c!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:c-t}async function P(c,t){const h=c.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(h!=="none"&&(await t.saveAll(),h==="allEditorsInActiveGroup")){const o=t.activeEditorPane;o&&o.input.resource?.scheme===y.Schemas.untitled&&await t.save({editor:o.input,groupId:o.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=P}),define(Ee[83],be([1,0,29,160,69,9,17,23,45]),function(Y,e,r,k,b,$,y,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",b.Mimes.latex,b.Mimes.markdown,"image/png","image/jpeg",b.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[b.Mimes.latex,b.Mimes.markdown,"application/json",b.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var N;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(N=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var i;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(i=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var S;(function(E){E.scheme=$.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function A(j,J){return j.with({scheme:E.scheme,fragment:`ch${J.toString().padStart(7,"0")}${j.scheme!==$.Schemas.file?j.scheme:""}`})}E.generate=A;function x(j){if(j.scheme!==E.scheme)return;const J=T.exec(j.fragment);return J?{handle:Number(J[1]),notebook:j.with({scheme:j.fragment.substring(J[0].length)||$.Schemas.file,fragment:null})}:void 0}E.parse=x;function g(j,J,V){return j.with({scheme:$.Schemas.vscodeNotebookCellOutput,fragment:`ch${J.toString().padStart(7,"0")},${V??""},${j.scheme!==$.Schemas.file?j.scheme:""}`})}E.generateCellOutputUri=g;function U(j){if(j.scheme!==$.Schemas.vscodeNotebookCellOutput)return;const J=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(j.fragment);if(!J)return;const V=Number(J[1]),ie=J[2]&&J[2]!==""?J[2]:void 0,ae=J[3];return{handle:V,outputId:ie,notebook:j.with({scheme:ae||$.Schemas.file,fragment:null})}}E.parseCellOutputUri=U;function z(j,J,V){return j.with({scheme:V,fragment:`ch${J.toString().padStart(7,"0")}${j.scheme!==$.Schemas.file?j.scheme:""}`})}E.generateCellUri=z;function q(j,J){if(j.scheme!==J)return;const V=T.exec(j.fragment);return V?{handle:Number(V[1]),notebook:j.with({scheme:j.fragment.substring(V[0].length)||$.Schemas.file,fragment:null})}:void 0}E.parseCellUri=q})(S=e.CellUri||(e.CellUri={}));const _=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[b.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(E){return _.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=w;function d(E){return _.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=d;function D(E){return _.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=D;const a=E=>O.isWindows?E.replace(/\//g,"\\"):E;class P{constructor(T=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(T)].map(x=>({pattern:x,matches:r.parse(a(x))}))}sort(T){const A=new Map(k.Iterable.map(T,g=>[g,a(g)]));let x=[];for(const{matches:g}of this.order)for(const[U,z]of A)if(g(z)){x.push(U),A.delete(U);break}return A.size&&(x=x.concat([...A.keys()].sort((g,U)=>this.defaultOrder.indexOf(g)-this.defaultOrder.indexOf(U)))),x}prioritize(T,A){const x=this.findIndex(T);if(x===-1){this.order.unshift({pattern:T,matches:r.parse(a(T))});return}const g=new Set(A.map(z=>this.findIndex(z,x)));g.delete(-1);const U=Array.from(g).sort();this.order.splice(x+1,0,...U.map(z=>this.order[z]));for(let z=U.length-1;z>=0;z--)this.order.splice(U[z],1)}toArray(){return this.order.map(T=>T.pattern)}findIndex(T,A=this.order.length){const x=a(T);for(let g=0;g<A;g++)if(this.order[g].matches(x))return g;return-1}}e.MimeTypeDisplayOrder=P;function c(E,T,A,x=(g,U)=>g===U){const g=[];function U(j,J,V){if(J===0&&V.length===0)return;const ie=g[g.length-1];ie&&ie.start+ie.deleteCount===j?(ie.deleteCount+=J,ie.toInsert.push(...V)):g.push({start:j,deleteCount:J,toInsert:V})}let z=0,q=0;for(;;){if(z===E.length){U(z,0,T.slice(q));break}if(q===T.length){U(z,E.length-z,[]);break}const j=E[z],J=T[q];if(x(j,J)){z+=1,q+=1;continue}A(J)?(U(z,1,[]),z+=1):(U(z,0,[J]),q+=1)}return g}e.diff=c,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(E){E.default="default",E.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(E){const T=E;return!!((typeof T.include=="string"||r.isRelativePattern(T.include))&&(typeof T.exclude=="string"||r.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=h;function o(E,T,A){if(Array.isArray(E.viewType)&&E.viewType.indexOf(T)>=0||E.viewType===T)return!0;if(E.filenamePattern){const x=h(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,g=h(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(r.match(x,(0,y.basename)(A.fsPath).toLowerCase()))return!(g&&r.match(g,(0,y.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class l{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)T[A]=this.textModel.cells[A].getHashValue();return T}}e.CellSequence=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var f;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class m{static create(T){return`${m._prefix}${T}`}static parse(T){if(T.startsWith(m._prefix))return T.substring(m._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=m,m._prefix="notebook/"}),define(Ee[161],be([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(k=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ee[162],be([1,0,3,45]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,r.createDecorator)(e.OUTPUT_SERVICE_ID);var b;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(b=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[163],be([1,0,131,3,45]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new b.RawContextKey("customExecutionSupported",!0,r.localize(0,null)),e.ShellExecutionSupportedContext=new b.RawContextKey("shellExecutionSupported",!1,r.localize(1,null)),e.ProcessExecutionSupportedContext=new b.RawContextKey("processExecutionSupported",!1,r.localize(2,null)),e.ITaskService=(0,k.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[164],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=r;function k(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=k}),define(Ee[84],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var r;(function(v){v[v.Unset=0]="Unset",v[v.Queued=1]="Queued",v[v.Running=2]="Running",v[v.Passed=3]="Passed",v[v.Failed=4]="Failed",v[v.Skipped=5]="Skipped",v[v.Errored=6]="Errored"})(r=e.TestResultState||(e.TestResultState={}));var k;(function(v){v[v.Run=2]="Run",v[v.Debug=4]="Debug",v[v.Coverage=8]="Coverage",v[v.HasNonDefaultProfile=16]="HasNonDefaultProfile",v[v.HasConfigurable=32]="HasConfigurable"})(k=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var b;(function(v){v[v.Error=0]="Error",v[v.Info=1]="Info"})(b=e.TestMessageType||(e.TestMessageType={}));var $;(function(v){v[v.NotExpandable=0]="NotExpandable",v[v.Expandable=1]="Expandable",v[v.BusyExpanding=2]="BusyExpanding",v[v.Expanded=3]="Expanded"})($=e.TestItemExpandState||(e.TestItemExpandState={}));const y=(v,n)=>{n.expand!==void 0&&(v.expand=n.expand),n.item!==void 0&&(v.item=v.item?Object.assign(v.item,n.item):n.item)};e.applyTestItemUpdate=y;var O;(function(v){v[v.Function=0]="Function",v[v.Statement=1]="Statement"})(O=e.DetailType||(e.DetailType={}));var I;(function(v){v[v.Add=0]="Add",v[v.Update=1]="Update",v[v.Remove=2]="Remove",v[v.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",v[v.Retire=4]="Retire",v[v.AddTag=5]="AddTag",v[v.RemoveTag=6]="RemoveTag"})(I=e.TestDiffOpType||(e.TestDiffOpType={}));class R{add(n){}update(n){}remove(n,p){}complete(){}}e.IncrementalChangeCollector=R;class N{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const p=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const i=s[1];if(i.parent){if(this.items.has(i.parent)){const u=this.items.get(i.parent);u.children.add(i.item.extId);const S=this.createItem(i,u);this.items.set(i.item.extId,S),p.add(S)}}else{const u=this.createItem(i);this.roots.add(u),this.items.set(i.item.extId,u),p.add(u)}i.expand===2&&this.busyControllerCount++;break}case 1:{const i=s[1],u=this.items.get(i.extId);if(!u)break;i.expand!==void 0&&(u.expand===2&&this.busyControllerCount--,i.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(u,i),p.update(u);break}case 2:{const i=this.items.get(s[1]);if(!i)break;i.parent?this.items.get(i.parent).children.delete(i.item.extId):this.roots.delete(i);const u=[[s[1]]];for(;u.length;)for(const S of u.pop()){const _=this.items.get(S);_&&(u.push(_.children),this.items.delete(S),p.remove(_,_!==i),_.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}p.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new R}}e.AbstractIncrementalTestCollection=N}),define(Ee[61],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function($){$.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var k;(function($){$[$.IsSame=0]="IsSame",$[$.Disconnected=1]="Disconnected",$[$.IsChild=2]="IsChild",$[$.IsParent=3]="IsParent"})(k=e.TestPosition||(e.TestPosition={}));class b{constructor(y,O=y.length){if(this.path=y,this.viewEnd=O,y.length===0||O<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(y,O,I=y.parent){if(y.id===O)return new b([O]);let R=[y.id];for(let N=I;N&&N.id!==O;N=N.parent)R.push(N.id);return R.push(O),new b(R.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const O=y.indexOf("\0");return O===-1?y:y.slice(0,O)}static fromString(y){return new b(y.split("\0"))}static join(y,O){return new b([...y.path,O])}static joinToString(y,O){return y.toString()+"\0"+O}static compare(y,O){return y===O?0:O.startsWith(y+"\0")?2:y.startsWith(O+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new b(this.path,y)}compare(y){if(typeof y=="string")return b.compare(this.toString(),y);for(let O=0;O<y.viewEnd&&O<this.viewEnd;O++)if(y.path[O]!==this.path[O])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=b}),define(Ee[165],be([1,0,17,85,13,26,23,71,132]),function(Y,e,r,k,b,$,y,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(v,n,p){this._contributedVariables=new Map,this._context=v,this._labelService=n,p&&(this._envVariablesPromise=p.then(s=>this.prepareEnv(s)))}prepareEnv(v){if(y.isWindows){const n=Object.create(null);return Object.keys(v).forEach(p=>{n[p.toLowerCase()]=v[p]}),n}return v}resolveWithEnvironment(v,n,p){return this.recursiveResolve(this.prepareEnv(v),n?n.uri:void 0,p)}async resolveAsync(v,n){return this.recursiveResolve(await this._envVariablesPromise,v?v.uri:void 0,n)}async resolveAnyBase(v,n,p,s){const i=$.deepClone(n);return y.isWindows&&i.windows?Object.keys(i.windows).forEach(u=>i[u]=i.windows[u]):y.isMacintosh&&i.osx?Object.keys(i.osx).forEach(u=>i[u]=i.osx[u]):y.isLinux&&i.linux&&Object.keys(i.linux).forEach(u=>i[u]=i.linux[u]),delete i.windows,delete i.osx,delete i.linux,this.recursiveResolve(await this._envVariablesPromise,v?v.uri:void 0,i,p,s)}async resolveAnyAsync(v,n,p){return this.resolveAnyBase(v,n,p)}async resolveAnyMap(v,n,p){const s=new Map;return{newConfig:await this.resolveAnyBase(v,n,p,s),resolvedVariables:s}}resolveWithInteractionReplace(v,n,p,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,n,p,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,n){if(this._contributedVariables.has(v))throw new Error("Variable "+v+" is contributed twice.");this._contributedVariables.set(v,n)}recursiveResolve(v,n,p,s,i){if(b.isString(p))return this.resolveString(v,n,p,s,i);if(b.isArray(p))return p.map(u=>this.recursiveResolve(v,n,u,s,i));if(b.isObject(p)){let u=Object.create(null);return Object.keys(p).forEach(S=>{const _=this.resolveString(v,n,S,s,i);u[_]=this.recursiveResolve(v,n,p[S],s,i)}),u}return p}resolveString(v,n,p,s,i){return p.replace(R.VARIABLE_REGEXP,(S,_)=>{if(_.includes(R.VARIABLE_LHS))return S;let w=this.evaluateSingleVariable(v,S,_,n,s);return i&&i.set(_,w),w!==S&&b.isString(w)&&w.match(R.VARIABLE_REGEXP)&&(w=this.resolveString(v,n,w,s,i)),w})}fsPath(v){return this._labelService?this._labelService.getUriLabel(v,{noPrefix:!0}):v.fsPath}evaluateSingleVariable(v,n,p,s,i){let u;const S=p.split(":");S.length>1&&(p=S[0],u=S[1]);const _=()=>{const D=this._context.getFilePath();if(D)return D;throw new Error((0,I.localize)(0,null,n))},w=()=>{const D=_();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,I.localize)(1,null,n,r.basename(D)))},d=()=>{if(u){const D=this._context.getFolderUri(u);if(D)return D;throw new Error((0,I.localize)(2,null,n,u))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,I.localize)(3,null,n)):new Error((0,I.localize)(4,null,n))};switch(p){case"env":if(u){if(v){const D=v[y.isWindows?u.toLowerCase():u];if(b.isString(D))return D}return""}throw new Error((0,I.localize)(5,null,n));case"config":if(u){const D=this._context.getConfigurationValue(s,u);if(b.isUndefinedOrNull(D))throw new Error((0,I.localize)(6,null,n,u));if(b.isObject(D))throw new Error((0,I.localize)(7,null,n,u));return D}throw new Error((0,I.localize)(8,null,n));case"command":return this.resolveFromMap(n,u,i,"command");case"input":return this.resolveFromMap(n,u,i,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,O.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return s||u?(0,O.normalizeDriveLetter)(this.fsPath(d())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(d()));case"lineNumber":{const D=this._context.getLineNumber();if(D)return D;throw new Error((0,I.localize)(9,null,n))}case"selectedText":{const D=this._context.getSelectedText();if(D)return D;throw new Error((0,I.localize)(10,null,n))}case"file":return _();case"fileWorkspaceFolder":return w();case"relativeFile":return s||u?r.relative(this.fsPath(d()),_()):_();case"relativeFileDirname":{const D=r.dirname(_());if(s||u){const a=r.relative(this.fsPath(d()),D);return a.length===0?".":a}return D}case"fileDirname":return r.dirname(_());case"fileExtname":return r.extname(_());case"fileBasename":return r.basename(_());case"fileBasenameNoExtension":{const D=r.basename(_());return D.slice(0,D.length-r.extname(D).length)}case"fileDirnameBasename":return r.basename(r.dirname(_()));case"execPath":{const D=this._context.getExecPath();return D||n}case"execInstallFolder":{const D=this._context.getAppRoot();return D||n}case"pathSeparator":return r.sep;default:try{const D=u?`${p}:${u}`:p;return this.resolveFromMap(n,D,i,void 0)}catch{return n}}}}resolveFromMap(v,n,p,s){if(n&&p){const i=s===void 0?p[n]:p[s+":"+n];if(typeof i=="string")return i;throw new Error((0,I.localize)(11,null,v))}return v}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[86],be([1,0,3,155]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var b;(function(s){s[s.UP=0]="UP",s[s.DOWN=1]="DOWN",s[s.LEFT=2]="LEFT",s[s.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var $;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})($=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(s){s[s.FIRST=0]="FIRST",s[s.LAST=1]="LAST",s[s.NEXT=2]="NEXT",s[s.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var O;(function(s){s[s.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",s[s.EVEN=1]="EVEN",s[s.TOGGLE=2]="TOGGLE"})(O=e.GroupsArrangement||(e.GroupsArrangement={}));var I;(function(s){s[s.COPY_EDITORS=0]="COPY_EDITORS",s[s.MOVE_EDITORS=1]="MOVE_EDITORS"})(I=e.MergeGroupMode||(e.MergeGroupMode={}));function R(s){const i=s;return(0,k.isEditorInput)(i?.editor)&&(0,k.isEditorInput)(i?.replacement)}e.isEditorReplacement=R;var N;(function(s){s[s.CREATION_TIME=0]="CREATION_TIME",s[s.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",s[s.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var v;(function(s){s[s.NEW_EDITOR=1]="NEW_EDITOR",s[s.MOVE_EDITOR=2]="MOVE_EDITOR",s[s.COPY_EDITOR=3]="COPY_EDITOR"})(v=e.OpenEditorContext||(e.OpenEditorContext={}));function n(s){const i=s;return!!i&&typeof i.id=="number"&&Array.isArray(i.editors)}e.isEditorGroup=n;function p(s){return s.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(Ee[166],be([1,0,3,86]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b($){const y=$;return typeof $=="number"||(0,k.isEditorGroup)(y)}e.isPreferredGroup=b}),define(Ee[8],be([1,0,16,21,70,101,54,26,13,2,87,88,134,76,48,83,61,166,7]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var w;(function(he){function le(K){const{selectionStartLineNumber:_e,selectionStartColumn:Ce,positionLineNumber:$e,positionColumn:We}=K,nt=new _.Position(_e-1,Ce-1),pt=new _.Position($e-1,We-1);return new _.Selection(nt,pt)}he.to=le;function oe(K){const{anchor:_e,active:Ce}=K;return{selectionStartLineNumber:_e.line+1,selectionStartColumn:_e.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}he.from=oe})(w=e.Selection||(e.Selection={}));var d;(function(he){function le(K){if(!K)return;const{start:_e,end:Ce}=K;return{startLineNumber:_e.line+1,startColumn:_e.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}he.from=le;function oe(K){if(!K)return;const{startLineNumber:_e,startColumn:Ce,endLineNumber:$e,endColumn:We}=K;return new _.Range(_e-1,Ce-1,$e-1,We-1)}he.to=oe})(d=e.Range||(e.Range={}));var D;(function(he){function le(oe){switch(oe){case 1:return _.StandardTokenType.Comment;case 0:return _.StandardTokenType.Other;case 3:return _.StandardTokenType.RegEx;case 2:return _.StandardTokenType.String}}he.to=le})(D=e.TokenType||(e.TokenType={}));var a;(function(he){function le(K){return new _.Position(K.lineNumber-1,K.column-1)}he.to=le;function oe(K){return{lineNumber:K.line+1,column:K.character+1}}he.from=oe})(a=e.Position||(e.Position={}));var P;(function(he){function le(_e,Ce){return(0,r.coalesce)((0,r.asArray)(_e).map($e=>oe($e,Ce)))}he.from=le;function oe(_e,Ce){if(typeof _e=="string")return{$serialized:!0,language:_e};if(_e)return{$serialized:!0,language:_e.language,scheme:K(_e.scheme,Ce),pattern:Q.from(_e.pattern)??void 0,exclusive:_e.exclusive}}function K(_e,Ce){return Ce&&typeof _e=="string"?Ce.transformOutgoingScheme(_e):_e}})(P=e.DocumentSelector||(e.DocumentSelector={}));var c;(function(he){function le(K){switch(K){case _.DiagnosticTag.Unnecessary:return 1;case _.DiagnosticTag.Deprecated:return 2}}he.from=le;function oe(K){switch(K){case 1:return _.DiagnosticTag.Unnecessary;case 2:return _.DiagnosticTag.Deprecated;default:return}}he.to=oe})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(he){function le(K){let _e;return K.code&&((0,I.isString)(K.code)||(0,I.isNumber)(K.code)?_e=String(K.code):_e={value:String(K.code.value),target:K.code.target}),{...d.from(K.range),message:K.message,source:K.source,code:_e,severity:o.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(h.from),tags:Array.isArray(K.tags)?(0,r.coalesce)(K.tags.map(c.from)):void 0}}he.from=le;function oe(K){const _e=new _.Diagnostic(d.to(K),K.message,o.to(K.severity));return _e.source=K.source,_e.code=(0,I.isString)(K.code)?K.code:K.code?.value,_e.relatedInformation=K.relatedInformation&&K.relatedInformation.map(h.to),_e.tags=K.tags&&(0,r.coalesce)(K.tags.map(c.to)),_e}he.to=oe})(t=e.Diagnostic||(e.Diagnostic={}));var h;(function(he){function le(K){return{...d.from(K.location.range),message:K.message,resource:K.location.uri}}he.from=le;function oe(K){return new _.DiagnosticRelatedInformation(new _.Location(K.resource,d.to(K)),K.message)}he.to=oe})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(he){function le(K){switch(K){case _.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case _.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case _.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case _.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}he.from=le;function oe(K){switch(K){case p.MarkerSeverity.Info:return _.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return _.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return _.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return _.DiagnosticSeverity.Hint;default:return _.DiagnosticSeverity.Error}}he.to=oe})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(he){function le(K){return typeof K=="number"&&K>=_.ViewColumn.One?K-1:K===_.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}he.from=le;function oe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}he.to=oe})(l=e.ViewColumn||(e.ViewColumn={}));function f(he){return typeof he.range!="undefined"}function m(he){return he.length===0?!0:!!f(he[0])}e.isDecorationOptionsArr=m;var E;(function(he){function le(We){return We.map(he.from)}he.fromMany=le;function oe(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function K(We){let nt;if(oe(We)){const{language:dt,value:rt}=We;nt={value:"```"+dt+`
`+rt+"\n```\n"}}else _.MarkdownString.isMarkdownString(We)?nt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?nt={value:We}:nt={value:""};const pt=Object.create(null);nt.uris=pt;const wt=dt=>{try{let rt=R.URI.parse(dt,!0);rt=rt.with({query:_e(rt.query,pt)}),pt[dt]=rt}catch{}return""},vt=new $.marked.Renderer;return vt.link=wt,vt.image=dt=>typeof dt=="string"?wt(b.parseHrefAndDimensions(dt).href):"",(0,$.marked)(nt.value,{renderer:vt}),nt}he.from=K;function _e(We,nt){if(!We)return We;let pt;try{pt=(0,y.parse)(We)}catch{}if(!pt)return We;let wt=!1;return pt=(0,O.cloneAndChange)(pt,vt=>{if(R.URI.isUri(vt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[dt]=vt,wt=!0,dt}else return}),wt?JSON.stringify(pt):We}function Ce(We){const nt=new _.MarkdownString(We.value,We.supportThemeIcons);return nt.isTrusted=We.isTrusted,nt.supportHtml=We.supportHtml,nt.baseUri=We.baseUri?R.URI.from(We.baseUri):void 0,nt}he.to=Ce;function $e(We){if(!!We)return typeof We=="string"?We:he.from(We)}he.fromStrict=$e})(E=e.MarkdownString||(e.MarkdownString={}));function T(he){return m(he)?he.map(le=>({range:d.from(le.range),hoverMessage:Array.isArray(le.hoverMessage)?E.fromMany(le.hoverMessage):le.hoverMessage?E.from(le.hoverMessage):void 0,renderOptions:le.renderOptions})):he.map(le=>({range:d.from(le)}))}e.fromRangeOrRangeWithMessage=T;function A(he){return typeof he=="undefined"?he:typeof he=="string"?R.URI.file(he):he}e.pathOrURIToURI=A;var x;(function(he){function le(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?A(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}he.from=le})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var g;(function(he){function le(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?A(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?x.from(oe.before):void 0,after:oe.after?x.from(oe.after):void 0}}he.from=le})(g=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var U;(function(he){function le(oe){if(typeof oe=="undefined")return oe;switch(oe){case _.DecorationRangeBehavior.OpenOpen:return 0;case _.DecorationRangeBehavior.ClosedClosed:return 1;case _.DecorationRangeBehavior.OpenClosed:return 2;case _.DecorationRangeBehavior.ClosedOpen:return 3}}he.from=le})(U=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(he){function le(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?U.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?g.from(oe.light):void 0,dark:oe.dark?g.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?A(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?x.from(oe.before):void 0,after:oe.after?x.from(oe.after):void 0}}he.from=le})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var q;(function(he){function le(K){return{text:K.newText,eol:K.newEol&&Xe.from(K.newEol),range:d.from(K.range)}}he.from=le;function oe(K){const _e=new _.TextEdit(d.to(K.range),K.text);return _e.newEol=typeof K.eol=="undefined"?void 0:Xe.to(K.eol),_e}he.to=oe})(q=e.TextEdit||(e.TextEdit={}));var j;(function(he){function le(K,_e){const Ce={edits:[]};if(K instanceof _.WorkspaceEdit)for(let $e of K._allEntries())$e._type===1?Ce.edits.push({_type:1,oldUri:$e.from,newUri:$e.to,options:$e.options,metadata:$e.metadata}):$e._type===2?Ce.edits.push({_type:2,resource:$e.uri,edit:q.from($e.edit),modelVersionId:_e?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?Ce.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,edit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:_e?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Ce.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,notebookVersionId:_e?.getNotebookDocumentVersion($e.uri),edit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(at.from)}});return Ce}he.from=le;function oe(K){const _e=new _.WorkspaceEdit;for(const Ce of K.edits)Ce.edit?_e.replace(R.URI.revive(Ce.resource),d.to(Ce.edit.range),Ce.edit.text):_e.renameFile(R.URI.revive(Ce.oldUri),R.URI.revive(Ce.newUri),Ce.options);return _e}he.to=oe})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(he){const le=Object.create(null);le[_.SymbolKind.File]=0,le[_.SymbolKind.Module]=1,le[_.SymbolKind.Namespace]=2,le[_.SymbolKind.Package]=3,le[_.SymbolKind.Class]=4,le[_.SymbolKind.Method]=5,le[_.SymbolKind.Property]=6,le[_.SymbolKind.Field]=7,le[_.SymbolKind.Constructor]=8,le[_.SymbolKind.Enum]=9,le[_.SymbolKind.Interface]=10,le[_.SymbolKind.Function]=11,le[_.SymbolKind.Variable]=12,le[_.SymbolKind.Constant]=13,le[_.SymbolKind.String]=14,le[_.SymbolKind.Number]=15,le[_.SymbolKind.Boolean]=16,le[_.SymbolKind.Array]=17,le[_.SymbolKind.Object]=18,le[_.SymbolKind.Key]=19,le[_.SymbolKind.Null]=20,le[_.SymbolKind.EnumMember]=21,le[_.SymbolKind.Struct]=22,le[_.SymbolKind.Event]=23,le[_.SymbolKind.Operator]=24,le[_.SymbolKind.TypeParameter]=25;function oe(_e){return typeof le[_e]=="number"?le[_e]:6}he.from=oe;function K(_e){for(const Ce in le)if(le[Ce]===_e)return Number(Ce);return _.SymbolKind.Property}he.to=K})(J=e.SymbolKind||(e.SymbolKind={}));var V;(function(he){function le(K){switch(K){case _.SymbolTag.Deprecated:return 1}}he.from=le;function oe(K){switch(K){case 1:return _.SymbolTag.Deprecated}}he.to=oe})(V=e.SymbolTag||(e.SymbolTag={}));var ie;(function(he){function le(K){return{name:K.name,kind:J.from(K.kind),tags:K.tags&&K.tags.map(V.from),containerName:K.containerName,location:Se.from(K.location)}}he.from=le;function oe(K){const _e=new _.SymbolInformation(K.name,J.to(K.kind),K.containerName,Se.to(K.location));return _e.tags=K.tags&&K.tags.map(V.to),_e}he.to=oe})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ae;(function(he){function le(K){const _e={name:K.name||"!!MISSING: name!!",detail:K.detail,range:d.from(K.range),selectionRange:d.from(K.selectionRange),kind:J.from(K.kind),tags:K.tags?.map(V.from)??[]};return K.children&&(_e.children=K.children.map(le)),_e}he.from=le;function oe(K){const _e=new _.DocumentSymbol(K.name,K.detail,J.to(K.kind),d.to(K.range),d.to(K.selectionRange));return(0,r.isNonEmptyArray)(K.tags)&&(_e.tags=K.tags.map(V.to)),K.children&&(_e.children=K.children.map(oe)),_e}he.to=oe})(ae=e.DocumentSymbol||(e.DocumentSymbol={}));var te;(function(he){function le(K){const _e=new _.CallHierarchyItem(J.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),d.to(K.range),d.to(K.selectionRange));return _e._sessionId=K._sessionId,_e._itemId=K._itemId,_e}he.to=le;function oe(K,_e,Ce){if(_e=_e??K._sessionId,Ce=Ce??K._itemId,_e===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:Ce,name:K.name,detail:K.detail,kind:J.from(K.kind),uri:K.uri,range:d.from(K.range),selectionRange:d.from(K.selectionRange),tags:K.tags?.map(V.from)}}he.from=oe})(te=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(he){function le(oe){return new _.CallHierarchyIncomingCall(te.to(oe.from),oe.fromRanges.map(K=>d.to(K)))}he.to=le})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var fe;(function(he){function le(oe){return new _.CallHierarchyOutgoingCall(te.to(oe.to),oe.fromRanges.map(K=>d.to(K)))}he.to=le})(fe=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Se;(function(he){function le(K){return{range:K.range&&d.from(K.range),uri:K.uri}}he.from=le;function oe(K){return new _.Location(R.URI.revive(K.uri),d.to(K.range))}he.to=oe})(Se=e.location||(e.location={}));var ge;(function(he){function le(K){const _e=K,Ce=K;return{originSelectionRange:_e.originSelectionRange?d.from(_e.originSelectionRange):void 0,uri:_e.targetUri?_e.targetUri:Ce.uri,range:d.from(_e.targetRange?_e.targetRange:Ce.range),targetSelectionRange:_e.targetSelectionRange?d.from(_e.targetSelectionRange):void 0}}he.from=le;function oe(K){return{targetUri:R.URI.revive(K.uri),targetRange:d.to(K.range),targetSelectionRange:K.targetSelectionRange?d.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?d.to(K.originSelectionRange):void 0}}he.to=oe})(ge=e.DefinitionLink||(e.DefinitionLink={}));var ne;(function(he){function le(K){return{range:d.from(K.range),contents:E.fromMany(K.contents)}}he.from=le;function oe(K){return new _.Hover(K.contents.map(E.to),d.to(K.range))}he.to=oe})(ne=e.Hover||(e.Hover={}));var me;(function(he){function le(K){return{range:d.from(K.range),expression:K.expression}}he.from=le;function oe(K){return new _.EvaluatableExpression(d.to(K.range),K.expression)}he.to=oe})(me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ie;(function(he){function le(K){if(K instanceof _.InlineValueText)return{type:"text",range:d.from(K.range),text:K.text};if(K instanceof _.InlineValueVariableLookup)return{type:"variable",range:d.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof _.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}he.from=le;function oe(K){switch(K.type){case"text":return{range:d.to(K.range),text:K.text};case"variable":return{range:d.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:d.to(K.range),expression:K.expression}}}he.to=oe})(Ie=e.InlineValue||(e.InlineValue={}));var Ae;(function(he){function le(K){return{frameId:K.frameId,stoppedLocation:d.from(K.stoppedLocation)}}he.from=le;function oe(K){return new _.InlineValueContext(K.frameId,d.to(K.stoppedLocation))}he.to=oe})(Ae=e.InlineValueContext||(e.InlineValueContext={}));var Ue;(function(he){function le(K){return{range:d.from(K.range),kind:K.kind}}he.from=le;function oe(K){return new _.DocumentHighlight(d.to(K.range),K.kind)}he.to=oe})(Ue=e.DocumentHighlight||(e.DocumentHighlight={}));var Ke;(function(he){function le(oe){switch(oe){case 1:return _.CompletionTriggerKind.TriggerCharacter;case 2:return _.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return _.CompletionTriggerKind.Invoke}}he.to=le})(Ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var pe;(function(he){function le(oe){return{triggerKind:Ke.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}he.to=le})(pe=e.CompletionContext||(e.CompletionContext={}));var de;(function(he){function le(K){switch(K){case _.CompletionItemTag.Deprecated:return 1}}he.from=le;function oe(K){switch(K){case 1:return _.CompletionItemTag.Deprecated}}he.to=oe})(de=e.CompletionItemTag||(e.CompletionItemTag={}));var L;(function(he){const le=new Map([[_.CompletionItemKind.Method,0],[_.CompletionItemKind.Function,1],[_.CompletionItemKind.Constructor,2],[_.CompletionItemKind.Field,3],[_.CompletionItemKind.Variable,4],[_.CompletionItemKind.Class,5],[_.CompletionItemKind.Interface,7],[_.CompletionItemKind.Struct,6],[_.CompletionItemKind.Module,8],[_.CompletionItemKind.Property,9],[_.CompletionItemKind.Unit,12],[_.CompletionItemKind.Value,13],[_.CompletionItemKind.Constant,14],[_.CompletionItemKind.Enum,15],[_.CompletionItemKind.EnumMember,16],[_.CompletionItemKind.Keyword,17],[_.CompletionItemKind.Snippet,27],[_.CompletionItemKind.Text,18],[_.CompletionItemKind.Color,19],[_.CompletionItemKind.File,20],[_.CompletionItemKind.Reference,21],[_.CompletionItemKind.Folder,23],[_.CompletionItemKind.Event,10],[_.CompletionItemKind.Operator,11],[_.CompletionItemKind.TypeParameter,24],[_.CompletionItemKind.Issue,26],[_.CompletionItemKind.User,25]]);function oe(Ce){return le.get(Ce)??9}he.from=oe;const K=new Map([[0,_.CompletionItemKind.Method],[1,_.CompletionItemKind.Function],[2,_.CompletionItemKind.Constructor],[3,_.CompletionItemKind.Field],[4,_.CompletionItemKind.Variable],[5,_.CompletionItemKind.Class],[7,_.CompletionItemKind.Interface],[6,_.CompletionItemKind.Struct],[8,_.CompletionItemKind.Module],[9,_.CompletionItemKind.Property],[12,_.CompletionItemKind.Unit],[13,_.CompletionItemKind.Value],[14,_.CompletionItemKind.Constant],[15,_.CompletionItemKind.Enum],[16,_.CompletionItemKind.EnumMember],[17,_.CompletionItemKind.Keyword],[27,_.CompletionItemKind.Snippet],[18,_.CompletionItemKind.Text],[19,_.CompletionItemKind.Color],[20,_.CompletionItemKind.File],[21,_.CompletionItemKind.Reference],[23,_.CompletionItemKind.Folder],[10,_.CompletionItemKind.Event],[11,_.CompletionItemKind.Operator],[24,_.CompletionItemKind.TypeParameter],[25,_.CompletionItemKind.User],[26,_.CompletionItemKind.Issue]]);function _e(Ce){return K.get(Ce)??_.CompletionItemKind.Property}he.to=_e})(L=e.CompletionItemKind||(e.CompletionItemKind={}));var F;(function(he){function le(oe,K){const _e=new _.CompletionItem(oe.label);return _e.insertText=oe.insertText,_e.kind=L.to(oe.kind),_e.tags=oe.tags?.map(de.to),_e.detail=oe.detail,_e.documentation=b.isMarkdownString(oe.documentation)?E.to(oe.documentation):oe.documentation,_e.sortText=oe.sortText,_e.filterText=oe.filterText,_e.preselect=oe.preselect,_e.commitCharacters=oe.commitCharacters,N.Range.isIRange(oe.range)?_e.range=d.to(oe.range):typeof oe.range=="object"&&(_e.range={inserting:d.to(oe.range.insert),replacing:d.to(oe.range.replace)}),_e.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?_e.insertText=new _.SnippetString(oe.insertText):(_e.insertText=oe.insertText,_e.textEdit=_e.range instanceof _.Range?new _.TextEdit(_e.range,_e.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(_e.additionalTextEdits=oe.additionalTextEdits.map(Ce=>q.to(Ce))),_e.command=K&&oe.command?K.fromInternal(oe.command):void 0,_e}he.to=le})(F=e.CompletionItem||(e.CompletionItem={}));var C;(function(he){function le(K){return{label:K.label,documentation:K.documentation?E.fromStrict(K.documentation):void 0}}he.from=le;function oe(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?E.to(K.documentation):K.documentation}}he.to=oe})(C=e.ParameterInformation||(e.ParameterInformation={}));var M;(function(he){function le(K){return{label:K.label,documentation:K.documentation?E.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(C.from):[],activeParameter:K.activeParameter}}he.from=le;function oe(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?E.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(C.to):[],activeParameter:K.activeParameter}}he.to=oe})(M=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(he){function le(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(M.from):[]}}he.from=le;function oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(M.to):[]}}he.to=oe})(H=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(he){function le(oe,K){const _e=new _.InlayHint(typeof K.label=="string"?K.label:K.label.map(re.to.bind(void 0,oe)),a.to(K.position),ve.to(K.kind));return _e.tooltip=b.isMarkdownString(K.tooltip)?E.to(K.tooltip):K.tooltip,_e.paddingLeft=K.paddingLeft,_e.paddingRight=K.paddingRight,_e}he.to=le})(X=e.InlayHint||(e.InlayHint={}));var re;(function(he){function le(oe,K){const _e=new _.InlayHintLabelPart(K.label);return _e.tooltip=b.isMarkdownString(K.tooltip)?E.to(K.tooltip):K.tooltip,v.Command.is(K.command)&&(_e.command=oe.fromInternal(K.command)),K.location&&(_e.location=Se.to(K.location)),_e}he.to=le})(re=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(he){function le(K){return K}he.from=le;function oe(K){return K}he.to=oe})(ve=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(he){function le(K){return{range:d.from(K.range),url:K.target,tooltip:K.tooltip}}he.from=le;function oe(K){let _e;if(K.url)try{_e=typeof K.url=="string"?R.URI.parse(K.url,!0):R.URI.revive(K.url)}catch{}return new _.DocumentLink(d.to(K.range),_e)}he.to=oe})(ke=e.DocumentLink||(e.DocumentLink={}));var Me;(function(he){function le(K){const _e=new _.ColorPresentation(K.label);return K.textEdit&&(_e.textEdit=q.to(K.textEdit)),K.additionalTextEdits&&(_e.additionalTextEdits=K.additionalTextEdits.map(Ce=>q.to(Ce))),_e}he.to=le;function oe(K){return{label:K.label,textEdit:K.textEdit?q.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(_e=>q.from(_e)):void 0}}he.from=oe})(Me=e.ColorPresentation||(e.ColorPresentation={}));var Le;(function(he){function le(K){return new _.Color(K[0],K[1],K[2],K[3])}he.to=le;function oe(K){return[K.red,K.green,K.blue,K.alpha]}he.from=oe})(Le=e.Color||(e.Color={}));var ze;(function(he){function le(K){return{range:d.from(K.range)}}he.from=le;function oe(K){return new _.SelectionRange(d.to(K.range))}he.to=oe})(ze=e.SelectionRange||(e.SelectionRange={}));var Be;(function(he){function le(oe){switch(oe){case 2:return _.TextDocumentSaveReason.AfterDelay;case 1:return _.TextDocumentSaveReason.Manual;case 3:case 4:return _.TextDocumentSaveReason.FocusOut}}he.to=le})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Oe;(function(he){function le(K){switch(K){case _.TextEditorLineNumbersStyle.Off:return 0;case _.TextEditorLineNumbersStyle.Relative:return 2;case _.TextEditorLineNumbersStyle.On:default:return 1}}he.from=le;function oe(K){switch(K){case 0:return _.TextEditorLineNumbersStyle.Off;case 2:return _.TextEditorLineNumbersStyle.Relative;case 1:default:return _.TextEditorLineNumbersStyle.On}}he.to=oe})(Oe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Xe;(function(he){function le(K){if(K===_.EndOfLine.CRLF)return 1;if(K===_.EndOfLine.LF)return 0}he.from=le;function oe(K){if(K===1)return _.EndOfLine.CRLF;if(K===0)return _.EndOfLine.LF}he.to=oe})(Xe=e.EndOfLine||(e.EndOfLine={}));var tt;(function(he){function le(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case _.ProgressLocation.SourceControl:return 3;case _.ProgressLocation.Window:return 10;case _.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}he.from=le})(tt=e.ProgressLocation||(e.ProgressLocation={}));var Te;(function(he){function le(oe){const K={start:oe.start+1,end:oe.end+1};return oe.kind&&(K.kind=et.from(oe.kind)),K}he.from=le})(Te=e.FoldingRange||(e.FoldingRange={}));var et;(function(he){function le(oe){if(oe)switch(oe){case _.FoldingRangeKind.Comment:return v.FoldingRangeKind.Comment;case _.FoldingRangeKind.Imports:return v.FoldingRangeKind.Imports;case _.FoldingRangeKind.Region:return v.FoldingRangeKind.Region}}he.from=le})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var G;(function(he){function le(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?d.from(oe.selection):void 0,override:typeof oe.override=="boolean"?n.EditorResolution.DISABLED:void 0}}he.from=le})(G=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(he){function le(Ce){return Ce instanceof _.RelativePattern?Ce.toJSON():typeof Ce=="string"?Ce:oe(Ce)||K(Ce)?new _.RelativePattern(Ce.baseUri??Ce.base,Ce.pattern).toJSON():Ce}he.from=le;function oe(Ce){const $e=Ce;return $e?R.URI.isUri($e.baseUri)&&typeof $e.pattern=="string":!1}function K(Ce){const $e=Ce;return $e?typeof $e.base=="string"&&typeof $e.pattern=="string":!1}function _e(Ce){return typeof Ce=="string"?Ce:new _.RelativePattern(R.URI.revive(Ce.baseUri),Ce.pattern)}he.to=_e})(Q=e.GlobPattern||(e.GlobPattern={}));var ce;(function(he){function le(oe){if(oe){if(Array.isArray(oe))return oe.map(le);if(typeof oe=="string")return oe;{const K=oe;return{language:K.language,scheme:K.scheme,pattern:Q.from(K.pattern),exclusive:K.exclusive}}}else return}he.from=le})(ce=e.LanguageSelector||(e.LanguageSelector={}));var Re;(function(he){function le(K){return{start:K.start,end:K.end}}he.from=le;function oe(K){return new _.NotebookRange(K.start,K.end)}he.to=oe})(Re=e.NotebookRange||(e.NotebookRange={}));var xe;(function(he){function le(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}he.to=le;function oe(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}he.from=oe})(xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ge;(function(he){function le(K){switch(K){case _.NotebookCellKind.Markup:return i.CellKind.Markup;case _.NotebookCellKind.Code:default:return i.CellKind.Code}}he.from=le;function oe(K){switch(K){case i.CellKind.Markup:return _.NotebookCellKind.Markup;case i.CellKind.Code:default:return _.NotebookCellKind.Code}}he.to=oe})(Ge=e.NotebookCellKind||(e.NotebookCellKind={}));var Je;(function(he){function le(K){const _e={metadata:K.metadata??Object.create(null),cells:[]};for(let Ce of K.cells)_.NotebookCellData.validate(Ce),_e.cells.push(at.from(Ce));return _e}he.from=le;function oe(K){const _e=new _.NotebookData(K.cells.map(at.to));return(0,I.isEmptyObject)(K.metadata)||(_e.metadata=K.metadata),_e}he.to=oe})(Je=e.NotebookData||(e.NotebookData={}));var at;(function(he){function le(K){return{cellKind:Ge.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:xe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Dt.from):[]}}he.from=le;function oe(K){return new _.NotebookCellData(Ge.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Dt.to):void 0,K.metadata,K.internalMetadata?xe.to(K.internalMetadata):void 0)}he.to=oe})(at=e.NotebookCellData||(e.NotebookCellData={}));var yt;(function(he){function le(K){return{mime:K.mime,valueBytes:k.VSBuffer.wrap(K.data)}}he.from=le;function oe(K){return new _.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}he.to=oe})(yt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Dt;(function(he){function le(K){return{outputId:K.id,items:K.items.map(yt.from),metadata:K.metadata}}he.from=le;function oe(K){const _e=K.items.map(yt.to);return new _.NotebookCellOutput(_e,K.outputId,K.metadata)}he.to=oe})(Dt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ot;(function(he){function le(_e){return K(_e)?{include:(0,I.withNullAsUndefined)(Q.from(_e.include)),exclude:(0,I.withNullAsUndefined)(Q.from(_e.exclude))}:(0,I.withNullAsUndefined)(Q.from(_e))}he.from=le;function oe(_e){return K(_e)?{include:Q.to(_e.include),exclude:Q.to(_e.exclude)}:Q.to(_e)}he.to=oe;function K(_e){const Ce=_e;return Ce?!!Ce.include&&!!Ce.exclude:!1}})(Ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ve;(function(he){function le(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?x.from(oe.top):void 0}}he.from=le})(Ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var gt;(function(he){function le(oe,K,_e){const Ce=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===_.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ce,_e),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}he.from=le})(gt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Nt;(function(he){function le(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{}}}he.from=le})(Nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var it;(function(he){function le(K){return{uri:K.uri,provides:K.provides}}he.from=le;function oe(K){return new _.NotebookRendererScript(R.URI.revive(K.uri),K.provides)}he.to=oe})(it=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ot;(function(he){function le(K){return{message:E.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Se.from(K.location):void 0}}he.from=le;function oe(K){const _e=new _.TestMessage(typeof K.message=="string"?K.message:E.to(K.message));return _e.actualOutput=K.actual,_e.expectedOutput=K.expected,_e.location=K.location?Se.to(K.location):void 0,_e}he.to=oe})(ot=e.TestMessage||(e.TestMessage={}));var It;(function(he){let le;(function(oe){oe.Delimiter="\0"})(le||(le={})),he.namespace=(oe,K)=>oe+"\0"+K,he.denamespace=oe=>{const K=oe.indexOf("\0");return{ctrlId:oe.slice(0,K),tagId:oe.slice(K+1)}}})(It=e.TestTag||(e.TestTag={}));var Pt;(function(he){function le(Ce){const $e=(0,s.getPrivateApiFor)(Ce).controllerId;return{extId:u.TestId.fromExtHostTestItem(Ce,$e).toString(),label:Ce.label,uri:Ce.uri,tags:Ce.tags.map(We=>It.namespace($e,We.id)),range:d.from(Ce.range)||null,description:Ce.description||null,sortText:Ce.sortText||null,error:Ce.error&&E.fromStrict(Ce.error)||null}}he.from=le;function oe(Ce){return{parent:void 0,error:void 0,id:u.TestId.fromString(Ce.extId).localId,label:Ce.label,uri:R.URI.revive(Ce.uri),tags:(Ce.tags||[]).map($e=>{const{tagId:We}=It.denamespace($e);return new _.TestTag(We)}),range:d.to(Ce.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ce.description||void 0,sortText:Ce.sortText||void 0}}he.toPlain=oe;function K(Ce){const $e=u.TestId.fromString(Ce.extId),We=new s.TestItemImpl($e.controllerId,$e.localId,Ce.label,R.URI.revive(Ce.uri));return We.range=d.to(Ce.range||void 0),We.description=Ce.description||void 0,We.sortText=Ce.sortText||void 0,We}function _e(Ce){let $e;for(const We of Ce.tests){const nt=K(We.item);(0,s.getPrivateApiFor)(nt).parent=$e,$e=nt}return $e}he.toItemFromContext=_e})(Pt=e.TestItem||(e.TestItem={})),function(he){function le(K){return{id:K.id}}he.from=le;function oe(K){return new _.TestTag(K.id)}he.to=oe}(It=e.TestTag||(e.TestTag={}));var kt;(function(he){const le=(K,_e)=>{const Ce={...Pt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(We=>We.type===0).map(ot.to)})),children:K.children.map($e=>_e.get($e)).filter(I.isDefined).map($e=>le($e,_e))};for(const $e of Ce.children)$e.parent=Ce;return Ce};function oe(K){const _e=[],Ce=new Map;for(const $e of K.items)Ce.set($e.item.extId,$e),K.request.targets.some(We=>We.controllerId===$e.controllerId&&We.testIds.includes($e.item.extId))&&_e.push($e);return{completedAt:K.completedAt,results:_e.map($e=>le($e,Ce))}}he.to=oe})(kt=e.TestResults||(e.TestResults={}));var lt;(function(he){function le(Ce){return{covered:Ce.covered,total:Ce.covered}}function oe(Ce){return"line"in Ce?a.from(Ce):d.from(Ce)}function K(Ce){return"branches"in Ce?{count:Ce.executionCount,location:oe(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map($e=>({count:$e.executionCount,location:$e.location&&oe($e.location)})):void 0}:{type:0,count:Ce.executionCount,location:oe(Ce.location)}}he.fromDetailed=K;function _e(Ce){return{uri:Ce.uri,statement:le(Ce.statementCoverage),branch:Ce.branchCoverage&&le(Ce.branchCoverage),function:Ce.functionCoverage&&le(Ce.functionCoverage),details:Ce.detailedCoverage?.map(K)}}he.fromFile=_e})(lt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(he){function le(oe){switch(oe){case 1:return _.CodeActionTriggerKind.Invoke;case 2:return _.CodeActionTriggerKind.Automatic}}he.to=le})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(he){function le(K){const _e=new _.TypeHierarchyItem(J.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),d.to(K.range),d.to(K.selectionRange));return _e._sessionId=K._sessionId,_e._itemId=K._itemId,_e}he.to=le;function oe(K,_e,Ce){if(_e=_e??K._sessionId,Ce=Ce??K._itemId,_e===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:Ce,kind:J.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:d.from(K.range),selectionRange:d.from(K.selectionRange),tags:K.tags?.map(V.from)}}he.from=oe})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[167],be([1,0,2,15,7,8,227]),function(Y,e,r,k,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class O{constructor(R,N,v,n={timeout:1500,errors:3}){this._logService=R,this._documents=N,this._mainThreadBulkEdits=v,this._thresholds=n,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(N,v,n)=>{const s={dispose:this._callbacks.push([N,v,R])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(R,N){const v=r.URI.revive(R);let n=!1;const p=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let i of[...this._callbacks]){if(n)break;const u=this._documents.getDocument(v),S=await this._deliverEventAsyncAndBlameBadListeners(i,{document:u,reason:$.TextDocumentSaveReason.to(N)});s.push(S)}}finally{clearTimeout(p)}return s}_deliverEventAsyncAndBlameBadListeners([R,N,v],n){const p=this._badListeners.get(R);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(v,R,N,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const i=this._badListeners.get(R);this._badListeners.set(R,i?i+1:1),typeof i=="number"&&i>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,N,v,n){const p=[],s=Date.now(),{document:i,reason:u}=n,{version:S}=i,_=Object.freeze({document:i,reason:u,waitUntil(w){if(Object.isFrozen(p))throw(0,k.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(w))}});try{N.apply(v,[_])}catch(w){return Promise.reject(w)}return Object.freeze(p),new Promise((w,d)=>{const D=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(D),w(a)}).catch(a=>{clearTimeout(D),d(a)})}).then(w=>{const d={edits:[]};for(const D of w)if(Array.isArray(D)&&D.every(a=>a instanceof b.TextEdit))for(const{newText:a,newEol:P,range:c}of D)d.edits.push({_type:2,resource:i.uri,edit:{range:c&&$.Range.from(c),text:a,eol:P&&$.EndOfLine.from(P)}});if(d.edits.length!==0)return S===i.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=O}),define(Ee[168],be([1,0,9,26,2,8,83]),function(Y,e,r,k,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class O{constructor(v,n,p,s){this.start=v,this.deletedCount=n,this.deletedItems=p,this.items=s}static asApiEvents(v){return v.map(n=>({start:n.start,deletedCount:n.deletedCount,deletedItems:n.deletedItems,items:n.items.map(p=>p.apiCell)}))}}class I{constructor(v,n,p){this.notebook=v,this._extHostDocument=n,this._cellData=p,this.handle=p.handle,this.uri=b.URI.revive(p.uri),this.cellKind=p.cellKind,this._outputs=p.outputs.map($.NotebookCellOutput.to),this._internalMetadata=p.internalMetadata??{},this._metadata=Object.freeze(p.metadata??{}),this._previousResult=Object.freeze($.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}static asModelAddData(v,n){return{EOL:n.eol,lines:n.source,languageId:n.language,uri:n.uri,isDirty:!1,versionId:1,notebook:v}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const v=this,n=this._extHostDocument.getDocument(this.uri);if(!n)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return v.notebook.getCellIndex(v)},notebook:v.notebook.apiNotebook,kind:$.NotebookCellKind.to(this._cellData.cellKind),document:n.document,get mime(){return v._mime},set mime(p){v._mime=p},get outputs(){return v._outputs.slice(0)},get metadata(){return v._metadata},get executionSummary(){return v._previousResult}})}return this._apiCell}setOutputs(v){this._outputs=v.map($.NotebookCellOutput.to)}setOutputItems(v,n,p){const s=p.map($.NotebookCellOutputItem.to),i=this._outputs.find(u=>u.id===v);i&&(n||(i.items.length=0),i.items.push(...s))}setMetadata(v){this._metadata=Object.freeze(v)}setInternalMetadata(v){this._internalMetadata=v,this._previousResult=Object.freeze($.NotebookCellExecutionSummary.to(v))}setMime(v){}}e.ExtHostCell=I;class R{constructor(v,n,p,s,i,u){this._proxy=v,this._textDocumentsAndEditors=n,this._textDocuments=p,this._emitter=s,this.uri=i,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=u.viewType,this._metadata=Object.freeze(u.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,u.cells]],!0),this._versionId=u.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const v=this;this._notebook={get uri(){return v.uri},get version(){return v._versionId},get notebookType(){return v._notebookType},get isDirty(){return v._isDirty},get isUntitled(){return v.uri.scheme===r.Schemas.untitled},get isClosed(){return v._disposed},get metadata(){return v._metadata},get cellCount(){return v._cells.length},cellAt(n){return n=v._validateIndex(n),v._cells[n].apiCell},getCells(n){return(n?v._getCells(n):v._cells).map(s=>s.apiCell)},save(){return v._save()}}}return this._notebook}updateBackup(v){this._backup?.delete(),this._backup=v}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(v){v.metadata&&(this._metadata=Object.freeze({...this._metadata,...v.metadata}))}acceptDirty(v){this._isDirty=v}acceptModelChanged(v,n){this._versionId=v.versionId,this._isDirty=n;for(const p of v.rawEvents)p.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(p.changes,!1):p.kind===y.NotebookCellsChangeType.Move?this._moveCell(p.index,p.newIdx):p.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(p.index,p.outputs):p.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(p.index,p.outputId,p.append,p.outputItems):p.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(p.index,p.language):p.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(p.index,p.mime):p.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(p.index,p.metadata):p.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(p.index,p.internalMetadata)}_validateIndex(v){return v=v|0,v<0?0:v>=this._cells.length?this._cells.length-1:v}_validateRange(v){let n=v.start|0,p=v.end|0;return n<0&&(n=0),p>this._cells.length&&(p=this._cells.length),v.with({start:n,end:p})}_getCells(v){v=this._validateRange(v);const n=[];for(let p=v.start;p<v.end;p++)n.push(this._cells[p]);return n}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(v,n){if(this._disposed)return;const p=[],s=[],i=[];v.reverse().forEach(u=>{const _=u[2].map(D=>{const a=new I(this,this._textDocumentsAndEditors,D);return n||s.push(I.asModelAddData(this.apiNotebook,D)),a}),w=new O(u[0],u[1],[],_),d=this._cells.splice(u[0],u[1],..._);for(const D of d)i.push(D.uri),w.deletedItems.push(D.apiCell);p.push(w)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:i}),n||this._emitter.emitModelChange((0,k.deepFreeze)({document:this.apiNotebook,changes:O.asApiEvents(p)}))}_moveCell(v,n){const p=this._cells.splice(v,1);this._cells.splice(n,0,...p);const s=[new O(v,1,p.map(i=>i.apiCell),[]),new O(n,0,[],p)];this._emitter.emitModelChange((0,k.deepFreeze)({document:this.apiNotebook,changes:O.asApiEvents(s)}))}_setCellOutputs(v,n){const p=this._cells[v];p.setOutputs(n),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_setCellOutputItems(v,n,p,s){const i=this._cells[v];i.setOutputItems(n,p,s),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.apiNotebook,cells:[i.apiCell]}))}_changeCellLanguage(v,n){const p=this._cells[v];p.apiCell.document.languageId!==n&&this._textDocuments.$acceptModelLanguageChanged(p.uri,n)}_changeCellMime(v,n){const p=this._cells[v];p.apiCell.mime=n}_changeCellMetadata(v,n){const p=this._cells[v],s=p.apiCell.metadata;p.setMetadata(n);const i=p.apiCell.metadata;(0,k.equals)(s,i)||this._emitter.emitCellMetadataChange((0,k.deepFreeze)({document:this.apiNotebook,cell:p.apiCell}))}_changeCellInternalMetadata(v,n){this._cells[v].setInternalMetadata(n)}getCellFromApiCell(v){return this._cells.find(n=>n.apiCell===v)}getCellFromIndex(v){return this._cells[v]}getCell(v){return this._cells.find(n=>n.handle===v)}getCellIndex(v){return this._cells.indexOf(v)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(Ee[89],be([1,0,7,8,15]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class ${constructor(I){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=I}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(I){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:I})}replaceCellMetadata(I,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:I,metadata:R})}replaceCells(I,R,N){this._throwIfFinalized(),!(I===R&&N.length===0)&&this._collectedEdits.push({editType:1,index:I,count:R-I,cells:N.map(k.NotebookCellData.from)})}}class y{constructor(I,R,N,v,n,p){this.id=I,this._proxy=R,this.notebookData=N,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=v,this._viewColumn=p}get apiEditor(){if(!this._editor){const I=this;this._editor={get document(){return I.notebookData.apiNotebook},get selections(){return I._selections},set selections(R){if(!Array.isArray(R)||!R.every(r.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");I._selections=R,I._trySetSelections(R)},get visibleRanges(){return I._visibleRanges},revealRange(R,N){I._proxy.$tryRevealRange(I.id,k.NotebookRange.from(R),N??r.NotebookEditorRevealType.Default)},get viewColumn(){return I._viewColumn},edit(R){const N=new $(this.document.version);return R(N),I._applyEdit(N.finalize())},setDecorations(R,N){return I.setDecorations(R,N)}},y.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(I){this._visible=I}_acceptVisibleRanges(I){this._visibleRanges=I}_acceptSelections(I){this._selections=I}_trySetSelections(I){this._proxy.$trySetSelections(this.id,I.map(k.NotebookRange.from))}_acceptViewColumn(I){this._viewColumn=I}_applyEdit(I){if(I.cellEdits.length===0)return Promise.resolve(!0);const R=[];let N=-1;for(let v=0;v<I.cellEdits.length;v++){if(N<0){R.push(I.cellEdits[v]),N++;continue}const p=R[N],s=I.cellEdits[v];if(p.editType===1&&s.editType===1&&p.index===s.index){p.cells.push(...I.cellEdits[v].cells),p.count+=I.cellEdits[v].count;continue}R.push(I.cellEdits[v]),N++}return this._proxy.$tryApplyEdits(this.id,I.documentVersionId,R)}setDecorations(I,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(I.key)))return R.isEmpty?this._hasDecorationsForKey.delete(I.key):this._hasDecorationsForKey.add(I.key),this._proxy.$trySetDecorations(this.id,k.NotebookRange.from(R),I.key)}}e.ExtHostNotebookEditor=y,y.apiEditorsToExtHost=new WeakMap}),define(Ee[169],be([1,0,8,140,123,20,52,15]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,p,s){const i=this._handles++,{title:u,location:S,cancellable:_}=p,w={label:(0,b.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(i,{location:r.ProgressLocation.from(S),title:u,source:w,cancellable:_},n.isUnderDevelopment?void 0:n.identifier.value).catch(O.onUnexpectedExternalError),this._withProgress(i,s,!!_)}_withProgress(n,p,s){let i;s&&(i=new $.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,i));const u=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),i&&i.dispose()};let S;try{S=p(new N(this._proxy,n),s&&i?i.token:$.CancellationToken.None)}catch(_){throw u(n),_}return S.then(_=>u(n),_=>u(n)),S}$acceptProgressCanceled(n){const p=this._mapHandleToCancellationSource.get(n);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=I;function R(v,n){return v.message=n.message,typeof n.increment=="number"&&(typeof v.increment=="number"?v.increment+=n.increment:v.increment=n.increment),v}class N extends k.Progress{constructor(n,p){super(s=>this.throttledReport(s));this._proxy=n,this._handle=p}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}Fe([(0,y.throttle)(100,(v,n)=>R(v,n),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(Ee[90],be([1,0,42,15,53,8,7]),function(Y,e,r,k,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class O{constructor(n,p,s){const i=O._Keys.nextId();n.$registerTextEditorDecorationType(p.identifier,i,$.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:i,dispose(){n.$removeTextEditorDecorationType(i)}})}}e.TextEditorDecorationType=O,O._Keys=new b.IdGenerator("TextEditorDecorationType");class I{constructor(n,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,p){this._throwIfFinalized();let s=null;if(n instanceof y.Position)s=new y.Range(n,n);else if(n instanceof y.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,p,!1)}insert(n,p){this._throwIfFinalized(),this._pushEdit(new y.Range(n,n),p,!0)}delete(n){this._throwIfFinalized();let p=null;if(n instanceof y.Range)p=n;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(n,p,s){const i=this._document.validateRange(n);this._collectedEdits.push({range:i,text:p,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==y.EndOfLine.LF&&n!==y.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=I;class R{constructor(n,p,s,i){this._proxy=n,this._id=p,this._accept(s),this._logService=i;const u=this;this.value={get tabSize(){return u._tabSize},set tabSize(S){u._setTabSize(S)},get insertSpaces(){return u._insertSpaces},set insertSpaces(S){u._setInsertSpaces(S)},get cursorStyle(){return u._cursorStyle},set cursorStyle(S){u._setCursorStyle(S)},get lineNumbers(){return u._lineNumbers},set lineNumbers(S){u._setLineNumbers(S)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=$.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const p=Math.floor(n);return p>0?p:null}if(typeof n=="string"){const p=parseInt(n,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(n){const p=this._validateTabSize(n);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const p=this._validateInsertSpaces(n);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:$.TextEditorLineNumbersStyle.from(n)})))}assign(n){const p={};let s=!1;if(typeof n.tabSize!="undefined"){const i=this._validateTabSize(n.tabSize);i==="auto"?(s=!0,p.tabSize=i):typeof i=="number"&&this._tabSize!==i&&(this._tabSize=i,s=!0,p.tabSize=i)}if(typeof n.insertSpaces!="undefined"){const i=this._validateInsertSpaces(n.insertSpaces);i==="auto"?(s=!0,p.insertSpaces=i):this._insertSpaces!==i&&(this._insertSpaces=i,s=!0,p.insertSpaces=i)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,p.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,p.lineNumbers=$.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,p))}_warnOnError(n,p){p.catch(s=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(s)})}}e.ExtHostTextEditorOptions=R;class N{constructor(n,p,s,i,u,S,_,w){this.id=n,this._proxy=p,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._options=new R(this._proxy,this.id,S,s),this._visibleRanges=_,this._viewColumn=w;const d=this;this.value=Object.freeze({get document(){return i.getValue()},set document(D){throw(0,k.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(D){if(!(D instanceof y.Selection))throw(0,k.illegalArgument)("selection");d._selections=[D],d._trySetSelection()},get selections(){return d._selections},set selections(D){if(!Array.isArray(D)||D.some(a=>!(a instanceof y.Selection)))throw(0,k.illegalArgument)("selections");d._selections=D,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(D){throw(0,k.readonly)("visibleRanges")},get options(){return d._options.value},set options(D){d._disposed||d._options.assign(D)},get viewColumn(){return d._viewColumn},set viewColumn(D){throw(0,k.readonly)("viewColumn")},edit(D,a={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const P=new I(i.getValue(),a);return D(P),d._applyEdit(P)},insertSnippet(D,a,P={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!a||Array.isArray(a)&&a.length===0)c=d._selections.map(t=>$.Range.from(t));else if(a instanceof y.Position){const{lineNumber:t,column:h}=$.Position.from(a);c=[{startLineNumber:t,startColumn:h,endLineNumber:t,endColumn:h}]}else if(a instanceof y.Range)c=[$.Range.from(a)];else{c=[];for(const t of a)if(t instanceof y.Range)c.push($.Range.from(t));else{const{lineNumber:h,column:o}=$.Position.from(t);c.push({startLineNumber:h,startColumn:o,endLineNumber:h,endColumn:o})}}return p.$tryInsertSnippet(n,D.value,c,P)},setDecorations(D,a){const P=a.length===0;P&&!d._hasDecorationsForKey.has(D.key)||(P?d._hasDecorationsForKey.delete(D.key):d._hasDecorationsForKey.add(D.key),d._runOnProxy(()=>{if($.isDecorationOptionsArr(a))return p.$trySetDecorations(n,D.key,$.fromRangeOrRangeWithMessage(a));{const c=new Array(4*a.length);for(let t=0,h=a.length;t<h;t++){const o=a[t];c[4*t]=o.start.line+1,c[4*t+1]=o.start.character+1,c[4*t+2]=o.end.line+1,c[4*t+3]=o.end.character+1}return p.$trySetDecorationsFast(n,D.key,c)}}))},revealRange(D,a){d._runOnProxy(()=>p.$tryRevealRange(n,$.Range.from(D),a||y.TextEditorRevealType.Default))},show(D){p.$tryShowEditor(n,$.ViewColumn.from(D))},hide(){p.$tryHideEditor(n)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,r.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,r.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,r.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,r.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map($.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const p=n.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const s=p.edits.map(u=>u.range);s.sort((u,S)=>u.end.line===S.end.line?u.end.character===S.end.character?u.start.line===S.start.line?u.start.character-S.start.character:u.start.line-S.start.line:u.end.character-S.end.character:u.end.line-S.end.line);for(let u=0,S=s.length-1;u<S;u++){const _=s[u].end;if(s[u+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const i=p.edits.map(u=>({range:$.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,i,{setEndOfLine:typeof p.setEndOfLine=="number"?$.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=N}),define(Ee[170],be([1,0,11,5,6,13,48,8,84,61]),function(Y,e,r,k,b,$,y,O,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class N extends b.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new k.Emitter),this.root=new y.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const p=this.diff[this.diff.length-1];if(p&&n[0]===1){if(p[0]===1&&p[1].extId===n[1].extId){(0,I.applyTestItemUpdate)(p[1],n[1]);return}if(p[0]===0&&p[1].item.extId===n[1].extId){(0,I.applyTestItemUpdate)(p[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,p){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||p>s.expandLevels)&&(s.expandLevels=p),s.expand===1){const i=this.resolveChildren(s);return i.isOpen()?this.expandChildren(s,p-1):i.wait().then(()=>this.expandChildren(s,p-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,p-1)):this.expandChildren(s,p-1)}}dispose(){for(const n of this.tree.values())(0,y.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,p){switch(p.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(R.TestId.joinToString(n.fullId,p.id));break;case 0:this.upsertItem(p.item,n);break;case 4:for(const s of p.ops)this.onTestItemEvent(n,s);break;case 3:{const{key:s,value:i,previous:u}=p,S=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(i,u,S);break;case"range":this.pushDiff([1,{extId:S,item:{range:O.Range.from(i)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:O.MarkdownString.fromStrict(i)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[s]:i??null}}]);break}break}default:(0,$.assertNever)(p)}}upsertItem(n,p){if(!(n instanceof y.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=R.TestId.fromExtHostTestItem(n,this.root.id,p?.actual),i=(0,y.getPrivateApiFor)(n);i.parent&&i.parent!==p?.actual&&i.parent.children.delete(n.id);let u=this.tree.get(s.toString());if(!u){u={fullId:s,actual:n,parent:p?s.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(u.fullId.toString(),u),this.setItemParent(n,p),this.pushDiff([0,{parent:u.parent&&u.parent.toString(),controllerId:this.controllerId,expand:u.expand,item:O.TestItem.from(n)}]),this.connectItemAndChildren(n,u,p);return}if(u.actual===n){this.connectItem(n,u,p);return}const S=u.actual.children,_=u.actual,w=(0,y.diffTestItems)(_,n);(0,y.getPrivateApiFor)(_).listener=void 0,u.actual=n,u.expand=0;for(const[d,D]of w)this.onTestItemEvent(u,{op:3,key:d,value:D,previous:_[d]});this.connectItemAndChildren(n,u,p);for(const d of S)n.children.get(d.id)||this.removeItem(R.TestId.joinToString(s,d.id))}diffTagRefs(n,p,s){const i=new Set(p.map(u=>u.id));for(const u of n)i.delete(u.id)||this.incrementTagRefs(u);this.pushDiff([1,{extId:s,item:{tags:n.map(u=>O.TestTag.namespace(this.controllerId,u.id))}}]),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const p=this.tags.get(n.id);p?p.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:O.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const p=this.tags.get(n);p&&!--p.refCount&&(this.tags.delete(n),this.pushDiff([6,O.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,p){(0,y.getPrivateApiFor)(n).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(n,p,s){this.setItemParent(n,s);const i=(0,y.getPrivateApiFor)(n);i.parent=s?.actual,i.listener=u=>this.onTestItemEvent(p,u),this.updateExpandability(p)}connectItemAndChildren(n,p,s){this.connectItem(n,p,s);for(const i of n.children)this.upsertItem(i,p)}updateExpandability(n){let p;this._resolveHandler?n.resolveBarrier?p=n.resolveBarrier.isOpen()?3:2:p=n.actual.canResolveChildren?1:0:p=0,p!==n.expand&&(n.expand=p,this.pushDiff([1,{extId:n.fullId.toString(),expand:p}]),p===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,p){if(p<0)return;const s=[];for(const i of n.actual.children){const u=this.expand(R.TestId.joinToString(n.fullId,i.id),p);(0,r.isThenable)(u)&&s.push(u)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const u=new r.Barrier;return u.open(),u}n.expand=2,this.pushExpandStateUpdate(n);const p=n.resolveBarrier=new r.Barrier,s=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=u.stack||u.message||String(u))};let i;try{i=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(u){s(u)}return(0,r.isThenable)(i)?i.catch(s).then(()=>{p.open(),this.updateExpandability(n)}):(p.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const p=this.tree.get(n);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[p];for(;s.length;){const i=s.pop();if(!!i){(0,y.getPrivateApiFor)(i.actual).listener=void 0;for(const u of i.actual.tags)this.decrementTagRefs(u.id);this.tree.delete(i.fullId.toString());for(const u of i.actual.children)s.push(this.tree.get(R.TestId.joinToString(i.fullId,u.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=N}),define(Ee[171],be([1,0,3,137]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(k.IEnvironmentService)}),define(Ee[172],be([1,0,25,5,17]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class ${constructor(N){this.removedDueToLooping=N}}e.DeltaExtensionsResult=$;class y{constructor(N){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=N,this._initialize()}_initialize(){this._extensionDescriptions.sort(I),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const N of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(N.identifier))){console.error("Extension `"+N.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(N.identifier),N),this._extensionsArr.push(N),Array.isArray(N.activationEvents))for(let v of N.activationEvents)v==="onUri"&&(v=`onUri:${r.ExtensionIdentifier.toKey(N.identifier)}`),this._activationMap.has(v)||this._activationMap.set(v,[]),this._activationMap.get(v).push(N)}}keepOnly(N){const v=new Set;N.forEach(n=>v.add(r.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>v.has(r.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(N,v){N.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(N));const n=y._findLoopingExtensions(this._extensionDescriptions);if(v=v.concat(n.map(p=>p.identifier)),v.length>0){const p=new Set;v.forEach(s=>p.add(r.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!p.has(r.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new $(n)}static _findLoopingExtensions(N){const v=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(u){this._nodesSet.has(u)||(this._nodesSet.add(u),this._nodesArr.push(u))}addArc(u,S){this.addNode(u),this.addNode(S),this._arcs.has(u)?this._arcs.get(u).push(S):this._arcs.set(u,[S])}getArcs(u){return this._arcs.has(u)?this._arcs.get(u):[]}hasOnlyGoodArcs(u,S){const _=v.getArcs(u);for(let w=0;w<_.length;w++)if(!S.has(_[w]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let u of N){const S=r.ExtensionIdentifier.toKey(u.identifier);if(n.set(S,u),u.extensionDependencies)for(let _ of u.extensionDependencies){const w=r.ExtensionIdentifier.toKey(_);v.addArc(S,w)}}let p=new Set;v.getNodes().filter(u=>v.getArcs(u).length===0).forEach(u=>p.add(u));let s=v.getNodes().filter(u=>!p.has(u)),i;do{i=!1;for(let u=0;u<s.length;u++){const S=s[u];v.hasOnlyGoodArcs(S,p)&&(s.splice(u,1),u--,p.add(S),i=!0)}}while(i);return s.map(u=>n.get(u))}containsActivationEvent(N){return this._activationMap.has(N)}containsExtension(N){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(N))}getExtensionDescriptionsForActivationEvent(N){const v=this._activationMap.get(N);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(N){const v=this._extensionsMap.get(r.ExtensionIdentifier.toKey(N));return v||void 0}}e.ExtensionDescriptionRegistry=y;var O;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(O||(O={}));function I(R,N){const v=R.isBuiltin?0:R.isUnderDevelopment?2:1,n=N.isBuiltin?0:N.isUnderDevelopment?2:1;if(v!==n)return v-n;const p=b.posix.basename(R.extensionLocation.path),s=b.posix.basename(N.extensionLocation.path);return p<s?-1:p>s?1:0}}),define(Ee[91],be([1,0,21]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var k;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var b;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var $;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})($=e.MessageType||(e.MessageType={}));function y(I){const R=r.VSBuffer.alloc(1);switch(I){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=y;function O(I,R){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=O}),define(Ee[27],be([1,0,5,2,3,25,143]),function(Y,e,r,k,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new $.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");var O;(function(d){d[d.None=0]="None",d[d.LocalProcess=1]="LocalProcess",d[d.LocalWebWorker=2]="LocalWebWorker",d[d.Remote=3]="Remote"})(O=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function I(d){switch(d){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=I;class R{constructor(D){this.dependency=D}}e.MissingExtensionDependency=R;var N;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(N=e.ExtensionHostKind||(e.ExtensionHostKind={}));function v(d){switch(d){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=v;function n(d,D){return d.enabledApiProposals?d.enabledApiProposals.includes(D):!1}e.isProposedApiEnabled=n;function p(d,D){if(!n(d,D))throw new Error(`Extension '${d.identifier.value}' CANNOT use API proposal: ${D}.
Its package.json#enabledApiProposals-property declares: ${d.enabledApiProposals?.join(", ")??"[]"} but NOT ${D}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.checkProposedApiEnabled=p;class s{constructor(D,a,P,c){this.codeLoadingTime=D,this.activateCallTime=a,this.activateResolvedTime=P,this.activationReason=c}}e.ActivationTimes=s;class i{constructor(D,a){this.description=D,this.value=a}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var u;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(u=e.ActivationKind||(e.ActivationKind={}));function S(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=S;function _(d,D){return{identifier:new $.ExtensionIdentifier((0,y.getExtensionId)(d.manifest.publisher,d.manifest.name)),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!!D,extensionLocation:d.location,...d.manifest,uuid:d.identifier.uuid}}e.toExtensionDescription=_;class w{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None}activateByEvent(D){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(D){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(D){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(D){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(D,a){return Promise.resolve()}}e.NullExtensionService=w}),define(Ee[173],be([1,0,15,25,27,12]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class O{constructor(i,u,S,_){this.startup=i,this.codeLoadingTime=u,this.activateCallTime=S,this.activateResolvedTime=_}}e.ExtensionActivationTimes=O,O.NONE=new O(!1,-1,-1,-1);class I{constructor(i){this._startup=i,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(i,u){return i===-1||u===-1?-1:u-i}build(){return new O(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class R{constructor(i,u,S,_,w,d){this.activationFailed=i,this.activationFailedError=u,this.activationTimes=S,this.module=_,this.exports=w,this.subscriptions=d}}e.ActivatedExtension=R;class N extends R{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=N;class v extends R{constructor(){super(!1,null,O.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class n extends R{constructor(i){super(!0,i,O.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let p=class{constructor(i,u,S,_,w){this._logService=w,this._isDisposed=!1,this._registry=i,this._resolvedExtensionsSet=new Set,u.forEach(d=>this._resolvedExtensionsSet.add(k.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,S.forEach(d=>this._hostExtensionsMap.set(k.ExtensionIdentifier.toKey(d),d)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(i){const u=k.ExtensionIdentifier.toKey(i);return this._activatedExtensions.has(u)}getActivatedExtension(i){const u=k.ExtensionIdentifier.toKey(i),S=this._activatedExtensions.get(u);if(!S)throw new Error("Extension `"+i.value+"` is not known or not activated");return S}activateByEvent(i,u){if(this._alreadyActivatedEvents[i])return y;const S=this._registry.getExtensionDescriptionsForActivationEvent(i);return this._activateExtensions(S.map(_=>({id:_.identifier,reason:{startup:u,extensionId:_.identifier,activationEvent:i}}))).then(()=>{this._alreadyActivatedEvents[i]=!0})}activateById(i,u){const S=this._registry.getExtensionDescription(i);if(!S)throw new Error("Extension `"+i+"` is not known");return this._activateExtensions([{id:S.identifier,reason:u}])}_handleActivateRequest(i,u,S){if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(i.id))){u[k.ExtensionIdentifier.toKey(i.id)]=i;return}const _=this._registry.getExtensionDescription(i.id);if(!_){const D=new Error(`Cannot activate unknown extension '${i.id.value}'`);this._host.onExtensionActivationError(i.id,D,new b.MissingExtensionDependency(i.id.value)),this._activatedExtensions.set(k.ExtensionIdentifier.toKey(i.id),new n(D));return}const w=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let d=!0;for(let D=0,a=w.length;D<a;D++){const P=w[D];if(this._resolvedExtensionsSet.has(k.ExtensionIdentifier.toKey(P)))continue;const c=this._activatedExtensions.get(k.ExtensionIdentifier.toKey(P));if(c&&!c.activationFailed)continue;if(c&&c.activationFailed){const l=_.displayName||_.identifier.value,f=this._registry.getExtensionDescription(P),m=f&&f.displayName||P,E=new Error(`Cannot activate the '${l}' extension because its dependency '${m}' failed to activate`);E.detail=c.activationFailedError,this._host.onExtensionActivationError(_.identifier,E,null),this._activatedExtensions.set(k.ExtensionIdentifier.toKey(_.identifier),new n(E));return}if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(P))){d=!1,u[k.ExtensionIdentifier.toKey(P)]={id:this._hostExtensionsMap.get(k.ExtensionIdentifier.toKey(P)),reason:i.reason};continue}const t=this._registry.getExtensionDescription(P);if(t){if(!t.main&&!t.browser)continue;d=!1,u[k.ExtensionIdentifier.toKey(P)]={id:t.identifier,reason:i.reason};continue}const h=_.displayName||_.identifier.value,o=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${P}'`);this._host.onExtensionActivationError(_.identifier,o,new b.MissingExtensionDependency(P)),this._activatedExtensions.set(k.ExtensionIdentifier.toKey(_.identifier),new n(o));return}d?u[k.ExtensionIdentifier.toKey(_.identifier)]=i:S.push(i)}_activateExtensions(i){if(i.length===0||(i=i.filter(w=>!this._activatedExtensions.has(k.ExtensionIdentifier.toKey(w.id))),i.length===0))return Promise.resolve(void 0);const u=Object.create(null),S=[];for(let w=0,d=i.length;w<d;w++)this._handleActivateRequest(i[w],u,S);for(let w=0,d=S.length;w<d;w++){const D=k.ExtensionIdentifier.toKey(S[w].id);u[D]&&delete u[D]}const _=Object.keys(u).map(w=>u[w]);return S.length===0?Promise.all(_.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(_).then(w=>this._activateExtensions(S))}_activateExtension(i,u){const S=k.ExtensionIdentifier.toKey(i);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const _=this._activatingExtensions.get(S);if(_)return _;const w=this._host.actualActivateExtension(i,u).then(void 0,d=>{const D=new Error;return d&&d.name&&(D.name=d.name),d&&d.message?D.message=`Activating extension '${i.value}' failed: ${d.message}.`:D.message=`Activating extension '${i.value}' failed: ${d}.`,d&&d.stack&&(D.stack=d.stack),this._isDisposed&&r.isCancellationError(d)?new n(d):(this._host.onExtensionActivationError(i,D,null),this._logService.error(`Activating extension ${i.value} failed due to an error:`),this._logService.error(d),new n(d))}).then(d=>{this._activatedExtensions.set(S,d),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,w),w}};p=Fe([Ne(4,$.ILogService)],p),e.ExtensionsActivator=p}),define(Ee[174],be([1,0,12,28,27]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let $=class extends r.LogService{constructor(O,I){super(O.createLogger(I.logFile,{name:b.ExtensionHostLogFileName}))}};$=Fe([Ne(0,r.ILoggerService),Ne(1,k.IExtHostInitDataService)],$),e.ExtHostLogService=$}),define(Ee[175],be([1,0,15]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise(($,y)=>{this._actualOk=$,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk($){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=$,this._actual&&this._actualOk($))}resolveErr($){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=$,this._actual?this._actualErr($):(0,r.onUnexpectedError)($))}then($,y){return this._ensureActual().then($,y)}catch($){return this._ensureActual().then(void 0,$)}finally($){return this._ensureActual().finally($)}}e.LazyPromise=k}),define(Ee[38],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(I){this._proxyIdentifierBrand=void 0,this.sid=I,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const k=[];function b(O){const I=new r(O);return k[I.nid]=I,I}e.createProxyIdentifier=b;function $(O){return k[O].sid}e.getStringIdentifierForProxy=$;class y{constructor(I){this.value=I}}e.SerializableObjectWithBuffers=y}),define(Ee[4],be([1,0,54,2,38]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=void 0;var $;(function(S){S[S.Default=0]="Default",S[S.InCenter=1]="InCenter",S[S.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",S[S.AtTop=3]="AtTop"})($=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(S){S[S.Editable=0]="Editable",S[S.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var O;(function(S){S[S.Int8Array=1]="Int8Array",S[S.Uint8Array=2]="Uint8Array",S[S.Uint8ClampedArray=3]="Uint8ClampedArray",S[S.Int16Array=4]="Int16Array",S[S.Uint16Array=5]="Uint16Array",S[S.Int32Array=6]="Int32Array",S[S.Uint32Array=7]="Uint32Array",S[S.Float32Array=8]="Float32Array",S[S.Float64Array=9]="Float64Array",S[S.BigInt64Array=10]="BigInt64Array",S[S.BigUint64Array=11]="BigUint64Array"})(O=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(S){S[S.Text=1]="Text",S[S.Error=2]="Error",S[S.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(S){S[S.Default=0]="Default",S[S.InCenter=1]="InCenter",S[S.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",S[S.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(S){S[S.None=0]="None",S[S.Process=1]="Process",S[S.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class v{static mixin(_){return _._id=v._n++,_}}e.IdObject=v,v._n=0;var n;(function(S){S.label="a",S.kind="b",S.detail="c",S.documentation="d",S.sortText="e",S.filterText="f",S.preselect="g",S.insertText="h",S.insertTextRules="i",S.range="j",S.commitCharacters="k",S.additionalTextEdits="l",S.command="m",S.kindModifier="n"})(n=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(S){S.defaultRanges="a",S.completions="b",S.isIncomplete="c",S.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var s;(function(S){S[S.File=1]="File",S[S.Text=2]="Text",S[S.Cell=3]="Cell"})(s=e.WorkspaceEditType||(e.WorkspaceEditType={}));function i(S){if(S&&S.edits)for(const _ of S.edits)typeof _.resource=="object"?_.resource=k.URI.revive(_.resource):(_.newUri=k.URI.revive(_.newUri),_.oldUri=k.URI.revive(_.oldUri)),_.metadata&&_.metadata.iconPath&&(_.metadata=(0,r.revive)(_.metadata));return S}e.reviveWorkspaceEditDto=i;var u;(function(S){S[S.Workspace=0]="Workspace",S[S.TextDocument=1]="TextDocument"})(u=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,b.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,b.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,b.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,b.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[62],be([1,0,4,5,3]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class ${constructor(O){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=O.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(O){this._onDidChangePassword.fire(O)}get(O,I){return this._proxy.$getPassword(O,I)}store(O,I,R){return this._proxy.$setPassword(O,I,R)}delete(O,I){return this._proxy.$deletePassword(O,I)}}e.ExtHostSecretState=$,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(Ee[63],be([1,0,3,12,4,14]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(I,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=I.getProxy(b.MainContext.MainThreadTelemetry)}report(I,R,N){const v=this.getUsageKey(I,R);this._reportedUsages.has(v)||(this._reportedUsages.add(v),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${I}' is deprecated. ${N}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:I}))}getUsageKey(I,R){return`${I}-${R.identifier.value}`}};y=Fe([Ne(0,$.IExtHostRpcService),Ne(1,k.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(O,I,R){}})}),define(Ee[176],be([1,0,5,4,7,25]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(I){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=I.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(I){return this._providers=I,Promise.resolve()}async getSession(I,R,N,v={}){const n=$.ExtensionIdentifier.toKey(I.identifier),p=this._inFlightRequests.get(n)||[],s=[...N].sort().join(" ");let i=p.find(u=>u.scopes===s);if(i)return i.result;{const u=this._getSession(I,n,R,N,v);i={scopes:s,result:u},p.push(i),this._inFlightRequests.set(n,p);try{await u}finally{const S=p.findIndex(_=>_.scopes===s);S>-1&&(p.splice(S),this._inFlightRequests.set(n,p))}return u}}async _getSession(I,R,N,v,n={}){await this._proxy.$ensureProvider(N);const p=I.displayName||I.name;return this._proxy.$getSession(N,v,R,p,n)}async removeSession(I,R){const N=this._authenticationProviders.get(I);return N?N.provider.removeSession(R):this._proxy.$removeSession(I,R)}registerAuthenticationProvider(I,R,N,v){if(this._authenticationProviders.get(I))throw new Error(`An authentication provider with id '${I}' is already registered.`);this._authenticationProviders.set(I,{label:R,provider:N,options:v??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===I)||this._providers.push({id:I,label:R});const n=N.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(I,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(I,R,v?.supportsMultipleAccounts??!1),new b.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(I);const p=this._providers.findIndex(s=>s.id===I);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(I)})}$createSession(I,R){const N=this._authenticationProviders.get(I);if(N)return Promise.resolve(N.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${I}`)}$removeSession(I,R){const N=this._authenticationProviders.get(I);if(N)return Promise.resolve(N.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${I}`)}$getSessions(I,R){const N=this._authenticationProviders.get(I);if(N)return Promise.resolve(N.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${I}`)}$onDidChangeAuthenticationSessions(I,R){return this._onDidChangeSessions.fire({provider:{id:I,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(Ee[177],be([1,0,4,14,8]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let $=class{constructor(O,I){this._proxy=O.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>I.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(O){const I=b.WorkspaceEdit.from(O,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(I)}};$=Fe([Ne(0,k.IExtHostRpcService)],$),e.ExtHostBulkEdits=$}),define(Ee[178],be([1,0,4]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor($){const y=$.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(O){return y.$writeText(O)}})}}e.ExtHostClipboard=k});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[39],be([1,0,13,7,8,26,4,16,12,54,87,228,2,6,3,14,48,21,38,43]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_,w){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let D=class{constructor(o,l){d.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,je(this,d,o.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=l,this.converter=new a(this,f=>{const m=this._apiCommands.get(f);return m?.result===c.Void?m:void 0},l),this._argumentProcessors=[{processArgument(f){return(0,R.revive)(f)}},{processArgument(f){return(0,$.cloneAndChange)(f,function(m){if(N.Range.isIRange(m))return b.Range.to(m);if(v.Position.isIPosition(m))return b.Position.to(m);if(N.Range.isIRange(m.range)&&n.URI.isUri(m.uri))return b.location.to(m);if(m instanceof S.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const l=this.registerCommand(!1,o.id,async(...f)=>{const m=o.args.map((T,A)=>{if(!T.validate(f[A]))throw new Error(`Invalid argument '${T.name}' when running '${o.id}', received: ${f[A]}`);return T.convert(f[A])}),E=await this.executeCommand(o.internalId,...m);return o.result.convert(E,f,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new k.Disposable(()=>{l.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,l,f,m,E,T){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:f,thisArg:m,description:E,extension:T}),o&&De(this,d,"f").$registerCommand(l),new k.Disposable(()=>{this._commands.delete(l)&&o&&De(this,d,"f").$unregisterCommand(l)})}executeCommand(o,...l){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,l,!0)}async _doExecuteCommand(o,l,f){if(this._commands.has(o))return this._executeContributedCommand(o,l,!1);{let m=!1;const E=(0,$.cloneAndChange)(l,function(T){if(T instanceof k.Position)return b.Position.from(T);if(T instanceof k.Range)return b.Range.from(T);if(T instanceof k.Location)return b.location.from(T);if(k.NotebookRange.isNotebookRange(T))return b.NotebookRange.from(T);if(T instanceof ArrayBuffer)return m=!0,S.VSBuffer.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return m=!0,S.VSBuffer.wrap(T);if(!Array.isArray(T))return T});try{const T=await De(this,d,"f").$executeCommand(o,m?new _.SerializableObjectWithBuffers(E):E,f);return(0,R.revive)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this._doExecuteCommand(o,l,!1);throw T}}}async _executeContributedCommand(o,l,f){const m=this._commands.get(o);if(!m)throw new Error("Unknown command");let{callback:E,thisArg:T,description:A}=m;if(A)for(let x=0;x<A.args.length;x++)try{(0,r.validateConstraint)(l[x],A.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${A.args[x].name}' - ${A.args[x].description}`)}try{return await E.apply(T,l)}catch(x){if(o===this.converter.delegatingCommandId){const g=this.converter.getActualCommand(...l);g&&(o=g.command)}throw this._logService.error(x,o,m.extension?.identifier),f?new class extends Error{constructor(){super((0,w.toErrorMessage)(x));this.id=o,this.source=m.extension?.displayName??m.extension?.name}}:x}}$executeContributedCommand(o,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(l=l.map(f=>this._argumentProcessors.reduce((m,E)=>E.processArgument(m),f)),this._executeContributedCommand(o,l,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),De(this,d,"f").$getCommands().then(l=>(o&&(l=l.filter(f=>f[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(let[l,f]of this._commands){let{description:m}=f;m&&(o[l]=m)}return Promise.resolve(o)}};d=new WeakMap,D=Fe([Ne(0,i.IExtHostRpcService),Ne(1,I.ILogService)],D),e.ExtHostCommands=D,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class a{constructor(o,l,f){this._commands=o,this._lookupApiCommand=l,this._logService=f,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,l){if(!o)return;const f={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return f;const m=this._lookupApiCommand(o.command);if(m)f.id=m.internalId,f.arguments=m.args.map((E,T)=>E.convert(o.arguments&&o.arguments[T]));else if((0,O.isNonEmptyArray)(o.arguments)){const E=++this._cachIdPool;this._cache.set(E,o),l.add((0,p.toDisposable)(()=>{this._cache.delete(E),this._logService.trace("CommandsConverter#DISPOSE",E)})),f.$ident=E,f.id=this.delegatingCommandId,f.arguments=[E],this._logService.trace("CommandsConverter#CREATE",o.command,E)}return f}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const l=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class P{constructor(o,l,f,m){this.name=o,this.description=l,this.validate=f,this.convert=m}optional(){return new P(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,l){return new P(o??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",h=>n.URI.isUri(h),h=>h),P.Position=new P("position","A position in a text document",h=>k.Position.isPosition(h),b.Position.from),P.Range=new P("range","A range in a text document",h=>k.Range.isRange(h),b.Range.from),P.Selection=new P("selection","A selection in a text document",h=>k.Selection.isSelection(h),b.Selection.from),P.Number=new P("number","",h=>typeof h=="number",h=>h),P.String=new P("string","",h=>typeof h=="string",h=>h),P.CallHierarchyItem=new P("item","A call hierarchy item",h=>h instanceof k.CallHierarchyItem,b.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",h=>h instanceof k.TypeHierarchyItem,b.TypeHierarchyItem.from),P.TestItem=new P("testItem","A VS Code TestItem",h=>h instanceof u.TestItemImpl,b.TestItem.from);class c{constructor(o,l){this.description=o,this.convert=l}}e.ApiCommandResult=c,c.Void=new c("no result",h=>h);class t{constructor(o,l,f,m,E){this.id=o,this.internalId=l,this.description=f,this.args=m,this.result=E}}e.ApiCommand=t}),define(Ee[179],be([1,0,2,8,7,88,39,16,73,77,9]),function(Y,e,r,k,b,$,y,O,I,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const v=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(k.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,u)=>{if((0,O.isFalsyOrEmpty)(i))return;class S extends b.SymbolInformation{static to(w){const d=new S(w.name,k.SymbolKind.to(w.kind),w.containerName||"",new b.Location(u[0],k.Range.to(w.range)));return d.detail=w.detail,d.range=d.location.range,d.selectionRange=k.Range.to(w.selectionRange),d.children=w.children?w.children.map(S.to):[],d}}return i.map(S.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(k.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(k.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new y.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(k.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",s)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",s)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",s)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",s)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(k.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(k.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(u=>b.Position.isPosition(u)),i=>i.map(k.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(u=>{let S;for(const _ of u.reverse())S=new b.SelectionRange(k.Range.to(_),S);return S}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(k.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(k.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(k.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(k.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:k.Range.to(i.range),placeholder:i.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return k.WorkspaceEdit.to(i)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(k.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new b.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const u=(0,I.decodeSemanticTokensDto)(i);if(u.type==="full")return new b.SemanticTokens(u.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new b.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const u=(0,I.decodeSemanticTokensDto)(i);if(u.type==="full")return new b.SemanticTokens(u.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,u,S)=>{if(!i)return new b.CompletionList([]);const _=i.suggestions.map(w=>k.CompletionItem.to(w,S));return new b.CompletionList(_,i.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return k.SignatureHelp.to(i)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,u,S)=>p(_=>new b.CodeLens(k.Range.to(_.range),_.command&&S.fromInternal(_.command)))(i))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>b.Range.isRange(i),i=>b.Selection.isSelection(i)?k.Selection.from(i):k.Range.from(i)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,u,S)=>p(_=>{if(_._isSynthetic){if(!_.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(_.command)}else{const w=new b.CodeAction(_.title,_.kind?new b.CodeActionKind(_.kind):void 0);return _.edit&&(w.edit=k.WorkspaceEdit.to(_.edit)),_.command&&(w.command=S.fromInternal(_.command)),w.isPreferred=_.isPreferred,w}})(i))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(u=>new b.ColorInformation(k.Range.to(u.range),k.Color.to(u.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",i=>i instanceof b.Color,k.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:k.Range.from(i.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(k.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,u,S)=>i.map(k.InlayHint.to.bind(void 0,S)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(u=>k.NotebookExclusiveDocumentPattern.to(u))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(k.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",i=>r.URI.isUri(i)||typeof i=="string"&&(0,R.matchesSomeScheme)(i,N.Schemas.http,N.Schemas.https),i=>i),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[k.ViewColumn.from(i),void 0]:[k.ViewColumn.from(i.viewColumn),k.TextEditorOpenOptions.from(i)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[k.ViewColumn.from(i),void 0]:[k.ViewColumn.from(i.viewColumn),k.TextEditorOpenOptions.from(i)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[k.ViewColumn.from(i.viewColumn),k.TextEditorOpenOptions.from(i)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(k.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(k.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(k.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void)];class n{static register(u){v.forEach(u.registerApiCommand,u)}}e.ExtHostApiCommands=n;function p(i){return u=>{if(Array.isArray(u))return u.map(i)}}function s(i){if(!Array.isArray(i))return;const u=[];for(const S of i)$.isLocationLink(S)?u.push(k.DefinitionLink.to(S)):u.push(k.location.to(S));return u}}),define(Ee[180],be([1,0,11,52,5,6,2,88,25,8,7,27,4]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(s,i,u){const S=s.getProxy(n.MainContext.MainThreadComments);class _{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,i.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const o=this._commentControllers.get(h.handle);return o||h}else if(h&&h.$mid===7){const o=this._commentControllers.get(h.commentControlHandle);if(!o)return h;const l=o.getCommentThread(h.commentThreadHandle);return l||h}else if(h&&h.$mid===8){const o=this._commentControllers.get(h.thread.commentControlHandle);if(!o)return h;const l=o.getCommentThread(h.thread.commentThreadHandle);return l?{thread:l,text:h.text}:h}else if(h&&h.$mid===9){const o=this._commentControllers.get(h.thread.commentControlHandle);if(!o)return h;const l=o.getCommentThread(h.thread.commentThreadHandle);if(!l)return h;let f=h.commentUniqueId,m=l.getCommentByUniqueId(f);return m||h}else if(h&&h.$mid===10){const o=this._commentControllers.get(h.thread.commentControlHandle);if(!o)return h;const l=o.getCommentThread(h.thread.commentThreadHandle);if(!l)return h;let f=h.text,m=h.commentUniqueId,E=l.getCommentByUniqueId(m);return E?(E.body=f,E):h}return h}})}createCommentController(h,o,l){const f=_.handlePool++,m=new d(h,f,o,l);this._commentControllers.set(m.handle,m);const E=this._commentControllersByExtension.get(I.ExtensionIdentifier.toKey(h.identifier))||[];return E.push(m),this._commentControllersByExtension.set(I.ExtensionIdentifier.toKey(h.identifier),E),m.value}$createCommentThreadTemplate(h,o,l){const f=this._commentControllers.get(h);!f||f.$createCommentThreadTemplate(o,l)}async $updateCommentThreadTemplate(h,o,l){const f=this._commentControllers.get(h);!f||f.$updateCommentThreadTemplate(o,l)}$deleteCommentThread(h,o){const l=this._commentControllers.get(h);l&&l.$deleteCommentThread(o)}$provideCommentingRanges(h,o,l){const f=this._commentControllers.get(h);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const m=u.getDocument(y.URI.revive(o));return(0,r.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(m,l)).then(E=>E?E.map(T=>R.Range.from(T)):void 0)}$toggleReaction(h,o,l,f,m){const E=this._commentControllers.get(h);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const T=E.getCommentThread(o);if(T){const A=T.getCommentByUniqueId(f.uniqueIdInThread);if(E!==void 0&&A&&E.reactionHandler)return E.reactionHandler(A,P(m))}return Promise.resolve(void 0)})}dispose(){}}_.handlePool=0;class w{constructor(h,o,l,f,m,E,T){this._commentControllerHandle=o,this._id=l,this._uri=f,this._range=m,this._comments=E,this.extensionDescription=T,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new $.MutableDisposable,this._acceptInputDisposables.value=new $.DisposableStore,this._id===void 0&&(this._id=`${h}.${this.handle}`),S.$createCommentThread(o,this.handle,this._id,this._uri,R.Range.from(this._range),T.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{S.$deleteCommentThread(o,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(x){A.range=x},get comments(){return A.comments},set comments(x){A.comments=x},get collapsibleState(){return A.collapsibleState},set collapsibleState(x){A.collapsibleState=x},get canReply(){return A.canReply},set canReply(x){A.canReply=x},get contextValue(){return A.contextValue},set contextValue(x){A.contextValue=x},get label(){return A.label},set label(x){A.label=x},dispose:()=>{A.dispose()}}}set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){h.isEqual(this._range)||(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new $.DisposableStore);const h=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),o={};h("range")&&(o.range=R.Range.from(this._range)),h("label")&&(o.label=this.label),h("contextValue")&&(o.contextValue=this.contextValue??null),h("comments")&&(o.comments=this._comments.map(l=>D(this,l,this._commentsMap))),h("collapsibleState")&&(o.collapseState=c(this._collapseState)),h("canReply")&&(o.canReply=this.canReply),this.modifications={},S.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(h){for(let o of this._commentsMap){let l=o[0],f=o[1];if(h===f)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose())}}w._handlePool=0,Fe([(0,k.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class d{constructor(h,o,l,f){this._extension=h,this._handle=o,this._id=l,this._label=f,this._threads=new Map,S.$registerCommentController(this.handle,l,f);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(E){m.options=E},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(E){m.commentingRangeProvider=E},get reactionHandler(){return m.reactionHandler},set reactionHandler(E){m.reactionHandler=E},createCommentThread(E,T,A){return m.createCommentThread(E,T,A).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{S.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(h){this._commentingRangeProvider=h,S.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,S.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,S.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(h,o,l,f){if(typeof h=="string"){const m=new w(this.id,this.handle,h,o,l,f,this._extension);return this._threads.set(m.handle,m),m}else{const m=new w(this.id,this.handle,void 0,h,o,l,this._extension);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(h,o){const l=new w(this.id,this.handle,void 0,y.URI.revive(h),R.Range.to(o),[],this._extension);return l.collapsibleState=O.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(h,o){let l=this._threads.get(h);l&&(l.range=R.Range.to(o))}$deleteCommentThread(h){let o=this._threads.get(h);o&&o.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._localDisposables.forEach(h=>h.dispose())}}function D(t,h,o){let l=o.get(h);l||(l=++t.commentHandle,o.set(h,l));const f=h.author&&h.author.iconPath?h.author.iconPath.toString():void 0;h.timestamp&&(0,v.checkProposedApiEnabled)(t.extensionDescription,"commentTimestamp");let m;return h.timestamp&&(m={source:h.timestamp,$mid:14}),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:l,body:typeof h.body=="string"?h.body:R.MarkdownString.from(h.body),userName:h.author.name,userIconPath:f,label:h.label,commentReactions:h.reactions?h.reactions.map(E=>a(E)):void 0,timestamp:m}}function a(t){return{label:t.label,iconPath:t.iconPath?R.pathOrURIToURI(t.iconPath):void 0,count:t.count,hasReacted:t.authorHasReacted}}function P(t){return{label:t.label||"",count:t.count||0,iconPath:t.iconPath?y.URI.revive(t.iconPath):"",authorHasReacted:t.hasReacted||!1}}function c(t){if(t!==void 0)switch(t){case N.CommentThreadCollapsibleState.Expanded:return O.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return O.CommentThreadCollapsibleState.Collapsed}return O.CommentThreadCollapsibleState.Collapsed}return new _}e.createExtHostComments=p}),define(Ee[92],be([1,0,2,4,7,3,14,12,16,10,17]),function(Y,e,r,k,b,$,y,O,I,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class wi{constructor(p,s){this._logService=s,this._provider=new Map,this._proxy=p.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,s){const i=wi._handlePool++;this._provider.set(i,{provider:p,extensionId:s}),this._proxy.$registerDecorationProvider(i,s.value);const u=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(S=>{if(!S){this._proxy.$onDidChange(i,null);return}let _=(0,I.asArray)(S);if(_.length<=wi._maxEventSize){this._proxy.$onDidChange(i,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,_.length);const w=_.map(a=>({uri:a,rank:(0,R.count)(a.path,"/")})),d=(0,I.groupBy)(w,(a,P)=>a.rank-P.rank||(0,R.compare)(a.uri.path,P.uri.path));let D=[];e:for(let a of d){let P;for(let c of a){let t=(0,N.dirname)(c.uri.path);if(P!==t&&(P=t,D.push(c.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(i,D)});return new b.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(i),this._provider.delete(i)})}async $provideDecorations(p,s,i){if(!this._provider.has(p))return Object.create(null);const u=Object.create(null),{provider:S,extensionId:_}=this._provider.get(p);return await Promise.all(s.map(async w=>{try{const{uri:d,id:D}=w,a=await Promise.resolve(S.provideFileDecoration(r.URI.revive(d),i));if(!a)return;try{b.FileDecoration.validate(a),u[D]=[a.propagate,a.tooltip,a.badge,a.color]}catch(P){this._logService.warn(`INVALID decoration from extension '${_.value}': ${P}`)}}catch(d){this._logService.error(d)}})),u}};v._handlePool=0,v._maxEventSize=250,v=Fe([Ne(0,y.IExtHostRpcService),Ne(1,O.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,$.createDecorator)("IExtHostDecorations")});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[181],be([1,0,121,76,2,4,7,8,5,12,22,30]),function(Y,e,r,k,b,$,y,O,I,R,N,v){"use strict";var n,p,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class i{constructor(_,w,d,D,a,P){this._name=_,this._owner=w,this._maxDiagnosticsPerFile=d,n.set(this,void 0),p.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,je(this,s,new N.ResourceMap(c=>D.getComparisonKey(c)),"f"),je(this,n,a,"f"),je(this,p,P,"f")}dispose(){this._isDisposed||(De(this,p,"f").fire([...De(this,s,"f").keys()]),De(this,n,"f")&&De(this,n,"f").$clear(this._owner),De(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(_,w){if(!_){this.clear();return}this._checkDisposed();let d=[];if(b.URI.isUri(_)){if(!w){this.delete(_);return}De(this,s,"f").set(_,w.slice()),d=[_]}else if(Array.isArray(_)){d=[];let a;_=[..._].sort(i._compareIndexedTuplesByUri);for(const P of _){const[c,t]=P;if((!a||c.toString()!==a.toString())&&(a&&De(this,s,"f").get(a).length===0&&De(this,s,"f").delete(a),a=c,d.push(c),De(this,s,"f").set(c,[])),t){const h=De(this,s,"f").get(c);h&&h.push(...t)}else{const h=De(this,s,"f").get(c);h&&(h.length=0)}}}if(De(this,p,"f").fire(d),!De(this,n,"f"))return;const D=[];for(let a of d){let P=[];const c=De(this,s,"f").get(a);if(c)if(c.length>this._maxDiagnosticsPerFile){P=[];const t=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(let o of c)if(o.severity===t[h]&&P.push(O.Diagnostic.from(o))===this._maxDiagnosticsPerFile)break e;P.push({severity:k.MarkerSeverity.Info,message:(0,r.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:P[P.length-1].startLineNumber,startColumn:P[P.length-1].startColumn,endLineNumber:P[P.length-1].endLineNumber,endColumn:P[P.length-1].endColumn})}else P=c.map(t=>O.Diagnostic.from(t));D.push([a,P])}De(this,n,"f").$changeMany(this._owner,D)}delete(_){this._checkDisposed(),De(this,p,"f").fire([_]),De(this,s,"f").delete(_),De(this,n,"f")&&De(this,n,"f").$changeMany(this._owner,[[_,void 0]])}clear(){this._checkDisposed(),De(this,p,"f").fire([...De(this,s,"f").keys()]),De(this,s,"f").clear(),De(this,n,"f")&&De(this,n,"f").$clear(this._owner)}forEach(_,w){this._checkDisposed();for(let d of De(this,s,"f").keys())_.apply(w,[d,this.get(d),this])}get(_){this._checkDisposed();const w=De(this,s,"f").get(_);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(_){return this._checkDisposed(),Array.isArray(De(this,s,"f").get(_))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(_,w){return _[0].toString()<w[0].toString()?-1:_[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=i,n=new WeakMap,p=new WeakMap,s=new WeakMap;let u=class si{constructor(_,w,d){this._logService=w,this._fileSystemInfoService=d,this._collections=new Map,this._onDidChangeDiagnostics=new I.DebounceEmitter({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=I.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=_.getProxy($.MainContext.MainThreadDiagnostics)}static _mapper(_){const w=new N.ResourceMap;for(const d of _)w.set(d,d);return{uris:Object.freeze(Array.from(w.values()))}}createDiagnosticCollection(_,w){const{_collections:d,_proxy:D,_onDidChangeDiagnostics:a,_logService:P,_fileSystemInfoService:c}=this,t=new class{$changeMany(l,f){D.$changeMany(l,f),P.trace("[DiagnosticCollection] change many (extension, owner, uris)",_.value,l,f.length===0?"CLEARING":f)}$clear(l){D.$clear(l),P.trace("[DiagnosticCollection] remove all (extension, owner)",_.value,l)}dispose(){D.dispose()}};let h;if(!w)w="_generated_diagnostic_collection_name_#"+si._idPool++,h=w;else if(!d.has(w))h=w;else{this._logService.warn(`DiagnosticCollection with name '${w}' does already exist.`);do h=w+si._idPool++;while(d.has(h))}return new class extends i{constructor(){super(w,h,si._maxDiagnosticsPerFile,c.extUri,t,a);d.set(h,this)}dispose(){super.dispose(),d.delete(h)}}}getDiagnostics(_){if(_)return this._getDiagnostics(_);{const w=new Map,d=[];for(const D of this._collections.values())D.forEach((a,P)=>{let c=w.get(a.toString());typeof c=="undefined"&&(c=d.length,w.set(a.toString(),c),d.push([a,[]])),d[c][1]=d[c][1].concat(...P)});return d}}_getDiagnostics(_){let w=[];for(let d of this._collections.values())d.has(_)&&(w=w.concat(d.get(_)));return w}$acceptMarkersChange(_){if(!this._mirrorCollection){const w="_generated_mirror",d=new i(w,w,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(w,d),this._mirrorCollection=d}for(const[w,d]of _)this._mirrorCollection.set(b.URI.revive(w),d.map(O.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=Fe([Ne(1,R.ILogService),Ne(2,v.IExtHostFileSystemInfo)],u),e.ExtHostDiagnostics=u}),define(Ee[182],be([1,0,2,4]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(y){this._proxy=y.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(O=>O?O.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(O=>O?r.URI.revive(O):void 0)}}e.ExtHostDialogs=b}),define(Ee[183],be([1,0,15,2,7,4,9,20,10]),function(Y,e,r,k,b,$,y,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(v,n,p){this._documentsAndEditors=n,this._logService=p,this._documentContentProviders=new Map,this._proxy=v.getProxy($.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(v,n){if(Object.keys(y.Schemas).indexOf(v)>=0)throw new Error(`scheme '${v}' already registered`);const p=R._handlePool++;this._documentContentProviders.set(p,n),this._proxy.$registerTextContentProvider(p,v);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(i=>{if(i.scheme!==v){this._logService.warn(`Provider for scheme '${v}' is firing event for schema '${i.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(i)&&this.$provideTextDocumentContent(p,i).then(u=>{if(!u&&typeof u!="string")return;const S=this._documentsAndEditors.getDocument(i);if(!S)return;const _=(0,I.splitLines)(u);if(!S.equalLines(_))return this._proxy.$onVirtualDocumentChange(i,u)},r.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(v,n){const p=this._documentContentProviders.get(v);return p?Promise.resolve(p.provideTextDocumentContent(k.URI.revive(n),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(Ee[184],be([1,0,5,6,2,4,82,8,13,26,7]),function(Y,e,r,k,b,$,y,O,I,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class v{constructor(p,s){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy($.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(i=>{for(const u of i)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(i=>{for(const u of i)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const s=this._documentsAndEditors.getDocument(p);if(s)return s}getDocument(p){const s=this.getDocumentData(p);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return s.document}ensureDocumentData(p){const s=this._documentsAndEditors.getDocument(p);if(s)return Promise.resolve(s);let i=this._documentLoader.get(p.toString());return i||(i=this._proxy.$tryOpenDocument(p).then(u=>{this._documentLoader.delete(p.toString());const S=b.URI.revive(u);return(0,I.assertIsDefined)(this._documentsAndEditors.getDocument(S))},u=>(this._documentLoader.delete(p.toString()),Promise.reject(u))),this._documentLoader.set(p.toString(),i)),i}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(s=>b.URI.revive(s))}$acceptModelLanguageChanged(p,s){const i=b.URI.revive(p),u=this._documentsAndEditors.getDocument(i);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(s),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(p){const s=b.URI.revive(p),i=this._documentsAndEditors.getDocument(s);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(i.document)}$acceptDirtyStateChanged(p,s){const i=b.URI.revive(p),u=this._documentsAndEditors.getDocument(i);if(!u)throw new Error("unknown document");u._acceptIsDirty(s),this._onDidChangeDocument.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,s,i){const u=b.URI.revive(p),S=this._documentsAndEditors.getDocument(u);if(!S)throw new Error("unknown document");S._acceptIsDirty(i),S.onEvents(s);let _;s.isUndoing?_=N.TextDocumentChangeReason.Undo:s.isRedoing&&(_=N.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:S.document,contentChanges:s.changes.map(w=>({range:O.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:_}))}setWordDefinitionFor(p,s){(0,y.setWordDefinitionFor)(p,s)}}e.ExtHostDocuments=v}),define(Ee[49],be([1,0,42,5,6,2,3,4,82,14,90,8,12,22,9,160,229]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class S{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(d,D){this._extHostRpc=d,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const D=[],a=[],P=[];if(d.removedDocuments)for(const c of d.removedDocuments){const t=$.URI.revive(c),h=this._documents.get(t);h?.unref()&&(this._documents.delete(t),D.push(h.value))}if(d.addedDocuments)for(const c of d.addedDocuments){const t=$.URI.revive(c.uri);let h=this._documents.get(t);if(h&&t.scheme!==s.Schemas.vscodeNotebookCell&&t.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);h||(h=new S(new I.ExtHostDocumentData(this._extHostRpc.getProxy(O.MainContext.MainThreadDocuments),t,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this._documents.set(t,h),a.push(h.value)),h.ref()}if(d.removedEditors)for(const c of d.removedEditors){const t=this._editors.get(c);this._editors.delete(c),t&&P.push(t)}if(d.addedEditors)for(const c of d.addedEditors){const t=$.URI.revive(c.documentUri);r.ok(this._documents.has(t),`document '${t}' does not exist`),r.ok(!this._editors.has(c.id),`editor '${c.id}' already exists!`);const h=this._documents.get(t).value,o=new N.ExtHostTextEditor(c.id,this._extHostRpc.getProxy(O.MainContext.MainThreadTextEditors),this._logService,new u.Lazy(()=>h.document),c.selections.map(v.Selection.to),c.options,c.visibleRanges.map(l=>v.Range.to(l)),typeof c.editorPosition=="number"?v.ViewColumn.to(c.editorPosition):void 0);this._editors.set(c.id,o)}d.newActiveEditor!==void 0&&(r.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,b.dispose)(D),(0,b.dispose)(P),d.removedDocuments&&this._onDidRemoveDocuments.fire(D),d.addedDocuments&&this._onDidAddDocuments.fire(a),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(c=>c.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return i.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return d?D:D?.value}allEditors(){return[...this._editors.values()]}};_=Fe([Ne(0,R.IExtHostRpcService),Ne(1,n.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[64],be([1,0,8,4,2,5,3,14,11]),function(Y,e,r,k,b,$,y,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");let R=class{constructor(v){this._onDidChangeTabs=new $.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new $.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=v.getProxy(k.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(v){let n=-1;this._tabs=v.map((s,i)=>(s.isActive&&(n=i),Object.freeze({label:s.label,viewColumn:r.ViewColumn.to(s.viewColumn),index:i,resource:b.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:u,viewId:S})=>({resource:b.URI.revive(u),viewId:S})),viewId:s.editorId,isActive:s.isActive,move:async(u,S)=>{this._proxy.$moveTab(s,u,r.ViewColumn.from(S)),await(0,I.raceTimeout)($.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,I.raceTimeout)($.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,i)=>s.viewColumn===i.viewColumn?s.index-i.index:s.viewColumn-i.viewColumn);const p=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==p&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};R=Fe([Ne(0,O.IExtHostRpcService)],R),e.ExtHostEditorTabs=R}),define(Ee[185],be([1,0,2,4,6,7,8,230,10,21,27]),function(Y,e,r,k,b,$,y,O,I,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class v{constructor(){this._schemes=[]}add(s){this._stateMachine=void 0,this._schemes.push(s)}delete(s){const i=this._schemes.indexOf(s);i>=0&&(this._schemes.splice(i,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const s=this._schemes.sort(),i=[];let u,S,_=14,w=14;for(const d of s){let D=u?(0,I.commonPrefixLength)(u,d):0;for(D===0?S=1:S=w;D<d.length;D++)D+1===d.length?(_=w,w=9):w+=1,i.push([S,d.toUpperCase().charCodeAt(D),w]),i.push([S,d.toLowerCase().charCodeAt(D),w]),S=w;u=d,w=_}i.push([9,58,10]),i.push([10,47,12]),this._stateMachine=new O.StateMachine(i)}}provideDocumentLinks(s){this._initStateMachine();const i=[],u=O.LinkComputer.computeLinks({getLineContent(S){return s.lineAt(S-1).text},getLineCount(){return s.lineCount}},this._stateMachine);for(const S of u){const _=y.DocumentLink.to(S);_.target&&i.push(_)}return i}}class n{constructor(s,i){this._extHostLanguageFeatures=i,this._linkProvider=new v,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=s.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(s,i,u,S={}){if(this._registeredSchemes.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(s,"*",this._linkProvider));const _=this._handlePool++;this._linkProvider.add(i),this._registeredSchemes.add(i),this._fsProvider.set(_,u);let w=2;S.isCaseSensitive&&(w+=1024),S.isReadonly&&(w+=2048),typeof u.copy=="function"&&(w+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&((0,N.checkProposedApiEnabled)(s,"fsChunks"),w+=4),this._proxy.$registerFileSystemProvider(_,i,w).catch(D=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${i}`),console.error(D)});const d=u.onDidChangeFile(D=>{const a=[];for(const P of D){let{uri:c,type:t}=P;if(c.scheme!==i)continue;let h;switch(t){case $.FileChangeType.Changed:h=0;break;case $.FileChangeType.Created:h=1;break;case $.FileChangeType.Deleted:h=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:c,type:h})}this._proxy.$onFileSystemChange(_,a)});return(0,b.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(i),this._registeredSchemes.delete(i),this._fsProvider.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(s){const{type:i,ctime:u,mtime:S,size:_,permissions:w}=s;return{type:i,ctime:u,mtime:S,size:_,permissions:w}}$stat(s,i){return Promise.resolve(this._getFsProvider(s).stat(r.URI.revive(i))).then(u=>n._asIStat(u))}$readdir(s,i){return Promise.resolve(this._getFsProvider(s).readDirectory(r.URI.revive(i)))}$readFile(s,i){return Promise.resolve(this._getFsProvider(s).readFile(r.URI.revive(i))).then(u=>R.VSBuffer.wrap(u))}$writeFile(s,i,u,S){return Promise.resolve(this._getFsProvider(s).writeFile(r.URI.revive(i),u.buffer,S))}$delete(s,i,u){return Promise.resolve(this._getFsProvider(s).delete(r.URI.revive(i),u))}$rename(s,i,u,S){return Promise.resolve(this._getFsProvider(s).rename(r.URI.revive(i),r.URI.revive(u),S))}$copy(s,i,u,S){const _=this._getFsProvider(s);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(r.URI.revive(i),r.URI.revive(u),S))}$mkdir(s,i){return Promise.resolve(this._getFsProvider(s).createDirectory(r.URI.revive(i)))}$watch(s,i,u,S){const _=this._getFsProvider(s).watch(r.URI.revive(u),S);this._watches.set(i,_)}$unwatch(s,i){const u=this._watches.get(i);u&&(u.dispose(),this._watches.delete(i))}$open(s,i,u){const S=this._getFsProvider(s);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(r.URI.revive(i),u))}$close(s,i){const u=this._getFsProvider(s);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(i))}$read(s,i,u,S){const _=this._getFsProvider(s);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const w=R.VSBuffer.alloc(S);return Promise.resolve(_.read(i,u,w.buffer,0,S)).then(d=>w.slice(0,d))}$write(s,i,u,S){const _=this._getFsProvider(s);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(i,u,S.buffer,0,S.byteLength))}_getFsProvider(s){const i=this._fsProvider.get(s);if(!i){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return i}}e.ExtHostFileSystem=n}),define(Ee[50],be([1,0,4,46,7,21,3,14,30,6]),function(Y,e,r,k,b,$,y,O,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class Kt{constructor(n,p){this._fileSystemProvider=new Map,this._proxy=n.getProxy(r.MainContext.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(i){try{const u=s._fileSystemProvider.get(i.scheme);if(!u)return await s._proxy.$stat(i);await s._proxy.$ensureActivation(i.scheme);const S=await u.stat(i);return{type:S.type,ctime:S.ctime,mtime:S.mtime,size:S.size,permissions:S.permissions}}catch(u){Kt._handleError(u)}},async readDirectory(i){try{const u=s._fileSystemProvider.get(i.scheme);return u?(await s._proxy.$ensureActivation(i.scheme),(await u.readDirectory(i)).slice()):await s._proxy.$readdir(i)}catch(u){return Kt._handleError(u)}},async createDirectory(i){try{return await s._proxy.$mkdir(i)}catch(u){return Kt._handleError(u)}},async readFile(i){try{const u=s._fileSystemProvider.get(i.scheme);return u?(await s._proxy.$ensureActivation(i.scheme),(await u.readFile(i)).slice()):(await s._proxy.$readFile(i)).buffer}catch(u){return Kt._handleError(u)}},async writeFile(i,u){try{return await s._proxy.$writeFile(i,$.VSBuffer.wrap(u))}catch(S){return Kt._handleError(S)}},async delete(i,u){try{const S=s._fileSystemProvider.get(i.scheme);return S?(await s._proxy.$ensureActivation(i.scheme),await S.delete(i,{recursive:!1,...u})):await s._proxy.$delete(i,{recursive:!1,useTrash:!1,...u})}catch(S){return Kt._handleError(S)}},async rename(i,u,S){try{return await s._proxy.$rename(i,u,{overwrite:!1,...S})}catch(_){return Kt._handleError(_)}},async copy(i,u,S){try{return await s._proxy.$copy(i,u,{overwrite:!1,...S})}catch(_){return Kt._handleError(_)}},isWritableFileSystem(i){const u=p.getCapabilities(i);if(typeof u=="number")return!(u&2048)}})}static _handleError(n){if(n instanceof b.FileSystemError)throw n;if(!(n instanceof Error))throw new b.FileSystemError(String(n));if(n.name==="ENOPRO")throw b.FileSystemError.Unavailable(n.message);switch(n.name){case k.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(n.message);case k.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(n.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(n.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(n.message);case k.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(n.message);case k.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(n.message);default:throw new b.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,p){return this._fileSystemProvider.set(n,p),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(n))}};N=Fe([Ne(0,O.IExtHostRpcService),Ne(1,I.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[186],be([1,0,5,29,2,4,8,7]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(v,n,p,s,i,u,S,_){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const w=this.ensureWatching(v,p,i);this._config=0,u&&(this._config+=1),S&&(this._config+=2),_&&(this._config+=4);const d=(0,k.parse)(i),D=typeof i=="string",a=s(P=>{if(!u)for(let c of P.created){const t=b.URI.revive(c);d(t.fsPath)&&(!D||n.getWorkspaceFolder(t))&&this._onDidCreate.fire(t)}if(!S)for(let c of P.changed){const t=b.URI.revive(c);d(t.fsPath)&&(!D||n.getWorkspaceFolder(t))&&this._onDidChange.fire(t)}if(!_)for(let c of P.deleted){const t=b.URI.revive(c);d(t.fsPath)&&(!D||n.getWorkspaceFolder(t))&&this._onDidDelete.fire(t)}});this._disposable=O.Disposable.from(w,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(v,n,p){let s=O.Disposable.from();if(typeof p=="string")return s;const i=v.getProxy($.MainContext.MainThreadFileSystem);let u=!1;(p.pattern.includes(k.GLOBSTAR)||p.pattern.includes(k.GLOB_SPLIT))&&(u=!0);const S=Math.random();return i.$watch(n.identifier.value,S,p.baseUri,{recursive:u,excludes:[]}),O.Disposable.from({dispose:()=>i.$unwatch(S)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(v,n,p){this._mainContext=v,this._logService=n,this._extHostDocumentsAndEditors=p,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(v,n,p,s,i,u){return new I(this._mainContext,v,n,this._onFileSystemEvent.event,y.GlobPattern.from(p),s,i,u)}$onFileEvent(v){this._onFileSystemEvent.fire(v)}$onDidRunFileOperation(v,n){switch(v){case 2:this._onDidRenameFile.fire(Object.freeze({files:n.map(p=>({oldUri:b.URI.revive(p.source),newUri:b.URI.revive(p.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:n.map(p=>b.URI.revive(p.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:n.map(p=>b.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(v){return this._createWillExecuteEvent(v,this._onWillRenameFile)}getOnWillCreateFileEvent(v){return this._createWillExecuteEvent(v,this._onWillCreateFile)}getOnWillDeleteFileEvent(v){return this._createWillExecuteEvent(v,this._onWillDeleteFile)}_createWillExecuteEvent(v,n){return(p,s,i)=>{const u=function(_){p.call(s,_)};return u.extension=v,n.event(u,void 0,i)}}async $onWillRunFileOperation(v,n,p,s){switch(v){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:n.map(i=>({oldUri:b.URI.revive(i.source),newUri:b.URI.revive(i.target)}))},p,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:n.map(i=>b.URI.revive(i.target))},p,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:n.map(i=>b.URI.revive(i.target))},p,s)}}async _fireWillEvent(v,n,p,s){const i=new Set,u=[];if(await v.fireAsync(n,s,async(_,w)=>{const d=Date.now(),D=await Promise.resolve(_);D instanceof O.WorkspaceEdit&&(u.push(D),i.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-d>p&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),s.isCancellationRequested||u.length===0)return;const S={edits:[]};for(let _ of u){let{edits:w}=y.WorkspaceEdit.from(_,{getTextDocumentVersion:d=>this._extHostDocumentsAndEditors.getDocument(d)?.version,getNotebookDocumentVersion:()=>{}});S.edits=S.edits.concat(w)}return{edit:S,extensionNames:Array.from(i)}}}e.ExtHostFileSystemEventService=R}),define(Ee[187],be([1,0,2,39]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(y,O,I,R){this._extHostNotebooks=O,this._textDocumentsAndEditors=I,this._commands=R;const N=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new k.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new k.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new k.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new k.ApiCommandResult("Notebook and input URI",v=>{if(v.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(v.notebookEditorId);return{notebookUri:r.URI.revive(v.notebookUri),inputUri:r.URI.revive(v.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:r.URI.revive(v.notebookUri),inputUri:r.URI.revive(v.inputUri)}}));this._commands.registerApiCommand(N)}$willAddInteractiveDocument(y,O,I,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:I,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,O){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=b}),define(Ee[188],be([1,0,6,4]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(y){this._handlePool=0,this._proxy=y.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const O=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(O,y),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(O)})}}e.ExtHostLabelService=b}),define(Ee[189],be([1,0,2,26,8,7,4,10,87,16,13,231,20,6,73,53,57,190,15,5,11]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class D{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentSymbols(L,F){const C=this._documents.getDocument(L),M=await this._provider.provideDocumentSymbols(C,F);if(!(0,R.isFalsyOrEmpty)(M))return M[0]instanceof $.DocumentSymbol?M.map(b.DocumentSymbol.from):D._asDocumentSymbolTree(M)}static _asDocumentSymbolTree(L){L=L.slice(0).sort((M,H)=>{let X=M.location.range.start.compareTo(H.location.range.start);return X===0&&(X=H.location.range.end.compareTo(M.location.range.end)),X});const F=[],C=[];for(const M of L){const H={name:M.name||"!!MISSING: name!!",kind:b.SymbolKind.from(M.kind),tags:M.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:M.containerName,range:b.Range.from(M.location.range),selectionRange:b.Range.from(M.location.range),children:[]};for(;;){if(C.length===0){C.push(H),F.push(H);break}const X=C[C.length-1];if(I.Range.containsRange(X.range,H.range)&&!I.Range.equalsRange(X.range,H.range)){X.children&&X.children.push(H),C.push(H);break}C.pop()}}return F}}class a{constructor(L,F,C){this._documents=L,this._commands=F,this._provider=C,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(L,F){const C=this._documents.getDocument(L),M=await this._provider.provideCodeLenses(C,F);if(!M||F.isCancellationRequested)return;const H=this._cache.add(M),X=new p.DisposableStore;this._disposables.set(H,X);const re={cacheId:H,lenses:[]};for(let ve=0;ve<M.length;ve++)re.lenses.push({cacheId:[H,ve],range:b.Range.from(M[ve].range),command:this._commands.toInternal(M[ve].command,X)});return re}async resolveCodeLens(L,F){const C=L.cacheId&&this._cache.get(...L.cacheId);if(!C)return;let M;if(typeof this._provider.resolveCodeLens!="function"||C.isResolved?M=C:M=await this._provider.resolveCodeLens(C,F),M||(M=C),F.isCancellationRequested)return;const H=L.cacheId&&this._disposables.get(L.cacheId[0]);if(!!H)return L.command=this._commands.toInternal(M.command??a._badCmd,H),L}releaseCodeLenses(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function P(de){return Array.isArray(de)?de.map(b.DefinitionLink.from):de?[b.DefinitionLink.from(de)]:[]}class c{constructor(L,F){this._documents=L,this._provider=F}async provideDefinition(L,F,C){const M=this._documents.getDocument(L),H=b.Position.to(F),X=await this._provider.provideDefinition(M,H,C);return P(X)}}class t{constructor(L,F){this._documents=L,this._provider=F}async provideDeclaration(L,F,C){const M=this._documents.getDocument(L),H=b.Position.to(F),X=await this._provider.provideDeclaration(M,H,C);return P(X)}}class h{constructor(L,F){this._documents=L,this._provider=F}async provideImplementation(L,F,C){const M=this._documents.getDocument(L),H=b.Position.to(F),X=await this._provider.provideImplementation(M,H,C);return P(X)}}class o{constructor(L,F){this._documents=L,this._provider=F}async provideTypeDefinition(L,F,C){const M=this._documents.getDocument(L),H=b.Position.to(F),X=await this._provider.provideTypeDefinition(M,H,C);return P(X)}}class l{constructor(L,F){this._documents=L,this._provider=F}async provideHover(L,F,C){const M=this._documents.getDocument(L),H=b.Position.to(F),X=await this._provider.provideHover(M,H,C);if(!(!X||(0,R.isFalsyOrEmpty)(X.contents)))return X.range||(X.range=M.getWordRangeAtPosition(H)),X.range||(X.range=new $.Range(H,H)),b.Hover.from(X)}}class f{constructor(L,F){this._documents=L,this._provider=F}async provideEvaluatableExpression(L,F,C){const M=this._documents.getDocument(L),H=b.Position.to(F),X=await this._provider.provideEvaluatableExpression(M,H,C);if(X)return b.EvaluatableExpression.from(X)}}class m{constructor(L,F){this._documents=L,this._provider=F}async provideInlineValues(L,F,C,M){const H=this._documents.getDocument(L),X=await this._provider.provideInlineValues(H,b.Range.to(F),b.InlineValueContext.to(C),M);if(Array.isArray(X))return X.map(re=>b.InlineValue.from(re))}}class E{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentHighlights(L,F,C){const M=this._documents.getDocument(L),H=b.Position.to(F),X=await this._provider.provideDocumentHighlights(M,H,C);if(Array.isArray(X))return X.map(b.DocumentHighlight.from)}}class T{constructor(L,F){this._documents=L,this._provider=F}async provideLinkedEditingRanges(L,F,C){const M=this._documents.getDocument(L),H=b.Position.to(F),X=await this._provider.provideLinkedEditingRanges(M,H,C);if(X&&Array.isArray(X.ranges))return{ranges:(0,R.coalesce)(X.ranges.map(b.Range.from)),wordPattern:X.wordPattern}}}class A{constructor(L,F){this._documents=L,this._provider=F}async provideReferences(L,F,C,M){const H=this._documents.getDocument(L),X=b.Position.to(F),re=await this._provider.provideReferences(H,X,C,M);if(Array.isArray(re))return re.map(b.location.from)}}class x{constructor(L,F,C,M,H,X,re){this._documents=L,this._commands=F,this._diagnostics=C,this._provider=M,this._logService=H,this._extension=X,this._apiDeprecation=re,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(L,F,C,M){const H=this._documents.getDocument(L),X=v.Selection.isISelection(F)?b.Selection.to(F):b.Range.to(F),re=[];for(const Be of this._diagnostics.getDiagnostics(L))if(X.intersection(Be.range)&&re.push(Be)>x._maxCodeActionsPerFile)break;const ve={diagnostics:re,only:C.only?new $.CodeActionKind(C.only):void 0,triggerKind:b.CodeActionTriggerKind.to(C.trigger)},ke=await this._provider.provideCodeActions(H,X,ve,M);if(!(0,R.isNonEmptyArray)(ke)||M.isCancellationRequested)return;const Me=this._cache.add(ke),Le=new p.DisposableStore;this._disposables.set(Me,Le);const ze=[];for(let Be=0;Be<ke.length;Be++){const Oe=ke[Be];!Oe||(x._isCommand(Oe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Oe.title,command:this._commands.toInternal(Oe,Le)})):(ve.only&&(Oe.kind?ve.only.contains(Oe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Oe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[Me,Be],title:Oe.title,command:Oe.command&&this._commands.toInternal(Oe.command,Le),diagnostics:Oe.diagnostics&&Oe.diagnostics.map(b.Diagnostic.from),edit:Oe.edit&&b.WorkspaceEdit.from(Oe.edit),kind:Oe.kind&&Oe.kind.value,isPreferred:Oe.isPreferred,disabled:Oe.disabled?.reason})))}return{cacheId:Me,actions:ze}}async resolveCodeAction(L,F){const[C,M]=L,H=this._cache.get(C,M);if(!H||x._isCommand(H)||!this._provider.resolveCodeAction)return;const X=await this._provider.resolveCodeAction(H,F)??H;return X?.edit?b.WorkspaceEdit.from(X.edit):void 0}releaseCodeActions(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}static _isCommand(L){return typeof L.command=="string"&&typeof L.title=="string"}}x._maxCodeActionsPerFile=1e3;class g{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentFormattingEdits(L,F,C){const M=this._documents.getDocument(L),H=await this._provider.provideDocumentFormattingEdits(M,F,C);if(Array.isArray(H))return H.map(b.TextEdit.from)}}class U{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentRangeFormattingEdits(L,F,C,M){const H=this._documents.getDocument(L),X=b.Range.to(F),re=await this._provider.provideDocumentRangeFormattingEdits(H,X,C,M);if(Array.isArray(re))return re.map(b.TextEdit.from)}}class z{constructor(L,F){this._documents=L,this._provider=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(L,F,C,M,H){const X=this._documents.getDocument(L),re=b.Position.to(F),ve=await this._provider.provideOnTypeFormattingEdits(X,re,C,M,H);if(Array.isArray(ve))return ve.map(b.TextEdit.from)}}class q{constructor(L,F){this._provider=L,this._logService=F,this._cache=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(L,F){const C=await this._provider.provideWorkspaceSymbols(L,F);if(!(0,R.isNonEmptyArray)(C))return{symbols:[]};const M=this._cache.add(C),H={cacheId:M,symbols:[]};for(let X=0;X<C.length;X++){const re=C[X];if(!re||!re.name){this._logService.warn("INVALID SymbolInformation",re);continue}H.symbols.push({...b.WorkspaceSymbol.from(re),cacheId:[M,X]})}return H}async resolveWorkspaceSymbol(L,F){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!L.cacheId)return L;const C=this._cache.get(...L.cacheId);if(C){const M=await this._provider.resolveWorkspaceSymbol(C,F);return M&&(0,k.mixin)(L,b.WorkspaceSymbol.from(M),!0)}}releaseWorkspaceSymbols(L){this._cache.delete(L)}}class j{constructor(L,F,C){this._documents=L,this._provider=F,this._logService=C}static supportsResolving(L){return typeof L.prepareRename=="function"}async provideRenameEdits(L,F,C,M){const H=this._documents.getDocument(L),X=b.Position.to(F);try{const re=await this._provider.provideRenameEdits(H,X,C,M);return re?b.WorkspaceEdit.from(re):void 0}catch(re){const ve=j._asMessage(re);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(re)}}async resolveRenameLocation(L,F,C){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const M=this._documents.getDocument(L),H=b.Position.to(F);try{const X=await this._provider.prepareRename(M,H,C);let re,ve;if($.Range.isRange(X)?(re=X,ve=M.getText(X)):(0,N.isObject)(X)&&(re=X.range,ve=X.placeholder),!re||!ve)return;if(re.start.line>H.line||re.end.line<H.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(re),text:ve}}catch(X){const re=j._asMessage(X);return re?{rejectReason:re,range:void 0,text:void 0}:Promise.reject(X)}}static _asMessage(L){return typeof L=="string"?L:L instanceof Error&&typeof L.message=="string"?L.message:void 0}}class J{constructor(L,F){this.resultId=L,this.tokens=F}}class V{constructor(L,F){this._documents=L,this._provider=F,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(L,F,C){const M=this._documents.getDocument(L),H=F!==0?this._previousResults.get(F):null;let X=typeof H?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(M,H.resultId,C):await this._provider.provideDocumentSemanticTokens(M,C);return H&&this._previousResults.delete(F),X?(X=V._fixProvidedSemanticTokens(X),this._send(V._convertToEdits(H,X),X)):null}async releaseDocumentSemanticColoring(L){this._previousResults.delete(L)}static _fixProvidedSemanticTokens(L){return V._isSemanticTokens(L)?V._isCorrectSemanticTokens(L)?L:new $.SemanticTokens(new Uint32Array(L.data),L.resultId):V._isSemanticTokensEdits(L)?V._isCorrectSemanticTokensEdits(L)?L:new $.SemanticTokensEdits(L.edits.map(F=>new $.SemanticTokensEdit(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),L.resultId):L}static _isSemanticTokens(L){return L&&!!L.data}static _isCorrectSemanticTokens(L){return L.data instanceof Uint32Array}static _isSemanticTokensEdits(L){return L&&Array.isArray(L.edits)}static _isCorrectSemanticTokensEdits(L){for(const F of L.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(L,F){if(!V._isSemanticTokens(F)||!L||!L.tokens)return F;const C=L.tokens,M=C.length,H=F.data,X=H.length;let re=0;const ve=Math.min(M,X);for(;re<ve&&C[re]===H[re];)re++;if(re===M&&re===X)return new $.SemanticTokensEdits([],F.resultId);let ke=0;const Me=ve-re;for(;ke<Me&&C[M-ke-1]===H[X-ke-1];)ke++;return new $.SemanticTokensEdits([{start:re,deleteCount:M-re-ke,data:H.subarray(re,X-ke)}],F.resultId)}_send(L,F){if(V._isSemanticTokens(L)){const C=this._nextResultId++;return this._previousResults.set(C,new J(L.resultId,L.data)),(0,s.encodeSemanticTokensDto)({id:C,type:"full",data:L.data})}if(V._isSemanticTokensEdits(L)){const C=this._nextResultId++;return V._isSemanticTokens(F)?this._previousResults.set(C,new J(F.resultId,F.data)):this._previousResults.set(C,new J(L.resultId)),(0,s.encodeSemanticTokensDto)({id:C,type:"delta",deltas:(L.edits||[]).map(M=>({start:M.start,deleteCount:M.deleteCount,data:M.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class ie{constructor(L,F){this._documents=L,this._provider=F}async provideDocumentRangeSemanticTokens(L,F,C){const M=this._documents.getDocument(L),H=await this._provider.provideDocumentRangeSemanticTokens(M,b.Range.to(F),C);return H?this._send(H):null}_send(L){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:L.data})}}e.DocumentRangeSemanticTokensAdapter=ie;class ae{constructor(L,F,C,M,H){this._documents=L,this._commands=F,this._provider=C,this._apiDeprecation=M,this._extension=H,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(L){return typeof L.resolveCompletionItem=="function"}async provideCompletionItems(L,F,C,M){const H=this._documents.getDocument(L),X=b.Position.to(F),re=H.getWordRangeAtPosition(X)||new $.Range(X,X),ve=re.with({end:X}),ke=new S.StopWatch(!0),Me=await this._provider.provideCompletionItems(H,X,M,b.CompletionContext.to(C));if(!Me||M.isCancellationRequested)return;const Le=Array.isArray(Me)?new $.CompletionList(Me):Me,ze=ae.supportsResolving(this._provider)?this._cache.add(Le.items):this._cache.add([]),Be=new p.DisposableStore;this._disposables.set(ze,Be);const Oe=[],Xe={x:ze,b:Oe,a:{replace:b.Range.from(re),insert:b.Range.from(ve)},c:Le.isIncomplete||void 0,d:ke.elapsed()};for(let tt=0;tt<Le.items.length;tt++){const Te=Le.items[tt],et=this._convertCompletionItem(Te,[ze,tt],ve,re);Oe.push(et)}return Xe}async resolveCompletionItem(L,F){if(typeof this._provider.resolveCompletionItem!="function")return;const C=this._cache.get(...L);if(!C)return;const M=await this._provider.resolveCompletionItem(C,F);if(!!M)return this._convertCompletionItem(M,L)}releaseCompletionItems(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}_convertCompletionItem(L,F,C,M){const H=this._disposables.get(F[0]);if(!H)throw Error("DisposableStore is missing...");const X={x:F,a:L.label,b:L.kind!==void 0?b.CompletionItemKind.from(L.kind):void 0,n:L.tags&&L.tags.map(b.CompletionItemTag.from),c:L.detail,d:typeof L.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(L.documentation),e:L.sortText!==L.label?L.sortText:void 0,f:L.filterText!==L.label?L.filterText:void 0,g:L.preselect||void 0,i:L.keepWhitespace?1:0,k:L.commitCharacters,l:L.additionalTextEdits&&L.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(L.command,H)};L.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),X.h=L.textEdit.newText):typeof L.insertText=="string"?X.h=L.insertText:L.insertText instanceof $.SnippetString&&(X.h=L.insertText.value,X.i|=4);let re;return L.textEdit?re=L.textEdit.range:L.range&&(re=L.range),$.Range.isRange(re)?X.j=b.Range.from(re):re&&(!C?.isEqual(re.inserting)||!M?.isEqual(re.replacing))&&(X.j={insert:b.Range.from(re.inserting),replace:b.Range.from(re.replacing)}),X}}class te{constructor(L,F,C){this._documents=L,this._provider=F,this._commands=C,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(L,F,C,M){const H=this._documents.getDocument(L),X=b.Position.to(F),re=await this._provider.provideInlineCompletionItems(H,X,{selectedCompletionInfo:C.selectedSuggestionInfo?{range:b.Range.to(C.selectedSuggestionInfo.range),text:C.selectedSuggestionInfo.text,isSnippetText:C.selectedSuggestionInfo.isSnippetText,completionKind:b.CompletionItemKind.to(C.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:C.triggerKind},M);if(!re||M.isCancellationRequested)return;const ve=(0,N.isArray)(re)?{items:re}:re,ke=this._cache.add(ve.items);let Me;return{pid:ke,items:ve.items.map((Le,ze)=>{let Be;return Le.command&&(Me||(Me=new p.DisposableStore,this._disposables.set(ke,Me)),Be=this._commands.toInternal(Le.command,Me)),{text:Le.text,range:Le.range?b.Range.from(Le.range):void 0,command:Be,idx:ze,completeBracketPairs:Le.completeBracketPairs}})}}disposeCompletions(L){this._cache.delete(L);const F=this._disposables.get(L);F&&F.clear(),this._disposables.delete(L)}handleDidShowCompletionItem(L,F){const C=this._cache.get(L,F);C&&ue.get(this._provider).fireOnDidShowCompletionItem({completionItem:C})}}class ue{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(L){let F=ue.map.get(L);return F||(F=new ue,ue.map.set(L,F)),F}fireOnDidShowCompletionItem(L){this._onDidShowCompletionItemEmitter.fire(L)}}e.InlineCompletionController=ue,ue.map=new WeakMap;class fe{constructor(L,F){this._documents=L,this._provider=F,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(L,F,C,M){const H=this._documents.getDocument(L),X=b.Position.to(F),re=this.reviveContext(C),ve=await this._provider.provideSignatureHelp(H,X,M,re);if(ve){const ke=this._cache.add([ve]);return{...b.SignatureHelp.from(ve),id:ke}}}reviveContext(L){let F;if(L.activeSignatureHelp){const C=b.SignatureHelp.to(L.activeSignatureHelp),M=this._cache.get(L.activeSignatureHelp.id,0);M?(F=M,F.activeSignature=C.activeSignature,F.activeParameter=C.activeParameter):F=C}return{...L,activeSignatureHelp:F}}releaseSignatureHelp(L){this._cache.delete(L)}}class Se{constructor(L,F,C,M,H){this._documents=L,this._commands=F,this._provider=C,this._logService=M,this._extension=H,this._cache=new u.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(L,F,C){const M=this._documents.getDocument(L),H=b.Range.to(F),X=await this._provider.provideInlayHints(M,H,C);if(!Array.isArray(X)||X.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${F}`);return}if(C.isCancellationRequested)return;const re=this._cache.add(X);this._disposables.set(re,new p.DisposableStore);const ve={hints:[],cacheId:re};for(let ke=0;ke<X.length;ke++)this._isValidInlayHint(X[ke],H)&&ve.hints.push(this._convertInlayHint(X[ke],[re,ke]));return this._logService.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this._extension.identifier.value}' for ${F}`),ve}async resolveInlayHint(L,F){if(typeof this._provider.resolveInlayHint!="function")return;const C=this._cache.get(...L);if(!C)return;const M=await this._provider.resolveInlayHint(C,F);if(!!M&&!!this._isValidInlayHint(M))return this._convertInlayHint(M,L)}releaseHints(L){this._disposables.get(L)?.dispose(),this._disposables.delete(L),this._cache.delete(L)}_isValidInlayHint(L,F){return L.label.length===0||Array.isArray(L.label)&&L.label.every(C=>C.label.length===0)?(console.log("INVALID inlay hint, empty label",L),!1):!(F&&!F.contains(L.position))}_convertInlayHint(L,F){const C=this._disposables.get(F[0]);if(!C)throw Error("DisposableStore is missing...");const M={label:"",cacheId:F,tooltip:L.tooltip&&b.MarkdownString.from(L.tooltip),position:b.Position.from(L.position),kind:b.InlayHintKind.from(L.kind??$.InlayHintKind.Other),paddingLeft:L.paddingLeft,paddingRight:L.paddingRight};return typeof L.label=="string"?M.label=L.label:M.label=L.label.map(H=>{let X={label:H.label};return X.tooltip=H.tooltip&&b.MarkdownString.from(H.tooltip),$.Location.isLocation(H.location)&&(X.location=b.location.from(H.location)),H.command&&(X.command=this._commands.toInternal(H.command,C)),X}),M}}class ge{constructor(L,F){this._documents=L,this._provider=F,this._cache=new u.Cache("DocumentLink")}async provideLinks(L,F){const C=this._documents.getDocument(L),M=await this._provider.provideDocumentLinks(C,F);if(!(!Array.isArray(M)||M.length===0)&&!F.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:M.filter(ge._validateLink).map(b.DocumentLink.from)};{const H=this._cache.add(M),X={links:[],cacheId:H};for(let re=0;re<M.length;re++){if(!ge._validateLink(M[re]))continue;const ve=b.DocumentLink.from(M[re]);ve.cacheId=[H,re],X.links.push(ve)}return X}}}static _validateLink(L){return L.target&&L.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(L,F){if(typeof this._provider.resolveDocumentLink!="function")return;const C=this._cache.get(...L);if(!C)return;const M=await this._provider.resolveDocumentLink(C,F);if(!(!M||!ge._validateLink(M)))return b.DocumentLink.from(M)}releaseLinks(L){this._cache.delete(L)}}class ne{constructor(L,F){this._documents=L,this._provider=F}async provideColors(L,F){const C=this._documents.getDocument(L),M=await this._provider.provideDocumentColors(C,F);return Array.isArray(M)?M.map(X=>({color:b.Color.from(X.color),range:b.Range.from(X.range)})):[]}async provideColorPresentations(L,F,C){const M=this._documents.getDocument(L),H=b.Range.to(F.range),X=b.Color.to(F.color),re=await this._provider.provideColorPresentations(X,{document:M,range:H},C);if(!!Array.isArray(re))return re.map(b.ColorPresentation.from)}}class me{constructor(L,F){this._documents=L,this._provider=F}async provideFoldingRanges(L,F,C){const M=this._documents.getDocument(L),H=await this._provider.provideFoldingRanges(M,F,C);if(!!Array.isArray(H))return H.map(b.FoldingRange.from)}}class Ie{constructor(L,F,C){this._documents=L,this._provider=F,this._logService=C}async provideSelectionRanges(L,F,C){const M=this._documents.getDocument(L),H=F.map(b.Position.to),X=await this._provider.provideSelectionRanges(M,H,C);if(!(0,R.isNonEmptyArray)(X))return[];if(X.length!==H.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const re=[];for(let ve=0;ve<H.length;ve++){const ke=[];re.push(ke);let Me=H[ve],Le=X[ve];for(;;){if(!Le.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(b.SelectionRange.from(Le)),!Le.parent)break;Me=Le.range,Le=Le.parent}}return re}}class Ae{constructor(L,F){this._documents=L,this._provider=F,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(L,F,C){const M=this._documents.getDocument(L),H=b.Position.to(F),X=await this._provider.prepareCallHierarchy(M,H,C);if(!X)return;const re=this._idPool.nextId();return this._cache.set(re,new Map),Array.isArray(X)?X.map(ve=>this._cacheAndConvertItem(re,ve)):[this._cacheAndConvertItem(re,X)]}async provideCallsTo(L,F,C){const M=this._itemFromCache(L,F);if(!M)throw new Error("missing call hierarchy item");const H=await this._provider.provideCallHierarchyIncomingCalls(M,C);if(!!H)return H.map(X=>({from:this._cacheAndConvertItem(L,X.from),fromRanges:X.fromRanges.map(re=>b.Range.from(re))}))}async provideCallsFrom(L,F,C){const M=this._itemFromCache(L,F);if(!M)throw new Error("missing call hierarchy item");const H=await this._provider.provideCallHierarchyOutgoingCalls(M,C);if(!!H)return H.map(X=>({to:this._cacheAndConvertItem(L,X.to),fromRanges:X.fromRanges.map(re=>b.Range.from(re))}))}releaseSession(L){this._cache.delete(L)}_cacheAndConvertItem(L,F){const C=this._cache.get(L),M=b.CallHierarchyItem.from(F,L,C.size.toString(36));return C.set(M._itemId,F),M}_itemFromCache(L,F){return this._cache.get(L)?.get(F)}}class Ue{constructor(L,F){this._documents=L,this._provider=F,this._idPool=new i.IdGenerator(""),this._cache=new Map}async prepareSession(L,F,C){const M=this._documents.getDocument(L),H=b.Position.to(F),X=await this._provider.prepareTypeHierarchy(M,H,C);if(!X)return;const re=this._idPool.nextId();return this._cache.set(re,new Map),Array.isArray(X)?X.map(ve=>this._cacheAndConvertItem(re,ve)):[this._cacheAndConvertItem(re,X)]}async provideSupertypes(L,F,C){const M=this._itemFromCache(L,F);if(!M)throw new Error("missing type hierarchy item");const H=await this._provider.provideTypeHierarchySupertypes(M,C);if(!!H)return H.map(X=>this._cacheAndConvertItem(L,X))}async provideSubtypes(L,F,C){const M=this._itemFromCache(L,F);if(!M)throw new Error("missing type hierarchy item");const H=await this._provider.provideTypeHierarchySubtypes(M,C);if(!!H)return H.map(X=>this._cacheAndConvertItem(L,X))}releaseSession(L){this._cache.delete(L)}_cacheAndConvertItem(L,F){const C=this._cache.get(L),M=b.TypeHierarchyItem.from(F,L,C.size.toString(36));return C.set(M._itemId,F),M}_itemFromCache(L,F){return this._cache.get(L)?.get(F)}}class Ke{constructor(L,F){this.adapter=L,this.extension=F}}class pe{constructor(L,F,C,M,H,X,re){this._adapter=new Map,this._uriTransformer=F,this._proxy=L.getProxy(y.MainContext.MainThreadLanguageFeatures),this._documents=C,this._commands=M,this._diagnostics=H,this._logService=X,this._apiDeprecation=re}_transformDocumentSelector(L){return b.DocumentSelector.from(L,this._uriTransformer)}_createDisposable(L){return new $.Disposable(()=>{this._adapter.delete(L),this._proxy.$unregister(L)})}_nextHandle(){return pe._handlePool++}async _withAdapter(L,F,C,M,H){const X=this._adapter.get(L);if(!X||!(X.adapter instanceof F))return M;const re=Date.now();this._logService.trace(`[${X.extension.identifier.value}] INVOKE provider '${C.toString().replace(/[\r\n]/g,"")}'`);const ve=C(X.adapter,X.extension);return Promise.resolve(ve).catch(ke=>{(0,_.isCancellationError)(ke)||(this._logService.error(`[${X.extension.identifier.value}] provider FAILED`),this._logService.error(ke))}).finally(()=>{this._logService.trace(`[${X.extension.identifier.value}] provider DONE after ${Date.now()-re}ms`)}),n.CancellationToken.isCancellationToken(H)?(0,d.raceCancellationError)(ve,H):ve}_addNewAdapter(L,F){const C=this._nextHandle();return this._adapter.set(C,new Ke(L,F)),C}static _extLabel(L){return L.displayName||L.name}registerDocumentSymbolProvider(L,F,C,M){const H=this._addNewAdapter(new D(this._documents,C),L),X=M&&M.label||pe._extLabel(L);return this._proxy.$registerDocumentSymbolProvider(H,this._transformDocumentSelector(F),X),this._createDisposable(H)}$provideDocumentSymbols(L,F,C){return this._withAdapter(L,D,M=>M.provideDocumentSymbols(r.URI.revive(F),C),void 0,C)}registerCodeLensProvider(L,F,C){const M=this._nextHandle(),H=typeof C.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(M,new Ke(new a(this._documents,this._commands.converter,C),L)),this._proxy.$registerCodeLensSupport(M,this._transformDocumentSelector(F),H);let X=this._createDisposable(M);if(H!==void 0){const re=C.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(H));X=$.Disposable.from(X,re)}return X}$provideCodeLenses(L,F,C){return this._withAdapter(L,a,M=>M.provideCodeLenses(r.URI.revive(F),C),void 0,C)}$resolveCodeLens(L,F,C){return this._withAdapter(L,a,M=>M.resolveCodeLens(F,C),void 0,void 0)}$releaseCodeLenses(L,F){this._withAdapter(L,a,C=>Promise.resolve(C.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(L,F,C){const M=this._addNewAdapter(new c(this._documents,C),L);return this._proxy.$registerDefinitionSupport(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$provideDefinition(L,F,C,M){return this._withAdapter(L,c,H=>H.provideDefinition(r.URI.revive(F),C,M),[],M)}registerDeclarationProvider(L,F,C){const M=this._addNewAdapter(new t(this._documents,C),L);return this._proxy.$registerDeclarationSupport(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$provideDeclaration(L,F,C,M){return this._withAdapter(L,t,H=>H.provideDeclaration(r.URI.revive(F),C,M),[],M)}registerImplementationProvider(L,F,C){const M=this._addNewAdapter(new h(this._documents,C),L);return this._proxy.$registerImplementationSupport(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$provideImplementation(L,F,C,M){return this._withAdapter(L,h,H=>H.provideImplementation(r.URI.revive(F),C,M),[],M)}registerTypeDefinitionProvider(L,F,C){const M=this._addNewAdapter(new o(this._documents,C),L);return this._proxy.$registerTypeDefinitionSupport(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$provideTypeDefinition(L,F,C,M){return this._withAdapter(L,o,H=>H.provideTypeDefinition(r.URI.revive(F),C,M),[],M)}registerHoverProvider(L,F,C,M){const H=this._addNewAdapter(new l(this._documents,C),L);return this._proxy.$registerHoverProvider(H,this._transformDocumentSelector(F)),this._createDisposable(H)}$provideHover(L,F,C,M){return this._withAdapter(L,l,H=>H.provideHover(r.URI.revive(F),C,M),void 0,M)}registerEvaluatableExpressionProvider(L,F,C,M){const H=this._addNewAdapter(new f(this._documents,C),L);return this._proxy.$registerEvaluatableExpressionProvider(H,this._transformDocumentSelector(F)),this._createDisposable(H)}$provideEvaluatableExpression(L,F,C,M){return this._withAdapter(L,f,H=>H.provideEvaluatableExpression(r.URI.revive(F),C,M),void 0,void 0)}registerInlineValuesProvider(L,F,C,M){const H=typeof C.onDidChangeInlineValues=="function"?this._nextHandle():void 0,X=this._addNewAdapter(new m(this._documents,C),L);this._proxy.$registerInlineValuesProvider(X,this._transformDocumentSelector(F),H);let re=this._createDisposable(X);if(H!==void 0){const ve=C.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(H));re=$.Disposable.from(re,ve)}return re}$provideInlineValues(L,F,C,M,H){return this._withAdapter(L,m,X=>X.provideInlineValues(r.URI.revive(F),C,M,H),void 0,void 0)}registerDocumentHighlightProvider(L,F,C){const M=this._addNewAdapter(new E(this._documents,C),L);return this._proxy.$registerDocumentHighlightProvider(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$provideDocumentHighlights(L,F,C,M){return this._withAdapter(L,E,H=>H.provideDocumentHighlights(r.URI.revive(F),C,M),void 0,M)}registerLinkedEditingRangeProvider(L,F,C){const M=this._addNewAdapter(new T(this._documents,C),L);return this._proxy.$registerLinkedEditingRangeProvider(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$provideLinkedEditingRanges(L,F,C,M){return this._withAdapter(L,T,async H=>{const X=await H.provideLinkedEditingRanges(r.URI.revive(F),C,M);if(X)return{ranges:X.ranges,wordPattern:X.wordPattern?pe._serializeRegExp(X.wordPattern):void 0}},void 0,M)}registerReferenceProvider(L,F,C){const M=this._addNewAdapter(new A(this._documents,C),L);return this._proxy.$registerReferenceSupport(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$provideReferences(L,F,C,M,H){return this._withAdapter(L,A,X=>X.provideReferences(r.URI.revive(F),C,M,H),void 0,H)}registerCodeActionProvider(L,F,C,M){const H=new p.DisposableStore,X=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,C,this._logService,L,this._apiDeprecation),L);return this._proxy.$registerQuickFixSupport(X,this._transformDocumentSelector(F),{providedKinds:M?.providedCodeActionKinds?.map(re=>re.value),documentation:M?.documentation?.map(re=>({kind:re.kind.value,command:this._commands.converter.toInternal(re.command,H)}))},pe._extLabel(L),Boolean(C.resolveCodeAction)),H.add(this._createDisposable(X)),H}$provideCodeActions(L,F,C,M,H){return this._withAdapter(L,x,X=>X.provideCodeActions(r.URI.revive(F),C,M,H),void 0,H)}$resolveCodeAction(L,F,C){return this._withAdapter(L,x,M=>M.resolveCodeAction(F,C),void 0,void 0)}$releaseCodeActions(L,F){this._withAdapter(L,x,C=>Promise.resolve(C.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(L,F,C){const M=this._addNewAdapter(new g(this._documents,C),L);return this._proxy.$registerDocumentFormattingSupport(M,this._transformDocumentSelector(F),L.identifier,L.displayName||L.name),this._createDisposable(M)}$provideDocumentFormattingEdits(L,F,C,M){return this._withAdapter(L,g,H=>H.provideDocumentFormattingEdits(r.URI.revive(F),C,M),void 0,void 0)}registerDocumentRangeFormattingEditProvider(L,F,C){const M=this._addNewAdapter(new U(this._documents,C),L);return this._proxy.$registerRangeFormattingSupport(M,this._transformDocumentSelector(F),L.identifier,L.displayName||L.name),this._createDisposable(M)}$provideDocumentRangeFormattingEdits(L,F,C,M,H){return this._withAdapter(L,U,X=>X.provideDocumentRangeFormattingEdits(r.URI.revive(F),C,M,H),void 0,void 0)}registerOnTypeFormattingEditProvider(L,F,C,M){const H=this._addNewAdapter(new z(this._documents,C),L);return this._proxy.$registerOnTypeFormattingSupport(H,this._transformDocumentSelector(F),M,L.identifier),this._createDisposable(H)}$provideOnTypeFormattingEdits(L,F,C,M,H,X){return this._withAdapter(L,z,re=>re.provideOnTypeFormattingEdits(r.URI.revive(F),C,M,H,X),void 0,X)}registerWorkspaceSymbolProvider(L,F){const C=this._addNewAdapter(new q(F,this._logService),L);return this._proxy.$registerNavigateTypeSupport(C,typeof F.resolveWorkspaceSymbol=="function"),this._createDisposable(C)}$provideWorkspaceSymbols(L,F,C){return this._withAdapter(L,q,M=>M.provideWorkspaceSymbols(F,C),{symbols:[]},C)}$resolveWorkspaceSymbol(L,F,C){return this._withAdapter(L,q,M=>M.resolveWorkspaceSymbol(F,C),void 0,void 0)}$releaseWorkspaceSymbols(L,F){this._withAdapter(L,q,C=>C.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(L,F,C){const M=this._addNewAdapter(new j(this._documents,C,this._logService),L);return this._proxy.$registerRenameSupport(M,this._transformDocumentSelector(F),j.supportsResolving(C)),this._createDisposable(M)}$provideRenameEdits(L,F,C,M,H){return this._withAdapter(L,j,X=>X.provideRenameEdits(r.URI.revive(F),C,M,H),void 0,void 0)}$resolveRenameLocation(L,F,C,M){return this._withAdapter(L,j,H=>H.resolveRenameLocation(r.URI.revive(F),C,M),void 0,void 0)}registerDocumentSemanticTokensProvider(L,F,C,M){const H=this._addNewAdapter(new V(this._documents,C),L),X=typeof C.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(H,this._transformDocumentSelector(F),M,X);let re=this._createDisposable(H);if(X){const ve=C.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(X));re=$.Disposable.from(re,ve)}return re}$provideDocumentSemanticTokens(L,F,C,M){return this._withAdapter(L,V,H=>H.provideDocumentSemanticTokens(r.URI.revive(F),C,M),null,M)}$releaseDocumentSemanticTokens(L,F){this._withAdapter(L,V,C=>C.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(L,F,C,M){const H=this._addNewAdapter(new ie(this._documents,C),L);return this._proxy.$registerDocumentRangeSemanticTokensProvider(H,this._transformDocumentSelector(F),M),this._createDisposable(H)}$provideDocumentRangeSemanticTokens(L,F,C,M){return this._withAdapter(L,ie,H=>H.provideDocumentRangeSemanticTokens(r.URI.revive(F),C,M),null,M)}registerCompletionItemProvider(L,F,C,M){const H=this._addNewAdapter(new ae(this._documents,this._commands.converter,C,this._apiDeprecation,L),L);return this._proxy.$registerSuggestSupport(H,this._transformDocumentSelector(F),M,ae.supportsResolving(C),`${L.identifier.value}(${M.join("")})`),this._createDisposable(H)}$provideCompletionItems(L,F,C,M,H){return this._withAdapter(L,ae,X=>X.provideCompletionItems(r.URI.revive(F),C,M,H),void 0,H)}$resolveCompletionItem(L,F,C){return this._withAdapter(L,ae,M=>M.resolveCompletionItem(F,C),void 0,C)}$releaseCompletionItems(L,F){this._withAdapter(L,ae,C=>C.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(L,F,C){const M=this._addNewAdapter(new te(this._documents,C,this._commands.converter),L);return this._proxy.$registerInlineCompletionsSupport(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$provideInlineCompletions(L,F,C,M,H){return this._withAdapter(L,te,X=>X.provideInlineCompletions(r.URI.revive(F),C,M,H),void 0,void 0)}$handleInlineCompletionDidShow(L,F,C){this._withAdapter(L,te,async M=>{M.handleDidShowCompletionItem(F,C)},void 0,void 0)}$freeInlineCompletionsList(L,F){this._withAdapter(L,te,async C=>{C.disposeCompletions(F)},void 0,void 0)}registerSignatureHelpProvider(L,F,C,M){const H=Array.isArray(M)?{triggerCharacters:M,retriggerCharacters:[]}:M,X=this._addNewAdapter(new fe(this._documents,C),L);return this._proxy.$registerSignatureHelpProvider(X,this._transformDocumentSelector(F),H),this._createDisposable(X)}$provideSignatureHelp(L,F,C,M,H){return this._withAdapter(L,fe,X=>X.provideSignatureHelp(r.URI.revive(F),C,M,H),void 0,void 0)}$releaseSignatureHelp(L,F){this._withAdapter(L,fe,C=>C.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(L,F,C){const M=typeof C.onDidChangeInlayHints=="function"?this._nextHandle():void 0,H=this._addNewAdapter(new Se(this._documents,this._commands.converter,C,this._logService,L),L);this._proxy.$registerInlayHintsProvider(H,this._transformDocumentSelector(F),typeof C.resolveInlayHint=="function",M,pe._extLabel(L));let X=this._createDisposable(H);if(M!==void 0){const re=C.onDidChangeInlayHints(ve=>this._proxy.$emitInlayHintsEvent(M));X=$.Disposable.from(X,re)}return X}$provideInlayHints(L,F,C,M){return this._withAdapter(L,Se,H=>H.provideInlayHints(r.URI.revive(F),C,M),void 0,M)}$resolveInlayHint(L,F,C){return this._withAdapter(L,Se,M=>M.resolveInlayHint(F,C),void 0,C)}$releaseInlayHints(L,F){this._withAdapter(L,Se,C=>C.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(L,F,C){const M=this._addNewAdapter(new ge(this._documents,C),L);return this._proxy.$registerDocumentLinkProvider(M,this._transformDocumentSelector(F),typeof C.resolveDocumentLink=="function"),this._createDisposable(M)}$provideDocumentLinks(L,F,C){return this._withAdapter(L,ge,M=>M.provideLinks(r.URI.revive(F),C),void 0,void 0)}$resolveDocumentLink(L,F,C){return this._withAdapter(L,ge,M=>M.resolveLink(F,C),void 0,void 0)}$releaseDocumentLinks(L,F){this._withAdapter(L,ge,C=>C.releaseLinks(F),void 0,void 0)}registerColorProvider(L,F,C){const M=this._addNewAdapter(new ne(this._documents,C),L);return this._proxy.$registerDocumentColorProvider(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$provideDocumentColors(L,F,C){return this._withAdapter(L,ne,M=>M.provideColors(r.URI.revive(F),C),[],void 0)}$provideColorPresentations(L,F,C,M){return this._withAdapter(L,ne,H=>H.provideColorPresentations(r.URI.revive(F),C,M),void 0,void 0)}registerFoldingRangeProvider(L,F,C){const M=this._nextHandle(),H=typeof C.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(M,new Ke(new me(this._documents,C),L)),this._proxy.$registerFoldingRangeProvider(M,this._transformDocumentSelector(F),H);let X=this._createDisposable(M);if(H!==void 0){const re=C.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(H));X=$.Disposable.from(X,re)}return X}$provideFoldingRanges(L,F,C,M){return this._withAdapter(L,me,H=>H.provideFoldingRanges(r.URI.revive(F),C,M),void 0,void 0)}registerSelectionRangeProvider(L,F,C){const M=this._addNewAdapter(new Ie(this._documents,C,this._logService),L);return this._proxy.$registerSelectionRangeProvider(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$provideSelectionRanges(L,F,C,M){return this._withAdapter(L,Ie,H=>H.provideSelectionRanges(r.URI.revive(F),C,M),[],M)}registerCallHierarchyProvider(L,F,C){const M=this._addNewAdapter(new Ae(this._documents,C),L);return this._proxy.$registerCallHierarchyProvider(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$prepareCallHierarchy(L,F,C,M){return this._withAdapter(L,Ae,H=>Promise.resolve(H.prepareSession(r.URI.revive(F),C,M)),void 0,M)}$provideCallHierarchyIncomingCalls(L,F,C,M){return this._withAdapter(L,Ae,H=>H.provideCallsTo(F,C,M),void 0,M)}$provideCallHierarchyOutgoingCalls(L,F,C,M){return this._withAdapter(L,Ae,H=>H.provideCallsFrom(F,C,M),void 0,M)}$releaseCallHierarchy(L,F){this._withAdapter(L,Ae,C=>Promise.resolve(C.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(L,F,C){const M=this._addNewAdapter(new Ue(this._documents,C),L);return this._proxy.$registerTypeHierarchyProvider(M,this._transformDocumentSelector(F)),this._createDisposable(M)}$prepareTypeHierarchy(L,F,C,M){return this._withAdapter(L,Ue,H=>Promise.resolve(H.prepareSession(r.URI.revive(F),C,M)),void 0,M)}$provideTypeHierarchySupertypes(L,F,C,M){return this._withAdapter(L,Ue,H=>H.provideSupertypes(F,C,M),void 0,M)}$provideTypeHierarchySubtypes(L,F,C,M){return this._withAdapter(L,Ue,H=>H.provideSubtypes(F,C,M),void 0,M)}$releaseTypeHierarchy(L,F){this._withAdapter(L,Ue,C=>Promise.resolve(C.releaseSession(F)),void 0,void 0)}static _serializeRegExp(L){return{pattern:L.source,flags:(0,O.regExpFlags)(L)}}static _serializeIndentationRule(L){return{decreaseIndentPattern:pe._serializeRegExp(L.decreaseIndentPattern),increaseIndentPattern:pe._serializeRegExp(L.increaseIndentPattern),indentNextLinePattern:L.indentNextLinePattern?pe._serializeRegExp(L.indentNextLinePattern):void 0,unIndentedLinePattern:L.unIndentedLinePattern?pe._serializeRegExp(L.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(L){return{beforeText:pe._serializeRegExp(L.beforeText),afterText:L.afterText?pe._serializeRegExp(L.afterText):void 0,previousLineText:L.previousLineText?pe._serializeRegExp(L.previousLineText):void 0,action:L.action}}static _serializeOnEnterRules(L){return L.map(pe._serializeOnEnterRule)}setLanguageConfiguration(L,F,C){let{wordPattern:M}=C;if(M&&(0,O.regExpLeadsToEndlessLoop)(M))throw new Error(`Invalid language configuration: wordPattern '${M}' is not allowed to match the empty string.`);M?this._documents.setWordDefinitionFor(F,M):this._documents.setWordDefinitionFor(F,void 0),C.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",L,"Do not use."),C.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",L,"Do not use.");const H=this._nextHandle(),X={comments:C.comments,brackets:C.brackets,wordPattern:C.wordPattern?pe._serializeRegExp(C.wordPattern):void 0,indentationRules:C.indentationRules?pe._serializeIndentationRule(C.indentationRules):void 0,onEnterRules:C.onEnterRules?pe._serializeOnEnterRules(C.onEnterRules):void 0,__electricCharacterSupport:C.__electricCharacterSupport,__characterPairSupport:C.__characterPairSupport};return this._proxy.$setLanguageConfiguration(H,F,X),this._createDisposable(H)}$setWordDefinitions(L){for(const F of L)this._documents.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.ExtHostLanguageFeatures=pe,pe._handlePool=0}),define(Ee[191],be([1,0,4,8,7,34,11,6]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(N,v,n,p){this._documents=v,this._commands=n,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=N.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this._languageIds=N}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(N,v){await this._proxy.$changeLanguage(N,v);const n=this._documents.getDocumentData(N);if(!n)throw new Error(`document '${N.toString}' NOT found`);return n.document}async tokenAtPosition(N,v){const n=N.version,p=k.Position.from(v),s=await this._proxy.$tokensAtPosition(N.uri,p),i={type:b.StandardTokenType.Other,range:N.getWordRangeAtPosition(v)??new b.Range(v.line,v.character,v.line,v.character)};if(!s)return i;const u={range:k.Range.to(s.range),type:k.TokenType.to(s.type)};return!u.range.contains(v)||n!==N.version?i:u}createLanguageStatusItem(N,v,n){const p=this._handlePool++,s=this._proxy,i=this._ids,u=`${N.identifier.value}/${v}`;if(i.has(u))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);i.add(u);const S={selector:n,id:v,name:N.displayName??N.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let _,w=new O.DisposableStore;const d=()=>{_?.dispose(),_=(0,y.disposableTimeout)(()=>{w.clear(),this._proxy.$setLanguageStatus(p,{id:u,name:S.name??N.displayName??N.name,source:N.displayName??N.name,selector:k.DocumentSelector.from(S.selector,this._uriTransformer),label:S.text,detail:S.detail??"",severity:S.severity===b.LanguageStatusSeverity.Error?$.default.Error:S.severity===b.LanguageStatusSeverity.Warning?$.default.Warning:$.default.Info,command:S.command&&this._commands.toInternal(S.command,w),accessibilityInfo:S.accessibilityInformation,busy:S.busy})},0)},D={dispose(){w.dispose(),_?.dispose(),s.$removeLanguageStatus(p),i.delete(u)},get id(){return S.id},get name(){return S.name},set name(a){S.name=a,d()},get selector(){return S.selector},set selector(a){S.selector=a,d()},get text(){return S.text},set text(a){S.text=a,d()},get detail(){return S.detail},set detail(a){S.detail=a,d()},get severity(){return S.severity},set severity(a){S.severity=a,d()},get accessibilityInformation(){return S.accessibilityInformation},set accessibilityInformation(a){S.accessibilityInformation=a,d()},get command(){return S.command},set command(a){S.command=a,d()},get busy(){return S.busy},set busy(a){S.busy=a,d()}};return d(),D}}e.ExtHostLanguages=I}),define(Ee[192],be([1,0,12,4,28,14,5]),function(Y,e,r,k,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let O=class extends r.AbstractLoggerService{constructor(N,v){const n=new y.Emitter;super(v.logLevel,n.event);this._proxy=N.getProxy(k.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(N){this._onDidChangeLogLevel.fire(N)}doCreateLogger(N,v,n){return new I(this._proxy,N,v,n)}};O=Fe([Ne(0,$.IExtHostRpcService),Ne(1,b.IExtHostInitDataService)],O),e.ExtHostLoggerService=O;class I extends r.AbstractMessageLogger{constructor(N,v,n,p){super(p?.always);this.proxy=N,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(v,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(N,v){const n=[[N,v]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(N){this.proxy.$log(this.file,N)}}}),define(Ee[193],be([1,0,4,12,27]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function $(O){return O&&O.title}let y=class{constructor(I,R){this._logService=R,this._proxy=I.getProxy(r.MainContext.MainThreadMessageService)}showMessage(I,R,N,v,n){const p={source:{identifier:I.identifier,label:I.displayName||I.name}};let s;typeof v=="string"||$(v)?s=[v,...n]:(p.modal=v?.modal,p.useCustom=v?.useCustom,p.detail=v?.detail,s=n),p.useCustom&&(0,b.checkProposedApiEnabled)(I,"resolvers");const i=[];for(let u=0;u<s.length;u++){const S=s[u];if(typeof S=="string")i.push({title:S,handle:u,isCloseAffordance:!1});else if(typeof S=="object"){let{title:_,isCloseAffordance:w}=S;i.push({title:_,isCloseAffordance:!!w,handle:u})}else this._logService.warn("Invalid message item:",S)}return this._proxy.$showMessage(R,N,p,i).then(u=>{if(typeof u=="number")return s[u]})}};y=Fe([Ne(1,k.ILogService)],y),e.ExtHostMessageService=y}),define(Ee[194],be([1,0,21,5,93,6,22,10,13,2,57,4,8,7,38,168,89]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(w,d,D,a,P){this._textDocumentsAndEditors=D,this._textDocuments=a,this._extensionStoragePaths=P,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new y.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new k.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new k.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new k.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new N.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=w.getProxy(v.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=w.getProxy(v.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=w.getProxy(v.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===12){const t=c.notebookEditor?.notebookUri,h=c.cell.handle,l=this._documents.get(t)?.getCell(h);if(l)return l.apiCell}return c}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(w=>w.apiEditor)}getEditorById(w){const d=this._editors.get(w);if(!d)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(w){for(const[d,D]of this._editors)if(D.apiEditor===w)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(w,d){const D=this._documents.get(w);if(!D&&!d)throw new Error(`NO notebook document for '${w}'`);return D}_getProviderData(w){const d=this._notebookContentProviders.get(w);if(!d)throw new Error(`NO provider for '${w}'`);return d}registerNotebookContentProvider(w,d,D,a,P){if((0,O.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:w,provider:D});let c;return D.onDidChangeNotebookContentOptions&&(c=D.onDidChangeNotebookContentOptions(()=>{const t=n.NotebookDocumentContentOptions.from(D.options);this._notebookProxy.$updateNotebookProviderOptions(d,t)})),this._notebookProxy.$registerNotebookProvider({id:w.identifier,location:w.extensionLocation},d,n.NotebookDocumentContentOptions.from(a),S._convertNotebookRegistrationData(w,P)),new p.Disposable(()=>{c?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(w,d){if(!d)return;const D=d.filenamePattern.map(a=>n.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(d.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:d.displayName,filenamePattern:D,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,d,D){const a=S._notebookStatusBarItemProviderHandlePool++,P=typeof D.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,D),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,P,d);let c;return P!==void 0&&(c=D.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(P))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,P),c&&c.dispose()})}async createNotebookDocument(w){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:w.viewType,content:w.content&&n.NotebookData.from(w.content)});return R.URI.revive(d)}async openNotebookDocument(w){const d=this._documents.get(w);if(d)return d.apiNotebook;const D=await this._notebookDocumentsProxy.$tryOpenNotebook(w),a=this._documents.get(R.URI.revive(D));return(0,I.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(w,d){R.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let D;typeof d=="object"?D={position:n.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(n.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:D={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(w.uri,w.notebookType,D),P=a&&this._editors.get(a)?.apiEditor;if(P)return P;throw a?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,d,D,a){const P=this._notebookStatusBarItemProviders.get(w),c=R.URI.revive(d),t=this._documents.get(c);if(!t||!P)return;const h=t.getCellFromIndex(D);if(!h)return;const o=await P.provideCellStatusBarItems(h.apiCell,a);if(!o)return;const l=new $.DisposableStore,f=this._statusBarCache.add([l]),E=(Array.isArray(o)?o:[o]).map(T=>n.NotebookStatusBarItem.from(T,this._commandsConverter,l));return{cacheId:f,items:E}}$releaseNotebookCellStatusBarItems(w){this._statusBarCache.delete(w)}registerNotebookSerializer(w,d,D,a,P){if((0,O.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const c=this._handlePool++;return this._notebookSerializer.set(c,D),this._notebookProxy.$registerNotebookSerializer(c,{id:w.identifier,location:w.extensionLocation},d,n.NotebookDocumentContentOptions.from(a),S._convertNotebookRegistrationData(w,P)),(0,$.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(c)})}async $dataToNotebook(w,d,D){const a=this._notebookSerializer.get(w);if(!a)throw new Error("NO serializer found");const P=await a.deserializeNotebook(d.buffer,D);return new s.SerializableObjectWithBuffers(n.NotebookData.from(P))}async $notebookToData(w,d,D){const a=this._notebookSerializer.get(w);if(!a)throw new Error("NO serializer found");const P=await a.serializeNotebook(n.NotebookData.to(d.value),D);return r.VSBuffer.wrap(P)}async $openNotebook(w,d,D,a,P){const{provider:c}=this._getProviderData(w),t=await c.openNotebook(R.URI.revive(d),{backupId:D,untitledDocumentData:a?.buffer},P);return new s.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(n.NotebookCellData.from)})}async $saveNotebook(w,d,D){const a=this.getNotebookDocument(R.URI.revive(d)),{provider:P}=this._getProviderData(w);return await P.saveNotebook(a.apiNotebook,D),!0}async $saveNotebookAs(w,d,D,a){const P=this.getNotebookDocument(R.URI.revive(d)),{provider:c}=this._getProviderData(w);return await c.saveNotebookAs(R.URI.revive(D),P.apiNotebook,a),!0}async $backupNotebook(w,d,D){const a=this.getNotebookDocument(R.URI.revive(d)),P=this._getProviderData(w),c=this._extensionStoragePaths.workspaceValue(P.extension)??this._extensionStoragePaths.globalValue(P.extension),t=String((0,b.hash)([a.uri.toString(),this._backupIdPool++])),h=R.URI.joinPath(c,t),o=await P.provider.backupNotebook(a.apiNotebook,{destination:h},D);return a.updateBackup(o),o.id}_createExtHostEditor(w,d,D){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const a=new u.ExtHostNotebookEditor(d,this._notebookEditorsProxy,w,D.visibleRanges.map(n.NotebookRange.to),D.selections.map(n.NotebookRange.to),typeof D.viewColumn=="number"?n.ViewColumn.to(D.viewColumn):void 0);this._editors.set(d,a)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const D of w.value.removedDocuments){const a=R.URI.revive(D),P=this._documents.get(a);P&&(P.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:P.apiNotebook.getCells().map(c=>c.document.uri)}),this._onDidCloseNotebookDocument.fire(P.apiNotebook));for(const c of this._editors.values())c.notebookData.uri.toString()===a.toString()&&this._editors.delete(c.id)}if(w.value.addedDocuments){const D=[];for(const a of w.value.addedDocuments){const P=R.URI.revive(a.uri);if(this._documents.has(P))throw new Error(`adding EXISTING notebook ${P} `);const c=this,t=new i.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(h){c._onDidChangeNotebookCells.fire(h)},emitCellOutputsChange(h){c._onDidChangeCellOutputs.fire(h)},emitCellMetadataChange(h){c._onDidChangeCellMetadata.fire(h)}},P,a);D.push(...a.cells.map(h=>i.ExtHostCell.asModelAddData(t.apiNotebook,h))),this._documents.get(P)?.dispose(),this._documents.set(P,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(w.value.addedEditors)for(const D of w.value.addedEditors){if(this._editors.has(D.id))return;const a=R.URI.revive(D.documentUri),P=this._documents.get(a);P&&this._createExtHostEditor(P,D.id,D)}const d=[];if(w.value.removedEditors)for(const D of w.value.removedEditors){const a=this._editors.get(D);a&&(this._editors.delete(D),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),d.push(a))}if(w.value.visibleEditors){this._visibleNotebookEditors=w.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const D=new Set;this._visibleNotebookEditors.forEach(a=>D.add(a.id));for(const a of this._editors.values()){const P=D.has(a.id);a._acceptVisibility(P)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this._activeNotebookEditor=void 0:w.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(Ee[195],be([1,0,5,53,12,4,14,8]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class I{constructor(v,n){const p=I._Keys.nextId();v.$registerNotebookEditorDecorationType(p,O.NotebookDecorationRenderOptions.from(n)),this.value={key:p,dispose(){v.$removeNotebookEditorDecorationType(p)}}}}I._Keys=new k.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(v,n,p){this._logService=v,this._extHostRpc=n,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(v){return new I(this._extHostRpc.getProxy($.MainContext.MainThreadNotebookEditors),v).value}$acceptEditorPropertiesChanged(v,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,n);const p=this._notebooksAndEditors.getEditorById(v);n.visibleRanges&&p._acceptVisibleRanges(n.visibleRanges.ranges.map(O.NotebookRange.to)),n.selections&&p._acceptSelections(n.selections.selections.map(O.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const n in v)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(O.ViewColumn.to(v[n]))}};R=Fe([Ne(0,b.ILogService),Ne(1,y.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(Ee[196],be([1,0,16,11,20,5,6,22,2,25,12,4,39,8,7,60,161,27,38]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,h,o,l,f){this._initData=h,this._extHostNotebook=o,this._commands=l,this._logService=f,this._activeExecutions=new O.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new $.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=t.getProxy(v.MainContext.MainThreadNotebookKernels);const m=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const T=this._extHostNotebook.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:T}}else if(E&&"notebookEditor"in E){const T=this._extHostNotebook.getIdByEditor(E.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.document.uri.toString()}`);return{notebookEditorId:T}}return E})],n.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(t,h,o,l,f,m){for(const ue of this._kernelData.values())if(ue.controller.id===h&&R.ExtensionIdentifier.equals(t.identifier,ue.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const E=this._handlePool++,T=this;this._logService.trace(`NotebookController[${E}], CREATED by ${t.identifier.value}, ${h}`);const A=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${t.identifier}'`);let x=!1;const g=new y.DisposableStore,U=new $.Emitter,z=new $.Emitter,q={id:P(t,h),notebookType:o,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:l||t.identifier.value,preloads:m?m.map(p.NotebookRendererScript.from):[]};let j=f??A,J;this._proxy.$addKernel(E,q).catch(ue=>{console.log(ue),x=!0});let V=0;const ie=()=>{if(x)return;const ue=++V;Promise.resolve().then(()=>{ue===V&&this._proxy.$updateKernel(E,q)})},ae=new O.ResourceMap,te={get id(){return h},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return q.label},set label(ue){q.label=ue??t.displayName??t.name,ie()},get detail(){return q.detail??""},set detail(ue){q.detail=ue,ie()},get description(){return q.description??""},set description(ue){q.description=ue,ie()},get kind(){return(0,S.checkProposedApiEnabled)(t,"notebookControllerKind"),q.kind??""},set kind(ue){(0,S.checkProposedApiEnabled)(t,"notebookControllerKind"),q.kind=ue,ie()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(ue){q.supportedLanguages=ue,ie()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){q.supportsExecutionOrder=ue,ie()},get rendererScripts(){return q.preloads?q.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return j},set executeHandler(ue){j=ue??A},get interruptHandler(){return J},set interruptHandler(ue){J=ue,q.supportsInterrupt=Boolean(ue),ie()},createNotebookCellExecution(ue){if(x)throw new Error("notebook controller is DISPOSED");if(!ae.has(ue.notebook.uri))throw T._logService.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(fe=>fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return T._createNotebookCellExecution(ue,P(t,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${E}], DISPOSED`),x=!0,this._kernelData.delete(E),g.dispose(),U.dispose(),z.dispose(),this._proxy.$removeKernel(E))},updateNotebookAffinity(ue,fe){T._proxy.$updateNotebookPriority(E,ue.uri,fe)},onDidReceiveMessage:z.event,postMessage(ue,fe){return(0,S.checkProposedApiEnabled)(t,"notebookMessaging"),T._proxy.$postMessage(E,fe&&T._extHostNotebook.getIdByEditor(fe),ue)},asWebviewUri(ue){return(0,S.checkProposedApiEnabled)(t,"notebookMessaging"),(0,i.asWebviewUri)(ue,T._initData.remote)}};return this._kernelData.set(E,{extensionId:t.identifier,controller:te,onDidReceiveMessage:z,onDidChangeSelection:U,associatedNotebooks:ae}),te}$acceptNotebookAssociation(t,h,o){const l=this._kernelData.get(t);if(l){const f=this._extHostNotebook.getNotebookDocument(I.URI.revive(h));o?l.associatedNotebooks.set(f.uri,!0):l.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,f.uri.toString(),o),l.onDidChangeSelection.fire({selected:o,notebook:f.apiNotebook})}}async $executeCells(t,h,o){const l=this._kernelData.get(t);if(!l)return;const f=this._extHostNotebook.getNotebookDocument(I.URI.revive(h)),m=[];for(const E of o){const T=f.getCell(E);T&&m.push(T.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,f.uri.toString(),m.length),await l.controller.executeHandler.call(l.controller,m,f.apiNotebook,l.controller)}catch(E){this._logService.error(`NotebookController[${t}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(t,h,o){const l=this._kernelData.get(t);if(!l)return;const f=this._extHostNotebook.getNotebookDocument(I.URI.revive(h));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,f.apiNotebook);else for(const m of o){const E=f.getCell(m);E&&this._activeExecutions.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,h,o){const l=this._kernelData.get(t);if(!l)return;const f=this._extHostNotebook.getEditorById(h);l.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:o}))}$cellExecutionChanged(t,h,o){const f=this._extHostNotebook.getNotebookDocument(I.URI.revive(t)).getCell(h);f&&this._onDidChangeCellExecutionState.fire({cell:f.apiCell,state:o??s.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(t,h){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const f=new D(h,l,this._proxy);this._activeExecutions.set(l.uri,f);const m=f.onDidChangeState(()=>{f.state===d.Resolved&&(f.dispose(),m.dispose(),this._activeExecutions.delete(l.uri))});return f.asApiObject()}};w=Fe([Ne(4,N.ILogService)],w),e.ExtHostNotebookKernels=w;var d;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(d||(d={}));class D extends y.Disposable{constructor(t,h,o){super();this._cell=h,this._proxy=o,this._handle=D.HANDLE++,this._onDidChangeState=new $.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new a(10,l=>this.update(l)),this._executionOrder=h.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,t,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(t){await this._collector.addItem(t)}async update(t){const h=Array.isArray(t)?t:[t];return this._proxy.$updateExecution(this._handle,new _.SerializableObjectWithBuffers(h))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(t){return t.map(h=>{const o=s.NotebookCellOutput.ensureUniqueMimeTypes(h.items,!0);return o===h.items?p.NotebookCellOutput.from(h):p.NotebookCellOutput.from({items:o,id:h.id,metadata:h.metadata})})}async updateOutputs(t,h,o){const l=this.validateAndConvertOutputs((0,r.asArray)(t));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,append:o,outputs:l})}async updateOutputItems(t,h,o){return t=s.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(t),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,items:t.map(p.NotebookCellOutputItem.from),outputId:h.id,append:o})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(o){t._executionOrder=o,t.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:t._executionOrder}])},start(o){if(t._state===d.Resolved||t._state===d.Started)throw new Error("Cannot call start again");t._state=d.Started,t._onDidChangeState.fire(),t.update({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:o})},end(o,l){if(t._state===d.Resolved)throw new Error("Cannot call resolve twice");t._state=d.Resolved,t._onDidChangeState.fire(),t._collector.flush(),t._proxy.$completeExecution(t._handle,new _.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:o}))},clearOutput(o){return t.verifyStateForOutput(),t.updateOutputs([],o,!1)},appendOutput(o,l){return t.verifyStateForOutput(),t.updateOutputs(o,l,!0)},replaceOutput(o,l){return t.verifyStateForOutput(),t.updateOutputs(o,l,!1)},appendOutputItems(o,l){return t.verifyStateForOutput(),t.updateOutputItems(o,l,!0)},replaceOutputItems(o,l){return t.verifyStateForOutput(),t.updateOutputItems(o,l,!1)}})}}D.HANDLE=0;class a{constructor(t,h){this.delay=t,this.callback=h,this.batch=[],this.startedTimer=Date.now()}addItem(t){return this.batch.push(t),this.currentDeferred||(this.currentDeferred=new k.DeferredPromise,this.startedTimer=Date.now(),(0,k.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const t=this.currentDeferred;this.currentDeferred=void 0;const h=this.batch;return this.batch=[],this.callback(h).finally(()=>t.complete())}}function P(c,t){return`${c.identifier.value}/${t}`}}),define(Ee[197],be([1,0,5,4,89,27]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(I,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,R,N){const v=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(R)?.fire({editor:v.apiEditor,message:N})}createRendererMessaging(I,R){if(!I.contributes?.notebookRenderer?.some(p=>p.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const N=(0,$.isProposedApiEnabled)(I,"notebookEditor"),v=new WeakMap;return{onDidReceiveMessage:(p,s,i)=>{const u=N?p:S=>{const _={};v.set(_,S.editor),p({editor:_,message:S.message})};return this.getOrCreateEmitterFor(R).event(u,s,i)},postMessage:(p,s)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(p)&&([p,s]=[s,p]);const i=N?s:v.get(s),u=i&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(i);return this.proxy.$postMessage(u?.id,R,p)}}}getOrCreateEmitterFor(I){let R=this._rendererMessageEmitters.get(I);return R||(R=new r.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,R),R)}}e.ExtHostNotebookRenderers=y}),define(Ee[94],be([1,0,4,6,3,14,12,162,50,28,30,112,21]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class p extends k.Disposable{constructor(u,S,_,w){super();this.id=u,this.name=S,this.logger=_,this.proxy=w,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(u){this.append(u+`
`)}append(u){this.write(u),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,O.OutputChannelUpdateMode.Append))}clear(){const u=this.offset;this.logger.flush(),this.proxy.$update(this.id,O.OutputChannelUpdateMode.Clear,u)}replace(u){const S=this.offset;this.write(u),this.proxy.$update(this.id,O.OutputChannelUpdateMode.Replace,S),this.visible&&this.logger.flush()}show(u,S){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof u=="boolean"?u:S))}hide(){this.proxy.$close(this.id)}write(u){this.offset+=n.VSBuffer.fromString(u).byteLength,this.logger.info(u)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=p;let s=class{constructor(u,S,_,w,d){this.extHostFileSystem=_,this.extHostFileSystemInfo=w,this.loggerService=d,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=u.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(S.logsLocation,`output_logging_${(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.visibleChannelId=u;for(const[S,_]of this.channels)_.visible=S===this.visibleChannelId}createOutputChannel(u,S){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const _=this.doCreateOutputChannel(u,S);return _.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),this.createExtHostOutputChannel(u,_)}async doCreateOutputChannel(u,S){const _=await this.createOutputDirectory(),w=this.extHostFileSystemInfo.extUri.joinPath(_,`${this.namePool++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(w,{always:!0,donotRotate:!0,donotUseFormatters:!0}),D=await this.proxy.$register(u,!1,w,S.identifier.value);return new p(D,u,d,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(u,S){let _=!1;const w=()=>{if(_)throw new Error("Channel has been closed")};return{get name(){return u},append(d){w(),S.then(D=>D.append(d))},appendLine(d){w(),S.then(D=>D.appendLine(d))},clear(){w(),S.then(d=>d.clear())},replace(d){w(),S.then(D=>D.replace(d))},show(d,D){w(),S.then(a=>a.show(d,D))},hide(){w(),S.then(d=>d.hide())},dispose(){_=!0,S.then(d=>d.dispose())}}}};s=Fe([Ne(0,$.IExtHostRpcService),Ne(1,R.IExtHostInitDataService),Ne(2,I.IExtHostConsumerFileSystem),Ne(3,N.IExtHostFileSystemInfo),Ne(4,y.ILoggerService)],s),e.ExtHostOutputService=s,e.IExtHostOutputService=(0,b.createDecorator)("IExtHostOutputService")}),define(Ee[198],be([1,0,11,20,5,6,4,2,7,15,16,34,56]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(s,i,u){const S=s.getProxy(y.MainContext.MainThreadQuickOpen);class _{constructor(o,l){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=l}showQuickPick(o,l,f=k.CancellationToken.None){this._onDidSelectItem=void 0;const m=Promise.resolve(o),E=++this._instances,T=S.$show(E,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},f),A={},x=T.then(()=>A);return Promise.race([x,m]).then(g=>{if(g!==A)return m.then(U=>{const z=[];for(let q=0;q<U.length;q++){const j=U[q];typeof j=="string"?z.push({label:j,handle:q}):j.kind===I.QuickPickItemKind.Separator?z.push({type:"separator",label:j.label}):z.push({label:j.label,description:j.description,detail:j.detail,picked:j.picked,alwaysShow:j.alwaysShow,handle:q})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{l.onDidSelectItem(U[q])}),S.$setItems(E,z),T.then(q=>{if(typeof q=="number")return U[q];if(Array.isArray(q))return q.map(j=>U[j])})})}).then(void 0,g=>{if(!(0,R.isCancellationError)(g))return S.$setError(E,g),Promise.reject(g)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,l=k.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,S.$input(o,typeof this._validateInput=="function",l).then(void 0,f=>{if(!(0,R.isCancellationError)(f))return Promise.reject(f)})}$validateInput(o){return this._validateInput?(0,r.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,l=k.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!f)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(E=>E.uri.toString()===f.uri.toString())}createQuickPick(o){const l=new c(o,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(o){const l=new t(o,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(o,l){const f=this._sessions.get(o);f&&f._fireDidChangeValue(l)}$onDidAccept(o){const l=this._sessions.get(o);l&&l._fireDidAccept()}$onDidChangeActive(o,l){const f=this._sessions.get(o);f instanceof c&&f._fireDidChangeActive(l)}$onDidChangeSelection(o,l){const f=this._sessions.get(o);f instanceof c&&f._fireDidChangeSelection(l)}$onDidTriggerButton(o,l){const f=this._sessions.get(o);f&&f._fireDidTriggerButton(l)}$onDidTriggerItemButton(o,l,f){const m=this._sessions.get(o);m instanceof c&&m._fireDidTriggerItemButton(l,f)}$onDidHide(o){const l=this._sessions.get(o);l&&l._fireDidHide()}}class w{constructor(o,l){this._extensionId=o,this._onDidDispose=l,this._id=c._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new b.Emitter,this._onDidChangeValueEmitter=new b.Emitter,this._onDidTriggerButtonEmitter=new b.Emitter,this._onDidHideEmitter=new b.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((l,f)=>{const m=l===I.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(m,l)}),this.update({buttons:o.map((l,f)=>({...P(l),tooltip:l.tooltip,handle:l===I.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const l=this._handlesToButtons.get(o);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,$.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(o){if(!this._disposed){for(const l of Object.keys(o)){const f=o[l];this._pendingUpdate[l]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function d(h){if(h instanceof I.ThemeIcon)return{id:h.id};const o=a(h),l=D(h);return{dark:typeof o=="string"?O.URI.file(o):o,light:typeof l=="string"?O.URI.file(l):l}}function D(h){return typeof h=="object"&&"light"in h?h.light:h}function a(h){return typeof h=="object"&&"dark"in h?h.dark:h}function P(h){const o=d(h.iconPath);let l,f;return"id"in o?f=n.ThemeIcon.asClassName(o):l=o,{iconPath:l,iconClass:f}}class c extends w{constructor(o,l){super(o.identifier,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new b.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new b.Emitter,this._onDidTriggerItemButtonEmitter=new b.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((f,m)=>{this._handlesToItems.set(m,f),this._itemsToHandles.set(f,m)});const l=[];for(let f=0;f<o.length;f++){const m=o[f];m.kind===I.QuickPickItemKind.Separator?l.push({type:"separator",label:m.label}):l.push({handle:f,label:m.label,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons?.map((E,T)=>({...P(E),tooltip:E.tooltip,handle:T}))})}this.update({items:l})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(o){const l=(0,N.coalesce)(o.map(f=>this._handlesToItems.get(f)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(o){const l=(0,N.coalesce)(o.map(f=>this._handlesToItems.get(f)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}_fireDidTriggerItemButton(o,l){const f=this._handlesToItems.get(o);if(!f||!f.buttons||!f.buttons.length)return;const m=f.buttons[l];m&&this._onDidTriggerItemButtonEmitter.fire({button:m,item:f})}}class t extends w{constructor(o,l){super(o,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?v.default.Error:v.default.Ignore})}}return new _(i,u)}e.createExtHostQuickOpen=p});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[199],be([1,0,2,5,52,6,11,4,16,107,12,25,56,8,27]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s){"use strict";var i,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function S(f){if(f)return typeof f.iconPath=="string"?r.URI.file(f.iconPath):r.URI.isUri(f.iconPath)||n.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function _(f,m){if(!f.iconPath&&!m.iconPath)return 0;if(f.iconPath){if(!m.iconPath)return 1}else return-1;const E=typeof f.iconPath=="string"?f.iconPath:r.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,T=typeof m.iconPath=="string"?m.iconPath:r.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,R.comparePaths)(E,T)}function w(f,m){let E=0;if(f.strikeThrough!==m.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==m.faded)return f.faded?1:-1;if(f.tooltip!==m.tooltip)return(f.tooltip||"").localeCompare(m.tooltip||"");if(E=_(f,m),E!==0)return E;if(f.light&&m.light)E=_(f.light,m.light);else{if(f.light)return 1;if(m.light)return-1}if(E!==0)return E;if(f.dark&&m.dark)E=_(f.dark,m.dark);else{if(f.dark)return 1;if(m.dark)return-1}return E}function d(f,m){if(f.command!==m.command)return f.command<m.command?-1:1;if(f.title!==m.title)return f.title<m.title?-1:1;if(f.tooltip!==m.tooltip){if(f.tooltip!==void 0&&m.tooltip!==void 0)return f.tooltip<m.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(f.arguments===m.arguments)return 0;if(f.arguments)if(m.arguments){if(f.arguments.length!==m.arguments.length)return f.arguments.length-m.arguments.length}else return 1;else return-1;for(let E=0;E<f.arguments.length;E++){const T=f.arguments[E],A=m.arguments[E];if(T!==A)return T<A?-1:1}return 0}function D(f,m){let E=(0,R.comparePaths)(f.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(E!==0)return E;if(f.command&&m.command)E=d(f.command,m.command);else{if(f.command)return 1;if(m.command)return-1}if(E!==0)return E;if(f.decorations&&m.decorations)E=w(f.decorations,m.decorations);else{if(f.decorations)return 1;if(m.decorations)return-1}return E}function a(f,m){for(let E=0;E<f.length;E++)if(f[E]!==m[E])return!1;return!0}function P(f,m){return f.command===m.command&&f.title===m.title&&f.tooltip===m.tooltip&&(f.arguments&&m.arguments?a(f.arguments,m.arguments):f.arguments===m.arguments)}function c(f,m){return(0,I.equals)(f,m,P)}class t{constructor(m,E,T){this._extension=m,this._sourceControlHandle=T,i.set(this,void 0),this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0,je(this,i,E,"f")}get value(){return this._value}set value(m){m=m??"",De(this,i,"f").$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){De(this,i,"f").$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(m){if((0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,De(this,i,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,De(this,i,"f").$setInputBoxVisibility(this._sourceControlHandle,m))}showValidationMessage(m,E){(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),De(this,i,"f").$showValidationMessage(this._sourceControlHandle,m,E)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=t,i=new WeakMap;class h{constructor(m,E,T,A,x){this._proxy=m,this._commands=E,this._sourceControlHandle=T,this._id=A,this._label=x,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=h._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,E){const T=this._resourceStatesCommandsMap.get(m);return T?(0,y.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(D),T=(0,I.sortedDiff)(this._resourceSnapshot,m,D).map(g=>{const U=g.toInsert.map(z=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,z);const j=z.resourceUri;let J;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const me=new $.DisposableStore;J=this._commands.converter.toInternal(z.command,me),this._resourceStatesDisposablesMap.set(q,me)}else this._resourceStatesCommandsMap.set(q,z.command);const V=S(z.decorations),ie=z.decorations&&S(z.decorations.light)||V,ae=z.decorations&&S(z.decorations.dark)||V,te=[ie,ae],ue=z.decorations&&z.decorations.tooltip||"",fe=z.decorations&&!!z.decorations.strikeThrough,Se=z.decorations&&!!z.decorations.faded,ge=z.contextValue||"";return{rawResource:[q,j,te,ue,fe,Se,ge,J],handle:q}});return{start:g.start,deleteCount:g.deleteCount,toInsert:U}}),A=T.map(({start:g,deleteCount:U,toInsert:z})=>[g,U,z.map(q=>q.rawResource)]),x=T.reverse();for(const{start:g,deleteCount:U,toInsert:z}of x){const q=z.map(J=>J.handle),j=this._handlesSnapshot.splice(g,U,...q);for(const J of j)this._resourceStatesMap.delete(J),this._resourceStatesCommandsMap.delete(J),this._resourceStatesDisposablesMap.get(J)?.dispose(),this._resourceStatesDisposablesMap.delete(J)}return this._resourceSnapshot=m,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}h._handlePool=0;class o{constructor(m,E,T,A,x,g){this._extension=m,this._commands=T,this._id=A,this._label=x,this._rootUri=g,u.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new $.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new $.MutableDisposable,this._statusBarDisposables=new $.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,je(this,u,E,"f"),this._inputBox=new t(m,De(this,u,"f"),this.handle),De(this,u,"f").$registerSourceControl(this.handle,A,x,g)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,De(this,u,"f").$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,De(this,u,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,De(this,u,"f").$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new $.DisposableStore,this._acceptInputCommand=m;const E=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);De(this,u,"f").$updateSourceControl(this.handle,{acceptInputCommand:E})}get actionButton(){return(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(m){(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new $.DisposableStore,this._actionButton=m;const E=m!==void 0?{command:this._commands.converter.toInternal(m.command,this._actionButtonDisposables.value),description:m.description}:void 0;De(this,u,"f").$updateSourceControl(this.handle,{actionButton:E??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&c(this._statusBarCommands,m))return;this._statusBarDisposables.value=new $.DisposableStore,this._statusBarCommands=m;const E=(m||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));De(this,u,"f").$updateSourceControl(this.handle,{statusBarCommands:E})}get selected(){return this._selected}createResourceGroup(m,E){const T=new h(De(this,u,"f"),this._commands,this.handle,m,E),A=k.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,A),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const m=[],E=[];for(const[T,A]of this.createdResourceGroups){A.dispose();const x=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});k.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),x.dispose(),this._groups.delete(T.handle),De(this,u,"f").$unregisterGroup(this.handle,T.handle)}),m.push([T.handle,T.id,T.label,T.features]);const g=T._takeResourceStateSnapshot();g.length>0&&E.push([T.handle,g]),this._groups.set(T.handle,T)}De(this,u,"f").$registerGroups(this.handle,m,E),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(E=>{const T=E._takeResourceStateSnapshot();T.length!==0&&m.push([E.handle,T])}),m.length>0&&De(this,u,"f").$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),De(this,u,"f").$unregisterSourceControl(this.handle)}}u=new WeakMap,o._handlePool=0,Fe([(0,b.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Fe([(0,b.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let l=class Wi{constructor(m,E,T){this._commands=E,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=m.getProxy(O.MainContext.MainThreadSCM),this._telemetry=m.getProxy(O.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const x=this._sourceControls.get(A.sourceControlHandle);if(!x)return A;const g=x.getResourceGroup(A.groupHandle);return g?g.getResourceState(A.handle):A}else if(A&&A.$mid===4){const x=this._sourceControls.get(A.sourceControlHandle);return x?x.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const x=this._sourceControls.get(A.handle);return x||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,E,T,A){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,E,T,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const x=Wi._handlePool++,g=new o(m,this._proxy,this._commands,E,T,A);this._sourceControls.set(x,g);const U=this._sourceControlsByExtension.get(v.ExtensionIdentifier.toKey(m.identifier))||[];return U.push(g),this._sourceControlsByExtension.set(v.ExtensionIdentifier.toKey(m.identifier),U),g}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const E=this._sourceControlsByExtension.get(v.ExtensionIdentifier.toKey(m.identifier)),T=E&&E[E.length-1];return T&&T.inputBox}$provideOriginalResource(m,E,T){const A=r.URI.revive(E);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,A.toString());const x=this._sourceControls.get(m);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(A,T)).then(g=>g||null)}$onInputBoxValueChange(m,E){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const T=this._sourceControls.get(m);return T&&T.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(m,E,T,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,E,T);const x=this._sourceControls.get(m);if(!x)return Promise.resolve(void 0);const g=x.getResourceGroup(E);return g?g.$executeResourceCommand(T,A):Promise.resolve(void 0)}$validateInput(m,E,T){this.logService.trace("ExtHostSCM#$validateInput",m);const A=this._sourceControls.get(m);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>A.inputBox.validateInput(E,T)).then(x=>{if(!x)return Promise.resolve(void 0);const g=p.MarkdownString.fromStrict(x.message);return g?Promise.resolve([g,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};l._handlePool=0,l=Fe([Ne(2,N.ILogService)],l),e.ExtHostSCM=l});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[200],be([1,0,7,4,124,6,8,13]),function(Y,e,r,k,b,$,y,O){"use strict";var I,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(s,i,u,S,_=r.StatusBarAlignment.Left,w){I.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new $.DisposableStore,je(this,I,s,"f"),je(this,R,i,"f"),this._entryId=N.ID_GEN++,this._extension=u,this._id=S,this._alignment=_,this._priority=this.validatePriority(w)}validatePriority(s){if(!!(0,O.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!N.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:De(this,R,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:De(this,R,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,De(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let i;this._name?i=this._name:i=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let u=this._color;this._backgroundColor&&(u=N.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip?y.MarkdownString.fromStrict(this._tooltip):void 0;De(this,I,"f").$setEntry(this._entryId,s,i,this._text,S,this._command?.internal,u,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=N,I=new WeakMap,R=new WeakMap,N.ID_GEN=0,N.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class v{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const i={message:s};return this._messages.unshift(i),this._update(),new r.Disposable(()=>{const u=this._messages.indexOf(i);u>=0&&(this._messages.splice(u,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(s,i){this._proxy=s.getProxy(k.MainContext.MainThreadStatusBar),this._commands=i,this._statusMessage=new v(this)}createStatusBarEntry(s,i,u,S){return new N(this._proxy,this._commands,s,i,u,S)}setStatusBarMessage(s,i){const u=this._statusMessage.setMessage(s);let S;return typeof i=="number"?S=setTimeout(()=>u.dispose(),i):typeof i!="undefined"&&i.then(()=>u.dispose(),()=>u.dispose()),new r.Disposable(()=>{u.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=n}),define(Ee[65],be([1,0,4,5,3]),function(Y,e,r,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class ${constructor(O){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=O.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(O,I){this._proxy.$registerExtensionStorageKeysToSync(O,I)}initializeExtensionStorage(O,I,R){return this._proxy.$initializeExtensionStorage(O,I).then(N=>N||R)}setValue(O,I,R){return this._proxy.$setValue(O,I,R)}$acceptValue(O,I,R){this._onDidChangeStorage.fire({shared:O,key:I,value:R})}}e.ExtHostStorage=$,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(Ee[66],be([1,0,3,28,12,50,2]),function(Y,e,r,k,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let O=class{constructor(R,N,v){this._logService=N,this._extHostFileSystem=v,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(R){return y.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,N=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(N),this._logService.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",N),await this._extHostFileSystem.value.createDirectory(N),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),N}catch(v){this._logService.error("[ExtHostStorage]",v);return}}workspaceValue(R){if(this._value)return y.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return y.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};O=Fe([Ne(0,k.IExtHostInitDataService),Ne(1,b.ILogService),Ne(2,$.IExtHostConsumerFileSystem)],O),e.ExtensionStoragePaths=O}),define(Ee[40],be([1,0,5,4,3,2,14,6,7,125,15,164,20,36,144,56,13,11]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class _{constructor(o,l,f,m){this._proxy=o,this._id=l,this._creationOptions=f,this._name=m,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(T,A=!0){E._checkDisposed(),E._proxy.$sendText(E._id,T,A)},show(T){E._checkDisposed(),E._proxy.$show(E._id,T)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(o,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,u.withNullAsUndefined)(o.shellPath),shellArgs:(0,u.withNullAsUndefined)(o.shellArgs),cwd:(0,u.withNullAsUndefined)(o.cwd),env:(0,u.withNullAsUndefined)(o.env),icon:(0,u.withNullAsUndefined)(c(o.iconPath)),color:i.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,u.withNullAsUndefined)(o.message),strictEnv:(0,u.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,u.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,u.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,u.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(o.location,l?.resolvedExtHostIdentifier),disablePersistence:(0,u.withNullAsUndefined)(o.disablePersistence)})}async createExtensionTerminal(o,l,f,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:i.ThemeColor.isThemeColor(m)?m.id:void 0,location:this._serializeParentTerminal(o,l),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,l){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in o?{viewColumn:o.viewColumn,preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitCode(o){this._exitStatus=Object.freeze({code:o})}setDimensions(o,l){return o===this._cols&&l===this._rows||o===0||l===0?!1:(this._cols=o,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=_;class w{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,l){this._pty.setDimensions?.({columns:o,rows:l})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let d=1,D=class extends O.Disposable{constructor(o,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[f,m]of this._terminalProcesses)m.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,l){const f=new _(this._proxy,(0,p.generateUuid)(),o,o.name),m=new w(o.pty);return f.createExtensionTerminal(o.location,this._serializeParentTerminal(o,l).resolvedExtHostIdentifier,c(o.iconPath),t(o.color)).then(E=>{const T=this._setupExtHostProcessListeners(E,m);this._terminalProcessDisposables[E]=T}),this._terminals.push(f),f.value}_serializeParentTerminal(o,l){if(l=l||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const f=o.location.parentTerminal;if(f){const m=this._terminals.find(E=>E.value===f);m&&(l.resolvedExtHostIdentifier=m._id)}}else o.location&&typeof o.location!="object"?l.location=o.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(o,l){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const m=new w(l),E=this._setupExtHostProcessListeners(o,m);this._terminalProcessDisposables[o]=E}async $acceptActiveTerminalChanged(o){const l=this._activeTerminal;if(o===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(o);f&&(this._activeTerminal=f,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,l){const f=this._getTerminalById(o);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:l})}async $acceptTerminalDimensions(o,l,f){const m=this._getTerminalById(o);m&&m.setDimensions(l,f)&&this._onDidChangeTerminalDimensions.fire({terminal:m.value,dimensions:m.value.dimensions})}async $acceptTerminalMaximumDimensions(o,l,f){this._terminalProcesses.get(o)?.resize(l,f)}async $acceptTerminalTitleChange(o,l){const f=this._getTerminalById(o);f&&(f.name=l)}async $acceptTerminalClosed(o,l){const f=this._getTerminalObjectIndexById(this._terminals,o);if(f!==null){const m=this._terminals.splice(f,1)[0];m.setExitCode(l),this._onDidCloseTerminal.fire(m.value)}}$acceptTerminalOpened(o,l,f,m){if(l){const A=this._getTerminalObjectIndexById(this._terminals,l);if(A!==null){this._terminals[A]._id=o,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const E={name:m.name,shellPath:m.executable,shellArgs:m.args,cwd:typeof m.cwd=="string"?m.cwd:$.URI.revive(m.cwd),env:m.env,hideFromUser:m.hideFromUser},T=new _(this._proxy,o,E,f);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(o,l){const f=this._getTerminalById(o);f&&f._setProcessId(l)}async $startExtensionTerminal(o,l){const f=this._getTerminalById(o);if(!f)return{message:(0,R.localize)(0,null,o)};f.isOpen||await new Promise(E=>{const T=this.onDidOpenTerminal(async A=>{A===f.value&&(T.dispose(),E())})});const m=this._terminalProcesses.get(o);m?m.startSendingEvents(l):this._extensionTerminalAwaitingStart[o]={initialDimensions:l}}_setupExtHostProcessListeners(o,l){const f=new O.DisposableStore;f.add(l.onProcessReady(E=>this._proxy.$sendProcessReady(o,E.pid,E.cwd))),f.add(l.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(o,E))),this._bufferer.startBuffering(o,l.onProcessData),f.add(l.onProcessExit(E=>this._onProcessExit(o,E))),this._terminalProcesses.set(o,l);const m=this._extensionTerminalAwaitingStart[o];return m&&l instanceof w&&(l.startSendingEvents(m.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),f}$acceptProcessAckDataEvent(o,l){this._terminalProcesses.get(o)?.acknowledgeDataEvent(l)}$acceptProcessInput(o,l){this._terminalProcesses.get(o)?.input(l)}$acceptTerminalInteraction(o){const l=this._getTerminalById(o);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(o,l,f){try{this._terminalProcesses.get(o)?.resize(l,f)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(o,l){this._terminalProcesses.get(o)?.shutdown(l)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(l=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:l}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new I.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,l,f){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,f),this._proxy.$registerProfileProvider(l,o.identifier.value),new I.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(o,l){const f=new n.CancellationTokenSource().token;let m=await this._profileProviders.get(o)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(m&&!("options"in m)&&(m={options:m}),!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,l);return}this.createTerminalFromOptions(m.options,l)}}async $provideLinks(o,l){const f=this._getTerminalById(o);if(!f)return[];this._terminalLinkCache.delete(o);const m=this._terminalLinkCancellationSource.get(o);m&&m.dispose(!0);const E=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,E);const T=[],A={terminal:f.value,line:l},x=[];for(const z of this._linkProviders)x.push(S.Promises.withAsyncBody(async q=>{E.token.onCancellationRequested(()=>q({provider:z,links:[]}));const j=await z.provideTerminalLinks(A,E.token)||[];E.token.isCancellationRequested||q({provider:z,links:j})}));const g=await Promise.all(x);if(E.token.isCancellationRequested)return[];const U=new Map;for(const z of g)z&&z.links.length>0&&T.push(...z.links.map(q=>{const j={id:d++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return U.set(j.id,{provider:z.provider,link:q}),j}));return this._terminalLinkCache.set(o,U),T}$activateLink(o,l){const f=this._terminalLinkCache.get(o)?.get(l);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(o,l){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const f=this._terminalProcessDisposables[o];f&&(f.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,l)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,l){const f=this._getTerminalObjectIndexById(o,l);return f!==null?o[f]:null}_getTerminalObjectIndexById(o,l){let f=null;return o.some((m,E)=>m._id===l?(f=E,!0):!1),f}getEnvironmentVariableCollection(o){let l=this._environmentVariableCollections.get(o.identifier.value);return l||(l=new a,this._setEnvironmentVariableCollection(o.identifier.value,l)),l}_syncEnvironmentVariableCollection(o,l){const f=(0,v.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(o,l.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(o){o.forEach(l=>{const f=l[0],m=new a(l[1]);this._setEnvironmentVariableCollection(f,m)})}$acceptDefaultProfile(o,l){this._defaultProfile=o,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(o,l){this._environmentVariableCollections.set(o,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,l)})}};D=Fe([Ne(1,y.IExtHostRpcService)],D),e.BaseExtHostTerminalService=D;class a{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,l){this._setIfDiffers(o,{value:l,type:I.EnvironmentVariableMutatorType.Replace})}append(o,l){this._setIfDiffers(o,{value:l,type:I.EnvironmentVariableMutatorType.Append})}prepend(o,l){this._setIfDiffers(o,{value:l,type:I.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,l){const f=this.map.get(o);(!f||f.value!==l.value||f.type!==l.type)&&(this.map.set(o,l),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,l){this.map.forEach((f,m)=>o.call(l,m,f,this))}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let P=class extends D{constructor(o){super(!1,o)}createTerminal(o,l,f){throw new N.NotSupportedError}createTerminalFromOptions(o,l){throw new N.NotSupportedError}};P=Fe([Ne(0,y.IExtHostRpcService)],P),e.WorkerExtHostTerminalService=P;function c(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function t(h){return i.ThemeColor.isThemeColor(h)?h:void 0}});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[201],be([1,0,16,21,20,5,232,93,6,26,13,36,4,14,48,8,7,170,84,61]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_,w){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let D=class{constructor(A,x){this.resultsChangedEmitter=new $.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(n.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new P(this.proxy),x.registerArgumentProcessor({processArgument:g=>g?.$mid===13?i.TestItem.toItemFromContext(g):g})}createTestController(A,x,g){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const U=new I.DisposableStore,z=U.add(new S.SingleUseTestCollection(A));z.root.label=x;const q=new Map,j=this.proxy,J={items:z.root.children,get label(){return x},set label(ie){x=ie,z.root.label=ie,j.$updateController(A,{label:x})},get refreshHandler(){return g},set refreshHandler(ie){g=ie,j.$updateController(A,{canRefresh:!!ie})},get id(){return A},createRunProfile:(ie,ae,te,ue,fe)=>{let Se=(0,O.hash)(ie);for(;q.has(Se);)Se++;const ge=new m(this.proxy,A,Se,ie,ae,te,ue,fe);return q.set(Se,ge),ge},createTestItem(ie,ae,te){return new s.TestItemImpl(A,ie,ae,te)},createTestRun:(ie,ae,te=!0)=>this.runTracker.createTestRun(A,z,ie,ae,te),set resolveHandler(ie){z.resolveHandler=ie},get resolveHandler(){return z.resolveHandler},dispose:()=>{U.dispose()}};j.$registerTestController(A,x,!!g),U.add((0,I.toDisposable)(()=>j.$unregisterTestController(A)));const V={controller:J,collection:z,profiles:q};return this.controllers.set(A,V),U.add((0,I.toDisposable)(()=>this.controllers.delete(A))),U.add(z.onDidGenerateDiff(ie=>j.$publishDiff(A,ie))),J}createTestObserver(){return this.observer.checkout()}async runTests(A,x=b.CancellationToken.None){const g=c(A);if(!g)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(g.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:A.include?.map(z=>z.id)??[U.collection.root.id],profileGroup:E[g.kind],profileId:g.profileId,controllerId:g.controllerId}],exclude:A.exclude?.map(z=>z.id)},x)}$provideFileCoverage(A,x,g){return(0,r.mapFind)(this.runTracker.trackers,z=>z.id===A?z.getCoverage(x):void 0)?.provideFileCoverage(g)??Promise.resolve([])}$resolveFileCoverage(A,x,g,U){return(0,r.mapFind)(this.runTracker.trackers,q=>q.id===A?q.getCoverage(x):void 0)?.resolveFileCoverage(g,U)??Promise.resolve([])}$configureRunProfile(A,x){this.controllers.get(A)?.profiles.get(x)?.configureHandler?.()}async $refreshTests(A,x){await this.controllers.get(A)?.controller.refreshHandler?.(x)}$publishTestResults(A){this.results=Object.freeze(A.map(x=>(0,R.deepFreeze)(i.TestResults.to(x))).concat(this.results).sort((x,g)=>g.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,x){const g=this.controllers.get(w.TestId.fromString(A).controllerId)?.collection;g&&(await g.expand(A,x<0?1/0:x),g.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,x){const g=this.controllers.get(A.controllerId);if(!g)return;const{collection:U,profiles:z}=g,q=z.get(A.profileId);if(!q)return;const j=A.testIds.map(ae=>U.tree.get(ae)).filter(N.isDefined),J=A.excludeExtIds.map(ae=>g.collection.tree.get(ae)).filter(N.isDefined).filter(ae=>j.some(te=>te.fullId.compare(ae.fullId)===2));if(!j.length)return;const V=new u.TestRunRequest(j.some(ae=>ae.actual instanceof s.TestItemRootImpl)?void 0:j.map(ae=>ae.actual),J.map(ae=>ae.actual),q),ie=this.runTracker.prepareForMainThreadTestRun(V,t.fromInternal(A,g.collection),x);try{await q.runHandler(V,x)}finally{ie.isRunning&&!x.isCancellationRequested&&await $.Event.toPromise(ie.onEnd),ie.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};D=Fe([Ne(0,p.IExtHostRpcService)],D),e.ExtHostTesting=D;class a extends I.Disposable{constructor(A,x,g){super();this.dto=A,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new $.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(g)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:U}of this.tasks.values())U.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const x=this.dto.id,g=this.dto.controllerId,U=(0,v.generateUuid)(),z=new h(this.proxy,x,U),q=ie=>(ae,...te)=>{if(J){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ae)||(this.ensureTestIsKnown(ae),ie(ae,...te))},j=(ie,ae)=>{const te=ae instanceof Array?ae.map(i.TestMessage.from):[i.TestMessage.from(ae)];if(ie.uri&&ie.range){const ue={range:i.Range.from(ie.range),uri:ie.uri};for(const fe of te)fe.location=fe.location||ue}this.proxy.$appendTestMessagesInRun(x,U,w.TestId.fromExtHostTestItem(ie,g).toString(),te)};let J=!1;const V={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return z.coverageProvider},set coverageProvider(ie){z.coverageProvider=ie},enqueued:q(ie=>{this.proxy.$updateTestStateInRun(x,U,w.TestId.fromExtHostTestItem(ie,g).toString(),1)}),skipped:q(ie=>{this.proxy.$updateTestStateInRun(x,U,w.TestId.fromExtHostTestItem(ie,g).toString(),5)}),started:q(ie=>{this.proxy.$updateTestStateInRun(x,U,w.TestId.fromExtHostTestItem(ie,g).toString(),2)}),errored:q((ie,ae,te)=>{j(ie,ae),this.proxy.$updateTestStateInRun(x,U,w.TestId.fromExtHostTestItem(ie,g).toString(),6,te)}),failed:q((ie,ae,te)=>{j(ie,ae),this.proxy.$updateTestStateInRun(x,U,w.TestId.fromExtHostTestItem(ie,g).toString(),4,te)}),passed:q((ie,ae)=>{this.proxy.$updateTestStateInRun(x,U,w.TestId.fromExtHostTestItem(ie,this.dto.controllerId).toString(),3,ae)}),appendOutput:(ie,ae,te)=>{J||(te&&(this.dto.isIncluded(te)?this.ensureTestIsKnown(te):te=void 0),this.proxy.$appendOutputToRun(x,U,k.VSBuffer.fromString(ie),ae&&i.location.from(ae),te&&w.TestId.fromExtHostTestItem(te,g).toString()))},end:()=>{J||(J=!0,this.proxy.$finishedTestRunTask(x,U),this.tasks.delete(U),this.isRunning||this.dispose())}};return this.tasks.set(U,{run:V,coverage:z}),this.proxy.$startedTestRunTask(x,{id:U,name:A,running:!0}),V}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof s.TestItemImpl))throw new s.InvalidTestItemError(A.id);if(this.sharedTestIds.has(w.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const x=[],g=this.dto.colllection.root;for(;;){const U=i.TestItem.from(A);if(x.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),A===g))break;A=A.parent||g}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class P{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,x,g){return this.getTracker(A,x,g)}cancelRunById(A){for(const x of this.tracked.values())if(x.id===A){x.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,x,g,U,z){const q=this.tracked.get(g);if(q)return q.createRun(U);const j=t.fromPublic(A,x,g,z),J=c(g);this.proxy.$startedExtensionTestRun({controllerId:A,profile:J&&{group:E[J.kind],id:J.profileId},exclude:g.exclude?.map(ie=>ie.id)??[],id:j.id,include:g.include?.map(ie=>ie.id)??[x.root.id],persist:z});const V=this.getTracker(g,j);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun(j.id)),V.createRun(U)}getTracker(A,x,g){const U=new a(x,this.proxy,g);return this.tracked.set(A,U),U.onEnd(()=>this.tracked.delete(A)),U}}e.TestRunCoordinator=P;const c=T=>{if(!!T.profile){if(!(T.profile instanceof m))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class t{constructor(A,x,g,U,z,q){this.controllerId=A,this.id=x,this.isPersisted=z,this.colllection=q,this.includePrefix=g.map(j=>j+"\0"),this.excludePrefix=U.map(j=>j+"\0")}static fromPublic(A,x,g,U){return new t(A,(0,v.generateUuid)(),g.include?.map(z=>w.TestId.fromExtHostTestItem(z,A).toString())??[A],g.exclude?.map(z=>w.TestId.fromExtHostTestItem(z,A).toString())??[],U,x)}static fromInternal(A,x){return new t(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,x)}isIncluded(A){const x=w.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const g of this.excludePrefix)if(x===g||x.startsWith(g))return!1;for(const g of this.includePrefix)if(x===g||x.startsWith(g))return!0;return!1}}e.TestRunDto=t;class h{constructor(A,x,g){this.proxy=A,this.runId=x,this.taskId=g}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(i.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(A,x){const g=await this.fileCoverage;let U=g?.[A];return!this._coverageProvider||!g||!U?[]:(U.detailedCoverage||(U=g[A]=await this._coverageProvider.resolveFileCoverage?.(U,x)??U),U.detailedCoverage?.map(i.TestCoverage.fromDetailed)??[])}}class o extends _.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,i.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:x,removed:g}=this;return{get added(){return[...A].map(U=>U.revived)},get updated(){return[...x].map(U=>U.revived)},get removed(){return[...g].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new $.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,x){return{...A,revived:i.TestItem.toPlain(A.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=l;class f{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(x=>x.revived)},dispose:(0,y.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class m{constructor(A,x,g,U,z,q,j=!1,J=void 0){this.controllerId=x,this.profileId=g,this._label=U,this.kind=z,this.runHandler=q,this._isDefault=j,this._tag=J,d.set(this,void 0),je(this,d,A,"f");const V=E[z];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);De(this,d,"f").$publishTestRunProfile({profileId:g,controllerId:x,tag:J?i.TestTag.namespace(this.controllerId,J.id):null,label:U,group:V,isDefault:j,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,De(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,De(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,De(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?i.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,De(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){De(this,d,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=m,d=new WeakMap;const E={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(Ee[202],be([1,0,5,16,4,90,8,7]),function(Y,e,r,k,b,$,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class I{constructor(N,v){this._extHostDocumentsAndEditors=v,this._onDidChangeTextEditorSelection=new r.Emitter,this._onDidChangeTextEditorOptions=new r.Emitter,this._onDidChangeTextEditorVisibleRanges=new r.Emitter,this._onDidChangeTextEditorViewColumn=new r.Emitter,this._onDidChangeActiveTextEditor=new r.Emitter,this._onDidChangeVisibleTextEditors=new r.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=N.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(N){const v=this._extHostDocumentsAndEditors.allEditors();return N?v:v.map(n=>n.value)}async showTextDocument(N,v,n){let p;typeof v=="number"?p={position:y.ViewColumn.from(v),preserveFocus:n}:typeof v=="object"?p={position:y.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?y.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:p={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(N.uri,p),i=s&&this._extHostDocumentsAndEditors.getEditor(s);if(i)return i.value;throw s?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,v){return new $.TextEditorDecorationType(this._proxy,N,v).value}$acceptEditorPropertiesChanged(N,v){const n=this._extHostDocumentsAndEditors.getEditor(N);if(!n)throw new Error("unknown text editor");if(v.options&&n._acceptOptions(v.options),v.selections){const p=v.selections.selections.map(y.Selection.to);n._acceptSelections(p)}if(v.visibleRanges){const p=k.coalesce(v.visibleRanges.map(y.Range.to));n._acceptVisibleRanges(p)}if(v.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...v.options,lineNumbers:y.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const p=O.TextEditorSelectionChangeKind.fromValue(v.selections.source),s=v.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:p})}if(v.visibleRanges){const p=k.coalesce(v.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:p})}}$acceptEditorPositionData(N){for(const v in N){const n=this._extHostDocumentsAndEditors.getEditor(v);if(!n)throw new Error("Unknown text editor");const p=y.ViewColumn.to(N[v]);n.value.viewColumn!==p&&(n._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:p}))}}getDiffInformation(N){return Promise.resolve(this._proxy.$getDiffInformation(N))}}e.ExtHostEditors=I}),define(Ee[203],be([1,0,2,3,4,6,7]),function(Y,e,r,k,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class O{constructor(N,v){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=N.getProxy(b.MainContext.MainThreadTimeline),v.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const p=n.uri===void 0?void 0:r.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(I(p))?.get(n.handle)}return n}})}async $getTimeline(N,v,n,p,s){return this._providers.get(N)?.provideTimeline(r.URI.revive(v),n,p,s)}registerTimelineProvider(N,v,n,p){const s=new $.DisposableStore,i=this.convertTimelineItem(v.id,p,s).bind(this);let u;v.onDidChange&&(u=v.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:v.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...v,scheme:N,onDidChange:void 0,async provideTimeline(_,w,d,D){D?.resetCache&&(s.clear(),S.get(v.id)?.clear());const a=await v.provideTimeline(_,w,d);if(a==null)return;const P=i(_,D);return{...a,source:v.id,items:a.items.map(P)}},dispose(){for(const _ of S.values())_.get(v.id)?.clear();u?.dispose(),s.dispose()}})}convertTimelineItem(N,v,n){return(p,s)=>{let i;if(s?.cacheResults){let u=this._itemsBySourceAndUriMap.get(N);u===void 0&&(u=new Map,this._itemsBySourceAndUriMap.set(N,u));const S=I(p);i=u.get(S),i===void 0&&(i=new Map,u.set(S,i))}return u=>{const{iconPath:S,..._}=u,w=`${N}|${u.id??u.timestamp}`;i?.set(w,u);let d,D,a;return u.iconPath&&(S instanceof y.ThemeIcon?a={id:S.id,color:S.color}:r.URI.isUri(S)?(d=S,D=S):{light:d,dark:D}=S),{..._,id:_.id??void 0,handle:w,source:N,command:u.command?v.toInternal(u.command,n):void 0,icon:d,iconDark:D,themeIcon:a,accessibilityInformation:u.accessibilityInformation}}}}registerTimelineProviderCore(N){if(this._providers.get(N.id))throw new Error(`Timeline Provider ${N.id} already exists.`);return this._proxy.$registerTimelineProvider({id:N.id,label:N.label,scheme:N.scheme}),this._providers.set(N.id,N),(0,$.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(N.id)?.clear();this._providers.delete(N.id),this._proxy.$unregisterTimelineProvider(N.id),N.dispose()})}}e.ExtHostTimeline=O;function I(R){return R?.toString()}}),define(Ee[204],be([1,0,6,9,2,4]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(I){this._openers=new Map,this._proxy=I.getProxy($.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(I,R,N,v){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const n=v.schemes.find(p=>!y.supportedSchemes.has(p));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,N),this._proxy.$registerUriOpener(R,v.schemes,I,v.label),(0,r.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(I,R,N){const v=this._openers.get(I);if(!v)throw new Error(`Unknown opener with id: ${I}`);const n=b.URI.revive(R);return v.canOpenExternalUri(n,N)}async $openUri(I,R,N){const v=this._openers.get(I);if(!v)throw new Error(`Unknown opener id: '${I}'`);return v.openExternalUri(b.URI.revive(R.resolvedUri),{sourceUri:b.URI.revive(R.sourceUri)},N)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(Ee[205],be([1,0,4,2,6,15,25]),function(Y,e,r,k,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class O{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(R,N){if(this.handles.has(y.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const v=O.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(R)),this.handlers.set(v,N),this._proxy.$registerUriHandler(v,R),(0,b.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(R)),this.handlers.delete(v),this._proxy.$unregisterUriHandler(v)})}$handleExternalUri(R,N){const v=this.handlers.get(R);if(!v)return Promise.resolve(void 0);try{v.handleUri(k.URI.revive(N))}catch(n){(0,$.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(R){return k.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=O,O.HandlePool=0});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[51],be([1,0,5,9,2,135,153,60,4]),function(Y,e,r,k,b,$,y,O,I){"use strict";var R,N,v,n,p,s,i,u,S,_,w,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{constructor(f,m,E,T,A,x,g){R.set(this,void 0),N.set(this,void 0),v.set(this,void 0),n.set(this,void 0),p.set(this,void 0),s.set(this,void 0),i.set(this,""),u.set(this,void 0),S.set(this,!1),_.set(this,!1),w.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new r.Emitter),this._onDidDispose=De(this,d,"f").event,je(this,R,f,"f"),je(this,N,m,"f"),je(this,u,E,"f"),je(this,n,T,"f"),je(this,p,A,"f"),je(this,s,x,"f"),je(this,w,a(x),"f"),je(this,v,g,"f")}dispose(){je(this,S,!0,"f"),De(this,d,"f").fire(),De(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return je(this,_,!0,"f"),(0,O.asWebviewUri)(f,De(this,n,"f").remote)}get cspSource(){const f=De(this,s,"f").extensionLocation;if(f.scheme===k.Schemas.https||f.scheme===k.Schemas.http){let m=f.toString();return m.endsWith("/")||(m+="/"),m+" "+O.webviewGenericCspSource}return O.webviewGenericCspSource}get html(){return this.assertNotDisposed(),De(this,i,"f")}set html(f){this.assertNotDisposed(),De(this,i,"f")!==f&&(je(this,i,f,"f"),!De(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(je(this,_,!0,"f"),De(this,v,"f").report("Webview vscode-resource: uris",De(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),De(this,N,"f").$setHtml(De(this,R,"f"),f))}get options(){return this.assertNotDisposed(),De(this,u,"f")}set options(f){this.assertNotDisposed(),De(this,N,"f").$setOptions(De(this,R,"f"),t(De(this,s,"f"),De(this,p,"f"),f)),je(this,u,f,"f")}async postMessage(f){if(De(this,S,"f"))return!1;const m=(0,y.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:De(this,w,"f")});return De(this,N,"f").$postMessage(De(this,R,"f"),m.message,...m.buffers)}assertNotDisposed(){if(De(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=D,R=new WeakMap,N=new WeakMap,v=new WeakMap,n=new WeakMap,p=new WeakMap,s=new WeakMap,i=new WeakMap,u=new WeakMap,S=new WeakMap,_=new WeakMap,w=new WeakMap,d=new WeakMap;function a(l){try{const f=(0,$.normalizeVersion)((0,$.parseVersion)(l.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class P{constructor(f,m,E,T,A){this.initData=m,this.workspace=E,this._logService=T,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=f.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(f,m,E){const T=this.getWebview(f);if(T){const{message:A}=(0,y.deserializeWebviewMessage)(m,E.value);T._onMessageEmitter.fire(A)}}$onMissingCsp(f,m){this._logService.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,m,E){const T=new D(f,this._webviewProxy,h(m),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(f,T),T._onDidDispose(()=>{this._webviews.delete(f)}),T}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=P;function c(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=c;function t(l,f,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||o(l,f)}}e.serializeWebviewOptions=t;function h(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(f=>b.URI.from(f))}}e.reviveOptions=h;function o(l,f){return[...(f?.getWorkspaceFolders()||[]).map(m=>m.uri),l.extensionLocation]}}),define(Ee[206],be([1,0,20,93,6,9,24,2,8,51,57,4,7]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(a,P){this.document=a,this._storagePath=P,this._backupCounter=1,this._edits=new N.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,P){await this.getEdit(a).undo(),P||this.disposeBackup()}async redo(a,P){await this.getEdit(a).redo(),P||this.disposeBackup()}disposeEdits(a){for(const P of a)this._edits.delete(P)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=d(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const P=this._edits.get(a,0);if(!P)throw new Error("No edit found");return P}}class s{constructor(){this._documents=new Map}get(a,P){return this._documents.get(this.key(a,P))}add(a,P,c){const t=this.key(a,P.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${a} resource:${P.uri}`);const h=new p(P,c);return this._documents.set(t,h),h}delete(a,P){const c=this.key(a,P.uri);this._documents.delete(c)}key(a,P){return`${a}@@@${P}`}}var i;(function(D){D[D.Text=0]="Text",D[D.Custom=1]="Custom"})(i||(i={}));class u{constructor(){this._providers=new Map}addTextProvider(a,P,c){return this.add(0,a,P,c)}addCustomProvider(a,P,c){return this.add(1,a,P,c)}get(a){return this._providers.get(a)}add(a,P,c,t){if(this._providers.has(P))throw new Error(`Provider for viewType:${P} already registered`);return this._providers.set(P,{type:a,extension:c,provider:t}),new n.Disposable(()=>this._providers.delete(P))}}class S{constructor(a,P,c,t,h){this._extHostDocuments=P,this._extensionStoragePaths=c,this._extHostWebview=t,this._extHostWebviewPanels=h,this._editorProviders=new u,this._documents=new s,this._proxy=a.getProxy(v.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,P,c,t){const h=new b.DisposableStore;return _(c)?(h.add(this._editorProviders.addTextProvider(P,a,c)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(a),P,t.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(a))):(h.add(this._editorProviders.addCustomProvider(P,a,c)),this.supportEditing(c)&&h.add(c.onDidChangeCustomDocument(o=>{const l=this.getCustomDocumentEntry(P,o.document.uri);if(w(o)){const f=l.addEdit(o);this._proxy.$onDidEdit(o.document.uri,P,f,o.label)}else this._proxy.$onContentChange(o.document.uri,P)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(a),P,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(a))),n.Disposable.from(h,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(P)}))}async $createCustomDocument(a,P,c,t,h){const o=this._editorProviders.get(P);if(!o)throw new Error(`No provider found for '${P}'`);if(o.type!==1)throw new Error(`Invalid provide type for '${P}'`);const l=O.URI.revive(a),f=await o.provider.openCustomDocument(l,{backupId:c,untitledDocumentData:t?.buffer},h);let m;return this.supportEditing(o.provider)&&this._extensionStoragePaths&&(m=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension)),this._documents.add(P,f,m),{editable:this.supportEditing(o.provider)}}async $disposeCustomDocument(a,P){const c=this._editorProviders.get(P);if(!c)throw new Error(`No provider found for '${P}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${P}'`);const t=O.URI.revive(a),{document:h}=this.getCustomDocumentEntry(P,t);this._documents.delete(P,h),h.dispose()}async $resolveWebviewEditor(a,P,c,t,h,o){const l=this._editorProviders.get(c);if(!l)throw new Error(`No provider found for '${c}'`);const f=I.ViewColumn.to(h),m=this._extHostWebview.createNewWebview(P,t.webviewOptions,l.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(P,c,t.title,f,t.panelOptions,m),T=O.URI.revive(a);switch(l.type){case 1:{const{document:A}=this.getCustomDocumentEntry(c,T);return l.provider.resolveCustomEditor(A,E,o)}case 0:{const A=this._extHostDocuments.getDocument(T);return l.provider.resolveCustomTextEditor(A,E,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,P,c){this.getCustomDocumentEntry(P,a).disposeEdits(c)}async $onMoveCustomEditor(a,P,c){const t=this._editorProviders.get(c);if(!t)throw new Error(`No provider found for '${c}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const h=this._extHostWebviewPanels.getWebviewPanel(a);if(!h)throw new Error("No webview found");const o=O.URI.revive(P),l=this._extHostDocuments.getDocument(o);await t.provider.moveCustomTextEditor(l,h,r.CancellationToken.None)}async $undo(a,P,c,t){return this.getCustomDocumentEntry(P,a).undo(c,t)}async $redo(a,P,c,t){return this.getCustomDocumentEntry(P,a).redo(c,t)}async $revert(a,P,c){const t=this.getCustomDocumentEntry(P,a);await this.getCustomEditorProvider(P).revertCustomDocument(t.document,c),t.disposeBackup()}async $onSave(a,P,c){const t=this.getCustomDocumentEntry(P,a);await this.getCustomEditorProvider(P).saveCustomDocument(t.document,c),t.disposeBackup()}async $onSaveAs(a,P,c,t){const h=this.getCustomDocumentEntry(P,a);return this.getCustomEditorProvider(P).saveCustomDocumentAs(h.document,O.URI.revive(c),t)}async $backup(a,P,c){const t=this.getCustomDocumentEntry(P,a),o=await this.getCustomEditorProvider(P).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},c);return t.updateBackup(o),o.id}getCustomDocumentEntry(a,P){const c=this._documents.get(a,O.URI.revive(P));if(!c)throw new Error("No custom document found");return c}getCustomEditorProvider(a){const c=this._editorProviders.get(a)?.provider;if(!c||!this.supportEditing(c))throw new Error("Custom document is not editable");return c}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=S;function _(D){return typeof D.resolveCustomTextEditor=="function"}function w(D){return typeof D.undo=="function"&&typeof D.redo=="function"}function d(D){const a=D.scheme===$.Schemas.file||D.scheme===$.Schemas.untitled?D.fsPath:D.toString();return(0,k.hash)(a)+""}});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[207],be([1,0,5,6,2,36,8,51,4,7]),function(Y,e,r,k,b,$,y,O,I,R){"use strict";var N,v,n,p,s,i,u,S,_,w,d,D,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends k.Disposable{constructor(o,l,f,m,E,T,A){super();N.set(this,void 0),v.set(this,void 0),n.set(this,void 0),p.set(this,void 0),s.set(this,void 0),i.set(this,void 0),u.set(this,void 0),S.set(this,void 0),_.set(this,!0),w.set(this,!0),d.set(this,!1),D.set(this,this._register(new r.Emitter)),this.onDidDispose=De(this,D,"f").event,a.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=De(this,a,"f").event,je(this,N,o,"f"),je(this,v,l,"f"),je(this,n,f,"f"),je(this,s,T,"f"),je(this,S,E,"f"),je(this,i,m,"f"),je(this,p,A,"f")}dispose(){De(this,d,"f")||(je(this,d,!0,"f"),De(this,D,"f").fire(),De(this,v,"f").$disposeWebview(De(this,N,"f")),De(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),De(this,p,"f")}get viewType(){return this.assertNotDisposed(),De(this,n,"f")}get title(){return this.assertNotDisposed(),De(this,i,"f")}set title(o){this.assertNotDisposed(),De(this,i,"f")!==o&&(je(this,i,o,"f"),De(this,v,"f").$setTitle(De(this,N,"f"),o))}get iconPath(){return this.assertNotDisposed(),De(this,u,"f")}set iconPath(o){this.assertNotDisposed(),De(this,u,"f")!==o&&(je(this,u,o,"f"),De(this,v,"f").$setIconPath(De(this,N,"f"),b.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return De(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof De(this,S,"f")=="number"&&De(this,S,"f")<0))return De(this,S,"f")}get active(){return this.assertNotDisposed(),De(this,w,"f")}get visible(){return this.assertNotDisposed(),De(this,_,"f")}_updateViewState(o){De(this,d,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(je(this,w,o.active,"f"),je(this,_,o.visible,"f"),je(this,S,o.viewColumn,"f"),De(this,a,"f").fire({webviewPanel:this}))}reveal(o,l){this.assertNotDisposed(),De(this,v,"f").$reveal(De(this,N,"f"),{viewColumn:typeof o=="undefined"?void 0:y.ViewColumn.from(o),preserveFocus:!!l})}assertNotDisposed(){if(De(this,d,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,v=new WeakMap,n=new WeakMap,p=new WeakMap,s=new WeakMap,i=new WeakMap,u=new WeakMap,S=new WeakMap,_=new WeakMap,w=new WeakMap,d=new WeakMap,D=new WeakMap,a=new WeakMap;class c{constructor(o,l,f){this.webviews=l,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(I.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,$.generateUuid)()}createWebviewPanel(o,l,f,m,E={}){const T=typeof m=="object"?m.viewColumn:m,A={viewColumn:y.ViewColumn.from(T),preserveFocus:typeof m=="object"&&!!m.preserveFocus},x=(0,O.shouldSerializeBuffersForPostMessage)(o),g=c.newHandle();this._proxy.$createWebviewPanel((0,O.toExtensionData)(o),g,l,{title:f,panelOptions:t(E),webviewOptions:(0,O.serializeWebviewOptions)(o,this.workspace,E),serializeBuffersForPostMessage:x},A);const U=this.webviews.createNewWebview(g,E,o);return this.createNewWebviewPanel(g,l,f,T,E,U)}$onDidChangeWebviewPanelViewStates(o){const l=Object.keys(o);l.sort((f,m)=>{const E=o[f],T=o[m];return E.active?1:T.active?-1:+E.visible-+T.visible});for(const f of l){const m=this.getWebviewPanel(f);if(!m)continue;const E=o[f];m._updateViewState({active:E.active,visible:E.visible,viewColumn:y.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(o){this.getWebviewPanel(o)?.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,l,f){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:f,extension:o}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,O.shouldSerializeBuffersForPostMessage)(o)}),new R.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(o,l,f,m){const E=this._serializers.get(l);if(!E)throw new Error(`No serializer found for '${l}'`);const{serializer:T,extension:A}=E,x=this.webviews.createNewWebview(o,f.webviewOptions,A),g=this.createNewWebviewPanel(o,l,f.title,m,f.panelOptions,x);await T.deserializeWebviewPanel(g,f.state)}createNewWebviewPanel(o,l,f,m,E,T){const A=new P(o,this._proxy,l,f,m,E,T);return this._webviewPanels.set(o,A),A}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=c;function t(h){return{enableFindWidget:h.enableFindWidget,retainContextWhenHidden:h.retainContextWhenHidden}}});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[208],be([1,0,5,6,51,4,7]),function(Y,e,r,k,b,$,y){"use strict";var O,I,R,N,v,n,p,s,i,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends k.Disposable{constructor(d,D,a,P,c,t){super();O.set(this,void 0),I.set(this,void 0),R.set(this,void 0),N.set(this,void 0),v.set(this,!1),n.set(this,void 0),p.set(this,void 0),s.set(this,void 0),i.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=De(this,i,"f").event,u.set(this,this._register(new r.Emitter)),this.onDidDispose=De(this,u,"f").event,je(this,R,a,"f"),je(this,p,P,"f"),je(this,O,d,"f"),je(this,I,D,"f"),je(this,N,c,"f"),je(this,n,t,"f")}dispose(){De(this,v,"f")||(je(this,v,!0,"f"),De(this,u,"f").fire(),De(this,N,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),De(this,p,"f")}set title(d){this.assertNotDisposed(),De(this,p,"f")!==d&&(je(this,p,d,"f"),De(this,I,"f").$setWebviewViewTitle(De(this,O,"f"),d))}get description(){return this.assertNotDisposed(),De(this,s,"f")}set description(d){this.assertNotDisposed(),De(this,s,"f")!==d&&(je(this,s,d,"f"),De(this,I,"f").$setWebviewViewDescription(De(this,O,"f"),d))}get visible(){return De(this,n,"f")}get webview(){return De(this,N,"f")}get viewType(){return De(this,R,"f")}_setVisible(d){d===De(this,n,"f")||De(this,v,"f")||(je(this,n,d,"f"),De(this,i,"f").fire())}show(d){this.assertNotDisposed(),De(this,I,"f").$show(De(this,O,"f"),!!d)}assertNotDisposed(){if(De(this,v,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,I=new WeakMap,R=new WeakMap,N=new WeakMap,v=new WeakMap,n=new WeakMap,p=new WeakMap,s=new WeakMap,i=new WeakMap,u=new WeakMap;class _{constructor(d,D){this._extHostWebview=D,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy($.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,D,a,P){if(this._viewProviders.has(D))throw new Error(`View provider for '${D}' already registered`);return this._viewProviders.set(D,{provider:a,extension:d}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(d),D,{retainContextWhenHidden:P?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(D),this._proxy.$unregisterWebviewViewProvider(D)})}async $resolveWebviewView(d,D,a,P,c){const t=this._viewProviders.get(D);if(!t)throw new Error(`No view provider found for '${D}'`);const{provider:h,extension:o}=t,l=this._extHostWebview.createNewWebview(d,{},o),f=new S(d,this._proxy,D,a,l,!0);this._webviewViews.set(d,f),await h.resolveWebviewView(f,{state:P},c)}async $onDidChangeWebviewViewVisibility(d,D){this.getWebviewView(d)._setVisible(D)}async $disposeWebviewView(d){const D=this.getWebviewView(d);this._webviewViews.delete(d),D.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const D=this._webviewViews.get(d);if(!D)throw new Error("No webview found");return D}}e.ExtHostWebviewViews=_}),define(Ee[95],be([1,0,5,4,2,9,10,3,14]),function(Y,e,r,k,b,$,y,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class Vi{constructor(v){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Vi.InitialState,this._proxy=v.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(v){v!==this._state.focused&&(this._state={...this._state,focused:v},this._onDidChangeWindowState.fire(this._state))}openUri(v,n){let p;if(typeof v=="string"){p=v;try{v=b.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,y.isFalsyOrWhitespace)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===$.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this._proxy.$openUri(v,p,n)}async asExternalUri(v,n){if((0,y.isFalsyOrWhitespace)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(v,n);return b.URI.from(p)}};R.InitialState={focused:!0},R=Fe([Ne(0,I.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,O.createDecorator)("IExtHostWindow")}),define(Ee[209],be([1,0,11,21,20,15,5,6,108,175,38]),function(Y,e,r,k,b,$,y,O,I,R,N){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(E,T){try{return JSON.stringify(E,T)}catch{return"null"}}const p="$$ref$$",s={[p]:-1};class i{constructor(T,A){this.jsonString=T,this.referencedBuffers=A}}function u(E,T=null,A=!1){const x=[];return{jsonString:(A?n:JSON.stringify)(E,(U,z)=>{if(typeof z=="undefined")return s;if(typeof z=="object"){if(z instanceof k.VSBuffer){const q=x.push(z)-1;return{[p]:q}}if(T)return T(U,z)}return z}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=u;function S(E,T,A){return JSON.parse(E,(x,g)=>{if(g){const U=g[p];if(typeof U=="number")return T[U];if(A&&g.$mid===1)return A.transformIncoming(g)}return g})}e.parseJsonAndRestoreBufferRefs=S;function _(E,T){return JSON.stringify(E,T)}function w(E){return E?(T,A)=>A&&A.$mid===1?E.transformOutgoing(A):A:null}var d;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var D;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(D=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},P=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class t extends O.Disposable{constructor(T,A=null,x=null){super();this[v]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=A,this._uriTransformer=x,this._uriReplacer=w(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let g=0,U=N.ProxyIdentifier.count;g<U;g++)this._locals[g]=null,this._proxies[g]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(g=>this._receiveOneMessage(g))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr($.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,I.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:A,sid:x}=T;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,x)),this._proxies[A]}_createProxy(T,A){let x={get:(g,U)=>(typeof U=="string"&&!g[U]&&U.charCodeAt(0)===36&&(g[U]=(...z)=>this._remoteCall(T,U,z)),U===c?A:g[U])};return new Proxy(Object.create(null),x)}set(T,A){return this._locals[T.nid]=A,A}assertRegistered(T){for(let A=0,x=T.length;A<x;A++){const g=T[A];if(!this._locals[g.nid])throw new Error(`Missing proxy instance ${g.sid}`)}}_receiveOneMessage(T){if(this._isDisposed)return;const A=T.byteLength,x=h.read(T,0),g=x.readUInt8(),U=x.readUInt32();switch(g){case 1:case 2:{let{rpcId:z,method:q,args:j}=l.deserializeRequestJSONArgs(x);this._uriTransformer&&(j=(0,I.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(A,U,z,q,j,g===2);break}case 3:case 4:{let{rpcId:z,method:q,args:j}=l.deserializeRequestMixedArgs(x);this._uriTransformer&&(j=(0,I.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(A,U,z,q,j,g===4);break}case 5:{this._logger&&this._logger.logIncoming(A,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(A,U);break}case 7:{this._receiveReply(A,U,void 0);break}case 9:{let z=l.deserializeReplyOKJSON(x);this._uriTransformer&&(z=(0,I.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReply(A,U,z);break}case 10:{const z=l.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(A,U,z);break}case 8:{let z=l.deserializeReplyOKVSBuffer(x);this._receiveReply(A,U,z);break}case 11:{let z=l.deserializeReplyErrError(x);this._uriTransformer&&(z=(0,I.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReplyErr(A,U,z);break}case 12:{this._receiveReplyErr(A,U,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,A,x,g,U,z){this._logger&&this._logger.logIncoming(T,A,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(x)}.${g}(`,U);const q=String(A);let j,J;if(z){const ie=new b.CancellationTokenSource;U.push(ie.token),j=this._invokeHandler(x,g,U),J=()=>ie.cancel()}else j=this._invokeHandler(x,g,U),J=a;this._cancelInvokedHandlers[q]=J;const V=l.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(V.byteLength,A,1,"ack"),this._protocol.send(V),j.then(ie=>{delete this._cancelInvokedHandlers[q];const ae=l.serializeReplyOK(A,ie,this._uriReplacer);this._logger&&this._logger.logOutgoing(ae.byteLength,A,1,"reply:",ie),this._protocol.send(ae)},ie=>{delete this._cancelInvokedHandlers[q];const ae=l.serializeReplyErr(A,ie);this._logger&&this._logger.logOutgoing(ae.byteLength,A,1,"replyErr:",ie),this._protocol.send(ae)})}_receiveCancel(T,A){this._logger&&this._logger.logIncoming(T,A,1,"receiveCancel");const x=String(A);this._cancelInvokedHandlers[x]&&this._cancelInvokedHandlers[x]()}_receiveReply(T,A,x){this._logger&&this._logger.logIncoming(T,A,0,"receiveReply:",x);const g=String(A);if(!this._pendingRPCReplies.hasOwnProperty(g))return;const U=this._pendingRPCReplies[g];delete this._pendingRPCReplies[g],U.resolveOk(x)}_receiveReplyErr(T,A,x){this._logger&&this._logger.logIncoming(T,A,0,"receiveReplyErr:",x);const g=String(A);if(!this._pendingRPCReplies.hasOwnProperty(g))return;const U=this._pendingRPCReplies[g];delete this._pendingRPCReplies[g];let z;x&&(x.$isError?(z=new Error,z.name=x.name,z.message=x.message,z.stack=x.stack):z=x),U.resolveErr(z)}_invokeHandler(T,A,x){try{return Promise.resolve(this._doInvokeHandler(T,A,x))}catch(g){return Promise.reject(g)}}_doInvokeHandler(T,A,x){const g=this._locals[T];if(!g)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(T));let U=g[A];if(typeof U!="function")throw new Error("Unknown method "+A+" on actor "+(0,N.getStringIdentifierForProxy)(T));return U.apply(g,x)}_remoteCall(T,A,x){if(this._isDisposed)return Promise.reject($.canceled());let g=null;if(x.length>0&&b.CancellationToken.isCancellationToken(x[x.length-1])&&(g=x.pop()),g&&g.isCancellationRequested)return Promise.reject($.canceled());const U=l.serializeRequestArguments(x,this._uriReplacer),z=++this._lastMessageId,q=String(z),j=new R.LazyPromise;g&&g.onCancellationRequested(()=>{const V=l.serializeCancel(z);this._logger&&this._logger.logOutgoing(V.byteLength,z,0,"cancel"),this._protocol.send(l.serializeCancel(z))}),this._pendingRPCReplies[q]=j,this._onWillSendRequest(z);const J=l.serializeRequest(z,T,A,U,!!g);return this._logger&&this._logger.logOutgoing(J.byteLength,z,0,`request: ${(0,N.getStringIdentifierForProxy)(T)}.${A}(`,x),this._protocol.send(J),j}}e.RPCProtocol=t,v=P,t.UNRESPONSIVE_TIME=3*1e3;class h{constructor(T,A){this._buff=T,this._offset=A}static alloc(T,A,x){let g=new h(k.VSBuffer.alloc(x+1+4),0);return g.writeUInt8(T),g.writeUInt32(A),g}static read(T,A){return new h(T,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,x}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,x}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,A}static sizeMixedArray(T){let A=0;A+=1;for(let x=0,g=T.length;x<g;x++){const U=T[x];switch(A+=1,U.type){case 1:A+=this.sizeLongString(U.value);break;case 2:A+=this.sizeVSBuffer(U.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(U.value);for(let z=0;z<U.buffers.length;++z)A+=this.sizeVSBuffer(U.buffers[z]);break;case 4:break}}return A}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let A=0,x=T.length;A<x;A++){const g=T[A];switch(g.type){case 1:this.writeUInt8(1),this.writeLongString(g.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(g.value);break;case 3:this.writeUInt8(3),this.writeUInt32(g.buffers.length),this.writeLongString(g.value);for(let U=0;U<g.buffers.length;++U)this.writeBuffer(g.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(T);for(let x=0;x<T;x++)switch(this.readUInt8()){case 1:A[x]=this.readLongString();break;case 2:A[x]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),z=this.readLongString(),q=[];for(let j=0;j<U;++j)q.push(this.readVSBuffer());A[x]=new N.SerializableObjectWithBuffers(S(z,q,null));break}case 4:A[x]=void 0;break}return A}}h.sizeUInt32=4;var o;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(o||(o={}));class l{static _useMixedArgSerialization(T){for(let A=0,x=T.length;A<x;A++)if(T[A]instanceof k.VSBuffer||T[A]instanceof N.SerializableObjectWithBuffers||typeof T[A]=="undefined")return!0;return!1}static serializeRequestArguments(T,A){if(this._useMixedArgSerialization(T)){const x=[];for(let g=0,U=T.length;g<U;g++){const z=T[g];if(z instanceof k.VSBuffer)x[g]={type:2,value:z};else if(typeof z=="undefined")x[g]={type:4};else if(z instanceof N.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:j}=u(z.value,A);x[g]={type:3,value:k.VSBuffer.fromString(q),buffers:j}}else x[g]={type:1,value:k.VSBuffer.fromString(_(z,A))}}return{type:1,args:x}}return{type:0,args:_(T,A)}}static serializeRequest(T,A,x,g,U){switch(g.type){case 0:return this._requestJSONArgs(T,A,x,g.args,U);case 1:return this._requestMixedArgs(T,A,x,g.args,U)}}static _requestJSONArgs(T,A,x,g,U){const z=k.VSBuffer.fromString(x),q=k.VSBuffer.fromString(g);let j=0;j+=h.sizeUInt8(),j+=h.sizeShortString(z),j+=h.sizeLongString(q);let J=h.alloc(U?2:1,T,j);return J.writeUInt8(A),J.writeShortString(z),J.writeLongString(q),J.buffer}static deserializeRequestJSONArgs(T){const A=T.readUInt8(),x=T.readShortString(),g=T.readLongString();return{rpcId:A,method:x,args:JSON.parse(g)}}static _requestMixedArgs(T,A,x,g,U){const z=k.VSBuffer.fromString(x);let q=0;q+=h.sizeUInt8(),q+=h.sizeShortString(z),q+=h.sizeMixedArray(g);let j=h.alloc(U?4:3,T,q);return j.writeUInt8(A),j.writeShortString(z),j.writeMixedArray(g),j.buffer}static deserializeRequestMixedArgs(T){const A=T.readUInt8(),x=T.readShortString(),g=T.readMixedArray(),U=new Array(g.length);for(let z=0,q=g.length;z<q;z++){const j=g[z];typeof j=="string"?U[z]=JSON.parse(j):U[z]=j}return{rpcId:A,method:x,args:U}}static serializeAcknowledged(T){return h.alloc(5,T,0).buffer}static serializeCancel(T){return h.alloc(6,T,0).buffer}static serializeReplyOK(T,A,x){if(typeof A=="undefined")return this._serializeReplyOKEmpty(T);if(A instanceof k.VSBuffer)return this._serializeReplyOKVSBuffer(T,A);if(A instanceof N.SerializableObjectWithBuffers){const{jsonString:g,referencedBuffers:U}=u(A.value,x,!0);return this._serializeReplyOKJSONWithBuffers(T,g,U)}else return this._serializeReplyOKJSON(T,n(A,x))}static _serializeReplyOKEmpty(T){return h.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,A){let x=0;x+=h.sizeVSBuffer(A);let g=h.alloc(8,T,x);return g.writeVSBuffer(A),g.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,A){const x=k.VSBuffer.fromString(A);let g=0;g+=h.sizeLongString(x);let U=h.alloc(9,T,g);return U.writeLongString(x),U.buffer}static _serializeReplyOKJSONWithBuffers(T,A,x){const g=k.VSBuffer.fromString(A);let U=0;U+=h.sizeUInt32,U+=h.sizeLongString(g);for(const q of x)U+=h.sizeVSBuffer(q);let z=h.alloc(10,T,U);z.writeUInt32(x.length),z.writeLongString(g);for(const q of x)z.writeBuffer(q);return z.buffer}static deserializeReplyOKJSON(T){const A=T.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(T,A){const x=T.readUInt32(),g=T.readLongString(),U=[];for(let z=0;z<x;++z)U.push(T.readVSBuffer());return new N.SerializableObjectWithBuffers(S(g,U,A))}static serializeReplyErr(T,A){return A?this._serializeReplyErrEror(T,A):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,A){const x=k.VSBuffer.fromString(n($.transformErrorForSerialization(A),null));let g=0;g+=h.sizeLongString(x);let U=h.alloc(11,T,g);return U.writeLongString(x),U.buffer}static deserializeReplyErrError(T){const A=T.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(T){return h.alloc(12,T,0).buffer}}var f;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var m;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(m||(m={}))}),define(Ee[210],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function($){const y=O=>{self.removeEventListener("message",y);const I=O.data;Object.defineProperties(self,{postMessage:{value(R,N){I.postMessage(R,N)}},onmessage:{get(){return I.onmessage},set(R){I.onmessage=R}}}),I.addEventListener("message",R=>{self.dispatchEvent(new MessageEvent("message",{data:R.data}))}),I.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts($)};self.addEventListener("message",y)}.toString();class k extends EventTarget{constructor($,y,O){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const I=`((${r})('${y}'))`,R=new Blob([I],{type:"application/javascript"}),N=URL.createObjectURL(R),v=new MessageChannel,n=N,p={type:"_newWorker",id:n,port:v.port2,url:N,options:O};$(p,[v.port2]),this.postMessage=v.port1.postMessage.bind(v.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};v.port1.postMessage(s),URL.revokeObjectURL(N),v.port1.close(),v.port2.close()},Object.defineProperties(this,{onmessage:{get(){return v.port1.onmessage},set(s){v.port1.onmessage=s}},onmessageerror:{get(){return v.port1.onmessageerror},set(s){v.port1.onmessageerror=s}}}),v.port1.addEventListener("messageerror",s=>{const i=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(i)}),v.port1.addEventListener("message",s=>{const i=new MessageEvent("message",{data:s.data});this.dispatchEvent(i)}),v.port1.start()}}e.NestedWorker=k}),define(Ee[211],be([1,0,3]),function(Y,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Ee[212],be([1,0,35,9,17,23,24,2,3,147,47,171,211]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,I.createDecorator)("pathService");let p=class ji{constructor(i,u,S,_){this.localUserHome=i,this.remoteAgentService=u,this.environmentService=S,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||$.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||i})()}hasValidBasename(i,u,S){return typeof u=="string"||typeof u=="undefined"?this.resolveOS.then(_=>this.doHasValidBasename(i,_,u)):this.doHasValidBasename(i,u,S)}doHasValidBasename(i,u,S){return i.scheme===k.Schemas.file||i.scheme===k.Schemas.vscodeRemote?(0,r.isValidBasename)(S??(0,y.basename)(i),u===1):!0}get defaultUriScheme(){return ji.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(i,u){if(i.remoteAuthority)return k.Schemas.vscodeRemote;const S=(0,R.getVirtualWorkspaceScheme)(u.getWorkspace());if(S)return S;const _=u.getWorkspace().folders[0];if(_)return _.uri.scheme;const w=u.getWorkspace().configuration;return w?w.scheme:k.Schemas.file}async userHome(i){return i?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?b.win32:b.posix)}async fileURI(i){let u="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const _=i.indexOf("/",2);_===-1?(u=i.substring(2),i="/"):(u=i.substring(2,_),i=i.substring(_)||"/")}return O.URI.from({scheme:k.Schemas.file,authority:u,path:i,query:"",fragment:""})}};p=Fe([Ne(1,n.IRemoteAgentService),Ne(2,v.IWorkbenchEnvironmentService),Ne(3,N.IWorkspaceContextService)],p),e.AbstractPathService=p}),define(Ee[96],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(y,O){this.line=y,this.character=O}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,O){return new r(0,0)}with(y){return new r(0,0)}}e.Position=r;class k{constructor(y,O,I,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(y,O),this.end=new r(I,R)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new k(0,0,0,0)}with(y){return new k(0,0,0,0)}}e.Range=k;var b;(function($){$[$.Information=1]="Information",$[$.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[41],be([1,0,16,29,26,35,10,3,17,15,96,11]),function(Y,e,r,k,b,$,y,O,I,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",p=" characters skipped \u27EB",s=(n.length+p.length+5)*2;e.ISearchService=(0,O.createDecorator)("searchService");var i;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(i=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function S(V){return!!V.preview}e.resultIsMatch=S;function _(V){return!!V.resource}e.isFileMatch=_;function w(V){return!!V.message}e.isProgressMessage=w;var d;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class D{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=D;class a{constructor(ie,ae,te){this.ranges=ae;const ue=Array.isArray(ae)?ae:[ae];if(te&&te.matchLines===1&&P(ue)){ie=(0,y.getNLines)(ie,te.matchLines);let fe="",Se=0,ge=0;const ne=Math.floor(te.charsPerLine/5),me=[];for(const Ie of ue){const Ae=Math.max(Ie.startColumn-ne,0),Ue=Ie.startColumn+te.charsPerLine;if(Ae>ge+ne+s){const Ke=n+(Ae-ge)+p;fe+=Ke+ie.slice(Ae,Ue),Se+=Ae-(ge+Ke.length)}else fe+=ie.slice(ge,Ue);me.push(new t(0,Ie.startColumn-Se,Ie.endColumn-Se)),ge=Ue}this.preview={text:fe,matches:Array.isArray(this.ranges)?me:me[0]}}else{const fe=Array.isArray(ae)?ae[0].startLineNumber:ae.startLineNumber;this.preview={text:ie,matches:(0,r.mapArrayOrNot)(ae,Se=>new c(Se.startLineNumber-fe,Se.startColumn,Se.endLineNumber-fe,Se.endColumn))}}}}e.TextSearchMatch=a;function P(V){const ie=V[0].startLineNumber;for(const ae of V)if(ae.startLineNumber!==ie||ae.endLineNumber!==ie)return!1;return!0}class c{constructor(ie,ae,te,ue){this.startLineNumber=ie,this.startColumn=ae,this.endLineNumber=te,this.endColumn=ue}}e.SearchRange=c;class t extends c{constructor(ie,ae,te){super(ie,ae,ie,te)}}e.OneLineRange=t;var h;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function o(V,ie=!0){const ae=V&&V.files&&V.files.exclude,te=ie&&V&&V.search&&V.search.exclude;if(!ae&&!te)return;if(!ae||!te)return ae||te;let ue=Object.create(null);return ue=b.mixin(ue,b.deepClone(ae)),ue=b.mixin(ue,b.deepClone(te),!0),ue}e.getExcludes=o;function l(V,ie){return V.excludePattern&&k.match(V.excludePattern,ie)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&k.match(V.includePattern,ie)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(ae=>{const te=ae.folder.fsPath;if($.isEqualOrParent(ie,te)){const ue=I.relative(te,ie);return!ae.includePattern||!!k.match(ae.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var f;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class m extends Error{constructor(ie,ae){super(ie);this.code=ae}}e.SearchError=m;function E(V){const ie=V.message;if((0,R.isCancellationError)(V))return new m(ie,f.canceled);try{const ae=JSON.parse(ie);return new m(ae.message,ae.code)}catch{return new m(ie,f.other)}}e.deserializeSearchError=E;function T(V){const ie={message:V.message,code:V.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=T;function A(V){return V.type==="error"?!0:V.type==="success"}e.isSerializedSearchComplete=A;function x(V){return V.type==="success"}e.isSerializedSearchSuccess=x;function g(V){return!!V.path}e.isSerializedFileMatch=g;function U(V,ie){const ae=V.searchPath?V.searchPath:V.relativePath;return(0,y.fuzzyContains)(ae,ie)}e.isFilePatternMatch=U;class z{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=z;function q(V,ie){const ae={...V||{},...ie||{}};return Object.keys(ae).filter(te=>{const ue=ae[te];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=q;class j{constructor(ie,ae){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...ae.excludePattern||{}},this._parsedExcludeExpression=k.parse(this._excludeExpression);let te=ie.includePattern;ae.includePattern&&(te?te={...te,...ae.includePattern}:te=ae.includePattern),te&&(this._parsedIncludeExpression=k.parse(te))}matchesExcludesSync(ie,ae,te){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ae,te))}includedInQuerySync(ie,ae,te){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ae,te)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,ae,te))}includedInQuery(ie,ae,te){const ue=this._parsedExcludeExpression(ie,ae,te),fe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,ae,te):!0;return(0,v.isThenable)(ue)?ue.then(Se=>Se?!1:fe()):fe()}hasSiblingExcludeClauses(){return J(this._excludeExpression)}}e.QueryGlobTester=j;function J(V){for(const ie in V)if(typeof V[ie]!="boolean")return!0;return!1}}),define(Ee[31],be([1,0,16,11,20,5,22,9,102,24,10,13,2,127,3,12,139,47,30,28,14,8,7,41,4]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_,w,d,D,a,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function t(A,x,g){return new R.ExtUri(U=>f(U,g)).isEqual(A,x)}function h(A,x,g){return t(A.uri,x.uri,g)?0:(0,N.compare)(A.uri.toString(),x.uri.toString())}function o(A,x,g){return A.index!==x.index?A.index<x.index?-1:1:t(A.uri,x.uri,g)?(0,N.compare)(A.name,x.name):(0,N.compare)(A.uri.toString(),x.uri.toString())}function l(A,x,g,U){const z=A.slice(0).sort((j,J)=>g(j,J,U)),q=x.slice(0).sort((j,J)=>g(j,J,U));return(0,r.delta)(z,q,(j,J)=>g(j,J,U))}function f(A,x){const g=x.getCapabilities(A.scheme);return!(g&&g&1024)}class m extends S.Workspace{constructor(x,g,U,z,q,j,J){super(x,U.map(V=>new S.WorkspaceFolder(V)),z,q,J);this._name=g,this._isUntitled=j,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(J),U.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(x,g,U,z){if(!x)return{workspace:null,added:[],removed:[]};const{id:q,name:j,folders:J,configuration:V,transient:ie,isUntitled:ae}=x,te=[],ue=g;g?J.forEach((ne,me)=>{const Ie=n.URI.revive(ne.uri),Ae=m._findFolder(U||g,Ie,z);Ae?(Ae.name=ne.name,Ae.index=ne.index,te.push(Ae)):te.push({uri:Ie,name:ne.name,index:me})}):te.push(...J.map(({uri:ne,name:me,index:Ie})=>({uri:n.URI.revive(ne),name:me,index:Ie}))),te.sort((ne,me)=>ne.index<me.index?-1:1);const fe=new m(q,j,te,!!ie,V?n.URI.revive(V):null,!!ae,ne=>f(ne,z)),{added:Se,removed:ge}=l(ue?ue.workspaceFolders:[],fe.workspaceFolders,h,z);return{workspace:fe,added:Se,removed:ge}}static _findFolder(x,g,U){for(let z=0;z<x.folders.length;z++){const q=x.workspaceFolders[z];if(t(q.uri,g,U))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,g){return g&&this._structure.get(x)&&(x=(0,R.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let E=class{constructor(x,g,U,z){this._onDidChangeWorkspace=new $.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new $.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=U,this._requestIdProvider=new I.Counter,this._barrier=new k.Barrier,this._proxy=x.getProxy(c.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(c.MainContext.MainThreadMessageService);const q=g.workspace;this._confirmedWorkspace=q?new m(q.id,q.name,[],!!q.transient,q.configuration?n.URI.revive(q.configuration):null,!!q.isUntitled,j=>f(j,U)):void 0}$initializeWorkspace(x,g){this._trusted=g,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:O.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,g,U,...z){const q=[];if(Array.isArray(z)&&z.forEach(ae=>{n.URI.isUri(ae.uri)&&!q.some(te=>t(te.uri,ae.uri,this._extHostFileSystemInfo))&&q.push({uri:ae.uri,name:ae.name||(0,R.basenameOrAuthority)(ae.uri)})}),this._unconfirmedWorkspace||[g,U].some(ae=>typeof ae!="number"||ae<0)||U===0&&q.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(g+U>j.length)return!1;const J=j.slice(0);J.splice(g,U,...q.map(ae=>({uri:ae.uri,name:ae.name||(0,R.basenameOrAuthority)(ae.uri),index:void 0})));for(let ae=0;ae<J.length;ae++){const te=J[ae];if(J.some((ue,fe)=>fe!==ae&&t(te.uri,ue.uri,this._extHostFileSystemInfo)))return!1}J.forEach((ae,te)=>ae.index=te);const{added:V,removed:ie}=l(j,J,o,this._extHostFileSystemInfo);if(V.length===0&&ie.length===0)return!1;if(this._proxy){const ae=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(ae,g,U,q).then(void 0,te=>{this._unconfirmedWorkspace=void 0;const ue={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(u.Severity.Error,(0,p.localize)(0,null,ae,te.toString()),ue,[])})}return this.trySetWorkspaceFolders(J),!0}getWorkspaceFolder(x,g){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,g)}async getWorkspaceFolder2(x,g){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,g)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,g){let U,z="";if(typeof x=="string"?(U=n.URI.file(x),z=x):typeof x!="undefined"&&(U=x,z=x.fsPath),!U)return z;const q=this.getWorkspaceFolder(U,!0);if(!q)return z;typeof g=="undefined"&&this._actualWorkspace&&(g=this._actualWorkspace.folders.length>1);let j=(0,R.relativePath)(q.uri,U);return g&&q.name&&(j=`${q.name}/${j}`),j}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:g,added:U,removed:z}=m.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=g||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:z}))}findFiles(x,g,U,z,q=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let j;if(g===null?j=!1:g&&(typeof g=="string"?j=g:j=g.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:J,folder:V}=T(D.GlobPattern.from(x));return this._proxy.$startFileSearch((0,v.withUndefinedAsNull)(J),(0,v.withUndefinedAsNull)(V),(0,v.withUndefinedAsNull)(j),(0,v.withUndefinedAsNull)(U),q).then(ie=>Array.isArray(ie)?ie.map(ae=>n.URI.revive(ae)):[])}async findTextInFiles(x,g,U,z,q=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),J=typeof g.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:g.previewOptions,{includePattern:V,folder:ie}=T(D.GlobPattern.from(g.include)),ae=typeof g.exclude=="string"?g.exclude:g.exclude?g.exclude.pattern:void 0,te={ignoreSymlinks:typeof g.followSymlinks=="boolean"?!g.followSymlinks:void 0,disregardIgnoreFiles:typeof g.useIgnoreFiles=="boolean"?!g.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof g.useGlobalIgnoreFiles=="boolean"?!g.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof g.useParentIgnoreFiles=="boolean"?!g.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof g.useDefaultExcludes=="boolean"?!g.useDefaultExcludes:!0,fileEncoding:g.encoding,maxResults:g.maxResults,previewOptions:J,afterContext:g.afterContext,beforeContext:g.beforeContext,includePattern:V,excludePattern:ae},ue=!1;if(this._activeSearchCallbacks[j]=fe=>{if(ue)return;const Se=n.URI.revive(fe.resource);fe.results.forEach(ge=>{(0,P.resultIsMatch)(ge)?U({uri:Se,preview:{text:ge.preview.text,matches:(0,r.mapArrayOrNot)(ge.preview.matches,ne=>new a.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,r.mapArrayOrNot)(ge.ranges,ne=>new a.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):U({uri:Se,text:ge.text,lineNumber:ge.lineNumber})})},q.isCancellationRequested)return{};try{const fe=await this._proxy.$startTextSearch(x,(0,v.withUndefinedAsNull)(ie),te,j,q);return delete this._activeSearchCallbacks[j],fe||{}}catch(fe){throw delete this._activeSearchCallbacks[j],fe}}$handleTextSearchResult(x,g){this._activeSearchCallbacks[g]&&this._activeSearchCallbacks[g](x)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=Fe([Ne(0,d.IExtHostRpcService),Ne(1,w.IExtHostInitDataService),Ne(2,_.IExtHostFileSystemInfo),Ne(3,i.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function T(A){let x,g;return A&&(typeof A=="string"?x=A:(x=A.pattern,g=n.URI.revive(A.baseUri))),{includePattern:x,folder:g}}}),define(Ee[32],be([1,0,26,5,31,4,7,142,78,13,11,3,14,12,2]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function i(P,c){if(c){const t=c.split(".");let h=P;for(let o=0;h&&o<t.length;o++)h=h[t[o]];return h}}function u(P){return P instanceof s.URI}function S(P){return P&&P.uri instanceof s.URI&&P.languageId&&typeof P.languageId=="string"}function _(P){return P&&!P.uri&&P.languageId&&typeof P.languageId=="string"}function w(P){return P&&P.uri instanceof s.URI&&(!P.name||typeof P.name=="string")&&(!P.index||typeof P.index=="number")}function d(P){if(u(P))return{resource:P};if(S(P))return{resource:P.uri,overrideIdentifier:P.languageId};if(_(P))return{overrideIdentifier:P.languageId};if(w(P))return{resource:P.uri};if(P===null)return{resource:null}}let D=class{constructor(c,t,h){this._proxy=c.getProxy($.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=h,this._barrier=new N.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(c=>this._actual)}$initializeConfiguration(c){this._actual=new a(this._proxy,this._extHostWorkspace,c,this._logService),this._barrier.open()}$acceptConfigurationChanged(c,t){this.getConfigProvider().then(h=>h.$acceptConfigurationChanged(c,t))}};D=Fe([Ne(0,n.IExtHostRpcService),Ne(1,b.IExtHostWorkspace),Ne(2,p.ILogService)],D),e.ExtHostConfiguration=D;class a{constructor(c,t,h,o){this._onDidChangeConfiguration=new k.Emitter,this._proxy=c,this._logService=o,this._extHostWorkspace=t,this._configuration=O.Configuration.parse(h),this._configurationScopes=this._toMap(h.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(c,t){const h={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=O.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,h))}getConfiguration(c,t,h){const o=d(t)||{},l=this._toReadonlyValue(c?i(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),c):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));c&&this._validateConfigurationAccess(c,o,h?.identifier);function f(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const m={has(E){return typeof i(l,E)!="undefined"},get:(E,T)=>{this._validateConfigurationAccess(c?`${c}.${E}`:E,o,h?.identifier);let A=i(l,E);if(typeof A=="undefined")A=T;else{let x;const g=(U,z)=>{let q;const j=()=>{x=x||(0,r.deepClone)(l),q=q||i(x,z)};return(0,R.isObject)(U)?new Proxy(U,{get:(J,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return j(),()=>q;if(x)return q=q||i(x,z),q[V];const ie=J[V];return typeof V=="string"?g(ie,`${z}.${V}`):ie},set:(J,V,ie)=>(j(),q&&(q[V]=ie),!0),deleteProperty:(J,V)=>(j(),q&&delete q[V],!0),defineProperty:(J,V,ie)=>(j(),q&&Object.defineProperty(q,V,ie),!0)}):U};A=g(A,E)}return A},update:(E,T,A,x)=>{E=c?`${c}.${E}`:E;const g=f(A);return T!==void 0?this._proxy.$updateConfigurationOption(g,E,T,o,x):this._proxy.$removeConfigurationOption(g,E,o,x)},inspect:E=>{E=c?`${c}.${E}`:E;const T=(0,r.deepClone)(this._configuration.inspect(E,o,this._extHostWorkspace.workspace));if(T)return{key:E,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof l=="object"&&(0,r.mixin)(m,l,!1),Object.freeze(m)}_toReadonlyValue(c){const t=h=>(0,R.isObject)(h)?new Proxy(h,{get:(o,l)=>t(o[l]),set:(o,l,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(o,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(o,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):h;return t(c)}_validateConfigurationAccess(c,t,h){const o=I.OVERRIDE_PROPERTY_REGEX.test(c)?4:this._configurationScopes.get(c),l=h?`[${h.value}] `:"";if(o===4){typeof t?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){t?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(c,t){const h=new O.ConfigurationChangeEvent(c,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,l)=>h.affectsConfiguration(o,d(l))})}_toMap(c){return c.reduce((t,h)=>(t.set(h[0],h[1]),t),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,v.createDecorator)("IExtHostConfiguration")});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[97],be([1,0,2,11,5,4,7,31,49,32,20,40,14,28,3,9,23,12,63,163,15]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_,w,d){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(z){function q(J){if(J!=null)return J}z.from=q;function j(J){if(J!=null)return J}z.to=j})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var P;(function(z){function q(J){if(J!=null)return J}z.from=q;function j(J){if(J!=null)return J}z.to=j})(P=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var c;(function(z){function q(J){if(J!=null)return J}z.from=q;function j(J){if(J!=null)return J}z.to=j})(c=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(z){function q(V){if(V){const ie=V;return ie&&!!ie.process}else return!1}z.is=q;function j(V){if(V==null)return;const ie={process:V.process,args:V.args};return V.options&&(ie.options=c.from(V.options)),ie}z.from=j;function J(V){if(V!=null)return new y.ProcessExecution(V.process,V.args,V.options)}z.to=J})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var h;(function(z){function q(J){if(J!=null)return J}z.from=q;function j(J){if(J!=null)return J}z.to=j})(h=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function(z){function q(V){if(V){const ie=V;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}z.is=q;function j(V){if(V==null)return;const ie={};return V.commandLine!==void 0?ie.commandLine=V.commandLine:(ie.command=V.command,ie.args=V.args),V.options&&(ie.options=h.from(V.options)),ie}z.from=j;function J(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new y.ShellExecution(V.commandLine,V.options):new y.ShellExecution(V.command,V.args?V.args:[],V.options)}z.to=J})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function(z){function q(V){if(V){let ie=V;return ie&&ie.customExecution==="customExecution"}else return!1}z.is=q;function j(V){return{customExecution:"customExecution"}}z.from=j;function J(V,ie){return ie.get(V)}z.to=J})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function(z){function q(j,J){let V;return j.scope!==void 0&&typeof j.scope!="number"?V=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===y.TaskScope.Workspace&&J&&J.workspaceFile?V=J.workspaceFile:V=w.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:V}}z.from=q})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(z){function q(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}z.from=q})(m=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(z){function q(V,ie){if(V==null)return[];const ae=[];for(let te of V){const ue=j(te,ie);ue&&ae.push(ue)}return ae}z.fromMany=q;function j(V,ie){if(V==null)return;let ae;V.execution instanceof y.ProcessExecution?ae=t.from(V.execution):V.execution instanceof y.ShellExecution?ae=o.from(V.execution):V.execution&&V.execution instanceof y.CustomExecution&&(ae=l.from(V.execution));const te=a.from(V.definition);let ue;return V.scope?typeof V.scope=="number"?ue=V.scope:ue=V.scope.uri:ue=y.TaskScope.Workspace,!te||!ue?void 0:{_id:V._id,definition:te,name:V.name,source:{extensionId:ie.identifier.value,label:V.source,scope:ue},execution:ae,isBackground:V.isBackground,group:m.from(V.group),presentationOptions:P.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}z.from=j;async function J(V,ie,ae){if(V==null)return;let te;t.is(V.execution)?te=t.to(V.execution):o.is(V.execution)?te=o.to(V.execution):l.is(V.execution)&&(te=l.to(V._id,ae));const ue=a.to(V.definition);let fe;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?fe=V.source.scope:fe=await ie.resolveWorkspaceFolder(r.URI.revive(V.source.scope)):fe=y.TaskScope.Workspace),!ue||!fe)return;const Se=new y.Task(ue,fe,V.name,V.source.label,te,V.problemMatchers);return V.isBackground!==void 0&&(Se.isBackground=V.isBackground),V.group!==void 0&&(Se.group=y.TaskGroup.from(V.group._id),Se.group&&V.group.isDefault&&(Se.group=new y.TaskGroup(Se.group.id,Se.group.label),V.group.isDefault&&(Se.group.isDefault=V.group.isDefault))),V.presentationOptions&&(Se.presentationOptions=P.to(V.presentationOptions)),V._id&&(Se._id=V._id),V.detail&&(Se.detail=V.detail),Se}z.to=J})(E=e.TaskDTO||(e.TaskDTO={}));var T;(function(z){function q(J){return J}z.from=q;function j(J){if(!!J)return Object.assign(Object.create(null),J)}z.to=j})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(q,j,J){this._id=j,this._task=J,D.set(this,void 0),je(this,D,q,"f")}get task(){return this._task}terminate(){De(this,D,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}D=new WeakMap;var x;(function(z){function q(j){return{id:j._id,task:void 0}}z.from=q})(x=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let g=class{constructor(q,j,J,V,ie,ae,te,ue){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=q.getProxy($.MainContext.MainThreadTask),this._workspaceProvider=J,this._editorService=V,this._configurationService=ie,this._terminalService=ae,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=te,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,j,J){if(!J)return new y.Disposable(()=>{});const V=this.nextHandle();return this._handlers.set(V,{type:j,provider:J,extension:q}),this._proxy.$registerTaskProvider(V,j),new y.Disposable(()=>{this._handlers.delete(V),this._proxy.$unregisterTaskProvider(V)})}registerTaskSystem(q,j){this._proxy.$registerTaskSystem(q,j)}fetchTasks(q){return this._proxy.$fetchTasks(T.from(q)).then(async j=>{const J=[];for(let V of j){const ie=await E.to(V,this._workspaceProvider,this._providedCustomExecutions2);ie&&J.push(ie)}return J})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(j=>q.push(j)),q}terminateTask(q){if(!(q instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,j,J){const V=this._providedCustomExecutions2.get(q.id);V&&(this._activeCustomExecutions2.set(q.id,V),this._terminalService.attachPtyToTerminal(j,await V.callback(J))),this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const j=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const j=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:j,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const j=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:q.exitCode})}$provideTasks(q,j){const J=this._handlers.get(q);if(!J)return Promise.reject(new Error("no handler found"));const V=[],ie=(0,k.asPromise)(()=>J.provider.provideTasks(N.CancellationToken.None)).then(ae=>this.provideTasksInternal(j,V,J,ae));return new Promise(ae=>{ie.then(te=>{Promise.all(V).then(()=>{ae(te)})})})}async $resolveTask(q,j){const J=this._handlers.get(q);if(!J)return Promise.reject(new Error("no handler found"));if(j.definition.type!==J.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${J.type}].`);const V=await E.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const ie=await J.provider.resolveTask(V,N.CancellationToken.None);if(!ie)return;this.checkDeprecation(ie,J);const ae=E.from(ie,J.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(ae.execution)&&await this.addCustomExecution(ae,ie,!0),await this.resolveTaskInternal(ae)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,j,J){const V=await this._proxy.$createTaskId(q);!J&&!this._providedCustomExecutions2.has(V)&&(this._notProvidedCustomExecutions.add(V),this._activeCustomExecutions2.set(V,j.execution)),this._providedCustomExecutions2.set(V,j.execution)}async getTaskExecution(q,j){if(typeof q=="string"){const ie=this._taskExecutionPromises.get(q);if(!ie)throw new Error("Unexpected: The specified task is missing an execution");return ie}let J=this._taskExecutionPromises.get(q.id);if(J)return J;const V=new Promise((ie,ae)=>{function te(ue,fe,Se){Se?ie(new A(ue,fe.id,Se)):ae("Unexpected: Task does not exist.")}j?te(this,q,j):E.to(q.task,this._workspaceProvider,this._providedCustomExecutions2).then(ue=>te(this,q,ue))});return this._taskExecutionPromises.set(q.id,V),V.then(ie=>(this._taskExecutions.set(q.id,ie),ie),ie=>Promise.reject(ie))}checkDeprecation(q,j){q._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let J=this._notProvidedCustomExecutions.values(),V=J.next();for(;!V.done;)!this._activeCustomExecutions2.has(V.value)&&this._lastStartedTask!==V.value&&(this._providedCustomExecutions2.delete(V.value),this._notProvidedCustomExecutions.delete(V.value)),V=J.next()}};g=Fe([Ne(0,n.IExtHostRpcService),Ne(1,p.IExtHostInitDataService),Ne(2,O.IExtHostWorkspace),Ne(3,I.IExtHostDocumentsAndEditors),Ne(4,R.IExtHostConfiguration),Ne(5,v.IExtHostTerminalService),Ne(6,S.ILogService),Ne(7,_.IExtHostApiDeprecationService)],g),e.ExtHostTaskBase=g;let U=class extends g{constructor(q,j,J,V,ie,ae,te,ue){super(q,j,J,V,ie,ae,te,ue);this.registerTaskSystem(i.Schemas.vscodeRemote,{scheme:i.Schemas.vscodeRemote,authority:"",platform:u.PlatformToString(0)})}async executeTask(q,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const J=E.from(j,q);if(J===void 0)throw new Error("Task is not valid");if(l.is(J.execution))await this.addCustomExecution(J,j,!1);else throw new d.NotSupportedError;const V=await this.getTaskExecution(await this._proxy.$getTaskExecution(J),j);return this._proxy.$executeTask(J).catch(ie=>{throw new Error(ie)}),V}provideTasksInternal(q,j,J,V){const ie=[];if(V)for(let ae of V){this.checkDeprecation(ae,J),(!ae.definition||!q[ae.definition.type])&&this._logService.warn(`The task [${ae.source}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`);const te=E.from(ae,J.extension);te&&l.is(te.execution)?(ie.push(te),j.push(this.addCustomExecution(te,ae,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:J.extension}}async resolveTaskInternal(q){if(l.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,j,J){}};U=Fe([Ne(0,n.IExtHostRpcService),Ne(1,p.IExtHostInitDataService),Ne(2,O.IExtHostWorkspace),Ne(3,I.IExtHostDocumentsAndEditors),Ne(4,R.IExtHostConfiguration),Ne(5,v.IExtHostTerminalService),Ne(6,S.ILogService),Ne(7,_.IExtHostApiDeprecationService)],U),e.WorkerExtHostTask=U,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(Ee[213],be([1,0,17,20,43,29,24,190,41]),function(Y,e,r,k,b,$,y,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(n,p,s){this.config=n,this.provider=p,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&$.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&$.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const p=this.config.folderQueries||[];return new Promise((s,i)=>{const u=S=>{this.resultCount++,n(S)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(S=>{const _=S.toString(),w=r.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,w)||this.matchFile(u,{base:S,basename:w})}),Promise.all(p.map(S=>this.searchInFolder(S,u))).then(S=>{s({limitHit:this.isLimitHit,stats:S[0]||void 0})},S=>{i(new Error((0,b.toErrorMessage)(S)))})})}async searchInFolder(n,p){const s=new k.CancellationTokenSource,i=this.getSearchOptionsForFolder(n),u=this.initDirectoryTree(),S=new I.QueryGlobTester(this.config,n),_=!S.hasSiblingExcludeClauses();let w;try{this.activeCancellationTokens.add(s),w=O.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},i,s.token),D=w.elapsed(),a=O.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(P=>{const c=r.posix.relative(n.folder.path,P.path);if(_){const t=r.basename(P.path);this.matchFile(p,{base:n.folder,relativePath:c,basename:t});return}this.addDirectoryEntries(u,n.folder,c,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(u,S,p),{providerTime:D,postProcessTime:a.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const p=(0,I.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,I.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:p,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},p,s,i){if(s===this.filePattern){const S=r.basename(this.filePattern);this.matchFile(i,{base:p,relativePath:this.filePattern,basename:S})}function u(S){const _=r.basename(S),w=r.dirname(S);let d=n[w];d||(d=n[w]=[],u(w)),d.push({base:p,relativePath:S,basename:_})}u(s)}matchDirectoryTree({rootEntries:n,pathToEntries:p},s,i){const u=this,S=this.filePattern;function _(w){const d=$.hasSiblingFn(()=>w.map(D=>D.basename));for(let D=0,a=w.length;D<a;D++){const P=w[D],{relativePath:c,basename:t}=P;if(s.matchesExcludesSync(c,t,S!==t?d:void 0))continue;const h=p[c];if(h)_(h);else{if(c===S)continue;u.matchFile(i,P)}if(u.isLimitHit)break}}_(n)}matchFile(n,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(p))}}class N{constructor(){this.sessions=new Map}fileSearch(n,p,s,i){const u=this.getSessionTokenSource(n.cacheKey),S=new R(n,p,u&&u.token);let _=0;const w=d=>{_+=d.length,s(d.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(S,N.BATCH_SIZE,w,i).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:d.stats}}))}clearCache(n){const p=this.getSessionTokenSource(n);p&&p.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new k.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:y.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,p,s,i){i.onCancellationRequested(()=>{n.cancel()});const u=_=>{_&&(S.push(_),p>0&&S.length>=p&&(s(S),S=[]))};let S=[];return n.search(u).then(_=>(S.length&&s(S),_),_=>(S.length&&s(S),Promise.reject(_)))}}e.FileSearchManager=N,N.BATCH_SIZE=512}),define(Ee[214],be([1,0,16,68,29,71,22,9,17,24,10,13,2,233,133,75,47,86,212,41]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(f,m,E,T){this.configurationService=f,this.workspaceContextService=m,this.editorGroupsService=E,this.pathService=T}text(f,m,E={}){f=this.getContentPattern(f,E);const T=this.configurationService.getValue(),A=m&&m.some(g=>!this.configurationService.getValue({resource:g}).search.useRipgrep);return{...this.commonQuery(m?.map(u.toWorkspaceFolder),E),type:2,contentPattern:f,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:T.search.usePCRE2||A||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(f,m){const E=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const T={...f,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(f,m)&&(T.isCaseSensitive=!0),this.isMultiline(f)&&(T.isMultiline=!0),T}file(f,m={}){return{...this.commonQuery(f,m),type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey}}handleIncludeExclude(f,m){return f?(f=Array.isArray(f)?f.map(t):t(f),m?this.parseSearchPaths(f):{pattern:a(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],m={}){const E=this.handleIncludeExclude(m.includePattern,m.expandPatterns),T=this.handleIncludeExclude(m.excludePattern,m.expandPatterns),A=f.length>1,x=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,m,T)):f.map(z=>this.getFolderQueryForRoot(z,m,T,A))).filter(z=>!!z),g={_reason:m._reason,folderQueries:x,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:T.pattern,includePattern:E.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const q=r.coalesce(r.flatten(this.editorGroupsService.groups.map(J=>J.editors.map(V=>V.resource)))).filter(J=>(0,w.pathIncludedInQuery)(g,J.fsPath)),j=this.commonQueryFromFileList(q);return{...g,...j}}const U=m.extraFileResources&&m.extraFileResources.filter(z=>(0,w.pathIncludedInQuery)(g,z.fsPath));return g.extraFileResources=U&&U.length?U:void 0,g}commonQueryFromFileList(f){const m=[],E=new y.ResourceMap,T={};let A=!1;return f.forEach(x=>{if(x.scheme===O.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(x)){const U=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:I.dirname(x.fsPath)});let z=E.get(U);z||(A=!0,z={folder:U,includePattern:{}},m.push(z),E.set(U,z));const q=I.relative(U.fsPath,x.fsPath);(0,v.assertIsDefined)(z.includePattern)[q.replace(/\\/g,"/")]=!0}else x.fsPath&&(A=!0,T[x.fsPath]=!0)}),{folderQueries:m,includePattern:T,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(f,m){if(m.isSmartCase){if(f.isRegExp){if(N.containsUppercaseCharacter(f.pattern,!0))return!0}else if(N.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,p.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const m=j=>I.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),T=(Array.isArray(f)?f:P(f)).map(j=>{const J=this.pathService.resolvedUserHome;return J?(0,$.untildify)(j,J.scheme===O.Schemas.file?J.fsPath:J.path):j}),A=k.groupBy(T,j=>m(j)?"searchPaths":"exprSegments"),x=(A.exprSegments||[]).map(j=>N.rtrim(j,"/")).map(j=>N.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),c(j))),g={},U=this.expandSearchPathPatterns(A.searchPaths||[]);U&&U.length&&(g.searchPaths=U);const z=r.flatten(x),q=a(...z);return q&&(g.pattern=q),g}getExcludesForFolder(f,m){return m.disregardExcludeSettings?void 0:(0,w.getExcludes)(f,!m.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const m=r.flatten(f.map(T=>{let{pathPortion:A,globPortion:x}=D(T);x&&(x=h(x));const g=this.expandOneSearchPath(A);return r.flatten(g.map(U=>this.resolveOneSearchPathPattern(U,x)))})),E=new Map;return m.forEach(T=>{const A=T.searchPath.toString(),x=E.get(A);x?T.pattern&&(x.pattern=x.pattern||{},x.pattern[T.pattern]=!0):E.set(A,{searchPath:T.searchPath,pattern:T.pattern?a(T.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(f){if(I.isAbsolute(f)){const m=this.workspaceContextService.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==O.Schemas.file?[{searchPath:m[0].uri.with({path:f})}]:[{searchPath:n.URI.file(I.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const m=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=t(f),f.startsWith("../")||f===".."){const T=I.posix.resolve(m.path,f);return[{searchPath:m.with({path:T})}]}const E=h(f);return[{searchPath:m,pattern:E}]}else{if(f==="./"||f===".\\")return[];{const m=f.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(A=>{const x=m.match(new RegExp(`^${N.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return x?{match:x,folder:A}:null}).filter(v.isDefined);if(T.length)return T.map(A=>{const x=A.match[1];return{searchPath:A.folder.uri,pattern:x&&h(x)}});{const A=f.match(/\.[\/\\](.+)[\/\\]?/),x=A?A[1]:f,g=s.localize(0,null,x);throw new Error(g)}}}}resolveOneSearchPathPattern(f,m){const E=f.pattern&&m?`${f.pattern}/${m}`:f.pattern||m,T=[{searchPath:f.searchPath,pattern:E}];return E&&!E.endsWith("**")&&T.push({searchPath:f.searchPath,pattern:E+"/**"}),T}getFolderQueryForSearchPath(f,m,E){const T=this.getFolderQueryForRoot((0,u.toWorkspaceFolder)(f.searchPath),m,E,!1);return T?{...T,includePattern:f.pattern}:null}getFolderQueryForRoot(f,m,E,T){let A;const x=n.URI.isUri(f)?f:f.uri;if(E.searchPaths){const j=E.searchPaths.filter(J=>(0,R.isEqual)(J.searchPath,x))[0];if(j&&!j.pattern)return null;j&&(A=j.pattern)}const g=this.configurationService.getValue({resource:x}),z={...this.getExcludesForFolder(g,m)||{},...A||{}},q=n.URI.isUri(f)?(0,R.basename)(f):f.name;return{folder:x,folderName:T?q:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:g.files&&g.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!g.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!g.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!g.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!g.search.followSymlinks}}};d=Fe([Ne(0,i.IConfigurationService),Ne(1,u.IWorkspaceContextService),Ne(2,S.IEditorGroupsService),Ne(3,_.IPathService)],d),e.QueryBuilder=d;function D(l){const f=l.match(/[\*\{\}\(\)\[\]\?]/);if(f){const m=f.index,E=l.substr(0,m).match(/[/|\\][^/\\]*$/);if(E){let T=l.substr(0,E.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:l.substr((E.index||0)+1)}}}return{pathPortion:l}}function a(...l){return l.length?l.reduce((f,m)=>(f[m]=!0,f),Object.create(null)):void 0}function P(l){return b.splitGlobAware(l,",").map(f=>f.trim()).filter(f=>!!f.length)}function c(l){return[`**/${l}/**`,`**/${l}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function t(l){return l.replace(/\\/g,"/")}function h(l){return t(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(l,f){l=r.distinct(l,T=>T.toString());const m=[],E=f.getWorkspace();return l&&l.forEach(T=>{let A;if(f.getWorkbenchState()===2)A=(0,R.relativePath)(E.folders[0].uri,T),A&&A!=="."&&(A="./"+A);else{const x=f.getWorkspaceFolder(T);if(x){const g=x.name;if(E.folders.filter(z=>z.name===g).length===1){const z=(0,R.relativePath)(x.uri,T);z===""?A=`./${x.name}`:A=`./${x.name}/${z}`}else A=T.fsPath}}A&&m.push(A)}),m}e.resolveResourcesForSearchIncludes=o}),define(Ee[215],be([1,0,24,2,20,15,3,214,41,47]),function(Y,e,r,k,b,$,y,O,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function v(i,u){const S=u.activationEvents;if(!S)return Promise.resolve(void 0);const _=[],w=[];for(const t of S)if(/^workspaceContains:/.test(t)){const h=t.substr("workspaceContains:".length);h.indexOf("*")>=0||h.indexOf("?")>=0||i.forceUsingSearch?w.push(h):_.push(h)}if(_.length===0&&w.length===0)return Promise.resolve(void 0);let d;const D=new Promise((t,h)=>{d=t}),a=t=>d({activationEvent:t}),P=Promise.all(_.map(t=>n(i,t,a))).then(()=>{}),c=p(i,u.identifier,w,a);return Promise.all([P,c]).then(()=>{d(void 0)}),D}e.checkActivateWorkspaceContainsExtension=v;async function n(i,u,S){for(const _ of i.folders)if(await i.exists(r.joinPath(k.URI.revive(_),u))){S(`workspaceContains:${u}`);return}}async function p(i,u,S,_){if(S.length===0)return Promise.resolve(void 0);const w=new b.CancellationTokenSource,d=i.checkExists(i.folders,S,w.token),D=setTimeout(async()=>{w.cancel(),i.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${S.join(",")}`)},N);let a=!1;try{a=await d}catch(P){$.isCancellationError(P)||$.onUnexpectedError(P)}w.dispose(),clearTimeout(D),a&&_(`workspaceContains:${S.join(",")}`)}function s(i,u,S,_){const w=i.get(y.IInstantiationService),d=i.get(I.ISearchService),a=w.createInstance(O.QueryBuilder).file(u.map(P=>(0,R.toWorkspaceFolder)(k.URI.revive(P))),{_reason:"checkExists",includePattern:S,exists:!0});return d.fileSearch(a,_).then(P=>!!P.limitHit,P=>$.isCancellationError(P)?!1:Promise.reject(P))}e.checkGlobFileExists=s});var je=this&&this.__classPrivateFieldSet||function(Y,e,r,k,b){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!b:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?b.call(Y,r):b?b.value=r:e.set(Y,r),r},De=this&&this.__classPrivateFieldGet||function(Y,e,r,k){if(r==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?k:r==="a"?k.call(Y):k?k.value:e.get(Y)};define(Ee[33],be([1,0,122,17,67,24,11,6,22,2,12,4,32,173,65,31,27,172,15,25,21,148,7,79,3,28,66,14,55,58,40,5,215,62,150,9]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_,w,d,D,a,P,c,t,h,o,l,f,m,E,T,A,x,g){"use strict";var U,z,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,c.createDecorator)("IHostUtils");let j=class qi extends O.Disposable{constructor(te,ue,fe,Se,ge,ne,me,Ie,Ae,Ue){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ue,this._extHostContext=fe,this._initData=me,this._extHostWorkspace=Se,this._extHostConfiguration=ge,this._logService=ne,this._extHostTunnelService=Ae,this._extHostTerminalService=Ue,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(v.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(v.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(v.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new S.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=te.createChild(new l.ServiceCollection([s.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const Ke=new Set;this._initData.hostExtensions.forEach(pe=>Ke.add(w.ExtensionIdentifier.toKey(pe))),this._activator=this._register(new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(pe,de,L)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(pe,_.transformErrorForSerialization(de),L)},actualActivateExtension:async(pe,de)=>{if(Ke.has(w.ExtensionIdentifier.toKey(pe)))return await this._mainThreadExtensionsProxy.$activateExtension(pe,de),new p.HostExtension;const L=this._registry.getExtensionDescription(pe);return this._activateExtension(L,de)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){_.onUnexpectedError(te)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._registry.getAllExtensionDescriptions().map(ge=>ge.identifier).filter(ge=>this.isActivated(ge)).map(ge=>this._deactivate(ge))}catch{}await Promise.all(te)}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}_activateByEvent(te,ue){return this._activator.activateByEvent(te,ue)}_activateById(te,ue){return this._activator.activateById(te,ue)}activateByIdWithErrors(te,ue){return this._activateById(te,ue).then(()=>{const fe=this._activator.getActivatedExtension(te);if(fe.activationFailed)return Promise.reject(fe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._registry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==g.Schemas.file)return te;const ue=await this._hostUtils.realpath(te.fsPath);return R.URI.file(ue)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const te=I.TernarySearchTree.forUris(ue=>$.extUriBiasedIgnorePathCase.ignorePathCasing(ue));for(const ue of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ue)){const fe=await this._realPathExtensionUri(ue.extensionLocation);te.set(fe,ue)}return te})()),this._extensionPathIndex}_deactivate(te){let ue=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return ue;const fe=this._activator.getActivatedExtension(te);if(!fe)return ue;try{typeof fe.module.deactivate=="function"&&(ue=Promise.resolve(fe.module.deactivate()).then(void 0,Se=>(this._logService.error(Se),Promise.resolve(void 0))))}catch(Se){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(Se)}try{(0,O.dispose)(fe.subscriptions)}catch(Se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(Se)}return ue}async _activateExtension(te,ue){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,ue).then(fe=>{const Se=fe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,ue),this._logExtensionActivationTimes(te,ue,"success",Se),fe},fe=>{throw this._logExtensionActivationTimes(te,ue,"failure"),fe})}_logExtensionActivationTimes(te,ue,fe,Se){const ge=J(te,ue);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ge,...Se||{},outcome:fe})}_doActivateExtension(te,ue){const fe=J(te,ue);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",fe);const Se=this._getEntryPoint(te);if(!Se)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${te.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this._logService.flush();const ge=new p.ExtensionActivationTimesBuilder(ue.startup);return Promise.all([this._loadCommonJSModule(te.identifier,(0,$.joinPath)(te.extensionLocation,Se),ge),this._loadExtensionContext(te)]).then(ne=>(b.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),qi._callActivate(this._logService,te.identifier,ne[0],ne[1],ge))).then(ne=>(b.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ne))}_loadExtensionContext(te){const ue=new D.ExtensionGlobalMemento(te,this._storage),fe=new D.ExtensionMemento(te.identifier.value,!1,this._storage),Se=new x.ExtensionSecrets(te,this._secretState),ge=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,ne=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([ue.whenReady,fe.whenReady,this._storagePath.whenReady]).then(()=>{const me=this;let Ie,Ae;const Ue=(0,u.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(w.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:fe,secrets:Se,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(Ke){return k.join(te.extensionLocation.fsPath,Ke)},get storagePath(){return me._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return me._storagePath.globalValue(te).fsPath},get logPath(){return k.join(me._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return R.URI.joinPath(me._initData.logsLocation,te.identifier.value)},get storageUri(){return me._storagePath.workspaceValue(te)},get globalStorageUri(){return me._storagePath.globalValue(te)},get extensionMode(){return ge},get extension(){return Ie===void 0&&(Ie=new V(me,te.identifier,te,ne)),Ie},get extensionRuntime(){return(0,u.checkProposedApiEnabled)(te,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Ae){if(!Ue)return;const Ke=E.Event.buffer(E.Event.fromDOMEventEmitter(Ue,"message",pe=>pe.data));Ue.start(),Ae={onDidReceiveMessage:Ke,postMessage:Ue.postMessage.bind(Ue)}}return Ae}})})}static _callActivate(te,ue,fe,Se,ge){return fe=fe||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,ue,fe,Se,ge).then(ne=>new p.ActivatedExtension(!1,null,ge.build(),fe,ne,Se.subscriptions))}static _callActivateOptional(te,ue,fe,Se,ge){if(typeof fe.activate=="function")try{ge.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const ne=typeof global=="object"?global:self,me=fe.activate.apply(ne,[Se]);return ge.activateCallStop(),ge.activateResolveStart(),Promise.resolve(me).then(Ie=>(ge.activateResolveStop(),Ie))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(fe)}_activateOneStartupFinished(te,ue){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:ue}).then(void 0,fe=>{this._logService.error(fe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const te of this._registry.getAllExtensionDescriptions())if(te.activationEvents)for(const ue of te.activationEvents)ue==="onStartupFinished"&&this._activateOneStartupFinished(te,ue)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,ge=>{this._logService.error(ge)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ge=>this._handleWorkspaceContainsEagerExtensions(ge.added)));const ue=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],fe=this._handleWorkspaceContainsEagerExtensions(ue),Se=Promise.all([te,fe]).then(()=>{});return Promise.race([Se,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Se}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ue=>this._handleWorkspaceContainsEagerExtension(te,ue))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,ue){if(this.isActivated(ue.identifier))return;const fe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Se={logService:this._logService,folders:te.map(ne=>ne.uri),forceUsingSearch:fe,exists:ne=>this._hostUtils.exists(ne.fsPath),checkExists:(ne,me,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(ne,me,Ie)},ge=await(0,T.checkActivateWorkspaceContainsExtension)(Se,ue);if(!!ge)return this._activateById(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:ge.activationEvent}).then(void 0,ne=>this._logService.error(ne))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:ue}=this._initData.environment;if(!te||!ue)throw new Error(r.localize(0,null));const fe=await this._loadCommonJSModule(null,ue,new p.ExtensionActivationTimesBuilder(!1));if(!fe||typeof fe.run!="function")throw new Error(r.localize(1,null,ue.toString()));return new Promise((Se,ge)=>{const ne=(Ae,Ue)=>{Ae?ge(Ae):Se(typeof Ue=="number"&&Ue>0?1:0)},me=(0,$.originalFSPath)(ue),Ie=fe.run(me,ne);Ie&&Ie.then&&Ie.then(()=>{Se(0)}).catch(Ae=>{ge(Ae instanceof Error&&Ae.stack?Ae.stack:String(Ae))})})}async $extensionTestsExit(te){this._logService.info(`Extension host terminating: test runner requested exit with code ${te}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${te}`),this._logService.flush(),this._hostUtils.exit(te)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,ue){return this._resolvers[te]=ue,(0,O.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const ue=te.indexOf("+");if(ue===-1)throw new Error("Not an authority that can be resolved!");const fe=te.substr(0,ue);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${fe}`,!1),{authorityPrefix:fe,resolver:this._resolvers[fe]}}async $resolveAuthority(te,ue){this._logService.info(`$resolveAuthority invoked for authority (${ie(te)})`);const{authorityPrefix:fe,resolver:Se}=await this._activateAndGetResolver(te);if(!Se)return{type:"error",error:{code:P.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${fe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(Se)),b.mark(`code/extHost/willResolveAuthority/${fe}`);const ge=await Se.resolve(te,{resolveAttempt:ue});b.mark(`code/extHost/didResolveAuthorityOK/${fe}`);const ne={authority:te,host:ge.host,port:ge.port,connectionToken:ge.connectionToken},me={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ne,options:me,tunnelInformation:{environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures}}}}catch(ge){if(b.mark(`code/extHost/didResolveAuthorityError/${fe}`),ge instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:ge._code,message:ge._message,detail:ge._detail}};throw ge}}async $getCanonicalURI(te,ue){this._logService.info(`$getCanonicalURI invoked for authority (${ie(te)})`);const{authorityPrefix:fe,resolver:Se}=await this._activateAndGetResolver(te);if(!Se)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${fe}`);const ge=R.URI.revive(ue);if(typeof Se.getCanonicalURI=="undefined")return ge;const ne=await(0,y.asPromise)(()=>Se.getCanonicalURI(ge));return ne||ge}$startExtensionHost(te){return this._registry.keepOnly(te),this._startExtensionHost()}$activateByEvent(te,ue){return ue===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(fe=>this._activateByEvent(te,!1))}async $activate(te,ue){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(te)?(await this._activateById(te,ue),!0):!1}async $deltaExtensions(te,ue){te.forEach(Se=>Se.extensionLocation=R.URI.revive(Se.extensionLocation));const fe=await this.getExtensionPathIndex();return await Promise.all(ue.map(async Se=>{const ge=this._registry.getExtensionDescription(Se);ge&&fe.delete(await this._realPathExtensionUri(ge.extensionLocation))})),await Promise.all(te.map(async Se=>{const ge=await this._realPathExtensionUri(Se.extensionLocation);fe.set(ge,Se)})),this._registry.deltaExtensions(te,ue),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){let ue=d.VSBuffer.alloc(te),fe=Math.random()%256;for(let Se=0;Se<te;Se++)ue.writeUInt8(fe,Se);return ue}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};j=Fe([Ne(0,c.IInstantiationService),Ne(1,e.IHostUtils),Ne(2,o.IExtHostRpcService),Ne(3,i.IExtHostWorkspace),Ne(4,n.IExtHostConfiguration),Ne(5,N.ILogService),Ne(6,t.IExtHostInitDataService),Ne(7,h.IExtensionStoragePaths),Ne(8,f.IExtHostTunnelService),Ne(9,m.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function J(ae,te){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,c.createDecorator)("IExtHostExtensionService");class V{constructor(te,ue,fe,Se){U.set(this,void 0),z.set(this,void 0),q.set(this,void 0),je(this,U,te,"f"),je(this,z,ue,"f"),je(this,q,fe.identifier,"f"),this.id=fe.identifier.value,this.extensionUri=fe.extensionLocation,this.extensionPath=k.normalize((0,$.originalFSPath)(fe.extensionLocation)),this.packageJSON=fe,this.extensionKind=Se}get isActive(){return De(this,U,"f").isActivated(De(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return De(this,U,"f").getExtensionExports(De(this,q,"f"))}activate(){return De(this,U,"f").activateByIdWithErrors(De(this,q,"f"),{startup:!1,extensionId:De(this,z,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=V,U=new WeakMap,z=new WeakMap,q=new WeakMap;function ie(ae){const te=ae.indexOf("+");return te===-1?ae:ae.substring(0,te)}}),define(Ee[98],be([1,0,17,2,5,11,4,7,157,31,33,49,165,32,159,14,3,13,85,64]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,u.createDecorator)("IExtHostDebugService");let d=class{constructor(l,f,m,E,T,A){this._workspaceService=f,this._extensionService=m,this._editorsService=E,this._configurationService=T,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new b.Emitter,this._onDidTerminateDebugSession=new b.Emitter,this._onDidChangeActiveDebugSession=new b.Emitter,this._onDidReceiveDebugSessionCustomEvent=new b.Emitter,this._debugServiceProxy=l.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new b.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(g=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,f){const m=l;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let E=`debug:${encodeURIComponent(m.path||"")}`,T="?";return f&&(E+=`${T}session=${encodeURIComponent(f.id)}`,T="&"),E+=`${T}ref=${m.sourceReference}`,k.URI.parse(E)}else{if(m.path)return k.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const f=[];for(const m of l.getAllExtensionDescriptions())if(m.contributes){const E=m.contributes.debuggers;if(E&&E.length>0)for(const T of E)(0,s.isDebuggerMainContribution)(T)&&f.push(T.type)}this._debugServiceProxy.$registerDebugTypes(f)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(f=>l.push(f)),l}addBreakpoints(l){this.startBreakpoints();const f=l.filter(T=>{const A=T.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,T),!0)});this.fireBreakpointChanges(f,[],[]);const m=[],E=new Map;for(const T of f)if(T instanceof O.SourceBreakpoint){let A=E.get(T.location.uri.toString());A||(A={type:"sourceMulti",uri:T.location.uri,lines:[]},E.set(T.location.uri.toString(),A),m.push(A)),A.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof O.FunctionBreakpoint&&m.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(m)}removeBreakpoints(l){this.startBreakpoints();const f=l.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],f,[]);const m=f.filter(A=>A instanceof O.SourceBreakpoint).map(A=>A.id),E=f.filter(A=>A instanceof O.FunctionBreakpoint).map(A=>A.id),T=f.filter(A=>A instanceof O.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(m,E,T)}startDebugging(l,f,m){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,f,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===O.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,debugUI:m.debugUI,suppressSaveBeforeStart:m.suppressSaveBeforeStart})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,f,m){if(!f)return new O.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:E,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,m,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,E),new O.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(l,f,m){if(!m)return new O.Disposable(()=>{});if(!this.definesDebugType(l,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:E,factory:m}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,E),new O.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==m),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(l,f){if(!f)return new O.Disposable(()=>{});const m=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:m,factory:f}),new O.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==f)})}async $runInTerminal(l,f){return Promise.resolve(void 0)}async $substituteVariables(l,f){if(!this._variableResolver){const[T,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,A)}let m;const E=await this.getFolder(l);return E&&(m={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(m,f)}createDebugAdapter(l,f){if(l.type==="implementation")return new t(l.implementation)}createSignService(){}async $startDASession(l,f){const m=this,E=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const A=this.convertToDto(T),x=this.createDebugAdapter(A,E);if(!x)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const g=x;return this._debugAdapters.set(l,g),this.getDebugAdapterTrackers(E).then(U=>(U&&this._debugAdaptersTrackers.set(l,U),g.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const q=z,j={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const J=await this._signService.sign(q.arguments.value);j.body={signature:J},g.sendResponse(j)}else throw new Error("no signer")}catch(J){j.success=!1,j.message=J.message,g.sendResponse(j)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(z),z=(0,s.convertToVSCPaths)(z,!0),m._debugServiceProxy.$acceptDAMessage(l,z)}),g.onError(z=>{U&&U.onError&&U.onError(z),this._debugServiceProxy.$acceptDAError(l,z.name,z.message,z.stack)}),g.onExit(z=>{U&&U.onExit&&U.onExit((0,S.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,S.withNullAsUndefined)(z),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),g.startSession()))})}$sendDAMessage(l,f){f=(0,s.convertToDAPaths)(f,!1);const m=this._debugAdaptersTrackers.get(l);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(f);const E=this._debugAdapters.get(l);E&&E.sendMessage(f)}$stopDASession(l){const f=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),f&&f.onWillStopSession&&f.onWillStopSession();const m=this._debugAdapters.get(l);return this._debugAdapters.delete(l),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const f=[],m=[],E=[];if(l.added)for(const T of l.added){const A=T.id;if(A&&!this._breakpoints.has(A)){let x;if(T.type==="function")x=new O.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")x=new O.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const g=k.URI.revive(T.uri);x=new O.SourceBreakpoint(new O.Location(g,new O.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}x._id=A,this._breakpoints.set(A,x),f.push(x)}}if(l.removed)for(const T of l.removed){const A=this._breakpoints.get(T);A&&(this._breakpoints.delete(T),m.push(A))}if(l.changed){for(const T of l.changed)if(T.id){const A=this._breakpoints.get(T.id);if(A){if(A instanceof O.FunctionBreakpoint&&T.type==="function"){const x=A;x.enabled=T.enabled,x.condition=T.condition,x.hitCondition=T.hitCondition,x.logMessage=T.logMessage,x.functionName=T.functionName}else if(A instanceof O.SourceBreakpoint&&T.type==="source"){const x=A;x.enabled=T.enabled,x.condition=T.condition,x.hitCondition=T.hitCondition,x.logMessage=T.logMessage,x.location=new O.Location(k.URI.revive(T.uri),new O.Position(T.line,T.character))}E.push(A)}}}this.fireBreakpointChanges(f,m,E)}$provideDebugConfigurations(l,f,m){return(0,$.asPromise)(async()=>{const E=this.getConfigProviderByHandle(l);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(f);return E.provideDebugConfigurations(T,m)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(l,f,m,E){return(0,$.asPromise)(async()=>{const T=this.getConfigProviderByHandle(l);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(f);return T.resolveDebugConfiguration(A,m,E)})}$resolveDebugConfigurationWithSubstitutedVariables(l,f,m,E){return(0,$.asPromise)(async()=>{const T=this.getConfigProviderByHandle(l);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(f);return T.resolveDebugConfigurationWithSubstitutedVariables(A,m,E)})}async $provideDebugAdapter(l,f){const m=this.getAdapterDescriptorFactoryByHandle(l);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(f);return this.getAdapterDescriptor(m,E).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(l){const f=await this.getSession(l);this._onDidStartDebugSession.fire(f)}async $acceptDebugSessionTerminated(l){const f=await this.getSession(l);f&&(this._onDidTerminateDebugSession.fire(f),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,f){const m=await this.getSession(l);m&&m._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(l,f){const E={session:await this.getSession(l),event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(l){if(l instanceof O.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof O.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof O.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof O.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const f=this._adapterFactories.filter(m=>m.type===l);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(l){const f=this._adapterFactories.filter(m=>m.handle===l);if(f.length>0)return f[0].factory}getConfigProviderByHandle(l){const f=this._configProviders.filter(m=>m.handle===l);if(f.length>0)return f[0].provider}definesDebugType(l,f){if(l.contributes){const m=l.contributes.debuggers;if(m&&m.length>0){for(const E of m)if(E.label&&E.type&&E.type===f)return!0}}return!1}getDebugAdapterTrackers(l){const m=l.configuration.type,E=this._trackerFactories.filter(T=>T.type===m||T.type==="*").map(T=>(0,$.asPromise)(()=>T.factory.createDebugAdapterTracker(l)).then(A=>A,A=>null));return Promise.race([Promise.all(E).then(T=>{const A=T.filter(x=>!!x);if(A.length>0)return new c(A)}),new Promise((T,A)=>{const x=setTimeout(()=>{clearTimeout(x),A(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(l,f){const m=f.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new O.DebugAdapterServer(m));if(l){const T=await this._extensionService.getExtensionRegistry();return(0,$.asPromise)(()=>l.createDebugAdapterDescriptor(f,this.daExecutableFromPackage(f,T))).then(A=>{if(A)return A})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,E))}daExecutableFromPackage(l,f){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,f,m){(l.length>0||f.length>0||m.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:f,changed:m}))}async getSession(l){if(l)if(typeof l=="string"){const f=this._debugSessions.get(l);if(f)return f}else{let f=this._debugSessions.get(l.id);if(!f){const m=await this.getFolder(l.folderUri),E=l.parent?this._debugSessions.get(l.parent):void 0;f=new D(this._debugServiceProxy,l.id,l.type,l.name,m,l.configuration,E),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(l){if(l){const f=k.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}};d=Fe([Ne(0,i.IExtHostRpcService),Ne(1,R.IExtHostWorkspace),Ne(2,N.IExtHostExtensionService),Ne(3,v.IExtHostDocumentsAndEditors),Ne(4,p.IExtHostConfiguration),Ne(5,w.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class D{constructor(l,f,m,E,T,A,x){this._debugServiceProxy=l,this._id=f,this._type=m,this._name=E,this._workspaceFolder=T,this._configuration=A,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,f){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,f)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=D;class a{constructor(l){this.value=Object.freeze({append(f){l.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=a;class P extends n.AbstractVariableResolverService{constructor(l,f,m,E,T){function A(){if(f){const x=f.activeEditor();if(x)return x.document.uri;const g=E.tabs.filter(U=>U.isActive);if(g.length>0){const U=g[0].resource;return U&&(U.primary||U.secondary)?U.primary??U.secondary:g[0].resource}}}super({getFolderUri:x=>{const g=l.filter(U=>U.name===x);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(x,g)=>m.getConfiguration(void 0,x).get(g),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const x=A();if(x)return r.normalize(x.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const x=A();if(x){const g=T.getWorkspaceFolder(x);if(g)return r.normalize(g.uri.fsPath)}}},getSelectedText:()=>{if(f){const x=f.activeEditor();if(x&&!x.selection.isEmpty)return x.document.getText(x.selection)}},getLineNumber:()=>{if(f){const x=f.activeEditor();if(x)return String(x.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=P;class c{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(f=>f.onError?f.onError(l):void 0)}onExit(l,f){this.trackers.forEach(m=>m.onExit?m.onExit(l,f):void 0)}}class t extends I.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let h=class extends d{constructor(l,f,m,E,T,A){super(l,f,m,E,T,A)}createVariableResolver(l,f,m){return new P(l,f,m,this._editorTabs)}};h=Fe([Ne(0,i.IExtHostRpcService),Ne(1,R.IExtHostWorkspace),Ne(2,N.IExtHostExtensionService),Ne(3,v.IExtHostDocumentsAndEditors),Ne(4,p.IExtHostConfiguration),Ne(5,w.IExtHostEditorTabs)],h),e.WorkerExtHostDebugService=h}),define(Ee[216],be([1,0,67,2,4,32,27,25,14,28,3,33,85,12,10]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let i=class{constructor(D,a,P,c,t,h,o){this._apiFactory=D,this._extensionRegistry=a,this._instaService=P,this._extHostConfiguration=c,this._extHostExtensionService=t,this._initData=h,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const D=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new S(this._apiFactory,a,this._extensionRegistry,D,this._logService)),this.register(this._instaService.createInstance(_,a)),this.register(this._instaService.createInstance(u)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,a,this._initData.environment.appUriScheme))}register(D){if("nodeModuleName"in D)if(Array.isArray(D.nodeModuleName))for(let a of D.nodeModuleName)this._factories.set(a,D);else this._factories.set(D.nodeModuleName,D);typeof D.alternativeModuleName=="function"&&this._alternatives.push(a=>D.alternativeModuleName(a))}};i=Fe([Ne(2,N.IInstantiationService),Ne(3,$.IExtHostConfiguration),Ne(4,v.IExtHostExtensionService),Ne(5,R.IExtHostInitDataService),Ne(6,p.ILogService)],i),e.RequireInterceptor=i;let u=class Hi{constructor(D){if(D.environment.appRoot&&Hi.aliased.size){const a=(0,s.escapeRegExpCharacters)(this.forceForwardSlashes(D.environment.appRoot.fsPath)),P="[a-z0-9_.-]",c=`@${P}+\\/${P}+|${P}+`,t="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${t}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(D){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(D));if(!a)return;const[,P,c,t]=a,h=Hi.aliased.get(c);if(h!==void 0)return console.warn(`${c} as been renamed to ${h}, please update your imports`),P+h+t}forceForwardSlashes(D){return D.replace(/\\/g,"/")}};u.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),u=Fe([Ne(0,R.IExtHostInitDataService)],u);class S{constructor(D,a,P,c,t){this._apiFactory=D,this._extensionPaths=a,this._extensionRegistry=P,this._configProvider=c,this._logService=t,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(D,a){const P=this._extensionPaths.findSubstr(a);if(P){let c=this._extApiImpl.get(O.ExtensionIdentifier.toKey(P.identifier));return c||(c=this._apiFactory(P,this._extensionRegistry,this._configProvider),this._extApiImpl.set(O.ExtensionIdentifier.toKey(P.identifier),c)),c}if(!this._defaultApiImpl){let c="";this._extensionPaths.forEach((t,h)=>c+=`	${h} -> ${t.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${c}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(D,a,P){this._extensionPaths=D,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(b.MainContext.MainThreadTelemetry);const{environment:c}=P,t=a.getProxy(b.MainContext.MainThreadKeytar);if(c.appRoot){let h=c.appRoot.fsPath;n.platform==="win32"&&(h=h.replace(/\\/g,"/")),h[h.length-1]==="/"&&(h=h.substr(0,h.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${h}/node_modules.asar/keytar`),this.alternativeNames.add(`${h}/node_modules/keytar`)}this._impl={getPassword:(h,o)=>t.$getPassword(h,o),setPassword:(h,o,l)=>t.$setPassword(h,o,l),deletePassword:(h,o)=>t.$deletePassword(h,o),findPassword:h=>t.$findPassword(h),findCredentials(h){return t.$findCredentials(h)}}}load(D,a){const P=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:P?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(D){const a=D.length;if(a<=7||!this.alternativeNames)return;const P=a-7;if((D.charAt(P)==="/"||D.charAt(P)==="\\")&&D.endsWith("keytar")&&(D=D.replace(/\\/g,"/"),this.alternativeNames.has(D)))return"keytar"}};_=Fe([Ne(1,I.IExtHostRpcService),Ne(2,R.IExtHostInitDataService)],_);let w=class{constructor(D,a,P){this._extensionPaths=D,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=P.getProxy(b.MainContext.MainThreadTelemetry);const c=P.getProxy(b.MainContext.MainThreadWindow);this._impl=(t,h)=>{const o=k.URI.parse(t);return h?this.callOriginal(t,h):o.scheme==="http"||o.scheme==="https"?c.$openUri(o,t,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?c.$openUri(o,t,{}):this.callOriginal(t,h)}}load(D,a,P){const c=this._extensionPaths.findSubstr(a);return c&&(this._extensionId=c.identifier.value,this.sendShimmingTelemetry()),this._original=P(D),this._impl}callOriginal(D,a){return this.sendNoForwardTelemetry(),this._original(D,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Fe([Ne(2,I.IExtHostRpcService)],w)}),define(Ee[217],be([1,0,11,15,67,6,2,4,209,12,44,55,28,138,14,59,33,40]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(d,D,a,P,c){this._disposables=new $.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new I.RPCProtocol(d,null,P),D=_._transform(D,this._rpcProtocol);const t=new v.ServiceCollection(...(0,N.getSingletonServiceDescriptors)());t.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...D,messagePorts:c}),t.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),t.set(i.IURITransformerService,new i.URITransformerService(P)),t.set(u.IHostUtils,a);const h=new p.InstantiationService(t,!0);this._disposables.add(h.invokeFunction(m=>m.get(S.IExtHostTerminalService))),this._disposables.add(h.invokeFunction(m=>m.get(u.IExtHostExtensionService))),this._logService=h.invokeFunction(m=>m.get(R.ILogService)),b.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",D),this._extensionService=h.invokeFunction(m=>m.get(u.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const o=new WeakMap;this._extensionService.getExtensionPathIndex().then(m=>{Error.prepareStackTrace=(E,T)=>{let A="",x,g;for(const U of T)A+=`
	at ${U.toString()}`,g=U.getFileName(),!x&&g&&(x=m.findSubstr(y.URI.file(g)));return o.set(E,x),`${E.name||"Error"}: ${E.message||""}${A}`}});const l=this._rpcProtocol.getProxy(O.MainContext.MainThreadExtensionService),f=this._rpcProtocol.getProxy(O.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(m=>{const E=k.transformErrorForSerialization(m),T=o.get(m);T?l.$onExtensionRuntimeError(T.identifier,E):f.$onUnexpectedError(E)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const D=this._extensionService.deactivateAll();Promise.race([(0,r.timeout)(5e3),D]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(d,D){d.extensions.forEach(P=>P.extensionLocation=y.URI.revive(D.transformIncomingURIs(P.extensionLocation))),d.environment.appRoot=y.URI.revive(D.transformIncomingURIs(d.environment.appRoot));const a=d.environment.extensionDevelopmentLocationURI;return a&&(d.environment.extensionDevelopmentLocationURI=a.map(P=>y.URI.revive(D.transformIncomingURIs(P)))),d.environment.extensionTestsLocationURI=y.URI.revive(D.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=y.URI.revive(D.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=y.URI.revive(D.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=y.URI.revive(D.transformIncomingURIs(d.logsLocation)),d.logFile=y.URI.revive(D.transformIncomingURIs(d.logFile)),d.workspace=D.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=_}),define(Ee[218],be([1,0,16,11,20,43,29,9,17,24,13,2,41]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class p{constructor(d,D,a,P){this.query=d,this.provider=D,this.fileUtils=a,this.processType=P,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,D){const a=this.query.folderQueries||[],P=new b.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),new Promise((c,t)=>{this.collector=new i(d);let h=!1;const o=(l,f)=>{if(!h&&!this.isLimitHit){const m=this.resultSize(l);S(l)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,h=!0,P.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const E=this.resultSize(l);this.resultCount+=E,(E>0||!S(l))&&this.collector.add(l,f)}};Promise.all(a.map((l,f)=>this.searchInFolder(l,m=>o(m,f),P.token))).then(l=>{P.dispose(),this.collector.flush();const f=l.some(m=>!!m&&!!m.limitHit);c({limitHit:this.isLimitHit||f,messages:(0,r.flatten)(l.map(m=>m?.message?(0,N.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},l=>{P.dispose();const f=(0,$.toErrorMessage)(l);t(new Error(f))})})}resultSize(d){return S(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,D){const a=Array.isArray(d.ranges)?d.ranges:[d.ranges],P=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:a.slice(0,D),preview:{matches:P.slice(0,D),text:d.preview.text},uri:d.uri}}async searchInFolder(d,D,a){const P=new n.QueryGlobTester(this.query,d),c=[],t={report:l=>{if(!this.validateProviderResult(l))return;const f=d.folder.scheme===O.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(R.dirname(l.uri))):void 0,m=R.relativePath(d.folder,l.uri);if(m){const E=P.includedInQuery(m,I.basename(m),f);(0,k.isThenable)(E)?c.push(E.then(T=>{T&&D(l)})):E&&D(l)}}},h=this.getSearchOptionsForFolder(d),o=await this.provider.provideTextSearchResults(s(this.query.contentPattern),h,t,a);return c.length&&await Promise.all(c),o}validateProviderResult(d){if(S(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const D=(0,n.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),a=(0,n.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),P={folder:v.URI.from(d.folder),excludes:a,includes:D,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return P.usePCRE2=this.query.usePCRE2,P}}e.TextSearchManager=p;function s(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class i{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new _(512,D=>this.sendItems(D))}add(d,D){this._currentFileMatch&&(this._currentFolderIdx!==D||!R.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=D,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(u(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=i;function u(w){return S(w)?{preview:{matches:(0,r.mapArrayOrNot)(w.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:w.preview.text},ranges:(0,r.mapArrayOrNot)(w.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function S(w){return!!w.preview}e.extensionResultIsMatch=S;class _{constructor(d,D){this.maxBatchSize=d,this.cb=D,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,D){!d||this.addItemToBatch(d,D)}addItems(d,D){!d||this.addItemsToBatch(d,D)}addItemToBatch(d,D){this.batch.push(d),this.batchSize+=D,this.onUpdate()}addItemsToBatch(d,D){this.batch=this.batch.concat(d),this.batchSize+=D,this.onUpdate()}onUpdate(){this.totalNumberCompleted<_.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},_.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=_,_.TIMEOUT=4e3,_.START_BATCH_AFTER_COUNT=50}),define(Ee[99],be([1,0,6,4,3,213,14,59,12,2,218]),function(Y,e,r,k,b,$,y,O,I,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let v=class{constructor(i,u,S){this.extHostRpc=i,this._uriTransformer=u,this._logService=S,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new $.FileSearchManager}_transformScheme(i){return this._uriTransformer.transformOutgoingScheme(i)}registerTextSearchProvider(i,u){if(this._textSearchUsedSchemes.has(i))throw new Error(`a text search provider for the scheme '${i}' is already registered`);this._textSearchUsedSchemes.add(i);const S=this._handlePool++;return this._textSearchProvider.set(S,u),this._proxy.$registerTextSearchProvider(S,this._transformScheme(i)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(i),this._textSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}registerFileSearchProvider(i,u){if(this._fileSearchUsedSchemes.has(i))throw new Error(`a file search provider for the scheme '${i}' is already registered`);this._fileSearchUsedSchemes.add(i);const S=this._handlePool++;return this._fileSearchProvider.set(S,u),this._proxy.$registerFileSearchProvider(S,this._transformScheme(i)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(i),this._fileSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(i,u,S,_){const w=n(S),d=this._fileSearchProvider.get(i);if(d)return this._fileSearchManager.fileSearch(w,d,D=>{this._proxy.$handleFileMatch(i,u,D.map(a=>a.resource))},_);throw new Error("unknown provider: "+i)}$clearCache(i){return this._fileSearchManager.clearCache(i),Promise.resolve(void 0)}$provideTextSearchResults(i,u,S,_){const w=this._textSearchProvider.get(i);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${i}`);const d=n(S);return this.createTextSearchManager(d,w).search(a=>this._proxy.$handleTextMatch(i,u,a),_)}$enableExtensionHostSearch(){}createTextSearchManager(i,u){return new N.TextSearchManager(i,u,{readdir:S=>Promise.resolve([]),toCanonicalName:S=>S},"textSearchProvider")}};v=Fe([Ne(0,y.IExtHostRpcService),Ne(1,O.IURITransformerService),Ne(2,I.ILogService)],v),e.ExtHostSearch=v;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(p),extraFileResources:s.extraFileResources&&s.extraFileResources.map(i=>R.URI.revive(i))}}e.reviveQuery=n;function p(s){return{...s,folder:R.URI.revive(s.folder)}}}),define(Ee[219],be([1,0,44,94,31,92,32,39,49,40,97,98,99,65,58,63,95,50,30,62,81,64,192,12,174]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_,w,d,D,a,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(P.ILoggerService,a.ExtHostLoggerService),(0,r.registerSingleton)(P.ILogService,c.ExtHostLogService),(0,r.registerSingleton)(i.IExtHostApiDeprecationService,i.ExtHostApiDeprecationService),(0,r.registerSingleton)(O.IExtHostCommands,O.ExtHostCommands),(0,r.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,r.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,r.registerSingleton)(v.IExtHostDebugService,v.WorkerExtHostDebugService),(0,r.registerSingleton)($.IExtHostDecorations,$.ExtHostDecorations),(0,r.registerSingleton)(I.IExtHostDocumentsAndEditors,I.ExtHostDocumentsAndEditors),(0,r.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,r.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService),(0,r.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,r.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,r.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask),(0,r.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,r.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,r.registerSingleton)(u.IExtHostWindow,u.ExtHostWindow),(0,r.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,r.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState),(0,r.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,r.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs)}),define(Ee[220],be([1,0,44,3]),function(Y,e,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,k.createDecorator)("treeViewsDragAndDropService");class b{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(y){if(y&&this._dragOperations.has(y)){const O=this._dragOperations.get(y);return this._dragOperations.delete(y),O}}addDragOperationTransfer(y,O){this._dragOperations.set(y,O)}}e.TreeViewsDragAndDropService=b,(0,r.registerSingleton)(e.ITreeViewsDragAndDropService,b)}),define(Ee[221],be([1,0,126,24,2,5,6,11,7,13,16,8,20,154,220]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function i(_,w){if((0,R.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let d;return Array.isArray(_.highlights)&&(d=_.highlights.filter(D=>D.length===2&&typeof D[0]=="number"&&typeof D[1]=="number"),d=d.length?d:void 0),{label:_.label,highlights:d}}}class u{constructor(w,d,D){this._proxy=w,this.commands=d,this.logService=D,this.treeViews=new Map,this.treeDragAndDropService=new s.TreeViewsDragAndDropService;function a(P){return P&&P.$treeViewId&&P.$treeItemHandle}d.registerArgumentProcessor({processArgument:P=>a(P)?this.convertArgument(P):Array.isArray(P)&&P.length>0?P.map(c=>a(c)?this.convertArgument(c):c):P})}registerTreeDataProvider(w,d,D){const a=this.createTreeView(w,{treeDataProvider:d},D);return{dispose:()=>a.dispose()}}createTreeView(w,d,D){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=d.dragAndDropController?.dropMimeTypes,P=d.dragAndDropController?.dragMimeTypes,c=!!d.dragAndDropController?.handleDrag,t=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,dropMimeTypes:a,dragMimeTypes:P,hasHandleDrag:c}),h=this.createExtHostTreeView(w,d,D);return{get onDidCollapseElement(){return h.onDidCollapseElement},get onDidExpandElement(){return h.onDidExpandElement},get selection(){return h.selectedElements},get onDidChangeSelection(){return h.onDidChangeSelection},get visible(){return h.visible},get onDidChangeVisibility(){return h.onDidChangeVisibility},get message(){return h.message},set message(o){h.message=o},get title(){return h.title},set title(o){h.title=o},get description(){return h.description},set description(o){h.description=o},reveal:(o,l)=>h.reveal(o,l),dispose:async()=>{await t,this.treeViews.delete(w),h.dispose()}}}$getChildren(w,d){const D=this.treeViews.get(w);return D?D.getChildren(d):Promise.reject(new Error((0,r.localize)(0,null,w)))}async $handleDrop(w,d,D,a,P,c,t){const h=this.treeViews.get(w);if(!h)return Promise.reject(new Error((0,r.localize)(1,null,w)));const o=p.TreeDataTransferConverter.toITreeDataTransfer(d);return c===w&&t&&await this.addAdditionalTransferItems(o,h,t,a,P),h.onDrop(o,D,a)}async addAdditionalTransferItems(w,d,D,a,P){const c=this.treeDragAndDropService.removeDragOperationTransfer(P);if(c)(await c)?.forEach((t,h)=>{t&&w.set(h,t)});else if(P&&d.handleDrag){const t=d.handleDrag(D,w,a);this.treeDragAndDropService.addDragOperationTransfer(P,t),await t}return w}async $handleDrag(w,d,D,a){const P=this.treeViews.get(w);if(!P)return Promise.reject(new Error((0,r.localize)(2,null,w)));const c=await this.addAdditionalTransferItems(new Map,P,d,a,D);if(!!c)return p.TreeDataTransferConverter.toTreeDataTransferDTO(c)}async $hasResolve(w){const d=this.treeViews.get(w);if(!d)throw new Error((0,r.localize)(3,null,w));return d.hasResolve}$resolve(w,d,D){const a=this.treeViews.get(w);if(!a)throw new Error((0,r.localize)(4,null,w));return a.resolveTreeItem(d,D)}$setExpanded(w,d,D){const a=this.treeViews.get(w);if(!a)throw new Error((0,r.localize)(5,null,w));a.setExpanded(d,D)}$setSelection(w,d){const D=this.treeViews.get(w);if(!D)throw new Error((0,r.localize)(6,null,w));D.setSelection(d)}$setVisible(w,d){const D=this.treeViews.get(w);if(!D)throw new Error((0,r.localize)(7,null,w));D.setVisible(d)}createExtHostTreeView(w,d,D){const a=new S(w,d,this._proxy,this.commands.converter,this.logService,D);return this.treeViews.set(w,a),a}convertArgument(w){const d=this.treeViews.get(w.$treeViewId);return d?d.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=u;class S extends y.Disposable{constructor(w,d,D,a,P,c){super();if(this.viewId=w,this.proxy=D,this.commands=a,this.logService=P,this.extension=c,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new $.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new $.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new $.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new $.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new $.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,c.contributes&&c.contributes.views)for(const o in c.contributes.views)for(const l of c.contributes.views[o])l.id===w&&(this._title=l.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(o=>this._onDidChangeData.fire({message:!1,element:o}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let t,h;this._register($.Event.debounce(this._onDidChangeData.event,(o,l)=>(o||(o={message:!1,elements:[]}),l.element!==!1&&(t||(t=new Promise(f=>h=f),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(l.element)?o.elements.push(...l.element):o.elements.push(l.element)),l.message&&(o.message=!0),o),200,!0)(({message:o,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=h;return t=null,this.refresh(l).then(()=>f())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,R.isUndefinedOrNull)(w))}async getChildren(w){const d=w?this.getExtensionElement(w):void 0;if(w&&!d)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);let D=this.getChildrenNodes(w);return D||(D=await this.fetchChildrenNodes(d)),D?D.map(a=>a.item):void 0}getExtensionElement(w){return this.elements.get(w)}reveal(w,d){d=d||{select:!0,focus:!1};const D=(0,R.isUndefinedOrNull)(d.select)?!0:d.select,a=(0,R.isUndefinedOrNull)(d.focus)?!1:d.focus,P=(0,R.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(c=>this.resolveTreeNode(w,c[c.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:c.map(h=>h.item)},{select:D,focus:a,expand:P})),c=>this.logService.error(c)):this.proxy.$reveal(this.viewId,void 0,{select:D,focus:a,expand:P})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,d){const D=this.getExtensionElement(w);D&&(d?this._onDidExpandElement.fire(Object.freeze({element:D})):this._onDidCollapseElement.fire(Object.freeze({element:D})))}setSelection(w){(0,N.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(w,d,D){const a=[];for(const P of w){const c=this.getExtensionElement(P);c&&a.push(c)}if(!(!this.dndController?.handleDrag||a.length===0))return await this.dndController.handleDrag(a,d,D),d}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(w,d,D){const a=this.getExtensionElement(d);if(!!a)return(0,O.asPromise)(()=>this.dndController?.handleDrop(w,a,D))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,d){if(!this.dataProvider.resolveTreeItem)return;const D=this.elements.get(w);if(D){const a=this.nodes.get(D);if(a){const P=await this.dataProvider.resolveTreeItem(a.extensionItem,D,d)??a.extensionItem;return a.item.tooltip=this.getTooltip(P.tooltip),a.item.command=this.getCommand(a.disposableStore,P.command),a.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(d=>d?this.resolveUnknownParentChain(d).then(D=>this.resolveTreeNode(d,D[D.length-1]).then(a=>(D.push(a),D))):Promise.resolve([]))}resolveParent(w){const d=this.nodes.get(w);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,O.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,d){const D=this.nodes.get(w);return D?Promise.resolve(D):(0,O.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(a=>this.createHandle(w,a,d,!0)).then(a=>this.getChildren(d?d.item.handle:void 0).then(()=>{const P=this.getExtensionElement(a);if(P){const c=this.nodes.get(P);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(w){if(w){let d;if(typeof w=="string"){const D=this.getExtensionElement(w);d=D?this.nodes.get(D):void 0}else d=w;return d&&d.children||void 0}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const d=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const D=w?this.nodes.get(w):void 0,a=await this.dataProvider.getChildren(w);if(d.token.isCancellationRequested)return;const P=await Promise.all((0,N.coalesce)(a||[]).map(async c=>{const t=await this.dataProvider.getTreeItem(c);return t&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(c,t,D):null}));return d.token.isCancellationRequested?void 0:(0,N.coalesce)(P)}finally{d.dispose()}}refresh(w){if(w.some(D=>!D))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const D=this.getHandlesToRefresh(w);if(D.length)return this.refreshHandles(D)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const d=new Set,D=w.map(P=>this.nodes.get(P));for(const P of D)if(P&&!d.has(P.item.handle)){let c=P;for(;c&&c.parent&&D.findIndex(t=>c&&c.parent&&t&&t.item.handle===c.parent.item.handle)===-1;){const t=this.elements.get(c.parent.item.handle);c=t?this.nodes.get(t):void 0}c&&!c.parent&&d.add(P.item.handle)}const a=[];return d.forEach(P=>{const c=this.elements.get(P);if(c){const t=this.nodes.get(c);t&&(!t.parent||!d.has(t.parent.item.handle))&&a.push(P)}}),a}refreshHandles(w){const d={};return Promise.all(w.map(D=>this.refreshNode(D).then(a=>{a&&(d[D]=a.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(w){const d=this.getExtensionElement(w);if(d){const D=this.nodes.get(d);if(D)return this.clearChildren(d),(0,O.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(a=>{if(a){const P=this.createTreeNode(d,a,D.parent);return this.updateNodeCache(d,P,D,D.parent),D.dispose(),P}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,d,D){const a=this.createTreeNode(w,d,D);if(d.id&&this.elements.has(a.item.handle))throw new Error((0,r.localize)(8,null,d.id));return this.addNodeToCache(w,a),this.addNodeToParentCache(a,D),a}getTooltip(w){return I.MarkdownString.isMarkdownString(w)?v.MarkdownString.from(w):w}getCommand(w,d){return d?this.commands.toInternal(d,w):void 0}createTreeNode(w,d,D){const a=new y.DisposableStore,P=this.createHandle(w,d,D),c=this.getLightIconPath(d);return{item:{handle:P,parentHandle:D?D.item.handle:void 0,label:i(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(a,d.command),contextValue:d.contextValue,icon:c,iconDark:this.getDarkIconPath(d)||c,themeIcon:this.getThemeIcon(d),collapsibleState:(0,R.isUndefinedOrNull)(d.collapsibleState)?I.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:D,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(w){return w.iconPath instanceof I.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:d,label:D,resourceUri:a},P,c){if(d)return`${S.ID_HANDLE_PREFIX}/${d}`;const t=i(D,this.extension),h=P?P.item.handle:S.LABEL_HANDLE_PREFIX;let o=t?t.label:a?(0,k.basename)(a):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const l=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,f=this.getChildrenNodes(P)||[];let m,E=0;do{if(m=`${h}/${E}:${o}`,c||!this.elements.has(m)||l===m)break;E++}while(E<=f.length);return m}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof I.ThemeIcon))return typeof w.iconPath=="string"||b.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof I.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return b.URI.isUri(w)?w:b.URI.file(w)}addNodeToCache(w,d){this.elements.set(d.item.handle,w),this.nodes.set(w,d)}updateNodeCache(w,d,D,a){this.elements.delete(d.item.handle),this.nodes.delete(w),d.item.handle!==D.item.handle&&this.elements.delete(D.item.handle),this.addNodeToCache(w,d);const P=this.getChildrenNodes(a)||[],c=P.filter(t=>t.item.handle===D.item.handle)[0];c&&P.splice(P.indexOf(c),1,d)}addNodeToParentCache(w,d){d?(d.children||(d.children=[]),d.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const d=this.nodes.get(w);if(d){if(d.children)for(const D of d.children){const a=this.elements.get(D.item.handle);a&&this.clear(a)}d.children=void 0}}else this.clearAll()}clear(w){const d=this.nodes.get(w);if(d){if(d.children)for(const D of d.children){const a=this.elements.get(D.item.handle);a&&this.clear(a)}this.nodes.delete(w),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(Ee[222],be([1,0,20,15,5,34,2,115,234,110,72,46,4,91,179,178,39,180,32,181,182,183,167,184,49,33,185,186,189,191,193,94,169,198,199,200,65,40,202,221,8,7,205,51,95,31,68,156,188,80,92,97,98,99,12,59,14,28,194,152,58,63,176,203,151,66,50,208,206,207,177,30,201,204,62,64,81,196,96,197,9,77,195,149,187,6,27,158]),function(Y,e,r,k,b,$,y,O,I,R,N,v,n,p,s,i,u,S,_,w,d,D,a,P,c,t,h,o,l,f,m,E,T,A,x,g,U,z,q,j,J,V,ie,ae,te,ue,fe,Se,ge,ne,me,Ie,Ae,Ue,Ke,pe,de,L,F,C,M,H,X,re,ve,ke,Me,Le,ze,Be,Oe,Xe,tt,Te,et,G,Q,ce,Re,xe,Ge,Je,at,yt,Dt,Ot,Ve,gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(it){const ot=it.get(L.IExtHostInitDataService),It=it.get(Xe.IExtHostFileSystemInfo),Pt=it.get(Me.IExtHostConsumerFileSystem),kt=it.get(t.IExtHostExtensionService),lt=it.get(ue.IExtHostWorkspace),Ft=it.get(Q.IExtHostTelemetry),Lt=it.get(_.IExtHostConfiguration),he=it.get(pe.IURITransformerService),le=it.get(de.IExtHostRpcService),oe=it.get(U.IExtHostStorage),K=it.get(ke.IExtensionStoragePaths),_e=it.get(Ke.ILoggerService),Ce=it.get(Ke.ILogService),$e=it.get(M.IExtHostTunnelService),We=it.get(H.IExtHostApiDeprecationService),nt=it.get(te.IExtHostWindow),pt=it.get(et.IExtHostSecretState),wt=it.get(G.IExtHostEditorTabs);le.set(n.ExtHostContext.ExtHostFileSystemInfo,It),le.set(n.ExtHostContext.ExtHostLogLevelServiceShape,_e),le.set(n.ExtHostContext.ExtHostWorkspace,lt),le.set(n.ExtHostContext.ExtHostConfiguration,Lt),le.set(n.ExtHostContext.ExtHostExtensionService,kt),le.set(n.ExtHostContext.ExtHostStorage,oe),le.set(n.ExtHostContext.ExtHostTunnelService,$e),le.set(n.ExtHostContext.ExtHostWindow,nt),le.set(n.ExtHostContext.ExtHostSecretState,pt),le.set(n.ExtHostContext.ExtHostTelemetry,Ft),le.set(n.ExtHostContext.ExtHostEditorTabs,wt);const vt=le.set(n.ExtHostContext.ExtHostDecorations,it.get(me.IExtHostDecorations)),dt=le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,it.get(c.IExtHostDocumentsAndEditors)),rt=le.set(n.ExtHostContext.ExtHostCommands,it.get(u.IExtHostCommands)),Et=le.set(n.ExtHostContext.ExtHostTerminalService,it.get(z.IExtHostTerminalService)),ft=le.set(n.ExtHostContext.ExtHostDebugService,it.get(Ae.IExtHostDebugService)),Mt=le.set(n.ExtHostContext.ExtHostSearch,it.get(Ue.IExtHostSearch)),ct=le.set(n.ExtHostContext.ExtHostTask,it.get(Ie.IExtHostTask)),Ct=le.set(n.ExtHostContext.ExtHostOutputService,it.get(E.IExtHostOutputService)),Ut=le.set(n.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(le)),bt=le.set(n.ExtHostContext.ExtHostDocuments,new P.ExtHostDocuments(le,dt)),Bt=le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new D.ExtHostDocumentContentProvider(le,dt,Ce)),Wt=le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(Ce,bt,le.getProxy(n.MainContext.MainThreadBulkEdits))),ht=le.set(n.ExtHostContext.ExtHostNotebook,new F.ExtHostNotebookController(le,rt,dt,bt,K)),ei=le.set(n.ExtHostContext.ExtHostNotebookDocuments,new yt.ExtHostNotebookDocuments(Ce,ht)),Yt=le.set(n.ExtHostContext.ExtHostNotebookEditors,new at.ExtHostNotebookEditors(Ce,le,ht)),ti=le.set(n.ExtHostContext.ExtHostNotebookKernels,new ce.ExtHostNotebookKernels(le,ot,ht,rt,Ce)),oi=le.set(n.ExtHostContext.ExtHostNotebookRenderers,new xe.ExtHostNotebookRenderers(le,ht)),Tt=le.set(n.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(le,dt)),ii=le.set(n.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews(le.getProxy(n.MainContext.MainThreadTreeViews),rt,Ce)),_i=le.set(n.ExtHostContext.ExtHostEditorInsets,new Se.ExtHostEditorInsets(le.getProxy(n.MainContext.MainThreadEditorInsets),Tt,ot)),Gt=le.set(n.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(le,Ce,It)),Xt=le.set(n.ExtHostContext.ExtHostLanguages,new f.ExtHostLanguages(le,bt,rt.converter,he)),st=le.set(n.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(le,he,bt,rt,Gt,Ce,We)),ai=le.set(n.ExtHostContext.ExtHostFileSystem,new h.ExtHostFileSystem(le,st)),Vt=le.set(n.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(le,Ce,dt)),jt=le.set(n.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(le,lt,rt)),ni=le.set(n.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(le,rt,Ce)),Si=le.set(n.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(le,rt,bt)),gi=le.set(n.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(le.getProxy(n.MainContext.MainThreadProgress))),yi=le.set(n.ExtHostContext.ExtHosLabelService,new ge.ExtHostLabelService(le)),pi=le.set(n.ExtHostContext.ExtHostTheming,new C.ExtHostTheming(le)),ri=le.set(n.ExtHostContext.ExtHostAuthentication,new X.ExtHostAuthentication(le)),li=le.set(n.ExtHostContext.ExtHostTimeline,new re.ExtHostTimeline(le,rt)),Jt=le.set(n.ExtHostContext.ExtHostWebviews,new ae.ExtHostWebviews(le,{remote:ot.remote},lt,Ce,We)),ci=le.set(n.ExtHostContext.ExtHostWebviewPanels,new Be.ExtHostWebviewPanels(le,Jt,lt)),Di=le.set(n.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(le,bt,K,Jt,ci)),Ci=le.set(n.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(le,Jt)),$t=le.set(n.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(le,rt)),Ii=le.set(n.ExtHostContext.ExtHostUriOpeners,new Te.ExtHostUriOpeners(le));le.set(n.ExtHostContext.ExtHostInteractive,new Dt.ExtHostInteractive(le,ht,dt,rt));const ki=(0,fe.values)(n.ExtHostContext);le.assertRegistered(ki);const Ti=new Oe.ExtHostBulkEdits(le,dt),ui=new i.ExtHostClipboard(le),di=new m.ExtHostMessageService(le,Ce),Qt=new d.ExtHostDialogs(le),Ht=new g.ExtHostStatusBar(le,rt.converter);return s.ExtHostApiCommands.register(rt),function(Pe,Rt,Zt){const ut=function(){let Z=!Pe.isUnderDevelopment;function se(){Z||(Ce.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function ye(Qe){if(Array.isArray(Qe))Qe.forEach(ye);else if(typeof Qe=="string")se();else{const mt=Qe;typeof mt.scheme=="undefined"&&se(),typeof mt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Pe,"documentFiltersExclusive")}return Qe}}(),Pi={getSession(Z,se,ye){return ri.getSession(Pe,Z,se,ye)},async hasSession(Z,se){return(0,Ve.checkProposedApiEnabled)(Pe,"authSession"),!!await ri.getSession(Pe,Z,se,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(Z,se,ye,Qe){return ri.registerAuthenticationProvider(Z,se,ye,Qe)}},Ai={registerCommand(Z,se,ye){return rt.registerCommand(!0,Z,se,ye,void 0,Pe)},registerTextEditorCommand(Z,se,ye){return rt.registerCommand(!0,Z,(...Qe)=>{const mt=Tt.getActiveTextEditor();if(!mt){Ce.warn("Cannot execute "+Z+" because there is no active text editor.");return}return mt.edit(St=>{se.apply(ye,[mt,St,...Qe])}).then(St=>{St||Ce.warn("Edits from command "+Z+" were not applied.")},St=>{Ce.warn("An error occurred while running command "+Z,St)})},void 0,void 0,Pe)},registerDiffInformationCommand:(Z,se,ye)=>((0,Ve.checkProposedApiEnabled)(Pe,"diffCommand"),rt.registerCommand(!0,Z,async(...Qe)=>{const mt=dt.activeEditor(!0);if(!mt){Ce.warn("Cannot execute "+Z+" because there is no active text editor.");return}const St=await Tt.getDiffInformation(mt.id);se.apply(ye,[St,...Qe])},void 0,void 0,Pe)),executeCommand(Z,...se){return rt.executeCommand(Z,...se)},getCommands(Z=!1){return rt.getCommands(Z)}},vi={get machineId(){return ot.telemetryInfo.machineId},get sessionId(){return ot.telemetryInfo.sessionId},get language(){return ot.environment.appLanguage},get appName(){return ot.environment.appName},get appRoot(){return ot.environment.appRoot?.fsPath??""},get appHost(){return ot.environment.appHost},get uriScheme(){return ot.environment.appUriScheme},get clipboard(){return ui.value},get shell(){return Et.getDefaultShell(!1)},get isTelemetryEnabled(){return Ft.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ft.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Pe,"telemetry"),Ft.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Pe,"telemetry"),Ft.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const Z=Date.now()-new Date(ot.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,se){return nt.openUri(Z,{allowTunneling:!!ot.remote.authority,allowContributedOpeners:se?.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===ot.environment.appUriScheme)return Ut.createAppUri(Z);try{return await nt.asExternalUri(Z,{allowTunneling:!!ot.remote.authority})}catch(se){if((0,Je.matchesScheme)(Z,Ge.Schemas.http)||(0,Je.matchesScheme)(Z,Ge.Schemas.https))return Z;throw se}},get remoteName(){return(0,ne.getRemoteName)(ot.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),ot.remote.authority},get uiKind(){return ot.uiKind}};ot.environment.extensionTestsLocationURI||Object.freeze(vi);const Ei=ot.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,Ri={createTestController(Z,se,ye){return ye&&(0,Ve.checkProposedApiEnabled)(Pe,"testRefresh"),$t.createTestController(Z,se,ye)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.createTestObserver()},runTests(Z){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.runTests(Z)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Pe,"testObserver"),$t.results}},Oi={getExtension(Z){const se=Rt.getExtensionDescription(Z);if(se)return new t.Extension(kt,Pe.identifier,se,Ei)},get all(){return Rt.getAllExtensionDescriptions().map(Z=>new t.Extension(kt,Pe.identifier,Z,Ei))},get onDidChange(){return Rt.onDidChange}},hi={createDiagnosticCollection(Z){return Gt.createDiagnosticCollection(Pe.identifier,Z)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:Z=>Gt.getDiagnostics(Z),getLanguages(){return Xt.getLanguages()},setTextDocumentLanguage(Z,se){return Xt.changeLanguage(Z.uri,se)},match(Z,se){return(0,N.score)(J.LanguageSelector.from(Z),se.uri,se.languageId,!0)},registerCodeActionsProvider(Z,se,ye){return st.registerCodeActionProvider(Pe,ut(Z),se,ye)},registerCodeLensProvider(Z,se){return st.registerCodeLensProvider(Pe,ut(Z),se)},registerDefinitionProvider(Z,se){return st.registerDefinitionProvider(Pe,ut(Z),se)},registerDeclarationProvider(Z,se){return st.registerDeclarationProvider(Pe,ut(Z),se)},registerImplementationProvider(Z,se){return st.registerImplementationProvider(Pe,ut(Z),se)},registerTypeDefinitionProvider(Z,se){return st.registerTypeDefinitionProvider(Pe,ut(Z),se)},registerHoverProvider(Z,se){return st.registerHoverProvider(Pe,ut(Z),se,Pe.identifier)},registerEvaluatableExpressionProvider(Z,se){return st.registerEvaluatableExpressionProvider(Pe,ut(Z),se,Pe.identifier)},registerInlineValuesProvider(Z,se){return st.registerInlineValuesProvider(Pe,ut(Z),se,Pe.identifier)},registerDocumentHighlightProvider(Z,se){return st.registerDocumentHighlightProvider(Pe,ut(Z),se)},registerLinkedEditingRangeProvider(Z,se){return st.registerLinkedEditingRangeProvider(Pe,ut(Z),se)},registerReferenceProvider(Z,se){return st.registerReferenceProvider(Pe,ut(Z),se)},registerRenameProvider(Z,se){return st.registerRenameProvider(Pe,ut(Z),se)},registerDocumentSymbolProvider(Z,se,ye){return st.registerDocumentSymbolProvider(Pe,ut(Z),se,ye)},registerWorkspaceSymbolProvider(Z){return st.registerWorkspaceSymbolProvider(Pe,Z)},registerDocumentFormattingEditProvider(Z,se){return st.registerDocumentFormattingEditProvider(Pe,ut(Z),se)},registerDocumentRangeFormattingEditProvider(Z,se){return st.registerDocumentRangeFormattingEditProvider(Pe,ut(Z),se)},registerOnTypeFormattingEditProvider(Z,se,ye,...Qe){return st.registerOnTypeFormattingEditProvider(Pe,ut(Z),se,[ye].concat(Qe))},registerDocumentSemanticTokensProvider(Z,se,ye){return st.registerDocumentSemanticTokensProvider(Pe,ut(Z),se,ye)},registerDocumentRangeSemanticTokensProvider(Z,se,ye){return st.registerDocumentRangeSemanticTokensProvider(Pe,ut(Z),se,ye)},registerSignatureHelpProvider(Z,se,ye,...Qe){return typeof ye=="object"?st.registerSignatureHelpProvider(Pe,ut(Z),se,ye):st.registerSignatureHelpProvider(Pe,ut(Z),se,typeof ye=="undefined"?[]:[ye,...Qe])},registerCompletionItemProvider(Z,se,...ye){return st.registerCompletionItemProvider(Pe,ut(Z),se,ye)},registerInlineCompletionItemProvider(Z,se){return(0,Ve.checkProposedApiEnabled)(Pe,"inlineCompletions"),st.registerInlineCompletionsProvider(Pe,ut(Z),se)},registerDocumentLinkProvider(Z,se){return st.registerDocumentLinkProvider(Pe,ut(Z),se)},registerColorProvider(Z,se){return st.registerColorProvider(Pe,ut(Z),se)},registerFoldingRangeProvider(Z,se){return st.registerFoldingRangeProvider(Pe,ut(Z),se)},registerSelectionRangeProvider(Z,se){return st.registerSelectionRangeProvider(Pe,Z,se)},registerCallHierarchyProvider(Z,se){return st.registerCallHierarchyProvider(Pe,Z,se)},registerTypeHierarchyProvider(Z,se){return st.registerTypeHierarchyProvider(Pe,Z,se)},setLanguageConfiguration:(Z,se)=>st.setLanguageConfiguration(Pe,Z,se),getTokenInformationAtPosition(Z,se){return(0,Ve.checkProposedApiEnabled)(Pe,"tokenInformation"),Xt.tokenAtPosition(Z,se)},registerInlayHintsProvider(Z,se){return(0,Ve.checkProposedApiEnabled)(Pe,"inlayHints"),st.registerInlayHintsProvider(Pe,Z,se)},createLanguageStatusItem(Z,se){return(0,Ve.checkProposedApiEnabled)(Pe,"languageStatus"),Xt.createLanguageStatusItem(Pe,Z,se)}},Fi={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(Z,se,ye){const Qe=await(y.URI.isUri(Z)?Promise.resolve(bi.openTextDocument(Z)):Promise.resolve(Z));return Tt.showTextDocument(Qe,se,ye)},createTextEditorDecorationType(Z){return Tt.createTextEditorDecorationType(Pe,Z)},onDidChangeActiveTextEditor(Z,se,ye){return Tt.onDidChangeActiveTextEditor(Z,se,ye)},onDidChangeVisibleTextEditors(Z,se,ye){return Tt.onDidChangeVisibleTextEditors(Z,se,ye)},onDidChangeTextEditorSelection(Z,se,ye){return Tt.onDidChangeTextEditorSelection(Z,se,ye)},onDidChangeTextEditorOptions(Z,se,ye){return Tt.onDidChangeTextEditorOptions(Z,se,ye)},onDidChangeTextEditorVisibleRanges(Z,se,ye){return Tt.onDidChangeTextEditorVisibleRanges(Z,se,ye)},onDidChangeTextEditorViewColumn(Z,se,ye){return Tt.onDidChangeTextEditorViewColumn(Z,se,ye)},onDidCloseTerminal(Z,se,ye){return Et.onDidCloseTerminal(Z,se,ye)},onDidOpenTerminal(Z,se,ye){return Et.onDidOpenTerminal(Z,se,ye)},onDidChangeActiveTerminal(Z,se,ye){return Et.onDidChangeActiveTerminal(Z,se,ye)},onDidChangeTerminalDimensions(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"terminalDimensions"),Et.onDidChangeTerminalDimensions(Z,se,ye)},onDidChangeTerminalState(Z,se,ye){return Et.onDidChangeTerminalState(Z,se,ye)},onDidWriteTerminalData(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"terminalDataWriteEvent"),Et.onDidWriteTerminalData(Z,se,ye)},get state(){return nt.state},onDidChangeWindowState(Z,se,ye){return nt.onDidChangeWindowState(Z,se,ye)},showInformationMessage(Z,...se){return di.showMessage(Pe,$.default.Info,Z,se[0],se.slice(1))},showWarningMessage(Z,...se){return di.showMessage(Pe,$.default.Warning,Z,se[0],se.slice(1))},showErrorMessage(Z,...se){return di.showMessage(Pe,$.default.Error,Z,se[0],se.slice(1))},showQuickPick(Z,se,ye){return jt.showQuickPick(Z,se,ye)},showWorkspaceFolderPick(Z){return jt.showWorkspaceFolderPick(Z)},showInputBox(Z,se){return jt.showInput(Z,se)},showOpenDialog(Z){return Qt.showOpenDialog(Z)},showSaveDialog(Z){return Qt.showSaveDialog(Z)},createStatusBarItem(Z,se,ye){let Qe,mt,St;return typeof Z=="string"?(Qe=Z,mt=se,St=ye):(mt=Z,St=se),Ht.createStatusBarEntry(Pe,Qe,mt,St)},setStatusBarMessage(Z,se){return Ht.setStatusBarMessage(Z,se)},withScmProgress(Z){return We.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),gi.withProgress(Pe,{location:V.ProgressLocation.SourceControl},(se,ye)=>Z({report(Qe){}}))},withProgress(Z,se){return gi.withProgress(Pe,Z,se)},createOutputChannel(Z){return Ct.createOutputChannel(Z,Pe)},createWebviewPanel(Z,se,ye,Qe){return ci.createWebviewPanel(Pe,Z,se,ye,Qe)},createWebviewTextEditorInset(Z,se,ye,Qe){return(0,Ve.checkProposedApiEnabled)(Pe,"editorInsets"),_i.createWebviewEditorInset(Z,se,ye,Qe,Pe)},createTerminal(Z,se,ye){return Z&&typeof Z=="object"&&"disablePersistence"in Z&&(0,Ve.checkProposedApiEnabled)(Pe,"terminalDisablePersistence"),typeof Z=="object"?"pty"in Z?Et.createExtensionTerminal(Z):Et.createTerminalFromOptions(Z):Et.createTerminal(Z,se,ye)},registerTerminalLinkProvider(Z){return Et.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,se){return Et.registerProfileProvider(Pe,Z,se)},registerTreeDataProvider(Z,se){return ii.registerTreeDataProvider(Z,se,Pe)},createTreeView(Z,se){return ii.createTreeView(Z,se,Pe)},registerWebviewPanelSerializer:(Z,se)=>ci.registerWebviewPanelSerializer(Pe,Z,se),registerCustomEditorProvider:(Z,se,ye={})=>Di.registerCustomEditorProvider(Pe,Z,se,ye),registerFileDecorationProvider(Z){return vt.registerFileDecorationProvider(Z,Pe.identifier)},registerUriHandler(Z){return Ut.registerUriHandler(Pe.identifier,Z)},createQuickPick(){return jt.createQuickPick(Pe)},createInputBox(){return jt.createInputBox(Pe.identifier)},get activeColorTheme(){return pi.activeColorTheme},onDidChangeActiveColorTheme(Z,se,ye){return pi.onDidChangeActiveColorTheme(Z,se,ye)},registerWebviewViewProvider(Z,se,ye){return Ci.registerWebviewViewProvider(Pe,Z,se,ye?.webviewOptions)},get activeNotebookEditor(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ht.onDidChangeActiveNotebookEditor(Z,se,ye)},get visibleNotebookEditors(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),Yt.onDidChangeNotebookEditorSelection(Z,se,ye)},onDidChangeNotebookEditorVisibleRanges(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),Yt.onDidChangeNotebookEditorVisibleRanges(Z,se,ye)},showNotebookDocument(Z,se){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ht.showNotebookDocument(Z,se)},registerExternalUriOpener(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"externalUriOpener"),Ii.registerExternalUriOpener(Pe.identifier,Z,se,ye)},get tabs(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),wt.tabs},get activeTab(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),wt.activeTab},get onDidChangeTabs(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),wt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,Ve.checkProposedApiEnabled)(Pe,"tabs"),wt.onDidChangeActiveTab},getInlineCompletionItemController(Z){return(0,Ve.checkProposedApiEnabled)(Pe,"inlineCompletions"),l.InlineCompletionController.get(Z)}},bi={get rootPath(){return We.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),lt.getPath()},set rootPath(Z){throw k.readonly()},getWorkspaceFolder(Z){return lt.getWorkspaceFolder(Z)},get workspaceFolders(){return lt.getWorkspaceFolders()},get name(){return lt.name},set name(Z){throw k.readonly()},get workspaceFile(){return lt.workspaceFile},set workspaceFile(Z){throw k.readonly()},updateWorkspaceFolders:(Z,se,...ye)=>lt.updateWorkspaceFolders(Pe,Z,se||0,...ye),onDidChangeWorkspaceFolders:function(Z,se,ye){return lt.onDidChangeWorkspace(Z,se,ye)},asRelativePath:(Z,se)=>lt.getRelativePath(Z,se),findFiles:(Z,se,ye,Qe)=>lt.findFiles(Z,se,ye,Pe.identifier,Qe),findTextInFiles:(Z,se,ye,Qe)=>{(0,Ve.checkProposedApiEnabled)(Pe,"findTextInFiles");let mt,St;return typeof se=="object"?(mt=se,St=ye):(mt={},St=se,Qe=ye),lt.findTextInFiles(Z,mt||{},St,Pe.identifier,Qe)},saveAll:Z=>lt.saveAll(Z),applyEdit(Z){return Ti.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,se,ye,Qe)=>Vt.createFileSystemWatcher(lt,Pe,Z,se,ye,Qe),get textDocuments(){return bt.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw k.readonly()},openTextDocument(Z){let se;const ye=Z;if(typeof Z=="string")se=Promise.resolve(y.URI.file(Z));else if(y.URI.isUri(Z))se=Promise.resolve(Z);else if(!ye||typeof ye=="object")se=bt.createDocumentData(ye);else throw new Error("illegal argument - uriOrFileNameOrOptions");return se.then(Qe=>bt.ensureDocumentData(Qe).then(mt=>mt.document))},onDidOpenTextDocument:(Z,se,ye)=>bt.onDidAddDocument(Z,se,ye),onDidCloseTextDocument:(Z,se,ye)=>bt.onDidRemoveDocument(Z,se,ye),onDidChangeTextDocument:(Z,se,ye)=>bt.onDidChangeDocument(Z,se,ye),onDidSaveTextDocument:(Z,se,ye)=>bt.onDidSaveDocument(Z,se,ye),onWillSaveTextDocument:(Z,se,ye)=>Wt.getOnWillSaveTextDocumentEvent(Pe)(Z,se,ye),get notebookDocuments(){return ht.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,se){let ye;if(y.URI.isUri(Z))ye=Z,await ht.openNotebookDocument(Z);else if(typeof Z=="string")ye=y.URI.revive(await ht.createNotebookDocument({viewType:Z,content:se}));else throw new Error("Invalid arguments");return ht.getNotebookDocument(ye).apiNotebook},get onDidOpenNotebookDocument(){return ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ht.onDidCloseNotebookDocument},registerNotebookSerializer(Z,se,ye,Qe){return ht.registerNotebookSerializer(Pe,Z,se,ye,(0,Ve.isProposedApiEnabled)(Pe,"notebookLiveShare")?Qe:void 0)},registerNotebookContentProvider:(Z,se,ye,Qe)=>((0,Ve.checkProposedApiEnabled)(Pe,"notebookContentProvider"),ht.registerNotebookContentProvider(Pe,Z,se,ye,(0,Ve.isProposedApiEnabled)(Pe,"notebookLiveShare")?Qe:void 0)),onDidChangeConfiguration:(Z,se,ye)=>Zt.onDidChangeConfiguration(Z,se,ye),getConfiguration(Z,se){return se=arguments.length===1?void 0:se,Zt.getConfiguration(Z,se,Pe)},registerTextDocumentContentProvider(Z,se){return Bt.registerTextDocumentContentProvider(Z,se)},registerTaskProvider:(Z,se)=>(We.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),ct.registerTaskProvider(Pe,Z,se)),registerFileSystemProvider(Z,se,ye){return(0,Ot.combinedDisposable)(ai.registerFileSystemProvider(Pe,Z,se,ye),Pt.addFileSystemProvider(Z,se))},get fs(){return Pt.value},registerFileSearchProvider:(Z,se)=>((0,Ve.checkProposedApiEnabled)(Pe,"fileSearchProvider"),Mt.registerFileSearchProvider(Z,se)),registerTextSearchProvider:(Z,se)=>((0,Ve.checkProposedApiEnabled)(Pe,"textSearchProvider"),Mt.registerTextSearchProvider(Z,se)),registerRemoteAuthorityResolver:(Z,se)=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),kt.registerRemoteAuthorityResolver(Z,se)),registerResourceLabelFormatter:Z=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),yi.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,se,ye)=>Vt.onDidCreateFile(Z,se,ye),onDidDeleteFiles:(Z,se,ye)=>Vt.onDidDeleteFile(Z,se,ye),onDidRenameFiles:(Z,se,ye)=>Vt.onDidRenameFile(Z,se,ye),onWillCreateFiles:(Z,se,ye)=>Vt.getOnWillCreateFileEvent(Pe)(Z,se,ye),onWillDeleteFiles:(Z,se,ye)=>Vt.getOnWillDeleteFileEvent(Pe)(Z,se,ye),onWillRenameFiles:(Z,se,ye)=>Vt.getOnWillRenameFileEvent(Pe)(Z,se,ye),openTunnel:Z=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),$e.openTunnel(Pe,Z).then(se=>{if(!se)throw new Error("cannot open tunnel");return se})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),$e.getTunnels()},onDidChangeTunnels:(Z,se,ye)=>((0,Ve.checkProposedApiEnabled)(Pe,"resolvers"),$e.onDidChangeTunnels(Z,se,ye)),registerPortAttributesProvider:(Z,se)=>((0,Ve.checkProposedApiEnabled)(Pe,"portsAttributes"),$e.registerPortsAttributesProvider(Z,se)),registerTimelineProvider:(Z,se)=>((0,Ve.checkProposedApiEnabled)(Pe,"timeline"),li.registerTimelineProvider(Z,se,Pe.identifier,rt.converter)),get isTrusted(){return lt.trusted},requestWorkspaceTrust:Z=>((0,Ve.checkProposedApiEnabled)(Pe,"workspaceTrust"),lt.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,se,ye)=>lt.onDidGrantWorkspaceTrust(Z,se,ye)},Mi={get inputBox(){return We.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Pe)},createSourceControl(Z,se,ye){return ni.createSourceControl(Pe,Z,se,ye)}},Ni={createCommentController(Z,se){return Si.createCommentController(Pe,Z,se)}},Li={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(Z,se,ye){return ft.onDidStartDebugSession(Z,se,ye)},onDidTerminateDebugSession(Z,se,ye){return ft.onDidTerminateDebugSession(Z,se,ye)},onDidChangeActiveDebugSession(Z,se,ye){return ft.onDidChangeActiveDebugSession(Z,se,ye)},onDidReceiveDebugSessionCustomEvent(Z,se,ye){return ft.onDidReceiveDebugSessionCustomEvent(Z,se,ye)},onDidChangeBreakpoints(Z,se,ye){return ft.onDidChangeBreakpoints(Z,se,ye)},registerDebugConfigurationProvider(Z,se,ye){return ft.registerDebugConfigurationProvider(Z,se,ye||gt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,se){return ft.registerDebugAdapterDescriptorFactory(Pe,Z,se)},registerDebugAdapterTrackerFactory(Z,se){return ft.registerDebugAdapterTrackerFactory(Z,se)},startDebugging(Z,se,ye){return!ye||typeof ye=="object"&&"configuration"in ye?ft.startDebugging(Z,se,{parentSession:ye}):ft.startDebugging(Z,se,ye||{})},stopDebugging(Z){return ft.stopDebugging(Z)},addBreakpoints(Z){return ft.addBreakpoints(Z)},removeBreakpoints(Z){return ft.removeBreakpoints(Z)},asDebugSourceUri(Z,se){return ft.asDebugSourceUri(Z,se)}},Ui={registerTaskProvider:(Z,se)=>ct.registerTaskProvider(Pe,Z,se),fetchTasks:Z=>ct.fetchTasks(Z),executeTask:Z=>ct.executeTask(Pe,Z),get taskExecutions(){return ct.taskExecutions},onDidStartTask:(Z,se,ye)=>ct.onDidStartTask(Z,se,ye),onDidEndTask:(Z,se,ye)=>ct.onDidEndTask(Z,se,ye),onDidStartTaskProcess:(Z,se,ye)=>ct.onDidStartTaskProcess(Z,se,ye),onDidEndTaskProcess:(Z,se,ye)=>ct.onDidEndTaskProcess(Z,se,ye)},Bi={createNotebookController(Z,se,ye,Qe,mt){return ti.createNotebookController(Pe,Z,se,ye,Qe,(0,Ve.isProposedApiEnabled)(Pe,"notebookMessaging")?mt:void 0)},registerNotebookCellStatusBarItemProvider:(Z,se)=>ht.registerNotebookCellStatusBarItemProvider(Pe,Z,se),get onDidSaveNotebookDocument(){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Z){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditorDecorationType"),Yt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return oi.createRendererMessaging(Pe,Z)},onDidChangeNotebookDocumentMetadata(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(Z,se,ye)},onDidChangeNotebookCells(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ht.onDidChangeNotebookCells(Z,se,ye)},onDidChangeNotebookCellExecutionState(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(Z,se,ye)},onDidChangeCellOutputs(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ht.onDidChangeCellOutputs(Z,se,ye)},onDidChangeCellMetadata(Z,se,ye){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookEditor"),ht.onDidChangeCellMetadata(Z,se,ye)},createConcatTextDocument(Z,se){return(0,Ve.checkProposedApiEnabled)(Pe,"notebookConcatTextDocument"),new ve.ExtHostNotebookConcatDocument(ht,bt,Z,se)}};return{version:ot.version,authentication:Pi,commands:Ai,comments:Ni,debug:Li,env:vi,extensions:Oi,languages:hi,notebooks:Bi,scm:Mi,tasks:Ui,tests:Ri,window:Fi,workspace:bi,Breakpoint:V.Breakpoint,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:gt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:b.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestions,Hover:V.Hover,IndentAction:R.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:I.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,TextEditorCursorStyle:O.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:p.UIKind,Uri:y.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Re.TextSearchCompleteMessageType,TreeDataTransfer:V.TreeDataTransfer,TreeDataTransferItem:V.TreeDataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Nt}),define(Ee[223],be([1,0,222,33,216,7,11,4,9]),function(Y,e,r,k,b,$,y,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class R extends b.RequireInterceptor{_installInterceptor(){}getModule(s,i){for(let u of this._alternatives){let S=u(s);if(S){s=S;break}}if(this._factories.has(s))return this._factories.get(s).load(s,i,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=$.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(O.MainContext.MainThreadConsole);n(s,this._initData.environment.isExtensionDevelopmentDebug);const i=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,i,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,i,u){i=i.with({path:v(i.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const S=await fetch(I.FileAccess.asBrowserUri(i).toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),S.status!==200)throw new Error(S.statusText);const _=await S.text(),w=`${i.toString(!0)}#vscode-extension`,d=`${_}
//# sourceURL=${w}`;let D;try{D=new Function("module","exports","require",d)}catch(t){throw console.error(s?`Loading code for extension ${s.value} failed: ${t.message}`:`Loading code failed: ${t.message}`),console.error(`${i.toString(!0)}${typeof t.line=="number"?` line ${t.line}`:""}${typeof t.column=="number"?` column ${t.column}`:""}`),console.error(t),t}const a={},P={exports:a},c=t=>{const h=this._fakeModules.getModule(t,i);if(h===void 0)throw new Error(`Cannot load module '${t}'`);return h};try{return u.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),D(P,a,c),P.exports!==a?P.exports:a}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),u.codeLoadingStop()}}async $setRemoteEnvironment(s){}async _waitForDebuggerAttachment(s=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const i=Date.now()+s;for(;Date.now()<i&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}e.ExtHostExtensionService=N;function v(p,s){return p.endsWith(s)?p:p+s}function n(p,s){i("info","log"),i("log","log"),i("warn","warn"),i("error","error");function i(_,w){const d=console[_];console[_]=function(){p.$logExtensionHostMessage({type:"__$console",severity:w,arguments:S(arguments)}),s&&d.apply(console,arguments)}}const u=1e5;function S(_){const w=[],d=[];if(_.length)for(let D=0;D<_.length;D++){if(typeof _[D]=="undefined")_[D]="undefined";else if(_[D]instanceof Error){const a=_[D];a.stack?_[D]=a.stack:_[D]=a.toString()}d.push(_[D])}try{const D=JSON.stringify(d,function(a,P){if(P&&typeof P=="object"){if(w.indexOf(P)!==-1)return"[Circular]";w.push(P)}return P});return D.length>u?"Output omitted for a large object that exceeds the limits":D}catch(D){return`Output omitted for an object that cannot be inspected ('${D.toString()}')`}}}}),define(Ee[224],be([1,0,44,33,66,223]),function(Y,e,r,k,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(k.IExtHostExtensionService,$.ExtHostExtensionService),(0,r.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths)}),define(Ee[235],be([1,0,21,5,91,217,210,17,67,9,2,219,224]),function(Y,e,r,k,b,$,y,O,I,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const v=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const p=fetch.bind(self);if(self.fetch=function(w,d){return w instanceof Request||/^file:/i.test(String(w))&&(w=R.FileAccess.asBrowserUri(N.URI.parse(String(w))).toString(!0)),p(w,d)},self.XMLHttpRequest=class extends XMLHttpRequest{open(w,d,D,a,P){return/^file:/i.test(d.toString())&&(d=R.FileAccess.asBrowserUri(N.URI.parse(d.toString())).toString(!0)),super.open(w,d,D??!0,a,P)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const w=self.Worker;Worker=function(d,D){/^file:/i.test(d.toString())&&(d=R.FileAccess.asBrowserUri(N.URI.parse(d.toString())).toString(!0));const P=`(${function(o){function l(E){return typeof E=="string"||E instanceof URL?String(E).replace(/^file:\/\//i,"vscode-file://vscode-app"):E}const f=fetch.bind(self);self.fetch=function(E,T){return E instanceof Request?f(E,T):f(l(E),T)},self.XMLHttpRequest=class extends XMLHttpRequest{open(E,T,A,x,g){return super.open(E,l(T),A??!0,x,g)}};const m=importScripts.bind(self);self.importScripts=(...E)=>{m(...E.map(l))},m(o)}.toString()}('${d}'))`;D=D||{},D.name=D.name||O.basename(d.toString());const c=new Blob([P],{type:"application/javascript"}),t=URL.createObjectURL(c);return new w(t,D)}}else self.Worker=class extends y.NestedWorker{constructor(w,d){super(n,w,{name:O.basename(w.toString()),...d})}};const s=new class{constructor(){this.pid=void 0}exit(w){v()}async exists(w){return!0}async realpath(w){return w}};class i{constructor(){const d=new MessageChannel,D=new k.Emitter;let a=!1;n(d.port2,[d.port2]),d.port1.onmessage=P=>{const{data:c}=P;if(!(c instanceof ArrayBuffer)){console.warn("UNKNOWN data received",c);return}const t=r.VSBuffer.wrap(new Uint8Array(c,0,c.byteLength));if((0,b.isMessageOfType)(t,2)){a=!0,S("received terminate message from renderer");return}D.fire(t)},this.protocol={onMessage:D.event,send:P=>{if(!a){const c=P.buffer.buffer.slice(P.buffer.byteOffset,P.buffer.byteOffset+P.buffer.byteLength);d.port1.postMessage(c,[c])}}}}}function u(w){return new Promise(d=>{const D=w.onMessage(a=>{D.dispose();const P=JSON.parse(a.toString());w.send((0,b.createMessageOfType)(0)),d({protocol:w,initData:P})});w.send((0,b.createMessageOfType)(1))})}let S=w=>v();function _(){I.mark("code/extHost/willConnectToRenderer");const w=new i;return{onmessage(d){u(w.protocol).then(D=>{I.mark("code/extHost/didWaitForInitData");const a=new $.ExtensionHostMain(D.protocol,D.initData,s,null,d);S=P=>a.terminate(P)})}}}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/921264bfe3ffbbfe5ec8c4b08214b88e2148fa3e/core/vs/workbench/api/worker/extensionHostWorker.js.map
